-- Backup and Migrate (Drupal) MySQL Dump
-- Backup and Migrate Version: 7.x-3.x
-- http://drupal.org/project/backup_migrate
-- Drupal Version: 7.54
-- http://drupal.org/
--
-- Host: http://site01.readingbydesign.org/
-- Site Name: http://site01.readingbydesign.org/
-- Generation Time: Mon, 01 May 2017 09:49:05 -0700
-- MySQL Version: 5.5.54-0ubuntu0.14.04.1

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE=NO_AUTO_VALUE_ON_ZERO */;

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET NAMES utf8;

DROP TABLE IF EXISTS `_pantheon_heartbeat`;
CREATE TABLE `_pantheon_heartbeat` (   `time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,   `actor` varchar(64) NOT NULL,   PRIMARY KEY (`actor`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
INSERT INTO `_pantheon_heartbeat` VALUES ('2017-03-28 23:56:22','resurrection');
DROP TABLE IF EXISTS `accesslog`;
CREATE TABLE `accesslog` (   `aid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique accesslog ID.',   `sid` varchar(128) NOT NULL DEFAULT '' COMMENT 'Browser session ID of user that visited page.',   `title` varchar(255) DEFAULT NULL COMMENT 'Title of page visited.',   `path` varchar(255) DEFAULT NULL COMMENT 'Internal path to page visited (relative to Drupal root.)',   `url` text COMMENT 'Referrer URI.',   `hostname` varchar(128) DEFAULT NULL COMMENT 'Hostname of user that visited the page.',   `uid` int(10) unsigned DEFAULT '0' COMMENT 'User users.uid that visited the page.',   `timer` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Time in milliseconds that the page took to load.',   `timestamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Timestamp of when the page was visited.',   PRIMARY KEY (`aid`),   KEY `accesslog_timestamp` (`timestamp`),   KEY `uid` (`uid`) ) ENGINE=InnoDB AUTO_INCREMENT=872912 DEFAULT CHARSET=utf8 COMMENT='Stores site access information for statistics.' AUTO_INCREMENT=872912;
DROP TABLE IF EXISTS `actions`;
CREATE TABLE `actions` (   `aid` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Primary Key: Unique actions ID.',   `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The object that that action acts on (node, user, comment, system or custom types.)',   `callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The callback function that executes when the action runs.',   `parameters` longblob NOT NULL COMMENT 'Parameters to be passed to the callback function.',   `label` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Label of the action.',   PRIMARY KEY (`aid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores action information.';
INSERT INTO `actions` VALUES ('comment_publish_action','comment','comment_publish_action','','Publish comment'),('comment_save_action','comment','comment_save_action','','Save comment'),('comment_unpublish_action','comment','comment_unpublish_action','','Unpublish comment'),('node_make_sticky_action','node','node_make_sticky_action','','Make content sticky'),('node_make_unsticky_action','node','node_make_unsticky_action','','Make content unsticky'),('node_promote_action','node','node_promote_action','','Promote content to front page'),('node_publish_action','node','node_publish_action','','Publish content'),('node_save_action','node','node_save_action','','Save content'),('node_unpromote_action','node','node_unpromote_action','','Remove content from front page'),('node_unpublish_action','node','node_unpublish_action','','Unpublish content'),('pathauto_node_update_action','node','pathauto_node_update_action','','Update node alias'),('pathauto_taxonomy_term_update_action','taxonomy_term','pathauto_taxonomy_term_update_action','','Update taxonomy term alias'),('pathauto_user_update_action','user','pathauto_user_update_action','','Update user alias'),('system_block_ip_action','user','system_block_ip_action','','Ban IP address of current user'),('user_block_user_action','user','user_block_user_action','','Block current user'),('views_bulk_operations_archive_action','file','views_bulk_operations_archive_action','','Create an archive of selected files'),('views_bulk_operations_argument_selector_action','entity','views_bulk_operations_argument_selector_action','','Pass ids as arguments to a page'),('views_bulk_operations_delete_item','entity','views_bulk_operations_delete_item','','Delete item'),('views_bulk_operations_delete_revision','entity','views_bulk_operations_delete_revision','','Delete revision'),('views_bulk_operations_modify_action','entity','views_bulk_operations_modify_action','','Modify entity values');
DROP TABLE IF EXISTS `advanced_help_index`;
CREATE TABLE `advanced_help_index` (   `sid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary key to give to the search engine for this topic.',   `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The module that owns this topic.',   `topic` varchar(255) NOT NULL DEFAULT '' COMMENT 'The topic id.',   `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The language this search index relates to.',   PRIMARY KEY (`sid`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores search index correlations for advanced help topics.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `authmap`;
CREATE TABLE `authmap` (   `aid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique authmap ID.',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'User’s users.uid.',   `authname` varchar(128) NOT NULL DEFAULT '' COMMENT 'Unique authentication name.',   `module` varchar(128) NOT NULL DEFAULT '' COMMENT 'Module which is controlling the authentication.',   PRIMARY KEY (`aid`),   UNIQUE KEY `authname` (`authname`),   KEY `uid_module` (`uid`,`module`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores distributed authentication mapping.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `backup_migrate_destinations`;
CREATE TABLE `backup_migrate_destinations` (   `destination_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary ID field for the table. Not used for anything except internal lookups.',   `machine_name` varchar(255) NOT NULL DEFAULT '0' COMMENT 'The primary identifier for a destination.',   `name` varchar(255) NOT NULL COMMENT 'The name of the destination.',   `subtype` varchar(32) NOT NULL COMMENT 'The type of the destination.',   `location` text NOT NULL COMMENT 'The the location string of the destination.',   `settings` text NOT NULL COMMENT 'Other settings for the destination.',   PRIMARY KEY (`destination_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `backup_migrate_profiles`;
CREATE TABLE `backup_migrate_profiles` (   `profile_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary ID field for the table. Not used for anything except internal lookups.',   `machine_name` varchar(255) NOT NULL DEFAULT '0' COMMENT 'The primary identifier for a profile.',   `name` varchar(255) NOT NULL COMMENT 'The name of the profile.',   `filename` varchar(255) NOT NULL COMMENT 'The name of the profile.',   `append_timestamp` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Append a timestamp to the filename.',   `timestamp_format` varchar(14) NOT NULL COMMENT 'The format of the timestamp.',   `filters` text NOT NULL COMMENT 'The filter settings for the profile.',   PRIMARY KEY (`profile_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `backup_migrate_schedules`;
CREATE TABLE `backup_migrate_schedules` (   `schedule_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary ID field for the table. Not used for anything except internal lookups.',   `machine_name` varchar(255) NOT NULL DEFAULT '0' COMMENT 'The primary identifier for a profile.',   `name` varchar(255) NOT NULL COMMENT 'The name of the profile.',   `source_id` varchar(255) NOT NULL DEFAULT 'db' COMMENT 'The backup_migrate_destination.destination_id of the source to backup from.',   `destination_id` varchar(255) NOT NULL DEFAULT '0' COMMENT 'The backup_migrate_destination.destination_id of the destination to back up to.',   `copy_destination_id` varchar(32) NOT NULL DEFAULT '0' COMMENT 'A second backup_migrate_destination.destination_id of the destination to copy the backup to.',   `profile_id` varchar(255) NOT NULL DEFAULT '0' COMMENT 'The primary identifier for a profile.',   `keep` int(11) NOT NULL DEFAULT '0' COMMENT 'The number of backups to keep.',   `period` int(11) NOT NULL DEFAULT '0' COMMENT 'The number of seconds between backups.',   `enabled` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Whether the schedule is enabled.',   `cron` varchar(32) NOT NULL DEFAULT 'builtin' COMMENT 'Whether the schedule should be run during cron.',   `cron_schedule` varchar(255) NOT NULL DEFAULT '0 4 * * *' COMMENT 'The cron schedule to run on.',   PRIMARY KEY (`schedule_id`) ) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 AUTO_INCREMENT=2;
INSERT INTO `backup_migrate_schedules` VALUES ('1','db_backup','DB Backup','db','scheduled','','default','-2','28800','1','builtin','0 4 * * *');
DROP TABLE IF EXISTS `backup_migrate_sources`;
CREATE TABLE `backup_migrate_sources` (   `source_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary ID field for the table. Not used for anything except internal lookups.',   `machine_name` varchar(32) NOT NULL DEFAULT '0' COMMENT 'The primary identifier for a source.',   `name` varchar(255) NOT NULL COMMENT 'The name of the source.',   `subtype` varchar(32) NOT NULL COMMENT 'The type of the source.',   `location` text NOT NULL COMMENT 'The the location string of the source.',   `settings` text NOT NULL COMMENT 'Other settings for the source.',   PRIMARY KEY (`source_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `batch`;
CREATE TABLE `batch` (   `bid` int(10) unsigned NOT NULL COMMENT 'Primary Key: Unique batch ID.',   `token` varchar(64) NOT NULL COMMENT 'A string token generated against the current user’s session id and the batch id, used to ensure that only the user who submitted the batch can effectively access it.',   `timestamp` int(11) NOT NULL COMMENT 'A Unix timestamp indicating when this batch was submitted for processing. Stale batches are purged at cron time.',   `batch` longblob COMMENT 'A serialized array containing the processing data for the batch.',   PRIMARY KEY (`bid`),   KEY `token` (`token`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores details about batches (processes that run in...';
DROP TABLE IF EXISTS `block`;
CREATE TABLE `block` (   `bid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique block ID.',   `module` varchar(64) NOT NULL DEFAULT '' COMMENT 'The module from which the block originates; for example, ’user’ for the Who’s Online block, and ’block’ for any custom blocks.',   `delta` varchar(32) NOT NULL DEFAULT '0' COMMENT 'Unique ID for block within a module.',   `theme` varchar(64) NOT NULL DEFAULT '' COMMENT 'The theme under which the block settings apply.',   `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Block enabled status. (1 = enabled, 0 = disabled)',   `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Block weight within region.',   `region` varchar(64) NOT NULL DEFAULT '' COMMENT 'Theme region within which the block is set.',   `custom` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate how users may control visibility of the block. (0 = Users cannot control, 1 = On by default, but can be hidden, 2 = Hidden by default, but can be shown)',   `visibility` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate how to show blocks on pages. (0 = Show on all pages except listed pages, 1 = Show only on listed pages, 2 = Use custom PHP code to determine visibility)',   `pages` text NOT NULL COMMENT 'Contents of the `Pages` block; contains either a list of paths on which to include/exclude the block or PHP code, depending on `visibility` setting.',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Custom title for the block. (Empty string will use block default title, <none> will remove the title, text will cause block to use specified title.)',   `cache` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Binary flag to indicate block cache mode. (-2: Custom cache, -1: Do not cache, 1: Cache per role, 2: Cache per user, 4: Cache per page, 8: Block cache global) See DRUPAL_CACHE_* constants in ../includes/common.inc for more detailed information.',   `css_class` varchar(255) NOT NULL DEFAULT '' COMMENT 'String containing the classes for the block.',   PRIMARY KEY (`bid`),   UNIQUE KEY `tmd` (`theme`,`module`,`delta`),   KEY `list` (`theme`,`status`,`region`,`weight`,`module`) ) ENGINE=InnoDB AUTO_INCREMENT=137 DEFAULT CHARSET=utf8 COMMENT='Stores block settings, such as region and visibility...' AUTO_INCREMENT=137;
INSERT INTO `block` VALUES ('1','system','main','bartik','1','0','content','0','0','','','-1',''),('2','search','form','bartik','1','-1','sidebar_first','0','0','','','-1',''),('3','node','recent','seven','1','10','dashboard_main','0','0','','','-1',''),('4','user','login','bartik','1','0','sidebar_first','0','0','<front>','','-1',''),('5','system','navigation','bartik','1','0','sidebar_first','0','0','','','-1',''),('6','system','powered-by','bartik','1','10','footer','0','0','','','-1',''),('7','system','help','bartik','1','0','help','0','0','','','-1',''),('8','system','main','seven','1','0','content','0','0','','','-1',''),('9','system','help','seven','1','0','help','0','0','','','-1',''),('10','user','login','seven','1','10','content','0','0','<front>','','-1',''),('11','user','new','seven','1','0','dashboard_sidebar','0','0','','','-1',''),('12','search','form','seven','1','-10','dashboard_sidebar','0','0','','','-1',''),('13','comment','recent','bartik','0','0','-1','0','0','','','1',''),('14','node','syndicate','bartik','0','0','-1','0','0','','','-1',''),('15','node','recent','bartik','0','0','-1','0','0','','','1',''),('16','shortcut','shortcuts','bartik','0','0','-1','0','0','','','-1',''),('17','system','management','bartik','0','0','-1','0','0','','','-1',''),('18','system','user-menu','bartik','0','0','-1','0','0','','','-1',''),('19','system','main-menu','bartik','0','0','-1','0','0','','','-1',''),('20','user','new','bartik','0','0','-1','0','0','','','1',''),('21','user','online','bartik','0','0','-1','0','0','','','-1',''),('22','comment','recent','seven','1','0','dashboard_inactive','0','0','','','1',''),('23','node','syndicate','seven','0','0','-1','0','0','','','-1',''),('24','shortcut','shortcuts','seven','0','0','-1','0','0','','','-1',''),('25','system','powered-by','seven','0','10','-1','0','0','','','-1',''),('26','system','navigation','seven','0','0','-1','0','0','','','-1',''),('27','system','management','seven','0','0','-1','0','0','','','-1',''),('28','system','user-menu','seven','0','0','-1','0','0','','','-1',''),('29','system','main-menu','seven','0','0','-1','0','0','','','-1','');
INSERT INTO `block` VALUES ('30','user','online','seven','1','0','dashboard_inactive','0','0','','','-1',''),('31','comment','recent','bookpoints_custom','0','0','-1','0','0','','','1',''),('32','node','recent','bookpoints_custom','0','0','-1','0','0','','','1',''),('33','node','syndicate','bookpoints_custom','0','0','-1','0','0','','','-1',''),('34','search','form','bookpoints_custom','0','-1','-1','0','0','','','-1',''),('35','shortcut','shortcuts','bookpoints_custom','0','0','-1','0','0','','','-1',''),('36','system','help','bookpoints_custom','1','0','help','0','0','','','-1',''),('37','system','main','bookpoints_custom','1','0','content','0','0','','','-1',''),('38','system','main-menu','bookpoints_custom','1','0','menu_bar','0','0','','','-1',''),('39','system','management','bookpoints_custom','0','0','-1','0','0','','','-1',''),('40','system','navigation','bookpoints_custom','0','0','-1','0','0','','','-1',''),('41','system','powered-by','bookpoints_custom','0','10','-1','0','0','','','-1',''),('42','system','user-menu','bookpoints_custom','0','0','-1','0','0','','','-1',''),('43','user','login','bookpoints_custom','1','-31','sidebar_first','0','0','<front>','','-1',''),('44','user','new','bookpoints_custom','0','0','-1','0','0','','','1',''),('45','user','online','bookpoints_custom','0','0','-1','0','0','','','-1',''),('46','menu','devel','bartik','0','0','-1','0','0','','','-1',''),('47','menu','features','bartik','0','0','-1','0','0','','','-1',''),('48','workflow','workflow_transition','bartik','0','0','-1','0','0','','','-1',''),('49','devel','execute_php','bartik','0','0','-1','0','0','','','-1',''),('50','devel','switch_user','bartik','0','0','-1','0','0','','','-1',''),('51','menu','devel','bookpoints_custom','0','0','-1','0','0','','','-1',''),('52','menu','features','bookpoints_custom','0','0','-1','0','0','','','-1',''),('53','workflow','workflow_transition','bookpoints_custom','0','0','-1','0','0','','','-1',''),('54','devel','execute_php','bookpoints_custom','0','0','-1','0','0','','','-1',''),('55','devel','switch_user','bookpoints_custom','0','0','-1','0','0','','','-1','');
INSERT INTO `block` VALUES ('56','menu','devel','seven','0','0','-1','0','0','','','-1',''),('57','menu','features','seven','0','0','-1','0','0','','','-1',''),('58','workflow','workflow_transition','seven','0','0','-1','0','0','','','-1',''),('59','devel','execute_php','seven','0','0','-1','0','0','','','-1',''),('60','devel','switch_user','seven','0','0','-1','0','0','','','-1',''),('61','block','1','bartik','0','0','-1','0','1','<front>','','-1',''),('62','block','1','bookpoints_custom','0','0','-1','0','1','<front>','','-1',''),('63','block','1','seven','0','0','-1','0','1','<front>','','-1',''),('64','menu','menu-library-menu','bookpoints_custom','0','-15','-1','0','0','','','-1',''),('65','views','branches-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('66','views','programs-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('67','views','levels-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('68','views','readers-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('69','views','reader_logs-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('72','menu','menu-library-menu','bartik','0','0','-1','0','0','','','-1',''),('73','views','branches-block','bartik','0','0','-1','0','0','','','-1',''),('74','views','programs-block','bartik','0','0','-1','0','0','','','-1',''),('75','views','levels-block','bartik','0','0','-1','0','0','','','-1',''),('76','views','readers-block','bartik','0','0','-1','0','0','','','-1',''),('77','views','reader_logs-block','bartik','0','0','-1','0','0','','','-1',''),('79','menu','menu-library-menu','seven','0','0','-1','0','0','','','-1',''),('80','views','branches-block','seven','0','0','-1','0','0','','','-1',''),('81','views','programs-block','seven','0','0','-1','0','0','','','-1',''),('82','views','levels-block','seven','0','0','-1','0','0','','','-1',''),('83','views','readers-block','seven','0','0','-1','0','0','','','-1',''),('84','views','reader_logs-block','seven','0','0','-1','0','0','','','-1',''),('85','menu','menu-library-menu1','bartik','0','0','-1','0','0','/library/dashboard/','','-1','');
INSERT INTO `block` VALUES ('86','menu','menu-library-menu1','bookpoints_custom','1','-33','sidebar_first','0','0','/library/dashboard/','','-1',''),('87','menu','menu-library-menu1','seven','0','0','-1','0','0','/library/dashboard/','','-1',''),('88','views','readers-block_1','bookpoints_custom','0','0','-1','0','0','','','-1',''),('89','views','readers-block_1','bartik','0','0','-1','0','0','','','-1',''),('90','views','readers-block_1','seven','0','0','-1','0','0','','','-1',''),('91','views','badges-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('92','views','prize-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('93','views','entity_badges-block','bookpoints_custom','0','0','-1','0','1','program/program/*','','-1',''),('94','views','program_level-block','bookpoints_custom','1','0','content','0','1','program/program/*','','-1',''),('95','views','badges-block_1','bookpoints_custom','0','0','-1','0','0','','','-1',''),('96','views','program_badge-block','bookpoints_custom','1','0','content','0','1','program/program/*','','-1',''),('97','views','program_prizes-block','bookpoints_custom','1','0','content','0','1','program/program/*','','-1',''),('98','views','prizes-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('99','views','drawing_ticket-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('100','views','reader_points_for_reader-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('101','views','all_reader_prizes-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('102','views','all_reader_prizes-block_1','bookpoints_custom','0','0','-1','0','0','','','-1',''),('103','views','all_reader_prizes-block_2','bookpoints_custom','0','0','-1','0','0','','','-1',''),('104','views','prize_per_reader-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('105','views','user_search-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('106','views','reader_admin_overview-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('107','views','reading_log_by_reader-block','bookpoints_custom','0','0','-1','0','0','','','-1','');
INSERT INTO `block` VALUES ('108','block','2','bookpoints_custom','0','0','-1','0','0','','Reader Dashboard Left','-1','reader-dashboard-left'),('109','block','3','bookpoints_custom','0','0','-1','0','0','','Middle Panel','-1','reader-dashboard-middle'),('110','block','4','bookpoints_custom','0','0','-1','0','0','','Right Panel','-1','reader-dashboard-right'),('111','views','readers-block_2','bookpoints_custom','0','0','-1','0','0','','','-1',''),('112','views','reader_badge_by_reader-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('113','views','activity_log_page-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('114','views','readers-block_3','bookpoints_custom','0','0','-1','0','0','','','-1',''),('115','views','prize_by_program-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('116','views','tickets_by_reader-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('117','views','badge_view-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('118','block','5','bookpoints_custom','0','0','-1','0','0','','','-1',''),('119','views','activities_view-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('120','views','activities_view-block_1','bookpoints_custom','0','0','-1','0','0','','','-1',''),('121','views','secret_codes_view-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('122','views','secret_codes_view-block_1','bookpoints_custom','0','0','-1','0','0','','','-1',''),('123','block','6','bookpoints_custom','0','0','-1','0','0','','','-1','reader-dashboard-bottom'),('124','backup_migrate','quick_backup','bookpoints_custom','0','0','-1','0','0','','','1',''),('125','block','7','bookpoints_custom','0','0','-1','0','1','','','-1',''),('126','calendar','calendar_legend','bookpoints_custom','0','0','-1','0','0','','','1',''),('127','views','calendar-block_1','bookpoints_custom','0','0','-1','0','0','','','-1',''),('128','views','calendar-block_2','bookpoints_custom','0','0','-1','0','0','','','-1',''),('129','block','8','bookpoints_custom','1','0','footer','0','0','','','-1','');
INSERT INTO `block` VALUES ('130','menu','menu-setup-menu','bookpoints_custom','1','-32','sidebar_first','0','0','','','-1',''),('131','views','book_logs-block','bookpoints_custom','0','0','-1','0','0','','','-1',''),('132','block','9','bookpoints_custom','1','-34','sidebar_first','0','0','','You''re an admin!','-1',''),('133','block','10','bookpoints_custom','1','0','content','0','1','user/register','','-1',''),('134','block','11','bookpoints_custom','1','0','sidebar_first','0','1','user/register\r\nuser/register*','','-1',''),('135','views','program_dashboard-block_1','bookpoints_custom','0','0','-1','0','0','','','-1',''),('136','statistics','popular','bookpoints_custom','0','0','-1','0','0','','','-1','');
DROP TABLE IF EXISTS `block_access_roles`;
CREATE TABLE `block_access_roles` (   `module` varchar(64) NOT NULL COMMENT 'The block’s origin module, from blocks.module.',   `delta` varchar(32) NOT NULL COMMENT 'The block’s unique delta within module, from blocks.delta.',   `rid` int(10) unsigned NOT NULL COMMENT 'The user’s role ID from users_roles.rid.',   `permission` varchar(32) NOT NULL COMMENT 'The permission being granted',   PRIMARY KEY (`module`,`delta`,`rid`,`permission`),   KEY `rid` (`rid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Extension of block_role';
DROP TABLE IF EXISTS `block_custom`;
CREATE TABLE `block_custom` (   `bid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The block’s block.bid.',   `body` longtext COMMENT 'Block contents.',   `info` varchar(128) NOT NULL DEFAULT '' COMMENT 'Block description.',   `format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the block body.',   PRIMARY KEY (`bid`),   UNIQUE KEY `info` (`info`) ) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8 COMMENT='Stores contents of custom-made blocks.' AUTO_INCREMENT=12;
INSERT INTO `block_custom` VALUES ('1','<form action="user/register">\r\n    <input type="submit" value="Register" />\r\n</form>\r\n','Register Button','full_html'),('2',' Placeholder\r\n','Left Panel','full_html'),('3','Placeholder','Middle Panel','full_html'),('4','Placeholder','Right Panel','filtered_html'),('5','You have at least one prize waiting! See your librarian!','Top Nag Message','filtered_html'),('6','Placeholder','Bottom Panel','filtered_html'),('7','<strong>Replace this content with your library''s custom "welcome!" message.</strong>\r\n\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Donec porta dui et sapien malesuada, ut feugiat enim euismod. Duis mollis convallis lorem, non fringilla lacus aliquam a. Proin in sollicitudin ex, in porttitor ipsum. Sed elementum posuere dolor, eu lacinia mi efficitur ut. Phasellus pharetra, ex non elementum sodales, velit dolor molestie est, quis pretium quam leo vel erat. Suspendisse et quam luctus justo tincidunt interdum. Duis eu purus ut enim scelerisque vestibulum.\r\n\r\nVestibulum rutrum vitae enim sed condimentum. Suspendisse non mauris euismod, elementum eros a, lobortis odio. Etiam viverra, leo a facilisis tincidunt, risus magna egestas purus, quis pulvinar urna nibh quis urna. Suspendisse cursus mattis posuere. Donec lectus arcu, dignissim eleifend molestie in, semper quis justo. Donec dui urna, rhoncus et suscipit eu, volutpat id felis. Morbi lorem risus, tempus non elit ac, finibus fringilla erat. Aliquam ornare gravida aliquam. Sed et tempor neque. Donec maximus dolor sed euismod molestie. Aenean placerat semper justo, in porttitor ligula feugiat pretium.','home page welcome block for visitors','filtered_html'),('8','<p>This is the footer block. &nbsp;ADMINS can click the little gear icon in the upper right corner and then click "Configure block" to edit.</p>','Footer Block','filtered_html'),('9','<p>You''re logged in as an administrator -- so <strong>be careful</strong>! &nbsp;Only use this account for setup and administration activities. &nbsp;Use your "Librarian"-level account for day-to-day management.</p>','admin warning block','filtered_html');
INSERT INTO `block_custom` VALUES ('10','<p><strong>FAMILY ACCOUNT: </strong>Create <strong>ONE</strong>&nbsp;website account on this page for your entire family. &nbsp;Add all of your family''s Summer Readers on the following pages!</p><p><strong>INDIVIDUAL ACCOUNT: </strong>Create a website account on this page. &nbsp;Add yourself as a Summer Reader on the next page!</p>','HELP: create user (top user registration page)','filtered_html'),('11','<p><strong>Librarians: You can customize this instruction panel for your specific signup form!</strong></p><ul><li>Sample instructions</li><li>Sample instructions</li><li>Sample instructions</li></ul><p>&nbsp;</p>','HELP: Create User Instructions (customizable)','filtered_html');
DROP TABLE IF EXISTS `block_node_type`;
CREATE TABLE `block_node_type` (   `module` varchar(64) NOT NULL COMMENT 'The block’s origin module, from block.module.',   `delta` varchar(32) NOT NULL COMMENT 'The block’s unique delta within module, from block.delta.',   `type` varchar(32) NOT NULL COMMENT 'The machine-readable name of this type from node_type.type.',   PRIMARY KEY (`module`,`delta`,`type`),   KEY `type` (`type`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sets up display criteria for blocks based on content types';
DROP TABLE IF EXISTS `block_role`;
CREATE TABLE `block_role` (   `module` varchar(64) NOT NULL COMMENT 'The block’s origin module, from block.module.',   `delta` varchar(32) NOT NULL COMMENT 'The block’s unique delta within module, from block.delta.',   `rid` int(10) unsigned NOT NULL COMMENT 'The user’s role ID from users_roles.rid.',   PRIMARY KEY (`module`,`delta`,`rid`),   KEY `rid` (`rid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sets up access permissions for blocks based on user roles';
INSERT INTO `block_role` VALUES ('block','1','1'),('user','login','1'),('block','2','2'),('block','3','2'),('block','4','2'),('block','2','3'),('block','3','3'),('block','4','3'),('block','9','3'),('menu','menu-library-menu1','3'),('menu','menu-setup-menu','3'),('block','2','4'),('block','3','4'),('block','4','4'),('menu','menu-library-menu','4'),('block','2','5'),('block','3','5'),('block','4','5'),('menu','menu-library-menu1','5'),('views','program_badge-block','5'),('views','program_level-block','5'),('views','program_prizes-block','5');
DROP TABLE IF EXISTS `blocked_ips`;
CREATE TABLE `blocked_ips` (   `iid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: unique ID for IP addresses.',   `ip` varchar(40) NOT NULL DEFAULT '' COMMENT 'IP address',   PRIMARY KEY (`iid`),   KEY `blocked_ip` (`ip`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores blocked IP addresses.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `cache`;
CREATE TABLE `cache` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
DROP TABLE IF EXISTS `cache_admin_menu`;
CREATE TABLE `cache_admin_menu` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for Administration menu to store client-side...';
DROP TABLE IF EXISTS `cache_block`;
CREATE TABLE `cache_block` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the Block module to store already built...';
DROP TABLE IF EXISTS `cache_bootstrap`;
CREATE TABLE `cache_bootstrap` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for data required to bootstrap Drupal, may be...';
DROP TABLE IF EXISTS `cache_eck`;
CREATE TABLE `cache_eck` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
INSERT INTO `cache_eck` VALUES ('bundles','a:20:{s:13:"branch_branch";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:13:"branch_branch";s:11:"entity_type";s:6:"branch";s:4:"name";s:6:"branch";s:5:"label";s:6:"Branch";s:6:"config";a:0:{}s:2:"id";s:1:"1";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:15:"program_program";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:15:"program_program";s:11:"entity_type";s:7:"program";s:4:"name";s:7:"program";s:5:"label";s:7:"Program";s:6:"config";a:0:{}s:2:"id";s:1:"2";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:11:"level_level";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:11:"level_level";s:11:"entity_type";s:5:"level";s:4:"name";s:5:"level";s:5:"label";s:5:"Level";s:6:"config";a:0:{}s:2:"id";s:1:"3";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:13:"reader_reader";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:13:"reader_reader";s:11:"entity_type";s:6:"reader";s:4:"name";s:6:"reader";s:5:"label";s:6:"Reader";s:6:"config";a:0:{}s:2:"id";s:1:"5";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:21:"reader_log_reader_log";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:21:"reader_log_reader_log";s:11:"entity_type";s:10:"reader_log";s:4:"name";s:10:"reader_log";s:5:"label";s:10:"Reader Log";s:6:"config";a:0:{}s:2:"id";s:1:"6";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:29:"drawing_ticket_drawing_ticket";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:29:"drawing_ticket_drawing_ticket";s:11:"entity_type";s:14:"drawing_ticket";s:4:"name";s:14:"drawing_ticket";s:5:"label";s:14:"Drawing Ticket";s:6:"config";a:0:{}s:2:"id";s:1:"7";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:11:"prize_prize";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:11:"prize_prize";s:11:"entity_type";s:5:"prize";s:4:"name";s:5:"prize";s:5:"label";s:5:"Prize";s:6:"config";a:0:{}s:2:"id";s:1:"8";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:13:"school_school";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:13:"school_school";s:11:"entity_type";s:6:"school";s:4:"name";s:6:"school";s:5:"label";s:6:"School";s:6:"config";a:0:{}s:2:"id";s:1:"9";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:23:"reading_log_reading_log";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:23:"reading_log_reading_log";s:11:"entity_type";s:11:"reading_log";s:4:"name";s:11:"reading_log";s:5:"label";s:11:"Reading Log";s:6:"config";a:0:{}s:2:"id";s:2:"10";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:11:"badge_badge";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:11:"badge_badge";s:11:"entity_type";s:5:"badge";s:4:"name";s:5:"badge";s:5:"label";s:5:"Badge";s:6:"config";a:0:{}s:2:"id";s:2:"11";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:25:"reader_prize_reader_prize";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:25:"reader_prize_reader_prize";s:11:"entity_type";s:12:"reader_prize";s:4:"name";s:12:"reader_prize";s:5:"label";s:12:"Reader Prize";s:6:"config";a:0:{}s:2:"id";s:2:"12";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:13:"points_points";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:13:"points_points";s:11:"entity_type";s:6:"points";s:4:"name";s:6:"points";s:5:"label";s:6:"Points";s:6:"config";a:0:{}s:2:"id";s:2:"13";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:45:"activity_log_reference_activity_log_reference";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:45:"activity_log_reference_activity_log_reference";s:11:"entity_type";s:22:"activity_log_reference";s:4:"name";s:22:"activity_log_reference";s:5:"label";s:22:"Activity Log Reference";s:6:"config";a:0:{}s:2:"id";s:2:"14";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:25:"reader_badge_reader_badge";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:25:"reader_badge_reader_badge";s:11:"entity_type";s:12:"reader_badge";s:4:"name";s:12:"reader_badge";s:5:"label";s:12:"Reader Badge";s:6:"config";a:0:{}s:2:"id";s:2:"15";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:39:"reader_activity_log_reader_activity_log";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:39:"reader_activity_log_reader_activity_log";s:11:"entity_type";s:19:"reader_activity_log";s:4:"name";s:19:"reader_activity_log";s:5:"label";s:19:"Reader Activity Log";s:6:"config";a:0:{}s:2:"id";s:2:"16";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:23:"nag_message_nag_message";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:23:"nag_message_nag_message";s:11:"entity_type";s:11:"nag_message";s:4:"name";s:11:"nag_message";s:5:"label";s:11:"Nag Message";s:6:"config";a:0:{}s:2:"id";s:2:"17";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:27:"reader_ticket_reader_ticket";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:27:"reader_ticket_reader_ticket";s:11:"entity_type";s:13:"reader_ticket";s:4:"name";s:13:"reader_ticket";s:5:"label";s:13:"Reader Ticket";s:6:"config";a:0:{}s:2:"id";s:2:"18";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:17:"activity_activity";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:17:"activity_activity";s:11:"entity_type";s:8:"activity";s:4:"name";s:8:"activity";s:5:"label";s:8:"Activity";s:6:"config";a:0:{}s:2:"id";s:2:"19";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:20:"activity_secret_code";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:20:"activity_secret_code";s:11:"entity_type";s:8:"activity";s:4:"name";s:11:"secret_code";s:5:"label";s:11:"Secret Code";s:6:"config";a:0:{}s:2:"id";s:2:"20";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}s:25:"activity_log_activity_log";O:6:"Bundle":7:{s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:10:"eck_bundle";s:14:"\0DBObject\0vars";a:6:{i:0;s:2:"id";i:1;s:12:"machine_name";i:2;s:11:"entity_type";i:3;s:4:"name";i:4;s:5:"label";i:5;s:6:"config";}s:14:"\0DBObject\0data";a:6:{s:12:"machine_name";s:25:"activity_log_activity_log";s:11:"entity_type";s:12:"activity_log";s:4:"name";s:12:"activity_log";s:5:"label";s:12:"Activity Log";s:6:"config";a:0:{}s:2:"id";s:2:"21";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:6:"config";}}}','0','1493618724','1');
INSERT INTO `cache_eck` VALUES ('entity_types','a:19:{s:8:"activity";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:8:"activity";s:5:"label";s:8:"Activity";s:10:"properties";a:4:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}s:3:"uid";a:3:{s:5:"label";s:6:"Author";s:4:"type";s:7:"integer";s:8:"behavior";s:6:"author";}s:7:"created";a:3:{s:5:"label";s:7:"Created";s:4:"type";s:7:"integer";s:8:"behavior";s:7:"created";}s:8:"language";a:3:{s:5:"label";s:15:"Entity language";s:4:"type";s:8:"language";s:8:"behavior";s:8:"language";}}s:2:"id";s:2:"19";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:12:"activity_log";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:12:"activity_log";s:5:"label";s:12:"Activity Log";s:10:"properties";a:4:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}s:3:"uid";a:3:{s:5:"label";s:6:"Author";s:4:"type";s:7:"integer";s:8:"behavior";s:6:"author";}s:7:"created";a:3:{s:5:"label";s:7:"Created";s:4:"type";s:7:"integer";s:8:"behavior";s:7:"created";}s:8:"language";a:3:{s:5:"label";s:15:"Entity language";s:4:"type";s:8:"language";s:8:"behavior";s:8:"language";}}s:2:"id";s:2:"20";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:22:"activity_log_reference";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:22:"activity_log_reference";s:5:"label";s:22:"Activity Log Reference";s:10:"properties";a:0:{}s:2:"id";s:2:"14";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:5:"badge";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:5:"badge";s:5:"label";s:5:"Badge";s:10:"properties";a:1:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}}s:2:"id";s:2:"11";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:6:"branch";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:6:"branch";s:5:"label";s:6:"Branch";s:10:"properties";a:3:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}s:3:"uid";a:3:{s:5:"label";s:6:"Author";s:4:"type";s:7:"integer";s:8:"behavior";s:6:"author";}s:7:"created";a:3:{s:5:"label";s:7:"Created";s:4:"type";s:7:"integer";s:8:"behavior";s:7:"created";}}s:2:"id";s:1:"1";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:14:"drawing_ticket";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:14:"drawing_ticket";s:5:"label";s:14:"Drawing Ticket";s:10:"properties";a:3:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}s:3:"uid";a:3:{s:5:"label";s:6:"Author";s:4:"type";s:7:"integer";s:8:"behavior";s:6:"author";}s:7:"created";a:3:{s:5:"label";s:7:"Created";s:4:"type";s:7:"integer";s:8:"behavior";s:7:"created";}}s:2:"id";s:1:"7";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:5:"level";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:5:"level";s:5:"label";s:5:"Level";s:10:"properties";a:3:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}s:3:"uid";a:3:{s:5:"label";s:6:"Author";s:4:"type";s:7:"integer";s:8:"behavior";s:6:"author";}s:7:"created";a:3:{s:5:"label";s:7:"Created";s:4:"type";s:7:"integer";s:8:"behavior";s:7:"created";}}s:2:"id";s:1:"3";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:11:"nag_message";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:11:"nag_message";s:5:"label";s:11:"Nag Message";s:10:"properties";a:1:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}}s:2:"id";s:2:"17";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:6:"points";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:6:"points";s:5:"label";s:6:"Points";s:10:"properties";a:1:{s:3:"uid";a:3:{s:5:"label";s:6:"Author";s:4:"type";s:7:"integer";s:8:"behavior";s:6:"author";}}s:2:"id";s:2:"13";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:5:"prize";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:5:"prize";s:5:"label";s:5:"Prize";s:10:"properties";a:3:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}s:3:"uid";a:3:{s:5:"label";s:6:"Author";s:4:"type";s:7:"integer";s:8:"behavior";s:6:"author";}s:7:"created";a:3:{s:5:"label";s:7:"Created";s:4:"type";s:7:"integer";s:8:"behavior";s:7:"created";}}s:2:"id";s:1:"8";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:7:"program";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:7:"program";s:5:"label";s:7:"Program";s:10:"properties";a:3:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}s:3:"uid";a:3:{s:5:"label";s:6:"Author";s:4:"type";s:7:"integer";s:8:"behavior";s:6:"author";}s:7:"created";a:3:{s:5:"label";s:7:"Created";s:4:"type";s:7:"integer";s:8:"behavior";s:7:"created";}}s:2:"id";s:1:"2";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:6:"reader";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:6:"reader";s:5:"label";s:6:"Reader";s:10:"properties";a:2:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}s:3:"uid";a:3:{s:5:"label";s:6:"Author";s:4:"type";s:7:"integer";s:8:"behavior";s:6:"author";}}s:2:"id";s:1:"5";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:19:"reader_activity_log";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:19:"reader_activity_log";s:5:"label";s:19:"Reader Activity Log";s:10:"properties";a:1:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}}s:2:"id";s:2:"16";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:12:"reader_badge";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:12:"reader_badge";s:5:"label";s:12:"Reader Badge";s:10:"properties";a:1:{s:3:"uid";a:3:{s:5:"label";s:6:"Author";s:4:"type";s:7:"integer";s:8:"behavior";s:6:"author";}}s:2:"id";s:2:"15";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:10:"reader_log";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:10:"reader_log";s:5:"label";s:10:"Reader Log";s:10:"properties";a:1:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}}s:2:"id";s:1:"6";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:12:"reader_prize";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:12:"reader_prize";s:5:"label";s:12:"Reader Prize";s:10:"properties";a:3:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}s:7:"created";a:3:{s:5:"label";s:7:"Created";s:4:"type";s:7:"integer";s:8:"behavior";s:7:"created";}s:3:"uid";a:3:{s:5:"label";s:6:"Author";s:4:"type";s:7:"integer";s:8:"behavior";s:6:"author";}}s:2:"id";s:2:"12";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:13:"reader_ticket";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:13:"reader_ticket";s:5:"label";s:13:"Reader Ticket";s:10:"properties";a:3:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}s:3:"uid";a:3:{s:5:"label";s:6:"Author";s:4:"type";s:7:"integer";s:8:"behavior";s:6:"author";}s:7:"created";a:3:{s:5:"label";s:7:"Created";s:4:"type";s:7:"integer";s:8:"behavior";s:7:"created";}}s:2:"id";s:2:"18";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:11:"reading_log";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:11:"reading_log";s:5:"label";s:11:"Reading Log";s:10:"properties";a:4:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}s:3:"uid";a:3:{s:5:"label";s:6:"Author";s:4:"type";s:7:"integer";s:8:"behavior";s:6:"author";}s:7:"created";a:3:{s:5:"label";s:7:"Created";s:4:"type";s:7:"integer";s:8:"behavior";s:7:"created";}s:7:"changed";a:3:{s:5:"label";s:7:"Changed";s:4:"type";s:7:"integer";s:8:"behavior";s:7:"changed";}}s:2:"id";s:2:"10";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}s:6:"school";O:10:"EntityType":8:{s:19:"\0EntityType\0changes";a:0:{}s:5:"isNew";b:0;s:18:"\0DBObject\0position";i:0;s:15:"\0DBObject\0table";s:15:"eck_entity_type";s:14:"\0DBObject\0vars";a:4:{i:0;s:2:"id";i:1;s:4:"name";i:2;s:5:"label";i:3;s:10:"properties";}s:14:"\0DBObject\0data";a:4:{s:4:"name";s:6:"school";s:5:"label";s:6:"School";s:10:"properties";a:1:{s:5:"title";a:3:{s:5:"label";s:5:"Title";s:4:"type";s:4:"text";s:8:"behavior";s:5:"title";}}s:2:"id";s:1:"9";}s:21:"\0DBObject\0primaryKeys";a:1:{i:0;s:2:"id";}s:19:"\0DBObject\0serialize";a:1:{i:0;s:10:"properties";}}}','0','1493618724','1');
DROP TABLE IF EXISTS `cache_features`;
CREATE TABLE `cache_features` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for features to store module info.';
INSERT INTO `cache_features` VALUES ('features_api','a:34:{s:23:"backup_migrate_profiles";a:8:{s:4:"name";s:18:"Backup and Migrate";s:12:"default_hook";s:35:"exportables_backup_migrate_profiles";s:12:"default_file";i:2;s:6:"module";s:14:"backup_migrate";s:14:"feature_source";b:1;s:3:"api";s:26:"backup_migrate_exportables";s:16:"default_filename";s:26:"backup_migrate_exportables";s:15:"current_version";i:1;}s:27:"backup_migrate_destinations";a:8:{s:4:"name";s:18:"Backup and Migrate";s:12:"default_hook";s:39:"exportables_backup_migrate_destinations";s:12:"default_file";i:2;s:6:"module";s:14:"backup_migrate";s:14:"feature_source";b:1;s:3:"api";s:26:"backup_migrate_exportables";s:16:"default_filename";s:26:"backup_migrate_exportables";s:15:"current_version";i:1;}s:22:"backup_migrate_sources";a:8:{s:4:"name";s:18:"Backup and Migrate";s:12:"default_hook";s:34:"exportables_backup_migrate_sources";s:12:"default_file";i:2;s:6:"module";s:14:"backup_migrate";s:14:"feature_source";b:1;s:3:"api";s:26:"backup_migrate_exportables";s:16:"default_filename";s:26:"backup_migrate_exportables";s:15:"current_version";i:1;}s:24:"backup_migrate_schedules";a:8:{s:4:"name";s:18:"Backup and Migrate";s:12:"default_hook";s:36:"exportables_backup_migrate_schedules";s:12:"default_file";i:2;s:6:"module";s:14:"backup_migrate";s:14:"feature_source";b:1;s:3:"api";s:26:"backup_migrate_exportables";s:16:"default_filename";s:26:"backup_migrate_exportables";s:15:"current_version";i:1;}s:12:"block_access";a:4:{s:4:"name";s:12:"Block Access";s:14:"feature_source";b:1;s:12:"default_hook";s:21:"block_access_defaults";s:12:"default_file";i:1;}s:6:"ctools";a:3:{s:4:"name";s:17:"CTools export API";s:14:"feature_source";b:1;s:10:"duplicates";i:1;}s:15:"eck_entity_type";a:4:{s:4:"name";s:12:"Entity Types";s:14:"feature_source";b:1;s:4:"file";s:46:"sites/all/modules/contrib/eck/eck.features.inc";s:12:"default_hook";s:20:"eck_entity_type_info";}s:10:"eck_bundle";a:4:{s:4:"name";s:7:"Bundles";s:14:"feature_source";b:1;s:4:"file";s:46:"sites/all/modules/contrib/eck/eck.features.inc";s:12:"default_hook";s:15:"eck_bundle_info";}s:15:"entityform_type";a:5:{s:4:"name";s:15:"Entityform Type";s:14:"feature_source";b:1;s:12:"default_hook";s:23:"default_entityform_type";s:4:"base";s:6:"entity";s:4:"file";s:52:"sites/all/modules/contrib/entity/entity.features.inc";}s:8:"Workflow";a:5:{s:4:"name";s:8:"Workflow";s:14:"feature_source";b:1;s:12:"default_hook";s:16:"default_Workflow";s:4:"base";s:6:"entity";s:4:"file";s:52:"sites/all/modules/contrib/entity/entity.features.inc";}s:12:"rules_config";a:7:{s:4:"name";s:19:"Rules configuration";s:14:"feature_source";b:1;s:12:"default_hook";s:27:"default_rules_configuration";s:4:"base";s:6:"entity";s:4:"file";s:52:"sites/all/modules/contrib/entity/entity.features.inc";s:12:"default_file";i:2;s:16:"default_filename";s:14:"rules_defaults";}s:14:"feeds_importer";a:8:{s:4:"name";s:5:"Feeds";s:12:"default_hook";s:22:"feeds_importer_default";s:12:"default_file";i:2;s:6:"module";s:5:"feeds";s:14:"feature_source";b:1;s:3:"api";s:22:"feeds_importer_default";s:16:"default_filename";s:22:"feeds_importer_default";s:15:"current_version";i:1;}s:5:"field";a:4:{s:4:"name";s:6:"Fields";s:12:"default_hook";s:20:"field_default_fields";s:12:"default_file";i:1;s:14:"feature_source";b:0;}s:10:"field_base";a:5:{s:4:"name";s:11:"Field Bases";s:12:"default_hook";s:25:"field_default_field_bases";s:12:"default_file";i:1;s:14:"feature_source";b:1;s:10:"supersedes";s:5:"field";}s:14:"field_instance";a:5:{s:4:"name";s:15:"Field Instances";s:12:"default_hook";s:29:"field_default_field_instances";s:12:"default_file";i:1;s:14:"feature_source";b:1;s:10:"supersedes";s:5:"field";}s:6:"filter";a:4:{s:4:"name";s:12:"Text formats";s:12:"default_hook";s:22:"filter_default_formats";s:12:"default_file";i:1;s:14:"feature_source";b:1;}s:5:"image";a:4:{s:4:"name";s:12:"Image styles";s:14:"feature_source";b:1;s:12:"default_hook";s:20:"image_default_styles";s:10:"alter_hook";s:12:"image_styles";}s:11:"menu_custom";a:4:{s:4:"name";s:5:"Menus";s:12:"default_hook";s:24:"menu_default_menu_custom";s:14:"feature_source";b:1;s:12:"default_file";i:1;}s:10:"menu_links";a:4:{s:4:"name";s:10:"Menu links";s:12:"default_hook";s:23:"menu_default_menu_links";s:14:"feature_source";b:1;s:12:"default_file";i:1;}s:4:"menu";a:4:{s:4:"name";s:10:"Menu items";s:12:"default_hook";s:18:"menu_default_items";s:12:"default_file";i:1;s:14:"feature_source";b:0;}s:4:"node";a:4:{s:4:"name";s:13:"Content types";s:14:"feature_source";b:1;s:12:"default_hook";s:9:"node_info";s:10:"alter_type";s:6:"inline";}s:24:"panels_renderer_pipeline";a:8:{s:4:"name";s:6:"Panels";s:12:"default_hook";s:32:"default_panels_renderer_pipeline";s:12:"default_file";i:2;s:6:"module";s:6:"panels";s:14:"feature_source";b:1;s:3:"api";s:9:"pipelines";s:16:"default_filename";s:9:"pipelines";s:15:"current_version";i:1;}s:13:"panels_layout";a:8:{s:4:"name";s:6:"Panels";s:12:"default_hook";s:21:"default_panels_layout";s:12:"default_file";i:2;s:6:"module";s:6:"panels";s:14:"feature_source";b:1;s:3:"api";s:7:"layouts";s:16:"default_filename";s:7:"layouts";s:15:"current_version";i:1;}s:11:"panels_mini";a:8:{s:4:"name";s:11:"Mini panels";s:12:"default_hook";s:19:"default_panels_mini";s:12:"default_file";i:2;s:6:"module";s:11:"panels_mini";s:14:"feature_source";b:1;s:3:"api";s:14:"panels_default";s:16:"default_filename";s:14:"panels_default";s:15:"current_version";i:1;}s:8:"taxonomy";a:4:{s:4:"name";s:8:"Taxonomy";s:14:"feature_source";b:1;s:12:"default_hook";s:29:"taxonomy_default_vocabularies";s:12:"default_file";i:1;}s:9:"user_role";a:4:{s:4:"name";s:5:"Roles";s:14:"feature_source";b:1;s:12:"default_hook";s:18:"user_default_roles";s:12:"default_file";i:1;}s:15:"user_permission";a:4:{s:4:"name";s:11:"Permissions";s:14:"feature_source";b:1;s:12:"default_hook";s:24:"user_default_permissions";s:12:"default_file";i:1;}s:8:"workflow";a:4:{s:4:"name";s:8:"Workflow";s:4:"file";s:56:"sites/all/modules/contrib/workflow/workflow.features.inc";s:12:"default_hook";s:26:"workflow_default_workflows";s:14:"feature_source";b:1;}s:7:"wysiwyg";a:5:{s:4:"name";s:16:"Wysiwyg profiles";s:12:"default_hook";s:24:"wysiwyg_default_profiles";s:12:"default_file";i:1;s:14:"feature_source";b:1;s:4:"file";s:54:"sites/all/modules/contrib/wysiwyg/wysiwyg.features.inc";}s:11:"field_group";a:8:{s:4:"name";s:11:"Field Group";s:12:"default_hook";s:16:"field_group_info";s:12:"default_file";i:2;s:6:"module";s:11:"field_group";s:14:"feature_source";b:1;s:3:"api";s:11:"field_group";s:16:"default_filename";s:11:"field_group";s:15:"current_version";i:1;}s:10:"views_view";a:8:{s:4:"name";s:5:"Views";s:12:"default_hook";s:19:"views_default_views";s:12:"default_file";i:2;s:6:"module";s:5:"views";s:14:"feature_source";b:1;s:3:"api";s:13:"views_default";s:16:"default_filename";s:13:"views_default";s:15:"current_version";s:3:"3.0";}s:12:"dependencies";a:3:{s:4:"name";s:12:"Dependencies";s:14:"feature_source";b:1;s:10:"duplicates";i:1;}s:21:"page_manager_handlers";a:8:{s:4:"name";s:12:"Page manager";s:12:"default_hook";s:29:"default_page_manager_handlers";s:12:"default_file";i:2;s:6:"module";s:12:"page_manager";s:14:"feature_source";b:1;s:3:"api";s:13:"pages_default";s:16:"default_filename";s:13:"pages_default";s:15:"current_version";i:1;}s:18:"page_manager_pages";a:8:{s:4:"name";s:12:"Page manager";s:12:"default_hook";s:26:"default_page_manager_pages";s:12:"default_file";i:2;s:6:"module";s:12:"page_manager";s:14:"feature_source";b:1;s:3:"api";s:13:"pages_default";s:16:"default_filename";s:13:"pages_default";s:15:"current_version";i:1;}}','0','1493618724','1');
INSERT INTO `cache_features` VALUES ('features_module_info','a:2:{s:7:"feature";a:12:{s:25:"block_class_fe_block_test";O:8:"stdClass":12:{s:3:"uri";s:76:"sites/all/modules/contrib/block_class/tests/block_class_fe_block_test.module";s:8:"filename";s:76:"sites/all/modules/contrib/block_class/tests/block_class_fe_block_test.module";s:4:"name";s:25:"block_class_fe_block_test";s:4:"info";a:12:{s:4:"name";s:44:"Block Class FE Block Integration Test Helper";s:11:"description";s:99:"Helper module for testing the integration of Block Class with Features through the FE Block module.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Features";s:12:"dependencies";a:1:{i:0;s:8:"fe_block";}s:8:"features";a:2:{s:17:"fe_block_settings";a:1:{i:0;s:11:"user-online";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}}s:6:"hidden";b:1;s:7:"version";s:7:"7.x-2.3";s:7:"project";s:11:"block_class";s:9:"datestamp";s:10:"1450415951";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:8:"fe_block";a:1:{s:4:"name";s:8:"fe_block";}}s:4:"sort";i:0;s:10:"components";a:3:{i:0;s:17:"fe_block_settings";i:1;s:12:"features_api";i:2;s:12:"dependencies";}}s:8:"booklist";O:8:"stdClass":12:{s:3:"uri";s:49:"sites/all/modules/custom/booklist/booklist.module";s:8:"filename";s:49:"sites/all/modules/custom/booklist/booklist.module";s:4:"name";s:8:"booklist";s:4:"info";a:10:{s:4:"name";s:8:"booklist";s:4:"core";s:3:"7.x";s:7:"package";s:10:"Bookpoints";s:7:"version";s:16:"7.x-1.0-beta0319";s:8:"features";a:7:{s:6:"ctools";a:1:{i:0;s:23:"views:views_default:3.0";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:10:"field_base";a:5:{i:0;s:17:"field_bl_b_author";i:1;s:16:"field_bl_b_image";i:2;s:15:"field_bl_b_link";i:3;s:16:"field_bl_b_title";i:4;s:20:"field_booklist_books";}s:14:"field_instance";a:6:{i:0;s:60:"field_collection_item-field_booklist_books-field_bl_b_author";i:1;s:59:"field_collection_item-field_booklist_books-field_bl_b_image";i:2;s:58:"field_collection_item-field_booklist_books-field_bl_b_link";i:3;s:59:"field_collection_item-field_booklist_books-field_bl_b_title";i:4;s:19:"node-book_list-body";i:5;s:35:"node-book_list-field_booklist_books";}s:11:"menu_custom";a:2:{i:0;s:9:"main-menu";i:1;s:18:"menu-library-menu1";}s:4:"node";a:1:{i:0;s:9:"book_list";}s:10:"views_view";a:1:{i:0;s:10:"book_lists";}}s:12:"project path";s:24:"sites/all/modules/custom";s:12:"dependencies";a:0:{}s:11:"description";s:0:"";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;s:10:"components";a:7:{i:0;s:6:"ctools";i:1;s:12:"features_api";i:2;s:10:"field_base";i:3;s:14:"field_instance";i:4;s:11:"menu_custom";i:5;s:4:"node";i:6;s:10:"views_view";}}s:9:"book_logs";O:8:"stdClass":12:{s:3:"uri";s:51:"sites/all/modules/custom/book_logs/book_logs.module";s:8:"filename";s:51:"sites/all/modules/custom/book_logs/book_logs.module";s:4:"name";s:9:"book_logs";s:4:"info";a:11:{s:4:"name";s:9:"Book Logs";s:11:"description";s:34:"Shows a user''s reader''s books read";s:4:"core";s:3:"7.x";s:7:"package";s:10:"Bookpoints";s:7:"version";s:17:"7.x-1.0-beta0319b";s:12:"dependencies";a:1:{i:0;s:5:"views";}s:8:"features";a:3:{s:6:"ctools";a:1:{i:0;s:23:"views:views_default:3.0";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:10:"views_view";a:1:{i:0;s:9:"book_logs";}}s:16:"features_exclude";a:1:{s:12:"dependencies";a:1:{s:6:"ctools";s:6:"ctools";}}s:12:"project path";s:24:"sites/all/modules/custom";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-15;s:10:"components";a:4:{i:0;s:6:"ctools";i:1;s:12:"features_api";i:2;s:10:"views_view";i:3;s:12:"dependencies";}}s:18:"bookpoints_drawing";O:8:"stdClass":12:{s:3:"uri";s:69:"sites/all/modules/custom/bookpoints_drawing/bookpoints_drawing.module";s:8:"filename";s:69:"sites/all/modules/custom/bookpoints_drawing/bookpoints_drawing.module";s:4:"name";s:18:"bookpoints_drawing";s:4:"info";a:11:{s:4:"name";s:18:"Bookpoints Drawing";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Features";s:7:"version";s:17:"7.x-1.0-beta0227a";s:12:"dependencies";a:1:{i:0;s:5:"views";}s:8:"features";a:3:{s:6:"ctools";a:1:{i:0;s:23:"views:views_default:3.0";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:10:"views_view";a:1:{i:0;s:7:"drawing";}}s:16:"features_exclude";a:1:{s:12:"dependencies";a:1:{s:6:"ctools";s:6:"ctools";}}s:12:"project path";s:24:"sites/all/modules/custom";s:11:"description";s:0:"";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-16;s:10:"components";a:4:{i:0;s:6:"ctools";i:1;s:12:"features_api";i:2;s:10:"views_view";i:3;s:12:"dependencies";}}s:17:"bookpoints_events";O:8:"stdClass":12:{s:3:"uri";s:67:"sites/all/modules/custom/bookpoints_events/bookpoints_events.module";s:8:"filename";s:67:"sites/all/modules/custom/bookpoints_events/bookpoints_events.module";s:4:"name";s:17:"bookpoints_events";s:4:"info";a:11:{s:4:"name";s:17:"Bookpoints Events";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Features";s:7:"version";s:17:"7.x-1.0-beta0319b";s:12:"dependencies";a:8:{i:0;s:8:"calendar";i:1;s:4:"date";i:2;s:10:"date_views";i:3;s:15:"entityreference";i:4;s:8:"features";i:5;s:7:"options";i:6;s:4:"text";i:7;s:5:"views";}s:8:"features";a:6:{s:6:"ctools";a:1:{i:0;s:23:"views:views_default:3.0";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:10:"field_base";a:3:{i:0;s:4:"body";i:1;s:10:"field_date";i:2;s:13:"field_program";}s:14:"field_instance";a:3:{i:0;s:15:"node-event-body";i:1;s:21:"node-event-field_date";i:2;s:24:"node-event-field_program";}s:4:"node";a:1:{i:0;s:5:"event";}s:10:"views_view";a:2:{i:0;s:8:"calendar";i:1;s:13:"manage_events";}}s:16:"features_exclude";a:1:{s:12:"dependencies";a:1:{s:6:"ctools";s:6:"ctools";}}s:12:"project path";s:24:"sites/all/modules/custom";s:11:"description";s:0:"";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:13:{s:8:"calendar";a:1:{s:4:"name";s:8:"calendar";}s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:8:"date_api";a:1:{s:4:"name";s:8:"date_api";}s:10:"date_views";a:1:{s:4:"name";s:10:"date_views";}s:4:"date";a:1:{s:4:"name";s:4:"date";}s:15:"entityreference";a:1:{s:4:"name";s:15:"entityreference";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:8:"features";a:1:{s:4:"name";s:8:"features";}s:7:"options";a:1:{s:4:"name";s:7:"options";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:4:"text";a:1:{s:4:"name";s:4:"text";}}s:4:"sort";i:-27;s:10:"components";a:7:{i:0;s:6:"ctools";i:1;s:12:"features_api";i:2;s:10:"field_base";i:3;s:14:"field_instance";i:4;s:4:"node";i:5;s:10:"views_view";i:6;s:12:"dependencies";}}s:20:"bookpoints_importers";O:8:"stdClass":12:{s:3:"uri";s:73:"sites/all/modules/custom/bookpoints_importers/bookpoints_importers.module";s:8:"filename";s:73:"sites/all/modules/custom/bookpoints_importers/bookpoints_importers.module";s:4:"name";s:20:"bookpoints_importers";s:4:"info";a:10:{s:4:"name";s:20:"Bookpoints Importers";s:4:"core";s:3:"7.x";s:7:"package";s:10:"Bookpoints";s:7:"version";s:16:"7.x-1.0-beta0324";s:12:"dependencies";a:4:{i:0;s:6:"ctools";i:1;s:3:"eck";i:2;s:5:"feeds";i:3;s:22:"feeds_entity_processor";}s:8:"features";a:3:{s:6:"ctools";a:1:{i:0;s:30:"feeds:feeds_importer_default:1";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:14:"feeds_importer";a:7:{i:0;s:17:"import_activities";i:1;s:13:"import_badges";i:2;s:15:"import_branches";i:3;s:13:"import_prizes";i:4;s:14:"import_schools";i:5;s:19:"import_secret_codes";i:6;s:21:"import_staff_accounts";}}s:12:"project path";s:24:"sites/all/modules/custom";s:11:"description";s:0:"";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:6:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:3:"eck";a:1:{s:4:"name";s:3:"eck";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:5:"feeds";a:1:{s:4:"name";s:5:"feeds";}s:13:"job_scheduler";a:1:{s:4:"name";s:13:"job_scheduler";}s:22:"feeds_entity_processor";a:1:{s:4:"name";s:22:"feeds_entity_processor";}}s:4:"sort";i:-32;s:10:"components";a:4:{i:0;s:6:"ctools";i:1;s:12:"features_api";i:2;s:14:"feeds_importer";i:3;s:12:"dependencies";}}s:20:"date_migrate_example";O:8:"stdClass":12:{s:3:"uri";s:92:"sites/all/modules/contrib/date/date_migrate/date_migrate_example/date_migrate_example.module";s:8:"filename";s:92:"sites/all/modules/contrib/date/date_migrate/date_migrate_example/date_migrate_example.module";s:4:"name";s:20:"date_migrate_example";s:4:"info";a:11:{s:4:"core";s:3:"7.x";s:12:"dependencies";a:5:{i:0;s:4:"date";i:1;s:11:"date_repeat";i:2;s:17:"date_repeat_field";i:3;s:8:"features";i:4;s:7:"migrate";}s:11:"description";s:42:"Examples of migrating with the Date module";s:8:"features";a:2:{s:5:"field";a:8:{i:0;s:30:"node-date_migrate_example-body";i:1;s:36:"node-date_migrate_example-field_date";i:2;s:42:"node-date_migrate_example-field_date_range";i:3;s:43:"node-date_migrate_example-field_date_repeat";i:4;s:41:"node-date_migrate_example-field_datestamp";i:5;s:47:"node-date_migrate_example-field_datestamp_range";i:6;s:40:"node-date_migrate_example-field_datetime";i:7;s:46:"node-date_migrate_example-field_datetime_range";}s:4:"node";a:1:{i:0;s:20:"date_migrate_example";}}s:5:"files";a:1:{i:0;s:32:"date_migrate_example.migrate.inc";}s:4:"name";s:22:"Date Migration Example";s:7:"package";s:8:"Features";s:7:"project";s:4:"date";s:7:"version";s:7:"7.x-2.9";s:9:"datestamp";s:10:"1441727353";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:6:{s:4:"date";a:1:{s:4:"name";s:4:"date";}s:8:"date_api";a:1:{s:4:"name";s:8:"date_api";}s:11:"date_repeat";a:1:{s:4:"name";s:11:"date_repeat";}s:17:"date_repeat_field";a:1:{s:4:"name";s:17:"date_repeat_field";}s:8:"features";a:1:{s:4:"name";s:8:"features";}s:7:"migrate";a:1:{s:4:"name";s:7:"migrate";}}s:4:"sort";i:-55;s:10:"components";a:3:{i:0;s:5:"field";i:1;s:4:"node";i:2;s:12:"dependencies";}}s:15:"entityform_test";O:8:"stdClass":12:{s:3:"uri";s:75:"sites/all/modules/contrib/entityform/entityform_test/entityform_test.module";s:8:"filename";s:75:"sites/all/modules/contrib/entityform/entityform_test/entityform_test.module";s:4:"name";s:15:"entityform_test";s:4:"info";a:11:{s:4:"name";s:15:"entityform_test";s:11:"description";s:33:"Feature for Entityform simpletest";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Features";s:12:"dependencies";a:5:{i:0;s:6:"entity";i:1;s:10:"entityform";i:2;s:8:"features";i:3;s:17:"field_sql_storage";i:4;s:4:"text";}s:8:"features";a:3:{s:15:"entityform_type";a:1:{i:0;s:21:"simpletest_entityform";}s:12:"features_api";a:1:{i:0;s:5:"api:1";}s:5:"field";a:1:{i:0;s:43:"entityform-simpletest_entityform-field_text";}}s:7:"version";s:11:"7.x-2.0-rc1";s:7:"project";s:10:"entityform";s:9:"datestamp";s:10:"1413913852";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:8:{s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:10:"entityform";a:1:{s:4:"name";s:10:"entityform";}s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:8:"features";a:1:{s:4:"name";s:8:"features";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:4:"text";a:1:{s:4:"name";s:4:"text";}}s:4:"sort";i:-74;s:10:"components";a:4:{i:0;s:15:"entityform_type";i:1;s:12:"features_api";i:2;s:5:"field";i:3;s:12:"dependencies";}}s:13:"features_test";O:8:"stdClass":12:{s:3:"uri";s:75:"sites/all/modules/contrib/features/tests/features_test/features_test.module";s:8:"filename";s:75:"sites/all/modules/contrib/features/tests/features_test/features_test.module";s:4:"name";s:13:"features_test";s:4:"info";a:12:{s:4:"name";s:14:"Features Tests";s:11:"description";s:33:"Test module for Features testing.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:12:"dependencies";a:5:{i:0;s:8:"features";i:1;s:5:"image";i:2;s:9:"strongarm";i:3;s:8:"taxonomy";i:4;s:5:"views";}s:8:"features";a:10:{s:6:"ctools";a:2:{i:0;s:21:"strongarm:strongarm:1";i:1;s:23:"views:views_default:3.0";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:10:"field_base";a:1:{i:0;s:19:"field_features_test";}s:14:"field_instance";a:1:{i:0;s:38:"node-features_test-field_features_test";}s:6:"filter";a:1:{i:0;s:13:"features_test";}s:5:"image";a:1:{i:0;s:13:"features_test";}s:4:"node";a:1:{i:0;s:13:"features_test";}s:8:"taxonomy";a:1:{i:0;s:22:"taxonomy_features_test";}s:15:"user_permission";a:1:{i:0;s:28:"create features_test content";}s:10:"views_view";a:1:{i:0;s:13:"features_test";}}s:6:"hidden";s:1:"1";s:7:"version";s:8:"7.x-2.10";s:7:"project";s:8:"features";s:9:"datestamp";s:10:"1461011641";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:10:{s:8:"features";a:1:{s:4:"name";s:8:"features";}s:5:"image";a:1:{s:4:"name";s:5:"image";}s:4:"file";a:1:{s:4:"name";s:4:"file";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:9:"strongarm";a:1:{s:4:"name";s:9:"strongarm";}s:8:"taxonomy";a:1:{s:4:"name";s:8:"taxonomy";}s:7:"options";a:1:{s:4:"name";s:7:"options";}s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-81;s:10:"components";a:11:{i:0;s:6:"ctools";i:1;s:12:"features_api";i:2;s:10:"field_base";i:3;s:14:"field_instance";i:4;s:6:"filter";i:5;s:5:"image";i:6;s:4:"node";i:7;s:8:"taxonomy";i:8;s:15:"user_permission";i:9;s:10:"views_view";i:10;s:12:"dependencies";}}s:12:"feeds_import";O:8:"stdClass":12:{s:3:"uri";s:64:"sites/all/modules/contrib/feeds/feeds_import/feeds_import.module";s:8:"filename";s:64:"sites/all/modules/contrib/feeds/feeds_import/feeds_import.module";s:4:"name";s:12:"feeds_import";s:4:"info";a:11:{s:4:"name";s:12:"Feeds Import";s:11:"description";s:50:"An example of a node importer and a user importer.";s:4:"core";s:3:"7.x";s:7:"package";s:5:"Feeds";s:12:"dependencies";a:2:{i:0;s:6:"ctools";i:1;s:5:"feeds";}s:8:"features";a:3:{s:6:"ctools";a:1:{i:0;s:30:"feeds:feeds_importer_default:1";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:14:"feeds_importer";a:2:{i:0;s:4:"node";i:1;s:4:"user";}}s:5:"files";a:1:{i:0;s:17:"feeds_import.test";}s:7:"version";s:13:"7.x-2.0-beta3";s:7:"project";s:5:"feeds";s:9:"datestamp";s:10:"1479993785";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:5:"feeds";a:1:{s:4:"name";s:5:"feeds";}s:13:"job_scheduler";a:1:{s:4:"name";s:13:"job_scheduler";}}s:4:"sort";i:-82;s:10:"components";a:4:{i:0;s:6:"ctools";i:1;s:12:"features_api";i:2;s:14:"feeds_importer";i:3;s:12:"dependencies";}}s:10:"feeds_news";O:8:"stdClass":12:{s:3:"uri";s:60:"sites/all/modules/contrib/feeds/feeds_news/feeds_news.module";s:8:"filename";s:60:"sites/all/modules/contrib/feeds/feeds_news/feeds_news.module";s:4:"name";s:10:"feeds_news";s:4:"info";a:11:{s:4:"name";s:10:"Feeds News";s:11:"description";s:93:"A news aggregator built with feeds, creates nodes from imported feed items. With OPML import.";s:4:"core";s:3:"7.x";s:7:"package";s:5:"Feeds";s:12:"dependencies";a:4:{i:0;s:6:"ctools";i:1;s:8:"features";i:2;s:5:"feeds";i:3;s:5:"views";}s:8:"features";a:7:{s:6:"ctools";a:2:{i:0;s:30:"feeds:feeds_importer_default:1";i:1;s:23:"views:views_default:3.0";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:14:"feeds_importer";a:2:{i:0;s:4:"feed";i:1;s:4:"opml";}s:10:"field_base";a:1:{i:0;s:27:"field_feed_item_description";}s:14:"field_instance";a:1:{i:0;s:42:"node-feed_item-field_feed_item_description";}s:4:"node";a:2:{i:0;s:4:"feed";i:1;s:9:"feed_item";}s:10:"views_view";a:1:{i:0;s:25:"feeds_defaults_feed_items";}}s:5:"files";a:2:{i:0;s:17:"feeds_news.module";i:1;s:15:"feeds_news.test";}s:7:"version";s:13:"7.x-2.0-beta3";s:7:"project";s:5:"feeds";s:9:"datestamp";s:10:"1479993785";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:5:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:8:"features";a:1:{s:4:"name";s:8:"features";}s:5:"feeds";a:1:{s:4:"name";s:5:"feeds";}s:13:"job_scheduler";a:1:{s:4:"name";s:13:"job_scheduler";}s:5:"views";a:1:{s:4:"name";s:5:"views";}}s:4:"sort";i:-83;s:10:"components";a:8:{i:0;s:6:"ctools";i:1;s:12:"features_api";i:2;s:14:"feeds_importer";i:3;s:10:"field_base";i:4;s:14:"field_instance";i:5;s:4:"node";i:6;s:10:"views_view";i:7;s:12:"dependencies";}}s:21:"uuid_services_example";O:8:"stdClass":12:{s:3:"uri";s:81:"sites/all/modules/contrib/uuid/uuid_services_example/uuid_services_example.module";s:8:"filename";s:81:"sites/all/modules/contrib/uuid/uuid_services_example/uuid_services_example.module";s:4:"name";s:21:"uuid_services_example";s:4:"info";a:11:{s:4:"name";s:21:"UUID Services Example";s:11:"description";s:90:"Example feature of a UUID service. Works well with the Deploy Example feature as a client.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Features";s:12:"dependencies";a:4:{i:0;s:11:"rest_server";i:1;s:8:"services";i:2;s:4:"uuid";i:3;s:13:"uuid_services";}s:8:"features";a:3:{s:6:"ctools";a:1:{i:0;s:19:"services:services:3";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:17:"services_endpoint";a:1:{i:0;s:21:"uuid_services_example";}}s:7:"version";s:13:"7.x-1.0-beta2";s:7:"project";s:4:"uuid";s:9:"datestamp";s:10:"1470153540";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:7:{s:11:"rest_server";a:1:{s:4:"name";s:11:"rest_server";}s:8:"services";a:1:{s:4:"name";s:8:"services";}s:4:"uuid";a:1:{s:4:"name";s:4:"uuid";}s:4:"node";a:1:{s:4:"name";s:4:"node";}s:4:"user";a:1:{s:4:"name";s:4:"user";}s:13:"uuid_services";a:1:{s:4:"name";s:13:"uuid_services";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-164;s:10:"components";a:4:{i:0;s:6:"ctools";i:1;s:12:"features_api";i:2;s:17:"services_endpoint";i:3;s:12:"dependencies";}}}s:6:"module";a:305:{s:15:"aaa_update_test";O:8:"stdClass":11:{s:3:"uri";s:43:"modules/update/tests/aaa_update_test.module";s:8:"filename";s:43:"modules/update/tests/aaa_update_test.module";s:4:"name";s:15:"aaa_update_test";s:4:"info";a:11:{s:4:"name";s:15:"AAA Update test";s:11:"description";s:41:"Support module for update module testing.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:17:"actions_loop_test";O:8:"stdClass":11:{s:3:"uri";s:49:"modules/simpletest/tests/actions_loop_test.module";s:8:"filename";s:49:"modules/simpletest/tests/actions_loop_test.module";s:4:"name";s:17:"actions_loop_test";s:4:"info";a:11:{s:4:"name";s:17:"Actions loop test";s:11:"description";s:39:"Support module for action loop testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:19:"actions_permissions";O:8:"stdClass":11:{s:3:"uri";s:74:"sites/all/modules/contrib/views_bulk_operations/actions_permissions.module";s:8:"filename";s:74:"sites/all/modules/contrib/views_bulk_operations/actions_permissions.module";s:4:"name";s:19:"actions_permissions";s:4:"info";a:10:{s:4:"name";s:25:"Actions permissions (VBO)";s:11:"description";s:84:"Provides permission-based access control for actions. Used by Views Bulk Operations.";s:7:"package";s:14:"Administration";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-3.3";s:7:"project";s:21:"views_bulk_operations";s:9:"datestamp";s:10:"1435764542";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:12:"addressfield";O:8:"stdClass":11:{s:3:"uri";s:58:"sites/all/modules/contrib/addressfield/addressfield.module";s:8:"filename";s:58:"sites/all/modules/contrib/addressfield/addressfield.module";s:4:"name";s:12:"addressfield";s:4:"info";a:12:{s:4:"name";s:13:"Address Field";s:11:"description";s:64:"Manage a flexible address field, implementing the xNAL standard.";s:4:"core";s:3:"7.x";s:7:"package";s:6:"Fields";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:5:"files";a:4:{i:0;s:24:"addressfield.migrate.inc";i:1;s:62:"views/addressfield_views_handler_field_administrative_area.inc";i:2;s:50:"views/addressfield_views_handler_field_country.inc";i:3;s:51:"views/addressfield_views_handler_filter_country.inc";}s:7:"version";s:7:"7.x-1.2";s:7:"project";s:12:"addressfield";s:9:"datestamp";s:10:"1444254070";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7001";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:20:"addressfield_example";a:1:{s:4:"name";s:12:"addressfield";}}s:8:"requires";a:1:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-1;}s:20:"addressfield_example";O:8:"stdClass":11:{s:3:"uri";s:74:"sites/all/modules/contrib/addressfield/example/addressfield_example.module";s:8:"filename";s:74:"sites/all/modules/contrib/addressfield/example/addressfield_example.module";s:4:"name";s:20:"addressfield_example";s:4:"info";a:11:{s:4:"name";s:21:"Address Field Example";s:11:"description";s:67:"Example module for how to implement an addressfield format handler.";s:4:"core";s:3:"7.x";s:7:"package";s:6:"Fields";s:6:"hidden";b:1;s:12:"dependencies";a:2:{i:0;s:6:"ctools";i:1;s:12:"addressfield";}s:7:"version";s:7:"7.x-1.2";s:7:"project";s:12:"addressfield";s:9:"datestamp";s:10:"1444254070";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:12:"addressfield";a:1:{s:4:"name";s:12:"addressfield";}}s:4:"sort";i:-2;}s:11:"admin_devel";O:8:"stdClass":11:{s:3:"uri";s:67:"sites/all/modules/contrib/admin_menu/admin_devel/admin_devel.module";s:8:"filename";s:67:"sites/all/modules/contrib/admin_menu/admin_devel/admin_devel.module";s:4:"name";s:11:"admin_devel";s:4:"info";a:11:{s:4:"name";s:32:"Administration Development tools";s:11:"description";s:76:"Administration and debugging functionality for developers and site builders.";s:7:"package";s:14:"Administration";s:4:"core";s:3:"7.x";s:7:"scripts";a:1:{s:14:"admin_devel.js";s:63:"sites/all/modules/contrib/admin_menu/admin_devel/admin_devel.js";}s:7:"version";s:11:"7.x-3.0-rc5";s:7:"project";s:10:"admin_menu";s:9:"datestamp";s:10:"1419029284";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:14:"admin_language";O:8:"stdClass":11:{s:3:"uri";s:62:"sites/all/modules/contrib/admin_language/admin_language.module";s:8:"filename";s:62:"sites/all/modules/contrib/admin_language/admin_language.module";s:4:"name";s:14:"admin_language";s:4:"info";a:11:{s:4:"name";s:23:"Administration language";s:11:"description";s:97:"Makes sure all administration pages are displayed in the preferred language of the administrator.";s:12:"dependencies";a:1:{i:0;s:6:"locale";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:9:"configure";s:45:"admin/config/regional/language/admin_language";s:7:"version";s:13:"7.x-1.0-beta4";s:7:"project";s:14:"admin_language";s:9:"datestamp";s:10:"1473428686";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:6:"locale";a:1:{s:4:"name";s:6:"locale";}}s:4:"sort";i:-4;}s:10:"admin_menu";O:8:"stdClass":11:{s:3:"uri";s:54:"sites/all/modules/contrib/admin_menu/admin_menu.module";s:8:"filename";s:54:"sites/all/modules/contrib/admin_menu/admin_menu.module";s:4:"name";s:10:"admin_menu";s:4:"info";a:11:{s:4:"name";s:19:"Administration menu";s:11:"description";s:123:"Provides a dropdown menu to most administrative tasks and other common destinations (to users with the proper permissions).";s:7:"package";s:14:"Administration";s:4:"core";s:3:"7.x";s:9:"configure";s:38:"admin/config/administration/admin_menu";s:12:"dependencies";a:1:{i:0;s:14:"system (>7.10)";}s:5:"files";a:1:{i:0;s:21:"tests/admin_menu.test";}s:7:"version";s:11:"7.x-3.0-rc5";s:7:"project";s:10:"admin_menu";s:9:"datestamp";s:10:"1419029284";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7304";s:6:"weight";s:3:"100";s:11:"required_by";a:1:{s:18:"admin_menu_toolbar";a:1:{s:4:"name";s:10:"admin_menu";}}s:8:"requires";a:1:{s:6:"system";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:8:" (>7.10)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:4:"7.10";}}}}s:4:"sort";i:-6;}s:18:"admin_menu_toolbar";O:8:"stdClass":11:{s:3:"uri";s:81:"sites/all/modules/contrib/admin_menu/admin_menu_toolbar/admin_menu_toolbar.module";s:8:"filename";s:81:"sites/all/modules/contrib/admin_menu/admin_menu_toolbar/admin_menu_toolbar.module";s:4:"name";s:18:"admin_menu_toolbar";s:4:"info";a:10:{s:4:"name";s:33:"Administration menu Toolbar style";s:11:"description";s:17:"A better Toolbar.";s:7:"package";s:14:"Administration";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:10:"admin_menu";}s:7:"version";s:11:"7.x-3.0-rc5";s:7:"project";s:10:"admin_menu";s:9:"datestamp";s:10:"1419029284";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:10:"admin_menu";a:1:{s:4:"name";s:10:"admin_menu";}s:6:"system";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:8:" (>7.10)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:4:"7.10";}}}}s:4:"sort";i:-7;}s:11:"admin_views";O:8:"stdClass":11:{s:3:"uri";s:56:"sites/all/modules/contrib/admin_views/admin_views.module";s:8:"filename";s:56:"sites/all/modules/contrib/admin_views/admin_views.module";s:4:"name";s:11:"admin_views";s:4:"info";a:10:{s:4:"name";s:20:"Administration views";s:11:"description";s:75:"Replaces all system object management pages in Drupal core with real views.";s:7:"package";s:14:"Administration";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:5:"views";i:1;s:33:"views_bulk_operations (>=7.x-3.2)";}s:5:"files";a:3:{i:0;s:39:"plugins/views_plugin_display_system.inc";i:1;s:36:"plugins/views_plugin_access_menu.inc";i:2;s:22:"tests/admin_views.test";}s:7:"version";s:7:"7.x-1.6";s:7:"project";s:11:"admin_views";s:9:"datestamp";s:10:"1470165840";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:2:"12";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:21:"views_bulk_operations";a:3:{s:4:"name";s:21:"views_bulk_operations";s:16:"original_version";s:12:" (>=7.x-3.2)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"3.2";}}}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-11;}s:16:"admin_views_test";O:8:"stdClass":11:{s:3:"uri";s:84:"sites/all/modules/contrib/admin_views/tests/admin_views_test/admin_views_test.module";s:8:"filename";s:84:"sites/all/modules/contrib/admin_views/tests/admin_views_test/admin_views_test.module";s:4:"name";s:16:"admin_views_test";s:4:"info";a:11:{s:4:"name";s:25:"Administration views test";s:11:"description";s:32:"Administration views test module";s:4:"core";s:3:"7.x";s:7:"package";s:14:"administration";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-1.6";s:7:"project";s:11:"admin_views";s:9:"datestamp";s:10:"1470165840";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:13:"advanced_help";O:8:"stdClass":11:{s:3:"uri";s:60:"sites/all/modules/contrib/advanced_help/advanced_help.module";s:8:"filename";s:60:"sites/all/modules/contrib/advanced_help/advanced_help.module";s:4:"name";s:13:"advanced_help";s:4:"info";a:11:{s:4:"name";s:13:"Advanced help";s:11:"description";s:40:"Provide extended help and documentation.";s:4:"core";s:3:"7.x";s:12:"attributions";a:1:{s:10:"click_icon";a:7:{s:4:"type";s:5:"asset";s:9:"exception";s:8:"#2460769";s:6:"author";s:14:"Gisle Hannemyr";s:4:"hide";b:1;s:5:"title";s:14:"click_icon.png";s:7:"license";s:18:"Creative Commons 0";s:11:"license_url";s:50:"https://creativecommons.org/publicdomain/zero/1.0/";}}s:7:"version";s:7:"7.x-1.3";s:7:"project";s:13:"advanced_help";s:9:"datestamp";s:10:"1432557782";s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:2:{s:21:"ctools_plugin_example";a:1:{s:4:"name";s:13:"advanced_help";}s:12:"help_example";a:1:{s:4:"name";s:13:"advanced_help";}}s:8:"requires";a:0:{}s:4:"sort";i:-12;}s:10:"aggregator";O:8:"stdClass":11:{s:3:"uri";s:36:"modules/aggregator/aggregator.module";s:8:"filename";s:36:"modules/aggregator/aggregator.module";s:4:"name";s:10:"aggregator";s:4:"info";a:12:{s:4:"name";s:10:"Aggregator";s:11:"description";s:57:"Aggregates syndicated content (RSS, RDF, and Atom feeds).";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:15:"aggregator.test";}s:9:"configure";s:41:"admin/config/services/aggregator/settings";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:14:"aggregator.css";s:33:"modules/aggregator/aggregator.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:15:"aggregator_test";O:8:"stdClass":11:{s:3:"uri";s:47:"modules/aggregator/tests/aggregator_test.module";s:8:"filename";s:47:"modules/aggregator/tests/aggregator_test.module";s:4:"name";s:15:"aggregator_test";s:4:"info";a:11:{s:4:"name";s:23:"Aggregator module tests";s:11:"description";s:46:"Support module for aggregator related testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:15:"ajax_forms_test";O:8:"stdClass":11:{s:3:"uri";s:47:"modules/simpletest/tests/ajax_forms_test.module";s:8:"filename";s:47:"modules/simpletest/tests/ajax_forms_test.module";s:4:"name";s:15:"ajax_forms_test";s:4:"info";a:11:{s:4:"name";s:26:"AJAX form test mock module";s:11:"description";s:25:"Test for AJAX form calls.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:9:"ajax_test";O:8:"stdClass":11:{s:3:"uri";s:41:"modules/simpletest/tests/ajax_test.module";s:8:"filename";s:41:"modules/simpletest/tests/ajax_test.module";s:4:"name";s:9:"ajax_test";s:4:"info";a:11:{s:4:"name";s:9:"AJAX Test";s:11:"description";s:40:"Support module for AJAX framework tests.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:14:"backup_migrate";O:8:"stdClass":11:{s:3:"uri";s:62:"sites/all/modules/contrib/backup_migrate/backup_migrate.module";s:8:"filename";s:62:"sites/all/modules/contrib/backup_migrate/backup_migrate.module";s:4:"name";s:14:"backup_migrate";s:4:"info";a:11:{s:4:"name";s:18:"Backup and Migrate";s:11:"description";s:76:"Backup the Drupal database and files or migrate them to another environment.";s:4:"core";s:3:"7.x";s:5:"files";a:3:{i:0;s:25:"includes/destinations.inc";i:1;s:21:"includes/profiles.inc";i:2;s:22:"includes/schedules.inc";}s:9:"configure";s:34:"admin/config/system/backup_migrate";s:7:"version";s:7:"7.x-3.1";s:7:"project";s:14:"backup_migrate";s:9:"datestamp";s:10:"1431350582";s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7304";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:10:"batch_test";O:8:"stdClass":11:{s:3:"uri";s:42:"modules/simpletest/tests/batch_test.module";s:8:"filename";s:42:"modules/simpletest/tests/batch_test.module";s:4:"name";s:10:"batch_test";s:4:"info";a:11:{s:4:"name";s:14:"Batch API test";s:11:"description";s:35:"Support module for Batch API tests.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:15:"bbb_update_test";O:8:"stdClass":11:{s:3:"uri";s:43:"modules/update/tests/bbb_update_test.module";s:8:"filename";s:43:"modules/update/tests/bbb_update_test.module";s:4:"name";s:15:"bbb_update_test";s:4:"info";a:11:{s:4:"name";s:15:"BBB Update test";s:11:"description";s:41:"Support module for update module testing.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:5:"block";O:8:"stdClass":11:{s:3:"uri";s:26:"modules/block/block.module";s:8:"filename";s:26:"modules/block/block.module";s:4:"name";s:5:"block";s:4:"info";a:11:{s:4:"name";s:5:"Block";s:11:"description";s:140:"Controls the visual building blocks a page is constructed with. Blocks are boxes of content rendered into an area, or region, of a web page.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:10:"block.test";}s:9:"configure";s:21:"admin/structure/block";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7009";s:6:"weight";s:2:"-5";s:11:"required_by";a:6:{s:11:"block_class";a:1:{s:4:"name";s:5:"block";}s:9:"dashboard";a:1:{s:4:"name";s:5:"block";}s:12:"entity_block";a:1:{s:4:"name";s:5:"block";}s:10:"i18n_block";a:1:{s:4:"name";s:5:"block";}s:8:"pantheon";a:1:{s:4:"name";s:5:"block";}s:25:"relation_entity_collector";a:1:{s:4:"name";s:5:"block";}}s:8:"requires";a:0:{}s:4:"sort";i:-13;}s:12:"block_access";O:8:"stdClass":11:{s:3:"uri";s:58:"sites/all/modules/contrib/block_access/block_access.module";s:8:"filename";s:58:"sites/all/modules/contrib/block_access/block_access.module";s:4:"name";s:12:"block_access";s:4:"info";a:10:{s:4:"name";s:12:"Block Access";s:11:"description";s:54:"Provides flexible block administration access control.";s:7:"package";s:14:"Access control";s:4:"core";s:3:"7.x";s:5:"files";a:15:{i:0;s:20:"block_access.install";i:1;s:19:"block_access.module";i:2;s:22:"block_access.admin.inc";i:3;s:19:"block_access.db.inc";i:4;s:22:"block_access.theme.inc";i:5;s:17:"tests/common.test";i:6;s:13:"tests/ui.test";i:7;s:24:"tests/op_basic_view.test";i:8;s:24:"tests/op_basic_move.test";i:9;s:26:"tests/op_basic_enable.test";i:10;s:27:"tests/op_basic_disable.test";i:11;s:26:"tests/op_basic_config.test";i:12;s:26:"tests/op_basic_delete.test";i:13;s:20:"tests/op_config.test";i:14;s:20:"tests/op_region.test";}s:7:"version";s:7:"7.x-1.6";s:7:"project";s:12:"block_access";s:9:"datestamp";s:10:"1425477100";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:11:"block_class";O:8:"stdClass":11:{s:3:"uri";s:56:"sites/all/modules/contrib/block_class/block_class.module";s:8:"filename";s:56:"sites/all/modules/contrib/block_class/block_class.module";s:4:"name";s:11:"block_class";s:4:"info";a:11:{s:4:"name";s:11:"Block Class";s:11:"description";s:39:"Allows assigning CSS classes to blocks.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"block";}s:5:"files";a:1:{i:0;s:16:"block_class.test";}s:17:"test_dependencies";a:3:{i:0;s:7:"context";i:1;s:14:"features (2.x)";i:2;s:14:"features_extra";}s:7:"version";s:7:"7.x-2.3";s:7:"project";s:11:"block_class";s:9:"datestamp";s:10:"1450415951";s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7103";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:5:"block";a:1:{s:4:"name";s:5:"block";}}s:4:"sort";i:-14;}s:25:"block_class_fe_block_test";r:3;s:10:"block_test";O:8:"stdClass":11:{s:3:"uri";s:37:"modules/block/tests/block_test.module";s:8:"filename";s:37:"modules/block/tests/block_test.module";s:4:"name";s:10:"block_test";s:4:"info";a:11:{s:4:"name";s:10:"Block test";s:11:"description";s:21:"Provides test blocks.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"blog";O:8:"stdClass":11:{s:3:"uri";s:24:"modules/blog/blog.module";s:8:"filename";s:24:"modules/blog/blog.module";s:4:"name";s:4:"blog";s:4:"info";a:10:{s:4:"name";s:4:"Blog";s:11:"description";s:25:"Enables multi-user blogs.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:9:"blog.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"rdf_test";a:1:{s:4:"name";s:4:"blog";}}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"book";O:8:"stdClass":11:{s:3:"uri";s:24:"modules/book/book.module";s:8:"filename";s:24:"modules/book/book.module";s:4:"name";s:4:"book";s:4:"info";a:12:{s:4:"name";s:4:"Book";s:11:"description";s:66:"Allows users to create and organize related content in an outline.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:9:"book.test";}s:9:"configure";s:27:"admin/content/book/settings";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:8:"book.css";s:21:"modules/book/book.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:9:"book_logs";r:92;s:8:"booklist";r:38;s:18:"bookpoints_drawing";r:133;s:17:"bookpoints_events";r:174;s:20:"bookpoints_importers";r:258;s:11:"boot_test_1";O:8:"stdClass":11:{s:3:"uri";s:43:"modules/simpletest/tests/boot_test_1.module";s:8:"filename";s:43:"modules/simpletest/tests/boot_test_1.module";s:4:"name";s:11:"boot_test_1";s:4:"info";a:11:{s:4:"name";s:21:"Early bootstrap tests";s:11:"description";s:39:"A support module for hook_boot testing.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:11:"boot_test_2";O:8:"stdClass":11:{s:3:"uri";s:43:"modules/simpletest/tests/boot_test_2.module";s:8:"filename";s:43:"modules/simpletest/tests/boot_test_2.module";s:4:"name";s:11:"boot_test_2";s:4:"info";a:11:{s:4:"name";s:21:"Early bootstrap tests";s:11:"description";s:44:"A support module for hook_boot hook testing.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:11:"bulk_export";O:8:"stdClass":11:{s:3:"uri";s:63:"sites/all/modules/contrib/ctools/bulk_export/bulk_export.module";s:8:"filename";s:63:"sites/all/modules/contrib/ctools/bulk_export/bulk_export.module";s:4:"name";s:11:"bulk_export";s:4:"info";a:10:{s:4:"name";s:11:"Bulk Export";s:11:"description";s:67:"Performs bulk exporting of data objects known about by Chaos tools.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-33;}s:8:"calendar";O:8:"stdClass":11:{s:3:"uri";s:50:"sites/all/modules/contrib/calendar/calendar.module";s:8:"filename";s:50:"sites/all/modules/contrib/calendar/calendar.module";s:4:"name";s:8:"calendar";s:4:"info";a:11:{s:4:"name";s:8:"Calendar";s:11:"description";s:60:"Views plugin to display views containing dates as Calendars.";s:12:"dependencies";a:3:{i:0;s:5:"views";i:1;s:8:"date_api";i:2;s:10:"date_views";}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:25:"css/calendar_multiday.css";s:60:"sites/all/modules/contrib/calendar/css/calendar_multiday.css";}}s:5:"files";a:8:{i:0;s:16:"calendar.install";i:1;s:15:"calendar.module";i:2;s:27:"includes/calendar.views.inc";i:3;s:34:"includes/calendar_plugin_style.inc";i:4;s:32:"includes/calendar_plugin_row.inc";i:5;s:36:"includes/calendar.views_template.inc";i:6;s:15:"theme/theme.inc";i:7;s:28:"theme/calendar-style.tpl.php";}s:7:"version";s:7:"7.x-3.5";s:7:"project";s:8:"calendar";s:9:"datestamp";s:10:"1413299943";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7002";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:17:"bookpoints_events";a:1:{s:4:"name";s:8:"calendar";}}s:8:"requires";a:4:{s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:8:"date_api";a:1:{s:4:"name";s:8:"date_api";}s:10:"date_views";a:1:{s:4:"name";s:10:"date_views";}}s:4:"sort";i:-19;}s:15:"ccc_update_test";O:8:"stdClass":11:{s:3:"uri";s:43:"modules/update/tests/ccc_update_test.module";s:8:"filename";s:43:"modules/update/tests/ccc_update_test.module";s:4:"name";s:15:"ccc_update_test";s:4:"info";a:11:{s:4:"name";s:15:"CCC Update test";s:11:"description";s:41:"Support module for update module testing.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:5:"color";O:8:"stdClass":11:{s:3:"uri";s:26:"modules/color/color.module";s:8:"filename";s:26:"modules/color/color.module";s:4:"name";s:5:"color";s:4:"info";a:10:{s:4:"name";s:5:"Color";s:11:"description";s:70:"Allows administrators to change the color scheme of compatible themes.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:10:"color.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7001";s:6:"weight";s:1:"0";s:11:"required_by";a:2:{s:8:"pantheon";a:1:{s:4:"name";s:5:"color";}s:8:"stylizer";a:1:{s:4:"name";s:5:"color";}}s:8:"requires";a:0:{}s:4:"sort";i:-34;}s:7:"comment";O:8:"stdClass":11:{s:3:"uri";s:30:"modules/comment/comment.module";s:8:"filename";s:30:"modules/comment/comment.module";s:4:"name";s:7:"comment";s:4:"info";a:12:{s:4:"name";s:7:"Comment";s:11:"description";s:57:"Allows users to comment on and discuss published content.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:4:"text";}s:5:"files";a:2:{i:0;s:14:"comment.module";i:1;s:12:"comment.test";}s:9:"configure";s:21:"admin/content/comment";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:11:"comment.css";s:27:"modules/comment/comment.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7009";s:6:"weight";s:1:"0";s:11:"required_by";a:6:{s:22:"flag_comment_flag_test";a:1:{s:4:"name";s:7:"comment";}s:5:"forum";a:1:{s:4:"name";s:7:"comment";}s:10:"i18n_forum";a:1:{s:4:"name";s:7:"comment";}s:8:"pantheon";a:1:{s:4:"name";s:7:"comment";}s:18:"requirements2_test";a:1:{s:4:"name";s:7:"comment";}s:7:"tracker";a:1:{s:4:"name";s:7:"comment";}}s:8:"requires";a:3:{s:4:"text";a:1:{s:4:"name";s:4:"text";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-35;}s:11:"common_test";O:8:"stdClass":11:{s:3:"uri";s:43:"modules/simpletest/tests/common_test.module";s:8:"filename";s:43:"modules/simpletest/tests/common_test.module";s:4:"name";s:11:"common_test";s:4:"info";a:12:{s:4:"name";s:11:"Common Test";s:11:"description";s:32:"Support module for Common tests.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:2:{s:3:"all";a:1:{s:15:"common_test.css";s:40:"modules/simpletest/tests/common_test.css";}s:5:"print";a:1:{s:21:"common_test.print.css";s:46:"modules/simpletest/tests/common_test.print.css";}}s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:23:"common_test_cron_helper";O:8:"stdClass":11:{s:3:"uri";s:55:"modules/simpletest/tests/common_test_cron_helper.module";s:8:"filename";s:55:"modules/simpletest/tests/common_test_cron_helper.module";s:4:"name";s:23:"common_test_cron_helper";s:4:"info";a:11:{s:4:"name";s:23:"Common Test Cron Helper";s:11:"description";s:56:"Helper module for CronRunTestCase::testCronExceptions().";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:7:"contact";O:8:"stdClass":11:{s:3:"uri";s:30:"modules/contact/contact.module";s:8:"filename";s:30:"modules/contact/contact.module";s:4:"name";s:7:"contact";s:4:"info";a:11:{s:4:"name";s:7:"Contact";s:11:"description";s:61:"Enables the use of both personal and site-wide contact forms.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:12:"contact.test";}s:9:"configure";s:23:"admin/structure/contact";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:12:"i18n_contact";a:1:{s:4:"name";s:7:"contact";}}s:8:"requires";a:0:{}s:4:"sort";i:-36;}s:14:"content_access";O:8:"stdClass":11:{s:3:"uri";s:62:"sites/all/modules/contrib/content_access/content_access.module";s:8:"filename";s:62:"sites/all/modules/contrib/content_access/content_access.module";s:4:"name";s:14:"content_access";s:4:"info";a:10:{s:4:"name";s:14:"Content Access";s:11:"description";s:41:"Provides flexible content access control.";s:4:"core";s:3:"7.x";s:7:"package";s:14:"Access control";s:5:"files";a:3:{i:0;s:24:"content_access.rules.inc";i:1;s:25:"tests/content_access.test";i:2;s:29:"tests/content_access_acl.test";}s:7:"version";s:19:"7.x-1.2-BETA2+0-dev";s:7:"project";s:14:"content_access";s:9:"datestamp";s:10:"1380566961";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7101";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:20:"content_access_rules";a:1:{s:4:"name";s:14:"content_access";}}s:8:"requires";a:0:{}s:4:"sort";i:-37;}s:20:"content_access_rules";O:8:"stdClass":11:{s:3:"uri";s:89:"sites/all/modules/contrib/content_access/content_access_rules/content_access_rules.module";s:8:"filename";s:89:"sites/all/modules/contrib/content_access/content_access_rules/content_access_rules.module";s:4:"name";s:20:"content_access_rules";s:4:"info";a:10:{s:4:"name";s:33:"Content Access Rules Integrations";s:11:"description";s:94:"Integrates Rules with Content access. Allows to act on access events, conditions, and actions.";s:7:"package";s:14:"Access control";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:14:"content_access";i:1;s:5:"rules";}s:5:"files";a:1:{i:0;s:24:"content_access.rules.inc";}s:7:"version";s:19:"7.x-1.2-BETA2+0-dev";s:7:"project";s:14:"content_access";s:9:"datestamp";s:10:"1380566961";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:14:"content_access";a:1:{s:4:"name";s:14:"content_access";}s:5:"rules";a:1:{s:4:"name";s:5:"rules";}s:12:"entity_token";a:1:{s:4:"name";s:12:"entity_token";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-40;}s:10:"contextual";O:8:"stdClass":11:{s:3:"uri";s:36:"modules/contextual/contextual.module";s:8:"filename";s:36:"modules/contextual/contextual.module";s:4:"name";s:10:"contextual";s:4:"info";a:10:{s:4:"name";s:16:"Contextual links";s:11:"description";s:75:"Provides contextual links to perform actions related to elements on a page.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:15:"contextual.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"pantheon";a:1:{s:4:"name";s:10:"contextual";}}s:8:"requires";a:0:{}s:4:"sort";i:-41;}s:15:"cron_queue_test";O:8:"stdClass":11:{s:3:"uri";s:43:"modules/system/tests/cron_queue_test.module";s:8:"filename";s:43:"modules/system/tests/cron_queue_test.module";s:4:"name";s:15:"cron_queue_test";s:4:"info";a:11:{s:4:"name";s:15:"Cron Queue test";s:11:"description";s:41:"Support module for the cron queue runner.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:6:"ctools";O:8:"stdClass":11:{s:3:"uri";s:46:"sites/all/modules/contrib/ctools/ctools.module";s:8:"filename";s:46:"sites/all/modules/contrib/ctools/ctools.module";s:4:"name";s:6:"ctools";s:4:"info";a:10:{s:4:"name";s:11:"Chaos tools";s:11:"description";s:46:"A library of helpful tools by Merlin of Chaos.";s:4:"core";s:3:"7.x";s:7:"package";s:16:"Chaos tool suite";s:5:"files";a:5:{i:0;s:20:"includes/context.inc";i:1;s:22:"includes/css-cache.inc";i:2;s:22:"includes/math-expr.inc";i:3;s:21:"includes/stylizer.inc";i:4;s:20:"tests/css_cache.test";}s:7:"version";s:8:"7.x-1.11";s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7001";s:6:"weight";s:1:"0";s:11:"required_by";a:56:{s:12:"addressfield";a:1:{s:4:"name";s:6:"ctools";}s:20:"addressfield_example";a:1:{s:4:"name";s:6:"ctools";}s:5:"views";a:1:{s:4:"name";s:6:"ctools";}s:21:"views_bulk_operations";a:1:{s:4:"name";s:6:"ctools";}s:11:"admin_views";a:1:{s:4:"name";s:6:"ctools";}s:9:"book_logs";a:1:{s:4:"name";s:6:"ctools";}s:18:"bookpoints_drawing";a:1:{s:4:"name";s:6:"ctools";}s:10:"date_views";a:1:{s:4:"name";s:6:"ctools";}s:8:"calendar";a:1:{s:4:"name";s:6:"ctools";}s:15:"entityreference";a:1:{s:4:"name";s:6:"ctools";}s:17:"bookpoints_events";a:1:{s:4:"name";s:6:"ctools";}s:3:"eck";a:1:{s:4:"name";s:6:"ctools";}s:5:"feeds";a:1:{s:4:"name";s:6:"ctools";}s:22:"feeds_entity_processor";a:1:{s:4:"name";s:6:"ctools";}s:20:"bookpoints_importers";a:1:{s:4:"name";s:6:"ctools";}s:11:"bulk_export";a:1:{s:4:"name";s:6:"ctools";}s:21:"ctools_access_ruleset";a:1:{s:4:"name";s:6:"ctools";}s:18:"ctools_ajax_sample";a:1:{s:4:"name";s:6:"ctools";}s:21:"ctools_custom_content";a:1:{s:4:"name";s:6:"ctools";}s:18:"ctools_export_test";a:1:{s:4:"name";s:6:"ctools";}s:6:"panels";a:1:{s:4:"name";s:6:"ctools";}s:12:"page_manager";a:1:{s:4:"name";s:6:"ctools";}s:21:"ctools_plugin_example";a:1:{s:4:"name";s:6:"ctools";}s:18:"ctools_plugin_test";a:1:{s:4:"name";s:6:"ctools";}s:15:"eck_entitycache";a:1:{s:4:"name";s:6:"ctools";}s:11:"eck_example";a:1:{s:4:"name";s:6:"ctools";}s:12:"eck_services";a:1:{s:4:"name";s:6:"ctools";}s:12:"entity_block";a:1:{s:4:"name";s:6:"ctools";}s:10:"entityform";a:1:{s:4:"name";s:6:"ctools";}s:20:"entityform_anonymous";a:1:{s:4:"name";s:6:"ctools";}s:24:"entityform_notifications";a:1:{s:4:"name";s:6:"ctools";}s:15:"entityform_test";a:1:{s:4:"name";s:6:"ctools";}s:32:"entityreference_behavior_example";a:1:{s:4:"name";s:6:"ctools";}s:8:"feeds_ui";a:1:{s:4:"name";s:6:"ctools";}s:26:"entityreference_feeds_test";a:1:{s:4:"name";s:6:"ctools";}s:13:"features_test";a:1:{s:4:"name";s:6:"ctools";}s:12:"feeds_import";a:1:{s:4:"name";s:6:"ctools";}s:10:"feeds_news";a:1:{s:4:"name";s:6:"ctools";}s:11:"field_group";a:1:{s:4:"name";s:6:"ctools";}s:20:"field_group_multiple";a:1:{s:4:"name";s:6:"ctools";}s:11:"i18n_panels";a:1:{s:4:"name";s:6:"ctools";}s:9:"i18nviews";a:1:{s:4:"name";s:6:"ctools";}s:10:"panels_ipe";a:1:{s:4:"name";s:6:"ctools";}s:11:"panels_mini";a:1:{s:4:"name";s:6:"ctools";}s:11:"panels_node";a:1:{s:4:"name";s:6:"ctools";}s:20:"relation_ctools_test";a:1:{s:4:"name";s:6:"ctools";}s:14:"relation_feeds";a:1:{s:4:"name";s:6:"ctools";}s:21:"relation_migrate_test";a:1:{s:4:"name";s:6:"ctools";}s:8:"stylizer";a:1:{s:4:"name";s:6:"ctools";}s:10:"term_depth";a:1:{s:4:"name";s:6:"ctools";}s:14:"variable_views";a:1:{s:4:"name";s:6:"ctools";}s:13:"views_content";a:1:{s:4:"name";s:6:"ctools";}s:17:"views_data_export";a:1:{s:4:"name";s:6:"ctools";}s:10:"views_test";a:1:{s:4:"name";s:6:"ctools";}s:8:"views_ui";a:1:{s:4:"name";s:6:"ctools";}s:14:"workflow_views";a:1:{s:4:"name";s:6:"ctools";}}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:21:"ctools_access_ruleset";O:8:"stdClass":11:{s:3:"uri";s:83:"sites/all/modules/contrib/ctools/ctools_access_ruleset/ctools_access_ruleset.module";s:8:"filename";s:83:"sites/all/modules/contrib/ctools/ctools_access_ruleset/ctools_access_ruleset.module";s:4:"name";s:21:"ctools_access_ruleset";s:4:"info";a:10:{s:4:"name";s:15:"Custom rulesets";s:11:"description";s:81:"Create custom, exportable, reusable access rulesets for applications like Panels.";s:4:"core";s:3:"7.x";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-42;}s:18:"ctools_ajax_sample";O:8:"stdClass":11:{s:3:"uri";s:77:"sites/all/modules/contrib/ctools/ctools_ajax_sample/ctools_ajax_sample.module";s:8:"filename";s:77:"sites/all/modules/contrib/ctools/ctools_ajax_sample/ctools_ajax_sample.module";s:4:"name";s:18:"ctools_ajax_sample";s:4:"info";a:10:{s:4:"name";s:33:"Chaos Tools (CTools) AJAX Example";s:11:"description";s:41:"Shows how to use the power of Chaos AJAX.";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:4:"core";s:3:"7.x";s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-43;}s:21:"ctools_custom_content";O:8:"stdClass":11:{s:3:"uri";s:83:"sites/all/modules/contrib/ctools/ctools_custom_content/ctools_custom_content.module";s:8:"filename";s:83:"sites/all/modules/contrib/ctools/ctools_custom_content/ctools_custom_content.module";s:4:"name";s:21:"ctools_custom_content";s:4:"info";a:10:{s:4:"name";s:20:"Custom content panes";s:11:"description";s:79:"Create custom, exportable, reusable content panes for applications like Panels.";s:4:"core";s:3:"7.x";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-44;}s:18:"ctools_export_test";O:8:"stdClass":11:{s:3:"uri";s:83:"sites/all/modules/contrib/ctools/tests/ctools_export_test/ctools_export_test.module";s:8:"filename";s:83:"sites/all/modules/contrib/ctools/tests/ctools_export_test/ctools_export_test.module";s:4:"name";s:18:"ctools_export_test";s:4:"info";a:11:{s:4:"name";s:18:"CTools export test";s:11:"description";s:25:"CTools export test module";s:4:"core";s:3:"7.x";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:6:"hidden";b:1;s:5:"files";a:1:{i:0;s:18:"ctools_export.test";}s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-45;}s:21:"ctools_plugin_example";O:8:"stdClass":11:{s:3:"uri";s:83:"sites/all/modules/contrib/ctools/ctools_plugin_example/ctools_plugin_example.module";s:8:"filename";s:83:"sites/all/modules/contrib/ctools/ctools_plugin_example/ctools_plugin_example.module";s:4:"name";s:21:"ctools_plugin_example";s:4:"info";a:10:{s:4:"name";s:35:"Chaos Tools (CTools) Plugin Example";s:11:"description";s:75:"Shows how an external module can provide ctools plugins (for Panels, etc.).";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:12:"dependencies";a:4:{i:0;s:6:"ctools";i:1;s:6:"panels";i:2;s:12:"page_manager";i:3;s:13:"advanced_help";}s:4:"core";s:3:"7.x";s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:6:"panels";a:1:{s:4:"name";s:6:"panels";}s:12:"page_manager";a:1:{s:4:"name";s:12:"page_manager";}s:13:"advanced_help";a:1:{s:4:"name";s:13:"advanced_help";}}s:4:"sort";i:-48;}s:18:"ctools_plugin_test";O:8:"stdClass":11:{s:3:"uri";s:64:"sites/all/modules/contrib/ctools/tests/ctools_plugin_test.module";s:8:"filename";s:64:"sites/all/modules/contrib/ctools/tests/ctools_plugin_test.module";s:4:"name";s:18:"ctools_plugin_test";s:4:"info";a:11:{s:4:"name";s:24:"Chaos tools plugins test";s:11:"description";s:42:"Provides hooks for testing ctools plugins.";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:5:"files";a:6:{i:0;s:19:"ctools.plugins.test";i:1;s:17:"object_cache.test";i:2;s:8:"css.test";i:3;s:12:"context.test";i:4;s:20:"math_expression.test";i:5;s:26:"math_expression_stack.test";}s:6:"hidden";b:1;s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-49;}s:9:"dashboard";O:8:"stdClass":11:{s:3:"uri";s:34:"modules/dashboard/dashboard.module";s:8:"filename";s:34:"modules/dashboard/dashboard.module";s:4:"name";s:9:"dashboard";s:4:"info";a:11:{s:4:"name";s:9:"Dashboard";s:11:"description";s:136:"Provides a dashboard page in the administrative interface for organizing administrative tasks and tracking information within your site.";s:4:"core";s:3:"7.x";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:5:"files";a:1:{i:0;s:14:"dashboard.test";}s:12:"dependencies";a:1:{i:0;s:5:"block";}s:9:"configure";s:25:"admin/dashboard/customize";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"pantheon";a:1:{s:4:"name";s:9:"dashboard";}}s:8:"requires";a:1:{s:5:"block";a:1:{s:4:"name";s:5:"block";}}s:4:"sort";i:-50;}s:13:"database_test";O:8:"stdClass":11:{s:3:"uri";s:45:"modules/simpletest/tests/database_test.module";s:8:"filename";s:45:"modules/simpletest/tests/database_test.module";s:4:"name";s:13:"database_test";s:4:"info";a:11:{s:4:"name";s:13:"Database Test";s:11:"description";s:40:"Support module for Database layer tests.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"date";O:8:"stdClass":11:{s:3:"uri";s:42:"sites/all/modules/contrib/date/date.module";s:8:"filename";s:42:"sites/all/modules/contrib/date/date.module";s:4:"name";s:4:"date";s:4:"info";a:12:{s:4:"name";s:4:"Date";s:11:"description";s:33:"Makes date/time fields available.";s:12:"dependencies";a:1:{i:0;s:8:"date_api";}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:5:"files";a:9:{i:0;s:16:"date.migrate.inc";i:1;s:19:"tests/date_api.test";i:2;s:15:"tests/date.test";i:3;s:21:"tests/date_field.test";i:4;s:23:"tests/date_migrate.test";i:5;s:26:"tests/date_validation.test";i:6;s:24:"tests/date_timezone.test";i:7;s:27:"tests/date_views_pager.test";i:8;s:27:"tests/date_views_popup.test";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7004";s:6:"weight";s:1:"0";s:11:"required_by";a:6:{s:17:"bookpoints_events";a:1:{s:4:"name";s:4:"date";}s:12:"date_all_day";a:1:{s:4:"name";s:4:"date";}s:12:"date_context";a:1:{s:4:"name";s:4:"date";}s:17:"date_repeat_field";a:1:{s:4:"name";s:4:"date";}s:20:"date_migrate_example";a:1:{s:4:"name";s:4:"date";}s:10:"date_tools";a:1:{s:4:"name";s:4:"date";}}s:8:"requires";a:1:{s:8:"date_api";a:1:{s:4:"name";s:8:"date_api";}}s:4:"sort";i:-20;}s:12:"date_all_day";O:8:"stdClass":11:{s:3:"uri";s:63:"sites/all/modules/contrib/date/date_all_day/date_all_day.module";s:8:"filename";s:63:"sites/all/modules/contrib/date/date_all_day/date_all_day.module";s:4:"name";s:12:"date_all_day";s:4:"info";a:10:{s:4:"name";s:12:"Date All Day";s:11:"description";s:142:"Adds ''All Day'' functionality to date fields, including an ''All Day'' theme and ''All Day'' checkboxes for the Date select and Date popup widgets.";s:12:"dependencies";a:2:{i:0;s:8:"date_api";i:1;s:4:"date";}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:8:"date_api";a:1:{s:4:"name";s:8:"date_api";}s:4:"date";a:1:{s:4:"name";s:4:"date";}}s:4:"sort";i:-51;}s:8:"date_api";O:8:"stdClass":11:{s:3:"uri";s:55:"sites/all/modules/contrib/date/date_api/date_api.module";s:8:"filename";s:55:"sites/all/modules/contrib/date/date_api/date_api.module";s:4:"name";s:8:"date_api";s:4:"info";a:11:{s:4:"name";s:8:"Date API";s:11:"description";s:45:"A Date API that can be used by other modules.";s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:8:"date.css";s:48:"sites/all/modules/contrib/date/date_api/date.css";}}s:5:"files";a:2:{i:0;s:15:"date_api.module";i:1;s:16:"date_api_sql.inc";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7001";s:6:"weight";s:1:"0";s:11:"required_by";a:11:{s:10:"date_views";a:1:{s:4:"name";s:8:"date_api";}s:8:"calendar";a:1:{s:4:"name";s:8:"date_api";}s:4:"date";a:1:{s:4:"name";s:8:"date_api";}s:17:"bookpoints_events";a:1:{s:4:"name";s:8:"date_api";}s:12:"date_all_day";a:1:{s:4:"name";s:8:"date_api";}s:12:"date_context";a:1:{s:4:"name";s:8:"date_api";}s:11:"date_repeat";a:1:{s:4:"name";s:8:"date_api";}s:17:"date_repeat_field";a:1:{s:4:"name";s:8:"date_api";}s:20:"date_migrate_example";a:1:{s:4:"name";s:8:"date_api";}s:10:"date_popup";a:1:{s:4:"name";s:8:"date_api";}s:10:"date_tools";a:1:{s:4:"name";s:8:"date_api";}}s:8:"requires";a:0:{}s:4:"sort";i:-17;}s:12:"date_context";O:8:"stdClass":11:{s:3:"uri";s:63:"sites/all/modules/contrib/date/date_context/date_context.module";s:8:"filename";s:63:"sites/all/modules/contrib/date/date_context/date_context.module";s:4:"name";s:12:"date_context";s:4:"info";a:10:{s:4:"name";s:12:"Date Context";s:11:"description";s:99:"Adds an option to the Context module to set a context condition based on the value of a date field.";s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:4:"date";i:1;s:7:"context";}s:5:"files";a:2:{i:0;s:19:"date_context.module";i:1;s:39:"plugins/date_context_date_condition.inc";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:4:"date";a:1:{s:4:"name";s:4:"date";}s:8:"date_api";a:1:{s:4:"name";s:8:"date_api";}s:7:"context";a:1:{s:4:"name";s:7:"context";}}s:4:"sort";i:-52;}s:12:"date_migrate";O:8:"stdClass":11:{s:3:"uri";s:63:"sites/all/modules/contrib/date/date_migrate/date_migrate.module";s:8:"filename";s:63:"sites/all/modules/contrib/date/date_migrate/date_migrate.module";s:4:"name";s:12:"date_migrate";s:4:"info";a:11:{s:4:"name";s:14:"Date Migration";s:11:"description";s:73:"Obsolete data migration module. Disable if no other modules depend on it.";s:4:"core";s:3:"7.x";s:7:"package";s:9:"Date/Time";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:20:"date_migrate_example";r:313;s:10:"date_popup";O:8:"stdClass":11:{s:3:"uri";s:59:"sites/all/modules/contrib/date/date_popup/date_popup.module";s:8:"filename";s:59:"sites/all/modules/contrib/date/date_popup/date_popup.module";s:4:"name";s:10:"date_popup";s:4:"info";a:12:{s:4:"name";s:10:"Date Popup";s:11:"description";s:84:"Enables jquery popup calendars and time entry widgets for selecting dates and times.";s:12:"dependencies";a:1:{i:0;s:8:"date_api";}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:9:"configure";s:28:"admin/config/date/date_popup";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:25:"themes/datepicker.1.7.css";s:67:"sites/all/modules/contrib/date/date_popup/themes/datepicker.1.7.css";}}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:8:"date_api";a:1:{s:4:"name";s:8:"date_api";}}s:4:"sort";i:-56;}s:11:"date_repeat";O:8:"stdClass":11:{s:3:"uri";s:61:"sites/all/modules/contrib/date/date_repeat/date_repeat.module";s:8:"filename";s:61:"sites/all/modules/contrib/date/date_repeat/date_repeat.module";s:4:"name";s:11:"date_repeat";s:4:"info";a:10:{s:4:"name";s:15:"Date Repeat API";s:11:"description";s:73:"A Date Repeat API to calculate repeating dates and times from iCal rules.";s:12:"dependencies";a:1:{i:0;s:8:"date_api";}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:22:"tests/date_repeat.test";i:1;s:27:"tests/date_repeat_form.test";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"1";s:11:"required_by";a:2:{s:17:"date_repeat_field";a:1:{s:4:"name";s:11:"date_repeat";}s:20:"date_migrate_example";a:1:{s:4:"name";s:11:"date_repeat";}}s:8:"requires";a:1:{s:8:"date_api";a:1:{s:4:"name";s:8:"date_api";}}s:4:"sort";i:-53;}s:17:"date_repeat_field";O:8:"stdClass":11:{s:3:"uri";s:73:"sites/all/modules/contrib/date/date_repeat_field/date_repeat_field.module";s:8:"filename";s:73:"sites/all/modules/contrib/date/date_repeat_field/date_repeat_field.module";s:4:"name";s:17:"date_repeat_field";s:4:"info";a:11:{s:4:"name";s:17:"Date Repeat Field";s:11:"description";s:97:"Creates the option of Repeating date fields and manages Date fields that use the Date Repeat API.";s:12:"dependencies";a:3:{i:0;s:8:"date_api";i:1;s:4:"date";i:2;s:11:"date_repeat";}s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:21:"date_repeat_field.css";s:70:"sites/all/modules/contrib/date/date_repeat_field/date_repeat_field.css";}}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:20:"date_migrate_example";a:1:{s:4:"name";s:17:"date_repeat_field";}}s:8:"requires";a:3:{s:8:"date_api";a:1:{s:4:"name";s:8:"date_api";}s:4:"date";a:1:{s:4:"name";s:4:"date";}s:11:"date_repeat";a:1:{s:4:"name";s:11:"date_repeat";}}s:4:"sort";i:-54;}s:10:"date_tools";O:8:"stdClass":11:{s:3:"uri";s:59:"sites/all/modules/contrib/date/date_tools/date_tools.module";s:8:"filename";s:59:"sites/all/modules/contrib/date/date_tools/date_tools.module";s:4:"name";s:10:"date_tools";s:4:"info";a:11:{s:4:"name";s:10:"Date Tools";s:11:"description";s:52:"Tools to import and auto-create dates and calendars.";s:12:"dependencies";a:1:{i:0;s:4:"date";}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:9:"configure";s:23:"admin/config/date/tools";s:5:"files";a:1:{i:0;s:21:"tests/date_tools.test";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:4:"date";a:1:{s:4:"name";s:4:"date";}s:8:"date_api";a:1:{s:4:"name";s:8:"date_api";}}s:4:"sort";i:-57;}s:10:"date_views";O:8:"stdClass":11:{s:3:"uri";s:59:"sites/all/modules/contrib/date/date_views/date_views.module";s:8:"filename";s:59:"sites/all/modules/contrib/date/date_views/date_views.module";s:4:"name";s:10:"date_views";s:4:"info";a:10:{s:4:"name";s:10:"Date Views";s:11:"description";s:57:"Views integration for date fields and date functionality.";s:7:"package";s:9:"Date/Time";s:12:"dependencies";a:2:{i:0;s:8:"date_api";i:1;s:5:"views";}s:4:"core";s:3:"7.x";s:5:"files";a:6:{i:0;s:40:"includes/date_views_argument_handler.inc";i:1;s:47:"includes/date_views_argument_handler_simple.inc";i:2;s:38:"includes/date_views_filter_handler.inc";i:3;s:45:"includes/date_views_filter_handler_simple.inc";i:4;s:29:"includes/date_views.views.inc";i:5;s:36:"includes/date_views_plugin_pager.inc";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7200";s:6:"weight";s:1:"0";s:11:"required_by";a:2:{s:8:"calendar";a:1:{s:4:"name";s:10:"date_views";}s:17:"bookpoints_events";a:1:{s:4:"name";s:10:"date_views";}}s:8:"requires";a:3:{s:8:"date_api";a:1:{s:4:"name";s:8:"date_api";}s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-18;}s:5:"dblog";O:8:"stdClass":11:{s:3:"uri";s:26:"modules/dblog/dblog.module";s:8:"filename";s:26:"modules/dblog/dblog.module";s:4:"name";s:5:"dblog";s:4:"info";a:10:{s:4:"name";s:16:"Database logging";s:11:"description";s:47:"Logs and records system events to the database.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:10:"dblog.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7003";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"pantheon";a:1:{s:4:"name";s:5:"dblog";}}s:8:"requires";a:0:{}s:4:"sort";i:-58;}s:5:"devel";O:8:"stdClass":11:{s:3:"uri";s:44:"sites/all/modules/contrib/devel/devel.module";s:8:"filename";s:44:"sites/all/modules/contrib/devel/devel.module";s:4:"name";s:5:"devel";s:4:"info";a:12:{s:4:"name";s:5:"Devel";s:11:"description";s:52:"Various blocks, pages, and functions for developers.";s:7:"package";s:11:"Development";s:4:"core";s:3:"7.x";s:9:"configure";s:30:"admin/config/development/devel";s:4:"tags";a:1:{i:0;s:9:"developer";}s:5:"files";a:2:{i:0;s:10:"devel.test";i:1;s:14:"devel.mail.inc";}s:7:"version";s:7:"7.x-1.5";s:7:"project";s:5:"devel";s:9:"datestamp";s:10:"1398963366";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7006";s:6:"weight";s:2:"88";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:14:"devel_generate";O:8:"stdClass":11:{s:3:"uri";s:68:"sites/all/modules/contrib/devel/devel_generate/devel_generate.module";s:8:"filename";s:68:"sites/all/modules/contrib/devel/devel_generate/devel_generate.module";s:4:"name";s:14:"devel_generate";s:4:"info";a:12:{s:4:"name";s:14:"Devel generate";s:11:"description";s:48:"Generate dummy users, nodes, and taxonomy terms.";s:7:"package";s:11:"Development";s:4:"core";s:3:"7.x";s:4:"tags";a:1:{i:0;s:9:"developer";}s:9:"configure";s:33:"admin/config/development/generate";s:5:"files";a:1:{i:0;s:19:"devel_generate.test";}s:7:"version";s:7:"7.x-1.5";s:7:"project";s:5:"devel";s:9:"datestamp";s:10:"1398963366";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:17:"devel_node_access";O:8:"stdClass":11:{s:3:"uri";s:56:"sites/all/modules/contrib/devel/devel_node_access.module";s:8:"filename";s:56:"sites/all/modules/contrib/devel/devel_node_access.module";s:4:"name";s:17:"devel_node_access";s:4:"info";a:12:{s:4:"name";s:17:"Devel node access";s:11:"description";s:68:"Developer blocks and page illustrating relevant node_access records.";s:7:"package";s:11:"Development";s:12:"dependencies";a:1:{i:0;s:4:"menu";}s:4:"core";s:3:"7.x";s:9:"configure";s:30:"admin/config/development/devel";s:4:"tags";a:1:{i:0;s:9:"developer";}s:7:"version";s:7:"7.x-1.5";s:7:"project";s:5:"devel";s:9:"datestamp";s:10:"1398963366";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:4:"menu";a:1:{s:4:"name";s:4:"menu";}}s:4:"sort";i:-60;}s:20:"drupal_autoload_test";O:8:"stdClass":11:{s:3:"uri";s:73:"modules/simpletest/tests/drupal_autoload_test/drupal_autoload_test.module";s:8:"filename";s:73:"modules/simpletest/tests/drupal_autoload_test/drupal_autoload_test.module";s:4:"name";s:20:"drupal_autoload_test";s:4:"info";a:11:{s:4:"name";s:25:"Drupal code registry test";s:11:"description";s:45:"Support module for testing the code registry.";s:5:"files";a:2:{i:0;s:34:"drupal_autoload_test_interface.inc";i:1;s:30:"drupal_autoload_test_class.inc";}s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:37:"drupal_system_listing_compatible_test";O:8:"stdClass":11:{s:3:"uri";s:107:"modules/simpletest/tests/drupal_system_listing_compatible_test/drupal_system_listing_compatible_test.module";s:8:"filename";s:107:"modules/simpletest/tests/drupal_system_listing_compatible_test/drupal_system_listing_compatible_test.module";s:4:"name";s:37:"drupal_system_listing_compatible_test";s:4:"info";a:11:{s:4:"name";s:37:"Drupal system listing compatible test";s:11:"description";s:62:"Support module for testing the drupal_system_listing function.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:39:"drupal_system_listing_incompatible_test";O:8:"stdClass":11:{s:3:"uri";s:111:"modules/simpletest/tests/drupal_system_listing_incompatible_test/drupal_system_listing_incompatible_test.module";s:8:"filename";s:111:"modules/simpletest/tests/drupal_system_listing_incompatible_test/drupal_system_listing_incompatible_test.module";s:4:"name";s:39:"drupal_system_listing_incompatible_test";s:4:"info";a:11:{s:4:"name";s:39:"Drupal system listing incompatible test";s:11:"description";s:62:"Support module for testing the drupal_system_listing function.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:3:"eck";O:8:"stdClass":11:{s:3:"uri";s:40:"sites/all/modules/contrib/eck/eck.module";s:8:"filename";s:40:"sites/all/modules/contrib/eck/eck.module";s:4:"name";s:3:"eck";s:4:"info";a:13:{s:4:"name";s:23:"Entity Construction Kit";s:11:"description";s:126:"ECK (Entity Construction Kit) Allows users to create and administer entity types, bundles, and entities from an easy to use UI";s:7:"package";s:3:"ECK";s:4:"core";s:3:"7.x";s:9:"configure";s:27:"admin/structure/entity-type";s:12:"dependencies";a:2:{i:0;s:6:"entity";i:1;s:6:"ctools";}s:5:"files";a:5:{i:0;s:47:"views/handlers/eck_views_handler_field_link.inc";i:1;s:52:"views/handlers/eck_views_handler_field_link_edit.inc";i:2;s:54:"views/handlers/eck_views_handler_field_link_delete.inc";i:3;s:36:"includes/translation.handler.eck.inc";i:4;s:35:"includes/eck.inline_entity_form.inc";}s:7:"version";s:11:"7.x-2.0-rc8";s:7:"project";s:3:"eck";s:9:"datestamp";s:10:"1448560416";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:60:"Entity types created by ECK are still present in the system.";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7011";s:6:"weight";s:1:"0";s:11:"required_by";a:4:{s:20:"bookpoints_importers";a:1:{s:4:"name";s:3:"eck";}s:15:"eck_entitycache";a:1:{s:4:"name";s:3:"eck";}s:11:"eck_example";a:1:{s:4:"name";s:3:"eck";}s:12:"eck_services";a:1:{s:4:"name";s:3:"eck";}}s:8:"requires";a:2:{s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-28;}s:15:"eck_entitycache";O:8:"stdClass":11:{s:3:"uri";s:76:"sites/all/modules/contrib/eck/modules/eck_entitycache/eck_entitycache.module";s:8:"filename";s:76:"sites/all/modules/contrib/eck/modules/eck_entitycache/eck_entitycache.module";s:4:"name";s:15:"eck_entitycache";s:4:"info";a:10:{s:4:"name";s:17:"ECK - Entitycache";s:11:"description";s:53:"Integrates the ECK module with the Entitycache module";s:7:"package";s:27:"Performance and scalability";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:3:"eck";i:1;s:11:"entitycache";}s:7:"version";s:11:"7.x-2.0-rc8";s:7:"project";s:3:"eck";s:9:"datestamp";s:10:"1448560416";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:3:"eck";a:1:{s:4:"name";s:3:"eck";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:11:"entitycache";a:1:{s:4:"name";s:11:"entitycache";}}s:4:"sort";i:-61;}s:11:"eck_example";O:8:"stdClass":11:{s:3:"uri";s:57:"sites/all/modules/contrib/eck/examples/eck_example.module";s:8:"filename";s:57:"sites/all/modules/contrib/eck/examples/eck_example.module";s:4:"name";s:11:"eck_example";s:4:"info";a:10:{s:4:"name";s:11:"ECK Example";s:11:"description";s:67:"A module demonstrating the kind of things that ECK can do from code";s:7:"package";s:3:"ECK";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:3:"eck";}s:7:"version";s:11:"7.x-2.0-rc8";s:7:"project";s:3:"eck";s:9:"datestamp";s:10:"1448560416";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:3:"eck";a:1:{s:4:"name";s:3:"eck";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-62;}s:12:"eck_services";O:8:"stdClass":11:{s:3:"uri";s:70:"sites/all/modules/contrib/eck/modules/eck_services/eck_services.module";s:8:"filename";s:70:"sites/all/modules/contrib/eck/modules/eck_services/eck_services.module";s:4:"name";s:12:"eck_services";s:4:"info";a:10:{s:4:"name";s:12:"ECK Services";s:11:"description";s:25:"Service resources for ECK";s:4:"core";s:3:"7.x";s:7:"package";s:3:"ECK";s:12:"dependencies";a:2:{i:0;s:3:"eck";i:1;s:8:"services";}s:7:"version";s:11:"7.x-2.0-rc8";s:7:"project";s:3:"eck";s:9:"datestamp";s:10:"1448560416";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:3:"eck";a:1:{s:4:"name";s:3:"eck";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:8:"services";a:1:{s:4:"name";s:8:"services";}}s:4:"sort";i:-63;}s:6:"entity";O:8:"stdClass":11:{s:3:"uri";s:46:"sites/all/modules/contrib/entity/entity.module";s:8:"filename";s:46:"sites/all/modules/contrib/entity/entity.module";s:4:"name";s:6:"entity";s:4:"info";a:10:{s:4:"name";s:10:"Entity API";s:11:"description";s:69:"Enables modules to work with any entity type and to provide entities.";s:4:"core";s:3:"7.x";s:5:"files";a:24:{i:0;s:19:"entity.features.inc";i:1;s:15:"entity.i18n.inc";i:2;s:15:"entity.info.inc";i:3;s:16:"entity.rules.inc";i:4;s:11:"entity.test";i:5;s:19:"includes/entity.inc";i:6;s:30:"includes/entity.controller.inc";i:7;s:22:"includes/entity.ui.inc";i:8;s:27:"includes/entity.wrapper.inc";i:9;s:22:"views/entity.views.inc";i:10;s:52:"views/handlers/entity_views_field_handler_helper.inc";i:11;s:51:"views/handlers/entity_views_handler_area_entity.inc";i:12;s:53:"views/handlers/entity_views_handler_field_boolean.inc";i:13;s:50:"views/handlers/entity_views_handler_field_date.inc";i:14;s:54:"views/handlers/entity_views_handler_field_duration.inc";i:15;s:52:"views/handlers/entity_views_handler_field_entity.inc";i:16;s:51:"views/handlers/entity_views_handler_field_field.inc";i:17;s:53:"views/handlers/entity_views_handler_field_numeric.inc";i:18;s:53:"views/handlers/entity_views_handler_field_options.inc";i:19;s:50:"views/handlers/entity_views_handler_field_text.inc";i:20;s:49:"views/handlers/entity_views_handler_field_uri.inc";i:21;s:62:"views/handlers/entity_views_handler_relationship_by_bundle.inc";i:22;s:52:"views/handlers/entity_views_handler_relationship.inc";i:23;s:53:"views/plugins/entity_views_plugin_row_entity_view.inc";}s:7:"version";s:7:"7.x-1.8";s:7:"project";s:6:"entity";s:9:"datestamp";s:10:"1474546503";s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7003";s:6:"weight";s:1:"0";s:11:"required_by";a:47:{s:21:"views_bulk_operations";a:1:{s:4:"name";s:6:"entity";}s:11:"admin_views";a:1:{s:4:"name";s:6:"entity";}s:15:"entityreference";a:1:{s:4:"name";s:6:"entity";}s:17:"bookpoints_events";a:1:{s:4:"name";s:6:"entity";}s:3:"eck";a:1:{s:4:"name";s:6:"entity";}s:22:"feeds_entity_processor";a:1:{s:4:"name";s:6:"entity";}s:20:"bookpoints_importers";a:1:{s:4:"name";s:6:"entity";}s:12:"entity_token";a:1:{s:4:"name";s:6:"entity";}s:5:"rules";a:1:{s:4:"name";s:6:"entity";}s:20:"content_access_rules";a:1:{s:4:"name";s:6:"entity";}s:15:"eck_entitycache";a:1:{s:4:"name";s:6:"entity";}s:11:"eck_example";a:1:{s:4:"name";s:6:"entity";}s:12:"eck_services";a:1:{s:4:"name";s:6:"entity";}s:12:"entity_block";a:1:{s:4:"name";s:6:"entity";}s:11:"entity_test";a:1:{s:4:"name";s:6:"entity";}s:14:"entity_feature";a:1:{s:4:"name";s:6:"entity";}s:16:"entity_test_i18n";a:1:{s:4:"name";s:6:"entity";}s:10:"entityform";a:1:{s:4:"name";s:6:"entity";}s:20:"entityform_anonymous";a:1:{s:4:"name";s:6:"entity";}s:24:"entityform_notifications";a:1:{s:4:"name";s:6:"entity";}s:15:"entityform_test";a:1:{s:4:"name";s:6:"entity";}s:32:"entityreference_behavior_example";a:1:{s:4:"name";s:6:"entity";}s:26:"entityreference_feeds_test";a:1:{s:4:"name";s:6:"entity";}s:16:"field_collection";a:1:{s:4:"name";s:6:"entity";}s:14:"flag_hook_test";a:1:{s:4:"name";s:6:"entity";}s:21:"relation_migrate_test";a:1:{s:4:"name";s:6:"entity";}s:11:"rules_admin";a:1:{s:4:"name";s:6:"entity";}s:17:"rules_conditional";a:1:{s:4:"name";s:6:"entity";}s:22:"rules_conditional_test";a:1:{s:4:"name";s:6:"entity";}s:10:"rules_i18n";a:1:{s:4:"name";s:6:"entity";}s:15:"rules_scheduler";a:1:{s:4:"name";s:6:"entity";}s:13:"uuid_services";a:1:{s:4:"name";s:6:"entity";}s:21:"uuid_services_example";a:1:{s:4:"name";s:6:"entity";}s:8:"workflow";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:15:"workflow_access";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:16:"workflow_actions";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:17:"workflow_admin_ui";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:16:"workflow_cleanup";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:15:"workflow_notify";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:18:"workflow_notify_og";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:15:"workflow_revert";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:14:"workflow_rules";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:12:"workflownode";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:19:"workflow_search_api";a:1:{s:4:"name";s:6:"entity";}s:12:"workflow_vbo";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:14:"workflow_views";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:13:"workflowfield";a:1:{s:4:"name";s:6:"entity";}}s:8:"requires";a:0:{}s:4:"sort";i:-9;}s:12:"entity_block";O:8:"stdClass":11:{s:3:"uri";s:58:"sites/all/modules/contrib/entity_block/entity_block.module";s:8:"filename";s:58:"sites/all/modules/contrib/entity_block/entity_block.module";s:4:"name";s:12:"entity_block";s:4:"info";a:10:{s:4:"name";s:12:"Entity Block";s:11:"description";s:57:"Display entities (via view modes) using fieldable blocks.";s:4:"core";s:3:"7.x";s:7:"package";s:5:"Other";s:12:"dependencies";a:2:{i:0;s:5:"block";i:1;s:15:"entityreference";}s:5:"files";a:1:{i:0;s:27:"entity_block.controller.inc";}s:7:"version";s:11:"7.x-1.x-dev";s:7:"project";s:12:"entity_block";s:9:"datestamp";s:10:"1438801447";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:5:"block";a:1:{s:4:"name";s:5:"block";}s:15:"entityreference";a:1:{s:4:"name";s:15:"entityreference";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-64;}s:17:"entity_cache_test";O:8:"stdClass":11:{s:3:"uri";s:49:"modules/simpletest/tests/entity_cache_test.module";s:8:"filename";s:49:"modules/simpletest/tests/entity_cache_test.module";s:4:"name";s:17:"entity_cache_test";s:4:"info";a:11:{s:4:"name";s:17:"Entity cache test";s:11:"description";s:40:"Support module for testing entity cache.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:28:"entity_cache_test_dependency";}s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:28:"entity_cache_test_dependency";a:1:{s:4:"name";s:28:"entity_cache_test_dependency";}}s:4:"sort";i:-1;}s:28:"entity_cache_test_dependency";O:8:"stdClass":11:{s:3:"uri";s:60:"modules/simpletest/tests/entity_cache_test_dependency.module";s:8:"filename";s:60:"modules/simpletest/tests/entity_cache_test_dependency.module";s:4:"name";s:28:"entity_cache_test_dependency";s:4:"info";a:11:{s:4:"name";s:28:"Entity cache test dependency";s:11:"description";s:51:"Support dependency module for testing entity cache.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:17:"entity_cache_test";a:1:{s:4:"name";s:28:"entity_cache_test_dependency";}}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:21:"entity_crud_hook_test";O:8:"stdClass":11:{s:3:"uri";s:53:"modules/simpletest/tests/entity_crud_hook_test.module";s:8:"filename";s:53:"modules/simpletest/tests/entity_crud_hook_test.module";s:4:"name";s:21:"entity_crud_hook_test";s:4:"info";a:11:{s:4:"name";s:22:"Entity CRUD Hooks Test";s:11:"description";s:35:"Support module for CRUD hook tests.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:14:"entity_feature";O:8:"stdClass":11:{s:3:"uri";s:60:"sites/all/modules/contrib/entity/tests/entity_feature.module";s:8:"filename";s:60:"sites/all/modules/contrib/entity/tests/entity_feature.module";s:4:"name";s:14:"entity_feature";s:4:"info";a:11:{s:4:"name";s:21:"Entity feature module";s:11:"description";s:31:"Provides some entities in code.";s:7:"version";s:7:"7.x-1.8";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:21:"entity_feature.module";}s:12:"dependencies";a:1:{i:0;s:11:"entity_test";}s:6:"hidden";b:1;s:7:"project";s:6:"entity";s:9:"datestamp";s:10:"1474546503";s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:11:"entity_test";a:1:{s:4:"name";s:11:"entity_test";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-66;}s:24:"entity_query_access_test";O:8:"stdClass":11:{s:3:"uri";s:56:"modules/simpletest/tests/entity_query_access_test.module";s:8:"filename";s:56:"modules/simpletest/tests/entity_query_access_test.module";s:4:"name";s:24:"entity_query_access_test";s:4:"info";a:11:{s:4:"name";s:24:"Entity query access test";s:11:"description";s:49:"Support module for checking entity query results.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:11:"entity_test";O:8:"stdClass":11:{s:3:"uri";s:57:"sites/all/modules/contrib/entity/tests/entity_test.module";s:8:"filename";s:57:"sites/all/modules/contrib/entity/tests/entity_test.module";s:4:"name";s:11:"entity_test";s:4:"info";a:11:{s:4:"name";s:23:"Entity CRUD test module";s:11:"description";s:46:"Provides entity types based upon the CRUD API.";s:7:"version";s:7:"7.x-1.8";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:18:"entity_test.module";i:1;s:19:"entity_test.install";}s:12:"dependencies";a:1:{i:0;s:6:"entity";}s:6:"hidden";b:1;s:7:"project";s:6:"entity";s:9:"datestamp";s:10:"1474546503";s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:2:{s:14:"entity_feature";a:1:{s:4:"name";s:11:"entity_test";}s:16:"entity_test_i18n";a:1:{s:4:"name";s:11:"entity_test";}}s:8:"requires";a:1:{s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-65;}s:16:"entity_test_i18n";O:8:"stdClass":11:{s:3:"uri";s:62:"sites/all/modules/contrib/entity/tests/entity_test_i18n.module";s:8:"filename";s:62:"sites/all/modules/contrib/entity/tests/entity_test_i18n.module";s:4:"name";s:16:"entity_test_i18n";s:4:"info";a:11:{s:4:"name";s:28:"Entity-test type translation";s:11:"description";s:37:"Allows translating entity-test types.";s:12:"dependencies";a:2:{i:0;s:11:"entity_test";i:1;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-1.8";s:7:"project";s:6:"entity";s:9:"datestamp";s:10:"1474546503";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:6:{s:11:"entity_test";a:1:{s:4:"name";s:11:"entity_test";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:11:"i18n_string";a:1:{s:4:"name";s:11:"i18n_string";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-70;}s:12:"entity_token";O:8:"stdClass":11:{s:3:"uri";s:52:"sites/all/modules/contrib/entity/entity_token.module";s:8:"filename";s:52:"sites/all/modules/contrib/entity/entity_token.module";s:4:"name";s:12:"entity_token";s:4:"info";a:10:{s:4:"name";s:13:"Entity tokens";s:11:"description";s:99:"Provides token replacements for all properties that have no tokens and are known to the entity API.";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:23:"entity_token.tokens.inc";i:1;s:19:"entity_token.module";}s:12:"dependencies";a:1:{i:0;s:6:"entity";}s:7:"version";s:7:"7.x-1.8";s:7:"project";s:6:"entity";s:9:"datestamp";s:10:"1474546503";s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:10:{s:5:"rules";a:1:{s:4:"name";s:12:"entity_token";}s:20:"content_access_rules";a:1:{s:4:"name";s:12:"entity_token";}s:24:"entityform_notifications";a:1:{s:4:"name";s:12:"entity_token";}s:14:"flag_hook_test";a:1:{s:4:"name";s:12:"entity_token";}s:11:"rules_admin";a:1:{s:4:"name";s:12:"entity_token";}s:17:"rules_conditional";a:1:{s:4:"name";s:12:"entity_token";}s:22:"rules_conditional_test";a:1:{s:4:"name";s:12:"entity_token";}s:10:"rules_i18n";a:1:{s:4:"name";s:12:"entity_token";}s:15:"rules_scheduler";a:1:{s:4:"name";s:12:"entity_token";}s:14:"workflow_rules";a:1:{s:4:"name";s:12:"entity_token";}}s:8:"requires";a:1:{s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-38;}s:10:"entityform";O:8:"stdClass":11:{s:3:"uri";s:54:"sites/all/modules/contrib/entityform/entityform.module";s:8:"filename";s:54:"sites/all/modules/contrib/entityform/entityform.module";s:4:"name";s:10:"entityform";s:4:"info";a:11:{s:4:"name";s:11:"Entityforms";s:11:"description";s:31:"Provides fieldable entity forms";s:4:"core";s:3:"7.x";s:7:"package";s:11:"Entityforms";s:9:"configure";s:32:"admin/structure/entityform_types";s:12:"dependencies";a:2:{i:0;s:6:"entity";i:1;s:5:"views";}s:5:"files";a:12:{i:0;s:20:"entityform.admin.inc";i:1;s:19:"entityform.info.inc";i:2;s:25:"entityform_type.admin.inc";i:3;s:26:"entityform.pages.admin.inc";i:4;s:26:"views/entityform.views.inc";i:5;s:39:"views/entityform_handler_link_field.inc";i:6;s:46:"views/entityform_handler_delete_link_field.inc";i:7;s:44:"views/entityform_handler_edit_link_field.inc";i:8;s:56:"views/entityform_handler_entityform_operations_field.inc";i:9;s:34:"views/entityform.views_default.inc";i:10;s:51:"views/entityform_type_handler_submit_link_field.inc";i:11;s:15:"entityform.test";}s:7:"version";s:11:"7.x-2.0-rc1";s:7:"project";s:10:"entityform";s:9:"datestamp";s:10:"1413913852";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7005";s:6:"weight";s:1:"0";s:11:"required_by";a:3:{s:20:"entityform_anonymous";a:1:{s:4:"name";s:10:"entityform";}s:24:"entityform_notifications";a:1:{s:4:"name";s:10:"entityform";}s:15:"entityform_test";a:1:{s:4:"name";s:10:"entityform";}}s:8:"requires";a:3:{s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-71;}s:20:"entityform_anonymous";O:8:"stdClass":11:{s:3:"uri";s:85:"sites/all/modules/contrib/entityform/entityform_anonymous/entityform_anonymous.module";s:8:"filename";s:85:"sites/all/modules/contrib/entityform/entityform_anonymous/entityform_anonymous.module";s:4:"name";s:20:"entityform_anonymous";s:4:"info";a:10:{s:4:"name";s:20:"Entityform Anonymous";s:11:"description";s:51:"Allows tracking of anonymous Entityform submissions";s:4:"core";s:3:"7.x";s:7:"package";s:11:"Entityforms";s:12:"dependencies";a:2:{i:0;s:11:"session_api";i:1;s:10:"entityform";}s:7:"version";s:11:"7.x-2.0-rc1";s:7:"project";s:10:"entityform";s:9:"datestamp";s:10:"1413913852";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:5:{s:11:"session_api";a:1:{s:4:"name";s:11:"session_api";}s:10:"entityform";a:1:{s:4:"name";s:10:"entityform";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-72;}s:24:"entityform_notifications";O:8:"stdClass":11:{s:3:"uri";s:93:"sites/all/modules/contrib/entityform/entityform_notifications/entityform_notifications.module";s:8:"filename";s:93:"sites/all/modules/contrib/entityform/entityform_notifications/entityform_notifications.module";s:4:"name";s:24:"entityform_notifications";s:4:"info";a:10:{s:4:"name";s:25:"Entityforms Notifications";s:11:"description";s:97:"Enable this module if you want Entityforms to send e-mail notifications when a form is submitted.";s:4:"core";s:3:"7.x";s:7:"package";s:11:"Entityforms";s:12:"dependencies";a:4:{i:0;s:10:"entityform";i:1;s:12:"entity_rules";i:2;s:11:"entity2text";i:3;s:5:"rules";}s:7:"version";s:11:"7.x-2.0-rc1";s:7:"project";s:10:"entityform";s:9:"datestamp";s:10:"1413913852";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:8:{s:10:"entityform";a:1:{s:4:"name";s:10:"entityform";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:12:"entity_rules";a:1:{s:4:"name";s:12:"entity_rules";}s:11:"entity2text";a:1:{s:4:"name";s:11:"entity2text";}s:5:"rules";a:1:{s:4:"name";s:5:"rules";}s:12:"entity_token";a:1:{s:4:"name";s:12:"entity_token";}}s:4:"sort";i:-73;}s:15:"entityform_test";r:369;s:15:"entityreference";O:8:"stdClass":11:{s:3:"uri";s:64:"sites/all/modules/contrib/entityreference/entityreference.module";s:8:"filename";s:64:"sites/all/modules/contrib/entityreference/entityreference.module";s:4:"name";s:15:"entityreference";s:4:"info";a:13:{s:4:"name";s:16:"Entity Reference";s:11:"description";s:51:"Provides a field that can reference other entities.";s:7:"package";s:6:"Fields";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:6:"entity";i:1;s:6:"ctools";}s:17:"test_dependencies";a:2:{i:0;s:5:"feeds";i:1;s:5:"views";}s:5:"files";a:12:{i:0;s:27:"entityreference.migrate.inc";i:1;s:30:"plugins/selection/abstract.inc";i:2;s:27:"plugins/selection/views.inc";i:3;s:29:"plugins/behavior/abstract.inc";i:4;s:40:"views/entityreference_plugin_display.inc";i:5;s:38:"views/entityreference_plugin_style.inc";i:6;s:43:"views/entityreference_plugin_row_fields.inc";i:7;s:35:"tests/entityreference.handlers.test";i:8;s:35:"tests/entityreference.taxonomy.test";i:9;s:32:"tests/entityreference.admin.test";i:10;s:32:"tests/entityreference.feeds.test";i:11;s:45:"tests/entityreference.entity_translation.test";}s:7:"version";s:7:"7.x-1.2";s:7:"project";s:15:"entityreference";s:9:"datestamp";s:10:"1474306740";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7002";s:6:"weight";s:1:"0";s:11:"required_by";a:5:{s:17:"bookpoints_events";a:1:{s:4:"name";s:15:"entityreference";}s:12:"entity_block";a:1:{s:4:"name";s:15:"entityreference";}s:32:"entityreference_behavior_example";a:1:{s:4:"name";s:15:"entityreference";}s:26:"entityreference_feeds_test";a:1:{s:4:"name";s:15:"entityreference";}s:21:"relation_migrate_test";a:1:{s:4:"name";s:15:"entityreference";}}s:8:"requires";a:2:{s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-21;}s:32:"entityreference_behavior_example";O:8:"stdClass":11:{s:3:"uri";s:123:"sites/all/modules/contrib/entityreference/examples/entityreference_behavior_example/entityreference_behavior_example.module";s:8:"filename";s:123:"sites/all/modules/contrib/entityreference/examples/entityreference_behavior_example/entityreference_behavior_example.module";s:4:"name";s:32:"entityreference_behavior_example";s:4:"info";a:10:{s:4:"name";s:33:"Entity Reference Behavior Example";s:11:"description";s:71:"Provides some example code for implementing Entity Reference behaviors.";s:4:"core";s:3:"7.x";s:7:"package";s:6:"Fields";s:12:"dependencies";a:1:{i:0;s:15:"entityreference";}s:7:"version";s:7:"7.x-1.2";s:7:"project";s:15:"entityreference";s:9:"datestamp";s:10:"1474306740";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:15:"entityreference";a:1:{s:4:"name";s:15:"entityreference";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-75;}s:26:"entityreference_feeds_test";O:8:"stdClass":11:{s:3:"uri";s:116:"sites/all/modules/contrib/entityreference/tests/modules/entityreference_feeds_test/entityreference_feeds_test.module";s:8:"filename";s:116:"sites/all/modules/contrib/entityreference/tests/modules/entityreference_feeds_test/entityreference_feeds_test.module";s:4:"name";s:26:"entityreference_feeds_test";s:4:"info";a:11:{s:4:"name";s:41:"Entityreference - Feeds integration tests";s:11:"description";s:65:"Support module for the Entityreference - Feeds integration tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:3:{i:0;s:5:"feeds";i:1;s:8:"feeds_ui";i:2;s:15:"entityreference";}s:7:"version";s:7:"7.x-1.2";s:7:"project";s:15:"entityreference";s:9:"datestamp";s:10:"1474306740";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:6:{s:5:"feeds";a:1:{s:4:"name";s:5:"feeds";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:13:"job_scheduler";a:1:{s:4:"name";s:13:"job_scheduler";}s:8:"feeds_ui";a:1:{s:4:"name";s:8:"feeds_ui";}s:15:"entityreference";a:1:{s:4:"name";s:15:"entityreference";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-77;}s:10:"error_test";O:8:"stdClass":11:{s:3:"uri";s:42:"modules/simpletest/tests/error_test.module";s:8:"filename";s:42:"modules/simpletest/tests/error_test.module";s:4:"name";s:10:"error_test";s:4:"info";a:11:{s:4:"name";s:10:"Error test";s:11:"description";s:47:"Support module for error and exception testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:8:"features";O:8:"stdClass":11:{s:3:"uri";s:50:"sites/all/modules/contrib/features/features.module";s:8:"filename";s:50:"sites/all/modules/contrib/features/features.module";s:4:"name";s:8:"features";s:4:"info";a:12:{s:4:"name";s:8:"Features";s:11:"description";s:39:"Provides feature management for Drupal.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Features";s:5:"files";a:1:{i:0;s:19:"tests/features.test";}s:17:"test_dependencies";a:4:{i:0;s:5:"image";i:1;s:9:"strongarm";i:2;s:8:"taxonomy";i:3;s:5:"views";}s:9:"configure";s:33:"admin/structure/features/settings";s:7:"version";s:8:"7.x-2.10";s:7:"project";s:8:"features";s:9:"datestamp";s:10:"1461011641";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7200";s:6:"weight";s:2:"20";s:11:"required_by";a:5:{s:17:"bookpoints_events";a:1:{s:4:"name";s:8:"features";}s:20:"date_migrate_example";a:1:{s:4:"name";s:8:"features";}s:15:"entityform_test";a:1:{s:4:"name";s:8:"features";}s:13:"features_test";a:1:{s:4:"name";s:8:"features";}s:10:"feeds_news";a:1:{s:4:"name";s:8:"features";}}s:8:"requires";a:0:{}s:4:"sort";i:-22;}s:13:"features_test";r:424;s:5:"feeds";O:8:"stdClass":11:{s:3:"uri";s:44:"sites/all/modules/contrib/feeds/feeds.module";s:8:"filename";s:44:"sites/all/modules/contrib/feeds/feeds.module";s:4:"name";s:5:"feeds";s:4:"info";a:11:{s:4:"name";s:5:"Feeds";s:11:"description";s:58:"Aggregates RSS/Atom/RDF feeds, imports CSV files and more.";s:7:"package";s:5:"Feeds";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:6:"ctools";i:1;s:13:"job_scheduler";}s:17:"test_dependencies";a:7:{i:0;s:9:"date:date";i:1;s:37:"entity_translation:entity_translation";i:2;s:35:"feeds_xpathparser:feeds_xpathparser";i:3;s:18:"i18n:i18n_taxonomy";i:4;s:9:"link:link";i:5;s:11:"rules:rules";i:6;s:17:"variable:variable";}s:5:"files";a:65:{i:0;s:30:"includes/FeedsConfigurable.inc";i:1;s:26:"includes/FeedsImporter.inc";i:2;s:24:"includes/FeedsSource.inc";i:3;s:23:"libraries/ParserCSV.inc";i:4;s:26:"libraries/http_request.inc";i:5;s:28:"libraries/PuSHSubscriber.inc";i:6;s:26:"plugins/FeedsCSVParser.inc";i:7;s:24:"plugins/FeedsFetcher.inc";i:8;s:28:"plugins/FeedsFileFetcher.inc";i:9;s:28:"plugins/FeedsHTTPFetcher.inc";i:10;s:30:"plugins/FeedsNodeProcessor.inc";i:11;s:27:"plugins/FeedsOPMLParser.inc";i:12;s:23:"plugins/FeedsParser.inc";i:13;s:23:"plugins/FeedsPlugin.inc";i:14;s:26:"plugins/FeedsProcessor.inc";i:15;s:32:"plugins/FeedsSimplePieParser.inc";i:16;s:30:"plugins/FeedsSitemapParser.inc";i:17;s:34:"plugins/FeedsSyndicationParser.inc";i:18;s:30:"plugins/FeedsTermProcessor.inc";i:19;s:30:"plugins/FeedsUserProcessor.inc";i:20;s:16:"tests/feeds.test";i:21;s:36:"tests/common_syndication_parser.test";i:22;s:29:"tests/feeds_content_type.test";i:23;s:26:"tests/feeds_date_time.test";i:24;s:28:"tests/feeds_mapper_date.test";i:25;s:37:"tests/feeds_mapper_date_multiple.test";i:26;s:29:"tests/feeds_mapper_field.test";i:27;s:28:"tests/feeds_mapper_file.test";i:28;s:29:"tests/feeds_mapper_hooks.test";i:29;s:28:"tests/feeds_mapper_link.test";i:30;s:28:"tests/feeds_mapper_list.test";i:31;s:43:"tests/feeds_mapper_multilingual_fields.test";i:32;s:28:"tests/feeds_mapper_path.test";i:33;s:31:"tests/feeds_mapper_profile.test";i:34;s:30:"tests/feeds_mapper_unique.test";i:35;s:23:"tests/feeds_mapper.test";i:36;s:30:"tests/feeds_mapper_config.test";i:37;s:29:"tests/feeds_fetcher_file.test";i:38;s:37:"tests/feeds_mapper_format_config.test";i:39;s:29:"tests/feeds_fetcher_http.test";i:40;s:21:"tests/feeds_i18n.test";i:41;s:26:"tests/feeds_i18n_node.test";i:42;s:30:"tests/feeds_i18n_taxonomy.test";i:43;s:27:"tests/feeds_parser_csv.test";i:44;s:31:"tests/feeds_parser_sitemap.test";i:45;s:35:"tests/feeds_parser_syndication.test";i:46;s:31:"tests/feeds_processor_node.test";i:47;s:31:"tests/feeds_processor_term.test";i:48;s:31:"tests/feeds_processor_user.test";i:49;s:21:"tests/feeds_push.test";i:50;s:22:"tests/feeds_rules.test";i:51;s:26:"tests/feeds_scheduler.test";i:52;s:28:"tests/feeds_mapper_link.test";i:53;s:31:"tests/feeds_mapper_summary.test";i:54;s:32:"tests/feeds_mapper_taxonomy.test";i:55;s:23:"tests/feeds_tokens.test";i:56;s:23:"tests/http_request.test";i:57;s:21:"tests/parser_csv.test";i:58;s:50:"views/feeds_views_handler_argument_importer_id.inc";i:59;s:49:"views/feeds_views_handler_field_importer_name.inc";i:60;s:47:"views/feeds_views_handler_field_log_message.inc";i:61;s:44:"views/feeds_views_handler_field_severity.inc";i:62;s:42:"views/feeds_views_handler_field_source.inc";i:63;s:45:"views/feeds_views_handler_filter_severity.inc";i:64;s:55:"views/feeds_views_plugin_argument_validate_feed_nid.inc";}s:7:"version";s:13:"7.x-2.0-beta3";s:7:"project";s:5:"feeds";s:9:"datestamp";s:10:"1479993785";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7212";s:6:"weight";s:1:"0";s:11:"required_by";a:7:{s:22:"feeds_entity_processor";a:3:{s:4:"name";s:5:"feeds";s:16:"original_version";s:14:" (7.x-2.x-dev)";s:8:"versions";a:2:{i:0;a:2:{s:2:"op";s:1:"<";s:7:"version";s:3:"3.x";}i:1;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"2.x";}}}s:20:"bookpoints_importers";a:1:{s:4:"name";s:5:"feeds";}s:8:"feeds_ui";a:1:{s:4:"name";s:5:"feeds";}s:26:"entityreference_feeds_test";a:1:{s:4:"name";s:5:"feeds";}s:12:"feeds_import";a:1:{s:4:"name";s:5:"feeds";}s:10:"feeds_news";a:1:{s:4:"name";s:5:"feeds";}s:14:"relation_feeds";a:3:{s:4:"name";s:5:"feeds";s:16:"original_version";s:19:" (!=7.x-1.0-alpha8)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:"!=";s:7:"version";s:10:"1.0-alpha8";}}}}s:8:"requires";a:2:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:13:"job_scheduler";a:1:{s:4:"name";s:13:"job_scheduler";}}s:4:"sort";i:-30;}s:22:"feeds_entity_processor";O:8:"stdClass":11:{s:3:"uri";s:78:"sites/all/modules/contrib/feeds_entity_processor/feeds_entity_processor.module";s:8:"filename";s:78:"sites/all/modules/contrib/feeds_entity_processor/feeds_entity_processor.module";s:4:"name";s:22:"feeds_entity_processor";s:4:"info";a:12:{s:4:"name";s:22:"Feeds entity processor";s:11:"description";s:46:"Provides a generic entity processor for Feeds.";s:7:"package";s:5:"Feeds";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:19:"feeds (7.x-2.x-dev)";i:1;s:6:"entity";}s:5:"files";a:7:{i:0;s:44:"tests/src/FeedsEntityProcessorBasicTest.test";i:1;s:47:"tests/src/FeedsEntityProcessorPropertyTest.test";i:2;s:52:"src/Property/FeedsEntityProcessorPropertyBoolean.php";i:3;s:49:"src/Property/FeedsEntityProcessorPropertyDate.php";i:4;s:52:"src/Property/FeedsEntityProcessorPropertyDefault.php";i:5;s:51:"src/Property/FeedsEntityProcessorPropertyEntity.php";i:6;s:54:"src/Property/FeedsEntityProcessorPropertyInterface.php";}s:7:"version";s:11:"7.x-1.x-dev";s:7:"project";s:22:"feeds_entity_processor";s:9:"datestamp";s:10:"1456071845";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:62:"Feeds is currently using this module for one or more importers";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:20:"bookpoints_importers";a:1:{s:4:"name";s:22:"feeds_entity_processor";}}s:8:"requires";a:4:{s:5:"feeds";a:3:{s:4:"name";s:5:"feeds";s:16:"original_version";s:14:" (7.x-2.x-dev)";s:8:"versions";a:2:{i:0;a:2:{s:2:"op";s:1:"<";s:7:"version";s:3:"3.x";}i:1;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"2.x";}}}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:13:"job_scheduler";a:1:{s:4:"name";s:13:"job_scheduler";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-31;}s:27:"feeds_entity_processor_test";O:8:"stdClass":11:{s:3:"uri";s:125:"sites/all/modules/contrib/feeds_entity_processor/tests/modules/feeds_entity_processor_test/feeds_entity_processor_test.module";s:8:"filename";s:125:"sites/all/modules/contrib/feeds_entity_processor/tests/modules/feeds_entity_processor_test/feeds_entity_processor_test.module";s:4:"name";s:27:"feeds_entity_processor_test";s:4:"info";a:11:{s:4:"name";s:35:"Feeds entity processor module tests";s:11:"description";s:58:"Support module for Feeds entity processor related testing.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:5:"files";a:1:{i:0;s:50:"src/FeedsEntityProcessorTestMetadataController.php";}s:7:"version";s:11:"7.x-1.x-dev";s:7:"project";s:22:"feeds_entity_processor";s:9:"datestamp";s:10:"1456071845";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:12:"feeds_import";r:506;s:10:"feeds_news";r:550;s:11:"feeds_tests";O:8:"stdClass":11:{s:3:"uri";s:56:"sites/all/modules/contrib/feeds/tests/feeds_tests.module";s:8:"filename";s:56:"sites/all/modules/contrib/feeds/tests/feeds_tests.module";s:4:"name";s:11:"feeds_tests";s:4:"info";a:11:{s:4:"name";s:18:"Feeds module tests";s:11:"description";s:41:"Support module for Feeds related testing.";s:7:"package";s:7:"Testing";s:7:"version";s:13:"7.x-2.0-beta3";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:5:"feeds";s:9:"datestamp";s:10:"1479993785";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:8:"feeds_ui";O:8:"stdClass":11:{s:3:"uri";s:56:"sites/all/modules/contrib/feeds/feeds_ui/feeds_ui.module";s:8:"filename";s:56:"sites/all/modules/contrib/feeds/feeds_ui/feeds_ui.module";s:4:"name";s:8:"feeds_ui";s:4:"info";a:11:{s:4:"name";s:14:"Feeds Admin UI";s:11:"description";s:35:"Administrative UI for Feeds module.";s:7:"package";s:5:"Feeds";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"feeds";}s:9:"configure";s:21:"admin/structure/feeds";s:5:"files";a:1:{i:0;s:13:"feeds_ui.test";}s:7:"version";s:13:"7.x-2.0-beta3";s:7:"project";s:5:"feeds";s:9:"datestamp";s:10:"1479993785";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7000";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:26:"entityreference_feeds_test";a:1:{s:4:"name";s:8:"feeds_ui";}}s:8:"requires";a:3:{s:5:"feeds";a:1:{s:4:"name";s:5:"feeds";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:13:"job_scheduler";a:1:{s:4:"name";s:13:"job_scheduler";}}s:4:"sort";i:-76;}s:5:"field";O:8:"stdClass":11:{s:3:"uri";s:26:"modules/field/field.module";s:8:"filename";s:26:"modules/field/field.module";s:4:"name";s:5:"field";s:4:"info";a:12:{s:4:"name";s:5:"Field";s:11:"description";s:57:"Field API to add fields to entities like nodes and users.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:4:{i:0;s:12:"field.module";i:1;s:16:"field.attach.inc";i:2;s:20:"field.info.class.inc";i:3;s:16:"tests/field.test";}s:12:"dependencies";a:1:{i:0;s:17:"field_sql_storage";}s:8:"required";b:1;s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:15:"theme/field.css";s:29:"modules/field/theme/field.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7004";s:6:"weight";s:1:"0";s:11:"required_by";a:27:{s:17:"field_sql_storage";a:1:{s:4:"name";s:5:"field";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:7:"options";a:1:{s:4:"name";s:5:"field";}s:4:"text";a:1:{s:4:"name";s:5:"field";}s:17:"bookpoints_events";a:1:{s:4:"name";s:5:"field";}s:7:"comment";a:1:{s:4:"name";s:5:"field";}s:15:"entityform_test";a:1:{s:4:"name";s:5:"field";}s:4:"file";a:1:{s:4:"name";s:5:"field";}s:5:"image";a:1:{s:4:"name";s:5:"field";}s:8:"taxonomy";a:1:{s:4:"name";s:5:"field";}s:13:"features_test";a:1:{s:4:"name";s:5:"field";}s:11:"field_group";a:1:{s:4:"name";s:5:"field";}s:20:"field_group_multiple";a:1:{s:4:"name";s:5:"field";}s:8:"field_ui";a:1:{s:4:"name";s:5:"field";}s:22:"flag_comment_flag_test";a:1:{s:4:"name";s:5:"field";}s:5:"forum";a:1:{s:4:"name";s:5:"field";}s:10:"i18n_field";a:1:{s:4:"name";s:5:"field";}s:13:"i18n_taxonomy";a:1:{s:4:"name";s:5:"field";}s:10:"i18n_forum";a:1:{s:4:"name";s:5:"field";}s:4:"list";a:1:{s:4:"name";s:5:"field";}s:6:"number";a:1:{s:4:"name";s:5:"field";}s:8:"pantheon";a:1:{s:4:"name";s:5:"field";}s:18:"requirements2_test";a:1:{s:4:"name";s:5:"field";}s:13:"taxonomy_test";a:1:{s:4:"name";s:5:"field";}s:9:"telephone";a:1:{s:4:"name";s:5:"field";}s:7:"tracker";a:1:{s:4:"name";s:5:"field";}s:13:"workflowfield";a:1:{s:4:"name";s:5:"field";}}s:8:"requires";a:2:{s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:5:"field";a:1:{s:4:"name";s:5:"field";}}s:4:"sort";i:-24;}s:16:"field_collection";O:8:"stdClass":11:{s:3:"uri";s:66:"sites/all/modules/contrib/field_collection/field_collection.module";s:8:"filename";s:66:"sites/all/modules/contrib/field_collection/field_collection.module";s:4:"name";s:16:"field_collection";s:4:"info";a:13:{s:4:"name";s:16:"Field collection";s:11:"description";s:81:"Provides a field collection field, to which any number of fields can be attached.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:6:"entity";}s:5:"files";a:5:{i:0;s:21:"field_collection.test";i:1;s:27:"field_collection.entity.inc";i:2;s:25:"field_collection.info.inc";i:3;s:47:"views/field_collection_handler_relationship.inc";i:4;s:28:"field_collection.migrate.inc";}s:9:"configure";s:33:"admin/structure/field-collections";s:7:"package";s:6:"Fields";s:7:"version";s:14:"7.x-1.0-beta11";s:7:"project";s:16:"field_collection";s:9:"datestamp";s:10:"1454338759";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7006";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-84;}s:11:"field_group";O:8:"stdClass":11:{s:3:"uri";s:56:"sites/all/modules/contrib/field_group/field_group.module";s:8:"filename";s:56:"sites/all/modules/contrib/field_group/field_group.module";s:4:"name";s:11:"field_group";s:4:"info";a:10:{s:4:"name";s:11:"Field Group";s:11:"description";s:67:"Provides the ability to group your fields on both form and display.";s:7:"package";s:6:"Fields";s:12:"dependencies";a:2:{i:0;s:5:"field";i:1;s:6:"ctools";}s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:25:"tests/field_group.ui.test";i:1;s:30:"tests/field_group.display.test";}s:7:"version";s:7:"7.x-1.5";s:7:"project";s:11:"field_group";s:9:"datestamp";s:10:"1452033709";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7008";s:6:"weight";s:1:"1";s:11:"required_by";a:1:{s:20:"field_group_multiple";a:1:{s:4:"name";s:11:"field_group";}}s:8:"requires";a:3:{s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-85;}s:20:"field_group_multiple";O:8:"stdClass":11:{s:3:"uri";s:74:"sites/all/modules/contrib/field_group_multiple/field_group_multiple.module";s:8:"filename";s:74:"sites/all/modules/contrib/field_group_multiple/field_group_multiple.module";s:4:"name";s:20:"field_group_multiple";s:4:"info";a:10:{s:4:"name";s:20:"Field group multiple";s:11:"description";s:78:"Widget and display formatter for transposed grouping of multiple value fields.";s:7:"package";s:6:"Fields";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:33:"field_group_multiple.field_ui.inc";}s:12:"dependencies";a:3:{i:0;s:5:"field";i:1;s:6:"ctools";i:2;s:11:"field_group";}s:7:"version";s:13:"7.x-1.0-beta3";s:7:"project";s:20:"field_group_multiple";s:9:"datestamp";s:10:"1428343453";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"2";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:11:"field_group";a:1:{s:4:"name";s:11:"field_group";}}s:4:"sort";i:-86;}s:16:"field_group_test";O:8:"stdClass":11:{s:3:"uri";s:67:"sites/all/modules/contrib/field_group/tests/field_group_test.module";s:8:"filename";s:67:"sites/all/modules/contrib/field_group/tests/field_group_test.module";s:4:"name";s:16:"field_group_test";s:4:"info";a:11:{s:4:"name";s:16:"Field Group Test";s:11:"description";s:27:"Test module for Field Group";s:4:"core";s:3:"7.x";s:7:"package";s:6:"Fields";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-1.5";s:7:"project";s:11:"field_group";s:9:"datestamp";s:10:"1452033709";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:17:"field_permissions";O:8:"stdClass":11:{s:3:"uri";s:68:"sites/all/modules/contrib/field_permissions/field_permissions.module";s:8:"filename";s:68:"sites/all/modules/contrib/field_permissions/field_permissions.module";s:4:"name";s:17:"field_permissions";s:4:"info";a:11:{s:4:"name";s:17:"Field Permissions";s:11:"description";s:61:"Set field-level permissions to create, update or view fields.";s:7:"package";s:6:"Fields";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:22:"field_permissions.test";}s:9:"configure";s:32:"admin/reports/fields/permissions";s:7:"version";s:7:"7.x-1.0";s:7:"project";s:17:"field_permissions";s:9:"datestamp";s:10:"1476649740";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7001";s:6:"weight";s:2:"50";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:17:"field_sql_storage";O:8:"stdClass":11:{s:3:"uri";s:64:"modules/field/modules/field_sql_storage/field_sql_storage.module";s:8:"filename";s:64:"modules/field/modules/field_sql_storage/field_sql_storage.module";s:4:"name";s:17:"field_sql_storage";s:4:"info";a:11:{s:4:"name";s:17:"Field SQL storage";s:11:"description";s:37:"Stores field data in an SQL database.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:22:"field_sql_storage.test";}s:8:"required";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7002";s:6:"weight";s:1:"0";s:11:"required_by";a:27:{s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:5:"field";a:1:{s:4:"name";s:17:"field_sql_storage";}s:7:"options";a:1:{s:4:"name";s:17:"field_sql_storage";}s:4:"text";a:1:{s:4:"name";s:17:"field_sql_storage";}s:17:"bookpoints_events";a:1:{s:4:"name";s:17:"field_sql_storage";}s:7:"comment";a:1:{s:4:"name";s:17:"field_sql_storage";}s:15:"entityform_test";a:1:{s:4:"name";s:17:"field_sql_storage";}s:4:"file";a:1:{s:4:"name";s:17:"field_sql_storage";}s:5:"image";a:1:{s:4:"name";s:17:"field_sql_storage";}s:8:"taxonomy";a:1:{s:4:"name";s:17:"field_sql_storage";}s:13:"features_test";a:1:{s:4:"name";s:17:"field_sql_storage";}s:11:"field_group";a:1:{s:4:"name";s:17:"field_sql_storage";}s:20:"field_group_multiple";a:1:{s:4:"name";s:17:"field_sql_storage";}s:8:"field_ui";a:1:{s:4:"name";s:17:"field_sql_storage";}s:22:"flag_comment_flag_test";a:1:{s:4:"name";s:17:"field_sql_storage";}s:5:"forum";a:1:{s:4:"name";s:17:"field_sql_storage";}s:10:"i18n_field";a:1:{s:4:"name";s:17:"field_sql_storage";}s:13:"i18n_taxonomy";a:1:{s:4:"name";s:17:"field_sql_storage";}s:10:"i18n_forum";a:1:{s:4:"name";s:17:"field_sql_storage";}s:4:"list";a:1:{s:4:"name";s:17:"field_sql_storage";}s:6:"number";a:1:{s:4:"name";s:17:"field_sql_storage";}s:8:"pantheon";a:1:{s:4:"name";s:17:"field_sql_storage";}s:18:"requirements2_test";a:1:{s:4:"name";s:17:"field_sql_storage";}s:13:"taxonomy_test";a:1:{s:4:"name";s:17:"field_sql_storage";}s:9:"telephone";a:1:{s:4:"name";s:17:"field_sql_storage";}s:7:"tracker";a:1:{s:4:"name";s:17:"field_sql_storage";}s:13:"workflowfield";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:8:"requires";a:2:{s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-23;}s:10:"field_test";O:8:"stdClass":11:{s:3:"uri";s:37:"modules/field/tests/field_test.module";s:8:"filename";s:37:"modules/field/tests/field_test.module";s:4:"name";s:10:"field_test";s:4:"info";a:11:{s:4:"name";s:14:"Field API Test";s:11:"description";s:39:"Support module for the Field API tests.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:5:"files";a:1:{i:0;s:21:"field_test.entity.inc";}s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:8:"field_ui";O:8:"stdClass":11:{s:3:"uri";s:32:"modules/field_ui/field_ui.module";s:8:"filename";s:32:"modules/field_ui/field_ui.module";s:4:"name";s:8:"field_ui";s:4:"info";a:10:{s:4:"name";s:8:"Field UI";s:11:"description";s:33:"User interface for the Field API.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:13:"field_ui.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"pantheon";a:1:{s:4:"name";s:8:"field_ui";}}s:8:"requires";a:2:{s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-87;}s:4:"file";O:8:"stdClass":11:{s:3:"uri";s:24:"modules/file/file.module";s:8:"filename";s:24:"modules/file/file.module";s:4:"name";s:4:"file";s:4:"info";a:10:{s:4:"name";s:4:"File";s:11:"description";s:26:"Defines a file field type.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:15:"tests/file.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:3:{s:5:"image";a:1:{s:4:"name";s:4:"file";}s:13:"features_test";a:1:{s:4:"name";s:4:"file";}s:8:"pantheon";a:1:{s:4:"name";s:4:"file";}}s:8:"requires";a:2:{s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-78;}s:16:"file_module_test";O:8:"stdClass":11:{s:3:"uri";s:42:"modules/file/tests/file_module_test.module";s:8:"filename";s:42:"modules/file/tests/file_module_test.module";s:4:"name";s:16:"file_module_test";s:4:"info";a:11:{s:4:"name";s:9:"File test";s:11:"description";s:53:"Provides hooks for testing File module functionality.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:9:"file_test";O:8:"stdClass":11:{s:3:"uri";s:41:"modules/simpletest/tests/file_test.module";s:8:"filename";s:41:"modules/simpletest/tests/file_test.module";s:4:"name";s:9:"file_test";s:4:"info";a:11:{s:4:"name";s:9:"File test";s:11:"description";s:39:"Support module for file handling tests.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:16:"file_test.module";}s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:6:"filter";O:8:"stdClass":11:{s:3:"uri";s:28:"modules/filter/filter.module";s:8:"filename";s:28:"modules/filter/filter.module";s:4:"name";s:6:"filter";s:4:"info";a:12:{s:4:"name";s:6:"Filter";s:11:"description";s:43:"Filters content in preparation for display.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:11:"filter.test";}s:8:"required";b:1;s:9:"configure";s:28:"admin/config/content/formats";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7010";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:29:"system_project_namespace_test";a:2:{s:7:"project";s:6:"drupal";s:4:"name";s:6:"filter";}}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:11:"filter_test";O:8:"stdClass":11:{s:3:"uri";s:43:"modules/simpletest/tests/filter_test.module";s:8:"filename";s:43:"modules/simpletest/tests/filter_test.module";s:4:"name";s:11:"filter_test";s:4:"info";a:11:{s:4:"name";s:18:"Filter test module";s:11:"description";s:33:"Tests filter hooks and functions.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"flag";O:8:"stdClass":11:{s:3:"uri";s:42:"sites/all/modules/contrib/flag/flag.module";s:8:"filename";s:42:"sites/all/modules/contrib/flag/flag.module";s:4:"name";s:4:"flag";s:4:"info";a:12:{s:4:"name";s:4:"Flag";s:11:"description";s:55:"Create customized flags that users can set on entities.";s:4:"core";s:3:"7.x";s:7:"package";s:5:"Flags";s:9:"configure";s:21:"admin/structure/flags";s:17:"test_dependencies";a:2:{i:0;s:5:"token";i:1;s:5:"rules";}s:5:"files";a:16:{i:0;s:27:"includes/flag/flag_flag.inc";i:1;s:29:"includes/flag/flag_entity.inc";i:2;s:27:"includes/flag/flag_node.inc";i:3;s:30:"includes/flag/flag_comment.inc";i:4;s:27:"includes/flag/flag_user.inc";i:5;s:32:"includes/flag.cookie_storage.inc";i:6;s:24:"includes/flag.entity.inc";i:7;s:14:"flag.rules.inc";i:8;s:50:"includes/views/flag_handler_argument_entity_id.inc";i:9;s:41:"includes/views/flag_handler_field_ops.inc";i:10;s:45:"includes/views/flag_handler_field_flagged.inc";i:11;s:46:"includes/views/flag_handler_filter_flagged.inc";i:12;s:44:"includes/views/flag_handler_sort_flagged.inc";i:13;s:45:"includes/views/flag_handler_relationships.inc";i:14;s:61:"includes/views/flag_plugin_argument_validate_flaggability.inc";i:15;s:15:"tests/flag.test";}s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:6:{s:12:"flag_actions";a:1:{s:4:"name";s:4:"flag";}s:13:"flag_bookmark";a:1:{s:4:"name";s:4:"flag";}s:22:"flag_comment_flag_test";a:1:{s:4:"name";s:4:"flag";}s:16:"flag_fields_test";a:1:{s:4:"name";s:4:"flag";}s:14:"flag_hook_test";a:1:{s:4:"name";s:4:"flag";}s:14:"flagaccesstest";a:1:{s:4:"name";s:4:"flag";}}s:8:"requires";a:0:{}s:4:"sort";i:-88;}s:12:"flag_actions";O:8:"stdClass":11:{s:3:"uri";s:50:"sites/all/modules/contrib/flag/flag_actions.module";s:8:"filename";s:50:"sites/all/modules/contrib/flag/flag_actions.module";s:4:"name";s:12:"flag_actions";s:4:"info";a:11:{s:4:"name";s:12:"Flag actions";s:11:"description";s:31:"Execute actions on Flag events.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:4:"flag";}s:7:"package";s:5:"Flags";s:9:"configure";s:29:"admin/structure/flags/actions";s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:4:"flag";a:1:{s:4:"name";s:4:"flag";}}s:4:"sort";i:-89;}s:13:"flag_bookmark";O:8:"stdClass":11:{s:3:"uri";s:65:"sites/all/modules/contrib/flag/flag_bookmark/flag_bookmark.module";s:8:"filename";s:65:"sites/all/modules/contrib/flag/flag_bookmark/flag_bookmark.module";s:4:"name";s:13:"flag_bookmark";s:4:"info";a:10:{s:4:"name";s:13:"Flag Bookmark";s:11:"description";s:55:"Provides an example bookmark flag and supporting views.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:4:"flag";}s:7:"package";s:5:"Flags";s:5:"files";a:1:{i:0;s:46:"plugins/flag_bookmark_plugin_validate_user.inc";}s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:4:"flag";a:1:{s:4:"name";s:4:"flag";}}s:4:"sort";i:-90;}s:22:"flag_comment_flag_test";O:8:"stdClass":11:{s:3:"uri";s:89:"sites/all/modules/contrib/flag/tests/flag_comment_flag_test/flag_comment_flag_test.module";s:8:"filename";s:89:"sites/all/modules/contrib/flag/tests/flag_comment_flag_test/flag_comment_flag_test.module";s:4:"name";s:22:"flag_comment_flag_test";s:4:"info";a:11:{s:4:"name";s:22:"Flag Comment Flag Test";s:11:"description";s:30:"Test module for comment flags.";s:12:"dependencies";a:2:{i:0;s:4:"flag";i:1;s:7:"comment";}s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:7:"package";s:5:"Other";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:5:{s:4:"flag";a:1:{s:4:"name";s:4:"flag";}s:7:"comment";a:1:{s:4:"name";s:7:"comment";}s:4:"text";a:1:{s:4:"name";s:4:"text";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-91;}s:16:"flag_fields_test";O:8:"stdClass":11:{s:3:"uri";s:77:"sites/all/modules/contrib/flag/tests/flag_fields_test/flag_fields_test.module";s:8:"filename";s:77:"sites/all/modules/contrib/flag/tests/flag_fields_test/flag_fields_test.module";s:4:"name";s:16:"flag_fields_test";s:4:"info";a:11:{s:4:"name";s:16:"Flag Fields Test";s:11:"description";s:44:"Test module for fields on Flagging entities.";s:12:"dependencies";a:1:{i:0;s:4:"flag";}s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:7:"package";s:5:"Other";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:4:"flag";a:1:{s:4:"name";s:4:"flag";}}s:4:"sort";i:-92;}s:14:"flag_hook_test";O:8:"stdClass":11:{s:3:"uri";s:73:"sites/all/modules/contrib/flag/tests/flag_hook_test/flag_hook_test.module";s:8:"filename";s:73:"sites/all/modules/contrib/flag/tests/flag_hook_test/flag_hook_test.module";s:4:"name";s:14:"flag_hook_test";s:4:"info";a:11:{s:4:"name";s:15:"Flag Hooks Test";s:11:"description";s:41:"Test module for invocation of flag hooks.";s:12:"dependencies";a:2:{i:0;s:4:"flag";i:1;s:5:"rules";}s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:7:"package";s:5:"Other";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:4:"flag";a:1:{s:4:"name";s:4:"flag";}s:5:"rules";a:1:{s:4:"name";s:5:"rules";}s:12:"entity_token";a:1:{s:4:"name";s:12:"entity_token";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-93;}s:14:"flagaccesstest";O:8:"stdClass":11:{s:3:"uri";s:73:"sites/all/modules/contrib/flag/tests/flagaccesstest/flagaccesstest.module";s:8:"filename";s:73:"sites/all/modules/contrib/flag/tests/flagaccesstest/flagaccesstest.module";s:4:"name";s:14:"flagaccesstest";s:4:"info";a:11:{s:4:"name";s:26:"Flag hook_flag_access test";s:11:"description";s:26:"Tests for hook_flag_access";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:4:"flag";}s:7:"package";s:5:"Flags";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:4:"flag";a:1:{s:4:"name";s:4:"flag";}}s:4:"sort";i:-94;}s:9:"form_test";O:8:"stdClass":11:{s:3:"uri";s:41:"modules/simpletest/tests/form_test.module";s:8:"filename";s:41:"modules/simpletest/tests/form_test.module";s:4:"name";s:9:"form_test";s:4:"info";a:11:{s:4:"name";s:12:"FormAPI Test";s:11:"description";s:34:"Support module for Form API tests.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:5:"forum";O:8:"stdClass":11:{s:3:"uri";s:26:"modules/forum/forum.module";s:8:"filename";s:26:"modules/forum/forum.module";s:4:"name";s:5:"forum";s:4:"info";a:12:{s:4:"name";s:5:"Forum";s:11:"description";s:27:"Provides discussion forums.";s:12:"dependencies";a:2:{i:0;s:8:"taxonomy";i:1;s:7:"comment";}s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:10:"forum.test";}s:9:"configure";s:21:"admin/structure/forum";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:9:"forum.css";s:23:"modules/forum/forum.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:10:"i18n_forum";a:1:{s:4:"name";s:5:"forum";}}s:8:"requires";a:6:{s:8:"taxonomy";a:1:{s:4:"name";s:8:"taxonomy";}s:7:"options";a:1:{s:4:"name";s:7:"options";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:7:"comment";a:1:{s:4:"name";s:7:"comment";}s:4:"text";a:1:{s:4:"name";s:4:"text";}}s:4:"sort";i:-95;}s:13:"galecia_model";O:8:"stdClass":11:{s:3:"uri";s:59:"sites/all/modules/custom/galecia_model/galecia_model.module";s:8:"filename";s:59:"sites/all/modules/custom/galecia_model/galecia_model.module";s:4:"name";s:13:"galecia_model";s:4:"info";a:8:{s:4:"name";s:20:"Galecia Model Module";s:11:"description";s:73:"A custom module containing various functionality for the Galecia Project.";s:4:"core";s:3:"7.x";s:7:"package";s:9:"Dashboard";s:12:"dependencies";a:0:{}s:7:"version";N;s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:23:"galecia_profile_builder";O:8:"stdClass":11:{s:3:"uri";s:79:"sites/all/modules/custom/galecia_profile_builder/galecia_profile_builder.module";s:8:"filename";s:79:"sites/all/modules/custom/galecia_profile_builder/galecia_profile_builder.module";s:4:"name";s:23:"galecia_profile_builder";s:4:"info";a:8:{s:4:"name";s:23:"Galecia Profile Builder";s:11:"description";s:68:"This module will create a custom node form to add users and readers.";s:4:"core";s:3:"7.x";s:7:"package";s:12:"Custom Forms";s:12:"dependencies";a:0:{}s:7:"version";N;s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:24:"galecia_reader_dashboard";O:8:"stdClass":11:{s:3:"uri";s:81:"sites/all/modules/custom/galecia_reader_dashboard/galecia_reader_dashboard.module";s:8:"filename";s:81:"sites/all/modules/custom/galecia_reader_dashboard/galecia_reader_dashboard.module";s:4:"name";s:24:"galecia_reader_dashboard";s:4:"info";a:8:{s:4:"name";s:31:"Galecia Reader Dashboard Module";s:11:"description";s:82:"A custom module containing various functionality for the Galecia Reader Dashboard.";s:4:"core";s:3:"7.x";s:7:"package";s:9:"Dashboard";s:12:"dependencies";a:0:{}s:7:"version";N;s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:15:"googleanalytics";O:8:"stdClass":11:{s:3:"uri";s:65:"sites/all/modules/contrib/google_analytics/googleanalytics.module";s:8:"filename";s:65:"sites/all/modules/contrib/google_analytics/googleanalytics.module";s:4:"name";s:15:"googleanalytics";s:4:"info";a:12:{s:4:"name";s:16:"Google Analytics";s:11:"description";s:102:"Allows your site to be tracked by Google Analytics by adding a Javascript tracking code to every page.";s:4:"core";s:3:"7.x";s:7:"package";s:10:"Statistics";s:9:"configure";s:35:"admin/config/system/googleanalytics";s:5:"files";a:1:{i:0;s:20:"googleanalytics.test";}s:17:"test_dependencies";a:1:{i:0;s:5:"token";}s:7:"version";s:7:"7.x-2.3";s:7:"project";s:16:"google_analytics";s:9:"datestamp";s:10:"1470779953";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7205";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:10:"gtranslate";O:8:"stdClass":11:{s:3:"uri";s:54:"sites/all/modules/contrib/gtranslate/gtranslate.module";s:8:"filename";s:54:"sites/all/modules/contrib/gtranslate/gtranslate.module";s:4:"name";s:10:"gtranslate";s:4:"info";a:11:{s:4:"name";s:10:"GTranslate";s:11:"description";s:45:"Uses Google power to translate your web site.";s:9:"configure";s:32:"admin/config/regional/gtranslate";s:7:"package";s:13:"Multilanguage";s:4:"core";s:3:"7.x";s:7:"version";s:8:"7.x-1.14";s:7:"project";s:10:"gtranslate";s:9:"datestamp";s:10:"1473179357";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"help";O:8:"stdClass":11:{s:3:"uri";s:24:"modules/help/help.module";s:8:"filename";s:24:"modules/help/help.module";s:4:"name";s:4:"help";s:4:"info";a:10:{s:4:"name";s:4:"Help";s:11:"description";s:35:"Manages the display of online help.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:9:"help.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"pantheon";a:1:{s:4:"name";s:4:"help";}}s:8:"requires";a:0:{}s:4:"sort";i:-96;}s:12:"help_example";O:8:"stdClass":11:{s:3:"uri";s:72:"sites/all/modules/contrib/advanced_help/help_example/help_example.module";s:8:"filename";s:72:"sites/all/modules/contrib/advanced_help/help_example/help_example.module";s:4:"name";s:12:"help_example";s:4:"info";a:11:{s:4:"name";s:21:"Advanced help example";s:11:"description";s:62:"A example help module to demonstrate the advanced help module.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:13:"advanced_help";}s:12:"attributions";a:3:{s:18:"wikipedia_adaption";a:11:{s:4:"type";s:5:"asset";s:6:"weight";s:3:"-10";s:9:"exception";s:8:"#2460769";s:5:"title";s:68:"About PHP, History of PHP, Usage of PHP, PHP Syntax, Security of PHP";s:11:"license_url";s:46:"http://creativecommons.org/licenses/by-sa/3.0/";s:9:"org_title";s:15:"PHP (Wikipedia)";s:10:"org_author";s:31:"multiple Wikipedia contributors";s:14:"org_author_url";s:60:"http://en.wikipedia.org/w/index.php?title=PHP&action=history";s:12:"org_work_url";s:32:"http://en.wikipedia.org/wiki/PHP";s:11:"org_license";s:26:"Creative Commons BY-SA 3.0";s:15:"org_license_url";s:107:"http://en.wikipedia.org/wiki/Wikipedia:Text_of_Creative_Commons_Attribution-ShareAlike_3.0_Unported_License";}s:7:"lerdorf";a:7:{s:4:"type";s:5:"asset";s:9:"exception";s:8:"#2460769";s:6:"author";s:11:"Jud Dagnall";s:8:"work_url";s:45:"http://en.wikipedia.org/wiki/File:Lerdorf.jpg";s:5:"title";s:7:"Lerdorf";s:7:"license";s:26:"Creative Commons BY-SA 3.0";s:11:"license_url";s:53:"http://creativecommons.org/licenses/by-sa/3.0/deed.en";}s:7:"gutmans";a:8:{s:4:"type";s:5:"asset";s:9:"exception";s:8:"#2460769";s:6:"author";s:12:"Jim Winstead";s:10:"author_url";s:42:"https://www.flickr.com/people/81342178@N00";s:8:"work_url";s:52:"http://en.wikipedia.org/wiki/File:Andi_Gutmans_1.jpg";s:5:"title";s:12:"Andi Gutmans";s:7:"license";s:23:"Creative Commons BY 2.0";s:11:"license_url";s:50:"http://creativecommons.org/licenses/by/2.0/deed.en";}}s:7:"version";s:7:"7.x-1.3";s:7:"project";s:13:"advanced_help";s:9:"datestamp";s:10:"1432557782";s:7:"package";s:5:"Other";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:13:"advanced_help";a:1:{s:4:"name";s:13:"advanced_help";}}s:4:"sort";i:-97;}s:4:"i18n";O:8:"stdClass":11:{s:3:"uri";s:42:"sites/all/modules/contrib/i18n/i18n.module";s:8:"filename";s:42:"sites/all/modules/contrib/i18n/i18n.module";s:4:"name";s:4:"i18n";s:4:"info";a:11:{s:4:"name";s:20:"Internationalization";s:11:"description";s:49:"Extends Drupal support for multilingual features.";s:12:"dependencies";a:2:{i:0;s:6:"locale";i:1;s:8:"variable";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:15:"i18n_object.inc";i:1;s:9:"i18n.test";}s:9:"configure";s:26:"admin/config/regional/i18n";s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:20:{s:11:"i18n_string";a:1:{s:4:"name";s:4:"i18n";}s:16:"entity_test_i18n";a:1:{s:4:"name";s:4:"i18n";}s:10:"i18n_block";a:1:{s:4:"name";s:4:"i18n";}s:12:"i18n_contact";a:1:{s:4:"name";s:4:"i18n";}s:10:"i18n_field";a:1:{s:4:"name";s:4:"i18n";}s:16:"i18n_translation";a:1:{s:4:"name";s:4:"i18n";}s:13:"i18n_taxonomy";a:1:{s:4:"name";s:4:"i18n";}s:9:"i18n_node";a:1:{s:4:"name";s:4:"i18n";}s:10:"i18n_forum";a:1:{s:4:"name";s:4:"i18n";}s:9:"i18n_menu";a:1:{s:4:"name";s:4:"i18n";}s:11:"i18n_panels";a:1:{s:4:"name";s:4:"i18n";}s:9:"i18n_path";a:1:{s:4:"name";s:4:"i18n";}s:13:"i18n_redirect";a:1:{s:4:"name";s:4:"i18n";}s:11:"i18n_select";a:1:{s:4:"name";s:4:"i18n";}s:9:"i18n_sync";a:1:{s:4:"name";s:4:"i18n";}s:9:"i18n_test";a:1:{s:4:"name";s:4:"i18n";}s:13:"i18n_variable";a:1:{s:4:"name";s:4:"i18n";}s:9:"i18n_user";a:1:{s:4:"name";s:4:"i18n";}s:9:"i18nviews";a:1:{s:4:"name";s:4:"i18n";}s:10:"rules_i18n";a:1:{s:4:"name";s:4:"i18n";}}s:8:"requires";a:2:{s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-68;}s:10:"i18n_block";O:8:"stdClass":11:{s:3:"uri";s:59:"sites/all/modules/contrib/i18n/i18n_block/i18n_block.module";s:8:"filename";s:59:"sites/all/modules/contrib/i18n/i18n_block/i18n_block.module";s:4:"name";s:10:"i18n_block";s:4:"info";a:10:{s:4:"name";s:15:"Block languages";s:11:"description";s:68:"Enables language selector for blocks and optional block translation.";s:12:"dependencies";a:2:{i:0;s:5:"block";i:1;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:14:"i18n_block.inc";i:1;s:15:"i18n_block.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:5:{s:5:"block";a:1:{s:4:"name";s:5:"block";}s:11:"i18n_string";a:1:{s:4:"name";s:11:"i18n_string";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-98;}s:12:"i18n_contact";O:8:"stdClass":11:{s:3:"uri";s:63:"sites/all/modules/contrib/i18n/i18n_contact/i18n_contact.module";s:8:"filename";s:63:"sites/all/modules/contrib/i18n/i18n_contact/i18n_contact.module";s:4:"name";s:12:"i18n_contact";s:4:"info";a:10:{s:4:"name";s:19:"Contact translation";s:11:"description";s:63:"Makes contact categories and replies available for translation.";s:12:"dependencies";a:2:{i:0;s:7:"contact";i:1;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:5:{s:7:"contact";a:1:{s:4:"name";s:7:"contact";}s:11:"i18n_string";a:1:{s:4:"name";s:11:"i18n_string";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-99;}s:10:"i18n_field";O:8:"stdClass":11:{s:3:"uri";s:59:"sites/all/modules/contrib/i18n/i18n_field/i18n_field.module";s:8:"filename";s:59:"sites/all/modules/contrib/i18n/i18n_field/i18n_field.module";s:4:"name";s:10:"i18n_field";s:4:"info";a:10:{s:4:"name";s:17:"Field translation";s:11:"description";s:26:"Translate field properties";s:12:"dependencies";a:2:{i:0;s:5:"field";i:1;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:14:"i18n_field.inc";i:1;s:15:"i18n_field.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:6:{s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:11:"i18n_string";a:1:{s:4:"name";s:11:"i18n_string";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-100;}s:10:"i18n_forum";O:8:"stdClass":11:{s:3:"uri";s:59:"sites/all/modules/contrib/i18n/i18n_forum/i18n_forum.module";s:8:"filename";s:59:"sites/all/modules/contrib/i18n/i18n_forum/i18n_forum.module";s:4:"name";s:10:"i18n_forum";s:4:"info";a:10:{s:4:"name";s:18:"Multilingual forum";s:11:"description";s:60:"Enables multilingual forum, translates names and containers.";s:12:"dependencies";a:3:{i:0;s:5:"forum";i:1;s:13:"i18n_taxonomy";i:2;s:9:"i18n_node";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:15:"i18n_forum.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:15:{s:5:"forum";a:1:{s:4:"name";s:5:"forum";}s:8:"taxonomy";a:1:{s:4:"name";s:8:"taxonomy";}s:7:"options";a:1:{s:4:"name";s:7:"options";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:7:"comment";a:1:{s:4:"name";s:7:"comment";}s:4:"text";a:1:{s:4:"name";s:4:"text";}s:13:"i18n_taxonomy";a:1:{s:4:"name";s:13:"i18n_taxonomy";}s:11:"i18n_string";a:1:{s:4:"name";s:11:"i18n_string";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}s:16:"i18n_translation";a:1:{s:4:"name";s:16:"i18n_translation";}s:9:"i18n_node";a:1:{s:4:"name";s:9:"i18n_node";}s:11:"translation";a:1:{s:4:"name";s:11:"translation";}}s:4:"sort";i:-105;}s:9:"i18n_menu";O:8:"stdClass":11:{s:3:"uri";s:57:"sites/all/modules/contrib/i18n/i18n_menu/i18n_menu.module";s:8:"filename";s:57:"sites/all/modules/contrib/i18n/i18n_menu/i18n_menu.module";s:4:"name";s:9:"i18n_menu";s:4:"info";a:10:{s:4:"name";s:16:"Menu translation";s:11:"description";s:40:"Supports translatable custom menu items.";s:12:"dependencies";a:4:{i:0;s:4:"i18n";i:1;s:4:"menu";i:2;s:11:"i18n_string";i:3;s:16:"i18n_translation";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:13:"i18n_menu.inc";i:1;s:14:"i18n_menu.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:6:{s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}s:4:"menu";a:1:{s:4:"name";s:4:"menu";}s:11:"i18n_string";a:1:{s:4:"name";s:11:"i18n_string";}s:16:"i18n_translation";a:1:{s:4:"name";s:16:"i18n_translation";}}s:4:"sort";i:-106;}s:9:"i18n_node";O:8:"stdClass":11:{s:3:"uri";s:57:"sites/all/modules/contrib/i18n/i18n_node/i18n_node.module";s:8:"filename";s:57:"sites/all/modules/contrib/i18n/i18n_node/i18n_node.module";s:4:"name";s:9:"i18n_node";s:4:"info";a:11:{s:4:"name";s:20:"Multilingual content";s:11:"description";s:46:"Extended node options for multilingual content";s:12:"dependencies";a:3:{i:0;s:11:"translation";i:1;s:4:"i18n";i:2;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:9:"configure";s:31:"admin/config/regional/i18n/node";s:5:"files";a:2:{i:0;s:14:"i18n_node.test";i:1;s:22:"i18n_node.variable.inc";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:10:"i18n_forum";a:1:{s:4:"name";s:9:"i18n_node";}}s:8:"requires";a:5:{s:11:"translation";a:1:{s:4:"name";s:11:"translation";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}s:11:"i18n_string";a:1:{s:4:"name";s:11:"i18n_string";}}s:4:"sort";i:-104;}s:11:"i18n_panels";O:8:"stdClass":11:{s:3:"uri";s:63:"sites/all/modules/contrib/panels/i18n_panels/i18n_panels.module";s:8:"filename";s:63:"sites/all/modules/contrib/panels/i18n_panels/i18n_panels.module";s:4:"name";s:11:"i18n_panels";s:4:"info";a:10:{s:4:"name";s:18:"Panels translation";s:11:"description";s:35:"Supports translatable panels items.";s:12:"dependencies";a:4:{i:0;s:4:"i18n";i:1;s:6:"panels";i:2;s:11:"i18n_string";i:3;s:16:"i18n_translation";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-3.8";s:7:"project";s:6:"panels";s:9:"datestamp";s:10:"1476582295";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:7:{s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}s:6:"panels";a:1:{s:4:"name";s:6:"panels";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:11:"i18n_string";a:1:{s:4:"name";s:11:"i18n_string";}s:16:"i18n_translation";a:1:{s:4:"name";s:16:"i18n_translation";}}s:4:"sort";i:-107;}s:9:"i18n_path";O:8:"stdClass":11:{s:3:"uri";s:57:"sites/all/modules/contrib/i18n/i18n_path/i18n_path.module";s:8:"filename";s:57:"sites/all/modules/contrib/i18n/i18n_path/i18n_path.module";s:4:"name";s:9:"i18n_path";s:4:"info";a:10:{s:4:"name";s:16:"Path translation";s:11:"description";s:37:"Define translations for generic paths";s:12:"dependencies";a:1:{i:0;s:16:"i18n_translation";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:13:"i18n_path.inc";i:1;s:14:"i18n_path.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:16:"i18n_translation";a:1:{s:4:"name";s:16:"i18n_translation";}s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-108;}s:13:"i18n_redirect";O:8:"stdClass":11:{s:3:"uri";s:65:"sites/all/modules/contrib/i18n/i18n_redirect/i18n_redirect.module";s:8:"filename";s:65:"sites/all/modules/contrib/i18n/i18n_redirect/i18n_redirect.module";s:4:"name";s:13:"i18n_redirect";s:4:"info";a:10:{s:4:"name";s:20:"Translation redirect";s:11:"description";s:71:"Redirect to translated page when available. SEO for multilingual sites.";s:12:"dependencies";a:1:{i:0;s:4:"i18n";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-109;}s:11:"i18n_select";O:8:"stdClass":11:{s:3:"uri";s:61:"sites/all/modules/contrib/i18n/i18n_select/i18n_select.module";s:8:"filename";s:61:"sites/all/modules/contrib/i18n/i18n_select/i18n_select.module";s:4:"name";s:11:"i18n_select";s:4:"info";a:11:{s:4:"name";s:19:"Multilingual select";s:11:"description";s:45:"API module for multilingual content selection";s:12:"dependencies";a:1:{i:0;s:4:"i18n";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:9:"configure";s:33:"admin/config/regional/i18n/select";s:5:"files";a:1:{i:0;s:16:"i18n_select.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-110;}s:11:"i18n_string";O:8:"stdClass":11:{s:3:"uri";s:61:"sites/all/modules/contrib/i18n/i18n_string/i18n_string.module";s:8:"filename";s:61:"sites/all/modules/contrib/i18n/i18n_string/i18n_string.module";s:4:"name";s:11:"i18n_string";s:4:"info";a:11:{s:4:"name";s:18:"String translation";s:11:"description";s:57:"Provides support for translation of user defined strings.";s:12:"dependencies";a:2:{i:0;s:6:"locale";i:1;s:4:"i18n";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:3:{i:0;s:21:"i18n_string.admin.inc";i:1;s:15:"i18n_string.inc";i:2;s:16:"i18n_string.test";}s:9:"configure";s:34:"admin/config/regional/i18n/strings";s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:11:{s:16:"entity_test_i18n";a:1:{s:4:"name";s:11:"i18n_string";}s:10:"i18n_block";a:1:{s:4:"name";s:11:"i18n_string";}s:12:"i18n_contact";a:1:{s:4:"name";s:11:"i18n_string";}s:10:"i18n_field";a:1:{s:4:"name";s:11:"i18n_string";}s:13:"i18n_taxonomy";a:1:{s:4:"name";s:11:"i18n_string";}s:9:"i18n_node";a:1:{s:4:"name";s:11:"i18n_string";}s:10:"i18n_forum";a:1:{s:4:"name";s:11:"i18n_string";}s:9:"i18n_menu";a:1:{s:4:"name";s:11:"i18n_string";}s:11:"i18n_panels";a:1:{s:4:"name";s:11:"i18n_string";}s:9:"i18nviews";a:1:{s:4:"name";s:11:"i18n_string";}s:10:"rules_i18n";a:1:{s:4:"name";s:11:"i18n_string";}}s:8:"requires";a:3:{s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-69;}s:9:"i18n_sync";O:8:"stdClass":11:{s:3:"uri";s:57:"sites/all/modules/contrib/i18n/i18n_sync/i18n_sync.module";s:8:"filename";s:57:"sites/all/modules/contrib/i18n/i18n_sync/i18n_sync.module";s:4:"name";s:9:"i18n_sync";s:4:"info";a:10:{s:4:"name";s:24:"Synchronize translations";s:11:"description";s:74:"Synchronizes taxonomy and fields accross translations of the same content.";s:12:"dependencies";a:2:{i:0;s:4:"i18n";i:1;s:11:"translation";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:5:{i:0;s:16:"i18n_sync.module";i:1;s:17:"i18n_sync.install";i:2;s:20:"i18n_sync.module.inc";i:3;s:18:"i18n_sync.node.inc";i:4;s:14:"i18n_sync.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}s:11:"translation";a:1:{s:4:"name";s:11:"translation";}}s:4:"sort";i:-111;}s:13:"i18n_taxonomy";O:8:"stdClass":11:{s:3:"uri";s:65:"sites/all/modules/contrib/i18n/i18n_taxonomy/i18n_taxonomy.module";s:8:"filename";s:65:"sites/all/modules/contrib/i18n/i18n_taxonomy/i18n_taxonomy.module";s:4:"name";s:13:"i18n_taxonomy";s:4:"info";a:10:{s:4:"name";s:20:"Taxonomy translation";s:11:"description";s:30:"Enables multilingual taxonomy.";s:12:"dependencies";a:3:{i:0;s:8:"taxonomy";i:1;s:11:"i18n_string";i:2;s:16:"i18n_translation";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:4:{i:0;s:17:"i18n_taxonomy.inc";i:1;s:23:"i18n_taxonomy.pages.inc";i:2;s:23:"i18n_taxonomy.admin.inc";i:3;s:18:"i18n_taxonomy.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:10:"i18n_forum";a:1:{s:4:"name";s:13:"i18n_taxonomy";}}s:8:"requires";a:9:{s:8:"taxonomy";a:1:{s:4:"name";s:8:"taxonomy";}s:7:"options";a:1:{s:4:"name";s:7:"options";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:11:"i18n_string";a:1:{s:4:"name";s:11:"i18n_string";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}s:16:"i18n_translation";a:1:{s:4:"name";s:16:"i18n_translation";}}s:4:"sort";i:-102;}s:9:"i18n_test";O:8:"stdClass":11:{s:3:"uri";s:53:"sites/all/modules/contrib/i18n/tests/i18n_test.module";s:8:"filename";s:53:"sites/all/modules/contrib/i18n/tests/i18n_test.module";s:4:"name";s:9:"i18n_test";s:4:"info";a:11:{s:4:"name";s:26:"Internationalization tests";s:11:"description";s:55:"Helper module for testing i18n (do not enable manually)";s:12:"dependencies";a:3:{i:0;s:6:"locale";i:1;s:11:"translation";i:2;s:4:"i18n";}s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:11:"translation";a:1:{s:4:"name";s:11:"translation";}s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-112;}s:16:"i18n_translation";O:8:"stdClass":11:{s:3:"uri";s:71:"sites/all/modules/contrib/i18n/i18n_translation/i18n_translation.module";s:8:"filename";s:71:"sites/all/modules/contrib/i18n/i18n_translation/i18n_translation.module";s:4:"name";s:16:"i18n_translation";s:4:"info";a:10:{s:4:"name";s:16:"Translation sets";s:11:"description";s:47:"Simple translation sets API for generic objects";s:12:"dependencies";a:1:{i:0;s:4:"i18n";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:20:"i18n_translation.inc";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:5:{s:13:"i18n_taxonomy";a:1:{s:4:"name";s:16:"i18n_translation";}s:10:"i18n_forum";a:1:{s:4:"name";s:16:"i18n_translation";}s:9:"i18n_menu";a:1:{s:4:"name";s:16:"i18n_translation";}s:11:"i18n_panels";a:1:{s:4:"name";s:16:"i18n_translation";}s:9:"i18n_path";a:1:{s:4:"name";s:16:"i18n_translation";}}s:8:"requires";a:3:{s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-101;}s:9:"i18n_user";O:8:"stdClass":11:{s:3:"uri";s:57:"sites/all/modules/contrib/i18n/i18n_user/i18n_user.module";s:8:"filename";s:57:"sites/all/modules/contrib/i18n/i18n_user/i18n_user.module";s:4:"name";s:9:"i18n_user";s:4:"info";a:10:{s:4:"name";s:21:"User mail translation";s:11:"description";s:43:"Translate emails sent from the User module.";s:4:"core";s:3:"7.x";s:7:"package";s:35:"Multilingual - Internationalization";s:12:"dependencies";a:1:{i:0;s:13:"i18n_variable";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:6:{s:13:"i18n_variable";a:1:{s:4:"name";s:13:"i18n_variable";}s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}s:14:"variable_store";a:3:{s:4:"name";s:14:"variable_store";s:16:"original_version";s:10:" (7.x-2.x)";s:8:"versions";a:2:{i:0;a:2:{s:2:"op";s:1:"<";s:7:"version";s:3:"3.x";}i:1;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"2.x";}}}s:14:"variable_realm";a:3:{s:4:"name";s:14:"variable_realm";s:16:"original_version";s:10:" (7.x-2.x)";s:8:"versions";a:2:{i:0;a:2:{s:2:"op";s:1:"<";s:7:"version";s:3:"3.x";}i:1;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"2.x";}}}}s:4:"sort";i:-116;}s:13:"i18n_variable";O:8:"stdClass":11:{s:3:"uri";s:65:"sites/all/modules/contrib/i18n/i18n_variable/i18n_variable.module";s:8:"filename";s:65:"sites/all/modules/contrib/i18n/i18n_variable/i18n_variable.module";s:4:"name";s:13:"i18n_variable";s:4:"info";a:11:{s:4:"name";s:20:"Variable translation";s:11:"description";s:71:"Multilingual variables that switch language depending on page language.";s:12:"dependencies";a:3:{i:0;s:4:"i18n";i:1;s:24:"variable_store (7.x-2.x)";i:2;s:24:"variable_realm (7.x-2.x)";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:9:"configure";s:35:"admin/config/regional/i18n/variable";s:5:"files";a:2:{i:0;s:23:"i18n_variable.class.inc";i:1;s:18:"i18n_variable.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:9:"i18n_user";a:1:{s:4:"name";s:13:"i18n_variable";}}s:8:"requires";a:5:{s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}s:14:"variable_store";a:3:{s:4:"name";s:14:"variable_store";s:16:"original_version";s:10:" (7.x-2.x)";s:8:"versions";a:2:{i:0;a:2:{s:2:"op";s:1:"<";s:7:"version";s:3:"3.x";}i:1;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"2.x";}}}s:14:"variable_realm";a:3:{s:4:"name";s:14:"variable_realm";s:16:"original_version";s:10:" (7.x-2.x)";s:8:"versions";a:2:{i:0;a:2:{s:2:"op";s:1:"<";s:7:"version";s:3:"3.x";}i:1;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"2.x";}}}}s:4:"sort";i:-115;}s:9:"i18nviews";O:8:"stdClass":11:{s:3:"uri";s:52:"sites/all/modules/contrib/i18nviews/i18nviews.module";s:8:"filename";s:52:"sites/all/modules/contrib/i18nviews/i18nviews.module";s:4:"name";s:9:"i18nviews";s:4:"info";a:10:{s:4:"name";s:17:"Views translation";s:11:"description";s:80:"Translation of views strings and content selection for views. Requires Views 3.x";s:12:"dependencies";a:2:{i:0;s:5:"views";i:1;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:20:{i:0;s:13:"i18nviews.inc";i:1;s:18:"i18nviews.i18n.inc";i:2;s:49:"includes/i18nviews_handler_argument_node_type.inc";i:3;s:58:"includes/i18nviews_handler_argument_taxonomy_index_tid.inc";i:4;s:58:"includes/i18nviews_handler_argument_taxonomy_term_name.inc";i:5;s:62:"includes/i18nviews_handler_argument_taxonomy_term_language.inc";i:6;s:59:"includes/i18nviews_handler_argument_term_node_tid_depth.inc";i:7;s:46:"includes/i18nviews_handler_field_node_type.inc";i:8;s:62:"includes/i18nviews_handler_field_taxonomy_term_description.inc";i:9;s:59:"includes/i18nviews_handler_field_taxonomy_term_language.inc";i:10;s:55:"includes/i18nviews_handler_field_taxonomy_term_name.inc";i:11;s:50:"includes/i18nviews_handler_field_term_node_tid.inc";i:12;s:48:"includes/i18nviews_handler_filter_field_list.inc";i:13;s:47:"includes/i18nviews_handler_filter_node_type.inc";i:14;s:56:"includes/i18nviews_handler_filter_taxonomy_index_tid.inc";i:15;s:56:"includes/i18nviews_handler_filter_taxonomy_term_name.inc";i:16;s:60:"includes/i18nviews_handler_filter_taxonomy_term_language.inc";i:17;s:57:"includes/i18nviews_handler_filter_term_node_tid_depth.inc";i:18;s:66:"includes/i18nviews_plugin_argument_validate_i18n_taxonomy_term.inc";i:19;s:54:"includes/i18nviews_plugin_localization_i18nstrings.inc";}s:7:"version";s:14:"7.x-3.0-alpha1";s:7:"project";s:9:"i18nviews";s:9:"datestamp";s:10:"1454021946";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:6:{s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:11:"i18n_string";a:1:{s:4:"name";s:11:"i18n_string";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-117;}s:5:"image";O:8:"stdClass":11:{s:3:"uri";s:26:"modules/image/image.module";s:8:"filename";s:26:"modules/image/image.module";s:4:"name";s:5:"image";s:4:"info";a:13:{s:4:"name";s:5:"Image";s:11:"description";s:34:"Provides image manipulation tools.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:4:"file";}s:5:"files";a:1:{i:0;s:10:"image.test";}s:9:"configure";s:31:"admin/config/media/image-styles";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7005";s:6:"weight";s:1:"0";s:11:"required_by";a:2:{s:13:"features_test";a:1:{s:4:"name";s:5:"image";}s:8:"pantheon";a:1:{s:4:"name";s:5:"image";}}s:8:"requires";a:3:{s:4:"file";a:1:{s:4:"name";s:4:"file";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-79;}s:17:"image_module_test";O:8:"stdClass":11:{s:3:"uri";s:44:"modules/image/tests/image_module_test.module";s:8:"filename";s:44:"modules/image/tests/image_module_test.module";s:4:"name";s:17:"image_module_test";s:4:"info";a:11:{s:4:"name";s:10:"Image test";s:11:"description";s:69:"Provides hook implementations for testing Image module functionality.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:24:"image_module_test.module";}s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:10:"image_test";O:8:"stdClass":11:{s:3:"uri";s:42:"modules/simpletest/tests/image_test.module";s:8:"filename";s:42:"modules/simpletest/tests/image_test.module";s:4:"name";s:10:"image_test";s:4:"info";a:11:{s:4:"name";s:10:"Image test";s:11:"description";s:39:"Support module for image toolkit tests.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"imce";O:8:"stdClass":11:{s:3:"uri";s:42:"sites/all/modules/contrib/imce/imce.module";s:8:"filename";s:42:"sites/all/modules/contrib/imce/imce.module";s:4:"name";s:4:"imce";s:4:"info";a:11:{s:4:"name";s:4:"IMCE";s:11:"description";s:82:"An image/file uploader and browser supporting personal directories and user quota.";s:4:"core";s:3:"7.x";s:7:"package";s:5:"Media";s:9:"configure";s:23:"admin/config/media/imce";s:7:"version";s:8:"7.x-1.10";s:7:"project";s:4:"imce";s:9:"datestamp";s:10:"1459346870";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7002";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:12:"imce_wysiwyg";a:1:{s:4:"name";s:4:"imce";}}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:12:"imce_wysiwyg";O:8:"stdClass":11:{s:3:"uri";s:58:"sites/all/modules/contrib/imce_wysiwyg/imce_wysiwyg.module";s:8:"filename";s:58:"sites/all/modules/contrib/imce_wysiwyg/imce_wysiwyg.module";s:4:"name";s:12:"imce_wysiwyg";s:4:"info";a:10:{s:4:"name";s:23:"IMCE Wysiwyg API bridge";s:11:"description";s:82:"Makes IMCE available as plugin for client-side editors integrated via Wysiwyg API.";s:7:"package";s:14:"User interface";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:4:"imce";i:1;s:7:"wysiwyg";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:12:"imce_wysiwyg";s:9:"datestamp";s:10:"1317851503";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:4:"imce";a:1:{s:4:"name";s:4:"imce";}s:7:"wysiwyg";a:1:{s:4:"name";s:7:"wysiwyg";}}s:4:"sort";i:-2;}s:13:"job_scheduler";O:8:"stdClass":11:{s:3:"uri";s:60:"sites/all/modules/contrib/job_scheduler/job_scheduler.module";s:8:"filename";s:60:"sites/all/modules/contrib/job_scheduler/job_scheduler.module";s:4:"name";s:13:"job_scheduler";s:4:"info";a:10:{s:4:"name";s:13:"Job Scheduler";s:11:"description";s:13:"Scheduler API";s:5:"files";a:4:{i:0;s:20:"job_scheduler.module";i:1;s:21:"job_scheduler.install";i:2;s:16:"JobScheduler.inc";i:3;s:23:"JobSchedulerCronTab.inc";}s:4:"core";s:3:"7.x";s:7:"version";s:14:"7.x-2.0-alpha3";s:7:"project";s:13:"job_scheduler";s:9:"datestamp";s:10:"1336466457";s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7101";s:6:"weight";s:1:"0";s:11:"required_by";a:9:{s:5:"feeds";a:1:{s:4:"name";s:13:"job_scheduler";}s:22:"feeds_entity_processor";a:1:{s:4:"name";s:13:"job_scheduler";}s:20:"bookpoints_importers";a:1:{s:4:"name";s:13:"job_scheduler";}s:8:"feeds_ui";a:1:{s:4:"name";s:13:"job_scheduler";}s:26:"entityreference_feeds_test";a:1:{s:4:"name";s:13:"job_scheduler";}s:12:"feeds_import";a:1:{s:4:"name";s:13:"job_scheduler";}s:10:"feeds_news";a:1:{s:4:"name";s:13:"job_scheduler";}s:21:"job_scheduler_trigger";a:1:{s:4:"name";s:13:"job_scheduler";}s:14:"relation_feeds";a:1:{s:4:"name";s:13:"job_scheduler";}}s:8:"requires";a:0:{}s:4:"sort";i:-29;}s:21:"job_scheduler_trigger";O:8:"stdClass":11:{s:3:"uri";s:98:"sites/all/modules/contrib/job_scheduler/modules/job_scheduler_trigger/job_scheduler_trigger.module";s:8:"filename";s:98:"sites/all/modules/contrib/job_scheduler/modules/job_scheduler_trigger/job_scheduler_trigger.module";s:4:"name";s:21:"job_scheduler_trigger";s:4:"info";a:10:{s:4:"name";s:21:"Job Scheduler Trigger";s:11:"description";s:62:"Creates scheduler triggers that fire up at certain days, times";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:13:"job_scheduler";}s:7:"version";s:14:"7.x-2.0-alpha3";s:7:"project";s:13:"job_scheduler";s:9:"datestamp";s:10:"1336466457";s:7:"package";s:5:"Other";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:13:"job_scheduler";a:1:{s:4:"name";s:13:"job_scheduler";}}s:4:"sort";i:-118;}s:13:"jquery_update";O:8:"stdClass":11:{s:3:"uri";s:60:"sites/all/modules/contrib/jquery_update/jquery_update.module";s:8:"filename";s:60:"sites/all/modules/contrib/jquery_update/jquery_update.module";s:4:"name";s:13:"jquery_update";s:4:"info";a:11:{s:4:"name";s:13:"jQuery Update";s:11:"description";s:53:"Update jQuery and jQuery UI to a more recent version.";s:7:"package";s:14:"User interface";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:20:"jquery_update.module";i:1;s:21:"jquery_update.install";}s:9:"configure";s:38:"admin/config/development/jquery_update";s:7:"version";s:7:"7.x-2.7";s:7:"project";s:13:"jquery_update";s:9:"datestamp";s:10:"1445379855";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7000";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:11:"l10n_update";O:8:"stdClass":11:{s:3:"uri";s:56:"sites/all/modules/contrib/l10n_update/l10n_update.module";s:8:"filename";s:56:"sites/all/modules/contrib/l10n_update/l10n_update.module";s:4:"name";s:11:"l10n_update";s:4:"info";a:11:{s:4:"name";s:19:"Localization update";s:11:"description";s:58:"Provides automatic downloads and updates for translations.";s:12:"dependencies";a:1:{i:0;s:6:"locale";}s:4:"core";s:3:"7.x";s:7:"package";s:12:"Multilingual";s:9:"configure";s:37:"admin/config/regional/language/update";s:5:"files";a:24:{i:0;s:29:"includes/gettext/PoHeader.php";i:1;s:27:"includes/gettext/PoItem.php";i:2;s:35:"includes/gettext/PoMemoryWriter.php";i:3;s:40:"includes/gettext/PoMetadataInterface.php";i:4;s:38:"includes/gettext/PoReaderInterface.php";i:5;s:38:"includes/gettext/PoStreamInterface.php";i:6;s:35:"includes/gettext/PoStreamReader.php";i:7;s:35:"includes/gettext/PoStreamWriter.php";i:8;s:38:"includes/gettext/PoWriterInterface.php";i:9;s:27:"includes/locale/Gettext.php";i:10;s:36:"includes/locale/PoDatabaseReader.php";i:11;s:36:"includes/locale/PoDatabaseWriter.php";i:12;s:32:"includes/locale/SourceString.php";i:13;s:30:"includes/locale/StringBase.php";i:14;s:41:"includes/locale/StringDatabaseStorage.php";i:15;s:35:"includes/locale/StringInterface.php";i:16;s:42:"includes/locale/StringStorageException.php";i:17;s:42:"includes/locale/StringStorageInterface.php";i:18;s:37:"includes/locale/TranslationString.php";i:19;s:45:"includes/locale/TranslationsStreamWrapper.php";i:20;s:29:"tests/L10nUpdateCronTest.test";i:21;s:34:"tests/L10nUpdateInterfaceTest.test";i:22;s:25:"tests/L10nUpdateTest.test";i:23;s:29:"tests/L10nUpdateTestBase.test";}s:7:"version";s:7:"7.x-2.1";s:7:"project";s:11:"l10n_update";s:9:"datestamp";s:10:"1480765987";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:6:"locale";a:1:{s:4:"name";s:6:"locale";}}s:4:"sort";i:-119;}s:16:"l10n_update_test";O:8:"stdClass":11:{s:3:"uri";s:92:"sites/all/modules/contrib/l10n_update/tests/modules/l10n_update_test/l10n_update_test.module";s:8:"filename";s:92:"sites/all/modules/contrib/l10n_update/tests/modules/l10n_update_test/l10n_update_test.module";s:4:"name";s:16:"l10n_update_test";s:4:"info";a:12:{s:4:"name";s:24:"Localization Update test";s:4:"type";s:6:"module";s:11:"description";s:54:"Support module for Localization Update module testing.";s:7:"package";s:7:"Testing";s:7:"version";s:7:"7.x-2.1";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:11:"l10n_update";s:9:"datestamp";s:10:"1480765987";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:26:"l10n_update_test_translate";O:8:"stdClass":11:{s:3:"uri";s:112:"sites/all/modules/contrib/l10n_update/tests/modules/l10n_update_test_translate/l10n_update_test_translate.module";s:8:"filename";s:112:"sites/all/modules/contrib/l10n_update/tests/modules/l10n_update_test_translate/l10n_update_test_translate.module";s:4:"name";s:26:"l10n_update_test_translate";s:4:"info";a:14:{s:4:"name";s:34:"Localization Update test translate";s:4:"type";s:6:"module";s:11:"description";s:63:"Translation test module for Localization Update module testing.";s:7:"package";s:7:"Testing";s:7:"version";s:7:"7.x-2.1";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:29:"interface translation project";s:26:"l10n_update_test_translate";s:9:"l10n path";s:131:"sites/all/modules/contrib/l10n_update/tests/modules/l10n_update_test_translate/translations/l10n_update_test_translate.%language.po";s:7:"project";s:11:"l10n_update";s:9:"datestamp";s:10:"1480765987";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:9:"libraries";O:8:"stdClass":11:{s:3:"uri";s:52:"sites/all/modules/contrib/libraries/libraries.module";s:8:"filename";s:52:"sites/all/modules/contrib/libraries/libraries.module";s:4:"name";s:9:"libraries";s:4:"info";a:10:{s:4:"name";s:9:"Libraries";s:11:"description";s:64:"Allows version-dependent and shared usage of external libraries.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:15:"system (>=7.11)";}s:5:"files";a:4:{i:0;s:32:"tests/LibrariesAdminWebTest.test";i:1;s:31:"tests/LibrariesLoadWebTest.test";i:2;s:28:"tests/LibrariesUnitTest.test";i:3;s:31:"tests/LibrariesWebTestBase.test";}s:7:"version";s:7:"7.x-2.3";s:7:"project";s:9:"libraries";s:9:"datestamp";s:10:"1463077450";s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7201";s:6:"weight";s:1:"0";s:11:"required_by";a:2:{s:21:"libraries_test_module";a:1:{s:4:"name";s:9:"libraries";}s:11:"placeholder";a:3:{s:4:"name";s:9:"libraries";s:16:"original_version";s:12:" (>=7.x-2.2)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"2.2";}}}}s:8:"requires";a:1:{s:6:"system";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.11)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.11";}}}}s:4:"sort";i:-120;}s:21:"libraries_test_module";O:8:"stdClass":11:{s:3:"uri";s:100:"sites/all/modules/contrib/libraries/tests/modules/libraries_test_module/libraries_test_module.module";s:8:"filename";s:100:"sites/all/modules/contrib/libraries/tests/modules/libraries_test_module/libraries_test_module.module";s:4:"name";s:21:"libraries_test_module";s:4:"info";a:11:{s:4:"name";s:21:"Libraries test module";s:11:"description";s:36:"Tests library detection and loading.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:12:"dependencies";a:1:{i:0;s:9:"libraries";}s:6:"hidden";b:1;s:7:"version";s:7:"7.x-2.3";s:7:"project";s:9:"libraries";s:9:"datestamp";s:10:"1463077450";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:9:"libraries";a:1:{s:4:"name";s:9:"libraries";}s:6:"system";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.11)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.11";}}}}s:4:"sort";i:-121;}s:17:"library_dashboard";O:8:"stdClass":11:{s:3:"uri";s:67:"sites/all/modules/custom/library_dashboard/library_dashboard.module";s:8:"filename";s:67:"sites/all/modules/custom/library_dashboard/library_dashboard.module";s:4:"name";s:17:"library_dashboard";s:4:"info";a:11:{s:4:"name";s:24:"Library Dashboard Module";s:11:"description";s:83:"A custom module containing various functionality for the Galicia Library Dashboard.";s:7:"package";s:7:"Galicia";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:16:"/css/galicia.css";s:59:"sites/all/modules/custom/library_dashboard//css/galicia.css";}}s:7:"version";s:7:"7.x-1.x";s:4:"core";s:3:"7.x";s:7:"project";s:17:"library_dashboard";s:9:"datestamp";s:10:"1426097283";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"link";O:8:"stdClass":11:{s:3:"uri";s:42:"sites/all/modules/contrib/link/link.module";s:8:"filename";s:42:"sites/all/modules/contrib/link/link.module";s:4:"name";s:4:"link";s:4:"info";a:12:{s:4:"name";s:4:"Link";s:11:"description";s:32:"Defines simple link field types.";s:4:"core";s:3:"7.x";s:7:"package";s:6:"Fields";s:5:"files";a:11:{i:0;s:11:"link.module";i:1;s:16:"link.migrate.inc";i:2;s:15:"tests/link.test";i:3;s:25:"tests/link.attribute.test";i:4;s:20:"tests/link.crud.test";i:5;s:28:"tests/link.crud_browser.test";i:6;s:21:"tests/link.token.test";i:7;s:28:"tests/link.entity_token.test";i:8;s:24:"tests/link.validate.test";i:9;s:44:"views/link_views_handler_argument_target.inc";i:10;s:44:"views/link_views_handler_filter_protocol.inc";}s:7:"version";s:7:"7.x-1.4";s:7:"project";s:4:"link";s:9:"datestamp";s:10:"1452830642";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7001";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"list";O:8:"stdClass":11:{s:3:"uri";s:38:"modules/field/modules/list/list.module";s:8:"filename";s:38:"modules/field/modules/list/list.module";s:4:"name";s:4:"list";s:4:"info";a:12:{s:4:"name";s:4:"List";s:11:"description";s:69:"Defines list field types. Use with Options to create selection lists.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:5:"field";i:1;s:7:"options";}s:5:"files";a:1:{i:0;s:15:"tests/list.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7002";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"pantheon";a:1:{s:4:"name";s:4:"list";}}s:8:"requires";a:3:{s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:7:"options";a:1:{s:4:"name";s:7:"options";}}s:4:"sort";i:-122;}s:9:"list_test";O:8:"stdClass":11:{s:3:"uri";s:49:"modules/field/modules/list/tests/list_test.module";s:8:"filename";s:49:"modules/field/modules/list/tests/list_test.module";s:4:"name";s:9:"list_test";s:4:"info";a:11:{s:4:"name";s:9:"List test";s:11:"description";s:41:"Support module for the List module tests.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:6:"locale";O:8:"stdClass":11:{s:3:"uri";s:28:"modules/locale/locale.module";s:8:"filename";s:28:"modules/locale/locale.module";s:4:"name";s:6:"locale";s:4:"info";a:11:{s:4:"name";s:6:"Locale";s:11:"description";s:119:"Adds language handling functionality and enables the translation of the user interface to languages other than English.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:11:"locale.test";}s:9:"configure";s:30:"admin/config/regional/language";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:24:{s:14:"admin_language";a:1:{s:4:"name";s:6:"locale";}s:4:"i18n";a:1:{s:4:"name";s:6:"locale";}s:11:"i18n_string";a:1:{s:4:"name";s:6:"locale";}s:16:"entity_test_i18n";a:1:{s:4:"name";s:6:"locale";}s:10:"i18n_block";a:1:{s:4:"name";s:6:"locale";}s:12:"i18n_contact";a:1:{s:4:"name";s:6:"locale";}s:10:"i18n_field";a:1:{s:4:"name";s:6:"locale";}s:16:"i18n_translation";a:1:{s:4:"name";s:6:"locale";}s:13:"i18n_taxonomy";a:1:{s:4:"name";s:6:"locale";}s:11:"translation";a:1:{s:4:"name";s:6:"locale";}s:9:"i18n_node";a:1:{s:4:"name";s:6:"locale";}s:10:"i18n_forum";a:1:{s:4:"name";s:6:"locale";}s:9:"i18n_menu";a:1:{s:4:"name";s:6:"locale";}s:11:"i18n_panels";a:1:{s:4:"name";s:6:"locale";}s:9:"i18n_path";a:1:{s:4:"name";s:6:"locale";}s:13:"i18n_redirect";a:1:{s:4:"name";s:6:"locale";}s:11:"i18n_select";a:1:{s:4:"name";s:6:"locale";}s:9:"i18n_sync";a:1:{s:4:"name";s:6:"locale";}s:9:"i18n_test";a:1:{s:4:"name";s:6:"locale";}s:13:"i18n_variable";a:1:{s:4:"name";s:6:"locale";}s:9:"i18n_user";a:1:{s:4:"name";s:6:"locale";}s:9:"i18nviews";a:1:{s:4:"name";s:6:"locale";}s:11:"l10n_update";a:1:{s:4:"name";s:6:"locale";}s:10:"rules_i18n";a:1:{s:4:"name";s:6:"locale";}}s:8:"requires";a:0:{}s:4:"sort";i:-3;}s:11:"locale_test";O:8:"stdClass":11:{s:3:"uri";s:39:"modules/locale/tests/locale_test.module";s:8:"filename";s:39:"modules/locale/tests/locale_test.module";s:4:"name";s:11:"locale_test";s:4:"info";a:11:{s:4:"name";s:11:"Locale Test";s:11:"description";s:42:"Support module for the locale layer tests.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"menu";O:8:"stdClass":11:{s:3:"uri";s:24:"modules/menu/menu.module";s:8:"filename";s:24:"modules/menu/menu.module";s:4:"name";s:4:"menu";s:4:"info";a:11:{s:4:"name";s:4:"Menu";s:11:"description";s:60:"Allows administrators to customize the site navigation menu.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:9:"menu.test";}s:9:"configure";s:20:"admin/structure/menu";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7003";s:6:"weight";s:1:"0";s:11:"required_by";a:3:{s:17:"devel_node_access";a:1:{s:4:"name";s:4:"menu";}s:9:"i18n_menu";a:1:{s:4:"name";s:4:"menu";}s:8:"pantheon";a:1:{s:4:"name";s:4:"menu";}}s:8:"requires";a:0:{}s:4:"sort";i:-59;}s:9:"menu_test";O:8:"stdClass":11:{s:3:"uri";s:41:"modules/simpletest/tests/menu_test.module";s:8:"filename";s:41:"modules/simpletest/tests/menu_test.module";s:4:"name";s:9:"menu_test";s:4:"info";a:11:{s:4:"name";s:15:"Hook menu tests";s:11:"description";s:37:"Support module for menu hook testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:13:"module_filter";O:8:"stdClass":11:{s:3:"uri";s:60:"sites/all/modules/contrib/module_filter/module_filter.module";s:8:"filename";s:60:"sites/all/modules/contrib/module_filter/module_filter.module";s:4:"name";s:13:"module_filter";s:4:"info";a:11:{s:4:"name";s:13:"Module filter";s:11:"description";s:24:"Filter the modules list.";s:4:"core";s:3:"7.x";s:7:"package";s:14:"Administration";s:5:"files";a:9:{i:0;s:21:"module_filter.install";i:1;s:16:"module_filter.js";i:2;s:20:"module_filter.module";i:3;s:23:"module_filter.admin.inc";i:4;s:23:"module_filter.theme.inc";i:5;s:21:"css/module_filter.css";i:6;s:25:"css/module_filter_tab.css";i:7;s:19:"js/module_filter.js";i:8;s:23:"js/module_filter_tab.js";}s:9:"configure";s:40:"admin/config/user-interface/modulefilter";s:7:"version";s:7:"7.x-2.0";s:7:"project";s:13:"module_filter";s:9:"datestamp";s:10:"1424631189";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:11:"module_test";O:8:"stdClass":11:{s:3:"uri";s:43:"modules/simpletest/tests/module_test.module";s:8:"filename";s:43:"modules/simpletest/tests/module_test.module";s:4:"name";s:11:"module_test";s:4:"info";a:11:{s:4:"name";s:11:"Module test";s:11:"description";s:41:"Support module for module system testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"node";O:8:"stdClass":11:{s:3:"uri";s:24:"modules/node/node.module";s:8:"filename";s:24:"modules/node/node.module";s:4:"name";s:4:"node";s:4:"info";a:13:{s:4:"name";s:4:"Node";s:11:"description";s:66:"Allows content to be submitted to the site and displayed on pages.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:11:"node.module";i:1;s:9:"node.test";}s:8:"required";b:1;s:9:"configure";s:21:"admin/structure/types";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:8:"node.css";s:21:"modules/node/node.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7016";s:6:"weight";s:1:"0";s:11:"required_by";a:4:{s:4:"uuid";a:1:{s:4:"name";s:4:"node";}s:9:"uuid_path";a:1:{s:4:"name";s:4:"node";}s:13:"uuid_services";a:1:{s:4:"name";s:4:"node";}s:21:"uuid_services_example";a:1:{s:4:"name";s:4:"node";}}s:8:"requires";a:0:{}s:4:"sort";i:-123;}s:16:"node_access_test";O:8:"stdClass":11:{s:3:"uri";s:42:"modules/node/tests/node_access_test.module";s:8:"filename";s:42:"modules/node/tests/node_access_test.module";s:4:"name";s:16:"node_access_test";s:4:"info";a:11:{s:4:"name";s:24:"Node module access tests";s:11:"description";s:43:"Support module for node permission testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:9:"node_test";O:8:"stdClass":11:{s:3:"uri";s:35:"modules/node/tests/node_test.module";s:8:"filename";s:35:"modules/node/tests/node_test.module";s:4:"name";s:9:"node_test";s:4:"info";a:11:{s:4:"name";s:17:"Node module tests";s:11:"description";s:40:"Support module for node related testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:19:"node_test_exception";O:8:"stdClass":11:{s:3:"uri";s:45:"modules/node/tests/node_test_exception.module";s:8:"filename";s:45:"modules/node/tests/node_test_exception.module";s:4:"name";s:19:"node_test_exception";s:4:"info";a:11:{s:4:"name";s:27:"Node module exception tests";s:11:"description";s:50:"Support module for node related exception testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:6:"number";O:8:"stdClass":11:{s:3:"uri";s:42:"modules/field/modules/number/number.module";s:8:"filename";s:42:"modules/field/modules/number/number.module";s:4:"name";s:6:"number";s:4:"info";a:12:{s:4:"name";s:6:"Number";s:11:"description";s:28:"Defines numeric field types.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:11:"number.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"pantheon";a:1:{s:4:"name";s:6:"number";}}s:8:"requires";a:2:{s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-124;}s:6:"openid";O:8:"stdClass":11:{s:3:"uri";s:28:"modules/openid/openid.module";s:8:"filename";s:28:"modules/openid/openid.module";s:4:"name";s:6:"openid";s:4:"info";a:10:{s:4:"name";s:6:"OpenID";s:11:"description";s:48:"Allows users to log into your site using OpenID.";s:7:"version";s:4:"7.54";s:7:"package";s:4:"Core";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:11:"openid.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:11:"openid_test";a:1:{s:4:"name";s:6:"openid";}}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:11:"openid_test";O:8:"stdClass":11:{s:3:"uri";s:39:"modules/openid/tests/openid_test.module";s:8:"filename";s:39:"modules/openid/tests/openid_test.module";s:4:"name";s:11:"openid_test";s:4:"info";a:11:{s:4:"name";s:21:"OpenID dummy provider";s:11:"description";s:33:"OpenID provider used for testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:6:"openid";}s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:6:"openid";a:1:{s:4:"name";s:6:"openid";}}s:4:"sort";i:-1;}s:25:"optional_mail_on_register";O:8:"stdClass":11:{s:3:"uri";s:72:"sites/all/modules/contrib/optional_mail/optional_mail_on_register.module";s:8:"filename";s:72:"sites/all/modules/contrib/optional_mail/optional_mail_on_register.module";s:4:"name";s:25:"optional_mail_on_register";s:4:"info";a:10:{s:4:"name";s:25:"Optional mail on register";s:11:"description";s:64:"New users need not enter a valid email address when registering.";s:4:"core";s:3:"7.x";s:7:"package";s:15:"User Management";s:5:"files";a:4:{i:0;s:30:"optional_mail_on_register.info";i:1;s:32:"optional_mail_on_register.module";i:2;s:28:"optional_mail_on_register.js";i:3;s:29:"optional_mail_on_register.css";}s:7:"version";s:7:"7.x-1.1";s:7:"project";s:13:"optional_mail";s:9:"datestamp";s:10:"1333497970";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:7:"options";O:8:"stdClass":11:{s:3:"uri";s:44:"modules/field/modules/options/options.module";s:8:"filename";s:44:"modules/field/modules/options/options.module";s:4:"name";s:7:"options";s:4:"info";a:10:{s:4:"name";s:7:"Options";s:11:"description";s:82:"Defines selection, check box and radio button widgets for text and numeric fields.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:12:"options.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:10:{s:17:"bookpoints_events";a:1:{s:4:"name";s:7:"options";}s:8:"taxonomy";a:1:{s:4:"name";s:7:"options";}s:13:"features_test";a:1:{s:4:"name";s:7:"options";}s:5:"forum";a:1:{s:4:"name";s:7:"options";}s:13:"i18n_taxonomy";a:1:{s:4:"name";s:7:"options";}s:10:"i18n_forum";a:1:{s:4:"name";s:7:"options";}s:4:"list";a:1:{s:4:"name";s:7:"options";}s:8:"pantheon";a:1:{s:4:"name";s:7:"options";}s:13:"taxonomy_test";a:1:{s:4:"name";s:7:"options";}s:13:"workflowfield";a:1:{s:4:"name";s:7:"options";}}s:8:"requires";a:2:{s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-25;}s:7:"overlay";O:8:"stdClass":11:{s:3:"uri";s:30:"modules/overlay/overlay.module";s:8:"filename";s:30:"modules/overlay/overlay.module";s:4:"name";s:7:"overlay";s:4:"info";a:10:{s:4:"name";s:7:"Overlay";s:11:"description";s:59:"Displays the Drupal administration interface in an overlay.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"pantheon";a:1:{s:4:"name";s:7:"overlay";}}s:8:"requires";a:0:{}s:4:"sort";i:-125;}s:12:"page_manager";O:8:"stdClass":11:{s:3:"uri";s:65:"sites/all/modules/contrib/ctools/page_manager/page_manager.module";s:8:"filename";s:65:"sites/all/modules/contrib/ctools/page_manager/page_manager.module";s:4:"name";s:12:"page_manager";s:4:"info";a:10:{s:4:"name";s:12:"Page manager";s:11:"description";s:54:"Provides a UI and API to manage pages within the site.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:2:"99";s:11:"required_by";a:1:{s:21:"ctools_plugin_example";a:1:{s:4:"name";s:12:"page_manager";}}s:8:"requires";a:1:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-47;}s:6:"panels";O:8:"stdClass":11:{s:3:"uri";s:46:"sites/all/modules/contrib/panels/panels.module";s:8:"filename";s:46:"sites/all/modules/contrib/panels/panels.module";s:4:"name";s:6:"panels";s:4:"info";a:11:{s:4:"name";s:6:"Panels";s:11:"description";s:107:"Core Panels display functions; provides no external UI, at least one other Panels module should be enabled.";s:4:"core";s:3:"7.x";s:7:"package";s:6:"Panels";s:9:"configure";s:22:"admin/structure/panels";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:5:"files";a:9:{i:0;s:13:"panels.module";i:1;s:19:"includes/common.inc";i:2;s:19:"includes/legacy.inc";i:3;s:20:"includes/plugins.inc";i:4;s:48:"plugins/views/panels_views_plugin_row_fields.inc";i:5;s:38:"tests/PanelsEntityViewWebTestCase.test";i:6;s:36:"tests/PanelsNodeViewWebTestCase.test";i:7;s:36:"tests/PanelsTermViewWebTestCase.test";i:8;s:36:"tests/PanelsUserViewWebTestCase.test";}s:7:"version";s:7:"7.x-3.8";s:7:"project";s:6:"panels";s:9:"datestamp";s:10:"1476582295";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7308";s:6:"weight";s:1:"0";s:11:"required_by";a:5:{s:21:"ctools_plugin_example";a:1:{s:4:"name";s:6:"panels";}s:11:"i18n_panels";a:1:{s:4:"name";s:6:"panels";}s:10:"panels_ipe";a:1:{s:4:"name";s:6:"panels";}s:11:"panels_mini";a:1:{s:4:"name";s:6:"panels";}s:11:"panels_node";a:1:{s:4:"name";s:6:"panels";}}s:8:"requires";a:1:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-46;}s:10:"panels_ipe";O:8:"stdClass":11:{s:3:"uri";s:61:"sites/all/modules/contrib/panels/panels_ipe/panels_ipe.module";s:8:"filename";s:61:"sites/all/modules/contrib/panels/panels_ipe/panels_ipe.module";s:4:"name";s:10:"panels_ipe";s:4:"info";a:11:{s:4:"name";s:22:"Panels In-Place Editor";s:11:"description";s:101:"Provide a UI for managing some Panels directly on the frontend, instead of having to use the backend.";s:7:"package";s:6:"Panels";s:12:"dependencies";a:1:{i:0;s:6:"panels";}s:4:"core";s:3:"7.x";s:9:"configure";s:22:"admin/structure/panels";s:5:"files";a:1:{i:0;s:17:"panels_ipe.module";}s:7:"version";s:7:"7.x-3.8";s:7:"project";s:6:"panels";s:9:"datestamp";s:10:"1476582295";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:6:"panels";a:1:{s:4:"name";s:6:"panels";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-126;}s:11:"panels_mini";O:8:"stdClass":11:{s:3:"uri";s:63:"sites/all/modules/contrib/panels/panels_mini/panels_mini.module";s:8:"filename";s:63:"sites/all/modules/contrib/panels/panels_mini/panels_mini.module";s:4:"name";s:11:"panels_mini";s:4:"info";a:10:{s:4:"name";s:11:"Mini panels";s:11:"description";s:89:"Create mini panels that can be used as blocks by Drupal and panes by other panel modules.";s:7:"package";s:6:"Panels";s:12:"dependencies";a:1:{i:0;s:6:"panels";}s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:42:"plugins/export_ui/panels_mini_ui.class.php";}s:7:"version";s:7:"7.x-3.8";s:7:"project";s:6:"panels";s:9:"datestamp";s:10:"1476582295";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7301";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:6:"panels";a:1:{s:4:"name";s:6:"panels";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-127;}s:11:"panels_node";O:8:"stdClass":11:{s:3:"uri";s:63:"sites/all/modules/contrib/panels/panels_node/panels_node.module";s:8:"filename";s:63:"sites/all/modules/contrib/panels/panels_node/panels_node.module";s:4:"name";s:11:"panels_node";s:4:"info";a:11:{s:4:"name";s:11:"Panel nodes";s:11:"description";s:65:"Create nodes that are divided into areas with selectable content.";s:7:"package";s:6:"Panels";s:12:"dependencies";a:1:{i:0;s:6:"panels";}s:9:"configure";s:22:"admin/structure/panels";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:18:"panels_node.module";}s:7:"version";s:7:"7.x-3.8";s:7:"project";s:6:"panels";s:9:"datestamp";s:10:"1476582295";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7302";s:6:"weight";s:2:"11";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:6:"panels";a:1:{s:4:"name";s:6:"panels";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-128;}s:8:"pantheon";O:8:"stdClass":11:{s:4:"name";s:8:"pantheon";s:3:"uri";s:34:"profiles/pantheon/pantheon.profile";s:8:"filename";s:34:"profiles/pantheon/pantheon.profile";s:6:"weight";i:1000;s:4:"info";a:11:{s:4:"name";s:8:"Pantheon";s:11:"description";s:65:"Install with pre-configured integration for the Pantheon Platform";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:23:{i:0;s:5:"block";i:1;s:5:"color";i:2;s:7:"comment";i:3;s:10:"contextual";i:4;s:9:"dashboard";i:5;s:4:"help";i:6;s:5:"image";i:7;s:4:"list";i:8;s:4:"menu";i:9;s:6:"number";i:10;s:7:"options";i:11;s:4:"path";i:12;s:8:"taxonomy";i:13;s:5:"dblog";i:14;s:6:"search";i:15;s:8:"shortcut";i:16;s:7:"toolbar";i:17;s:7:"overlay";i:18;s:8:"field_ui";i:19;s:4:"file";i:20;s:3:"rdf";i:21;s:12:"pantheon_api";i:22;s:14:"pantheon_login";}s:5:"files";a:1:{i:0;s:16:"pantheon.profile";}s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;s:6:"hidden";b:1;s:8:"required";b:1;s:17:"distribution_name";s:6:"Drupal";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:26:{s:5:"block";a:1:{s:4:"name";s:5:"block";}s:5:"color";a:1:{s:4:"name";s:5:"color";}s:7:"comment";a:1:{s:4:"name";s:7:"comment";}s:4:"text";a:1:{s:4:"name";s:4:"text";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:10:"contextual";a:1:{s:4:"name";s:10:"contextual";}s:9:"dashboard";a:1:{s:4:"name";s:9:"dashboard";}s:4:"help";a:1:{s:4:"name";s:4:"help";}s:5:"image";a:1:{s:4:"name";s:5:"image";}s:4:"file";a:1:{s:4:"name";s:4:"file";}s:4:"list";a:1:{s:4:"name";s:4:"list";}s:7:"options";a:1:{s:4:"name";s:7:"options";}s:4:"menu";a:1:{s:4:"name";s:4:"menu";}s:6:"number";a:1:{s:4:"name";s:6:"number";}s:4:"path";a:1:{s:4:"name";s:4:"path";}s:8:"taxonomy";a:1:{s:4:"name";s:8:"taxonomy";}s:5:"dblog";a:1:{s:4:"name";s:5:"dblog";}s:6:"search";a:1:{s:4:"name";s:6:"search";}s:8:"shortcut";a:1:{s:4:"name";s:8:"shortcut";}s:7:"toolbar";a:1:{s:4:"name";s:7:"toolbar";}s:7:"overlay";a:1:{s:4:"name";s:7:"overlay";}s:8:"field_ui";a:1:{s:4:"name";s:8:"field_ui";}s:3:"rdf";a:1:{s:4:"name";s:3:"rdf";}s:12:"pantheon_api";a:1:{s:4:"name";s:12:"pantheon_api";}s:14:"pantheon_login";a:1:{s:4:"name";s:14:"pantheon_login";}}s:4:"sort";i:-134;}s:4:"path";O:8:"stdClass":11:{s:3:"uri";s:24:"modules/path/path.module";s:8:"filename";s:24:"modules/path/path.module";s:4:"name";s:4:"path";s:4:"info";a:11:{s:4:"name";s:4:"Path";s:11:"description";s:28:"Allows users to rename URLs.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:9:"path.test";}s:9:"configure";s:24:"admin/config/search/path";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:2:{s:8:"pantheon";a:1:{s:4:"name";s:4:"path";}s:8:"pathauto";a:1:{s:4:"name";s:4:"path";}}s:8:"requires";a:0:{}s:4:"sort";i:-129;}s:9:"path_test";O:8:"stdClass":11:{s:3:"uri";s:41:"modules/simpletest/tests/path_test.module";s:8:"filename";s:41:"modules/simpletest/tests/path_test.module";s:4:"name";s:9:"path_test";s:4:"info";a:11:{s:4:"name";s:15:"Hook path tests";s:11:"description";s:37:"Support module for path hook testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:8:"pathauto";O:8:"stdClass":11:{s:3:"uri";s:50:"sites/all/modules/contrib/pathauto/pathauto.module";s:8:"filename";s:50:"sites/all/modules/contrib/pathauto/pathauto.module";s:4:"name";s:8:"pathauto";s:4:"info";a:12:{s:4:"name";s:8:"Pathauto";s:11:"description";s:95:"Provides a mechanism for modules to automatically generate aliases for the content they manage.";s:12:"dependencies";a:2:{i:0;s:4:"path";i:1;s:5:"token";}s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:20:"pathauto.migrate.inc";i:1;s:13:"pathauto.test";}s:9:"configure";s:33:"admin/config/search/path/patterns";s:10:"recommends";a:1:{i:0;s:8:"redirect";}s:7:"version";s:7:"7.x-1.3";s:7:"project";s:8:"pathauto";s:9:"datestamp";s:10:"1444232655";s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7006";s:6:"weight";s:1:"1";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:4:"path";a:1:{s:4:"name";s:4:"path";}s:5:"token";a:1:{s:4:"name";s:5:"token";}}s:4:"sort";i:-136;}s:3:"php";O:8:"stdClass":11:{s:3:"uri";s:22:"modules/php/php.module";s:8:"filename";s:22:"modules/php/php.module";s:4:"name";s:3:"php";s:4:"info";a:10:{s:4:"name";s:10:"PHP filter";s:11:"description";s:50:"Allows embedded PHP code/snippets to be evaluated.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:8:"php.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:11:"placeholder";O:8:"stdClass":11:{s:3:"uri";s:56:"sites/all/modules/contrib/placeholder/placeholder.module";s:8:"filename";s:56:"sites/all/modules/contrib/placeholder/placeholder.module";s:4:"name";s:11:"placeholder";s:4:"info";a:10:{s:4:"name";s:11:"Placeholder";s:11:"description";s:85:"Add support for the HTML5 placeholder attribute, with backward browser compatibility.";s:4:"core";s:3:"7.x";s:7:"package";s:5:"Other";s:12:"dependencies";a:1:{i:0;s:21:"libraries (>=7.x-2.2)";}s:7:"version";s:7:"7.x-1.1";s:7:"project";s:11:"placeholder";s:9:"datestamp";s:10:"1411850355";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:9:"libraries";a:3:{s:4:"name";s:9:"libraries";s:16:"original_version";s:12:" (>=7.x-2.2)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"2.2";}}}s:6:"system";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.11)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.11";}}}}s:4:"sort";i:-137;}s:4:"poll";O:8:"stdClass":11:{s:3:"uri";s:24:"modules/poll/poll.module";s:8:"filename";s:24:"modules/poll/poll.module";s:4:"name";s:4:"poll";s:4:"info";a:11:{s:4:"name";s:4:"Poll";s:11:"description";s:95:"Allows your site to capture votes on different topics in the form of multiple choice questions.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:9:"poll.test";}s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:8:"poll.css";s:21:"modules/poll/poll.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:7:"profile";O:8:"stdClass":11:{s:3:"uri";s:30:"modules/profile/profile.module";s:8:"filename";s:30:"modules/profile/profile.module";s:4:"name";s:7:"profile";s:4:"info";a:12:{s:4:"name";s:7:"Profile";s:11:"description";s:36:"Supports configurable user profiles.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:12:"profile.test";}s:9:"configure";s:27:"admin/config/people/profile";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:10:"psr_0_test";O:8:"stdClass":11:{s:3:"uri";s:53:"modules/simpletest/tests/psr_0_test/psr_0_test.module";s:8:"filename";s:53:"modules/simpletest/tests/psr_0_test/psr_0_test.module";s:4:"name";s:10:"psr_0_test";s:4:"info";a:11:{s:4:"name";s:16:"PSR-0 Test cases";s:11:"description";s:44:"Test classes to be discovered by simpletest.";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:10:"psr_4_test";O:8:"stdClass":11:{s:3:"uri";s:53:"modules/simpletest/tests/psr_4_test/psr_4_test.module";s:8:"filename";s:53:"modules/simpletest/tests/psr_4_test/psr_4_test.module";s:4:"name";s:10:"psr_4_test";s:4:"info";a:11:{s:4:"name";s:16:"PSR-4 Test cases";s:11:"description";s:44:"Test classes to be discovered by simpletest.";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:3:"rdf";O:8:"stdClass":11:{s:3:"uri";s:22:"modules/rdf/rdf.module";s:8:"filename";s:22:"modules/rdf/rdf.module";s:4:"name";s:3:"rdf";s:4:"info";a:10:{s:4:"name";s:3:"RDF";s:11:"description";s:148:"Enriches your content with metadata to let other applications (e.g. search engines, aggregators) better understand its relationships and attributes.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:8:"rdf.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"pantheon";a:1:{s:4:"name";s:3:"rdf";}}s:8:"requires";a:0:{}s:4:"sort";i:-133;}s:8:"rdf_test";O:8:"stdClass":11:{s:3:"uri";s:33:"modules/rdf/tests/rdf_test.module";s:8:"filename";s:33:"modules/rdf/tests/rdf_test.module";s:4:"name";s:8:"rdf_test";s:4:"info";a:11:{s:4:"name";s:16:"RDF module tests";s:11:"description";s:38:"Support module for RDF module testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:4:"blog";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:4:"blog";a:1:{s:4:"name";s:4:"blog";}}s:4:"sort";i:-1;}s:8:"relation";O:8:"stdClass":11:{s:3:"uri";s:50:"sites/all/modules/contrib/relation/relation.module";s:8:"filename";s:50:"sites/all/modules/contrib/relation/relation.module";s:4:"name";s:8:"relation";s:4:"info";a:10:{s:4:"name";s:8:"Relation";s:11:"description";s:41:"Describes relationships between entities.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Relation";s:5:"files";a:9:{i:0;s:21:"relation.database.inc";i:1;s:19:"tests/relation.test";i:2;s:25:"tests/relation.rules.test";i:3;s:25:"tests/relation.views.test";i:4;s:26:"tests/relation.ctools.test";i:5;s:39:"views/relation_handler_relationship.inc";i:6;s:43:"views/views_handler_field_relation_link.inc";i:7;s:50:"views/views_handler_field_relation_link_delete.inc";i:8;s:48:"views/views_handler_field_relation_link_edit.inc";}s:12:"dependencies";a:2:{i:0;s:17:"relation_endpoint";i:1;s:15:"system (>=7.33)";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:5:{s:20:"relation_dummy_field";a:1:{s:4:"name";s:8:"relation";}s:25:"relation_entity_collector";a:1:{s:4:"name";s:8:"relation";}s:14:"relation_feeds";a:1:{s:4:"name";s:8:"relation";}s:11:"relation_ui";a:1:{s:4:"name";s:8:"relation";}s:16:"relation_migrate";a:1:{s:4:"name";s:8:"relation";}}s:8:"requires";a:2:{s:17:"relation_endpoint";a:1:{s:4:"name";s:17:"relation_endpoint";}s:6:"system";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.33)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.33";}}}}s:4:"sort";i:-139;}s:20:"relation_ctools_test";O:8:"stdClass":11:{s:3:"uri";s:68:"sites/all/modules/contrib/relation/tests/relation_ctools_test.module";s:8:"filename";s:68:"sites/all/modules/contrib/relation/tests/relation_ctools_test.module";s:4:"name";s:20:"relation_ctools_test";s:4:"info";a:11:{s:4:"name";s:14:"Relation Tests";s:11:"description";s:59:"Support module for the Relation - ctools integration tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-140;}s:20:"relation_dummy_field";O:8:"stdClass":11:{s:3:"uri";s:83:"sites/all/modules/contrib/relation/relation_dummy_field/relation_dummy_field.module";s:8:"filename";s:83:"sites/all/modules/contrib/relation/relation_dummy_field/relation_dummy_field.module";s:4:"name";s:20:"relation_dummy_field";s:4:"info";a:10:{s:4:"name";s:20:"Relation Dummy Field";s:11:"description";s:56:"Dummy field to display relation data inline on entities.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Relation";s:12:"dependencies";a:1:{i:0;s:8:"relation";}s:5:"files";a:1:{i:0;s:31:"tests/relation_dummy_field.test";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:8:"relation";a:1:{s:4:"name";s:8:"relation";}s:17:"relation_endpoint";a:1:{s:4:"name";s:17:"relation_endpoint";}s:6:"system";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.33)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.33";}}}}s:4:"sort";i:-141;}s:17:"relation_endpoint";O:8:"stdClass":11:{s:3:"uri";s:59:"sites/all/modules/contrib/relation/relation_endpoint.module";s:8:"filename";s:59:"sites/all/modules/contrib/relation/relation_endpoint.module";s:4:"name";s:17:"relation_endpoint";s:4:"info";a:10:{s:4:"name";s:24:"Relation Endpoints Field";s:11:"description";s:84:"Helper module for Relation. Defines endpoints field (not usable except by relation).";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Relation";s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:6:{s:8:"relation";a:1:{s:4:"name";s:17:"relation_endpoint";}s:20:"relation_dummy_field";a:1:{s:4:"name";s:17:"relation_endpoint";}s:25:"relation_entity_collector";a:1:{s:4:"name";s:17:"relation_endpoint";}s:14:"relation_feeds";a:1:{s:4:"name";s:17:"relation_endpoint";}s:11:"relation_ui";a:1:{s:4:"name";s:17:"relation_endpoint";}s:16:"relation_migrate";a:1:{s:4:"name";s:17:"relation_endpoint";}}s:8:"requires";a:0:{}s:4:"sort";i:-138;}s:25:"relation_entity_collector";O:8:"stdClass":11:{s:3:"uri";s:93:"sites/all/modules/contrib/relation/relation_entity_collector/relation_entity_collector.module";s:8:"filename";s:93:"sites/all/modules/contrib/relation/relation_entity_collector/relation_entity_collector.module";s:4:"name";s:25:"relation_entity_collector";s:4:"info";a:11:{s:4:"name";s:31:"Relation Entity Collector block";s:11:"description";s:82:"A block to collect entities loaded on any page(s), and create relations from them.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Relation";s:12:"dependencies";a:2:{i:0;s:8:"relation";i:1;s:5:"block";}s:5:"files";a:1:{i:0;s:36:"tests/relation_entity_collector.test";}s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:29:"relation_entity_collector.css";s:90:"sites/all/modules/contrib/relation/relation_entity_collector/relation_entity_collector.css";}}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:8:"relation";a:1:{s:4:"name";s:8:"relation";}s:17:"relation_endpoint";a:1:{s:4:"name";s:17:"relation_endpoint";}s:6:"system";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.33)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.33";}}}s:5:"block";a:1:{s:4:"name";s:5:"block";}}s:4:"sort";i:-142;}s:14:"relation_feeds";O:8:"stdClass":11:{s:3:"uri";s:71:"sites/all/modules/contrib/relation/relation_feeds/relation_feeds.module";s:8:"filename";s:71:"sites/all/modules/contrib/relation/relation_feeds/relation_feeds.module";s:4:"name";s:14:"relation_feeds";s:4:"info";a:10:{s:4:"name";s:14:"Relation feeds";s:11:"description";s:38:"Feeds integration module for Relation.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Relation";s:5:"files";a:1:{i:0;s:35:"tests/relation.feeds_processor.test";}s:12:"dependencies";a:2:{i:0;s:8:"relation";i:1;s:24:"feeds (!=7.x-1.0-alpha8)";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:6:{s:8:"relation";a:1:{s:4:"name";s:8:"relation";}s:17:"relation_endpoint";a:1:{s:4:"name";s:17:"relation_endpoint";}s:6:"system";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.33)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.33";}}}s:5:"feeds";a:3:{s:4:"name";s:5:"feeds";s:16:"original_version";s:19:" (!=7.x-1.0-alpha8)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:"!=";s:7:"version";s:10:"1.0-alpha8";}}}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:13:"job_scheduler";a:1:{s:4:"name";s:13:"job_scheduler";}}s:4:"sort";i:-143;}s:16:"relation_migrate";O:8:"stdClass":11:{s:3:"uri";s:75:"sites/all/modules/contrib/relation/relation_migrate/relation_migrate.module";s:8:"filename";s:75:"sites/all/modules/contrib/relation/relation_migrate/relation_migrate.module";s:4:"name";s:16:"relation_migrate";s:4:"info";a:10:{s:4:"name";s:16:"Relation migrate";s:11:"description";s:40:"Migrate integration module for Relation.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Relation";s:5:"files";a:3:{i:0;s:32:"relation_migrate.destination.inc";i:1;s:27:"relation_migrate.source.inc";i:2;s:30:"relation_migrate.migration.inc";}s:12:"dependencies";a:3:{i:0;s:8:"relation";i:1;s:11:"relation_ui";i:2;s:7:"migrate";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:5:{s:8:"relation";a:1:{s:4:"name";s:8:"relation";}s:17:"relation_endpoint";a:1:{s:4:"name";s:17:"relation_endpoint";}s:6:"system";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.33)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.33";}}}s:11:"relation_ui";a:1:{s:4:"name";s:11:"relation_ui";}s:7:"migrate";a:1:{s:4:"name";s:7:"migrate";}}s:4:"sort";i:-145;}s:21:"relation_migrate_test";O:8:"stdClass":11:{s:3:"uri";s:86:"sites/all/modules/contrib/relation/relation_migrate/tests/relation_migrate_test.module";s:8:"filename";s:86:"sites/all/modules/contrib/relation/relation_migrate/tests/relation_migrate_test.module";s:4:"name";s:21:"relation_migrate_test";s:4:"info";a:11:{s:4:"name";s:22:"Relation Migrate Tests";s:11:"description";s:60:"Support module for the Relation - Migrate integration tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:4:{i:0;s:14:"node_reference";i:1;s:14:"user_reference";i:2;s:15:"entityreference";i:3;s:5:"views";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:6:{s:14:"node_reference";a:1:{s:4:"name";s:14:"node_reference";}s:14:"user_reference";a:1:{s:4:"name";s:14:"user_reference";}s:15:"entityreference";a:1:{s:4:"name";s:15:"entityreference";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:5:"views";a:1:{s:4:"name";s:5:"views";}}s:4:"sort";i:-146;}s:19:"relation_rules_test";O:8:"stdClass":11:{s:3:"uri";s:67:"sites/all/modules/contrib/relation/tests/relation_rules_test.module";s:8:"filename";s:67:"sites/all/modules/contrib/relation/tests/relation_rules_test.module";s:4:"name";s:19:"relation_rules_test";s:4:"info";a:11:{s:4:"name";s:14:"Relation Tests";s:11:"description";s:58:"Support module for the Relation - Rules integration tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:11:"relation_ui";O:8:"stdClass":11:{s:3:"uri";s:53:"sites/all/modules/contrib/relation/relation_ui.module";s:8:"filename";s:53:"sites/all/modules/contrib/relation/relation_ui.module";s:4:"name";s:11:"relation_ui";s:4:"info";a:11:{s:4:"name";s:11:"Relation UI";s:11:"description";s:105:"Administrative interface to relation. Without this module, you cannot create or edit your relation types.";s:7:"package";s:8:"Relation";s:4:"core";s:3:"7.x";s:9:"configure";s:24:"admin/structure/relation";s:12:"dependencies";a:1:{i:0;s:8:"relation";}s:5:"files";a:2:{i:0;s:18:"relation_ui.module";i:1;s:22:"tests/relation_ui.test";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:16:"relation_migrate";a:1:{s:4:"name";s:11:"relation_ui";}}s:8:"requires";a:3:{s:8:"relation";a:1:{s:4:"name";s:8:"relation";}s:17:"relation_endpoint";a:1:{s:4:"name";s:17:"relation_endpoint";}s:6:"system";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.33)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.33";}}}}s:4:"sort";i:-144;}s:18:"requirements1_test";O:8:"stdClass":11:{s:3:"uri";s:50:"modules/simpletest/tests/requirements1_test.module";s:8:"filename";s:50:"modules/simpletest/tests/requirements1_test.module";s:4:"name";s:18:"requirements1_test";s:4:"info";a:11:{s:4:"name";s:19:"Requirements 1 Test";s:11:"description";s:80:"Tests that a module is not installed when it fails hook_requirements(''install'').";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:18:"requirements2_test";a:1:{s:4:"name";s:18:"requirements1_test";}}s:8:"requires";a:0:{}s:4:"sort";i:-147;}s:18:"requirements2_test";O:8:"stdClass":11:{s:3:"uri";s:50:"modules/simpletest/tests/requirements2_test.module";s:8:"filename";s:50:"modules/simpletest/tests/requirements2_test.module";s:4:"name";s:18:"requirements2_test";s:4:"info";a:11:{s:4:"name";s:19:"Requirements 2 Test";s:11:"description";s:98:"Tests that a module is not installed when the one it depends on fails hook_requirements(''install).";s:12:"dependencies";a:2:{i:0;s:18:"requirements1_test";i:1;s:7:"comment";}s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:5:{s:18:"requirements1_test";a:1:{s:4:"name";s:18:"requirements1_test";}s:7:"comment";a:1:{s:4:"name";s:7:"comment";}s:4:"text";a:1:{s:4:"name";s:4:"text";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-148;}s:5:"rules";O:8:"stdClass":11:{s:3:"uri";s:44:"sites/all/modules/contrib/rules/rules.module";s:8:"filename";s:44:"sites/all/modules/contrib/rules/rules.module";s:4:"name";s:5:"rules";s:4:"info";a:11:{s:4:"name";s:5:"Rules";s:11:"description";s:51:"React on events and conditionally evaluate actions.";s:7:"package";s:5:"Rules";s:4:"core";s:3:"7.x";s:5:"files";a:17:{i:0;s:18:"rules.features.inc";i:1;s:16:"tests/rules.test";i:2;s:18:"includes/faces.inc";i:3;s:23:"includes/rules.core.inc";i:4;s:24:"includes/rules.event.inc";i:5;s:28:"includes/rules.processor.inc";i:6;s:26:"includes/rules.plugins.inc";i:7;s:24:"includes/rules.state.inc";i:8;s:29:"includes/rules.dispatcher.inc";i:9;s:21:"modules/node.eval.inc";i:10;s:20:"modules/php.eval.inc";i:11;s:27:"modules/rules_core.eval.inc";i:12;s:23:"modules/system.eval.inc";i:13;s:20:"ui/ui.controller.inc";i:14;s:14:"ui/ui.core.inc";i:15;s:14:"ui/ui.data.inc";i:16;s:17:"ui/ui.plugins.inc";}s:12:"dependencies";a:2:{i:0;s:12:"entity_token";i:1;s:6:"entity";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:9:"bootstrap";i:0;s:9:"configure";s:27:"admin/config/workflow/rules";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7214";s:6:"weight";s:2:"20";s:11:"required_by";a:9:{s:20:"content_access_rules";a:1:{s:4:"name";s:5:"rules";}s:24:"entityform_notifications";a:1:{s:4:"name";s:5:"rules";}s:14:"flag_hook_test";a:1:{s:4:"name";s:5:"rules";}s:11:"rules_admin";a:1:{s:4:"name";s:5:"rules";}s:17:"rules_conditional";a:1:{s:4:"name";s:5:"rules";}s:22:"rules_conditional_test";a:1:{s:4:"name";s:5:"rules";}s:10:"rules_i18n";a:1:{s:4:"name";s:5:"rules";}s:15:"rules_scheduler";a:1:{s:4:"name";s:5:"rules";}s:14:"workflow_rules";a:1:{s:4:"name";s:5:"rules";}}s:8:"requires";a:2:{s:12:"entity_token";a:1:{s:4:"name";s:12:"entity_token";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-39;}s:11:"rules_admin";O:8:"stdClass":11:{s:3:"uri";s:62:"sites/all/modules/contrib/rules/rules_admin/rules_admin.module";s:8:"filename";s:62:"sites/all/modules/contrib/rules/rules_admin/rules_admin.module";s:4:"name";s:11:"rules_admin";s:4:"info";a:10:{s:4:"name";s:8:"Rules UI";s:11:"description";s:44:"Administrative interface for managing rules.";s:7:"package";s:5:"Rules";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:18:"rules_admin.module";i:1;s:15:"rules_admin.inc";}s:12:"dependencies";a:1:{i:0;s:5:"rules";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:5:"rules";a:1:{s:4:"name";s:5:"rules";}s:12:"entity_token";a:1:{s:4:"name";s:12:"entity_token";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-149;}s:17:"rules_conditional";O:8:"stdClass":11:{s:3:"uri";s:68:"sites/all/modules/contrib/rules_conditional/rules_conditional.module";s:8:"filename";s:68:"sites/all/modules/contrib/rules_conditional/rules_conditional.module";s:4:"name";s:17:"rules_conditional";s:4:"info";a:10:{s:4:"name";s:17:"Conditional Rules";s:11:"description";s:63:"Provides conditional control elements within action containers.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"rules";}s:7:"package";s:5:"Rules";s:5:"files";a:4:{i:0;s:35:"includes/rules_conditional.core.inc";i:1;s:37:"includes/rules_conditional.plugin.inc";i:2;s:33:"includes/rules_conditional.ui.inc";i:3;s:28:"tests/rules_conditional.test";}s:7:"version";s:13:"7.x-1.0-beta2";s:7:"project";s:17:"rules_conditional";s:9:"datestamp";s:10:"1352752992";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:22:"rules_conditional_test";a:1:{s:4:"name";s:17:"rules_conditional";}}s:8:"requires";a:3:{s:5:"rules";a:1:{s:4:"name";s:5:"rules";}s:12:"entity_token";a:1:{s:4:"name";s:12:"entity_token";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-150;}s:22:"rules_conditional_test";O:8:"stdClass":11:{s:3:"uri";s:79:"sites/all/modules/contrib/rules_conditional/tests/rules_conditional_test.module";s:8:"filename";s:79:"sites/all/modules/contrib/rules_conditional/tests/rules_conditional_test.module";s:4:"name";s:22:"rules_conditional_test";s:4:"info";a:11:{s:4:"name";s:22:"Conditional Rules Test";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:5:"rules";i:1;s:17:"rules_conditional";}s:5:"files";a:1:{i:0;s:26:"rules_conditional_test.inc";}s:7:"package";s:5:"Rules";s:6:"hidden";b:1;s:7:"version";s:13:"7.x-1.0-beta2";s:7:"project";s:17:"rules_conditional";s:9:"datestamp";s:10:"1352752992";s:11:"description";s:0:"";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:5:"rules";a:1:{s:4:"name";s:5:"rules";}s:12:"entity_token";a:1:{s:4:"name";s:12:"entity_token";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:17:"rules_conditional";a:1:{s:4:"name";s:17:"rules_conditional";}}s:4:"sort";i:-151;}s:10:"rules_i18n";O:8:"stdClass":11:{s:3:"uri";s:60:"sites/all/modules/contrib/rules/rules_i18n/rules_i18n.module";s:8:"filename";s:60:"sites/all/modules/contrib/rules/rules_i18n/rules_i18n.module";s:4:"name";s:10:"rules_i18n";s:4:"info";a:10:{s:4:"name";s:17:"Rules translation";s:11:"description";s:25:"Allows translating rules.";s:12:"dependencies";a:2:{i:0;s:5:"rules";i:1;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:3:{i:0;s:19:"rules_i18n.i18n.inc";i:1;s:20:"rules_i18n.rules.inc";i:2;s:15:"rules_i18n.test";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:7:{s:5:"rules";a:1:{s:4:"name";s:5:"rules";}s:12:"entity_token";a:1:{s:4:"name";s:12:"entity_token";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:11:"i18n_string";a:1:{s:4:"name";s:11:"i18n_string";}s:6:"locale";a:1:{s:4:"name";s:6:"locale";}s:4:"i18n";a:1:{s:4:"name";s:4:"i18n";}s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-152;}s:15:"rules_scheduler";O:8:"stdClass":11:{s:3:"uri";s:70:"sites/all/modules/contrib/rules/rules_scheduler/rules_scheduler.module";s:8:"filename";s:70:"sites/all/modules/contrib/rules/rules_scheduler/rules_scheduler.module";s:4:"name";s:15:"rules_scheduler";s:4:"info";a:11:{s:4:"name";s:15:"Rules Scheduler";s:11:"description";s:57:"Schedule the execution of Rules components using actions.";s:12:"dependencies";a:1:{i:0;s:5:"rules";}s:7:"package";s:5:"Rules";s:4:"core";s:3:"7.x";s:5:"files";a:9:{i:0;s:25:"rules_scheduler.admin.inc";i:1;s:22:"rules_scheduler.module";i:2;s:23:"rules_scheduler.install";i:3;s:25:"rules_scheduler.rules.inc";i:4;s:20:"rules_scheduler.test";i:5;s:36:"includes/rules_scheduler.handler.inc";i:6;s:42:"includes/rules_scheduler.views_default.inc";i:7;s:34:"includes/rules_scheduler.views.inc";i:8;s:41:"includes/rules_scheduler_views_filter.inc";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:9:"bootstrap";i:0;s:9:"configure";s:36:"admin/config/workflow/rules/schedule";}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:5:"rules";a:1:{s:4:"name";s:5:"rules";}s:12:"entity_token";a:1:{s:4:"name";s:12:"entity_token";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-153;}s:20:"rules_scheduler_test";O:8:"stdClass":11:{s:3:"uri";s:81:"sites/all/modules/contrib/rules/rules_scheduler/tests/rules_scheduler_test.module";s:8:"filename";s:81:"sites/all/modules/contrib/rules/rules_scheduler/tests/rules_scheduler_test.module";s:4:"name";s:20:"rules_scheduler_test";s:4:"info";a:11:{s:4:"name";s:21:"Rules Scheduler Tests";s:11:"description";s:45:"Support module for the Rules Scheduler tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:24:"rules_scheduler_test.inc";}s:6:"hidden";b:1;s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:10:"rules_test";O:8:"stdClass":11:{s:3:"uri";s:55:"sites/all/modules/contrib/rules/tests/rules_test.module";s:8:"filename";s:55:"sites/all/modules/contrib/rules/tests/rules_test.module";s:4:"name";s:10:"rules_test";s:4:"info";a:11:{s:4:"name";s:11:"Rules Tests";s:11:"description";s:35:"Support module for the Rules tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:20:"rules_test.rules.inc";i:1;s:29:"rules_test.rules_defaults.inc";}s:6:"hidden";b:1;s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:21:"rules_test_invocation";O:8:"stdClass":11:{s:3:"uri";s:66:"sites/all/modules/contrib/rules/tests/rules_test_invocation.module";s:8:"filename";s:66:"sites/all/modules/contrib/rules/tests/rules_test_invocation.module";s:4:"name";s:21:"rules_test_invocation";s:4:"info";a:11:{s:4:"name";s:21:"Rules Test invocation";s:11:"description";s:40:"Helper module to test Rules invocations.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:6:"search";O:8:"stdClass":11:{s:3:"uri";s:28:"modules/search/search.module";s:8:"filename";s:28:"modules/search/search.module";s:4:"name";s:6:"search";s:4:"info";a:12:{s:4:"name";s:6:"Search";s:11:"description";s:36:"Enables site-wide keyword searching.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:19:"search.extender.inc";i:1;s:11:"search.test";}s:9:"configure";s:28:"admin/config/search/settings";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:10:"search.css";s:25:"modules/search/search.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7000";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"pantheon";a:1:{s:4:"name";s:6:"search";}}s:8:"requires";a:0:{}s:4:"sort";i:-130;}s:20:"search_embedded_form";O:8:"stdClass":11:{s:3:"uri";s:48:"modules/search/tests/search_embedded_form.module";s:8:"filename";s:48:"modules/search/tests/search_embedded_form.module";s:4:"name";s:20:"search_embedded_form";s:4:"info";a:11:{s:4:"name";s:20:"Search embedded form";s:11:"description";s:59:"Support module for search module testing of embedded forms.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:17:"search_extra_type";O:8:"stdClass":11:{s:3:"uri";s:45:"modules/search/tests/search_extra_type.module";s:8:"filename";s:45:"modules/search/tests/search_extra_type.module";s:4:"name";s:17:"search_extra_type";s:4:"info";a:11:{s:4:"name";s:16:"Test search type";s:11:"description";s:41:"Support module for search module testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:16:"search_node_tags";O:8:"stdClass":11:{s:3:"uri";s:44:"modules/search/tests/search_node_tags.module";s:8:"filename";s:44:"modules/search/tests/search_node_tags.module";s:4:"name";s:16:"search_node_tags";s:4:"info";a:11:{s:4:"name";s:21:"Test search node tags";s:11:"description";s:44:"Support module for Node search tags testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:12:"session_test";O:8:"stdClass":11:{s:3:"uri";s:44:"modules/simpletest/tests/session_test.module";s:8:"filename";s:44:"modules/simpletest/tests/session_test.module";s:4:"name";s:12:"session_test";s:4:"info";a:11:{s:4:"name";s:12:"Session test";s:11:"description";s:40:"Support module for session data testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:11:"sharedemail";O:8:"stdClass":11:{s:3:"uri";s:56:"sites/all/modules/contrib/sharedemail/sharedemail.module";s:8:"filename";s:56:"sites/all/modules/contrib/sharedemail/sharedemail.module";s:4:"name";s:11:"sharedemail";s:4:"info";a:11:{s:4:"name";s:13:"Shared E-mail";s:11:"description";s:65:"Allow an e-mail address to be used by more than one user account.";s:4:"core";s:3:"7.x";s:9:"configure";s:31:"admin/config/people/sharedemail";s:7:"version";s:7:"7.x-1.0";s:7:"project";s:11:"sharedemail";s:9:"datestamp";s:10:"1409870031";s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:8:"shortcut";O:8:"stdClass":11:{s:3:"uri";s:32:"modules/shortcut/shortcut.module";s:8:"filename";s:32:"modules/shortcut/shortcut.module";s:4:"name";s:8:"shortcut";s:4:"info";a:11:{s:4:"name";s:8:"Shortcut";s:11:"description";s:60:"Allows users to manage customizable lists of shortcut links.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:13:"shortcut.test";}s:9:"configure";s:36:"admin/config/user-interface/shortcut";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"pantheon";a:1:{s:4:"name";s:8:"shortcut";}}s:8:"requires";a:0:{}s:4:"sort";i:-131;}s:10:"simpletest";O:8:"stdClass":11:{s:3:"uri";s:36:"modules/simpletest/simpletest.module";s:8:"filename";s:36:"modules/simpletest/simpletest.module";s:4:"name";s:10:"simpletest";s:4:"info";a:11:{s:4:"name";s:7:"Testing";s:11:"description";s:53:"Provides a framework for unit and functional testing.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:50:{i:0;s:15:"simpletest.test";i:1;s:24:"drupal_web_test_case.php";i:2;s:18:"tests/actions.test";i:3;s:15:"tests/ajax.test";i:4;s:16:"tests/batch.test";i:5;s:15:"tests/boot.test";i:6;s:20:"tests/bootstrap.test";i:7;s:16:"tests/cache.test";i:8;s:17:"tests/common.test";i:9;s:24:"tests/database_test.test";i:10;s:22:"tests/entity_crud.test";i:11;s:32:"tests/entity_crud_hook_test.test";i:12;s:23:"tests/entity_query.test";i:13;s:16:"tests/error.test";i:14;s:15:"tests/file.test";i:15;s:23:"tests/filetransfer.test";i:16;s:15:"tests/form.test";i:17;s:16:"tests/graph.test";i:18;s:16:"tests/image.test";i:19;s:15:"tests/lock.test";i:20;s:15:"tests/mail.test";i:21;s:15:"tests/menu.test";i:22;s:17:"tests/module.test";i:23;s:16:"tests/pager.test";i:24;s:19:"tests/password.test";i:25;s:15:"tests/path.test";i:26;s:19:"tests/registry.test";i:27;s:17:"tests/schema.test";i:28;s:18:"tests/session.test";i:29;s:20:"tests/tablesort.test";i:30;s:16:"tests/theme.test";i:31;s:18:"tests/unicode.test";i:32;s:17:"tests/update.test";i:33;s:17:"tests/xmlrpc.test";i:34;s:26:"tests/upgrade/upgrade.test";i:35;s:34:"tests/upgrade/upgrade.comment.test";i:36;s:33:"tests/upgrade/upgrade.filter.test";i:37;s:32:"tests/upgrade/upgrade.forum.test";i:38;s:33:"tests/upgrade/upgrade.locale.test";i:39;s:31:"tests/upgrade/upgrade.menu.test";i:40;s:31:"tests/upgrade/upgrade.node.test";i:41;s:35:"tests/upgrade/upgrade.taxonomy.test";i:42;s:34:"tests/upgrade/upgrade.trigger.test";i:43;s:39:"tests/upgrade/upgrade.translatable.test";i:44;s:33:"tests/upgrade/upgrade.upload.test";i:45;s:31:"tests/upgrade/upgrade.user.test";i:46;s:36:"tests/upgrade/update.aggregator.test";i:47;s:33:"tests/upgrade/update.trigger.test";i:48;s:31:"tests/upgrade/update.field.test";i:49;s:30:"tests/upgrade/update.user.test";}s:9:"configure";s:41:"admin/config/development/testing/settings";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"smtp";O:8:"stdClass":11:{s:3:"uri";s:42:"sites/all/modules/contrib/smtp/smtp.module";s:8:"filename";s:42:"sites/all/modules/contrib/smtp/smtp.module";s:4:"name";s:4:"smtp";s:4:"info";a:12:{s:4:"name";s:27:"SMTP Authentication Support";s:11:"description";s:71:"Allow for site emails to be sent through an SMTP server of your choice.";s:4:"core";s:3:"7.x";s:7:"package";s:4:"Mail";s:9:"configure";s:24:"admin/config/system/smtp";s:5:"files";a:4:{i:0;s:13:"smtp.mail.inc";i:1;s:18:"smtp.phpmailer.inc";i:2;s:18:"smtp.transport.inc";i:3;s:20:"tests/smtp.unit.test";}s:17:"test_dependencies";a:1:{i:0;s:7:"maillog";}s:7:"version";s:7:"7.x-1.6";s:7:"project";s:4:"smtp";s:9:"datestamp";s:10:"1482783785";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7103";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:10:"smtp_tests";O:8:"stdClass":11:{s:3:"uri";s:54:"sites/all/modules/contrib/smtp/tests/smtp_tests.module";s:8:"filename";s:54:"sites/all/modules/contrib/smtp/tests/smtp_tests.module";s:4:"name";s:10:"smtp_tests";s:4:"info";a:11:{s:4:"name";s:10:"SMTP tests";s:11:"description";s:41:"Contains helper logic for the SMTP tests.";s:7:"package";s:4:"Mail";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-1.6";s:7:"project";s:4:"smtp";s:9:"datestamp";s:10:"1482783785";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:10:"statistics";O:8:"stdClass":11:{s:3:"uri";s:36:"modules/statistics/statistics.module";s:8:"filename";s:36:"modules/statistics/statistics.module";s:4:"name";s:10:"statistics";s:4:"info";a:11:{s:4:"name";s:10:"Statistics";s:11:"description";s:37:"Logs access statistics for your site.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:15:"statistics.test";}s:9:"configure";s:30:"admin/config/system/statistics";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7000";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:15:"stringoverrides";O:8:"stdClass":11:{s:3:"uri";s:64:"sites/all/modules/contrib/stringoverrides/stringoverrides.module";s:8:"filename";s:64:"sites/all/modules/contrib/stringoverrides/stringoverrides.module";s:4:"name";s:15:"stringoverrides";s:4:"info";a:11:{s:4:"name";s:16:"String Overrides";s:11:"description";s:48:"Provides a quick and easy way of replacing text.";s:4:"core";s:3:"7.x";s:5:"files";a:3:{i:0;s:22:"stringoverrides.module";i:1;s:23:"stringoverrides.install";i:2;s:25:"stringoverrides.admin.inc";}s:9:"configure";s:37:"admin/config/regional/stringoverrides";s:7:"version";s:7:"7.x-1.8";s:7:"project";s:15:"stringoverrides";s:9:"datestamp";s:10:"1304446316";s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7000";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:23:"stringoverrides_migrate";a:1:{s:4:"name";s:15:"stringoverrides";}}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:23:"stringoverrides_migrate";O:8:"stdClass":11:{s:3:"uri";s:72:"sites/all/modules/contrib/stringoverrides/stringoverrides_migrate.module";s:8:"filename";s:72:"sites/all/modules/contrib/stringoverrides/stringoverrides_migrate.module";s:4:"name";s:23:"stringoverrides_migrate";s:4:"info";a:10:{s:4:"name";s:24:"String Overrides Migrate";s:11:"description";s:59:"Tools for importing and exporting string override settings.";s:12:"dependencies";a:1:{i:0;s:15:"stringoverrides";}s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:30:"stringoverrides_migrate.module";i:1;s:33:"stringoverrides_migrate.admin.inc";}s:7:"version";s:7:"7.x-1.8";s:7:"project";s:15:"stringoverrides";s:9:"datestamp";s:10:"1304446316";s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:15:"stringoverrides";a:1:{s:4:"name";s:15:"stringoverrides";}}s:4:"sort";i:-1;}s:8:"stylizer";O:8:"stdClass":11:{s:3:"uri";s:57:"sites/all/modules/contrib/ctools/stylizer/stylizer.module";s:8:"filename";s:57:"sites/all/modules/contrib/ctools/stylizer/stylizer.module";s:4:"name";s:8:"stylizer";s:4:"info";a:10:{s:4:"name";s:8:"Stylizer";s:11:"description";s:53:"Create custom styles for applications such as Panels.";s:4:"core";s:3:"7.x";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:12:"dependencies";a:2:{i:0;s:6:"ctools";i:1;s:5:"color";}s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:5:"color";a:1:{s:4:"name";s:5:"color";}}s:4:"sort";i:-154;}s:6:"syslog";O:8:"stdClass":11:{s:3:"uri";s:28:"modules/syslog/syslog.module";s:8:"filename";s:28:"modules/syslog/syslog.module";s:4:"name";s:6:"syslog";s:4:"info";a:11:{s:4:"name";s:6:"Syslog";s:11:"description";s:41:"Logs and records system events to syslog.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:11:"syslog.test";}s:9:"configure";s:32:"admin/config/development/logging";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:6:"system";O:8:"stdClass":11:{s:3:"uri";s:28:"modules/system/system.module";s:8:"filename";s:28:"modules/system/system.module";s:4:"name";s:6:"system";s:4:"info";a:12:{s:4:"name";s:6:"System";s:11:"description";s:54:"Handles general site configuration for administrators.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:6:{i:0;s:19:"system.archiver.inc";i:1;s:15:"system.mail.inc";i:2;s:16:"system.queue.inc";i:3;s:14:"system.tar.inc";i:4;s:18:"system.updater.inc";i:5;s:11:"system.test";}s:8:"required";b:1;s:9:"configure";s:19:"admin/config/system";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7081";s:6:"weight";s:1:"0";s:11:"required_by";a:11:{s:10:"admin_menu";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:8:" (>7.10)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:4:"7.10";}}}s:18:"admin_menu_toolbar";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:8:" (>7.10)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:4:"7.10";}}}s:9:"libraries";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.11)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.11";}}}s:21:"libraries_test_module";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.11)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.11";}}}s:11:"placeholder";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.11)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.11";}}}s:8:"relation";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.33)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.33";}}}s:20:"relation_dummy_field";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.33)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.33";}}}s:25:"relation_entity_collector";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.33)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.33";}}}s:14:"relation_feeds";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.33)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.33";}}}s:11:"relation_ui";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.33)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.33";}}}s:16:"relation_migrate";a:3:{s:4:"name";s:6:"system";s:16:"original_version";s:9:" (>=7.33)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:4:"7.33";}}}}s:8:"requires";a:0:{}s:4:"sort";i:-5;}s:16:"system_cron_test";O:8:"stdClass":11:{s:3:"uri";s:44:"modules/system/tests/system_cron_test.module";s:8:"filename";s:44:"modules/system/tests/system_cron_test.module";s:4:"name";s:16:"system_cron_test";s:4:"info";a:11:{s:4:"name";s:16:"System Cron Test";s:11:"description";s:45:"Support module for testing the system_cron().";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:24:"system_dependencies_test";O:8:"stdClass":11:{s:3:"uri";s:56:"modules/simpletest/tests/system_dependencies_test.module";s:8:"filename";s:56:"modules/simpletest/tests/system_dependencies_test.module";s:4:"name";s:24:"system_dependencies_test";s:4:"info";a:11:{s:4:"name";s:22:"System dependency test";s:11:"description";s:47:"Support module for testing system dependencies.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:19:"_missing_dependency";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:19:"_missing_dependency";a:1:{s:4:"name";s:19:"_missing_dependency";}}s:4:"sort";i:0;}s:50:"system_incompatible_core_version_dependencies_test";O:8:"stdClass":11:{s:3:"uri";s:82:"modules/simpletest/tests/system_incompatible_core_version_dependencies_test.module";s:8:"filename";s:82:"modules/simpletest/tests/system_incompatible_core_version_dependencies_test.module";s:4:"name";s:50:"system_incompatible_core_version_dependencies_test";s:4:"info";a:11:{s:4:"name";s:50:"System incompatible core version dependencies test";s:11:"description";s:47:"Support module for testing system dependencies.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:37:"system_incompatible_core_version_test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:37:"system_incompatible_core_version_test";a:1:{s:4:"name";s:37:"system_incompatible_core_version_test";}}s:4:"sort";i:-1;}s:37:"system_incompatible_core_version_test";O:8:"stdClass":11:{s:3:"uri";s:69:"modules/simpletest/tests/system_incompatible_core_version_test.module";s:8:"filename";s:69:"modules/simpletest/tests/system_incompatible_core_version_test.module";s:4:"name";s:37:"system_incompatible_core_version_test";s:4:"info";a:11:{s:4:"name";s:37:"System incompatible core version test";s:11:"description";s:47:"Support module for testing system dependencies.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"5.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:50:"system_incompatible_core_version_dependencies_test";a:1:{s:4:"name";s:37:"system_incompatible_core_version_test";}}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:52:"system_incompatible_module_version_dependencies_test";O:8:"stdClass":11:{s:3:"uri";s:84:"modules/simpletest/tests/system_incompatible_module_version_dependencies_test.module";s:8:"filename";s:84:"modules/simpletest/tests/system_incompatible_module_version_dependencies_test.module";s:4:"name";s:52:"system_incompatible_module_version_dependencies_test";s:4:"info";a:11:{s:4:"name";s:52:"System incompatible module version dependencies test";s:11:"description";s:47:"Support module for testing system dependencies.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:46:"system_incompatible_module_version_test (>2.0)";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:39:"system_incompatible_module_version_test";a:3:{s:4:"name";s:39:"system_incompatible_module_version_test";s:16:"original_version";s:7:" (>2.0)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"2.0";}}}}s:4:"sort";i:-1;}s:39:"system_incompatible_module_version_test";O:8:"stdClass":11:{s:3:"uri";s:71:"modules/simpletest/tests/system_incompatible_module_version_test.module";s:8:"filename";s:71:"modules/simpletest/tests/system_incompatible_module_version_test.module";s:4:"name";s:39:"system_incompatible_module_version_test";s:4:"info";a:11:{s:4:"name";s:39:"System incompatible module version test";s:11:"description";s:47:"Support module for testing system dependencies.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:52:"system_incompatible_module_version_dependencies_test";a:3:{s:4:"name";s:39:"system_incompatible_module_version_test";s:16:"original_version";s:7:" (>2.0)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"2.0";}}}}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:29:"system_project_namespace_test";O:8:"stdClass":11:{s:3:"uri";s:61:"modules/simpletest/tests/system_project_namespace_test.module";s:8:"filename";s:61:"modules/simpletest/tests/system_project_namespace_test.module";s:4:"name";s:29:"system_project_namespace_test";s:4:"info";a:11:{s:4:"name";s:29:"System project namespace test";s:11:"description";s:58:"Support module for testing project namespace dependencies.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:13:"drupal:filter";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:6:"filter";a:2:{s:7:"project";s:6:"drupal";s:4:"name";s:6:"filter";}}s:4:"sort";i:-1;}s:11:"system_test";O:8:"stdClass":11:{s:3:"uri";s:43:"modules/simpletest/tests/system_test.module";s:8:"filename";s:43:"modules/simpletest/tests/system_test.module";s:4:"name";s:11:"system_test";s:4:"info";a:11:{s:4:"name";s:11:"System test";s:11:"description";s:34:"Support module for system testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:18:"system_test.module";}s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:8:"taxonomy";O:8:"stdClass":11:{s:3:"uri";s:32:"modules/taxonomy/taxonomy.module";s:8:"filename";s:32:"modules/taxonomy/taxonomy.module";s:4:"name";s:8:"taxonomy";s:4:"info";a:13:{s:4:"name";s:8:"Taxonomy";s:11:"description";s:38:"Enables the categorization of content.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:7:"options";}s:5:"files";a:2:{i:0;s:15:"taxonomy.module";i:1;s:13:"taxonomy.test";}s:9:"configure";s:24:"admin/structure/taxonomy";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7011";s:6:"weight";s:1:"0";s:11:"required_by";a:6:{s:13:"features_test";a:1:{s:4:"name";s:8:"taxonomy";}s:5:"forum";a:1:{s:4:"name";s:8:"taxonomy";}s:13:"i18n_taxonomy";a:1:{s:4:"name";s:8:"taxonomy";}s:10:"i18n_forum";a:1:{s:4:"name";s:8:"taxonomy";}s:8:"pantheon";a:1:{s:4:"name";s:8:"taxonomy";}s:13:"taxonomy_test";a:1:{s:4:"name";s:8:"taxonomy";}}s:8:"requires";a:3:{s:7:"options";a:1:{s:4:"name";s:7:"options";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-80;}s:13:"taxonomy_test";O:8:"stdClass":11:{s:3:"uri";s:45:"modules/simpletest/tests/taxonomy_test.module";s:8:"filename";s:45:"modules/simpletest/tests/taxonomy_test.module";s:4:"name";s:13:"taxonomy_test";s:4:"info";a:11:{s:4:"name";s:20:"Taxonomy test module";s:11:"description";s:45:""Tests functions and hooks not used in core".";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:8:"taxonomy";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:8:"taxonomy";a:1:{s:4:"name";s:8:"taxonomy";}s:7:"options";a:1:{s:4:"name";s:7:"options";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-155;}s:9:"telephone";O:8:"stdClass":11:{s:3:"uri";s:52:"sites/all/modules/contrib/telephone/telephone.module";s:8:"filename";s:52:"sites/all/modules/contrib/telephone/telephone.module";s:4:"name";s:9:"telephone";s:4:"info";a:10:{s:4:"name";s:9:"Telephone";s:11:"description";s:43:"Defines a field type for telephone numbers.";s:7:"package";s:6:"Fields";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:21:"telephone.migrate.inc";}s:7:"version";s:14:"7.x-1.0-alpha1";s:7:"project";s:9:"telephone";s:9:"datestamp";s:10:"1389736105";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-156;}s:10:"term_depth";O:8:"stdClass":11:{s:3:"uri";s:61:"sites/all/modules/contrib/ctools/term_depth/term_depth.module";s:8:"filename";s:61:"sites/all/modules/contrib/ctools/term_depth/term_depth.module";s:4:"name";s:10:"term_depth";s:4:"info";a:10:{s:4:"name";s:17:"Term Depth access";s:11:"description";s:48:"Controls access to context based upon term depth";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-157;}s:12:"terms_of_use";O:8:"stdClass":11:{s:3:"uri";s:58:"sites/all/modules/contrib/terms_of_use/terms_of_use.module";s:8:"filename";s:58:"sites/all/modules/contrib/terms_of_use/terms_of_use.module";s:4:"name";s:12:"terms_of_use";s:4:"info";a:11:{s:4:"name";s:12:"Terms of Use";s:11:"description";s:43:"Adds terms of Use to the registration page.";s:4:"core";s:3:"7.x";s:9:"configure";s:32:"admin/config/people/terms_of_use";s:5:"files";a:1:{i:0;s:23:"tests/terms_of_use.test";}s:7:"version";s:7:"7.x-1.2";s:7:"project";s:12:"terms_of_use";s:9:"datestamp";s:10:"1341924142";s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"text";O:8:"stdClass":11:{s:3:"uri";s:38:"modules/field/modules/text/text.module";s:8:"filename";s:38:"modules/field/modules/text/text.module";s:4:"name";s:4:"text";s:4:"info";a:12:{s:4:"name";s:4:"Text";s:11:"description";s:32:"Defines simple text field types.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:9:"text.test";}s:8:"required";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7000";s:6:"weight";s:1:"0";s:11:"required_by";a:9:{s:17:"bookpoints_events";a:1:{s:4:"name";s:4:"text";}s:7:"comment";a:1:{s:4:"name";s:4:"text";}s:15:"entityform_test";a:1:{s:4:"name";s:4:"text";}s:22:"flag_comment_flag_test";a:1:{s:4:"name";s:4:"text";}s:5:"forum";a:1:{s:4:"name";s:4:"text";}s:10:"i18n_forum";a:1:{s:4:"name";s:4:"text";}s:8:"pantheon";a:1:{s:4:"name";s:4:"text";}s:18:"requirements2_test";a:1:{s:4:"name";s:4:"text";}s:7:"tracker";a:1:{s:4:"name";s:4:"text";}}s:8:"requires";a:2:{s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-26;}s:10:"theme_test";O:8:"stdClass":11:{s:3:"uri";s:42:"modules/simpletest/tests/theme_test.module";s:8:"filename";s:42:"modules/simpletest/tests/theme_test.module";s:4:"name";s:10:"theme_test";s:4:"info";a:11:{s:4:"name";s:10:"Theme test";s:11:"description";s:40:"Support module for theme system testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:5:"token";O:8:"stdClass":11:{s:3:"uri";s:44:"sites/all/modules/contrib/token/token.module";s:8:"filename";s:44:"sites/all/modules/contrib/token/token.module";s:4:"name";s:5:"token";s:4:"info";a:10:{s:4:"name";s:5:"Token";s:11:"description";s:73:"Provides a user interface for the Token API and some missing core tokens.";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:10:"token.test";}s:7:"version";s:7:"7.x-1.6";s:7:"project";s:5:"token";s:9:"datestamp";s:10:"1425149060";s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7001";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"pathauto";a:1:{s:4:"name";s:5:"token";}}s:8:"requires";a:0:{}s:4:"sort";i:-135;}s:10:"token_test";O:8:"stdClass":11:{s:3:"uri";s:55:"sites/all/modules/contrib/token/tests/token_test.module";s:8:"filename";s:55:"sites/all/modules/contrib/token/tests/token_test.module";s:4:"name";s:10:"token_test";s:4:"info";a:11:{s:4:"name";s:10:"Token Test";s:11:"description";s:39:"Testing module for token functionality.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:17:"token_test.module";}s:6:"hidden";b:1;s:7:"version";s:7:"7.x-1.6";s:7:"project";s:5:"token";s:9:"datestamp";s:10:"1425149060";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:7:"toolbar";O:8:"stdClass":11:{s:3:"uri";s:30:"modules/toolbar/toolbar.module";s:8:"filename";s:30:"modules/toolbar/toolbar.module";s:4:"name";s:7:"toolbar";s:4:"info";a:10:{s:4:"name";s:7:"Toolbar";s:11:"description";s:99:"Provides a toolbar that shows the top-level administration menu items and links from other modules.";s:4:"core";s:3:"7.x";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:8:"pantheon";a:1:{s:4:"name";s:7:"toolbar";}}s:8:"requires";a:0:{}s:4:"sort";i:-132;}s:7:"tracker";O:8:"stdClass":11:{s:3:"uri";s:30:"modules/tracker/tracker.module";s:8:"filename";s:30:"modules/tracker/tracker.module";s:4:"name";s:7:"tracker";s:4:"info";a:10:{s:4:"name";s:7:"Tracker";s:11:"description";s:45:"Enables tracking of recent content for users.";s:12:"dependencies";a:1:{i:0;s:7:"comment";}s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:12:"tracker.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:7:"comment";a:1:{s:4:"name";s:7:"comment";}s:4:"text";a:1:{s:4:"name";s:4:"text";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}}s:4:"sort";i:-158;}s:11:"translation";O:8:"stdClass":11:{s:3:"uri";s:38:"modules/translation/translation.module";s:8:"filename";s:38:"modules/translation/translation.module";s:4:"name";s:11:"translation";s:4:"info";a:10:{s:4:"name";s:19:"Content translation";s:11:"description";s:57:"Allows content to be translated into different languages.";s:12:"dependencies";a:1:{i:0;s:6:"locale";}s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:16:"translation.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:4:{s:9:"i18n_node";a:1:{s:4:"name";s:11:"translation";}s:10:"i18n_forum";a:1:{s:4:"name";s:11:"translation";}s:9:"i18n_sync";a:1:{s:4:"name";s:11:"translation";}s:9:"i18n_test";a:1:{s:4:"name";s:11:"translation";}}s:8:"requires";a:1:{s:6:"locale";a:1:{s:4:"name";s:6:"locale";}}s:4:"sort";i:-103;}s:16:"translation_test";O:8:"stdClass":11:{s:3:"uri";s:49:"modules/translation/tests/translation_test.module";s:8:"filename";s:49:"modules/translation/tests/translation_test.module";s:4:"name";s:16:"translation_test";s:4:"info";a:11:{s:4:"name";s:24:"Content Translation Test";s:11:"description";s:49:"Support module for the content translation tests.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:15:"transliteration";O:8:"stdClass":11:{s:3:"uri";s:64:"sites/all/modules/contrib/transliteration/transliteration.module";s:8:"filename";s:64:"sites/all/modules/contrib/transliteration/transliteration.module";s:4:"name";s:15:"transliteration";s:4:"info";a:11:{s:4:"name";s:15:"Transliteration";s:11:"description";s:61:"Converts non-latin text to US-ASCII and sanitizes file names.";s:4:"core";s:3:"7.x";s:9:"configure";s:30:"admin/config/media/file-system";s:7:"version";s:7:"7.x-3.2";s:7:"project";s:15:"transliteration";s:9:"datestamp";s:10:"1395079444";s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:7:"trigger";O:8:"stdClass":11:{s:3:"uri";s:30:"modules/trigger/trigger.module";s:8:"filename";s:30:"modules/trigger/trigger.module";s:4:"name";s:7:"trigger";s:4:"info";a:11:{s:4:"name";s:7:"Trigger";s:11:"description";s:90:"Enables actions to be fired on certain system events, such as when new content is created.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:12:"trigger.test";}s:9:"configure";s:23:"admin/structure/trigger";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:16:"workflow_actions";a:1:{s:4:"name";s:7:"trigger";}}s:8:"requires";a:0:{}s:4:"sort";i:-159;}s:12:"trigger_test";O:8:"stdClass":11:{s:3:"uri";s:41:"modules/trigger/tests/trigger_test.module";s:8:"filename";s:41:"modules/trigger/tests/trigger_test.module";s:4:"name";s:12:"trigger_test";s:4:"info";a:11:{s:4:"name";s:12:"Trigger Test";s:11:"description";s:33:"Support module for Trigger tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:6:"update";O:8:"stdClass":11:{s:3:"uri";s:28:"modules/update/update.module";s:8:"filename";s:28:"modules/update/update.module";s:4:"name";s:6:"update";s:4:"info";a:11:{s:4:"name";s:14:"Update manager";s:11:"description";s:104:"Checks for available updates, and can securely install or update modules and themes via a web interface.";s:7:"version";s:4:"7.54";s:7:"package";s:4:"Core";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:11:"update.test";}s:9:"configure";s:30:"admin/reports/updates/settings";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:18:"update_script_test";O:8:"stdClass":11:{s:3:"uri";s:50:"modules/simpletest/tests/update_script_test.module";s:8:"filename";s:50:"modules/simpletest/tests/update_script_test.module";s:4:"name";s:18:"update_script_test";s:4:"info";a:11:{s:4:"name";s:18:"Update script test";s:11:"description";s:41:"Support module for update script testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:11:"update_test";O:8:"stdClass":11:{s:3:"uri";s:39:"modules/update/tests/update_test.module";s:8:"filename";s:39:"modules/update/tests/update_test.module";s:4:"name";s:11:"update_test";s:4:"info";a:11:{s:4:"name";s:11:"Update test";s:11:"description";s:41:"Support module for update module testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:13:"update_test_1";O:8:"stdClass":11:{s:3:"uri";s:45:"modules/simpletest/tests/update_test_1.module";s:8:"filename";s:45:"modules/simpletest/tests/update_test_1.module";s:4:"name";s:13:"update_test_1";s:4:"info";a:11:{s:4:"name";s:11:"Update test";s:11:"description";s:34:"Support module for update testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:13:"update_test_2";O:8:"stdClass":11:{s:3:"uri";s:45:"modules/simpletest/tests/update_test_2.module";s:8:"filename";s:45:"modules/simpletest/tests/update_test_2.module";s:4:"name";s:13:"update_test_2";s:4:"info";a:11:{s:4:"name";s:11:"Update test";s:11:"description";s:34:"Support module for update testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:13:"update_test_3";O:8:"stdClass":11:{s:3:"uri";s:45:"modules/simpletest/tests/update_test_3.module";s:8:"filename";s:45:"modules/simpletest/tests/update_test_3.module";s:4:"name";s:13:"update_test_3";s:4:"info";a:11:{s:4:"name";s:11:"Update test";s:11:"description";s:34:"Support module for update testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:14:"url_alter_test";O:8:"stdClass":11:{s:3:"uri";s:46:"modules/simpletest/tests/url_alter_test.module";s:8:"filename";s:46:"modules/simpletest/tests/url_alter_test.module";s:4:"name";s:14:"url_alter_test";s:4:"info";a:11:{s:4:"name";s:15:"Url_alter tests";s:11:"description";s:45:"A support modules for url_alter hook testing.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"user";O:8:"stdClass":11:{s:3:"uri";s:24:"modules/user/user.module";s:8:"filename";s:24:"modules/user/user.module";s:4:"name";s:4:"user";s:4:"info";a:13:{s:4:"name";s:4:"User";s:11:"description";s:47:"Manages the user registration and login system.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:11:"user.module";i:1;s:9:"user.test";}s:8:"required";b:1;s:9:"configure";s:19:"admin/config/people";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:8:"user.css";s:21:"modules/user/user.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7019";s:6:"weight";s:1:"0";s:11:"required_by";a:4:{s:4:"uuid";a:1:{s:4:"name";s:4:"user";}s:9:"uuid_path";a:1:{s:4:"name";s:4:"user";}s:13:"uuid_services";a:1:{s:4:"name";s:4:"user";}s:21:"uuid_services_example";a:1:{s:4:"name";s:4:"user";}}s:8:"requires";a:0:{}s:4:"sort";i:-160;}s:14:"user_form_test";O:8:"stdClass":11:{s:3:"uri";s:40:"modules/user/tests/user_form_test.module";s:8:"filename";s:40:"modules/user/tests/user_form_test.module";s:4:"name";s:14:"user_form_test";s:4:"info";a:11:{s:4:"name";s:22:"User module form tests";s:11:"description";s:37:"Support module for user form testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}s:4:"uuid";O:8:"stdClass":11:{s:3:"uri";s:42:"sites/all/modules/contrib/uuid/uuid.module";s:8:"filename";s:42:"sites/all/modules/contrib/uuid/uuid.module";s:4:"name";s:4:"uuid";s:4:"info";a:11:{s:4:"name";s:21:"Universally Unique ID";s:11:"description";s:85:"Extends the entity functionality and adds support for universally unique identifiers.";s:4:"core";s:3:"7.x";s:7:"package";s:4:"UUID";s:9:"configure";s:24:"admin/config/system/uuid";s:5:"files";a:1:{i:0;s:9:"uuid.test";}s:12:"dependencies";a:2:{i:0;s:4:"node";i:1;s:4:"user";}s:7:"version";s:13:"7.x-1.0-beta2";s:7:"project";s:4:"uuid";s:9:"datestamp";s:10:"1470153540";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:3:{s:9:"uuid_path";a:1:{s:4:"name";s:4:"uuid";}s:13:"uuid_services";a:1:{s:4:"name";s:4:"uuid";}s:21:"uuid_services_example";a:1:{s:4:"name";s:4:"uuid";}}s:8:"requires";a:2:{s:4:"node";a:1:{s:4:"name";s:4:"node";}s:4:"user";a:1:{s:4:"name";s:4:"user";}}s:4:"sort";i:-161;}s:9:"uuid_path";O:8:"stdClass":11:{s:3:"uri";s:57:"sites/all/modules/contrib/uuid/uuid_path/uuid_path.module";s:8:"filename";s:57:"sites/all/modules/contrib/uuid/uuid_path/uuid_path.module";s:4:"name";s:9:"uuid_path";s:4:"info";a:10:{s:4:"name";s:9:"UUID Path";s:11:"description";s:46:"Provides export functionality for url aliases.";s:4:"core";s:3:"7.x";s:7:"package";s:4:"UUID";s:12:"dependencies";a:1:{i:0;s:4:"uuid";}s:7:"version";s:13:"7.x-1.0-beta2";s:7:"project";s:4:"uuid";s:9:"datestamp";s:10:"1470153540";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:4:"uuid";a:1:{s:4:"name";s:4:"uuid";}s:4:"node";a:1:{s:4:"name";s:4:"node";}s:4:"user";a:1:{s:4:"name";s:4:"user";}}s:4:"sort";i:-162;}s:13:"uuid_services";O:8:"stdClass":11:{s:3:"uri";s:65:"sites/all/modules/contrib/uuid/uuid_services/uuid_services.module";s:8:"filename";s:65:"sites/all/modules/contrib/uuid/uuid_services/uuid_services.module";s:4:"name";s:13:"uuid_services";s:4:"info";a:10:{s:4:"name";s:13:"UUID Services";s:11:"description";s:84:"Provides integration with the Services module, like exposing a UUID entity resource.";s:4:"core";s:3:"7.x";s:7:"package";s:20:"Services - resources";s:12:"dependencies";a:3:{i:0;s:8:"services";i:1;s:4:"uuid";i:2;s:6:"entity";}s:7:"version";s:13:"7.x-1.0-beta2";s:7:"project";s:4:"uuid";s:9:"datestamp";s:10:"1470153540";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:21:"uuid_services_example";a:1:{s:4:"name";s:13:"uuid_services";}}s:8:"requires";a:5:{s:8:"services";a:1:{s:4:"name";s:8:"services";}s:4:"uuid";a:1:{s:4:"name";s:4:"uuid";}s:4:"node";a:1:{s:4:"name";s:4:"node";}s:4:"user";a:1:{s:4:"name";s:4:"user";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}}s:4:"sort";i:-163;}s:21:"uuid_services_example";r:615;s:8:"variable";O:8:"stdClass":11:{s:3:"uri";s:50:"sites/all/modules/contrib/variable/variable.module";s:8:"filename";s:50:"sites/all/modules/contrib/variable/variable.module";s:4:"name";s:8:"variable";s:4:"info";a:10:{s:4:"name";s:8:"Variable";s:11:"description";s:43:"Variable Information and basic variable API";s:7:"package";s:8:"Variable";s:4:"core";s:3:"7.x";s:5:"files";a:9:{i:0;s:27:"includes/forum.variable.inc";i:1;s:28:"includes/locale.variable.inc";i:2;s:26:"includes/menu.variable.inc";i:3;s:26:"includes/node.variable.inc";i:4;s:28:"includes/system.variable.inc";i:5;s:30:"includes/taxonomy.variable.inc";i:6;s:33:"includes/translation.variable.inc";i:7;s:26:"includes/user.variable.inc";i:8;s:13:"variable.test";}s:7:"version";s:7:"7.x-2.5";s:7:"project";s:8:"variable";s:9:"datestamp";s:10:"1398250128";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:26:{s:4:"i18n";a:1:{s:4:"name";s:8:"variable";}s:11:"i18n_string";a:1:{s:4:"name";s:8:"variable";}s:16:"entity_test_i18n";a:1:{s:4:"name";s:8:"variable";}s:10:"i18n_block";a:1:{s:4:"name";s:8:"variable";}s:12:"i18n_contact";a:1:{s:4:"name";s:8:"variable";}s:10:"i18n_field";a:1:{s:4:"name";s:8:"variable";}s:16:"i18n_translation";a:1:{s:4:"name";s:8:"variable";}s:13:"i18n_taxonomy";a:1:{s:4:"name";s:8:"variable";}s:9:"i18n_node";a:1:{s:4:"name";s:8:"variable";}s:10:"i18n_forum";a:1:{s:4:"name";s:8:"variable";}s:9:"i18n_menu";a:1:{s:4:"name";s:8:"variable";}s:11:"i18n_panels";a:1:{s:4:"name";s:8:"variable";}s:9:"i18n_path";a:1:{s:4:"name";s:8:"variable";}s:13:"i18n_redirect";a:1:{s:4:"name";s:8:"variable";}s:11:"i18n_select";a:1:{s:4:"name";s:8:"variable";}s:9:"i18n_sync";a:1:{s:4:"name";s:8:"variable";}s:9:"i18n_test";a:1:{s:4:"name";s:8:"variable";}s:14:"variable_store";a:1:{s:4:"name";s:8:"variable";}s:14:"variable_realm";a:1:{s:4:"name";s:8:"variable";}s:13:"i18n_variable";a:1:{s:4:"name";s:8:"variable";}s:9:"i18n_user";a:1:{s:4:"name";s:8:"variable";}s:9:"i18nviews";a:1:{s:4:"name";s:8:"variable";}s:10:"rules_i18n";a:1:{s:4:"name";s:8:"variable";}s:14:"variable_admin";a:1:{s:4:"name";s:8:"variable";}s:16:"variable_example";a:1:{s:4:"name";s:8:"variable";}s:14:"variable_views";a:1:{s:4:"name";s:8:"variable";}}s:8:"requires";a:0:{}s:4:"sort";i:-67;}s:14:"variable_admin";O:8:"stdClass":11:{s:3:"uri";s:71:"sites/all/modules/contrib/variable/variable_admin/variable_admin.module";s:8:"filename";s:71:"sites/all/modules/contrib/variable/variable_admin/variable_admin.module";s:4:"name";s:14:"variable_admin";s:4:"info";a:10:{s:4:"name";s:14:"Variable admin";s:11:"description";s:26:"Variable Administration UI";s:12:"dependencies";a:1:{i:0;s:8:"variable";}s:7:"package";s:8:"Variable";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.5";s:7:"project";s:8:"variable";s:9:"datestamp";s:10:"1398250128";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-165;}s:16:"variable_example";O:8:"stdClass":11:{s:3:"uri";s:75:"sites/all/modules/contrib/variable/variable_example/variable_example.module";s:8:"filename";s:75:"sites/all/modules/contrib/variable/variable_example/variable_example.module";s:4:"name";s:16:"variable_example";s:4:"info";a:10:{s:4:"name";s:16:"Variable example";s:11:"description";s:83:"An example module showing how to use the Variable API and providing some variables.";s:12:"dependencies";a:2:{i:0;s:8:"variable";i:1;s:14:"variable_store";}s:7:"package";s:15:"Example modules";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:29:"variable_example.variable.inc";}s:7:"version";s:7:"7.x-2.5";s:7:"project";s:8:"variable";s:9:"datestamp";s:10:"1398250128";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:8:"variable";a:1:{s:4:"name";s:8:"variable";}s:14:"variable_store";a:1:{s:4:"name";s:14:"variable_store";}}s:4:"sort";i:-166;}s:14:"variable_realm";O:8:"stdClass":11:{s:3:"uri";s:71:"sites/all/modules/contrib/variable/variable_realm/variable_realm.module";s:8:"filename";s:71:"sites/all/modules/contrib/variable/variable_realm/variable_realm.module";s:4:"name";s:14:"variable_realm";s:4:"info";a:10:{s:4:"name";s:14:"Variable realm";s:11:"description";s:49:"API to use variable realms from different modules";s:12:"dependencies";a:1:{i:0;s:8:"variable";}s:7:"package";s:8:"Variable";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.5";s:5:"files";a:2:{i:0;s:24:"variable_realm.class.inc";i:1;s:30:"variable_realm_union.class.inc";}s:7:"project";s:8:"variable";s:9:"datestamp";s:10:"1398250128";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:2:{s:13:"i18n_variable";a:3:{s:4:"name";s:14:"variable_realm";s:16:"original_version";s:10:" (7.x-2.x)";s:8:"versions";a:2:{i:0;a:2:{s:2:"op";s:1:"<";s:7:"version";s:3:"3.x";}i:1;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"2.x";}}}s:9:"i18n_user";a:3:{s:4:"name";s:14:"variable_realm";s:16:"original_version";s:10:" (7.x-2.x)";s:8:"versions";a:2:{i:0;a:2:{s:2:"op";s:1:"<";s:7:"version";s:3:"3.x";}i:1;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"2.x";}}}}s:8:"requires";a:1:{s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-114;}s:14:"variable_store";O:8:"stdClass":11:{s:3:"uri";s:71:"sites/all/modules/contrib/variable/variable_store/variable_store.module";s:8:"filename";s:71:"sites/all/modules/contrib/variable/variable_store/variable_store.module";s:4:"name";s:14:"variable_store";s:4:"info";a:10:{s:4:"name";s:14:"Variable store";s:11:"description";s:60:"Database storage for variable realms. This is an API module.";s:12:"dependencies";a:1:{i:0;s:8:"variable";}s:7:"package";s:8:"Variable";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.5";s:5:"files";a:2:{i:0;s:24:"variable_store.class.inc";i:1;s:19:"variable_store.test";}s:7:"project";s:8:"variable";s:9:"datestamp";s:10:"1398250128";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:3:{s:13:"i18n_variable";a:3:{s:4:"name";s:14:"variable_store";s:16:"original_version";s:10:" (7.x-2.x)";s:8:"versions";a:2:{i:0;a:2:{s:2:"op";s:1:"<";s:7:"version";s:3:"3.x";}i:1;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"2.x";}}}s:9:"i18n_user";a:3:{s:4:"name";s:14:"variable_store";s:16:"original_version";s:10:" (7.x-2.x)";s:8:"versions";a:2:{i:0;a:2:{s:2:"op";s:1:"<";s:7:"version";s:3:"3.x";}i:1;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"2.x";}}}s:16:"variable_example";a:1:{s:4:"name";s:14:"variable_store";}}s:8:"requires";a:1:{s:8:"variable";a:1:{s:4:"name";s:8:"variable";}}s:4:"sort";i:-113;}s:14:"variable_views";O:8:"stdClass":11:{s:3:"uri";s:71:"sites/all/modules/contrib/variable/variable_views/variable_views.module";s:8:"filename";s:71:"sites/all/modules/contrib/variable/variable_views/variable_views.module";s:4:"name";s:14:"variable_views";s:4:"info";a:10:{s:4:"name";s:14:"Variable views";s:11:"description";s:78:"Provides views integration for variable, included a default variable argument.";s:12:"dependencies";a:2:{i:0;s:8:"variable";i:1;s:5:"views";}s:7:"package";s:8:"Variable";s:4:"core";s:3:"7.x";s:5:"files";a:3:{i:0;s:51:"includes/views_plugin_argument_default_variable.inc";i:1;s:47:"includes/views_handler_field_variable_title.inc";i:2;s:47:"includes/views_handler_field_variable_value.inc";}s:7:"version";s:7:"7.x-2.5";s:7:"project";s:8:"variable";s:9:"datestamp";s:10:"1398250128";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:8:"variable";a:1:{s:4:"name";s:8:"variable";}s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-167;}s:5:"views";O:8:"stdClass":11:{s:3:"uri";s:44:"sites/all/modules/contrib/views/views.module";s:8:"filename";s:44:"sites/all/modules/contrib/views/views.module";s:4:"name";s:5:"views";s:4:"info";a:11:{s:4:"name";s:5:"Views";s:11:"description";s:55:"Create customized lists and queries from your database.";s:7:"package";s:5:"Views";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:13:"css/views.css";s:45:"sites/all/modules/contrib/views/css/views.css";}}s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:5:"files";a:313:{i:0;s:31:"handlers/views_handler_area.inc";i:1;s:40:"handlers/views_handler_area_messages.inc";i:2;s:38:"handlers/views_handler_area_result.inc";i:3;s:36:"handlers/views_handler_area_text.inc";i:4;s:43:"handlers/views_handler_area_text_custom.inc";i:5;s:36:"handlers/views_handler_area_view.inc";i:6;s:35:"handlers/views_handler_argument.inc";i:7;s:40:"handlers/views_handler_argument_date.inc";i:8;s:43:"handlers/views_handler_argument_formula.inc";i:9;s:47:"handlers/views_handler_argument_many_to_one.inc";i:10;s:40:"handlers/views_handler_argument_null.inc";i:11;s:43:"handlers/views_handler_argument_numeric.inc";i:12;s:42:"handlers/views_handler_argument_string.inc";i:13;s:52:"handlers/views_handler_argument_group_by_numeric.inc";i:14;s:32:"handlers/views_handler_field.inc";i:15;s:40:"handlers/views_handler_field_counter.inc";i:16;s:40:"handlers/views_handler_field_boolean.inc";i:17;s:49:"handlers/views_handler_field_contextual_links.inc";i:18;s:48:"handlers/views_handler_field_ctools_dropdown.inc";i:19;s:39:"handlers/views_handler_field_custom.inc";i:20;s:37:"handlers/views_handler_field_date.inc";i:21;s:39:"handlers/views_handler_field_entity.inc";i:22;s:38:"handlers/views_handler_field_links.inc";i:23;s:39:"handlers/views_handler_field_markup.inc";i:24;s:37:"handlers/views_handler_field_math.inc";i:25;s:40:"handlers/views_handler_field_numeric.inc";i:26;s:47:"handlers/views_handler_field_prerender_list.inc";i:27;s:46:"handlers/views_handler_field_time_interval.inc";i:28;s:43:"handlers/views_handler_field_serialized.inc";i:29;s:45:"handlers/views_handler_field_machine_name.inc";i:30;s:36:"handlers/views_handler_field_url.inc";i:31;s:33:"handlers/views_handler_filter.inc";i:32;s:50:"handlers/views_handler_filter_boolean_operator.inc";i:33;s:57:"handlers/views_handler_filter_boolean_operator_string.inc";i:34;s:41:"handlers/views_handler_filter_combine.inc";i:35;s:38:"handlers/views_handler_filter_date.inc";i:36;s:42:"handlers/views_handler_filter_equality.inc";i:37;s:47:"handlers/views_handler_filter_entity_bundle.inc";i:38;s:50:"handlers/views_handler_filter_group_by_numeric.inc";i:39;s:45:"handlers/views_handler_filter_in_operator.inc";i:40;s:45:"handlers/views_handler_filter_many_to_one.inc";i:41;s:41:"handlers/views_handler_filter_numeric.inc";i:42;s:40:"handlers/views_handler_filter_string.inc";i:43;s:48:"handlers/views_handler_filter_fields_compare.inc";i:44;s:39:"handlers/views_handler_relationship.inc";i:45;s:53:"handlers/views_handler_relationship_groupwise_max.inc";i:46;s:31:"handlers/views_handler_sort.inc";i:47;s:36:"handlers/views_handler_sort_date.inc";i:48;s:39:"handlers/views_handler_sort_formula.inc";i:49;s:48:"handlers/views_handler_sort_group_by_numeric.inc";i:50;s:46:"handlers/views_handler_sort_menu_hierarchy.inc";i:51;s:38:"handlers/views_handler_sort_random.inc";i:52;s:17:"includes/base.inc";i:53;s:21:"includes/handlers.inc";i:54;s:20:"includes/plugins.inc";i:55;s:17:"includes/view.inc";i:56;s:60:"modules/aggregator/views_handler_argument_aggregator_fid.inc";i:57;s:60:"modules/aggregator/views_handler_argument_aggregator_iid.inc";i:58;s:69:"modules/aggregator/views_handler_argument_aggregator_category_cid.inc";i:59;s:64:"modules/aggregator/views_handler_field_aggregator_title_link.inc";i:60;s:62:"modules/aggregator/views_handler_field_aggregator_category.inc";i:61;s:70:"modules/aggregator/views_handler_field_aggregator_item_description.inc";i:62;s:57:"modules/aggregator/views_handler_field_aggregator_xss.inc";i:63;s:67:"modules/aggregator/views_handler_filter_aggregator_category_cid.inc";i:64;s:54:"modules/aggregator/views_plugin_row_aggregator_rss.inc";i:65;s:56:"modules/book/views_plugin_argument_default_book_root.inc";i:66;s:59:"modules/comment/views_handler_argument_comment_user_uid.inc";i:67;s:47:"modules/comment/views_handler_field_comment.inc";i:68;s:53:"modules/comment/views_handler_field_comment_depth.inc";i:69;s:52:"modules/comment/views_handler_field_comment_link.inc";i:70;s:60:"modules/comment/views_handler_field_comment_link_approve.inc";i:71;s:59:"modules/comment/views_handler_field_comment_link_delete.inc";i:72;s:57:"modules/comment/views_handler_field_comment_link_edit.inc";i:73;s:58:"modules/comment/views_handler_field_comment_link_reply.inc";i:74;s:57:"modules/comment/views_handler_field_comment_node_link.inc";i:75;s:56:"modules/comment/views_handler_field_comment_username.inc";i:76;s:61:"modules/comment/views_handler_field_ncs_last_comment_name.inc";i:77;s:56:"modules/comment/views_handler_field_ncs_last_updated.inc";i:78;s:52:"modules/comment/views_handler_field_node_comment.inc";i:79;s:57:"modules/comment/views_handler_field_node_new_comments.inc";i:80;s:62:"modules/comment/views_handler_field_last_comment_timestamp.inc";i:81;s:57:"modules/comment/views_handler_filter_comment_user_uid.inc";i:82;s:57:"modules/comment/views_handler_filter_ncs_last_updated.inc";i:83;s:53:"modules/comment/views_handler_filter_node_comment.inc";i:84;s:53:"modules/comment/views_handler_sort_comment_thread.inc";i:85;s:60:"modules/comment/views_handler_sort_ncs_last_comment_name.inc";i:86;s:55:"modules/comment/views_handler_sort_ncs_last_updated.inc";i:87;s:48:"modules/comment/views_plugin_row_comment_rss.inc";i:88;s:49:"modules/comment/views_plugin_row_comment_view.inc";i:89;s:52:"modules/contact/views_handler_field_contact_link.inc";i:90;s:43:"modules/field/views_handler_field_field.inc";i:91;s:59:"modules/field/views_handler_relationship_entity_reverse.inc";i:92;s:51:"modules/field/views_handler_argument_field_list.inc";i:93;s:57:"modules/field/views_handler_filter_field_list_boolean.inc";i:94;s:58:"modules/field/views_handler_argument_field_list_string.inc";i:95;s:49:"modules/field/views_handler_filter_field_list.inc";i:96;s:57:"modules/filter/views_handler_field_filter_format_name.inc";i:97;s:52:"modules/locale/views_handler_field_node_language.inc";i:98;s:53:"modules/locale/views_handler_filter_node_language.inc";i:99;s:54:"modules/locale/views_handler_argument_locale_group.inc";i:100;s:57:"modules/locale/views_handler_argument_locale_language.inc";i:101;s:51:"modules/locale/views_handler_field_locale_group.inc";i:102;s:54:"modules/locale/views_handler_field_locale_language.inc";i:103;s:55:"modules/locale/views_handler_field_locale_link_edit.inc";i:104;s:52:"modules/locale/views_handler_filter_locale_group.inc";i:105;s:55:"modules/locale/views_handler_filter_locale_language.inc";i:106;s:54:"modules/locale/views_handler_filter_locale_version.inc";i:107;s:51:"modules/locale/views_handler_sort_node_language.inc";i:108;s:53:"modules/node/views_handler_argument_dates_various.inc";i:109;s:53:"modules/node/views_handler_argument_node_language.inc";i:110;s:48:"modules/node/views_handler_argument_node_nid.inc";i:111;s:49:"modules/node/views_handler_argument_node_type.inc";i:112;s:48:"modules/node/views_handler_argument_node_vid.inc";i:113;s:57:"modules/node/views_handler_argument_node_uid_revision.inc";i:114;s:59:"modules/node/views_handler_field_history_user_timestamp.inc";i:115;s:41:"modules/node/views_handler_field_node.inc";i:116;s:46:"modules/node/views_handler_field_node_link.inc";i:117;s:53:"modules/node/views_handler_field_node_link_delete.inc";i:118;s:51:"modules/node/views_handler_field_node_link_edit.inc";i:119;s:50:"modules/node/views_handler_field_node_revision.inc";i:120;s:55:"modules/node/views_handler_field_node_revision_link.inc";i:121;s:62:"modules/node/views_handler_field_node_revision_link_delete.inc";i:122;s:62:"modules/node/views_handler_field_node_revision_link_revert.inc";i:123;s:46:"modules/node/views_handler_field_node_path.inc";i:124;s:46:"modules/node/views_handler_field_node_type.inc";i:125;s:55:"modules/node/views_handler_field_node_version_count.inc";i:126;s:60:"modules/node/views_handler_filter_history_user_timestamp.inc";i:127;s:49:"modules/node/views_handler_filter_node_access.inc";i:128;s:49:"modules/node/views_handler_filter_node_status.inc";i:129;s:47:"modules/node/views_handler_filter_node_type.inc";i:130;s:55:"modules/node/views_handler_filter_node_uid_revision.inc";i:131;s:56:"modules/node/views_handler_filter_node_version_count.inc";i:132;s:54:"modules/node/views_handler_sort_node_version_count.inc";i:133;s:51:"modules/node/views_plugin_argument_default_node.inc";i:134;s:52:"modules/node/views_plugin_argument_validate_node.inc";i:135;s:42:"modules/node/views_plugin_row_node_rss.inc";i:136;s:43:"modules/node/views_plugin_row_node_view.inc";i:137;s:52:"modules/profile/views_handler_field_profile_date.inc";i:138;s:52:"modules/profile/views_handler_field_profile_list.inc";i:139;s:58:"modules/profile/views_handler_filter_profile_selection.inc";i:140;s:48:"modules/search/views_handler_argument_search.inc";i:141;s:51:"modules/search/views_handler_field_search_score.inc";i:142;s:46:"modules/search/views_handler_filter_search.inc";i:143;s:50:"modules/search/views_handler_sort_search_score.inc";i:144;s:47:"modules/search/views_plugin_row_search_view.inc";i:145;s:57:"modules/statistics/views_handler_field_accesslog_path.inc";i:146;s:65:"modules/statistics/views_handler_field_node_counter_timestamp.inc";i:147;s:61:"modules/statistics/views_handler_field_statistics_numeric.inc";i:148;s:50:"modules/system/views_handler_argument_file_fid.inc";i:149;s:43:"modules/system/views_handler_field_file.inc";i:150;s:53:"modules/system/views_handler_field_file_extension.inc";i:151;s:52:"modules/system/views_handler_field_file_filemime.inc";i:152;s:47:"modules/system/views_handler_field_file_uri.inc";i:153;s:50:"modules/system/views_handler_field_file_status.inc";i:154;s:51:"modules/system/views_handler_filter_file_status.inc";i:155;s:52:"modules/taxonomy/views_handler_argument_taxonomy.inc";i:156;s:57:"modules/taxonomy/views_handler_argument_term_node_tid.inc";i:157;s:63:"modules/taxonomy/views_handler_argument_term_node_tid_depth.inc";i:158;s:68:"modules/taxonomy/views_handler_argument_term_node_tid_depth_join.inc";i:159;s:72:"modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc";i:160;s:58:"modules/taxonomy/views_handler_argument_vocabulary_vid.inc";i:161;s:67:"modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc";i:162;s:49:"modules/taxonomy/views_handler_field_taxonomy.inc";i:163;s:54:"modules/taxonomy/views_handler_field_term_node_tid.inc";i:164;s:55:"modules/taxonomy/views_handler_field_term_link_edit.inc";i:165;s:55:"modules/taxonomy/views_handler_filter_term_node_tid.inc";i:166;s:61:"modules/taxonomy/views_handler_filter_term_node_tid_depth.inc";i:167;s:66:"modules/taxonomy/views_handler_filter_term_node_tid_depth_join.inc";i:168;s:56:"modules/taxonomy/views_handler_filter_vocabulary_vid.inc";i:169;s:65:"modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc";i:170;s:62:"modules/taxonomy/views_handler_relationship_node_term_data.inc";i:171;s:65:"modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc";i:172;s:63:"modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc";i:173;s:67:"modules/tracker/views_handler_argument_tracker_comment_user_uid.inc";i:174;s:65:"modules/tracker/views_handler_filter_tracker_comment_user_uid.inc";i:175;s:65:"modules/tracker/views_handler_filter_tracker_boolean_operator.inc";i:176;s:51:"modules/system/views_handler_filter_system_type.inc";i:177;s:56:"modules/translation/views_handler_argument_node_tnid.inc";i:178;s:63:"modules/translation/views_handler_field_node_link_translate.inc";i:179;s:65:"modules/translation/views_handler_field_node_translation_link.inc";i:180;s:54:"modules/translation/views_handler_filter_node_tnid.inc";i:181;s:60:"modules/translation/views_handler_filter_node_tnid_child.inc";i:182;s:62:"modules/translation/views_handler_relationship_translation.inc";i:183;s:48:"modules/user/views_handler_argument_user_uid.inc";i:184;s:55:"modules/user/views_handler_argument_users_roles_rid.inc";i:185;s:41:"modules/user/views_handler_field_user.inc";i:186;s:50:"modules/user/views_handler_field_user_language.inc";i:187;s:46:"modules/user/views_handler_field_user_link.inc";i:188;s:53:"modules/user/views_handler_field_user_link_cancel.inc";i:189;s:51:"modules/user/views_handler_field_user_link_edit.inc";i:190;s:46:"modules/user/views_handler_field_user_mail.inc";i:191;s:46:"modules/user/views_handler_field_user_name.inc";i:192;s:53:"modules/user/views_handler_field_user_permissions.inc";i:193;s:49:"modules/user/views_handler_field_user_picture.inc";i:194;s:47:"modules/user/views_handler_field_user_roles.inc";i:195;s:50:"modules/user/views_handler_filter_user_current.inc";i:196;s:47:"modules/user/views_handler_filter_user_name.inc";i:197;s:54:"modules/user/views_handler_filter_user_permissions.inc";i:198;s:48:"modules/user/views_handler_filter_user_roles.inc";i:199;s:59:"modules/user/views_plugin_argument_default_current_user.inc";i:200;s:51:"modules/user/views_plugin_argument_default_user.inc";i:201;s:52:"modules/user/views_plugin_argument_validate_user.inc";i:202;s:43:"modules/user/views_plugin_row_user_view.inc";i:203;s:31:"plugins/views_plugin_access.inc";i:204;s:36:"plugins/views_plugin_access_none.inc";i:205;s:36:"plugins/views_plugin_access_perm.inc";i:206;s:36:"plugins/views_plugin_access_role.inc";i:207;s:41:"plugins/views_plugin_argument_default.inc";i:208;s:45:"plugins/views_plugin_argument_default_php.inc";i:209;s:47:"plugins/views_plugin_argument_default_fixed.inc";i:210;s:45:"plugins/views_plugin_argument_default_raw.inc";i:211;s:42:"plugins/views_plugin_argument_validate.inc";i:212;s:50:"plugins/views_plugin_argument_validate_numeric.inc";i:213;s:46:"plugins/views_plugin_argument_validate_php.inc";i:214;s:30:"plugins/views_plugin_cache.inc";i:215;s:35:"plugins/views_plugin_cache_none.inc";i:216;s:35:"plugins/views_plugin_cache_time.inc";i:217;s:32:"plugins/views_plugin_display.inc";i:218;s:43:"plugins/views_plugin_display_attachment.inc";i:219;s:38:"plugins/views_plugin_display_block.inc";i:220;s:40:"plugins/views_plugin_display_default.inc";i:221;s:38:"plugins/views_plugin_display_embed.inc";i:222;s:41:"plugins/views_plugin_display_extender.inc";i:223;s:37:"plugins/views_plugin_display_feed.inc";i:224;s:37:"plugins/views_plugin_display_page.inc";i:225;s:43:"plugins/views_plugin_exposed_form_basic.inc";i:226;s:37:"plugins/views_plugin_exposed_form.inc";i:227;s:52:"plugins/views_plugin_exposed_form_input_required.inc";i:228;s:42:"plugins/views_plugin_localization_core.inc";i:229;s:37:"plugins/views_plugin_localization.inc";i:230;s:42:"plugins/views_plugin_localization_none.inc";i:231;s:30:"plugins/views_plugin_pager.inc";i:232;s:35:"plugins/views_plugin_pager_full.inc";i:233;s:35:"plugins/views_plugin_pager_mini.inc";i:234;s:35:"plugins/views_plugin_pager_none.inc";i:235;s:35:"plugins/views_plugin_pager_some.inc";i:236;s:30:"plugins/views_plugin_query.inc";i:237;s:38:"plugins/views_plugin_query_default.inc";i:238;s:28:"plugins/views_plugin_row.inc";i:239;s:35:"plugins/views_plugin_row_fields.inc";i:240;s:39:"plugins/views_plugin_row_rss_fields.inc";i:241;s:30:"plugins/views_plugin_style.inc";i:242;s:38:"plugins/views_plugin_style_default.inc";i:243;s:35:"plugins/views_plugin_style_grid.inc";i:244;s:35:"plugins/views_plugin_style_list.inc";i:245;s:40:"plugins/views_plugin_style_jump_menu.inc";i:246;s:38:"plugins/views_plugin_style_mapping.inc";i:247;s:34:"plugins/views_plugin_style_rss.inc";i:248;s:38:"plugins/views_plugin_style_summary.inc";i:249;s:48:"plugins/views_plugin_style_summary_jump_menu.inc";i:250;s:50:"plugins/views_plugin_style_summary_unformatted.inc";i:251;s:36:"plugins/views_plugin_style_table.inc";i:252;s:34:"tests/handlers/views_handlers.test";i:253;s:43:"tests/handlers/views_handler_area_text.test";i:254;s:47:"tests/handlers/views_handler_argument_null.test";i:255;s:49:"tests/handlers/views_handler_argument_string.test";i:256;s:39:"tests/handlers/views_handler_field.test";i:257;s:47:"tests/handlers/views_handler_field_boolean.test";i:258;s:46:"tests/handlers/views_handler_field_custom.test";i:259;s:47:"tests/handlers/views_handler_field_counter.test";i:260;s:44:"tests/handlers/views_handler_field_date.test";i:261;s:54:"tests/handlers/views_handler_field_file_extension.test";i:262;s:49:"tests/handlers/views_handler_field_file_size.test";i:263;s:44:"tests/handlers/views_handler_field_math.test";i:264;s:43:"tests/handlers/views_handler_field_url.test";i:265;s:43:"tests/handlers/views_handler_field_xss.test";i:266;s:48:"tests/handlers/views_handler_filter_combine.test";i:267;s:45:"tests/handlers/views_handler_filter_date.test";i:268;s:49:"tests/handlers/views_handler_filter_equality.test";i:269;s:52:"tests/handlers/views_handler_filter_in_operator.test";i:270;s:48:"tests/handlers/views_handler_filter_numeric.test";i:271;s:47:"tests/handlers/views_handler_filter_string.test";i:272;s:45:"tests/handlers/views_handler_sort_random.test";i:273;s:43:"tests/handlers/views_handler_sort_date.test";i:274;s:38:"tests/handlers/views_handler_sort.test";i:275;s:46:"tests/test_handlers/views_test_area_access.inc";i:276;s:60:"tests/test_plugins/views_test_plugin_access_test_dynamic.inc";i:277;s:59:"tests/test_plugins/views_test_plugin_access_test_static.inc";i:278;s:59:"tests/test_plugins/views_test_plugin_style_test_mapping.inc";i:279;s:39:"tests/plugins/views_plugin_display.test";i:280;s:46:"tests/styles/views_plugin_style_jump_menu.test";i:281;s:36:"tests/styles/views_plugin_style.test";i:282;s:41:"tests/styles/views_plugin_style_base.test";i:283;s:44:"tests/styles/views_plugin_style_mapping.test";i:284;s:48:"tests/styles/views_plugin_style_unformatted.test";i:285;s:23:"tests/views_access.test";i:286;s:24:"tests/views_analyze.test";i:287;s:22:"tests/views_basic.test";i:288;s:33:"tests/views_argument_default.test";i:289;s:35:"tests/views_argument_validator.test";i:290;s:29:"tests/views_exposed_form.test";i:291;s:31:"tests/field/views_fieldapi.test";i:292;s:25:"tests/views_glossary.test";i:293;s:24:"tests/views_groupby.test";i:294;s:25:"tests/views_handlers.test";i:295;s:23:"tests/views_module.test";i:296;s:22:"tests/views_pager.test";i:297;s:40:"tests/views_plugin_localization_test.inc";i:298;s:29:"tests/views_translatable.test";i:299;s:22:"tests/views_query.test";i:300;s:24:"tests/views_upgrade.test";i:301;s:34:"tests/views_test.views_default.inc";i:302;s:58:"tests/comment/views_handler_argument_comment_user_uid.test";i:303;s:56:"tests/comment/views_handler_filter_comment_user_uid.test";i:304;s:45:"tests/node/views_node_revision_relations.test";i:305;s:61:"tests/taxonomy/views_handler_relationship_node_term_data.test";i:306;s:45:"tests/user/views_handler_field_user_name.test";i:307;s:43:"tests/user/views_user_argument_default.test";i:308;s:44:"tests/user/views_user_argument_validate.test";i:309;s:26:"tests/user/views_user.test";i:310;s:22:"tests/views_cache.test";i:311;s:21:"tests/views_view.test";i:312;s:19:"tests/views_ui.test";}s:7:"version";s:8:"7.x-3.16";s:7:"project";s:5:"views";s:9:"datestamp";s:10:"1491158591";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7302";s:6:"weight";s:2:"10";s:11:"required_by";a:21:{s:21:"views_bulk_operations";a:1:{s:4:"name";s:5:"views";}s:11:"admin_views";a:1:{s:4:"name";s:5:"views";}s:9:"book_logs";a:1:{s:4:"name";s:5:"views";}s:18:"bookpoints_drawing";a:1:{s:4:"name";s:5:"views";}s:10:"date_views";a:1:{s:4:"name";s:5:"views";}s:8:"calendar";a:1:{s:4:"name";s:5:"views";}s:17:"bookpoints_events";a:1:{s:4:"name";s:5:"views";}s:10:"entityform";a:1:{s:4:"name";s:5:"views";}s:20:"entityform_anonymous";a:1:{s:4:"name";s:5:"views";}s:24:"entityform_notifications";a:1:{s:4:"name";s:5:"views";}s:15:"entityform_test";a:1:{s:4:"name";s:5:"views";}s:13:"features_test";a:1:{s:4:"name";s:5:"views";}s:10:"feeds_news";a:1:{s:4:"name";s:5:"views";}s:9:"i18nviews";a:1:{s:4:"name";s:5:"views";}s:21:"relation_migrate_test";a:1:{s:4:"name";s:5:"views";}s:14:"variable_views";a:1:{s:4:"name";s:5:"views";}s:13:"views_content";a:1:{s:4:"name";s:5:"views";}s:17:"views_data_export";a:1:{s:4:"name";s:5:"views";}s:10:"views_test";a:1:{s:4:"name";s:5:"views";}s:8:"views_ui";a:1:{s:4:"name";s:5:"views";}s:14:"workflow_views";a:3:{s:4:"name";s:5:"views";s:16:"original_version";s:7:" (>3.3)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"3.3";}}}}s:8:"requires";a:1:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-8;}s:21:"views_bulk_operations";O:8:"stdClass":11:{s:3:"uri";s:76:"sites/all/modules/contrib/views_bulk_operations/views_bulk_operations.module";s:8:"filename";s:76:"sites/all/modules/contrib/views_bulk_operations/views_bulk_operations.module";s:4:"name";s:21:"views_bulk_operations";s:4:"info";a:10:{s:4:"name";s:21:"Views Bulk Operations";s:11:"description";s:74:"Provides a way of selecting multiple rows and applying operations to them.";s:12:"dependencies";a:2:{i:0;s:6:"entity";i:1;s:5:"views";}s:7:"package";s:5:"Views";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:38:"plugins/operation_types/base.class.php";i:1;s:56:"views/views_bulk_operations_handler_field_operations.inc";}s:7:"version";s:7:"7.x-3.3";s:7:"project";s:21:"views_bulk_operations";s:9:"datestamp";s:10:"1435764542";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:11:"admin_views";a:3:{s:4:"name";s:21:"views_bulk_operations";s:16:"original_version";s:12:" (>=7.x-3.2)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:2:">=";s:7:"version";s:3:"3.2";}}}}s:8:"requires";a:3:{s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-10;}s:13:"views_content";O:8:"stdClass":11:{s:3:"uri";s:67:"sites/all/modules/contrib/ctools/views_content/views_content.module";s:8:"filename";s:67:"sites/all/modules/contrib/ctools/views_content/views_content.module";s:4:"name";s:13:"views_content";s:4:"info";a:10:{s:4:"name";s:19:"Views content panes";s:11:"description";s:104:"Allows Views content to be used in Panels, Dashboard and other modules which use the CTools Content API.";s:7:"package";s:16:"Chaos tool suite";s:12:"dependencies";a:2:{i:0;s:6:"ctools";i:1;s:5:"views";}s:4:"core";s:3:"7.x";s:7:"version";s:8:"7.x-1.11";s:5:"files";a:3:{i:0;s:61:"plugins/views/views_content_plugin_display_ctools_context.inc";i:1;s:57:"plugins/views/views_content_plugin_display_panel_pane.inc";i:2;s:59:"plugins/views/views_content_plugin_style_ctools_context.inc";}s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}s:5:"views";a:1:{s:4:"name";s:5:"views";}}s:4:"sort";i:-168;}s:17:"views_data_export";O:8:"stdClass":11:{s:3:"uri";s:68:"sites/all/modules/contrib/views_data_export/views_data_export.module";s:8:"filename";s:68:"sites/all/modules/contrib/views_data_export/views_data_export.module";s:4:"name";s:17:"views_data_export";s:4:"info";a:10:{s:4:"name";s:17:"Views Data Export";s:11:"description";s:53:"Plugin to export views data into various file formats";s:7:"package";s:5:"Views";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"views";}s:5:"files";a:12:{i:0;s:51:"plugins/views_data_export_plugin_display_export.inc";i:1;s:49:"plugins/views_data_export_plugin_style_export.inc";i:2;s:53:"plugins/views_data_export_plugin_style_export_csv.inc";i:3;s:53:"plugins/views_data_export_plugin_style_export_xml.inc";i:4;s:15:"tests/base.test";i:5;s:17:"tests/access.test";i:6;s:28:"tests/garbagecollection.test";i:7;s:21:"tests/csv_export.test";i:8;s:21:"tests/doc_export.test";i:9;s:21:"tests/txt_export.test";i:10;s:21:"tests/xls_export.test";i:11;s:21:"tests/xml_export.test";}s:7:"version";s:7:"7.x-3.1";s:7:"project";s:17:"views_data_export";s:9:"datestamp";s:10:"1474360174";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7301";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-169;}s:10:"views_test";O:8:"stdClass":11:{s:3:"uri";s:55:"sites/all/modules/contrib/views/tests/views_test.module";s:8:"filename";s:55:"sites/all/modules/contrib/views/tests/views_test.module";s:4:"name";s:10:"views_test";s:4:"info";a:11:{s:4:"name";s:10:"Views Test";s:11:"description";s:22:"Test module for Views.";s:7:"package";s:5:"Views";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"views";}s:6:"hidden";b:1;s:7:"version";s:8:"7.x-3.16";s:7:"project";s:5:"views";s:9:"datestamp";s:10:"1491158591";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-170;}s:8:"views_ui";O:8:"stdClass":11:{s:3:"uri";s:47:"sites/all/modules/contrib/views/views_ui.module";s:8:"filename";s:47:"sites/all/modules/contrib/views/views_ui.module";s:4:"name";s:8:"views_ui";s:4:"info";a:11:{s:4:"name";s:8:"Views UI";s:11:"description";s:93:"Administrative interface to views. Without this module, you cannot create or edit your views.";s:7:"package";s:5:"Views";s:4:"core";s:3:"7.x";s:9:"configure";s:21:"admin/structure/views";s:12:"dependencies";a:1:{i:0;s:5:"views";}s:5:"files";a:2:{i:0;s:15:"views_ui.module";i:1;s:57:"plugins/views_wizard/views_ui_base_views_wizard.class.php";}s:7:"version";s:8:"7.x-3.16";s:7:"project";s:5:"views";s:9:"datestamp";s:10:"1491158591";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:5:"views";a:1:{s:4:"name";s:5:"views";}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-171;}s:8:"workflow";O:8:"stdClass":11:{s:3:"uri";s:50:"sites/all/modules/contrib/workflow/workflow.module";s:8:"filename";s:50:"sites/all/modules/contrib/workflow/workflow.module";s:4:"name";s:8:"workflow";s:4:"info";a:10:{s:4:"name";s:12:"Workflow API";s:11:"description";s:94:"Workflow API. (Enable Workflow Node or Workflow Field to add arbitrary workflows to entities.)";s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:17:"entity (>7.x-1.5)";}s:5:"files";a:10:{i:0;s:28:"includes/Entity/Workflow.php";i:1;s:37:"includes/Entity/WorkflowInterface.php";i:2;s:33:"includes/Entity/WorkflowState.php";i:3;s:44:"includes/Entity/WorkflowConfigTransition.php";i:4;s:47:"includes/Entity/WorkflowScheduledTransition.php";i:5;s:38:"includes/Entity/WorkflowTransition.php";i:6;s:33:"includes/Field/WorkflowD7Base.php";i:7;s:31:"includes/Field/WorkflowItem.php";i:8;s:40:"includes/Field/WorkflowDefaultWidget.php";i:9;s:40:"includes/Form/WorkflowTransitionForm.php";}s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7017";s:6:"weight";s:1:"0";s:11:"required_by";a:13:{s:15:"workflow_access";a:1:{s:4:"name";s:8:"workflow";}s:16:"workflow_actions";a:1:{s:4:"name";s:8:"workflow";}s:17:"workflow_admin_ui";a:1:{s:4:"name";s:8:"workflow";}s:16:"workflow_cleanup";a:1:{s:4:"name";s:8:"workflow";}s:15:"workflow_notify";a:1:{s:4:"name";s:8:"workflow";}s:18:"workflow_notify_og";a:1:{s:4:"name";s:8:"workflow";}s:15:"workflow_revert";a:1:{s:4:"name";s:8:"workflow";}s:14:"workflow_rules";a:1:{s:4:"name";s:8:"workflow";}s:12:"workflownode";a:1:{s:4:"name";s:8:"workflow";}s:19:"workflow_search_api";a:1:{s:4:"name";s:8:"workflow";}s:12:"workflow_vbo";a:1:{s:4:"name";s:8:"workflow";}s:14:"workflow_views";a:1:{s:4:"name";s:8:"workflow";}s:13:"workflowfield";a:1:{s:4:"name";s:8:"workflow";}}s:8:"requires";a:1:{s:6:"entity";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}}s:4:"sort";i:-172;}s:15:"workflow_access";O:8:"stdClass":11:{s:3:"uri";s:73:"sites/all/modules/contrib/workflow/workflow_access/workflow_access.module";s:8:"filename";s:73:"sites/all/modules/contrib/workflow/workflow_access/workflow_access.module";s:4:"name";s:15:"workflow_access";s:4:"info";a:10:{s:4:"name";s:15:"Workflow access";s:11:"description";s:130:"Content access control based on workflows and roles. Depends on the node_access system, so only works for entities of type ''node''.";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:8:"workflow";a:1:{s:4:"name";s:8:"workflow";}s:6:"entity";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}}s:4:"sort";i:-173;}s:16:"workflow_actions";O:8:"stdClass":11:{s:3:"uri";s:75:"sites/all/modules/contrib/workflow/workflow_actions/workflow_actions.module";s:8:"filename";s:75:"sites/all/modules/contrib/workflow/workflow_actions/workflow_actions.module";s:4:"name";s:16:"workflow_actions";s:4:"info";a:10:{s:4:"name";s:16:"Workflow Trigger";s:11:"description";s:57:"Enables actions to be fired upon a Workflow State change.";s:12:"dependencies";a:2:{i:0;s:8:"workflow";i:1;s:7:"trigger";}s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:8:"workflow";a:1:{s:4:"name";s:8:"workflow";}s:6:"entity";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:7:"trigger";a:1:{s:4:"name";s:7:"trigger";}}s:4:"sort";i:-174;}s:17:"workflow_admin_ui";O:8:"stdClass":11:{s:3:"uri";s:77:"sites/all/modules/contrib/workflow/workflow_admin_ui/workflow_admin_ui.module";s:8:"filename";s:77:"sites/all/modules/contrib/workflow/workflow_admin_ui/workflow_admin_ui.module";s:4:"name";s:17:"workflow_admin_ui";s:4:"info";a:12:{s:4:"name";s:11:"Workflow UI";s:11:"description";s:40:"Provides administrative UI for workflow.";s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:9:"configure";s:30:"admin/config/workflow/workflow";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:5:"files";a:1:{i:0;s:46:"includes/Entity/EntityWorkflowUIController.php";}s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:21:"workflow_admin_ui.css";s:74:"sites/all/modules/contrib/workflow/workflow_admin_ui/workflow_admin_ui.css";}}s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7001";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:8:"workflow";a:1:{s:4:"name";s:8:"workflow";}s:6:"entity";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}}s:4:"sort";i:-175;}s:16:"workflow_cleanup";O:8:"stdClass":11:{s:3:"uri";s:75:"sites/all/modules/contrib/workflow/workflow_cleanup/workflow_cleanup.module";s:8:"filename";s:75:"sites/all/modules/contrib/workflow/workflow_cleanup/workflow_cleanup.module";s:4:"name";s:16:"workflow_cleanup";s:4:"info";a:11:{s:4:"name";s:17:"Workflow Clean Up";s:11:"description";s:25:"Cleans up Workflow cruft.";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:4:"core";s:3:"7.x";s:7:"package";s:8:"Workflow";s:9:"configure";s:38:"admin/config/workflow/workflow/cleanup";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:8:"workflow";a:1:{s:4:"name";s:8:"workflow";}s:6:"entity";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}}s:4:"sort";i:-176;}s:15:"workflow_notify";O:8:"stdClass":11:{s:3:"uri";s:73:"sites/all/modules/contrib/workflow/workflow_notify/workflow_notify.module";s:8:"filename";s:73:"sites/all/modules/contrib/workflow/workflow_notify/workflow_notify.module";s:4:"name";s:15:"workflow_notify";s:4:"info";a:11:{s:4:"name";s:15:"Workflow Notify";s:11:"description";s:37:"Notify roles of Workflow transitions.";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:9:"configure";s:30:"admin/config/workflow/workflow";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Workflow";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:18:"workflow_notify_og";a:1:{s:4:"name";s:15:"workflow_notify";}}s:8:"requires";a:2:{s:8:"workflow";a:1:{s:4:"name";s:8:"workflow";}s:6:"entity";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}}s:4:"sort";i:-177;}s:18:"workflow_notify_og";O:8:"stdClass":11:{s:3:"uri";s:95:"sites/all/modules/contrib/workflow/workflow_notify/workflow_notify_og/workflow_notify_og.module";s:8:"filename";s:95:"sites/all/modules/contrib/workflow/workflow_notify/workflow_notify_og/workflow_notify_og.module";s:4:"name";s:18:"workflow_notify_og";s:4:"info";a:10:{s:4:"name";s:18:"Workflow Notify OG";s:11:"description";s:50:"Notify roles by OG groups of Workflow transitions.";s:12:"dependencies";a:1:{i:0;s:15:"workflow_notify";}s:4:"core";s:3:"7.x";s:7:"package";s:8:"Workflow";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:15:"workflow_notify";a:1:{s:4:"name";s:15:"workflow_notify";}s:8:"workflow";a:1:{s:4:"name";s:8:"workflow";}s:6:"entity";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}}s:4:"sort";i:-178;}s:15:"workflow_revert";O:8:"stdClass":11:{s:3:"uri";s:73:"sites/all/modules/contrib/workflow/workflow_revert/workflow_revert.module";s:8:"filename";s:73:"sites/all/modules/contrib/workflow/workflow_revert/workflow_revert.module";s:4:"name";s:15:"workflow_revert";s:4:"info";a:10:{s:4:"name";s:15:"Workflow Revert";s:11:"description";s:55:"Adds a ''Revert'' link to the first workflow history row.";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:4:"core";s:3:"7.x";s:7:"package";s:8:"Workflow";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:8:"workflow";a:1:{s:4:"name";s:8:"workflow";}s:6:"entity";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}}s:4:"sort";i:-179;}s:14:"workflow_rules";O:8:"stdClass":11:{s:3:"uri";s:71:"sites/all/modules/contrib/workflow/workflow_rules/workflow_rules.module";s:8:"filename";s:71:"sites/all/modules/contrib/workflow/workflow_rules/workflow_rules.module";s:4:"name";s:14:"workflow_rules";s:4:"info";a:11:{s:4:"name";s:14:"Workflow Rules";s:11:"description";s:57:"Provides additional, workflow-specific Rules integration.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Workflow";s:12:"dependencies";a:2:{i:0;s:8:"workflow";i:1;s:5:"rules";}s:9:"configure";s:27:"admin/config/workflow/rules";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:1:"0";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:8:"workflow";a:1:{s:4:"name";s:8:"workflow";}s:6:"entity";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:5:"rules";a:1:{s:4:"name";s:5:"rules";}s:12:"entity_token";a:1:{s:4:"name";s:12:"entity_token";}}s:4:"sort";i:-180;}s:19:"workflow_search_api";O:8:"stdClass":11:{s:3:"uri";s:81:"sites/all/modules/contrib/workflow/workflow_search_api/workflow_search_api.module";s:8:"filename";s:81:"sites/all/modules/contrib/workflow/workflow_search_api/workflow_search_api.module";s:4:"name";s:19:"workflow_search_api";s:4:"info";a:10:{s:4:"name";s:24:"Workflow Node Search API";s:11:"description";s:59:"Adds Workflow Node''s state information to Search API index.";s:12:"dependencies";a:3:{i:0;s:8:"workflow";i:1;s:12:"workflownode";i:2;s:6:"entity";}s:4:"core";s:3:"7.x";s:7:"package";s:8:"Workflow";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:3:{s:8:"workflow";a:1:{s:4:"name";s:8:"workflow";}s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:12:"workflownode";a:1:{s:4:"name";s:12:"workflownode";}}s:4:"sort";i:-182;}s:12:"workflow_vbo";O:8:"stdClass":11:{s:3:"uri";s:67:"sites/all/modules/contrib/workflow/workflow_vbo/workflow_vbo.module";s:8:"filename";s:67:"sites/all/modules/contrib/workflow/workflow_vbo/workflow_vbo.module";s:4:"name";s:12:"workflow_vbo";s:4:"info";a:10:{s:4:"name";s:16:"Workflow Actions";s:11:"description";s:175:"Provides actions that can be associated to triggers, or\n               used as VBO-action. Provided actions are ''set to next state''\n               and ''set to specific state''.";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:2:{s:8:"workflow";a:1:{s:4:"name";s:8:"workflow";}s:6:"entity";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}}s:4:"sort";i:-183;}s:14:"workflow_views";O:8:"stdClass":11:{s:3:"uri";s:71:"sites/all/modules/contrib/workflow/workflow_views/workflow_views.module";s:8:"filename";s:71:"sites/all/modules/contrib/workflow/workflow_views/workflow_views.module";s:4:"name";s:14:"workflow_views";s:4:"info";a:10:{s:4:"name";s:14:"Workflow views";s:11:"description";s:41:"Provides views integration for workflows.";s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:8:"workflow";i:1;s:12:"views (>3.3)";}s:5:"files";a:7:{i:0;s:46:"handlers/workflow_views_handler_filter_sid.inc";i:1;s:45:"handlers/workflow_views_handler_field_sid.inc";i:2;s:47:"handlers/workflow_views_handler_field_state.inc";i:3;s:50:"handlers/workflow_views_handler_field_username.inc";i:4;s:60:"handlers/workflow_views_handler_field_node_link_workflow.inc";i:5;s:59:"handlers/workflow_views_handler_field_comment_link_edit.inc";i:6;s:50:"handlers/workflow_views_handler_argument_state.inc";}s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:4:{s:8:"workflow";a:1:{s:4:"name";s:8:"workflow";}s:6:"entity";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}s:5:"views";a:3:{s:4:"name";s:5:"views";s:16:"original_version";s:7:" (>3.3)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"3.3";}}}s:6:"ctools";a:1:{s:4:"name";s:6:"ctools";}}s:4:"sort";i:-184;}s:13:"workflowfield";O:8:"stdClass":11:{s:3:"uri";s:70:"sites/all/modules/contrib/workflow/workflow_field/workflowfield.module";s:8:"filename";s:70:"sites/all/modules/contrib/workflow/workflow_field/workflowfield.module";s:4:"name";s:13:"workflowfield";s:4:"info";a:10:{s:4:"name";s:14:"Workflow Field";s:11:"description";s:106:"Defines a Workflow field, widget and formatter. (Do not enable Workflow Field and Workflow Node together.)";s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:12:"dependencies";a:4:{i:0;s:6:"entity";i:1;s:5:"field";i:2;s:7:"options";i:3;s:8:"workflow";}s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:5:{s:6:"entity";a:1:{s:4:"name";s:6:"entity";}s:5:"field";a:1:{s:4:"name";s:5:"field";}s:17:"field_sql_storage";a:1:{s:4:"name";s:17:"field_sql_storage";}s:7:"options";a:1:{s:4:"name";s:7:"options";}s:8:"workflow";a:1:{s:4:"name";s:8:"workflow";}}s:4:"sort";i:-185;}s:12:"workflownode";O:8:"stdClass":11:{s:3:"uri";s:68:"sites/all/modules/contrib/workflow/workflow_node/workflownode.module";s:8:"filename";s:68:"sites/all/modules/contrib/workflow/workflow_node/workflownode.module";s:4:"name";s:12:"workflownode";s:4:"info";a:10:{s:4:"name";s:13:"Workflow Node";s:11:"description";s:115:"Adds a Workflow to nodes. (Use only if you come from a version below 7.x-2.x. If not, use ''Workfow Field'' instead).";s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:1:{s:19:"workflow_search_api";a:1:{s:4:"name";s:12:"workflownode";}}s:8:"requires";a:2:{s:8:"workflow";a:1:{s:4:"name";s:8:"workflow";}s:6:"entity";a:3:{s:4:"name";s:6:"entity";s:16:"original_version";s:11:" (>7.x-1.5)";s:8:"versions";a:1:{i:0;a:2:{s:2:"op";s:1:">";s:7:"version";s:3:"1.5";}}}}s:4:"sort";i:-181;}s:7:"wysiwyg";O:8:"stdClass":11:{s:3:"uri";s:48:"sites/all/modules/contrib/wysiwyg/wysiwyg.module";s:8:"filename";s:48:"sites/all/modules/contrib/wysiwyg/wysiwyg.module";s:4:"name";s:7:"wysiwyg";s:4:"info";a:11:{s:4:"name";s:7:"Wysiwyg";s:11:"description";s:48:"Allows to edit content with client-side editors.";s:7:"package";s:14:"User interface";s:4:"core";s:3:"7.x";s:9:"configure";s:28:"admin/config/content/wysiwyg";s:5:"files";a:2:{i:0;s:14:"wysiwyg.module";i:1;s:18:"tests/wysiwyg.test";}s:7:"version";s:7:"7.x-2.3";s:7:"project";s:7:"wysiwyg";s:9:"datestamp";s:10:"1483223295";s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"1";s:14:"schema_version";s:4:"7204";s:6:"weight";s:1:"0";s:11:"required_by";a:2:{s:12:"imce_wysiwyg";a:1:{s:4:"name";s:7:"wysiwyg";}s:12:"wysiwyg_test";a:1:{s:4:"name";s:7:"wysiwyg";}}s:8:"requires";a:0:{}s:4:"sort";i:-1;}s:12:"wysiwyg_test";O:8:"stdClass":11:{s:3:"uri";s:59:"sites/all/modules/contrib/wysiwyg/tests/wysiwyg_test.module";s:8:"filename";s:59:"sites/all/modules/contrib/wysiwyg/tests/wysiwyg_test.module";s:4:"name";s:12:"wysiwyg_test";s:4:"info";a:11:{s:4:"name";s:15:"Wysiwyg testing";s:11:"description";s:50:"Tests Wysiwyg module functionality. Do not enable.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:7:"wysiwyg";}s:5:"files";a:1:{i:0;s:19:"wysiwyg_test.module";}s:7:"version";s:7:"7.x-2.3";s:7:"project";s:7:"wysiwyg";s:9:"datestamp";s:10:"1483223295";s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:1:{s:7:"wysiwyg";a:1:{s:4:"name";s:7:"wysiwyg";}}s:4:"sort";i:-3;}s:11:"xmlrpc_test";O:8:"stdClass":11:{s:3:"uri";s:43:"modules/simpletest/tests/xmlrpc_test.module";s:8:"filename";s:43:"modules/simpletest/tests/xmlrpc_test.module";s:4:"name";s:11:"xmlrpc_test";s:4:"info";a:11:{s:4:"name";s:12:"XML-RPC Test";s:11:"description";s:75:"Support module for XML-RPC tests according to the validator1 specification.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}s:4:"type";s:6:"module";s:6:"status";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:11:"required_by";a:0:{}s:8:"requires";a:0:{}s:4:"sort";i:0;}}}','0','1493618724','1');
DROP TABLE IF EXISTS `cache_feeds_http`;
CREATE TABLE `cache_feeds_http` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for Feeds downloads.';
DROP TABLE IF EXISTS `cache_field`;
CREATE TABLE `cache_field` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the Field module to store already built...';
DROP TABLE IF EXISTS `cache_filter`;
CREATE TABLE `cache_filter` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the Filter module to store already...';
DROP TABLE IF EXISTS `cache_form`;
CREATE TABLE `cache_form` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the form system to store recently built...';
DROP TABLE IF EXISTS `cache_image`;
CREATE TABLE `cache_image` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table used to store information about image...';
DROP TABLE IF EXISTS `cache_libraries`;
CREATE TABLE `cache_libraries` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table to store library information.';
DROP TABLE IF EXISTS `cache_menu`;
CREATE TABLE `cache_menu` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the menu system to store router...';
DROP TABLE IF EXISTS `cache_page`;
CREATE TABLE `cache_page` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table used to store compressed pages for anonymous...';
DROP TABLE IF EXISTS `cache_panels`;
CREATE TABLE `cache_panels` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
DROP TABLE IF EXISTS `cache_path`;
CREATE TABLE `cache_path` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for path alias lookup.';
DROP TABLE IF EXISTS `cache_rules`;
CREATE TABLE `cache_rules` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the rules engine to store configured items.';
INSERT INTO `cache_rules` VALUES ('data:en','a:4:{s:9:"data_info";a:100:{s:12:"feeds_source";a:5:{s:5:"label";s:12:"Feeds source";s:5:"group";s:5:"Feeds";s:4:"wrap";b:1;s:13:"property info";a:2:{s:2:"id";a:3:{s:5:"label";s:2:"ID";s:4:"type";s:4:"text";s:11:"description";s:49:"The machine readable name of the source importer.";}s:8:"imported";a:3:{s:5:"label";s:13:"Date imported";s:4:"type";s:4:"date";s:11:"description";s:38:"The date the source was last imported.";}}s:6:"module";s:5:"feeds";}s:9:"log_entry";a:4:{s:5:"label";s:18:"watchdog log entry";s:4:"wrap";b:1;s:13:"property info";a:5:{s:4:"type";a:2:{s:4:"type";s:4:"text";s:5:"label";s:42:"The category to which this message belongs";}s:7:"message";a:4:{s:4:"type";s:4:"text";s:5:"label";s:11:"Log message";s:15:"getter callback";s:28:"rules_system_log_get_message";s:9:"sanitized";b:1;}s:8:"severity";a:3:{s:4:"type";s:7:"integer";s:5:"label";s:8:"Severity";s:12:"options list";s:24:"watchdog_severity_levels";}s:11:"request_uri";a:2:{s:4:"type";s:3:"uri";s:5:"label";s:11:"Request uri";}s:4:"link";a:2:{s:4:"type";s:4:"text";s:5:"label";s:34:"An associated, HTML formatted link";}}s:6:"module";s:5:"rules";}s:4:"text";a:4:{s:5:"label";s:4:"text";s:8:"ui class";s:15:"RulesDataUIText";s:10:"token type";s:10:"rules_text";s:6:"module";s:5:"rules";}s:5:"token";a:5:{s:5:"label";s:10:"text token";s:6:"parent";s:4:"text";s:8:"ui class";s:20:"RulesDataUITextToken";s:10:"token type";s:11:"rules_token";s:6:"module";s:5:"rules";}s:14:"text_formatted";a:5:{s:5:"label";s:14:"formatted text";s:8:"ui class";s:24:"RulesDataUITextFormatted";s:4:"wrap";b:1;s:13:"property info";a:3:{s:5:"value";a:7:{s:4:"type";s:4:"text";s:5:"label";s:4:"Text";s:9:"sanitized";b:1;s:15:"getter callback";s:30:"entity_metadata_field_text_get";s:15:"setter callback";s:28:"entity_property_verbatim_set";s:17:"setter permission";s:16:"administer nodes";s:19:"raw getter callback";s:28:"entity_property_verbatim_get";}s:7:"summary";a:7:{s:4:"type";s:4:"text";s:5:"label";s:7:"Summary";s:9:"sanitized";b:1;s:15:"getter callback";s:30:"entity_metadata_field_text_get";s:15:"setter callback";s:28:"entity_property_verbatim_set";s:17:"setter permission";s:16:"administer nodes";s:19:"raw getter callback";s:28:"entity_property_verbatim_get";}s:6:"format";a:6:{s:4:"type";s:5:"token";s:5:"label";s:11:"Text format";s:12:"options list";s:34:"entity_metadata_field_text_formats";s:15:"getter callback";s:28:"entity_property_verbatim_get";s:15:"setter callback";s:28:"entity_property_verbatim_set";s:18:"setter permissions";s:18:"administer filters";}}s:6:"module";s:5:"rules";}s:7:"decimal";a:5:{s:5:"label";s:14:"decimal number";s:6:"parent";s:4:"text";s:8:"ui class";s:18:"RulesDataUIDecimal";s:10:"token type";s:13:"rules_decimal";s:6:"module";s:5:"rules";}s:7:"integer";a:6:{s:5:"label";s:7:"integer";s:5:"class";s:19:"RulesIntegerWrapper";s:6:"parent";s:7:"decimal";s:8:"ui class";s:18:"RulesDataUIInteger";s:10:"token type";s:13:"rules_integer";s:6:"module";s:5:"rules";}s:4:"date";a:4:{s:5:"label";s:4:"date";s:8:"ui class";s:15:"RulesDataUIDate";s:10:"token type";s:10:"rules_date";s:6:"module";s:5:"rules";}s:8:"duration";a:5:{s:5:"label";s:8:"duration";s:6:"parent";s:7:"integer";s:8:"ui class";s:19:"RulesDataUIDuration";s:10:"token type";s:14:"rules_duration";s:6:"module";s:5:"rules";}s:7:"boolean";a:4:{s:5:"label";s:11:"truth value";s:8:"ui class";s:18:"RulesDataUIBoolean";s:10:"token type";s:13:"rules_boolean";s:6:"module";s:5:"rules";}s:3:"uri";a:6:{s:5:"label";s:3:"URI";s:6:"parent";s:4:"text";s:17:"cleaning callback";s:12:"rawurlencode";s:8:"ui class";s:14:"RulesDataUIURI";s:10:"token type";s:9:"rules_uri";s:6:"module";s:5:"rules";}s:4:"list";a:4:{s:5:"label";s:4:"list";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:6:"module";s:5:"rules";}s:10:"list<text>";a:5:{s:5:"label";s:12:"list of text";s:8:"ui class";s:19:"RulesDataUIListText";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:6:"module";s:5:"rules";}s:13:"list<integer>";a:5:{s:5:"label";s:15:"list of integer";s:8:"ui class";s:22:"RulesDataUIListInteger";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:6:"module";s:5:"rules";}s:11:"list<token>";a:5:{s:5:"label";s:19:"list of text tokens";s:8:"ui class";s:20:"RulesDataUIListToken";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:6:"module";s:5:"rules";}s:6:"entity";a:4:{s:5:"label";s:10:"any entity";s:5:"group";s:6:"Entity";s:10:"is wrapped";b:1;s:6:"module";s:5:"rules";}s:10:"ip_address";a:5:{s:5:"label";s:10:"IP Address";s:6:"parent";s:4:"text";s:8:"ui class";s:20:"RulesDataUIIPAddress";s:10:"token type";s:10:"rules_text";s:6:"module";s:5:"rules";}s:7:"comment";a:6:{s:5:"label";s:7:"comment";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:8:"activity";a:6:{s:5:"label";s:8:"activity";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:12:"activity_log";a:6:{s:5:"label";s:12:"activity Log";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:22:"activity_log_reference";a:6:{s:5:"label";s:22:"activity Log Reference";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:5:"badge";a:6:{s:5:"label";s:5:"badge";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:6:"branch";a:6:{s:5:"label";s:6:"branch";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:14:"drawing_ticket";a:6:{s:5:"label";s:14:"drawing Ticket";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:5:"level";a:6:{s:5:"label";s:5:"level";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:11:"nag_message";a:6:{s:5:"label";s:11:"nag Message";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:6:"points";a:6:{s:5:"label";s:6:"points";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:5:"prize";a:6:{s:5:"label";s:5:"prize";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:7:"program";a:6:{s:5:"label";s:7:"program";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:6:"reader";a:6:{s:5:"label";s:6:"reader";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:19:"reader_activity_log";a:6:{s:5:"label";s:19:"reader Activity Log";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:12:"reader_badge";a:6:{s:5:"label";s:12:"reader Badge";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:10:"reader_log";a:6:{s:5:"label";s:10:"reader Log";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:12:"reader_prize";a:6:{s:5:"label";s:12:"reader Prize";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:13:"reader_ticket";a:6:{s:5:"label";s:13:"reader Ticket";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:11:"reading_log";a:6:{s:5:"label";s:11:"reading Log";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:6:"school";a:6:{s:5:"label";s:6:"school";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:10:"entityform";a:6:{s:5:"label";s:21:"entityform Submission";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:15:"entityform_type";a:6:{s:5:"label";s:15:"entityform Type";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:23:"RulesDataUIBundleEntity";s:6:"module";s:5:"rules";}s:12:"entity_block";a:6:{s:5:"label";s:12:"entity block";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:21:"field_collection_item";a:6:{s:5:"label";s:21:"field collection item";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:4:"node";a:6:{s:5:"label";s:4:"node";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:4:"file";a:6:{s:5:"label";s:4:"file";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:13:"taxonomy_term";a:6:{s:5:"label";s:13:"taxonomy term";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:19:"taxonomy_vocabulary";a:7:{s:5:"label";s:19:"taxonomy vocabulary";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:29:"RulesDataUITaxonomyVocabulary";s:13:"wrapper class";s:30:"RulesTaxonomyVocabularyWrapper";s:6:"module";s:5:"rules";}s:4:"user";a:6:{s:5:"label";s:4:"user";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:8:"Workflow";a:6:{s:5:"label";s:8:"workflow";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:23:"RulesDataUIBundleEntity";s:6:"module";s:5:"rules";}s:13:"WorkflowState";a:6:{s:5:"label";s:14:"workflow state";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:24:"WorkflowConfigTransition";a:6:{s:5:"label";s:26:"workflow config transition";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:18:"WorkflowTransition";a:6:{s:5:"label";s:28:"workflow executed transition";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:27:"WorkflowScheduledTransition";a:6:{s:5:"label";s:29:"workflow scheduled transition";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:15:"wysiwyg_profile";a:6:{s:5:"label";s:15:"wysiwyg profile";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:17:"RulesDataUIEntity";s:6:"module";s:5:"rules";}s:12:"rules_config";a:6:{s:5:"label";s:19:"rules configuration";s:6:"parent";s:6:"entity";s:4:"wrap";b:1;s:5:"group";s:6:"Entity";s:8:"ui class";s:27:"RulesDataUIEntityExportable";s:6:"module";s:5:"rules";}s:18:"list<feeds_source>";a:3:{s:5:"label";s:26:"list of Feeds source items";s:4:"wrap";b:1;s:5:"group";s:4:"List";}s:15:"list<log_entry>";a:3:{s:5:"label";s:32:"list of watchdog log entry items";s:4:"wrap";b:1;s:5:"group";s:4:"List";}s:20:"list<text_formatted>";a:3:{s:5:"label";s:28:"list of formatted text items";s:4:"wrap";b:1;s:5:"group";s:4:"List";}s:13:"list<decimal>";a:3:{s:5:"label";s:28:"list of decimal number items";s:4:"wrap";b:1;s:5:"group";s:4:"List";}s:10:"list<date>";a:3:{s:5:"label";s:18:"list of date items";s:4:"wrap";b:1;s:5:"group";s:4:"List";}s:14:"list<duration>";a:3:{s:5:"label";s:22:"list of duration items";s:4:"wrap";b:1;s:5:"group";s:4:"List";}s:13:"list<boolean>";a:3:{s:5:"label";s:25:"list of truth value items";s:4:"wrap";b:1;s:5:"group";s:4:"List";}s:9:"list<uri>";a:3:{s:5:"label";s:17:"list of URI items";s:4:"wrap";b:1;s:5:"group";s:4:"List";}s:10:"list<list>";a:3:{s:5:"label";s:18:"list of list items";s:4:"wrap";b:1;s:5:"group";s:4:"List";}s:12:"list<entity>";a:3:{s:5:"label";s:24:"list of any entity items";s:4:"wrap";b:1;s:5:"group";s:4:"List";}s:16:"list<ip_address>";a:3:{s:5:"label";s:24:"list of IP Address items";s:4:"wrap";b:1;s:5:"group";s:4:"List";}s:13:"list<comment>";a:4:{s:5:"label";s:21:"list of comment items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:14:"list<activity>";a:4:{s:5:"label";s:22:"list of activity items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:18:"list<activity_log>";a:4:{s:5:"label";s:26:"list of activity Log items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:28:"list<activity_log_reference>";a:4:{s:5:"label";s:36:"list of activity Log Reference items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:11:"list<badge>";a:4:{s:5:"label";s:19:"list of badge items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:12:"list<branch>";a:4:{s:5:"label";s:20:"list of branch items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:20:"list<drawing_ticket>";a:4:{s:5:"label";s:28:"list of drawing Ticket items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:11:"list<level>";a:4:{s:5:"label";s:19:"list of level items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:17:"list<nag_message>";a:4:{s:5:"label";s:25:"list of nag Message items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:12:"list<points>";a:4:{s:5:"label";s:20:"list of points items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:11:"list<prize>";a:4:{s:5:"label";s:19:"list of prize items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:13:"list<program>";a:4:{s:5:"label";s:21:"list of program items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:12:"list<reader>";a:4:{s:5:"label";s:20:"list of reader items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:25:"list<reader_activity_log>";a:4:{s:5:"label";s:33:"list of reader Activity Log items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:18:"list<reader_badge>";a:4:{s:5:"label";s:26:"list of reader Badge items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:16:"list<reader_log>";a:4:{s:5:"label";s:24:"list of reader Log items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:18:"list<reader_prize>";a:4:{s:5:"label";s:26:"list of reader Prize items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:19:"list<reader_ticket>";a:4:{s:5:"label";s:27:"list of reader Ticket items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:17:"list<reading_log>";a:4:{s:5:"label";s:25:"list of reading Log items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:12:"list<school>";a:4:{s:5:"label";s:20:"list of school items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:16:"list<entityform>";a:4:{s:5:"label";s:35:"list of entityform Submission items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:21:"list<entityform_type>";a:4:{s:5:"label";s:29:"list of entityform Type items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:18:"list<entity_block>";a:4:{s:5:"label";s:26:"list of entity block items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:27:"list<field_collection_item>";a:4:{s:5:"label";s:35:"list of field collection item items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:10:"list<node>";a:4:{s:5:"label";s:18:"list of node items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:10:"list<file>";a:4:{s:5:"label";s:18:"list of file items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:19:"list<taxonomy_term>";a:4:{s:5:"label";s:27:"list of taxonomy term items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:25:"list<taxonomy_vocabulary>";a:4:{s:5:"label";s:33:"list of taxonomy vocabulary items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:10:"list<user>";a:4:{s:5:"label";s:18:"list of user items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:14:"list<Workflow>";a:4:{s:5:"label";s:22:"list of workflow items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:19:"list<WorkflowState>";a:4:{s:5:"label";s:28:"list of workflow state items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:30:"list<WorkflowConfigTransition>";a:4:{s:5:"label";s:40:"list of workflow config transition items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:24:"list<WorkflowTransition>";a:4:{s:5:"label";s:42:"list of workflow executed transition items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:33:"list<WorkflowScheduledTransition>";a:4:{s:5:"label";s:43:"list of workflow scheduled transition items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:21:"list<wysiwyg_profile>";a:4:{s:5:"label";s:29:"list of wysiwyg profile items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}s:18:"list<rules_config>";a:4:{s:5:"label";s:33:"list of rules configuration items";s:4:"wrap";b:1;s:5:"group";s:4:"List";s:8:"ui class";s:21:"RulesDataUIListEntity";}}s:11:"plugin_info";a:18:{s:11:"conditional";a:5:{s:5:"label";s:11:"Conditional";s:5:"class";s:16:"RulesConditional";s:10:"embeddable";s:20:"RulesActionContainer";s:6:"module";s:17:"rules_conditional";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:13:"form_validate";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:11:"form_submit";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:12:"buildContent";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:4:"help";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:10:"operations";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:2:"if";a:6:{s:5:"label";s:2:"If";s:5:"class";s:18:"RulesConditionalIf";s:10:"embeddable";s:16:"RulesConditional";s:11:"import keys";a:2:{i:0;s:2:"IF";i:1;s:7:"ELSE IF";}s:6:"module";s:17:"rules_conditional";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:27:"RulesConditionalPredicateUI";}s:13:"form_validate";a:1:{i:1;s:27:"RulesConditionalPredicateUI";}s:11:"form_submit";a:1:{i:1;s:27:"RulesConditionalPredicateUI";}s:12:"buildContent";a:1:{i:1;s:27:"RulesConditionalPredicateUI";}s:4:"help";a:1:{i:1;s:27:"RulesConditionalPredicateUI";}s:10:"operations";a:1:{i:1;s:27:"RulesConditionalPredicateUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:4:"else";a:7:{s:5:"label";s:4:"Else";s:5:"class";s:20:"RulesConditionalElse";s:10:"embeddable";s:16:"RulesConditional";s:18:"conditional single";b:1;s:19:"conditional depends";a:1:{i:0;s:2:"if";}s:6:"module";s:17:"rules_conditional";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:13:"form_validate";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:11:"form_submit";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:12:"buildContent";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:4:"help";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:10:"operations";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:6:"switch";a:5:{s:5:"label";s:6:"Switch";s:5:"class";s:22:"RulesConditionalSwitch";s:10:"embeddable";s:20:"RulesActionContainer";s:6:"module";s:17:"rules_conditional";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:24:"RulesConditionalPluginUI";}s:13:"form_validate";a:1:{i:1;s:24:"RulesConditionalPluginUI";}s:11:"form_submit";a:1:{i:1;s:24:"RulesConditionalPluginUI";}s:12:"buildContent";a:1:{i:1;s:24:"RulesConditionalPluginUI";}s:4:"help";a:1:{i:1;s:24:"RulesConditionalPluginUI";}s:10:"operations";a:1:{i:1;s:24:"RulesConditionalPluginUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:4:"case";a:5:{s:5:"label";s:4:"Case";s:5:"class";s:20:"RulesConditionalCase";s:10:"embeddable";s:22:"RulesConditionalSwitch";s:6:"module";s:17:"rules_conditional";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:22:"RulesConditionalCaseUI";}s:13:"form_validate";a:1:{i:1;s:22:"RulesConditionalCaseUI";}s:11:"form_submit";a:1:{i:1;s:22:"RulesConditionalCaseUI";}s:12:"buildContent";a:1:{i:1;s:22:"RulesConditionalCaseUI";}s:4:"help";a:1:{i:1;s:22:"RulesConditionalCaseUI";}s:10:"operations";a:1:{i:1;s:22:"RulesConditionalCaseUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:12:"default case";a:7:{s:5:"label";s:12:"Default case";s:5:"class";s:27:"RulesConditionalDefaultCase";s:10:"embeddable";s:22:"RulesConditionalSwitch";s:18:"conditional single";b:1;s:19:"conditional depends";a:1:{i:0;s:4:"case";}s:6:"module";s:17:"rules_conditional";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:13:"form_validate";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:11:"form_submit";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:12:"buildContent";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:4:"help";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}s:10:"operations";a:1:{i:1;s:23:"RulesConditionalEmptyUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:5:"while";a:5:{s:5:"label";s:5:"While";s:5:"class";s:21:"RulesConditionalWhile";s:10:"embeddable";s:20:"RulesActionContainer";s:6:"module";s:17:"rules_conditional";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:23:"RulesConditionalWhileUI";}s:13:"form_validate";a:1:{i:1;s:23:"RulesConditionalWhileUI";}s:11:"form_submit";a:1:{i:1;s:23:"RulesConditionalWhileUI";}s:12:"buildContent";a:1:{i:1;s:23:"RulesConditionalWhileUI";}s:4:"help";a:1:{i:1;s:23:"RulesConditionalWhileUI";}s:10:"operations";a:1:{i:1;s:23:"RulesConditionalWhileUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:18:"rule condition set";a:6:{s:5:"label";s:20:"Condition set (rule)";s:5:"class";s:16:"RuleConditionSet";s:10:"embeddable";b:0;s:9:"component";b:1;s:6:"module";s:17:"rules_conditional";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:18:"RuleConditionSetUI";}s:13:"form_validate";a:1:{i:1;s:18:"RuleConditionSetUI";}s:11:"form_submit";a:1:{i:1;s:18:"RuleConditionSetUI";}s:12:"buildContent";a:1:{i:1;s:18:"RuleConditionSetUI";}s:4:"help";a:1:{i:1;s:18:"RuleConditionSetUI";}s:10:"operations";a:1:{i:1;s:18:"RuleConditionSetUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:9:"condition";a:4:{s:5:"class";s:14:"RulesCondition";s:10:"embeddable";s:23:"RulesConditionContainer";s:6:"module";s:5:"rules";s:11:"faces_cache";a:3:{i:0;a:15:{s:7:"execute";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:8:"validate";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:7:"process";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:10:"info_alter";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:6:"access";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:12:"dependencies";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:10:"form_alter";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:10:"assertions";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:15:"features_export";a:1:{i:0;s:47:"rules_features_abstract_default_features_export";}s:4:"form";a:1:{i:1;s:21:"RulesAbstractPluginUI";}s:13:"form_validate";a:1:{i:1;s:21:"RulesAbstractPluginUI";}s:11:"form_submit";a:1:{i:1;s:21:"RulesAbstractPluginUI";}s:12:"buildContent";a:1:{i:1;s:21:"RulesAbstractPluginUI";}s:4:"help";a:1:{i:1;s:21:"RulesAbstractPluginUI";}s:10:"operations";a:1:{i:1;s:21:"RulesAbstractPluginUI";}}i:1;a:0:{}i:2;a:4:{s:24:"RulesPluginImplInterface";s:24:"RulesPluginImplInterface";s:27:"RulesPluginHandlerInterface";s:27:"RulesPluginHandlerInterface";s:38:"RulesPluginFeaturesIntegrationInterace";s:38:"RulesPluginFeaturesIntegrationInterace";s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:6:"action";a:4:{s:5:"class";s:11:"RulesAction";s:10:"embeddable";s:20:"RulesActionContainer";s:6:"module";s:5:"rules";s:11:"faces_cache";a:3:{i:0;a:15:{s:7:"execute";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:8:"validate";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:7:"process";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:10:"info_alter";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:6:"access";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:12:"dependencies";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:10:"form_alter";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:10:"assertions";a:1:{i:1;s:27:"RulesAbstractPluginDefaults";}s:15:"features_export";a:1:{i:0;s:47:"rules_features_abstract_default_features_export";}s:4:"form";a:1:{i:1;s:21:"RulesAbstractPluginUI";}s:13:"form_validate";a:1:{i:1;s:21:"RulesAbstractPluginUI";}s:11:"form_submit";a:1:{i:1;s:21:"RulesAbstractPluginUI";}s:12:"buildContent";a:1:{i:1;s:21:"RulesAbstractPluginUI";}s:4:"help";a:1:{i:1;s:21:"RulesAbstractPluginUI";}s:10:"operations";a:1:{i:1;s:21:"RulesAbstractPluginUI";}}i:1;a:0:{}i:2;a:4:{s:24:"RulesPluginImplInterface";s:24:"RulesPluginImplInterface";s:27:"RulesPluginHandlerInterface";s:27:"RulesPluginHandlerInterface";s:38:"RulesPluginFeaturesIntegrationInterace";s:38:"RulesPluginFeaturesIntegrationInterace";s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:2:"or";a:6:{s:5:"label";s:18:"Condition set (OR)";s:5:"class";s:7:"RulesOr";s:10:"embeddable";s:23:"RulesConditionContainer";s:9:"component";b:1;s:6:"module";s:5:"rules";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:25:"RulesConditionContainerUI";}s:13:"form_validate";a:1:{i:1;s:25:"RulesConditionContainerUI";}s:11:"form_submit";a:1:{i:1;s:25:"RulesConditionContainerUI";}s:12:"buildContent";a:1:{i:1;s:25:"RulesConditionContainerUI";}s:4:"help";a:1:{i:1;s:25:"RulesConditionContainerUI";}s:10:"operations";a:1:{i:1;s:25:"RulesConditionContainerUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:3:"and";a:6:{s:5:"label";s:19:"Condition set (AND)";s:5:"class";s:8:"RulesAnd";s:10:"embeddable";s:23:"RulesConditionContainer";s:9:"component";b:1;s:6:"module";s:5:"rules";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:25:"RulesConditionContainerUI";}s:13:"form_validate";a:1:{i:1;s:25:"RulesConditionContainerUI";}s:11:"form_submit";a:1:{i:1;s:25:"RulesConditionContainerUI";}s:12:"buildContent";a:1:{i:1;s:25:"RulesConditionContainerUI";}s:4:"help";a:1:{i:1;s:25:"RulesConditionContainerUI";}s:10:"operations";a:1:{i:1;s:25:"RulesConditionContainerUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:10:"action set";a:6:{s:5:"label";s:10:"Action set";s:5:"class";s:14:"RulesActionSet";s:10:"embeddable";b:0;s:9:"component";b:1;s:6:"module";s:5:"rules";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:22:"RulesActionContainerUI";}s:13:"form_validate";a:1:{i:1;s:22:"RulesActionContainerUI";}s:11:"form_submit";a:1:{i:1;s:22:"RulesActionContainerUI";}s:12:"buildContent";a:1:{i:1;s:22:"RulesActionContainerUI";}s:4:"help";a:1:{i:1;s:22:"RulesActionContainerUI";}s:10:"operations";a:1:{i:1;s:22:"RulesActionContainerUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:4:"rule";a:6:{s:5:"label";s:4:"Rule";s:5:"class";s:4:"Rule";s:10:"embeddable";s:12:"RulesRuleSet";s:9:"component";b:1;s:6:"module";s:5:"rules";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:11:"RulesRuleUI";}s:13:"form_validate";a:1:{i:1;s:11:"RulesRuleUI";}s:11:"form_submit";a:1:{i:1;s:11:"RulesRuleUI";}s:12:"buildContent";a:1:{i:1;s:11:"RulesRuleUI";}s:4:"help";a:1:{i:1;s:11:"RulesRuleUI";}s:10:"operations";a:1:{i:1;s:11:"RulesRuleUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:4:"loop";a:4:{s:5:"class";s:9:"RulesLoop";s:10:"embeddable";s:20:"RulesActionContainer";s:6:"module";s:5:"rules";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:11:"RulesLoopUI";}s:13:"form_validate";a:1:{i:1;s:11:"RulesLoopUI";}s:11:"form_submit";a:1:{i:1;s:11:"RulesLoopUI";}s:12:"buildContent";a:1:{i:1;s:11:"RulesLoopUI";}s:4:"help";a:1:{i:1;s:11:"RulesLoopUI";}s:10:"operations";a:1:{i:1;s:11:"RulesLoopUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:13:"reaction rule";a:4:{s:5:"class";s:17:"RulesReactionRule";s:10:"embeddable";b:0;s:6:"module";s:5:"rules";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:19:"RulesReactionRuleUI";}s:13:"form_validate";a:1:{i:1;s:19:"RulesReactionRuleUI";}s:11:"form_submit";a:1:{i:1;s:19:"RulesReactionRuleUI";}s:12:"buildContent";a:1:{i:1;s:19:"RulesReactionRuleUI";}s:4:"help";a:1:{i:1;s:19:"RulesReactionRuleUI";}s:10:"operations";a:1:{i:1;s:19:"RulesReactionRuleUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}s:9:"event set";a:3:{s:5:"class";s:13:"RulesEventSet";s:10:"embeddable";b:0;s:6:"module";s:5:"rules";}s:8:"rule set";a:6:{s:5:"label";s:8:"Rule set";s:5:"class";s:12:"RulesRuleSet";s:9:"component";b:1;s:10:"embeddable";b:0;s:6:"module";s:5:"rules";s:11:"faces_cache";a:3:{i:0;a:6:{s:4:"form";a:1:{i:1;s:14:"RulesRuleSetUI";}s:13:"form_validate";a:1:{i:1;s:14:"RulesRuleSetUI";}s:11:"form_submit";a:1:{i:1;s:14:"RulesRuleSetUI";}s:12:"buildContent";a:1:{i:1;s:14:"RulesRuleSetUI";}s:4:"help";a:1:{i:1;s:14:"RulesRuleSetUI";}s:10:"operations";a:1:{i:1;s:14:"RulesRuleSetUI";}}i:1;a:0:{}i:2;a:1:{s:22:"RulesPluginUIInterface";s:22:"RulesPluginUIInterface";}}}}s:14:"condition_info";a:20:{s:44:"views_bulk_operations_condition_result_count";a:6:{s:5:"label";s:46:"Check number of results returned by a VBO View";s:9:"parameter";a:3:{s:4:"view";a:5:{s:4:"type";s:4:"text";s:5:"label";s:16:"View and display";s:12:"options list";s:32:"views_bulk_operations_views_list";s:11:"description";s:49:"Select the VBO view and display you want to check";s:11:"restriction";s:5:"input";}s:4:"args";a:4:{s:4:"type";s:4:"text";s:5:"label";s:9:"Arguments";s:11:"description";s:98:"Any arguments to pass to the view, one per line.\n          You may use token replacement patterns.";s:8:"optional";b:1;}s:7:"minimum";a:3:{s:4:"type";s:7:"integer";s:5:"label";s:25:"Minimum number of results";s:11:"description";s:91:"This condition returns TRUE if the view has at\n          least the given number of results.";}}s:5:"group";s:21:"Views Bulk Operations";s:6:"module";s:21:"views_bulk_operations";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:44:"views_bulk_operations_condition_result_count";}}i:1;a:1:{s:7:"execute";s:27:"views_bulk_operations.rules";}}}}s:7:"data_is";a:6:{s:5:"label";s:15:"Data comparison";s:9:"parameter";a:3:{s:4:"data";a:4:{s:4:"type";s:1:"*";s:5:"label";s:15:"Data to compare";s:11:"description";s:85:"The data to be compared, specified by using a data selector, e.g. "node:author:name".";s:10:"allow null";b:1;}s:2:"op";a:7:{s:4:"type";s:4:"text";s:5:"label";s:8:"Operator";s:11:"description";s:24:"The comparison operator.";s:8:"optional";b:1;s:13:"default value";s:2:"==";s:12:"options list";s:40:"rules_condition_data_is_operator_options";s:11:"restriction";s:5:"input";}s:5:"value";a:4:{s:4:"type";s:1:"*";s:5:"label";s:10:"Data value";s:11:"description";s:35:"The value to compare the data with.";s:10:"allow null";b:1;}}s:5:"group";s:4:"Data";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:2:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:4:{s:7:"execute";a:1:{i:0;s:23:"rules_condition_data_is";}s:10:"info_alter";a:1:{i:0;s:34:"rules_condition_data_is_info_alter";}s:10:"form_alter";a:1:{i:0;s:34:"rules_condition_data_is_form_alter";}s:10:"assertions";a:1:{i:0;s:34:"rules_condition_data_is_assertions";}}i:1;a:4:{s:7:"execute";s:17:"modules/data.eval";s:10:"info_alter";s:17:"modules/data.eval";s:10:"form_alter";s:18:"modules/data.rules";s:10:"assertions";s:18:"modules/data.rules";}}s:22:"RulesPluginUIInterface";a:2:{i:0;a:1:{s:4:"help";a:1:{i:0;s:28:"rules_condition_data_is_help";}}i:1;a:1:{s:4:"help";s:18:"modules/data.rules";}}}}s:13:"data_is_empty";a:6:{s:5:"label";s:19:"Data value is empty";s:9:"parameter";a:1:{s:4:"data";a:5:{s:4:"type";s:1:"*";s:5:"label";s:13:"Data to check";s:11:"description";s:96:"The data to be checked to be empty, specified by using a data selector, e.g. "node:author:name".";s:10:"allow null";b:1;s:7:"wrapped";b:1;}}s:5:"group";s:4:"Data";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:29:"rules_condition_data_is_empty";}}i:1;a:1:{s:7:"execute";s:17:"modules/data.eval";}}}}s:13:"list_contains";a:6:{s:5:"label";s:18:"List contains item";s:9:"parameter";a:2:{s:4:"list";a:3:{s:4:"type";s:4:"list";s:5:"label";s:4:"List";s:11:"restriction";s:8:"selector";}s:4:"item";a:3:{s:4:"type";s:7:"unknown";s:5:"label";s:4:"Item";s:11:"description";s:22:"The item to check for.";}}s:5:"group";s:4:"Data";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:3:{s:7:"execute";a:1:{i:0;s:34:"rules_condition_data_list_contains";}s:10:"info_alter";a:1:{i:0;s:26:"rules_data_list_info_alter";}s:10:"form_alter";a:1:{i:0;s:26:"rules_data_list_form_alter";}}i:1;a:3:{s:7:"execute";s:17:"modules/data.eval";s:10:"info_alter";s:17:"modules/data.eval";s:10:"form_alter";s:18:"modules/data.rules";}}}}s:13:"list_count_is";a:6:{s:5:"label";s:21:"List count comparison";s:9:"parameter";a:3:{s:4:"list";a:3:{s:4:"type";s:4:"list";s:5:"label";s:13:"List to check";s:11:"description";s:112:"A multi value data element to have its count compared, specified by using a data selector, eg node:author:roles.";}s:2:"op";a:7:{s:4:"type";s:4:"text";s:5:"label";s:8:"Operator";s:11:"description";s:24:"The comparison operator.";s:8:"optional";b:1;s:13:"default value";s:2:"==";s:12:"options list";s:51:"rules_condition_data_list_count_is_operator_options";s:11:"restriction";s:5:"input";}s:5:"value";a:3:{s:4:"type";s:7:"integer";s:5:"label";s:5:"Count";s:11:"description";s:41:"The count to compare the data count with.";}}s:5:"group";s:4:"Data";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:34:"rules_condition_data_list_count_is";}}i:1;a:1:{s:7:"execute";s:17:"modules/data.eval";}}}}s:12:"text_matches";a:6:{s:5:"label";s:15:"Text comparison";s:9:"parameter";a:3:{s:4:"text";a:3:{s:4:"type";s:4:"text";s:5:"label";s:4:"Text";s:11:"restriction";s:8:"selector";}s:5:"match";a:2:{s:4:"type";s:4:"text";s:5:"label";s:13:"Matching text";}s:9:"operation";a:7:{s:4:"type";s:4:"text";s:5:"label";s:20:"Comparison operation";s:12:"options list";s:41:"rules_data_text_comparison_operation_list";s:11:"restriction";s:5:"input";s:13:"default value";s:8:"contains";s:8:"optional";b:1;s:11:"description";s:354:"In case the comparison operation regular expression is selected, the matching pattern will be interpreted as a <a href="http://en.wikipedia.org/wiki/Regular_expression">regular expression</a>.  Tip: <a href="http://gskinner.com/RegExr/">RegExr: Online Regular Expression Testing Tool</a> is helpful for learning, writing, and testing Regular Expressions.";}}s:5:"group";s:4:"Data";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:26:"rules_data_text_comparison";}}i:1;a:1:{s:7:"execute";s:17:"modules/data.eval";}}}}s:13:"entity_is_new";a:6:{s:5:"label";s:13:"Entity is new";s:9:"parameter";a:1:{s:6:"entity";a:4:{s:4:"type";s:6:"entity";s:5:"label";s:6:"Entity";s:11:"description";s:57:"Specifies the entity for which to evaluate the condition.";s:11:"restriction";s:8:"selector";}}s:5:"group";s:8:"Entities";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:2:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:29:"rules_condition_entity_is_new";}}i:1;a:1:{s:7:"execute";s:19:"modules/entity.eval";}}s:22:"RulesPluginUIInterface";a:2:{i:0;a:1:{s:4:"help";a:1:{i:0;s:34:"rules_condition_entity_is_new_help";}}i:1;a:1:{s:4:"help";s:20:"modules/entity.rules";}}}}s:16:"entity_has_field";a:6:{s:5:"label";s:16:"Entity has field";s:9:"parameter";a:2:{s:6:"entity";a:4:{s:4:"type";s:6:"entity";s:5:"label";s:6:"Entity";s:11:"description";s:57:"Specifies the entity for which to evaluate the condition.";s:11:"restriction";s:8:"selector";}s:5:"field";a:5:{s:4:"type";s:4:"text";s:5:"label";s:5:"Field";s:11:"description";s:35:"The name of the field to check for.";s:12:"options list";s:40:"rules_condition_entity_has_field_options";s:11:"restriction";s:5:"input";}}s:5:"group";s:8:"Entities";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:2:{s:7:"execute";a:1:{i:0;s:32:"rules_condition_entity_has_field";}s:10:"assertions";a:1:{i:0;s:43:"rules_condition_entity_has_field_assertions";}}i:1;a:2:{s:7:"execute";s:19:"modules/entity.eval";s:10:"assertions";s:20:"modules/entity.rules";}}}}s:17:"entity_is_of_type";a:6:{s:5:"label";s:17:"Entity is of type";s:9:"parameter";a:2:{s:6:"entity";a:3:{s:4:"type";s:6:"entity";s:5:"label";s:6:"Entity";s:11:"description";s:57:"Specifies the entity for which to evaluate the condition.";}s:4:"type";a:5:{s:4:"type";s:5:"token";s:5:"label";s:11:"Entity type";s:11:"description";s:29:"The entity type to check for.";s:12:"options list";s:32:"rules_entity_action_type_options";s:11:"restriction";s:5:"input";}}s:5:"group";s:8:"Entities";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:2:{s:7:"execute";a:1:{i:0;s:33:"rules_condition_entity_is_of_type";}s:10:"assertions";a:1:{i:0;s:44:"rules_condition_entity_is_of_type_assertions";}}i:1;a:2:{s:7:"execute";s:19:"modules/entity.eval";s:10:"assertions";s:20:"modules/entity.rules";}}}}s:19:"entity_is_of_bundle";a:6:{s:5:"label";s:19:"Entity is of bundle";s:9:"parameter";a:3:{s:6:"entity";a:3:{s:4:"type";s:6:"entity";s:5:"label";s:6:"Entity";s:11:"description";s:57:"Specifies the entity for which to evaluate the condition.";}s:4:"type";a:5:{s:4:"type";s:5:"token";s:5:"label";s:11:"Entity type";s:11:"description";s:31:"The type of the checked entity.";s:12:"options list";s:32:"rules_entity_action_type_options";s:11:"restriction";s:5:"input";}s:6:"bundle";a:5:{s:4:"type";s:10:"list<text>";s:5:"label";s:13:"Entity bundle";s:11:"description";s:69:"The condition is met if the entity is of one of the selected bundles.";s:12:"options list";s:27:"rules_entity_bundle_options";s:11:"restriction";s:5:"input";}}s:5:"group";s:8:"Entities";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:4:{s:7:"execute";a:1:{i:0;s:35:"rules_condition_entity_is_of_bundle";}s:7:"process";a:1:{i:0;s:43:"rules_condition_entity_is_of_bundle_process";}s:10:"form_alter";a:1:{i:0;s:46:"rules_condition_entity_is_of_bundle_form_alter";}s:10:"assertions";a:1:{i:0;s:46:"rules_condition_entity_is_of_bundle_assertions";}}i:1;a:4:{s:7:"execute";s:19:"modules/entity.eval";s:7:"process";s:20:"modules/entity.rules";s:10:"form_alter";s:20:"modules/entity.rules";s:10:"assertions";s:20:"modules/entity.rules";}}}}s:19:"entity_field_access";a:6:{s:5:"label";s:21:"User has field access";s:9:"parameter";a:4:{s:6:"entity";a:5:{s:4:"type";s:6:"entity";s:5:"label";s:6:"Entity";s:11:"description";s:57:"Specifies the entity for which to evaluate the condition.";s:11:"restriction";s:8:"selector";s:7:"wrapped";b:1;}s:5:"field";a:5:{s:4:"type";s:5:"token";s:5:"label";s:10:"Field name";s:11:"description";s:35:"The name of the field to check for.";s:12:"options list";s:40:"rules_condition_entity_has_field_options";s:11:"restriction";s:5:"input";}s:2:"op";a:6:{s:4:"type";s:4:"text";s:5:"label";s:16:"Access operation";s:12:"options list";s:46:"rules_condition_entity_field_access_op_options";s:11:"restriction";s:5:"input";s:8:"optional";b:1;s:13:"default value";s:4:"view";}s:7:"account";a:6:{s:4:"type";s:4:"user";s:5:"label";s:12:"User account";s:11:"description";s:111:"Specifies the user account for which to check access. If left empty, the currently logged in user will be used.";s:11:"restriction";s:8:"selector";s:8:"optional";b:1;s:13:"default value";N;}}s:5:"group";s:8:"Entities";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:35:"rules_condition_entity_field_access";}}i:1;a:1:{s:7:"execute";s:19:"modules/entity.eval";}}}}s:13:"user_has_role";a:7:{s:5:"label";s:16:"User has role(s)";s:9:"parameter";a:3:{s:7:"account";a:2:{s:4:"type";s:4:"user";s:5:"label";s:4:"User";}s:5:"roles";a:3:{s:4:"type";s:13:"list<integer>";s:5:"label";s:5:"Roles";s:12:"options list";s:29:"rules_user_roles_options_list";}s:9:"operation";a:7:{s:4:"type";s:4:"text";s:5:"label";s:11:"Match roles";s:12:"options list";s:31:"rules_user_condition_operations";s:11:"restriction";s:5:"input";s:8:"optional";b:1;s:13:"default value";s:3:"AND";s:11:"description";s:91:"If matching against all selected roles, the user must have <em>all</em> the roles selected.";}}s:5:"group";s:4:"User";s:15:"access callback";s:29:"rules_user_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:2:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:29:"rules_condition_user_has_role";}}i:1;a:1:{s:7:"execute";s:17:"modules/user.eval";}}s:22:"RulesPluginUIInterface";a:2:{i:0;a:1:{s:4:"help";a:1:{i:0;s:34:"rules_condition_user_has_role_help";}}i:1;a:1:{s:4:"help";s:18:"modules/user.rules";}}}}s:15:"user_is_blocked";a:7:{s:5:"label";s:15:"User is blocked";s:9:"parameter";a:1:{s:7:"account";a:2:{s:4:"type";s:4:"user";s:5:"label";s:4:"User";}}s:5:"group";s:4:"User";s:15:"access callback";s:29:"rules_user_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:31:"rules_condition_user_is_blocked";}}i:1;a:1:{s:7:"execute";s:17:"modules/user.eval";}}}}s:8:"php_eval";a:7:{s:5:"label";s:23:"Execute custom PHP code";s:5:"group";s:3:"PHP";s:9:"parameter";a:1:{s:4:"code";a:4:{s:11:"restriction";s:5:"input";s:4:"type";s:4:"text";s:5:"label";s:8:"PHP code";s:11:"description";s:132:"Enter PHP code without &lt;?php ?&gt; delimiters that returns a boolean value; e.g. <code>return arg(0) == &#039;node&#039;;</code>.";}}s:15:"access callback";s:28:"rules_php_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:4:{s:7:"execute";a:1:{i:0;s:22:"rules_execute_php_eval";}s:7:"process";a:1:{i:0;s:30:"rules_execute_php_eval_process";}s:12:"dependencies";a:1:{i:0;s:35:"rules_execute_php_eval_dependencies";}s:10:"form_alter";a:1:{i:0;s:33:"rules_execute_php_eval_form_alter";}}i:1;a:4:{s:7:"execute";s:16:"modules/php.eval";s:7:"process";s:17:"modules/php.rules";s:12:"dependencies";s:17:"modules/php.rules";s:10:"form_alter";s:17:"modules/php.rules";}}}}s:14:"path_has_alias";a:7:{s:5:"label";s:18:"Path has URL alias";s:5:"group";s:4:"Path";s:9:"parameter";a:2:{s:6:"source";a:4:{s:4:"type";s:4:"text";s:5:"label";s:20:"Existing system path";s:11:"description";s:100:"Specifies the existing path you wish to check for. For example: node/28, forum/1, taxonomy/term/1+2.";s:8:"optional";b:1;}s:8:"language";a:6:{s:4:"type";s:5:"token";s:5:"label";s:8:"Language";s:11:"description";s:59:"If specified, the language for which the URL alias applies.";s:12:"options list";s:29:"entity_metadata_language_list";s:8:"optional";b:1;s:13:"default value";s:3:"und";}}s:15:"access callback";s:29:"rules_path_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:2:{s:7:"execute";a:1:{i:0;s:30:"rules_condition_path_has_alias";}s:12:"dependencies";a:1:{i:0;s:23:"rules_path_dependencies";}}i:1;a:2:{s:7:"execute";s:17:"modules/path.eval";s:12:"dependencies";s:18:"modules/path.rules";}}}}s:17:"path_alias_exists";a:7:{s:5:"label";s:16:"URL alias exists";s:5:"group";s:4:"Path";s:9:"parameter";a:2:{s:5:"alias";a:5:{s:4:"type";s:4:"text";s:5:"label";s:9:"URL alias";s:11:"description";s:75:"Specify the URL alias to check for. For example, "about" for an about page.";s:8:"optional";b:1;s:17:"cleaning callback";s:35:"rules_path_clean_replacement_values";}s:8:"language";a:6:{s:4:"type";s:5:"token";s:5:"label";s:8:"Language";s:11:"description";s:59:"If specified, the language for which the URL alias applies.";s:12:"options list";s:29:"entity_metadata_language_list";s:8:"optional";b:1;s:13:"default value";s:3:"und";}}s:15:"access callback";s:29:"rules_path_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:2:{s:7:"execute";a:1:{i:0;s:33:"rules_condition_path_alias_exists";}s:12:"dependencies";a:1:{i:0;s:23:"rules_path_dependencies";}}i:1;a:2:{s:7:"execute";s:17:"modules/path.eval";s:12:"dependencies";s:18:"modules/path.rules";}}}}s:15:"node_is_of_type";a:10:{s:9:"parameter";a:2:{s:4:"node";a:2:{s:4:"type";s:4:"node";s:5:"label";s:7:"Content";}s:4:"type";a:5:{s:4:"type";s:10:"list<text>";s:5:"label";s:13:"Content types";s:12:"options list";s:19:"node_type_get_names";s:11:"description";s:33:"The content type(s) to check for.";s:11:"restriction";s:5:"input";}}s:8:"category";s:4:"node";s:15:"access callback";s:29:"rules_node_integration_access";s:4:"name";s:15:"node_is_of_type";s:5:"label";s:18:"Content is of type";s:4:"help";s:79:"Evaluates to TRUE if the given content is of one of the selected content types.";s:5:"class";s:22:"RulesNodeConditionType";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:0:{}}s:17:"node_is_published";a:9:{s:9:"parameter";a:1:{s:4:"node";a:2:{s:4:"type";s:4:"node";s:5:"label";s:7:"Content";}}s:8:"category";s:4:"node";s:15:"access callback";s:29:"rules_node_integration_access";s:4:"name";s:17:"node_is_published";s:5:"label";s:20:"Content is published";s:5:"class";s:27:"RulesNodeConditionPublished";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:0:{}}s:14:"node_is_sticky";a:9:{s:9:"parameter";a:1:{s:4:"node";a:2:{s:4:"type";s:4:"node";s:5:"label";s:7:"Content";}}s:8:"category";s:4:"node";s:15:"access callback";s:29:"rules_node_integration_access";s:4:"name";s:14:"node_is_sticky";s:5:"label";s:17:"Content is sticky";s:5:"class";s:24:"RulesNodeConditionSticky";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:0:{}}s:16:"node_is_promoted";a:9:{s:9:"parameter";a:1:{s:4:"node";a:2:{s:4:"type";s:4:"node";s:5:"label";s:7:"Content";}}s:8:"category";s:4:"node";s:15:"access callback";s:29:"rules_node_integration_access";s:4:"name";s:16:"node_is_promoted";s:5:"label";s:32:"Content is promoted to frontpage";s:5:"class";s:26:"RulesNodeConditionPromoted";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:0:{}}}s:11:"action_info";a:36:{s:15:"feeds_skip_item";a:7:{s:5:"label";s:25:"Skip import of feeds item";s:5:"group";s:5:"Feeds";s:9:"parameter";a:1:{s:6:"entity";a:2:{s:4:"type";s:6:"entity";s:5:"label";s:45:"The feeds import item to be marked as skipped";}}s:15:"access callback";s:27:"feeds_rules_access_callback";s:6:"module";s:5:"feeds";s:8:"provides";a:0:{}s:11:"faces_cache";a:2:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:22:"feeds_action_skip_item";}}i:1;a:1:{s:7:"execute";s:11:"feeds.rules";}}s:22:"RulesPluginUIInterface";a:2:{i:0;a:1:{s:4:"help";a:1:{i:0;s:27:"feeds_action_skip_item_help";}}i:1;a:1:{s:4:"help";s:11:"feeds.rules";}}}}s:38:"views_bulk_operations_action_load_list";a:6:{s:5:"label";s:46:"Load a list of entity objects from a VBO View.";s:9:"parameter";a:2:{s:4:"view";a:5:{s:4:"type";s:4:"text";s:5:"label";s:16:"View and display";s:12:"options list";s:32:"views_bulk_operations_views_list";s:11:"description";s:71:"Select the view and display you want to use to\n          create a list.";s:11:"restriction";s:5:"input";}s:4:"args";a:4:{s:4:"type";s:4:"text";s:5:"label";s:9:"Arguments";s:11:"description";s:98:"Any arguments to pass to the view, one per line.\n          You may use token replacement patterns.";s:8:"optional";b:1;}}s:8:"provides";a:1:{s:11:"entity_list";a:2:{s:4:"type";s:12:"list<entity>";s:5:"label";s:18:"A list of entities";}}s:5:"group";s:21:"Views Bulk Operations";s:6:"module";s:21:"views_bulk_operations";s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:2:{s:7:"execute";a:1:{i:0;s:38:"views_bulk_operations_action_load_list";}s:10:"info_alter";a:1:{i:0;s:49:"views_bulk_operations_action_load_list_info_alter";}}i:1;a:2:{s:7:"execute";s:27:"views_bulk_operations.rules";s:10:"info_alter";s:27:"views_bulk_operations.rules";}}}}s:41:"views_bulk_operations_action_load_id_list";a:6:{s:5:"label";s:42:"Load a list of entity ids from a VBO View.";s:9:"parameter";a:2:{s:4:"view";a:5:{s:4:"type";s:4:"text";s:5:"label";s:16:"View and display";s:12:"options list";s:32:"views_bulk_operations_views_list";s:11:"description";s:71:"Select the view and display you want to use to\n          create a list.";s:11:"restriction";s:5:"input";}s:4:"args";a:4:{s:4:"type";s:4:"text";s:5:"label";s:9:"Arguments";s:11:"description";s:98:"Any arguments to pass to the view, one per line.\n          You may use token replacement patterns.";s:8:"optional";b:1;}}s:8:"provides";a:1:{s:14:"entity_id_list";a:2:{s:4:"type";s:13:"list<integer>";s:5:"label";s:20:"A list of entity ids";}}s:5:"group";s:21:"Views Bulk Operations";s:6:"module";s:21:"views_bulk_operations";s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:41:"views_bulk_operations_action_load_id_list";}}i:1;a:1:{s:7:"execute";s:27:"views_bulk_operations.rules";}}}}s:8:"data_set";a:6:{s:5:"label";s:16:"Set a data value";s:9:"parameter";a:2:{s:4:"data";a:6:{s:4:"type";s:1:"*";s:5:"label";s:4:"Data";s:11:"description";s:81:"Specifies the data to be modified using a data selector, e.g. "node:author:name".";s:11:"restriction";s:8:"selector";s:7:"wrapped";b:1;s:10:"allow null";b:1;}s:5:"value";a:5:{s:4:"type";s:1:"*";s:5:"label";s:5:"Value";s:11:"description";s:44:"The new value to set for the specified data.";s:10:"allow null";b:1;s:8:"optional";b:1;}}s:5:"group";s:4:"Data";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:5:{s:7:"execute";a:1:{i:0;s:21:"rules_action_data_set";}s:8:"validate";a:1:{i:0;s:30:"rules_action_data_set_validate";}s:10:"info_alter";a:1:{i:0;s:32:"rules_action_data_set_info_alter";}s:6:"access";a:1:{i:0;s:28:"rules_action_data_set_access";}s:10:"form_alter";a:1:{i:0;s:32:"rules_action_data_set_form_alter";}}i:1;a:5:{s:7:"execute";s:17:"modules/data.eval";s:8:"validate";s:18:"modules/data.rules";s:10:"info_alter";s:17:"modules/data.eval";s:6:"access";s:18:"modules/data.rules";s:10:"form_alter";s:18:"modules/data.rules";}}}}s:9:"data_calc";a:6:{s:5:"label";s:17:"Calculate a value";s:9:"parameter";a:3:{s:7:"input_1";a:3:{s:4:"type";a:2:{i:0;s:7:"decimal";i:1;s:4:"date";}s:5:"label";s:13:"Input value 1";s:11:"description";s:42:"The first input value for the calculation.";}s:2:"op";a:6:{s:4:"type";s:4:"text";s:5:"label";s:8:"Operator";s:11:"description";s:25:"The calculation operator.";s:12:"options list";s:39:"rules_action_data_calc_operator_options";s:11:"restriction";s:5:"input";s:13:"default value";s:1:"+";}s:7:"input_2";a:3:{s:4:"type";s:7:"decimal";s:5:"label";s:13:"Input value 2";s:11:"description";s:23:"The second input value.";}}s:5:"group";s:4:"Data";s:8:"provides";a:1:{s:6:"result";a:2:{s:4:"type";s:7:"unknown";s:5:"label";s:18:"Calculation result";}}s:6:"module";s:5:"rules";s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:3:{s:7:"execute";a:1:{i:0;s:22:"rules_action_data_calc";}s:10:"info_alter";a:1:{i:0;s:33:"rules_action_data_calc_info_alter";}s:10:"form_alter";a:1:{i:0;s:33:"rules_action_data_calc_form_alter";}}i:1;a:3:{s:7:"execute";s:17:"modules/data.eval";s:10:"info_alter";s:17:"modules/data.eval";s:10:"form_alter";s:18:"modules/data.rules";}}}}s:8:"list_add";a:6:{s:5:"label";s:21:"Add an item to a list";s:9:"parameter";a:4:{s:4:"list";a:6:{s:4:"type";s:4:"list";s:5:"label";s:4:"List";s:11:"description";s:47:"The data list, to which an item is to be added.";s:11:"restriction";s:8:"selector";s:10:"allow null";b:1;s:4:"save";b:1;}s:4:"item";a:2:{s:4:"type";s:7:"unknown";s:5:"label";s:11:"Item to add";}s:6:"unique";a:5:{s:4:"type";s:7:"boolean";s:5:"label";s:18:"Enforce uniqueness";s:11:"description";s:57:"Only add the item to the list if it is not yet contained.";s:8:"optional";b:1;s:13:"default value";b:0;}s:3:"pos";a:5:{s:4:"type";s:4:"text";s:5:"label";s:15:"Insert position";s:8:"optional";b:1;s:13:"default value";s:3:"end";s:12:"options list";s:36:"rules_action_data_list_add_positions";}}s:5:"group";s:4:"Data";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:3:{s:7:"execute";a:1:{i:0;s:26:"rules_action_data_list_add";}s:10:"info_alter";a:1:{i:0;s:26:"rules_data_list_info_alter";}s:10:"form_alter";a:1:{i:0;s:26:"rules_data_list_form_alter";}}i:1;a:3:{s:7:"execute";s:17:"modules/data.eval";s:10:"info_alter";s:17:"modules/data.eval";s:10:"form_alter";s:18:"modules/data.rules";}}}}s:11:"list_remove";a:6:{s:5:"label";s:26:"Remove an item from a list";s:9:"parameter";a:2:{s:4:"list";a:5:{s:4:"type";s:4:"list";s:5:"label";s:4:"List";s:11:"description";s:49:"The data list for which an item is to be removed.";s:11:"restriction";s:8:"selector";s:4:"save";b:1;}s:4:"item";a:2:{s:4:"type";s:7:"unknown";s:5:"label";s:14:"Item to remove";}}s:5:"group";s:4:"Data";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:3:{s:7:"execute";a:1:{i:0;s:29:"rules_action_data_list_remove";}s:10:"info_alter";a:1:{i:0;s:26:"rules_data_list_info_alter";}s:10:"form_alter";a:1:{i:0;s:26:"rules_data_list_form_alter";}}i:1;a:3:{s:7:"execute";s:17:"modules/data.eval";s:10:"info_alter";s:17:"modules/data.eval";s:10:"form_alter";s:18:"modules/data.rules";}}}}s:12:"variable_add";a:7:{s:5:"label";s:14:"Add a variable";s:15:"named parameter";b:1;s:9:"parameter";a:2:{s:4:"type";a:5:{s:4:"type";s:4:"text";s:5:"label";s:4:"Type";s:12:"options list";s:38:"rules_data_action_variable_add_options";s:11:"description";s:56:"Specifies the type of the variable that should be added.";s:11:"restriction";s:5:"input";}s:5:"value";a:4:{s:4:"type";s:7:"unknown";s:5:"label";s:5:"Value";s:8:"optional";b:1;s:11:"description";s:54:"Optionally, specify the initial value of the variable.";}}s:8:"provides";a:1:{s:14:"variable_added";a:2:{s:4:"type";s:7:"unknown";s:5:"label";s:14:"Added variable";}}s:5:"group";s:4:"Data";s:6:"module";s:5:"rules";s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:4:{s:7:"execute";a:1:{i:0;s:25:"rules_action_variable_add";}s:8:"validate";a:1:{i:0;s:33:"rules_action_create_type_validate";}s:10:"info_alter";a:1:{i:0;s:36:"rules_action_variable_add_info_alter";}s:10:"form_alter";a:1:{i:0;s:28:"rules_action_type_form_alter";}}i:1;a:4:{s:7:"execute";s:17:"modules/data.eval";s:8:"validate";s:18:"modules/data.rules";s:10:"info_alter";s:17:"modules/data.eval";s:10:"form_alter";s:18:"modules/data.rules";}}}}s:12:"data_convert";a:7:{s:5:"label";s:17:"Convert data type";s:9:"parameter";a:3:{s:4:"type";a:5:{s:4:"type";s:5:"token";s:5:"label";s:11:"Target type";s:11:"description";s:36:"The data type to convert a value to.";s:12:"options list";s:39:"rules_action_data_convert_types_options";s:11:"restriction";s:5:"input";}s:5:"value";a:3:{s:4:"type";a:4:{i:0;s:7:"decimal";i:1;s:7:"integer";i:2;s:4:"text";i:3;s:5:"token";}s:5:"label";s:16:"Value to convert";s:12:"default mode";s:8:"selector";}s:17:"rounding_behavior";a:7:{s:4:"type";s:5:"token";s:5:"label";s:17:"Rounding behavior";s:11:"description";s:48:"The rounding behavior the conversion should use.";s:12:"options list";s:51:"rules_action_data_convert_rounding_behavior_options";s:11:"restriction";s:5:"input";s:13:"default value";s:5:"round";s:8:"optional";b:1;}}s:8:"provides";a:1:{s:17:"conversion_result";a:2:{s:4:"type";s:7:"unknown";s:5:"label";s:17:"Conversion result";}}s:5:"group";s:4:"Data";s:15:"named parameter";b:1;s:6:"module";s:5:"rules";s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:3:{s:7:"execute";a:1:{i:0;s:25:"rules_action_data_convert";}s:10:"info_alter";a:1:{i:0;s:36:"rules_action_data_convert_info_alter";}s:10:"form_alter";a:1:{i:0;s:28:"rules_action_type_form_alter";}}i:1;a:3:{s:7:"execute";s:17:"modules/data.eval";s:10:"info_alter";s:17:"modules/data.eval";s:10:"form_alter";s:18:"modules/data.rules";}}}}s:12:"entity_fetch";a:7:{s:5:"label";s:18:"Fetch entity by id";s:9:"parameter";a:2:{s:4:"type";a:5:{s:4:"type";s:4:"text";s:5:"label";s:11:"Entity type";s:12:"options list";s:32:"rules_entity_action_type_options";s:11:"description";s:52:"Specifies the type of entity that should be fetched.";s:11:"restriction";s:5:"input";}s:2:"id";a:2:{s:4:"type";s:7:"unknown";s:5:"label";s:10:"Identifier";}}s:8:"provides";a:1:{s:14:"entity_fetched";a:2:{s:4:"type";s:7:"unknown";s:5:"label";s:14:"Fetched entity";}}s:5:"group";s:8:"Entities";s:15:"access callback";s:26:"rules_entity_action_access";s:6:"module";s:5:"rules";s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:4:{s:7:"execute";a:1:{i:0;s:25:"rules_action_entity_fetch";}s:10:"info_alter";a:1:{i:0;s:36:"rules_action_entity_fetch_info_alter";}s:6:"access";a:1:{i:0;s:38:"rules_action_entity_createfetch_access";}s:10:"form_alter";a:1:{i:0;s:28:"rules_action_type_form_alter";}}i:1;a:4:{s:7:"execute";s:19:"modules/entity.eval";s:10:"info_alter";s:19:"modules/entity.eval";s:6:"access";s:20:"modules/entity.rules";s:10:"form_alter";s:18:"modules/data.rules";}}}}s:12:"entity_query";a:7:{s:5:"label";s:24:"Fetch entity by property";s:9:"parameter";a:4:{s:4:"type";a:5:{s:4:"type";s:4:"text";s:5:"label";s:11:"Entity type";s:12:"options list";s:32:"rules_entity_action_type_options";s:11:"description";s:56:"Specifies the type of the entity that should be fetched.";s:11:"restriction";s:5:"input";}s:8:"property";a:4:{s:4:"type";s:4:"text";s:5:"label";s:8:"Property";s:11:"description";s:51:"The property by which the entity is to be selected.";s:11:"restriction";s:5:"input";}s:5:"value";a:3:{s:4:"type";s:7:"unknown";s:5:"label";s:5:"Value";s:11:"description";s:47:"The property value of the entity to be fetched.";}s:5:"limit";a:5:{s:4:"type";s:7:"integer";s:5:"label";s:18:"Limit result count";s:11:"description";s:45:"Limit the maximum number of fetched entities.";s:8:"optional";b:1;s:13:"default value";s:2:"10";}}s:8:"provides";a:1:{s:14:"entity_fetched";a:2:{s:4:"type";s:4:"list";s:5:"label";s:14:"Fetched entity";}}s:5:"group";s:8:"Entities";s:15:"access callback";s:26:"rules_entity_action_access";s:6:"module";s:5:"rules";s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:4:{s:7:"execute";a:1:{i:0;s:25:"rules_action_entity_query";}s:10:"info_alter";a:1:{i:0;s:36:"rules_action_entity_query_info_alter";}s:6:"access";a:1:{i:0;s:32:"rules_action_entity_query_access";}s:10:"form_alter";a:1:{i:0;s:28:"rules_action_type_form_alter";}}i:1;a:4:{s:7:"execute";s:19:"modules/entity.eval";s:10:"info_alter";s:19:"modules/entity.eval";s:6:"access";s:20:"modules/entity.rules";s:10:"form_alter";s:18:"modules/data.rules";}}}}s:13:"entity_create";a:8:{s:5:"label";s:19:"Create a new entity";s:15:"named parameter";b:1;s:9:"parameter";a:1:{s:4:"type";a:5:{s:4:"type";s:4:"text";s:5:"label";s:11:"Entity type";s:12:"options list";s:32:"rules_entity_action_type_options";s:11:"description";s:56:"Specifies the type of the entity that should be created.";s:11:"restriction";s:5:"input";}}s:8:"provides";a:1:{s:14:"entity_created";a:3:{s:4:"type";s:7:"unknown";s:5:"label";s:14:"Created entity";s:4:"save";b:1;}}s:5:"group";s:8:"Entities";s:15:"access callback";s:26:"rules_entity_action_access";s:6:"module";s:5:"rules";s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:5:{s:7:"execute";a:1:{i:0;s:26:"rules_action_entity_create";}s:8:"validate";a:1:{i:0;s:33:"rules_action_create_type_validate";}s:10:"info_alter";a:1:{i:0;s:37:"rules_action_entity_create_info_alter";}s:6:"access";a:1:{i:0;s:38:"rules_action_entity_createfetch_access";}s:10:"form_alter";a:1:{i:0;s:28:"rules_action_type_form_alter";}}i:1;a:5:{s:7:"execute";s:19:"modules/entity.eval";s:8:"validate";s:18:"modules/data.rules";s:10:"info_alter";s:19:"modules/entity.eval";s:6:"access";s:20:"modules/entity.rules";s:10:"form_alter";s:18:"modules/data.rules";}}}}s:11:"entity_save";a:7:{s:5:"label";s:11:"Save entity";s:9:"parameter";a:2:{s:4:"data";a:5:{s:4:"type";s:6:"entity";s:5:"label";s:6:"Entity";s:11:"description";s:56:"Specifies the entity, which should be saved permanently.";s:11:"restriction";s:8:"selector";s:7:"wrapped";b:1;}s:9:"immediate";a:6:{s:4:"type";s:7:"boolean";s:5:"label";s:24:"Force saving immediately";s:11:"description";s:157:"Usually saving is postponed till the end of the evaluation, so that multiple saves can be fold into one. If this set, saving is forced to happen immediately.";s:13:"default value";b:0;s:8:"optional";b:1;s:11:"restriction";s:5:"input";}}s:5:"group";s:8:"Entities";s:15:"access callback";s:26:"rules_entity_action_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:2:{s:7:"execute";a:1:{i:0;s:24:"rules_action_entity_save";}s:6:"access";a:1:{i:0;s:37:"rules_action_entity_savedelete_access";}}i:1;a:2:{s:7:"execute";s:19:"modules/entity.eval";s:6:"access";s:20:"modules/entity.rules";}}}}s:13:"entity_delete";a:7:{s:5:"label";s:13:"Delete entity";s:9:"parameter";a:1:{s:4:"data";a:5:{s:4:"type";s:6:"entity";s:5:"label";s:6:"Entity";s:11:"description";s:58:"Specifies the entity, which should be deleted permanently.";s:11:"restriction";s:8:"selector";s:7:"wrapped";b:1;}}s:5:"group";s:8:"Entities";s:15:"access callback";s:26:"rules_entity_action_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:2:{s:7:"execute";a:1:{i:0;s:26:"rules_action_entity_delete";}s:6:"access";a:1:{i:0;s:37:"rules_action_entity_savedelete_access";}}i:1;a:2:{s:7:"execute";s:19:"modules/entity.eval";s:6:"access";s:20:"modules/entity.rules";}}}}s:12:"node_publish";a:7:{s:9:"parameter";a:1:{s:4:"node";a:3:{s:4:"type";s:4:"node";s:5:"label";s:7:"Content";s:4:"save";b:1;}}s:8:"category";s:4:"node";s:15:"access callback";s:23:"rules_node_admin_access";s:5:"label";s:15:"Publish content";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:19:"node_publish_action";}}i:1;a:0:{}}}}s:14:"node_unpublish";a:7:{s:9:"parameter";a:1:{s:4:"node";a:3:{s:4:"type";s:4:"node";s:5:"label";s:7:"Content";s:4:"save";b:1;}}s:8:"category";s:4:"node";s:15:"access callback";s:23:"rules_node_admin_access";s:5:"label";s:17:"Unpublish content";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:21:"node_unpublish_action";}}i:1;a:0:{}}}}s:16:"node_make_sticky";a:7:{s:9:"parameter";a:1:{s:4:"node";a:3:{s:4:"type";s:4:"node";s:5:"label";s:7:"Content";s:4:"save";b:1;}}s:8:"category";s:4:"node";s:15:"access callback";s:23:"rules_node_admin_access";s:5:"label";s:19:"Make content sticky";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:23:"node_make_sticky_action";}}i:1;a:0:{}}}}s:18:"node_make_unsticky";a:7:{s:9:"parameter";a:1:{s:4:"node";a:3:{s:4:"type";s:4:"node";s:5:"label";s:7:"Content";s:4:"save";b:1;}}s:8:"category";s:4:"node";s:15:"access callback";s:23:"rules_node_admin_access";s:5:"label";s:21:"Make content unsticky";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:25:"node_make_unsticky_action";}}i:1;a:0:{}}}}s:12:"node_promote";a:7:{s:9:"parameter";a:1:{s:4:"node";a:3:{s:4:"type";s:4:"node";s:5:"label";s:7:"Content";s:4:"save";b:1;}}s:8:"category";s:4:"node";s:15:"access callback";s:23:"rules_node_admin_access";s:5:"label";s:29:"Promote content to front page";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:19:"node_promote_action";}}i:1;a:0:{}}}}s:14:"node_unpromote";a:7:{s:9:"parameter";a:1:{s:4:"node";a:3:{s:4:"type";s:4:"node";s:5:"label";s:7:"Content";s:4:"save";b:1;}}s:8:"category";s:4:"node";s:15:"access callback";s:23:"rules_node_admin_access";s:5:"label";s:30:"Remove content from front page";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:21:"node_unpromote_action";}}i:1;a:0:{}}}}s:14:"drupal_message";a:7:{s:5:"label";s:26:"Show a message on the site";s:5:"group";s:6:"System";s:9:"parameter";a:3:{s:7:"message";a:4:{s:4:"type";s:4:"text";s:5:"label";s:7:"Message";s:8:"sanitize";b:1;s:12:"translatable";b:1;}s:4:"type";a:5:{s:4:"type";s:5:"token";s:5:"label";s:12:"Message type";s:12:"options list";s:33:"rules_action_drupal_message_types";s:13:"default value";s:6:"status";s:8:"optional";b:1;}s:6:"repeat";a:6:{s:4:"type";s:7:"boolean";s:5:"label";s:14:"Repeat message";s:11:"description";s:87:"If disabled and the message has been already shown, then the message won''t be repeated.";s:13:"default value";b:1;s:8:"optional";b:1;s:11:"restriction";s:5:"input";}}s:15:"access callback";s:31:"rules_system_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:27:"rules_action_drupal_message";}}i:1;a:1:{s:7:"execute";s:19:"modules/system.eval";}}}}s:8:"redirect";a:7:{s:5:"label";s:13:"Page redirect";s:5:"group";s:6:"System";s:9:"parameter";a:3:{s:3:"url";a:3:{s:4:"type";s:3:"uri";s:5:"label";s:3:"URL";s:11:"description";s:126:"A Drupal path, path alias, or external URL to redirect to. Enter (optional) queries after "?" and (optional) anchor after "#".";}s:5:"force";a:6:{s:4:"type";s:7:"boolean";s:5:"label";s:14:"Force redirect";s:11:"restriction";s:5:"input";s:11:"description";s:288:"Force the redirect even if another destination parameter is present. Per default Drupal would redirect to the path given as destination parameter, in case it is set. Usually the destination parameter is set by appending it to the URL, e.g. http://example.com/user/login?destination=node/2";s:8:"optional";b:1;s:13:"default value";b:1;}s:11:"destination";a:6:{s:4:"type";s:7:"boolean";s:5:"label";s:28:"Append destination parameter";s:11:"restriction";s:5:"input";s:11:"description";s:125:"Whether to append a destination parameter to the URL, so another redirect issued later on would lead back to the origin page.";s:8:"optional";b:1;s:13:"default value";b:0;}}s:15:"access callback";s:31:"rules_system_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:24:"rules_action_drupal_goto";}}i:1;a:1:{s:7:"execute";s:19:"modules/system.eval";}}}}s:14:"breadcrumb_set";a:7:{s:5:"label";s:14:"Set breadcrumb";s:5:"group";s:6:"System";s:9:"parameter";a:2:{s:6:"titles";a:4:{s:4:"type";s:10:"list<text>";s:5:"label";s:6:"Titles";s:11:"description";s:42:"A list of titles for the breadcrumb links.";s:12:"translatable";b:1;}s:5:"paths";a:3:{s:4:"type";s:10:"list<text>";s:5:"label";s:5:"Paths";s:11:"description";s:82:"A list of Drupal paths for the breadcrumb links, matching the order of the titles.";}}s:15:"access callback";s:31:"rules_system_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:27:"rules_action_breadcrumb_set";}}i:1;a:1:{s:7:"execute";s:19:"modules/system.eval";}}}}s:4:"mail";a:7:{s:5:"label";s:9:"Send mail";s:5:"group";s:6:"System";s:9:"parameter";a:5:{s:2:"to";a:3:{s:4:"type";s:4:"text";s:5:"label";s:2:"To";s:11:"description";s:123:"The e-mail address or addresses where the message will be sent to. The formatting of this string must comply with RFC 2822.";}s:7:"subject";a:4:{s:4:"type";s:4:"text";s:5:"label";s:7:"Subject";s:11:"description";s:19:"The mail''s subject.";s:12:"translatable";b:1;}s:7:"message";a:4:{s:4:"type";s:4:"text";s:5:"label";s:7:"Message";s:11:"description";s:24:"The mail''s message body.";s:12:"translatable";b:1;}s:4:"from";a:4:{s:4:"type";s:4:"text";s:5:"label";s:4:"From";s:11:"description";s:80:"The mail''s from address. Leave it empty to use the site-wide configured address.";s:8:"optional";b:1;}s:8:"language";a:7:{s:4:"type";s:5:"token";s:5:"label";s:8:"Language";s:11:"description";s:73:"If specified, the language used for getting the mail message and subject.";s:12:"options list";s:29:"entity_metadata_language_list";s:8:"optional";b:1;s:13:"default value";s:3:"und";s:12:"default mode";s:8:"selector";}}s:15:"access callback";s:31:"rules_system_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:17:"rules_action_mail";}}i:1;a:1:{s:7:"execute";s:19:"modules/system.eval";}}}}s:21:"mail_to_users_of_role";a:7:{s:5:"label";s:32:"Send mail to all users of a role";s:5:"group";s:6:"System";s:9:"parameter";a:4:{s:5:"roles";a:4:{s:4:"type";s:13:"list<integer>";s:5:"label";s:5:"Roles";s:12:"options list";s:26:"entity_metadata_user_roles";s:11:"description";s:53:"Select the roles whose users should receive the mail.";}s:7:"subject";a:3:{s:4:"type";s:4:"text";s:5:"label";s:7:"Subject";s:11:"description";s:19:"The mail''s subject.";}s:7:"message";a:3:{s:4:"type";s:4:"text";s:5:"label";s:7:"Message";s:11:"description";s:24:"The mail''s message body.";}s:4:"from";a:4:{s:4:"type";s:4:"text";s:5:"label";s:4:"From";s:11:"description";s:80:"The mail''s from address. Leave it empty to use the site-wide configured address.";s:8:"optional";b:1;}}s:15:"access callback";s:31:"rules_system_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:2:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:34:"rules_action_mail_to_users_of_role";}}i:1;a:1:{s:7:"execute";s:19:"modules/system.eval";}}s:22:"RulesPluginUIInterface";a:2:{i:0;a:1:{s:4:"help";a:1:{i:0;s:39:"rules_action_mail_to_users_of_role_help";}}i:1;a:1:{s:4:"help";s:20:"modules/system.rules";}}}}s:8:"block_ip";a:7:{s:5:"label";s:16:"Block IP address";s:5:"group";s:6:"System";s:9:"parameter";a:1:{s:10:"ip_address";a:5:{s:4:"type";s:10:"ip_address";s:5:"label";s:10:"IP address";s:11:"description";s:65:"If not provided, the IP address of the current user will be used.";s:8:"optional";b:1;s:13:"default value";N;}}s:15:"access callback";s:31:"rules_system_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:21:"rules_action_block_ip";}}i:1;a:1:{s:7:"execute";s:19:"modules/system.eval";}}}}s:13:"user_add_role";a:7:{s:9:"parameter";a:2:{s:7:"account";a:4:{s:4:"type";s:4:"user";s:5:"label";s:4:"User";s:11:"description";s:39:"The user whose roles should be changed.";s:4:"save";b:1;}s:5:"roles";a:3:{s:4:"type";s:13:"list<integer>";s:5:"label";s:5:"Roles";s:12:"options list";s:29:"rules_user_roles_options_list";}}s:5:"group";s:4:"User";s:15:"access callback";s:29:"rules_user_role_change_access";s:5:"label";s:13:"Add user role";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:26:"rules_action_user_add_role";}}i:1;a:1:{s:7:"execute";s:17:"modules/user.eval";}}}}s:16:"user_remove_role";a:7:{s:9:"parameter";a:2:{s:7:"account";a:4:{s:4:"type";s:4:"user";s:5:"label";s:4:"User";s:11:"description";s:39:"The user whose roles should be changed.";s:4:"save";b:1;}s:5:"roles";a:3:{s:4:"type";s:13:"list<integer>";s:5:"label";s:5:"Roles";s:12:"options list";s:29:"rules_user_roles_options_list";}}s:5:"group";s:4:"User";s:15:"access callback";s:29:"rules_user_role_change_access";s:5:"label";s:16:"Remove user role";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:29:"rules_action_user_remove_role";}}i:1;a:1:{s:7:"execute";s:17:"modules/user.eval";}}}}s:10:"user_block";a:7:{s:9:"parameter";a:1:{s:7:"account";a:3:{s:4:"type";s:4:"user";s:5:"label";s:4:"User";s:4:"save";b:1;}}s:5:"group";s:4:"User";s:15:"access callback";s:29:"rules_user_integration_access";s:5:"label";s:12:"Block a user";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:23:"rules_action_user_block";}}i:1;a:1:{s:7:"execute";s:17:"modules/user.eval";}}}}s:12:"user_unblock";a:7:{s:9:"parameter";a:1:{s:7:"account";a:3:{s:4:"type";s:4:"user";s:5:"label";s:4:"User";s:4:"save";b:1;}}s:5:"group";s:4:"User";s:15:"access callback";s:29:"rules_user_integration_access";s:5:"label";s:14:"Unblock a user";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:25:"rules_action_user_unblock";}}i:1;a:1:{s:7:"execute";s:17:"modules/user.eval";}}}}s:23:"user_send_account_email";a:7:{s:5:"label";s:19:"Send account e-mail";s:9:"parameter";a:2:{s:7:"account";a:2:{s:4:"type";s:4:"user";s:5:"label";s:7:"Account";}s:10:"email_type";a:4:{s:4:"type";s:4:"text";s:5:"label";s:11:"E-mail type";s:11:"description";s:76:"Select the e-mail based on your site''s account settings to send to the user.";s:12:"options list";s:37:"rules_user_account_email_options_list";}}s:5:"group";s:4:"User";s:15:"access callback";s:29:"rules_user_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:36:"rules_action_user_send_account_email";}}i:1;a:1:{s:7:"execute";s:17:"modules/user.eval";}}}}s:8:"php_eval";a:7:{s:5:"label";s:23:"Execute custom PHP code";s:5:"group";s:3:"PHP";s:9:"parameter";a:1:{s:4:"code";a:4:{s:11:"restriction";s:5:"input";s:4:"type";s:4:"text";s:5:"label";s:8:"PHP code";s:11:"description";s:49:"Enter PHP code without &lt;?php ?&gt; delimiters.";}}s:15:"access callback";s:28:"rules_php_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:4:{s:7:"execute";a:1:{i:0;s:22:"rules_execute_php_eval";}s:7:"process";a:1:{i:0;s:30:"rules_execute_php_eval_process";}s:12:"dependencies";a:1:{i:0;s:35:"rules_execute_php_eval_dependencies";}s:10:"form_alter";a:1:{i:0;s:33:"rules_execute_php_eval_form_alter";}}i:1;a:4:{s:7:"execute";s:16:"modules/php.eval";s:7:"process";s:17:"modules/php.rules";s:12:"dependencies";s:17:"modules/php.rules";s:10:"form_alter";s:17:"modules/php.rules";}}}}s:10:"path_alias";a:7:{s:5:"label";s:30:"Create or delete any URL alias";s:5:"group";s:4:"Path";s:9:"parameter";a:3:{s:6:"source";a:4:{s:4:"type";s:4:"text";s:5:"label";s:20:"Existing system path";s:11:"description";s:167:"Specifies the existing path you wish to alias. For example: node/28, forum/1, taxonomy/term/1+2. Leave it empty to delete URL aliases pointing to the given path alias.";s:8:"optional";b:1;}s:5:"alias";a:5:{s:4:"type";s:4:"text";s:5:"label";s:9:"URL alias";s:11:"description";s:228:"Specify an alternative path by which this data can be accessed. For example, "about" for an about page. Use a relative path and do not add a trailing slash. Leave it empty to delete URL aliases pointing to the given system path.";s:8:"optional";b:1;s:17:"cleaning callback";s:35:"rules_path_clean_replacement_values";}s:8:"language";a:6:{s:4:"type";s:5:"token";s:5:"label";s:8:"Language";s:11:"description";s:59:"If specified, the language for which the URL alias applies.";s:12:"options list";s:29:"entity_metadata_language_list";s:8:"optional";b:1;s:13:"default value";s:3:"und";}}s:15:"access callback";s:29:"rules_path_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:2:{s:7:"execute";a:1:{i:0;s:23:"rules_action_path_alias";}s:12:"dependencies";a:1:{i:0;s:23:"rules_path_dependencies";}}i:1;a:2:{s:7:"execute";s:17:"modules/path.eval";s:12:"dependencies";s:18:"modules/path.rules";}}}}s:15:"node_path_alias";a:7:{s:5:"label";s:38:"Create or delete a content''s URL alias";s:5:"group";s:4:"Path";s:9:"parameter";a:2:{s:4:"node";a:3:{s:4:"type";s:4:"node";s:5:"label";s:7:"Content";s:4:"save";b:1;}s:5:"alias";a:5:{s:4:"type";s:4:"text";s:5:"label";s:9:"URL alias";s:11:"description";s:198:"Specify an alternative path by which the content can be accessed. For example, "about" for an about page. Use a relative path and do not add a trailing slash. Leave it empty to delete the URL alias.";s:8:"optional";b:1;s:17:"cleaning callback";s:35:"rules_path_clean_replacement_values";}}s:15:"access callback";s:29:"rules_path_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:2:{s:7:"execute";a:1:{i:0;s:28:"rules_action_node_path_alias";}s:12:"dependencies";a:1:{i:0;s:23:"rules_path_dependencies";}}i:1;a:2:{s:7:"execute";s:17:"modules/path.eval";s:12:"dependencies";s:18:"modules/path.rules";}}}}s:24:"taxonomy_term_path_alias";a:7:{s:5:"label";s:44:"Create or delete a taxonomy term''s URL alias";s:5:"group";s:4:"Path";s:9:"parameter";a:2:{s:4:"node";a:3:{s:4:"type";s:13:"taxonomy_term";s:5:"label";s:13:"Taxonomy term";s:4:"save";b:1;}s:5:"alias";a:5:{s:4:"type";s:4:"text";s:5:"label";s:9:"URL alias";s:11:"description";s:204:"Specify an alternative path by which the term can be accessed. For example, "content/drupal" for a Drupal term. Use a relative path and do not add a trailing slash. Leave it empty to delete the URL alias.";s:8:"optional";b:1;s:17:"cleaning callback";s:35:"rules_path_clean_replacement_values";}}s:15:"access callback";s:29:"rules_path_integration_access";s:6:"module";s:5:"rules";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:2:{s:7:"execute";a:1:{i:0;s:28:"rules_action_node_path_alias";}s:12:"dependencies";a:1:{i:0;s:23:"rules_path_dependencies";}}i:1;a:2:{s:7:"execute";s:17:"modules/path.eval";s:12:"dependencies";s:18:"modules/path.rules";}}}}s:11:"devel_debug";a:6:{s:5:"label";s:11:"Debug value";s:5:"group";s:5:"Devel";s:9:"parameter";a:1:{s:5:"value";a:2:{s:4:"type";s:7:"unknown";s:5:"label";s:14:"Value to debug";}}s:6:"module";s:5:"devel";s:8:"provides";a:0:{}s:11:"faces_cache";a:1:{s:24:"RulesPluginImplInterface";a:2:{i:0;a:1:{s:7:"execute";a:1:{i:0;s:24:"devel_rules_debug_action";}}i:1;a:1:{s:7:"execute";s:11:"devel.rules";}}}}}}','0','1493613848','1');
INSERT INTO `cache_rules` VALUES ('event_badge_insert','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:12:"badge_insert";s:9:"recursion";b:1;s:11:"\0*\0children";a:1:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:2:"14";s:12:"\0*\0elementId";i:1;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:24:"rules_badges_add_another";s:5:"label";s:18:"Badges Add Another";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:3:{s:7:"message";s:91:"<a href="/library/dashboard/branches/program/badge/add">Click here to add another Badge</a>";s:4:"type";s:6:"status";s:6:"repeat";s:1:"1";}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:12:"badge_insert";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:6:"module";s:3:"eck";s:5:"group";s:5:"Badge";s:15:"access callback";s:37:"entity_rules_integration_event_access";s:5:"label";s:24:"After saving a new badge";s:9:"variables";a:1:{s:5:"badge";a:2:{s:4:"type";s:5:"badge";s:5:"label";s:13:"created badge";}}}}','0','1493613848','1'),('event_badge_presave','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:13:"badge_presave";s:9:"recursion";b:1;s:11:"\0*\0children";a:1:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:2:"20";s:12:"\0*\0elementId";i:1;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:22:"rules_badge_set_author";s:5:"label";s:16:"Badge Set Author";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"badge_presave";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:6:"module";s:3:"eck";s:5:"group";s:5:"Badge";s:15:"access callback";s:37:"entity_rules_integration_event_access";s:5:"label";s:21:"Before saving a badge";s:9:"variables";a:2:{s:5:"badge";a:3:{s:4:"type";s:5:"badge";s:5:"label";s:11:"saved badge";s:9:"skip save";b:1;}s:15:"badge_unchanged";a:3:{s:4:"type";s:5:"badge";s:5:"label";s:16:"unchanged entity";s:7:"handler";s:29:"rules_events_entity_unchanged";}}}}','0','1493613848','1');
INSERT INTO `cache_rules` VALUES ('event_branch_insert','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:13:"branch_insert";s:9:"recursion";b:1;s:11:"\0*\0children";a:1:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:2:"12";s:12:"\0*\0elementId";i:1;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:24:"rules_branch_add_another";s:5:"label";s:18:"Branch Add Another";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:7:"message";s:78:"<a href="/library/dashboard/branches/add">Click here to add another Branch</a>";s:4:"type";s:6:"status";s:6:"repeat";s:1:"1";}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"branch_insert";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:6:"module";s:3:"eck";s:5:"group";s:6:"Branch";s:15:"access callback";s:37:"entity_rules_integration_event_access";s:5:"label";s:25:"After saving a new branch";s:9:"variables";a:1:{s:6:"branch";a:2:{s:4:"type";s:6:"branch";s:5:"label";s:14:"created branch";}}}}','0','1493613848','1'),('event_level_insert','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:12:"level_insert";s:9:"recursion";b:1;s:11:"\0*\0children";a:1:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:2:"16";s:12:"\0*\0elementId";i:1;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:23:"rules_level_add_another";s:5:"label";s:17:"Level Add Another";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:2:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"program";s:9:"id:select";s:34:"level:field-program-reference:0:id";s:20:"entity_fetched:label";s:20:"Fetched Level Entity";s:18:"entity_fetched:var";s:20:"level_entity_fetched";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:1;s:8:"settings";a:4:{s:7:"message";s:155:"<a href="/library/dashboard/program/level/add/[level-entity-fetched:id]">Click here to add another Level to the [level:field-program-reference] Program</a>";s:4:"type";s:6:"status";s:6:"repeat";s:1:"1";s:15:"message:process";O:19:"RulesTokenEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:51;s:2:"id";N;s:12:"\0*\0elementId";i:6;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:5:"level";s:5:"field";s:23:"field_program_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:12:"level_insert";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:6:"module";s:3:"eck";s:5:"group";s:5:"Level";s:15:"access callback";s:37:"entity_rules_integration_event_access";s:5:"label";s:24:"After saving a new level";s:9:"variables";a:1:{s:5:"level";a:2:{s:4:"type";s:5:"level";s:5:"label";s:13:"created level";}}}}','0','1493613848','1');
INSERT INTO `cache_rules` VALUES ('event_points_insert','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:13:"points_insert";s:9:"recursion";b:1;s:11:"\0*\0children";a:2:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:2:"10";s:12:"\0*\0elementId";i:1;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:55:"rules_upon_adding_points_update_reader_points_reference";s:5:"label";s:49:"Upon Adding Points Update Reader Points Reference";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:3:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:6:"reader";s:9:"id:select";s:25:"points:field-readers:0:id";s:20:"entity_fetched:label";s:14:"Fetched entity";s:18:"entity_fetched:var";s:14:"entity_fetched";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:5;s:6:"weight";i:1;s:8:"settings";a:6:{s:4:"type";s:6:"points";s:8:"property";s:2:"id";s:12:"value:select";s:9:"points:id";s:5:"limit";s:1:"1";s:20:"entity_fetched:label";s:13:"loaded points";s:18:"entity_fetched:var";s:13:"loaded_points";}s:14:"\0*\0elementName";s:12:"entity_query";}i:2;O:16:"RulesConditional":7:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:6;s:6:"weight";i:2;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:18:"RulesConditionalIf":8:{s:9:"\0*\0parent";r:50;s:2:"id";N;s:12:"\0*\0elementId";i:7;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:57;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:11:"list:select";s:37:"entity-fetched:field-points-reference";s:11:"item:select";s:15:"loaded-points:0";s:6:"unique";b:0;s:3:"pos";s:3:"end";}s:14:"\0*\0elementName";s:8:"list_add";}}s:7:"\0*\0info";a:0:{}s:12:"\0*\0predicate";O:14:"RulesCondition":7:{s:9:"\0*\0parent";O:18:"RulesConditionalIf":8:{s:9:"\0*\0parent";O:16:"RulesConditional":7:{s:9:"\0*\0parent";O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";N;s:2:"id";s:2:"10";s:12:"\0*\0elementId";i:1;s:6:"weight";s:1:"0";s:8:"settings";a:0:{}s:4:"name";s:55:"rules_upon_adding_points_update_reader_points_reference";s:5:"label";s:49:"Upon Adding Points Update Reader Points Reference";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:3:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:79;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:6:"reader";s:9:"id:select";s:25:"points:field-readers:0:id";s:20:"entity_fetched:label";s:14:"Fetched entity";s:18:"entity_fetched:var";s:14:"entity_fetched";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:79;s:2:"id";N;s:12:"\0*\0elementId";i:5;s:6:"weight";i:1;s:8:"settings";a:6:{s:4:"type";s:6:"points";s:8:"property";s:2:"id";s:12:"value:select";s:9:"points:id";s:5:"limit";s:1:"1";s:20:"entity_fetched:label";s:13:"loaded points";s:18:"entity_fetched:var";s:13:"loaded_points";}s:14:"\0*\0elementName";s:12:"entity_query";}i:2;r:78;}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:79;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:121;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:6:"points";s:5:"field";s:13:"field_readers";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"points_insert";}s:16:"\0*\0eventSettings";a:0:{}}s:2:"id";N;s:12:"\0*\0elementId";i:6;s:6:"weight";i:2;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;r:77;}s:7:"\0*\0info";a:0:{}}s:2:"id";N;s:12:"\0*\0elementId";i:7;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:77;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:11:"list:select";s:37:"entity-fetched:field-points-reference";s:11:"item:select";s:15:"loaded-points:0";s:6:"unique";b:0;s:3:"pos";s:3:"end";}s:14:"\0*\0elementName";s:8:"list_add";}}s:7:"\0*\0info";a:0:{}s:12:"\0*\0predicate";r:76;}s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:14:"entity-fetched";s:5:"field";s:22:"field_points_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}}s:7:"\0*\0info";a:0:{}}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:178;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:6:"points";s:5:"field";s:13:"field_readers";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"points_insert";}s:16:"\0*\0eventSettings";a:0:{}}i:1;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:1:"9";s:12:"\0*\0elementId";i:1;s:6:"weight";i:1;s:8:"settings";a:0:{}s:4:"name";s:43:"rules_upon_adding_points_update_reading_log";s:5:"label";s:37:"Upon Adding Points Update Reading Log";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:3:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:200;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:11:"reading_log";s:9:"id:select";s:39:"points:field-reading-log-reference:0:id";s:20:"entity_fetched:label";s:14:"Fetched entity";s:18:"entity_fetched:var";s:14:"entity_fetched";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:200;s:2:"id";N;s:12:"\0*\0elementId";i:7;s:6:"weight";i:1;s:8:"settings";a:6:{s:4:"type";s:6:"points";s:8:"property";s:2:"id";s:12:"value:select";s:9:"points:id";s:5:"limit";s:1:"1";s:20:"entity_fetched:label";s:13:"loaded points";s:18:"entity_fetched:var";s:13:"loaded_points";}s:14:"\0*\0elementName";s:12:"entity_query";}i:2;O:16:"RulesConditional":7:{s:9:"\0*\0parent";r:200;s:2:"id";N;s:12:"\0*\0elementId";i:5;s:6:"weight";i:2;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:18:"RulesConditionalIf":8:{s:9:"\0*\0parent";r:240;s:2:"id";N;s:12:"\0*\0elementId";i:6;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:247;s:2:"id";N;s:12:"\0*\0elementId";i:8;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:37:"entity-fetched:field-points-reference";s:12:"value:select";s:13:"loaded-points";}s:14:"\0*\0elementName";s:8:"data_set";}}s:7:"\0*\0info";a:0:{}s:12:"\0*\0predicate";O:14:"RulesCondition":7:{s:9:"\0*\0parent";O:18:"RulesConditionalIf":8:{s:9:"\0*\0parent";O:16:"RulesConditional":7:{s:9:"\0*\0parent";O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";N;s:2:"id";s:1:"9";s:12:"\0*\0elementId";i:1;s:6:"weight";s:1:"3";s:8:"settings";a:0:{}s:4:"name";s:43:"rules_upon_adding_points_update_reading_log";s:5:"label";s:37:"Upon Adding Points Update Reading Log";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:3:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:267;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:11:"reading_log";s:9:"id:select";s:39:"points:field-reading-log-reference:0:id";s:20:"entity_fetched:label";s:14:"Fetched entity";s:18:"entity_fetched:var";s:14:"entity_fetched";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:267;s:2:"id";N;s:12:"\0*\0elementId";i:7;s:6:"weight";i:1;s:8:"settings";a:6:{s:4:"type";s:6:"points";s:8:"property";s:2:"id";s:12:"value:select";s:9:"points:id";s:5:"limit";s:1:"1";s:20:"entity_fetched:label";s:13:"loaded points";s:18:"entity_fetched:var";s:13:"loaded_points";}s:14:"\0*\0elementName";s:12:"entity_query";}i:2;r:266;}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:267;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:3:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:309;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:6:"points";s:5:"field";s:27:"field_reading_log_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:1;O:7:"RulesOr":8:{s:9:"\0*\0parent";r:309;s:2:"id";N;s:12:"\0*\0elementId";i:9;s:6:"weight";i:1;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}i:2;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:309;s:2:"id";N;s:12:"\0*\0elementId";i:10;s:6:"weight";i:2;s:8:"settings";a:2:{s:13:"entity:select";s:6:"points";s:5:"field";s:28:"field_activity_log_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"points_insert";}s:16:"\0*\0eventSettings";a:0:{}}s:2:"id";N;s:12:"\0*\0elementId";i:5;s:6:"weight";i:2;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;r:265;}s:7:"\0*\0info";a:0:{}}s:2:"id";N;s:12:"\0*\0elementId";i:6;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:265;s:2:"id";N;s:12:"\0*\0elementId";i:8;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:37:"entity-fetched:field-points-reference";s:12:"value:select";s:13:"loaded-points";}s:14:"\0*\0elementName";s:8:"data_set";}}s:7:"\0*\0info";a:0:{}s:12:"\0*\0predicate";r:264;}s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:14:"entity-fetched";s:5:"field";s:22:"field_points_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}}s:7:"\0*\0info";a:0:{}}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:200;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:2:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:383;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:6:"points";s:5:"field";s:27:"field_reading_log_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:1;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:383;s:2:"id";N;s:12:"\0*\0elementId";i:9;s:6:"weight";i:1;s:8:"settings";a:1:{s:11:"data:select";s:34:"points:field-reading-log-reference";}s:14:"\0*\0elementName";s:13:"data_is_empty";s:9:"\0*\0negate";b:1;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"points_insert";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:6:"module";s:3:"eck";s:5:"group";s:6:"Points";s:15:"access callback";s:37:"entity_rules_integration_event_access";s:5:"label";s:25:"After saving a new points";s:9:"variables";a:1:{s:6:"points";a:2:{s:4:"type";s:6:"points";s:5:"label";s:14:"created points";}}}}','0','1493613848','1');
INSERT INTO `cache_rules` VALUES ('event_prize_insert','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:12:"prize_insert";s:9:"recursion";b:1;s:11:"\0*\0children";a:1:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:2:"15";s:12:"\0*\0elementId";i:1;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:23:"rules_prize_add_another";s:5:"label";s:17:"Prize Add Another";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:3:{s:7:"message";s:91:"<a href="/library/dashboard/branches/program/prize/add">Click here to add another Prize</a>";s:4:"type";s:6:"status";s:6:"repeat";s:1:"1";}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:12:"prize_insert";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:6:"module";s:3:"eck";s:5:"group";s:5:"Prize";s:15:"access callback";s:37:"entity_rules_integration_event_access";s:5:"label";s:24:"After saving a new prize";s:9:"variables";a:1:{s:5:"prize";a:2:{s:4:"type";s:5:"prize";s:5:"label";s:13:"created prize";}}}}','0','1493613848','1'),('event_program_insert','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:14:"program_insert";s:9:"recursion";b:1;s:11:"\0*\0children";a:1:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:2:"13";s:12:"\0*\0elementId";i:1;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:25:"rules_program_add_another";s:5:"label";s:19:"Program Add Another";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:3:{s:7:"message";s:78:"<a href="/library/dashboard/program/add">Click here to add another Program</a>";s:4:"type";s:6:"status";s:6:"repeat";s:1:"1";}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:14:"program_insert";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:6:"module";s:3:"eck";s:5:"group";s:7:"Program";s:15:"access callback";s:37:"entity_rules_integration_event_access";s:5:"label";s:26:"After saving a new program";s:9:"variables";a:1:{s:7:"program";a:2:{s:4:"type";s:7:"program";s:5:"label";s:15:"created program";}}}}','0','1493613848','1');
INSERT INTO `cache_rules` VALUES ('event_reader_badge_insert','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:19:"reader_badge_insert";s:9:"recursion";b:1;s:11:"\0*\0children";a:1:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:2:"11";s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:26:"rules_badge_earned_message";s:5:"label";s:20:"Badge Earned Message";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:7:"message";s:34:"[reader-badge:field_badge_message]";s:6:"repeat";s:1:"0";s:15:"message:process";O:19:"RulesTokenEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:39;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:14:"account:select";s:17:"site:current-user";s:5:"roles";a:1:{i:4;s:1:"4";}}s:14:"\0*\0elementName";s:13:"user_has_role";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:19:"reader_badge_insert";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:6:"module";s:3:"eck";s:5:"group";s:12:"Reader Badge";s:15:"access callback";s:37:"entity_rules_integration_event_access";s:5:"label";s:31:"After saving a new reader badge";s:9:"variables";a:1:{s:12:"reader_badge";a:2:{s:4:"type";s:12:"reader_badge";s:5:"label";s:20:"created reader badge";}}}}','0','1493613848','1'),('event_reader_prize_insert','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:19:"reader_prize_insert";s:9:"recursion";b:1;s:11:"\0*\0children";a:1:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:2:"17";s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:26:"rules_prize_earned_message";s:5:"label";s:20:"Prize Earned Message";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:7:"message";s:34:"[reader-prize:field-prize-message]";s:6:"repeat";s:1:"0";s:15:"message:process";O:19:"RulesTokenEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:39;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:14:"account:select";s:17:"site:current-user";s:5:"roles";a:1:{i:4;s:1:"4";}}s:14:"\0*\0elementName";s:13:"user_has_role";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:19:"reader_prize_insert";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:6:"module";s:3:"eck";s:5:"group";s:12:"Reader Prize";s:15:"access callback";s:37:"entity_rules_integration_event_access";s:5:"label";s:31:"After saving a new reader prize";s:9:"variables";a:1:{s:12:"reader_prize";a:2:{s:4:"type";s:12:"reader_prize";s:5:"label";s:20:"created reader prize";}}}}','0','1493613848','1');
INSERT INTO `cache_rules` VALUES ('event_reader_update','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:13:"reader_update";s:9:"recursion";b:1;s:11:"\0*\0children";a:1:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:1:"8";s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:44:"rules_sum_and_update_points_on_reader_update";s:5:"label";s:38:"Sum and Update Points on Reader Update";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:4:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"integer";s:5:"value";s:1:"0";s:18:"variable_added:var";s:14:"variable_added";s:20:"variable_added:label";s:5:"Total";}s:14:"\0*\0elementName";s:12:"variable_add";}i:1;O:9:"RulesLoop":7:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:8:"item:var";s:9:"list_item";s:10:"item:label";s:17:"Current list item";s:11:"list:select";s:29:"reader:field-points-reference";}s:11:"\0*\0children";a:2:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:37;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:6:"points";s:9:"id:select";s:12:"list-item:id";s:18:"entity_fetched:var";s:14:"entity_fetched";s:20:"entity_fetched:label";s:14:"Fetched entity";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:16:"RulesConditional":7:{s:9:"\0*\0parent";r:37;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:18:"RulesConditionalIf":8:{s:9:"\0*\0parent";r:58;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:2:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:65;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:5:{s:14:"input_1:select";s:14:"variable-added";s:2:"op";s:1:"+";s:14:"input_2:select";s:27:"entity-fetched:field-points";s:10:"result:var";s:6:"result";s:12:"result:label";s:18:"Calculation result";}s:14:"\0*\0elementName";s:9:"data_calc";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:65;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:14:"variable-added";s:12:"value:select";s:6:"result";}s:14:"\0*\0elementName";s:8:"data_set";}}s:7:"\0*\0info";a:0:{}s:12:"\0*\0predicate";O:14:"RulesCondition":7:{s:9:"\0*\0parent";O:18:"RulesConditionalIf":8:{s:9:"\0*\0parent";O:16:"RulesConditional":7:{s:9:"\0*\0parent";O:9:"RulesLoop":7:{s:9:"\0*\0parent";O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";N;s:2:"id";s:1:"8";s:12:"\0*\0elementId";N;s:6:"weight";s:1:"0";s:8:"settings";a:0:{}s:4:"name";s:44:"rules_sum_and_update_points_on_reader_update";s:5:"label";s:38:"Sum and Update Points on Reader Update";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:4:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:98;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"integer";s:5:"value";s:1:"0";s:18:"variable_added:var";s:14:"variable_added";s:20:"variable_added:label";s:5:"Total";}s:14:"\0*\0elementName";s:12:"variable_add";}i:1;r:97;i:2;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:98;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:27:"reader:field-current-points";s:12:"value:select";s:14:"variable-added";}s:14:"\0*\0elementName";s:8:"data_set";}i:3;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:98;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:1:{s:11:"data:select";s:6:"reader";}s:14:"\0*\0elementName";s:11:"entity_save";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:98;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:3:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:144;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:6:"reader";s:5:"field";s:22:"field_points_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:1;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:144;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"list:select";s:29:"reader:field-points-reference";s:11:"item:select";s:31:"reader:field-points-reference:0";}s:14:"\0*\0elementName";s:13:"list_contains";s:9:"\0*\0negate";b:0;}i:2;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:144;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:6:"reader";s:5:"field";s:20:"field_current_points";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"reader_update";}s:16:"\0*\0eventSettings";a:0:{}}s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:8:"item:var";s:9:"list_item";s:10:"item:label";s:17:"Current list item";s:11:"list:select";s:29:"reader:field-points-reference";}s:11:"\0*\0children";a:2:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:97;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:6:"points";s:9:"id:select";s:12:"list-item:id";s:18:"entity_fetched:var";s:14:"entity_fetched";s:20:"entity_fetched:label";s:14:"Fetched entity";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;r:96;}s:7:"\0*\0info";a:0:{}}s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;r:95;}s:7:"\0*\0info";a:0:{}}s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:2:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:95;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:5:{s:14:"input_1:select";s:14:"variable-added";s:2:"op";s:1:"+";s:14:"input_2:select";s:27:"entity-fetched:field-points";s:10:"result:var";s:6:"result";s:12:"result:label";s:18:"Calculation result";}s:14:"\0*\0elementName";s:9:"data_calc";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:95;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:14:"variable-added";s:12:"value:select";s:6:"result";}s:14:"\0*\0elementName";s:8:"data_set";}}s:7:"\0*\0info";a:0:{}s:12:"\0*\0predicate";r:94;}s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:14:"entity-fetched";s:5:"field";s:12:"field_points";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}}s:7:"\0*\0info";a:0:{}}}s:7:"\0*\0info";a:0:{}}i:2;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:27:"reader:field-current-points";s:12:"value:select";s:14:"variable-added";}s:14:"\0*\0elementName";s:8:"data_set";}i:3;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:1:{s:11:"data:select";s:6:"reader";}s:14:"\0*\0elementName";s:11:"entity_save";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:3:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:270;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:6:"reader";s:5:"field";s:22:"field_points_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:1;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:270;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"list:select";s:29:"reader:field-points-reference";s:11:"item:select";s:31:"reader:field-points-reference:0";}s:14:"\0*\0elementName";s:13:"list_contains";s:9:"\0*\0negate";b:0;}i:2;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:270;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:6:"reader";s:5:"field";s:20:"field_current_points";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"reader_update";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:6:"module";s:3:"eck";s:5:"group";s:6:"Reader";s:15:"access callback";s:37:"entity_rules_integration_event_access";s:5:"label";s:33:"After updating an existing reader";s:9:"variables";a:2:{s:6:"reader";a:2:{s:4:"type";s:6:"reader";s:5:"label";s:14:"updated reader";}s:16:"reader_unchanged";a:3:{s:4:"type";s:6:"reader";s:5:"label";s:16:"unchanged entity";s:7:"handler";s:29:"rules_events_entity_unchanged";}}}}','0','1493613848','1');
INSERT INTO `cache_rules` VALUES ('event_reading_log_insert','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:18:"reading_log_insert";s:9:"recursion";b:1;s:11:"\0*\0children";a:1:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:1:"6";s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:23:"rules_onaddreadingentry";s:5:"label";s:17:"OnAddReadingEntry";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:12:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:11:"reading_log";s:9:"id:select";s:14:"reading-log:id";s:18:"entity_fetched:var";s:14:"reading_log_id";s:20:"entity_fetched:label";s:14:"reading log id";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:6:{s:4:"type";s:11:"reading_log";s:8:"property";s:21:"field_units_completed";s:12:"value:select";s:33:"reading-log:field-units-completed";s:5:"limit";s:1:"1";s:18:"entity_fetched:var";s:13:"fetched_units";s:20:"entity_fetched:label";s:13:"Fetched Units";}s:14:"\0*\0elementName";s:12:"entity_query";}i:2;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"program";s:9:"id:select";s:40:"reading-log:field-program-reference:0:id";s:18:"entity_fetched:var";s:24:"program_reference_entity";s:20:"entity_fetched:label";s:17:"Program Reference";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:3;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"integer";s:12:"value:select";s:33:"reading-log:field-units-completed";s:18:"variable_added:var";s:24:"units_completed_variable";s:20:"variable_added:label";s:24:"Units Completed Variable";}s:14:"\0*\0elementName";s:12:"variable_add";}i:4;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"integer";s:12:"value:select";s:30:"reading-log:field-readers:0:id";s:18:"variable_added:var";s:16:"reader_entity_id";s:20:"variable_added:label";s:16:"Reader Entity ID";}s:14:"\0*\0elementName";s:12:"variable_add";}i:5;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:6:"points";s:10:"param_type";s:6:"points";s:18:"entity_created:var";s:14:"entity_created";s:20:"entity_created:label";s:14:"Created entity";}s:14:"\0*\0elementName";s:13:"entity_create";}i:6;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:28:"entity-created:field-readers";s:12:"value:select";s:25:"reading-log:field-readers";}s:14:"\0*\0elementName";s:8:"data_set";}i:7;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:38:"entity-created:field-program-reference";s:12:"value:select";s:35:"reading-log:field-program-reference";}s:14:"\0*\0elementName";s:8:"data_set";}i:8;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:44:"entity-created:field-reading-log-reference:0";s:12:"value:select";s:14:"reading-log-id";}s:14:"\0*\0elementName";s:8:"data_set";}i:9;O:16:"RulesConditional":7:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:18:"RulesConditionalIf":8:{s:9:"\0*\0parent";r:121;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:2:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:128;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:5:{s:14:"input_1:select";s:24:"units-completed-variable";s:2:"op";s:1:"*";s:14:"input_2:select";s:51:"program-reference-entity:field-per-unit-point-value";s:10:"result:var";s:6:"result";s:12:"result:label";s:18:"Calculation result";}s:14:"\0*\0elementName";s:9:"data_calc";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:128;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:27:"entity-created:field-points";s:12:"value:select";s:6:"result";}s:14:"\0*\0elementName";s:8:"data_set";}}s:7:"\0*\0info";a:0:{}s:12:"\0*\0predicate";O:14:"RulesCondition":7:{s:9:"\0*\0parent";O:18:"RulesConditionalIf":8:{s:9:"\0*\0parent";O:16:"RulesConditional":7:{s:9:"\0*\0parent";O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";N;s:2:"id";s:1:"6";s:12:"\0*\0elementId";N;s:6:"weight";s:2:"-1";s:8:"settings";a:0:{}s:4:"name";s:23:"rules_onaddreadingentry";s:5:"label";s:17:"OnAddReadingEntry";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:12:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:160;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:11:"reading_log";s:9:"id:select";s:14:"reading-log:id";s:18:"entity_fetched:var";s:14:"reading_log_id";s:20:"entity_fetched:label";s:14:"reading log id";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:160;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:6:{s:4:"type";s:11:"reading_log";s:8:"property";s:21:"field_units_completed";s:12:"value:select";s:33:"reading-log:field-units-completed";s:5:"limit";s:1:"1";s:18:"entity_fetched:var";s:13:"fetched_units";s:20:"entity_fetched:label";s:13:"Fetched Units";}s:14:"\0*\0elementName";s:12:"entity_query";}i:2;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:160;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"program";s:9:"id:select";s:40:"reading-log:field-program-reference:0:id";s:18:"entity_fetched:var";s:24:"program_reference_entity";s:20:"entity_fetched:label";s:17:"Program Reference";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:3;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:160;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"integer";s:12:"value:select";s:33:"reading-log:field-units-completed";s:18:"variable_added:var";s:24:"units_completed_variable";s:20:"variable_added:label";s:24:"Units Completed Variable";}s:14:"\0*\0elementName";s:12:"variable_add";}i:4;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:160;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"integer";s:12:"value:select";s:30:"reading-log:field-readers:0:id";s:18:"variable_added:var";s:16:"reader_entity_id";s:20:"variable_added:label";s:16:"Reader Entity ID";}s:14:"\0*\0elementName";s:12:"variable_add";}i:5;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:160;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:6:"points";s:10:"param_type";s:6:"points";s:18:"entity_created:var";s:14:"entity_created";s:20:"entity_created:label";s:14:"Created entity";}s:14:"\0*\0elementName";s:13:"entity_create";}i:6;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:160;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:28:"entity-created:field-readers";s:12:"value:select";s:25:"reading-log:field-readers";}s:14:"\0*\0elementName";s:8:"data_set";}i:7;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:160;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:38:"entity-created:field-program-reference";s:12:"value:select";s:35:"reading-log:field-program-reference";}s:14:"\0*\0elementName";s:8:"data_set";}i:8;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:160;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:44:"entity-created:field-reading-log-reference:0";s:12:"value:select";s:14:"reading-log-id";}s:14:"\0*\0elementName";s:8:"data_set";}i:9;r:159;i:10;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:160;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:1:{s:7:"message";s:36:"Thank you for submitting your entry!";}s:14:"\0*\0elementName";s:14:"drupal_message";}i:11;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:160;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:14:"entity-created";s:9:"immediate";s:1:"1";}s:14:"\0*\0elementName";s:11:"entity_save";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:160;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:4:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:290;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:11:"reading-log";s:5:"field";s:13:"field_readers";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:1;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:290;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:11:"reading-log";s:5:"field";s:23:"field_program_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:2;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:290;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:11:"reading-log";s:5:"field";s:21:"field_units_completed";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:3;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:290;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:11:"reading-log";s:5:"field";s:22:"field_points_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:18:"reading_log_insert";}s:16:"\0*\0eventSettings";a:0:{}}s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;r:158;}s:7:"\0*\0info";a:0:{}}s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:2:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:158;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:5:{s:14:"input_1:select";s:24:"units-completed-variable";s:2:"op";s:1:"*";s:14:"input_2:select";s:51:"program-reference-entity:field-per-unit-point-value";s:10:"result:var";s:6:"result";s:12:"result:label";s:18:"Calculation result";}s:14:"\0*\0elementName";s:9:"data_calc";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:158;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:27:"entity-created:field-points";s:12:"value:select";s:6:"result";}s:14:"\0*\0elementName";s:8:"data_set";}}s:7:"\0*\0info";a:0:{}s:12:"\0*\0predicate";r:157;}s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:24:"program-reference-entity";s:5:"field";s:26:"field_per_unit_point_value";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}}s:7:"\0*\0info";a:0:{}}i:10;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:1:{s:7:"message";s:36:"Thank you for submitting your entry!";}s:14:"\0*\0elementName";s:14:"drupal_message";}i:11;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:14:"entity-created";s:9:"immediate";s:1:"1";}s:14:"\0*\0elementName";s:11:"entity_save";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:4:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:404;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:11:"reading-log";s:5:"field";s:13:"field_readers";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:1;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:404;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:11:"reading-log";s:5:"field";s:23:"field_program_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:2;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:404;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:11:"reading-log";s:5:"field";s:21:"field_units_completed";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:3;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:404;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:11:"reading-log";s:5:"field";s:22:"field_points_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:18:"reading_log_insert";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:6:"module";s:3:"eck";s:5:"group";s:11:"Reading Log";s:15:"access callback";s:37:"entity_rules_integration_event_access";s:5:"label";s:30:"After saving a new reading log";s:9:"variables";a:1:{s:11:"reading_log";a:2:{s:4:"type";s:11:"reading_log";s:5:"label";s:19:"created reading log";}}}}','0','1493613848','1');
INSERT INTO `cache_rules` VALUES ('event_user_insert','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:11:"user_insert";s:9:"recursion";b:1;s:11:"\0*\0children";a:1:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:1:"2";s:12:"\0*\0elementId";i:1;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:21:"rules_add_reader_role";s:5:"label";s:15:"Add Reader Role";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:2:{s:14:"account:select";s:7:"account";s:5:"roles";a:1:{i:4;s:1:"4";}}s:14:"\0*\0elementName";s:13:"user_add_role";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:37;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:0;s:8:"settings";a:3:{s:14:"account:select";s:7:"account";s:5:"roles";a:1:{i:5;s:1:"5";}s:9:"operation";s:2:"OR";}s:14:"\0*\0elementName";s:13:"user_has_role";s:9:"\0*\0negate";b:1;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:11:"user_insert";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:5:"label";s:31:"After saving a new user account";s:5:"group";s:4:"User";s:9:"variables";a:1:{s:7:"account";a:2:{s:4:"type";s:4:"user";s:5:"label";s:15:"registered user";}}s:15:"access callback";s:29:"rules_user_integration_access";s:6:"module";s:5:"rules";}}','0','1493613848','1'),('event_user_login','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:10:"user_login";s:9:"recursion";b:1;s:11:"\0*\0children";a:2:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:1:"1";s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:27:"rules_reader_login_redirect";s:5:"label";s:21:"Reader Login Redirect";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:3:"url";s:16:"reader-dashboard";s:11:"url:process";O:22:"RulesURIInputEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:8:"redirect";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:4:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:38;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:14:"account:select";s:7:"account";s:5:"roles";a:1:{i:4;s:1:"4";}s:9:"operation";s:2:"OR";}s:14:"\0*\0elementName";s:13:"user_has_role";s:9:"\0*\0negate";b:0;}i:1;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:38;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:1:{s:11:"data:select";s:21:"account:field-readers";}s:14:"\0*\0elementName";s:13:"data_is_empty";s:9:"\0*\0negate";b:1;}i:2;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:38;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:6:"source";s:18:"[account:edit-url]";s:14:"source:process";O:19:"RulesTokenEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:14:"path_has_alias";s:9:"\0*\0negate";b:1;}i:3;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:38;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"text:select";s:22:"site:current-page:path";s:5:"match";s:10:"user/reset";}s:14:"\0*\0elementName";s:12:"text_matches";s:9:"\0*\0negate";b:1;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:10:"user_login";}s:16:"\0*\0eventSettings";a:0:{}}i:1;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:1:"5";s:12:"\0*\0elementId";i:1;s:6:"weight";i:1;s:8:"settings";a:0:{}s:4:"name";s:38:"rules_reader_login_redirect_no_profile";s:5:"label";s:32:"Reader Login Redirect No Profile";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:93;s:2:"id";N;s:12:"\0*\0elementId";i:5;s:6:"weight";i:0;s:8:"settings";a:4:{s:3:"url";s:28:"reader/dashboard/profile/add";s:5:"force";s:1:"1";s:11:"destination";b:0;s:11:"url:process";O:22:"RulesURIInputEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:8:"redirect";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:93;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:2:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:123;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:3:{s:14:"account:select";s:7:"account";s:5:"roles";a:1:{i:4;s:1:"4";}s:9:"operation";s:2:"OR";}s:14:"\0*\0elementName";s:13:"user_has_role";s:9:"\0*\0negate";b:0;}i:1;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:123;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:1;s:8:"settings";a:1:{s:11:"data:select";s:21:"account:field-readers";}s:14:"\0*\0elementName";s:13:"data_is_empty";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:10:"user_login";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:5:"label";s:18:"User has logged in";s:5:"group";s:4:"User";s:9:"variables";a:1:{s:7:"account";a:2:{s:4:"type";s:4:"user";s:5:"label";s:14:"logged in user";}}s:15:"access callback";s:29:"rules_user_integration_access";s:6:"module";s:5:"rules";}}','0','1493613848','1');
INSERT INTO `cache_rules` VALUES ('event_user_logout','O:13:"RulesEventSet":9:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:11:"user_logout";s:9:"recursion";b:1;s:11:"\0*\0children";a:1:{i:0;O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";r:1;s:2:"id";s:1:"3";s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:28:"rules_reader_logout_redirect";s:5:"label";s:22:"Reader Logout Redirect";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:3:"url";s:7:"<front>";s:11:"url:process";O:22:"RulesURIInputEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:8:"redirect";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:10;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:11:"user_logout";}s:16:"\0*\0eventSettings";a:0:{}}}s:7:"\0*\0info";a:5:{s:5:"label";s:19:"User has logged out";s:5:"group";s:4:"User";s:9:"variables";a:1:{s:7:"account";a:2:{s:4:"type";s:4:"user";s:5:"label";s:15:"logged out user";}}s:15:"access callback";s:29:"rules_user_integration_access";s:6:"module";s:5:"rules";}}','0','1493613848','1'),('rules_event_whitelist','a:14:{s:10:"user_login";i:0;s:11:"user_insert";i:1;s:11:"user_logout";i:2;s:18:"reading_log_insert";i:3;s:13:"reader_update";i:4;s:13:"points_insert";i:5;s:19:"reader_badge_insert";i:6;s:13:"branch_insert";i:7;s:14:"program_insert";i:8;s:12:"badge_insert";i:9;s:12:"prize_insert";i:10;s:12:"level_insert";i:11;s:19:"reader_prize_insert";i:12;s:13:"badge_presave";i:13;}','0','1493613848','1');
DROP TABLE IF EXISTS `cache_token`;
CREATE TABLE `cache_token` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for token information.';
INSERT INTO `cache_token` VALUES ('field:info','a:75:{s:12:"comment_body";a:5:{s:11:"token types";a:1:{i:0;s:7:"comment";}s:6:"labels";a:6:{i:0;s:7:"Comment";i:1;s:7:"Comment";i:2;s:7:"Comment";i:3;s:7:"Comment";i:4;s:7:"Comment";i:5;s:7:"Comment";}s:7:"bundles";a:1:{s:7:"comment";a:6:{s:17:"comment_node_page";s:18:"Basic page comment";s:20:"comment_node_article";s:15:"Article comment";s:29:"comment_node_customformfields";s:24:"CustomFormFields comment";s:18:"comment_node_panel";s:13:"Panel comment";s:18:"comment_node_event";s:13:"Event comment";s:22:"comment_node_book_list";s:17:"Book List comment";}}s:5:"label";s:7:"Comment";s:11:"description";s:16:"Long text field.";}s:4:"body";a:5:{s:11:"token types";a:1:{i:0;s:4:"node";}s:6:"labels";a:5:{i:0;s:4:"Body";i:1;s:4:"Body";i:2;s:4:"Body";i:3;s:11:"Description";i:4;s:4:"Body";}s:7:"bundles";a:1:{s:4:"node";a:5:{s:4:"page";s:10:"Basic page";s:7:"article";s:7:"Article";s:16:"customformfields";s:16:"CustomFormFields";s:5:"event";s:5:"Event";s:9:"book_list";s:9:"Book List";}}s:5:"label";s:4:"Body";s:11:"description";s:84:"Long text and summary field. Also known as <em class="placeholder">Description</em>.";}s:10:"field_tags";a:5:{s:11:"token types";a:1:{i:0;s:4:"node";}s:6:"labels";a:1:{i:0;s:4:"Tags";}s:7:"bundles";a:1:{s:4:"node";a:1:{s:7:"article";s:7:"Article";}}s:5:"label";s:4:"Tags";s:11:"description";s:21:"Term reference field.";}s:11:"field_image";a:5:{s:11:"token types";a:1:{i:0;s:4:"node";}s:6:"labels";a:1:{i:0;s:5:"Image";}s:7:"bundles";a:1:{s:4:"node";a:1:{s:7:"article";s:7:"Article";}}s:5:"label";s:5:"Image";s:11:"description";s:12:"Image field.";}s:18:"field_branch_phone";a:5:{s:11:"token types";a:1:{i:0;s:6:"branch";}s:6:"labels";a:1:{i:0;s:12:"Branch Phone";}s:7:"bundles";a:1:{s:6:"branch";a:1:{s:6:"branch";s:6:"Branch";}}s:5:"label";s:12:"Branch Phone";s:11:"description";s:11:"Text field.";}s:20:"field_branch_address";a:5:{s:11:"token types";a:1:{i:0;s:6:"branch";}s:6:"labels";a:1:{i:0;s:14:"Branch Address";}s:7:"bundles";a:1:{s:6:"branch";a:1:{s:6:"branch";s:6:"Branch";}}s:5:"label";s:14:"Branch Address";s:11:"description";s:21:"Postal address field.";}s:25:"field_recommended_min_age";a:5:{s:11:"token types";a:1:{i:0;s:7:"program";}s:6:"labels";a:1:{i:0;s:19:"Recommended Min Age";}s:7:"bundles";a:1:{s:7:"program";a:1:{s:7:"program";s:7:"Program";}}s:5:"label";s:19:"Recommended Min Age";s:11:"description";s:14:"Integer field.";}s:25:"field_recommended_max_age";a:5:{s:11:"token types";a:1:{i:0;s:7:"program";}s:6:"labels";a:1:{i:0;s:19:"Recommended Max Age";}s:7:"bundles";a:1:{s:7:"program";a:1:{s:7:"program";s:7:"Program";}}s:5:"label";s:19:"Recommended Max Age";s:11:"description";s:14:"Integer field.";}s:18:"field_scoring_type";a:5:{s:11:"token types";a:1:{i:0;s:7:"program";}s:6:"labels";a:1:{i:0;s:12:"Scoring Type";}s:7:"bundles";a:1:{s:7:"program";a:1:{s:7:"program";s:7:"Program";}}s:5:"label";s:12:"Scoring Type";s:11:"description";s:18:"List (text) field.";}s:26:"field_per_unit_point_value";a:5:{s:11:"token types";a:1:{i:0;s:7:"program";}s:6:"labels";a:1:{i:0;s:20:"Per Unit Point Value";}s:7:"bundles";a:1:{s:7:"program";a:1:{s:7:"program";s:7:"Program";}}s:5:"label";s:20:"Per Unit Point Value";s:11:"description";s:14:"Integer field.";}s:25:"field_program_description";a:5:{s:11:"token types";a:1:{i:0;s:7:"program";}s:6:"labels";a:1:{i:0;s:19:"Program Description";}s:7:"bundles";a:1:{s:7:"program";a:1:{s:7:"program";s:7:"Program";}}s:5:"label";s:19:"Program Description";s:11:"description";s:16:"Long text field.";}s:18:"field_level_number";a:5:{s:11:"token types";a:1:{i:0;s:5:"level";}s:6:"labels";a:1:{i:0;s:12:"Level Number";}s:7:"bundles";a:1:{s:5:"level";a:1:{s:5:"level";s:5:"Level";}}s:5:"label";s:12:"Level Number";s:11:"description";s:14:"Integer field.";}s:21:"field_point_threshold";a:5:{s:11:"token types";a:1:{i:0;s:5:"level";}s:6:"labels";a:1:{i:0;s:15:"Point Threshold";}s:7:"bundles";a:1:{s:5:"level";a:1:{s:5:"level";s:5:"Level";}}s:5:"label";s:15:"Point Threshold";s:11:"description";s:14:"Integer field.";}s:19:"field_level_message";a:5:{s:11:"token types";a:1:{i:0;s:5:"level";}s:6:"labels";a:1:{i:0;s:13:"Level Message";}s:7:"bundles";a:1:{s:5:"level";a:1:{s:5:"level";s:5:"Level";}}s:5:"label";s:13:"Level Message";s:11:"description";s:16:"Long text field.";}s:16:"field_first_name";a:5:{s:11:"token types";a:2:{i:0;s:4:"user";i:1;s:6:"reader";}s:6:"labels";a:2:{i:0;s:10:"First Name";i:1;s:10:"First Name";}s:7:"bundles";a:2:{s:4:"user";a:1:{s:4:"user";s:4:"User";}s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:10:"First Name";s:11:"description";s:11:"Text field.";}s:15:"field_last_name";a:5:{s:11:"token types";a:2:{i:0;s:4:"user";i:1;s:6:"reader";}s:6:"labels";a:2:{i:0;s:9:"Last Name";i:1;s:9:"Last Name";}s:7:"bundles";a:2:{s:4:"user";a:1:{s:4:"user";s:4:"User";}s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:9:"Last Name";s:11:"description";s:11:"Text field.";}s:21:"field_favorite_branch";a:5:{s:11:"token types";a:1:{i:0;s:4:"user";}s:6:"labels";a:1:{i:0;s:15:"Favorite Branch";}s:7:"bundles";a:1:{s:4:"user";a:1:{s:4:"user";s:4:"User";}}s:5:"label";s:15:"Favorite Branch";s:11:"description";s:23:"Entity Reference field.";}s:23:"field_program_reference";a:5:{s:11:"token types";a:8:{i:0;s:5:"level";i:1;s:10:"reader_log";i:2;s:11:"reading_log";i:3;s:12:"reader_prize";i:4;s:19:"reader_activity_log";i:5;s:6:"points";i:6;s:5:"prize";i:7;s:8:"activity";}s:6:"labels";a:9:{i:0;s:17:"Program Reference";i:1;s:17:"Program Reference";i:2;s:17:"Program Reference";i:3;s:17:"Program Reference";i:4;s:17:"Program Reference";i:5;s:17:"Program Reference";i:6;s:17:"Program Reference";i:7;s:17:"Program Reference";i:8;s:17:"Program Reference";}s:7:"bundles";a:8:{s:5:"level";a:1:{s:5:"level";s:5:"Level";}s:10:"reader_log";a:1:{s:10:"reader_log";s:10:"Reader Log";}s:11:"reading_log";a:1:{s:11:"reading_log";s:11:"Reading Log";}s:12:"reader_prize";a:1:{s:12:"reader_prize";s:12:"Reader Prize";}s:19:"reader_activity_log";a:1:{s:19:"reader_activity_log";s:19:"Reader Activity Log";}s:6:"points";a:1:{s:6:"points";s:6:"Points";}s:5:"prize";a:1:{s:5:"prize";s:5:"Prize";}s:8:"activity";a:2:{s:8:"activity";s:8:"Activity";s:11:"secret_code";s:11:"Secret Code";}}s:5:"label";s:17:"Program Reference";s:11:"description";s:23:"Entity Reference field.";}s:9:"field_age";a:5:{s:11:"token types";a:1:{i:0;s:6:"reader";}s:6:"labels";a:1:{i:0;s:3:"Age";}s:7:"bundles";a:1:{s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:3:"Age";s:11:"description";s:14:"Integer field.";}s:11:"field_grade";a:5:{s:11:"token types";a:1:{i:0;s:6:"reader";}s:6:"labels";a:1:{i:0;s:5:"Grade";}s:7:"bundles";a:1:{s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:5:"Grade";s:11:"description";s:18:"List (text) field.";}s:13:"field_program";a:5:{s:11:"token types";a:3:{i:0;s:6:"reader";i:1;s:14:"drawing_ticket";i:2;s:4:"node";}s:6:"labels";a:3:{i:0;s:7:"Program";i:1;s:7:"Program";i:2;s:7:"Program";}s:7:"bundles";a:3:{s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}s:14:"drawing_ticket";a:1:{s:14:"drawing_ticket";s:14:"Drawing Ticket";}s:4:"node";a:1:{s:5:"event";s:5:"Event";}}s:5:"label";s:7:"Program";s:11:"description";s:23:"Entity Reference field.";}s:11:"field_level";a:5:{s:11:"token types";a:2:{i:0;s:12:"reader_prize";i:1;s:13:"reader_ticket";}s:6:"labels";a:2:{i:0;s:5:"Level";i:1;s:5:"Level";}s:7:"bundles";a:2:{s:12:"reader_prize";a:1:{s:12:"reader_prize";s:12:"Reader Prize";}s:13:"reader_ticket";a:1:{s:13:"reader_ticket";s:13:"Reader Ticket";}}s:5:"label";s:5:"Level";s:11:"description";s:23:"Entity Reference field.";}s:13:"field_readers";a:5:{s:11:"token types";a:10:{i:0;s:4:"user";i:1;s:10:"reader_log";i:2;s:14:"drawing_ticket";i:3;s:11:"reading_log";i:4;s:12:"reader_prize";i:5;s:6:"points";i:6;s:12:"reader_badge";i:7;s:19:"reader_activity_log";i:8;s:13:"reader_ticket";i:9;s:12:"activity_log";}s:6:"labels";a:10:{i:0;s:7:"Readers";i:1;s:7:"Readers";i:2;s:7:"Readers";i:3;s:7:"Readers";i:4;s:7:"Readers";i:5;s:7:"Readers";i:6;s:7:"Readers";i:7;s:7:"Readers";i:8;s:7:"Readers";i:9;s:7:"Readers";}s:7:"bundles";a:10:{s:4:"user";a:1:{s:4:"user";s:4:"User";}s:10:"reader_log";a:1:{s:10:"reader_log";s:10:"Reader Log";}s:14:"drawing_ticket";a:1:{s:14:"drawing_ticket";s:14:"Drawing Ticket";}s:11:"reading_log";a:1:{s:11:"reading_log";s:11:"Reading Log";}s:12:"reader_prize";a:1:{s:12:"reader_prize";s:12:"Reader Prize";}s:6:"points";a:1:{s:6:"points";s:6:"Points";}s:12:"reader_badge";a:1:{s:12:"reader_badge";s:12:"Reader Badge";}s:19:"reader_activity_log";a:1:{s:19:"reader_activity_log";s:19:"Reader Activity Log";}s:13:"reader_ticket";a:1:{s:13:"reader_ticket";s:13:"Reader Ticket";}s:12:"activity_log";a:1:{s:12:"activity_log";s:12:"Activity Log";}}s:5:"label";s:7:"Readers";s:11:"description";s:23:"Entity Reference field.";}s:16:"field_parent_uid";a:5:{s:11:"token types";a:1:{i:0;s:6:"reader";}s:6:"labels";a:1:{i:0;s:10:"Parent UID";}s:7:"bundles";a:1:{s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:10:"Parent UID";s:11:"description";s:23:"Entity Reference field.";}s:16:"field_book_title";a:5:{s:11:"token types";a:2:{i:0;s:10:"reader_log";i:1;s:11:"reading_log";}s:6:"labels";a:2:{i:0;s:10:"Book Title";i:1;s:10:"Book Title";}s:7:"bundles";a:2:{s:10:"reader_log";a:1:{s:10:"reader_log";s:10:"Reader Log";}s:11:"reading_log";a:1:{s:11:"reading_log";s:11:"Reading Log";}}s:5:"label";s:10:"Book Title";s:11:"description";s:11:"Text field.";}s:21:"field_units_completed";a:5:{s:11:"token types";a:2:{i:0;s:10:"reader_log";i:1;s:11:"reading_log";}s:6:"labels";a:2:{i:0;s:15:"Units Completed";i:1;s:15:"Units Completed";}s:7:"bundles";a:2:{s:10:"reader_log";a:1:{s:10:"reader_log";s:10:"Reader Log";}s:11:"reading_log";a:1:{s:11:"reading_log";s:11:"Reading Log";}}s:5:"label";s:15:"Units Completed";s:11:"description";s:14:"Integer field.";}s:15:"field_unit_type";a:5:{s:11:"token types";a:2:{i:0;s:10:"reader_log";i:1;s:11:"reading_log";}s:6:"labels";a:2:{i:0;s:9:"Unit Type";i:1;s:9:"Unit Type";}s:7:"bundles";a:2:{s:10:"reader_log";a:1:{s:10:"reader_log";s:10:"Reader Log";}s:11:"reading_log";a:1:{s:11:"reading_log";s:11:"Reading Log";}}s:5:"label";s:9:"Unit Type";s:11:"description";s:11:"Text field.";}s:19:"field_points_earned";a:5:{s:11:"token types";a:2:{i:0;s:10:"reader_log";i:1;s:12:"activity_log";}s:6:"labels";a:2:{i:0;s:13:"Points Earned";i:1;s:13:"Points Earned";}s:7:"bundles";a:2:{s:10:"reader_log";a:1:{s:10:"reader_log";s:10:"Reader Log";}s:12:"activity_log";a:1:{s:12:"activity_log";s:12:"Activity Log";}}s:5:"label";s:13:"Points Earned";s:11:"description";s:14:"Integer field.";}s:20:"field_current_reader";a:5:{s:11:"token types";a:2:{i:0;s:4:"user";i:1;s:11:"nag_message";}s:6:"labels";a:2:{i:0;s:14:"Current Reader";i:1;s:14:"Current Reader";}s:7:"bundles";a:2:{s:4:"user";a:1:{s:4:"user";s:4:"User";}s:11:"nag_message";a:1:{s:11:"nag_message";s:11:"Nag Message";}}s:5:"label";s:14:"Current Reader";s:11:"description";s:23:"Entity Reference field.";}s:17:"field_badge_image";a:5:{s:11:"token types";a:2:{i:0;s:4:"term";i:1;s:5:"badge";}s:6:"labels";a:2:{i:0;s:11:"Badge Image";i:1;s:11:"Badge Image";}s:7:"bundles";a:2:{s:4:"term";a:1:{s:5:"badge";s:5:"Badge";}s:5:"badge";a:1:{s:5:"badge";s:5:"Badge";}}s:5:"label";s:11:"Badge Image";s:11:"description";s:12:"Image field.";}s:12:"field_author";a:5:{s:11:"token types";a:2:{i:0;s:10:"reader_log";i:1;s:11:"reading_log";}s:6:"labels";a:2:{i:0;s:6:"Author";i:1;s:6:"Author";}s:7:"bundles";a:2:{s:10:"reader_log";a:1:{s:10:"reader_log";s:10:"Reader Log";}s:11:"reading_log";a:1:{s:11:"reading_log";s:11:"Reading Log";}}s:5:"label";s:6:"Author";s:11:"description";s:11:"Text field.";}s:11:"field_stars";a:5:{s:11:"token types";a:2:{i:0;s:10:"reader_log";i:1;s:11:"reading_log";}s:6:"labels";a:2:{i:0;s:5:"Stars";i:1;s:5:"Stars";}s:7:"bundles";a:2:{s:10:"reader_log";a:1:{s:10:"reader_log";s:10:"Reader Log";}s:11:"reading_log";a:1:{s:11:"reading_log";s:11:"Reading Log";}}s:5:"label";s:5:"Stars";s:11:"description";s:18:"List (text) field.";}s:11:"field_prize";a:5:{s:11:"token types";a:1:{i:0;s:4:"node";}s:6:"labels";a:1:{i:0;s:5:"Prize";}s:7:"bundles";a:1:{s:4:"node";a:1:{s:16:"customformfields";s:16:"CustomFormFields";}}s:5:"label";s:5:"Prize";s:11:"description";s:21:"Term reference field.";}s:11:"field_badge";a:5:{s:11:"token types";a:1:{i:0;s:4:"node";}s:6:"labels";a:1:{i:0;s:5:"badge";}s:7:"bundles";a:1:{s:4:"node";a:1:{s:16:"customformfields";s:16:"CustomFormFields";}}s:5:"label";s:5:"badge";s:11:"description";s:21:"Term reference field.";}s:15:"field_ticket_id";a:5:{s:11:"token types";a:1:{i:0;s:14:"drawing_ticket";}s:6:"labels";a:1:{i:0;s:9:"Ticket ID";}s:7:"bundles";a:1:{s:14:"drawing_ticket";a:1:{s:14:"drawing_ticket";s:14:"Drawing Ticket";}}s:5:"label";s:9:"Ticket ID";s:11:"description";s:14:"Integer field.";}s:23:"field_prize_description";a:5:{s:11:"token types";a:1:{i:0;s:5:"prize";}s:6:"labels";a:1:{i:0;s:17:"Prize Description";}s:7:"bundles";a:1:{s:5:"prize";a:1:{s:5:"prize";s:5:"Prize";}}s:5:"label";s:17:"Prize Description";s:11:"description";s:16:"Long text field.";}s:20:"field_per_unit_label";a:5:{s:11:"token types";a:1:{i:0;s:7:"program";}s:6:"labels";a:1:{i:0;s:14:"Per Unit Label";}s:7:"bundles";a:1:{s:7:"program";a:1:{s:7:"program";s:7:"Program";}}s:5:"label";s:14:"Per Unit Label";s:11:"description";s:18:"List (text) field.";}s:21:"field_school_address_";a:5:{s:11:"token types";a:1:{i:0;s:6:"school";}s:6:"labels";a:1:{i:0;s:15:"School Address ";}s:7:"bundles";a:1:{s:6:"school";a:1:{s:6:"school";s:6:"School";}}s:5:"label";s:15:"School Address ";s:11:"description";s:16:"Long text field.";}s:19:"field_reader_school";a:5:{s:11:"token types";a:1:{i:0;s:6:"reader";}s:6:"labels";a:1:{i:0;s:13:"Reader School";}s:7:"bundles";a:1:{s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:13:"Reader School";s:11:"description";s:23:"Entity Reference field.";}s:23:"field_badge_description";a:5:{s:11:"token types";a:1:{i:0;s:5:"badge";}s:6:"labels";a:1:{i:0;s:17:"Badge Description";}s:7:"bundles";a:1:{s:5:"badge";a:1:{s:5:"badge";s:5:"Badge";}}s:5:"label";s:17:"Badge Description";s:11:"description";s:16:"Long text field.";}s:12:"field_status";a:5:{s:11:"token types";a:1:{i:0;s:12:"reader_prize";}s:6:"labels";a:1:{i:0;s:6:"Status";}s:7:"bundles";a:1:{s:12:"reader_prize";a:1:{s:12:"reader_prize";s:12:"Reader Prize";}}s:5:"label";s:6:"Status";s:11:"description";s:18:"List (text) field.";}s:12:"field_points";a:5:{s:11:"token types";a:1:{i:0;s:6:"points";}s:6:"labels";a:1:{i:0;s:6:"Points";}s:7:"bundles";a:1:{s:6:"points";a:1:{s:6:"points";s:6:"Points";}}s:5:"label";s:6:"Points";s:11:"description";s:14:"Integer field.";}s:27:"field_reading_log_reference";a:5:{s:11:"token types";a:1:{i:0;s:6:"points";}s:6:"labels";a:1:{i:0;s:21:"Reading Log Reference";}s:7:"bundles";a:1:{s:6:"points";a:1:{s:6:"points";s:6:"Points";}}s:5:"label";s:21:"Reading Log Reference";s:11:"description";s:23:"Entity Reference field.";}s:24:"field_activity_log_title";a:5:{s:11:"token types";a:1:{i:0;s:22:"activity_log_reference";}s:6:"labels";a:1:{i:0;s:18:"Activity Log Title";}s:7:"bundles";a:1:{s:22:"activity_log_reference";a:1:{s:22:"activity_log_reference";s:22:"Activity Log Reference";}}s:5:"label";s:18:"Activity Log Title";s:11:"description";s:11:"Text field.";}s:30:"field_activity_log_description";a:5:{s:11:"token types";a:1:{i:0;s:22:"activity_log_reference";}s:6:"labels";a:1:{i:0;s:24:"Activity Log Description";}s:7:"bundles";a:1:{s:22:"activity_log_reference";a:1:{s:22:"activity_log_reference";s:22:"Activity Log Reference";}}s:5:"label";s:24:"Activity Log Description";s:11:"description";s:16:"Long text field.";}s:22:"field_points_reference";a:5:{s:11:"token types";a:4:{i:0;s:22:"activity_log_reference";i:1;s:11:"reading_log";i:2;s:19:"reader_activity_log";i:3;s:6:"reader";}s:6:"labels";a:4:{i:0;s:16:"Points Reference";i:1;s:16:"Points Reference";i:2;s:16:"Points Reference";i:3;s:16:"Points Reference";}s:7:"bundles";a:4:{s:22:"activity_log_reference";a:1:{s:22:"activity_log_reference";s:22:"Activity Log Reference";}s:11:"reading_log";a:1:{s:11:"reading_log";s:11:"Reading Log";}s:19:"reader_activity_log";a:1:{s:19:"reader_activity_log";s:19:"Reader Activity Log";}s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:16:"Points Reference";s:11:"description";s:23:"Entity Reference field.";}s:28:"field_activity_log_reference";a:5:{s:11:"token types";a:2:{i:0;s:6:"points";i:1;s:19:"reader_activity_log";}s:6:"labels";a:2:{i:0;s:22:"Activity Log Reference";i:1;s:22:"Activity Log Reference";}s:7:"bundles";a:2:{s:6:"points";a:1:{s:6:"points";s:6:"Points";}s:19:"reader_activity_log";a:1:{s:19:"reader_activity_log";s:19:"Reader Activity Log";}}s:5:"label";s:22:"Activity Log Reference";s:11:"description";s:23:"Entity Reference field.";}s:21:"field_prize_reference";a:5:{s:11:"token types";a:2:{i:0;s:12:"reader_prize";i:1;s:5:"level";}s:6:"labels";a:2:{i:0;s:15:"Prize Reference";i:1;s:15:"Prize Reference";}s:7:"bundles";a:2:{s:12:"reader_prize";a:1:{s:12:"reader_prize";s:12:"Reader Prize";}s:5:"level";a:1:{s:5:"level";s:5:"Level";}}s:5:"label";s:15:"Prize Reference";s:11:"description";s:23:"Entity Reference field.";}s:18:"field_reader_badge";a:5:{s:11:"token types";a:4:{i:0;s:12:"reader_badge";i:1;s:5:"level";i:2;s:8:"activity";i:3;s:12:"activity_log";}s:6:"labels";a:5:{i:0;s:12:"Reader Badge";i:1;s:12:"Reader Badge";i:2;s:12:"Reader Badge";i:3;s:12:"Reader Badge";i:4;s:12:"Reader Badge";}s:7:"bundles";a:4:{s:12:"reader_badge";a:1:{s:12:"reader_badge";s:12:"Reader Badge";}s:5:"level";a:1:{s:5:"level";s:5:"Level";}s:8:"activity";a:2:{s:8:"activity";s:8:"Activity";s:11:"secret_code";s:11:"Secret Code";}s:12:"activity_log";a:1:{s:12:"activity_log";s:12:"Activity Log";}}s:5:"label";s:12:"Reader Badge";s:11:"description";s:23:"Entity Reference field.";}s:21:"field_drawing_tickets";a:5:{s:11:"token types";a:1:{i:0;s:5:"level";}s:6:"labels";a:1:{i:0;s:15:"Drawing Tickets";}s:7:"bundles";a:1:{s:5:"level";a:1:{s:5:"level";s:5:"Level";}}s:5:"label";s:15:"Drawing Tickets";s:11:"description";s:14:"Integer field.";}s:13:"field_message";a:5:{s:11:"token types";a:1:{i:0;s:11:"nag_message";}s:6:"labels";a:1:{i:0;s:7:"Message";}s:7:"bundles";a:1:{s:11:"nag_message";a:1:{s:11:"nag_message";s:11:"Nag Message";}}s:5:"label";s:7:"Message";s:11:"description";s:11:"Text field.";}s:20:"field_current_points";a:5:{s:11:"token types";a:1:{i:0;s:6:"reader";}s:6:"labels";a:1:{i:0;s:14:"Current Points";}s:7:"bundles";a:1:{s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:14:"Current Points";s:11:"description";s:14:"Integer field.";}s:19:"field_current_level";a:5:{s:11:"token types";a:1:{i:0;s:6:"reader";}s:6:"labels";a:1:{i:0;s:13:"Current Level";}s:7:"bundles";a:1:{s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:13:"Current Level";s:11:"description";s:23:"Entity Reference field.";}s:21:"field_current_program";a:5:{s:11:"token types";a:1:{i:0;s:6:"reader";}s:6:"labels";a:1:{i:0;s:15:"Current Program";}s:7:"bundles";a:1:{s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:15:"Current Program";s:11:"description";s:23:"Entity Reference field.";}s:26:"field_current_reader_badge";a:5:{s:11:"token types";a:1:{i:0;s:6:"reader";}s:6:"labels";a:1:{i:0;s:20:"Current Reader Badge";}s:7:"bundles";a:1:{s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:20:"Current Reader Badge";s:11:"description";s:23:"Entity Reference field.";}s:27:"field_current_reader_prizes";a:5:{s:11:"token types";a:1:{i:0;s:6:"reader";}s:6:"labels";a:1:{i:0;s:21:"Current Reader Prizes";}s:7:"bundles";a:1:{s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:21:"Current Reader Prizes";s:11:"description";s:23:"Entity Reference field.";}s:29:"field_current_drawing_tickets";a:5:{s:11:"token types";a:1:{i:0;s:6:"reader";}s:6:"labels";a:1:{i:0;s:23:"Current Drawing Tickets";}s:7:"bundles";a:1:{s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:23:"Current Drawing Tickets";s:11:"description";s:23:"Entity Reference field.";}s:19:"field_ticket_status";a:5:{s:11:"token types";a:1:{i:0;s:13:"reader_ticket";}s:6:"labels";a:1:{i:0;s:13:"Ticket Status";}s:7:"bundles";a:1:{s:13:"reader_ticket";a:1:{s:13:"reader_ticket";s:13:"Reader Ticket";}}s:5:"label";s:13:"Ticket Status";s:11:"description";s:18:"List (text) field.";}s:19:"field_badge_message";a:5:{s:11:"token types";a:2:{i:0;s:12:"reader_badge";i:1;s:5:"badge";}s:6:"labels";a:2:{i:0;s:13:"Badge Message";i:1;s:13:"Badge Message";}s:7:"bundles";a:2:{s:12:"reader_badge";a:1:{s:12:"reader_badge";s:12:"Reader Badge";}s:5:"badge";a:1:{s:5:"badge";s:5:"Badge";}}s:5:"label";s:13:"Badge Message";s:11:"description";s:11:"Text field.";}s:18:"field_library_card";a:5:{s:11:"token types";a:1:{i:0;s:4:"user";}s:6:"labels";a:1:{i:0;s:12:"Library Card";}s:7:"bundles";a:1:{s:4:"user";a:1:{s:4:"user";s:4:"User";}}s:5:"label";s:12:"Library Card";s:11:"description";s:11:"Text field.";}s:26:"field_account_family_notes";a:5:{s:11:"token types";a:1:{i:0;s:4:"user";}s:6:"labels";a:1:{i:0;s:20:"Account/Family Notes";}s:7:"bundles";a:1:{s:4:"user";a:1:{s:4:"user";s:4:"User";}}s:5:"label";s:20:"Account/Family Notes";s:11:"description";s:16:"Long text field.";}s:19:"field_prize_message";a:5:{s:11:"token types";a:2:{i:0;s:5:"prize";i:1;s:12:"reader_prize";}s:6:"labels";a:2:{i:0;s:13:"Prize Message";i:1;s:13:"Prize Message";}s:7:"bundles";a:2:{s:5:"prize";a:1:{s:5:"prize";s:5:"Prize";}s:12:"reader_prize";a:1:{s:12:"reader_prize";s:12:"Reader Prize";}}s:5:"label";s:13:"Prize Message";s:11:"description";s:11:"Text field.";}s:26:"field_activity_description";a:5:{s:11:"token types";a:1:{i:0;s:8:"activity";}s:6:"labels";a:2:{i:0;s:11:"Description";i:1;s:11:"Description";}s:7:"bundles";a:1:{s:8:"activity";a:2:{s:8:"activity";s:8:"Activity";s:11:"secret_code";s:11:"Secret Code";}}s:5:"label";s:11:"Description";s:11:"description";s:16:"Long text field.";}s:21:"field_activity_points";a:5:{s:11:"token types";a:1:{i:0;s:8:"activity";}s:6:"labels";a:2:{i:0;s:14:"Points Awarded";i:1;s:14:"Points Awarded";}s:7:"bundles";a:1:{s:8:"activity";a:2:{s:8:"activity";s:8:"Activity";s:11:"secret_code";s:11:"Secret Code";}}s:5:"label";s:14:"Points Awarded";s:11:"description";s:14:"Integer field.";}s:24:"field_activity_reference";a:5:{s:11:"token types";a:1:{i:0;s:12:"activity_log";}s:6:"labels";a:1:{i:0;s:18:"Activity Reference";}s:7:"bundles";a:1:{s:12:"activity_log";a:1:{s:12:"activity_log";s:12:"Activity Log";}}s:5:"label";s:18:"Activity Reference";s:11:"description";s:23:"Entity Reference field.";}s:27:"field_secret_code_reference";a:5:{s:11:"token types";a:1:{i:0;s:12:"activity_log";}s:6:"labels";a:1:{i:0;s:21:"Secret Code Reference";}s:7:"bundles";a:1:{s:12:"activity_log";a:1:{s:12:"activity_log";s:12:"Activity Log";}}s:5:"label";s:21:"Secret Code Reference";s:11:"description";s:23:"Entity Reference field.";}s:24:"field_claimed_activities";a:5:{s:11:"token types";a:1:{i:0;s:6:"reader";}s:6:"labels";a:1:{i:0;s:18:"Claimed Activities";}s:7:"bundles";a:1:{s:6:"reader";a:1:{s:6:"reader";s:6:"Reader";}}s:5:"label";s:18:"Claimed Activities";s:11:"description";s:23:"Entity Reference field.";}s:19:"field_activity_code";a:5:{s:11:"token types";a:1:{i:0;s:8:"activity";}s:6:"labels";a:1:{i:0;s:11:"Secret Code";}s:7:"bundles";a:1:{s:8:"activity";a:1:{s:11:"secret_code";s:11:"Secret Code";}}s:5:"label";s:11:"Secret Code";s:11:"description";s:11:"Text field.";}s:10:"field_date";a:5:{s:11:"token types";a:1:{i:0;s:4:"node";}s:6:"labels";a:1:{i:0;s:4:"Date";}s:7:"bundles";a:1:{s:4:"node";a:1:{s:5:"event";s:5:"Event";}}s:5:"label";s:4:"Date";s:11:"description";s:11:"Date field.";}s:18:"field_phone_number";a:5:{s:11:"token types";a:1:{i:0;s:4:"user";}s:6:"labels";a:1:{i:0;s:12:"Phone Number";}s:7:"bundles";a:1:{s:4:"user";a:1:{s:4:"user";s:4:"User";}}s:5:"label";s:12:"Phone Number";s:11:"description";s:11:"Text field.";}s:17:"field_bl_b_author";a:5:{s:11:"token types";a:1:{i:0;s:21:"field_collection_item";}s:6:"labels";a:1:{i:0;s:11:"Book Author";}s:7:"bundles";a:1:{s:21:"field_collection_item";a:1:{s:20:"field_booklist_books";s:37:"Field collection field_booklist_books";}}s:5:"label";s:11:"Book Author";s:11:"description";s:11:"Text field.";}s:16:"field_bl_b_image";a:5:{s:11:"token types";a:1:{i:0;s:21:"field_collection_item";}s:6:"labels";a:1:{i:0;s:11:"Cover Image";}s:7:"bundles";a:1:{s:21:"field_collection_item";a:1:{s:20:"field_booklist_books";s:37:"Field collection field_booklist_books";}}s:5:"label";s:11:"Cover Image";s:11:"description";s:12:"Image field.";}s:15:"field_bl_b_link";a:5:{s:11:"token types";a:1:{i:0;s:21:"field_collection_item";}s:6:"labels";a:1:{i:0;s:12:"Catalog Link";}s:7:"bundles";a:1:{s:21:"field_collection_item";a:1:{s:20:"field_booklist_books";s:37:"Field collection field_booklist_books";}}s:5:"label";s:12:"Catalog Link";s:11:"description";s:11:"Link field.";}s:16:"field_bl_b_title";a:5:{s:11:"token types";a:1:{i:0;s:21:"field_collection_item";}s:6:"labels";a:1:{i:0;s:10:"Book Title";}s:7:"bundles";a:1:{s:21:"field_collection_item";a:1:{s:20:"field_booklist_books";s:37:"Field collection field_booklist_books";}}s:5:"label";s:10:"Book Title";s:11:"description";s:11:"Text field.";}s:20:"field_booklist_books";a:5:{s:11:"token types";a:1:{i:0;s:4:"node";}s:6:"labels";a:1:{i:0;s:5:"Books";}s:7:"bundles";a:1:{s:4:"node";a:1:{s:9:"book_list";s:9:"Book List";}}s:5:"label";s:5:"Books";s:11:"description";s:23:"Field collection field.";}}','0','1493614688','1');
INSERT INTO `cache_token` VALUES ('info:en','a:2:{s:6:"tokens";a:92:{s:4:"node";a:48:{s:6:"author";a:3:{s:4:"name";s:6:"Author";s:11:"description";s:23:"The author of the node.";s:4:"type";s:4:"user";}s:4:"body";a:3:{s:4:"name";s:4:"Body";s:11:"description";s:140:"The main body text of the node. The following properties may be appended to the token: value (Text), summary (Summary), format (Text format)";s:7:"dynamic";b:1;}s:20:"field-booklist-books";a:4:{s:4:"name";s:5:"Books";s:11:"description";s:29:"Field "field_booklist_books".";s:4:"type";s:27:"list<field_collection_item>";s:12:"entity-token";b:1;}s:20:"field_booklist_books";a:3:{s:4:"name";s:5:"Books";s:11:"description";s:23:"Field collection field.";s:6:"module";s:5:"token";}s:13:"comment-count";a:2:{s:4:"name";s:13:"Comment count";s:11:"description";s:40:"The number of comments posted on a node.";}s:8:"comments";a:4:{s:4:"name";s:8:"Comments";s:11:"description";s:18:"The node comments.";s:4:"type";s:13:"list<comment>";s:12:"entity-token";b:1;}s:7:"comment";a:4:{s:4:"name";s:16:"Comments allowed";s:11:"description";s:97:"Whether comments are allowed on this node: 0 = no, 1 = closed (read only), 2 = open (read/write).";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:3:"nid";a:2:{s:4:"name";s:10:"Content ID";s:11:"description";s:45:"The unique ID of the content item, or "node".";}s:12:"content-type";a:3:{s:4:"name";s:12:"Content type";s:11:"description";s:29:"The content type of the node.";s:4:"type";s:12:"content-type";}s:8:"revision";a:4:{s:4:"name";s:16:"Creates revision";s:11:"description";s:48:"Whether saving this node creates a new revision.";s:4:"type";s:7:"boolean";s:12:"entity-token";b:1;}s:10:"field-date";a:5:{s:4:"name";s:4:"Date";s:11:"description";s:133:"Field "field_date". The following properties may be appended to the token: value (Start date), value2 (End date), duration (Duration)";s:4:"type";s:6:"struct";s:12:"entity-token";b:1;s:7:"dynamic";b:1;}s:10:"field_date";a:3:{s:4:"name";s:4:"Date";s:11:"description";s:11:"Date field.";s:6:"module";s:5:"token";}s:7:"changed";a:3:{s:4:"name";s:12:"Date changed";s:11:"description";s:44:"The date the node was most recently updated.";s:4:"type";s:4:"date";}s:7:"created";a:3:{s:4:"name";s:12:"Date created";s:11:"description";s:29:"The date the node was posted.";s:4:"type";s:4:"date";}s:8:"edit-url";a:2:{s:4:"name";s:8:"Edit URL";s:11:"description";s:32:"The URL of the node''s edit page.";}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:11:"feed-source";a:3:{s:4:"name";s:11:"Feed source";s:11:"description";s:40:"The node the feed item was sourced from.";s:4:"type";s:4:"node";}s:11:"field_image";a:3:{s:4:"name";s:5:"Image";s:11:"description";s:12:"Image field.";s:6:"module";s:5:"token";}s:11:"field-image";a:5:{s:4:"name";s:5:"Image";s:11:"description";s:140:"Field "field_image". The following properties may be appended to the token: file (The image file.), alt (The &quot;Alt&quot; attribute text)";s:4:"type";s:6:"struct";s:12:"entity-token";b:1;s:7:"dynamic";b:1;}s:6:"is-new";a:4:{s:4:"name";s:6:"Is new";s:11:"description";s:58:"Whether the node is new and not saved to the database yet.";s:4:"type";s:7:"boolean";s:12:"entity-token";b:1;}s:8:"language";a:2:{s:4:"name";s:8:"Language";s:11:"description";s:36:"The language the node is written in.";}s:9:"last-view";a:3:{s:4:"name";s:9:"Last view";s:11:"description";s:47:"The date on which a visitor last read the node.";s:4:"type";s:4:"date";}s:9:"menu-link";a:3:{s:4:"name";s:9:"Menu link";s:11:"description";s:28:"The menu link for this node.";s:4:"type";s:9:"menu-link";}s:17:"comment-count-new";a:2:{s:4:"name";s:17:"New comment count";s:11:"description";s:72:"The number of comments posted on a node since the reader last viewed it.";}s:5:"views";a:4:{s:4:"name";s:15:"Number of views";s:11:"description";s:46:"The number of visitors who have read the node.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:11:"total-count";a:2:{s:4:"name";s:15:"Number of views";s:11:"description";s:46:"The number of visitors who have read the node.";}s:8:"original";a:4:{s:4:"name";s:13:"Original node";s:11:"description";s:61:"The original node data if the node is being updated or saved.";s:6:"module";s:5:"token";s:4:"type";s:4:"node";}s:11:"field-prize";a:4:{s:4:"name";s:5:"Prize";s:11:"description";s:20:"Field "field_prize".";s:4:"type";s:4:"term";s:12:"entity-token";b:1;}s:11:"field_prize";a:3:{s:4:"name";s:5:"Prize";s:11:"description";s:21:"Term reference field.";s:6:"module";s:5:"token";}s:13:"field-program";a:4:{s:4:"name";s:7:"Program";s:11:"description";s:22:"Field "field_program".";s:4:"type";s:13:"list<program>";s:12:"entity-token";b:1;}s:13:"field_program";a:3:{s:4:"name";s:7:"Program";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:7:"promote";a:4:{s:4:"name";s:21:"Promoted to frontpage";s:11:"description";s:46:"Whether the node is promoted to the frontpage.";s:4:"type";s:7:"boolean";s:12:"entity-token";b:1;}s:3:"vid";a:2:{s:4:"name";s:11:"Revision ID";s:11:"description";s:44:"The unique ID of the node''s latest revision.";}s:3:"log";a:2:{s:4:"name";s:20:"Revision log message";s:11:"description";s:60:"The explanation of the most recent changes made to the node.";}s:6:"status";a:4:{s:4:"name";s:6:"Status";s:11:"description";s:45:"Whether the node is published or unpublished.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:6:"sticky";a:4:{s:4:"name";s:15:"Sticky in lists";s:11:"description";s:70:"Whether the node is displayed at the top of lists in which it appears.";s:4:"type";s:7:"boolean";s:12:"entity-token";b:1;}s:7:"summary";a:2:{s:4:"name";s:7:"Summary";s:11:"description";s:41:"The summary of the node''s main body text.";}s:10:"field_tags";a:3:{s:4:"name";s:4:"Tags";s:11:"description";s:21:"Term reference field.";s:6:"module";s:5:"token";}s:10:"field-tags";a:4:{s:4:"name";s:4:"Tags";s:11:"description";s:19:"Field "field_tags".";s:4:"type";s:10:"list<term>";s:12:"entity-token";b:1;}s:5:"title";a:2:{s:4:"name";s:5:"Title";s:11:"description";s:22:"The title of the node.";}s:6:"source";a:3:{s:4:"name";s:23:"Translation source node";s:11:"description";s:56:"The source node for this current node''s translation set.";s:4:"type";s:4:"node";}s:3:"url";a:3:{s:4:"name";s:3:"URL";s:11:"description";s:20:"The URL of the node.";s:4:"type";s:3:"url";}s:9:"day-count";a:2:{s:4:"name";s:11:"Views today";s:11:"description";s:52:"The number of visitors who have read the node today.";}s:9:"day-views";a:4:{s:4:"name";s:11:"Views today";s:11:"description";s:52:"The number of visitors who have read the node today.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:15:"last-transition";a:4:{s:4:"name";s:24:"Workflow last transition";s:11:"description";s:42:"Last workflow state transition of content.";s:4:"type";s:18:"WorkflowTransition";s:6:"module";s:8:"workflow";}s:11:"field-badge";a:4:{s:4:"name";s:5:"badge";s:11:"description";s:20:"Field "field_badge".";s:4:"type";s:4:"term";s:12:"entity-token";b:1;}s:11:"field_badge";a:3:{s:4:"name";s:5:"badge";s:11:"description";s:21:"Term reference field.";s:6:"module";s:5:"token";}}s:12:"content-type";a:5:{s:11:"description";a:2:{s:4:"name";s:11:"Description";s:11:"description";s:45:"The optional description of the content type.";}s:8:"edit-url";a:2:{s:4:"name";s:8:"Edit URL";s:11:"description";s:40:"The URL of the content type''s edit page.";}s:12:"machine-name";a:2:{s:4:"name";s:21:"Machine-readable name";s:11:"description";s:53:"The unique machine-readable name of the content type.";}s:4:"name";a:2:{s:4:"name";s:4:"Name";s:11:"description";s:29:"The name of the content type.";}s:10:"node-count";a:2:{s:4:"name";s:10:"Node count";s:11:"description";s:50:"The number of nodes belonging to the content type.";}}s:4:"term";a:18:{s:11:"parents-all";a:4:{s:4:"name";s:16:"All parent terms";s:11:"description";s:65:"Ancestors of the term, i.e. parent of all above hierarchy levels.";s:4:"type";s:10:"list<term>";s:12:"entity-token";b:1;}s:17:"field-badge-image";a:5:{s:4:"name";s:11:"Badge Image";s:11:"description";s:104:"Field "field_badge_image". The following properties may be appended to the token: file (The image file.)";s:4:"type";s:6:"struct";s:12:"entity-token";b:1;s:7:"dynamic";b:1;}s:17:"field_badge_image";a:3:{s:4:"name";s:11:"Badge Image";s:11:"description";s:12:"Image field.";s:6:"module";s:5:"token";}s:11:"description";a:2:{s:4:"name";s:11:"Description";s:11:"description";s:46:"The optional description of the taxonomy term.";}s:8:"edit-url";a:2:{s:4:"name";s:8:"Edit URL";s:11:"description";s:41:"The URL of the taxonomy term''s edit page.";}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:4:"name";a:2:{s:4:"name";s:4:"Name";s:11:"description";s:30:"The name of the taxonomy term.";}s:10:"node-count";a:2:{s:4:"name";s:10:"Node count";s:11:"description";s:50:"The number of nodes tagged with the taxonomy term.";}s:8:"original";a:4:{s:4:"name";s:22:"Original taxonomy term";s:11:"description";s:79:"The original taxonomy term data if the taxonomy term is being updated or saved.";s:6:"module";s:5:"token";s:4:"type";s:4:"term";}s:7:"parents";a:3:{s:4:"name";s:7:"Parents";s:11:"description";s:59:"An array of all the term''s parents, starting with the root.";s:4:"type";s:5:"array";}s:6:"parent";a:3:{s:4:"name";s:11:"Parent term";s:11:"description";s:52:"The parent term of the taxonomy term, if one exists.";s:4:"type";s:4:"term";}s:4:"root";a:3:{s:4:"name";s:9:"Root term";s:11:"description";s:35:"The root term of the taxonomy term.";s:4:"type";s:4:"term";}s:3:"tid";a:2:{s:4:"name";s:7:"Term ID";s:11:"description";s:35:"The unique ID of the taxonomy term.";}s:3:"url";a:3:{s:4:"name";s:3:"URL";s:11:"description";s:29:"The URL of the taxonomy term.";s:4:"type";s:3:"url";}s:10:"vocabulary";a:3:{s:4:"name";s:10:"Vocabulary";s:11:"description";s:44:"The vocabulary the taxonomy term belongs to.";s:4:"type";s:10:"vocabulary";}s:6:"weight";a:4:{s:4:"name";s:6:"Weight";s:11:"description";s:72:"The weight of the term, which is used for ordering terms during display.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:15:"last-transition";a:4:{s:4:"name";s:24:"Workflow last transition";s:11:"description";s:42:"Last workflow state transition of content.";s:4:"type";s:18:"WorkflowTransition";s:6:"module";s:8:"workflow";}}s:10:"vocabulary";a:10:{s:11:"description";a:2:{s:4:"name";s:11:"Description";s:11:"description";s:52:"The optional description of the taxonomy vocabulary.";}s:8:"edit-url";a:2:{s:4:"name";s:8:"Edit URL";s:11:"description";s:38:"The URL of the vocabulary''s edit page.";}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:12:"machine-name";a:2:{s:4:"name";s:21:"Machine-readable name";s:11:"description";s:51:"The unique machine-readable name of the vocabulary.";}s:4:"name";a:2:{s:4:"name";s:4:"Name";s:11:"description";s:36:"The name of the taxonomy vocabulary.";}s:10:"node-count";a:2:{s:4:"name";s:10:"Node count";s:11:"description";s:75:"The number of nodes tagged with terms belonging to the taxonomy vocabulary.";}s:8:"original";a:4:{s:4:"name";s:28:"Original taxonomy vocabulary";s:11:"description";s:91:"The original taxonomy vocabulary data if the taxonomy vocabulary is being updated or saved.";s:6:"module";s:5:"token";s:4:"type";s:10:"vocabulary";}s:10:"term-count";a:2:{s:4:"name";s:10:"Term count";s:11:"description";s:57:"The number of terms belonging to the taxonomy vocabulary.";}s:3:"vid";a:2:{s:4:"name";s:13:"Vocabulary ID";s:11:"description";s:41:"The unique ID of the taxonomy vocabulary.";}}s:4:"file";a:14:{s:8:"basename";a:2:{s:4:"name";s:9:"Base name";s:11:"description";s:26:"The base name of the file.";}s:9:"extension";a:2:{s:4:"name";s:9:"Extension";s:11:"description";s:26:"The extension of the file.";}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:3:"fid";a:2:{s:4:"name";s:7:"File ID";s:11:"description";s:35:"The unique ID of the uploaded file.";}s:8:"size-raw";a:2:{s:4:"name";s:14:"File byte size";s:11:"description";s:31:"The size of the file, in bytes.";}s:4:"name";a:2:{s:4:"name";s:9:"File name";s:11:"description";s:29:"The name of the file on disk.";}s:4:"size";a:2:{s:4:"name";s:9:"File size";s:11:"description";s:21:"The size of the file.";}s:4:"mime";a:2:{s:4:"name";s:9:"MIME type";s:11:"description";s:26:"The MIME type of the file.";}s:8:"original";a:4:{s:4:"name";s:13:"Original file";s:11:"description";s:61:"The original file data if the file is being updated or saved.";s:6:"module";s:5:"token";s:4:"type";s:4:"file";}s:5:"owner";a:3:{s:4:"name";s:5:"Owner";s:11:"description";s:42:"The user who originally uploaded the file.";s:4:"type";s:4:"user";}s:4:"path";a:2:{s:4:"name";s:4:"Path";s:11:"description";s:49:"The location of the file relative to Drupal root.";}s:9:"timestamp";a:3:{s:4:"name";s:9:"Timestamp";s:11:"description";s:44:"The date the file was most recently changed.";s:4:"type";s:4:"date";}s:3:"url";a:2:{s:4:"name";s:3:"URL";s:11:"description";s:36:"The web-accessible URL for the file.";}}s:4:"user";a:35:{s:26:"field-account-family-notes";a:4:{s:4:"name";s:20:"Account/Family Notes";s:11:"description";s:35:"Field "field_account_family_notes".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:26:"field_account_family_notes";a:3:{s:4:"name";s:20:"Account/Family Notes";s:11:"description";s:16:"Long text field.";s:6:"module";s:5:"token";}s:10:"cancel-url";a:3:{s:4:"name";s:24:"Account cancellation URL";s:11:"description";s:56:"The URL of the confirm delete page for the user account.";s:10:"restricted";b:1;}s:7:"created";a:3:{s:4:"name";s:7:"Created";s:11:"description";s:38:"The date the user account was created.";s:4:"type";s:4:"date";}s:20:"field-current-reader";a:4:{s:4:"name";s:14:"Current Reader";s:11:"description";s:29:"Field "field_current_reader".";s:4:"type";s:6:"reader";s:12:"entity-token";b:1;}s:20:"field_current_reader";a:3:{s:4:"name";s:14:"Current Reader";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:5:"theme";a:4:{s:4:"name";s:13:"Default theme";s:11:"description";s:25:"The user''s default theme.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:8:"edit-url";a:2:{s:4:"name";s:8:"Edit URL";s:11:"description";s:33:"The URL of the account edit page.";}s:4:"mail";a:2:{s:4:"name";s:5:"Email";s:11:"description";s:38:"The email address of the user account.";}s:21:"field-favorite-branch";a:4:{s:4:"name";s:15:"Favorite Branch";s:11:"description";s:30:"Field "field_favorite_branch".";s:4:"type";s:6:"branch";s:12:"entity-token";b:1;}s:21:"field_favorite_branch";a:3:{s:4:"name";s:15:"Favorite Branch";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:16:"field-first-name";a:4:{s:4:"name";s:10:"First Name";s:11:"description";s:25:"Field "field_first_name".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:16:"field_first_name";a:3:{s:4:"name";s:10:"First Name";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:15:"field-last-name";a:4:{s:4:"name";s:9:"Last Name";s:11:"description";s:24:"Field "field_last_name".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:15:"field_last_name";a:3:{s:4:"name";s:9:"Last Name";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:11:"last-access";a:4:{s:4:"name";s:11:"Last access";s:11:"description";s:41:"The date the user last accessed the site.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:10:"last-login";a:3:{s:4:"name";s:10:"Last login";s:11:"description";s:45:"The date the user last logged in to the site.";s:4:"type";s:4:"date";}s:18:"field_library_card";a:3:{s:4:"name";s:12:"Library Card";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:18:"field-library-card";a:4:{s:4:"name";s:12:"Library Card";s:11:"description";s:27:"Field "field_library_card".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:4:"name";a:2:{s:4:"name";s:4:"Name";s:11:"description";s:35:"The login name of the user account.";}s:18:"one-time-login-url";a:3:{s:4:"name";s:18:"One-time login URL";s:11:"description";s:56:"The URL of the one-time login page for the user account.";s:10:"restricted";b:1;}s:8:"original";a:4:{s:4:"name";s:13:"Original user";s:11:"description";s:61:"The original user data if the user is being updated or saved.";s:6:"module";s:5:"token";s:4:"type";s:4:"user";}s:18:"field-phone-number";a:4:{s:4:"name";s:12:"Phone Number";s:11:"description";s:27:"Field "field_phone_number".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:18:"field_phone_number";a:3:{s:4:"name";s:12:"Phone Number";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:13:"field_readers";a:3:{s:4:"name";s:7:"Readers";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:13:"field-readers";a:4:{s:4:"name";s:7:"Readers";s:11:"description";s:22:"Field "field_readers".";s:4:"type";s:12:"list<reader>";s:12:"entity-token";b:1;}s:5:"roles";a:3:{s:4:"name";s:5:"Roles";s:11:"description";s:48:"The user roles associated with the user account.";s:4:"type";s:5:"array";}s:6:"status";a:4:{s:4:"name";s:6:"Status";s:11:"description";s:38:"Whether the user is active or blocked.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:3:"url";a:3:{s:4:"name";s:3:"URL";s:11:"description";s:36:"The URL of the account profile page.";s:4:"type";s:3:"url";}s:3:"uid";a:2:{s:4:"name";s:7:"User ID";s:11:"description";s:34:"The unique ID of the user account.";}s:8:"role-ids";a:3:{s:4:"name";s:13:"User role ids";s:11:"description";s:69:"The role ids the user account is a member of as comma separated list.";s:10:"needs-data";s:4:"user";}s:10:"role-names";a:3:{s:4:"name";s:15:"User role names";s:11:"description";s:71:"The role names the user account is a member of as comma separated list.";s:10:"needs-data";s:4:"user";}s:15:"last-transition";a:4:{s:4:"name";s:24:"Workflow last transition";s:11:"description";s:42:"Last workflow state transition of content.";s:4:"type";s:18:"WorkflowTransition";s:6:"module";s:8:"workflow";}}s:12:"current-user";a:36:{s:26:"field-account-family-notes";a:4:{s:4:"name";s:20:"Account/Family Notes";s:11:"description";s:35:"Field "field_account_family_notes".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:26:"field_account_family_notes";a:3:{s:4:"name";s:20:"Account/Family Notes";s:11:"description";s:16:"Long text field.";s:6:"module";s:5:"token";}s:10:"cancel-url";a:3:{s:4:"name";s:24:"Account cancellation URL";s:11:"description";s:56:"The URL of the confirm delete page for the user account.";s:10:"restricted";b:1;}s:7:"created";a:3:{s:4:"name";s:7:"Created";s:11:"description";s:38:"The date the user account was created.";s:4:"type";s:4:"date";}s:20:"field-current-reader";a:4:{s:4:"name";s:14:"Current Reader";s:11:"description";s:29:"Field "field_current_reader".";s:4:"type";s:6:"reader";s:12:"entity-token";b:1;}s:20:"field_current_reader";a:3:{s:4:"name";s:14:"Current Reader";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:5:"theme";a:4:{s:4:"name";s:13:"Default theme";s:11:"description";s:25:"The user''s default theme.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:8:"edit-url";a:2:{s:4:"name";s:8:"Edit URL";s:11:"description";s:33:"The URL of the account edit page.";}s:4:"mail";a:2:{s:4:"name";s:5:"Email";s:11:"description";s:38:"The email address of the user account.";}s:21:"field-favorite-branch";a:4:{s:4:"name";s:15:"Favorite Branch";s:11:"description";s:30:"Field "field_favorite_branch".";s:4:"type";s:6:"branch";s:12:"entity-token";b:1;}s:21:"field_favorite_branch";a:3:{s:4:"name";s:15:"Favorite Branch";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:16:"field-first-name";a:4:{s:4:"name";s:10:"First Name";s:11:"description";s:25:"Field "field_first_name".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:16:"field_first_name";a:3:{s:4:"name";s:10:"First Name";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:10:"ip-address";a:2:{s:4:"name";s:10:"IP address";s:11:"description";s:35:"The IP address of the current user.";}s:15:"field_last_name";a:3:{s:4:"name";s:9:"Last Name";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:15:"field-last-name";a:4:{s:4:"name";s:9:"Last Name";s:11:"description";s:24:"Field "field_last_name".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:11:"last-access";a:4:{s:4:"name";s:11:"Last access";s:11:"description";s:41:"The date the user last accessed the site.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:10:"last-login";a:3:{s:4:"name";s:10:"Last login";s:11:"description";s:45:"The date the user last logged in to the site.";s:4:"type";s:4:"date";}s:18:"field_library_card";a:3:{s:4:"name";s:12:"Library Card";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:18:"field-library-card";a:4:{s:4:"name";s:12:"Library Card";s:11:"description";s:27:"Field "field_library_card".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:4:"name";a:2:{s:4:"name";s:4:"Name";s:11:"description";s:35:"The login name of the user account.";}s:18:"one-time-login-url";a:3:{s:4:"name";s:18:"One-time login URL";s:11:"description";s:56:"The URL of the one-time login page for the user account.";s:10:"restricted";b:1;}s:8:"original";a:4:{s:4:"name";s:13:"Original user";s:11:"description";s:61:"The original user data if the user is being updated or saved.";s:6:"module";s:5:"token";s:4:"type";s:4:"user";}s:18:"field_phone_number";a:3:{s:4:"name";s:12:"Phone Number";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:18:"field-phone-number";a:4:{s:4:"name";s:12:"Phone Number";s:11:"description";s:27:"Field "field_phone_number".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:13:"field_readers";a:3:{s:4:"name";s:7:"Readers";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:13:"field-readers";a:4:{s:4:"name";s:7:"Readers";s:11:"description";s:22:"Field "field_readers".";s:4:"type";s:12:"list<reader>";s:12:"entity-token";b:1;}s:5:"roles";a:3:{s:4:"name";s:5:"Roles";s:11:"description";s:48:"The user roles associated with the user account.";s:4:"type";s:5:"array";}s:6:"status";a:4:{s:4:"name";s:6:"Status";s:11:"description";s:38:"Whether the user is active or blocked.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:3:"url";a:3:{s:4:"name";s:3:"URL";s:11:"description";s:36:"The URL of the account profile page.";s:4:"type";s:3:"url";}s:3:"uid";a:2:{s:4:"name";s:7:"User ID";s:11:"description";s:34:"The unique ID of the user account.";}s:8:"role-ids";a:3:{s:4:"name";s:13:"User role ids";s:11:"description";s:69:"The role ids the user account is a member of as comma separated list.";s:10:"needs-data";s:4:"user";}s:10:"role-names";a:3:{s:4:"name";s:15:"User role names";s:11:"description";s:71:"The role names the user account is a member of as comma separated list.";s:10:"needs-data";s:4:"user";}s:15:"last-transition";a:4:{s:4:"name";s:24:"Workflow last transition";s:11:"description";s:42:"Last workflow state transition of content.";s:4:"type";s:18:"WorkflowTransition";s:6:"module";s:8:"workflow";}}s:9:"menu-link";a:8:{s:8:"edit-url";a:2:{s:4:"name";s:8:"Edit URL";s:11:"description";s:37:"The URL of the menu link''s edit page.";}s:4:"mlid";a:2:{s:4:"name";s:7:"Link ID";s:11:"description";s:31:"The unique ID of the menu link.";}s:4:"menu";a:3:{s:4:"name";s:4:"Menu";s:11:"description";s:26:"The menu of the menu link.";s:4:"type";s:4:"menu";}s:6:"parent";a:3:{s:4:"name";s:6:"Parent";s:11:"description";s:23:"The menu link''s parent.";s:4:"type";s:9:"menu-link";}s:7:"parents";a:3:{s:4:"name";s:7:"Parents";s:11:"description";s:64:"An array of all the menu link''s parents, starting with the root.";s:4:"type";s:5:"array";}s:4:"root";a:3:{s:4:"name";s:4:"Root";s:11:"description";s:21:"The menu link''s root.";s:4:"type";s:9:"menu-link";}s:5:"title";a:2:{s:4:"name";s:5:"Title";s:11:"description";s:27:"The title of the menu link.";}s:3:"url";a:3:{s:4:"name";s:3:"URL";s:11:"description";s:25:"The URL of the menu link.";s:4:"type";s:3:"url";}}s:12:"current-page";a:4:{s:11:"page-number";a:2:{s:4:"name";s:11:"Page number";s:11:"description";s:61:"The page number of the current page when viewing paged lists.";}s:5:"query";a:3:{s:4:"name";s:18:"Query string value";s:11:"description";s:63:"The value of a specific query string field of the current page.";s:7:"dynamic";b:1;}s:5:"title";a:2:{s:4:"name";s:5:"Title";s:11:"description";s:30:"The title of the current page.";}s:3:"url";a:3:{s:4:"name";s:3:"URL";s:11:"description";s:28:"The URL of the current page.";s:4:"type";s:3:"url";}}s:3:"url";a:6:{s:8:"absolute";a:2:{s:4:"name";s:12:"Absolute URL";s:11:"description";s:17:"The absolute URL.";}s:4:"args";a:3:{s:4:"name";s:9:"Arguments";s:11:"description";s:90:"The specific argument of the current page (e.g. ''arg:1'' on the page ''node/1'' returns ''1'').";s:4:"type";s:5:"array";}s:5:"brief";a:2:{s:4:"name";s:9:"Brief URL";s:11:"description";s:52:"The URL without the protocol and trailing backslash.";}s:4:"path";a:2:{s:4:"name";s:4:"Path";s:11:"description";s:30:"The path component of the URL.";}s:8:"relative";a:2:{s:4:"name";s:12:"Relative URL";s:11:"description";s:17:"The relative URL.";}s:9:"unaliased";a:3:{s:4:"name";s:13:"Unaliased URL";s:11:"description";s:18:"The unaliased URL.";s:4:"type";s:3:"url";}}s:5:"array";a:8:{s:5:"count";a:2:{s:4:"name";s:5:"Count";s:11:"description";s:36:"The number of elements in the array.";}s:5:"first";a:2:{s:4:"name";s:5:"First";s:11:"description";s:31:"The first element of the array.";}s:4:"join";a:3:{s:4:"name";s:8:"Imploded";s:11:"description";s:83:"The values of the array joined together with a custom string in-between each value.";s:7:"dynamic";b:1;}s:9:"join-path";a:2:{s:4:"name";s:11:"Joined path";s:11:"description";s:109:"The array values each cleaned by Pathauto and then joined with the slash into a string that resembles an URL.";}s:4:"keys";a:3:{s:4:"name";s:4:"Keys";s:11:"description";s:31:"The array of keys of the array.";s:4:"type";s:5:"array";}s:4:"last";a:2:{s:4:"name";s:4:"Last";s:11:"description";s:30:"The last element of the array.";}s:8:"reversed";a:3:{s:4:"name";s:8:"Reversed";s:11:"description";s:19:"The array reversed.";s:4:"type";s:5:"array";}s:5:"value";a:3:{s:4:"name";s:5:"Value";s:11:"description";s:32:"The specific value of the array.";s:7:"dynamic";b:1;}}s:6:"random";a:2:{s:4:"hash";a:3:{s:4:"name";s:4:"Hash";s:11:"description";s:483:"A random hash. The possible hashing algorithms are: md2, md4, md5, sha1, sha224, sha256, sha384, sha512, ripemd128, ripemd160, ripemd256, ripemd320, whirlpool, tiger128,3, tiger160,3, tiger192,3, tiger128,4, tiger160,4, tiger192,4, snefru, snefru256, gost, adler32, crc32, crc32b, fnv132, fnv164, joaat, haval128,3, haval160,3, haval192,3, haval224,3, haval256,3, haval128,4, haval160,4, haval192,4, haval224,4, haval256,4, haval128,5, haval160,5, haval192,5, haval224,5, haval256,5.";s:7:"dynamic";b:1;}s:6:"number";a:2:{s:4:"name";s:6:"Number";s:11:"description";s:37:"A random number from 0 to 2147483647.";}}s:13:"address-field";a:14:{s:16:"format-mailchimp";a:2:{s:4:"name";s:31:"Address formatted for MailChimp";s:11:"description";s:53:"The full address formatted for import into MailChimp.";}s:19:"administrative-area";a:2:{s:4:"name";s:41:"Administrative area (i.e. State/Province)";s:11:"description";s:71:"The administrative area value, expanded to the full name if applicable.";}s:23:"administrative-area-raw";a:2:{s:4:"name";s:31:"Administrative area (raw value)";s:11:"description";s:34:"The raw administrative area value.";}s:12:"country-code";a:2:{s:4:"name";s:12:"Country code";s:11:"description";s:32:"The two letter ISO country code.";}s:7:"country";a:2:{s:4:"name";s:12:"Country name";s:11:"description";s:29:"The full name of the country.";}s:10:"first-name";a:2:{s:4:"name";s:10:"First name";s:11:"description";s:21:"The first name value.";}s:9:"name-line";a:2:{s:4:"name";s:9:"Full name";s:11:"description";s:35:"The name line value of the address.";}s:9:"last-name";a:2:{s:4:"name";s:9:"Last name";s:11:"description";s:20:"The last name value.";}s:8:"locality";a:2:{s:4:"name";s:20:"Locality (i.e. City)";s:11:"description";s:19:"The locality value.";}s:12:"organisation";a:2:{s:4:"name";s:12:"Organisation";s:11:"description";s:28:"The organisation name value.";}s:11:"postal-code";a:2:{s:4:"name";s:11:"Postal code";s:11:"description";s:22:"The postal code value.";}s:7:"premise";a:2:{s:4:"name";s:29:"Premise (i.e. Street address)";s:11:"description";s:18:"The premise value.";}s:11:"sub_premise";a:2:{s:4:"name";s:52:"Sub Premise (i.e. Suite, Apartment, Floor, Unknown.)";s:11:"description";s:22:"The sub premise value.";}s:12:"thoroughfare";a:2:{s:4:"name";s:34:"Thoroughfare (i.e. Street address)";s:11:"description";s:23:"The thoroughfare value.";}}s:7:"comment";a:20:{s:6:"author";a:3:{s:4:"name";s:6:"Author";s:11:"description";s:50:"The author of the comment, if they were logged in.";s:4:"type";s:4:"user";}s:3:"cid";a:2:{s:4:"name";s:10:"Comment ID";s:11:"description";s:29:"The unique ID of the comment.";}s:4:"body";a:2:{s:4:"name";s:7:"Content";s:11:"description";s:44:"The formatted content of the comment itself.";}s:7:"changed";a:3:{s:4:"name";s:12:"Date changed";s:11:"description";s:47:"The date the comment was most recently updated.";s:4:"type";s:4:"date";}s:7:"created";a:3:{s:4:"name";s:12:"Date created";s:11:"description";s:32:"The date the comment was posted.";s:4:"type";s:4:"date";}s:8:"edit-url";a:2:{s:4:"name";s:8:"Edit URL";s:11:"description";s:35:"The URL of the comment''s edit page.";}s:4:"mail";a:2:{s:4:"name";s:13:"Email address";s:11:"description";s:45:"The email address left by the comment author.";}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:8:"homepage";a:2:{s:4:"name";s:9:"Home page";s:11:"description";s:45:"The home page URL left by the comment author.";}s:8:"hostname";a:2:{s:4:"name";s:10:"IP Address";s:11:"description";s:59:"The IP address of the computer the comment was posted from.";}s:4:"name";a:2:{s:4:"name";s:4:"Name";s:11:"description";s:36:"The name left by the comment author.";}s:4:"node";a:3:{s:4:"name";s:4:"Node";s:11:"description";s:35:"The node the comment was posted to.";s:4:"type";s:4:"node";}s:8:"original";a:4:{s:4:"name";s:16:"Original comment";s:11:"description";s:67:"The original comment data if the comment is being updated or saved.";s:6:"module";s:5:"token";s:4:"type";s:7:"comment";}s:6:"parent";a:3:{s:4:"name";s:6:"Parent";s:11:"description";s:53:"The comment''s parent, if comment threading is active.";s:4:"type";s:7:"comment";}s:6:"status";a:4:{s:4:"name";s:6:"Status";s:11:"description";s:48:"Whether the comment is published or unpublished.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:7:"subject";a:4:{s:4:"name";s:7:"Subject";s:11:"description";s:27:"The subject of the comment.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:12:"comment-body";a:5:{s:4:"name";s:18:"The main body text";s:11:"description";s:108:"The main body text The following properties may be appended to the token: value (Text), format (Text format)";s:4:"type";s:6:"struct";s:12:"entity-token";b:1;s:7:"dynamic";b:1;}s:5:"title";a:2:{s:4:"name";s:5:"Title";s:11:"description";s:25:"The title of the comment.";}s:3:"url";a:3:{s:4:"name";s:3:"URL";s:11:"description";s:23:"The URL of the comment.";s:4:"type";s:3:"url";}}s:16:"date-field-value";a:2:{s:4:"date";a:3:{s:4:"name";s:4:"Date";s:11:"description";s:15:"The date value.";s:4:"type";s:4:"date";}s:7:"to-date";a:3:{s:4:"name";s:8:"End Date";s:11:"description";s:19:"The End date value.";s:4:"type";s:4:"date";}}s:15:"entityform_type";a:10:{s:4:"data";a:4:{s:4:"name";s:4:"Data";s:11:"description";s:32:"Entityform type "data" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:36:"Internal, numeric entityform type ID";s:11:"description";s:56:"The ID used to identify this entityform type internally.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:5:"label";a:4:{s:4:"name";s:5:"Label";s:11:"description";s:25:"The human readable label.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:4:"type";a:4:{s:4:"name";s:21:"Machine-readable name";s:11:"description";s:59:"The machine-readable name identifying this entityform type.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:6:"module";a:4:{s:4:"name";s:6:"Module";s:11:"description";s:34:"Entityform type "module" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:6:"status";a:4:{s:4:"name";s:6:"Status";s:11:"description";s:34:"Entityform type "status" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:10:"submit_url";a:2:{s:4:"name";s:14:"Submission URL";s:11:"description";s:31:"Submit URL for Entityform type.";}s:6:"weight";a:4:{s:4:"name";s:6:"Weight";s:11:"description";s:34:"Entityform type "weight" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}}s:4:"host";a:4:{s:4:"node";a:3:{s:4:"name";s:12:"Entity: Node";s:11:"description";s:71:"Host entity tokens when it is of type <em class="placeholder">Node</em>";s:4:"type";s:4:"node";}s:2:"id";a:2:{s:4:"name";s:14:"Host entity ID";s:11:"description";s:90:"The entity ID of the host. For nodes this is <code>nid</code>, for users <code>uid</code>.";}s:6:"bundle";a:2:{s:4:"name";s:18:"Host entity bundle";s:11:"description";s:126:"For <em>node</em> entity types this is the content type, otherwise available as <code>[node:content-type:machine-name]</code>.";}s:4:"type";a:2:{s:4:"name";s:16:"Host entity type";s:11:"description";s:78:"The entity type of the host. Common types are <em>node</em> and <em>user</em>.";}}s:4:"menu";a:5:{s:11:"description";a:2:{s:4:"name";s:11:"Description";s:11:"description";s:37:"The optional description of the menu.";}s:8:"edit-url";a:2:{s:4:"name";s:8:"Edit URL";s:11:"description";s:32:"The URL of the menu''s edit page.";}s:12:"machine-name";a:2:{s:4:"name";s:21:"Machine-readable name";s:11:"description";s:45:"The unique machine-readable name of the menu.";}s:15:"menu-link-count";a:2:{s:4:"name";s:15:"Menu link count";s:11:"description";s:47:"The number of menu links belonging to the menu.";}s:4:"name";a:2:{s:4:"name";s:4:"Name";s:11:"description";s:21:"The name of the menu.";}}s:4:"site";a:11:{s:12:"current-date";a:4:{s:4:"name";s:12:"Current date";s:11:"description";s:26:"The current date and time.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:12:"current-page";a:5:{s:4:"name";s:12:"Current page";s:11:"description";s:126:"Information related to the current page request. The following properties may be appended to the token: path (Path), url (URL)";s:4:"type";s:6:"struct";s:12:"entity-token";b:1;s:7:"dynamic";b:1;}s:4:"mail";a:2:{s:4:"name";s:5:"Email";s:11:"description";s:46:"The administrative email address for the site.";}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:12:"current-user";a:4:{s:4:"name";s:14:"Logged in user";s:11:"description";s:29:"The currently logged in user.";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:9:"login-url";a:2:{s:4:"name";s:10:"Login page";s:11:"description";s:33:"The URL of the site''s login page.";}s:4:"name";a:2:{s:4:"name";s:4:"Name";s:11:"description";s:21:"The name of the site.";}s:6:"slogan";a:2:{s:4:"name";s:6:"Slogan";s:11:"description";s:23:"The slogan of the site.";}s:3:"url";a:2:{s:4:"name";s:3:"URL";s:11:"description";s:33:"The URL of the site''s front page.";}s:9:"url-brief";a:2:{s:4:"name";s:11:"URL (brief)";s:11:"description";s:54:"The URL of the site''s front page without the protocol.";}}s:4:"date";a:7:{s:6:"custom";a:3:{s:4:"name";s:13:"Custom format";s:11:"description";s:122:"A date in a custom format. See <a href="http://php.net/manual/en/function.date.php">the PHP documentation</a> for details.";s:7:"dynamic";b:1;}s:4:"long";a:2:{s:4:"name";s:11:"Long format";s:11:"description";s:87:"A date in ''long'' format. (<em class="placeholder">Sunday, April 30, 2017 - 9:58pm</em>)";}s:6:"medium";a:2:{s:4:"name";s:13:"Medium format";s:11:"description";s:82:"A date in ''medium'' format. (<em class="placeholder">Sun, 04/30/2017 - 9:58pm</em>)";}s:3:"raw";a:2:{s:4:"name";s:13:"Raw timestamp";s:11:"description";s:73:"A date in UNIX timestamp format (<em class="placeholder">1493614688</em>)";}s:7:"seconds";a:3:{s:4:"name";s:13:"Seconds-since";s:11:"description";s:96:"A date in ''seconds ago'' format (<i>604800</i>). Use it for easy scheduling workflow transitions.";s:6:"module";s:8:"workflow";}s:5:"short";a:2:{s:4:"name";s:12:"Short format";s:11:"description";s:76:"A date in ''short'' format. (<em class="placeholder">04/30/2017 - 9:58pm</em>)";}s:5:"since";a:2:{s:4:"name";s:10:"Time-since";s:11:"description";s:79:"A date in ''time-since'' format. (<em class="placeholder">47 years 4 months</em>)";}}s:13:"WorkflowField";a:1:{s:15:"last-transition";a:4:{s:4:"name";s:24:"Workflow last transition";s:11:"description";s:42:"Last workflow state transition of content.";s:4:"type";s:18:"WorkflowTransition";s:6:"module";s:8:"workflow";}}s:4:"view";a:5:{s:11:"description";a:2:{s:4:"name";s:11:"Description";s:11:"description";s:28:"The description of the view.";}s:12:"machine-name";a:2:{s:4:"name";s:12:"Machine name";s:11:"description";s:38:"The machine-readable name of the view.";}s:4:"name";a:2:{s:4:"name";s:4:"Name";s:11:"description";s:36:"The human-readable name of the view.";}s:5:"title";a:2:{s:4:"name";s:5:"Title";s:11:"description";s:41:"The title of current display of the view.";}s:3:"url";a:3:{s:4:"name";s:3:"URL";s:11:"description";s:20:"The URL of the view.";s:4:"type";s:3:"url";}}s:10:"rules_text";a:1:{s:5:"value";a:2:{s:4:"name";s:5:"Value";s:11:"description";s:26:"The value of the variable.";}}s:13:"rules_integer";a:1:{s:5:"value";a:2:{s:4:"name";s:5:"Value";s:11:"description";s:26:"The value of the variable.";}}s:9:"rules_uri";a:1:{s:5:"value";a:2:{s:4:"name";s:5:"Value";s:11:"description";s:26:"The value of the variable.";}}s:11:"rules_token";a:1:{s:5:"value";a:2:{s:4:"name";s:5:"Value";s:11:"description";s:26:"The value of the variable.";}}s:13:"rules_decimal";a:1:{s:5:"value";a:2:{s:4:"name";s:5:"Value";s:11:"description";s:26:"The value of the variable.";}}s:10:"rules_date";a:1:{s:5:"value";a:2:{s:4:"name";s:5:"Value";s:11:"description";s:26:"The value of the variable.";}}s:14:"rules_duration";a:1:{s:5:"value";a:2:{s:4:"name";s:5:"Value";s:11:"description";s:26:"The value of the variable.";}}s:8:"activity";a:17:{s:3:"uid";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:6:"Author";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:7:"created";a:4:{s:4:"name";s:7:"Created";s:11:"description";s:32:"The date the entity was created.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:26:"field-activity-description";a:5:{s:4:"name";s:11:"Description";s:11:"description";s:125:"Field "field_activity_description". The following properties may be appended to the token: value (Text), format (Text format)";s:4:"type";s:6:"struct";s:12:"entity-token";b:1;s:7:"dynamic";b:1;}s:26:"field_activity_description";a:3:{s:4:"name";s:11:"Description";s:11:"description";s:16:"Long text field.";s:6:"module";s:5:"token";}s:8:"language";a:4:{s:4:"name";s:15:"Entity language";s:11:"description";s:15:"Entity language";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:21:"field_activity_points";a:3:{s:4:"name";s:14:"Points Awarded";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:21:"field-activity-points";a:4:{s:4:"name";s:14:"Points Awarded";s:11:"description";s:30:"Field "field_activity_points".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:23:"field-program-reference";a:4:{s:4:"name";s:17:"Program Reference";s:11:"description";s:32:"Field "field_program_reference".";s:4:"type";s:13:"list<program>";s:12:"entity-token";b:1;}s:23:"field_program_reference";a:3:{s:4:"name";s:17:"Program Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:18:"field_reader_badge";a:3:{s:4:"name";s:12:"Reader Badge";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:18:"field-reader-badge";a:4:{s:4:"name";s:12:"Reader Badge";s:11:"description";s:27:"Field "field_reader_badge".";s:4:"type";s:5:"badge";s:12:"entity-token";b:1;}s:19:"field-activity-code";a:4:{s:4:"name";s:11:"Secret Code";s:11:"description";s:28:"Field "field_activity_code".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:19:"field_activity_code";a:3:{s:4:"name";s:11:"Secret Code";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:12:"activity_log";a:17:{s:24:"field-activity-reference";a:4:{s:4:"name";s:18:"Activity Reference";s:11:"description";s:33:"Field "field_activity_reference".";s:4:"type";s:8:"activity";s:12:"entity-token";b:1;}s:24:"field_activity_reference";a:3:{s:4:"name";s:18:"Activity Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:3:"uid";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:6:"Author";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:7:"created";a:4:{s:4:"name";s:7:"Created";s:11:"description";s:32:"The date the entity was created.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:8:"language";a:4:{s:4:"name";s:15:"Entity language";s:11:"description";s:15:"Entity language";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:19:"field_points_earned";a:3:{s:4:"name";s:13:"Points Earned";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:19:"field-points-earned";a:4:{s:4:"name";s:13:"Points Earned";s:11:"description";s:28:"Field "field_points_earned".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:18:"field_reader_badge";a:3:{s:4:"name";s:12:"Reader Badge";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:18:"field-reader-badge";a:4:{s:4:"name";s:12:"Reader Badge";s:11:"description";s:27:"Field "field_reader_badge".";s:4:"type";s:5:"badge";s:12:"entity-token";b:1;}s:13:"field-readers";a:4:{s:4:"name";s:7:"Readers";s:11:"description";s:22:"Field "field_readers".";s:4:"type";s:12:"list<reader>";s:12:"entity-token";b:1;}s:13:"field_readers";a:3:{s:4:"name";s:7:"Readers";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:27:"field_secret_code_reference";a:3:{s:4:"name";s:21:"Secret Code Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:27:"field-secret-code-reference";a:4:{s:4:"name";s:21:"Secret Code Reference";s:11:"description";s:36:"Field "field_secret_code_reference".";s:4:"type";s:8:"activity";s:12:"entity-token";b:1;}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:22:"activity_log_reference";a:9:{s:30:"field_activity_log_description";a:3:{s:4:"name";s:24:"Activity Log Description";s:11:"description";s:16:"Long text field.";s:6:"module";s:5:"token";}s:30:"field-activity-log-description";a:4:{s:4:"name";s:24:"Activity Log Description";s:11:"description";s:39:"Field "field_activity_log_description".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:24:"field_activity_log_title";a:3:{s:4:"name";s:18:"Activity Log Title";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:24:"field-activity-log-title";a:4:{s:4:"name";s:18:"Activity Log Title";s:11:"description";s:33:"Field "field_activity_log_title".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:22:"field_points_reference";a:3:{s:4:"name";s:16:"Points Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:22:"field-points-reference";a:4:{s:4:"name";s:16:"Points Reference";s:11:"description";s:31:"Field "field_points_reference".";s:4:"type";s:12:"list<points>";s:12:"entity-token";b:1;}}s:5:"badge";a:10:{s:23:"field-badge-description";a:4:{s:4:"name";s:17:"Badge Description";s:11:"description";s:32:"Field "field_badge_description".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:23:"field_badge_description";a:3:{s:4:"name";s:17:"Badge Description";s:11:"description";s:16:"Long text field.";s:6:"module";s:5:"token";}s:17:"field_badge_image";a:3:{s:4:"name";s:11:"Badge Image";s:11:"description";s:12:"Image field.";s:6:"module";s:5:"token";}s:17:"field-badge-image";a:5:{s:4:"name";s:11:"Badge Image";s:11:"description";s:192:"Field "field_badge_image". The following properties may be appended to the token: file (The image file.), alt (The &quot;Alt&quot; attribute text), title (The &quot;Title&quot; attribute text)";s:4:"type";s:6:"struct";s:12:"entity-token";b:1;s:7:"dynamic";b:1;}s:19:"field_badge_message";a:3:{s:4:"name";s:13:"Badge Message";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:19:"field-badge-message";a:4:{s:4:"name";s:13:"Badge Message";s:11:"description";s:28:"Field "field_badge_message".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:6:"branch";a:10:{s:3:"uid";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:6:"Author";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:20:"field_branch_address";a:4:{s:4:"name";s:14:"Branch Address";s:11:"description";s:21:"Postal address field.";s:6:"module";s:5:"token";s:4:"type";s:13:"address-field";}s:20:"field-branch-address";a:5:{s:4:"name";s:14:"Branch Address";s:11:"description";s:590:"Field "field_branch_address". The following properties may be appended to the token: country (Country), name_line (Full name), first_name (First name), last_name (Last name), organisation_name (Company), administrative_area (Administrative area (i.e. State / Province)), sub_administrative_area (Sub administrative area), locality (Locality (i.e. City)), dependent_locality (Dependent locality), postal_code (Postal code), thoroughfare (Thoroughfare (i.e. Street address)), premise (Premise (i.e. Apartment / Suite number)), sub_premise (Sub Premise (i.e. Suite, Apartment, Floor, Unknown.)";s:4:"type";s:6:"struct";s:12:"entity-token";b:1;s:7:"dynamic";b:1;}s:18:"field_branch_phone";a:3:{s:4:"name";s:12:"Branch Phone";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:18:"field-branch-phone";a:4:{s:4:"name";s:12:"Branch Phone";s:11:"description";s:27:"Field "field_branch_phone".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:7:"created";a:4:{s:4:"name";s:7:"Created";s:11:"description";s:32:"The date the entity was created.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:14:"drawing_ticket";a:12:{s:3:"uid";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:6:"Author";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:7:"created";a:4:{s:4:"name";s:7:"Created";s:11:"description";s:32:"The date the entity was created.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:13:"field_program";a:3:{s:4:"name";s:7:"Program";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:13:"field-program";a:4:{s:4:"name";s:7:"Program";s:11:"description";s:22:"Field "field_program".";s:4:"type";s:13:"list<program>";s:12:"entity-token";b:1;}s:13:"field_readers";a:3:{s:4:"name";s:7:"Readers";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:13:"field-readers";a:4:{s:4:"name";s:7:"Readers";s:11:"description";s:22:"Field "field_readers".";s:4:"type";s:12:"list<reader>";s:12:"entity-token";b:1;}s:15:"field-ticket-id";a:4:{s:4:"name";s:9:"Ticket ID";s:11:"description";s:24:"Field "field_ticket_id".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:15:"field_ticket_id";a:3:{s:4:"name";s:9:"Ticket ID";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:5:"level";a:20:{s:3:"uid";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:6:"Author";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:7:"created";a:4:{s:4:"name";s:7:"Created";s:11:"description";s:32:"The date the entity was created.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:21:"field-drawing-tickets";a:4:{s:4:"name";s:15:"Drawing Tickets";s:11:"description";s:30:"Field "field_drawing_tickets".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:21:"field_drawing_tickets";a:3:{s:4:"name";s:15:"Drawing Tickets";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:19:"field-level-message";a:4:{s:4:"name";s:13:"Level Message";s:11:"description";s:28:"Field "field_level_message".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:19:"field_level_message";a:3:{s:4:"name";s:13:"Level Message";s:11:"description";s:16:"Long text field.";s:6:"module";s:5:"token";}s:18:"field-level-number";a:4:{s:4:"name";s:12:"Level Number";s:11:"description";s:27:"Field "field_level_number".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:18:"field_level_number";a:3:{s:4:"name";s:12:"Level Number";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:21:"field_point_threshold";a:3:{s:4:"name";s:15:"Point Threshold";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:21:"field-point-threshold";a:4:{s:4:"name";s:15:"Point Threshold";s:11:"description";s:30:"Field "field_point_threshold".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:21:"field_prize_reference";a:3:{s:4:"name";s:15:"Prize Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:21:"field-prize-reference";a:4:{s:4:"name";s:15:"Prize Reference";s:11:"description";s:30:"Field "field_prize_reference".";s:4:"type";s:5:"prize";s:12:"entity-token";b:1;}s:23:"field_program_reference";a:3:{s:4:"name";s:17:"Program Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:23:"field-program-reference";a:4:{s:4:"name";s:17:"Program Reference";s:11:"description";s:32:"Field "field_program_reference".";s:4:"type";s:13:"list<program>";s:12:"entity-token";b:1;}s:18:"field-reader-badge";a:4:{s:4:"name";s:12:"Reader Badge";s:11:"description";s:27:"Field "field_reader_badge".";s:4:"type";s:5:"badge";s:12:"entity-token";b:1;}s:18:"field_reader_badge";a:3:{s:4:"name";s:12:"Reader Badge";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:11:"nag_message";a:8:{s:20:"field-current-reader";a:4:{s:4:"name";s:14:"Current Reader";s:11:"description";s:29:"Field "field_current_reader".";s:4:"type";s:6:"reader";s:12:"entity-token";b:1;}s:20:"field_current_reader";a:3:{s:4:"name";s:14:"Current Reader";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:13:"field_message";a:3:{s:4:"name";s:7:"Message";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:13:"field-message";a:4:{s:4:"name";s:7:"Message";s:11:"description";s:22:"Field "field_message".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:6:"points";a:14:{s:28:"field_activity_log_reference";a:3:{s:4:"name";s:22:"Activity Log Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:28:"field-activity-log-reference";a:4:{s:4:"name";s:22:"Activity Log Reference";s:11:"description";s:37:"Field "field_activity_log_reference".";s:4:"type";s:8:"activity";s:12:"entity-token";b:1;}s:3:"uid";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:6:"Author";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:12:"field_points";a:3:{s:4:"name";s:6:"Points";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:12:"field-points";a:4:{s:4:"name";s:6:"Points";s:11:"description";s:21:"Field "field_points".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:23:"field-program-reference";a:4:{s:4:"name";s:17:"Program Reference";s:11:"description";s:32:"Field "field_program_reference".";s:4:"type";s:13:"list<program>";s:12:"entity-token";b:1;}s:23:"field_program_reference";a:3:{s:4:"name";s:17:"Program Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:13:"field-readers";a:4:{s:4:"name";s:7:"Readers";s:11:"description";s:22:"Field "field_readers".";s:4:"type";s:12:"list<reader>";s:12:"entity-token";b:1;}s:13:"field_readers";a:3:{s:4:"name";s:7:"Readers";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:27:"field-reading-log-reference";a:4:{s:4:"name";s:21:"Reading Log Reference";s:11:"description";s:36:"Field "field_reading_log_reference".";s:4:"type";s:17:"list<reading_log>";s:12:"entity-token";b:1;}s:27:"field_reading_log_reference";a:3:{s:4:"name";s:21:"Reading Log Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}}s:5:"prize";a:12:{s:3:"uid";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:6:"Author";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:7:"created";a:4:{s:4:"name";s:7:"Created";s:11:"description";s:32:"The date the entity was created.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:23:"field_prize_description";a:3:{s:4:"name";s:17:"Prize Description";s:11:"description";s:16:"Long text field.";s:6:"module";s:5:"token";}s:23:"field-prize-description";a:5:{s:4:"name";s:17:"Prize Description";s:11:"description";s:122:"Field "field_prize_description". The following properties may be appended to the token: value (Text), format (Text format)";s:4:"type";s:6:"struct";s:12:"entity-token";b:1;s:7:"dynamic";b:1;}s:19:"field_prize_message";a:3:{s:4:"name";s:13:"Prize Message";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:19:"field-prize-message";a:4:{s:4:"name";s:13:"Prize Message";s:11:"description";s:28:"Field "field_prize_message".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:23:"field-program-reference";a:4:{s:4:"name";s:17:"Program Reference";s:11:"description";s:32:"Field "field_program_reference".";s:4:"type";s:13:"list<program>";s:12:"entity-token";b:1;}s:23:"field_program_reference";a:3:{s:4:"name";s:17:"Program Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:7:"program";a:18:{s:3:"uid";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:6:"Author";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:7:"created";a:4:{s:4:"name";s:7:"Created";s:11:"description";s:32:"The date the entity was created.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:20:"field_per_unit_label";a:3:{s:4:"name";s:14:"Per Unit Label";s:11:"description";s:18:"List (text) field.";s:6:"module";s:5:"token";}s:20:"field-per-unit-label";a:4:{s:4:"name";s:14:"Per Unit Label";s:11:"description";s:29:"Field "field_per_unit_label".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:26:"field-per-unit-point-value";a:4:{s:4:"name";s:20:"Per Unit Point Value";s:11:"description";s:35:"Field "field_per_unit_point_value".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:26:"field_per_unit_point_value";a:3:{s:4:"name";s:20:"Per Unit Point Value";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:25:"field_program_description";a:3:{s:4:"name";s:19:"Program Description";s:11:"description";s:16:"Long text field.";s:6:"module";s:5:"token";}s:25:"field-program-description";a:5:{s:4:"name";s:19:"Program Description";s:11:"description";s:124:"Field "field_program_description". The following properties may be appended to the token: value (Text), format (Text format)";s:4:"type";s:6:"struct";s:12:"entity-token";b:1;s:7:"dynamic";b:1;}s:25:"field_recommended_max_age";a:3:{s:4:"name";s:19:"Recommended Max Age";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:25:"field-recommended-max-age";a:4:{s:4:"name";s:19:"Recommended Max Age";s:11:"description";s:34:"Field "field_recommended_max_age".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:25:"field-recommended-min-age";a:4:{s:4:"name";s:19:"Recommended Min Age";s:11:"description";s:34:"Field "field_recommended_min_age".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:25:"field_recommended_min_age";a:3:{s:4:"name";s:19:"Recommended Min Age";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:18:"field-scoring-type";a:4:{s:4:"name";s:12:"Scoring Type";s:11:"description";s:27:"Field "field_scoring_type".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:18:"field_scoring_type";a:3:{s:4:"name";s:12:"Scoring Type";s:11:"description";s:18:"List (text) field.";s:6:"module";s:5:"token";}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:6:"reader";a:35:{s:9:"field_age";a:3:{s:4:"name";s:3:"Age";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:9:"field-age";a:4:{s:4:"name";s:3:"Age";s:11:"description";s:18:"Field "field_age".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:3:"uid";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:6:"Author";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:24:"field-claimed-activities";a:4:{s:4:"name";s:18:"Claimed Activities";s:11:"description";s:33:"Field "field_claimed_activities".";s:4:"type";s:14:"list<activity>";s:12:"entity-token";b:1;}s:24:"field_claimed_activities";a:3:{s:4:"name";s:18:"Claimed Activities";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:29:"field_current_drawing_tickets";a:3:{s:4:"name";s:23:"Current Drawing Tickets";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:29:"field-current-drawing-tickets";a:4:{s:4:"name";s:23:"Current Drawing Tickets";s:11:"description";s:38:"Field "field_current_drawing_tickets".";s:4:"type";s:19:"list<reader_ticket>";s:12:"entity-token";b:1;}s:19:"field-current-level";a:4:{s:4:"name";s:13:"Current Level";s:11:"description";s:28:"Field "field_current_level".";s:4:"type";s:5:"level";s:12:"entity-token";b:1;}s:19:"field_current_level";a:3:{s:4:"name";s:13:"Current Level";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:20:"field-current-points";a:4:{s:4:"name";s:14:"Current Points";s:11:"description";s:29:"Field "field_current_points".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:20:"field_current_points";a:3:{s:4:"name";s:14:"Current Points";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:21:"field-current-program";a:4:{s:4:"name";s:15:"Current Program";s:11:"description";s:30:"Field "field_current_program".";s:4:"type";s:7:"program";s:12:"entity-token";b:1;}s:21:"field_current_program";a:3:{s:4:"name";s:15:"Current Program";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:26:"field_current_reader_badge";a:3:{s:4:"name";s:20:"Current Reader Badge";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:26:"field-current-reader-badge";a:4:{s:4:"name";s:20:"Current Reader Badge";s:11:"description";s:35:"Field "field_current_reader_badge".";s:4:"type";s:18:"list<reader_badge>";s:12:"entity-token";b:1;}s:27:"field_current_reader_prizes";a:3:{s:4:"name";s:21:"Current Reader Prizes";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:27:"field-current-reader-prizes";a:4:{s:4:"name";s:21:"Current Reader Prizes";s:11:"description";s:36:"Field "field_current_reader_prizes".";s:4:"type";s:18:"list<reader_prize>";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:16:"field-first-name";a:4:{s:4:"name";s:10:"First Name";s:11:"description";s:25:"Field "field_first_name".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:16:"field_first_name";a:3:{s:4:"name";s:10:"First Name";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:11:"field-grade";a:4:{s:4:"name";s:5:"Grade";s:11:"description";s:20:"Field "field_grade".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:11:"field_grade";a:3:{s:4:"name";s:5:"Grade";s:11:"description";s:18:"List (text) field.";s:6:"module";s:5:"token";}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:15:"field_last_name";a:3:{s:4:"name";s:9:"Last Name";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:15:"field-last-name";a:4:{s:4:"name";s:9:"Last Name";s:11:"description";s:24:"Field "field_last_name".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:16:"field_parent_uid";a:3:{s:4:"name";s:10:"Parent UID";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:16:"field-parent-uid";a:4:{s:4:"name";s:10:"Parent UID";s:11:"description";s:25:"Field "field_parent_uid".";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:22:"field-points-reference";a:4:{s:4:"name";s:16:"Points Reference";s:11:"description";s:31:"Field "field_points_reference".";s:4:"type";s:12:"list<points>";s:12:"entity-token";b:1;}s:22:"field_points_reference";a:3:{s:4:"name";s:16:"Points Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:13:"field_program";a:3:{s:4:"name";s:7:"Program";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:13:"field-program";a:4:{s:4:"name";s:7:"Program";s:11:"description";s:22:"Field "field_program".";s:4:"type";s:13:"list<program>";s:12:"entity-token";b:1;}s:19:"field-reader-school";a:4:{s:4:"name";s:13:"Reader School";s:11:"description";s:28:"Field "field_reader_school".";s:4:"type";s:6:"school";s:12:"entity-token";b:1;}s:19:"field_reader_school";a:3:{s:4:"name";s:13:"Reader School";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:19:"reader_activity_log";a:12:{s:28:"field-activity-log-reference";a:4:{s:4:"name";s:22:"Activity Log Reference";s:11:"description";s:37:"Field "field_activity_log_reference".";s:4:"type";s:8:"activity";s:12:"entity-token";b:1;}s:28:"field_activity_log_reference";a:3:{s:4:"name";s:22:"Activity Log Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:22:"field_points_reference";a:3:{s:4:"name";s:16:"Points Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:22:"field-points-reference";a:4:{s:4:"name";s:16:"Points Reference";s:11:"description";s:31:"Field "field_points_reference".";s:4:"type";s:12:"list<points>";s:12:"entity-token";b:1;}s:23:"field_program_reference";a:3:{s:4:"name";s:17:"Program Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:23:"field-program-reference";a:4:{s:4:"name";s:17:"Program Reference";s:11:"description";s:32:"Field "field_program_reference".";s:4:"type";s:13:"list<program>";s:12:"entity-token";b:1;}s:13:"field-readers";a:4:{s:4:"name";s:7:"Readers";s:11:"description";s:22:"Field "field_readers".";s:4:"type";s:12:"list<reader>";s:12:"entity-token";b:1;}s:13:"field_readers";a:3:{s:4:"name";s:7:"Readers";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:12:"reader_badge";a:10:{s:3:"uid";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:6:"Author";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:19:"field-badge-message";a:4:{s:4:"name";s:13:"Badge Message";s:11:"description";s:28:"Field "field_badge_message".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:19:"field_badge_message";a:3:{s:4:"name";s:13:"Badge Message";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:18:"field_reader_badge";a:3:{s:4:"name";s:12:"Reader Badge";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:18:"field-reader-badge";a:4:{s:4:"name";s:12:"Reader Badge";s:11:"description";s:27:"Field "field_reader_badge".";s:4:"type";s:5:"badge";s:12:"entity-token";b:1;}s:13:"field-readers";a:4:{s:4:"name";s:7:"Readers";s:11:"description";s:22:"Field "field_readers".";s:4:"type";s:12:"list<reader>";s:12:"entity-token";b:1;}s:13:"field_readers";a:3:{s:4:"name";s:7:"Readers";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}}s:10:"reader_log";a:20:{s:12:"field-author";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:21:"Field "field_author".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:12:"field_author";a:3:{s:4:"name";s:6:"Author";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:16:"field-book-title";a:4:{s:4:"name";s:10:"Book Title";s:11:"description";s:25:"Field "field_book_title".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:16:"field_book_title";a:3:{s:4:"name";s:10:"Book Title";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:19:"field_points_earned";a:3:{s:4:"name";s:13:"Points Earned";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:19:"field-points-earned";a:4:{s:4:"name";s:13:"Points Earned";s:11:"description";s:28:"Field "field_points_earned".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:23:"field_program_reference";a:3:{s:4:"name";s:17:"Program Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:23:"field-program-reference";a:4:{s:4:"name";s:17:"Program Reference";s:11:"description";s:32:"Field "field_program_reference".";s:4:"type";s:13:"list<program>";s:12:"entity-token";b:1;}s:13:"field_readers";a:3:{s:4:"name";s:7:"Readers";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:13:"field-readers";a:4:{s:4:"name";s:7:"Readers";s:11:"description";s:22:"Field "field_readers".";s:4:"type";s:12:"list<reader>";s:12:"entity-token";b:1;}s:11:"field-stars";a:4:{s:4:"name";s:5:"Stars";s:11:"description";s:20:"Field "field_stars".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:11:"field_stars";a:3:{s:4:"name";s:5:"Stars";s:11:"description";s:18:"List (text) field.";s:6:"module";s:5:"token";}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:15:"field_unit_type";a:3:{s:4:"name";s:9:"Unit Type";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:15:"field-unit-type";a:4:{s:4:"name";s:9:"Unit Type";s:11:"description";s:24:"Field "field_unit_type".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:21:"field_units_completed";a:3:{s:4:"name";s:15:"Units Completed";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}s:21:"field-units-completed";a:4:{s:4:"name";s:15:"Units Completed";s:11:"description";s:30:"Field "field_units_completed".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}}s:12:"reader_prize";a:18:{s:3:"uid";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:6:"Author";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:7:"created";a:4:{s:4:"name";s:7:"Created";s:11:"description";s:32:"The date the entity was created.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:11:"field_level";a:3:{s:4:"name";s:5:"Level";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:11:"field-level";a:4:{s:4:"name";s:5:"Level";s:11:"description";s:20:"Field "field_level".";s:4:"type";s:11:"list<level>";s:12:"entity-token";b:1;}s:19:"field_prize_message";a:3:{s:4:"name";s:13:"Prize Message";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:19:"field-prize-message";a:4:{s:4:"name";s:13:"Prize Message";s:11:"description";s:28:"Field "field_prize_message".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:21:"field-prize-reference";a:4:{s:4:"name";s:15:"Prize Reference";s:11:"description";s:30:"Field "field_prize_reference".";s:4:"type";s:5:"prize";s:12:"entity-token";b:1;}s:21:"field_prize_reference";a:3:{s:4:"name";s:15:"Prize Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:23:"field_program_reference";a:3:{s:4:"name";s:17:"Program Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:23:"field-program-reference";a:4:{s:4:"name";s:17:"Program Reference";s:11:"description";s:32:"Field "field_program_reference".";s:4:"type";s:13:"list<program>";s:12:"entity-token";b:1;}s:13:"field_readers";a:3:{s:4:"name";s:7:"Readers";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:13:"field-readers";a:4:{s:4:"name";s:7:"Readers";s:11:"description";s:22:"Field "field_readers".";s:4:"type";s:12:"list<reader>";s:12:"entity-token";b:1;}s:12:"field_status";a:3:{s:4:"name";s:6:"Status";s:11:"description";s:18:"List (text) field.";s:6:"module";s:5:"token";}s:12:"field-status";a:4:{s:4:"name";s:6:"Status";s:11:"description";s:21:"Field "field_status".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:13:"reader_ticket";a:12:{s:3:"uid";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:6:"Author";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:7:"created";a:4:{s:4:"name";s:7:"Created";s:11:"description";s:32:"The date the entity was created.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:11:"field_level";a:3:{s:4:"name";s:5:"Level";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:11:"field-level";a:4:{s:4:"name";s:5:"Level";s:11:"description";s:20:"Field "field_level".";s:4:"type";s:11:"list<level>";s:12:"entity-token";b:1;}s:13:"field_readers";a:3:{s:4:"name";s:7:"Readers";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:13:"field-readers";a:4:{s:4:"name";s:7:"Readers";s:11:"description";s:22:"Field "field_readers".";s:4:"type";s:12:"list<reader>";s:12:"entity-token";b:1;}s:19:"field-ticket-status";a:4:{s:4:"name";s:13:"Ticket Status";s:11:"description";s:28:"Field "field_ticket_status".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:19:"field_ticket_status";a:3:{s:4:"name";s:13:"Ticket Status";s:11:"description";s:18:"List (text) field.";s:6:"module";s:5:"token";}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:11:"reading_log";a:23:{s:3:"uid";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:6:"Author";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:12:"field_author";a:3:{s:4:"name";s:6:"Author";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:12:"field-author";a:4:{s:4:"name";s:6:"Author";s:11:"description";s:21:"Field "field_author".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:16:"field_book_title";a:3:{s:4:"name";s:10:"Book Title";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:16:"field-book-title";a:4:{s:4:"name";s:10:"Book Title";s:11:"description";s:25:"Field "field_book_title".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:7:"changed";a:4:{s:4:"name";s:7:"Changed";s:11:"description";s:38:"The last time this entity was updated.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:7:"created";a:4:{s:4:"name";s:7:"Created";s:11:"description";s:32:"The date the entity was created.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:22:"field_points_reference";a:3:{s:4:"name";s:16:"Points Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:22:"field-points-reference";a:4:{s:4:"name";s:16:"Points Reference";s:11:"description";s:31:"Field "field_points_reference".";s:4:"type";s:12:"list<points>";s:12:"entity-token";b:1;}s:23:"field-program-reference";a:4:{s:4:"name";s:17:"Program Reference";s:11:"description";s:32:"Field "field_program_reference".";s:4:"type";s:13:"list<program>";s:12:"entity-token";b:1;}s:23:"field_program_reference";a:3:{s:4:"name";s:17:"Program Reference";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:13:"field-readers";a:4:{s:4:"name";s:7:"Readers";s:11:"description";s:22:"Field "field_readers".";s:4:"type";s:12:"list<reader>";s:12:"entity-token";b:1;}s:13:"field_readers";a:3:{s:4:"name";s:7:"Readers";s:11:"description";s:23:"Entity Reference field.";s:6:"module";s:5:"token";}s:11:"field-stars";a:4:{s:4:"name";s:5:"Stars";s:11:"description";s:20:"Field "field_stars".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:11:"field_stars";a:3:{s:4:"name";s:5:"Stars";s:11:"description";s:18:"List (text) field.";s:6:"module";s:5:"token";}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:15:"field-unit-type";a:4:{s:4:"name";s:9:"Unit Type";s:11:"description";s:24:"Field "field_unit_type".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:15:"field_unit_type";a:3:{s:4:"name";s:9:"Unit Type";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:21:"field-units-completed";a:4:{s:4:"name";s:15:"Units Completed";s:11:"description";s:30:"Field "field_units_completed".";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:21:"field_units_completed";a:3:{s:4:"name";s:15:"Units Completed";s:11:"description";s:14:"Integer field.";s:6:"module";s:5:"token";}}s:6:"school";a:6:{s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:2:"Id";s:11:"description";s:2:"Id";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:21:"field-school-address-";a:4:{s:4:"name";s:15:"School Address ";s:11:"description";s:30:"Field "field_school_address_".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:21:"field_school_address_";a:3:{s:4:"name";s:15:"School Address ";s:11:"description";s:16:"Long text field.";s:6:"module";s:5:"token";}s:5:"title";a:4:{s:4:"name";s:5:"Title";s:11:"description";s:5:"Title";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:10:"entityform";a:11:{s:7:"changed";a:4:{s:4:"name";s:12:"Date changed";s:11:"description";s:44:"The date the form was most recently updated.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:7:"created";a:4:{s:4:"name";s:14:"Date submitted";s:11:"description";s:28:"The date form was submitted.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:5:"draft";a:4:{s:4:"name";s:5:"Draft";s:11:"description";s:39:"Entityform submission "draft" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:4:"type";a:4:{s:4:"name";s:15:"Entityform Type";s:11:"description";s:50:"The Entityform Type for the Entityform Submission.";s:4:"type";s:15:"entityform_type";s:12:"entity-token";b:1;}s:13:"entityform-id";a:4:{s:4:"name";s:24:"Entityform submission ID";s:11:"description";s:43:"The unique ID of the entityform submission.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:8:"language";a:4:{s:4:"name";s:8:"Language";s:11:"description";s:42:"Entityform submission "language" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:3:"url";a:4:{s:4:"name";s:3:"URL";s:11:"description";s:22:"The URL of the entity.";s:4:"type";s:3:"uri";s:12:"entity-token";b:1;}s:3:"uid";a:4:{s:4:"name";s:3:"Uid";s:11:"description";s:37:"Entityform submission "uid" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:4:"user";a:4:{s:4:"name";s:4:"User";s:11:"description";s:32:"The user who submitted the form.";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}}s:21:"field_collection_item";a:15:{s:8:"archived";a:4:{s:4:"name";s:8:"Archived";s:11:"description";s:42:"Field collection item "archived" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:17:"field-bl-b-author";a:4:{s:4:"name";s:11:"Book Author";s:11:"description";s:26:"Field "field_bl_b_author".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:17:"field_bl_b_author";a:3:{s:4:"name";s:11:"Book Author";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:16:"field_bl_b_title";a:3:{s:4:"name";s:10:"Book Title";s:11:"description";s:11:"Text field.";s:6:"module";s:5:"token";}s:16:"field-bl-b-title";a:4:{s:4:"name";s:10:"Book Title";s:11:"description";s:25:"Field "field_bl_b_title".";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:15:"field_bl_b_link";a:3:{s:4:"name";s:12:"Catalog Link";s:11:"description";s:11:"Link field.";s:6:"module";s:5:"token";}s:15:"field-bl-b-link";a:5:{s:4:"name";s:12:"Catalog Link";s:11:"description";s:180:"Field "field_bl_b_link". The following properties may be appended to the token: title (The title of the link.), url (The URL of the link.), attributes (The attributes of the link.)";s:4:"type";s:6:"struct";s:12:"entity-token";b:1;s:7:"dynamic";b:1;}s:16:"field_bl_b_image";a:3:{s:4:"name";s:11:"Cover Image";s:11:"description";s:12:"Image field.";s:6:"module";s:5:"token";}s:16:"field-bl-b-image";a:5:{s:4:"name";s:11:"Cover Image";s:11:"description";s:145:"Field "field_bl_b_image". The following properties may be appended to the token: file (The image file.), alt (The &quot;Alt&quot; attribute text)";s:4:"type";s:6:"struct";s:12:"entity-token";b:1;s:7:"dynamic";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:7:"item-id";a:4:{s:4:"name";s:24:"Field collection item ID";s:11:"description";s:43:"The unique ID of the field collection item.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:4:"host";a:3:{s:4:"name";s:11:"Host entity";s:11:"description";s:46:"The host entity of this field collection item.";s:4:"type";s:4:"host";}s:11:"revision-id";a:4:{s:4:"name";s:11:"Revision_id";s:11:"description";s:45:"Field collection item "revision_id" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:3:"url";a:4:{s:4:"name";s:3:"URL";s:11:"description";s:22:"The URL of the entity.";s:4:"type";s:3:"uri";s:12:"entity-token";b:1;}}s:8:"Workflow";a:11:{s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:5:"label";a:4:{s:4:"name";s:5:"Label";s:11:"description";s:26:"Workflow "label" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:6:"module";a:4:{s:4:"name";s:6:"Module";s:11:"description";s:27:"Workflow "module" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:6:"states";a:4:{s:4:"name";s:6:"States";s:11:"description";s:23:"States of the Workflow.";s:4:"type";s:19:"list<WorkflowState>";s:12:"entity-token";b:1;}s:6:"status";a:4:{s:4:"name";s:6:"Status";s:11:"description";s:27:"Workflow "status" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"tab-roles";a:4:{s:4:"name";s:9:"Tab_roles";s:11:"description";s:51:"The roles that can access the Workflow History tab.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:11:"transitions";a:4:{s:4:"name";s:11:"Transitions";s:11:"description";s:28:"Transitions of the Workflow.";s:4:"type";s:30:"list<WorkflowConfigTransition>";s:12:"entity-token";b:1;}s:3:"url";a:4:{s:4:"name";s:3:"URL";s:11:"description";s:22:"The URL of the entity.";s:4:"type";s:3:"uri";s:12:"entity-token";b:1;}s:3:"wid";a:4:{s:4:"name";s:11:"Workflow ID";s:11:"description";s:49:"The ID used to identify this workflow internally.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:7:"options";a:4:{s:4:"name";s:16:"Workflow options";s:11:"description";s:28:"Workflow "options" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}}s:13:"WorkflowState";a:10:{s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:5:"label";a:4:{s:4:"name";s:5:"Label";s:11:"description";s:23:"The label of the state.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:4:"name";a:4:{s:4:"name";s:4:"Name";s:11:"description";s:31:"Workflow state "name" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:6:"status";a:4:{s:4:"name";s:6:"Status";s:11:"description";s:33:"Workflow state "status" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:5:"sysid";a:4:{s:4:"name";s:5:"Sysid";s:11:"description";s:32:"Workflow state "sysid" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:3:"url";a:4:{s:4:"name";s:3:"URL";s:11:"description";s:22:"The URL of the entity.";s:4:"type";s:3:"uri";s:12:"entity-token";b:1;}s:6:"weight";a:4:{s:4:"name";s:6:"Weight";s:11:"description";s:33:"Workflow state "weight" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:3:"wid";a:4:{s:4:"name";s:3:"Wid";s:11:"description";s:30:"Workflow state "wid" property.";s:4:"type";s:8:"Workflow";s:12:"entity-token";b:1;}s:3:"sid";a:4:{s:4:"name";s:17:"Workflow state ID";s:11:"description";s:36:"The unique ID of the workflow state.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}}s:24:"WorkflowConfigTransition";a:12:{s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:5:"label";a:4:{s:4:"name";s:5:"Label";s:11:"description";s:44:"Workflow config transition "label" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:4:"name";a:4:{s:4:"name";s:4:"Name";s:11:"description";s:43:"Workflow config transition "name" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:9:"new-state";a:4:{s:4:"name";s:9:"New state";s:11:"description";s:14:"The new state.";s:4:"type";s:13:"WorkflowState";s:12:"entity-token";b:1;}s:9:"old-state";a:4:{s:4:"name";s:9:"Old state";s:11:"description";s:14:"The old state.";s:4:"type";s:13:"WorkflowState";s:12:"entity-token";b:1;}s:5:"roles";a:4:{s:4:"name";s:5:"Roles";s:11:"description";s:42:"The roles that may execute the transition.";s:4:"type";s:13:"list<integer>";s:12:"entity-token";b:1;}s:3:"sid";a:4:{s:4:"name";s:3:"Sid";s:11:"description";s:20:"The ID of old state.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:10:"target-sid";a:4:{s:4:"name";s:10:"Target_sid";s:11:"description";s:20:"The ID of new state.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:8:"workflow";a:4:{s:4:"name";s:8:"Workflow";s:11:"description";s:31:"The workflow of the transition.";s:4:"type";s:8:"Workflow";s:12:"entity-token";b:1;}s:3:"wid";a:4:{s:4:"name";s:12:"Workflow  ID";s:11:"description";s:34:"The workflow ID of the transition.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:3:"tid";a:4:{s:4:"name";s:29:"Workflow config transition ID";s:11:"description";s:48:"The unique ID of the workflow config transition.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}}s:18:"WorkflowTransition";a:20:{s:7:"comment";a:4:{s:4:"name";s:7:"Comment";s:11:"description";s:48:"Workflow executed transition "comment" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:5:"delta";a:4:{s:4:"name";s:5:"Delta";s:11:"description";s:46:"Workflow executed transition "delta" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:11:"entity-type";a:4:{s:4:"name";s:11:"Entity_type";s:11:"description";s:52:"Workflow executed transition "entity_type" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:10:"field-name";a:4:{s:4:"name";s:10:"Field_name";s:11:"description";s:51:"Workflow executed transition "field_name" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:5:"label";a:4:{s:4:"name";s:5:"Label";s:11:"description";s:44:"Workflow config transition "label" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:8:"language";a:4:{s:4:"name";s:8:"Language";s:11:"description";s:49:"Workflow executed transition "language" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:9:"new-state";a:4:{s:4:"name";s:9:"New state";s:11:"description";s:14:"The new state.";s:4:"type";s:13:"WorkflowState";s:12:"entity-token";b:1;}s:3:"nid";a:4:{s:4:"name";s:3:"Nid";s:11:"description";s:44:"Workflow executed transition "nid" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:7:"old-sid";a:4:{s:4:"name";s:7:"Old_sid";s:11:"description";s:20:"The ID of old state.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"old-state";a:4:{s:4:"name";s:9:"Old state";s:11:"description";s:14:"The old state.";s:4:"type";s:13:"WorkflowState";s:12:"entity-token";b:1;}s:11:"revision-id";a:4:{s:4:"name";s:11:"Revision_id";s:11:"description";s:52:"Workflow executed transition "revision_id" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:3:"sid";a:4:{s:4:"name";s:3:"Sid";s:11:"description";s:20:"The ID of new state.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"timestamp";a:4:{s:4:"name";s:9:"Timestamp";s:11:"description";s:43:"The date, time the transition was executed.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:3:"hid";a:4:{s:4:"name";s:13:"Transition ID";s:11:"description";s:50:"The unique ID of the workflow executed transition.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:3:"uid";a:4:{s:4:"name";s:3:"Uid";s:11:"description";s:44:"Workflow executed transition "uid" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:4:"user";a:4:{s:4:"name";s:4:"User";s:11:"description";s:38:"The user who triggered the transition.";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:8:"workflow";a:4:{s:4:"name";s:8:"Workflow";s:11:"description";s:31:"The workflow of the transition.";s:4:"type";s:8:"Workflow";s:12:"entity-token";b:1;}s:3:"wid";a:4:{s:4:"name";s:12:"Workflow  ID";s:11:"description";s:34:"The workflow ID of the transition.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}}s:27:"WorkflowScheduledTransition";a:17:{s:7:"comment";a:4:{s:4:"name";s:7:"Comment";s:11:"description";s:49:"Workflow scheduled transition "comment" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:5:"delta";a:4:{s:4:"name";s:5:"Delta";s:11:"description";s:47:"Workflow scheduled transition "delta" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:11:"entity-type";a:4:{s:4:"name";s:11:"Entity_type";s:11:"description";s:53:"Workflow scheduled transition "entity_type" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:10:"field-name";a:4:{s:4:"name";s:10:"Field_name";s:11:"description";s:52:"Workflow scheduled transition "field_name" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:8:"language";a:4:{s:4:"name";s:8:"Language";s:11:"description";s:50:"Workflow scheduled transition "language" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:9:"new-state";a:4:{s:4:"name";s:9:"New state";s:11:"description";s:14:"The new state.";s:4:"type";s:13:"WorkflowState";s:12:"entity-token";b:1;}s:3:"nid";a:4:{s:4:"name";s:3:"Nid";s:11:"description";s:45:"Workflow scheduled transition "nid" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:7:"old-sid";a:4:{s:4:"name";s:7:"Old_sid";s:11:"description";s:20:"The ID of old state.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"old-state";a:4:{s:4:"name";s:9:"Old state";s:11:"description";s:14:"The old state.";s:4:"type";s:13:"WorkflowState";s:12:"entity-token";b:1;}s:9:"scheduled";a:4:{s:4:"name";s:9:"Scheduled";s:11:"description";s:51:"Workflow scheduled transition "scheduled" property.";s:4:"type";s:4:"date";s:12:"entity-token";b:1;}s:3:"sid";a:4:{s:4:"name";s:3:"Sid";s:11:"description";s:20:"The ID of new state.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:3:"uid";a:4:{s:4:"name";s:3:"Uid";s:11:"description";s:45:"Workflow scheduled transition "uid" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:4:"user";a:4:{s:4:"name";s:4:"User";s:11:"description";s:38:"The user who triggered the transition.";s:4:"type";s:4:"user";s:12:"entity-token";b:1;}s:8:"workflow";a:4:{s:4:"name";s:8:"Workflow";s:11:"description";s:31:"The workflow of the transition.";s:4:"type";s:8:"Workflow";s:12:"entity-token";b:1;}s:3:"tid";a:4:{s:4:"name";s:32:"Workflow scheduled transition ID";s:11:"description";s:51:"The unique ID of the workflow scheduled transition.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}}s:12:"rules_config";a:12:{s:14:"access-exposed";a:4:{s:4:"name";s:14:"Access_exposed";s:11:"description";s:46:"Rules configuration "access_exposed" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:6:"active";a:4:{s:4:"name";s:6:"Active";s:11:"description";s:38:"Rules configuration "active" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:5:"dirty";a:4:{s:4:"name";s:5:"Dirty";s:11:"description";s:37:"Rules configuration "dirty" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:8:"feed-nid";a:4:{s:4:"name";s:8:"Feed NID";s:11:"description";s:47:"Nid of the Feed Node that imported this entity.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:9:"feed-node";a:4:{s:4:"name";s:9:"Feed node";s:11:"description";s:36:"Feed Node that imported this entity.";s:4:"type";s:4:"node";s:12:"entity-token";b:1;}s:2:"id";a:4:{s:4:"name";s:40:"Internal, numeric rules configuration ID";s:11:"description";s:60:"The ID used to identify this rules configuration internally.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:5:"label";a:4:{s:4:"name";s:5:"Label";s:11:"description";s:25:"The human readable label.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:6:"module";a:4:{s:4:"name";s:6:"Module";s:11:"description";s:38:"Rules configuration "module" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:5:"owner";a:4:{s:4:"name";s:5:"Owner";s:11:"description";s:37:"Rules configuration "owner" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:6:"plugin";a:4:{s:4:"name";s:6:"Plugin";s:11:"description";s:38:"Rules configuration "plugin" property.";s:4:"type";s:4:"text";s:12:"entity-token";b:1;}s:6:"status";a:4:{s:4:"name";s:6:"Status";s:11:"description";s:38:"Rules configuration "status" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}s:6:"weight";a:4:{s:4:"name";s:6:"Weight";s:11:"description";s:38:"Rules configuration "weight" property.";s:4:"type";s:7:"integer";s:12:"entity-token";b:1;}}s:13:"list<comment>";a:4:{i:0;a:3:{s:4:"name";s:21:"Comments with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:7:"comment";}i:1;a:3:{s:4:"name";s:21:"Comments with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:7:"comment";}i:2;a:3:{s:4:"name";s:21:"Comments with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:7:"comment";}i:3;a:3:{s:4:"name";s:21:"Comments with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:7:"comment";}}s:14:"list<activity>";a:4:{i:0;a:3:{s:4:"name";s:21:"Activity with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:8:"activity";}i:1;a:3:{s:4:"name";s:21:"Activity with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:8:"activity";}i:2;a:3:{s:4:"name";s:21:"Activity with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:8:"activity";}i:3;a:3:{s:4:"name";s:21:"Activity with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:8:"activity";}}s:18:"list<activity_log>";a:4:{i:0;a:3:{s:4:"name";s:25:"Activity Log with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"activity_log";}i:1;a:3:{s:4:"name";s:25:"Activity Log with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"activity_log";}i:2;a:3:{s:4:"name";s:25:"Activity Log with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"activity_log";}i:3;a:3:{s:4:"name";s:25:"Activity Log with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"activity_log";}}s:28:"list<activity_log_reference>";a:4:{i:0;a:3:{s:4:"name";s:35:"Activity Log Reference with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:22:"activity_log_reference";}i:1;a:3:{s:4:"name";s:35:"Activity Log Reference with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:22:"activity_log_reference";}i:2;a:3:{s:4:"name";s:35:"Activity Log Reference with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:22:"activity_log_reference";}i:3;a:3:{s:4:"name";s:35:"Activity Log Reference with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:22:"activity_log_reference";}}s:11:"list<badge>";a:4:{i:0;a:3:{s:4:"name";s:18:"Badge with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:5:"badge";}i:1;a:3:{s:4:"name";s:18:"Badge with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:5:"badge";}i:2;a:3:{s:4:"name";s:18:"Badge with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:5:"badge";}i:3;a:3:{s:4:"name";s:18:"Badge with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:5:"badge";}}s:12:"list<branch>";a:4:{i:0;a:3:{s:4:"name";s:19:"Branch with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"branch";}i:1;a:3:{s:4:"name";s:19:"Branch with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"branch";}i:2;a:3:{s:4:"name";s:19:"Branch with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"branch";}i:3;a:3:{s:4:"name";s:19:"Branch with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"branch";}}s:20:"list<drawing_ticket>";a:4:{i:0;a:3:{s:4:"name";s:27:"Drawing Ticket with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:14:"drawing_ticket";}i:1;a:3:{s:4:"name";s:27:"Drawing Ticket with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:14:"drawing_ticket";}i:2;a:3:{s:4:"name";s:27:"Drawing Ticket with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:14:"drawing_ticket";}i:3;a:3:{s:4:"name";s:27:"Drawing Ticket with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:14:"drawing_ticket";}}s:11:"list<level>";a:4:{i:0;a:3:{s:4:"name";s:18:"Level with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:5:"level";}i:1;a:3:{s:4:"name";s:18:"Level with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:5:"level";}i:2;a:3:{s:4:"name";s:18:"Level with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:5:"level";}i:3;a:3:{s:4:"name";s:18:"Level with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:5:"level";}}s:17:"list<nag_message>";a:4:{i:0;a:3:{s:4:"name";s:24:"Nag Message with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:11:"nag_message";}i:1;a:3:{s:4:"name";s:24:"Nag Message with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:11:"nag_message";}i:2;a:3:{s:4:"name";s:24:"Nag Message with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:11:"nag_message";}i:3;a:3:{s:4:"name";s:24:"Nag Message with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:11:"nag_message";}}s:12:"list<points>";a:4:{i:0;a:3:{s:4:"name";s:19:"Points with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"points";}i:1;a:3:{s:4:"name";s:19:"Points with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"points";}i:2;a:3:{s:4:"name";s:19:"Points with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"points";}i:3;a:3:{s:4:"name";s:19:"Points with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"points";}}s:11:"list<prize>";a:4:{i:0;a:3:{s:4:"name";s:18:"Prize with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:5:"prize";}i:1;a:3:{s:4:"name";s:18:"Prize with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:5:"prize";}i:2;a:3:{s:4:"name";s:18:"Prize with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:5:"prize";}i:3;a:3:{s:4:"name";s:18:"Prize with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:5:"prize";}}s:13:"list<program>";a:4:{i:0;a:3:{s:4:"name";s:20:"Program with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:7:"program";}i:1;a:3:{s:4:"name";s:20:"Program with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:7:"program";}i:2;a:3:{s:4:"name";s:20:"Program with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:7:"program";}i:3;a:3:{s:4:"name";s:20:"Program with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:7:"program";}}s:12:"list<reader>";a:4:{i:0;a:3:{s:4:"name";s:19:"Reader with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"reader";}i:1;a:3:{s:4:"name";s:19:"Reader with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"reader";}i:2;a:3:{s:4:"name";s:19:"Reader with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"reader";}i:3;a:3:{s:4:"name";s:19:"Reader with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"reader";}}s:25:"list<reader_activity_log>";a:4:{i:0;a:3:{s:4:"name";s:32:"Reader Activity Log with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:19:"reader_activity_log";}i:1;a:3:{s:4:"name";s:32:"Reader Activity Log with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:19:"reader_activity_log";}i:2;a:3:{s:4:"name";s:32:"Reader Activity Log with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:19:"reader_activity_log";}i:3;a:3:{s:4:"name";s:32:"Reader Activity Log with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:19:"reader_activity_log";}}s:18:"list<reader_badge>";a:4:{i:0;a:3:{s:4:"name";s:25:"Reader Badge with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"reader_badge";}i:1;a:3:{s:4:"name";s:25:"Reader Badge with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"reader_badge";}i:2;a:3:{s:4:"name";s:25:"Reader Badge with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"reader_badge";}i:3;a:3:{s:4:"name";s:25:"Reader Badge with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"reader_badge";}}s:16:"list<reader_log>";a:4:{i:0;a:3:{s:4:"name";s:23:"Reader Log with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:10:"reader_log";}i:1;a:3:{s:4:"name";s:23:"Reader Log with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:10:"reader_log";}i:2;a:3:{s:4:"name";s:23:"Reader Log with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:10:"reader_log";}i:3;a:3:{s:4:"name";s:23:"Reader Log with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:10:"reader_log";}}s:18:"list<reader_prize>";a:4:{i:0;a:3:{s:4:"name";s:25:"Reader Prize with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"reader_prize";}i:1;a:3:{s:4:"name";s:25:"Reader Prize with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"reader_prize";}i:2;a:3:{s:4:"name";s:25:"Reader Prize with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"reader_prize";}i:3;a:3:{s:4:"name";s:25:"Reader Prize with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"reader_prize";}}s:19:"list<reader_ticket>";a:4:{i:0;a:3:{s:4:"name";s:26:"Reader Ticket with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:13:"reader_ticket";}i:1;a:3:{s:4:"name";s:26:"Reader Ticket with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:13:"reader_ticket";}i:2;a:3:{s:4:"name";s:26:"Reader Ticket with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:13:"reader_ticket";}i:3;a:3:{s:4:"name";s:26:"Reader Ticket with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:13:"reader_ticket";}}s:17:"list<reading_log>";a:4:{i:0;a:3:{s:4:"name";s:24:"Reading Log with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:11:"reading_log";}i:1;a:3:{s:4:"name";s:24:"Reading Log with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:11:"reading_log";}i:2;a:3:{s:4:"name";s:24:"Reading Log with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:11:"reading_log";}i:3;a:3:{s:4:"name";s:24:"Reading Log with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:11:"reading_log";}}s:12:"list<school>";a:4:{i:0;a:3:{s:4:"name";s:19:"School with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"school";}i:1;a:3:{s:4:"name";s:19:"School with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"school";}i:2;a:3:{s:4:"name";s:19:"School with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"school";}i:3;a:3:{s:4:"name";s:19:"School with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:6:"school";}}s:16:"list<entityform>";a:4:{i:0;a:3:{s:4:"name";s:34:"Entityform Submission with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:10:"entityform";}i:1;a:3:{s:4:"name";s:34:"Entityform Submission with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:10:"entityform";}i:2;a:3:{s:4:"name";s:34:"Entityform Submission with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:10:"entityform";}i:3;a:3:{s:4:"name";s:34:"Entityform Submission with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:10:"entityform";}}s:21:"list<entityform_type>";a:4:{i:0;a:3:{s:4:"name";s:28:"Entityform Type with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:15:"entityform_type";}i:1;a:3:{s:4:"name";s:28:"Entityform Type with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:15:"entityform_type";}i:2;a:3:{s:4:"name";s:28:"Entityform Type with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:15:"entityform_type";}i:3;a:3:{s:4:"name";s:28:"Entityform Type with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:15:"entityform_type";}}s:27:"list<field_collection_item>";a:4:{i:0;a:3:{s:4:"name";s:34:"Field collection item with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:21:"field_collection_item";}i:1;a:3:{s:4:"name";s:34:"Field collection item with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:21:"field_collection_item";}i:2;a:3:{s:4:"name";s:34:"Field collection item with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:21:"field_collection_item";}i:3;a:3:{s:4:"name";s:34:"Field collection item with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:21:"field_collection_item";}}s:10:"list<node>";a:4:{i:0;a:3:{s:4:"name";s:18:"Nodes with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"node";}i:1;a:3:{s:4:"name";s:18:"Nodes with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"node";}i:2;a:3:{s:4:"name";s:18:"Nodes with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"node";}i:3;a:3:{s:4:"name";s:18:"Nodes with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"node";}}s:10:"list<file>";a:4:{i:0;a:3:{s:4:"name";s:18:"Files with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"file";}i:1;a:3:{s:4:"name";s:18:"Files with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"file";}i:2;a:3:{s:4:"name";s:18:"Files with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"file";}i:3;a:3:{s:4:"name";s:18:"Files with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"file";}}s:10:"list<term>";a:4:{i:0;a:3:{s:4:"name";s:27:"Taxonomy terms with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"term";}i:1;a:3:{s:4:"name";s:27:"Taxonomy terms with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"term";}i:2;a:3:{s:4:"name";s:27:"Taxonomy terms with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"term";}i:3;a:3:{s:4:"name";s:27:"Taxonomy terms with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"term";}}s:16:"list<vocabulary>";a:4:{i:0;a:3:{s:4:"name";s:25:"Vocabularies with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:10:"vocabulary";}i:1;a:3:{s:4:"name";s:25:"Vocabularies with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:10:"vocabulary";}i:2;a:3:{s:4:"name";s:25:"Vocabularies with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:10:"vocabulary";}i:3;a:3:{s:4:"name";s:25:"Vocabularies with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:10:"vocabulary";}}s:10:"list<user>";a:4:{i:0;a:3:{s:4:"name";s:18:"Users with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"user";}i:1;a:3:{s:4:"name";s:18:"Users with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"user";}i:2;a:3:{s:4:"name";s:18:"Users with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"user";}i:3;a:3:{s:4:"name";s:18:"Users with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"user";}}s:14:"list<Workflow>";a:4:{i:0;a:3:{s:4:"name";s:21:"Workflow with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:8:"Workflow";}i:1;a:3:{s:4:"name";s:21:"Workflow with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:8:"Workflow";}i:2;a:3:{s:4:"name";s:21:"Workflow with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:8:"Workflow";}i:3;a:3:{s:4:"name";s:21:"Workflow with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:8:"Workflow";}}s:19:"list<WorkflowState>";a:4:{i:0;a:3:{s:4:"name";s:27:"Workflow State with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:13:"WorkflowState";}i:1;a:3:{s:4:"name";s:27:"Workflow State with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:13:"WorkflowState";}i:2;a:3:{s:4:"name";s:27:"Workflow State with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:13:"WorkflowState";}i:3;a:3:{s:4:"name";s:27:"Workflow State with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:13:"WorkflowState";}}s:30:"list<WorkflowConfigTransition>";a:4:{i:0;a:3:{s:4:"name";s:39:"Workflow config transition with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:24:"WorkflowConfigTransition";}i:1;a:3:{s:4:"name";s:39:"Workflow config transition with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:24:"WorkflowConfigTransition";}i:2;a:3:{s:4:"name";s:39:"Workflow config transition with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:24:"WorkflowConfigTransition";}i:3;a:3:{s:4:"name";s:39:"Workflow config transition with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:24:"WorkflowConfigTransition";}}s:24:"list<WorkflowTransition>";a:4:{i:0;a:3:{s:4:"name";s:32:"Workflow Transition with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:18:"WorkflowTransition";}i:1;a:3:{s:4:"name";s:32:"Workflow Transition with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:18:"WorkflowTransition";}i:2;a:3:{s:4:"name";s:32:"Workflow Transition with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:18:"WorkflowTransition";}i:3;a:3:{s:4:"name";s:32:"Workflow Transition with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:18:"WorkflowTransition";}}s:33:"list<WorkflowScheduledTransition>";a:4:{i:0;a:3:{s:4:"name";s:42:"Workflow scheduled transition with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:27:"WorkflowScheduledTransition";}i:1;a:3:{s:4:"name";s:42:"Workflow scheduled transition with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:27:"WorkflowScheduledTransition";}i:2;a:3:{s:4:"name";s:42:"Workflow scheduled transition with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:27:"WorkflowScheduledTransition";}i:3;a:3:{s:4:"name";s:42:"Workflow scheduled transition with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:27:"WorkflowScheduledTransition";}}s:18:"list<rules_config>";a:4:{i:0;a:3:{s:4:"name";s:32:"Rules configuration with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"rules_config";}i:1;a:3:{s:4:"name";s:32:"Rules configuration with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"rules_config";}i:2;a:3:{s:4:"name";s:32:"Rules configuration with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"rules_config";}i:3;a:3:{s:4:"name";s:32:"Rules configuration with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:12:"rules_config";}}s:10:"list<date>";a:4:{i:0;a:3:{s:4:"name";s:18:"Dates with delta 0";s:11:"description";s:95:"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"date";}i:1;a:3:{s:4:"name";s:18:"Dates with delta 1";s:11:"description";s:95:"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"date";}i:2;a:3:{s:4:"name";s:18:"Dates with delta 2";s:11:"description";s:95:"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"date";}i:3;a:3:{s:4:"name";s:18:"Dates with delta 3";s:11:"description";s:95:"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.";s:4:"type";s:4:"date";}}s:12:"current-date";a:7:{s:6:"custom";a:3:{s:4:"name";s:13:"Custom format";s:11:"description";s:122:"A date in a custom format. See <a href="http://php.net/manual/en/function.date.php">the PHP documentation</a> for details.";s:7:"dynamic";b:1;}s:4:"long";a:2:{s:4:"name";s:11:"Long format";s:11:"description";s:87:"A date in ''long'' format. (<em class="placeholder">Sunday, April 30, 2017 - 9:58pm</em>)";}s:6:"medium";a:2:{s:4:"name";s:13:"Medium format";s:11:"description";s:82:"A date in ''medium'' format. (<em class="placeholder">Sun, 04/30/2017 - 9:58pm</em>)";}s:3:"raw";a:2:{s:4:"name";s:13:"Raw timestamp";s:11:"description";s:73:"A date in UNIX timestamp format (<em class="placeholder">1493614688</em>)";}s:7:"seconds";a:3:{s:4:"name";s:13:"Seconds-since";s:11:"description";s:96:"A date in ''seconds ago'' format (<i>604800</i>). Use it for easy scheduling workflow transitions.";s:6:"module";s:8:"workflow";}s:5:"short";a:2:{s:4:"name";s:12:"Short format";s:11:"description";s:76:"A date in ''short'' format. (<em class="placeholder">04/30/2017 - 9:58pm</em>)";}s:5:"since";a:2:{s:4:"name";s:10:"Time-since";s:11:"description";s:79:"A date in ''time-since'' format. (<em class="placeholder">47 years 4 months</em>)";}}}s:5:"types";a:92:{s:8:"activity";a:4:{s:4:"name";s:8:"Activity";s:11:"description";s:42:"Tokens related to the "Activity" entities.";s:10:"needs-data";s:8:"activity";s:4:"type";s:8:"activity";}s:12:"activity_log";a:4:{s:4:"name";s:12:"Activity Log";s:11:"description";s:46:"Tokens related to the "Activity Log" entities.";s:10:"needs-data";s:12:"activity_log";s:4:"type";s:12:"activity_log";}s:22:"activity_log_reference";a:4:{s:4:"name";s:22:"Activity Log Reference";s:11:"description";s:56:"Tokens related to the "Activity Log Reference" entities.";s:10:"needs-data";s:22:"activity_log_reference";s:4:"type";s:22:"activity_log_reference";}s:13:"address-field";a:5:{s:4:"name";s:13:"Address field";s:11:"description";s:60:"Tokens related to address field values and their components.";s:10:"needs-data";s:13:"address-field";s:5:"field";b:1;s:4:"type";s:13:"address-field";}s:5:"array";a:4:{s:4:"name";s:5:"Array";s:11:"description";s:36:"Tokens related to arrays of strings.";s:10:"needs-data";s:5:"array";s:4:"type";s:5:"array";}s:5:"badge";a:4:{s:4:"name";s:5:"Badge";s:11:"description";s:39:"Tokens related to the "Badge" entities.";s:10:"needs-data";s:5:"badge";s:4:"type";s:5:"badge";}s:6:"branch";a:4:{s:4:"name";s:6:"Branch";s:11:"description";s:40:"Tokens related to the "Branch" entities.";s:10:"needs-data";s:6:"branch";s:4:"type";s:6:"branch";}s:7:"comment";a:4:{s:4:"name";s:8:"Comments";s:11:"description";s:39:"Tokens for comments posted on the site.";s:10:"needs-data";s:7:"comment";s:4:"type";s:7:"comment";}s:12:"content-type";a:4:{s:4:"name";s:13:"Content types";s:11:"description";s:32:"Tokens related to content types.";s:10:"needs-data";s:9:"node_type";s:4:"type";s:12:"content-type";}s:12:"current-date";a:3:{s:4:"name";s:12:"Current date";s:11:"description";s:44:"Tokens related to the current date and time.";s:4:"type";s:4:"date";}s:12:"current-page";a:3:{s:4:"name";s:12:"Current page";s:11:"description";s:43:"Tokens related to the current page request.";s:4:"type";s:12:"current-page";}s:12:"current-user";a:3:{s:4:"name";s:12:"Current user";s:11:"description";s:47:"Tokens related to the currently logged in user.";s:4:"type";s:4:"user";}s:16:"date-field-value";a:5:{s:4:"name";s:17:"Date field values";s:11:"description";s:36:"Tokens related to date field values.";s:10:"needs-data";s:16:"date-field-value";s:11:"field-value";b:1;s:4:"type";s:16:"date-field-value";}s:4:"date";a:4:{s:4:"name";s:5:"Dates";s:11:"description";s:34:"Tokens related to times and dates.";s:10:"needs-data";s:4:"date";s:4:"type";s:4:"date";}s:14:"drawing_ticket";a:4:{s:4:"name";s:14:"Drawing Ticket";s:11:"description";s:48:"Tokens related to the "Drawing Ticket" entities.";s:10:"needs-data";s:14:"drawing_ticket";s:4:"type";s:14:"drawing_ticket";}s:10:"entityform";a:4:{s:4:"name";s:21:"Entityform Submission";s:11:"description";s:55:"Tokens related to the "Entityform Submission" entities.";s:10:"needs-data";s:10:"entityform";s:4:"type";s:10:"entityform";}s:15:"entityform_type";a:4:{s:4:"name";s:15:"Entityform Type";s:11:"description";s:49:"Tokens related to the "Entityform Type" entities.";s:10:"needs-data";s:15:"entityform_type";s:4:"type";s:15:"entityform_type";}s:21:"field_collection_item";a:4:{s:4:"name";s:16:"Field collection";s:11:"description";s:35:"Tokens related to field collection.";s:10:"needs-data";s:21:"field_collection_item";s:4:"type";s:21:"field_collection_item";}s:4:"host";a:4:{s:4:"name";s:28:"Field collection host entity";s:11:"description";s:49:"Tokens related to field collection host entities.";s:10:"needs-data";s:21:"field_collection_item";s:4:"type";s:4:"host";}s:4:"file";a:4:{s:4:"name";s:5:"Files";s:11:"description";s:33:"Tokens related to uploaded files.";s:10:"needs-data";s:4:"file";s:4:"type";s:4:"file";}s:5:"level";a:4:{s:4:"name";s:5:"Level";s:11:"description";s:39:"Tokens related to the "Level" entities.";s:10:"needs-data";s:5:"level";s:4:"type";s:5:"level";}s:28:"list<activity_log_reference>";a:4:{s:4:"name";s:31:"List of Activity Log References";s:11:"description";s:56:"Tokens related to the "Activity Log Reference" entities.";s:10:"needs-data";s:28:"list<activity_log_reference>";s:4:"type";s:28:"list<activity_log_reference>";}s:18:"list<activity_log>";a:4:{s:4:"name";s:21:"List of Activity Logs";s:11:"description";s:46:"Tokens related to the "Activity Log" entities.";s:10:"needs-data";s:18:"list<activity_log>";s:4:"type";s:18:"list<activity_log>";}s:14:"list<activity>";a:4:{s:4:"name";s:17:"List of Activitys";s:11:"description";s:42:"Tokens related to the "Activity" entities.";s:10:"needs-data";s:14:"list<activity>";s:4:"type";s:14:"list<activity>";}s:11:"list<badge>";a:4:{s:4:"name";s:14:"List of Badges";s:11:"description";s:39:"Tokens related to the "Badge" entities.";s:10:"needs-data";s:11:"list<badge>";s:4:"type";s:11:"list<badge>";}s:12:"list<branch>";a:4:{s:4:"name";s:15:"List of Branchs";s:11:"description";s:40:"Tokens related to the "Branch" entities.";s:10:"needs-data";s:12:"list<branch>";s:4:"type";s:12:"list<branch>";}s:13:"list<comment>";a:4:{s:4:"name";s:16:"List of Comments";s:11:"description";s:41:"Tokens related to the "Comment" entities.";s:10:"needs-data";s:13:"list<comment>";s:4:"type";s:13:"list<comment>";}s:20:"list<drawing_ticket>";a:4:{s:4:"name";s:23:"List of Drawing Tickets";s:11:"description";s:48:"Tokens related to the "Drawing Ticket" entities.";s:10:"needs-data";s:20:"list<drawing_ticket>";s:4:"type";s:20:"list<drawing_ticket>";}s:16:"list<entityform>";a:4:{s:4:"name";s:30:"List of Entityform Submissions";s:11:"description";s:55:"Tokens related to the "Entityform Submission" entities.";s:10:"needs-data";s:16:"list<entityform>";s:4:"type";s:16:"list<entityform>";}s:21:"list<entityform_type>";a:4:{s:4:"name";s:24:"List of Entityform Types";s:11:"description";s:49:"Tokens related to the "Entityform Type" entities.";s:10:"needs-data";s:21:"list<entityform_type>";s:4:"type";s:21:"list<entityform_type>";}s:27:"list<field_collection_item>";a:4:{s:4:"name";s:30:"List of Field collection items";s:11:"description";s:55:"Tokens related to the "Field collection item" entities.";s:10:"needs-data";s:27:"list<field_collection_item>";s:4:"type";s:27:"list<field_collection_item>";}s:10:"list<file>";a:4:{s:4:"name";s:13:"List of Files";s:11:"description";s:38:"Tokens related to the "File" entities.";s:10:"needs-data";s:10:"list<file>";s:4:"type";s:10:"list<file>";}s:11:"list<level>";a:4:{s:4:"name";s:14:"List of Levels";s:11:"description";s:39:"Tokens related to the "Level" entities.";s:10:"needs-data";s:11:"list<level>";s:4:"type";s:11:"list<level>";}s:17:"list<nag_message>";a:4:{s:4:"name";s:20:"List of Nag Messages";s:11:"description";s:45:"Tokens related to the "Nag Message" entities.";s:10:"needs-data";s:17:"list<nag_message>";s:4:"type";s:17:"list<nag_message>";}s:10:"list<node>";a:4:{s:4:"name";s:13:"List of Nodes";s:11:"description";s:38:"Tokens related to the "Node" entities.";s:10:"needs-data";s:10:"list<node>";s:4:"type";s:10:"list<node>";}s:12:"list<points>";a:4:{s:4:"name";s:15:"List of Pointss";s:11:"description";s:40:"Tokens related to the "Points" entities.";s:10:"needs-data";s:12:"list<points>";s:4:"type";s:12:"list<points>";}s:11:"list<prize>";a:4:{s:4:"name";s:14:"List of Prizes";s:11:"description";s:39:"Tokens related to the "Prize" entities.";s:10:"needs-data";s:11:"list<prize>";s:4:"type";s:11:"list<prize>";}s:13:"list<program>";a:4:{s:4:"name";s:16:"List of Programs";s:11:"description";s:41:"Tokens related to the "Program" entities.";s:10:"needs-data";s:13:"list<program>";s:4:"type";s:13:"list<program>";}s:25:"list<reader_activity_log>";a:4:{s:4:"name";s:28:"List of Reader Activity Logs";s:11:"description";s:53:"Tokens related to the "Reader Activity Log" entities.";s:10:"needs-data";s:25:"list<reader_activity_log>";s:4:"type";s:25:"list<reader_activity_log>";}s:18:"list<reader_badge>";a:4:{s:4:"name";s:21:"List of Reader Badges";s:11:"description";s:46:"Tokens related to the "Reader Badge" entities.";s:10:"needs-data";s:18:"list<reader_badge>";s:4:"type";s:18:"list<reader_badge>";}s:16:"list<reader_log>";a:4:{s:4:"name";s:19:"List of Reader Logs";s:11:"description";s:44:"Tokens related to the "Reader Log" entities.";s:10:"needs-data";s:16:"list<reader_log>";s:4:"type";s:16:"list<reader_log>";}s:18:"list<reader_prize>";a:4:{s:4:"name";s:21:"List of Reader Prizes";s:11:"description";s:46:"Tokens related to the "Reader Prize" entities.";s:10:"needs-data";s:18:"list<reader_prize>";s:4:"type";s:18:"list<reader_prize>";}s:19:"list<reader_ticket>";a:4:{s:4:"name";s:22:"List of Reader Tickets";s:11:"description";s:47:"Tokens related to the "Reader Ticket" entities.";s:10:"needs-data";s:19:"list<reader_ticket>";s:4:"type";s:19:"list<reader_ticket>";}s:12:"list<reader>";a:4:{s:4:"name";s:15:"List of Readers";s:11:"description";s:40:"Tokens related to the "Reader" entities.";s:10:"needs-data";s:12:"list<reader>";s:4:"type";s:12:"list<reader>";}s:17:"list<reading_log>";a:4:{s:4:"name";s:20:"List of Reading Logs";s:11:"description";s:45:"Tokens related to the "Reading Log" entities.";s:10:"needs-data";s:17:"list<reading_log>";s:4:"type";s:17:"list<reading_log>";}s:18:"list<rules_config>";a:4:{s:4:"name";s:28:"List of Rules configurations";s:11:"description";s:53:"Tokens related to the "Rules configuration" entities.";s:10:"needs-data";s:18:"list<rules_config>";s:4:"type";s:18:"list<rules_config>";}s:12:"list<school>";a:4:{s:4:"name";s:15:"List of Schools";s:11:"description";s:40:"Tokens related to the "School" entities.";s:10:"needs-data";s:12:"list<school>";s:4:"type";s:12:"list<school>";}s:10:"list<term>";a:4:{s:4:"name";s:22:"List of Taxonomy terms";s:11:"description";s:47:"Tokens related to the "Taxonomy term" entities.";s:10:"needs-data";s:10:"list<term>";s:4:"type";s:10:"list<term>";}s:16:"list<vocabulary>";a:4:{s:4:"name";s:29:"List of Taxonomy vocabularies";s:11:"description";s:53:"Tokens related to the "Taxonomy vocabulary" entities.";s:10:"needs-data";s:16:"list<vocabulary>";s:4:"type";s:16:"list<vocabulary>";}s:10:"list<user>";a:4:{s:4:"name";s:13:"List of Users";s:11:"description";s:38:"Tokens related to the "User" entities.";s:10:"needs-data";s:10:"list<user>";s:4:"type";s:10:"list<user>";}s:30:"list<WorkflowConfigTransition>";a:4:{s:4:"name";s:35:"List of Workflow config transitions";s:11:"description";s:60:"Tokens related to the "Workflow config transition" entities.";s:10:"needs-data";s:30:"list<WorkflowConfigTransition>";s:4:"type";s:30:"list<WorkflowConfigTransition>";}s:24:"list<WorkflowTransition>";a:4:{s:4:"name";s:37:"List of Workflow executed transitions";s:11:"description";s:62:"Tokens related to the "Workflow executed transition" entities.";s:10:"needs-data";s:24:"list<WorkflowTransition>";s:4:"type";s:24:"list<WorkflowTransition>";}s:14:"list<Workflow>";a:4:{s:4:"name";s:17:"List of Workflows";s:11:"description";s:42:"Tokens related to the "Workflow" entities.";s:10:"needs-data";s:14:"list<Workflow>";s:4:"type";s:14:"list<Workflow>";}s:33:"list<WorkflowScheduledTransition>";a:4:{s:4:"name";s:38:"List of Workflow scheduled transitions";s:11:"description";s:63:"Tokens related to the "Workflow scheduled transition" entities.";s:10:"needs-data";s:33:"list<WorkflowScheduledTransition>";s:4:"type";s:33:"list<WorkflowScheduledTransition>";}s:19:"list<WorkflowState>";a:4:{s:4:"name";s:23:"List of Workflow states";s:11:"description";s:48:"Tokens related to the "Workflow state" entities.";s:10:"needs-data";s:19:"list<WorkflowState>";s:4:"type";s:19:"list<WorkflowState>";}s:10:"list<date>";a:4:{s:4:"name";s:19:"List of date values";s:11:"description";s:32:"Tokens for lists of date values.";s:10:"needs-data";s:10:"list<date>";s:4:"type";s:10:"list<date>";}s:9:"menu-link";a:4:{s:4:"name";s:10:"Menu links";s:11:"description";s:29:"Tokens related to menu links.";s:10:"needs-data";s:9:"menu-link";s:4:"type";s:9:"menu-link";}s:4:"menu";a:4:{s:4:"name";s:5:"Menus";s:11:"description";s:24:"Tokens related to menus.";s:10:"needs-data";s:4:"menu";s:4:"type";s:4:"menu";}s:11:"nag_message";a:4:{s:4:"name";s:11:"Nag Message";s:11:"description";s:45:"Tokens related to the "Nag Message" entities.";s:10:"needs-data";s:11:"nag_message";s:4:"type";s:11:"nag_message";}s:4:"node";a:4:{s:4:"name";s:5:"Nodes";s:11:"description";s:55:"Tokens related to individual content items, or "nodes".";s:10:"needs-data";s:4:"node";s:4:"type";s:4:"node";}s:6:"points";a:4:{s:4:"name";s:6:"Points";s:11:"description";s:40:"Tokens related to the "Points" entities.";s:10:"needs-data";s:6:"points";s:4:"type";s:6:"points";}s:5:"prize";a:4:{s:4:"name";s:5:"Prize";s:11:"description";s:39:"Tokens related to the "Prize" entities.";s:10:"needs-data";s:5:"prize";s:4:"type";s:5:"prize";}s:7:"program";a:4:{s:4:"name";s:7:"Program";s:11:"description";s:41:"Tokens related to the "Program" entities.";s:10:"needs-data";s:7:"program";s:4:"type";s:7:"program";}s:6:"random";a:3:{s:4:"name";s:6:"Random";s:11:"description";s:30:"Tokens related to random data.";s:4:"type";s:6:"random";}s:6:"reader";a:4:{s:4:"name";s:6:"Reader";s:11:"description";s:40:"Tokens related to the "Reader" entities.";s:10:"needs-data";s:6:"reader";s:4:"type";s:6:"reader";}s:19:"reader_activity_log";a:4:{s:4:"name";s:19:"Reader Activity Log";s:11:"description";s:53:"Tokens related to the "Reader Activity Log" entities.";s:10:"needs-data";s:19:"reader_activity_log";s:4:"type";s:19:"reader_activity_log";}s:12:"reader_badge";a:4:{s:4:"name";s:12:"Reader Badge";s:11:"description";s:46:"Tokens related to the "Reader Badge" entities.";s:10:"needs-data";s:12:"reader_badge";s:4:"type";s:12:"reader_badge";}s:10:"reader_log";a:4:{s:4:"name";s:10:"Reader Log";s:11:"description";s:44:"Tokens related to the "Reader Log" entities.";s:10:"needs-data";s:10:"reader_log";s:4:"type";s:10:"reader_log";}s:12:"reader_prize";a:4:{s:4:"name";s:12:"Reader Prize";s:11:"description";s:46:"Tokens related to the "Reader Prize" entities.";s:10:"needs-data";s:12:"reader_prize";s:4:"type";s:12:"reader_prize";}s:13:"reader_ticket";a:4:{s:4:"name";s:13:"Reader Ticket";s:11:"description";s:47:"Tokens related to the "Reader Ticket" entities.";s:10:"needs-data";s:13:"reader_ticket";s:4:"type";s:13:"reader_ticket";}s:11:"reading_log";a:4:{s:4:"name";s:11:"Reading Log";s:11:"description";s:45:"Tokens related to the "Reading Log" entities.";s:10:"needs-data";s:11:"reading_log";s:4:"type";s:11:"reading_log";}s:12:"rules_config";a:4:{s:4:"name";s:19:"Rules configuration";s:11:"description";s:53:"Tokens related to the "Rules configuration" entities.";s:10:"needs-data";s:12:"rules_config";s:4:"type";s:12:"rules_config";}s:6:"school";a:4:{s:4:"name";s:6:"School";s:11:"description";s:40:"Tokens related to the "School" entities.";s:10:"needs-data";s:6:"school";s:4:"type";s:6:"school";}s:4:"site";a:3:{s:4:"name";s:16:"Site information";s:11:"description";s:59:"Tokens for site-wide settings and other global information.";s:4:"type";s:4:"site";}s:4:"term";a:4:{s:4:"name";s:14:"Taxonomy terms";s:11:"description";s:33:"Tokens related to taxonomy terms.";s:10:"needs-data";s:4:"term";s:4:"type";s:4:"term";}s:9:"rules_uri";a:4:{s:4:"name";s:3:"URI";s:11:"description";s:67:"Tokens related to <em class="placeholder">URI</em> Rules variables.";s:10:"needs-data";s:9:"rules_uri";s:4:"type";s:9:"rules_uri";}s:3:"url";a:4:{s:4:"name";s:3:"URL";s:11:"description";s:23:"Tokens related to URLs.";s:10:"needs-data";s:4:"path";s:4:"type";s:3:"url";}s:4:"user";a:4:{s:4:"name";s:5:"Users";s:11:"description";s:43:"Tokens related to individual user accounts.";s:10:"needs-data";s:4:"user";s:4:"type";s:4:"user";}s:4:"view";a:4:{s:4:"name";s:4:"View";s:11:"description";s:24:"Tokens related to views.";s:10:"needs-data";s:4:"view";s:4:"type";s:4:"view";}s:10:"vocabulary";a:4:{s:4:"name";s:12:"Vocabularies";s:11:"description";s:40:"Tokens related to taxonomy vocabularies.";s:10:"needs-data";s:10:"vocabulary";s:4:"type";s:10:"vocabulary";}s:8:"Workflow";a:4:{s:4:"name";s:8:"Workflow";s:11:"description";s:28:"Tokens related to workflows.";s:10:"needs-data";s:18:"WorkflowTransition";s:4:"type";s:8:"Workflow";}s:13:"WorkflowState";a:4:{s:4:"name";s:14:"Workflow State";s:11:"description";s:33:"Tokens related to workflow state.";s:10:"needs-data";s:18:"WorkflowTransition";s:4:"type";s:13:"WorkflowState";}s:18:"WorkflowTransition";a:4:{s:4:"name";s:19:"Workflow Transition";s:11:"description";s:39:"Tokens related to workflow transitions.";s:10:"needs-data";s:13:"WorkflowField";s:4:"type";s:18:"WorkflowTransition";}s:24:"WorkflowConfigTransition";a:4:{s:4:"name";s:26:"Workflow config transition";s:11:"description";s:60:"Tokens related to the "Workflow config transition" entities.";s:10:"needs-data";s:24:"WorkflowConfigTransition";s:4:"type";s:24:"WorkflowConfigTransition";}s:13:"WorkflowField";a:4:{s:4:"name";s:9:"Workflows";s:11:"description";s:28:"Tokens related to workflows.";s:10:"needs-data";s:6:"entity";s:4:"type";s:13:"WorkflowField";}s:27:"WorkflowScheduledTransition";a:4:{s:4:"name";s:29:"Workflow scheduled transition";s:11:"description";s:63:"Tokens related to the "Workflow scheduled transition" entities.";s:10:"needs-data";s:27:"WorkflowScheduledTransition";s:4:"type";s:27:"WorkflowScheduledTransition";}s:10:"rules_date";a:4:{s:4:"name";s:4:"date";s:11:"description";s:68:"Tokens related to <em class="placeholder">date</em> Rules variables.";s:10:"needs-data";s:10:"rules_date";s:4:"type";s:10:"rules_date";}s:13:"rules_decimal";a:4:{s:4:"name";s:14:"decimal number";s:11:"description";s:78:"Tokens related to <em class="placeholder">decimal number</em> Rules variables.";s:10:"needs-data";s:13:"rules_decimal";s:4:"type";s:13:"rules_decimal";}s:14:"rules_duration";a:4:{s:4:"name";s:8:"duration";s:11:"description";s:72:"Tokens related to <em class="placeholder">duration</em> Rules variables.";s:10:"needs-data";s:14:"rules_duration";s:4:"type";s:14:"rules_duration";}s:13:"rules_integer";a:4:{s:4:"name";s:7:"integer";s:11:"description";s:71:"Tokens related to <em class="placeholder">integer</em> Rules variables.";s:10:"needs-data";s:13:"rules_integer";s:4:"type";s:13:"rules_integer";}s:10:"rules_text";a:4:{s:4:"name";s:4:"text";s:11:"description";s:68:"Tokens related to <em class="placeholder">text</em> Rules variables.";s:10:"needs-data";s:10:"rules_text";s:4:"type";s:10:"rules_text";}s:11:"rules_token";a:4:{s:4:"name";s:10:"text token";s:11:"description";s:74:"Tokens related to <em class="placeholder">text token</em> Rules variables.";s:10:"needs-data";s:11:"rules_token";s:4:"type";s:11:"rules_token";}}}','0','1493614688','1');
DROP TABLE IF EXISTS `cache_views`;
CREATE TABLE `cache_views` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
DROP TABLE IF EXISTS `cache_views_data`;
CREATE TABLE `cache_views_data` (   `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',   `data` longblob COMMENT 'A collection of data to cache.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',   `serialized` smallint(6) NOT NULL DEFAULT '1' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',   PRIMARY KEY (`cid`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for views to store pre-rendered queries,...';
DROP TABLE IF EXISTS `comment`;
CREATE TABLE `comment` (   `cid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique comment ID.',   `pid` int(11) NOT NULL DEFAULT '0' COMMENT 'The comment.cid to which this comment is a reply. If set to 0, this comment is not a reply to an existing comment.',   `nid` int(11) NOT NULL DEFAULT '0' COMMENT 'The node.nid to which this comment is a reply.',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid who authored the comment. If set to 0, this comment was created by an anonymous user.',   `subject` varchar(64) NOT NULL DEFAULT '' COMMENT 'The comment title.',   `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'The author’s host name.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The time that the comment was created, as a Unix timestamp.',   `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The time that the comment was last edited, as a Unix timestamp.',   `status` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'The published status of a comment. (0 = Not Published, 1 = Published)',   `thread` varchar(255) NOT NULL COMMENT 'The vancode representation of the comment’s place in a thread.',   `name` varchar(60) DEFAULT NULL COMMENT 'The comment author’s name. Uses users.name if the user is logged in, otherwise uses the value typed into the comment form.',   `mail` varchar(64) DEFAULT NULL COMMENT 'The comment author’s e-mail address from the comment form, if user is anonymous, and the ’Anonymous users may/must leave their contact information’ setting is turned on.',   `homepage` varchar(255) DEFAULT NULL COMMENT 'The comment author’s home page address from the comment form, if user is anonymous, and the ’Anonymous users may/must leave their contact information’ setting is turned on.',   `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The languages.language of this comment.',   PRIMARY KEY (`cid`),   KEY `comment_status_pid` (`pid`,`status`),   KEY `comment_num_new` (`nid`,`status`,`created`,`cid`,`thread`),   KEY `comment_uid` (`uid`),   KEY `comment_nid_language` (`nid`,`language`),   KEY `comment_created` (`created`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores comments and associated data.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `content_access`;
CREATE TABLE `content_access` (   `nid` int(10) unsigned NOT NULL DEFAULT '0',   `settings` mediumtext,   PRIMARY KEY (`nid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ctools_css_cache`;
CREATE TABLE `ctools_css_cache` (   `cid` varchar(128) NOT NULL COMMENT 'The CSS ID this cache object belongs to.',   `filename` varchar(255) DEFAULT NULL COMMENT 'The filename this CSS is stored in.',   `css` longtext COMMENT 'CSS being stored.',   `filter` tinyint(4) DEFAULT NULL COMMENT 'Whether or not this CSS needs to be filtered.',   PRIMARY KEY (`cid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A special cache used to store CSS that must be non-volatile.';
DROP TABLE IF EXISTS `ctools_object_cache`;
CREATE TABLE `ctools_object_cache` (   `sid` varchar(64) NOT NULL COMMENT 'The session ID this cache object belongs to.',   `name` varchar(128) NOT NULL COMMENT 'The name of the object this cache is attached to.',   `obj` varchar(128) NOT NULL COMMENT 'The type of the object this cache is attached to; this essentially represents the owner so that several sub-systems can use this cache.',   `updated` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The time this cache was created or updated.',   `data` longblob COMMENT 'Serialized data being stored.',   PRIMARY KEY (`sid`,`obj`,`name`),   KEY `updated` (`updated`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A special cache used to store objects that are being...';
DROP TABLE IF EXISTS `date_format_locale`;
CREATE TABLE `date_format_locale` (   `format` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The date format string.',   `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',   `language` varchar(12) NOT NULL COMMENT 'A languages.language for this format to be used with.',   PRIMARY KEY (`type`,`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores configured date formats for each locale.';
DROP TABLE IF EXISTS `date_format_type`;
CREATE TABLE `date_format_type` (   `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',   `title` varchar(255) NOT NULL COMMENT 'The human readable name of the format type.',   `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether or not this is a system provided format.',   PRIMARY KEY (`type`),   KEY `title` (`title`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores configured date format types.';
INSERT INTO `date_format_type` VALUES ('long','Long','1'),('medium','Medium','1'),('short','Short','1');
DROP TABLE IF EXISTS `date_formats`;
CREATE TABLE `date_formats` (   `dfid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The date format identifier.',   `format` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The date format string.',   `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',   `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether or not this format can be modified.',   PRIMARY KEY (`dfid`),   UNIQUE KEY `formats` (`format`,`type`) ) ENGINE=InnoDB AUTO_INCREMENT=36 DEFAULT CHARSET=utf8 COMMENT='Stores configured date formats.' AUTO_INCREMENT=36;
INSERT INTO `date_formats` VALUES ('1','Y-m-d H:i','short','1'),('2','m/d/Y - H:i','short','1'),('3','d/m/Y - H:i','short','1'),('4','Y/m/d - H:i','short','1'),('5','d.m.Y - H:i','short','1'),('6','m/d/Y - g:ia','short','1'),('7','d/m/Y - g:ia','short','1'),('8','Y/m/d - g:ia','short','1'),('9','M j Y - H:i','short','1'),('10','j M Y - H:i','short','1'),('11','Y M j - H:i','short','1'),('12','M j Y - g:ia','short','1'),('13','j M Y - g:ia','short','1'),('14','Y M j - g:ia','short','1'),('15','D, Y-m-d H:i','medium','1'),('16','D, m/d/Y - H:i','medium','1'),('17','D, d/m/Y - H:i','medium','1'),('18','D, Y/m/d - H:i','medium','1'),('19','F j, Y - H:i','medium','1'),('20','j F, Y - H:i','medium','1'),('21','Y, F j - H:i','medium','1'),('22','D, m/d/Y - g:ia','medium','1'),('23','D, d/m/Y - g:ia','medium','1'),('24','D, Y/m/d - g:ia','medium','1'),('25','F j, Y - g:ia','medium','1'),('26','j F Y - g:ia','medium','1'),('27','Y, F j - g:ia','medium','1'),('28','j. F Y - G:i','medium','1'),('29','l, F j, Y - H:i','long','1'),('30','l, j F, Y - H:i','long','1');
INSERT INTO `date_formats` VALUES ('31','l, Y,  F j - H:i','long','1'),('32','l, F j, Y - g:ia','long','1'),('33','l, j F Y - g:ia','long','1'),('34','l, Y,  F j - g:ia','long','1'),('35','l, j. F Y - G:i','long','1');
DROP TABLE IF EXISTS `eck_activity`;
CREATE TABLE `eck_activity` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) activity.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'Language',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) activity.' AUTO_INCREMENT=9;
DROP TABLE IF EXISTS `eck_activity_log`;
CREATE TABLE `eck_activity_log` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) activity_log.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'Language',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=38 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) activity_log.' AUTO_INCREMENT=38;
INSERT INTO `eck_activity_log` VALUES ('1','activity_log','Sat Quietly activity claim93','53','1487895358','und'),('2','activity_log','Read the Harry Potter Series activity claim93','53','1487895364','und'),('3','activity_log','Open Sesamecode claim93','53','1487895383','und'),('4','activity_log','Read the Harry Potter Series activity claim93','53','1487895463','und'),('5','activity_log','Read the Harry Potter Series activity claim90','53','1487895479','und'),('6','activity_log','Sat Quietly activity claim90','53','1487895482','und'),('7','activity_log','Open Sesamecode claim90','53','1487895499','und'),('8','activity_log','Sat Quietly activity claim90','53','1487895588','und'),('9','activity_log','Sat Quietly activity claim102','95','1489622581','und'),('10','activity_log','Activity #3 activity claim102','95','1489622586','und'),('11','activity_log','Activity #5 activity claim102','95','1489622589','und'),('12','activity_log','Activity #6 activity claim102','95','1489622594','und'),('13','activity_log','Activity #5 activity claim102','0','1489674468','und'),('14','activity_log','Read the Harry Potter Series activity claim103','96','1489684396','und'),('15','activity_log','Sat Quietly activity claim105','97','1489689540','und'),('16','activity_log','Read the Harry Potter Series activity claim105','97','1489689543','und'),('17','activity_log','Activity #3 activity claim105','97','1489689546','und'),('18','activity_log','Activity #4 activity claim105','97','1489689549','und'),('19','activity_log','Activity #5 activity claim105','97','1489689555','und'),('20','activity_log','Sat Quietly activity claim106','99','1489717117','und'),('21','activity_log','Read the Harry Potter Series activity claim106','99','1489717120','und'),('22','activity_log','Activity #3 activity claim106','99','1489717122','und'),('23','activity_log','Activity #4 activity claim106','99','1489717123','und'),('24','activity_log','Activity #3 activity claim106','99','1489717125','und'),('25','activity_log','Activity #4 activity claim106','99','1489717128','und'),('26','activity_log','Play a board game in the library activity claim103','96','1489724063','und');
INSERT INTO `eck_activity_log` VALUES ('27','activity_log','Sat Quietly activity claim107','99','1490036470','und'),('28','activity_log','Read the Harry Potter Series activity claim107','99','1490036472','und'),('29','activity_log','Activity #3 activity claim107','99','1490036474','und'),('30','activity_log','Activity #4 activity claim107','99','1490036477','und'),('31','activity_log','Activity #5 activity claim107','99','1490036480','und'),('32','activity_log','Sat Quietly activity claim120','113','1490038699','und'),('33','activity_log','Sat Quietly activity claim120','0','1490038809','und'),('34','activity_log','Sat Quietly activity claim120','0','1490038891','und'),('35','activity_log','Sat Quietly activity claim120','0','1490039079','und'),('36','activity_log','Read the Harry Potter Series activity claim120','113','1490040433','und'),('37','activity_log','Activity #3 activity claim120','113','1490041477','und');
DROP TABLE IF EXISTS `eck_activity_log_reference`;
CREATE TABLE `eck_activity_log_reference` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) activity_log_reference.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) activity_log_reference.' AUTO_INCREMENT=3;
INSERT INTO `eck_activity_log_reference` VALUES ('1','activity_log_reference'),('2','activity_log_reference');
DROP TABLE IF EXISTS `eck_badge`;
CREATE TABLE `eck_badge` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) badge.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) badge.' AUTO_INCREMENT=15;
DROP TABLE IF EXISTS `eck_branch`;
CREATE TABLE `eck_branch` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) branch.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) branch.' AUTO_INCREMENT=3;
DROP TABLE IF EXISTS `eck_bundle`;
CREATE TABLE `eck_bundle` (   `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a bundle',   `machine_name` varchar(128) NOT NULL COMMENT 'A combination of the entity type and the name ofthis bundle, this combination is unique',   `entity_type` varchar(128) NOT NULL COMMENT 'The entity type this bundle belongs to',   `name` varchar(128) NOT NULL COMMENT 'The bundle’s name',   `label` varchar(128) NOT NULL COMMENT 'A human readable name for the bundle (not that the type is not human readable)',   `config` text NOT NULL COMMENT 'A serialized list of the bundle settings.',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=22 DEFAULT CHARSET=utf8 COMMENT='The base table for bundle information' AUTO_INCREMENT=22;
INSERT INTO `eck_bundle` VALUES ('1','branch_branch','branch','branch','Branch','[]'),('2','program_program','program','program','Program','[]'),('3','level_level','level','level','Level','[]'),('5','reader_reader','reader','reader','Reader','[]'),('6','reader_log_reader_log','reader_log','reader_log','Reader Log','[]'),('7','drawing_ticket_drawing_ticket','drawing_ticket','drawing_ticket','Drawing Ticket','[]'),('8','prize_prize','prize','prize','Prize','[]'),('9','school_school','school','school','School','[]'),('10','reading_log_reading_log','reading_log','reading_log','Reading Log','[]'),('11','badge_badge','badge','badge','Badge','[]'),('12','reader_prize_reader_prize','reader_prize','reader_prize','Reader Prize','[]'),('13','points_points','points','points','Points','[]'),('14','activity_log_reference_activity_log_reference','activity_log_reference','activity_log_reference','Activity Log Reference','[]'),('15','reader_badge_reader_badge','reader_badge','reader_badge','Reader Badge','[]'),('16','reader_activity_log_reader_activity_log','reader_activity_log','reader_activity_log','Reader Activity Log','[]'),('17','nag_message_nag_message','nag_message','nag_message','Nag Message','[]'),('18','reader_ticket_reader_ticket','reader_ticket','reader_ticket','Reader Ticket','[]'),('19','activity_activity','activity','activity','Activity','[]'),('20','activity_secret_code','activity','secret_code','Secret Code','[]'),('21','activity_log_activity_log','activity_log','activity_log','Activity Log','[]');
DROP TABLE IF EXISTS `eck_drawing_ticket`;
CREATE TABLE `eck_drawing_ticket` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) drawing_ticket.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   PRIMARY KEY (`id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) drawing_ticket.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `eck_entity_type`;
CREATE TABLE `eck_entity_type` (   `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a bundle',   `name` varchar(128) NOT NULL COMMENT 'The machine name of the entity',   `label` varchar(128) NOT NULL COMMENT 'The entity’s Label',   `properties` text NOT NULL COMMENT 'A serialized list of properties attached to this entity.',   PRIMARY KEY (`id`),   UNIQUE KEY `name` (`name`) ) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8 COMMENT='The base table for entity type information' AUTO_INCREMENT=21;
INSERT INTO `eck_entity_type` VALUES ('1','branch','Branch','{"title":{"label":"Title","type":"text","behavior":"title"},"uid":{"label":"Author","type":"integer","behavior":"author"},"created":{"label":"Created","type":"integer","behavior":"created"}}'),('2','program','Program','{"title":{"label":"Title","type":"text","behavior":"title"},"uid":{"label":"Author","type":"integer","behavior":"author"},"created":{"label":"Created","type":"integer","behavior":"created"}}'),('3','level','Level','{"title":{"label":"Title","type":"text","behavior":"title"},"uid":{"label":"Author","type":"integer","behavior":"author"},"created":{"label":"Created","type":"integer","behavior":"created"}}'),('5','reader','Reader','{"title":{"label":"Title","type":"text","behavior":"title"},"uid":{"label":"Author","type":"integer","behavior":"author"}}'),('6','reader_log','Reader Log','{"title":{"label":"Title","type":"text","behavior":"title"}}'),('7','drawing_ticket','Drawing Ticket','{"title":{"label":"Title","type":"text","behavior":"title"},"uid":{"label":"Author","type":"integer","behavior":"author"},"created":{"label":"Created","type":"integer","behavior":"created"}}'),('8','prize','Prize','{"title":{"label":"Title","type":"text","behavior":"title"},"uid":{"label":"Author","type":"integer","behavior":"author"},"created":{"label":"Created","type":"integer","behavior":"created"}}'),('9','school','School','{"title":{"label":"Title","type":"text","behavior":"title"}}'),('10','reading_log','Reading Log','{"title":{"label":"Title","type":"text","behavior":"title"},"uid":{"label":"Author","type":"integer","behavior":"author"},"created":{"label":"Created","type":"integer","behavior":"created"},"changed":{"label":"Changed","type":"integer","behavior":"changed"}}'),('11','badge','Badge','{"title":{"label":"Title","type":"text","behavior":"title"}}'),('12','reader_prize','Reader Prize','{"title":{"label":"Title","type":"text","behavior":"title"},"created":{"label":"Created","type":"integer","behavior":"created"},"uid":{"label":"Author","type":"integer","behavior":"author"}}');
INSERT INTO `eck_entity_type` VALUES ('13','points','Points','{"uid":{"label":"Author","type":"integer","behavior":"author"}}'),('14','activity_log_reference','Activity Log Reference','[]'),('15','reader_badge','Reader Badge','{"uid":{"label":"Author","type":"integer","behavior":"author"}}'),('16','reader_activity_log','Reader Activity Log','{"title":{"label":"Title","type":"text","behavior":"title"}}'),('17','nag_message','Nag Message','{"title":{"label":"Title","type":"text","behavior":"title"}}'),('18','reader_ticket','Reader Ticket','{"title":{"label":"Title","type":"text","behavior":"title"},"uid":{"label":"Author","type":"integer","behavior":"author"},"created":{"label":"Created","type":"integer","behavior":"created"}}'),('19','activity','Activity','{"title":{"label":"Title","type":"text","behavior":"title"},"uid":{"label":"Author","type":"integer","behavior":"author"},"created":{"label":"Created","type":"integer","behavior":"created"},"language":{"label":"Entity language","type":"language","behavior":"language"}}'),('20','activity_log','Activity Log','{"title":{"label":"Title","type":"text","behavior":"title"},"uid":{"label":"Author","type":"integer","behavior":"author"},"created":{"label":"Created","type":"integer","behavior":"created"},"language":{"label":"Entity language","type":"language","behavior":"language"}}');
DROP TABLE IF EXISTS `eck_level`;
CREATE TABLE `eck_level` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) level.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=32 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) level.' AUTO_INCREMENT=32;
INSERT INTO `eck_level` VALUES ('31','level','0 Test','1','1492737930');
DROP TABLE IF EXISTS `eck_nag_message`;
CREATE TABLE `eck_nag_message` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) nag_message.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   PRIMARY KEY (`id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) nag_message.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `eck_points`;
CREATE TABLE `eck_points` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) points.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=129 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) points.' AUTO_INCREMENT=129;
INSERT INTO `eck_points` VALUES ('5','points','0'),('6','points','0'),('7','points','0'),('8','points','0'),('9','points','0'),('10','points','0'),('11','points','0'),('12','points','0'),('13','points','0'),('14','points','0'),('15','points','0'),('16','points','0'),('17','points','0'),('18','points','0'),('19','points','0'),('20','points','0'),('21','points','0'),('22','points','0'),('23','points','0'),('24','points','0'),('25','points','0'),('26','points','0'),('27','points','0'),('28','points','0'),('29','points','0'),('30','points','0'),('31','points','0'),('32','points','0'),('33','points','0'),('34','points','0');
INSERT INTO `eck_points` VALUES ('35','points','0'),('36','points','0'),('37','points','0'),('38','points','0'),('39','points','0'),('40','points','0'),('41','points','0'),('42','points','0'),('43','points','0'),('51','points','74'),('52','points','74'),('53','points','74'),('54','points','74'),('55','points','74'),('56','points','74'),('57','points','75'),('58','points','75'),('59','points','75'),('60','points','75'),('61','points','75'),('63','points','53'),('64','points','53'),('65','points','53'),('66','points','53'),('67','points','53'),('68','points','53'),('69','points','53'),('70','points','53'),('71','points','95'),('72','points','95');
INSERT INTO `eck_points` VALUES ('73','points','95'),('74','points','95'),('75','points','0'),('85','points','99'),('86','points','99'),('87','points','99'),('88','points','99'),('89','points','99'),('90','points','99'),('91','points','99'),('92','points','99'),('93','points','99'),('94','points','99'),('95','points','99'),('96','points','99'),('97','points','99'),('113','points','106'),('114','points','107'),('115','points','108'),('116','points','110'),('117','points','99'),('118','points','99'),('119','points','99'),('120','points','99'),('121','points','99'),('122','points','113'),('123','points','113'),('124','points','113'),('125','points','113'),('126','points','113');
INSERT INTO `eck_points` VALUES ('127','points','113'),('128','points','113');
DROP TABLE IF EXISTS `eck_prize`;
CREATE TABLE `eck_prize` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) prize.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) prize.' AUTO_INCREMENT=7;
INSERT INTO `eck_prize` VALUES ('1','prize','Book collection','1','1480425978'),('2','prize','New Prize','1','1480433784'),('3','prize','Third Prize','1','1481922493'),('4','prize','Supro 1695T Black Magick','1','1487603904'),('5','prize','pizza ','71','1487606576'),('6','prize','pizza 2 ','71','1487606608');
DROP TABLE IF EXISTS `eck_program`;
CREATE TABLE `eck_program` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) program.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) program.' AUTO_INCREMENT=15;
INSERT INTO `eck_program` VALUES ('14','program','Test','1','1492737930');
DROP TABLE IF EXISTS `eck_reader`;
CREATE TABLE `eck_reader` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) reader.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=121 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) reader.' AUTO_INCREMENT=121;
DROP TABLE IF EXISTS `eck_reader_activity_log`;
CREATE TABLE `eck_reader_activity_log` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) reader_activity_log.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   PRIMARY KEY (`id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) reader_activity_log.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `eck_reader_badge`;
CREATE TABLE `eck_reader_badge` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) reader_badge.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=104 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) reader_badge.' AUTO_INCREMENT=104;
INSERT INTO `eck_reader_badge` VALUES ('4','reader_badge','0'),('5','reader_badge','0'),('6','reader_badge','0'),('7','reader_badge','0'),('8','reader_badge','0'),('9','reader_badge','0'),('10','reader_badge','0'),('11','reader_badge','0'),('12','reader_badge','0'),('13','reader_badge','0'),('14','reader_badge','0'),('15','reader_badge','0'),('16','reader_badge','0'),('17','reader_badge','0'),('18','reader_badge','0'),('19','reader_badge','0'),('20','reader_badge','0'),('21','reader_badge','0'),('22','reader_badge','0'),('23','reader_badge','0'),('24','reader_badge','0'),('25','reader_badge','0'),('26','reader_badge','0'),('27','reader_badge','0'),('28','reader_badge','0'),('29','reader_badge','0'),('30','reader_badge','0'),('31','reader_badge','0'),('32','reader_badge','0'),('33','reader_badge','0');
INSERT INTO `eck_reader_badge` VALUES ('34','reader_badge','0'),('38','reader_badge','74'),('39','reader_badge','74'),('40','reader_badge','74'),('41','reader_badge','74'),('42','reader_badge','74'),('43','reader_badge','74'),('44','reader_badge','74'),('45','reader_badge','75'),('47','reader_badge','77'),('48','reader_badge','53'),('49','reader_badge','53'),('50','reader_badge','53'),('51','reader_badge','53'),('52','reader_badge','53'),('53','reader_badge','95'),('54','reader_badge','95'),('59','reader_badge','99'),('60','reader_badge','99'),('61','reader_badge','99'),('62','reader_badge','99'),('63','reader_badge','99'),('82','reader_badge','106'),('83','reader_badge','106'),('84','reader_badge','106'),('85','reader_badge','107'),('86','reader_badge','107'),('87','reader_badge','107'),('88','reader_badge','108'),('89','reader_badge','108');
INSERT INTO `eck_reader_badge` VALUES ('90','reader_badge','108'),('91','reader_badge','109'),('92','reader_badge','110'),('93','reader_badge','110'),('94','reader_badge','110'),('95','reader_badge','112'),('96','reader_badge','113'),('97','reader_badge','99'),('98','reader_badge','113'),('99','reader_badge','113'),('100','reader_badge','113'),('101','reader_badge','113'),('102','reader_badge','113'),('103','reader_badge','113');
DROP TABLE IF EXISTS `eck_reader_log`;
CREATE TABLE `eck_reader_log` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) reader_log.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   PRIMARY KEY (`id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) reader_log.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `eck_reader_prize`;
CREATE TABLE `eck_reader_prize` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) reader_prize.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=45 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) reader_prize.' AUTO_INCREMENT=45;
DROP TABLE IF EXISTS `eck_reader_ticket`;
CREATE TABLE `eck_reader_ticket` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) reader_ticket.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=251 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) reader_ticket.' AUTO_INCREMENT=251;
DROP TABLE IF EXISTS `eck_reading_log`;
CREATE TABLE `eck_reading_log` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) reading_log.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=87 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) reading_log.' AUTO_INCREMENT=87;
INSERT INTO `eck_reading_log` VALUES ('57','reading_log','how many points do i need ','75','1487774208','1487774208'),('58','reading_log','1984','96','1489684276','1489684277'),('59','reading_log','Brave New World','96','1489684287','1489684288'),('60','reading_log','1984','96','1489684310','1489684310'),('61','reading_log','','99','1489717210','1489717210'),('62','reading_log','','99','1489717213','1489717214'),('63','reading_log','','99','1489717837','1489717837'),('64','reading_log','','99','1489717838','1489717839'),('65','reading_log','','99','1489717840','1489717840'),('66','reading_log','','99','1489717841','1489717841'),('67','reading_log','','99','1489717843','1489717843'),('68','reading_log','1984','100','1489725244','1489725245'),('69','reading_log','99','100','1489725252','1489725252'),('70','reading_log','','100','1489725255','1489725255'),('71','reading_log','99','100','1489725259','1489725259'),('72','reading_log','99','100','1489725263','1489725263'),('73','reading_log','99','100','1489725267','1489725267'),('74','reading_log','99','100','1489725270','1489725270'),('75','reading_log','99','100','1489725274','1489725274'),('76','reading_log','77','100','1489725295','1489725295'),('82','reading_log','fava','106','1489756819','1489756819'),('83','reading_log','Tacos','107','1489760336','1489760336'),('84','reading_log','fava','108','1489761067','1489761067'),('85','reading_log','awesome possume','110','1489761579','1489761579'),('86','reading_log','fava','113','1490042133','1490042134');
DROP TABLE IF EXISTS `eck_school`;
CREATE TABLE `eck_school` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) school.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',   PRIMARY KEY (`id`) ) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) school.' AUTO_INCREMENT=3;
DROP TABLE IF EXISTS `entity_block`;
CREATE TABLE `entity_block` (   `entity_block_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary key of an entity block.',   `bundle` mediumtext NOT NULL COMMENT 'The entity bundle',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The entity block title',   `target_entity_type` mediumtext NOT NULL COMMENT 'The target entity type',   `target_bundle` mediumtext NOT NULL COMMENT 'The target entity bundle',   `target_view_mode` mediumtext NOT NULL COMMENT 'The target entity view mode',   `target_entity_id` int(10) unsigned DEFAULT NULL COMMENT 'The target entity id',   PRIMARY KEY (`entity_block_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Base table for entity block.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `entityform`;
CREATE TABLE `entityform` (   `entityform_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Identifier for a entityform.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The entityform_type.type of this entityform.',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language of the entityform.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the entityform was created.',   `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the entityform was most recently saved.',   `data` longblob COMMENT 'A serialized array of additional data.',   `uid` int(10) unsigned DEFAULT NULL COMMENT 'The users.uid of the associated user.',   `draft` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Wheter this form submission is a draft.',   PRIMARY KEY (`entityform_id`),   KEY `type` (`type`),   KEY `uid` (`uid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='The base table for entityform entities.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `entityform_type`;
CREATE TABLE `entityform_type` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique entityform type identifier.',   `type` varchar(255) NOT NULL COMMENT 'The machine-readable name of this entityform type.',   `label` varchar(255) NOT NULL DEFAULT '' COMMENT 'The human-readable name of this entityform type.',   `weight` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The weight of this entityform type in relation to others.',   `data` longtext COMMENT 'A serialized array of additional data related to this entityform type.',   `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The exportable status of the entity.',   `module` varchar(255) DEFAULT NULL COMMENT 'The name of the providing module if the entity has been defined in code.',   PRIMARY KEY (`id`),   UNIQUE KEY `type` (`type`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about defined entityform types.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `feeds_importer`;
CREATE TABLE `feeds_importer` (   `id` varchar(128) NOT NULL DEFAULT '' COMMENT 'Id of the fields object.',   `config` longblob COMMENT 'Configuration of the feeds object.',   PRIMARY KEY (`id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Configuration of feeds objects.';
INSERT INTO `feeds_importer` VALUES ('reader_import','a:11:{s:4:"name";s:14:"Import Readers";s:11:"description";s:41:"Bookpoints: Reader Importer (Admin Setup)";s:7:"fetcher";a:2:{s:10:"plugin_key";s:16:"FeedsFileFetcher";s:6:"config";a:5:{s:18:"allowed_extensions";s:20:"txt csv tsv xml opml";s:20:"delete_uploaded_file";b:0;s:6:"direct";b:0;s:9:"directory";s:15:"private://feeds";s:15:"allowed_schemes";a:2:{i:0;s:6:"public";i:1;s:7:"private";}}}s:6:"parser";a:2:{s:10:"plugin_key";s:14:"FeedsCSVParser";s:6:"config";a:3:{s:9:"delimiter";s:1:",";s:8:"encoding";s:5:"UTF-8";s:10:"no_headers";i:0;}}s:9:"processor";a:2:{s:10:"plugin_key";s:26:"FeedsEntityProcessorReader";s:6:"config";a:10:{s:6:"values";a:3:{s:2:"id";s:0:"";s:5:"title";s:0:"";s:3:"uid";s:0:"";}s:9:"authorize";b:1;s:8:"mappings";a:7:{i:0;a:4:{s:6:"source";s:9:"Import ID";s:6:"target";s:4:"guid";s:6:"unique";i:1;s:8:"language";s:3:"und";}i:1;a:4:{s:6:"source";s:5:"First";s:6:"target";s:16:"field_first_name";s:6:"unique";b:0;s:8:"language";s:3:"und";}i:2;a:4:{s:6:"source";s:4:"Last";s:6:"target";s:15:"field_last_name";s:6:"unique";b:0;s:8:"language";s:3:"und";}i:3;a:4:{s:6:"source";s:3:"Age";s:6:"target";s:9:"field_age";s:6:"unique";b:0;s:8:"language";s:3:"und";}i:4;a:4:{s:6:"source";s:5:"Grade";s:6:"target";s:11:"field_grade";s:6:"unique";b:0;s:8:"language";s:3:"und";}i:5;a:4:{s:6:"source";s:6:"School";s:6:"target";s:25:"field_reader_school:label";s:6:"unique";b:0;s:8:"language";s:3:"und";}i:6;a:4:{s:6:"source";s:10:"Parent UID";s:6:"target";s:21:"field_parent_uid:etid";s:6:"unique";b:0;s:8:"language";s:3:"und";}}s:10:"insert_new";s:1:"1";s:15:"update_existing";s:1:"2";s:19:"update_non_existent";s:4:"skip";s:12:"input_format";s:10:"plain_text";s:15:"skip_hash_check";i:0;s:6:"bundle";s:6:"reader";s:8:"language";s:3:"und";}}s:12:"content_type";s:0:"";s:6:"update";i:0;s:13:"import_period";s:2:"-1";s:13:"expire_period";i:3600;s:16:"import_on_create";i:1;s:21:"process_in_background";i:0;}');
DROP TABLE IF EXISTS `feeds_item`;
CREATE TABLE `feeds_item` (   `entity_type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The entity type.',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The imported entity’s serial id.',   `id` varchar(128) NOT NULL DEFAULT '' COMMENT 'The id of the importer that created this item.',   `feed_nid` int(10) unsigned NOT NULL COMMENT 'Node id of the source, if available.',   `imported` int(11) NOT NULL DEFAULT '0' COMMENT 'Import date of the feed item, as a Unix timestamp.',   `url` text NOT NULL COMMENT 'Link to the feed item.',   `guid` text NOT NULL COMMENT 'Unique identifier for the feed item.',   `hash` varchar(32) NOT NULL DEFAULT '' COMMENT 'The hash of the source item.',   PRIMARY KEY (`entity_type`,`entity_id`),   KEY `id` (`id`),   KEY `feed_nid` (`feed_nid`),   KEY `lookup_url` (`entity_type`,`id`,`feed_nid`,`url`(128)),   KEY `lookup_guid` (`entity_type`,`id`,`feed_nid`,`guid`(128)),   KEY `global_lookup_url` (`entity_type`,`url`(128)),   KEY `global_lookup_guid` (`entity_type`,`guid`(128)),   KEY `imported` (`imported`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Tracks items such as nodes, terms, users.';
INSERT INTO `feeds_item` VALUES ('node','19','node','0','1493614688','','10001','65ca544bf141f21dc2d4953051e72f48');
DROP TABLE IF EXISTS `feeds_log`;
CREATE TABLE `feeds_log` (   `flid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique feeds event ID.',   `id` varchar(128) NOT NULL DEFAULT '' COMMENT 'The id of the importer that logged the event.',   `feed_nid` int(10) unsigned NOT NULL COMMENT 'Node id of the source, if available.',   `log_time` int(11) NOT NULL DEFAULT '0' COMMENT 'Unix timestamp of when event occurred.',   `request_time` int(11) NOT NULL DEFAULT '0' COMMENT 'Unix timestamp of the request when the event occurred.',   `type` varchar(64) NOT NULL DEFAULT '' COMMENT 'Type of log message, for example `feeds_import`.`',   `message` longtext NOT NULL COMMENT 'Text of log message to be passed into the t() function.',   `variables` longblob NOT NULL COMMENT 'Serialized array of variables that match the message string and that is passed into the t() function.',   `severity` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The severity level of the event; ranges from 0 (Emergency) to 7 (Debug)',   PRIMARY KEY (`flid`),   KEY `id` (`id`),   KEY `id_feed_nid` (`id`,`feed_nid`),   KEY `request_time` (`request_time`),   KEY `log_time` (`log_time`),   KEY `type` (`type`) ) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='Table that contains logs of feeds events.' AUTO_INCREMENT=3;
INSERT INTO `feeds_log` VALUES ('1','node','0','1493614693','1493614688','import','Created 1 node.','a:0:{}','6'),('2','node','0','1493614693','1493614688','import','Imported in @s seconds.','a:1:{s:2:"@s";i:0;}','6');
DROP TABLE IF EXISTS `feeds_push_subscriptions`;
CREATE TABLE `feeds_push_subscriptions` (   `domain` varchar(128) NOT NULL DEFAULT '' COMMENT 'Domain of the subscriber. Corresponds to an importer id.',   `subscriber_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'ID of the subscriber. Corresponds to a feed nid.',   `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Created timestamp.',   `hub` text NOT NULL COMMENT 'The URL of the hub endpoint of this subscription.',   `topic` text NOT NULL COMMENT 'The topic URL (feed URL) of this subscription.',   `secret` varchar(128) NOT NULL DEFAULT '' COMMENT 'Shared secret for message authentication.',   `status` varchar(64) NOT NULL DEFAULT '' COMMENT 'Status of subscription.',   `post_fields` text COMMENT 'Fields posted.',   PRIMARY KEY (`domain`,`subscriber_id`),   KEY `timestamp` (`timestamp`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='PubSubHubbub subscriptions.';
DROP TABLE IF EXISTS `feeds_source`;
CREATE TABLE `feeds_source` (   `id` varchar(128) NOT NULL DEFAULT '' COMMENT 'Id of the feed configuration.',   `feed_nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Node nid if this particular source is attached to a feed node.',   `config` longblob COMMENT 'Configuration of the source.',   `source` text NOT NULL COMMENT 'Main source resource identifier. E. g. a path or a URL.',   `state` longblob COMMENT 'State of import or clearing batches.',   `fetcher_result` longblob COMMENT 'Cache for fetcher result.',   `imported` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Timestamp when this source was imported last.',   PRIMARY KEY (`id`,`feed_nid`),   KEY `id` (`id`),   KEY `feed_nid` (`feed_nid`),   KEY `id_source` (`id`,`source`(128)) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Source definitions for feeds.';
INSERT INTO `feeds_source` VALUES ('node','0','a:2:{s:16:"FeedsFileFetcher";a:3:{s:3:"fid";s:0:"";s:6:"source";s:0:"";s:6:"upload";s:0:"";}s:14:"FeedsCSVParser";a:3:{s:9:"delimiter";s:1:",";s:8:"encoding";s:5:"UTF-8";s:10:"no_headers";i:0;}}','','b:0;','b:0;','1493614693');
DROP TABLE IF EXISTS `field_collection_item`;
CREATE TABLE `field_collection_item` (   `item_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique field collection item ID.',   `revision_id` int(11) NOT NULL COMMENT 'Default revision ID.',   `field_name` varchar(32) NOT NULL COMMENT 'The name of the field on the host entity embedding this entity.',   `archived` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the field collection item is archived.',   PRIMARY KEY (`item_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about field collection items.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `field_collection_item_revision`;
CREATE TABLE `field_collection_item_revision` (   `revision_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique revision ID.',   `item_id` int(11) NOT NULL COMMENT 'Field collection item ID.',   PRIMARY KEY (`revision_id`),   KEY `item_id` (`item_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores revision information about field collection items.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `field_config`;
CREATE TABLE `field_config` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a field',   `field_name` varchar(32) NOT NULL COMMENT 'The name of this field. Non-deleted field names are unique, but multiple deleted fields can have the same name.',   `type` varchar(128) NOT NULL COMMENT 'The type of this field.',   `module` varchar(128) NOT NULL DEFAULT '' COMMENT 'The module that implements the field type.',   `active` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the module that implements the field type is enabled.',   `storage_type` varchar(128) NOT NULL COMMENT 'The storage backend for the field.',   `storage_module` varchar(128) NOT NULL DEFAULT '' COMMENT 'The module that implements the storage backend.',   `storage_active` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the module that implements the storage backend is enabled.',   `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT '@TODO',   `data` longblob NOT NULL COMMENT 'Serialized data containing the field properties that do not warrant a dedicated column.',   `cardinality` tinyint(4) NOT NULL DEFAULT '0',   `translatable` tinyint(4) NOT NULL DEFAULT '0',   `deleted` tinyint(4) NOT NULL DEFAULT '0',   PRIMARY KEY (`id`),   KEY `field_name` (`field_name`),   KEY `active` (`active`),   KEY `storage_active` (`storage_active`),   KEY `deleted` (`deleted`),   KEY `module` (`module`),   KEY `storage_module` (`storage_module`),   KEY `type` (`type`),   KEY `storage_type` (`storage_type`) ) ENGINE=InnoDB AUTO_INCREMENT=114 DEFAULT CHARSET=utf8 AUTO_INCREMENT=114;
INSERT INTO `field_config` VALUES ('1','comment_body','text_long','text','1','field_sql_storage','field_sql_storage','1','0','a:6:{s:12:"entity_types";a:1:{i:0;s:7:"comment";}s:12:"translatable";b:0;s:8:"settings";a:0:{}s:7:"storage";a:4:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";i:1;}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}}','1','0','0'),('2','body','text_with_summary','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"entity_types";a:1:{i:0;s:4:"node";}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:8:"settings";a:0:{}s:12:"translatable";i:0;s:7:"storage";a:4:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:2:"id";s:1:"2";}','1','0','0'),('3','field_tags','taxonomy_term_reference','taxonomy','1','field_sql_storage','field_sql_storage','1','0','a:6:{s:8:"settings";a:1:{s:14:"allowed_values";a:1:{i:0;a:2:{s:10:"vocabulary";s:4:"tags";s:6:"parent";i:0;}}}s:12:"entity_types";a:0:{}s:12:"translatable";b:0;s:7:"storage";a:4:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";i:1;}s:12:"foreign keys";a:1:{s:3:"tid";a:2:{s:5:"table";s:18:"taxonomy_term_data";s:7:"columns";a:1:{s:3:"tid";s:3:"tid";}}}s:7:"indexes";a:1:{s:3:"tid";a:1:{i:0;s:3:"tid";}}}','-1','0','0'),('4','field_image','image','image','1','field_sql_storage','field_sql_storage','1','0','a:6:{s:7:"indexes";a:1:{s:3:"fid";a:1:{i:0;s:3:"fid";}}s:8:"settings";a:2:{s:10:"uri_scheme";s:6:"public";s:13:"default_image";b:0;}s:7:"storage";a:4:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";i:1;}s:12:"entity_types";a:0:{}s:12:"translatable";b:0;s:12:"foreign keys";a:1:{s:3:"fid";a:2:{s:5:"table";s:12:"file_managed";s:7:"columns";a:1:{s:3:"fid";s:3:"fid";}}}}','1','0','0');
INSERT INTO `field_config` VALUES ('7','field_branch_phone','text','text','1','field_sql_storage','field_sql_storage','1','0','a:8:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:2:{s:10:"max_length";s:3:"255";s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:29:"field_data_field_branch_phone";a:2:{s:5:"value";s:24:"field_branch_phone_value";s:6:"format";s:25:"field_branch_phone_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:33:"field_revision_field_branch_phone";a:2:{s:5:"value";s:24:"field_branch_phone_value";s:6:"format";s:25:"field_branch_phone_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:1:"7";s:17:"field_permissions";a:1:{s:4:"type";s:1:"0";}}','1','0','0'),('8','field_branch_address','addressfield','addressfield','1','field_sql_storage','field_sql_storage','1','0','a:8:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:31:"field_data_field_branch_address";a:14:{s:7:"country";s:28:"field_branch_address_country";s:19:"administrative_area";s:40:"field_branch_address_administrative_area";s:23:"sub_administrative_area";s:44:"field_branch_address_sub_administrative_area";s:8:"locality";s:29:"field_branch_address_locality";s:18:"dependent_locality";s:39:"field_branch_address_dependent_locality";s:11:"postal_code";s:32:"field_branch_address_postal_code";s:12:"thoroughfare";s:33:"field_branch_address_thoroughfare";s:7:"premise";s:28:"field_branch_address_premise";s:11:"sub_premise";s:32:"field_branch_address_sub_premise";s:17:"organisation_name";s:38:"field_branch_address_organisation_name";s:9:"name_line";s:30:"field_branch_address_name_line";s:10:"first_name";s:31:"field_branch_address_first_name";s:9:"last_name";s:30:"field_branch_address_last_name";s:4:"data";s:25:"field_branch_address_data";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:35:"field_revision_field_branch_address";a:14:{s:7:"country";s:28:"field_branch_address_country";s:19:"administrative_area";s:40:"field_branch_address_administrative_area";s:23:"sub_administrative_area";s:44:"field_branch_address_sub_administrative_area";s:8:"locality";s:29:"field_branch_address_locality";s:18:"dependent_locality";s:39:"field_branch_address_dependent_locality";s:11:"postal_code";s:32:"field_branch_address_postal_code";s:12:"thoroughfare";s:33:"field_branch_address_thoroughfare";s:7:"premise";s:28:"field_branch_address_premise";s:11:"sub_premise";s:32:"field_branch_address_sub_premise";s:17:"organisation_name";s:38:"field_branch_address_organisation_name";s:9:"name_line";s:30:"field_branch_address_name_line";s:10:"first_name";s:31:"field_branch_address_first_name";s:9:"last_name";s:30:"field_branch_address_last_name";s:4:"data";s:25:"field_branch_address_data";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:1:"8";s:17:"field_permissions";a:1:{s:4:"type";s:1:"0";}}','1','0','0');
INSERT INTO `field_config` VALUES ('10','field_recommended_min_age','number_integer','number','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:36:"field_data_field_recommended_min_age";a:1:{s:5:"value";s:31:"field_recommended_min_age_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:40:"field_revision_field_recommended_min_age";a:1:{s:5:"value";s:31:"field_recommended_min_age_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:2:"10";}','1','0','0'),('11','field_recommended_max_age','number_integer','number','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:36:"field_data_field_recommended_max_age";a:1:{s:5:"value";s:31:"field_recommended_max_age_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:40:"field_revision_field_recommended_max_age";a:1:{s:5:"value";s:31:"field_recommended_max_age_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:2:"11";}','1','0','0'),('12','field_scoring_type','list_text','list','1','field_sql_storage','field_sql_storage','1','0','a:8:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:14:"allowed_values";a:1:{s:15:"Points Per Unit";s:15:"Points Per Unit";}s:23:"allowed_values_function";s:0:"";s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:29:"field_data_field_scoring_type";a:1:{s:5:"value";s:24:"field_scoring_type_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:33:"field_revision_field_scoring_type";a:1:{s:5:"value";s:24:"field_scoring_type_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:1:{s:5:"value";a:1:{i:0;s:5:"value";}}s:2:"id";s:2:"12";s:17:"field_permissions";a:1:{s:4:"type";s:1:"0";}}','1','0','0');
INSERT INTO `field_config` VALUES ('15','field_per_unit_point_value','number_integer','number','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:37:"field_data_field_per_unit_point_value";a:1:{s:5:"value";s:32:"field_per_unit_point_value_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:41:"field_revision_field_per_unit_point_value";a:1:{s:5:"value";s:32:"field_per_unit_point_value_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:2:"15";}','1','0','0'),('17','field_program_description','text_long','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:36:"field_data_field_program_description";a:2:{s:5:"value";s:31:"field_program_description_value";s:6:"format";s:32:"field_program_description_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:40:"field_revision_field_program_description";a:2:{s:5:"value";s:31:"field_program_description_value";s:6:"format";s:32:"field_program_description_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"17";}','1','0','0'),('19','field_level_number','number_integer','number','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:29:"field_data_field_level_number";a:1:{s:5:"value";s:24:"field_level_number_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:33:"field_revision_field_level_number";a:1:{s:5:"value";s:24:"field_level_number_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:2:"19";}','1','0','0');
INSERT INTO `field_config` VALUES ('20','field_point_threshold','number_integer','number','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:32:"field_data_field_point_threshold";a:1:{s:5:"value";s:27:"field_point_threshold_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:36:"field_revision_field_point_threshold";a:1:{s:5:"value";s:27:"field_point_threshold_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:2:"20";}','1','0','0'),('22','field_level_message','text_long','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:30:"field_data_field_level_message";a:2:{s:5:"value";s:25:"field_level_message_value";s:6:"format";s:26:"field_level_message_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:34:"field_revision_field_level_message";a:2:{s:5:"value";s:25:"field_level_message_value";s:6:"format";s:26:"field_level_message_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"22";}','1','0','0'),('28','field_first_name','text','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:2:{s:10:"max_length";s:3:"255";s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:27:"field_data_field_first_name";a:2:{s:5:"value";s:22:"field_first_name_value";s:6:"format";s:23:"field_first_name_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:31:"field_revision_field_first_name";a:2:{s:5:"value";s:22:"field_first_name_value";s:6:"format";s:23:"field_first_name_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"28";}','1','0','0');
INSERT INTO `field_config` VALUES ('29','field_last_name','text','text','1','field_sql_storage','field_sql_storage','1','0','a:8:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:2:{s:10:"max_length";s:3:"255";s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:26:"field_data_field_last_name";a:2:{s:5:"value";s:21:"field_last_name_value";s:6:"format";s:22:"field_last_name_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:30:"field_revision_field_last_name";a:2:{s:5:"value";s:21:"field_last_name_value";s:6:"format";s:22:"field_last_name_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"29";s:17:"field_permissions";a:1:{s:4:"type";s:1:"0";}}','1','0','0'),('30','field_favorite_branch','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:4:{s:11:"target_type";s:6:"branch";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:0:{}s:4:"sort";a:3:{s:4:"type";s:8:"property";s:8:"property";s:5:"title";s:9:"direction";s:3:"ASC";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:1;}}}s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:32:"field_data_field_favorite_branch";a:1:{s:9:"target_id";s:31:"field_favorite_branch_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:36:"field_revision_field_favorite_branch";a:1:{s:9:"target_id";s:31:"field_favorite_branch_target_id";}}}}}s:12:"foreign keys";a:1:{s:10:"eck_branch";a:2:{s:5:"table";s:10:"eck_branch";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"30";}','1','0','0');
INSERT INTO `field_config` VALUES ('31','field_program_reference','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:4:{s:11:"target_type";s:7:"program";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:7:"program";s:7:"program";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:34:"field_data_field_program_reference";a:1:{s:9:"target_id";s:33:"field_program_reference_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:38:"field_revision_field_program_reference";a:1:{s:9:"target_id";s:33:"field_program_reference_target_id";}}}}}s:12:"foreign keys";a:1:{s:11:"eck_program";a:2:{s:5:"table";s:11:"eck_program";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"31";}','-1','0','0'),('34','field_age','number_integer','number','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:20:"field_data_field_age";a:1:{s:5:"value";s:15:"field_age_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:24:"field_revision_field_age";a:1:{s:5:"value";s:15:"field_age_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:2:"34";}','1','0','0'),('35','field_grade','list_text','list','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:14:"allowed_values";a:17:{s:9:"Headstart";s:9:"Headstart";s:5:"Pre-K";s:5:"Pre-K";s:12:"Kindergarten";s:12:"Kindergarten";s:5:"First";s:5:"First";s:6:"Second";s:6:"Second";s:5:"Third";s:5:"Third";s:6:"Fourth";s:6:"Fourth";s:5:"Fifth";s:5:"Fifth";s:5:"Sixth";s:5:"Sixth";s:7:"Seventh";s:7:"Seventh";s:6:"Eighth";s:6:"Eighth";s:5:"Ninth";s:5:"Ninth";s:5:"Tenth";s:5:"Tenth";s:8:"Eleventh";s:8:"Eleventh";s:7:"Twelfth";s:7:"Twelfth";s:7:"College";s:7:"College";s:13:"Not in School";s:13:"Not in School";}s:23:"allowed_values_function";s:0:"";s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:22:"field_data_field_grade";a:1:{s:5:"value";s:17:"field_grade_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:26:"field_revision_field_grade";a:1:{s:5:"value";s:17:"field_grade_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:1:{s:5:"value";a:1:{i:0;s:5:"value";}}s:2:"id";s:2:"35";}','1','0','0');
INSERT INTO `field_config` VALUES ('38','field_program','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:8:{s:12:"entity_types";a:0:{}s:17:"field_permissions";a:1:{s:4:"type";i:0;}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:8:"settings";a:4:{s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:1;}}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:14:"target_bundles";a:1:{s:7:"program";s:7:"program";}}s:16:"profile2_private";b:0;s:11:"target_type";s:7:"program";}s:12:"translatable";i:0;s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:24:"field_data_field_program";a:1:{s:9:"target_id";s:23:"field_program_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:28:"field_revision_field_program";a:1:{s:9:"target_id";s:23:"field_program_target_id";}}}}}s:12:"foreign keys";a:1:{s:11:"eck_program";a:2:{s:5:"table";s:11:"eck_program";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:2:"id";s:2:"38";}','-1','0','0'),('39','field_level','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:4:{s:11:"target_type";s:5:"level";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:5:"level";s:5:"level";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}s:16:"profile2_private";b:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:22:"field_data_field_level";a:1:{s:9:"target_id";s:21:"field_level_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:26:"field_revision_field_level";a:1:{s:9:"target_id";s:21:"field_level_target_id";}}}}}s:12:"foreign keys";a:1:{s:9:"eck_level";a:2:{s:5:"table";s:9:"eck_level";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"39";}','-1','0','0');
INSERT INTO `field_config` VALUES ('46','field_readers','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:6:"reader";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:6:"reader";s:6:"reader";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:24:"field_data_field_readers";a:1:{s:9:"target_id";s:23:"field_readers_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:28:"field_revision_field_readers";a:1:{s:9:"target_id";s:23:"field_readers_target_id";}}}}}s:12:"foreign keys";a:1:{s:10:"eck_reader";a:2:{s:5:"table";s:10:"eck_reader";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"46";}','-1','0','0'),('48','field_parent_uid','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:4:"user";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:0:{}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:27:"field_data_field_parent_uid";a:1:{s:9:"target_id";s:26:"field_parent_uid_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:31:"field_revision_field_parent_uid";a:1:{s:9:"target_id";s:26:"field_parent_uid_target_id";}}}}}s:12:"foreign keys";a:1:{s:5:"users";a:2:{s:5:"table";s:5:"users";s:7:"columns";a:1:{s:9:"target_id";s:3:"uid";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"48";}','1','0','0');
INSERT INTO `field_config` VALUES ('50','field_book_title','text','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:10:"max_length";s:3:"255";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:27:"field_data_field_book_title";a:2:{s:5:"value";s:22:"field_book_title_value";s:6:"format";s:23:"field_book_title_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:31:"field_revision_field_book_title";a:2:{s:5:"value";s:22:"field_book_title_value";s:6:"format";s:23:"field_book_title_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"50";}','1','0','0'),('51','field_units_completed','number_integer','number','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:0:{}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:32:"field_data_field_units_completed";a:1:{s:5:"value";s:27:"field_units_completed_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:36:"field_revision_field_units_completed";a:1:{s:5:"value";s:27:"field_units_completed_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:2:"51";}','1','0','0'),('52','field_unit_type','text','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:10:"max_length";s:3:"255";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:26:"field_data_field_unit_type";a:2:{s:5:"value";s:21:"field_unit_type_value";s:6:"format";s:22:"field_unit_type_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:30:"field_revision_field_unit_type";a:2:{s:5:"value";s:21:"field_unit_type_value";s:6:"format";s:22:"field_unit_type_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"52";}','1','0','0');
INSERT INTO `field_config` VALUES ('53','field_points_earned','number_integer','number','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:0:{}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:30:"field_data_field_points_earned";a:1:{s:5:"value";s:25:"field_points_earned_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:34:"field_revision_field_points_earned";a:1:{s:5:"value";s:25:"field_points_earned_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:2:"53";}','1','0','0'),('54','field_current_reader','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:6:"reader";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:6:"reader";s:6:"reader";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:31:"field_data_field_current_reader";a:1:{s:9:"target_id";s:30:"field_current_reader_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:35:"field_revision_field_current_reader";a:1:{s:9:"target_id";s:30:"field_current_reader_target_id";}}}}}s:12:"foreign keys";a:1:{s:10:"eck_reader";a:2:{s:5:"table";s:10:"eck_reader";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"54";}','1','0','0'),('55','field_badge_image','image','image','1','field_sql_storage','field_sql_storage','1','0','a:8:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:2:{s:10:"uri_scheme";s:6:"public";s:13:"default_image";i:0;}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:28:"field_data_field_badge_image";a:5:{s:3:"fid";s:21:"field_badge_image_fid";s:3:"alt";s:21:"field_badge_image_alt";s:5:"title";s:23:"field_badge_image_title";s:5:"width";s:23:"field_badge_image_width";s:6:"height";s:24:"field_badge_image_height";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:32:"field_revision_field_badge_image";a:5:{s:3:"fid";s:21:"field_badge_image_fid";s:3:"alt";s:21:"field_badge_image_alt";s:5:"title";s:23:"field_badge_image_title";s:5:"width";s:23:"field_badge_image_width";s:6:"height";s:24:"field_badge_image_height";}}}}}s:12:"foreign keys";a:1:{s:3:"fid";a:2:{s:5:"table";s:12:"file_managed";s:7:"columns";a:1:{s:3:"fid";s:3:"fid";}}}s:7:"indexes";a:1:{s:3:"fid";a:1:{i:0;s:3:"fid";}}s:2:"id";s:2:"55";s:17:"field_permissions";a:1:{s:4:"type";s:1:"0";}}','1','0','0');
INSERT INTO `field_config` VALUES ('57','field_author','text','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:10:"max_length";s:3:"255";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:23:"field_data_field_author";a:2:{s:5:"value";s:18:"field_author_value";s:6:"format";s:19:"field_author_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:27:"field_revision_field_author";a:2:{s:5:"value";s:18:"field_author_value";s:6:"format";s:19:"field_author_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"57";}','1','0','0'),('58','field_stars','list_text','list','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:2:{s:14:"allowed_values";a:5:{s:3:"One";s:3:"One";s:3:"Two";s:3:"Two";s:5:"Three";s:5:"Three";s:4:"Four";s:4:"Four";s:4:"Five";s:4:"Five";}s:23:"allowed_values_function";s:0:"";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:22:"field_data_field_stars";a:1:{s:5:"value";s:17:"field_stars_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:26:"field_revision_field_stars";a:1:{s:5:"value";s:17:"field_stars_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:1:{s:5:"value";a:1:{i:0;s:5:"value";}}s:2:"id";s:2:"58";}','1','0','0'),('59','field_prize','taxonomy_term_reference','taxonomy','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:14:"allowed_values";a:1:{i:0;a:2:{s:10:"vocabulary";s:5:"prize";s:6:"parent";s:1:"0";}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:22:"field_data_field_prize";a:1:{s:3:"tid";s:15:"field_prize_tid";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:26:"field_revision_field_prize";a:1:{s:3:"tid";s:15:"field_prize_tid";}}}}}s:12:"foreign keys";a:1:{s:3:"tid";a:2:{s:5:"table";s:18:"taxonomy_term_data";s:7:"columns";a:1:{s:3:"tid";s:3:"tid";}}}s:7:"indexes";a:1:{s:3:"tid";a:1:{i:0;s:3:"tid";}}s:2:"id";s:2:"59";}','1','0','0');
INSERT INTO `field_config` VALUES ('60','field_badge','taxonomy_term_reference','taxonomy','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:14:"allowed_values";a:1:{i:0;a:2:{s:10:"vocabulary";s:5:"badge";s:6:"parent";s:1:"0";}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:22:"field_data_field_badge";a:1:{s:3:"tid";s:15:"field_badge_tid";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:26:"field_revision_field_badge";a:1:{s:3:"tid";s:15:"field_badge_tid";}}}}}s:12:"foreign keys";a:1:{s:3:"tid";a:2:{s:5:"table";s:18:"taxonomy_term_data";s:7:"columns";a:1:{s:3:"tid";s:3:"tid";}}}s:7:"indexes";a:1:{s:3:"tid";a:1:{i:0;s:3:"tid";}}s:2:"id";s:2:"60";}','1','0','0'),('61','field_ticket_id','number_integer','number','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:0:{}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:26:"field_data_field_ticket_id";a:1:{s:5:"value";s:21:"field_ticket_id_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:30:"field_revision_field_ticket_id";a:1:{s:5:"value";s:21:"field_ticket_id_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:2:"61";}','1','0','0'),('64','field_prize_description','text_long','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:0:{}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:34:"field_data_field_prize_description";a:2:{s:5:"value";s:29:"field_prize_description_value";s:6:"format";s:30:"field_prize_description_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:38:"field_revision_field_prize_description";a:2:{s:5:"value";s:29:"field_prize_description_value";s:6:"format";s:30:"field_prize_description_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"64";}','1','0','0');
INSERT INTO `field_config` VALUES ('65','field_per_unit_label','list_text','list','1','field_sql_storage','field_sql_storage','1','0','a:8:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:2:{s:14:"allowed_values";a:8:{s:4:"Book";s:4:"Book";s:4:"Page";s:4:"Page";s:6:"Minute";s:6:"Minute";s:4:"Hour";s:4:"Hour";s:4:"Days";s:4:"Days";s:16:"15-minute period";s:16:"15-minute period";s:16:"20-minute period";s:16:"20-minute period";s:8:"Activity";s:8:"Activity";}s:23:"allowed_values_function";s:0:"";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:31:"field_data_field_per_unit_label";a:1:{s:5:"value";s:26:"field_per_unit_label_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:35:"field_revision_field_per_unit_label";a:1:{s:5:"value";s:26:"field_per_unit_label_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:1:{s:5:"value";a:1:{i:0;s:5:"value";}}s:2:"id";s:2:"65";s:17:"field_permissions";a:1:{s:4:"type";s:1:"0";}}','1','0','0'),('71','field_school_address_','text_long','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:0:{}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:32:"field_data_field_school_address_";a:2:{s:5:"value";s:27:"field_school_address__value";s:6:"format";s:28:"field_school_address__format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:36:"field_revision_field_school_address_";a:2:{s:5:"value";s:27:"field_school_address__value";s:6:"format";s:28:"field_school_address__format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"71";}','1','0','0'),('73','field_reader_school','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:6:"school";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:6:"school";s:6:"school";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:30:"field_data_field_reader_school";a:1:{s:9:"target_id";s:29:"field_reader_school_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:34:"field_revision_field_reader_school";a:1:{s:9:"target_id";s:29:"field_reader_school_target_id";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"73";}','1','0','0');
INSERT INTO `field_config` VALUES ('75','field_badge_description','text_long','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:0:{}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:34:"field_data_field_badge_description";a:2:{s:5:"value";s:29:"field_badge_description_value";s:6:"format";s:30:"field_badge_description_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:38:"field_revision_field_badge_description";a:2:{s:5:"value";s:29:"field_badge_description_value";s:6:"format";s:30:"field_badge_description_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"75";}','1','0','0'),('76','field_status','list_text','list','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:2:{s:14:"allowed_values";a:3:{s:9:"Unclaimed";s:9:"Unclaimed";s:7:"Claimed";s:7:"Claimed";s:9:"Withdrawn";s:9:"Withdrawn";}s:23:"allowed_values_function";s:0:"";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:23:"field_data_field_status";a:1:{s:5:"value";s:18:"field_status_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:27:"field_revision_field_status";a:1:{s:5:"value";s:18:"field_status_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:1:{s:5:"value";a:1:{i:0;s:5:"value";}}s:2:"id";s:2:"76";}','1','0','0'),('77','field_points','number_integer','number','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:0:{}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:23:"field_data_field_points";a:1:{s:5:"value";s:18:"field_points_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:27:"field_revision_field_points";a:1:{s:5:"value";s:18:"field_points_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:2:"77";}','1','0','0');
INSERT INTO `field_config` VALUES ('78','field_reading_log_reference','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:11:"reading_log";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:0:{}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:38:"field_data_field_reading_log_reference";a:1:{s:9:"target_id";s:37:"field_reading_log_reference_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:42:"field_revision_field_reading_log_reference";a:1:{s:9:"target_id";s:37:"field_reading_log_reference_target_id";}}}}}s:12:"foreign keys";a:1:{s:15:"eck_reading_log";a:2:{s:5:"table";s:15:"eck_reading_log";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"78";}','-1','0','0'),('79','field_activity_log_title','text','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:10:"max_length";s:3:"255";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:35:"field_data_field_activity_log_title";a:2:{s:5:"value";s:30:"field_activity_log_title_value";s:6:"format";s:31:"field_activity_log_title_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:39:"field_revision_field_activity_log_title";a:2:{s:5:"value";s:30:"field_activity_log_title_value";s:6:"format";s:31:"field_activity_log_title_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"79";}','1','0','0');
INSERT INTO `field_config` VALUES ('80','field_activity_log_description','text_long','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:0:{}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:41:"field_data_field_activity_log_description";a:2:{s:5:"value";s:36:"field_activity_log_description_value";s:6:"format";s:37:"field_activity_log_description_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:45:"field_revision_field_activity_log_description";a:2:{s:5:"value";s:36:"field_activity_log_description_value";s:6:"format";s:37:"field_activity_log_description_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"80";}','1','0','0'),('81','field_points_reference','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:6:"points";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:6:"points";s:6:"points";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:33:"field_data_field_points_reference";a:1:{s:9:"target_id";s:32:"field_points_reference_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:37:"field_revision_field_points_reference";a:1:{s:9:"target_id";s:32:"field_points_reference_target_id";}}}}}s:12:"foreign keys";a:1:{s:10:"eck_points";a:2:{s:5:"table";s:10:"eck_points";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"81";}','-1','0','0');
INSERT INTO `field_config` VALUES ('82','field_activity_log_reference','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:8:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:8:"activity";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:2:{s:8:"activity";s:8:"activity";s:11:"secret_code";s:11:"secret_code";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:39:"field_data_field_activity_log_reference";a:1:{s:9:"target_id";s:38:"field_activity_log_reference_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:43:"field_revision_field_activity_log_reference";a:1:{s:9:"target_id";s:38:"field_activity_log_reference_target_id";}}}}}s:12:"foreign keys";a:1:{s:12:"eck_activity";a:2:{s:5:"table";s:12:"eck_activity";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"82";s:17:"field_permissions";a:1:{s:4:"type";s:1:"0";}}','1','0','0'),('83','field_prize_reference','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:5:"prize";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:5:"prize";s:5:"prize";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:32:"field_data_field_prize_reference";a:1:{s:9:"target_id";s:31:"field_prize_reference_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:36:"field_revision_field_prize_reference";a:1:{s:9:"target_id";s:31:"field_prize_reference_target_id";}}}}}s:12:"foreign keys";a:1:{s:9:"eck_prize";a:2:{s:5:"table";s:9:"eck_prize";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"83";}','1','0','0');
INSERT INTO `field_config` VALUES ('85','field_reader_badge','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:5:"badge";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:5:"badge";s:5:"badge";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:29:"field_data_field_reader_badge";a:1:{s:9:"target_id";s:28:"field_reader_badge_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:33:"field_revision_field_reader_badge";a:1:{s:9:"target_id";s:28:"field_reader_badge_target_id";}}}}}s:12:"foreign keys";a:1:{s:9:"eck_badge";a:2:{s:5:"table";s:9:"eck_badge";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"85";}','1','0','0'),('86','field_drawing_tickets','number_integer','number','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:0:{}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:32:"field_data_field_drawing_tickets";a:1:{s:5:"value";s:27:"field_drawing_tickets_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:36:"field_revision_field_drawing_tickets";a:1:{s:5:"value";s:27:"field_drawing_tickets_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:2:"86";}','1','0','0'),('87','field_message','text','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:10:"max_length";s:3:"255";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:24:"field_data_field_message";a:2:{s:5:"value";s:19:"field_message_value";s:6:"format";s:20:"field_message_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:28:"field_revision_field_message";a:2:{s:5:"value";s:19:"field_message_value";s:6:"format";s:20:"field_message_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"87";}','1','0','0');
INSERT INTO `field_config` VALUES ('89','field_current_points','number_integer','number','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:0:{}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:31:"field_data_field_current_points";a:1:{s:5:"value";s:26:"field_current_points_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:35:"field_revision_field_current_points";a:1:{s:5:"value";s:26:"field_current_points_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:2:"89";}','1','0','0'),('90','field_current_level','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:5:"level";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:5:"level";s:5:"level";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:30:"field_data_field_current_level";a:1:{s:9:"target_id";s:29:"field_current_level_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:34:"field_revision_field_current_level";a:1:{s:9:"target_id";s:29:"field_current_level_target_id";}}}}}s:12:"foreign keys";a:1:{s:9:"eck_level";a:2:{s:5:"table";s:9:"eck_level";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"90";}','1','0','0'),('91','field_current_program','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:7:"program";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:7:"program";s:7:"program";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:32:"field_data_field_current_program";a:1:{s:9:"target_id";s:31:"field_current_program_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:36:"field_revision_field_current_program";a:1:{s:9:"target_id";s:31:"field_current_program_target_id";}}}}}s:12:"foreign keys";a:1:{s:11:"eck_program";a:2:{s:5:"table";s:11:"eck_program";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"91";}','1','0','0');
INSERT INTO `field_config` VALUES ('92','field_current_reader_badge','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:12:"reader_badge";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:12:"reader_badge";s:12:"reader_badge";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:37:"field_data_field_current_reader_badge";a:1:{s:9:"target_id";s:36:"field_current_reader_badge_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:41:"field_revision_field_current_reader_badge";a:1:{s:9:"target_id";s:36:"field_current_reader_badge_target_id";}}}}}s:12:"foreign keys";a:1:{s:16:"eck_reader_badge";a:2:{s:5:"table";s:16:"eck_reader_badge";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"92";}','-1','0','0'),('93','field_current_reader_prizes','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:12:"reader_prize";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:12:"reader_prize";s:12:"reader_prize";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:38:"field_data_field_current_reader_prizes";a:1:{s:9:"target_id";s:37:"field_current_reader_prizes_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:42:"field_revision_field_current_reader_prizes";a:1:{s:9:"target_id";s:37:"field_current_reader_prizes_target_id";}}}}}s:12:"foreign keys";a:1:{s:16:"eck_reader_prize";a:2:{s:5:"table";s:16:"eck_reader_prize";s:7:"columns";a:1:{s:9:"target_id";s:2:"id";}}}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"93";}','-1','0','0');
INSERT INTO `field_config` VALUES ('94','field_current_drawing_tickets','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:13:"reader_ticket";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:13:"reader_ticket";s:13:"reader_ticket";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:40:"field_data_field_current_drawing_tickets";a:1:{s:9:"target_id";s:39:"field_current_drawing_tickets_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:44:"field_revision_field_current_drawing_tickets";a:1:{s:9:"target_id";s:39:"field_current_drawing_tickets_target_id";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:2:"94";}','-1','0','0'),('95','field_ticket_status','list_text','list','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:2:{s:14:"allowed_values";a:3:{s:9:"Not Drawn";s:9:"Not Drawn";s:3:"Won";s:3:"Won";s:9:"Withdrawn";s:9:"Withdrawn";}s:23:"allowed_values_function";s:0:"";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:30:"field_data_field_ticket_status";a:1:{s:5:"value";s:25:"field_ticket_status_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:34:"field_revision_field_ticket_status";a:1:{s:5:"value";s:25:"field_ticket_status_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:1:{s:5:"value";a:1:{i:0;s:5:"value";}}s:2:"id";s:2:"95";}','1','0','0'),('96','field_badge_message','text','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:10:"max_length";s:3:"255";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:30:"field_data_field_badge_message";a:2:{s:5:"value";s:25:"field_badge_message_value";s:6:"format";s:26:"field_badge_message_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:34:"field_revision_field_badge_message";a:2:{s:5:"value";s:25:"field_badge_message_value";s:6:"format";s:26:"field_badge_message_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"96";}','1','0','0');
INSERT INTO `field_config` VALUES ('97','field_library_card','text','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:10:"max_length";s:3:"255";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:29:"field_data_field_library_card";a:2:{s:5:"value";s:24:"field_library_card_value";s:6:"format";s:25:"field_library_card_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:33:"field_revision_field_library_card";a:2:{s:5:"value";s:24:"field_library_card_value";s:6:"format";s:25:"field_library_card_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"97";}','1','0','0'),('98','field_account_family_notes','text_long','text','1','field_sql_storage','field_sql_storage','1','0','a:8:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:0:{}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:37:"field_data_field_account_family_notes";a:2:{s:5:"value";s:32:"field_account_family_notes_value";s:6:"format";s:33:"field_account_family_notes_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:41:"field_revision_field_account_family_notes";a:2:{s:5:"value";s:32:"field_account_family_notes_value";s:6:"format";s:33:"field_account_family_notes_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"98";s:17:"field_permissions";a:1:{s:4:"type";s:1:"2";}}','1','0','0'),('99','field_prize_message','text','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:10:"max_length";s:3:"255";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:30:"field_data_field_prize_message";a:2:{s:5:"value";s:25:"field_prize_message_value";s:6:"format";s:26:"field_prize_message_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:34:"field_revision_field_prize_message";a:2:{s:5:"value";s:25:"field_prize_message_value";s:6:"format";s:26:"field_prize_message_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:2:"99";}','1','0','0');
INSERT INTO `field_config` VALUES ('100','field_activity_description','text_long','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:0:{}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:37:"field_data_field_activity_description";a:2:{s:5:"value";s:32:"field_activity_description_value";s:6:"format";s:33:"field_activity_description_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:41:"field_revision_field_activity_description";a:2:{s:5:"value";s:32:"field_activity_description_value";s:6:"format";s:33:"field_activity_description_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:3:"100";}','1','0','0'),('102','field_activity_points','number_integer','number','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:0:{}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:32:"field_data_field_activity_points";a:1:{s:5:"value";s:27:"field_activity_points_value";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:36:"field_revision_field_activity_points";a:1:{s:5:"value";s:27:"field_activity_points_value";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:0:{}s:2:"id";s:3:"102";}','1','0','0'),('103','field_activity_reference','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:8:"activity";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:8:"activity";s:8:"activity";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:35:"field_data_field_activity_reference";a:1:{s:9:"target_id";s:34:"field_activity_reference_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:39:"field_revision_field_activity_reference";a:1:{s:9:"target_id";s:34:"field_activity_reference_target_id";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:3:"103";}','1','0','0');
INSERT INTO `field_config` VALUES ('104','field_secret_code_reference','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:8:"activity";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:1:{s:11:"secret_code";s:11:"secret_code";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:38:"field_data_field_secret_code_reference";a:1:{s:9:"target_id";s:37:"field_secret_code_reference_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:42:"field_revision_field_secret_code_reference";a:1:{s:9:"target_id";s:37:"field_secret_code_reference_target_id";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:3:"104";}','1','0','0'),('105','field_claimed_activities','entityreference','entityreference','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:3:{s:11:"target_type";s:8:"activity";s:7:"handler";s:4:"base";s:16:"handler_settings";a:3:{s:14:"target_bundles";a:2:{s:8:"activity";s:8:"activity";s:11:"secret_code";s:11:"secret_code";}s:4:"sort";a:1:{s:4:"type";s:4:"none";}s:9:"behaviors";a:1:{s:17:"views-select-list";a:1:{s:6:"status";i:0;}}}}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:35:"field_data_field_claimed_activities";a:1:{s:9:"target_id";s:34:"field_claimed_activities_target_id";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:39:"field_revision_field_claimed_activities";a:1:{s:9:"target_id";s:34:"field_claimed_activities_target_id";}}}}}s:12:"foreign keys";a:0:{}s:7:"indexes";a:1:{s:9:"target_id";a:1:{i:0;s:9:"target_id";}}s:2:"id";s:3:"105";}','-1','0','0');
INSERT INTO `field_config` VALUES ('106','field_activity_code','text','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:10:"max_length";s:3:"255";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:30:"field_data_field_activity_code";a:2:{s:5:"value";s:25:"field_activity_code_value";s:6:"format";s:26:"field_activity_code_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:34:"field_revision_field_activity_code";a:2:{s:5:"value";s:25:"field_activity_code_value";s:6:"format";s:26:"field_activity_code_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:3:"106";}','1','0','0'),('107','field_date','datetime','date','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"entity_types";a:0:{}s:7:"indexes";a:0:{}s:8:"settings";a:5:{s:11:"granularity";a:5:{s:3:"day";s:3:"day";s:4:"hour";s:4:"hour";s:6:"minute";s:6:"minute";s:5:"month";s:5:"month";s:4:"year";s:4:"year";}s:6:"repeat";i:0;s:11:"timezone_db";s:3:"UTC";s:6:"todate";s:8:"optional";s:11:"tz_handling";s:4:"site";}s:12:"translatable";i:0;s:7:"storage";a:4:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";}s:12:"foreign keys";a:0:{}s:2:"id";s:3:"107";}','1','0','0'),('108','field_phone_number','text','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"translatable";s:1:"0";s:12:"entity_types";a:0:{}s:8:"settings";a:1:{s:10:"max_length";s:3:"255";}s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:29:"field_data_field_phone_number";a:2:{s:5:"value";s:24:"field_phone_number_value";s:6:"format";s:25:"field_phone_number_format";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:33:"field_revision_field_phone_number";a:2:{s:5:"value";s:24:"field_phone_number_value";s:6:"format";s:25:"field_phone_number_format";}}}}}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:2:"id";s:3:"108";}','1','0','0');
INSERT INTO `field_config` VALUES ('109','field_bl_b_author','text','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"entity_types";a:0:{}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:8:"settings";a:1:{s:10:"max_length";i:255;}s:12:"translatable";i:0;s:7:"storage";a:4:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:2:"id";s:3:"109";}','1','0','0'),('110','field_bl_b_image','image','image','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"entity_types";a:0:{}s:7:"indexes";a:1:{s:3:"fid";a:1:{i:0;s:3:"fid";}}s:8:"settings";a:2:{s:13:"default_image";i:0;s:10:"uri_scheme";s:6:"public";}s:12:"translatable";i:0;s:7:"storage";a:4:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";}s:12:"foreign keys";a:1:{s:3:"fid";a:2:{s:5:"table";s:12:"file_managed";s:7:"columns";a:1:{s:3:"fid";s:3:"fid";}}}s:2:"id";s:3:"110";}','1','0','0'),('111','field_bl_b_link','link_field','link','1','field_sql_storage','field_sql_storage','1','0','a:8:{s:12:"entity_types";a:0:{}s:7:"indexes";a:0:{}s:8:"settings";a:7:{s:10:"attributes";a:3:{s:5:"class";s:0:"";s:3:"rel";s:0:"";s:6:"target";s:7:"default";}s:7:"display";a:1:{s:10:"url_cutoff";i:80;}s:13:"enable_tokens";i:1;s:5:"title";s:8:"optional";s:15:"title_maxlength";i:128;s:11:"title_value";s:0:"";s:3:"url";i:0;}s:12:"translatable";s:1:"0";s:7:"storage";a:5:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";s:7:"details";a:1:{s:3:"sql";a:2:{s:18:"FIELD_LOAD_CURRENT";a:1:{s:26:"field_data_field_bl_b_link";a:3:{s:3:"url";s:19:"field_bl_b_link_url";s:5:"title";s:21:"field_bl_b_link_title";s:10:"attributes";s:26:"field_bl_b_link_attributes";}}s:19:"FIELD_LOAD_REVISION";a:1:{s:30:"field_revision_field_bl_b_link";a:3:{s:3:"url";s:19:"field_bl_b_link_url";s:5:"title";s:21:"field_bl_b_link_title";s:10:"attributes";s:26:"field_bl_b_link_attributes";}}}}}s:12:"foreign keys";a:0:{}s:2:"id";s:3:"111";s:17:"field_permissions";a:1:{s:4:"type";s:1:"0";}}','1','0','0');
INSERT INTO `field_config` VALUES ('112','field_bl_b_title','text','text','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"entity_types";a:0:{}s:7:"indexes";a:1:{s:6:"format";a:1:{i:0;s:6:"format";}}s:8:"settings";a:1:{s:10:"max_length";i:255;}s:12:"translatable";i:0;s:7:"storage";a:4:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";}s:12:"foreign keys";a:1:{s:6:"format";a:2:{s:5:"table";s:13:"filter_format";s:7:"columns";a:1:{s:6:"format";s:6:"format";}}}s:2:"id";s:3:"112";}','1','0','0'),('113','field_booklist_books','field_collection','field_collection','1','field_sql_storage','field_sql_storage','1','0','a:7:{s:12:"entity_types";a:0:{}s:7:"indexes";a:1:{s:11:"revision_id";a:1:{i:0;s:11:"revision_id";}}s:8:"settings";a:2:{s:16:"hide_blank_items";i:1;s:4:"path";s:0:"";}s:12:"translatable";i:0;s:7:"storage";a:4:{s:4:"type";s:17:"field_sql_storage";s:8:"settings";a:0:{}s:6:"module";s:17:"field_sql_storage";s:6:"active";s:1:"1";}s:12:"foreign keys";a:0:{}s:2:"id";s:3:"113";}','-1','0','0');
DROP TABLE IF EXISTS `field_config_instance`;
CREATE TABLE `field_config_instance` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a field instance',   `field_id` int(11) NOT NULL COMMENT 'The identifier of the field attached by this instance',   `field_name` varchar(32) NOT NULL DEFAULT '',   `entity_type` varchar(32) NOT NULL DEFAULT '',   `bundle` varchar(128) NOT NULL DEFAULT '',   `data` longblob NOT NULL,   `deleted` tinyint(4) NOT NULL DEFAULT '0',   PRIMARY KEY (`id`),   KEY `field_name_bundle` (`field_name`,`entity_type`,`bundle`),   KEY `deleted` (`deleted`) ) ENGINE=InnoDB AUTO_INCREMENT=176 DEFAULT CHARSET=utf8 AUTO_INCREMENT=176;
INSERT INTO `field_config_instance` VALUES ('1','1','comment_body','comment','comment_node_page','a:6:{s:5:"label";s:7:"Comment";s:8:"settings";a:2:{s:15:"text_processing";i:1;s:18:"user_register_form";b:0;}s:8:"required";b:1;s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:12:"text_default";s:6:"weight";i:0;s:8:"settings";a:0:{}s:6:"module";s:4:"text";}}s:6:"widget";a:4:{s:4:"type";s:13:"text_textarea";s:8:"settings";a:1:{s:4:"rows";i:5;}s:6:"weight";i:0;s:6:"module";s:4:"text";}s:11:"description";s:0:"";}','0'),('2','2','body','node','page','a:6:{s:5:"label";s:4:"Body";s:6:"widget";a:4:{s:4:"type";s:26:"text_textarea_with_summary";s:8:"settings";a:2:{s:4:"rows";i:20;s:12:"summary_rows";i:5;}s:6:"weight";i:-4;s:6:"module";s:4:"text";}s:8:"settings";a:3:{s:15:"display_summary";b:1;s:15:"text_processing";i:1;s:18:"user_register_form";b:0;}s:7:"display";a:2:{s:7:"default";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:0;}s:6:"teaser";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:23:"text_summary_or_trimmed";s:8:"settings";a:1:{s:11:"trim_length";i:600;}s:6:"module";s:4:"text";s:6:"weight";i:0;}}s:8:"required";b:0;s:11:"description";s:0:"";}','0'),('3','1','comment_body','comment','comment_node_article','a:6:{s:5:"label";s:7:"Comment";s:8:"settings";a:2:{s:15:"text_processing";i:1;s:18:"user_register_form";b:0;}s:8:"required";b:1;s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:12:"text_default";s:6:"weight";i:0;s:8:"settings";a:0:{}s:6:"module";s:4:"text";}}s:6:"widget";a:4:{s:4:"type";s:13:"text_textarea";s:8:"settings";a:1:{s:4:"rows";i:5;}s:6:"weight";i:0;s:6:"module";s:4:"text";}s:11:"description";s:0:"";}','0'),('4','2','body','node','article','a:6:{s:5:"label";s:4:"Body";s:6:"widget";a:4:{s:4:"type";s:26:"text_textarea_with_summary";s:8:"settings";a:2:{s:4:"rows";i:20;s:12:"summary_rows";i:5;}s:6:"weight";i:-4;s:6:"module";s:4:"text";}s:8:"settings";a:3:{s:15:"display_summary";b:1;s:15:"text_processing";i:1;s:18:"user_register_form";b:0;}s:7:"display";a:2:{s:7:"default";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:0;}s:6:"teaser";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:23:"text_summary_or_trimmed";s:8:"settings";a:1:{s:11:"trim_length";i:600;}s:6:"module";s:4:"text";s:6:"weight";i:0;}}s:8:"required";b:0;s:11:"description";s:0:"";}','0');
INSERT INTO `field_config_instance` VALUES ('5','3','field_tags','node','article','a:6:{s:5:"label";s:4:"Tags";s:11:"description";s:63:"Enter a comma-separated list of words to describe your content.";s:6:"widget";a:4:{s:4:"type";s:21:"taxonomy_autocomplete";s:6:"weight";i:-4;s:8:"settings";a:2:{s:4:"size";i:60;s:17:"autocomplete_path";s:21:"taxonomy/autocomplete";}s:6:"module";s:8:"taxonomy";}s:7:"display";a:2:{s:7:"default";a:5:{s:4:"type";s:28:"taxonomy_term_reference_link";s:6:"weight";i:10;s:5:"label";s:5:"above";s:8:"settings";a:0:{}s:6:"module";s:8:"taxonomy";}s:6:"teaser";a:5:{s:4:"type";s:28:"taxonomy_term_reference_link";s:6:"weight";i:10;s:5:"label";s:5:"above";s:8:"settings";a:0:{}s:6:"module";s:8:"taxonomy";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:8:"required";b:0;}','0'),('6','4','field_image','node','article','a:6:{s:5:"label";s:5:"Image";s:11:"description";s:40:"Upload an image to go with this article.";s:8:"required";b:0;s:8:"settings";a:9:{s:14:"file_directory";s:11:"field/image";s:15:"file_extensions";s:16:"png gif jpg jpeg";s:12:"max_filesize";s:0:"";s:14:"max_resolution";s:0:"";s:14:"min_resolution";s:0:"";s:9:"alt_field";b:1;s:11:"title_field";s:0:"";s:13:"default_image";i:0;s:18:"user_register_form";b:0;}s:6:"widget";a:4:{s:4:"type";s:11:"image_image";s:8:"settings";a:2:{s:18:"progress_indicator";s:8:"throbber";s:19:"preview_image_style";s:9:"thumbnail";}s:6:"weight";i:-1;s:6:"module";s:5:"image";}s:7:"display";a:2:{s:7:"default";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:5:"image";s:8:"settings";a:2:{s:11:"image_style";s:5:"large";s:10:"image_link";s:0:"";}s:6:"weight";i:-1;s:6:"module";s:5:"image";}s:6:"teaser";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:5:"image";s:8:"settings";a:2:{s:11:"image_style";s:6:"medium";s:10:"image_link";s:7:"content";}s:6:"weight";i:-1;s:6:"module";s:5:"image";}}}','0'),('9','7','field_branch_phone','branch','branch','a:7:{s:5:"label";s:12:"Branch Phone";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:22:"format: (123) 456-7890";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('10','8','field_branch_address','branch','branch','a:7:{s:5:"label";s:14:"Branch Address";s:6:"widget";a:5:{s:6:"weight";s:1:"3";s:4:"type";s:21:"addressfield_standard";s:6:"module";s:12:"addressfield";s:6:"active";i:1;s:8:"settings";a:3:{s:19:"available_countries";a:1:{s:2:"US";s:2:"US";}s:15:"default_country";s:2:"US";s:15:"format_handlers";a:8:{s:7:"address";s:7:"address";s:20:"address-hide-country";s:20:"address-hide-country";s:24:"address-hide-postal-code";i:0;s:19:"address-hide-street";i:0;s:12:"organisation";i:0;s:9:"name-full";i:0;s:12:"name-oneline";i:0;s:16:"address-optional";i:0;}}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:20:"addressfield_default";s:8:"settings";a:2:{s:19:"use_widget_handlers";i:1;s:15:"format_handlers";a:1:{i:0;s:7:"address";}}s:6:"module";s:12:"addressfield";s:6:"weight";i:2;}}s:8:"required";i:1;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('12','10','field_recommended_min_age','program','program','a:7:{s:5:"label";s:19:"Recommended Min Age";s:6:"widget";a:5:{s:6:"weight";s:1:"1";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:6:"weight";s:1:"1";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('13','11','field_recommended_max_age','program','program','a:7:{s:5:"label";s:19:"Recommended Max Age";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:6:"weight";s:1:"2";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('14','12','field_scoring_type','program','program','a:7:{s:5:"label";s:12:"Scoring Type";s:6:"widget";a:5:{s:6:"weight";s:1:"3";s:4:"type";s:15:"options_buttons";s:6:"module";s:7:"options";s:6:"active";i:1;s:8:"settings";a:0:{}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:4:{s:5:"label";s:5:"above";s:4:"type";s:6:"hidden";s:6:"weight";s:1:"6";s:8:"settings";a:0:{}}}s:8:"required";i:1;s:11:"description";s:0:"";s:13:"default_value";a:1:{i:0;a:1:{s:5:"value";s:15:"Points Per Book";}}}','0'),('17','15','field_per_unit_point_value','program','program','a:7:{s:5:"label";s:20:"Per Unit Point Value";s:6:"widget";a:5:{s:6:"weight";s:1:"5";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:6:"weight";s:1:"4";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('19','17','field_program_description','program','program','a:7:{s:5:"label";s:19:"Program Description";s:6:"widget";a:5:{s:6:"weight";s:1:"6";s:4:"type";s:13:"text_textarea";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"rows";s:1:"5";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"1";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:6:"weight";s:1:"5";s:8:"settings";a:0:{}s:6:"module";s:4:"text";}}s:8:"required";i:1;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('21','19','field_level_number','level','level','a:7:{s:5:"label";s:12:"Level Number";s:6:"widget";a:5:{s:6:"weight";s:1:"1";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:6:"weight";s:1:"0";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('22','20','field_point_threshold','level','level','a:7:{s:5:"label";s:15:"Point Threshold";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:6:"weight";s:1:"1";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('24','22','field_level_message','level','level','a:7:{s:5:"label";s:13:"Level Message";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:13:"text_textarea";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"rows";s:1:"5";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:6:"weight";s:1:"3";s:8:"settings";a:0:{}s:6:"module";s:4:"text";}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('27','25','field_prize_name','prize','prize','a:7:{s:5:"label";s:10:"Prize Name";s:6:"widget";a:5:{s:6:"weight";s:1:"1";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','1'),('28','26','field_prize_descriptions','prize','prize','a:7:{s:5:"label";s:17:"Prize Description";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:13:"text_textarea";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"rows";s:1:"5";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','1');
INSERT INTO `field_config_instance` VALUES ('30','28','field_first_name','user','user','a:7:{s:5:"label";s:10:"First Name";s:6:"widget";a:5:{s:6:"weight";s:1:"7";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";i:1;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('31','29','field_last_name','user','user','a:7:{s:5:"label";s:9:"Last Name";s:6:"widget";a:5:{s:6:"weight";s:1:"8";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";i:1;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('32','30','field_favorite_branch','user','user','a:7:{s:5:"label";s:15:"Favorite Branch";s:6:"widget";a:5:{s:6:"weight";s:1:"9";s:4:"type";s:15:"options_buttons";s:6:"module";s:7:"options";s:6:"active";i:1;s:8:"settings";a:0:{}}s:8:"settings";a:1:{s:18:"user_register_form";i:1;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:2;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('33','31','field_program_reference','level','level','a:7:{s:5:"label";s:17:"Program Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"7";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:6:"weight";s:1:"6";s:8:"settings";a:1:{s:4:"link";i:1;}s:6:"module";s:15:"entityreference";}}s:8:"required";i:1;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('36','28','field_first_name','reader','reader','a:7:{s:5:"label";s:10:"First Name";s:6:"widget";a:5:{s:6:"weight";s:1:"0";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:6:"weight";s:1:"0";s:8:"settings";a:0:{}s:6:"module";s:4:"text";}}s:8:"required";i:1;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('37','34','field_age','reader','reader','a:7:{s:5:"label";s:3:"Age";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:6:"weight";s:1:"2";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('38','35','field_grade','reader','reader','a:7:{s:5:"label";s:5:"Grade";s:6:"widget";a:5:{s:6:"weight";s:1:"3";s:4:"type";s:14:"options_select";s:6:"module";s:7:"options";s:6:"active";i:1;s:8:"settings";a:0:{}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"list_default";s:6:"weight";s:1:"3";s:8:"settings";a:0:{}s:6:"module";s:4:"list";}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('41','38','field_program','reader','reader','a:7:{s:5:"label";s:7:"Program";s:6:"widget";a:5:{s:6:"weight";s:1:"5";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:6:"weight";s:1:"6";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('49','46','field_readers','user','user','a:7:{s:5:"label";s:7:"Readers";s:6:"widget";a:5:{s:6:"weight";s:2:"10";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";i:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:3;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('51','48','field_parent_uid','reader','reader','a:7:{s:5:"label";s:10:"Parent UID";s:6:"widget";a:5:{s:6:"weight";s:1:"6";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:6:"weight";s:2:"10";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";}}s:8:"required";i:1;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('56','50','field_book_title','reader_log','reader_log','a:7:{s:5:"label";s:10:"Book Title";s:6:"widget";a:5:{s:6:"weight";s:1:"0";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:4;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('57','51','field_units_completed','reader_log','reader_log','a:7:{s:5:"label";s:15:"Units Completed";s:6:"widget";a:5:{s:6:"weight";s:1:"3";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";s:6:"weight";i:5;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('59','31','field_program_reference','reader_log','reader_log','a:7:{s:5:"label";s:17:"Program Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:6;}}s:8:"required";i:1;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('60','46','field_readers','reader_log','reader_log','a:7:{s:5:"label";s:7:"Readers";s:6:"widget";a:5:{s:6:"weight";s:1:"5";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:7;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('61','52','field_unit_type','reader_log','reader_log','a:7:{s:5:"label";s:9:"Unit Type";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:8;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('62','53','field_points_earned','reader_log','reader_log','a:7:{s:5:"label";s:13:"Points Earned";s:6:"widget";a:5:{s:6:"weight";s:1:"6";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";s:6:"weight";i:9;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('63','54','field_current_reader','user','user','a:7:{s:5:"label";s:14:"Current Reader";s:6:"widget";a:5:{s:6:"weight";s:2:"11";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";i:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:4;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('64','55','field_badge_image','taxonomy_term','badge','a:6:{s:5:"label";s:11:"Badge Image";s:6:"widget";a:5:{s:6:"weight";s:2:"31";s:4:"type";s:11:"image_image";s:6:"module";s:5:"image";s:6:"active";i:1;s:8:"settings";a:2:{s:18:"progress_indicator";s:8:"throbber";s:19:"preview_image_style";s:9:"thumbnail";}}s:8:"settings";a:9:{s:14:"file_directory";s:0:"";s:15:"file_extensions";s:16:"png gif jpg jpeg";s:12:"max_filesize";s:0:"";s:14:"max_resolution";s:0:"";s:14:"min_resolution";s:0:"";s:9:"alt_field";i:0;s:11:"title_field";i:0;s:13:"default_image";i:0;s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:5:"image";s:8:"settings";a:2:{s:11:"image_style";s:0:"";s:10:"image_link";s:0:"";}s:6:"module";s:5:"image";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";}','0'),('68','57','field_author','reader_log','reader_log','a:7:{s:5:"label";s:6:"Author";s:6:"widget";a:5:{s:6:"weight";s:1:"1";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:10;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('69','58','field_stars','reader_log','reader_log','a:7:{s:5:"label";s:5:"Stars";s:6:"widget";a:5:{s:6:"weight";s:1:"7";s:4:"type";s:15:"options_buttons";s:6:"module";s:7:"options";s:6:"active";i:1;s:8:"settings";a:0:{}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"list_default";s:8:"settings";a:0:{}s:6:"module";s:4:"list";s:6:"weight";i:11;}}s:8:"required";i:1;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('70','1','comment_body','comment','comment_node_customformfields','a:6:{s:5:"label";s:7:"Comment";s:8:"settings";a:2:{s:15:"text_processing";i:1;s:18:"user_register_form";b:0;}s:8:"required";b:1;s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:12:"text_default";s:6:"weight";i:0;s:8:"settings";a:0:{}s:6:"module";s:4:"text";}}s:6:"widget";a:4:{s:4:"type";s:13:"text_textarea";s:8:"settings";a:1:{s:4:"rows";i:5;}s:6:"weight";i:0;s:6:"module";s:4:"text";}s:11:"description";s:0:"";}','0'),('71','2','body','node','customformfields','a:6:{s:5:"label";s:4:"Body";s:6:"widget";a:4:{s:4:"type";s:26:"text_textarea_with_summary";s:8:"settings";a:2:{s:4:"rows";i:20;s:12:"summary_rows";i:5;}s:6:"weight";s:2:"31";s:6:"module";s:4:"text";}s:8:"settings";a:3:{s:15:"display_summary";b:1;s:15:"text_processing";i:1;s:18:"user_register_form";b:0;}s:7:"display";a:2:{s:7:"default";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:0;}s:6:"teaser";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:23:"text_summary_or_trimmed";s:8:"settings";a:1:{s:11:"trim_length";i:600;}s:6:"module";s:4:"text";s:6:"weight";i:0;}}s:8:"required";b:0;s:11:"description";s:0:"";}','0'),('72','59','field_prize','node','customformfields','a:7:{s:5:"label";s:5:"Prize";s:6:"widget";a:5:{s:6:"weight";s:2:"32";s:4:"type";s:21:"taxonomy_autocomplete";s:6:"module";s:8:"taxonomy";s:6:"active";i:0;s:8:"settings";a:2:{s:4:"size";i:60;s:17:"autocomplete_path";s:21:"taxonomy/autocomplete";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:28:"taxonomy_term_reference_link";s:8:"settings";a:0:{}s:6:"module";s:8:"taxonomy";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('73','60','field_badge','node','customformfields','a:7:{s:5:"label";s:5:"badge";s:6:"widget";a:5:{s:6:"weight";s:2:"33";s:4:"type";s:21:"taxonomy_autocomplete";s:6:"module";s:8:"taxonomy";s:6:"active";i:0;s:8:"settings";a:2:{s:4:"size";i:60;s:17:"autocomplete_path";s:21:"taxonomy/autocomplete";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:28:"taxonomy_term_reference_link";s:8:"settings";a:0:{}s:6:"module";s:8:"taxonomy";s:6:"weight";i:2;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('74','61','field_ticket_id','drawing_ticket','drawing_ticket','a:7:{s:5:"label";s:9:"Ticket ID";s:6:"widget";a:5:{s:6:"weight";s:1:"1";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:6:"weight";s:1:"0";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('75','46','field_readers','drawing_ticket','drawing_ticket','a:7:{s:5:"label";s:7:"Readers";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:6:"weight";s:1:"1";s:8:"settings";a:1:{s:4:"link";i:0;}s:6:"module";s:15:"entityreference";}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('77','38','field_program','drawing_ticket','drawing_ticket','a:7:{s:5:"label";s:7:"Program";s:6:"widget";a:5:{s:6:"weight";s:1:"5";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:6:"weight";s:1:"3";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('79','64','field_prize_description','prize','prize','a:7:{s:5:"label";s:17:"Prize Description";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:13:"text_textarea";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"rows";s:1:"5";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"1";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('80','29','field_last_name','reader','reader','a:7:{s:5:"label";s:9:"Last Name";s:6:"widget";a:5:{s:6:"weight";s:1:"1";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:6:"weight";s:1:"1";s:8:"settings";a:0:{}s:6:"module";s:4:"text";}}s:8:"required";i:1;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('81','65','field_per_unit_label','program','program','a:7:{s:5:"label";s:14:"Per Unit Label";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:14:"options_select";s:6:"module";s:7:"options";s:6:"active";i:1;s:8:"settings";a:0:{}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"list_default";s:6:"weight";s:1:"3";s:8:"settings";a:0:{}s:6:"module";s:4:"list";}}s:8:"required";i:1;s:11:"description";s:0:"";s:13:"default_value";a:1:{i:0;a:1:{s:5:"value";s:4:"Book";}}}','0'),('88','71','field_school_address_','school','school','a:7:{s:5:"label";s:15:"School Address ";s:6:"widget";a:5:{s:6:"weight";s:1:"1";s:4:"type";s:13:"text_textarea";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"rows";s:1:"5";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('90','73','field_reader_school','reader','reader','a:7:{s:5:"label";s:13:"Reader School";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:11;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('91','50','field_book_title','reading_log','reading_log','a:7:{s:5:"label";s:10:"Book Title";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('92','57','field_author','reading_log','reading_log','a:7:{s:5:"label";s:6:"Author";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('93','52','field_unit_type','reading_log','reading_log','a:7:{s:5:"label";s:9:"Unit Type";s:6:"widget";a:5:{s:6:"weight";s:1:"6";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:2;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('94','51','field_units_completed','reading_log','reading_log','a:7:{s:5:"label";s:15:"Units Completed";s:6:"widget";a:5:{s:6:"weight";s:1:"8";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";s:6:"weight";i:3;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('95','31','field_program_reference','reading_log','reading_log','a:7:{s:5:"label";s:17:"Program Reference";s:6:"widget";a:5:{s:6:"weight";s:2:"10";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:4;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('96','46','field_readers','reading_log','reading_log','a:7:{s:5:"label";s:7:"Readers";s:6:"widget";a:5:{s:6:"weight";s:2:"12";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:5;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('97','58','field_stars','reading_log','reading_log','a:7:{s:5:"label";s:5:"Stars";s:6:"widget";a:5:{s:6:"weight";s:2:"14";s:4:"type";s:15:"options_buttons";s:6:"module";s:7:"options";s:6:"active";i:1;s:8:"settings";a:0:{}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"list_default";s:8:"settings";a:0:{}s:6:"module";s:4:"list";s:6:"weight";i:6;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('99','75','field_badge_description','badge','badge','a:7:{s:5:"label";s:17:"Badge Description";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:13:"text_textarea";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"rows";s:1:"5";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:6:"weight";s:1:"1";s:8:"settings";a:0:{}s:6:"module";s:4:"text";}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('100','31','field_program_reference','reader_prize','reader_prize','a:7:{s:5:"label";s:17:"Program Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('101','39','field_level','reader_prize','reader_prize','a:7:{s:5:"label";s:5:"Level";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:14:"options_select";s:6:"module";s:7:"options";s:6:"active";i:1;s:8:"settings";a:0:{}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('102','46','field_readers','reader_prize','reader_prize','a:7:{s:5:"label";s:7:"Readers";s:6:"widget";a:5:{s:6:"weight";s:1:"6";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:2;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('103','76','field_status','reader_prize','reader_prize','a:7:{s:5:"label";s:6:"Status";s:6:"widget";a:5:{s:6:"weight";s:1:"7";s:4:"type";s:15:"options_buttons";s:6:"module";s:7:"options";s:6:"active";i:1;s:8:"settings";a:0:{}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"list_default";s:8:"settings";a:0:{}s:6:"module";s:4:"list";s:6:"weight";i:3;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('104','55','field_badge_image','badge','badge','a:6:{s:5:"label";s:11:"Badge Image";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:11:"image_image";s:6:"module";s:5:"image";s:6:"active";i:1;s:8:"settings";a:2:{s:18:"progress_indicator";s:8:"throbber";s:19:"preview_image_style";s:6:"medium";}}s:8:"settings";a:9:{s:14:"file_directory";s:0:"";s:15:"file_extensions";s:16:"png gif jpg jpeg";s:12:"max_filesize";s:3:"5MB";s:14:"max_resolution";s:7:"600x600";s:14:"min_resolution";s:0:"";s:9:"alt_field";i:1;s:11:"title_field";i:1;s:13:"default_image";i:0;s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:5:"image";s:6:"weight";s:1:"2";s:8:"settings";a:2:{s:11:"image_style";s:6:"medium";s:10:"image_link";s:0:"";}s:6:"module";s:5:"image";}}s:8:"required";i:0;s:11:"description";s:0:"";}','0');
INSERT INTO `field_config_instance` VALUES ('105','77','field_points','points','points','a:7:{s:5:"label";s:6:"Points";s:6:"widget";a:5:{s:6:"weight";s:1:"1";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('106','46','field_readers','points','points','a:7:{s:5:"label";s:7:"Readers";s:6:"widget";a:5:{s:6:"weight";s:1:"3";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('107','78','field_reading_log_reference','points','points','a:7:{s:5:"label";s:21:"Reading Log Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:2;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('108','79','field_activity_log_title','activity_log_reference','activity_log_reference','a:7:{s:5:"label";s:18:"Activity Log Title";s:6:"widget";a:5:{s:6:"weight";s:1:"1";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('109','80','field_activity_log_description','activity_log_reference','activity_log_reference','a:7:{s:5:"label";s:24:"Activity Log Description";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:13:"text_textarea";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"rows";s:1:"5";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('110','81','field_points_reference','activity_log_reference','activity_log_reference','a:7:{s:5:"label";s:16:"Points Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"3";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:2;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('111','82','field_activity_log_reference','points','points','a:7:{s:5:"label";s:22:"Activity Log Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"5";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:3;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('112','81','field_points_reference','reading_log','reading_log','a:7:{s:5:"label";s:16:"Points Reference";s:6:"widget";a:5:{s:6:"weight";s:2:"16";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:7;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('113','1','comment_body','comment','comment_node_panel','a:6:{s:5:"label";s:7:"Comment";s:8:"settings";a:2:{s:15:"text_processing";i:1;s:18:"user_register_form";b:0;}s:8:"required";b:1;s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:12:"text_default";s:6:"weight";i:0;s:8:"settings";a:0:{}s:6:"module";s:4:"text";}}s:6:"widget";a:4:{s:4:"type";s:13:"text_textarea";s:8:"settings";a:1:{s:4:"rows";i:5;}s:6:"weight";i:0;s:6:"module";s:4:"text";}s:11:"description";s:0:"";}','0'),('114','83','field_prize_reference','reader_prize','reader_prize','a:7:{s:5:"label";s:15:"Prize Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"8";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:4;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('117','46','field_readers','reader_badge','reader_badge','a:7:{s:5:"label";s:7:"Readers";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('118','85','field_reader_badge','reader_badge','reader_badge','a:7:{s:5:"label";s:12:"Reader Badge";s:6:"widget";a:5:{s:6:"weight";s:1:"3";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('119','46','field_readers','reader_activity_log','reader_activity_log','a:7:{s:5:"label";s:7:"Readers";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('120','82','field_activity_log_reference','reader_activity_log','reader_activity_log','a:7:{s:5:"label";s:22:"Activity Log Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('121','31','field_program_reference','reader_activity_log','reader_activity_log','a:7:{s:5:"label";s:17:"Program Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"6";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:2;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('123','81','field_points_reference','reader_activity_log','reader_activity_log','a:7:{s:5:"label";s:16:"Points Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"8";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:3;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('124','83','field_prize_reference','level','level','a:6:{s:5:"label";s:15:"Prize Reference";s:6:"widget";a:4:{s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"weight";s:1:"9";s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";i:60;s:4:"path";s:0:"";}s:6:"module";s:15:"entityreference";}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:6:"weight";s:1:"7";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";}}s:8:"required";b:0;s:11:"description";s:0:"";}','0'),('125','85','field_reader_badge','level','level','a:6:{s:5:"label";s:12:"Reader Badge";s:6:"widget";a:4:{s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"weight";s:2:"11";s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";i:60;s:4:"path";s:0:"";}s:6:"module";s:15:"entityreference";}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:6:"weight";s:1:"8";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";}}s:8:"required";b:0;s:11:"description";s:0:"";}','0'),('126','86','field_drawing_tickets','level','level','a:6:{s:5:"label";s:15:"Drawing Tickets";s:6:"widget";a:4:{s:4:"type";s:6:"number";s:6:"weight";s:2:"12";s:8:"settings";a:0:{}s:6:"module";s:6:"number";}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:6:"weight";s:1:"9";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";}}s:8:"required";b:0;s:11:"description";s:0:"";}','0');
INSERT INTO `field_config_instance` VALUES ('127','31','field_program_reference','points','points','a:7:{s:5:"label";s:17:"Program Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"7";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:4;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('128','87','field_message','nag_message','nag_message','a:7:{s:5:"label";s:7:"Message";s:6:"widget";a:5:{s:6:"weight";s:1:"1";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('129','54','field_current_reader','nag_message','nag_message','a:7:{s:5:"label";s:14:"Current Reader";s:6:"widget";a:5:{s:6:"weight";s:1:"3";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('130','31','field_program_reference','prize','prize','a:7:{s:5:"label";s:17:"Program Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"5";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:3;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('132','81','field_points_reference','reader','reader','a:7:{s:5:"label";s:16:"Points Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"8";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:12;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('133','89','field_current_points','reader','reader','a:7:{s:5:"label";s:14:"Current Points";s:6:"widget";a:5:{s:6:"weight";s:1:"9";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";s:6:"weight";i:13;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('134','90','field_current_level','reader','reader','a:7:{s:5:"label";s:13:"Current Level";s:6:"widget";a:5:{s:6:"weight";s:2:"10";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:14;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('135','91','field_current_program','reader','reader','a:7:{s:5:"label";s:15:"Current Program";s:6:"widget";a:5:{s:6:"weight";s:2:"11";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:15;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('136','92','field_current_reader_badge','reader','reader','a:7:{s:5:"label";s:20:"Current Reader Badge";s:6:"widget";a:5:{s:6:"weight";s:2:"12";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:16;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('137','93','field_current_reader_prizes','reader','reader','a:7:{s:5:"label";s:21:"Current Reader Prizes";s:6:"widget";a:5:{s:6:"weight";s:2:"13";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:17;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('138','94','field_current_drawing_tickets','reader','reader','a:7:{s:5:"label";s:23:"Current Drawing Tickets";s:6:"widget";a:5:{s:6:"weight";s:2:"14";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:18;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('139','46','field_readers','reader_ticket','reader_ticket','a:7:{s:5:"label";s:7:"Readers";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('140','39','field_level','reader_ticket','reader_ticket','a:7:{s:5:"label";s:5:"Level";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:14:"options_select";s:6:"module";s:7:"options";s:6:"active";i:1;s:8:"settings";a:0:{}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('141','95','field_ticket_status','reader_ticket','reader_ticket','a:7:{s:5:"label";s:13:"Ticket Status";s:6:"widget";a:5:{s:6:"weight";s:1:"5";s:4:"type";s:14:"options_select";s:6:"module";s:7:"options";s:6:"active";i:1;s:8:"settings";a:0:{}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"list_default";s:8:"settings";a:0:{}s:6:"module";s:4:"list";s:6:"weight";i:2;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";a:1:{i:0;a:1:{s:5:"value";s:9:"Not Drawn";}}}','0'),('142','96','field_badge_message','reader_badge','reader_badge','a:7:{s:5:"label";s:13:"Badge Message";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:2;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('143','96','field_badge_message','badge','badge','a:7:{s:5:"label";s:13:"Badge Message";s:6:"widget";a:5:{s:6:"weight";s:1:"6";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:6:"weight";s:1:"3";s:8:"settings";a:0:{}s:6:"module";s:4:"text";}}s:8:"required";i:1;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('144','97','field_library_card','user','user','a:7:{s:5:"label";s:12:"Library Card";s:6:"widget";a:5:{s:6:"weight";s:2:"12";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";i:1;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:5;}}s:8:"required";i:1;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('145','98','field_account_family_notes','user','user','a:7:{s:5:"label";s:20:"Account/Family Notes";s:6:"widget";a:5:{s:6:"weight";s:2:"13";s:4:"type";s:13:"text_textarea";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"rows";s:1:"5";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";i:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:6;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('146','99','field_prize_message','prize','prize','a:7:{s:5:"label";s:13:"Prize Message";s:6:"widget";a:5:{s:6:"weight";s:1:"6";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:4;}}s:8:"required";i:1;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('147','99','field_prize_message','reader_prize','reader_prize','a:7:{s:5:"label";s:13:"Prize Message";s:6:"widget";a:5:{s:6:"weight";s:2:"10";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:5;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('148','100','field_activity_description','activity','activity','a:7:{s:5:"label";s:11:"Description";s:6:"widget";a:5:{s:6:"weight";s:1:"1";s:4:"type";s:13:"text_textarea";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"rows";s:1:"5";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"1";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('150','85','field_reader_badge','activity','activity','a:7:{s:5:"label";s:12:"Reader Badge";s:6:"widget";a:5:{s:6:"weight";s:1:"3";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:2;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('151','31','field_program_reference','activity','activity','a:7:{s:5:"label";s:17:"Program Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:3;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('152','100','field_activity_description','activity','secret_code','a:7:{s:5:"label";s:11:"Description";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:13:"text_textarea";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"rows";s:1:"5";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"1";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('153','102','field_activity_points','activity','activity','a:7:{s:5:"label";s:14:"Points Awarded";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";s:6:"weight";i:4;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('154','102','field_activity_points','activity','secret_code','a:7:{s:5:"label";s:14:"Points Awarded";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('155','85','field_reader_badge','activity','secret_code','a:7:{s:5:"label";s:12:"Reader Badge";s:6:"widget";a:5:{s:6:"weight";s:1:"6";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:2;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('156','31','field_program_reference','activity','secret_code','a:7:{s:5:"label";s:17:"Program Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"8";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:3;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('157','46','field_readers','activity_log','activity_log','a:7:{s:5:"label";s:7:"Readers";s:6:"widget";a:5:{s:6:"weight";s:1:"2";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:0;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('158','85','field_reader_badge','activity_log','activity_log','a:7:{s:5:"label";s:12:"Reader Badge";s:6:"widget";a:5:{s:6:"weight";s:1:"4";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:1;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('159','53','field_points_earned','activity_log','activity_log','a:7:{s:5:"label";s:13:"Points Earned";s:6:"widget";a:5:{s:6:"weight";s:1:"6";s:4:"type";s:6:"number";s:6:"module";s:6:"number";s:6:"active";i:0;s:8:"settings";a:0:{}}s:8:"settings";a:5:{s:3:"min";s:0:"";s:3:"max";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:14:"number_integer";s:8:"settings";a:4:{s:18:"thousand_separator";s:0:"";s:17:"decimal_separator";s:1:".";s:5:"scale";i:0;s:13:"prefix_suffix";b:1;}s:6:"module";s:6:"number";s:6:"weight";i:2;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('160','103','field_activity_reference','activity_log','activity_log','a:7:{s:5:"label";s:18:"Activity Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"7";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:3;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('161','104','field_secret_code_reference','activity_log','activity_log','a:7:{s:5:"label";s:21:"Secret Code Reference";s:6:"widget";a:5:{s:6:"weight";s:1:"8";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:4;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('162','105','field_claimed_activities','reader','reader','a:7:{s:5:"label";s:18:"Claimed Activities";s:6:"widget";a:5:{s:6:"weight";s:2:"15";s:4:"type";s:33:"entityreference_autocomplete_tags";s:6:"module";s:15:"entityreference";s:6:"active";i:1;s:8:"settings";a:3:{s:14:"match_operator";s:8:"CONTAINS";s:4:"size";s:2:"60";s:4:"path";s:0:"";}}s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";b:0;}s:6:"module";s:15:"entityreference";s:6:"weight";i:19;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0');
INSERT INTO `field_config_instance` VALUES ('163','106','field_activity_code','activity','secret_code','a:7:{s:5:"label";s:11:"Secret Code";s:6:"widget";a:5:{s:6:"weight";s:1:"9";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";b:0;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:4;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('164','1','comment_body','comment','comment_node_event','a:6:{s:5:"label";s:7:"Comment";s:8:"settings";a:2:{s:15:"text_processing";i:1;s:18:"user_register_form";b:0;}s:8:"required";b:1;s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:12:"text_default";s:6:"weight";i:0;s:8:"settings";a:0:{}s:6:"module";s:4:"text";}}s:6:"widget";a:4:{s:4:"type";s:13:"text_textarea";s:8:"settings";a:1:{s:4:"rows";i:5;}s:6:"weight";i:0;s:6:"module";s:4:"text";}s:11:"description";s:0:"";}','0'),('165','2','body','node','event','a:7:{s:13:"default_value";N;s:11:"description";s:0:"";s:7:"display";a:2:{s:7:"default";a:5:{s:5:"label";s:6:"hidden";s:6:"module";s:4:"text";s:8:"settings";a:0:{}s:4:"type";s:12:"text_default";s:6:"weight";i:0;}s:6:"teaser";a:6:{s:5:"label";s:6:"hidden";s:6:"module";s:4:"text";s:8:"settings";a:1:{s:11:"trim_length";i:600;}s:11:"trim_length";i:600;s:4:"type";s:23:"text_summary_or_trimmed";s:6:"weight";i:0;}}s:5:"label";s:11:"Description";s:8:"required";b:0;s:8:"settings";a:3:{s:15:"display_summary";b:1;s:15:"text_processing";i:1;s:18:"user_register_form";b:0;}s:6:"widget";a:4:{s:6:"module";s:4:"text";s:8:"settings";a:2:{s:4:"rows";i:20;s:12:"summary_rows";i:5;}s:4:"type";s:26:"text_textarea_with_summary";s:6:"weight";i:2;}}','0'),('166','107','field_date','node','event','a:7:{s:11:"description";s:0:"";s:7:"display";a:2:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:6:"module";s:4:"date";s:8:"settings";a:7:{s:11:"format_type";s:4:"long";s:6:"fromto";s:4:"both";s:13:"multiple_from";s:0:"";s:15:"multiple_number";s:0:"";s:11:"multiple_to";s:0:"";s:19:"show_remaining_days";b:0;s:16:"show_repeat_rule";s:4:"show";}s:4:"type";s:12:"date_default";s:6:"weight";i:0;}s:6:"teaser";a:5:{s:5:"label";s:5:"above";s:6:"module";s:4:"date";s:8:"settings";a:7:{s:11:"format_type";s:4:"long";s:6:"fromto";s:4:"both";s:13:"multiple_from";s:0:"";s:15:"multiple_number";s:0:"";s:11:"multiple_to";s:0:"";s:19:"show_remaining_days";b:0;s:16:"show_repeat_rule";s:4:"show";}s:4:"type";s:12:"date_default";s:6:"weight";i:0;}}s:5:"label";s:4:"Date";s:8:"required";b:0;s:8:"settings";a:5:{s:13:"default_value";s:3:"now";s:14:"default_value2";s:5:"blank";s:18:"default_value_code";s:0:"";s:19:"default_value_code2";s:0:"";s:18:"user_register_form";b:0;}s:6:"weight";i:-4;s:6:"widget";a:4:{s:6:"module";s:4:"date";s:8:"settings";a:8:{s:15:"display_all_day";i:0;s:9:"increment";i:15;s:12:"input_format";s:14:"m/d/Y - g:i:sa";s:19:"input_format_custom";s:0:"";s:14:"label_position";s:5:"above";s:16:"repeat_collapsed";i:0;s:10:"text_parts";a:0:{}s:10:"year_range";s:5:"-1:+1";}s:4:"type";s:10:"date_popup";s:6:"weight";i:1;}}','0');
INSERT INTO `field_config_instance` VALUES ('167','108','field_phone_number','user','user','a:7:{s:5:"label";s:12:"Phone Number";s:6:"widget";a:5:{s:6:"weight";s:2:"14";s:4:"type";s:14:"text_textfield";s:6:"module";s:4:"text";s:6:"active";i:1;s:8:"settings";a:1:{s:4:"size";s:2:"60";}}s:8:"settings";a:2:{s:15:"text_processing";s:1:"0";s:18:"user_register_form";i:1;}s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:6:"module";s:4:"text";s:6:"weight";i:7;}}s:8:"required";i:0;s:11:"description";s:0:"";s:13:"default_value";N;}','0'),('168','1','comment_body','comment','comment_node_book_list','a:6:{s:5:"label";s:7:"Comment";s:8:"settings";a:2:{s:15:"text_processing";i:1;s:18:"user_register_form";b:0;}s:8:"required";b:1;s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:6:"hidden";s:4:"type";s:12:"text_default";s:6:"weight";i:0;s:8:"settings";a:0:{}s:6:"module";s:4:"text";}}s:6:"widget";a:4:{s:4:"type";s:13:"text_textarea";s:8:"settings";a:1:{s:4:"rows";i:5;}s:6:"weight";i:0;s:6:"module";s:4:"text";}s:11:"description";s:0:"";}','0'),('169','109','field_bl_b_author','field_collection_item','field_booklist_books','a:7:{s:13:"default_value";N;s:11:"description";s:29:"Enter the author of the book.";s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:6:"module";s:4:"text";s:8:"settings";a:0:{}s:4:"type";s:12:"text_default";s:6:"weight";i:1;}}s:5:"label";s:11:"Book Author";s:8:"required";i:0;s:8:"settings";a:2:{s:15:"text_processing";i:0;s:18:"user_register_form";b:0;}s:6:"widget";a:5:{s:6:"active";i:1;s:6:"module";s:4:"text";s:8:"settings";a:1:{s:4:"size";i:60;}s:4:"type";s:14:"text_textfield";s:6:"weight";i:2;}}','0'),('170','110','field_bl_b_image','field_collection_item','field_booklist_books','a:6:{s:11:"description";s:35:"Upload an image of the book''s cover";s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:6:"module";s:5:"image";s:8:"settings";a:2:{s:10:"image_link";s:0:"";s:11:"image_style";s:0:"";}s:4:"type";s:5:"image";s:6:"weight";i:3;}}s:5:"label";s:11:"Cover Image";s:8:"required";i:0;s:8:"settings";a:9:{s:9:"alt_field";i:1;s:13:"default_image";i:0;s:14:"file_directory";s:16:"book_list_covers";s:15:"file_extensions";s:16:"png gif jpg jpeg";s:12:"max_filesize";s:0:"";s:14:"max_resolution";s:0:"";s:14:"min_resolution";s:0:"";s:11:"title_field";i:0;s:18:"user_register_form";b:0;}s:6:"widget";a:5:{s:6:"active";i:1;s:6:"module";s:5:"image";s:8:"settings";a:2:{s:19:"preview_image_style";s:9:"thumbnail";s:18:"progress_indicator";s:8:"throbber";}s:4:"type";s:11:"image_image";s:6:"weight";i:4;}}','0');
INSERT INTO `field_config_instance` VALUES ('171','111','field_bl_b_link','field_collection_item','field_booklist_books','a:7:{s:13:"default_value";N;s:11:"description";s:63:"Enter a link to your ILS or online catalog entry for this book.";s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:6:"module";N;s:8:"settings";a:0:{}s:4:"type";N;s:6:"weight";i:2;}}s:5:"label";s:12:"Catalog Link";s:8:"required";i:0;s:8:"settings";a:12:{s:12:"absolute_url";i:1;s:12:"validate_url";i:1;s:3:"url";s:8:"optional";s:5:"title";s:5:"value";s:11:"title_value";s:18:"Reserve this book!";s:27:"title_label_use_field_label";i:0;s:15:"title_maxlength";s:3:"128";s:13:"enable_tokens";i:1;s:7:"display";a:1:{s:10:"url_cutoff";s:2:"80";}s:10:"attributes";a:6:{s:6:"target";s:6:"_blank";s:3:"rel";s:0:"";s:18:"configurable_class";i:0;s:5:"class";s:0:"";s:18:"configurable_title";i:0;s:5:"title";s:0:"";}s:10:"rel_remove";s:7:"default";s:18:"user_register_form";b:0;}s:6:"widget";a:5:{s:6:"weight";i:3;s:4:"type";s:10:"link_field";s:6:"module";s:4:"link";s:6:"active";i:0;s:8:"settings";a:0:{}}}','0'),('172','112','field_bl_b_title','field_collection_item','field_booklist_books','a:7:{s:13:"default_value";N;s:11:"description";s:27:"Enter the title of the book";s:7:"display";a:1:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:6:"module";s:4:"text";s:8:"settings";a:0:{}s:4:"type";s:12:"text_default";s:6:"weight";i:0;}}s:5:"label";s:10:"Book Title";s:8:"required";i:0;s:8:"settings";a:2:{s:15:"text_processing";i:0;s:18:"user_register_form";b:0;}s:6:"widget";a:5:{s:6:"active";i:1;s:6:"module";s:4:"text";s:8:"settings";a:1:{s:4:"size";i:60;}s:4:"type";s:14:"text_textfield";s:6:"weight";i:1;}}','0'),('173','2','body','node','book_list','a:7:{s:13:"default_value";N;s:11:"description";s:0:"";s:7:"display";a:2:{s:7:"default";a:5:{s:5:"label";s:6:"hidden";s:6:"module";s:4:"text";s:8:"settings";a:0:{}s:4:"type";s:12:"text_default";s:6:"weight";i:0;}s:6:"teaser";a:5:{s:5:"label";s:6:"hidden";s:6:"module";s:4:"text";s:8:"settings";a:1:{s:11:"trim_length";i:600;}s:4:"type";s:23:"text_summary_or_trimmed";s:6:"weight";i:0;}}s:5:"label";s:4:"Body";s:8:"required";b:0;s:8:"settings";a:3:{s:15:"display_summary";b:1;s:15:"text_processing";i:1;s:18:"user_register_form";b:0;}s:6:"widget";a:4:{s:6:"module";s:4:"text";s:8:"settings";a:2:{s:4:"rows";i:20;s:12:"summary_rows";i:5;}s:4:"type";s:26:"text_textarea_with_summary";s:6:"weight";i:31;}}','0');
INSERT INTO `field_config_instance` VALUES ('174','113','field_booklist_books','node','book_list','a:7:{s:13:"default_value";N;s:11:"description";s:33:"Enter your books using this form.";s:7:"display";a:2:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:6:"module";s:16:"field_collection";s:8:"settings";a:5:{s:3:"add";s:3:"Add";s:6:"delete";s:6:"Delete";s:11:"description";b:1;s:4:"edit";s:4:"Edit";s:9:"view_mode";s:4:"full";}s:4:"type";s:21:"field_collection_view";s:6:"weight";i:1;}s:6:"teaser";a:4:{s:5:"label";s:5:"above";s:8:"settings";a:0:{}s:4:"type";s:6:"hidden";s:6:"weight";i:0;}}s:5:"label";s:5:"Books";s:8:"required";i:0;s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:6:"widget";a:5:{s:6:"active";i:0;s:6:"module";s:16:"field_collection";s:8:"settings";a:0:{}s:4:"type";s:22:"field_collection_embed";s:6:"weight";i:32;}}','0'),('175','38','field_program','node','event','a:7:{s:13:"default_value";N;s:11:"description";s:0:"";s:7:"display";a:2:{s:7:"default";a:5:{s:5:"label";s:5:"above";s:6:"module";s:15:"entityreference";s:8:"settings";a:1:{s:4:"link";b:0;}s:4:"type";s:21:"entityreference_label";s:6:"weight";i:1;}s:6:"teaser";a:4:{s:5:"label";s:5:"above";s:8:"settings";a:0:{}s:4:"type";s:6:"hidden";s:6:"weight";i:0;}}s:5:"label";s:7:"Program";s:8:"required";i:0;s:8:"settings";a:1:{s:18:"user_register_form";b:0;}s:6:"widget";a:5:{s:6:"active";i:1;s:6:"module";s:7:"options";s:8:"settings";a:0:{}s:4:"type";s:15:"options_buttons";s:6:"weight";i:3;}}','0');
DROP TABLE IF EXISTS `field_data_body`;
CREATE TABLE `field_data_body` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `body_value` longtext,   `body_summary` longtext,   `body_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `body_format` (`body_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 2 (body)';
INSERT INTO `field_data_body` VALUES ('node','page','0','18','18','und','0','<p>CUSTOMIZE THIS PAGE TO DESCRIBE YOUR PROGRAMS</p>','','filtered_html'),('node','article','0','19','19','und','0','By using this website, I agree to the following terms and conditions: * I am at least 13 years old, or I am a parent/legal guardian creating an account for my child under 13 years old.',null,'plain_text');
DROP TABLE IF EXISTS `field_data_comment_body`;
CREATE TABLE `field_data_comment_body` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `comment_body_value` longtext,   `comment_body_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `comment_body_format` (`comment_body_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 1 (comment_body)';
DROP TABLE IF EXISTS `field_data_field_account_family_notes`;
CREATE TABLE `field_data_field_account_family_notes` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_account_family_notes_value` longtext,   `field_account_family_notes_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_account_family_notes_format` (`field_account_family_notes_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 98 (field_account_family_notes)';
DROP TABLE IF EXISTS `field_data_field_activity_code`;
CREATE TABLE `field_data_field_activity_code` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_code_value` varchar(255) DEFAULT NULL,   `field_activity_code_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_activity_code_format` (`field_activity_code_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 106 (field_activity_code)';
DROP TABLE IF EXISTS `field_data_field_activity_description`;
CREATE TABLE `field_data_field_activity_description` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_description_value` longtext,   `field_activity_description_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_activity_description_format` (`field_activity_description_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 100 (field_activity_description)';
DROP TABLE IF EXISTS `field_data_field_activity_log_description`;
CREATE TABLE `field_data_field_activity_log_description` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_log_description_value` longtext,   `field_activity_log_description_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_activity_log_description_format` (`field_activity_log_description_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 80 (field_activity_log_description)';
INSERT INTO `field_data_field_activity_log_description` VALUES ('activity_log_reference','activity_log_reference','0','1','1','und','0','testing activity log',null),('activity_log_reference','activity_log_reference','0','2','2','und','0','testing activity log',null);
DROP TABLE IF EXISTS `field_data_field_activity_log_reference`;
CREATE TABLE `field_data_field_activity_log_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_log_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_activity_log_reference_target_id` (`field_activity_log_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 82 (field_activity_log_reference)';
DROP TABLE IF EXISTS `field_data_field_activity_log_title`;
CREATE TABLE `field_data_field_activity_log_title` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_log_title_value` varchar(255) DEFAULT NULL,   `field_activity_log_title_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_activity_log_title_format` (`field_activity_log_title_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 79 (field_activity_log_title)';
INSERT INTO `field_data_field_activity_log_title` VALUES ('activity_log_reference','activity_log_reference','0','1','1','und','0','test',null),('activity_log_reference','activity_log_reference','0','2','2','und','0','activity 2',null);
DROP TABLE IF EXISTS `field_data_field_activity_points`;
CREATE TABLE `field_data_field_activity_points` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_points_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 102 (field_activity_points)';
DROP TABLE IF EXISTS `field_data_field_activity_reference`;
CREATE TABLE `field_data_field_activity_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_activity_reference_target_id` (`field_activity_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 103 (field_activity_reference)';
INSERT INTO `field_data_field_activity_reference` VALUES ('activity_log','activity_log','0','1','1','und','0','1'),('activity_log','activity_log','0','2','2','und','0','2'),('activity_log','activity_log','0','4','4','und','0','2'),('activity_log','activity_log','0','5','5','und','0','2'),('activity_log','activity_log','0','6','6','und','0','1'),('activity_log','activity_log','0','8','8','und','0','1'),('activity_log','activity_log','0','9','9','und','0','1'),('activity_log','activity_log','0','10','10','und','0','4'),('activity_log','activity_log','0','11','11','und','0','6'),('activity_log','activity_log','0','12','12','und','0','7'),('activity_log','activity_log','0','13','13','und','0','6'),('activity_log','activity_log','0','14','14','und','0','2'),('activity_log','activity_log','0','15','15','und','0','1'),('activity_log','activity_log','0','16','16','und','0','2'),('activity_log','activity_log','0','17','17','und','0','4'),('activity_log','activity_log','0','18','18','und','0','5'),('activity_log','activity_log','0','19','19','und','0','6'),('activity_log','activity_log','0','20','20','und','0','1'),('activity_log','activity_log','0','21','21','und','0','2'),('activity_log','activity_log','0','22','22','und','0','4'),('activity_log','activity_log','0','23','23','und','0','5'),('activity_log','activity_log','0','24','24','und','0','4'),('activity_log','activity_log','0','25','25','und','0','5'),('activity_log','activity_log','0','26','26','und','0','8'),('activity_log','activity_log','0','27','27','und','0','1'),('activity_log','activity_log','0','28','28','und','0','2'),('activity_log','activity_log','0','29','29','und','0','4'),('activity_log','activity_log','0','30','30','und','0','5'),('activity_log','activity_log','0','31','31','und','0','6'),('activity_log','activity_log','0','32','32','und','0','1');
INSERT INTO `field_data_field_activity_reference` VALUES ('activity_log','activity_log','0','33','33','und','0','1'),('activity_log','activity_log','0','34','34','und','0','1'),('activity_log','activity_log','0','35','35','und','0','1'),('activity_log','activity_log','0','36','36','und','0','2'),('activity_log','activity_log','0','37','37','und','0','4');
DROP TABLE IF EXISTS `field_data_field_age`;
CREATE TABLE `field_data_field_age` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_age_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 34 (field_age)';
DROP TABLE IF EXISTS `field_data_field_author`;
CREATE TABLE `field_data_field_author` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_author_value` varchar(255) DEFAULT NULL,   `field_author_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_author_format` (`field_author_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 57 (field_author)';
INSERT INTO `field_data_field_author` VALUES ('reading_log','reading_log','0','57','57','und','0','red ',null),('reading_log','reading_log','0','58','58','und','0','',null),('reading_log','reading_log','0','59','59','und','0','',null),('reading_log','reading_log','0','60','60','und','0','',null),('reading_log','reading_log','0','61','61','und','0','',null),('reading_log','reading_log','0','62','62','und','0','',null),('reading_log','reading_log','0','63','63','und','0','',null),('reading_log','reading_log','0','64','64','und','0','',null),('reading_log','reading_log','0','65','65','und','0','',null),('reading_log','reading_log','0','66','66','und','0','',null),('reading_log','reading_log','0','67','67','und','0','',null),('reading_log','reading_log','0','68','68','und','0','',null),('reading_log','reading_log','0','69','69','und','0','',null),('reading_log','reading_log','0','70','70','und','0','',null),('reading_log','reading_log','0','71','71','und','0','',null),('reading_log','reading_log','0','72','72','und','0','',null),('reading_log','reading_log','0','73','73','und','0','',null),('reading_log','reading_log','0','74','74','und','0','',null),('reading_log','reading_log','0','75','75','und','0','',null),('reading_log','reading_log','0','76','76','und','0','',null),('reading_log','reading_log','0','82','82','und','0','22',null),('reading_log','reading_log','0','83','83','und','0','time',null),('reading_log','reading_log','0','84','84','und','0','33',null),('reading_log','reading_log','0','85','85','und','0','22',null),('reading_log','reading_log','0','86','86','und','0','22',null);
DROP TABLE IF EXISTS `field_data_field_badge`;
CREATE TABLE `field_data_field_badge` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_badge_tid` int(10) unsigned DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_badge_tid` (`field_badge_tid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 60 (field_badge)';
DROP TABLE IF EXISTS `field_data_field_badge_description`;
CREATE TABLE `field_data_field_badge_description` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_badge_description_value` longtext,   `field_badge_description_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_badge_description_format` (`field_badge_description_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 75 (field_badge_description)';
DROP TABLE IF EXISTS `field_data_field_badge_image`;
CREATE TABLE `field_data_field_badge_image` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_badge_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',   `field_badge_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',   `field_badge_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',   `field_badge_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',   `field_badge_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_badge_image_fid` (`field_badge_image_fid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 55 (field_badge_image)';
INSERT INTO `field_data_field_badge_image` VALUES ('taxonomy_term','badge','0','1','1','und','0','2','','','169','169'),('taxonomy_term','badge','0','4','4','und','0','1','','','295','295'),('taxonomy_term','badge','0','10','10','und','0','4',null,null,'303','469'),('taxonomy_term','badge','0','11','11','und','0','6','','','276','375');
DROP TABLE IF EXISTS `field_data_field_badge_message`;
CREATE TABLE `field_data_field_badge_message` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_badge_message_value` varchar(255) DEFAULT NULL,   `field_badge_message_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_badge_message_format` (`field_badge_message_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 96 (field_badge_message)';
INSERT INTO `field_data_field_badge_message` VALUES ('reader_badge','reader_badge','0','27','27','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','28','28','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','30','30','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','31','31','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','33','33','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','34','34','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','39','39','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','40','40','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','42','42','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','43','43','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','44','44','und','0','test',null),('reader_badge','reader_badge','0','45','45','und','0','test',null),('reader_badge','reader_badge','0','48','48','und','0','test',null),('reader_badge','reader_badge','0','49','49','und','0','Congratulations you earned the kangaroo badge!!',null),('reader_badge','reader_badge','0','50','50','und','0','test',null),('reader_badge','reader_badge','0','51','51','und','0','Congratulations you earned the kangaroo badge!!',null),('reader_badge','reader_badge','0','52','52','und','0','test',null),('reader_badge','reader_badge','0','54','54','und','0','test',null),('reader_badge','reader_badge','0','60','60','und','0','test',null),('reader_badge','reader_badge','0','61','61','und','0','Congratulations you earned badge #1!!',null),('reader_badge','reader_badge','0','63','63','und','0','Congratulations you earned badge #1!!',null),('reader_badge','reader_badge','0','83','83','und','0','Congratulations you earned the christmas badge!!',null);
INSERT INTO `field_data_field_badge_message` VALUES ('reader_badge','reader_badge','0','84','84','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','86','86','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','87','87','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','89','89','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','90','90','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','93','93','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','94','94','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','97','97','und','0','test',null),('reader_badge','reader_badge','0','98','98','und','0','test',null),('reader_badge','reader_badge','0','99','99','und','0','test',null),('reader_badge','reader_badge','0','100','100','und','0','test',null),('reader_badge','reader_badge','0','101','101','und','0','test',null),('reader_badge','reader_badge','0','102','102','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','103','103','und','0','Congratulations you earned the happy face badge!!',null);
DROP TABLE IF EXISTS `field_data_field_bl_b_author`;
CREATE TABLE `field_data_field_bl_b_author` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_bl_b_author_value` varchar(255) DEFAULT NULL,   `field_bl_b_author_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_bl_b_author_format` (`field_bl_b_author_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 109 (field_bl_b_author)';
DROP TABLE IF EXISTS `field_data_field_bl_b_image`;
CREATE TABLE `field_data_field_bl_b_image` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_bl_b_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',   `field_bl_b_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',   `field_bl_b_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',   `field_bl_b_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',   `field_bl_b_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_bl_b_image_fid` (`field_bl_b_image_fid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 110 (field_bl_b_image)';
DROP TABLE IF EXISTS `field_data_field_bl_b_link`;
CREATE TABLE `field_data_field_bl_b_link` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_bl_b_link_url` varchar(2048) DEFAULT NULL,   `field_bl_b_link_title` varchar(255) DEFAULT NULL,   `field_bl_b_link_attributes` mediumtext,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 111 (field_bl_b_link)';
DROP TABLE IF EXISTS `field_data_field_bl_b_title`;
CREATE TABLE `field_data_field_bl_b_title` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_bl_b_title_value` varchar(255) DEFAULT NULL,   `field_bl_b_title_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_bl_b_title_format` (`field_bl_b_title_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 112 (field_bl_b_title)';
DROP TABLE IF EXISTS `field_data_field_book_title`;
CREATE TABLE `field_data_field_book_title` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_book_title_value` varchar(255) DEFAULT NULL,   `field_book_title_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_book_title_format` (`field_book_title_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 50 (field_book_title)';
INSERT INTO `field_data_field_book_title` VALUES ('reading_log','reading_log','0','57','57','und','0','how many points do i need ',null),('reading_log','reading_log','0','58','58','und','0','1984',null),('reading_log','reading_log','0','59','59','und','0','Brave New World',null),('reading_log','reading_log','0','60','60','und','0','1984',null),('reading_log','reading_log','0','61','61','und','0','',null),('reading_log','reading_log','0','62','62','und','0','',null),('reading_log','reading_log','0','63','63','und','0','',null),('reading_log','reading_log','0','64','64','und','0','',null),('reading_log','reading_log','0','65','65','und','0','',null),('reading_log','reading_log','0','66','66','und','0','',null),('reading_log','reading_log','0','67','67','und','0','',null),('reading_log','reading_log','0','68','68','und','0','1984',null),('reading_log','reading_log','0','69','69','und','0','99',null),('reading_log','reading_log','0','70','70','und','0','',null),('reading_log','reading_log','0','71','71','und','0','99',null),('reading_log','reading_log','0','72','72','und','0','99',null),('reading_log','reading_log','0','73','73','und','0','99',null),('reading_log','reading_log','0','74','74','und','0','99',null),('reading_log','reading_log','0','75','75','und','0','99',null),('reading_log','reading_log','0','76','76','und','0','77',null),('reading_log','reading_log','0','82','82','und','0','fava',null),('reading_log','reading_log','0','83','83','und','0','Tacos',null),('reading_log','reading_log','0','84','84','und','0','fava',null),('reading_log','reading_log','0','85','85','und','0','awesome possume',null),('reading_log','reading_log','0','86','86','und','0','fava',null);
DROP TABLE IF EXISTS `field_data_field_booklist_books`;
CREATE TABLE `field_data_field_booklist_books` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_booklist_books_value` int(11) DEFAULT NULL COMMENT 'The field collection item id.',   `field_booklist_books_revision_id` int(11) DEFAULT NULL COMMENT 'The field collection item revision id.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_booklist_books_revision_id` (`field_booklist_books_revision_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 113 (field_booklist_books)';
DROP TABLE IF EXISTS `field_data_field_branch_address`;
CREATE TABLE `field_data_field_branch_address` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_branch_address_country` varchar(2) DEFAULT '' COMMENT 'Two letter ISO country code of this address.',   `field_branch_address_administrative_area` varchar(255) DEFAULT '' COMMENT 'The administrative area of this address. (i.e. State/Province)',   `field_branch_address_sub_administrative_area` varchar(255) DEFAULT '' COMMENT 'The sub administrative area of this address.',   `field_branch_address_locality` varchar(255) DEFAULT '' COMMENT 'The locality of this address. (i.e. City)',   `field_branch_address_dependent_locality` varchar(255) DEFAULT '' COMMENT 'The dependent locality of this address.',   `field_branch_address_postal_code` varchar(255) DEFAULT '' COMMENT 'The postal code of this address.',   `field_branch_address_thoroughfare` varchar(255) DEFAULT '' COMMENT 'The thoroughfare of this address. (i.e. Street address)',   `field_branch_address_premise` varchar(255) DEFAULT '' COMMENT 'The premise of this address. (i.e. Apartment / Suite number)',   `field_branch_address_sub_premise` varchar(255) DEFAULT '' COMMENT 'The sub_premise of this address.',   `field_branch_address_organisation_name` varchar(255) DEFAULT '' COMMENT 'Contents of a primary OrganisationName element in the xNL XML.',   `field_branch_address_name_line` varchar(255) DEFAULT '' COMMENT 'Contents of a primary NameLine element in the xNL XML.',   `field_branch_address_first_name` varchar(255) DEFAULT '' COMMENT 'Contents of the FirstName element of a primary PersonName element in the xNL XML.',   `field_branch_address_last_name` varchar(255) DEFAULT '' COMMENT 'Contents of the LastName element of a primary PersonName element in the xNL XML.',   `field_branch_address_data` longtext COMMENT 'Additional data for this address.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 8 (field_branch_address)';
DROP TABLE IF EXISTS `field_data_field_branch_phone`;
CREATE TABLE `field_data_field_branch_phone` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_branch_phone_value` varchar(255) DEFAULT NULL,   `field_branch_phone_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_branch_phone_format` (`field_branch_phone_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 7 (field_branch_phone)';
DROP TABLE IF EXISTS `field_data_field_claimed_activities`;
CREATE TABLE `field_data_field_claimed_activities` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_claimed_activities_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_claimed_activities_target_id` (`field_claimed_activities_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 105 (field_claimed_activities)';
DROP TABLE IF EXISTS `field_data_field_current_drawing_tickets`;
CREATE TABLE `field_data_field_current_drawing_tickets` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_drawing_tickets_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_current_drawing_tickets_target_id` (`field_current_drawing_tickets_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 94 (field_current_drawing_tickets)';
DROP TABLE IF EXISTS `field_data_field_current_level`;
CREATE TABLE `field_data_field_current_level` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_level_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_current_level_target_id` (`field_current_level_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 90 (field_current_level)';
DROP TABLE IF EXISTS `field_data_field_current_points`;
CREATE TABLE `field_data_field_current_points` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_points_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 89 (field_current_points)';
DROP TABLE IF EXISTS `field_data_field_current_program`;
CREATE TABLE `field_data_field_current_program` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_program_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_current_program_target_id` (`field_current_program_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 91 (field_current_program)';
DROP TABLE IF EXISTS `field_data_field_current_reader`;
CREATE TABLE `field_data_field_current_reader` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_reader_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_current_reader_target_id` (`field_current_reader_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 54 (field_current_reader)';
DROP TABLE IF EXISTS `field_data_field_current_reader_badge`;
CREATE TABLE `field_data_field_current_reader_badge` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_reader_badge_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_current_reader_badge_target_id` (`field_current_reader_badge_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 92 (field_current_reader_badge)';
DROP TABLE IF EXISTS `field_data_field_current_reader_prizes`;
CREATE TABLE `field_data_field_current_reader_prizes` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_reader_prizes_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_current_reader_prizes_target_id` (`field_current_reader_prizes_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 93 (field_current_reader_prizes)';
DROP TABLE IF EXISTS `field_data_field_date`;
CREATE TABLE `field_data_field_date` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_date_value` datetime DEFAULT NULL,   `field_date_value2` datetime DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 107 (field_date)';
DROP TABLE IF EXISTS `field_data_field_drawing_tickets`;
CREATE TABLE `field_data_field_drawing_tickets` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_drawing_tickets_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 86 (field_drawing_tickets)';
DROP TABLE IF EXISTS `field_data_field_favorite_branch`;
CREATE TABLE `field_data_field_favorite_branch` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_favorite_branch_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_favorite_branch_target_id` (`field_favorite_branch_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 30 (field_favorite_branch)';
DROP TABLE IF EXISTS `field_data_field_first_name`;
CREATE TABLE `field_data_field_first_name` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_first_name_value` varchar(255) DEFAULT NULL,   `field_first_name_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_first_name_format` (`field_first_name_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 28 (field_first_name)';
INSERT INTO `field_data_field_first_name` VALUES ('user','user','0','1','1','und','0','admin',null);
DROP TABLE IF EXISTS `field_data_field_grade`;
CREATE TABLE `field_data_field_grade` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_grade_value` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_grade_value` (`field_grade_value`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 35 (field_grade)';
DROP TABLE IF EXISTS `field_data_field_image`;
CREATE TABLE `field_data_field_image` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',   `field_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',   `field_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',   `field_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',   `field_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_image_fid` (`field_image_fid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 4 (field_image)';
DROP TABLE IF EXISTS `field_data_field_last_name`;
CREATE TABLE `field_data_field_last_name` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_last_name_value` varchar(255) DEFAULT NULL,   `field_last_name_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_last_name_format` (`field_last_name_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 29 (field_last_name)';
INSERT INTO `field_data_field_last_name` VALUES ('user','user','0','1','1','und','0','admin',null);
DROP TABLE IF EXISTS `field_data_field_level`;
CREATE TABLE `field_data_field_level` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_level_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_level_target_id` (`field_level_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 39 (field_level)';
DROP TABLE IF EXISTS `field_data_field_level_message`;
CREATE TABLE `field_data_field_level_message` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_level_message_value` longtext,   `field_level_message_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_level_message_format` (`field_level_message_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 22 (field_level_message)';
INSERT INTO `field_data_field_level_message` VALUES ('level','level','0','31','31','und','0','This is the auto-generated beginning level. You may edit any of these details later',null);
DROP TABLE IF EXISTS `field_data_field_level_number`;
CREATE TABLE `field_data_field_level_number` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_level_number_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 19 (field_level_number)';
INSERT INTO `field_data_field_level_number` VALUES ('level','level','0','31','31','und','0','1');
DROP TABLE IF EXISTS `field_data_field_library_card`;
CREATE TABLE `field_data_field_library_card` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_library_card_value` varchar(255) DEFAULT NULL,   `field_library_card_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_library_card_format` (`field_library_card_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 97 (field_library_card)';
INSERT INTO `field_data_field_library_card` VALUES ('user','user','0','1','1','und','0','000',null);
DROP TABLE IF EXISTS `field_data_field_message`;
CREATE TABLE `field_data_field_message` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_message_value` varchar(255) DEFAULT NULL,   `field_message_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_message_format` (`field_message_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 87 (field_message)';
DROP TABLE IF EXISTS `field_data_field_parent_uid`;
CREATE TABLE `field_data_field_parent_uid` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_parent_uid_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_parent_uid_target_id` (`field_parent_uid_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 48 (field_parent_uid)';
DROP TABLE IF EXISTS `field_data_field_per_unit_label`;
CREATE TABLE `field_data_field_per_unit_label` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_per_unit_label_value` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_per_unit_label_value` (`field_per_unit_label_value`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 65 (field_per_unit_label)';
INSERT INTO `field_data_field_per_unit_label` VALUES ('program','program','0','14','14','und','0','Book');
DROP TABLE IF EXISTS `field_data_field_per_unit_point_value`;
CREATE TABLE `field_data_field_per_unit_point_value` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_per_unit_point_value_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 15 (field_per_unit_point_value)';
INSERT INTO `field_data_field_per_unit_point_value` VALUES ('program','program','0','14','14','und','0','100');
DROP TABLE IF EXISTS `field_data_field_phone_number`;
CREATE TABLE `field_data_field_phone_number` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_phone_number_value` varchar(255) DEFAULT NULL,   `field_phone_number_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_phone_number_format` (`field_phone_number_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 108 (field_phone_number)';
DROP TABLE IF EXISTS `field_data_field_point_threshold`;
CREATE TABLE `field_data_field_point_threshold` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_point_threshold_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 20 (field_point_threshold)';
INSERT INTO `field_data_field_point_threshold` VALUES ('level','level','0','31','31','und','0','0');
DROP TABLE IF EXISTS `field_data_field_points`;
CREATE TABLE `field_data_field_points` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_points_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 77 (field_points)';
INSERT INTO `field_data_field_points` VALUES ('points','points','0','5','5','und','0','100000'),('points','points','0','6','6','und','0','13'),('points','points','0','7','7','und','0','100'),('points','points','0','8','8','und','0','220'),('points','points','0','9','9','und','0','220'),('points','points','0','10','10','und','0','220'),('points','points','0','11','11','und','0','110'),('points','points','0','12','12','und','0','13'),('points','points','0','13','13','und','0','13'),('points','points','0','14','14','und','0','13'),('points','points','0','15','15','und','0','8'),('points','points','0','16','16','und','0','20'),('points','points','0','17','17','und','0','20'),('points','points','0','18','18','und','0','20'),('points','points','0','19','19','und','0','20'),('points','points','0','20','20','und','0','10'),('points','points','0','21','21','und','0','1'),('points','points','0','22','22','und','0','20'),('points','points','0','23','23','und','0','5'),('points','points','0','24','24','und','0','4'),('points','points','0','25','25','und','0','4'),('points','points','0','26','26','und','0','10'),('points','points','0','27','27','und','0','1000'),('points','points','0','28','28','und','0','100'),('points','points','0','29','29','und','0','110'),('points','points','0','30','30','und','0','9990'),('points','points','0','31','31','und','0','13'),('points','points','0','32','32','und','0','110'),('points','points','0','33','33','und','0','550'),('points','points','0','34','34','und','0','10000');
INSERT INTO `field_data_field_points` VALUES ('points','points','0','35','35','und','0','1000'),('points','points','0','36','36','und','0','1000'),('points','points','0','37','37','und','0','330'),('points','points','0','38','38','und','0','1110'),('points','points','0','39','39','und','0','220'),('points','points','0','40','40','und','0','1000'),('points','points','0','41','41','und','0','120'),('points','points','0','42','42','und','0','1440'),('points','points','0','43','43','und','0','100'),('points','points','0','51','51','und','0','1780'),('points','points','0','52','52','und','0','10'),('points','points','0','53','53','und','0','10'),('points','points','0','54','54','und','0','100'),('points','points','0','55','55','und','0','114'),('points','points','0','56','56','und','0','60'),('points','points','0','57','57','und','0','28'),('points','points','0','58','58','und','0','30'),('points','points','0','59','59','und','0','30'),('points','points','0','60','60','und','0','30'),('points','points','0','61','61','und','0','40'),('points','points','0','63','63','und','0','10'),('points','points','0','64','64','und','0','20'),('points','points','0','65','65','und','0','10'),('points','points','0','66','66','und','0','20'),('points','points','0','67','67','und','0','20'),('points','points','0','68','68','und','0','10'),('points','points','0','69','69','und','0','10'),('points','points','0','70','70','und','0','10'),('points','points','0','71','71','und','0','10'),('points','points','0','72','72','und','0','10');
INSERT INTO `field_data_field_points` VALUES ('points','points','0','73','73','und','0','10'),('points','points','0','74','74','und','0','10'),('points','points','0','75','75','und','0','10'),('points','points','0','85','85','und','0','10'),('points','points','0','86','86','und','0','20'),('points','points','0','87','87','und','0','10'),('points','points','0','88','88','und','0','10'),('points','points','0','89','89','und','0','10'),('points','points','0','90','90','und','0','10'),('points','points','0','91','91','und','0','20'),('points','points','0','92','92','und','0','20'),('points','points','0','93','93','und','0','20'),('points','points','0','94','94','und','0','20'),('points','points','0','95','95','und','0','20'),('points','points','0','96','96','und','0','20'),('points','points','0','97','97','und','0','20'),('points','points','0','113','113','und','0','220'),('points','points','0','114','114','und','0','220'),('points','points','0','115','115','und','0','220'),('points','points','0','116','116','und','0','110'),('points','points','0','117','117','und','0','10'),('points','points','0','118','118','und','0','20'),('points','points','0','119','119','und','0','10'),('points','points','0','120','120','und','0','10'),('points','points','0','121','121','und','0','10'),('points','points','0','122','122','und','0','10'),('points','points','0','123','123','und','0','10'),('points','points','0','124','124','und','0','10'),('points','points','0','125','125','und','0','10'),('points','points','0','126','126','und','0','20');
INSERT INTO `field_data_field_points` VALUES ('points','points','0','127','127','und','0','10'),('points','points','0','128','128','und','0','220');
DROP TABLE IF EXISTS `field_data_field_points_earned`;
CREATE TABLE `field_data_field_points_earned` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_points_earned_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 53 (field_points_earned)';
INSERT INTO `field_data_field_points_earned` VALUES ('activity_log','activity_log','0','1','1','und','0','10'),('activity_log','activity_log','0','2','2','und','0','20'),('activity_log','activity_log','0','3','3','und','0','10'),('activity_log','activity_log','0','4','4','und','0','20'),('activity_log','activity_log','0','5','5','und','0','20'),('activity_log','activity_log','0','6','6','und','0','10'),('activity_log','activity_log','0','7','7','und','0','10'),('activity_log','activity_log','0','8','8','und','0','10'),('activity_log','activity_log','0','9','9','und','0','10'),('activity_log','activity_log','0','10','10','und','0','10'),('activity_log','activity_log','0','11','11','und','0','10'),('activity_log','activity_log','0','12','12','und','0','10'),('activity_log','activity_log','0','13','13','und','0','10'),('activity_log','activity_log','0','14','14','und','0','20'),('activity_log','activity_log','0','15','15','und','0','10'),('activity_log','activity_log','0','16','16','und','0','20'),('activity_log','activity_log','0','17','17','und','0','10'),('activity_log','activity_log','0','18','18','und','0','10'),('activity_log','activity_log','0','19','19','und','0','10'),('activity_log','activity_log','0','20','20','und','0','10'),('activity_log','activity_log','0','21','21','und','0','20'),('activity_log','activity_log','0','22','22','und','0','10'),('activity_log','activity_log','0','23','23','und','0','10'),('activity_log','activity_log','0','24','24','und','0','10'),('activity_log','activity_log','0','25','25','und','0','10'),('activity_log','activity_log','0','26','26','und','0','50'),('activity_log','activity_log','0','27','27','und','0','10'),('activity_log','activity_log','0','28','28','und','0','20'),('activity_log','activity_log','0','29','29','und','0','10'),('activity_log','activity_log','0','30','30','und','0','10');
INSERT INTO `field_data_field_points_earned` VALUES ('activity_log','activity_log','0','31','31','und','0','10'),('activity_log','activity_log','0','32','32','und','0','10'),('activity_log','activity_log','0','33','33','und','0','10'),('activity_log','activity_log','0','34','34','und','0','10'),('activity_log','activity_log','0','35','35','und','0','10'),('activity_log','activity_log','0','36','36','und','0','20'),('activity_log','activity_log','0','37','37','und','0','10');
DROP TABLE IF EXISTS `field_data_field_points_reference`;
CREATE TABLE `field_data_field_points_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_points_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_points_reference_target_id` (`field_points_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 81 (field_points_reference)';
INSERT INTO `field_data_field_points_reference` VALUES ('activity_log_reference','activity_log_reference','0','1','1','und','0','2'),('activity_log_reference','activity_log_reference','0','2','2','und','0','3'),('reading_log','reading_log','0','57','57','und','0','61'),('reading_log','reading_log','0','58','58','und','0','76'),('reading_log','reading_log','0','59','59','und','0','77'),('reading_log','reading_log','0','60','60','und','0','78'),('reading_log','reading_log','0','61','61','und','0','91'),('reading_log','reading_log','0','62','62','und','0','92'),('reading_log','reading_log','0','63','63','und','0','93'),('reading_log','reading_log','0','64','64','und','0','94'),('reading_log','reading_log','0','65','65','und','0','95'),('reading_log','reading_log','0','66','66','und','0','96'),('reading_log','reading_log','0','67','67','und','0','97'),('reading_log','reading_log','0','68','68','und','0','99'),('reading_log','reading_log','0','69','69','und','0','100'),('reading_log','reading_log','0','70','70','und','0','101'),('reading_log','reading_log','0','71','71','und','0','102'),('reading_log','reading_log','0','72','72','und','0','103'),('reading_log','reading_log','0','73','73','und','0','104'),('reading_log','reading_log','0','74','74','und','0','105'),('reading_log','reading_log','0','75','75','und','0','106'),('reading_log','reading_log','0','76','76','und','0','107'),('reading_log','reading_log','0','82','82','und','0','113'),('reading_log','reading_log','0','83','83','und','0','114'),('reading_log','reading_log','0','84','84','und','0','115'),('reading_log','reading_log','0','85','85','und','0','116'),('reading_log','reading_log','0','86','86','und','0','128');
DROP TABLE IF EXISTS `field_data_field_prize`;
CREATE TABLE `field_data_field_prize` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_prize_tid` int(10) unsigned DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_prize_tid` (`field_prize_tid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 59 (field_prize)';
DROP TABLE IF EXISTS `field_data_field_prize_description`;
CREATE TABLE `field_data_field_prize_description` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_prize_description_value` longtext,   `field_prize_description_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_prize_description_format` (`field_prize_description_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 64 (field_prize_description)';
INSERT INTO `field_data_field_prize_description` VALUES ('prize','prize','0','1','1','und','0','<p>This prize can be claimed at the front desk of your library.</p>','full_html'),('prize','prize','0','2','2','und','0','test',null),('prize','prize','0','4','4','und','0','Guitar Prize.',null),('prize','prize','0','5','5','und','0','test prize ',null),('prize','prize','0','6','6','und','0','more pizza ',null);
DROP TABLE IF EXISTS `field_data_field_prize_message`;
CREATE TABLE `field_data_field_prize_message` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_prize_message_value` varchar(255) DEFAULT NULL,   `field_prize_message_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_prize_message_format` (`field_prize_message_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 99 (field_prize_message)';
INSERT INTO `field_data_field_prize_message` VALUES ('prize','prize','0','1','1','und','0','Congratulations you won a Book Collection!!',null),('prize','prize','0','2','2','und','0','Congratulations you won a NEW prize!!',null),('prize','prize','0','3','3','und','0','Congratulations you won a third prize!!',null),('prize','prize','0','4','4','und','0','You won the guitar prize.',null),('prize','prize','0','5','5','und','0','woo hoo ',null),('prize','prize','0','6','6','und','0','pizza ',null);
DROP TABLE IF EXISTS `field_data_field_prize_reference`;
CREATE TABLE `field_data_field_prize_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_prize_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_prize_reference_target_id` (`field_prize_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 83 (field_prize_reference)';
DROP TABLE IF EXISTS `field_data_field_program`;
CREATE TABLE `field_data_field_program` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_program_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_program_target_id` (`field_program_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 38 (field_program)';
DROP TABLE IF EXISTS `field_data_field_program_description`;
CREATE TABLE `field_data_field_program_description` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_program_description_value` longtext,   `field_program_description_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_program_description_format` (`field_program_description_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 17 (field_program_description)';
INSERT INTO `field_data_field_program_description` VALUES ('program','program','0','14','14','und','0','<p>Yo</p>','filtered_html');
DROP TABLE IF EXISTS `field_data_field_program_reference`;
CREATE TABLE `field_data_field_program_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_program_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_program_reference_target_id` (`field_program_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 31 (field_program_reference)';
INSERT INTO `field_data_field_program_reference` VALUES ('level','level','0','31','31','und','0','14'),('points','points','0','5','5','und','0','3'),('points','points','0','6','6','und','0','8'),('points','points','0','7','7','und','0','3'),('points','points','0','8','8','und','0','3'),('points','points','0','9','9','und','0','3'),('points','points','0','10','10','und','0','3'),('points','points','0','11','11','und','0','3'),('points','points','0','12','12','und','0','8'),('points','points','0','13','13','und','0','8'),('points','points','0','14','14','und','0','8'),('points','points','0','15','15','und','0','10'),('points','points','0','16','16','und','0','9'),('points','points','0','17','17','und','0','9'),('points','points','0','18','18','und','0','9'),('points','points','0','19','19','und','0','9'),('points','points','0','20','20','und','0','10'),('points','points','0','21','21','und','0','10'),('points','points','0','22','22','und','0','9'),('points','points','0','23','23','und','0','10'),('points','points','0','24','24','und','0','10'),('points','points','0','25','25','und','0','10'),('points','points','0','26','26','und','0','10'),('points','points','0','27','27','und','0','3'),('points','points','0','28','28','und','0','3'),('points','points','0','29','29','und','0','3'),('points','points','0','30','30','und','0','3'),('points','points','0','31','31','und','0','8'),('points','points','0','32','32','und','0','3'),('points','points','0','33','33','und','0','3');
INSERT INTO `field_data_field_program_reference` VALUES ('points','points','0','34','34','und','0','3'),('points','points','0','35','35','und','0','3'),('points','points','0','36','36','und','0','3'),('points','points','0','37','37','und','0','3'),('points','points','0','38','38','und','0','3'),('points','points','0','39','39','und','0','3'),('points','points','0','40','40','und','0','3'),('points','points','0','41','41','und','0','3'),('points','points','0','42','42','und','0','3'),('points','points','0','43','43','und','0','3'),('points','points','0','51','51','und','0','3'),('points','points','0','52','52','und','0','3'),('points','points','0','53','53','und','0','3'),('points','points','0','54','54','und','0','3'),('points','points','0','55','55','und','0','12'),('points','points','0','56','56','und','0','12'),('points','points','0','57','57','und','0','13'),('points','points','0','58','58','und','0','13'),('points','points','0','59','59','und','0','13'),('points','points','0','60','60','und','0','13'),('points','points','0','61','61','und','0','13'),('points','points','0','63','63','und','0','3'),('points','points','0','64','64','und','0','3'),('points','points','0','65','65','und','0','3'),('points','points','0','66','66','und','0','3'),('points','points','0','67','67','und','0','3'),('points','points','0','68','68','und','0','3'),('points','points','0','69','69','und','0','3'),('points','points','0','70','70','und','0','3'),('points','points','0','71','71','und','0','3');
INSERT INTO `field_data_field_program_reference` VALUES ('points','points','0','72','72','und','0','3'),('points','points','0','73','73','und','0','3'),('points','points','0','74','74','und','0','3'),('points','points','0','75','75','und','0','3'),('points','points','0','85','85','und','0','3'),('points','points','0','86','86','und','0','3'),('points','points','0','87','87','und','0','3'),('points','points','0','88','88','und','0','3'),('points','points','0','89','89','und','0','3'),('points','points','0','90','90','und','0','3'),('points','points','0','91','91','und','0','9'),('points','points','0','92','92','und','0','9'),('points','points','0','93','93','und','0','9'),('points','points','0','94','94','und','0','9'),('points','points','0','95','95','und','0','9'),('points','points','0','96','96','und','0','9'),('points','points','0','97','97','und','0','9'),('points','points','0','113','113','und','0','3'),('points','points','0','114','114','und','0','3'),('points','points','0','115','115','und','0','3'),('points','points','0','116','116','und','0','3'),('points','points','0','117','117','und','0','3'),('points','points','0','118','118','und','0','3'),('points','points','0','119','119','und','0','3'),('points','points','0','120','120','und','0','3'),('points','points','0','121','121','und','0','3'),('points','points','0','122','122','und','0','3'),('points','points','0','123','123','und','0','3'),('points','points','0','124','124','und','0','3'),('points','points','0','125','125','und','0','3');
INSERT INTO `field_data_field_program_reference` VALUES ('points','points','0','126','126','und','0','3'),('points','points','0','127','127','und','0','3'),('points','points','0','128','128','und','0','3'),('prize','prize','0','1','1','und','0','3'),('prize','prize','0','2','2','und','0','3'),('prize','prize','0','3','3','und','0','8'),('prize','prize','0','4','4','und','0','3'),('prize','prize','0','5','5','und','0','11'),('prize','prize','0','6','6','und','0','11'),('reading_log','reading_log','0','57','57','und','0','13'),('reading_log','reading_log','0','58','58','und','0','8'),('reading_log','reading_log','0','59','59','und','0','8'),('reading_log','reading_log','0','60','60','und','0','8'),('reading_log','reading_log','0','61','61','und','0','9'),('reading_log','reading_log','0','62','62','und','0','9'),('reading_log','reading_log','0','63','63','und','0','9'),('reading_log','reading_log','0','64','64','und','0','9'),('reading_log','reading_log','0','65','65','und','0','9'),('reading_log','reading_log','0','66','66','und','0','9'),('reading_log','reading_log','0','67','67','und','0','9'),('reading_log','reading_log','0','68','68','und','0','8'),('reading_log','reading_log','0','69','69','und','0','8'),('reading_log','reading_log','0','70','70','und','0','8'),('reading_log','reading_log','0','71','71','und','0','8'),('reading_log','reading_log','0','72','72','und','0','8'),('reading_log','reading_log','0','73','73','und','0','8'),('reading_log','reading_log','0','74','74','und','0','8'),('reading_log','reading_log','0','75','75','und','0','8'),('reading_log','reading_log','0','76','76','und','0','8'),('reading_log','reading_log','0','82','82','und','0','3');
INSERT INTO `field_data_field_program_reference` VALUES ('reading_log','reading_log','0','83','83','und','0','3'),('reading_log','reading_log','0','84','84','und','0','3'),('reading_log','reading_log','0','85','85','und','0','3'),('reading_log','reading_log','0','86','86','und','0','3');
DROP TABLE IF EXISTS `field_data_field_reader_badge`;
CREATE TABLE `field_data_field_reader_badge` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_reader_badge_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_reader_badge_target_id` (`field_reader_badge_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 85 (field_reader_badge)';
INSERT INTO `field_data_field_reader_badge` VALUES ('activity_log','activity_log','0','1','1','und','0','14'),('activity_log','activity_log','0','3','3','und','0','5'),('activity_log','activity_log','0','6','6','und','0','14'),('activity_log','activity_log','0','7','7','und','0','5'),('activity_log','activity_log','0','8','8','und','0','14'),('activity_log','activity_log','0','9','9','und','0','14'),('activity_log','activity_log','0','15','15','und','0','14'),('activity_log','activity_log','0','20','20','und','0','14'),('activity_log','activity_log','0','26','26','und','0','1'),('activity_log','activity_log','0','27','27','und','0','14'),('activity_log','activity_log','0','32','32','und','0','14'),('activity_log','activity_log','0','33','33','und','0','14'),('activity_log','activity_log','0','34','34','und','0','14'),('activity_log','activity_log','0','35','35','und','0','14'),('reader_badge','reader_badge','0','4','4','und','0','2'),('reader_badge','reader_badge','0','5','5','und','0','1'),('reader_badge','reader_badge','0','6','6','und','0','1'),('reader_badge','reader_badge','0','7','7','und','0','2'),('reader_badge','reader_badge','0','8','8','und','0','1'),('reader_badge','reader_badge','0','9','9','und','0','1'),('reader_badge','reader_badge','0','10','10','und','0','1'),('reader_badge','reader_badge','0','11','11','und','0','1'),('reader_badge','reader_badge','0','12','12','und','0','1'),('reader_badge','reader_badge','0','13','13','und','0','1'),('reader_badge','reader_badge','0','14','14','und','0','1'),('reader_badge','reader_badge','0','15','15','und','0','1'),('reader_badge','reader_badge','0','16','16','und','0','1'),('reader_badge','reader_badge','0','17','17','und','0','1'),('reader_badge','reader_badge','0','18','18','und','0','1'),('reader_badge','reader_badge','0','19','19','und','0','1');
INSERT INTO `field_data_field_reader_badge` VALUES ('reader_badge','reader_badge','0','20','20','und','0','1'),('reader_badge','reader_badge','0','21','21','und','0','1'),('reader_badge','reader_badge','0','22','22','und','0','1'),('reader_badge','reader_badge','0','23','23','und','0','1'),('reader_badge','reader_badge','0','24','24','und','0','1'),('reader_badge','reader_badge','0','25','25','und','0','1'),('reader_badge','reader_badge','0','26','26','und','0','1'),('reader_badge','reader_badge','0','27','27','und','0','2'),('reader_badge','reader_badge','0','28','28','und','0','3'),('reader_badge','reader_badge','0','29','29','und','0','1'),('reader_badge','reader_badge','0','30','30','und','0','2'),('reader_badge','reader_badge','0','31','31','und','0','3'),('reader_badge','reader_badge','0','32','32','und','0','1'),('reader_badge','reader_badge','0','33','33','und','0','2'),('reader_badge','reader_badge','0','34','34','und','0','3'),('reader_badge','reader_badge','0','38','38','und','0','1'),('reader_badge','reader_badge','0','39','39','und','0','2'),('reader_badge','reader_badge','0','40','40','und','0','3'),('reader_badge','reader_badge','0','41','41','und','0','1'),('reader_badge','reader_badge','0','42','42','und','0','2'),('reader_badge','reader_badge','0','43','43','und','0','3'),('reader_badge','reader_badge','0','44','44','und','0','14'),('reader_badge','reader_badge','0','45','45','und','0','14'),('reader_badge','reader_badge','0','47','47','und','0','1'),('reader_badge','reader_badge','0','48','48','und','0','14'),('reader_badge','reader_badge','0','49','49','und','0','5'),('reader_badge','reader_badge','0','50','50','und','0','14'),('reader_badge','reader_badge','0','51','51','und','0','5'),('reader_badge','reader_badge','0','52','52','und','0','14'),('reader_badge','reader_badge','0','53','53','und','0','1');
INSERT INTO `field_data_field_reader_badge` VALUES ('reader_badge','reader_badge','0','54','54','und','0','14'),('reader_badge','reader_badge','0','59','59','und','0','1'),('reader_badge','reader_badge','0','60','60','und','0','14'),('reader_badge','reader_badge','0','61','61','und','0','1'),('reader_badge','reader_badge','0','62','62','und','0','1'),('reader_badge','reader_badge','0','63','63','und','0','1'),('reader_badge','reader_badge','0','82','82','und','0','1'),('reader_badge','reader_badge','0','83','83','und','0','2'),('reader_badge','reader_badge','0','84','84','und','0','3'),('reader_badge','reader_badge','0','85','85','und','0','1'),('reader_badge','reader_badge','0','86','86','und','0','2'),('reader_badge','reader_badge','0','87','87','und','0','3'),('reader_badge','reader_badge','0','88','88','und','0','1'),('reader_badge','reader_badge','0','89','89','und','0','2'),('reader_badge','reader_badge','0','90','90','und','0','3'),('reader_badge','reader_badge','0','91','91','und','0','1'),('reader_badge','reader_badge','0','92','92','und','0','1'),('reader_badge','reader_badge','0','93','93','und','0','2'),('reader_badge','reader_badge','0','94','94','und','0','3'),('reader_badge','reader_badge','0','95','95','und','0','1'),('reader_badge','reader_badge','0','96','96','und','0','1'),('reader_badge','reader_badge','0','97','97','und','0','14'),('reader_badge','reader_badge','0','98','98','und','0','14'),('reader_badge','reader_badge','0','99','99','und','0','14'),('reader_badge','reader_badge','0','100','100','und','0','14'),('reader_badge','reader_badge','0','101','101','und','0','14'),('reader_badge','reader_badge','0','102','102','und','0','2'),('reader_badge','reader_badge','0','103','103','und','0','3');
DROP TABLE IF EXISTS `field_data_field_reader_school`;
CREATE TABLE `field_data_field_reader_school` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_reader_school_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_reader_school_target_id` (`field_reader_school_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 73 (field_reader_school)';
DROP TABLE IF EXISTS `field_data_field_readers`;
CREATE TABLE `field_data_field_readers` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_readers_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_readers_target_id` (`field_readers_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 46 (field_readers)';
INSERT INTO `field_data_field_readers` VALUES ('activity_log','activity_log','0','1','1','und','0','93'),('activity_log','activity_log','0','2','2','und','0','93'),('activity_log','activity_log','0','3','3','und','0','93'),('activity_log','activity_log','0','4','4','und','0','93'),('activity_log','activity_log','0','5','5','und','0','90'),('activity_log','activity_log','0','6','6','und','0','90'),('activity_log','activity_log','0','7','7','und','0','90'),('activity_log','activity_log','0','8','8','und','0','90'),('activity_log','activity_log','0','9','9','und','0','102'),('activity_log','activity_log','0','10','10','und','0','102'),('activity_log','activity_log','0','11','11','und','0','102'),('activity_log','activity_log','0','12','12','und','0','102'),('activity_log','activity_log','0','13','13','und','0','102'),('activity_log','activity_log','0','14','14','und','0','103'),('activity_log','activity_log','0','15','15','und','0','105'),('activity_log','activity_log','0','16','16','und','0','105'),('activity_log','activity_log','0','17','17','und','0','105'),('activity_log','activity_log','0','18','18','und','0','105'),('activity_log','activity_log','0','19','19','und','0','105'),('activity_log','activity_log','0','20','20','und','0','106'),('activity_log','activity_log','0','21','21','und','0','106'),('activity_log','activity_log','0','22','22','und','0','106'),('activity_log','activity_log','0','23','23','und','0','106'),('activity_log','activity_log','0','24','24','und','0','106'),('activity_log','activity_log','0','25','25','und','0','106'),('activity_log','activity_log','0','26','26','und','0','103'),('activity_log','activity_log','0','27','27','und','0','107'),('activity_log','activity_log','0','28','28','und','0','107'),('activity_log','activity_log','0','29','29','und','0','107'),('activity_log','activity_log','0','30','30','und','0','107');
INSERT INTO `field_data_field_readers` VALUES ('activity_log','activity_log','0','31','31','und','0','107'),('activity_log','activity_log','0','32','32','und','0','120'),('activity_log','activity_log','0','33','33','und','0','120'),('activity_log','activity_log','0','34','34','und','0','120'),('activity_log','activity_log','0','35','35','und','0','120'),('activity_log','activity_log','0','36','36','und','0','120'),('activity_log','activity_log','0','37','37','und','0','120'),('points','points','0','5','5','und','0','65'),('points','points','0','6','6','und','0','66'),('points','points','0','7','7','und','0','67'),('points','points','0','8','8','und','0','65'),('points','points','0','9','9','und','0','65'),('points','points','0','10','10','und','0','65'),('points','points','0','11','11','und','0','68'),('points','points','0','12','12','und','0','66'),('points','points','0','13','13','und','0','71'),('points','points','0','14','14','und','0','71'),('points','points','0','15','15','und','0','72'),('points','points','0','16','16','und','0','73'),('points','points','0','17','17','und','0','73'),('points','points','0','18','18','und','0','73'),('points','points','0','19','19','und','0','74'),('points','points','0','20','20','und','0','75'),('points','points','0','21','21','und','0','75'),('points','points','0','22','22','und','0','73'),('points','points','0','23','23','und','0','75'),('points','points','0','24','24','und','0','75'),('points','points','0','25','25','und','0','75'),('points','points','0','26','26','und','0','75'),('points','points','0','27','27','und','0','82');
INSERT INTO `field_data_field_readers` VALUES ('points','points','0','28','28','und','0','82'),('points','points','0','29','29','und','0','83'),('points','points','0','30','30','und','0','83'),('points','points','0','31','31','und','0','84'),('points','points','0','32','32','und','0','85'),('points','points','0','33','33','und','0','85'),('points','points','0','34','34','und','0','86'),('points','points','0','35','35','und','0','88'),('points','points','0','36','36','und','0','88'),('points','points','0','37','37','und','0','89'),('points','points','0','38','38','und','0','89'),('points','points','0','39','39','und','0','90'),('points','points','0','40','40','und','0','91'),('points','points','0','41','41','und','0','91'),('points','points','0','42','42','und','0','92'),('points','points','0','43','43','und','0','93'),('points','points','0','51','51','und','0','97'),('points','points','0','52','52','und','0','97'),('points','points','0','53','53','und','0','98'),('points','points','0','54','54','und','0','98'),('points','points','0','55','55','und','0','99'),('points','points','0','56','56','und','0','99'),('points','points','0','57','57','und','0','100'),('points','points','0','58','58','und','0','100'),('points','points','0','59','59','und','0','100'),('points','points','0','60','60','und','0','100'),('points','points','0','61','61','und','0','100'),('points','points','0','63','63','und','0','93'),('points','points','0','64','64','und','0','93'),('points','points','0','65','65','und','0','93');
INSERT INTO `field_data_field_readers` VALUES ('points','points','0','66','66','und','0','93'),('points','points','0','67','67','und','0','90'),('points','points','0','68','68','und','0','90'),('points','points','0','69','69','und','0','90'),('points','points','0','70','70','und','0','90'),('points','points','0','71','71','und','0','102'),('points','points','0','72','72','und','0','102'),('points','points','0','73','73','und','0','102'),('points','points','0','74','74','und','0','102'),('points','points','0','75','75','und','0','102'),('points','points','0','85','85','und','0','106'),('points','points','0','86','86','und','0','106'),('points','points','0','87','87','und','0','106'),('points','points','0','88','88','und','0','106'),('points','points','0','89','89','und','0','106'),('points','points','0','90','90','und','0','106'),('points','points','0','91','91','und','0','106'),('points','points','0','92','92','und','0','106'),('points','points','0','93','93','und','0','107'),('points','points','0','94','94','und','0','107'),('points','points','0','95','95','und','0','107'),('points','points','0','96','96','und','0','107'),('points','points','0','97','97','und','0','107'),('points','points','0','113','113','und','0','114'),('points','points','0','114','114','und','0','115'),('points','points','0','115','115','und','0','116'),('points','points','0','116','116','und','0','118'),('points','points','0','117','117','und','0','107'),('points','points','0','118','118','und','0','107'),('points','points','0','119','119','und','0','107');
INSERT INTO `field_data_field_readers` VALUES ('points','points','0','120','120','und','0','107'),('points','points','0','121','121','und','0','107'),('points','points','0','122','122','und','0','120'),('points','points','0','123','123','und','0','120'),('points','points','0','124','124','und','0','120'),('points','points','0','125','125','und','0','120'),('points','points','0','126','126','und','0','120'),('points','points','0','127','127','und','0','120'),('points','points','0','128','128','und','0','120'),('reader_badge','reader_badge','0','4','4','und','0','65'),('reader_badge','reader_badge','0','5','5','und','0','68'),('reader_badge','reader_badge','0','6','6','und','0','69'),('reader_badge','reader_badge','0','7','7','und','0','68'),('reader_badge','reader_badge','0','8','8','und','0','70'),('reader_badge','reader_badge','0','9','9','und','0','71'),('reader_badge','reader_badge','0','10','10','und','0','73'),('reader_badge','reader_badge','0','11','11','und','0','74'),('reader_badge','reader_badge','0','12','12','und','0','76'),('reader_badge','reader_badge','0','13','13','und','0','77'),('reader_badge','reader_badge','0','14','14','und','0','78'),('reader_badge','reader_badge','0','15','15','und','0','79'),('reader_badge','reader_badge','0','16','16','und','0','81'),('reader_badge','reader_badge','0','17','17','und','0','82'),('reader_badge','reader_badge','0','18','18','und','0','83'),('reader_badge','reader_badge','0','19','19','und','0','84'),('reader_badge','reader_badge','0','20','20','und','0','85'),('reader_badge','reader_badge','0','21','21','und','0','86'),('reader_badge','reader_badge','0','22','22','und','0','87'),('reader_badge','reader_badge','0','23','23','und','0','88'),('reader_badge','reader_badge','0','24','24','und','0','89');
INSERT INTO `field_data_field_readers` VALUES ('reader_badge','reader_badge','0','25','25','und','0','90'),('reader_badge','reader_badge','0','26','26','und','0','91'),('reader_badge','reader_badge','0','27','27','und','0','91'),('reader_badge','reader_badge','0','28','28','und','0','91'),('reader_badge','reader_badge','0','29','29','und','0','92'),('reader_badge','reader_badge','0','30','30','und','0','92'),('reader_badge','reader_badge','0','31','31','und','0','92'),('reader_badge','reader_badge','0','32','32','und','0','93'),('reader_badge','reader_badge','0','33','33','und','0','93'),('reader_badge','reader_badge','0','34','34','und','0','93'),('reader_badge','reader_badge','0','38','38','und','0','97'),('reader_badge','reader_badge','0','39','39','und','0','97'),('reader_badge','reader_badge','0','40','40','und','0','97'),('reader_badge','reader_badge','0','41','41','und','0','98'),('reader_badge','reader_badge','0','42','42','und','0','98'),('reader_badge','reader_badge','0','43','43','und','0','98'),('reader_badge','reader_badge','0','44','44','und','0','99'),('reader_badge','reader_badge','0','45','45','und','0','100'),('reader_badge','reader_badge','0','47','47','und','0','101'),('reader_badge','reader_badge','0','48','48','und','0','93'),('reader_badge','reader_badge','0','49','49','und','0','93'),('reader_badge','reader_badge','0','50','50','und','0','90'),('reader_badge','reader_badge','0','51','51','und','0','90'),('reader_badge','reader_badge','0','52','52','und','0','90'),('reader_badge','reader_badge','0','53','53','und','0','102'),('reader_badge','reader_badge','0','54','54','und','0','102'),('reader_badge','reader_badge','0','59','59','und','0','106'),('reader_badge','reader_badge','0','60','60','und','0','106'),('reader_badge','reader_badge','0','61','61','und','0','106'),('reader_badge','reader_badge','0','62','62','und','0','107');
INSERT INTO `field_data_field_readers` VALUES ('reader_badge','reader_badge','0','63','63','und','0','107'),('reader_badge','reader_badge','0','82','82','und','0','114'),('reader_badge','reader_badge','0','83','83','und','0','114'),('reader_badge','reader_badge','0','84','84','und','0','114'),('reader_badge','reader_badge','0','85','85','und','0','115'),('reader_badge','reader_badge','0','86','86','und','0','115'),('reader_badge','reader_badge','0','87','87','und','0','115'),('reader_badge','reader_badge','0','88','88','und','0','116'),('reader_badge','reader_badge','0','89','89','und','0','116'),('reader_badge','reader_badge','0','90','90','und','0','116'),('reader_badge','reader_badge','0','91','91','und','0','117'),('reader_badge','reader_badge','0','92','92','und','0','118'),('reader_badge','reader_badge','0','93','93','und','0','118'),('reader_badge','reader_badge','0','94','94','und','0','118'),('reader_badge','reader_badge','0','95','95','und','0','119'),('reader_badge','reader_badge','0','96','96','und','0','120'),('reader_badge','reader_badge','0','97','97','und','0','107'),('reader_badge','reader_badge','0','98','98','und','0','120'),('reader_badge','reader_badge','0','99','99','und','0','120'),('reader_badge','reader_badge','0','100','100','und','0','120'),('reader_badge','reader_badge','0','101','101','und','0','120'),('reader_badge','reader_badge','0','102','102','und','0','120'),('reader_badge','reader_badge','0','103','103','und','0','120'),('reading_log','reading_log','0','57','57','und','0','100'),('reading_log','reading_log','0','58','58','und','0','104'),('reading_log','reading_log','0','59','59','und','0','104'),('reading_log','reading_log','0','60','60','und','0','103'),('reading_log','reading_log','0','61','61','und','0','106'),('reading_log','reading_log','0','62','62','und','0','106'),('reading_log','reading_log','0','63','63','und','0','107');
INSERT INTO `field_data_field_readers` VALUES ('reading_log','reading_log','0','64','64','und','0','107'),('reading_log','reading_log','0','65','65','und','0','107'),('reading_log','reading_log','0','66','66','und','0','107'),('reading_log','reading_log','0','67','67','und','0','107'),('reading_log','reading_log','0','68','68','und','0','108'),('reading_log','reading_log','0','69','69','und','0','108'),('reading_log','reading_log','0','70','70','und','0','108'),('reading_log','reading_log','0','71','71','und','0','108'),('reading_log','reading_log','0','72','72','und','0','108'),('reading_log','reading_log','0','73','73','und','0','108'),('reading_log','reading_log','0','74','74','und','0','108'),('reading_log','reading_log','0','75','75','und','0','108'),('reading_log','reading_log','0','76','76','und','0','108'),('reading_log','reading_log','0','82','82','und','0','114'),('reading_log','reading_log','0','83','83','und','0','115'),('reading_log','reading_log','0','84','84','und','0','116'),('reading_log','reading_log','0','85','85','und','0','118'),('reading_log','reading_log','0','86','86','und','0','120');
DROP TABLE IF EXISTS `field_data_field_reading_log_reference`;
CREATE TABLE `field_data_field_reading_log_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_reading_log_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_reading_log_reference_target_id` (`field_reading_log_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 78 (field_reading_log_reference)';
INSERT INTO `field_data_field_reading_log_reference` VALUES ('points','points','0','5','5','und','0','1'),('points','points','0','6','6','und','0','2'),('points','points','0','7','7','und','0','3'),('points','points','0','8','8','und','0','4'),('points','points','0','9','9','und','0','5'),('points','points','0','10','10','und','0','6'),('points','points','0','11','11','und','0','7'),('points','points','0','12','12','und','0','8'),('points','points','0','13','13','und','0','9'),('points','points','0','14','14','und','0','10'),('points','points','0','15','15','und','0','11'),('points','points','0','16','16','und','0','12'),('points','points','0','17','17','und','0','13'),('points','points','0','18','18','und','0','14'),('points','points','0','19','19','und','0','15'),('points','points','0','20','20','und','0','16'),('points','points','0','21','21','und','0','17'),('points','points','0','22','22','und','0','18'),('points','points','0','23','23','und','0','19'),('points','points','0','24','24','und','0','20'),('points','points','0','25','25','und','0','21'),('points','points','0','26','26','und','0','22'),('points','points','0','27','27','und','0','23'),('points','points','0','28','28','und','0','24'),('points','points','0','29','29','und','0','25'),('points','points','0','30','30','und','0','26'),('points','points','0','31','31','und','0','27'),('points','points','0','32','32','und','0','28'),('points','points','0','33','33','und','0','29'),('points','points','0','34','34','und','0','30');
INSERT INTO `field_data_field_reading_log_reference` VALUES ('points','points','0','35','35','und','0','31'),('points','points','0','36','36','und','0','32'),('points','points','0','37','37','und','0','33'),('points','points','0','38','38','und','0','34'),('points','points','0','39','39','und','0','35'),('points','points','0','40','40','und','0','36'),('points','points','0','41','41','und','0','37'),('points','points','0','42','42','und','0','38'),('points','points','0','43','43','und','0','39'),('points','points','0','51','51','und','0','47'),('points','points','0','52','52','und','0','48'),('points','points','0','53','53','und','0','49'),('points','points','0','54','54','und','0','50'),('points','points','0','55','55','und','0','51'),('points','points','0','56','56','und','0','52'),('points','points','0','57','57','und','0','53'),('points','points','0','58','58','und','0','54'),('points','points','0','59','59','und','0','55'),('points','points','0','60','60','und','0','56'),('points','points','0','61','61','und','0','57'),('points','points','0','91','91','und','0','61'),('points','points','0','92','92','und','0','62'),('points','points','0','93','93','und','0','63'),('points','points','0','94','94','und','0','64'),('points','points','0','95','95','und','0','65'),('points','points','0','96','96','und','0','66'),('points','points','0','97','97','und','0','67'),('points','points','0','113','113','und','0','82'),('points','points','0','114','114','und','0','83'),('points','points','0','115','115','und','0','84');
INSERT INTO `field_data_field_reading_log_reference` VALUES ('points','points','0','116','116','und','0','85'),('points','points','0','128','128','und','0','86');
DROP TABLE IF EXISTS `field_data_field_recommended_max_age`;
CREATE TABLE `field_data_field_recommended_max_age` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_recommended_max_age_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 11 (field_recommended_max_age)';
DROP TABLE IF EXISTS `field_data_field_recommended_min_age`;
CREATE TABLE `field_data_field_recommended_min_age` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_recommended_min_age_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 10 (field_recommended_min_age)';
DROP TABLE IF EXISTS `field_data_field_school_address_`;
CREATE TABLE `field_data_field_school_address_` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_school_address__value` longtext,   `field_school_address__format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_school_address__format` (`field_school_address__format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 71 (field_school_address_)';
DROP TABLE IF EXISTS `field_data_field_scoring_type`;
CREATE TABLE `field_data_field_scoring_type` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_scoring_type_value` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_scoring_type_value` (`field_scoring_type_value`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 12 (field_scoring_type)';
INSERT INTO `field_data_field_scoring_type` VALUES ('program','program','0','14','14','und','0','Points Per Unit');
DROP TABLE IF EXISTS `field_data_field_secret_code_reference`;
CREATE TABLE `field_data_field_secret_code_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_secret_code_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_secret_code_reference_target_id` (`field_secret_code_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 104 (field_secret_code_reference)';
INSERT INTO `field_data_field_secret_code_reference` VALUES ('activity_log','activity_log','0','3','3','und','0','3'),('activity_log','activity_log','0','7','7','und','0','3');
DROP TABLE IF EXISTS `field_data_field_stars`;
CREATE TABLE `field_data_field_stars` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_stars_value` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_stars_value` (`field_stars_value`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 58 (field_stars)';
INSERT INTO `field_data_field_stars` VALUES ('reading_log','reading_log','0','58','58','und','0','Three'),('reading_log','reading_log','0','59','59','und','0','Two'),('reading_log','reading_log','0','82','82','und','0','Two'),('reading_log','reading_log','0','83','83','und','0','Two'),('reading_log','reading_log','0','84','84','und','0','Two'),('reading_log','reading_log','0','85','85','und','0','Two'),('reading_log','reading_log','0','86','86','und','0','Two');
DROP TABLE IF EXISTS `field_data_field_status`;
CREATE TABLE `field_data_field_status` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_status_value` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_status_value` (`field_status_value`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 76 (field_status)';
DROP TABLE IF EXISTS `field_data_field_tags`;
CREATE TABLE `field_data_field_tags` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_tags_tid` int(10) unsigned DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_tags_tid` (`field_tags_tid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 3 (field_tags)';
DROP TABLE IF EXISTS `field_data_field_ticket_id`;
CREATE TABLE `field_data_field_ticket_id` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_ticket_id_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 61 (field_ticket_id)';
DROP TABLE IF EXISTS `field_data_field_ticket_status`;
CREATE TABLE `field_data_field_ticket_status` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_ticket_status_value` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_ticket_status_value` (`field_ticket_status_value`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 95 (field_ticket_status)';
DROP TABLE IF EXISTS `field_data_field_unit_type`;
CREATE TABLE `field_data_field_unit_type` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_unit_type_value` varchar(255) DEFAULT NULL,   `field_unit_type_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_unit_type_format` (`field_unit_type_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 52 (field_unit_type)';
INSERT INTO `field_data_field_unit_type` VALUES ('reading_log','reading_log','0','57','57','und','0','20-minute period',null),('reading_log','reading_log','0','58','58','und','0','Points Per Book',null),('reading_log','reading_log','0','59','59','und','0','Points Per Book',null),('reading_log','reading_log','0','60','60','und','0','Points Per Book',null),('reading_log','reading_log','0','61','61','und','0','Points Per Book',null),('reading_log','reading_log','0','62','62','und','0','Points Per Book',null),('reading_log','reading_log','0','63','63','und','0','Points Per Book',null),('reading_log','reading_log','0','64','64','und','0','Points Per Book',null),('reading_log','reading_log','0','65','65','und','0','Points Per Book',null),('reading_log','reading_log','0','66','66','und','0','Points Per Book',null),('reading_log','reading_log','0','67','67','und','0','Points Per Book',null),('reading_log','reading_log','0','68','68','und','0','Points Per Book',null),('reading_log','reading_log','0','69','69','und','0','Points Per Book',null),('reading_log','reading_log','0','70','70','und','0','Points Per Book',null),('reading_log','reading_log','0','71','71','und','0','Points Per Book',null),('reading_log','reading_log','0','72','72','und','0','Points Per Book',null),('reading_log','reading_log','0','73','73','und','0','Points Per Book',null),('reading_log','reading_log','0','74','74','und','0','Points Per Book',null),('reading_log','reading_log','0','75','75','und','0','Points Per Book',null),('reading_log','reading_log','0','76','76','und','0','Points Per Book',null),('reading_log','reading_log','0','82','82','und','0','Minute',null),('reading_log','reading_log','0','83','83','und','0','Minute',null),('reading_log','reading_log','0','84','84','und','0','Minute',null),('reading_log','reading_log','0','85','85','und','0','Minute',null),('reading_log','reading_log','0','86','86','und','0','Minute',null);
DROP TABLE IF EXISTS `field_data_field_units_completed`;
CREATE TABLE `field_data_field_units_completed` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_units_completed_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 51 (field_units_completed)';
INSERT INTO `field_data_field_units_completed` VALUES ('reading_log','reading_log','0','57','57','und','0','20'),('reading_log','reading_log','0','58','58','und','0','1'),('reading_log','reading_log','0','59','59','und','0','1'),('reading_log','reading_log','0','60','60','und','0','1'),('reading_log','reading_log','0','61','61','und','0','1'),('reading_log','reading_log','0','62','62','und','0','1'),('reading_log','reading_log','0','63','63','und','0','1'),('reading_log','reading_log','0','64','64','und','0','1'),('reading_log','reading_log','0','65','65','und','0','1'),('reading_log','reading_log','0','66','66','und','0','1'),('reading_log','reading_log','0','67','67','und','0','1'),('reading_log','reading_log','0','68','68','und','0','1'),('reading_log','reading_log','0','69','69','und','0','1'),('reading_log','reading_log','0','70','70','und','0','1'),('reading_log','reading_log','0','71','71','und','0','1'),('reading_log','reading_log','0','72','72','und','0','1'),('reading_log','reading_log','0','73','73','und','0','1'),('reading_log','reading_log','0','74','74','und','0','1'),('reading_log','reading_log','0','75','75','und','0','1'),('reading_log','reading_log','0','76','76','und','0','1'),('reading_log','reading_log','0','82','82','und','0','22'),('reading_log','reading_log','0','83','83','und','0','22'),('reading_log','reading_log','0','84','84','und','0','22'),('reading_log','reading_log','0','85','85','und','0','11'),('reading_log','reading_log','0','86','86','und','0','22');
DROP TABLE IF EXISTS `field_group`;
CREATE TABLE `field_group` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a group',   `identifier` varchar(255) NOT NULL DEFAULT '' COMMENT 'The unique string identifier for a group.',   `group_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The name of this group.',   `entity_type` varchar(32) NOT NULL DEFAULT '',   `bundle` varchar(128) NOT NULL DEFAULT '',   `mode` varchar(128) NOT NULL DEFAULT '',   `parent_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The parent name for a group',   `data` longblob NOT NULL COMMENT 'Serialized data containing the group properties that do not warrant a dedicated column.',   PRIMARY KEY (`id`),   UNIQUE KEY `identifier` (`identifier`),   KEY `group_name` (`group_name`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table that contains field group entries and settings.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `field_revision_body`;
CREATE TABLE `field_revision_body` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `body_value` longtext,   `body_summary` longtext,   `body_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `body_format` (`body_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 2 (body)';
INSERT INTO `field_revision_body` VALUES ('node','page','0','18','18','und','0','<p>CUSTOMIZE THIS PAGE TO DESCRIBE YOUR PROGRAMS</p>','','filtered_html'),('node','article','0','19','19','und','0','By using this website, I agree to the following terms and conditions: * I am at least 13 years old, or I am a parent/legal guardian creating an account for my child under 13 years old.',null,'plain_text');
DROP TABLE IF EXISTS `field_revision_comment_body`;
CREATE TABLE `field_revision_comment_body` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `comment_body_value` longtext,   `comment_body_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `comment_body_format` (`comment_body_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 1 (comment_body)';
DROP TABLE IF EXISTS `field_revision_field_account_family_notes`;
CREATE TABLE `field_revision_field_account_family_notes` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_account_family_notes_value` longtext,   `field_account_family_notes_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_account_family_notes_format` (`field_account_family_notes_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 98 (field_account...';
DROP TABLE IF EXISTS `field_revision_field_activity_code`;
CREATE TABLE `field_revision_field_activity_code` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_code_value` varchar(255) DEFAULT NULL,   `field_activity_code_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_activity_code_format` (`field_activity_code_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 106 (field_activity_code)';
DROP TABLE IF EXISTS `field_revision_field_activity_description`;
CREATE TABLE `field_revision_field_activity_description` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_description_value` longtext,   `field_activity_description_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_activity_description_format` (`field_activity_description_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 100 (field_activity...';
DROP TABLE IF EXISTS `field_revision_field_activity_log_description`;
CREATE TABLE `field_revision_field_activity_log_description` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_log_description_value` longtext,   `field_activity_log_description_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_activity_log_description_format` (`field_activity_log_description_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 80 (field_activity_log...';
INSERT INTO `field_revision_field_activity_log_description` VALUES ('activity_log_reference','activity_log_reference','0','1','1','und','0','testing activity log',null),('activity_log_reference','activity_log_reference','0','2','2','und','0','testing activity log',null);
DROP TABLE IF EXISTS `field_revision_field_activity_log_reference`;
CREATE TABLE `field_revision_field_activity_log_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_log_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_activity_log_reference_target_id` (`field_activity_log_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 82 (field_activity_log...';
DROP TABLE IF EXISTS `field_revision_field_activity_log_title`;
CREATE TABLE `field_revision_field_activity_log_title` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_log_title_value` varchar(255) DEFAULT NULL,   `field_activity_log_title_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_activity_log_title_format` (`field_activity_log_title_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 79 (field_activity_log...';
INSERT INTO `field_revision_field_activity_log_title` VALUES ('activity_log_reference','activity_log_reference','0','1','1','und','0','test',null),('activity_log_reference','activity_log_reference','0','2','2','und','0','activity 2',null);
DROP TABLE IF EXISTS `field_revision_field_activity_points`;
CREATE TABLE `field_revision_field_activity_points` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_points_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 102 (field_activity...';
DROP TABLE IF EXISTS `field_revision_field_activity_reference`;
CREATE TABLE `field_revision_field_activity_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_activity_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_activity_reference_target_id` (`field_activity_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 103 (field_activity...';
INSERT INTO `field_revision_field_activity_reference` VALUES ('activity_log','activity_log','0','1','1','und','0','1'),('activity_log','activity_log','0','2','2','und','0','2'),('activity_log','activity_log','0','4','4','und','0','2'),('activity_log','activity_log','0','5','5','und','0','2'),('activity_log','activity_log','0','6','6','und','0','1'),('activity_log','activity_log','0','8','8','und','0','1'),('activity_log','activity_log','0','9','9','und','0','1'),('activity_log','activity_log','0','10','10','und','0','4'),('activity_log','activity_log','0','11','11','und','0','6'),('activity_log','activity_log','0','12','12','und','0','7'),('activity_log','activity_log','0','13','13','und','0','6'),('activity_log','activity_log','0','14','14','und','0','2'),('activity_log','activity_log','0','15','15','und','0','1'),('activity_log','activity_log','0','16','16','und','0','2'),('activity_log','activity_log','0','17','17','und','0','4'),('activity_log','activity_log','0','18','18','und','0','5'),('activity_log','activity_log','0','19','19','und','0','6'),('activity_log','activity_log','0','20','20','und','0','1'),('activity_log','activity_log','0','21','21','und','0','2'),('activity_log','activity_log','0','22','22','und','0','4'),('activity_log','activity_log','0','23','23','und','0','5'),('activity_log','activity_log','0','24','24','und','0','4'),('activity_log','activity_log','0','25','25','und','0','5'),('activity_log','activity_log','0','26','26','und','0','8'),('activity_log','activity_log','0','27','27','und','0','1'),('activity_log','activity_log','0','28','28','und','0','2'),('activity_log','activity_log','0','29','29','und','0','4'),('activity_log','activity_log','0','30','30','und','0','5'),('activity_log','activity_log','0','31','31','und','0','6'),('activity_log','activity_log','0','32','32','und','0','1');
INSERT INTO `field_revision_field_activity_reference` VALUES ('activity_log','activity_log','0','33','33','und','0','1'),('activity_log','activity_log','0','34','34','und','0','1'),('activity_log','activity_log','0','35','35','und','0','1'),('activity_log','activity_log','0','36','36','und','0','2'),('activity_log','activity_log','0','37','37','und','0','4');
DROP TABLE IF EXISTS `field_revision_field_age`;
CREATE TABLE `field_revision_field_age` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_age_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 34 (field_age)';
DROP TABLE IF EXISTS `field_revision_field_author`;
CREATE TABLE `field_revision_field_author` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_author_value` varchar(255) DEFAULT NULL,   `field_author_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_author_format` (`field_author_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 57 (field_author)';
INSERT INTO `field_revision_field_author` VALUES ('reading_log','reading_log','0','57','57','und','0','red ',null),('reading_log','reading_log','0','58','58','und','0','',null),('reading_log','reading_log','0','59','59','und','0','',null),('reading_log','reading_log','0','60','60','und','0','',null),('reading_log','reading_log','0','61','61','und','0','',null),('reading_log','reading_log','0','62','62','und','0','',null),('reading_log','reading_log','0','63','63','und','0','',null),('reading_log','reading_log','0','64','64','und','0','',null),('reading_log','reading_log','0','65','65','und','0','',null),('reading_log','reading_log','0','66','66','und','0','',null),('reading_log','reading_log','0','67','67','und','0','',null),('reading_log','reading_log','0','68','68','und','0','',null),('reading_log','reading_log','0','69','69','und','0','',null),('reading_log','reading_log','0','70','70','und','0','',null),('reading_log','reading_log','0','71','71','und','0','',null),('reading_log','reading_log','0','72','72','und','0','',null),('reading_log','reading_log','0','73','73','und','0','',null),('reading_log','reading_log','0','74','74','und','0','',null),('reading_log','reading_log','0','75','75','und','0','',null),('reading_log','reading_log','0','76','76','und','0','',null),('reading_log','reading_log','0','82','82','und','0','22',null),('reading_log','reading_log','0','83','83','und','0','time',null),('reading_log','reading_log','0','84','84','und','0','33',null),('reading_log','reading_log','0','85','85','und','0','22',null),('reading_log','reading_log','0','86','86','und','0','22',null);
DROP TABLE IF EXISTS `field_revision_field_badge`;
CREATE TABLE `field_revision_field_badge` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_badge_tid` int(10) unsigned DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_badge_tid` (`field_badge_tid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 60 (field_badge)';
DROP TABLE IF EXISTS `field_revision_field_badge_description`;
CREATE TABLE `field_revision_field_badge_description` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_badge_description_value` longtext,   `field_badge_description_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_badge_description_format` (`field_badge_description_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 75 (field_badge...';
DROP TABLE IF EXISTS `field_revision_field_badge_image`;
CREATE TABLE `field_revision_field_badge_image` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_badge_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',   `field_badge_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',   `field_badge_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',   `field_badge_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',   `field_badge_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_badge_image_fid` (`field_badge_image_fid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 55 (field_badge_image)';
INSERT INTO `field_revision_field_badge_image` VALUES ('taxonomy_term','badge','0','1','1','und','0','2','','','169','169'),('taxonomy_term','badge','0','4','4','und','0','1','','','295','295'),('taxonomy_term','badge','0','10','10','und','0','4',null,null,'303','469'),('taxonomy_term','badge','0','11','11','und','0','6','','','276','375');
DROP TABLE IF EXISTS `field_revision_field_badge_message`;
CREATE TABLE `field_revision_field_badge_message` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_badge_message_value` varchar(255) DEFAULT NULL,   `field_badge_message_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_badge_message_format` (`field_badge_message_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 96 (field_badge_message)';
INSERT INTO `field_revision_field_badge_message` VALUES ('reader_badge','reader_badge','0','27','27','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','28','28','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','30','30','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','31','31','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','33','33','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','34','34','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','39','39','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','40','40','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','42','42','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','43','43','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','44','44','und','0','test',null),('reader_badge','reader_badge','0','45','45','und','0','test',null),('reader_badge','reader_badge','0','48','48','und','0','test',null),('reader_badge','reader_badge','0','49','49','und','0','Congratulations you earned the kangaroo badge!!',null),('reader_badge','reader_badge','0','50','50','und','0','test',null),('reader_badge','reader_badge','0','51','51','und','0','Congratulations you earned the kangaroo badge!!',null),('reader_badge','reader_badge','0','52','52','und','0','test',null),('reader_badge','reader_badge','0','54','54','und','0','test',null),('reader_badge','reader_badge','0','60','60','und','0','test',null),('reader_badge','reader_badge','0','61','61','und','0','Congratulations you earned badge #1!!',null),('reader_badge','reader_badge','0','63','63','und','0','Congratulations you earned badge #1!!',null),('reader_badge','reader_badge','0','83','83','und','0','Congratulations you earned the christmas badge!!',null);
INSERT INTO `field_revision_field_badge_message` VALUES ('reader_badge','reader_badge','0','84','84','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','86','86','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','87','87','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','89','89','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','90','90','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','93','93','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','94','94','und','0','Congratulations you earned the happy face badge!!',null),('reader_badge','reader_badge','0','97','97','und','0','test',null),('reader_badge','reader_badge','0','98','98','und','0','test',null),('reader_badge','reader_badge','0','99','99','und','0','test',null),('reader_badge','reader_badge','0','100','100','und','0','test',null),('reader_badge','reader_badge','0','101','101','und','0','test',null),('reader_badge','reader_badge','0','102','102','und','0','Congratulations you earned the christmas badge!!',null),('reader_badge','reader_badge','0','103','103','und','0','Congratulations you earned the happy face badge!!',null);
DROP TABLE IF EXISTS `field_revision_field_bl_b_author`;
CREATE TABLE `field_revision_field_bl_b_author` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_bl_b_author_value` varchar(255) DEFAULT NULL,   `field_bl_b_author_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_bl_b_author_format` (`field_bl_b_author_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 109 (field_bl_b_author)';
DROP TABLE IF EXISTS `field_revision_field_bl_b_image`;
CREATE TABLE `field_revision_field_bl_b_image` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_bl_b_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',   `field_bl_b_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',   `field_bl_b_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',   `field_bl_b_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',   `field_bl_b_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_bl_b_image_fid` (`field_bl_b_image_fid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 110 (field_bl_b_image)';
DROP TABLE IF EXISTS `field_revision_field_bl_b_link`;
CREATE TABLE `field_revision_field_bl_b_link` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_bl_b_link_url` varchar(2048) DEFAULT NULL,   `field_bl_b_link_title` varchar(255) DEFAULT NULL,   `field_bl_b_link_attributes` mediumtext,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 111 (field_bl_b_link)';
DROP TABLE IF EXISTS `field_revision_field_bl_b_title`;
CREATE TABLE `field_revision_field_bl_b_title` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_bl_b_title_value` varchar(255) DEFAULT NULL,   `field_bl_b_title_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_bl_b_title_format` (`field_bl_b_title_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 112 (field_bl_b_title)';
DROP TABLE IF EXISTS `field_revision_field_book_title`;
CREATE TABLE `field_revision_field_book_title` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_book_title_value` varchar(255) DEFAULT NULL,   `field_book_title_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_book_title_format` (`field_book_title_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 50 (field_book_title)';
INSERT INTO `field_revision_field_book_title` VALUES ('reading_log','reading_log','0','57','57','und','0','how many points do i need ',null),('reading_log','reading_log','0','58','58','und','0','1984',null),('reading_log','reading_log','0','59','59','und','0','Brave New World',null),('reading_log','reading_log','0','60','60','und','0','1984',null),('reading_log','reading_log','0','61','61','und','0','',null),('reading_log','reading_log','0','62','62','und','0','',null),('reading_log','reading_log','0','63','63','und','0','',null),('reading_log','reading_log','0','64','64','und','0','',null),('reading_log','reading_log','0','65','65','und','0','',null),('reading_log','reading_log','0','66','66','und','0','',null),('reading_log','reading_log','0','67','67','und','0','',null),('reading_log','reading_log','0','68','68','und','0','1984',null),('reading_log','reading_log','0','69','69','und','0','99',null),('reading_log','reading_log','0','70','70','und','0','',null),('reading_log','reading_log','0','71','71','und','0','99',null),('reading_log','reading_log','0','72','72','und','0','99',null),('reading_log','reading_log','0','73','73','und','0','99',null),('reading_log','reading_log','0','74','74','und','0','99',null),('reading_log','reading_log','0','75','75','und','0','99',null),('reading_log','reading_log','0','76','76','und','0','77',null),('reading_log','reading_log','0','82','82','und','0','fava',null),('reading_log','reading_log','0','83','83','und','0','Tacos',null),('reading_log','reading_log','0','84','84','und','0','fava',null),('reading_log','reading_log','0','85','85','und','0','awesome possume',null),('reading_log','reading_log','0','86','86','und','0','fava',null);
DROP TABLE IF EXISTS `field_revision_field_booklist_books`;
CREATE TABLE `field_revision_field_booklist_books` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_booklist_books_value` int(11) DEFAULT NULL COMMENT 'The field collection item id.',   `field_booklist_books_revision_id` int(11) DEFAULT NULL COMMENT 'The field collection item revision id.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_booklist_books_revision_id` (`field_booklist_books_revision_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 113 (field_booklist...';
DROP TABLE IF EXISTS `field_revision_field_branch_address`;
CREATE TABLE `field_revision_field_branch_address` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_branch_address_country` varchar(2) DEFAULT '' COMMENT 'Two letter ISO country code of this address.',   `field_branch_address_administrative_area` varchar(255) DEFAULT '' COMMENT 'The administrative area of this address. (i.e. State/Province)',   `field_branch_address_sub_administrative_area` varchar(255) DEFAULT '' COMMENT 'The sub administrative area of this address.',   `field_branch_address_locality` varchar(255) DEFAULT '' COMMENT 'The locality of this address. (i.e. City)',   `field_branch_address_dependent_locality` varchar(255) DEFAULT '' COMMENT 'The dependent locality of this address.',   `field_branch_address_postal_code` varchar(255) DEFAULT '' COMMENT 'The postal code of this address.',   `field_branch_address_thoroughfare` varchar(255) DEFAULT '' COMMENT 'The thoroughfare of this address. (i.e. Street address)',   `field_branch_address_premise` varchar(255) DEFAULT '' COMMENT 'The premise of this address. (i.e. Apartment / Suite number)',   `field_branch_address_sub_premise` varchar(255) DEFAULT '' COMMENT 'The sub_premise of this address.',   `field_branch_address_organisation_name` varchar(255) DEFAULT '' COMMENT 'Contents of a primary OrganisationName element in the xNL XML.',   `field_branch_address_name_line` varchar(255) DEFAULT '' COMMENT 'Contents of a primary NameLine element in the xNL XML.',   `field_branch_address_first_name` varchar(255) DEFAULT '' COMMENT 'Contents of the FirstName element of a primary PersonName element in the xNL XML.',   `field_branch_address_last_name` varchar(255) DEFAULT '' COMMENT 'Contents of the LastName element of a primary PersonName element in the xNL XML.',   `field_branch_address_data` longtext COMMENT 'Additional data for this address.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 8 (field_branch_address)';
DROP TABLE IF EXISTS `field_revision_field_branch_phone`;
CREATE TABLE `field_revision_field_branch_phone` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_branch_phone_value` varchar(255) DEFAULT NULL,   `field_branch_phone_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_branch_phone_format` (`field_branch_phone_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 7 (field_branch_phone)';
DROP TABLE IF EXISTS `field_revision_field_claimed_activities`;
CREATE TABLE `field_revision_field_claimed_activities` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_claimed_activities_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_claimed_activities_target_id` (`field_claimed_activities_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 105 (field_claimed...';
DROP TABLE IF EXISTS `field_revision_field_current_drawing_tickets`;
CREATE TABLE `field_revision_field_current_drawing_tickets` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_drawing_tickets_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_current_drawing_tickets_target_id` (`field_current_drawing_tickets_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 94 (field_current...';
DROP TABLE IF EXISTS `field_revision_field_current_level`;
CREATE TABLE `field_revision_field_current_level` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_level_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_current_level_target_id` (`field_current_level_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 90 (field_current_level)';
DROP TABLE IF EXISTS `field_revision_field_current_points`;
CREATE TABLE `field_revision_field_current_points` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_points_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 89 (field_current_points)';
DROP TABLE IF EXISTS `field_revision_field_current_program`;
CREATE TABLE `field_revision_field_current_program` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_program_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_current_program_target_id` (`field_current_program_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 91 (field_current...';
DROP TABLE IF EXISTS `field_revision_field_current_reader`;
CREATE TABLE `field_revision_field_current_reader` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_reader_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_current_reader_target_id` (`field_current_reader_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 54 (field_current_reader)';
DROP TABLE IF EXISTS `field_revision_field_current_reader_badge`;
CREATE TABLE `field_revision_field_current_reader_badge` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_reader_badge_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_current_reader_badge_target_id` (`field_current_reader_badge_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 92 (field_current...';
DROP TABLE IF EXISTS `field_revision_field_current_reader_prizes`;
CREATE TABLE `field_revision_field_current_reader_prizes` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_current_reader_prizes_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_current_reader_prizes_target_id` (`field_current_reader_prizes_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 93 (field_current...';
DROP TABLE IF EXISTS `field_revision_field_date`;
CREATE TABLE `field_revision_field_date` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_date_value` datetime DEFAULT NULL,   `field_date_value2` datetime DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 107 (field_date)';
DROP TABLE IF EXISTS `field_revision_field_drawing_tickets`;
CREATE TABLE `field_revision_field_drawing_tickets` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_drawing_tickets_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 86 (field_drawing...';
DROP TABLE IF EXISTS `field_revision_field_favorite_branch`;
CREATE TABLE `field_revision_field_favorite_branch` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_favorite_branch_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_favorite_branch_target_id` (`field_favorite_branch_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 30 (field_favorite...';
DROP TABLE IF EXISTS `field_revision_field_first_name`;
CREATE TABLE `field_revision_field_first_name` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_first_name_value` varchar(255) DEFAULT NULL,   `field_first_name_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_first_name_format` (`field_first_name_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 28 (field_first_name)';
INSERT INTO `field_revision_field_first_name` VALUES ('user','user','0','1','1','und','0','admin',null);
DROP TABLE IF EXISTS `field_revision_field_grade`;
CREATE TABLE `field_revision_field_grade` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_grade_value` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_grade_value` (`field_grade_value`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 35 (field_grade)';
DROP TABLE IF EXISTS `field_revision_field_image`;
CREATE TABLE `field_revision_field_image` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',   `field_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',   `field_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',   `field_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',   `field_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_image_fid` (`field_image_fid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 4 (field_image)';
DROP TABLE IF EXISTS `field_revision_field_last_name`;
CREATE TABLE `field_revision_field_last_name` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_last_name_value` varchar(255) DEFAULT NULL,   `field_last_name_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_last_name_format` (`field_last_name_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 29 (field_last_name)';
INSERT INTO `field_revision_field_last_name` VALUES ('user','user','0','1','1','und','0','admin',null);
DROP TABLE IF EXISTS `field_revision_field_level`;
CREATE TABLE `field_revision_field_level` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_level_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_level_target_id` (`field_level_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 39 (field_level)';
DROP TABLE IF EXISTS `field_revision_field_level_message`;
CREATE TABLE `field_revision_field_level_message` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_level_message_value` longtext,   `field_level_message_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_level_message_format` (`field_level_message_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 22 (field_level_message)';
INSERT INTO `field_revision_field_level_message` VALUES ('level','level','0','31','31','und','0','This is the auto-generated beginning level. You may edit any of these details later',null);
DROP TABLE IF EXISTS `field_revision_field_level_number`;
CREATE TABLE `field_revision_field_level_number` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_level_number_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 19 (field_level_number)';
INSERT INTO `field_revision_field_level_number` VALUES ('level','level','0','31','31','und','0','1');
DROP TABLE IF EXISTS `field_revision_field_library_card`;
CREATE TABLE `field_revision_field_library_card` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_library_card_value` varchar(255) DEFAULT NULL,   `field_library_card_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_library_card_format` (`field_library_card_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 97 (field_library_card)';
INSERT INTO `field_revision_field_library_card` VALUES ('user','user','0','1','1','und','0','000',null);
DROP TABLE IF EXISTS `field_revision_field_message`;
CREATE TABLE `field_revision_field_message` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_message_value` varchar(255) DEFAULT NULL,   `field_message_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_message_format` (`field_message_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 87 (field_message)';
DROP TABLE IF EXISTS `field_revision_field_parent_uid`;
CREATE TABLE `field_revision_field_parent_uid` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_parent_uid_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_parent_uid_target_id` (`field_parent_uid_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 48 (field_parent_uid)';
DROP TABLE IF EXISTS `field_revision_field_per_unit_label`;
CREATE TABLE `field_revision_field_per_unit_label` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_per_unit_label_value` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_per_unit_label_value` (`field_per_unit_label_value`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 65 (field_per_unit_label)';
INSERT INTO `field_revision_field_per_unit_label` VALUES ('program','program','0','14','14','und','0','Book');
DROP TABLE IF EXISTS `field_revision_field_per_unit_point_value`;
CREATE TABLE `field_revision_field_per_unit_point_value` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_per_unit_point_value_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 15 (field_per_unit...';
INSERT INTO `field_revision_field_per_unit_point_value` VALUES ('program','program','0','14','14','und','0','100');
DROP TABLE IF EXISTS `field_revision_field_phone_number`;
CREATE TABLE `field_revision_field_phone_number` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_phone_number_value` varchar(255) DEFAULT NULL,   `field_phone_number_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_phone_number_format` (`field_phone_number_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 108 (field_phone_number)';
DROP TABLE IF EXISTS `field_revision_field_point_threshold`;
CREATE TABLE `field_revision_field_point_threshold` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_point_threshold_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 20 (field_point...';
INSERT INTO `field_revision_field_point_threshold` VALUES ('level','level','0','31','31','und','0','0');
DROP TABLE IF EXISTS `field_revision_field_points`;
CREATE TABLE `field_revision_field_points` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_points_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 77 (field_points)';
INSERT INTO `field_revision_field_points` VALUES ('points','points','0','5','5','und','0','100000'),('points','points','0','6','6','und','0','13'),('points','points','0','7','7','und','0','100'),('points','points','0','8','8','und','0','220'),('points','points','0','9','9','und','0','220'),('points','points','0','10','10','und','0','220'),('points','points','0','11','11','und','0','110'),('points','points','0','12','12','und','0','13'),('points','points','0','13','13','und','0','13'),('points','points','0','14','14','und','0','13'),('points','points','0','15','15','und','0','8'),('points','points','0','16','16','und','0','20'),('points','points','0','17','17','und','0','20'),('points','points','0','18','18','und','0','20'),('points','points','0','19','19','und','0','20'),('points','points','0','20','20','und','0','10'),('points','points','0','21','21','und','0','1'),('points','points','0','22','22','und','0','20'),('points','points','0','23','23','und','0','5'),('points','points','0','24','24','und','0','4'),('points','points','0','25','25','und','0','4'),('points','points','0','26','26','und','0','10'),('points','points','0','27','27','und','0','1000'),('points','points','0','28','28','und','0','100'),('points','points','0','29','29','und','0','110'),('points','points','0','30','30','und','0','9990'),('points','points','0','31','31','und','0','13'),('points','points','0','32','32','und','0','110'),('points','points','0','33','33','und','0','550'),('points','points','0','34','34','und','0','10000');
INSERT INTO `field_revision_field_points` VALUES ('points','points','0','35','35','und','0','1000'),('points','points','0','36','36','und','0','1000'),('points','points','0','37','37','und','0','330'),('points','points','0','38','38','und','0','1110'),('points','points','0','39','39','und','0','220'),('points','points','0','40','40','und','0','1000'),('points','points','0','41','41','und','0','120'),('points','points','0','42','42','und','0','1440'),('points','points','0','43','43','und','0','100'),('points','points','0','51','51','und','0','1780'),('points','points','0','52','52','und','0','10'),('points','points','0','53','53','und','0','10'),('points','points','0','54','54','und','0','100'),('points','points','0','55','55','und','0','114'),('points','points','0','56','56','und','0','60'),('points','points','0','57','57','und','0','28'),('points','points','0','58','58','und','0','30'),('points','points','0','59','59','und','0','30'),('points','points','0','60','60','und','0','30'),('points','points','0','61','61','und','0','40'),('points','points','0','63','63','und','0','10'),('points','points','0','64','64','und','0','20'),('points','points','0','65','65','und','0','10'),('points','points','0','66','66','und','0','20'),('points','points','0','67','67','und','0','20'),('points','points','0','68','68','und','0','10'),('points','points','0','69','69','und','0','10'),('points','points','0','70','70','und','0','10'),('points','points','0','71','71','und','0','10'),('points','points','0','72','72','und','0','10');
INSERT INTO `field_revision_field_points` VALUES ('points','points','0','73','73','und','0','10'),('points','points','0','74','74','und','0','10'),('points','points','0','75','75','und','0','10'),('points','points','0','85','85','und','0','10'),('points','points','0','86','86','und','0','20'),('points','points','0','87','87','und','0','10'),('points','points','0','88','88','und','0','10'),('points','points','0','89','89','und','0','10'),('points','points','0','90','90','und','0','10'),('points','points','0','91','91','und','0','20'),('points','points','0','92','92','und','0','20'),('points','points','0','93','93','und','0','20'),('points','points','0','94','94','und','0','20'),('points','points','0','95','95','und','0','20'),('points','points','0','96','96','und','0','20'),('points','points','0','97','97','und','0','20'),('points','points','0','113','113','und','0','220'),('points','points','0','114','114','und','0','220'),('points','points','0','115','115','und','0','220'),('points','points','0','116','116','und','0','110'),('points','points','0','117','117','und','0','10'),('points','points','0','118','118','und','0','20'),('points','points','0','119','119','und','0','10'),('points','points','0','120','120','und','0','10'),('points','points','0','121','121','und','0','10'),('points','points','0','122','122','und','0','10'),('points','points','0','123','123','und','0','10'),('points','points','0','124','124','und','0','10'),('points','points','0','125','125','und','0','10'),('points','points','0','126','126','und','0','20');
INSERT INTO `field_revision_field_points` VALUES ('points','points','0','127','127','und','0','10'),('points','points','0','128','128','und','0','220');
DROP TABLE IF EXISTS `field_revision_field_points_earned`;
CREATE TABLE `field_revision_field_points_earned` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_points_earned_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 53 (field_points_earned)';
INSERT INTO `field_revision_field_points_earned` VALUES ('activity_log','activity_log','0','1','1','und','0','10'),('activity_log','activity_log','0','2','2','und','0','20'),('activity_log','activity_log','0','3','3','und','0','10'),('activity_log','activity_log','0','4','4','und','0','20'),('activity_log','activity_log','0','5','5','und','0','20'),('activity_log','activity_log','0','6','6','und','0','10'),('activity_log','activity_log','0','7','7','und','0','10'),('activity_log','activity_log','0','8','8','und','0','10'),('activity_log','activity_log','0','9','9','und','0','10'),('activity_log','activity_log','0','10','10','und','0','10'),('activity_log','activity_log','0','11','11','und','0','10'),('activity_log','activity_log','0','12','12','und','0','10'),('activity_log','activity_log','0','13','13','und','0','10'),('activity_log','activity_log','0','14','14','und','0','20'),('activity_log','activity_log','0','15','15','und','0','10'),('activity_log','activity_log','0','16','16','und','0','20'),('activity_log','activity_log','0','17','17','und','0','10'),('activity_log','activity_log','0','18','18','und','0','10'),('activity_log','activity_log','0','19','19','und','0','10'),('activity_log','activity_log','0','20','20','und','0','10'),('activity_log','activity_log','0','21','21','und','0','20'),('activity_log','activity_log','0','22','22','und','0','10'),('activity_log','activity_log','0','23','23','und','0','10'),('activity_log','activity_log','0','24','24','und','0','10'),('activity_log','activity_log','0','25','25','und','0','10'),('activity_log','activity_log','0','26','26','und','0','50'),('activity_log','activity_log','0','27','27','und','0','10'),('activity_log','activity_log','0','28','28','und','0','20'),('activity_log','activity_log','0','29','29','und','0','10'),('activity_log','activity_log','0','30','30','und','0','10');
INSERT INTO `field_revision_field_points_earned` VALUES ('activity_log','activity_log','0','31','31','und','0','10'),('activity_log','activity_log','0','32','32','und','0','10'),('activity_log','activity_log','0','33','33','und','0','10'),('activity_log','activity_log','0','34','34','und','0','10'),('activity_log','activity_log','0','35','35','und','0','10'),('activity_log','activity_log','0','36','36','und','0','20'),('activity_log','activity_log','0','37','37','und','0','10');
DROP TABLE IF EXISTS `field_revision_field_points_reference`;
CREATE TABLE `field_revision_field_points_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_points_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_points_reference_target_id` (`field_points_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 81 (field_points...';
INSERT INTO `field_revision_field_points_reference` VALUES ('activity_log_reference','activity_log_reference','0','1','1','und','0','2'),('activity_log_reference','activity_log_reference','0','2','2','und','0','3'),('reading_log','reading_log','0','57','57','und','0','61'),('reading_log','reading_log','0','58','58','und','0','76'),('reading_log','reading_log','0','59','59','und','0','77'),('reading_log','reading_log','0','60','60','und','0','78'),('reading_log','reading_log','0','61','61','und','0','91'),('reading_log','reading_log','0','62','62','und','0','92'),('reading_log','reading_log','0','63','63','und','0','93'),('reading_log','reading_log','0','64','64','und','0','94'),('reading_log','reading_log','0','65','65','und','0','95'),('reading_log','reading_log','0','66','66','und','0','96'),('reading_log','reading_log','0','67','67','und','0','97'),('reading_log','reading_log','0','68','68','und','0','99'),('reading_log','reading_log','0','69','69','und','0','100'),('reading_log','reading_log','0','70','70','und','0','101'),('reading_log','reading_log','0','71','71','und','0','102'),('reading_log','reading_log','0','72','72','und','0','103'),('reading_log','reading_log','0','73','73','und','0','104'),('reading_log','reading_log','0','74','74','und','0','105'),('reading_log','reading_log','0','75','75','und','0','106'),('reading_log','reading_log','0','76','76','und','0','107'),('reading_log','reading_log','0','82','82','und','0','113'),('reading_log','reading_log','0','83','83','und','0','114'),('reading_log','reading_log','0','84','84','und','0','115'),('reading_log','reading_log','0','85','85','und','0','116'),('reading_log','reading_log','0','86','86','und','0','128');
DROP TABLE IF EXISTS `field_revision_field_prize`;
CREATE TABLE `field_revision_field_prize` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_prize_tid` int(10) unsigned DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_prize_tid` (`field_prize_tid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 59 (field_prize)';
DROP TABLE IF EXISTS `field_revision_field_prize_description`;
CREATE TABLE `field_revision_field_prize_description` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_prize_description_value` longtext,   `field_prize_description_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_prize_description_format` (`field_prize_description_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 64 (field_prize...';
INSERT INTO `field_revision_field_prize_description` VALUES ('prize','prize','0','1','1','und','0','<p>This prize can be claimed at the front desk of your library.</p>','full_html'),('prize','prize','0','2','2','und','0','test',null),('prize','prize','0','4','4','und','0','Guitar Prize.',null),('prize','prize','0','5','5','und','0','test prize ',null),('prize','prize','0','6','6','und','0','more pizza ',null);
DROP TABLE IF EXISTS `field_revision_field_prize_message`;
CREATE TABLE `field_revision_field_prize_message` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_prize_message_value` varchar(255) DEFAULT NULL,   `field_prize_message_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_prize_message_format` (`field_prize_message_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 99 (field_prize_message)';
INSERT INTO `field_revision_field_prize_message` VALUES ('prize','prize','0','1','1','und','0','Congratulations you won a Book Collection!!',null),('prize','prize','0','2','2','und','0','Congratulations you won a NEW prize!!',null),('prize','prize','0','3','3','und','0','Congratulations you won a third prize!!',null),('prize','prize','0','4','4','und','0','You won the guitar prize.',null),('prize','prize','0','5','5','und','0','woo hoo ',null),('prize','prize','0','6','6','und','0','pizza ',null);
DROP TABLE IF EXISTS `field_revision_field_prize_reference`;
CREATE TABLE `field_revision_field_prize_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_prize_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_prize_reference_target_id` (`field_prize_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 83 (field_prize...';
DROP TABLE IF EXISTS `field_revision_field_program`;
CREATE TABLE `field_revision_field_program` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_program_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_program_target_id` (`field_program_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 38 (field_program)';
DROP TABLE IF EXISTS `field_revision_field_program_description`;
CREATE TABLE `field_revision_field_program_description` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_program_description_value` longtext,   `field_program_description_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_program_description_format` (`field_program_description_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 17 (field_program...';
INSERT INTO `field_revision_field_program_description` VALUES ('program','program','0','14','14','und','0','<p>Yo</p>','filtered_html');
DROP TABLE IF EXISTS `field_revision_field_program_reference`;
CREATE TABLE `field_revision_field_program_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_program_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_program_reference_target_id` (`field_program_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 31 (field_program...';
INSERT INTO `field_revision_field_program_reference` VALUES ('level','level','0','31','31','und','0','14'),('points','points','0','5','5','und','0','3'),('points','points','0','6','6','und','0','8'),('points','points','0','7','7','und','0','3'),('points','points','0','8','8','und','0','3'),('points','points','0','9','9','und','0','3'),('points','points','0','10','10','und','0','3'),('points','points','0','11','11','und','0','3'),('points','points','0','12','12','und','0','8'),('points','points','0','13','13','und','0','8'),('points','points','0','14','14','und','0','8'),('points','points','0','15','15','und','0','10'),('points','points','0','16','16','und','0','9'),('points','points','0','17','17','und','0','9'),('points','points','0','18','18','und','0','9'),('points','points','0','19','19','und','0','9'),('points','points','0','20','20','und','0','10'),('points','points','0','21','21','und','0','10'),('points','points','0','22','22','und','0','9'),('points','points','0','23','23','und','0','10'),('points','points','0','24','24','und','0','10'),('points','points','0','25','25','und','0','10'),('points','points','0','26','26','und','0','10'),('points','points','0','27','27','und','0','3'),('points','points','0','28','28','und','0','3'),('points','points','0','29','29','und','0','3'),('points','points','0','30','30','und','0','3'),('points','points','0','31','31','und','0','8'),('points','points','0','32','32','und','0','3'),('points','points','0','33','33','und','0','3');
INSERT INTO `field_revision_field_program_reference` VALUES ('points','points','0','34','34','und','0','3'),('points','points','0','35','35','und','0','3'),('points','points','0','36','36','und','0','3'),('points','points','0','37','37','und','0','3'),('points','points','0','38','38','und','0','3'),('points','points','0','39','39','und','0','3'),('points','points','0','40','40','und','0','3'),('points','points','0','41','41','und','0','3'),('points','points','0','42','42','und','0','3'),('points','points','0','43','43','und','0','3'),('points','points','0','51','51','und','0','3'),('points','points','0','52','52','und','0','3'),('points','points','0','53','53','und','0','3'),('points','points','0','54','54','und','0','3'),('points','points','0','55','55','und','0','12'),('points','points','0','56','56','und','0','12'),('points','points','0','57','57','und','0','13'),('points','points','0','58','58','und','0','13'),('points','points','0','59','59','und','0','13'),('points','points','0','60','60','und','0','13'),('points','points','0','61','61','und','0','13'),('points','points','0','63','63','und','0','3'),('points','points','0','64','64','und','0','3'),('points','points','0','65','65','und','0','3'),('points','points','0','66','66','und','0','3'),('points','points','0','67','67','und','0','3'),('points','points','0','68','68','und','0','3'),('points','points','0','69','69','und','0','3'),('points','points','0','70','70','und','0','3'),('points','points','0','71','71','und','0','3');
INSERT INTO `field_revision_field_program_reference` VALUES ('points','points','0','72','72','und','0','3'),('points','points','0','73','73','und','0','3'),('points','points','0','74','74','und','0','3'),('points','points','0','75','75','und','0','3'),('points','points','0','85','85','und','0','3'),('points','points','0','86','86','und','0','3'),('points','points','0','87','87','und','0','3'),('points','points','0','88','88','und','0','3'),('points','points','0','89','89','und','0','3'),('points','points','0','90','90','und','0','3'),('points','points','0','91','91','und','0','9'),('points','points','0','92','92','und','0','9'),('points','points','0','93','93','und','0','9'),('points','points','0','94','94','und','0','9'),('points','points','0','95','95','und','0','9'),('points','points','0','96','96','und','0','9'),('points','points','0','97','97','und','0','9'),('points','points','0','113','113','und','0','3'),('points','points','0','114','114','und','0','3'),('points','points','0','115','115','und','0','3'),('points','points','0','116','116','und','0','3'),('points','points','0','117','117','und','0','3'),('points','points','0','118','118','und','0','3'),('points','points','0','119','119','und','0','3'),('points','points','0','120','120','und','0','3'),('points','points','0','121','121','und','0','3'),('points','points','0','122','122','und','0','3'),('points','points','0','123','123','und','0','3'),('points','points','0','124','124','und','0','3'),('points','points','0','125','125','und','0','3');
INSERT INTO `field_revision_field_program_reference` VALUES ('points','points','0','126','126','und','0','3'),('points','points','0','127','127','und','0','3'),('points','points','0','128','128','und','0','3'),('prize','prize','0','1','1','und','0','3'),('prize','prize','0','2','2','und','0','3'),('prize','prize','0','3','3','und','0','8'),('prize','prize','0','4','4','und','0','3'),('prize','prize','0','5','5','und','0','11'),('prize','prize','0','6','6','und','0','11'),('reading_log','reading_log','0','57','57','und','0','13'),('reading_log','reading_log','0','58','58','und','0','8'),('reading_log','reading_log','0','59','59','und','0','8'),('reading_log','reading_log','0','60','60','und','0','8'),('reading_log','reading_log','0','61','61','und','0','9'),('reading_log','reading_log','0','62','62','und','0','9'),('reading_log','reading_log','0','63','63','und','0','9'),('reading_log','reading_log','0','64','64','und','0','9'),('reading_log','reading_log','0','65','65','und','0','9'),('reading_log','reading_log','0','66','66','und','0','9'),('reading_log','reading_log','0','67','67','und','0','9'),('reading_log','reading_log','0','68','68','und','0','8'),('reading_log','reading_log','0','69','69','und','0','8'),('reading_log','reading_log','0','70','70','und','0','8'),('reading_log','reading_log','0','71','71','und','0','8'),('reading_log','reading_log','0','72','72','und','0','8'),('reading_log','reading_log','0','73','73','und','0','8'),('reading_log','reading_log','0','74','74','und','0','8'),('reading_log','reading_log','0','75','75','und','0','8'),('reading_log','reading_log','0','76','76','und','0','8'),('reading_log','reading_log','0','82','82','und','0','3');
INSERT INTO `field_revision_field_program_reference` VALUES ('reading_log','reading_log','0','83','83','und','0','3'),('reading_log','reading_log','0','84','84','und','0','3'),('reading_log','reading_log','0','85','85','und','0','3'),('reading_log','reading_log','0','86','86','und','0','3');
DROP TABLE IF EXISTS `field_revision_field_reader_badge`;
CREATE TABLE `field_revision_field_reader_badge` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_reader_badge_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_reader_badge_target_id` (`field_reader_badge_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 85 (field_reader_badge)';
INSERT INTO `field_revision_field_reader_badge` VALUES ('activity_log','activity_log','0','1','1','und','0','14'),('activity_log','activity_log','0','3','3','und','0','5'),('activity_log','activity_log','0','6','6','und','0','14'),('activity_log','activity_log','0','7','7','und','0','5'),('activity_log','activity_log','0','8','8','und','0','14'),('activity_log','activity_log','0','9','9','und','0','14'),('activity_log','activity_log','0','15','15','und','0','14'),('activity_log','activity_log','0','20','20','und','0','14'),('activity_log','activity_log','0','26','26','und','0','1'),('activity_log','activity_log','0','27','27','und','0','14'),('activity_log','activity_log','0','32','32','und','0','14'),('activity_log','activity_log','0','33','33','und','0','14'),('activity_log','activity_log','0','34','34','und','0','14'),('activity_log','activity_log','0','35','35','und','0','14'),('reader_badge','reader_badge','0','4','4','und','0','2'),('reader_badge','reader_badge','0','5','5','und','0','1'),('reader_badge','reader_badge','0','6','6','und','0','1'),('reader_badge','reader_badge','0','7','7','und','0','2'),('reader_badge','reader_badge','0','8','8','und','0','1'),('reader_badge','reader_badge','0','9','9','und','0','1'),('reader_badge','reader_badge','0','10','10','und','0','1'),('reader_badge','reader_badge','0','11','11','und','0','1'),('reader_badge','reader_badge','0','12','12','und','0','1'),('reader_badge','reader_badge','0','13','13','und','0','1'),('reader_badge','reader_badge','0','14','14','und','0','1'),('reader_badge','reader_badge','0','15','15','und','0','1'),('reader_badge','reader_badge','0','16','16','und','0','1'),('reader_badge','reader_badge','0','17','17','und','0','1'),('reader_badge','reader_badge','0','18','18','und','0','1'),('reader_badge','reader_badge','0','19','19','und','0','1');
INSERT INTO `field_revision_field_reader_badge` VALUES ('reader_badge','reader_badge','0','20','20','und','0','1'),('reader_badge','reader_badge','0','21','21','und','0','1'),('reader_badge','reader_badge','0','22','22','und','0','1'),('reader_badge','reader_badge','0','23','23','und','0','1'),('reader_badge','reader_badge','0','24','24','und','0','1'),('reader_badge','reader_badge','0','25','25','und','0','1'),('reader_badge','reader_badge','0','26','26','und','0','1'),('reader_badge','reader_badge','0','27','27','und','0','2'),('reader_badge','reader_badge','0','28','28','und','0','3'),('reader_badge','reader_badge','0','29','29','und','0','1'),('reader_badge','reader_badge','0','30','30','und','0','2'),('reader_badge','reader_badge','0','31','31','und','0','3'),('reader_badge','reader_badge','0','32','32','und','0','1'),('reader_badge','reader_badge','0','33','33','und','0','2'),('reader_badge','reader_badge','0','34','34','und','0','3'),('reader_badge','reader_badge','0','38','38','und','0','1'),('reader_badge','reader_badge','0','39','39','und','0','2'),('reader_badge','reader_badge','0','40','40','und','0','3'),('reader_badge','reader_badge','0','41','41','und','0','1'),('reader_badge','reader_badge','0','42','42','und','0','2'),('reader_badge','reader_badge','0','43','43','und','0','3'),('reader_badge','reader_badge','0','44','44','und','0','14'),('reader_badge','reader_badge','0','45','45','und','0','14'),('reader_badge','reader_badge','0','47','47','und','0','1'),('reader_badge','reader_badge','0','48','48','und','0','14'),('reader_badge','reader_badge','0','49','49','und','0','5'),('reader_badge','reader_badge','0','50','50','und','0','14'),('reader_badge','reader_badge','0','51','51','und','0','5'),('reader_badge','reader_badge','0','52','52','und','0','14'),('reader_badge','reader_badge','0','53','53','und','0','1');
INSERT INTO `field_revision_field_reader_badge` VALUES ('reader_badge','reader_badge','0','54','54','und','0','14'),('reader_badge','reader_badge','0','59','59','und','0','1'),('reader_badge','reader_badge','0','60','60','und','0','14'),('reader_badge','reader_badge','0','61','61','und','0','1'),('reader_badge','reader_badge','0','62','62','und','0','1'),('reader_badge','reader_badge','0','63','63','und','0','1'),('reader_badge','reader_badge','0','82','82','und','0','1'),('reader_badge','reader_badge','0','83','83','und','0','2'),('reader_badge','reader_badge','0','84','84','und','0','3'),('reader_badge','reader_badge','0','85','85','und','0','1'),('reader_badge','reader_badge','0','86','86','und','0','2'),('reader_badge','reader_badge','0','87','87','und','0','3'),('reader_badge','reader_badge','0','88','88','und','0','1'),('reader_badge','reader_badge','0','89','89','und','0','2'),('reader_badge','reader_badge','0','90','90','und','0','3'),('reader_badge','reader_badge','0','91','91','und','0','1'),('reader_badge','reader_badge','0','92','92','und','0','1'),('reader_badge','reader_badge','0','93','93','und','0','2'),('reader_badge','reader_badge','0','94','94','und','0','3'),('reader_badge','reader_badge','0','95','95','und','0','1'),('reader_badge','reader_badge','0','96','96','und','0','1'),('reader_badge','reader_badge','0','97','97','und','0','14'),('reader_badge','reader_badge','0','98','98','und','0','14'),('reader_badge','reader_badge','0','99','99','und','0','14'),('reader_badge','reader_badge','0','100','100','und','0','14'),('reader_badge','reader_badge','0','101','101','und','0','14'),('reader_badge','reader_badge','0','102','102','und','0','2'),('reader_badge','reader_badge','0','103','103','und','0','3');
DROP TABLE IF EXISTS `field_revision_field_reader_school`;
CREATE TABLE `field_revision_field_reader_school` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_reader_school_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_reader_school_target_id` (`field_reader_school_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 73 (field_reader_school)';
DROP TABLE IF EXISTS `field_revision_field_readers`;
CREATE TABLE `field_revision_field_readers` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_readers_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_readers_target_id` (`field_readers_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 46 (field_readers)';
INSERT INTO `field_revision_field_readers` VALUES ('activity_log','activity_log','0','1','1','und','0','93'),('activity_log','activity_log','0','2','2','und','0','93'),('activity_log','activity_log','0','3','3','und','0','93'),('activity_log','activity_log','0','4','4','und','0','93'),('activity_log','activity_log','0','5','5','und','0','90'),('activity_log','activity_log','0','6','6','und','0','90'),('activity_log','activity_log','0','7','7','und','0','90'),('activity_log','activity_log','0','8','8','und','0','90'),('activity_log','activity_log','0','9','9','und','0','102'),('activity_log','activity_log','0','10','10','und','0','102'),('activity_log','activity_log','0','11','11','und','0','102'),('activity_log','activity_log','0','12','12','und','0','102'),('activity_log','activity_log','0','13','13','und','0','102'),('activity_log','activity_log','0','14','14','und','0','103'),('activity_log','activity_log','0','15','15','und','0','105'),('activity_log','activity_log','0','16','16','und','0','105'),('activity_log','activity_log','0','17','17','und','0','105'),('activity_log','activity_log','0','18','18','und','0','105'),('activity_log','activity_log','0','19','19','und','0','105'),('activity_log','activity_log','0','20','20','und','0','106'),('activity_log','activity_log','0','21','21','und','0','106'),('activity_log','activity_log','0','22','22','und','0','106'),('activity_log','activity_log','0','23','23','und','0','106'),('activity_log','activity_log','0','24','24','und','0','106'),('activity_log','activity_log','0','25','25','und','0','106'),('activity_log','activity_log','0','26','26','und','0','103'),('activity_log','activity_log','0','27','27','und','0','107'),('activity_log','activity_log','0','28','28','und','0','107'),('activity_log','activity_log','0','29','29','und','0','107'),('activity_log','activity_log','0','30','30','und','0','107');
INSERT INTO `field_revision_field_readers` VALUES ('activity_log','activity_log','0','31','31','und','0','107'),('activity_log','activity_log','0','32','32','und','0','120'),('activity_log','activity_log','0','33','33','und','0','120'),('activity_log','activity_log','0','34','34','und','0','120'),('activity_log','activity_log','0','35','35','und','0','120'),('activity_log','activity_log','0','36','36','und','0','120'),('activity_log','activity_log','0','37','37','und','0','120'),('points','points','0','5','5','und','0','65'),('points','points','0','6','6','und','0','66'),('points','points','0','7','7','und','0','67'),('points','points','0','8','8','und','0','65'),('points','points','0','9','9','und','0','65'),('points','points','0','10','10','und','0','65'),('points','points','0','11','11','und','0','68'),('points','points','0','12','12','und','0','66'),('points','points','0','13','13','und','0','71'),('points','points','0','14','14','und','0','71'),('points','points','0','15','15','und','0','72'),('points','points','0','16','16','und','0','73'),('points','points','0','17','17','und','0','73'),('points','points','0','18','18','und','0','73'),('points','points','0','19','19','und','0','74'),('points','points','0','20','20','und','0','75'),('points','points','0','21','21','und','0','75'),('points','points','0','22','22','und','0','73'),('points','points','0','23','23','und','0','75'),('points','points','0','24','24','und','0','75'),('points','points','0','25','25','und','0','75'),('points','points','0','26','26','und','0','75'),('points','points','0','27','27','und','0','82');
INSERT INTO `field_revision_field_readers` VALUES ('points','points','0','28','28','und','0','82'),('points','points','0','29','29','und','0','83'),('points','points','0','30','30','und','0','83'),('points','points','0','31','31','und','0','84'),('points','points','0','32','32','und','0','85'),('points','points','0','33','33','und','0','85'),('points','points','0','34','34','und','0','86'),('points','points','0','35','35','und','0','88'),('points','points','0','36','36','und','0','88'),('points','points','0','37','37','und','0','89'),('points','points','0','38','38','und','0','89'),('points','points','0','39','39','und','0','90'),('points','points','0','40','40','und','0','91'),('points','points','0','41','41','und','0','91'),('points','points','0','42','42','und','0','92'),('points','points','0','43','43','und','0','93'),('points','points','0','51','51','und','0','97'),('points','points','0','52','52','und','0','97'),('points','points','0','53','53','und','0','98'),('points','points','0','54','54','und','0','98'),('points','points','0','55','55','und','0','99'),('points','points','0','56','56','und','0','99'),('points','points','0','57','57','und','0','100'),('points','points','0','58','58','und','0','100'),('points','points','0','59','59','und','0','100'),('points','points','0','60','60','und','0','100'),('points','points','0','61','61','und','0','100'),('points','points','0','63','63','und','0','93'),('points','points','0','64','64','und','0','93'),('points','points','0','65','65','und','0','93');
INSERT INTO `field_revision_field_readers` VALUES ('points','points','0','66','66','und','0','93'),('points','points','0','67','67','und','0','90'),('points','points','0','68','68','und','0','90'),('points','points','0','69','69','und','0','90'),('points','points','0','70','70','und','0','90'),('points','points','0','71','71','und','0','102'),('points','points','0','72','72','und','0','102'),('points','points','0','73','73','und','0','102'),('points','points','0','74','74','und','0','102'),('points','points','0','75','75','und','0','102'),('points','points','0','85','85','und','0','106'),('points','points','0','86','86','und','0','106'),('points','points','0','87','87','und','0','106'),('points','points','0','88','88','und','0','106'),('points','points','0','89','89','und','0','106'),('points','points','0','90','90','und','0','106'),('points','points','0','91','91','und','0','106'),('points','points','0','92','92','und','0','106'),('points','points','0','93','93','und','0','107'),('points','points','0','94','94','und','0','107'),('points','points','0','95','95','und','0','107'),('points','points','0','96','96','und','0','107'),('points','points','0','97','97','und','0','107'),('points','points','0','113','113','und','0','114'),('points','points','0','114','114','und','0','115'),('points','points','0','115','115','und','0','116'),('points','points','0','116','116','und','0','118'),('points','points','0','117','117','und','0','107'),('points','points','0','118','118','und','0','107'),('points','points','0','119','119','und','0','107');
INSERT INTO `field_revision_field_readers` VALUES ('points','points','0','120','120','und','0','107'),('points','points','0','121','121','und','0','107'),('points','points','0','122','122','und','0','120'),('points','points','0','123','123','und','0','120'),('points','points','0','124','124','und','0','120'),('points','points','0','125','125','und','0','120'),('points','points','0','126','126','und','0','120'),('points','points','0','127','127','und','0','120'),('points','points','0','128','128','und','0','120'),('reader_badge','reader_badge','0','4','4','und','0','65'),('reader_badge','reader_badge','0','5','5','und','0','68'),('reader_badge','reader_badge','0','6','6','und','0','69'),('reader_badge','reader_badge','0','7','7','und','0','68'),('reader_badge','reader_badge','0','8','8','und','0','70'),('reader_badge','reader_badge','0','9','9','und','0','71'),('reader_badge','reader_badge','0','10','10','und','0','73'),('reader_badge','reader_badge','0','11','11','und','0','74'),('reader_badge','reader_badge','0','12','12','und','0','76'),('reader_badge','reader_badge','0','13','13','und','0','77'),('reader_badge','reader_badge','0','14','14','und','0','78'),('reader_badge','reader_badge','0','15','15','und','0','79'),('reader_badge','reader_badge','0','16','16','und','0','81'),('reader_badge','reader_badge','0','17','17','und','0','82'),('reader_badge','reader_badge','0','18','18','und','0','83'),('reader_badge','reader_badge','0','19','19','und','0','84'),('reader_badge','reader_badge','0','20','20','und','0','85'),('reader_badge','reader_badge','0','21','21','und','0','86'),('reader_badge','reader_badge','0','22','22','und','0','87'),('reader_badge','reader_badge','0','23','23','und','0','88'),('reader_badge','reader_badge','0','24','24','und','0','89');
INSERT INTO `field_revision_field_readers` VALUES ('reader_badge','reader_badge','0','25','25','und','0','90'),('reader_badge','reader_badge','0','26','26','und','0','91'),('reader_badge','reader_badge','0','27','27','und','0','91'),('reader_badge','reader_badge','0','28','28','und','0','91'),('reader_badge','reader_badge','0','29','29','und','0','92'),('reader_badge','reader_badge','0','30','30','und','0','92'),('reader_badge','reader_badge','0','31','31','und','0','92'),('reader_badge','reader_badge','0','32','32','und','0','93'),('reader_badge','reader_badge','0','33','33','und','0','93'),('reader_badge','reader_badge','0','34','34','und','0','93'),('reader_badge','reader_badge','0','38','38','und','0','97'),('reader_badge','reader_badge','0','39','39','und','0','97'),('reader_badge','reader_badge','0','40','40','und','0','97'),('reader_badge','reader_badge','0','41','41','und','0','98'),('reader_badge','reader_badge','0','42','42','und','0','98'),('reader_badge','reader_badge','0','43','43','und','0','98'),('reader_badge','reader_badge','0','44','44','und','0','99'),('reader_badge','reader_badge','0','45','45','und','0','100'),('reader_badge','reader_badge','0','47','47','und','0','101'),('reader_badge','reader_badge','0','48','48','und','0','93'),('reader_badge','reader_badge','0','49','49','und','0','93'),('reader_badge','reader_badge','0','50','50','und','0','90'),('reader_badge','reader_badge','0','51','51','und','0','90'),('reader_badge','reader_badge','0','52','52','und','0','90'),('reader_badge','reader_badge','0','53','53','und','0','102'),('reader_badge','reader_badge','0','54','54','und','0','102'),('reader_badge','reader_badge','0','59','59','und','0','106'),('reader_badge','reader_badge','0','60','60','und','0','106'),('reader_badge','reader_badge','0','61','61','und','0','106'),('reader_badge','reader_badge','0','62','62','und','0','107');
INSERT INTO `field_revision_field_readers` VALUES ('reader_badge','reader_badge','0','63','63','und','0','107'),('reader_badge','reader_badge','0','82','82','und','0','114'),('reader_badge','reader_badge','0','83','83','und','0','114'),('reader_badge','reader_badge','0','84','84','und','0','114'),('reader_badge','reader_badge','0','85','85','und','0','115'),('reader_badge','reader_badge','0','86','86','und','0','115'),('reader_badge','reader_badge','0','87','87','und','0','115'),('reader_badge','reader_badge','0','88','88','und','0','116'),('reader_badge','reader_badge','0','89','89','und','0','116'),('reader_badge','reader_badge','0','90','90','und','0','116'),('reader_badge','reader_badge','0','91','91','und','0','117'),('reader_badge','reader_badge','0','92','92','und','0','118'),('reader_badge','reader_badge','0','93','93','und','0','118'),('reader_badge','reader_badge','0','94','94','und','0','118'),('reader_badge','reader_badge','0','95','95','und','0','119'),('reader_badge','reader_badge','0','96','96','und','0','120'),('reader_badge','reader_badge','0','97','97','und','0','107'),('reader_badge','reader_badge','0','98','98','und','0','120'),('reader_badge','reader_badge','0','99','99','und','0','120'),('reader_badge','reader_badge','0','100','100','und','0','120'),('reader_badge','reader_badge','0','101','101','und','0','120'),('reader_badge','reader_badge','0','102','102','und','0','120'),('reader_badge','reader_badge','0','103','103','und','0','120'),('reading_log','reading_log','0','57','57','und','0','100'),('reading_log','reading_log','0','58','58','und','0','104'),('reading_log','reading_log','0','59','59','und','0','104'),('reading_log','reading_log','0','60','60','und','0','103'),('reading_log','reading_log','0','61','61','und','0','106'),('reading_log','reading_log','0','62','62','und','0','106'),('reading_log','reading_log','0','63','63','und','0','107');
INSERT INTO `field_revision_field_readers` VALUES ('reading_log','reading_log','0','64','64','und','0','107'),('reading_log','reading_log','0','65','65','und','0','107'),('reading_log','reading_log','0','66','66','und','0','107'),('reading_log','reading_log','0','67','67','und','0','107'),('reading_log','reading_log','0','68','68','und','0','108'),('reading_log','reading_log','0','69','69','und','0','108'),('reading_log','reading_log','0','70','70','und','0','108'),('reading_log','reading_log','0','71','71','und','0','108'),('reading_log','reading_log','0','72','72','und','0','108'),('reading_log','reading_log','0','73','73','und','0','108'),('reading_log','reading_log','0','74','74','und','0','108'),('reading_log','reading_log','0','75','75','und','0','108'),('reading_log','reading_log','0','76','76','und','0','108'),('reading_log','reading_log','0','82','82','und','0','114'),('reading_log','reading_log','0','83','83','und','0','115'),('reading_log','reading_log','0','84','84','und','0','116'),('reading_log','reading_log','0','85','85','und','0','118'),('reading_log','reading_log','0','86','86','und','0','120');
DROP TABLE IF EXISTS `field_revision_field_reading_log_reference`;
CREATE TABLE `field_revision_field_reading_log_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_reading_log_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_reading_log_reference_target_id` (`field_reading_log_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 78 (field_reading_log...';
INSERT INTO `field_revision_field_reading_log_reference` VALUES ('points','points','0','5','5','und','0','1'),('points','points','0','6','6','und','0','2'),('points','points','0','7','7','und','0','3'),('points','points','0','8','8','und','0','4'),('points','points','0','9','9','und','0','5'),('points','points','0','10','10','und','0','6'),('points','points','0','11','11','und','0','7'),('points','points','0','12','12','und','0','8'),('points','points','0','13','13','und','0','9'),('points','points','0','14','14','und','0','10'),('points','points','0','15','15','und','0','11'),('points','points','0','16','16','und','0','12'),('points','points','0','17','17','und','0','13'),('points','points','0','18','18','und','0','14'),('points','points','0','19','19','und','0','15'),('points','points','0','20','20','und','0','16'),('points','points','0','21','21','und','0','17'),('points','points','0','22','22','und','0','18'),('points','points','0','23','23','und','0','19'),('points','points','0','24','24','und','0','20'),('points','points','0','25','25','und','0','21'),('points','points','0','26','26','und','0','22'),('points','points','0','27','27','und','0','23'),('points','points','0','28','28','und','0','24'),('points','points','0','29','29','und','0','25'),('points','points','0','30','30','und','0','26'),('points','points','0','31','31','und','0','27'),('points','points','0','32','32','und','0','28'),('points','points','0','33','33','und','0','29'),('points','points','0','34','34','und','0','30');
INSERT INTO `field_revision_field_reading_log_reference` VALUES ('points','points','0','35','35','und','0','31'),('points','points','0','36','36','und','0','32'),('points','points','0','37','37','und','0','33'),('points','points','0','38','38','und','0','34'),('points','points','0','39','39','und','0','35'),('points','points','0','40','40','und','0','36'),('points','points','0','41','41','und','0','37'),('points','points','0','42','42','und','0','38'),('points','points','0','43','43','und','0','39'),('points','points','0','51','51','und','0','47'),('points','points','0','52','52','und','0','48'),('points','points','0','53','53','und','0','49'),('points','points','0','54','54','und','0','50'),('points','points','0','55','55','und','0','51'),('points','points','0','56','56','und','0','52'),('points','points','0','57','57','und','0','53'),('points','points','0','58','58','und','0','54'),('points','points','0','59','59','und','0','55'),('points','points','0','60','60','und','0','56'),('points','points','0','61','61','und','0','57'),('points','points','0','91','91','und','0','61'),('points','points','0','92','92','und','0','62'),('points','points','0','93','93','und','0','63'),('points','points','0','94','94','und','0','64'),('points','points','0','95','95','und','0','65'),('points','points','0','96','96','und','0','66'),('points','points','0','97','97','und','0','67'),('points','points','0','113','113','und','0','82'),('points','points','0','114','114','und','0','83'),('points','points','0','115','115','und','0','84');
INSERT INTO `field_revision_field_reading_log_reference` VALUES ('points','points','0','116','116','und','0','85'),('points','points','0','128','128','und','0','86');
DROP TABLE IF EXISTS `field_revision_field_recommended_max_age`;
CREATE TABLE `field_revision_field_recommended_max_age` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_recommended_max_age_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 11 (field_recommended...';
DROP TABLE IF EXISTS `field_revision_field_recommended_min_age`;
CREATE TABLE `field_revision_field_recommended_min_age` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_recommended_min_age_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 10 (field_recommended...';
DROP TABLE IF EXISTS `field_revision_field_school_address_`;
CREATE TABLE `field_revision_field_school_address_` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_school_address__value` longtext,   `field_school_address__format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_school_address__format` (`field_school_address__format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 71 (field_school...';
DROP TABLE IF EXISTS `field_revision_field_scoring_type`;
CREATE TABLE `field_revision_field_scoring_type` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_scoring_type_value` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_scoring_type_value` (`field_scoring_type_value`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 12 (field_scoring_type)';
INSERT INTO `field_revision_field_scoring_type` VALUES ('program','program','0','14','14','und','0','Points Per Unit');
DROP TABLE IF EXISTS `field_revision_field_secret_code_reference`;
CREATE TABLE `field_revision_field_secret_code_reference` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_secret_code_reference_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_secret_code_reference_target_id` (`field_secret_code_reference_target_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 104 (field_secret_code...';
INSERT INTO `field_revision_field_secret_code_reference` VALUES ('activity_log','activity_log','0','3','3','und','0','3'),('activity_log','activity_log','0','7','7','und','0','3');
DROP TABLE IF EXISTS `field_revision_field_stars`;
CREATE TABLE `field_revision_field_stars` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_stars_value` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_stars_value` (`field_stars_value`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 58 (field_stars)';
INSERT INTO `field_revision_field_stars` VALUES ('reading_log','reading_log','0','58','58','und','0','Three'),('reading_log','reading_log','0','59','59','und','0','Two'),('reading_log','reading_log','0','82','82','und','0','Two'),('reading_log','reading_log','0','83','83','und','0','Two'),('reading_log','reading_log','0','84','84','und','0','Two'),('reading_log','reading_log','0','85','85','und','0','Two'),('reading_log','reading_log','0','86','86','und','0','Two');
DROP TABLE IF EXISTS `field_revision_field_status`;
CREATE TABLE `field_revision_field_status` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_status_value` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_status_value` (`field_status_value`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 76 (field_status)';
DROP TABLE IF EXISTS `field_revision_field_tags`;
CREATE TABLE `field_revision_field_tags` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_tags_tid` int(10) unsigned DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_tags_tid` (`field_tags_tid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 3 (field_tags)';
DROP TABLE IF EXISTS `field_revision_field_ticket_id`;
CREATE TABLE `field_revision_field_ticket_id` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_ticket_id_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 61 (field_ticket_id)';
DROP TABLE IF EXISTS `field_revision_field_ticket_status`;
CREATE TABLE `field_revision_field_ticket_status` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_ticket_status_value` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_ticket_status_value` (`field_ticket_status_value`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 95 (field_ticket_status)';
DROP TABLE IF EXISTS `field_revision_field_unit_type`;
CREATE TABLE `field_revision_field_unit_type` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_unit_type_value` varchar(255) DEFAULT NULL,   `field_unit_type_format` varchar(255) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`),   KEY `field_unit_type_format` (`field_unit_type_format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 52 (field_unit_type)';
INSERT INTO `field_revision_field_unit_type` VALUES ('reading_log','reading_log','0','57','57','und','0','20-minute period',null),('reading_log','reading_log','0','58','58','und','0','Points Per Book',null),('reading_log','reading_log','0','59','59','und','0','Points Per Book',null),('reading_log','reading_log','0','60','60','und','0','Points Per Book',null),('reading_log','reading_log','0','61','61','und','0','Points Per Book',null),('reading_log','reading_log','0','62','62','und','0','Points Per Book',null),('reading_log','reading_log','0','63','63','und','0','Points Per Book',null),('reading_log','reading_log','0','64','64','und','0','Points Per Book',null),('reading_log','reading_log','0','65','65','und','0','Points Per Book',null),('reading_log','reading_log','0','66','66','und','0','Points Per Book',null),('reading_log','reading_log','0','67','67','und','0','Points Per Book',null),('reading_log','reading_log','0','68','68','und','0','Points Per Book',null),('reading_log','reading_log','0','69','69','und','0','Points Per Book',null),('reading_log','reading_log','0','70','70','und','0','Points Per Book',null),('reading_log','reading_log','0','71','71','und','0','Points Per Book',null),('reading_log','reading_log','0','72','72','und','0','Points Per Book',null),('reading_log','reading_log','0','73','73','und','0','Points Per Book',null),('reading_log','reading_log','0','74','74','und','0','Points Per Book',null),('reading_log','reading_log','0','75','75','und','0','Points Per Book',null),('reading_log','reading_log','0','76','76','und','0','Points Per Book',null),('reading_log','reading_log','0','82','82','und','0','Minute',null),('reading_log','reading_log','0','83','83','und','0','Minute',null),('reading_log','reading_log','0','84','84','und','0','Minute',null),('reading_log','reading_log','0','85','85','und','0','Minute',null),('reading_log','reading_log','0','86','86','und','0','Minute',null);
DROP TABLE IF EXISTS `field_revision_field_units_completed`;
CREATE TABLE `field_revision_field_units_completed` (   `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',   `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',   `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',   `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',   `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',   `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',   `field_units_completed_value` int(11) DEFAULT NULL,   PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),   KEY `entity_type` (`entity_type`),   KEY `bundle` (`bundle`),   KEY `deleted` (`deleted`),   KEY `entity_id` (`entity_id`),   KEY `revision_id` (`revision_id`),   KEY `language` (`language`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 51 (field_units...';
INSERT INTO `field_revision_field_units_completed` VALUES ('reading_log','reading_log','0','57','57','und','0','20'),('reading_log','reading_log','0','58','58','und','0','1'),('reading_log','reading_log','0','59','59','und','0','1'),('reading_log','reading_log','0','60','60','und','0','1'),('reading_log','reading_log','0','61','61','und','0','1'),('reading_log','reading_log','0','62','62','und','0','1'),('reading_log','reading_log','0','63','63','und','0','1'),('reading_log','reading_log','0','64','64','und','0','1'),('reading_log','reading_log','0','65','65','und','0','1'),('reading_log','reading_log','0','66','66','und','0','1'),('reading_log','reading_log','0','67','67','und','0','1'),('reading_log','reading_log','0','68','68','und','0','1'),('reading_log','reading_log','0','69','69','und','0','1'),('reading_log','reading_log','0','70','70','und','0','1'),('reading_log','reading_log','0','71','71','und','0','1'),('reading_log','reading_log','0','72','72','und','0','1'),('reading_log','reading_log','0','73','73','und','0','1'),('reading_log','reading_log','0','74','74','und','0','1'),('reading_log','reading_log','0','75','75','und','0','1'),('reading_log','reading_log','0','76','76','und','0','1'),('reading_log','reading_log','0','82','82','und','0','22'),('reading_log','reading_log','0','83','83','und','0','22'),('reading_log','reading_log','0','84','84','und','0','22'),('reading_log','reading_log','0','85','85','und','0','11'),('reading_log','reading_log','0','86','86','und','0','22');
DROP TABLE IF EXISTS `file_managed`;
CREATE TABLE `file_managed` (   `fid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'File ID.',   `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who is associated with the file.',   `filename` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the file with no path components. This may differ from the basename of the URI if the file is renamed to avoid overwriting an existing file.',   `uri` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT 'The URI to access the file (either local or remote).',   `filemime` varchar(255) NOT NULL DEFAULT '' COMMENT 'The file’s MIME type.',   `filesize` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'The size of the file in bytes.',   `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A field indicating the status of the file. Two status are defined in core: temporary (0) and permanent (1). Temporary files older than DRUPAL_MAXIMUM_TEMP_FILE_AGE will be removed during a cron run.',   `timestamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'UNIX timestamp for when the file was added.',   PRIMARY KEY (`fid`),   UNIQUE KEY `uri` (`uri`),   KEY `uid` (`uid`),   KEY `status` (`status`),   KEY `timestamp` (`timestamp`) ) ENGINE=InnoDB AUTO_INCREMENT=23 DEFAULT CHARSET=utf8 COMMENT='Stores information for uploaded files.' AUTO_INCREMENT=23;
INSERT INTO `file_managed` VALUES ('1','1','b898.001.png','public://b898.001.png','image/png','135437','1','1477662787'),('2','1','badge.png','public://badge.png','image/png','13246','1','1477664340'),('3','0','','','','0','1','1478194864'),('4','25','2_3.jpg','public://files/2_3.jpg','image/jpeg','110135','1','1478206183'),('6','42','tumblr_ndpdpsFfue1rltf5co1_400.jpg','public://tumblr_ndpdpsFfue1rltf5co1_400.jpg','image/jpeg','95836','1','1478793315'),('7','53','4576.jpg','public://4576.jpg','image/jpeg','16413','1','1481300594'),('8','53','4525.jpg','public://4525.jpg','image/jpeg','18925','1','1481300626'),('9','62','smiley_test.png','public://smiley_test.png','image/png','3424','1','1484624096'),('11','62','example_image.png','public://example_image.png','image/png','12924','1','1484624145'),('12','62','kangaroo_1.png','public://kangaroo_1.png','image/png','72705','1','1484624171'),('13','62','kangaroo_2.png','public://kangaroo_2.png','image/png','109721','1','1484624335'),('14','62','peanut.jpg','public://peanut.jpg','image/jpeg','2402737','1','1484624373'),('15','62','Punkin.png','public://Punkin.png','image/png','158587','1','1484624407'),('16','62','feedback_icon.png','public://feedback_icon.png','image/png','4612','1','1484624447'),('17','62','cryptozoo.jpg','public://cryptozoo.jpg','image/jpeg','192167','1','1484624550'),('18','62','airplanegoodluck.jpg','public://airplanegoodluck.jpg','image/jpeg','28163','1','1484624632'),('19','62','cool_story_bro.jpg','public://cool_story_bro.jpg','image/jpeg','55765','1','1484624720'),('20','71','pow.jpg','public://pow.jpg','image/jpeg','10343','1','1487606489'),('21','71','images.jpeg','public://images.jpeg','image/jpeg','4546','1','1487606530'),('22','1','Screen Shot 2017-04-17 at 23.31.37 .png','public://Screen Shot 2017-04-17 at 23.31.37 .png','image/png','59337','1','1492490507');
DROP TABLE IF EXISTS `file_usage`;
CREATE TABLE `file_usage` (   `fid` int(10) unsigned NOT NULL COMMENT 'File ID.',   `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the module that is using the file.',   `type` varchar(64) NOT NULL DEFAULT '' COMMENT 'The name of the object type in which the file is used.',   `id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The primary key of the object using the file.',   `count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The number of times this file is used by this object.',   PRIMARY KEY (`fid`,`type`,`id`,`module`),   KEY `type_id` (`type`,`id`),   KEY `fid_count` (`fid`,`count`),   KEY `fid_module` (`fid`,`module`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Track where a file is used.';
INSERT INTO `file_usage` VALUES ('1','file','taxonomy_term','4','1'),('2','file','taxonomy_term','1','1'),('4','file','taxonomy_term','10','1'),('6','file','taxonomy_term','11','1'),('22','imce','file','22','1');
DROP TABLE IF EXISTS `filter`;
CREATE TABLE `filter` (   `format` varchar(255) NOT NULL COMMENT 'Foreign key: The filter_format.format to which this filter is assigned.',   `module` varchar(64) NOT NULL DEFAULT '' COMMENT 'The origin module of the filter.',   `name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Name of the filter being referenced.',   `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of filter within format.',   `status` int(11) NOT NULL DEFAULT '0' COMMENT 'Filter enabled status. (1 = enabled, 0 = disabled)',   `settings` longblob COMMENT 'A serialized array of name value pairs that store the filter settings for the specific format.',   PRIMARY KEY (`format`,`name`),   KEY `list` (`weight`,`module`,`name`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table that maps filters (HTML corrector) to text formats ...';
INSERT INTO `filter` VALUES ('filtered_html','filter','filter_autop','2','1','a:0:{}'),('filtered_html','filter','filter_html','1','1','a:3:{s:12:"allowed_html";s:83:"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd> <p> <br>";s:16:"filter_html_help";i:1;s:20:"filter_html_nofollow";i:0;}'),('filtered_html','filter','filter_htmlcorrector','10','1','a:0:{}'),('filtered_html','filter','filter_html_escape','-10','0','a:0:{}'),('filtered_html','filter','filter_url','0','1','a:1:{s:17:"filter_url_length";s:2:"72";}'),('filtered_html','php','php_code','0','0','a:0:{}'),('full_html','filter','filter_autop','1','1','a:0:{}'),('full_html','filter','filter_html','-10','0','a:3:{s:12:"allowed_html";s:74:"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>";s:16:"filter_html_help";i:1;s:20:"filter_html_nofollow";i:0;}'),('full_html','filter','filter_htmlcorrector','10','1','a:0:{}'),('full_html','filter','filter_html_escape','-10','0','a:0:{}'),('full_html','filter','filter_url','0','1','a:1:{s:17:"filter_url_length";s:2:"72";}'),('full_html','php','php_code','0','0','a:0:{}'),('php_code','filter','filter_autop','0','0','a:0:{}'),('php_code','filter','filter_html','-10','0','a:3:{s:12:"allowed_html";s:74:"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>";s:16:"filter_html_help";i:1;s:20:"filter_html_nofollow";i:0;}'),('php_code','filter','filter_htmlcorrector','10','0','a:0:{}'),('php_code','filter','filter_html_escape','-10','0','a:0:{}'),('php_code','filter','filter_url','0','0','a:1:{s:17:"filter_url_length";i:72;}'),('php_code','php','php_code','0','1','a:0:{}'),('plain_text','filter','filter_autop','2','1','a:0:{}'),('plain_text','filter','filter_html','-10','0','a:3:{s:12:"allowed_html";s:74:"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>";s:16:"filter_html_help";i:1;s:20:"filter_html_nofollow";i:0;}'),('plain_text','filter','filter_htmlcorrector','10','0','a:0:{}'),('plain_text','filter','filter_html_escape','0','1','a:0:{}'),('plain_text','filter','filter_url','1','1','a:1:{s:17:"filter_url_length";i:72;}');
DROP TABLE IF EXISTS `filter_format`;
CREATE TABLE `filter_format` (   `format` varchar(255) NOT NULL COMMENT 'Primary Key: Unique machine name of the format.',   `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the text format (Filtered HTML).',   `cache` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate whether format is cacheable. (1 = cacheable, 0 = not cacheable)',   `status` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'The status of the text format. (1 = enabled, 0 = disabled)',   `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of text format to use when listing.',   PRIMARY KEY (`format`),   UNIQUE KEY `name` (`name`),   KEY `status_weight` (`status`,`weight`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores text formats: custom groupings of filters, such as...';
INSERT INTO `filter_format` VALUES ('filtered_html','Filtered HTML','1','1','0'),('full_html','Full HTML','1','1','1'),('php_code','PHP code','0','1','11'),('plain_text','Plain text','1','1','10');
DROP TABLE IF EXISTS `flood`;
CREATE TABLE `flood` (   `fid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Unique flood event ID.',   `event` varchar(64) NOT NULL DEFAULT '' COMMENT 'Name of event (e.g. contact).',   `identifier` varchar(128) NOT NULL DEFAULT '' COMMENT 'Identifier of the visitor, such as an IP address or hostname.',   `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp of the event.',   `expiration` int(11) NOT NULL DEFAULT '0' COMMENT 'Expiration timestamp. Expired events are purged on cron run.',   PRIMARY KEY (`fid`),   KEY `allow` (`event`,`identifier`,`timestamp`),   KEY `purge` (`expiration`) ) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8 COMMENT='Flood controls the threshold of events, such as the...' AUTO_INCREMENT=17;
INSERT INTO `flood` VALUES ('14','failed_login_attempt_user','1-10.183.248.6','1493642256','1493663856'),('15','failed_login_attempt_ip','10.183.248.6','1493655339','1493658939'),('16','failed_login_attempt_user','1-10.183.248.6','1493655339','1493676939');
DROP TABLE IF EXISTS `history`;
CREATE TABLE `history` (   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that read the node nid.',   `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid that was read.',   `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp at which the read occurred.',   PRIMARY KEY (`uid`,`nid`),   KEY `nid` (`nid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A record of which users have read which nodes.';
INSERT INTO `history` VALUES ('1','18','1491538907');
DROP TABLE IF EXISTS `image_effects`;
CREATE TABLE `image_effects` (   `ieid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for an image effect.',   `isid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The image_styles.isid for an image style.',   `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of the effect in the style.',   `name` varchar(255) NOT NULL COMMENT 'The unique name of the effect to be executed.',   `data` longblob NOT NULL COMMENT 'The configuration data for the effect.',   PRIMARY KEY (`ieid`),   KEY `isid` (`isid`),   KEY `weight` (`weight`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores configuration options for image effects.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `image_styles`;
CREATE TABLE `image_styles` (   `isid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for an image style.',   `name` varchar(255) NOT NULL COMMENT 'The style machine name.',   `label` varchar(255) NOT NULL DEFAULT '' COMMENT 'The style administrative name.',   PRIMARY KEY (`isid`),   UNIQUE KEY `name` (`name`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores configuration options for image styles.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `job_schedule`;
CREATE TABLE `job_schedule` (   `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique item ID.',   `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'Name of the schedule.',   `type` varchar(128) NOT NULL DEFAULT '' COMMENT 'Type identifier of the job.',   `id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Numeric identifier of the job.',   `period` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Time period after which job is to be executed.',   `crontab` varchar(255) NOT NULL DEFAULT '' COMMENT 'Crontab line in *NIX format.',   `data` longblob COMMENT 'The arbitrary data for the item.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when job expires.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the item was created.',   `last` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Timestamp when a job was last executed.',   `periodic` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'If true job will be automatically rescheduled.',   `next` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Timestamp when a job is to be executed (next = last + period), used for fast ordering.',   `scheduled` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Timestamp when a job was scheduled. 0 if a job is currently not scheduled.',   PRIMARY KEY (`item_id`),   KEY `name_type_id` (`name`,`type`,`id`),   KEY `name_type` (`name`,`type`),   KEY `next` (`next`),   KEY `scheduled` (`scheduled`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Schedule of jobs to be executed.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `menu_custom`;
CREATE TABLE `menu_custom` (   `menu_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique key for menu. This is used as a block delta so length is 32.',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Menu title; displayed at top of block.',   `description` text COMMENT 'Menu description.',   PRIMARY KEY (`menu_name`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds definitions for top-level custom menus (for example...';
INSERT INTO `menu_custom` VALUES ('devel','Development','Development link'),('features','Features','Menu items for any enabled features.'),('main-menu','Main menu','The <em>Main</em> menu is used on many sites to show the major sections of the site, often in a top navigation bar.'),('management','Management','The <em>Management</em> menu contains links for administrative tasks.'),('menu-library-menu','Reader menu',''),('menu-library-menu1','Library menu',''),('menu-setup-menu','Setup Menu','This is the "administrator" setup menu used during inital program setup.'),('navigation','Navigation','The <em>Navigation</em> menu contains links intended for site visitors. Links are added to the <em>Navigation</em> menu automatically by some modules.'),('user-menu','User menu','The <em>User</em> menu contains links related to the user''s account, as well as the ''Log out'' link.');
DROP TABLE IF EXISTS `menu_links`;
CREATE TABLE `menu_links` (   `menu_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The menu name. All links with the same menu name (such as ’navigation’) are part of the same menu.',   `mlid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The menu link ID (mlid) is the integer primary key.',   `plid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The parent link ID (plid) is the mlid of the link above in the hierarchy, or zero if the link is at the top level in its menu.',   `link_path` varchar(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path or external path this link points to.',   `router_path` varchar(255) NOT NULL DEFAULT '' COMMENT 'For links corresponding to a Drupal path (external = 0), this connects the link to a menu_router.path for joins.',   `link_title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The text displayed for the link, which may be modified by a title callback stored in menu_router.',   `options` blob COMMENT 'A serialized array of options to be passed to the url() or l() function, such as a query string or HTML attributes.',   `module` varchar(255) NOT NULL DEFAULT 'system' COMMENT 'The name of the module that generated this link.',   `hidden` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag for whether the link should be rendered in menus. (1 = a disabled menu item that may be shown on admin screens, -1 = a menu callback, 0 = a normal, visible link)',   `external` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate if the link points to a full URL starting with a protocol, like http:// (1 = external, 0 = internal).',   `has_children` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag indicating whether any links have this link as a parent (1 = children exist, 0 = no children).',   `expanded` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag for whether this link should be rendered as expanded in menus - expanded links always have their child links displayed, instead of only when the link is in the active trail (1 = expanded, 0 = not expanded)',   `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Link weight among links in the same menu at the same depth.',   `depth` smallint(6) NOT NULL DEFAULT '0' COMMENT 'The depth relative to the top level. A link with plid == 0 will have depth == 1.',   `customized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate that the user has manually created or edited the link (1 = customized, 0 = not customized).',   `p1` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The first mlid in the materialized path. If N = depth, then pN must equal the mlid. If depth > 1 then p(N-1) must equal the plid. All pX where X > depth must equal zero. The columns p1 .. p9 are also called the parents.',   `p2` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The second mlid in the materialized path. See p1.',   `p3` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The third mlid in the materialized path. See p1.',   `p4` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fourth mlid in the materialized path. See p1.',   `p5` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fifth mlid in the materialized path. See p1.',   `p6` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The sixth mlid in the materialized path. See p1.',   `p7` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The seventh mlid in the materialized path. See p1.',   `p8` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The eighth mlid in the materialized path. See p1.',   `p9` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The ninth mlid in the materialized path. See p1.',   `updated` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag that indicates that this link was generated during the update from Drupal 5.',   PRIMARY KEY (`mlid`),   KEY `path_menu` (`link_path`(128),`menu_name`),   KEY `menu_plid_expand_child` (`menu_name`,`plid`,`expanded`,`has_children`),   KEY `menu_parents` (`menu_name`,`p1`,`p2`,`p3`,`p4`,`p5`,`p6`,`p7`,`p8`,`p9`),   KEY `router_path` (`router_path`(128)) ) ENGINE=InnoDB AUTO_INCREMENT=1460 DEFAULT CHARSET=utf8 COMMENT='Contains the individual links within a menu.' AUTO_INCREMENT=1460;
INSERT INTO `menu_links` VALUES ('management','1','0','admin','admin','Administration','a:0:{}','system','0','0','1','0','9','1','0','1','0','0','0','0','0','0','0','0','0'),('user-menu','2','0','user','user','User account','a:1:{s:5:"alter";b:1;}','system','0','0','0','0','-10','1','0','2','0','0','0','0','0','0','0','0','0'),('navigation','3','0','comment/%','comment/%','Comment permalink','a:0:{}','system','0','0','1','0','0','1','0','3','0','0','0','0','0','0','0','0','0'),('navigation','4','0','filter/tips','filter/tips','Compose tips','a:0:{}','system','1','0','1','0','0','1','0','4','0','0','0','0','0','0','0','0','0'),('navigation','5','0','node/%','node/%','','a:0:{}','system','0','0','0','0','0','1','0','5','0','0','0','0','0','0','0','0','0'),('navigation','6','0','node/add','node/add','Add content','a:0:{}','system','0','0','1','0','0','1','0','6','0','0','0','0','0','0','0','0','0'),('management','7','1','admin/appearance','admin/appearance','Appearance','a:1:{s:10:"attributes";a:1:{s:5:"title";s:33:"Select and configure your themes.";}}','system','0','0','0','0','-6','2','0','1','7','0','0','0','0','0','0','0','0'),('management','8','1','admin/config','admin/config','Configuration','a:1:{s:10:"attributes";a:1:{s:5:"title";s:20:"Administer settings.";}}','system','0','0','1','0','0','2','0','1','8','0','0','0','0','0','0','0','0'),('management','9','1','admin/content','admin/content','Content','a:1:{s:10:"attributes";a:1:{s:5:"title";s:32:"Administer content and comments.";}}','system','0','0','1','0','-10','2','0','1','9','0','0','0','0','0','0','0','0'),('user-menu','10','2','user/register','user/register','Create new account','a:0:{}','system','-1','0','0','0','0','2','0','2','10','0','0','0','0','0','0','0','0'),('management','11','1','admin/dashboard','admin/dashboard','Dashboard','a:1:{s:10:"attributes";a:1:{s:5:"title";s:34:"View and customize your dashboard.";}}','system','0','0','0','0','-15','2','0','1','11','0','0','0','0','0','0','0','0'),('management','12','1','admin/help','admin/help','Help','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"Reference for usage, configuration, and modules.";}}','system','0','0','0','0','9','2','0','1','12','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','13','1','admin/index','admin/index','Index','a:0:{}','system','-1','0','0','0','-18','2','0','1','13','0','0','0','0','0','0','0','0'),('user-menu','14','2','user/login','user/login','Log in','a:0:{}','system','-1','0','0','0','0','2','0','2','14','0','0','0','0','0','0','0','0'),('user-menu','15','0','user/logout','user/logout','Log out','a:0:{}','system','0','0','0','0','10','1','0','15','0','0','0','0','0','0','0','0','0'),('management','16','1','admin/modules','admin/modules','Modules','a:1:{s:10:"attributes";a:1:{s:5:"title";s:26:"Extend site functionality.";}}','system','0','0','0','0','-2','2','0','1','16','0','0','0','0','0','0','0','0'),('navigation','17','0','user/%','user/%','My account','a:0:{}','system','0','0','1','0','0','1','0','17','0','0','0','0','0','0','0','0','0'),('management','18','1','admin/people','admin/people','People','a:1:{s:10:"attributes";a:1:{s:5:"title";s:45:"Manage user accounts, roles, and permissions.";}}','system','0','0','0','0','-4','2','0','1','18','0','0','0','0','0','0','0','0'),('management','19','1','admin/reports','admin/reports','Reports','a:1:{s:10:"attributes";a:1:{s:5:"title";s:34:"View reports, updates, and errors.";}}','system','0','0','1','0','5','2','0','1','19','0','0','0','0','0','0','0','0'),('user-menu','20','2','user/password','user/password','Request new password','a:0:{}','system','-1','0','0','0','0','2','0','2','20','0','0','0','0','0','0','0','0'),('management','21','1','admin/structure','admin/structure','Structure','a:1:{s:10:"attributes";a:1:{s:5:"title";s:45:"Administer blocks, content types, menus, etc.";}}','system','0','0','1','0','-8','2','0','1','21','0','0','0','0','0','0','0','0'),('management','22','1','admin/tasks','admin/tasks','Tasks','a:0:{}','system','-1','0','0','0','-20','2','0','1','22','0','0','0','0','0','0','0','0'),('navigation','23','0','comment/reply/%','comment/reply/%','Add new comment','a:0:{}','system','0','0','0','0','0','1','0','23','0','0','0','0','0','0','0','0','0'),('navigation','24','3','comment/%/approve','comment/%/approve','Approve','a:0:{}','system','0','0','0','0','1','2','0','3','24','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','25','4','filter/tips/%','filter/tips/%','Compose tips','a:0:{}','system','0','0','0','0','0','2','0','4','25','0','0','0','0','0','0','0','0'),('navigation','26','3','comment/%/delete','comment/%/delete','Delete','a:0:{}','system','-1','0','0','0','2','2','0','3','26','0','0','0','0','0','0','0','0'),('navigation','27','3','comment/%/edit','comment/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','2','0','3','27','0','0','0','0','0','0','0','0'),('navigation','28','0','taxonomy/term/%','taxonomy/term/%','Taxonomy term','a:0:{}','system','0','0','0','0','0','1','0','28','0','0','0','0','0','0','0','0','0'),('navigation','29','3','comment/%/view','comment/%/view','View comment','a:0:{}','system','-1','0','0','0','-10','2','0','3','29','0','0','0','0','0','0','0','0'),('management','30','18','admin/people/create','admin/people/create','Add user','a:0:{}','system','-1','0','0','0','0','3','0','1','18','30','0','0','0','0','0','0','0'),('management','31','21','admin/structure/block','admin/structure/block','Blocks','a:1:{s:10:"attributes";a:1:{s:5:"title";s:79:"Configure what block content appears in your site''s sidebars and other regions.";}}','system','0','0','1','0','0','3','0','1','21','31','0','0','0','0','0','0','0'),('navigation','32','17','user/%/cancel','user/%/cancel','Cancel account','a:0:{}','system','0','0','1','0','0','2','0','17','32','0','0','0','0','0','0','0','0'),('management','33','9','admin/content/comment','admin/content/comment','Comments','a:1:{s:10:"attributes";a:1:{s:5:"title";s:59:"List and edit site comments and the comment approval queue.";}}','system','0','0','0','0','0','3','0','1','9','33','0','0','0','0','0','0','0'),('management','34','11','admin/dashboard/configure','admin/dashboard/configure','Configure available dashboard blocks','a:1:{s:10:"attributes";a:1:{s:5:"title";s:53:"Configure which blocks can be shown on the dashboard.";}}','system','-1','0','0','0','0','3','0','1','11','34','0','0','0','0','0','0','0'),('management','35','9','admin/content/node','admin/content/node','Content','a:0:{}','system','-1','0','0','0','-10','3','0','1','9','35','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','36','8','admin/config/content','admin/config/content','Content authoring','a:1:{s:10:"attributes";a:1:{s:5:"title";s:53:"Settings related to formatting and authoring content.";}}','system','0','0','1','0','-15','3','0','1','8','36','0','0','0','0','0','0','0'),('management','37','21','admin/structure/types','admin/structure/types','Content types','a:1:{s:10:"attributes";a:1:{s:5:"title";s:92:"Manage content types, including default status, front page promotion, comment settings, etc.";}}','system','0','0','1','0','0','3','0','1','21','37','0','0','0','0','0','0','0'),('management','38','11','admin/dashboard/customize','admin/dashboard/customize','Customize dashboard','a:1:{s:10:"attributes";a:1:{s:5:"title";s:25:"Customize your dashboard.";}}','system','-1','0','0','0','0','3','0','1','11','38','0','0','0','0','0','0','0'),('navigation','39','5','node/%/delete','node/%/delete','Delete','a:0:{}','system','-1','0','0','0','1','2','0','5','39','0','0','0','0','0','0','0','0'),('management','40','8','admin/config/development','admin/config/development','Development','a:1:{s:10:"attributes";a:1:{s:5:"title";s:18:"Development tools.";}}','system','0','0','1','0','-10','3','0','1','8','40','0','0','0','0','0','0','0'),('navigation','41','17','user/%/edit','user/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','2','0','17','41','0','0','0','0','0','0','0','0'),('navigation','42','5','node/%/edit','node/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','2','0','5','42','0','0','0','0','0','0','0','0'),('management','43','19','admin/reports/fields','admin/reports/fields','Field list','a:1:{s:10:"attributes";a:1:{s:5:"title";s:39:"Overview of fields on all entity types.";}}','system','0','0','0','0','0','3','0','1','19','43','0','0','0','0','0','0','0'),('management','44','16','admin/modules/list','admin/modules/list','List','a:0:{}','system','-1','0','0','0','0','3','0','1','16','44','0','0','0','0','0','0','0'),('management','45','18','admin/people/people','admin/people/people','List','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"Find and manage people interacting with your site.";}}','system','-1','0','0','0','-10','3','0','1','18','45','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','46','7','admin/appearance/list','admin/appearance/list','List','a:1:{s:10:"attributes";a:1:{s:5:"title";s:31:"Select and configure your theme";}}','system','-1','0','0','0','-1','3','0','1','7','46','0','0','0','0','0','0','0'),('management','47','8','admin/config/media','admin/config/media','Media','a:1:{s:10:"attributes";a:1:{s:5:"title";s:12:"Media tools.";}}','system','0','0','1','0','-10','3','0','1','8','47','0','0','0','0','0','0','0'),('management','48','21','admin/structure/menu','admin/structure/menu','Menus','a:1:{s:10:"attributes";a:1:{s:5:"title";s:86:"Add new menus to your site, edit existing menus, and rename and reorganize menu links.";}}','system','0','0','1','0','0','3','0','1','21','48','0','0','0','0','0','0','0'),('management','49','8','admin/config/people','admin/config/people','People','a:1:{s:10:"attributes";a:1:{s:5:"title";s:24:"Configure user accounts.";}}','system','0','0','1','0','-20','3','0','1','8','49','0','0','0','0','0','0','0'),('management','50','18','admin/people/permissions','admin/people/permissions','Permissions','a:1:{s:10:"attributes";a:1:{s:5:"title";s:64:"Determine access to features by selecting permissions for roles.";}}','system','-1','0','0','0','0','3','0','1','18','50','0','0','0','0','0','0','0'),('management','51','19','admin/reports/dblog','admin/reports/dblog','Recent log messages','a:1:{s:10:"attributes";a:1:{s:5:"title";s:43:"View events that have recently been logged.";}}','system','0','0','0','0','-1','3','0','1','19','51','0','0','0','0','0','0','0'),('management','52','8','admin/config/regional','admin/config/regional','Regional and language','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"Regional settings, localization and translation.";}}','system','0','0','1','0','-5','3','0','1','8','52','0','0','0','0','0','0','0'),('navigation','53','5','node/%/revisions','node/%/revisions','Revisions','a:0:{}','system','-1','0','1','0','2','2','0','5','53','0','0','0','0','0','0','0','0'),('management','54','8','admin/config/search','admin/config/search','Search and metadata','a:1:{s:10:"attributes";a:1:{s:5:"title";s:36:"Local site search, metadata and SEO.";}}','system','0','0','1','0','-10','3','0','1','8','54','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','55','7','admin/appearance/settings','admin/appearance/settings','Settings','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"Configure default and theme specific settings.";}}','system','-1','0','0','0','20','3','0','1','7','55','0','0','0','0','0','0','0'),('management','56','19','admin/reports/status','admin/reports/status','Status report','a:1:{s:10:"attributes";a:1:{s:5:"title";s:74:"Get a status report about your site''s operation and any detected problems.";}}','system','0','0','0','0','-60','3','0','1','19','56','0','0','0','0','0','0','0'),('management','57','8','admin/config/system','admin/config/system','System','a:1:{s:10:"attributes";a:1:{s:5:"title";s:37:"General system related configuration.";}}','system','0','0','1','0','-20','3','0','1','8','57','0','0','0','0','0','0','0'),('management','58','21','admin/structure/taxonomy','admin/structure/taxonomy','Taxonomy','a:1:{s:10:"attributes";a:1:{s:5:"title";s:67:"Manage tagging, categorization, and classification of your content.";}}','system','0','0','1','0','0','3','0','1','21','58','0','0','0','0','0','0','0'),('management','59','19','admin/reports/access-denied','admin/reports/access-denied','Top ''access denied'' errors','a:1:{s:10:"attributes";a:1:{s:5:"title";s:35:"View ''access denied'' errors (403s).";}}','system','0','0','0','0','0','3','0','1','19','59','0','0','0','0','0','0','0'),('management','60','19','admin/reports/page-not-found','admin/reports/page-not-found','Top ''page not found'' errors','a:1:{s:10:"attributes";a:1:{s:5:"title";s:36:"View ''page not found'' errors (404s).";}}','system','0','0','0','0','0','3','0','1','19','60','0','0','0','0','0','0','0'),('management','61','16','admin/modules/uninstall','admin/modules/uninstall','Uninstall','a:0:{}','system','-1','0','0','0','20','3','0','1','16','61','0','0','0','0','0','0','0'),('management','62','8','admin/config/user-interface','admin/config/user-interface','User interface','a:1:{s:10:"attributes";a:1:{s:5:"title";s:38:"Tools that enhance the user interface.";}}','system','0','0','1','0','-15','3','0','1','8','62','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','63','5','node/%/view','node/%/view','View','a:0:{}','system','-1','0','0','0','-10','2','0','5','63','0','0','0','0','0','0','0','0'),('navigation','64','17','user/%/view','user/%/view','View','a:0:{}','system','-1','0','0','0','-10','2','0','17','64','0','0','0','0','0','0','0','0'),('management','65','8','admin/config/services','admin/config/services','Web services','a:1:{s:10:"attributes";a:1:{s:5:"title";s:30:"Tools related to web services.";}}','system','0','0','1','0','0','3','0','1','8','65','0','0','0','0','0','0','0'),('management','66','8','admin/config/workflow','admin/config/workflow','Workflow','a:1:{s:10:"attributes";a:1:{s:5:"title";s:43:"Content workflow, editorial workflow tools.";}}','system','0','0','1','0','5','3','0','1','8','66','0','0','0','0','0','0','0'),('management','67','12','admin/help/block','admin/help/block','block','a:0:{}','system','-1','0','0','0','0','3','0','1','12','67','0','0','0','0','0','0','0'),('management','68','12','admin/help/color','admin/help/color','color','a:0:{}','system','-1','0','0','0','0','3','0','1','12','68','0','0','0','0','0','0','0'),('management','69','12','admin/help/comment','admin/help/comment','comment','a:0:{}','system','-1','0','0','0','0','3','0','1','12','69','0','0','0','0','0','0','0'),('management','70','12','admin/help/contextual','admin/help/contextual','contextual','a:0:{}','system','-1','0','0','0','0','3','0','1','12','70','0','0','0','0','0','0','0'),('management','71','12','admin/help/dashboard','admin/help/dashboard','dashboard','a:0:{}','system','-1','0','0','0','0','3','0','1','12','71','0','0','0','0','0','0','0'),('management','72','12','admin/help/dblog','admin/help/dblog','dblog','a:0:{}','system','-1','0','0','0','0','3','0','1','12','72','0','0','0','0','0','0','0'),('management','73','12','admin/help/field','admin/help/field','field','a:0:{}','system','-1','0','0','0','0','3','0','1','12','73','0','0','0','0','0','0','0'),('management','74','12','admin/help/field_sql_storage','admin/help/field_sql_storage','field_sql_storage','a:0:{}','system','-1','0','0','0','0','3','0','1','12','74','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','75','12','admin/help/field_ui','admin/help/field_ui','field_ui','a:0:{}','system','-1','0','0','0','0','3','0','1','12','75','0','0','0','0','0','0','0'),('management','76','12','admin/help/file','admin/help/file','file','a:0:{}','system','-1','0','0','0','0','3','0','1','12','76','0','0','0','0','0','0','0'),('management','77','12','admin/help/filter','admin/help/filter','filter','a:0:{}','system','-1','0','0','0','0','3','0','1','12','77','0','0','0','0','0','0','0'),('management','78','12','admin/help/help','admin/help/help','help','a:0:{}','system','-1','0','0','0','0','3','0','1','12','78','0','0','0','0','0','0','0'),('management','79','12','admin/help/image','admin/help/image','image','a:0:{}','system','-1','0','0','0','0','3','0','1','12','79','0','0','0','0','0','0','0'),('management','80','12','admin/help/list','admin/help/list','list','a:0:{}','system','-1','0','0','0','0','3','0','1','12','80','0','0','0','0','0','0','0'),('management','81','12','admin/help/menu','admin/help/menu','menu','a:0:{}','system','-1','0','0','0','0','3','0','1','12','81','0','0','0','0','0','0','0'),('management','82','12','admin/help/node','admin/help/node','node','a:0:{}','system','-1','0','0','0','0','3','0','1','12','82','0','0','0','0','0','0','0'),('management','83','12','admin/help/options','admin/help/options','options','a:0:{}','system','-1','0','0','0','0','3','0','1','12','83','0','0','0','0','0','0','0'),('management','84','12','admin/help/system','admin/help/system','system','a:0:{}','system','-1','0','0','0','0','3','0','1','12','84','0','0','0','0','0','0','0'),('management','85','12','admin/help/taxonomy','admin/help/taxonomy','taxonomy','a:0:{}','system','-1','0','0','0','0','3','0','1','12','85','0','0','0','0','0','0','0'),('management','86','12','admin/help/text','admin/help/text','text','a:0:{}','system','-1','0','0','0','0','3','0','1','12','86','0','0','0','0','0','0','0'),('management','87','12','admin/help/user','admin/help/user','user','a:0:{}','system','-1','0','0','0','0','3','0','1','12','87','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','88','28','taxonomy/term/%/edit','taxonomy/term/%/edit','Edit','a:0:{}','system','-1','0','0','0','10','2','0','28','88','0','0','0','0','0','0','0','0'),('navigation','89','28','taxonomy/term/%/view','taxonomy/term/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','28','89','0','0','0','0','0','0','0','0'),('management','90','58','admin/structure/taxonomy/%','admin/structure/taxonomy/%','','a:0:{}','system','0','0','0','0','0','4','0','1','21','58','90','0','0','0','0','0','0'),('management','91','49','admin/config/people/accounts','admin/config/people/accounts','Account settings','a:1:{s:10:"attributes";a:1:{s:5:"title";s:109:"Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.";}}','system','0','0','0','0','-10','4','0','1','8','49','91','0','0','0','0','0','0'),('management','92','57','admin/config/system/actions','admin/config/system/actions','Actions','a:1:{s:10:"attributes";a:1:{s:5:"title";s:41:"Manage the actions defined for your site.";}}','system','0','0','1','0','0','4','0','1','8','57','92','0','0','0','0','0','0'),('management','93','31','admin/structure/block/add','admin/structure/block/add','Add block','a:0:{}','system','-1','0','0','0','0','4','0','1','21','31','93','0','0','0','0','0','0'),('management','94','37','admin/structure/types/add','admin/structure/types/add','Add content type','a:0:{}','system','-1','0','0','0','0','4','0','1','21','37','94','0','0','0','0','0','0'),('management','95','48','admin/structure/menu/add','admin/structure/menu/add','Add menu','a:0:{}','system','-1','0','0','0','0','4','0','1','21','48','95','0','0','0','0','0','0'),('management','96','58','admin/structure/taxonomy/add','admin/structure/taxonomy/add','Add vocabulary','a:0:{}','system','-1','0','0','0','0','4','0','1','21','58','96','0','0','0','0','0','0'),('management','97','55','admin/appearance/settings/bartik','admin/appearance/settings/bartik','Bartik','a:0:{}','system','-1','0','0','0','0','4','0','1','7','55','97','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','98','54','admin/config/search/clean-urls','admin/config/search/clean-urls','Clean URLs','a:1:{s:10:"attributes";a:1:{s:5:"title";s:43:"Enable or disable clean URLs for your site.";}}','system','0','0','0','0','5','4','0','1','8','54','98','0','0','0','0','0','0'),('management','99','57','admin/config/system/cron','admin/config/system/cron','Cron','a:1:{s:10:"attributes";a:1:{s:5:"title";s:40:"Manage automatic site maintenance tasks.";}}','system','0','0','0','0','20','4','0','1','8','57','99','0','0','0','0','0','0'),('management','100','52','admin/config/regional/date-time','admin/config/regional/date-time','Date and time','a:1:{s:10:"attributes";a:1:{s:5:"title";s:44:"Configure display formats for date and time.";}}','system','0','0','0','0','-15','4','0','1','8','52','100','0','0','0','0','0','0'),('management','101','19','admin/reports/event/%','admin/reports/event/%','Details','a:0:{}','system','0','0','0','0','0','3','0','1','19','101','0','0','0','0','0','0','0'),('management','102','47','admin/config/media/file-system','admin/config/media/file-system','File system','a:1:{s:10:"attributes";a:1:{s:5:"title";s:68:"Tell Drupal where to store uploaded files and how they are accessed.";}}','system','0','0','0','0','-10','4','0','1','8','47','102','0','0','0','0','0','0'),('management','103','55','admin/appearance/settings/garland','admin/appearance/settings/garland','Garland','a:0:{}','system','-1','0','0','0','0','4','0','1','7','55','103','0','0','0','0','0','0'),('management','104','55','admin/appearance/settings/global','admin/appearance/settings/global','Global settings','a:0:{}','system','-1','0','0','0','-1','4','0','1','7','55','104','0','0','0','0','0','0'),('management','105','49','admin/config/people/ip-blocking','admin/config/people/ip-blocking','IP address blocking','a:1:{s:10:"attributes";a:1:{s:5:"title";s:28:"Manage blocked IP addresses.";}}','system','0','0','1','0','10','4','0','1','8','49','105','0','0','0','0','0','0'),('management','106','47','admin/config/media/image-styles','admin/config/media/image-styles','Image styles','a:1:{s:10:"attributes";a:1:{s:5:"title";s:78:"Configure styles that can be used for resizing or adjusting images on display.";}}','system','0','0','1','0','0','4','0','1','8','47','106','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','107','47','admin/config/media/image-toolkit','admin/config/media/image-toolkit','Image toolkit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:74:"Choose which image toolkit to use if you have installed optional toolkits.";}}','system','0','0','0','0','20','4','0','1','8','47','107','0','0','0','0','0','0'),('management','108','44','admin/modules/list/confirm','admin/modules/list/confirm','List','a:0:{}','system','-1','0','0','0','0','4','0','1','16','44','108','0','0','0','0','0','0'),('management','109','37','admin/structure/types/list','admin/structure/types/list','List','a:0:{}','system','-1','0','0','0','-10','4','0','1','21','37','109','0','0','0','0','0','0'),('management','110','58','admin/structure/taxonomy/list','admin/structure/taxonomy/list','List','a:0:{}','system','-1','0','0','0','-10','4','0','1','21','58','110','0','0','0','0','0','0'),('management','111','48','admin/structure/menu/list','admin/structure/menu/list','List menus','a:0:{}','system','-1','0','0','0','-10','4','0','1','21','48','111','0','0','0','0','0','0'),('management','112','40','admin/config/development/logging','admin/config/development/logging','Logging and errors','a:1:{s:10:"attributes";a:1:{s:5:"title";s:154:"Settings for logging and alerts modules. Various modules can route Drupal''s system events to different destinations, such as syslog, database, email, etc.";}}','system','0','0','0','0','-15','4','0','1','8','40','112','0','0','0','0','0','0'),('management','113','40','admin/config/development/maintenance','admin/config/development/maintenance','Maintenance mode','a:1:{s:10:"attributes";a:1:{s:5:"title";s:62:"Take the site offline for maintenance or bring it back online.";}}','system','0','0','0','0','-10','4','0','1','8','40','113','0','0','0','0','0','0'),('management','114','40','admin/config/development/performance','admin/config/development/performance','Performance','a:1:{s:10:"attributes";a:1:{s:5:"title";s:101:"Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.";}}','system','0','0','0','0','-20','4','0','1','8','40','114','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','115','50','admin/people/permissions/list','admin/people/permissions/list','Permissions','a:1:{s:10:"attributes";a:1:{s:5:"title";s:64:"Determine access to features by selecting permissions for roles.";}}','system','-1','0','0','0','-8','4','0','1','18','50','115','0','0','0','0','0','0'),('management','116','33','admin/content/comment/new','admin/content/comment/new','Published comments','a:0:{}','system','-1','0','0','0','-10','4','0','1','9','33','116','0','0','0','0','0','0'),('management','117','65','admin/config/services/rss-publishing','admin/config/services/rss-publishing','RSS publishing','a:1:{s:10:"attributes";a:1:{s:5:"title";s:114:"Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.";}}','system','0','0','0','0','0','4','0','1','8','65','117','0','0','0','0','0','0'),('management','118','52','admin/config/regional/settings','admin/config/regional/settings','Regional settings','a:1:{s:10:"attributes";a:1:{s:5:"title";s:54:"Settings for the site''s default time zone and country.";}}','system','0','0','0','0','-20','4','0','1','8','52','118','0','0','0','0','0','0'),('management','119','50','admin/people/permissions/roles','admin/people/permissions/roles','Roles','a:1:{s:10:"attributes";a:1:{s:5:"title";s:30:"List, edit, or add user roles.";}}','system','-1','0','1','0','-5','4','0','1','18','50','119','0','0','0','0','0','0'),('management','120','48','admin/structure/menu/settings','admin/structure/menu/settings','Settings','a:0:{}','system','-1','0','0','0','5','4','0','1','21','48','120','0','0','0','0','0','0'),('management','121','55','admin/appearance/settings/seven','admin/appearance/settings/seven','Seven','a:0:{}','system','-1','0','0','0','0','4','0','1','7','55','121','0','0','0','0','0','0'),('management','122','57','admin/config/system/site-information','admin/config/system/site-information','Site information','a:1:{s:10:"attributes";a:1:{s:5:"title";s:104:"Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.";}}','system','0','0','0','0','-20','4','0','1','8','57','122','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','123','55','admin/appearance/settings/stark','admin/appearance/settings/stark','Stark','a:0:{}','system','-1','0','0','0','0','4','0','1','7','55','123','0','0','0','0','0','0'),('management','124','36','admin/config/content/formats','admin/config/content/formats','Text formats','a:1:{s:10:"attributes";a:1:{s:5:"title";s:127:"Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.";}}','system','0','0','1','0','0','4','0','1','8','36','124','0','0','0','0','0','0'),('management','125','33','admin/content/comment/approval','admin/content/comment/approval','Unapproved comments','a:0:{}','system','-1','0','0','0','0','4','0','1','9','33','125','0','0','0','0','0','0'),('management','126','61','admin/modules/uninstall/confirm','admin/modules/uninstall/confirm','Uninstall','a:0:{}','system','-1','0','0','0','0','4','0','1','16','61','126','0','0','0','0','0','0'),('navigation','127','41','user/%/edit/account','user/%/edit/account','Account','a:0:{}','system','-1','0','0','0','0','3','0','17','41','127','0','0','0','0','0','0','0'),('management','128','124','admin/config/content/formats/%','admin/config/content/formats/%','','a:0:{}','system','0','0','1','0','0','5','0','1','8','36','124','128','0','0','0','0','0'),('management','129','106','admin/config/media/image-styles/add','admin/config/media/image-styles/add','Add style','a:1:{s:10:"attributes";a:1:{s:5:"title";s:22:"Add a new image style.";}}','system','-1','0','0','0','2','5','0','1','8','47','106','129','0','0','0','0','0'),('management','130','90','admin/structure/taxonomy/%/add','admin/structure/taxonomy/%/add','Add term','a:0:{}','system','-1','0','0','0','0','5','0','1','21','58','90','130','0','0','0','0','0'),('management','131','124','admin/config/content/formats/add','admin/config/content/formats/add','Add text format','a:0:{}','system','-1','0','0','0','1','5','0','1','8','36','124','131','0','0','0','0','0'),('management','132','31','admin/structure/block/list/bartik','admin/structure/block/list/bartik','Bartik','a:0:{}','system','-1','0','0','0','0','4','0','1','21','31','132','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','133','92','admin/config/system/actions/configure','admin/config/system/actions/configure','Configure an advanced action','a:0:{}','system','-1','0','0','0','0','5','0','1','8','57','92','133','0','0','0','0','0'),('management','134','48','admin/structure/menu/manage/%','admin/structure/menu/manage/%','Customize menu','a:0:{}','system','0','0','1','0','0','4','0','1','21','48','134','0','0','0','0','0','0'),('management','135','90','admin/structure/taxonomy/%/edit','admin/structure/taxonomy/%/edit','Edit','a:0:{}','system','-1','0','0','0','-10','5','0','1','21','58','90','135','0','0','0','0','0'),('management','136','37','admin/structure/types/manage/%','admin/structure/types/manage/%','Edit content type','a:0:{}','system','0','0','1','0','0','4','0','1','21','37','136','0','0','0','0','0','0'),('management','137','100','admin/config/regional/date-time/formats','admin/config/regional/date-time/formats','Formats','a:1:{s:10:"attributes";a:1:{s:5:"title";s:51:"Configure display format strings for date and time.";}}','system','-1','0','1','0','-9','5','0','1','8','52','100','137','0','0','0','0','0'),('management','138','31','admin/structure/block/list/garland','admin/structure/block/list/garland','Garland','a:0:{}','system','-1','0','0','0','0','4','0','1','21','31','138','0','0','0','0','0','0'),('management','139','90','admin/structure/taxonomy/%/list','admin/structure/taxonomy/%/list','List','a:0:{}','system','-1','0','0','0','-20','5','0','1','21','58','90','139','0','0','0','0','0'),('management','140','124','admin/config/content/formats/list','admin/config/content/formats/list','List','a:0:{}','system','-1','0','0','0','0','5','0','1','8','36','124','140','0','0','0','0','0'),('management','141','106','admin/config/media/image-styles/list','admin/config/media/image-styles/list','List','a:1:{s:10:"attributes";a:1:{s:5:"title";s:42:"List the current image styles on the site.";}}','system','-1','0','0','0','1','5','0','1','8','47','106','141','0','0','0','0','0'),('management','142','92','admin/config/system/actions/manage','admin/config/system/actions/manage','Manage actions','a:1:{s:10:"attributes";a:1:{s:5:"title";s:41:"Manage the actions defined for your site.";}}','system','-1','0','0','0','-2','5','0','1','8','57','92','142','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','143','91','admin/config/people/accounts/settings','admin/config/people/accounts/settings','Settings','a:0:{}','system','-1','0','0','0','-10','5','0','1','8','49','91','143','0','0','0','0','0'),('management','144','31','admin/structure/block/list/seven','admin/structure/block/list/seven','Seven','a:0:{}','system','-1','0','0','0','0','4','0','1','21','31','144','0','0','0','0','0','0'),('management','145','31','admin/structure/block/list/stark','admin/structure/block/list/stark','Stark','a:0:{}','system','-1','0','0','0','0','4','0','1','21','31','145','0','0','0','0','0','0'),('management','146','100','admin/config/regional/date-time/types','admin/config/regional/date-time/types','Types','a:1:{s:10:"attributes";a:1:{s:5:"title";s:44:"Configure display formats for date and time.";}}','system','-1','0','1','0','-10','5','0','1','8','52','100','146','0','0','0','0','0'),('navigation','147','53','node/%/revisions/%/delete','node/%/revisions/%/delete','Delete earlier revision','a:0:{}','system','0','0','0','0','0','3','0','5','53','147','0','0','0','0','0','0','0'),('navigation','148','53','node/%/revisions/%/revert','node/%/revisions/%/revert','Revert to earlier revision','a:0:{}','system','0','0','0','0','0','3','0','5','53','148','0','0','0','0','0','0','0'),('navigation','149','53','node/%/revisions/%/view','node/%/revisions/%/view','Revisions','a:0:{}','system','0','0','0','0','0','3','0','5','53','149','0','0','0','0','0','0','0'),('management','150','138','admin/structure/block/list/garland/add','admin/structure/block/list/garland/add','Add block','a:0:{}','system','-1','0','0','0','0','5','0','1','21','31','138','150','0','0','0','0','0'),('management','151','144','admin/structure/block/list/seven/add','admin/structure/block/list/seven/add','Add block','a:0:{}','system','-1','0','0','0','0','5','0','1','21','31','144','151','0','0','0','0','0'),('management','152','145','admin/structure/block/list/stark/add','admin/structure/block/list/stark/add','Add block','a:0:{}','system','-1','0','0','0','0','5','0','1','21','31','145','152','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','153','146','admin/config/regional/date-time/types/add','admin/config/regional/date-time/types/add','Add date type','a:1:{s:10:"attributes";a:1:{s:5:"title";s:18:"Add new date type.";}}','system','-1','0','0','0','-10','6','0','1','8','52','100','146','153','0','0','0','0'),('management','154','137','admin/config/regional/date-time/formats/add','admin/config/regional/date-time/formats/add','Add format','a:1:{s:10:"attributes";a:1:{s:5:"title";s:43:"Allow users to add additional date formats.";}}','system','-1','0','0','0','-10','6','0','1','8','52','100','137','154','0','0','0','0'),('management','155','134','admin/structure/menu/manage/%/add','admin/structure/menu/manage/%/add','Add link','a:0:{}','system','-1','0','0','0','0','5','0','1','21','48','134','155','0','0','0','0','0'),('management','156','31','admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Configure block','a:0:{}','system','0','0','0','0','0','4','0','1','21','31','156','0','0','0','0','0','0'),('navigation','157','32','user/%/cancel/confirm/%/%','user/%/cancel/confirm/%/%','Confirm account cancellation','a:0:{}','system','0','0','0','0','0','3','0','17','32','157','0','0','0','0','0','0','0'),('management','158','136','admin/structure/types/manage/%/delete','admin/structure/types/manage/%/delete','Delete','a:0:{}','system','0','0','0','0','0','5','0','1','21','37','136','158','0','0','0','0','0'),('management','159','105','admin/config/people/ip-blocking/delete/%','admin/config/people/ip-blocking/delete/%','Delete IP address','a:0:{}','system','0','0','0','0','0','5','0','1','8','49','105','159','0','0','0','0','0'),('management','160','92','admin/config/system/actions/delete/%','admin/config/system/actions/delete/%','Delete action','a:1:{s:10:"attributes";a:1:{s:5:"title";s:17:"Delete an action.";}}','system','0','0','0','0','0','5','0','1','8','57','92','160','0','0','0','0','0'),('management','161','134','admin/structure/menu/manage/%/delete','admin/structure/menu/manage/%/delete','Delete menu','a:0:{}','system','0','0','0','0','0','5','0','1','21','48','134','161','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','162','48','admin/structure/menu/item/%/delete','admin/structure/menu/item/%/delete','Delete menu link','a:0:{}','system','0','0','0','0','0','4','0','1','21','48','162','0','0','0','0','0','0'),('management','163','119','admin/people/permissions/roles/delete/%','admin/people/permissions/roles/delete/%','Delete role','a:0:{}','system','0','0','0','0','0','5','0','1','18','50','119','163','0','0','0','0','0'),('management','164','128','admin/config/content/formats/%/disable','admin/config/content/formats/%/disable','Disable text format','a:0:{}','system','0','0','0','0','0','6','0','1','8','36','124','128','164','0','0','0','0'),('management','165','136','admin/structure/types/manage/%/edit','admin/structure/types/manage/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','5','0','1','21','37','136','165','0','0','0','0','0'),('management','166','134','admin/structure/menu/manage/%/edit','admin/structure/menu/manage/%/edit','Edit menu','a:0:{}','system','-1','0','0','0','0','5','0','1','21','48','134','166','0','0','0','0','0'),('management','167','48','admin/structure/menu/item/%/edit','admin/structure/menu/item/%/edit','Edit menu link','a:0:{}','system','0','0','0','0','0','4','0','1','21','48','167','0','0','0','0','0','0'),('management','168','119','admin/people/permissions/roles/edit/%','admin/people/permissions/roles/edit/%','Edit role','a:0:{}','system','0','0','0','0','0','5','0','1','18','50','119','168','0','0','0','0','0'),('management','169','106','admin/config/media/image-styles/edit/%','admin/config/media/image-styles/edit/%','Edit style','a:1:{s:10:"attributes";a:1:{s:5:"title";s:25:"Configure an image style.";}}','system','0','0','1','0','0','5','0','1','8','47','106','169','0','0','0','0','0'),('management','170','134','admin/structure/menu/manage/%/list','admin/structure/menu/manage/%/list','List links','a:0:{}','system','-1','0','0','0','-10','5','0','1','21','48','134','170','0','0','0','0','0'),('management','171','48','admin/structure/menu/item/%/reset','admin/structure/menu/item/%/reset','Reset menu link','a:0:{}','system','0','0','0','0','0','4','0','1','21','48','171','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','172','106','admin/config/media/image-styles/delete/%','admin/config/media/image-styles/delete/%','Delete style','a:1:{s:10:"attributes";a:1:{s:5:"title";s:22:"Delete an image style.";}}','system','0','0','0','0','0','5','0','1','8','47','106','172','0','0','0','0','0'),('management','173','106','admin/config/media/image-styles/revert/%','admin/config/media/image-styles/revert/%','Revert style','a:1:{s:10:"attributes";a:1:{s:5:"title";s:22:"Revert an image style.";}}','system','0','0','0','0','0','5','0','1','8','47','106','173','0','0','0','0','0'),('management','174','136','admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%/comment/display','Comment display','a:0:{}','system','-1','0','0','0','4','5','0','1','21','37','136','174','0','0','0','0','0'),('management','175','136','admin/structure/types/manage/%/comment/fields','admin/structure/types/manage/%/comment/fields','Comment fields','a:0:{}','system','-1','0','1','0','3','5','0','1','21','37','136','175','0','0','0','0','0'),('management','176','156','admin/structure/block/manage/%/%/configure','admin/structure/block/manage/%/%/configure','Configure block','a:0:{}','system','-1','0','0','0','0','5','0','1','21','31','156','176','0','0','0','0','0'),('management','177','156','admin/structure/block/manage/%/%/delete','admin/structure/block/manage/%/%/delete','Delete block','a:0:{}','system','-1','0','0','0','0','5','0','1','21','31','156','177','0','0','0','0','0'),('management','178','137','admin/config/regional/date-time/formats/%/delete','admin/config/regional/date-time/formats/%/delete','Delete date format','a:1:{s:10:"attributes";a:1:{s:5:"title";s:47:"Allow users to delete a configured date format.";}}','system','0','0','0','0','0','6','0','1','8','52','100','137','178','0','0','0','0'),('management','179','146','admin/config/regional/date-time/types/%/delete','admin/config/regional/date-time/types/%/delete','Delete date type','a:1:{s:10:"attributes";a:1:{s:5:"title";s:45:"Allow users to delete a configured date type.";}}','system','0','0','0','0','0','6','0','1','8','52','100','146','179','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','180','137','admin/config/regional/date-time/formats/%/edit','admin/config/regional/date-time/formats/%/edit','Edit date format','a:1:{s:10:"attributes";a:1:{s:5:"title";s:45:"Allow users to edit a configured date format.";}}','system','0','0','0','0','0','6','0','1','8','52','100','137','180','0','0','0','0'),('management','181','169','admin/config/media/image-styles/edit/%/add/%','admin/config/media/image-styles/edit/%/add/%','Add image effect','a:1:{s:10:"attributes";a:1:{s:5:"title";s:28:"Add a new effect to a style.";}}','system','0','0','0','0','0','6','0','1','8','47','106','169','181','0','0','0','0'),('management','182','169','admin/config/media/image-styles/edit/%/effects/%','admin/config/media/image-styles/edit/%/effects/%','Edit image effect','a:1:{s:10:"attributes";a:1:{s:5:"title";s:39:"Edit an existing effect within a style.";}}','system','0','0','1','0','0','6','0','1','8','47','106','169','182','0','0','0','0'),('management','183','182','admin/config/media/image-styles/edit/%/effects/%/delete','admin/config/media/image-styles/edit/%/effects/%/delete','Delete image effect','a:1:{s:10:"attributes";a:1:{s:5:"title";s:39:"Delete an existing effect from a style.";}}','system','0','0','0','0','0','7','0','1','8','47','106','169','182','183','0','0','0'),('management','184','48','admin/structure/menu/manage/main-menu','admin/structure/menu/manage/%','Main menu','a:0:{}','menu','0','0','0','0','0','4','0','1','21','48','184','0','0','0','0','0','0'),('management','185','48','admin/structure/menu/manage/management','admin/structure/menu/manage/%','Management','a:0:{}','menu','0','0','0','0','0','4','0','1','21','48','185','0','0','0','0','0','0'),('management','186','48','admin/structure/menu/manage/navigation','admin/structure/menu/manage/%','Navigation','a:0:{}','menu','0','0','0','0','0','4','0','1','21','48','186','0','0','0','0','0','0'),('management','187','48','admin/structure/menu/manage/user-menu','admin/structure/menu/manage/%','User menu','a:0:{}','menu','0','0','0','0','0','4','0','1','21','48','187','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','188','0','search','search','Search','a:0:{}','system','1','0','1','0','0','1','0','188','0','0','0','0','0','0','0','0','0'),('navigation','190','188','search/user','search/user','Users','a:0:{}','system','-1','0','0','0','-10','2','0','188','190','0','0','0','0','0','0','0','0'),('navigation','192','17','user/%/shortcuts','user/%/shortcuts','Shortcuts','a:0:{}','system','-1','0','0','0','0','2','0','17','192','0','0','0','0','0','0','0','0'),('management','193','19','admin/reports/search','admin/reports/search','Top search phrases','a:1:{s:10:"attributes";a:1:{s:5:"title";s:33:"View most popular search phrases.";}}','system','0','0','0','0','0','3','0','1','19','193','0','0','0','0','0','0','0'),('navigation','194','190','search/user/%','search/user/%','Users','a:0:{}','system','-1','0','0','0','0','3','0','188','190','194','0','0','0','0','0','0','0'),('management','195','12','admin/help/number','admin/help/number','number','a:0:{}','system','-1','0','0','0','0','3','0','1','12','195','0','0','0','0','0','0','0'),('management','197','12','admin/help/path','admin/help/path','path','a:0:{}','system','-1','0','0','0','0','3','0','1','12','197','0','0','0','0','0','0','0'),('management','198','12','admin/help/search','admin/help/search','search','a:0:{}','system','-1','0','0','0','0','3','0','1','12','198','0','0','0','0','0','0','0'),('management','199','12','admin/help/shortcut','admin/help/shortcut','shortcut','a:0:{}','system','-1','0','0','0','0','3','0','1','12','199','0','0','0','0','0','0','0'),('management','200','54','admin/config/search/settings','admin/config/search/settings','Search settings','a:1:{s:10:"attributes";a:1:{s:5:"title";s:67:"Configure relevance settings for search and other indexing options.";}}','system','0','0','0','0','-10','4','0','1','8','54','200','0','0','0','0','0','0'),('management','201','62','admin/config/user-interface/shortcut','admin/config/user-interface/shortcut','Shortcuts','a:1:{s:10:"attributes";a:1:{s:5:"title";s:29:"Add and modify shortcut sets.";}}','system','0','0','1','0','0','4','0','1','8','62','201','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','202','54','admin/config/search/path','admin/config/search/path','URL aliases','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"Change your site''s URL paths by aliasing them.";}}','system','0','0','1','0','-5','4','0','1','8','54','202','0','0','0','0','0','0'),('management','203','202','admin/config/search/path/add','admin/config/search/path/add','Add alias','a:0:{}','system','-1','0','0','0','0','5','0','1','8','54','202','203','0','0','0','0','0'),('management','204','201','admin/config/user-interface/shortcut/add-set','admin/config/user-interface/shortcut/add-set','Add shortcut set','a:0:{}','system','-1','0','0','0','0','5','0','1','8','62','201','204','0','0','0','0','0'),('management','205','200','admin/config/search/settings/reindex','admin/config/search/settings/reindex','Clear index','a:0:{}','system','-1','0','0','0','0','5','0','1','8','54','200','205','0','0','0','0','0'),('management','206','201','admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Edit shortcuts','a:0:{}','system','0','0','1','0','0','5','0','1','8','62','201','206','0','0','0','0','0'),('management','207','202','admin/config/search/path/list','admin/config/search/path/list','List','a:0:{}','system','-1','0','0','0','-10','5','0','1','8','54','202','207','0','0','0','0','0'),('management','208','206','admin/config/user-interface/shortcut/%/add-link','admin/config/user-interface/shortcut/%/add-link','Add shortcut','a:0:{}','system','-1','0','0','0','0','6','0','1','8','62','201','206','208','0','0','0','0'),('management','209','202','admin/config/search/path/delete/%','admin/config/search/path/delete/%','Delete alias','a:0:{}','system','0','0','0','0','0','5','0','1','8','54','202','209','0','0','0','0','0'),('management','210','206','admin/config/user-interface/shortcut/%/delete','admin/config/user-interface/shortcut/%/delete','Delete shortcut set','a:0:{}','system','0','0','0','0','0','6','0','1','8','62','201','206','210','0','0','0','0'),('management','211','202','admin/config/search/path/edit/%','admin/config/search/path/edit/%','Edit alias','a:0:{}','system','0','0','0','0','0','5','0','1','8','54','202','211','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','212','206','admin/config/user-interface/shortcut/%/edit','admin/config/user-interface/shortcut/%/edit','Edit set name','a:0:{}','system','-1','0','0','0','10','6','0','1','8','62','201','206','212','0','0','0','0'),('management','213','201','admin/config/user-interface/shortcut/link/%','admin/config/user-interface/shortcut/link/%','Edit shortcut','a:0:{}','system','0','0','1','0','0','5','0','1','8','62','201','213','0','0','0','0','0'),('management','214','206','admin/config/user-interface/shortcut/%/links','admin/config/user-interface/shortcut/%/links','List links','a:0:{}','system','-1','0','0','0','0','6','0','1','8','62','201','206','214','0','0','0','0'),('management','215','213','admin/config/user-interface/shortcut/link/%/delete','admin/config/user-interface/shortcut/link/%/delete','Delete shortcut','a:0:{}','system','0','0','0','0','0','6','0','1','8','62','201','213','215','0','0','0','0'),('shortcut-set-1','216','0','node/add','node/add','Add content','a:0:{}','menu','0','0','0','0','-20','1','0','216','0','0','0','0','0','0','0','0','0'),('shortcut-set-1','217','0','admin/content','admin/content','Find content','a:0:{}','menu','0','0','0','0','-19','1','0','217','0','0','0','0','0','0','0','0','0'),('main-menu','218','0','<front>','','Home','a:0:{}','menu','0','1','0','0','-50','1','1','218','0','0','0','0','0','0','0','0','0'),('navigation','219','6','node/add/article','node/add/article','Article','a:1:{s:10:"attributes";a:1:{s:5:"title";s:89:"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.";}}','system','0','0','0','0','0','2','0','6','219','0','0','0','0','0','0','0','0'),('navigation','220','6','node/add/page','node/add/page','Basic page','a:1:{s:10:"attributes";a:1:{s:5:"title";s:77:"Use <em>basic pages</em> for your static content, such as an ''About us'' page.";}}','system','0','0','0','0','0','2','0','6','220','0','0','0','0','0','0','0','0'),('management','221','12','admin/help/rdf','admin/help/rdf','rdf','a:0:{}','system','-1','0','0','0','0','3','0','1','12','221','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','299','90','admin/structure/taxonomy/%/display','admin/structure/taxonomy/%/display','Manage display','a:0:{}','system','-1','0','0','0','2','5','0','1','21','58','90','299','0','0','0','0','0'),('management','300','91','admin/config/people/accounts/display','admin/config/people/accounts/display','Manage display','a:0:{}','system','-1','0','0','0','2','5','0','1','8','49','91','300','0','0','0','0','0'),('management','301','90','admin/structure/taxonomy/%/fields','admin/structure/taxonomy/%/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','5','0','1','21','58','90','301','0','0','0','0','0'),('management','302','91','admin/config/people/accounts/fields','admin/config/people/accounts/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','5','0','1','8','49','91','302','0','0','0','0','0'),('management','303','299','admin/structure/taxonomy/%/display/default','admin/structure/taxonomy/%/display/default','Default','a:0:{}','system','-1','0','0','0','-10','6','0','1','21','58','90','299','303','0','0','0','0'),('management','304','300','admin/config/people/accounts/display/default','admin/config/people/accounts/display/default','Default','a:0:{}','system','-1','0','0','0','-10','6','0','1','8','49','91','300','304','0','0','0','0'),('management','305','136','admin/structure/types/manage/%/display','admin/structure/types/manage/%/display','Manage display','a:0:{}','system','-1','0','0','0','2','5','0','1','21','37','136','305','0','0','0','0','0'),('management','306','136','admin/structure/types/manage/%/fields','admin/structure/types/manage/%/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','5','0','1','21','37','136','306','0','0','0','0','0'),('management','307','299','admin/structure/taxonomy/%/display/full','admin/structure/taxonomy/%/display/full','Taxonomy term page','a:0:{}','system','-1','0','0','0','0','6','0','1','21','58','90','299','307','0','0','0','0'),('management','308','300','admin/config/people/accounts/display/full','admin/config/people/accounts/display/full','User account','a:0:{}','system','-1','0','0','0','0','6','0','1','8','49','91','300','308','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','309','301','admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','','a:0:{}','system','0','0','0','0','0','6','0','1','21','58','90','301','309','0','0','0','0'),('management','310','302','admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','','a:0:{}','system','0','0','0','0','0','6','0','1','8','49','91','302','310','0','0','0','0'),('management','311','305','admin/structure/types/manage/%/display/default','admin/structure/types/manage/%/display/default','Default','a:0:{}','system','-1','0','0','0','-10','6','0','1','21','37','136','305','311','0','0','0','0'),('management','312','305','admin/structure/types/manage/%/display/full','admin/structure/types/manage/%/display/full','Full content','a:0:{}','system','-1','0','0','0','0','6','0','1','21','37','136','305','312','0','0','0','0'),('management','313','305','admin/structure/types/manage/%/display/rss','admin/structure/types/manage/%/display/rss','RSS','a:0:{}','system','-1','0','0','0','2','6','0','1','21','37','136','305','313','0','0','0','0'),('management','314','305','admin/structure/types/manage/%/display/search_index','admin/structure/types/manage/%/display/search_index','Search index','a:0:{}','system','-1','0','0','0','3','6','0','1','21','37','136','305','314','0','0','0','0'),('management','315','305','admin/structure/types/manage/%/display/search_result','admin/structure/types/manage/%/display/search_result','Search result highlighting input','a:0:{}','system','-1','0','0','0','4','6','0','1','21','37','136','305','315','0','0','0','0'),('management','316','305','admin/structure/types/manage/%/display/teaser','admin/structure/types/manage/%/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','6','0','1','21','37','136','305','316','0','0','0','0'),('management','317','306','admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','','a:0:{}','system','0','0','0','0','0','6','0','1','21','37','136','306','317','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','318','309','admin/structure/taxonomy/%/fields/%/delete','admin/structure/taxonomy/%/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','7','0','1','21','58','90','301','309','318','0','0','0'),('management','319','309','admin/structure/taxonomy/%/fields/%/edit','admin/structure/taxonomy/%/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','7','0','1','21','58','90','301','309','319','0','0','0'),('management','320','309','admin/structure/taxonomy/%/fields/%/field-settings','admin/structure/taxonomy/%/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','7','0','1','21','58','90','301','309','320','0','0','0'),('management','321','309','admin/structure/taxonomy/%/fields/%/widget-type','admin/structure/taxonomy/%/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','7','0','1','21','58','90','301','309','321','0','0','0'),('management','322','310','admin/config/people/accounts/fields/%/delete','admin/config/people/accounts/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','7','0','1','8','49','91','302','310','322','0','0','0'),('management','323','310','admin/config/people/accounts/fields/%/edit','admin/config/people/accounts/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','7','0','1','8','49','91','302','310','323','0','0','0'),('management','324','310','admin/config/people/accounts/fields/%/field-settings','admin/config/people/accounts/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','7','0','1','8','49','91','302','310','324','0','0','0'),('management','325','310','admin/config/people/accounts/fields/%/widget-type','admin/config/people/accounts/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','7','0','1','8','49','91','302','310','325','0','0','0'),('management','326','174','admin/structure/types/manage/%/comment/display/default','admin/structure/types/manage/%/comment/display/default','Default','a:0:{}','system','-1','0','0','0','-10','6','0','1','21','37','136','174','326','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','327','174','admin/structure/types/manage/%/comment/display/full','admin/structure/types/manage/%/comment/display/full','Full comment','a:0:{}','system','-1','0','0','0','0','6','0','1','21','37','136','174','327','0','0','0','0'),('management','328','317','admin/structure/types/manage/%/fields/%/delete','admin/structure/types/manage/%/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','7','0','1','21','37','136','306','317','328','0','0','0'),('management','329','317','admin/structure/types/manage/%/fields/%/edit','admin/structure/types/manage/%/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','7','0','1','21','37','136','306','317','329','0','0','0'),('management','330','175','admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','','a:0:{}','system','0','0','0','0','0','6','0','1','21','37','136','175','330','0','0','0','0'),('management','331','317','admin/structure/types/manage/%/fields/%/field-settings','admin/structure/types/manage/%/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','7','0','1','21','37','136','306','317','331','0','0','0'),('management','332','317','admin/structure/types/manage/%/fields/%/widget-type','admin/structure/types/manage/%/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','7','0','1','21','37','136','306','317','332','0','0','0'),('management','333','330','admin/structure/types/manage/%/comment/fields/%/delete','admin/structure/types/manage/%/comment/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','7','0','1','21','37','136','175','330','333','0','0','0'),('management','334','330','admin/structure/types/manage/%/comment/fields/%/edit','admin/structure/types/manage/%/comment/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','7','0','1','21','37','136','175','330','334','0','0','0'),('management','335','330','admin/structure/types/manage/%/comment/fields/%/field-settings','admin/structure/types/manage/%/comment/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','7','0','1','21','37','136','175','330','335','0','0','0');
INSERT INTO `menu_links` VALUES ('management','336','330','admin/structure/types/manage/%/comment/fields/%/widget-type','admin/structure/types/manage/%/comment/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','7','0','1','21','37','136','175','330','336','0','0','0'),('management','337','55','admin/appearance/settings/adaptivetheme_admin','admin/appearance/settings/adaptivetheme_admin','AT Admin','a:0:{}','system','-1','0','0','0','0','4','0','1','7','55','337','0','0','0','0','0','0'),('management','338','55','admin/appearance/settings/adaptivetheme','admin/appearance/settings/adaptivetheme','AT Core','a:0:{}','system','-1','0','0','0','0','4','0','1','7','55','338','0','0','0','0','0','0'),('management','339','55','admin/appearance/settings/adaptivetheme_subtheme','admin/appearance/settings/adaptivetheme_subtheme','AT Subtheme','a:0:{}','system','-1','0','0','0','0','4','0','1','7','55','339','0','0','0','0','0','0'),('management','340','55','admin/appearance/settings/corolla','admin/appearance/settings/corolla','Corolla','a:0:{}','system','-1','0','0','0','0','4','0','1','7','55','340','0','0','0','0','0','0'),('management','341','55','admin/appearance/settings/skeletontheme','admin/appearance/settings/skeletontheme','Skeleton','a:0:{}','system','-1','0','0','0','0','4','0','1','7','55','341','0','0','0','0','0','0'),('management','342','31','admin/structure/block/list/adaptivetheme_admin','admin/structure/block/list/adaptivetheme_admin','AT Admin','a:0:{}','system','-1','0','0','0','0','4','0','1','21','31','342','0','0','0','0','0','0'),('management','343','31','admin/structure/block/list/adaptivetheme','admin/structure/block/list/adaptivetheme','AT Core','a:0:{}','system','-1','0','0','0','0','4','0','1','21','31','343','0','0','0','0','0','0'),('management','344','31','admin/structure/block/list/adaptivetheme_subtheme','admin/structure/block/list/adaptivetheme_subtheme','AT Subtheme','a:0:{}','system','-1','0','0','0','0','4','0','1','21','31','344','0','0','0','0','0','0'),('management','345','31','admin/structure/block/list/corolla','admin/structure/block/list/corolla','Corolla','a:0:{}','system','-1','0','0','0','0','4','0','1','21','31','345','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','346','31','admin/structure/block/list/skeletontheme','admin/structure/block/list/skeletontheme','Skeleton','a:0:{}','system','-1','0','0','0','0','4','0','1','21','31','346','0','0','0','0','0','0'),('management','347','343','admin/structure/block/list/adaptivetheme/add','admin/structure/block/list/adaptivetheme/add','Add block','a:0:{}','system','-1','0','0','0','0','5','0','1','21','31','343','347','0','0','0','0','0'),('management','348','342','admin/structure/block/list/adaptivetheme_admin/add','admin/structure/block/list/adaptivetheme_admin/add','Add block','a:0:{}','system','-1','0','0','0','0','5','0','1','21','31','342','348','0','0','0','0','0'),('management','349','344','admin/structure/block/list/adaptivetheme_subtheme/add','admin/structure/block/list/adaptivetheme_subtheme/add','Add block','a:0:{}','system','-1','0','0','0','0','5','0','1','21','31','344','349','0','0','0','0','0'),('management','350','345','admin/structure/block/list/corolla/add','admin/structure/block/list/corolla/add','Add block','a:0:{}','system','-1','0','0','0','0','5','0','1','21','31','345','350','0','0','0','0','0'),('management','351','346','admin/structure/block/list/skeletontheme/add','admin/structure/block/list/skeletontheme/add','Add block','a:0:{}','system','-1','0','0','0','0','5','0','1','21','31','346','351','0','0','0','0','0'),('management','352','55','admin/appearance/settings/bookpoints_custom','admin/appearance/settings/bookpoints_custom','Bookpoints Customizable','a:0:{}','system','-1','0','0','0','0','4','0','1','7','55','352','0','0','0','0','0','0'),('management','353','31','admin/structure/block/list/bookpoints_custom','admin/structure/block/list/bookpoints_custom','Bookpoints Customizable','a:0:{}','system','-1','0','0','0','-10','4','0','1','21','31','353','0','0','0','0','0','0'),('management','355','132','admin/structure/block/list/bartik/add','admin/structure/block/list/bartik/add','Add block','a:0:{}','system','-1','0','0','0','0','5','0','1','21','31','132','355','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('devel','357','0','devel/settings','devel/settings','Devel settings','a:1:{s:10:"attributes";a:1:{s:5:"title";s:168:"Helper functions, pages, and blocks to assist Drupal developers. The devel blocks can be managed via the <a href="/admin/structure/block">block administration</a> page.";}}','system','0','0','0','0','0','1','0','357','0','0','0','0','0','0','0','0','0'),('devel','358','0','devel/php','devel/php','Execute PHP Code','a:1:{s:10:"attributes";a:1:{s:5:"title";s:21:"Execute some PHP code";}}','system','0','0','0','0','0','1','0','358','0','0','0','0','0','0','0','0','0'),('devel','359','0','devel/reference','devel/reference','Function reference','a:1:{s:10:"attributes";a:1:{s:5:"title";s:73:"View a list of currently defined user functions with documentation links.";}}','system','0','0','0','0','0','1','0','359','0','0','0','0','0','0','0','0','0'),('devel','360','0','devel/elements','devel/elements','Hook_elements()','a:1:{s:10:"attributes";a:1:{s:5:"title";s:51:"View the active form/render elements for this site.";}}','system','0','0','0','0','0','1','0','360','0','0','0','0','0','0','0','0','0'),('devel','361','0','devel/phpinfo','devel/phpinfo','PHPinfo()','a:1:{s:10:"attributes";a:1:{s:5:"title";s:36:"View your server''s PHP configuration";}}','system','0','0','0','0','0','1','0','361','0','0','0','0','0','0','0','0','0'),('devel','362','0','devel/reinstall','devel/reinstall','Reinstall modules','a:2:{s:10:"attributes";a:1:{s:5:"title";s:64:"Run hook_uninstall() and then hook_install() for a given module.";}s:5:"alter";b:1;}','system','0','0','0','0','0','1','0','362','0','0','0','0','0','0','0','0','0'),('devel','363','0','devel/run-cron','devel/run-cron','Run cron','a:0:{}','system','0','0','0','0','0','1','0','363','0','0','0','0','0','0','0','0','0'),('devel','364','0','devel/session','devel/session','Session viewer','a:1:{s:10:"attributes";a:1:{s:5:"title";s:31:"List the contents of $_SESSION.";}}','system','0','0','0','0','0','1','0','364','0','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('devel','365','0','devel/variable','devel/variable','Variable editor','a:2:{s:10:"attributes";a:1:{s:5:"title";s:31:"Edit and delete site variables.";}s:5:"alter";b:1;}','system','0','0','0','0','0','1','0','365','0','0','0','0','0','0','0','0','0'),('navigation','367','0','eform/%/confirm','eform/%/confirm','','a:0:{}','system','0','0','0','0','0','1','0','367','0','0','0','0','0','0','0','0','0'),('navigation','368','0','eform/%/submissions','eform/%/submissions','','a:0:{}','system','0','0','0','0','0','1','0','368','0','0','0','0','0','0','0','0','0'),('navigation','369','0','entityform/%/delete','entityform/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','1','0','369','0','0','0','0','0','0','0','0','0'),('navigation','370','0','entityform/%/edit','entityform/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','1','0','370','0','0','0','0','0','0','0','0','0'),('navigation','371','0','eform/%/draft','eform/%/draft','Form Saved','a:0:{}','system','0','0','0','0','0','1','0','371','0','0','0','0','0','0','0','0','0'),('navigation','372','0','entityform/%/view','entityform/%/view','View','a:0:{}','system','-1','0','0','0','-10','1','0','372','0','0','0','0','0','0','0','0','0'),('navigation','373','188','search/advanced_help/%','search/advanced_help/%','','a:0:{}','system','0','0','0','0','0','2','0','188','373','0','0','0','0','0','0','0','0'),('management','374','12','admin/help/ah','admin/help/ah','Advanced Help','a:0:{}','system','-1','0','0','0','2','3','0','1','12','374','0','0','0','0','0','0','0'),('devel','375','0','devel/cache/clear','devel/cache/clear','Clear cache','a:2:{s:10:"attributes";a:1:{s:5:"title";s:100:"Clear the CSS cache and all database cache tables which store page, node, theme and variable caches.";}s:5:"alter";b:1;}','system','0','0','0','0','0','1','0','375','0','0','0','0','0','0','0','0','0'),('navigation','376','3','comment/%/devel','comment/%/devel','Devel','a:0:{}','system','-1','0','0','0','100','2','0','3','376','0','0','0','0','0','0','0','0'),('navigation','377','5','node/%/devel','node/%/devel','Devel','a:0:{}','system','-1','0','0','0','100','2','0','5','377','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','379','17','user/%/devel','user/%/devel','Devel','a:0:{}','system','-1','0','0','0','100','2','0','17','379','0','0','0','0','0','0','0','0'),('navigation','380','0','workflow_transition/%/edit','workflow_transition/%/edit','Edit workflow log comment','a:1:{s:10:"attributes";a:1:{s:5:"title";s:33:"Edit workflow transition comment.";}}','system','0','0','0','0','0','1','0','380','0','0','0','0','0','0','0','0','0'),('management','381','21','admin/structure/entity-blocks','admin/structure/entity-blocks','Entity blocks','a:1:{s:10:"attributes";a:1:{s:5:"title";s:25:"Administer entity blocks.";}}','system','0','0','1','0','0','3','0','1','21','381','0','0','0','0','0','0','0'),('devel','382','0','devel/entity/info','devel/entity/info','Entity info','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"View entity information across the whole site.";}}','system','0','0','0','0','0','1','0','382','0','0','0','0','0','0','0','0','0'),('management','383','21','admin/structure/entity-type','admin/structure/entity-type','Entity types','a:1:{s:10:"attributes";a:1:{s:5:"title";s:53:"A centralized administrative section for entity types";}}','system','0','0','1','0','0','3','0','1','21','383','0','0','0','0','0','0','0'),('management','384','21','admin/structure/entityform_types','admin/structure/entityform_types','Entityform Types','a:1:{s:10:"attributes";a:1:{s:5:"title";s:95:"Manage entityform entity types, including adding and removing fields and the display of fields.";}}','system','0','0','1','0','0','3','0','1','21','384','0','0','0','0','0','0','0'),('management','385','21','admin/structure/features','admin/structure/features','Features','a:1:{s:10:"attributes";a:1:{s:5:"title";s:16:"Manage features.";}}','system','0','0','0','0','0','3','0','1','21','385','0','0','0','0','0','0','0'),('management','386','21','admin/structure/field-collections','admin/structure/field-collections','Field collections','a:1:{s:10:"attributes";a:1:{s:5:"title";s:35:"Manage fields on field collections.";}}','system','0','0','1','0','0','3','0','1','21','386','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('devel','387','0','devel/field/info','devel/field/info','Field info','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"View fields information across the whole site.";}}','system','0','0','0','0','0','1','0','387','0','0','0','0','0','0','0','0','0'),('management','388','12','admin/help/tab1','admin/help/tab1','Help','a:0:{}','system','-1','0','0','0','0','3','0','1','12','388','0','0','0','0','0','0','0'),('management','389','19','admin/reports/libraries','admin/reports/libraries','Libraries','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"An overview of libraries installed on this site.";}}','system','0','0','1','0','0','3','0','1','19','389','0','0','0','0','0','0','0'),('devel','390','0','devel/menu/item','devel/menu/item','Menu item','a:2:{s:10:"attributes";a:1:{s:5:"title";s:32:"Details about a given menu item.";}s:5:"alter";b:1;}','system','0','0','0','0','0','1','0','390','0','0','0','0','0','0','0','0','0'),('devel','392','0','devel/menu/reset','devel/menu/reset','Rebuild menus','a:2:{s:10:"attributes";a:1:{s:5:"title";s:113:"Rebuild menu based on hook_menu() and revert any custom changes. All menu items return to their default settings.";}s:5:"alter";b:1;}','system','0','0','0','0','0','1','0','392','0','0','0','0','0','0','0','0','0'),('devel','393','0','devel/theme/registry','devel/theme/registry','Theme registry','a:1:{s:10:"attributes";a:1:{s:5:"title";s:63:"View a list of available theme functions across the whole site.";}}','system','0','0','0','0','0','1','0','393','0','0','0','0','0','0','0','0','0'),('management','394','21','admin/structure/views','admin/structure/views','Views','a:1:{s:10:"attributes";a:1:{s:5:"title";s:35:"Manage customized lists of content.";}}','system','0','0','1','0','0','3','0','1','21','394','0','0','0','0','0','0','0'),('management','395','19','admin/reports/views-plugins','admin/reports/views-plugins','Views plugins','a:1:{s:10:"attributes";a:1:{s:5:"title";s:38:"Overview of plugins used in all views.";}}','system','0','0','0','0','0','3','0','1','19','395','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','396','12','admin/help/devel','admin/help/devel','devel','a:0:{}','system','-1','0','0','0','0','3','0','1','12','396','0','0','0','0','0','0','0'),('management','397','12','admin/help/entityform','admin/help/entityform','entityform','a:0:{}','system','-1','0','0','0','0','3','0','1','12','397','0','0','0','0','0','0','0'),('management','398','12','admin/help/features','admin/help/features','features','a:0:{}','system','-1','0','0','0','0','3','0','1','12','398','0','0','0','0','0','0','0'),('management','399','12','admin/help/field_collection','admin/help/field_collection','field_collection','a:0:{}','system','-1','0','0','0','0','3','0','1','12','399','0','0','0','0','0','0','0'),('management','400','12','admin/help/googleanalytics','admin/help/googleanalytics','googleanalytics','a:0:{}','system','-1','0','0','0','0','3','0','1','12','400','0','0','0','0','0','0','0'),('management','401','12','admin/help/jquery_update','admin/help/jquery_update','jquery_update','a:0:{}','system','-1','0','0','0','0','3','0','1','12','401','0','0','0','0','0','0','0'),('management','402','12','admin/help/libraries','admin/help/libraries','libraries','a:0:{}','system','-1','0','0','0','0','3','0','1','12','402','0','0','0','0','0','0','0'),('management','403','12','admin/help/pathauto','admin/help/pathauto','pathauto','a:0:{}','system','-1','0','0','0','0','3','0','1','12','403','0','0','0','0','0','0','0'),('management','404','12','admin/help/rules','admin/help/rules','rules','a:0:{}','system','-1','0','0','0','0','3','0','1','12','404','0','0','0','0','0','0','0'),('management','405','12','admin/help/token','admin/help/token','token','a:0:{}','system','-1','0','0','0','0','3','0','1','12','405','0','0','0','0','0','0','0'),('management','406','12','admin/help/workflow','admin/help/workflow','workflow','a:0:{}','system','-1','0','0','0','0','3','0','1','12','406','0','0','0','0','0','0','0'),('management','407','12','admin/help/workflow_admin_ui','admin/help/workflow_admin_ui','workflow_admin_ui','a:0:{}','system','-1','0','0','0','0','3','0','1','12','407','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','411','19','admin/reports/entityforms','admin/reports/entityforms','Entityform Submissions','a:1:{s:10:"attributes";a:1:{s:5:"title";s:36:"View Submissions for all Entityforms";}}','system','0','0','0','0','0','3','0','1','19','411','0','0','0','0','0','0','0'),('management','412','0','entityform-submissions/submissions/%','entityform-submissions/submissions/%','Submissions','a:0:{}','system','0','0','0','0','0','1','0','412','0','0','0','0','0','0','0','0','0'),('management','413','0','entityform-user-submissions/submissions/%','entityform-user-submissions/submissions/%','Submissions','a:0:{}','system','0','0','0','0','0','1','0','413','0','0','0','0','0','0','0','0','0'),('navigation','414','0','help/ah/search/%','help/ah/search/%','Search help','a:0:{}','system','0','0','0','0','0','1','0','414','0','0','0','0','0','0','0','0','0'),('management','415','384','admin/structure/entityform_types/add','admin/structure/entityform_types/add','','a:0:{}','system','-1','0','0','0','0','4','0','1','21','384','415','0','0','0','0','0','0'),('management','417','384','admin/structure/entityform_types/import','admin/structure/entityform_types/import','','a:0:{}','system','-1','0','0','0','0','4','0','1','21','384','417','0','0','0','0','0','0'),('management','419','383','admin/structure/entity-type/add','admin/structure/entity-type/add','Add entity type','a:1:{s:10:"attributes";a:1:{s:5:"title";s:21:"Add a new entity type";}}','system','-1','0','0','0','-1','4','0','1','21','383','419','0','0','0','0','0','0'),('management','420','394','admin/structure/views/add','admin/structure/views/add','Add new view','a:0:{}','system','-1','0','0','0','0','4','0','1','21','394','420','0','0','0','0','0','0'),('management','421','394','admin/structure/views/add-template','admin/structure/views/add-template','Add view from template','a:0:{}','system','-1','0','0','0','0','4','0','1','21','394','421','0','0','0','0','0','0'),('management','422','385','admin/structure/features/create','admin/structure/features/create','Create feature','a:1:{s:10:"attributes";a:1:{s:5:"title";s:21:"Create a new feature.";}}','system','-1','0','0','0','10','4','0','1','21','385','422','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','423','28','taxonomy/term/%/devel','taxonomy/term/%/devel','Devel','a:0:{}','system','-1','0','0','0','100','2','0','28','423','0','0','0','0','0','0','0','0'),('management','424','40','admin/config/development/devel','admin/config/development/devel','Devel settings','a:1:{s:10:"attributes";a:1:{s:5:"title";s:168:"Helper functions, pages, and blocks to assist Drupal developers. The devel blocks can be managed via the <a href="/admin/structure/block">block administration</a> page.";}}','system','0','0','0','0','0','4','0','1','8','40','424','0','0','0','0','0','0'),('management','425','36','admin/config/content/entityform','admin/config/content/entityform','Entityform Settings','a:0:{}','system','0','0','0','0','0','4','0','1','8','36','425','0','0','0','0','0','0'),('management','426','21','admin/structure/entityforms/list','admin/structure/entityforms/list','Entityforms','a:1:{s:10:"attributes";a:1:{s:5:"title";s:32:"Add edit and update entityforms.";}}','system','-1','0','0','0','0','3','0','1','21','426','0','0','0','0','0','0','0'),('management','427','57','admin/config/system/googleanalytics','admin/config/system/googleanalytics','Google Analytics','a:1:{s:10:"attributes";a:1:{s:5:"title";s:98:"Configure tracking behavior to get insights into your website traffic and marketing effectiveness.";}}','system','0','0','0','0','0','4','0','1','8','57','427','0','0','0','0','0','0'),('management','428','394','admin/structure/views/import','admin/structure/views/import','Import','a:0:{}','system','-1','0','0','0','0','4','0','1','21','394','428','0','0','0','0','0','0'),('management','429','389','admin/reports/libraries/%','admin/reports/libraries/%','Library status report','a:1:{s:10:"attributes";a:1:{s:5:"title";s:36:"Status overview for a single library";}}','system','0','0','0','0','0','4','0','1','19','389','429','0','0','0','0','0','0'),('management','430','394','admin/structure/views/list','admin/structure/views/list','List','a:0:{}','system','-1','0','0','0','-10','4','0','1','21','394','430','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','431','43','admin/reports/fields/list','admin/reports/fields/list','List','a:0:{}','system','-1','0','0','0','-10','4','0','1','19','43','431','0','0','0','0','0','0'),('management','432','384','admin/structure/entityform_types/list','admin/structure/entityform_types/list','List','a:0:{}','system','-1','0','0','0','-10','4','0','1','21','384','432','0','0','0','0','0','0'),('navigation','434','376','comment/%/devel/load','comment/%/devel/load','Load','a:0:{}','system','-1','0','0','0','0','3','0','3','376','434','0','0','0','0','0','0','0'),('navigation','435','377','node/%/devel/load','node/%/devel/load','Load','a:0:{}','system','-1','0','0','0','0','3','0','5','377','435','0','0','0','0','0','0','0'),('navigation','436','379','user/%/devel/load','user/%/devel/load','Load','a:0:{}','system','-1','0','0','0','0','3','0','17','379','436','0','0','0','0','0','0','0'),('management','438','385','admin/structure/features/manage','admin/structure/features/manage','Manage','a:1:{s:10:"attributes";a:1:{s:5:"title";s:28:"Enable and disable features.";}}','system','-1','0','0','0','0','4','0','1','21','385','438','0','0','0','0','0','0'),('navigation','439','376','comment/%/devel/render','comment/%/devel/render','Render','a:0:{}','system','-1','0','0','0','100','3','0','3','376','439','0','0','0','0','0','0','0'),('navigation','440','377','node/%/devel/render','node/%/devel/render','Render','a:0:{}','system','-1','0','0','0','100','3','0','5','377','440','0','0','0','0','0','0','0'),('navigation','442','379','user/%/devel/render','user/%/devel/render','Render','a:0:{}','system','-1','0','0','0','100','3','0','17','379','442','0','0','0','0','0','0','0'),('management','443','66','admin/config/workflow/rules','admin/config/workflow/rules','Rules','a:1:{s:10:"attributes";a:1:{s:5:"title";s:42:"Manage reaction rules and rule components.";}}','system','0','0','0','0','0','4','0','1','8','66','443','0','0','0','0','0','0'),('management','444','385','admin/structure/features/settings','admin/structure/features/settings','Settings','a:1:{s:10:"attributes";a:1:{s:5:"title";s:42:"Adjust settings for using features module.";}}','system','-1','0','0','0','11','4','0','1','21','385','444','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','445','394','admin/structure/views/settings','admin/structure/views/settings','Settings','a:0:{}','system','-1','0','0','0','0','4','0','1','21','394','445','0','0','0','0','0','0'),('navigation','446','376','comment/%/devel/token','comment/%/devel/token','Tokens','a:0:{}','system','-1','0','0','0','5','3','0','3','376','446','0','0','0','0','0','0','0'),('navigation','447','377','node/%/devel/token','node/%/devel/token','Tokens','a:0:{}','system','-1','0','0','0','5','3','0','5','377','447','0','0','0','0','0','0','0'),('navigation','448','379','user/%/devel/token','user/%/devel/token','Tokens','a:0:{}','system','-1','0','0','0','5','3','0','17','379','448','0','0','0','0','0','0','0'),('management','449','43','admin/reports/fields/views-fields','admin/reports/fields/views-fields','Used in views','a:1:{s:10:"attributes";a:1:{s:5:"title";s:37:"Overview of fields used in all views.";}}','system','-1','0','0','0','0','4','0','1','19','43','449','0','0','0','0','0','0'),('management','450','66','admin/config/workflow/workflow','admin/config/workflow/workflow','Workflows','a:1:{s:10:"attributes";a:1:{s:5:"title";s:17:"Manage Workflows.";}}','system','0','0','1','0','0','4','0','1','8','66','450','0','0','0','0','0','0'),('management','451','40','admin/config/development/jquery_update','admin/config/development/jquery_update','jQuery update','a:1:{s:10:"attributes";a:1:{s:5:"title";s:83:"Configure settings related to the jQuery upgrade, the library path and compression.";}}','system','0','0','0','0','0','4','0','1','8','40','451','0','0','0','0','0','0'),('management','453','412','entityform-submissions/submissions/%/table','entityform-submissions/submissions/%/table','Table','a:1:{s:10:"attributes";a:1:{s:5:"title";s:36:"View Submissions for all Entityforms";}}','system','-1','0','0','0','0','2','0','412','453','0','0','0','0','0','0','0','0'),('management','454','412','entityform-submissions/submissions/%/list','entityform-submissions/submissions/%/list','List','a:1:{s:10:"attributes";a:1:{s:5:"title";s:36:"View Submissions for all Entityforms";}}','system','-1','0','0','0','0','2','0','412','454','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','455','413','entityform-user-submissions/submissions/%/list','entityform-user-submissions/submissions/%/list','List','a:1:{s:10:"attributes";a:1:{s:5:"title";s:36:"View Submissions for all Entityforms";}}','system','-1','0','0','0','0','2','0','413','455','0','0','0','0','0','0','0','0'),('management','456','450','admin/config/workflow/workflow/add','admin/config/workflow/workflow/add','','a:0:{}','system','-1','0','0','0','0','5','0','1','8','66','450','456','0','0','0','0','0'),('management','457','450','admin/config/workflow/workflow/import','admin/config/workflow/workflow/import','','a:0:{}','system','-1','0','0','0','0','5','0','1','8','66','450','457','0','0','0','0','0'),('management','458','411','admin/reports/entityforms/submissions/%','admin/reports/entityforms/submissions/%','','a:0:{}','system','-1','0','0','0','0','4','0','1','19','411','458','0','0','0','0','0','0'),('management','459','381','admin/structure/entity-blocks/manage/add','admin/structure/entity-blocks/manage/add','Add entity block','a:0:{}','system','-1','0','0','0','0','4','0','1','21','381','459','0','0','0','0','0','0'),('management','460','445','admin/structure/views/settings/advanced','admin/structure/views/settings/advanced','Advanced','a:0:{}','system','-1','0','0','0','1','5','0','1','21','394','445','460','0','0','0','0','0'),('management','461','445','admin/structure/views/settings/basic','admin/structure/views/settings/basic','Basic','a:0:{}','system','-1','0','0','0','0','5','0','1','21','394','445','461','0','0','0','0','0'),('management','462','202','admin/config/search/path/update_bulk','admin/config/search/path/update_bulk','Bulk generate','a:0:{}','system','-1','0','0','0','30','5','0','1','8','54','202','462','0','0','0','0','0'),('management','463','443','admin/config/workflow/rules/components','admin/config/workflow/rules/components','Components','a:0:{}','system','-1','0','0','0','0','5','0','1','8','66','443','463','0','0','0','0','0'),('management','464','202','admin/config/search/path/delete_bulk','admin/config/search/path/delete_bulk','Delete aliases','a:0:{}','system','-1','0','0','0','40','5','0','1','8','54','202','464','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','465','381','admin/structure/entity-blocks/%entity_block/edit','admin/structure/entity-blocks/%entity_block/edit','Edit','a:0:{}','system','0','0','0','0','0','4','0','1','21','381','465','0','0','0','0','0','0'),('management','466','450','admin/config/workflow/workflow/list','admin/config/workflow/workflow/list','List','a:0:{}','system','-1','0','0','0','-10','5','0','1','8','66','450','466','0','0','0','0','0'),('management','467','381','admin/structure/entity-blocks/manage/list','admin/structure/entity-blocks/manage/list','List','a:0:{}','system','-1','0','0','0','0','4','0','1','21','381','467','0','0','0','0','0','0'),('navigation','468','423','taxonomy/term/%/devel/load','taxonomy/term/%/devel/load','Load','a:0:{}','system','-1','0','0','0','0','3','0','28','423','468','0','0','0','0','0','0','0'),('management','469','381','admin/structure/entity-blocks/manage/display','admin/structure/entity-blocks/manage/display','Manage display','a:0:{}','system','-1','0','0','0','2','4','0','1','21','381','469','0','0','0','0','0','0'),('management','470','381','admin/structure/entity-blocks/manage/fields','admin/structure/entity-blocks/manage/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','4','0','1','21','381','470','0','0','0','0','0','0'),('management','471','202','admin/config/search/path/patterns','admin/config/search/path/patterns','Patterns','a:0:{}','system','-1','0','0','0','10','5','0','1','8','54','202','471','0','0','0','0','0'),('navigation','472','423','taxonomy/term/%/devel/render','taxonomy/term/%/devel/render','Render','a:0:{}','system','-1','0','0','0','100','3','0','28','423','472','0','0','0','0','0','0','0'),('management','473','443','admin/config/workflow/rules/reaction','admin/config/workflow/rules/reaction','Rules','a:0:{}','system','-1','0','0','0','-1','5','0','1','8','66','443','473','0','0','0','0','0'),('management','474','202','admin/config/search/path/settings','admin/config/search/path/settings','Settings','a:0:{}','system','-1','0','0','0','20','5','0','1','8','54','202','474','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','475','394','admin/structure/views/view/%','admin/structure/views/view/%','','a:0:{}','system','0','0','0','0','0','4','0','1','21','394','475','0','0','0','0','0','0'),('management','476','443','admin/config/workflow/rules/settings','admin/config/workflow/rules/settings','Settings','a:0:{}','system','-1','0','0','0','1','5','0','1','8','66','443','476','0','0','0','0','0'),('navigation','477','423','taxonomy/term/%/devel/token','taxonomy/term/%/devel/token','Tokens','a:0:{}','system','-1','0','0','0','5','3','0','28','423','477','0','0','0','0','0','0','0'),('management','478','385','admin/structure/features/%/view','admin/structure/features/%/view','View','a:1:{s:10:"attributes";a:1:{s:5:"title";s:32:"Display components of a feature.";}}','system','-1','0','0','0','-10','4','0','1','21','385','478','0','0','0','0','0','0'),('management','479','384','admin/structure/entityform_types/manage/%','admin/structure/entityform_types/manage/%','Edit','a:0:{}','system','0','0','1','0','0','4','0','1','21','384','479','0','0','0','0','0','0'),('management','481','385','admin/structure/features/%/recreate','admin/structure/features/%/recreate','Recreate','a:1:{s:10:"attributes";a:1:{s:5:"title";s:29:"Recreate an existing feature.";}}','system','-1','0','0','0','11','4','0','1','21','385','481','0','0','0','0','0','0'),('management','482','479','admin/structure/entityform_types/manage/%/submissions','admin/structure/entityform_types/manage/%/submissions','','a:0:{}','system','-1','0','0','0','100','5','0','1','21','384','479','482','0','0','0','0','0'),('management','483','343','admin/structure/block/list/adaptivetheme/add-entity-block','admin/structure/block/list/adaptivetheme/add-entity-block','Add entity block','a:1:{s:10:"attributes";a:1:{s:5:"title";s:23:"Add a new entity block.";}}','system','-1','0','0','0','0','5','0','1','21','31','343','483','0','0','0','0','0'),('management','484','342','admin/structure/block/list/adaptivetheme_admin/add-entity-block','admin/structure/block/list/adaptivetheme_admin/add-entity-block','Add entity block','a:1:{s:10:"attributes";a:1:{s:5:"title";s:23:"Add a new entity block.";}}','system','-1','0','0','0','0','5','0','1','21','31','342','484','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','485','344','admin/structure/block/list/adaptivetheme_subtheme/add-entity-block','admin/structure/block/list/adaptivetheme_subtheme/add-entity-block','Add entity block','a:1:{s:10:"attributes";a:1:{s:5:"title";s:23:"Add a new entity block.";}}','system','-1','0','0','0','0','5','0','1','21','31','344','485','0','0','0','0','0'),('management','486','132','admin/structure/block/list/bartik/add-entity-block','admin/structure/block/list/bartik/add-entity-block','Add entity block','a:1:{s:10:"attributes";a:1:{s:5:"title";s:23:"Add a new entity block.";}}','system','-1','0','0','0','0','5','0','1','21','31','132','486','0','0','0','0','0'),('management','487','345','admin/structure/block/list/corolla/add-entity-block','admin/structure/block/list/corolla/add-entity-block','Add entity block','a:1:{s:10:"attributes";a:1:{s:5:"title";s:23:"Add a new entity block.";}}','system','-1','0','0','0','0','5','0','1','21','31','345','487','0','0','0','0','0'),('management','488','138','admin/structure/block/list/garland/add-entity-block','admin/structure/block/list/garland/add-entity-block','Add entity block','a:1:{s:10:"attributes";a:1:{s:5:"title";s:23:"Add a new entity block.";}}','system','-1','0','0','0','0','5','0','1','21','31','138','488','0','0','0','0','0'),('management','489','144','admin/structure/block/list/seven/add-entity-block','admin/structure/block/list/seven/add-entity-block','Add entity block','a:1:{s:10:"attributes";a:1:{s:5:"title";s:23:"Add a new entity block.";}}','system','-1','0','0','0','0','5','0','1','21','31','144','489','0','0','0','0','0'),('management','490','346','admin/structure/block/list/skeletontheme/add-entity-block','admin/structure/block/list/skeletontheme/add-entity-block','Add entity block','a:1:{s:10:"attributes";a:1:{s:5:"title";s:23:"Add a new entity block.";}}','system','-1','0','0','0','0','5','0','1','21','31','346','490','0','0','0','0','0'),('management','491','145','admin/structure/block/list/stark/add-entity-block','admin/structure/block/list/stark/add-entity-block','Add entity block','a:1:{s:10:"attributes";a:1:{s:5:"title";s:23:"Add a new entity block.";}}','system','-1','0','0','0','0','5','0','1','21','31','145','491','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','492','463','admin/config/workflow/rules/components/add','admin/config/workflow/rules/components/add','Add new component','a:0:{}','system','-1','0','0','0','0','6','0','1','8','66','443','463','492','0','0','0','0'),('management','493','473','admin/config/workflow/rules/reaction/add','admin/config/workflow/rules/reaction/add','Add new rule','a:0:{}','system','-1','0','0','0','0','6','0','1','8','66','443','473','493','0','0','0','0'),('management','494','476','admin/config/workflow/rules/settings/advanced','admin/config/workflow/rules/settings/advanced','Advanced','a:0:{}','system','-1','0','0','0','0','6','0','1','8','66','443','476','494','0','0','0','0'),('management','495','476','admin/config/workflow/rules/settings/basic','admin/config/workflow/rules/settings/basic','Basic','a:0:{}','system','-1','0','0','0','-10','6','0','1','8','66','443','476','495','0','0','0','0'),('management','496','475','admin/structure/views/view/%/break-lock','admin/structure/views/view/%/break-lock','Break lock','a:0:{}','system','-1','0','0','0','0','5','0','1','21','394','475','496','0','0','0','0','0'),('management','497','469','admin/structure/entity-blocks/manage/display/default','admin/structure/entity-blocks/manage/display/default','Default','a:0:{}','system','-1','0','0','0','-10','5','0','1','21','381','469','497','0','0','0','0','0'),('management','498','475','admin/structure/views/view/%/edit','admin/structure/views/view/%/edit','Edit view','a:0:{}','system','-1','0','0','0','-10','5','0','1','21','394','475','498','0','0','0','0','0'),('management','499','479','admin/structure/entityform_types/manage/%/preview','admin/structure/entityform_types/manage/%/preview','Form Preview','a:0:{}','system','-1','0','0','0','110','5','0','1','21','384','479','499','0','0','0','0','0'),('management','500','463','admin/config/workflow/rules/components/import','admin/config/workflow/rules/components/import','Import component','a:0:{}','system','-1','0','0','0','0','6','0','1','8','66','443','463','500','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','501','473','admin/config/workflow/rules/reaction/import','admin/config/workflow/rules/reaction/import','Import rule','a:0:{}','system','-1','0','0','0','0','6','0','1','8','66','443','473','501','0','0','0','0'),('management','504','469','admin/structure/entity-blocks/manage/display/token','admin/structure/entity-blocks/manage/display/token','Tokens','a:0:{}','system','-1','0','0','0','0','5','0','1','21','381','469','504','0','0','0','0','0'),('management','505','299','admin/structure/taxonomy/%/display/token','admin/structure/taxonomy/%/display/token','Tokens','a:0:{}','system','-1','0','0','0','1','6','0','1','21','58','90','299','505','0','0','0','0'),('management','506','300','admin/config/people/accounts/display/token','admin/config/people/accounts/display/token','Tokens','a:0:{}','system','-1','0','0','0','1','6','0','1','8','49','91','300','506','0','0','0','0'),('management','507','479','admin/structure/entityform_types/manage/%/%','admin/structure/entityform_types/manage/%/%','','a:0:{}','system','0','0','0','0','0','5','0','1','21','384','479','507','0','0','0','0','0'),('management','508','470','admin/structure/entity-blocks/manage/fields/%','admin/structure/entity-blocks/manage/fields/%','','a:0:{}','system','0','0','0','0','0','5','0','1','21','381','470','508','0','0','0','0','0'),('management','510','475','admin/structure/views/view/%/clone','admin/structure/views/view/%/clone','Clone','a:0:{}','system','-1','0','0','0','0','5','0','1','21','394','475','510','0','0','0','0','0'),('management','511','479','admin/structure/entityform_types/manage/%/clone','admin/structure/entityform_types/manage/%/clone','Clone','a:0:{}','system','0','0','0','0','0','5','0','1','21','384','479','511','0','0','0','0','0'),('management','513','475','admin/structure/views/view/%/delete','admin/structure/views/view/%/delete','Delete','a:0:{}','system','-1','0','0','0','0','5','0','1','21','394','475','513','0','0','0','0','0'),('management','514','450','admin/config/workflow/workflow/manage/%','admin/config/workflow/workflow/manage/%','Edit','a:0:{}','system','0','0','1','0','0','5','0','1','8','66','450','514','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','515','475','admin/structure/views/view/%/export','admin/structure/views/view/%/export','Export','a:0:{}','system','-1','0','0','0','0','5','0','1','21','394','475','515','0','0','0','0','0'),('management','516','479','admin/structure/entityform_types/manage/%/edit','admin/structure/entityform_types/manage/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','5','0','1','21','384','479','516','0','0','0','0','0'),('management','518','475','admin/structure/views/view/%/revert','admin/structure/views/view/%/revert','Revert','a:0:{}','system','-1','0','0','0','0','5','0','1','21','394','475','518','0','0','0','0','0'),('management','519','463','admin/config/workflow/rules/components/manage/%','admin/config/workflow/rules/components/manage/%','','a:0:{}','system','-1','0','1','0','0','6','0','1','8','66','443','463','519','0','0','0','0'),('management','520','473','admin/config/workflow/rules/reaction/manage/%','admin/config/workflow/rules/reaction/manage/%','','a:0:{}','system','-1','0','1','0','0','6','0','1','8','66','443','473','520','0','0','0','0'),('management','524','305','admin/structure/types/manage/%/display/token','admin/structure/types/manage/%/display/token','Tokens','a:0:{}','system','-1','0','0','0','5','6','0','1','21','37','136','305','524','0','0','0','0'),('management','526','514','admin/config/workflow/workflow/manage/%/labels','admin/config/workflow/workflow/manage/%/labels','Labels','a:0:{}','system','-1','0','0','0','13','6','0','1','8','66','450','514','526','0','0','0','0'),('management','527','475','admin/structure/views/view/%/preview/%','admin/structure/views/view/%/preview/%','','a:0:{}','system','-1','0','0','0','0','5','0','1','21','394','475','527','0','0','0','0','0'),('management','528','514','admin/config/workflow/workflow/manage/%/transitions','admin/config/workflow/workflow/manage/%/transitions','Transitions','a:0:{}','system','-1','0','0','0','12','6','0','1','8','66','450','514','528','0','0','0','0'),('management','530','514','admin/config/workflow/workflow/manage/%/states','admin/config/workflow/workflow/manage/%/states','States','a:0:{}','system','-1','0','0','0','11','6','0','1','8','66','450','514','530','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','531','394','admin/structure/views/nojs/preview/%/%','admin/structure/views/nojs/preview/%/%','','a:0:{}','system','0','0','0','0','0','4','0','1','21','394','531','0','0','0','0','0','0'),('management','532','394','admin/structure/views/ajax/preview/%/%','admin/structure/views/ajax/preview/%/%','','a:0:{}','system','0','0','0','0','0','4','0','1','21','394','532','0','0','0','0','0','0'),('management','533','514','admin/config/workflow/workflow/manage/%/permissions','admin/config/workflow/workflow/manage/%/permissions','Permission summary','a:0:{}','system','-1','0','0','0','14','6','0','1','8','66','450','514','533','0','0','0','0'),('management','534','508','admin/structure/entity-blocks/manage/fields/%/delete','admin/structure/entity-blocks/manage/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','6','0','1','21','381','470','508','534','0','0','0','0'),('management','535','508','admin/structure/entity-blocks/manage/fields/%/edit','admin/structure/entity-blocks/manage/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','381','470','508','535','0','0','0','0'),('management','536','508','admin/structure/entity-blocks/manage/fields/%/field-settings','admin/structure/entity-blocks/manage/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','6','0','1','21','381','470','508','536','0','0','0','0'),('management','537','508','admin/structure/entity-blocks/manage/fields/%/widget-type','admin/structure/entity-blocks/manage/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','6','0','1','21','381','470','508','537','0','0','0','0'),('management','539','514','admin/config/workflow/workflow/manage/%/clone','admin/config/workflow/workflow/manage/%/clone','Clone','a:0:{}','system','0','0','0','0','0','6','0','1','8','66','450','514','539','0','0','0','0'),('management','540','514','admin/config/workflow/workflow/manage/%/edit','admin/config/workflow/workflow/manage/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','8','66','450','514','540','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','541','514','admin/config/workflow/workflow/manage/%/%','admin/config/workflow/workflow/manage/%/%','','a:0:{}','system','0','0','0','0','0','6','0','1','8','66','450','514','541','0','0','0','0'),('management','542','519','admin/config/workflow/rules/components/manage/%/clone','admin/config/workflow/rules/components/manage/%/clone','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','463','519','542','0','0','0'),('management','543','520','admin/config/workflow/rules/reaction/manage/%/clone','admin/config/workflow/rules/reaction/manage/%/clone','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','473','520','543','0','0','0'),('management','544','519','admin/config/workflow/rules/components/manage/%/execute','admin/config/workflow/rules/components/manage/%/execute','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','463','519','544','0','0','0'),('management','545','520','admin/config/workflow/rules/reaction/manage/%/execute','admin/config/workflow/rules/reaction/manage/%/execute','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','473','520','545','0','0','0'),('management','546','519','admin/config/workflow/rules/components/manage/%/export','admin/config/workflow/rules/components/manage/%/export','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','463','519','546','0','0','0'),('management','547','520','admin/config/workflow/rules/reaction/manage/%/export','admin/config/workflow/rules/reaction/manage/%/export','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','473','520','547','0','0','0'),('management','548','174','admin/structure/types/manage/%/comment/display/token','admin/structure/types/manage/%/comment/display/token','Tokens','a:0:{}','system','-1','0','0','0','1','6','0','1','21','37','136','174','548','0','0','0','0'),('management','549','519','admin/config/workflow/rules/components/manage/%/%','admin/config/workflow/rules/components/manage/%/%','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','463','519','549','0','0','0');
INSERT INTO `menu_links` VALUES ('management','550','520','admin/config/workflow/rules/reaction/manage/%/%','admin/config/workflow/rules/reaction/manage/%/%','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','473','520','550','0','0','0'),('management','555','519','admin/config/workflow/rules/components/manage/%/delete/event','admin/config/workflow/rules/components/manage/%/delete/event','Remove event','a:1:{s:10:"attributes";a:1:{s:5:"title";s:37:"Remove an event from a reaction rule.";}}','system','0','0','0','0','0','7','0','1','8','66','443','463','519','555','0','0','0'),('management','556','520','admin/config/workflow/rules/reaction/manage/%/delete/event','admin/config/workflow/rules/reaction/manage/%/delete/event','Remove event','a:1:{s:10:"attributes";a:1:{s:5:"title";s:37:"Remove an event from a reaction rule.";}}','system','0','0','0','0','0','7','0','1','8','66','443','473','520','556','0','0','0'),('management','557','519','admin/config/workflow/rules/components/manage/%/add/event','admin/config/workflow/rules/components/manage/%/add/event','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','463','519','557','0','0','0'),('management','558','520','admin/config/workflow/rules/reaction/manage/%/add/event','admin/config/workflow/rules/reaction/manage/%/add/event','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','473','520','558','0','0','0'),('management','559','519','admin/config/workflow/rules/components/manage/%/delete/%','admin/config/workflow/rules/components/manage/%/delete/%','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','463','519','559','0','0','0'),('management','560','520','admin/config/workflow/rules/reaction/manage/%/delete/%','admin/config/workflow/rules/reaction/manage/%/delete/%','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','473','520','560','0','0','0'),('management','561','519','admin/config/workflow/rules/components/manage/%/edit/%','admin/config/workflow/rules/components/manage/%/edit/%','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','463','519','561','0','0','0');
INSERT INTO `menu_links` VALUES ('management','562','520','admin/config/workflow/rules/reaction/manage/%/edit/%','admin/config/workflow/rules/reaction/manage/%/edit/%','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','473','520','562','0','0','0'),('management','563','519','admin/config/workflow/rules/components/manage/%/add/%','admin/config/workflow/rules/components/manage/%/add/%','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','463','519','563','0','0','0'),('management','564','520','admin/config/workflow/rules/reaction/manage/%/add/%','admin/config/workflow/rules/reaction/manage/%/add/%','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','473','520','564','0','0','0'),('navigation','565','0','branch/%','branch/%','','a:0:{}','system','0','0','1','0','0','1','0','565','0','0','0','0','0','0','0','0','0'),('navigation','566','565','branch/%/edit','branch/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','565','566','0','0','0','0','0','0','0','0'),('navigation','567','0','branch/branch/%','branch/branch/%','View Branch','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View an entity of type Branch with bundle Branch";}}','system','0','0','0','0','0','1','0','567','0','0','0','0','0','0','0','0','0'),('navigation','568','567','branch/branch/%/delete','branch/branch/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View an entity of type Branch with bundle Branch";}}','system','-1','0','0','0','2','2','0','567','568','0','0','0','0','0','0','0','0'),('navigation','569','567','branch/branch/%/edit','branch/branch/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View an entity of type Branch with bundle Branch";}}','system','-1','0','0','0','1','2','0','567','569','0','0','0','0','0','0','0','0'),('navigation','570','567','branch/branch/%/view','branch/branch/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','567','570','0','0','0','0','0','0','0','0'),('management','571','383','admin/structure/entity-type/branch','admin/structure/entity-type/branch','Branch','a:1:{s:10:"attributes";a:1:{s:5:"title";s:33:"View all the bundles for ''Branch''";}}','system','0','0','1','0','0','4','0','1','21','383','571','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','572','571','admin/structure/entity-type/branch/add','admin/structure/entity-type/branch/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:28:"Add a(n) new ''Branch Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','571','572','0','0','0','0','0'),('management','573','571','admin/structure/entity-type/branch/branch','admin/structure/entity-type/branch/branch','Branch','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"View all entites of type Branch with bundle Branch";}}','system','0','0','1','0','0','5','0','1','21','383','571','573','0','0','0','0','0'),('management','574','571','admin/structure/entity-type/branch/list','admin/structure/entity-type/branch/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','571','574','0','0','0','0','0'),('management','575','571','admin/structure/entity-type/branch/delete','admin/structure/entity-type/branch/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:31:"Delete the ''Branch'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','571','575','0','0','0','0','0'),('management','576','571','admin/structure/entity-type/branch/edit','admin/structure/entity-type/branch/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:29:"Edit the ''Branch'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','571','576','0','0','0','0','0'),('management','577','571','admin/structure/entity-type/branch/properties','admin/structure/entity-type/branch/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:47:"Manage the properties of the Branch entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','571','577','0','0','0','0','0'),('management','578','573','admin/structure/entity-type/branch/branch/delete','admin/structure/entity-type/branch/branch/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','571','573','578','0','0','0','0'),('management','579','573','admin/structure/entity-type/branch/branch/edit','admin/structure/entity-type/branch/branch/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','571','573','579','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','580','573','admin/structure/entity-type/branch/branch/list','admin/structure/entity-type/branch/branch/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','571','573','580','0','0','0','0'),('management','581','573','admin/structure/entity-type/branch/branch/display','admin/structure/entity-type/branch/branch/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','571','573','581','0','0','0','0'),('management','582','573','admin/structure/entity-type/branch/branch/fields','admin/structure/entity-type/branch/branch/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','571','573','582','0','0','0','0'),('management','583','573','admin/structure/entity-type/branch/branch/add','admin/structure/entity-type/branch/branch/add','Add Branch','a:1:{s:10:"attributes";a:1:{s:5:"title";s:47:"Add an entity of type Branch with bundle Branch";}}','system','0','0','0','0','0','6','0','1','21','383','571','573','583','0','0','0','0'),('management','584','581','admin/structure/entity-type/branch/branch/display/default','admin/structure/entity-type/branch/branch/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','571','573','581','584','0','0','0'),('management','585','581','admin/structure/entity-type/branch/branch/display/full','admin/structure/entity-type/branch/branch/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','571','573','581','585','0','0','0'),('management','586','581','admin/structure/entity-type/branch/branch/display/teaser','admin/structure/entity-type/branch/branch/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','571','573','581','586','0','0','0'),('management','587','581','admin/structure/entity-type/branch/branch/display/token','admin/structure/entity-type/branch/branch/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','571','573','581','587','0','0','0');
INSERT INTO `menu_links` VALUES ('management','588','573','admin/structure/entity-type/branch/branch/%/delete','admin/structure/entity-type/branch/branch/%/delete','Delete Branch','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"Delete an entity of type Branch with bundle Branch";}}','system','0','0','0','0','0','6','0','1','21','383','571','573','588','0','0','0','0'),('management','589','573','admin/structure/entity-type/branch/branch/%/edit','admin/structure/entity-type/branch/branch/%/edit','Edit Branch','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"Edit an entity of type Branch with bundle Branch";}}','system','0','0','0','0','0','6','0','1','21','383','571','573','589','0','0','0','0'),('management','590','582','admin/structure/entity-type/branch/branch/fields/%','admin/structure/entity-type/branch/branch/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','571','573','582','590','0','0','0'),('management','591','590','admin/structure/entity-type/branch/branch/fields/%/delete','admin/structure/entity-type/branch/branch/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','571','573','582','590','591','0','0'),('management','592','590','admin/structure/entity-type/branch/branch/fields/%/edit','admin/structure/entity-type/branch/branch/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','571','573','582','590','592','0','0'),('management','593','590','admin/structure/entity-type/branch/branch/fields/%/field-settings','admin/structure/entity-type/branch/branch/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','571','573','582','590','593','0','0'),('management','594','590','admin/structure/entity-type/branch/branch/fields/%/widget-type','admin/structure/entity-type/branch/branch/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','571','573','582','590','594','0','0'),('navigation','595','0','program/%','program/%','','a:0:{}','system','0','0','1','0','0','1','0','595','0','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','596','595','program/%/edit','program/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','595','596','0','0','0','0','0','0','0','0'),('navigation','597','0','program/program/%','program/program/%','View Program','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"View an entity of type Program with bundle Program";}}','system','0','0','0','0','0','1','0','597','0','0','0','0','0','0','0','0','0'),('navigation','598','597','program/program/%/delete','program/program/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"View an entity of type Program with bundle Program";}}','system','-1','0','0','0','2','2','0','597','598','0','0','0','0','0','0','0','0'),('navigation','599','597','program/program/%/edit','program/program/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"View an entity of type Program with bundle Program";}}','system','-1','0','0','0','1','2','0','597','599','0','0','0','0','0','0','0','0'),('navigation','600','597','program/program/%/view','program/program/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','597','600','0','0','0','0','0','0','0','0'),('management','601','383','admin/structure/entity-type/program','admin/structure/entity-type/program','Program','a:1:{s:10:"attributes";a:1:{s:5:"title";s:34:"View all the bundles for ''Program''";}}','system','0','0','1','0','0','4','0','1','21','383','601','0','0','0','0','0','0'),('management','602','601','admin/structure/entity-type/program/add','admin/structure/entity-type/program/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:29:"Add a(n) new ''Program Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','601','602','0','0','0','0','0'),('management','603','601','admin/structure/entity-type/program/list','admin/structure/entity-type/program/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','601','603','0','0','0','0','0'),('management','604','601','admin/structure/entity-type/program/delete','admin/structure/entity-type/program/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:32:"Delete the ''Program'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','601','604','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','605','601','admin/structure/entity-type/program/edit','admin/structure/entity-type/program/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:30:"Edit the ''Program'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','601','605','0','0','0','0','0'),('management','606','601','admin/structure/entity-type/program/properties','admin/structure/entity-type/program/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"Manage the properties of the Program entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','601','606','0','0','0','0','0'),('management','607','601','admin/structure/entity-type/program/program','admin/structure/entity-type/program/program','Program','a:1:{s:10:"attributes";a:1:{s:5:"title";s:52:"View all entites of type Program with bundle Program";}}','system','0','0','1','0','0','5','0','1','21','383','601','607','0','0','0','0','0'),('management','608','607','admin/structure/entity-type/program/program/delete','admin/structure/entity-type/program/program/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','601','607','608','0','0','0','0'),('management','609','607','admin/structure/entity-type/program/program/edit','admin/structure/entity-type/program/program/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','601','607','609','0','0','0','0'),('management','610','607','admin/structure/entity-type/program/program/list','admin/structure/entity-type/program/program/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','601','607','610','0','0','0','0'),('management','611','607','admin/structure/entity-type/program/program/display','admin/structure/entity-type/program/program/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','601','607','611','0','0','0','0'),('management','612','607','admin/structure/entity-type/program/program/fields','admin/structure/entity-type/program/program/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','601','607','612','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','613','607','admin/structure/entity-type/program/program/add','admin/structure/entity-type/program/program/add','Add Program','a:1:{s:10:"attributes";a:1:{s:5:"title";s:49:"Add an entity of type Program with bundle Program";}}','system','0','0','0','0','0','6','0','1','21','383','601','607','613','0','0','0','0'),('management','614','611','admin/structure/entity-type/program/program/display/default','admin/structure/entity-type/program/program/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','601','607','611','614','0','0','0'),('management','615','611','admin/structure/entity-type/program/program/display/full','admin/structure/entity-type/program/program/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','601','607','611','615','0','0','0'),('management','616','611','admin/structure/entity-type/program/program/display/teaser','admin/structure/entity-type/program/program/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','601','607','611','616','0','0','0'),('management','617','611','admin/structure/entity-type/program/program/display/token','admin/structure/entity-type/program/program/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','601','607','611','617','0','0','0'),('management','618','607','admin/structure/entity-type/program/program/%/delete','admin/structure/entity-type/program/program/%/delete','Delete Program','a:1:{s:10:"attributes";a:1:{s:5:"title";s:52:"Delete an entity of type Program with bundle Program";}}','system','0','0','0','0','0','6','0','1','21','383','601','607','618','0','0','0','0'),('management','619','607','admin/structure/entity-type/program/program/%/edit','admin/structure/entity-type/program/program/%/edit','Edit Program','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"Edit an entity of type Program with bundle Program";}}','system','0','0','0','0','0','6','0','1','21','383','601','607','619','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','620','612','admin/structure/entity-type/program/program/fields/%','admin/structure/entity-type/program/program/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','601','607','612','620','0','0','0'),('management','621','620','admin/structure/entity-type/program/program/fields/%/delete','admin/structure/entity-type/program/program/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','601','607','612','620','621','0','0'),('management','622','620','admin/structure/entity-type/program/program/fields/%/edit','admin/structure/entity-type/program/program/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','601','607','612','620','622','0','0'),('management','623','620','admin/structure/entity-type/program/program/fields/%/field-settings','admin/structure/entity-type/program/program/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','601','607','612','620','623','0','0'),('management','624','620','admin/structure/entity-type/program/program/fields/%/widget-type','admin/structure/entity-type/program/program/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','601','607','612','620','624','0','0'),('navigation','649','0','level/%','level/%','','a:0:{}','system','0','0','1','0','0','1','0','649','0','0','0','0','0','0','0','0','0'),('navigation','650','649','level/%/edit','level/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','649','650','0','0','0','0','0','0','0','0'),('navigation','651','0','level/level/%','level/level/%','View Level','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"View an entity of type Level with bundle Level";}}','system','0','0','0','0','0','1','0','651','0','0','0','0','0','0','0','0','0'),('navigation','652','651','level/level/%/delete','level/level/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"View an entity of type Level with bundle Level";}}','system','-1','0','0','0','2','2','0','651','652','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','653','651','level/level/%/edit','level/level/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"View an entity of type Level with bundle Level";}}','system','-1','0','0','0','1','2','0','651','653','0','0','0','0','0','0','0','0'),('navigation','654','651','level/level/%/view','level/level/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','651','654','0','0','0','0','0','0','0','0'),('management','655','383','admin/structure/entity-type/level','admin/structure/entity-type/level','Level','a:1:{s:10:"attributes";a:1:{s:5:"title";s:32:"View all the bundles for ''Level''";}}','system','0','0','1','0','0','4','0','1','21','383','655','0','0','0','0','0','0'),('management','656','655','admin/structure/entity-type/level/add','admin/structure/entity-type/level/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:27:"Add a(n) new ''Level Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','655','656','0','0','0','0','0'),('management','657','655','admin/structure/entity-type/level/list','admin/structure/entity-type/level/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','655','657','0','0','0','0','0'),('management','658','655','admin/structure/entity-type/level/delete','admin/structure/entity-type/level/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:30:"Delete the ''Level'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','655','658','0','0','0','0','0'),('management','659','655','admin/structure/entity-type/level/edit','admin/structure/entity-type/level/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:28:"Edit the ''Level'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','655','659','0','0','0','0','0'),('management','660','655','admin/structure/entity-type/level/level','admin/structure/entity-type/level/level','Level','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View all entites of type Level with bundle Level";}}','system','0','0','1','0','0','5','0','1','21','383','655','660','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','661','655','admin/structure/entity-type/level/properties','admin/structure/entity-type/level/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"Manage the properties of the Level entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','655','661','0','0','0','0','0'),('management','662','660','admin/structure/entity-type/level/level/delete','admin/structure/entity-type/level/level/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','655','660','662','0','0','0','0'),('management','663','660','admin/structure/entity-type/level/level/edit','admin/structure/entity-type/level/level/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','655','660','663','0','0','0','0'),('management','664','660','admin/structure/entity-type/level/level/list','admin/structure/entity-type/level/level/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','655','660','664','0','0','0','0'),('management','665','660','admin/structure/entity-type/level/level/display','admin/structure/entity-type/level/level/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','655','660','665','0','0','0','0'),('management','666','660','admin/structure/entity-type/level/level/fields','admin/structure/entity-type/level/level/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','655','660','666','0','0','0','0'),('management','667','660','admin/structure/entity-type/level/level/add','admin/structure/entity-type/level/level/add','Add Level','a:1:{s:10:"attributes";a:1:{s:5:"title";s:45:"Add an entity of type Level with bundle Level";}}','system','0','0','0','0','0','6','0','1','21','383','655','660','667','0','0','0','0'),('management','668','665','admin/structure/entity-type/level/level/display/default','admin/structure/entity-type/level/level/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','655','660','665','668','0','0','0');
INSERT INTO `menu_links` VALUES ('management','669','665','admin/structure/entity-type/level/level/display/full','admin/structure/entity-type/level/level/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','655','660','665','669','0','0','0'),('management','670','665','admin/structure/entity-type/level/level/display/teaser','admin/structure/entity-type/level/level/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','655','660','665','670','0','0','0'),('management','671','665','admin/structure/entity-type/level/level/display/token','admin/structure/entity-type/level/level/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','655','660','665','671','0','0','0'),('management','672','666','admin/structure/entity-type/level/level/fields/%','admin/structure/entity-type/level/level/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','655','660','666','672','0','0','0'),('management','673','660','admin/structure/entity-type/level/level/%/delete','admin/structure/entity-type/level/level/%/delete','Delete Level','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"Delete an entity of type Level with bundle Level";}}','system','0','0','0','0','0','6','0','1','21','383','655','660','673','0','0','0','0'),('management','674','660','admin/structure/entity-type/level/level/%/edit','admin/structure/entity-type/level/level/%/edit','Edit Level','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"Edit an entity of type Level with bundle Level";}}','system','0','0','0','0','0','6','0','1','21','383','655','660','674','0','0','0','0'),('management','675','672','admin/structure/entity-type/level/level/fields/%/delete','admin/structure/entity-type/level/level/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','655','660','666','672','675','0','0'),('management','676','672','admin/structure/entity-type/level/level/fields/%/edit','admin/structure/entity-type/level/level/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','655','660','666','672','676','0','0');
INSERT INTO `menu_links` VALUES ('management','677','672','admin/structure/entity-type/level/level/fields/%/field-settings','admin/structure/entity-type/level/level/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','655','660','666','672','677','0','0'),('management','678','672','admin/structure/entity-type/level/level/fields/%/widget-type','admin/structure/entity-type/level/level/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','655','660','666','672','678','0','0'),('navigation','709','0','reader/%','reader/%','','a:0:{}','system','0','0','1','0','0','1','0','709','0','0','0','0','0','0','0','0','0'),('navigation','710','709','reader/%/edit','reader/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','709','710','0','0','0','0','0','0','0','0'),('navigation','711','0','reader/reader/%','reader/reader/%','View Reader','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View an entity of type Reader with bundle Reader";}}','system','0','0','0','0','0','1','0','711','0','0','0','0','0','0','0','0','0'),('navigation','712','711','reader/reader/%/delete','reader/reader/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View an entity of type Reader with bundle Reader";}}','system','-1','0','0','0','2','2','0','711','712','0','0','0','0','0','0','0','0'),('navigation','713','711','reader/reader/%/edit','reader/reader/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View an entity of type Reader with bundle Reader";}}','system','-1','0','0','0','1','2','0','711','713','0','0','0','0','0','0','0','0'),('navigation','714','711','reader/reader/%/view','reader/reader/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','711','714','0','0','0','0','0','0','0','0'),('management','715','383','admin/structure/entity-type/reader','admin/structure/entity-type/reader','Reader','a:1:{s:10:"attributes";a:1:{s:5:"title";s:33:"View all the bundles for ''Reader''";}}','system','0','0','1','0','0','4','0','1','21','383','715','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','716','715','admin/structure/entity-type/reader/add','admin/structure/entity-type/reader/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:28:"Add a(n) new ''Reader Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','715','716','0','0','0','0','0'),('management','717','715','admin/structure/entity-type/reader/list','admin/structure/entity-type/reader/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','715','717','0','0','0','0','0'),('management','718','715','admin/structure/entity-type/reader/delete','admin/structure/entity-type/reader/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:31:"Delete the ''Reader'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','715','718','0','0','0','0','0'),('management','719','715','admin/structure/entity-type/reader/edit','admin/structure/entity-type/reader/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:29:"Edit the ''Reader'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','715','719','0','0','0','0','0'),('management','720','715','admin/structure/entity-type/reader/properties','admin/structure/entity-type/reader/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:47:"Manage the properties of the Reader entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','715','720','0','0','0','0','0'),('management','721','715','admin/structure/entity-type/reader/reader','admin/structure/entity-type/reader/reader','Reader','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"View all entites of type Reader with bundle Reader";}}','system','0','0','1','0','0','5','0','1','21','383','715','721','0','0','0','0','0'),('management','722','721','admin/structure/entity-type/reader/reader/delete','admin/structure/entity-type/reader/reader/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','715','721','722','0','0','0','0'),('management','723','721','admin/structure/entity-type/reader/reader/edit','admin/structure/entity-type/reader/reader/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','715','721','723','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','724','721','admin/structure/entity-type/reader/reader/list','admin/structure/entity-type/reader/reader/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','715','721','724','0','0','0','0'),('management','725','721','admin/structure/entity-type/reader/reader/display','admin/structure/entity-type/reader/reader/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','715','721','725','0','0','0','0'),('management','726','721','admin/structure/entity-type/reader/reader/fields','admin/structure/entity-type/reader/reader/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','715','721','726','0','0','0','0'),('management','727','721','admin/structure/entity-type/reader/reader/add','admin/structure/entity-type/reader/reader/add','Add Reader','a:1:{s:10:"attributes";a:1:{s:5:"title";s:47:"Add an entity of type Reader with bundle Reader";}}','system','0','0','0','0','0','6','0','1','21','383','715','721','727','0','0','0','0'),('management','728','725','admin/structure/entity-type/reader/reader/display/default','admin/structure/entity-type/reader/reader/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','715','721','725','728','0','0','0'),('management','729','725','admin/structure/entity-type/reader/reader/display/full','admin/structure/entity-type/reader/reader/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','715','721','725','729','0','0','0'),('management','730','725','admin/structure/entity-type/reader/reader/display/teaser','admin/structure/entity-type/reader/reader/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','715','721','725','730','0','0','0'),('management','731','725','admin/structure/entity-type/reader/reader/display/token','admin/structure/entity-type/reader/reader/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','715','721','725','731','0','0','0');
INSERT INTO `menu_links` VALUES ('management','732','721','admin/structure/entity-type/reader/reader/%/delete','admin/structure/entity-type/reader/reader/%/delete','Delete Reader','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"Delete an entity of type Reader with bundle Reader";}}','system','0','0','0','0','0','6','0','1','21','383','715','721','732','0','0','0','0'),('management','733','721','admin/structure/entity-type/reader/reader/%/edit','admin/structure/entity-type/reader/reader/%/edit','Edit Reader','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"Edit an entity of type Reader with bundle Reader";}}','system','0','0','0','0','0','6','0','1','21','383','715','721','733','0','0','0','0'),('management','734','726','admin/structure/entity-type/reader/reader/fields/%','admin/structure/entity-type/reader/reader/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','715','721','726','734','0','0','0'),('management','735','734','admin/structure/entity-type/reader/reader/fields/%/delete','admin/structure/entity-type/reader/reader/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','715','721','726','734','735','0','0'),('management','736','734','admin/structure/entity-type/reader/reader/fields/%/edit','admin/structure/entity-type/reader/reader/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','715','721','726','734','736','0','0'),('management','737','734','admin/structure/entity-type/reader/reader/fields/%/field-settings','admin/structure/entity-type/reader/reader/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','715','721','726','734','737','0','0'),('management','738','734','admin/structure/entity-type/reader/reader/fields/%/widget-type','admin/structure/entity-type/reader/reader/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','715','721','726','734','738','0','0'),('management','739','48','admin/structure/menu/manage/menu-library-menu','admin/structure/menu/manage/%','Reader menu','a:0:{}','menu','0','0','0','0','0','4','0','1','21','48','739','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','740','0','reader_log/%','reader_log/%','','a:0:{}','system','0','0','1','0','0','1','0','740','0','0','0','0','0','0','0','0','0'),('navigation','741','740','reader_log/%/edit','reader_log/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','740','741','0','0','0','0','0','0','0','0'),('navigation','742','0','reader_log/reader_log/%','reader_log/reader_log/%','View Reader Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:56:"View an entity of type Reader Log with bundle Reader Log";}}','system','0','0','0','0','0','1','0','742','0','0','0','0','0','0','0','0','0'),('navigation','743','742','reader_log/reader_log/%/delete','reader_log/reader_log/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:56:"View an entity of type Reader Log with bundle Reader Log";}}','system','-1','0','0','0','2','2','0','742','743','0','0','0','0','0','0','0','0'),('navigation','744','742','reader_log/reader_log/%/edit','reader_log/reader_log/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:56:"View an entity of type Reader Log with bundle Reader Log";}}','system','-1','0','0','0','1','2','0','742','744','0','0','0','0','0','0','0','0'),('navigation','745','742','reader_log/reader_log/%/view','reader_log/reader_log/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','742','745','0','0','0','0','0','0','0','0'),('management','746','383','admin/structure/entity-type/reader_log','admin/structure/entity-type/reader_log','Reader Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:37:"View all the bundles for ''Reader Log''";}}','system','0','0','1','0','0','4','0','1','21','383','746','0','0','0','0','0','0'),('management','747','746','admin/structure/entity-type/reader_log/add','admin/structure/entity-type/reader_log/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:32:"Add a(n) new ''Reader Log Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','746','747','0','0','0','0','0'),('management','748','746','admin/structure/entity-type/reader_log/list','admin/structure/entity-type/reader_log/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','746','748','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','749','746','admin/structure/entity-type/reader_log/delete','admin/structure/entity-type/reader_log/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:35:"Delete the ''Reader Log'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','746','749','0','0','0','0','0'),('management','750','746','admin/structure/entity-type/reader_log/edit','admin/structure/entity-type/reader_log/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:33:"Edit the ''Reader Log'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','746','750','0','0','0','0','0'),('management','751','746','admin/structure/entity-type/reader_log/properties','admin/structure/entity-type/reader_log/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:51:"Manage the properties of the Reader Log entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','746','751','0','0','0','0','0'),('management','752','746','admin/structure/entity-type/reader_log/reader_log','admin/structure/entity-type/reader_log/reader_log','Reader Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:58:"View all entites of type Reader Log with bundle Reader Log";}}','system','0','0','1','0','0','5','0','1','21','383','746','752','0','0','0','0','0'),('management','753','752','admin/structure/entity-type/reader_log/reader_log/delete','admin/structure/entity-type/reader_log/reader_log/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','746','752','753','0','0','0','0'),('management','754','752','admin/structure/entity-type/reader_log/reader_log/edit','admin/structure/entity-type/reader_log/reader_log/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','746','752','754','0','0','0','0'),('management','755','752','admin/structure/entity-type/reader_log/reader_log/list','admin/structure/entity-type/reader_log/reader_log/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','746','752','755','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','756','752','admin/structure/entity-type/reader_log/reader_log/display','admin/structure/entity-type/reader_log/reader_log/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','746','752','756','0','0','0','0'),('management','757','752','admin/structure/entity-type/reader_log/reader_log/fields','admin/structure/entity-type/reader_log/reader_log/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','746','752','757','0','0','0','0'),('management','758','752','admin/structure/entity-type/reader_log/reader_log/add','admin/structure/entity-type/reader_log/reader_log/add','Add Reader Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:55:"Add an entity of type Reader Log with bundle Reader Log";}}','system','0','0','0','0','0','6','0','1','21','383','746','752','758','0','0','0','0'),('management','759','756','admin/structure/entity-type/reader_log/reader_log/display/default','admin/structure/entity-type/reader_log/reader_log/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','746','752','756','759','0','0','0'),('management','760','756','admin/structure/entity-type/reader_log/reader_log/display/full','admin/structure/entity-type/reader_log/reader_log/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','746','752','756','760','0','0','0'),('management','761','756','admin/structure/entity-type/reader_log/reader_log/display/teaser','admin/structure/entity-type/reader_log/reader_log/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','746','752','756','761','0','0','0'),('management','762','756','admin/structure/entity-type/reader_log/reader_log/display/token','admin/structure/entity-type/reader_log/reader_log/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','746','752','756','762','0','0','0'),('management','763','757','admin/structure/entity-type/reader_log/reader_log/fields/%','admin/structure/entity-type/reader_log/reader_log/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','746','752','757','763','0','0','0');
INSERT INTO `menu_links` VALUES ('management','764','752','admin/structure/entity-type/reader_log/reader_log/%/delete','admin/structure/entity-type/reader_log/reader_log/%/delete','Delete Reader Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:58:"Delete an entity of type Reader Log with bundle Reader Log";}}','system','0','0','0','0','0','6','0','1','21','383','746','752','764','0','0','0','0'),('management','765','752','admin/structure/entity-type/reader_log/reader_log/%/edit','admin/structure/entity-type/reader_log/reader_log/%/edit','Edit Reader Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:56:"Edit an entity of type Reader Log with bundle Reader Log";}}','system','0','0','0','0','0','6','0','1','21','383','746','752','765','0','0','0','0'),('management','766','763','admin/structure/entity-type/reader_log/reader_log/fields/%/delete','admin/structure/entity-type/reader_log/reader_log/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','746','752','757','763','766','0','0'),('management','767','763','admin/structure/entity-type/reader_log/reader_log/fields/%/edit','admin/structure/entity-type/reader_log/reader_log/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','746','752','757','763','767','0','0'),('management','768','763','admin/structure/entity-type/reader_log/reader_log/fields/%/field-settings','admin/structure/entity-type/reader_log/reader_log/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','746','752','757','763','768','0','0'),('management','769','763','admin/structure/entity-type/reader_log/reader_log/fields/%/widget-type','admin/structure/entity-type/reader_log/reader_log/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','746','752','757','763','769','0','0'),('menu-library-menu','770','0','reader-dashboard','reader-dashboard','Dashboard','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','0','0','0','0','-50','1','1','770','0','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('menu-library-menu','771','0','reader/dashboard/profile/add','reader/dashboard/profile/add','Add Profile','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','1','0','0','0','-49','1','1','771','0','0','0','0','0','0','0','0','0'),('menu-library-menu','773','0','reader/dashboard/program/activity/add','reader/dashboard/program/activity/add','Add Reading Activity','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','1','0','0','0','-46','1','1','773','0','0','0','0','0','0','0','0','0'),('management','786','48','admin/structure/menu/manage/menu-library-menu1','admin/structure/menu/manage/%','Library menu','a:0:{}','menu','0','0','0','0','0','4','0','1','21','48','786','0','0','0','0','0','0'),('menu-library-menu1','789','0','library/dashboard/readers','library/dashboard/readers','Readers','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','0','0','0','0','-45','1','1','789','0','0','0','0','0','0','0','0','0'),('menu-setup-menu','790','0','library/dashboard/badges/manage_badges','library/dashboard/badges/manage_badges','Badges','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','0','0','0','0','-50','1','1','790','0','0','0','0','0','0','0','0','0'),('navigation','794','0','library/dashboard','library/dashboard','LIBRARY DASHBOARD','a:0:{}','system','0','0','1','0','0','1','0','794','0','0','0','0','0','0','0','0','0'),('navigation','795','794','library/dashboard/branches','library/dashboard/branches','Branches','a:0:{}','system','0','0','1','0','0','2','0','794','795','0','0','0','0','0','0','0','0'),('navigation','797','794','library/dashboard/program/add','library/dashboard/program/add','Add Programs','a:0:{}','system','0','0','0','0','0','2','0','794','797','0','0','0','0','0','0','0','0'),('navigation','799','794','library/dashboard/program/{program_id}/{level_id}/edit','library/dashboard/program/{program_id}/{level_id}/edit','Add Level','a:0:{}','system','0','0','0','0','0','2','0','794','799','0','0','0','0','0','0','0','0'),('navigation','807','794','library/dashboard/level/points','library/dashboard/level/points','Add Level','a:0:{}','system','0','0','0','0','0','2','0','794','807','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','808','795','library/dashboard/branches/program/badge/add','library/dashboard/branches/program/badge/add','Add Badge','a:0:{}','system','0','0','0','0','0','3','0','794','795','808','0','0','0','0','0','0','0'),('navigation','809','795','library/dashboard/branches/program/prize/add','library/dashboard/branches/program/prize/add','Add Prize','a:0:{}','system','0','0','0','0','0','3','0','794','795','809','0','0','0','0','0','0','0'),('menu-setup-menu','810','0','library/dashboard/branches','library/dashboard/branches','Branches','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','0','0','0','0','-48','1','1','810','0','0','0','0','0','0','0','0','0'),('menu-setup-menu','811','0','library/dashboard/program','library/dashboard/program','Programs','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','0','0','0','0','-46','1','1','811','0','0','0','0','0','0','0','0','0'),('navigation','812','794','library/dashboard/program','library/dashboard/program','All Programs','a:0:{}','system','0','0','1','0','0','2','0','794','812','0','0','0','0','0','0','0','0'),('navigation','813','794','library/dashboard/readers','library/dashboard/readers','Readers List','a:0:{}','system','0','0','1','0','0','2','0','794','813','0','0','0','0','0','0','0','0'),('navigation','814','812','library/dashboard/program/level/add','library/dashboard/program/level/add','Add Level','a:0:{}','system','0','0','0','0','0','3','0','794','812','814','0','0','0','0','0','0','0'),('navigation','816','0','reader/dashboard','reader/dashboard','Reader Dashboard','a:0:{}','system','0','0','1','0','0','1','0','816','0','0','0','0','0','0','0','0','0'),('navigation','817','816','reader/dashboard/profile/add','reader/dashboard/profile/add','Add Profile','a:0:{}','system','0','0','0','0','0','2','0','816','817','0','0','0','0','0','0','0','0'),('navigation','818','816','reader/dashboard/history/reading','reader/dashboard/history/reading','View history','a:0:{}','system','0','0','0','0','0','2','0','816','818','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','819','816','reader/dashboard/program/activity/add','reader/dashboard/program/activity/add','Add activity','a:0:{}','system','0','0','0','0','0','2','0','816','819','0','0','0','0','0','0','0','0'),('menu-library-menu','820','0','user/logout','user/logout','Log Out','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','0','0','0','0','-45','1','1','820','0','0','0','0','0','0','0','0','0'),('navigation','821','6','node/add/customformfields','node/add/customformfields','CustomFormFields','a:0:{}','system','0','0','0','0','0','2','0','6','821','0','0','0','0','0','0','0','0'),('navigation','822','0','drawing_ticket/%','drawing_ticket/%','','a:0:{}','system','0','0','1','0','0','1','0','822','0','0','0','0','0','0','0','0','0'),('navigation','823','822','drawing_ticket/%/edit','drawing_ticket/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','822','823','0','0','0','0','0','0','0','0'),('navigation','824','0','drawing_ticket/drawing_ticket/%','drawing_ticket/drawing_ticket/%','View Drawing Ticket','a:1:{s:10:"attributes";a:1:{s:5:"title";s:64:"View an entity of type Drawing Ticket with bundle Drawing Ticket";}}','system','0','0','0','0','0','1','0','824','0','0','0','0','0','0','0','0','0'),('navigation','825','824','drawing_ticket/drawing_ticket/%/delete','drawing_ticket/drawing_ticket/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:64:"View an entity of type Drawing Ticket with bundle Drawing Ticket";}}','system','-1','0','0','0','2','2','0','824','825','0','0','0','0','0','0','0','0'),('navigation','826','824','drawing_ticket/drawing_ticket/%/edit','drawing_ticket/drawing_ticket/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:64:"View an entity of type Drawing Ticket with bundle Drawing Ticket";}}','system','-1','0','0','0','1','2','0','824','826','0','0','0','0','0','0','0','0'),('navigation','827','824','drawing_ticket/drawing_ticket/%/view','drawing_ticket/drawing_ticket/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','824','827','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','828','383','admin/structure/entity-type/drawing_ticket','admin/structure/entity-type/drawing_ticket','Drawing Ticket','a:1:{s:10:"attributes";a:1:{s:5:"title";s:41:"View all the bundles for ''Drawing Ticket''";}}','system','0','0','1','0','0','4','0','1','21','383','828','0','0','0','0','0','0'),('management','829','828','admin/structure/entity-type/drawing_ticket/add','admin/structure/entity-type/drawing_ticket/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:36:"Add a(n) new ''Drawing Ticket Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','828','829','0','0','0','0','0'),('management','830','828','admin/structure/entity-type/drawing_ticket/list','admin/structure/entity-type/drawing_ticket/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','828','830','0','0','0','0','0'),('management','831','828','admin/structure/entity-type/drawing_ticket/delete','admin/structure/entity-type/drawing_ticket/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:39:"Delete the ''Drawing Ticket'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','828','831','0','0','0','0','0'),('management','832','828','admin/structure/entity-type/drawing_ticket/drawing_ticket','admin/structure/entity-type/drawing_ticket/drawing_ticket','Drawing Ticket','a:1:{s:10:"attributes";a:1:{s:5:"title";s:66:"View all entites of type Drawing Ticket with bundle Drawing Ticket";}}','system','0','0','1','0','0','5','0','1','21','383','828','832','0','0','0','0','0'),('management','833','828','admin/structure/entity-type/drawing_ticket/edit','admin/structure/entity-type/drawing_ticket/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:37:"Edit the ''Drawing Ticket'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','828','833','0','0','0','0','0'),('management','834','828','admin/structure/entity-type/drawing_ticket/properties','admin/structure/entity-type/drawing_ticket/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:55:"Manage the properties of the Drawing Ticket entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','828','834','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','835','832','admin/structure/entity-type/drawing_ticket/drawing_ticket/delete','admin/structure/entity-type/drawing_ticket/drawing_ticket/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','828','832','835','0','0','0','0'),('management','836','832','admin/structure/entity-type/drawing_ticket/drawing_ticket/edit','admin/structure/entity-type/drawing_ticket/drawing_ticket/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','828','832','836','0','0','0','0'),('management','837','832','admin/structure/entity-type/drawing_ticket/drawing_ticket/list','admin/structure/entity-type/drawing_ticket/drawing_ticket/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','828','832','837','0','0','0','0'),('management','838','832','admin/structure/entity-type/drawing_ticket/drawing_ticket/display','admin/structure/entity-type/drawing_ticket/drawing_ticket/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','828','832','838','0','0','0','0'),('management','839','832','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','828','832','839','0','0','0','0'),('management','840','832','admin/structure/entity-type/drawing_ticket/drawing_ticket/add','admin/structure/entity-type/drawing_ticket/drawing_ticket/add','Add Drawing Ticket','a:1:{s:10:"attributes";a:1:{s:5:"title";s:63:"Add an entity of type Drawing Ticket with bundle Drawing Ticket";}}','system','0','0','0','0','0','6','0','1','21','383','828','832','840','0','0','0','0'),('management','841','838','admin/structure/entity-type/drawing_ticket/drawing_ticket/display/default','admin/structure/entity-type/drawing_ticket/drawing_ticket/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','828','832','838','841','0','0','0'),('management','842','838','admin/structure/entity-type/drawing_ticket/drawing_ticket/display/full','admin/structure/entity-type/drawing_ticket/drawing_ticket/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','828','832','838','842','0','0','0');
INSERT INTO `menu_links` VALUES ('management','843','838','admin/structure/entity-type/drawing_ticket/drawing_ticket/display/teaser','admin/structure/entity-type/drawing_ticket/drawing_ticket/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','828','832','838','843','0','0','0'),('management','844','838','admin/structure/entity-type/drawing_ticket/drawing_ticket/display/token','admin/structure/entity-type/drawing_ticket/drawing_ticket/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','828','832','838','844','0','0','0'),('management','845','832','admin/structure/entity-type/drawing_ticket/drawing_ticket/%/delete','admin/structure/entity-type/drawing_ticket/drawing_ticket/%/delete','Delete Drawing Ticket','a:1:{s:10:"attributes";a:1:{s:5:"title";s:66:"Delete an entity of type Drawing Ticket with bundle Drawing Ticket";}}','system','0','0','0','0','0','6','0','1','21','383','828','832','845','0','0','0','0'),('management','846','832','admin/structure/entity-type/drawing_ticket/drawing_ticket/%/edit','admin/structure/entity-type/drawing_ticket/drawing_ticket/%/edit','Edit Drawing Ticket','a:1:{s:10:"attributes";a:1:{s:5:"title";s:64:"Edit an entity of type Drawing Ticket with bundle Drawing Ticket";}}','system','0','0','0','0','0','6','0','1','21','383','828','832','846','0','0','0','0'),('management','847','839','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','828','832','839','847','0','0','0'),('management','848','847','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%/delete','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','828','832','839','847','848','0','0'),('management','849','847','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%/edit','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','828','832','839','847','849','0','0');
INSERT INTO `menu_links` VALUES ('management','850','847','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%/field-settings','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','828','832','839','847','850','0','0'),('management','851','847','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%/widget-type','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','828','832','839','847','851','0','0'),('management','852','8','admin/config/date','admin/config/date','Date API','a:1:{s:10:"attributes";a:1:{s:5:"title";s:42:"Settings for modules the use the Date API.";}}','system','0','0','1','0','-10','3','0','1','8','852','0','0','0','0','0','0','0'),('management','853','12','admin/help/date','admin/help/date','date','a:0:{}','system','-1','0','0','0','0','3','0','1','12','853','0','0','0','0','0','0','0'),('management','854','12','admin/help/date_tools','admin/help/date_tools','date_tools','a:0:{}','system','-1','0','0','0','0','3','0','1','12','854','0','0','0','0','0','0','0'),('management','855','852','admin/config/date/date_popup','admin/config/date/date_popup','Date Popup','a:1:{s:10:"attributes";a:1:{s:5:"title";s:34:"Configure the Date Popup settings.";}}','system','0','0','0','0','0','4','0','1','8','852','855','0','0','0','0','0','0'),('management','856','852','admin/config/date/tools','admin/config/date/tools','Date Tools','a:1:{s:10:"attributes";a:1:{s:5:"title";s:70:"Date Wizard and other tools to manage and create dates and calendars. ";}}','system','0','0','0','0','0','4','0','1','8','852','856','0','0','0','0','0','0'),('management','857','856','admin/config/date/tools/about','admin/config/date/tools/about','About','a:1:{s:10:"attributes";a:1:{s:5:"title";s:70:"Date Wizard and other tools to manage and create dates and calendars. ";}}','system','-1','0','0','0','-5','5','0','1','8','852','856','857','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','858','100','admin/config/regional/date-time/date-views','admin/config/regional/date-time/date-views','Date views','a:1:{s:10:"attributes";a:1:{s:5:"title";s:34:"Configure settings for date views.";}}','system','-1','0','0','0','0','5','0','1','8','52','100','858','0','0','0','0','0'),('management','859','856','admin/config/date/tools/date_wizard','admin/config/date/tools/date_wizard','Date wizard','a:1:{s:10:"attributes";a:1:{s:5:"title";s:51:"Easy creation of date content types and calendars. ";}}','system','-1','0','0','0','1','5','0','1','8','852','856','859','0','0','0','0','0'),('navigation','860','0','prize/%','prize/%','','a:0:{}','system','0','0','1','0','0','1','0','860','0','0','0','0','0','0','0','0','0'),('navigation','861','860','prize/%/edit','prize/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','860','861','0','0','0','0','0','0','0','0'),('navigation','862','0','prize/prize/%','prize/prize/%','View Prize','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"View an entity of type Prize with bundle Prize";}}','system','0','0','0','0','0','1','0','862','0','0','0','0','0','0','0','0','0'),('navigation','863','862','prize/prize/%/delete','prize/prize/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"View an entity of type Prize with bundle Prize";}}','system','-1','0','0','0','2','2','0','862','863','0','0','0','0','0','0','0','0'),('navigation','864','862','prize/prize/%/edit','prize/prize/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"View an entity of type Prize with bundle Prize";}}','system','-1','0','0','0','1','2','0','862','864','0','0','0','0','0','0','0','0'),('navigation','865','862','prize/prize/%/view','prize/prize/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','862','865','0','0','0','0','0','0','0','0'),('management','866','383','admin/structure/entity-type/prize','admin/structure/entity-type/prize','Prize','a:1:{s:10:"attributes";a:1:{s:5:"title";s:32:"View all the bundles for ''Prize''";}}','system','0','0','1','0','0','4','0','1','21','383','866','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','867','866','admin/structure/entity-type/prize/add','admin/structure/entity-type/prize/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:27:"Add a(n) new ''Prize Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','866','867','0','0','0','0','0'),('management','868','866','admin/structure/entity-type/prize/list','admin/structure/entity-type/prize/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','866','868','0','0','0','0','0'),('management','869','866','admin/structure/entity-type/prize/delete','admin/structure/entity-type/prize/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:30:"Delete the ''Prize'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','866','869','0','0','0','0','0'),('management','870','866','admin/structure/entity-type/prize/edit','admin/structure/entity-type/prize/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:28:"Edit the ''Prize'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','866','870','0','0','0','0','0'),('management','871','866','admin/structure/entity-type/prize/properties','admin/structure/entity-type/prize/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"Manage the properties of the Prize entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','866','871','0','0','0','0','0'),('management','872','866','admin/structure/entity-type/prize/prize','admin/structure/entity-type/prize/prize','Prize','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View all entites of type Prize with bundle Prize";}}','system','0','0','1','0','0','5','0','1','21','383','866','872','0','0','0','0','0'),('management','873','872','admin/structure/entity-type/prize/prize/delete','admin/structure/entity-type/prize/prize/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','866','872','873','0','0','0','0'),('management','874','872','admin/structure/entity-type/prize/prize/edit','admin/structure/entity-type/prize/prize/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','866','872','874','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','875','872','admin/structure/entity-type/prize/prize/list','admin/structure/entity-type/prize/prize/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','866','872','875','0','0','0','0'),('management','876','872','admin/structure/entity-type/prize/prize/display','admin/structure/entity-type/prize/prize/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','866','872','876','0','0','0','0'),('management','877','872','admin/structure/entity-type/prize/prize/fields','admin/structure/entity-type/prize/prize/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','866','872','877','0','0','0','0'),('management','878','872','admin/structure/entity-type/prize/prize/add','admin/structure/entity-type/prize/prize/add','Add Prize','a:1:{s:10:"attributes";a:1:{s:5:"title";s:45:"Add an entity of type Prize with bundle Prize";}}','system','0','0','0','0','0','6','0','1','21','383','866','872','878','0','0','0','0'),('management','879','876','admin/structure/entity-type/prize/prize/display/default','admin/structure/entity-type/prize/prize/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','866','872','876','879','0','0','0'),('management','880','876','admin/structure/entity-type/prize/prize/display/full','admin/structure/entity-type/prize/prize/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','866','872','876','880','0','0','0'),('management','881','876','admin/structure/entity-type/prize/prize/display/teaser','admin/structure/entity-type/prize/prize/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','866','872','876','881','0','0','0'),('management','882','876','admin/structure/entity-type/prize/prize/display/token','admin/structure/entity-type/prize/prize/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','866','872','876','882','0','0','0'),('management','883','877','admin/structure/entity-type/prize/prize/fields/%','admin/structure/entity-type/prize/prize/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','866','872','877','883','0','0','0');
INSERT INTO `menu_links` VALUES ('management','884','872','admin/structure/entity-type/prize/prize/%/delete','admin/structure/entity-type/prize/prize/%/delete','Delete Prize','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"Delete an entity of type Prize with bundle Prize";}}','system','0','0','0','0','0','6','0','1','21','383','866','872','884','0','0','0','0'),('management','885','872','admin/structure/entity-type/prize/prize/%/edit','admin/structure/entity-type/prize/prize/%/edit','Edit Prize','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"Edit an entity of type Prize with bundle Prize";}}','system','0','0','0','0','0','6','0','1','21','383','866','872','885','0','0','0','0'),('management','886','883','admin/structure/entity-type/prize/prize/fields/%/delete','admin/structure/entity-type/prize/prize/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','866','872','877','883','886','0','0'),('management','887','883','admin/structure/entity-type/prize/prize/fields/%/edit','admin/structure/entity-type/prize/prize/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','866','872','877','883','887','0','0'),('management','888','883','admin/structure/entity-type/prize/prize/fields/%/field-settings','admin/structure/entity-type/prize/prize/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','866','872','877','883','888','0','0'),('management','889','883','admin/structure/entity-type/prize/prize/fields/%/widget-type','admin/structure/entity-type/prize/prize/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','866','872','877','883','889','0','0'),('navigation','891','795','library/dashboard/branches/program/drawing_ticket/add','library/dashboard/branches/program/drawing_ticket/add','Add Drawing Ticket','a:0:{}','system','0','0','0','0','0','3','0','794','795','891','0','0','0','0','0','0','0'),('navigation','892','0','school/%','school/%','','a:0:{}','system','0','0','1','0','0','1','0','892','0','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','893','892','school/%/edit','school/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','892','893','0','0','0','0','0','0','0','0'),('navigation','894','0','school/school/%','school/school/%','View School','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View an entity of type School with bundle School";}}','system','0','0','0','0','0','1','0','894','0','0','0','0','0','0','0','0','0'),('navigation','895','894','school/school/%/delete','school/school/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View an entity of type School with bundle School";}}','system','-1','0','0','0','2','2','0','894','895','0','0','0','0','0','0','0','0'),('navigation','896','894','school/school/%/edit','school/school/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View an entity of type School with bundle School";}}','system','-1','0','0','0','1','2','0','894','896','0','0','0','0','0','0','0','0'),('navigation','897','894','school/school/%/view','school/school/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','894','897','0','0','0','0','0','0','0','0'),('management','898','383','admin/structure/entity-type/school','admin/structure/entity-type/school','School','a:1:{s:10:"attributes";a:1:{s:5:"title";s:33:"View all the bundles for ''School''";}}','system','0','0','1','0','0','4','0','1','21','383','898','0','0','0','0','0','0'),('management','899','898','admin/structure/entity-type/school/add','admin/structure/entity-type/school/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:28:"Add a(n) new ''School Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','898','899','0','0','0','0','0'),('management','900','898','admin/structure/entity-type/school/list','admin/structure/entity-type/school/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','898','900','0','0','0','0','0'),('management','901','898','admin/structure/entity-type/school/delete','admin/structure/entity-type/school/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:31:"Delete the ''School'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','898','901','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','902','898','admin/structure/entity-type/school/edit','admin/structure/entity-type/school/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:29:"Edit the ''School'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','898','902','0','0','0','0','0'),('management','903','898','admin/structure/entity-type/school/properties','admin/structure/entity-type/school/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:47:"Manage the properties of the School entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','898','903','0','0','0','0','0'),('management','904','898','admin/structure/entity-type/school/school','admin/structure/entity-type/school/school','School','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"View all entites of type School with bundle School";}}','system','0','0','1','0','0','5','0','1','21','383','898','904','0','0','0','0','0'),('management','905','904','admin/structure/entity-type/school/school/delete','admin/structure/entity-type/school/school/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','898','904','905','0','0','0','0'),('management','906','904','admin/structure/entity-type/school/school/edit','admin/structure/entity-type/school/school/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','898','904','906','0','0','0','0'),('management','907','904','admin/structure/entity-type/school/school/list','admin/structure/entity-type/school/school/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','898','904','907','0','0','0','0'),('management','908','904','admin/structure/entity-type/school/school/display','admin/structure/entity-type/school/school/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','898','904','908','0','0','0','0'),('management','909','904','admin/structure/entity-type/school/school/fields','admin/structure/entity-type/school/school/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','898','904','909','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','910','904','admin/structure/entity-type/school/school/add','admin/structure/entity-type/school/school/add','Add School','a:1:{s:10:"attributes";a:1:{s:5:"title";s:47:"Add an entity of type School with bundle School";}}','system','0','0','0','0','0','6','0','1','21','383','898','904','910','0','0','0','0'),('management','911','908','admin/structure/entity-type/school/school/display/default','admin/structure/entity-type/school/school/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','898','904','908','911','0','0','0'),('management','912','908','admin/structure/entity-type/school/school/display/full','admin/structure/entity-type/school/school/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','898','904','908','912','0','0','0'),('management','913','908','admin/structure/entity-type/school/school/display/teaser','admin/structure/entity-type/school/school/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','898','904','908','913','0','0','0'),('management','914','908','admin/structure/entity-type/school/school/display/token','admin/structure/entity-type/school/school/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','898','904','908','914','0','0','0'),('management','915','904','admin/structure/entity-type/school/school/%/delete','admin/structure/entity-type/school/school/%/delete','Delete School','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"Delete an entity of type School with bundle School";}}','system','0','0','0','0','0','6','0','1','21','383','898','904','915','0','0','0','0'),('management','916','904','admin/structure/entity-type/school/school/%/edit','admin/structure/entity-type/school/school/%/edit','Edit School','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"Edit an entity of type School with bundle School";}}','system','0','0','0','0','0','6','0','1','21','383','898','904','916','0','0','0','0'),('management','917','909','admin/structure/entity-type/school/school/fields/%','admin/structure/entity-type/school/school/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','898','904','909','917','0','0','0');
INSERT INTO `menu_links` VALUES ('management','918','917','admin/structure/entity-type/school/school/fields/%/delete','admin/structure/entity-type/school/school/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','898','904','909','917','918','0','0'),('management','919','917','admin/structure/entity-type/school/school/fields/%/edit','admin/structure/entity-type/school/school/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','898','904','909','917','919','0','0'),('management','920','917','admin/structure/entity-type/school/school/fields/%/field-settings','admin/structure/entity-type/school/school/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','898','904','909','917','920','0','0'),('management','921','917','admin/structure/entity-type/school/school/fields/%/widget-type','admin/structure/entity-type/school/school/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','898','904','909','917','921','0','0'),('navigation','922','0','reading_log/%','reading_log/%','','a:0:{}','system','0','0','1','0','0','1','0','922','0','0','0','0','0','0','0','0','0'),('navigation','923','922','reading_log/%/edit','reading_log/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','922','923','0','0','0','0','0','0','0','0'),('navigation','924','0','reading_log/reading_log/%','reading_log/reading_log/%','View Reading Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:58:"View an entity of type Reading Log with bundle Reading Log";}}','system','0','0','0','0','0','1','0','924','0','0','0','0','0','0','0','0','0'),('navigation','925','924','reading_log/reading_log/%/delete','reading_log/reading_log/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:58:"View an entity of type Reading Log with bundle Reading Log";}}','system','-1','0','0','0','2','2','0','924','925','0','0','0','0','0','0','0','0'),('navigation','926','924','reading_log/reading_log/%/edit','reading_log/reading_log/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:58:"View an entity of type Reading Log with bundle Reading Log";}}','system','-1','0','0','0','1','2','0','924','926','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','927','924','reading_log/reading_log/%/view','reading_log/reading_log/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','924','927','0','0','0','0','0','0','0','0'),('management','928','383','admin/structure/entity-type/reading_log','admin/structure/entity-type/reading_log','Reading Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:38:"View all the bundles for ''Reading Log''";}}','system','0','0','1','0','0','4','0','1','21','383','928','0','0','0','0','0','0'),('management','929','928','admin/structure/entity-type/reading_log/add','admin/structure/entity-type/reading_log/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:33:"Add a(n) new ''Reading Log Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','928','929','0','0','0','0','0'),('management','930','928','admin/structure/entity-type/reading_log/list','admin/structure/entity-type/reading_log/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','928','930','0','0','0','0','0'),('management','931','928','admin/structure/entity-type/reading_log/delete','admin/structure/entity-type/reading_log/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:36:"Delete the ''Reading Log'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','928','931','0','0','0','0','0'),('management','932','928','admin/structure/entity-type/reading_log/edit','admin/structure/entity-type/reading_log/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:34:"Edit the ''Reading Log'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','928','932','0','0','0','0','0'),('management','933','928','admin/structure/entity-type/reading_log/properties','admin/structure/entity-type/reading_log/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:52:"Manage the properties of the Reading Log entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','928','933','0','0','0','0','0'),('management','934','928','admin/structure/entity-type/reading_log/reading_log','admin/structure/entity-type/reading_log/reading_log','Reading Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"View all entites of type Reading Log with bundle Reading Log";}}','system','0','0','1','0','0','5','0','1','21','383','928','934','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','935','934','admin/structure/entity-type/reading_log/reading_log/delete','admin/structure/entity-type/reading_log/reading_log/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','928','934','935','0','0','0','0'),('management','936','934','admin/structure/entity-type/reading_log/reading_log/edit','admin/structure/entity-type/reading_log/reading_log/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','928','934','936','0','0','0','0'),('management','937','934','admin/structure/entity-type/reading_log/reading_log/list','admin/structure/entity-type/reading_log/reading_log/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','928','934','937','0','0','0','0'),('management','938','934','admin/structure/entity-type/reading_log/reading_log/display','admin/structure/entity-type/reading_log/reading_log/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','928','934','938','0','0','0','0'),('management','939','934','admin/structure/entity-type/reading_log/reading_log/fields','admin/structure/entity-type/reading_log/reading_log/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','928','934','939','0','0','0','0'),('management','940','934','admin/structure/entity-type/reading_log/reading_log/add','admin/structure/entity-type/reading_log/reading_log/add','Add Reading Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:57:"Add an entity of type Reading Log with bundle Reading Log";}}','system','0','0','0','0','0','6','0','1','21','383','928','934','940','0','0','0','0'),('management','941','938','admin/structure/entity-type/reading_log/reading_log/display/default','admin/structure/entity-type/reading_log/reading_log/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','928','934','938','941','0','0','0'),('management','942','938','admin/structure/entity-type/reading_log/reading_log/display/full','admin/structure/entity-type/reading_log/reading_log/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','928','934','938','942','0','0','0');
INSERT INTO `menu_links` VALUES ('management','943','938','admin/structure/entity-type/reading_log/reading_log/display/teaser','admin/structure/entity-type/reading_log/reading_log/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','928','934','938','943','0','0','0'),('management','944','938','admin/structure/entity-type/reading_log/reading_log/display/token','admin/structure/entity-type/reading_log/reading_log/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','928','934','938','944','0','0','0'),('management','945','934','admin/structure/entity-type/reading_log/reading_log/%/delete','admin/structure/entity-type/reading_log/reading_log/%/delete','Delete Reading Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"Delete an entity of type Reading Log with bundle Reading Log";}}','system','0','0','0','0','0','6','0','1','21','383','928','934','945','0','0','0','0'),('management','946','934','admin/structure/entity-type/reading_log/reading_log/%/edit','admin/structure/entity-type/reading_log/reading_log/%/edit','Edit Reading Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:58:"Edit an entity of type Reading Log with bundle Reading Log";}}','system','0','0','0','0','0','6','0','1','21','383','928','934','946','0','0','0','0'),('management','947','939','admin/structure/entity-type/reading_log/reading_log/fields/%','admin/structure/entity-type/reading_log/reading_log/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','928','934','939','947','0','0','0'),('management','948','947','admin/structure/entity-type/reading_log/reading_log/fields/%/delete','admin/structure/entity-type/reading_log/reading_log/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','928','934','939','947','948','0','0'),('management','949','947','admin/structure/entity-type/reading_log/reading_log/fields/%/edit','admin/structure/entity-type/reading_log/reading_log/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','928','934','939','947','949','0','0');
INSERT INTO `menu_links` VALUES ('management','950','947','admin/structure/entity-type/reading_log/reading_log/fields/%/field-settings','admin/structure/entity-type/reading_log/reading_log/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','928','934','939','947','950','0','0'),('management','951','947','admin/structure/entity-type/reading_log/reading_log/fields/%/widget-type','admin/structure/entity-type/reading_log/reading_log/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','928','934','939','947','951','0','0'),('navigation','952','0','badge/%','badge/%','','a:0:{}','system','0','0','1','0','0','1','0','952','0','0','0','0','0','0','0','0','0'),('navigation','953','952','badge/%/edit','badge/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','952','953','0','0','0','0','0','0','0','0'),('navigation','954','0','badge/badge/%','badge/badge/%','View Badge','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"View an entity of type Badge with bundle Badge";}}','system','0','0','0','0','0','1','0','954','0','0','0','0','0','0','0','0','0'),('navigation','955','954','badge/badge/%/delete','badge/badge/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"View an entity of type Badge with bundle Badge";}}','system','-1','0','0','0','2','2','0','954','955','0','0','0','0','0','0','0','0'),('navigation','956','954','badge/badge/%/edit','badge/badge/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"View an entity of type Badge with bundle Badge";}}','system','-1','0','0','0','1','2','0','954','956','0','0','0','0','0','0','0','0'),('navigation','957','954','badge/badge/%/view','badge/badge/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','954','957','0','0','0','0','0','0','0','0'),('management','958','383','admin/structure/entity-type/badge','admin/structure/entity-type/badge','Badge','a:1:{s:10:"attributes";a:1:{s:5:"title";s:32:"View all the bundles for ''Badge''";}}','system','0','0','1','0','0','4','0','1','21','383','958','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','959','958','admin/structure/entity-type/badge/add','admin/structure/entity-type/badge/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:27:"Add a(n) new ''Badge Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','958','959','0','0','0','0','0'),('management','960','958','admin/structure/entity-type/badge/badge','admin/structure/entity-type/badge/badge','Badge','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View all entites of type Badge with bundle Badge";}}','system','0','0','1','0','0','5','0','1','21','383','958','960','0','0','0','0','0'),('management','961','958','admin/structure/entity-type/badge/list','admin/structure/entity-type/badge/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','958','961','0','0','0','0','0'),('management','962','958','admin/structure/entity-type/badge/delete','admin/structure/entity-type/badge/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:30:"Delete the ''Badge'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','958','962','0','0','0','0','0'),('management','963','958','admin/structure/entity-type/badge/edit','admin/structure/entity-type/badge/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:28:"Edit the ''Badge'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','958','963','0','0','0','0','0'),('management','964','958','admin/structure/entity-type/badge/properties','admin/structure/entity-type/badge/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"Manage the properties of the Badge entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','958','964','0','0','0','0','0'),('management','965','960','admin/structure/entity-type/badge/badge/delete','admin/structure/entity-type/badge/badge/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','958','960','965','0','0','0','0'),('management','966','960','admin/structure/entity-type/badge/badge/edit','admin/structure/entity-type/badge/badge/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','958','960','966','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','967','960','admin/structure/entity-type/badge/badge/list','admin/structure/entity-type/badge/badge/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','958','960','967','0','0','0','0'),('management','968','960','admin/structure/entity-type/badge/badge/display','admin/structure/entity-type/badge/badge/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','958','960','968','0','0','0','0'),('management','969','960','admin/structure/entity-type/badge/badge/fields','admin/structure/entity-type/badge/badge/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','958','960','969','0','0','0','0'),('management','970','960','admin/structure/entity-type/badge/badge/add','admin/structure/entity-type/badge/badge/add','Add Badge','a:1:{s:10:"attributes";a:1:{s:5:"title";s:45:"Add an entity of type Badge with bundle Badge";}}','system','0','0','0','0','0','6','0','1','21','383','958','960','970','0','0','0','0'),('management','971','968','admin/structure/entity-type/badge/badge/display/default','admin/structure/entity-type/badge/badge/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','958','960','968','971','0','0','0'),('management','972','968','admin/structure/entity-type/badge/badge/display/full','admin/structure/entity-type/badge/badge/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','958','960','968','972','0','0','0'),('management','973','968','admin/structure/entity-type/badge/badge/display/teaser','admin/structure/entity-type/badge/badge/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','958','960','968','973','0','0','0'),('management','974','968','admin/structure/entity-type/badge/badge/display/token','admin/structure/entity-type/badge/badge/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','958','960','968','974','0','0','0'),('management','975','960','admin/structure/entity-type/badge/badge/%/delete','admin/structure/entity-type/badge/badge/%/delete','Delete Badge','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"Delete an entity of type Badge with bundle Badge";}}','system','0','0','0','0','0','6','0','1','21','383','958','960','975','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','976','960','admin/structure/entity-type/badge/badge/%/edit','admin/structure/entity-type/badge/badge/%/edit','Edit Badge','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"Edit an entity of type Badge with bundle Badge";}}','system','0','0','0','0','0','6','0','1','21','383','958','960','976','0','0','0','0'),('management','977','969','admin/structure/entity-type/badge/badge/fields/%','admin/structure/entity-type/badge/badge/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','958','960','969','977','0','0','0'),('management','978','977','admin/structure/entity-type/badge/badge/fields/%/delete','admin/structure/entity-type/badge/badge/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','958','960','969','977','978','0','0'),('management','979','977','admin/structure/entity-type/badge/badge/fields/%/edit','admin/structure/entity-type/badge/badge/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','958','960','969','977','979','0','0'),('management','980','977','admin/structure/entity-type/badge/badge/fields/%/field-settings','admin/structure/entity-type/badge/badge/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','958','960','969','977','980','0','0'),('management','981','977','admin/structure/entity-type/badge/badge/fields/%/widget-type','admin/structure/entity-type/badge/badge/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','958','960','969','977','981','0','0'),('navigation','982','0','reader_prize/%','reader_prize/%','','a:0:{}','system','0','0','1','0','0','1','0','982','0','0','0','0','0','0','0','0','0'),('navigation','983','982','reader_prize/%/edit','reader_prize/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','982','983','0','0','0','0','0','0','0','0'),('navigation','984','0','reader_prize/reader_prize/%','reader_prize/reader_prize/%','View Reader Prize','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"View an entity of type Reader Prize with bundle Reader Prize";}}','system','0','0','0','0','0','1','0','984','0','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','985','984','reader_prize/reader_prize/%/delete','reader_prize/reader_prize/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"View an entity of type Reader Prize with bundle Reader Prize";}}','system','-1','0','0','0','2','2','0','984','985','0','0','0','0','0','0','0','0'),('navigation','986','984','reader_prize/reader_prize/%/edit','reader_prize/reader_prize/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"View an entity of type Reader Prize with bundle Reader Prize";}}','system','-1','0','0','0','1','2','0','984','986','0','0','0','0','0','0','0','0'),('navigation','987','984','reader_prize/reader_prize/%/view','reader_prize/reader_prize/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','984','987','0','0','0','0','0','0','0','0'),('management','988','383','admin/structure/entity-type/reader_prize','admin/structure/entity-type/reader_prize','Reader Prize','a:1:{s:10:"attributes";a:1:{s:5:"title";s:39:"View all the bundles for ''Reader Prize''";}}','system','0','0','1','0','0','4','0','1','21','383','988','0','0','0','0','0','0'),('management','989','988','admin/structure/entity-type/reader_prize/add','admin/structure/entity-type/reader_prize/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:34:"Add a(n) new ''Reader Prize Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','988','989','0','0','0','0','0'),('management','990','988','admin/structure/entity-type/reader_prize/list','admin/structure/entity-type/reader_prize/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','988','990','0','0','0','0','0'),('management','991','988','admin/structure/entity-type/reader_prize/delete','admin/structure/entity-type/reader_prize/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:37:"Delete the ''Reader Prize'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','988','991','0','0','0','0','0'),('management','992','988','admin/structure/entity-type/reader_prize/edit','admin/structure/entity-type/reader_prize/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:35:"Edit the ''Reader Prize'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','988','992','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','993','988','admin/structure/entity-type/reader_prize/properties','admin/structure/entity-type/reader_prize/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:53:"Manage the properties of the Reader Prize entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','988','993','0','0','0','0','0'),('management','994','988','admin/structure/entity-type/reader_prize/reader_prize','admin/structure/entity-type/reader_prize/reader_prize','Reader Prize','a:1:{s:10:"attributes";a:1:{s:5:"title";s:62:"View all entites of type Reader Prize with bundle Reader Prize";}}','system','0','0','1','0','0','5','0','1','21','383','988','994','0','0','0','0','0'),('management','995','994','admin/structure/entity-type/reader_prize/reader_prize/delete','admin/structure/entity-type/reader_prize/reader_prize/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','988','994','995','0','0','0','0'),('management','996','994','admin/structure/entity-type/reader_prize/reader_prize/edit','admin/structure/entity-type/reader_prize/reader_prize/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','988','994','996','0','0','0','0'),('management','997','994','admin/structure/entity-type/reader_prize/reader_prize/list','admin/structure/entity-type/reader_prize/reader_prize/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','988','994','997','0','0','0','0'),('management','998','994','admin/structure/entity-type/reader_prize/reader_prize/display','admin/structure/entity-type/reader_prize/reader_prize/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','988','994','998','0','0','0','0'),('management','999','994','admin/structure/entity-type/reader_prize/reader_prize/fields','admin/structure/entity-type/reader_prize/reader_prize/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','988','994','999','0','0','0','0'),('management','1000','994','admin/structure/entity-type/reader_prize/reader_prize/add','admin/structure/entity-type/reader_prize/reader_prize/add','Add Reader Prize','a:1:{s:10:"attributes";a:1:{s:5:"title";s:59:"Add an entity of type Reader Prize with bundle Reader Prize";}}','system','0','0','0','0','0','6','0','1','21','383','988','994','1000','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1001','998','admin/structure/entity-type/reader_prize/reader_prize/display/default','admin/structure/entity-type/reader_prize/reader_prize/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','988','994','998','1001','0','0','0'),('management','1002','998','admin/structure/entity-type/reader_prize/reader_prize/display/full','admin/structure/entity-type/reader_prize/reader_prize/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','988','994','998','1002','0','0','0'),('management','1003','998','admin/structure/entity-type/reader_prize/reader_prize/display/teaser','admin/structure/entity-type/reader_prize/reader_prize/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','988','994','998','1003','0','0','0'),('management','1004','998','admin/structure/entity-type/reader_prize/reader_prize/display/token','admin/structure/entity-type/reader_prize/reader_prize/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','988','994','998','1004','0','0','0'),('management','1005','999','admin/structure/entity-type/reader_prize/reader_prize/fields/%','admin/structure/entity-type/reader_prize/reader_prize/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','988','994','999','1005','0','0','0'),('management','1006','994','admin/structure/entity-type/reader_prize/reader_prize/%/delete','admin/structure/entity-type/reader_prize/reader_prize/%/delete','Delete Reader Prize','a:1:{s:10:"attributes";a:1:{s:5:"title";s:62:"Delete an entity of type Reader Prize with bundle Reader Prize";}}','system','0','0','0','0','0','6','0','1','21','383','988','994','1006','0','0','0','0'),('management','1007','994','admin/structure/entity-type/reader_prize/reader_prize/%/edit','admin/structure/entity-type/reader_prize/reader_prize/%/edit','Edit Reader Prize','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"Edit an entity of type Reader Prize with bundle Reader Prize";}}','system','0','0','0','0','0','6','0','1','21','383','988','994','1007','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1008','1005','admin/structure/entity-type/reader_prize/reader_prize/fields/%/delete','admin/structure/entity-type/reader_prize/reader_prize/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','988','994','999','1005','1008','0','0'),('management','1009','1005','admin/structure/entity-type/reader_prize/reader_prize/fields/%/edit','admin/structure/entity-type/reader_prize/reader_prize/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','988','994','999','1005','1009','0','0'),('management','1010','1005','admin/structure/entity-type/reader_prize/reader_prize/fields/%/field-settings','admin/structure/entity-type/reader_prize/reader_prize/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','988','994','999','1005','1010','0','0'),('management','1011','1005','admin/structure/entity-type/reader_prize/reader_prize/fields/%/widget-type','admin/structure/entity-type/reader_prize/reader_prize/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','988','994','999','1005','1011','0','0'),('navigation','1012','0','points/%','points/%','','a:0:{}','system','0','0','1','0','0','1','0','1012','0','0','0','0','0','0','0','0','0'),('navigation','1013','1012','points/%/edit','points/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','1012','1013','0','0','0','0','0','0','0','0'),('navigation','1014','0','points/points/%','points/points/%','View Points','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View an entity of type Points with bundle Points";}}','system','0','0','0','0','0','1','0','1014','0','0','0','0','0','0','0','0','0'),('navigation','1015','1014','points/points/%/delete','points/points/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View an entity of type Points with bundle Points";}}','system','-1','0','0','0','2','2','0','1014','1015','0','0','0','0','0','0','0','0'),('navigation','1016','1014','points/points/%/edit','points/points/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"View an entity of type Points with bundle Points";}}','system','-1','0','0','0','1','2','0','1014','1016','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','1017','1014','points/points/%/view','points/points/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','1014','1017','0','0','0','0','0','0','0','0'),('management','1018','383','admin/structure/entity-type/points','admin/structure/entity-type/points','Points','a:1:{s:10:"attributes";a:1:{s:5:"title";s:33:"View all the bundles for ''Points''";}}','system','0','0','1','0','0','4','0','1','21','383','1018','0','0','0','0','0','0'),('management','1019','1018','admin/structure/entity-type/points/add','admin/structure/entity-type/points/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:28:"Add a(n) new ''Points Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','1018','1019','0','0','0','0','0'),('management','1020','1018','admin/structure/entity-type/points/list','admin/structure/entity-type/points/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','1018','1020','0','0','0','0','0'),('management','1021','1018','admin/structure/entity-type/points/delete','admin/structure/entity-type/points/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:31:"Delete the ''Points'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','1018','1021','0','0','0','0','0'),('management','1022','1018','admin/structure/entity-type/points/edit','admin/structure/entity-type/points/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:29:"Edit the ''Points'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','1018','1022','0','0','0','0','0'),('management','1023','1018','admin/structure/entity-type/points/properties','admin/structure/entity-type/points/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:47:"Manage the properties of the Points entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','1018','1023','0','0','0','0','0'),('management','1024','1018','admin/structure/entity-type/points/points','admin/structure/entity-type/points/points','Points','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"View all entites of type Points with bundle Points";}}','system','0','0','1','0','0','5','0','1','21','383','1018','1024','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1025','1024','admin/structure/entity-type/points/points/delete','admin/structure/entity-type/points/points/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1018','1024','1025','0','0','0','0'),('management','1026','1024','admin/structure/entity-type/points/points/edit','admin/structure/entity-type/points/points/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1018','1024','1026','0','0','0','0'),('management','1027','1024','admin/structure/entity-type/points/points/list','admin/structure/entity-type/points/points/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','1018','1024','1027','0','0','0','0'),('management','1028','1024','admin/structure/entity-type/points/points/display','admin/structure/entity-type/points/points/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','1018','1024','1028','0','0','0','0'),('management','1029','1024','admin/structure/entity-type/points/points/fields','admin/structure/entity-type/points/points/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','1018','1024','1029','0','0','0','0'),('management','1030','1024','admin/structure/entity-type/points/points/add','admin/structure/entity-type/points/points/add','Add Points','a:1:{s:10:"attributes";a:1:{s:5:"title";s:47:"Add an entity of type Points with bundle Points";}}','system','0','0','0','0','0','6','0','1','21','383','1018','1024','1030','0','0','0','0'),('management','1031','1028','admin/structure/entity-type/points/points/display/default','admin/structure/entity-type/points/points/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','1018','1024','1028','1031','0','0','0'),('management','1032','1028','admin/structure/entity-type/points/points/display/full','admin/structure/entity-type/points/points/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','1018','1024','1028','1032','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1033','1028','admin/structure/entity-type/points/points/display/teaser','admin/structure/entity-type/points/points/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','1018','1024','1028','1033','0','0','0'),('management','1034','1028','admin/structure/entity-type/points/points/display/token','admin/structure/entity-type/points/points/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','1018','1024','1028','1034','0','0','0'),('management','1035','1029','admin/structure/entity-type/points/points/fields/%','admin/structure/entity-type/points/points/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','1018','1024','1029','1035','0','0','0'),('management','1036','1024','admin/structure/entity-type/points/points/%/delete','admin/structure/entity-type/points/points/%/delete','Delete Points','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"Delete an entity of type Points with bundle Points";}}','system','0','0','0','0','0','6','0','1','21','383','1018','1024','1036','0','0','0','0'),('management','1037','1024','admin/structure/entity-type/points/points/%/edit','admin/structure/entity-type/points/points/%/edit','Edit Points','a:1:{s:10:"attributes";a:1:{s:5:"title";s:48:"Edit an entity of type Points with bundle Points";}}','system','0','0','0','0','0','6','0','1','21','383','1018','1024','1037','0','0','0','0'),('management','1038','1035','admin/structure/entity-type/points/points/fields/%/delete','admin/structure/entity-type/points/points/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','1018','1024','1029','1035','1038','0','0'),('management','1039','1035','admin/structure/entity-type/points/points/fields/%/edit','admin/structure/entity-type/points/points/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1018','1024','1029','1035','1039','0','0'),('management','1040','1035','admin/structure/entity-type/points/points/fields/%/field-settings','admin/structure/entity-type/points/points/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1018','1024','1029','1035','1040','0','0');
INSERT INTO `menu_links` VALUES ('management','1041','1035','admin/structure/entity-type/points/points/fields/%/widget-type','admin/structure/entity-type/points/points/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1018','1024','1029','1035','1041','0','0'),('navigation','1042','0','activity_log_reference/%','activity_log_reference/%','','a:0:{}','system','0','0','1','0','0','1','0','1042','0','0','0','0','0','0','0','0','0'),('navigation','1043','1042','activity_log_reference/%/edit','activity_log_reference/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','1042','1043','0','0','0','0','0','0','0','0'),('navigation','1044','0','activity_log_reference/activity_log_reference/%','activity_log_reference/activity_log_reference/%','View Activity Log Reference','a:1:{s:10:"attributes";a:1:{s:5:"title";s:80:"View an entity of type Activity Log Reference with bundle Activity Log Reference";}}','system','0','0','0','0','0','1','0','1044','0','0','0','0','0','0','0','0','0'),('navigation','1045','1044','activity_log_reference/activity_log_reference/%/delete','activity_log_reference/activity_log_reference/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:80:"View an entity of type Activity Log Reference with bundle Activity Log Reference";}}','system','-1','0','0','0','2','2','0','1044','1045','0','0','0','0','0','0','0','0'),('navigation','1046','1044','activity_log_reference/activity_log_reference/%/edit','activity_log_reference/activity_log_reference/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:80:"View an entity of type Activity Log Reference with bundle Activity Log Reference";}}','system','-1','0','0','0','1','2','0','1044','1046','0','0','0','0','0','0','0','0'),('navigation','1047','1044','activity_log_reference/activity_log_reference/%/view','activity_log_reference/activity_log_reference/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','1044','1047','0','0','0','0','0','0','0','0'),('management','1048','383','admin/structure/entity-type/activity_log_reference','admin/structure/entity-type/activity_log_reference','Activity Log Reference','a:1:{s:10:"attributes";a:1:{s:5:"title";s:49:"View all the bundles for ''Activity Log Reference''";}}','system','0','0','1','0','0','4','0','1','21','383','1048','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1049','1048','admin/structure/entity-type/activity_log_reference/activity_log_reference','admin/structure/entity-type/activity_log_reference/activity_log_reference','Activity Log Reference','a:1:{s:10:"attributes";a:1:{s:5:"title";s:82:"View all entites of type Activity Log Reference with bundle Activity Log Reference";}}','system','0','0','1','0','0','5','0','1','21','383','1048','1049','0','0','0','0','0'),('management','1050','1048','admin/structure/entity-type/activity_log_reference/add','admin/structure/entity-type/activity_log_reference/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:44:"Add a(n) new ''Activity Log Reference Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','1048','1050','0','0','0','0','0'),('management','1051','1048','admin/structure/entity-type/activity_log_reference/list','admin/structure/entity-type/activity_log_reference/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','1048','1051','0','0','0','0','0'),('management','1052','1048','admin/structure/entity-type/activity_log_reference/delete','admin/structure/entity-type/activity_log_reference/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:47:"Delete the ''Activity Log Reference'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','1048','1052','0','0','0','0','0'),('management','1053','1048','admin/structure/entity-type/activity_log_reference/edit','admin/structure/entity-type/activity_log_reference/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:45:"Edit the ''Activity Log Reference'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','1048','1053','0','0','0','0','0'),('management','1054','1048','admin/structure/entity-type/activity_log_reference/properties','admin/structure/entity-type/activity_log_reference/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:63:"Manage the properties of the Activity Log Reference entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','1048','1054','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1055','1049','admin/structure/entity-type/activity_log_reference/activity_log_reference/delete','admin/structure/entity-type/activity_log_reference/activity_log_reference/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1048','1049','1055','0','0','0','0'),('management','1056','1049','admin/structure/entity-type/activity_log_reference/activity_log_reference/edit','admin/structure/entity-type/activity_log_reference/activity_log_reference/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1048','1049','1056','0','0','0','0'),('management','1057','1049','admin/structure/entity-type/activity_log_reference/activity_log_reference/list','admin/structure/entity-type/activity_log_reference/activity_log_reference/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','1048','1049','1057','0','0','0','0'),('management','1058','1049','admin/structure/entity-type/activity_log_reference/activity_log_reference/display','admin/structure/entity-type/activity_log_reference/activity_log_reference/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','1048','1049','1058','0','0','0','0'),('management','1059','1049','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','1048','1049','1059','0','0','0','0'),('management','1060','1049','admin/structure/entity-type/activity_log_reference/activity_log_reference/add','admin/structure/entity-type/activity_log_reference/activity_log_reference/add','Add Activity Log Reference','a:1:{s:10:"attributes";a:1:{s:5:"title";s:79:"Add an entity of type Activity Log Reference with bundle Activity Log Reference";}}','system','0','0','0','0','0','6','0','1','21','383','1048','1049','1060','0','0','0','0'),('management','1061','1058','admin/structure/entity-type/activity_log_reference/activity_log_reference/display/default','admin/structure/entity-type/activity_log_reference/activity_log_reference/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','1048','1049','1058','1061','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1062','1058','admin/structure/entity-type/activity_log_reference/activity_log_reference/display/full','admin/structure/entity-type/activity_log_reference/activity_log_reference/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','1048','1049','1058','1062','0','0','0'),('management','1063','1058','admin/structure/entity-type/activity_log_reference/activity_log_reference/display/teaser','admin/structure/entity-type/activity_log_reference/activity_log_reference/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','1048','1049','1058','1063','0','0','0'),('management','1064','1058','admin/structure/entity-type/activity_log_reference/activity_log_reference/display/token','admin/structure/entity-type/activity_log_reference/activity_log_reference/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','1048','1049','1058','1064','0','0','0'),('management','1065','1049','admin/structure/entity-type/activity_log_reference/activity_log_reference/%/delete','admin/structure/entity-type/activity_log_reference/activity_log_reference/%/delete','Delete Activity Log Reference','a:1:{s:10:"attributes";a:1:{s:5:"title";s:82:"Delete an entity of type Activity Log Reference with bundle Activity Log Reference";}}','system','0','0','0','0','0','6','0','1','21','383','1048','1049','1065','0','0','0','0'),('management','1066','1049','admin/structure/entity-type/activity_log_reference/activity_log_reference/%/edit','admin/structure/entity-type/activity_log_reference/activity_log_reference/%/edit','Edit Activity Log Reference','a:1:{s:10:"attributes";a:1:{s:5:"title";s:80:"Edit an entity of type Activity Log Reference with bundle Activity Log Reference";}}','system','0','0','0','0','0','6','0','1','21','383','1048','1049','1066','0','0','0','0'),('management','1067','1059','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','1048','1049','1059','1067','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1068','1067','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%/edit','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1048','1049','1059','1067','1068','0','0'),('management','1069','1067','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%/delete','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','1048','1049','1059','1067','1069','0','0'),('management','1070','1067','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%/field-settings','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1048','1049','1059','1067','1070','0','0'),('management','1071','1067','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%/widget-type','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1048','1049','1059','1067','1071','0','0'),('management','1072','21','admin/structure/panels','admin/structure/panels','Panels','a:1:{s:10:"attributes";a:1:{s:5:"title";s:49:"Get a bird''s eye view of items related to Panels.";}}','system','0','0','0','0','0','3','0','1','21','1072','0','0','0','0','0','0','0'),('management','1073','1072','admin/structure/panels/dashboard','admin/structure/panels/dashboard','Dashboard','a:0:{}','system','-1','0','0','0','-10','4','0','1','21','1072','1073','0','0','0','0','0','0'),('management','1075','1072','admin/structure/panels/settings','admin/structure/panels/settings','Settings','a:0:{}','system','-1','0','0','0','0','4','0','1','21','1072','1075','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1077','1075','admin/structure/panels/settings/general','admin/structure/panels/settings/general','General','a:0:{}','system','-1','0','0','0','-10','5','0','1','21','1072','1075','1077','0','0','0','0','0'),('management','1082','21','admin/structure/mini-panels','admin/structure/mini-panels','Mini panels','a:1:{s:10:"attributes";a:1:{s:5:"title";s:94:"Add, edit or delete mini panels, which can be used as blocks or content panes in other panels.";}}','system','0','0','0','0','0','3','0','1','21','1082','0','0','0','0','0','0','0'),('navigation','1083','6','node/add/panel','node/add/panel','Panel','a:1:{s:10:"attributes";a:1:{s:5:"title";s:47:"A panel layout broken up into rows and columns.";}}','system','0','0','0','0','0','2','0','6','1083','0','0','0','0','0','0','0','0'),('navigation','1084','5','node/%/panel_content','node/%/panel_content','Panel content','a:0:{}','system','-1','0','0','0','3','2','0','5','1084','0','0','0','0','0','0','0','0'),('navigation','1085','5','node/%/panel_layout','node/%/panel_layout','Panel layout','a:0:{}','system','-1','0','0','0','2','2','0','5','1085','0','0','0','0','0','0','0','0'),('management','1086','1082','admin/structure/mini-panels/add','admin/structure/mini-panels/add','Add','a:0:{}','system','-1','0','0','0','0','4','0','1','21','1082','1086','0','0','0','0','0','0'),('management','1087','1082','admin/structure/mini-panels/import','admin/structure/mini-panels/import','Import','a:0:{}','system','-1','0','0','0','0','4','0','1','21','1082','1087','0','0','0','0','0','0'),('management','1088','1082','admin/structure/mini-panels/list','admin/structure/mini-panels/list','List','a:0:{}','system','-1','0','0','0','-10','4','0','1','21','1082','1088','0','0','0','0','0','0'),('management','1089','1082','admin/structure/mini-panels/settings','admin/structure/mini-panels/settings','Settings','a:0:{}','system','-1','0','0','0','0','4','0','1','21','1082','1089','0','0','0','0','0','0'),('management','1090','1075','admin/structure/panels/settings/panels-mini','admin/structure/panels/settings/panels-mini','Mini panels','a:0:{}','system','-1','0','0','0','0','5','0','1','21','1072','1075','1090','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1091','1075','admin/structure/panels/settings/panel-node','admin/structure/panels/settings/panel-node','Panel nodes','a:1:{s:10:"attributes";a:1:{s:5:"title";s:67:"Configure which content is available to add to panel node displays.";}}','system','-1','0','0','0','0','5','0','1','21','1072','1075','1091','0','0','0','0','0'),('management','1092','1088','admin/structure/mini-panels/list/%/edit','admin/structure/mini-panels/list/%/edit','Edit','a:0:{}','system','-1','0','0','0','-10','5','0','1','21','1082','1088','1092','0','0','0','0','0'),('management','1093','1088','admin/structure/mini-panels/list/%/export','admin/structure/mini-panels/list/%/export','Export','a:0:{}','system','-1','0','0','0','0','5','0','1','21','1082','1088','1093','0','0','0','0','0'),('management','1094','21','admin/structure/pages','admin/structure/pages','Pages','a:1:{s:10:"attributes";a:1:{s:5:"title";s:84:"Add, edit and remove overridden system pages and user defined pages from the system.";}}','system','0','0','1','0','0','3','0','1','21','1094','0','0','0','0','0','0','0'),('management','1095','1094','admin/structure/pages/add','admin/structure/pages/add','Add custom page','a:0:{}','system','-1','0','0','0','0','4','0','1','21','1094','1095','0','0','0','0','0','0'),('management','1096','1094','admin/structure/pages/import','admin/structure/pages/import','Import page','a:0:{}','system','-1','0','0','0','0','4','0','1','21','1094','1096','0','0','0','0','0','0'),('management','1097','1094','admin/structure/pages/list','admin/structure/pages/list','List','a:0:{}','system','-1','0','0','0','-10','4','0','1','21','1094','1097','0','0','0','0','0','0'),('management','1098','1094','admin/structure/pages/wizard','admin/structure/pages/wizard','Wizards','a:0:{}','system','-1','0','0','0','-5','4','0','1','21','1094','1098','0','0','0','0','0','0'),('management','1099','1094','admin/structure/pages/edit/%','admin/structure/pages/edit/%','Edit','a:0:{}','system','0','0','0','0','0','4','0','1','21','1094','1099','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1100','1075','admin/structure/panels/settings/panel-page','admin/structure/panels/settings/panel-page','Panel pages','a:0:{}','system','-1','0','0','0','-10','5','0','1','21','1072','1075','1100','0','0','0','0','0'),('management','1101','1094','admin/structure/pages/%/operation/%','admin/structure/pages/%/operation/%','','a:0:{}','system','0','0','0','0','0','4','0','1','21','1094','1101','0','0','0','0','0','0'),('navigation','1102','0','reader_badge/%','reader_badge/%','','a:0:{}','system','0','0','1','0','0','1','0','1102','0','0','0','0','0','0','0','0','0'),('navigation','1103','1102','reader_badge/%/edit','reader_badge/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','1102','1103','0','0','0','0','0','0','0','0'),('navigation','1104','0','reader_badge/reader_badge/%','reader_badge/reader_badge/%','View Reader Badge','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"View an entity of type Reader Badge with bundle Reader Badge";}}','system','0','0','0','0','0','1','0','1104','0','0','0','0','0','0','0','0','0'),('navigation','1105','1104','reader_badge/reader_badge/%/delete','reader_badge/reader_badge/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"View an entity of type Reader Badge with bundle Reader Badge";}}','system','-1','0','0','0','2','2','0','1104','1105','0','0','0','0','0','0','0','0'),('navigation','1106','1104','reader_badge/reader_badge/%/edit','reader_badge/reader_badge/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"View an entity of type Reader Badge with bundle Reader Badge";}}','system','-1','0','0','0','1','2','0','1104','1106','0','0','0','0','0','0','0','0'),('navigation','1107','1104','reader_badge/reader_badge/%/view','reader_badge/reader_badge/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','1104','1107','0','0','0','0','0','0','0','0'),('management','1108','383','admin/structure/entity-type/reader_badge','admin/structure/entity-type/reader_badge','Reader Badge','a:1:{s:10:"attributes";a:1:{s:5:"title";s:39:"View all the bundles for ''Reader Badge''";}}','system','0','0','1','0','0','4','0','1','21','383','1108','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1109','1108','admin/structure/entity-type/reader_badge/add','admin/structure/entity-type/reader_badge/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:34:"Add a(n) new ''Reader Badge Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','1108','1109','0','0','0','0','0'),('management','1110','1108','admin/structure/entity-type/reader_badge/list','admin/structure/entity-type/reader_badge/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','1108','1110','0','0','0','0','0'),('management','1111','1108','admin/structure/entity-type/reader_badge/delete','admin/structure/entity-type/reader_badge/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:37:"Delete the ''Reader Badge'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','1108','1111','0','0','0','0','0'),('management','1112','1108','admin/structure/entity-type/reader_badge/edit','admin/structure/entity-type/reader_badge/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:35:"Edit the ''Reader Badge'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','1108','1112','0','0','0','0','0'),('management','1113','1108','admin/structure/entity-type/reader_badge/properties','admin/structure/entity-type/reader_badge/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:53:"Manage the properties of the Reader Badge entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','1108','1113','0','0','0','0','0'),('management','1114','1108','admin/structure/entity-type/reader_badge/reader_badge','admin/structure/entity-type/reader_badge/reader_badge','Reader Badge','a:1:{s:10:"attributes";a:1:{s:5:"title";s:62:"View all entites of type Reader Badge with bundle Reader Badge";}}','system','0','0','1','0','0','5','0','1','21','383','1108','1114','0','0','0','0','0'),('management','1115','1114','admin/structure/entity-type/reader_badge/reader_badge/delete','admin/structure/entity-type/reader_badge/reader_badge/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1108','1114','1115','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1116','1114','admin/structure/entity-type/reader_badge/reader_badge/edit','admin/structure/entity-type/reader_badge/reader_badge/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1108','1114','1116','0','0','0','0'),('management','1117','1114','admin/structure/entity-type/reader_badge/reader_badge/list','admin/structure/entity-type/reader_badge/reader_badge/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','1108','1114','1117','0','0','0','0'),('management','1118','1114','admin/structure/entity-type/reader_badge/reader_badge/display','admin/structure/entity-type/reader_badge/reader_badge/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','1108','1114','1118','0','0','0','0'),('management','1119','1114','admin/structure/entity-type/reader_badge/reader_badge/fields','admin/structure/entity-type/reader_badge/reader_badge/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','1108','1114','1119','0','0','0','0'),('management','1120','1114','admin/structure/entity-type/reader_badge/reader_badge/add','admin/structure/entity-type/reader_badge/reader_badge/add','Add Reader Badge','a:1:{s:10:"attributes";a:1:{s:5:"title";s:59:"Add an entity of type Reader Badge with bundle Reader Badge";}}','system','0','0','0','0','0','6','0','1','21','383','1108','1114','1120','0','0','0','0'),('management','1121','1118','admin/structure/entity-type/reader_badge/reader_badge/display/default','admin/structure/entity-type/reader_badge/reader_badge/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','1108','1114','1118','1121','0','0','0'),('management','1122','1118','admin/structure/entity-type/reader_badge/reader_badge/display/full','admin/structure/entity-type/reader_badge/reader_badge/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','1108','1114','1118','1122','0','0','0'),('management','1123','1118','admin/structure/entity-type/reader_badge/reader_badge/display/teaser','admin/structure/entity-type/reader_badge/reader_badge/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','1108','1114','1118','1123','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1124','1118','admin/structure/entity-type/reader_badge/reader_badge/display/token','admin/structure/entity-type/reader_badge/reader_badge/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','1108','1114','1118','1124','0','0','0'),('management','1125','1114','admin/structure/entity-type/reader_badge/reader_badge/%/delete','admin/structure/entity-type/reader_badge/reader_badge/%/delete','Delete Reader Badge','a:1:{s:10:"attributes";a:1:{s:5:"title";s:62:"Delete an entity of type Reader Badge with bundle Reader Badge";}}','system','0','0','0','0','0','6','0','1','21','383','1108','1114','1125','0','0','0','0'),('management','1126','1114','admin/structure/entity-type/reader_badge/reader_badge/%/edit','admin/structure/entity-type/reader_badge/reader_badge/%/edit','Edit Reader Badge','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"Edit an entity of type Reader Badge with bundle Reader Badge";}}','system','0','0','0','0','0','6','0','1','21','383','1108','1114','1126','0','0','0','0'),('management','1127','1119','admin/structure/entity-type/reader_badge/reader_badge/fields/%','admin/structure/entity-type/reader_badge/reader_badge/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','1108','1114','1119','1127','0','0','0'),('management','1128','1127','admin/structure/entity-type/reader_badge/reader_badge/fields/%/delete','admin/structure/entity-type/reader_badge/reader_badge/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','1108','1114','1119','1127','1128','0','0'),('management','1129','1127','admin/structure/entity-type/reader_badge/reader_badge/fields/%/edit','admin/structure/entity-type/reader_badge/reader_badge/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1108','1114','1119','1127','1129','0','0'),('management','1130','1127','admin/structure/entity-type/reader_badge/reader_badge/fields/%/field-settings','admin/structure/entity-type/reader_badge/reader_badge/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1108','1114','1119','1127','1130','0','0');
INSERT INTO `menu_links` VALUES ('management','1131','1127','admin/structure/entity-type/reader_badge/reader_badge/fields/%/widget-type','admin/structure/entity-type/reader_badge/reader_badge/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1108','1114','1119','1127','1131','0','0'),('navigation','1132','0','reader_activity_log/%','reader_activity_log/%','','a:0:{}','system','0','0','1','0','0','1','0','1132','0','0','0','0','0','0','0','0','0'),('navigation','1133','1132','reader_activity_log/%/edit','reader_activity_log/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','1132','1133','0','0','0','0','0','0','0','0'),('navigation','1134','0','reader_activity_log/reader_activity_log/%','reader_activity_log/reader_activity_log/%','View Reader Activity Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:74:"View an entity of type Reader Activity Log with bundle Reader Activity Log";}}','system','0','0','0','0','0','1','0','1134','0','0','0','0','0','0','0','0','0'),('navigation','1135','1134','reader_activity_log/reader_activity_log/%/delete','reader_activity_log/reader_activity_log/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:74:"View an entity of type Reader Activity Log with bundle Reader Activity Log";}}','system','-1','0','0','0','2','2','0','1134','1135','0','0','0','0','0','0','0','0'),('navigation','1136','1134','reader_activity_log/reader_activity_log/%/edit','reader_activity_log/reader_activity_log/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:74:"View an entity of type Reader Activity Log with bundle Reader Activity Log";}}','system','-1','0','0','0','1','2','0','1134','1136','0','0','0','0','0','0','0','0'),('navigation','1137','1134','reader_activity_log/reader_activity_log/%/view','reader_activity_log/reader_activity_log/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','1134','1137','0','0','0','0','0','0','0','0'),('management','1138','383','admin/structure/entity-type/reader_activity_log','admin/structure/entity-type/reader_activity_log','Reader Activity Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:46:"View all the bundles for ''Reader Activity Log''";}}','system','0','0','1','0','0','4','0','1','21','383','1138','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1139','1138','admin/structure/entity-type/reader_activity_log/add','admin/structure/entity-type/reader_activity_log/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:41:"Add a(n) new ''Reader Activity Log Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','1138','1139','0','0','0','0','0'),('management','1140','1138','admin/structure/entity-type/reader_activity_log/list','admin/structure/entity-type/reader_activity_log/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','1138','1140','0','0','0','0','0'),('management','1141','1138','admin/structure/entity-type/reader_activity_log/delete','admin/structure/entity-type/reader_activity_log/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:44:"Delete the ''Reader Activity Log'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','1138','1141','0','0','0','0','0'),('management','1142','1138','admin/structure/entity-type/reader_activity_log/edit','admin/structure/entity-type/reader_activity_log/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:42:"Edit the ''Reader Activity Log'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','1138','1142','0','0','0','0','0'),('management','1143','1138','admin/structure/entity-type/reader_activity_log/properties','admin/structure/entity-type/reader_activity_log/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"Manage the properties of the Reader Activity Log entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','1138','1143','0','0','0','0','0'),('management','1144','1138','admin/structure/entity-type/reader_activity_log/reader_activity_log','admin/structure/entity-type/reader_activity_log/reader_activity_log','Reader Activity Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:76:"View all entites of type Reader Activity Log with bundle Reader Activity Log";}}','system','0','0','1','0','0','5','0','1','21','383','1138','1144','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1145','1144','admin/structure/entity-type/reader_activity_log/reader_activity_log/delete','admin/structure/entity-type/reader_activity_log/reader_activity_log/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1138','1144','1145','0','0','0','0'),('management','1146','1144','admin/structure/entity-type/reader_activity_log/reader_activity_log/edit','admin/structure/entity-type/reader_activity_log/reader_activity_log/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1138','1144','1146','0','0','0','0'),('management','1147','1144','admin/structure/entity-type/reader_activity_log/reader_activity_log/list','admin/structure/entity-type/reader_activity_log/reader_activity_log/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','1138','1144','1147','0','0','0','0'),('management','1148','1144','admin/structure/entity-type/reader_activity_log/reader_activity_log/display','admin/structure/entity-type/reader_activity_log/reader_activity_log/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','1138','1144','1148','0','0','0','0'),('management','1149','1144','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','1138','1144','1149','0','0','0','0'),('management','1150','1144','admin/structure/entity-type/reader_activity_log/reader_activity_log/add','admin/structure/entity-type/reader_activity_log/reader_activity_log/add','Add Reader Activity Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:73:"Add an entity of type Reader Activity Log with bundle Reader Activity Log";}}','system','0','0','0','0','0','6','0','1','21','383','1138','1144','1150','0','0','0','0'),('management','1151','1148','admin/structure/entity-type/reader_activity_log/reader_activity_log/display/default','admin/structure/entity-type/reader_activity_log/reader_activity_log/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','1138','1144','1148','1151','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1152','1148','admin/structure/entity-type/reader_activity_log/reader_activity_log/display/full','admin/structure/entity-type/reader_activity_log/reader_activity_log/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','1138','1144','1148','1152','0','0','0'),('management','1153','1148','admin/structure/entity-type/reader_activity_log/reader_activity_log/display/teaser','admin/structure/entity-type/reader_activity_log/reader_activity_log/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','1138','1144','1148','1153','0','0','0'),('management','1154','1148','admin/structure/entity-type/reader_activity_log/reader_activity_log/display/token','admin/structure/entity-type/reader_activity_log/reader_activity_log/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','1138','1144','1148','1154','0','0','0'),('management','1155','1144','admin/structure/entity-type/reader_activity_log/reader_activity_log/%/delete','admin/structure/entity-type/reader_activity_log/reader_activity_log/%/delete','Delete Reader Activity Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:76:"Delete an entity of type Reader Activity Log with bundle Reader Activity Log";}}','system','0','0','0','0','0','6','0','1','21','383','1138','1144','1155','0','0','0','0'),('management','1156','1144','admin/structure/entity-type/reader_activity_log/reader_activity_log/%/edit','admin/structure/entity-type/reader_activity_log/reader_activity_log/%/edit','Edit Reader Activity Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:74:"Edit an entity of type Reader Activity Log with bundle Reader Activity Log";}}','system','0','0','0','0','0','6','0','1','21','383','1138','1144','1156','0','0','0','0'),('management','1157','1149','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','1138','1144','1149','1157','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1158','1157','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%/delete','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','1138','1144','1149','1157','1158','0','0'),('management','1159','1157','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%/edit','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1138','1144','1149','1157','1159','0','0'),('management','1160','1157','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%/field-settings','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1138','1144','1149','1157','1160','0','0'),('management','1161','1157','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%/widget-type','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1138','1144','1149','1157','1161','0','0'),('menu-library-menu','1162','0','reader/dashboard/activity_log_reference','reader/dashboard/activity_log_reference','Available Activities','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','1','0','0','0','-47','1','1','1162','0','0','0','0','0','0','0','0','0'),('navigation','1163','816','reader/dashboard/activity_log_reference','reader/dashboard/activity_log_reference','Activity Log','a:0:{}','system','0','0','1','0','0','2','0','816','1163','0','0','0','0','0','0','0','0'),('navigation','1164','794','library/dashboard/user_search','library/dashboard/user_search','User Search','a:0:{}','system','0','0','0','0','0','2','0','794','1164','0','0','0','0','0','0','0','0'),('navigation','1165','1163','reader/dashboard/activity_log_reference/add','reader/dashboard/activity_log_reference/add','Add activity log','a:0:{}','system','0','0','0','0','0','3','0','816','1163','1165','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','1166','795','library/dashboard/branches/manage_prizes','library/dashboard/branches/manage_prizes','Manage Prizes','a:0:{}','system','0','0','0','0','0','3','0','794','795','1166','0','0','0','0','0','0','0'),('navigation','1167','812','library/dashboard/program/program_overview_page','library/dashboard/program/program_overview_page','Program Overview','a:0:{}','system','0','0','0','0','0','3','0','794','812','1167','0','0','0','0','0','0','0'),('navigation','1168','813','library/dashboard/readers/reader_overview','library/dashboard/readers/reader_overview','Reader Overview','a:0:{}','system','0','0','0','0','0','3','0','794','813','1168','0','0','0','0','0','0','0'),('navigation','1169','0','nag_message/%','nag_message/%','','a:0:{}','system','0','0','1','0','0','1','0','1169','0','0','0','0','0','0','0','0','0'),('navigation','1170','1169','nag_message/%/edit','nag_message/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','1169','1170','0','0','0','0','0','0','0','0'),('navigation','1171','0','nag_message/nag_message/%','nag_message/nag_message/%','View Nag Message','a:1:{s:10:"attributes";a:1:{s:5:"title";s:58:"View an entity of type Nag Message with bundle Nag Message";}}','system','0','0','0','0','0','1','0','1171','0','0','0','0','0','0','0','0','0'),('navigation','1172','1171','nag_message/nag_message/%/delete','nag_message/nag_message/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:58:"View an entity of type Nag Message with bundle Nag Message";}}','system','-1','0','0','0','2','2','0','1171','1172','0','0','0','0','0','0','0','0'),('navigation','1173','1171','nag_message/nag_message/%/edit','nag_message/nag_message/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:58:"View an entity of type Nag Message with bundle Nag Message";}}','system','-1','0','0','0','1','2','0','1171','1173','0','0','0','0','0','0','0','0'),('navigation','1174','1171','nag_message/nag_message/%/view','nag_message/nag_message/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','1171','1174','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1175','383','admin/structure/entity-type/nag_message','admin/structure/entity-type/nag_message','Nag Message','a:1:{s:10:"attributes";a:1:{s:5:"title";s:38:"View all the bundles for ''Nag Message''";}}','system','0','0','1','0','0','4','0','1','21','383','1175','0','0','0','0','0','0'),('management','1176','1175','admin/structure/entity-type/nag_message/add','admin/structure/entity-type/nag_message/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:33:"Add a(n) new ''Nag Message Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','1175','1176','0','0','0','0','0'),('management','1177','1175','admin/structure/entity-type/nag_message/list','admin/structure/entity-type/nag_message/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','1175','1177','0','0','0','0','0'),('management','1178','1175','admin/structure/entity-type/nag_message/delete','admin/structure/entity-type/nag_message/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:36:"Delete the ''Nag Message'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','1175','1178','0','0','0','0','0'),('management','1179','1175','admin/structure/entity-type/nag_message/edit','admin/structure/entity-type/nag_message/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:34:"Edit the ''Nag Message'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','1175','1179','0','0','0','0','0'),('management','1180','1175','admin/structure/entity-type/nag_message/properties','admin/structure/entity-type/nag_message/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:52:"Manage the properties of the Nag Message entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','1175','1180','0','0','0','0','0'),('management','1181','1175','admin/structure/entity-type/nag_message/nag_message','admin/structure/entity-type/nag_message/nag_message','Nag Message','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"View all entites of type Nag Message with bundle Nag Message";}}','system','0','0','1','0','0','5','0','1','21','383','1175','1181','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1182','1181','admin/structure/entity-type/nag_message/nag_message/delete','admin/structure/entity-type/nag_message/nag_message/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1175','1181','1182','0','0','0','0'),('management','1183','1181','admin/structure/entity-type/nag_message/nag_message/edit','admin/structure/entity-type/nag_message/nag_message/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1175','1181','1183','0','0','0','0'),('management','1184','1181','admin/structure/entity-type/nag_message/nag_message/list','admin/structure/entity-type/nag_message/nag_message/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','1175','1181','1184','0','0','0','0'),('management','1185','1181','admin/structure/entity-type/nag_message/nag_message/display','admin/structure/entity-type/nag_message/nag_message/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','1175','1181','1185','0','0','0','0'),('management','1186','1181','admin/structure/entity-type/nag_message/nag_message/fields','admin/structure/entity-type/nag_message/nag_message/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','1175','1181','1186','0','0','0','0'),('management','1187','1181','admin/structure/entity-type/nag_message/nag_message/add','admin/structure/entity-type/nag_message/nag_message/add','Add Nag Message','a:1:{s:10:"attributes";a:1:{s:5:"title";s:57:"Add an entity of type Nag Message with bundle Nag Message";}}','system','0','0','0','0','0','6','0','1','21','383','1175','1181','1187','0','0','0','0'),('management','1188','1185','admin/structure/entity-type/nag_message/nag_message/display/default','admin/structure/entity-type/nag_message/nag_message/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','1175','1181','1185','1188','0','0','0'),('management','1189','1185','admin/structure/entity-type/nag_message/nag_message/display/full','admin/structure/entity-type/nag_message/nag_message/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','1175','1181','1185','1189','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1190','1185','admin/structure/entity-type/nag_message/nag_message/display/teaser','admin/structure/entity-type/nag_message/nag_message/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','1175','1181','1185','1190','0','0','0'),('management','1191','1185','admin/structure/entity-type/nag_message/nag_message/display/token','admin/structure/entity-type/nag_message/nag_message/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','1175','1181','1185','1191','0','0','0'),('management','1192','1181','admin/structure/entity-type/nag_message/nag_message/%/delete','admin/structure/entity-type/nag_message/nag_message/%/delete','Delete Nag Message','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"Delete an entity of type Nag Message with bundle Nag Message";}}','system','0','0','0','0','0','6','0','1','21','383','1175','1181','1192','0','0','0','0'),('management','1193','1181','admin/structure/entity-type/nag_message/nag_message/%/edit','admin/structure/entity-type/nag_message/nag_message/%/edit','Edit Nag Message','a:1:{s:10:"attributes";a:1:{s:5:"title";s:58:"Edit an entity of type Nag Message with bundle Nag Message";}}','system','0','0','0','0','0','6','0','1','21','383','1175','1181','1193','0','0','0','0'),('management','1194','1186','admin/structure/entity-type/nag_message/nag_message/fields/%','admin/structure/entity-type/nag_message/nag_message/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','1175','1181','1186','1194','0','0','0'),('management','1195','1194','admin/structure/entity-type/nag_message/nag_message/fields/%/delete','admin/structure/entity-type/nag_message/nag_message/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','1175','1181','1186','1194','1195','0','0'),('management','1196','1194','admin/structure/entity-type/nag_message/nag_message/fields/%/edit','admin/structure/entity-type/nag_message/nag_message/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1175','1181','1186','1194','1196','0','0');
INSERT INTO `menu_links` VALUES ('management','1197','1194','admin/structure/entity-type/nag_message/nag_message/fields/%/field-settings','admin/structure/entity-type/nag_message/nag_message/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1175','1181','1186','1194','1197','0','0'),('management','1198','1194','admin/structure/entity-type/nag_message/nag_message/fields/%/widget-type','admin/structure/entity-type/nag_message/nag_message/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1175','1181','1186','1194','1198','0','0'),('navigation','1199','0','reader_ticket/%','reader_ticket/%','','a:0:{}','system','0','0','1','0','0','1','0','1199','0','0','0','0','0','0','0','0','0'),('navigation','1200','1199','reader_ticket/%/edit','reader_ticket/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','1199','1200','0','0','0','0','0','0','0','0'),('navigation','1201','0','reader_ticket/reader_ticket/%','reader_ticket/reader_ticket/%','View Reader Ticket','a:1:{s:10:"attributes";a:1:{s:5:"title";s:62:"View an entity of type Reader Ticket with bundle Reader Ticket";}}','system','0','0','0','0','0','1','0','1201','0','0','0','0','0','0','0','0','0'),('navigation','1202','1201','reader_ticket/reader_ticket/%/delete','reader_ticket/reader_ticket/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:62:"View an entity of type Reader Ticket with bundle Reader Ticket";}}','system','-1','0','0','0','2','2','0','1201','1202','0','0','0','0','0','0','0','0'),('navigation','1203','1201','reader_ticket/reader_ticket/%/edit','reader_ticket/reader_ticket/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:62:"View an entity of type Reader Ticket with bundle Reader Ticket";}}','system','-1','0','0','0','1','2','0','1201','1203','0','0','0','0','0','0','0','0'),('navigation','1204','1201','reader_ticket/reader_ticket/%/view','reader_ticket/reader_ticket/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','1201','1204','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1205','383','admin/structure/entity-type/reader_ticket','admin/structure/entity-type/reader_ticket','Reader Ticket','a:1:{s:10:"attributes";a:1:{s:5:"title";s:40:"View all the bundles for ''Reader Ticket''";}}','system','0','0','1','0','0','4','0','1','21','383','1205','0','0','0','0','0','0'),('management','1206','1205','admin/structure/entity-type/reader_ticket/add','admin/structure/entity-type/reader_ticket/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:35:"Add a(n) new ''Reader Ticket Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','1205','1206','0','0','0','0','0'),('management','1207','1205','admin/structure/entity-type/reader_ticket/list','admin/structure/entity-type/reader_ticket/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','1205','1207','0','0','0','0','0'),('management','1208','1205','admin/structure/entity-type/reader_ticket/delete','admin/structure/entity-type/reader_ticket/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:38:"Delete the ''Reader Ticket'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','1205','1208','0','0','0','0','0'),('management','1209','1205','admin/structure/entity-type/reader_ticket/edit','admin/structure/entity-type/reader_ticket/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:36:"Edit the ''Reader Ticket'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','1205','1209','0','0','0','0','0'),('management','1210','1205','admin/structure/entity-type/reader_ticket/properties','admin/structure/entity-type/reader_ticket/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:54:"Manage the properties of the Reader Ticket entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','1205','1210','0','0','0','0','0'),('management','1211','1205','admin/structure/entity-type/reader_ticket/reader_ticket','admin/structure/entity-type/reader_ticket/reader_ticket','Reader Ticket','a:1:{s:10:"attributes";a:1:{s:5:"title";s:64:"View all entites of type Reader Ticket with bundle Reader Ticket";}}','system','0','0','1','0','0','5','0','1','21','383','1205','1211','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1212','1211','admin/structure/entity-type/reader_ticket/reader_ticket/delete','admin/structure/entity-type/reader_ticket/reader_ticket/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1205','1211','1212','0','0','0','0'),('management','1213','1211','admin/structure/entity-type/reader_ticket/reader_ticket/edit','admin/structure/entity-type/reader_ticket/reader_ticket/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1205','1211','1213','0','0','0','0'),('management','1214','1211','admin/structure/entity-type/reader_ticket/reader_ticket/list','admin/structure/entity-type/reader_ticket/reader_ticket/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','1205','1211','1214','0','0','0','0'),('management','1215','1211','admin/structure/entity-type/reader_ticket/reader_ticket/display','admin/structure/entity-type/reader_ticket/reader_ticket/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','1205','1211','1215','0','0','0','0'),('management','1216','1211','admin/structure/entity-type/reader_ticket/reader_ticket/fields','admin/structure/entity-type/reader_ticket/reader_ticket/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','1205','1211','1216','0','0','0','0'),('management','1217','1211','admin/structure/entity-type/reader_ticket/reader_ticket/add','admin/structure/entity-type/reader_ticket/reader_ticket/add','Add Reader Ticket','a:1:{s:10:"attributes";a:1:{s:5:"title";s:61:"Add an entity of type Reader Ticket with bundle Reader Ticket";}}','system','0','0','0','0','0','6','0','1','21','383','1205','1211','1217','0','0','0','0'),('management','1218','1215','admin/structure/entity-type/reader_ticket/reader_ticket/display/default','admin/structure/entity-type/reader_ticket/reader_ticket/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','1205','1211','1215','1218','0','0','0'),('management','1219','1215','admin/structure/entity-type/reader_ticket/reader_ticket/display/full','admin/structure/entity-type/reader_ticket/reader_ticket/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','1205','1211','1215','1219','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1220','1215','admin/structure/entity-type/reader_ticket/reader_ticket/display/token','admin/structure/entity-type/reader_ticket/reader_ticket/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','1205','1211','1215','1220','0','0','0'),('management','1221','1215','admin/structure/entity-type/reader_ticket/reader_ticket/display/teaser','admin/structure/entity-type/reader_ticket/reader_ticket/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','1205','1211','1215','1221','0','0','0'),('management','1222','1211','admin/structure/entity-type/reader_ticket/reader_ticket/%/delete','admin/structure/entity-type/reader_ticket/reader_ticket/%/delete','Delete Reader Ticket','a:1:{s:10:"attributes";a:1:{s:5:"title";s:64:"Delete an entity of type Reader Ticket with bundle Reader Ticket";}}','system','0','0','0','0','0','6','0','1','21','383','1205','1211','1222','0','0','0','0'),('management','1223','1216','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','1205','1211','1216','1223','0','0','0'),('management','1224','1211','admin/structure/entity-type/reader_ticket/reader_ticket/%/edit','admin/structure/entity-type/reader_ticket/reader_ticket/%/edit','Edit Reader Ticket','a:1:{s:10:"attributes";a:1:{s:5:"title";s:62:"Edit an entity of type Reader Ticket with bundle Reader Ticket";}}','system','0','0','0','0','0','6','0','1','21','383','1205','1211','1224','0','0','0','0'),('management','1225','1223','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%/delete','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','1205','1211','1216','1223','1225','0','0'),('management','1226','1223','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%/edit','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1205','1211','1216','1223','1226','0','0');
INSERT INTO `menu_links` VALUES ('management','1227','1223','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%/field-settings','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1205','1211','1216','1223','1227','0','0'),('management','1228','1223','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%/widget-type','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1205','1211','1216','1223','1228','0','0'),('management','1229','519','admin/config/workflow/rules/components/manage/%/add-case/%','admin/config/workflow/rules/components/manage/%/add-case/%','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','463','519','1229','0','0','0'),('management','1230','520','admin/config/workflow/rules/reaction/manage/%/add-case/%','admin/config/workflow/rules/reaction/manage/%/add-case/%','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','473','520','1230','0','0','0'),('management','1231','519','admin/config/workflow/rules/components/manage/%/add-predicate/%','admin/config/workflow/rules/components/manage/%/add-predicate/%','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','463','519','1231','0','0','0'),('management','1232','520','admin/config/workflow/rules/reaction/manage/%/add-predicate/%','admin/config/workflow/rules/reaction/manage/%/add-predicate/%','','a:0:{}','system','0','0','0','0','0','7','0','1','8','66','443','473','520','1232','0','0','0'),('menu-setup-menu','1233','0','library/dashboard/branches/manage_prizes','library/dashboard/branches/manage_prizes','Prizes','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','0','0','0','0','-49','1','1','1233','0','0','0','0','0','0','0','0','0'),('menu-library-menu1','1234','0','library/dashboard/user_search','library/dashboard/user_search','Users','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','0','0','0','0','-46','1','1','1234','0','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','1235','0','claim/%/prize','claim/%/prize','Claim Prize','a:0:{}','system','0','0','0','0','0','1','0','1235','0','0','0','0','0','0','0','0','0'),('navigation','1236','795','library/dashboard/branches/add','library/dashboard/branches/add','Add Branch','a:0:{}','system','0','0','0','0','0','3','0','794','795','1236','0','0','0','0','0','0','0'),('navigation','1237','794','library/dashboard/badges/manage_badges','library/dashboard/badges/manage_badges','Manage Badges','a:0:{}','system','0','0','0','0','0','2','0','794','1237','0','0','0','0','0','0','0','0'),('navigation','1238','0','unclaim/%/prize','unclaim/%/prize','Unclaim Prize','a:0:{}','system','0','0','0','0','0','1','0','1238','0','0','0','0','0','0','0','0','0'),('navigation','1239','0','activity/%','activity/%','','a:0:{}','system','0','0','1','0','0','1','0','1239','0','0','0','0','0','0','0','0','0'),('navigation','1240','1239','activity/%/edit','activity/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','1239','1240','0','0','0','0','0','0','0','0'),('navigation','1241','0','activity/activity/%','activity/activity/%','View Activity','a:1:{s:10:"attributes";a:1:{s:5:"title";s:52:"View an entity of type Activity with bundle Activity";}}','system','0','0','0','0','0','1','0','1241','0','0','0','0','0','0','0','0','0'),('navigation','1242','1241','activity/activity/%/delete','activity/activity/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:52:"View an entity of type Activity with bundle Activity";}}','system','-1','0','0','0','2','2','0','1241','1242','0','0','0','0','0','0','0','0'),('navigation','1243','1241','activity/activity/%/edit','activity/activity/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:52:"View an entity of type Activity with bundle Activity";}}','system','-1','0','0','0','1','2','0','1241','1243','0','0','0','0','0','0','0','0'),('navigation','1244','1241','activity/activity/%/view','activity/activity/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','1241','1244','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1245','383','admin/structure/entity-type/activity','admin/structure/entity-type/activity','Activity','a:1:{s:10:"attributes";a:1:{s:5:"title";s:35:"View all the bundles for ''Activity''";}}','system','0','0','1','0','0','4','0','1','21','383','1245','0','0','0','0','0','0'),('navigation','1246','794','library/dashboard/activities/manage_activities','library/dashboard/activities/manage_activities','Manage Activities','a:0:{}','system','0','0','0','0','0','2','0','794','1246','0','0','0','0','0','0','0','0'),('navigation','1247','794','library/dashboard/secret_codes/manage_secret_codes','library/dashboard/secret_codes/manage_secret_codes','Manage Secret Codes','a:0:{}','system','0','0','0','0','0','2','0','794','1247','0','0','0','0','0','0','0','0'),('management','1248','1245','admin/structure/entity-type/activity/activity','admin/structure/entity-type/activity/activity','Activity','a:1:{s:10:"attributes";a:1:{s:5:"title";s:54:"View all entites of type Activity with bundle Activity";}}','system','0','0','1','0','0','5','0','1','21','383','1245','1248','0','0','0','0','0'),('management','1249','1245','admin/structure/entity-type/activity/add','admin/structure/entity-type/activity/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:30:"Add a(n) new ''Activity Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','1245','1249','0','0','0','0','0'),('management','1250','1245','admin/structure/entity-type/activity/list','admin/structure/entity-type/activity/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','1245','1250','0','0','0','0','0'),('management','1251','1245','admin/structure/entity-type/activity/delete','admin/structure/entity-type/activity/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:33:"Delete the ''Activity'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','1245','1251','0','0','0','0','0'),('management','1252','1245','admin/structure/entity-type/activity/edit','admin/structure/entity-type/activity/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:31:"Edit the ''Activity'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','1245','1252','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1253','1245','admin/structure/entity-type/activity/properties','admin/structure/entity-type/activity/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:49:"Manage the properties of the Activity entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','1245','1253','0','0','0','0','0'),('navigation','1254','794','library/dashboard/activities/program/activity/add','library/dashboard/activities/program/activity/add','Add Activity','a:0:{}','system','0','0','0','0','0','2','0','794','1254','0','0','0','0','0','0','0','0'),('navigation','1255','794','library/dashboard/secret_codes/program/secret_code/add','library/dashboard/secret_codes/program/secret_code/add','Add Secret Code','a:0:{}','system','0','0','0','0','0','2','0','794','1255','0','0','0','0','0','0','0','0'),('management','1256','1248','admin/structure/entity-type/activity/activity/delete','admin/structure/entity-type/activity/activity/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1245','1248','1256','0','0','0','0'),('management','1257','1248','admin/structure/entity-type/activity/activity/edit','admin/structure/entity-type/activity/activity/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1245','1248','1257','0','0','0','0'),('management','1258','1248','admin/structure/entity-type/activity/activity/list','admin/structure/entity-type/activity/activity/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','1245','1248','1258','0','0','0','0'),('management','1259','1248','admin/structure/entity-type/activity/activity/display','admin/structure/entity-type/activity/activity/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','1245','1248','1259','0','0','0','0'),('management','1260','1248','admin/structure/entity-type/activity/activity/fields','admin/structure/entity-type/activity/activity/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','1245','1248','1260','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1261','1248','admin/structure/entity-type/activity/activity/add','admin/structure/entity-type/activity/activity/add','Add Activity','a:1:{s:10:"attributes";a:1:{s:5:"title";s:51:"Add an entity of type Activity with bundle Activity";}}','system','0','0','0','0','0','6','0','1','21','383','1245','1248','1261','0','0','0','0'),('management','1262','1259','admin/structure/entity-type/activity/activity/display/default','admin/structure/entity-type/activity/activity/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','1245','1248','1259','1262','0','0','0'),('management','1263','1259','admin/structure/entity-type/activity/activity/display/full','admin/structure/entity-type/activity/activity/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','1245','1248','1259','1263','0','0','0'),('management','1264','1259','admin/structure/entity-type/activity/activity/display/teaser','admin/structure/entity-type/activity/activity/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','1245','1248','1259','1264','0','0','0'),('management','1265','1259','admin/structure/entity-type/activity/activity/display/token','admin/structure/entity-type/activity/activity/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','1245','1248','1259','1265','0','0','0'),('management','1266','1248','admin/structure/entity-type/activity/activity/%/delete','admin/structure/entity-type/activity/activity/%/delete','Delete Activity','a:1:{s:10:"attributes";a:1:{s:5:"title";s:54:"Delete an entity of type Activity with bundle Activity";}}','system','0','0','0','0','0','6','0','1','21','383','1245','1248','1266','0','0','0','0'),('management','1267','1248','admin/structure/entity-type/activity/activity/%/edit','admin/structure/entity-type/activity/activity/%/edit','Edit Activity','a:1:{s:10:"attributes";a:1:{s:5:"title";s:52:"Edit an entity of type Activity with bundle Activity";}}','system','0','0','0','0','0','6','0','1','21','383','1245','1248','1267','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1268','1260','admin/structure/entity-type/activity/activity/fields/%','admin/structure/entity-type/activity/activity/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','1245','1248','1260','1268','0','0','0'),('management','1269','1268','admin/structure/entity-type/activity/activity/fields/%/delete','admin/structure/entity-type/activity/activity/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','1245','1248','1260','1268','1269','0','0'),('management','1270','1268','admin/structure/entity-type/activity/activity/fields/%/edit','admin/structure/entity-type/activity/activity/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1245','1248','1260','1268','1270','0','0'),('management','1271','1268','admin/structure/entity-type/activity/activity/fields/%/field-settings','admin/structure/entity-type/activity/activity/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1245','1248','1260','1268','1271','0','0'),('management','1272','1268','admin/structure/entity-type/activity/activity/fields/%/widget-type','admin/structure/entity-type/activity/activity/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1245','1248','1260','1268','1272','0','0'),('navigation','1273','0','activity/secret_code/%','activity/secret_code/%','View Secret Code','a:1:{s:10:"attributes";a:1:{s:5:"title";s:55:"View an entity of type Activity with bundle Secret Code";}}','system','0','0','0','0','0','1','0','1273','0','0','0','0','0','0','0','0','0'),('navigation','1274','1273','activity/secret_code/%/delete','activity/secret_code/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:55:"View an entity of type Activity with bundle Secret Code";}}','system','-1','0','0','0','2','2','0','1273','1274','0','0','0','0','0','0','0','0'),('navigation','1275','1273','activity/secret_code/%/edit','activity/secret_code/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:55:"View an entity of type Activity with bundle Secret Code";}}','system','-1','0','0','0','1','2','0','1273','1275','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','1276','1273','activity/secret_code/%/view','activity/secret_code/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','1273','1276','0','0','0','0','0','0','0','0'),('management','1277','1245','admin/structure/entity-type/activity/secret_code','admin/structure/entity-type/activity/secret_code','Secret Code','a:1:{s:10:"attributes";a:1:{s:5:"title";s:57:"View all entites of type Activity with bundle Secret Code";}}','system','0','0','1','0','0','5','0','1','21','383','1245','1277','0','0','0','0','0'),('management','1278','1277','admin/structure/entity-type/activity/secret_code/delete','admin/structure/entity-type/activity/secret_code/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1245','1277','1278','0','0','0','0'),('management','1279','1277','admin/structure/entity-type/activity/secret_code/edit','admin/structure/entity-type/activity/secret_code/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1245','1277','1279','0','0','0','0'),('management','1280','1277','admin/structure/entity-type/activity/secret_code/list','admin/structure/entity-type/activity/secret_code/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','1245','1277','1280','0','0','0','0'),('management','1281','1277','admin/structure/entity-type/activity/secret_code/display','admin/structure/entity-type/activity/secret_code/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','1245','1277','1281','0','0','0','0'),('management','1282','1277','admin/structure/entity-type/activity/secret_code/fields','admin/structure/entity-type/activity/secret_code/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','1245','1277','1282','0','0','0','0'),('management','1283','1277','admin/structure/entity-type/activity/secret_code/add','admin/structure/entity-type/activity/secret_code/add','Add Secret Code','a:1:{s:10:"attributes";a:1:{s:5:"title";s:54:"Add an entity of type Activity with bundle Secret Code";}}','system','0','0','0','0','0','6','0','1','21','383','1245','1277','1283','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1284','1281','admin/structure/entity-type/activity/secret_code/display/default','admin/structure/entity-type/activity/secret_code/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','1245','1277','1281','1284','0','0','0'),('management','1285','1281','admin/structure/entity-type/activity/secret_code/display/full','admin/structure/entity-type/activity/secret_code/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','1245','1277','1281','1285','0','0','0'),('management','1286','1281','admin/structure/entity-type/activity/secret_code/display/teaser','admin/structure/entity-type/activity/secret_code/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','1245','1277','1281','1286','0','0','0'),('management','1287','1281','admin/structure/entity-type/activity/secret_code/display/token','admin/structure/entity-type/activity/secret_code/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','1245','1277','1281','1287','0','0','0'),('management','1288','1277','admin/structure/entity-type/activity/secret_code/%/delete','admin/structure/entity-type/activity/secret_code/%/delete','Delete Secret Code','a:1:{s:10:"attributes";a:1:{s:5:"title";s:57:"Delete an entity of type Activity with bundle Secret Code";}}','system','0','0','0','0','0','6','0','1','21','383','1245','1277','1288','0','0','0','0'),('management','1289','1277','admin/structure/entity-type/activity/secret_code/%/edit','admin/structure/entity-type/activity/secret_code/%/edit','Edit Secret Code','a:1:{s:10:"attributes";a:1:{s:5:"title";s:55:"Edit an entity of type Activity with bundle Secret Code";}}','system','0','0','0','0','0','6','0','1','21','383','1245','1277','1289','0','0','0','0'),('management','1290','1282','admin/structure/entity-type/activity/secret_code/fields/%','admin/structure/entity-type/activity/secret_code/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','1245','1277','1282','1290','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1291','1290','admin/structure/entity-type/activity/secret_code/fields/%/delete','admin/structure/entity-type/activity/secret_code/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','1245','1277','1282','1290','1291','0','0'),('management','1292','1290','admin/structure/entity-type/activity/secret_code/fields/%/edit','admin/structure/entity-type/activity/secret_code/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1245','1277','1282','1290','1292','0','0'),('management','1293','1290','admin/structure/entity-type/activity/secret_code/fields/%/field-settings','admin/structure/entity-type/activity/secret_code/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1245','1277','1282','1290','1293','0','0'),('management','1294','1290','admin/structure/entity-type/activity/secret_code/fields/%/widget-type','admin/structure/entity-type/activity/secret_code/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1245','1277','1282','1290','1294','0','0'),('navigation','1295','0','activity_log/%','activity_log/%','','a:0:{}','system','0','0','1','0','0','1','0','1295','0','0','0','0','0','0','0','0','0'),('navigation','1296','1295','activity_log/%/edit','activity_log/%/edit','','a:0:{}','system','0','0','0','0','0','2','0','1295','1296','0','0','0','0','0','0','0','0'),('navigation','1297','0','activity_log/activity_log/%','activity_log/activity_log/%','View Activity Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"View an entity of type Activity Log with bundle Activity Log";}}','system','0','0','0','0','0','1','0','1297','0','0','0','0','0','0','0','0','0'),('navigation','1298','1297','activity_log/activity_log/%/delete','activity_log/activity_log/%/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"View an entity of type Activity Log with bundle Activity Log";}}','system','-1','0','0','0','2','2','0','1297','1298','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','1299','1297','activity_log/activity_log/%/edit','activity_log/activity_log/%/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"View an entity of type Activity Log with bundle Activity Log";}}','system','-1','0','0','0','1','2','0','1297','1299','0','0','0','0','0','0','0','0'),('navigation','1300','1297','activity_log/activity_log/%/view','activity_log/activity_log/%/view','View','a:0:{}','system','-1','0','0','0','0','2','0','1297','1300','0','0','0','0','0','0','0','0'),('management','1301','383','admin/structure/entity-type/activity_log','admin/structure/entity-type/activity_log','Activity Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:39:"View all the bundles for ''Activity Log''";}}','system','0','0','1','0','0','4','0','1','21','383','1301','0','0','0','0','0','0'),('management','1302','1301','admin/structure/entity-type/activity_log/activity_log','admin/structure/entity-type/activity_log/activity_log','Activity Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:62:"View all entites of type Activity Log with bundle Activity Log";}}','system','0','0','1','0','0','5','0','1','21','383','1301','1302','0','0','0','0','0'),('management','1303','1301','admin/structure/entity-type/activity_log/add','admin/structure/entity-type/activity_log/add','Add bundle ','a:1:{s:10:"attributes";a:1:{s:5:"title";s:34:"Add a(n) new ''Activity Log Bundle''";}}','system','-1','0','0','0','0','5','0','1','21','383','1301','1303','0','0','0','0','0'),('management','1304','1301','admin/structure/entity-type/activity_log/list','admin/structure/entity-type/activity_log/list','Bundle List','a:0:{}','system','-1','0','0','0','100','5','0','1','21','383','1301','1304','0','0','0','0','0'),('management','1305','1301','admin/structure/entity-type/activity_log/delete','admin/structure/entity-type/activity_log/delete','Delete','a:1:{s:10:"attributes";a:1:{s:5:"title";s:37:"Delete the ''Activity Log'' Entity Type";}}','system','-1','0','0','0','3','5','0','1','21','383','1301','1305','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1306','1301','admin/structure/entity-type/activity_log/edit','admin/structure/entity-type/activity_log/edit','Edit','a:1:{s:10:"attributes";a:1:{s:5:"title";s:35:"Edit the ''Activity Log'' entity type";}}','system','-1','0','0','0','2','5','0','1','21','383','1301','1306','0','0','0','0','0'),('management','1307','1301','admin/structure/entity-type/activity_log/properties','admin/structure/entity-type/activity_log/properties','Manage properties','a:1:{s:10:"attributes";a:1:{s:5:"title";s:53:"Manage the properties of the Activity Log entity type";}}','system','-1','0','0','0','4','5','0','1','21','383','1301','1307','0','0','0','0','0'),('management','1308','1302','admin/structure/entity-type/activity_log/activity_log/delete','admin/structure/entity-type/activity_log/activity_log/delete','Delete','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1301','1302','1308','0','0','0','0'),('management','1309','1302','admin/structure/entity-type/activity_log/activity_log/edit','admin/structure/entity-type/activity_log/activity_log/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','21','383','1301','1302','1309','0','0','0','0'),('management','1310','1302','admin/structure/entity-type/activity_log/activity_log/list','admin/structure/entity-type/activity_log/activity_log/list','Entity List','a:0:{}','system','-1','0','0','0','100','6','0','1','21','383','1301','1302','1310','0','0','0','0'),('management','1311','1302','admin/structure/entity-type/activity_log/activity_log/display','admin/structure/entity-type/activity_log/activity_log/display','Manage display','a:0:{}','system','-1','0','0','0','2','6','0','1','21','383','1301','1302','1311','0','0','0','0'),('management','1312','1302','admin/structure/entity-type/activity_log/activity_log/fields','admin/structure/entity-type/activity_log/activity_log/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','6','0','1','21','383','1301','1302','1312','0','0','0','0'),('management','1313','1302','admin/structure/entity-type/activity_log/activity_log/add','admin/structure/entity-type/activity_log/activity_log/add','Add Activity Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:59:"Add an entity of type Activity Log with bundle Activity Log";}}','system','0','0','0','0','0','6','0','1','21','383','1301','1302','1313','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1314','1311','admin/structure/entity-type/activity_log/activity_log/display/default','admin/structure/entity-type/activity_log/activity_log/display/default','Default','a:0:{}','system','-1','0','0','0','-10','7','0','1','21','383','1301','1302','1311','1314','0','0','0'),('management','1315','1311','admin/structure/entity-type/activity_log/activity_log/display/full','admin/structure/entity-type/activity_log/activity_log/display/full','Full','a:0:{}','system','-1','0','0','0','0','7','0','1','21','383','1301','1302','1311','1315','0','0','0'),('management','1316','1311','admin/structure/entity-type/activity_log/activity_log/display/teaser','admin/structure/entity-type/activity_log/activity_log/display/teaser','Teaser','a:0:{}','system','-1','0','0','0','1','7','0','1','21','383','1301','1302','1311','1316','0','0','0'),('management','1317','1311','admin/structure/entity-type/activity_log/activity_log/display/token','admin/structure/entity-type/activity_log/activity_log/display/token','Tokens','a:0:{}','system','-1','0','0','0','2','7','0','1','21','383','1301','1302','1311','1317','0','0','0'),('management','1318','1302','admin/structure/entity-type/activity_log/activity_log/%/delete','admin/structure/entity-type/activity_log/activity_log/%/delete','Delete Activity Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:62:"Delete an entity of type Activity Log with bundle Activity Log";}}','system','0','0','0','0','0','6','0','1','21','383','1301','1302','1318','0','0','0','0'),('management','1319','1302','admin/structure/entity-type/activity_log/activity_log/%/edit','admin/structure/entity-type/activity_log/activity_log/%/edit','Edit Activity Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"Edit an entity of type Activity Log with bundle Activity Log";}}','system','0','0','0','0','0','6','0','1','21','383','1301','1302','1319','0','0','0','0'),('management','1320','1312','admin/structure/entity-type/activity_log/activity_log/fields/%','admin/structure/entity-type/activity_log/activity_log/fields/%','','a:0:{}','system','0','0','0','0','0','7','0','1','21','383','1301','1302','1312','1320','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1321','1320','admin/structure/entity-type/activity_log/activity_log/fields/%/delete','admin/structure/entity-type/activity_log/activity_log/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','8','0','1','21','383','1301','1302','1312','1320','1321','0','0'),('management','1322','1320','admin/structure/entity-type/activity_log/activity_log/fields/%/edit','admin/structure/entity-type/activity_log/activity_log/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1301','1302','1312','1320','1322','0','0'),('management','1323','1320','admin/structure/entity-type/activity_log/activity_log/fields/%/field-settings','admin/structure/entity-type/activity_log/activity_log/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1301','1302','1312','1320','1323','0','0'),('management','1324','1320','admin/structure/entity-type/activity_log/activity_log/fields/%/widget-type','admin/structure/entity-type/activity_log/activity_log/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','8','0','1','21','383','1301','1302','1312','1320','1324','0','0'),('menu-setup-menu','1325','0','library/dashboard/activities/manage_activities','library/dashboard/activities/manage_activities','Activities','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','0','0','0','0','-45','1','1','1325','0','0','0','0','0','0','0','0','0'),('menu-setup-menu','1326','0','library/dashboard/secret_codes/manage_secret_codes','library/dashboard/secret_codes/manage_secret_codes','Secret Codes','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','0','0','0','0','-44','1','1','1326','0','0','0','0','0','0','0','0','0'),('navigation','1327','5','node/%/access','node/%/access','Access control','a:0:{}','system','-1','0','0','0','3','2','0','5','1327','0','0','0','0','0','0','0','0'),('management','1328','12','admin/help/content_access','admin/help/content_access','content_access','a:0:{}','system','-1','0','0','0','0','3','0','1','12','1328','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1329','136','admin/structure/types/manage/%/access','admin/structure/types/manage/%/access','Access control','a:1:{s:10:"attributes";a:1:{s:5:"title";s:33:"Configure content access control.";}}','system','-1','0','0','0','1','5','0','1','21','37','136','1329','0','0','0','0','0'),('management','1330','12','admin/help/php','admin/help/php','php','a:0:{}','system','-1','0','0','0','0','3','0','1','12','1330','0','0','0','0','0','0','0'),('management','1331','8','admin/config/administration','admin/config/administration','Administration','a:1:{s:10:"attributes";a:1:{s:5:"title";s:21:"Administration tools.";}}','system','0','0','1','0','0','3','0','1','8','1331','0','0','0','0','0','0','0'),('management','1332','12','admin/help/admin_menu','admin/help/admin_menu','admin_menu','a:0:{}','system','-1','0','0','0','0','3','0','1','12','1332','0','0','0','0','0','0','0'),('management','1333','1331','admin/config/administration/admin_menu','admin/config/administration/admin_menu','Administration menu','a:1:{s:10:"attributes";a:1:{s:5:"title";s:36:"Adjust administration menu settings.";}}','system','0','0','0','0','0','4','0','1','8','1331','1333','0','0','0','0','0','0'),('management','1334','12','admin/help/smtp','admin/help/smtp','smtp','a:0:{}','system','-1','0','0','0','0','3','0','1','12','1334','0','0','0','0','0','0','0'),('management','1335','57','admin/config/system/smtp','admin/config/system/smtp','SMTP Authentication Support','a:1:{s:10:"attributes";a:1:{s:5:"title";s:71:"Allow for site emails to be sent through an SMTP server of your choice.";}}','system','0','0','0','0','0','4','0','1','8','57','1335','0','0','0','0','0','0'),('management','1336','19','admin/reports/hits','admin/reports/hits','Recent hits','a:1:{s:10:"attributes";a:1:{s:5:"title";s:43:"View pages that have recently been visited.";}}','system','0','0','0','0','0','3','0','1','19','1336','0','0','0','0','0','0','0'),('management','1337','19','admin/reports/pages','admin/reports/pages','Top pages','a:1:{s:10:"attributes";a:1:{s:5:"title";s:41:"View pages that have been hit frequently.";}}','system','0','0','0','0','1','3','0','1','19','1337','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1338','19','admin/reports/referrers','admin/reports/referrers','Top referrers','a:1:{s:10:"attributes";a:1:{s:5:"title";s:19:"View top referrers.";}}','system','0','0','0','0','0','3','0','1','19','1338','0','0','0','0','0','0','0'),('management','1339','19','admin/reports/visitors','admin/reports/visitors','Top visitors','a:1:{s:10:"attributes";a:1:{s:5:"title";s:34:"View visitors that hit many pages.";}}','system','0','0','0','0','2','3','0','1','19','1339','0','0','0','0','0','0','0'),('navigation','1340','5','node/%/track','node/%/track','Track','a:0:{}','system','-1','0','0','0','2','2','0','5','1340','0','0','0','0','0','0','0','0'),('management','1341','12','admin/help/statistics','admin/help/statistics','statistics','a:0:{}','system','-1','0','0','0','0','3','0','1','12','1341','0','0','0','0','0','0','0'),('management','1342','19','admin/reports/access/%','admin/reports/access/%','Details','a:1:{s:10:"attributes";a:1:{s:5:"title";s:16:"View access log.";}}','system','0','0','0','0','0','3','0','1','19','1342','0','0','0','0','0','0','0'),('management','1343','57','admin/config/system/statistics','admin/config/system/statistics','Statistics','a:1:{s:10:"attributes";a:1:{s:5:"title";s:68:"Control details about what and how your site logs access statistics.";}}','system','0','0','0','0','-15','4','0','1','8','57','1343','0','0','0','0','0','0'),('navigation','1344','17','user/%/track/navigation','user/%/track/navigation','Track page visits','a:0:{}','system','-1','0','0','0','2','2','0','17','1344','0','0','0','0','0','0','0','0'),('management','1345','12','admin/help/backup_migrate','admin/help/backup_migrate','backup_migrate','a:0:{}','system','-1','0','0','0','0','3','0','1','12','1345','0','0','0','0','0','0','0'),('management','1346','57','admin/config/system/backup_migrate','admin/config/system/backup_migrate','Backup and Migrate','a:1:{s:10:"attributes";a:1:{s:5:"title";s:86:"Backup/restore your database and files or migrate data to or from another Drupal site.";}}','system','0','0','0','0','0','4','0','1','8','57','1346','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1347','1346','admin/config/system/backup_migrate/export','admin/config/system/backup_migrate/export','Backup','a:1:{s:10:"attributes";a:1:{s:5:"title";s:20:"Backup the database.";}}','system','-1','0','0','0','0','5','0','1','8','57','1346','1347','0','0','0','0','0'),('management','1348','1346','admin/config/system/backup_migrate/nodesquirrel','admin/config/system/backup_migrate/nodesquirrel','NodeSquirrel','a:0:{}','system','-1','0','0','0','10','5','0','1','8','57','1346','1348','0','0','0','0','0'),('management','1349','1346','admin/config/system/backup_migrate/restore','admin/config/system/backup_migrate/restore','Restore','a:1:{s:10:"attributes";a:1:{s:5:"title";s:43:"Restore the database from a previous backup";}}','system','-1','0','0','0','1','5','0','1','8','57','1346','1349','0','0','0','0','0'),('management','1350','1346','admin/config/system/backup_migrate/backups','admin/config/system/backup_migrate/backups','Saved Backups','a:1:{s:10:"attributes";a:1:{s:5:"title";s:26:"Previously created backups";}}','system','-1','0','0','0','2','5','0','1','8','57','1346','1350','0','0','0','0','0'),('management','1351','1346','admin/config/system/backup_migrate/schedule','admin/config/system/backup_migrate/schedule','Schedules','a:0:{}','system','-1','0','0','0','2','5','0','1','8','57','1346','1351','0','0','0','0','0'),('management','1352','1346','admin/config/system/backup_migrate/settings','admin/config/system/backup_migrate/settings','Settings','a:1:{s:10:"attributes";a:1:{s:5:"title";s:16:"Module settings.";}}','system','-1','0','0','0','4','5','0','1','8','57','1346','1352','0','0','0','0','0'),('management','1353','1351','admin/config/system/backup_migrate/schedule/add','admin/config/system/backup_migrate/schedule/add','Add !type','a:0:{}','system','-1','0','0','0','2','6','0','1','8','57','1346','1351','1353','0','0','0','0'),('management','1354','1347','admin/config/system/backup_migrate/export/advanced','admin/config/system/backup_migrate/export/advanced','Advanced Backup','a:1:{s:10:"attributes";a:1:{s:5:"title";s:20:"Backup the database.";}}','system','-1','0','0','0','1','6','0','1','8','57','1346','1347','1354','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1355','1352','admin/config/system/backup_migrate/settings/destination','admin/config/system/backup_migrate/settings/destination','Destinations','a:0:{}','system','-1','0','0','0','2','6','0','1','8','57','1346','1352','1355','0','0','0','0'),('management','1356','1352','admin/config/system/backup_migrate/settings/import','admin/config/system/backup_migrate/settings/import','Import','a:1:{s:10:"attributes";a:1:{s:5:"title";s:35:"Import backup and migrate settings.";}}','system','-1','0','0','0','10','6','0','1','8','57','1346','1352','1356','0','0','0','0'),('management','1357','1351','admin/config/system/backup_migrate/schedule/list','admin/config/system/backup_migrate/schedule/list','List !type','a:0:{}','system','-1','0','0','0','1','6','0','1','8','57','1346','1351','1357','0','0','0','0'),('management','1358','1347','admin/config/system/backup_migrate/export/quick','admin/config/system/backup_migrate/export/quick','Quick Backup','a:1:{s:10:"attributes";a:1:{s:5:"title";s:20:"Backup the database.";}}','system','-1','0','0','0','0','6','0','1','8','57','1346','1347','1358','0','0','0','0'),('management','1359','1352','admin/config/system/backup_migrate/settings/profile','admin/config/system/backup_migrate/settings/profile','Settings Profiles','a:0:{}','system','-1','0','0','0','2','6','0','1','8','57','1346','1352','1359','0','0','0','0'),('management','1360','1352','admin/config/system/backup_migrate/settings/source','admin/config/system/backup_migrate/settings/source','Sources','a:0:{}','system','-1','0','0','0','2','6','0','1','8','57','1346','1352','1360','0','0','0','0'),('management','1361','1355','admin/config/system/backup_migrate/settings/destination/add','admin/config/system/backup_migrate/settings/destination/add','Add !type','a:0:{}','system','-1','0','0','0','2','7','0','1','8','57','1346','1352','1355','1361','0','0','0'),('management','1362','1359','admin/config/system/backup_migrate/settings/profile/add','admin/config/system/backup_migrate/settings/profile/add','Add !type','a:0:{}','system','-1','0','0','0','2','7','0','1','8','57','1346','1352','1359','1362','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1363','1360','admin/config/system/backup_migrate/settings/source/add','admin/config/system/backup_migrate/settings/source/add','Add !type','a:0:{}','system','-1','0','0','0','2','7','0','1','8','57','1346','1352','1360','1363','0','0','0'),('management','1364','1355','admin/config/system/backup_migrate/settings/destination/list','admin/config/system/backup_migrate/settings/destination/list','List !type','a:0:{}','system','-1','0','0','0','1','7','0','1','8','57','1346','1352','1355','1364','0','0','0'),('management','1365','1359','admin/config/system/backup_migrate/settings/profile/list','admin/config/system/backup_migrate/settings/profile/list','List !type','a:0:{}','system','-1','0','0','0','1','7','0','1','8','57','1346','1352','1359','1365','0','0','0'),('management','1366','1360','admin/config/system/backup_migrate/settings/source/list','admin/config/system/backup_migrate/settings/source/list','List !type','a:0:{}','system','-1','0','0','0','1','7','0','1','8','57','1346','1352','1360','1366','0','0','0'),('management','1367','1364','admin/config/system/backup_migrate/settings/destination/list/deletefile','admin/config/system/backup_migrate/settings/destination/list/deletefile','Delete File','a:1:{s:10:"attributes";a:1:{s:5:"title";s:20:"Delete a backup file";}}','system','-1','0','0','0','0','8','0','1','8','57','1346','1352','1355','1364','1367','0','0'),('management','1368','1364','admin/config/system/backup_migrate/settings/destination/list/files','admin/config/system/backup_migrate/settings/destination/list/files','Destination Files','a:0:{}','system','-1','0','0','0','0','8','0','1','8','57','1346','1352','1355','1364','1368','0','0'),('management','1369','1364','admin/config/system/backup_migrate/settings/destination/list/restorefile','admin/config/system/backup_migrate/settings/destination/list/restorefile','Restore from backup','a:1:{s:10:"attributes";a:1:{s:5:"title";s:49:"Restore database from a backup file on the server";}}','system','-1','0','0','0','0','8','0','1','8','57','1346','1352','1355','1364','1369','0','0');
INSERT INTO `menu_links` VALUES ('menu-library-menu1','1370','0','library/dashboard/drawing','library/dashboard/drawing','Drawings','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','system','0','0','0','0','0','1','1','1370','0','0','0','0','0','0','0','0','0'),('navigation','1371','0','calendar','calendar','Calendar','a:0:{}','system','0','0','0','0','0','1','0','1371','0','0','0','0','0','0','0','0','0'),('navigation','1372','0','calendar-node-field-date/year','calendar-node-field-date/year','Year','a:0:{}','system','-1','0','0','0','4','1','0','1372','0','0','0','0','0','0','0','0','0'),('navigation','1373','1371','calendar/month','calendar/month','Month','a:0:{}','system','-1','0','0','0','0','2','0','1371','1373','0','0','0','0','0','0','0','0'),('navigation','1374','1371','calendar/week','calendar/week','Week','a:0:{}','system','-1','0','0','0','2','2','0','1371','1374','0','0','0','0','0','0','0','0'),('navigation','1375','1371','calendar/day','calendar/day','Day','a:0:{}','system','-1','0','0','0','3','2','0','1371','1375','0','0','0','0','0','0','0','0'),('navigation','1376','6','node/add/event','node/add/event','Event','a:1:{s:10:"attributes";a:1:{s:5:"title";s:55:"A date content type that is linked to a Views calendar.";}}','system','0','0','0','0','0','2','0','6','1376','0','0','0','0','0','0','0','0'),('management','1377','12','admin/help/calendar','admin/help/calendar','calendar','a:0:{}','system','-1','0','0','0','0','3','0','1','12','1377','0','0','0','0','0','0','0'),('management','1378','852','admin/config/date/calendar','admin/config/date/calendar','Calendar','a:1:{s:10:"attributes";a:1:{s:5:"title";s:24:"Calendar administration.";}}','system','0','0','0','0','0','4','0','1','8','852','1378','0','0','0','0','0','0'),('navigation','1379','17','user/%/imce','user/%/imce','File browser','a:0:{}','system','-1','0','0','0','10','2','0','17','1379','0','0','0','0','0','0','0','0'),('management','1380','12','admin/help/wysiwyg','admin/help/wysiwyg','wysiwyg','a:0:{}','system','-1','0','0','0','0','3','0','1','12','1380','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1381','47','admin/config/media/imce','admin/config/media/imce','IMCE','a:1:{s:10:"attributes";a:1:{s:5:"title";s:42:"Control how your image/file browser works.";}}','system','0','0','0','0','0','4','0','1','8','47','1381','0','0','0','0','0','0'),('management','1382','36','admin/config/content/wysiwyg','admin/config/content/wysiwyg','Wysiwyg profiles','a:1:{s:10:"attributes";a:1:{s:5:"title";s:30:"Configure client-side editors.";}}','system','0','0','1','0','0','4','0','1','8','36','1382','0','0','0','0','0','0'),('management','1383','1381','admin/config/media/imce/profile','admin/config/media/imce/profile','Add new profile','a:0:{}','system','-1','0','0','0','0','5','0','1','8','47','1381','1383','0','0','0','0','0'),('management','1384','1382','admin/config/content/wysiwyg/list','admin/config/content/wysiwyg/list','List','a:0:{}','system','-1','0','0','0','-10','5','0','1','8','36','1382','1384','0','0','0','0','0'),('management','1385','1382','admin/config/content/wysiwyg/profile/%','admin/config/content/wysiwyg/profile/%','','a:0:{}','system','0','0','0','0','0','5','0','1','8','36','1382','1385','0','0','0','0','0'),('management','1386','1385','admin/config/content/wysiwyg/profile/%/break-lock','admin/config/content/wysiwyg/profile/%/break-lock','Break lock','a:0:{}','system','-1','0','0','0','0','6','0','1','8','36','1382','1385','1386','0','0','0','0'),('management','1387','1385','admin/config/content/wysiwyg/profile/%/edit','admin/config/content/wysiwyg/profile/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','6','0','1','8','36','1382','1385','1387','0','0','0','0'),('management','1388','1385','admin/config/content/wysiwyg/profile/%/delete','admin/config/content/wysiwyg/profile/%/delete','Remove','a:0:{}','system','-1','0','0','0','10','6','0','1','8','36','1382','1385','1388','0','0','0','0'),('navigation','1389','0','import','import','Import','a:0:{}','system','0','0','1','0','0','1','0','1389','0','0','0','0','0','0','0','0','0'),('navigation','1390','1389','import/%','import/%','','a:0:{}','system','0','0','0','0','0','2','0','1389','1390','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','1391','1390','import/%/delete-items','import/%/delete-items','Delete items','a:0:{}','system','-1','0','0','0','0','3','0','1389','1390','1391','0','0','0','0','0','0','0'),('navigation','1392','1390','import/%/import','import/%/import','Import','a:0:{}','system','-1','0','0','0','-10','3','0','1389','1390','1392','0','0','0','0','0','0','0'),('navigation','1393','1390','import/%/unlock','import/%/unlock','Unlock','a:0:{}','system','-1','0','0','0','0','3','0','1389','1390','1393','0','0','0','0','0','0','0'),('navigation','1394','5','node/%/delete-items','node/%/delete-items','Delete items','a:0:{}','system','-1','0','0','0','11','2','0','5','1394','0','0','0','0','0','0','0','0'),('management','1395','21','admin/structure/feeds','admin/structure/feeds','Feeds importers','a:1:{s:10:"attributes";a:1:{s:5:"title";s:96:"Configure one or more Feeds importers to aggregate RSS and Atom feeds, import CSV files or more.";}}','system','0','0','1','0','0','3','0','1','21','1395','0','0','0','0','0','0','0'),('navigation','1396','5','node/%/import','node/%/import','Import','a:0:{}','system','-1','0','0','0','10','2','0','5','1396','0','0','0','0','0','0','0','0'),('navigation','1397','5','node/%/unlock','node/%/unlock','Unlock','a:0:{}','system','-1','0','0','0','11','2','0','5','1397','0','0','0','0','0','0','0','0'),('management','1398','12','admin/help/feeds_ui','admin/help/feeds_ui','feeds_ui','a:0:{}','system','-1','0','0','0','0','3','0','1','12','1398','0','0','0','0','0','0','0'),('management','1399','1395','admin/structure/feeds/%','admin/structure/feeds/%','','a:0:{}','system','0','0','0','0','0','4','0','1','21','1395','1399','0','0','0','0','0','0'),('management','1400','1395','admin/structure/feeds/create','admin/structure/feeds/create','Add importer','a:0:{}','system','-1','0','0','0','0','4','0','1','21','1395','1400','0','0','0','0','0','0'),('management','1401','1395','admin/structure/feeds/import','admin/structure/feeds/import','Import importer','a:0:{}','system','-1','0','0','0','0','4','0','1','21','1395','1401','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1402','1399','admin/structure/feeds/%/clone','admin/structure/feeds/%/clone','Clone','a:0:{}','system','-1','0','0','0','3','5','0','1','21','1395','1399','1402','0','0','0','0','0'),('management','1403','1399','admin/structure/feeds/%/delete','admin/structure/feeds/%/delete','Delete','a:0:{}','system','-1','0','0','0','4','5','0','1','21','1395','1399','1403','0','0','0','0','0'),('management','1404','1399','admin/structure/feeds/%/edit','admin/structure/feeds/%/edit','Edit','a:0:{}','system','-1','0','0','0','1','5','0','1','21','1395','1399','1404','0','0','0','0','0'),('management','1405','1399','admin/structure/feeds/%/export','admin/structure/feeds/%/export','Export','a:0:{}','system','-1','0','0','0','2','5','0','1','21','1395','1399','1405','0','0','0','0','0'),('management','1406','19','admin/reports/feeds','admin/reports/feeds','Feeds log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:58:"Review log messages of imports and subscriptions to feeds.";}}','system','0','0','0','0','0','3','0','1','19','1406','0','0','0','0','0','0','0'),('navigation','1407','1390','import/%/log','import/%/log','Log','a:0:{}','system','-1','0','0','0','0','3','0','1389','1390','1407','0','0','0','0','0','0','0'),('navigation','1408','5','node/%/log','node/%/log','Log','a:0:{}','system','-1','0','0','0','12','2','0','5','1408','0','0','0','0','0','0','0','0'),('navigation','1418','0','field-collection/field-booklist-books/%','field-collection/field-booklist-books/%','','a:0:{}','system','0','0','1','0','0','1','0','1418','0','0','0','0','0','0','0','0','0'),('navigation','1419','6','node/add/book-list','node/add/book-list','Book List','a:1:{s:10:"attributes";a:1:{s:5:"title";s:83:"A book list is a collection of books that can be displayed in a variety of formats.";}}','system','0','0','0','0','0','2','0','6','1419','0','0','0','0','0','0','0','0'),('navigation','1420','1418','field-collection/field-booklist-books/%/delete','field-collection/field-booklist-books/%/delete','Delete','a:0:{}','system','-1','0','0','0','0','2','0','1418','1420','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('navigation','1421','1418','field-collection/field-booklist-books/%/edit','field-collection/field-booklist-books/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','2','0','1418','1421','0','0','0','0','0','0','0','0'),('navigation','1422','1418','field-collection/field-booklist-books/%/view','field-collection/field-booklist-books/%/view','View','a:0:{}','system','-1','0','0','0','-10','2','0','1418','1422','0','0','0','0','0','0','0','0'),('management','1423','386','admin/structure/field-collections/%','admin/structure/field-collections/%','Manage fields','a:0:{}','system','0','0','0','0','1','4','0','1','21','386','1423','0','0','0','0','0','0'),('navigation','1424','0','field-collection/field-booklist-books/add/%/%','field-collection/field-booklist-books/add/%/%','','a:0:{}','system','0','0','0','0','0','1','0','1424','0','0','0','0','0','0','0','0','0'),('navigation','1425','1418','field-collection/field-booklist-books/%/revisions/%','field-collection/field-booklist-books/%/revisions/%','','a:0:{}','system','0','0','0','0','0','2','0','1418','1425','0','0','0','0','0','0','0','0'),('management','1426','1423','admin/structure/field-collections/%/display','admin/structure/field-collections/%/display','Manage display','a:0:{}','system','-1','0','0','0','2','5','0','1','21','386','1423','1426','0','0','0','0','0'),('management','1427','1423','admin/structure/field-collections/%/fields','admin/structure/field-collections/%/fields','Manage fields','a:0:{}','system','-1','0','1','0','1','5','0','1','21','386','1423','1427','0','0','0','0','0'),('management','1428','1426','admin/structure/field-collections/%/display/default','admin/structure/field-collections/%/display/default','Default','a:0:{}','system','-1','0','0','0','-10','6','0','1','21','386','1423','1426','1428','0','0','0','0'),('management','1429','1426','admin/structure/field-collections/%/display/full','admin/structure/field-collections/%/display/full','Full content','a:0:{}','system','-1','0','0','0','0','6','0','1','21','386','1423','1426','1429','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1430','1426','admin/structure/field-collections/%/display/token','admin/structure/field-collections/%/display/token','Tokens','a:0:{}','system','-1','0','0','0','1','6','0','1','21','386','1423','1426','1430','0','0','0','0'),('management','1431','1427','admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','','a:0:{}','system','0','0','0','0','0','6','0','1','21','386','1423','1427','1431','0','0','0','0'),('management','1432','1431','admin/structure/field-collections/%/fields/%/delete','admin/structure/field-collections/%/fields/%/delete','Delete','a:0:{}','system','-1','0','0','0','10','7','0','1','21','386','1423','1427','1431','1432','0','0','0'),('management','1433','1431','admin/structure/field-collections/%/fields/%/edit','admin/structure/field-collections/%/fields/%/edit','Edit','a:0:{}','system','-1','0','0','0','0','7','0','1','21','386','1423','1427','1431','1433','0','0','0'),('management','1434','1431','admin/structure/field-collections/%/fields/%/field-settings','admin/structure/field-collections/%/fields/%/field-settings','Field settings','a:0:{}','system','-1','0','0','0','0','7','0','1','21','386','1423','1427','1431','1434','0','0','0'),('management','1435','1431','admin/structure/field-collections/%/fields/%/widget-type','admin/structure/field-collections/%/fields/%/widget-type','Widget type','a:0:{}','system','-1','0','0','0','0','7','0','1','21','386','1423','1427','1431','1435','0','0','0'),('management','1436','12','admin/help/field_permissions','admin/help/field_permissions','field_permissions','a:0:{}','system','-1','0','0','0','0','3','0','1','12','1436','0','0','0','0','0','0','0'),('management','1437','1072','admin/structure/panels/layouts','admin/structure/panels/layouts','Layouts','a:1:{s:10:"attributes";a:1:{s:5:"title";s:43:"Add, edit or delete custom content layouts.";}}','system','-1','0','0','0','0','4','0','1','21','1072','1437','0','0','0','0','0','0'),('management','1438','43','admin/reports/fields/permissions','admin/reports/fields/permissions','Permissions','a:1:{s:10:"attributes";a:1:{s:5:"title";s:42:"Report and troubleshoot field permissions.";}}','system','-1','0','0','0','0','4','0','1','19','43','1438','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('management','1439','1437','admin/structure/panels/layouts/add-flexible','admin/structure/panels/layouts/add-flexible','Add flexible layout','a:0:{}','system','-1','0','0','0','0','5','0','1','21','1072','1437','1439','0','0','0','0','0'),('management','1440','1437','admin/structure/panels/layouts/import','admin/structure/panels/layouts/import','Import','a:0:{}','system','-1','0','0','0','0','5','0','1','21','1072','1437','1440','0','0','0','0','0'),('management','1441','1437','admin/structure/panels/layouts/list','admin/structure/panels/layouts/list','List','a:0:{}','system','-1','0','0','0','-10','5','0','1','21','1072','1437','1441','0','0','0','0','0'),('management','1442','1441','admin/structure/panels/layouts/list/%/edit','admin/structure/panels/layouts/list/%/edit','Edit','a:0:{}','system','-1','0','0','0','-10','6','0','1','21','1072','1437','1441','1442','0','0','0','0'),('management','1443','1441','admin/structure/panels/layouts/list/%/export','admin/structure/panels/layouts/list/%/export','Export','a:0:{}','system','-1','0','0','0','0','6','0','1','21','1072','1437','1441','1443','0','0','0','0'),('main-menu','1444','0','user/logout','user/logout','Logout','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','0','0','0','0','-45','1','1','1444','0','0','0','0','0','0','0','0','0'),('menu-library-menu1','1445','0','library/manage-events','library/manage-events','Events','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','system','0','0','0','0','0','1','1','1445','0','0','0','0','0','0','0','0','0'),('management','1446','48','admin/structure/menu/manage/menu-setup-menu','admin/structure/menu/manage/%','Setup Menu','a:0:{}','menu','0','0','0','0','0','4','0','1','21','48','1446','0','0','0','0','0','0'),('menu-setup-menu','1448','0','library/dashboard/schools','library/dashboard/schools','Schools','a:0:{}','system','0','0','0','0','-47','1','1','1448','0','0','0','0','0','0','0','0','0'),('main-menu','1449','0','book-lists','book-lists','Book Lists','a:0:{}','system','0','0','0','0','-47','1','1','1449','0','0','0','0','0','0','0','0','0');
INSERT INTO `menu_links` VALUES ('menu-library-menu1','1450','0','library/manage-book-lists','library/manage-book-lists','Book Lists','a:0:{}','system','0','0','0','0','0','1','0','1450','0','0','0','0','0','0','0','0','0'),('main-menu','1451','0','calendar','calendar','Events','a:1:{s:10:"attributes";a:1:{s:5:"title";s:0:"";}}','menu','0','0','0','0','-48','1','1','1451','0','0','0','0','0','0','0','0','0'),('management','1452','31','admin/structure/block/delete','admin/structure/block/delete','','a:0:{}','system','0','0','0','0','0','4','0','1','21','31','1452','0','0','0','0','0','0'),('management','1453','31','admin/structure/block/block-access','admin/structure/block/block-access','Block Access Settings','a:1:{s:10:"attributes";a:1:{s:5:"title";s:31:"Configure block access defaults";}}','system','-1','0','0','0','0','4','0','1','21','31','1453','0','0','0','0','0','0'),('main-menu','1454','0','my/book-log','my/book-log','Reading Log','a:1:{s:10:"attributes";a:1:{s:5:"title";s:50:"A list of all of your books and reading activities";}}','menu','0','0','0','0','-46','1','1','1454','0','0','0','0','0','0','0','0','0'),('main-menu','1455','0','node/18','node/%','Help','a:0:{}','menu','0','0','0','0','-49','1','1','1455','0','0','0','0','0','0','0','0','0'),('management','1456','12','admin/help/stringoverrides','admin/help/stringoverrides','stringoverrides','a:0:{}','system','-1','0','0','0','0','3','0','1','12','1456','0','0','0','0','0','0','0'),('management','1457','52','admin/config/regional/stringoverrides','admin/config/regional/stringoverrides','String overrides','a:1:{s:10:"attributes";a:1:{s:5:"title";s:60:"Provides a quick and easy way of replacing text on the site.";}}','system','0','0','0','0','0','4','0','1','8','52','1457','0','0','0','0','0','0'),('management','1458','1457','admin/config/regional/stringoverrides/manage/en','admin/config/regional/stringoverrides/manage/en','Overrides','a:0:{}','system','-1','0','0','0','0','5','0','1','8','52','1457','1458','0','0','0','0','0'),('management','1459','49','admin/config/people/terms_of_use','admin/config/people/terms_of_use','Terms of Use','a:1:{s:10:"attributes";a:1:{s:5:"title";s:42:"Add Terms of Use to the registration page.";}}','system','0','0','0','0','0','4','0','1','8','49','1459','0','0','0','0','0','0');
DROP TABLE IF EXISTS `menu_router`;
CREATE TABLE `menu_router` (   `path` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: the Drupal path this entry describes',   `load_functions` blob NOT NULL COMMENT 'A serialized array of function names (like node_load) to be called to load an object corresponding to a part of the current path.',   `to_arg_functions` blob NOT NULL COMMENT 'A serialized array of function names (like user_uid_optional_to_arg) to be called to replace a part of the router path with another string.',   `access_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The callback which determines the access to this router path. Defaults to user_access.',   `access_arguments` blob COMMENT 'A serialized array of arguments for the access callback.',   `page_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function that renders the page.',   `page_arguments` blob COMMENT 'A serialized array of arguments for the page callback.',   `delivery_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function that sends the result of the page_callback function to the browser.',   `fit` int(11) NOT NULL DEFAULT '0' COMMENT 'A numeric representation of how specific the path is.',   `number_parts` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Number of parts in this router path.',   `context` int(11) NOT NULL DEFAULT '0' COMMENT 'Only for local tasks (tabs) - the context of a local task to control its placement.',   `tab_parent` varchar(255) NOT NULL DEFAULT '' COMMENT 'Only for local tasks (tabs) - the router path of the parent page (which may also be a local task).',   `tab_root` varchar(255) NOT NULL DEFAULT '' COMMENT 'Router path of the closest non-tab parent page. For pages that are not local tasks, this will be the same as the path.',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title for the current page, or the title for the tab if this is a local task.',   `title_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'A function which will alter the title. Defaults to t()',   `title_arguments` varchar(255) NOT NULL DEFAULT '' COMMENT 'A serialized array of arguments for the title callback. If empty, the title will be used as the sole argument for the title callback.',   `theme_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'A function which returns the name of the theme that will be used to render this page. If left empty, the default theme will be used.',   `theme_arguments` varchar(255) NOT NULL DEFAULT '' COMMENT 'A serialized array of arguments for the theme callback.',   `type` int(11) NOT NULL DEFAULT '0' COMMENT 'Numeric representation of the type of the menu item, like MENU_LOCAL_TASK.',   `description` text NOT NULL COMMENT 'A description of this item.',   `position` varchar(255) NOT NULL DEFAULT '' COMMENT 'The position of the block (left or right) on the system administration page for this item.',   `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of the element. Lighter weights are higher up, heavier weights go down.',   `include_file` mediumtext COMMENT 'The file to include for this element, usually the page callback function lives in this file.',   PRIMARY KEY (`path`),   KEY `fit` (`fit`),   KEY `tab_parent` (`tab_parent`(64),`weight`,`title`),   KEY `tab_root_weight_title` (`tab_root`(64),`weight`,`title`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps paths to various callbacks (access, page and title)';
INSERT INTO `menu_router` VALUES ('activity/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','activity/%','','t','','','a:0:{}','6','','','0',''),('activity/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','activity/%/edit','','t','','','a:0:{}','6','','','0',''),('activity/activity/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:8:"activity";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:8:"activity";i:2;s:8:"activity";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;i:2;}','','6','3','0','','activity/activity/%','View Activity','t','','','a:0:{}','6','View an entity of type Activity with bundle Activity','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('activity/activity/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:8:"activity";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:8:"activity";i:2;s:8:"activity";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;i:2;}','','13','4','3','activity/activity/%','activity/activity/%','Delete','t','','','a:0:{}','132','View an entity of type Activity with bundle Activity','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('activity/activity/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:8:"activity";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:8:"activity";i:2;s:8:"activity";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;i:2;}','','13','4','3','activity/activity/%','activity/activity/%','Edit','t','','','a:0:{}','132','View an entity of type Activity with bundle Activity','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('activity/activity/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:8:"activity";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:8:"activity";i:2;s:8:"activity";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;i:2;}','','13','4','1','activity/activity/%','activity/activity/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('activity/log/claim/%/%','a:2:{i:3;N;i:4;N;}','','user_access','a:1:{i:0;s:14:"access content";}','galecia_model_create_activity_log','a:2:{i:0;i:3;i:1;i:4;}','galecia_model_create_activity_log_callback','28','5','0','','activity/log/claim/%/%','','t','','','a:0:{}','0','','','0',''),('activity/secret_code/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:8:"activity";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:8:"activity";i:2;s:11:"secret_code";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;i:2;}','','6','3','0','','activity/secret_code/%','View Secret Code','t','','','a:0:{}','6','View an entity of type Activity with bundle Secret Code','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('activity/secret_code/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:8:"activity";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:8:"activity";i:2;s:11:"secret_code";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;i:2;}','','13','4','3','activity/secret_code/%','activity/secret_code/%','Delete','t','','','a:0:{}','132','View an entity of type Activity with bundle Secret Code','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('activity/secret_code/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:8:"activity";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:8:"activity";i:2;s:11:"secret_code";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;i:2;}','','13','4','3','activity/secret_code/%','activity/secret_code/%','Edit','t','','','a:0:{}','132','View an entity of type Activity with bundle Secret Code','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('activity/secret_code/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:8:"activity";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:8:"activity";i:2;s:11:"secret_code";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;i:2;}','','13','4','1','activity/secret_code/%','activity/secret_code/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('activity_log/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','activity_log/%','','t','','','a:0:{}','6','','','0',''),('activity_log/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','activity_log/%/edit','','t','','','a:0:{}','6','','','0',''),('activity_log/activity_log/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"activity_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:12:"activity_log";i:2;s:12:"activity_log";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;i:2;}','','6','3','0','','activity_log/activity_log/%','View Activity Log','t','','','a:0:{}','6','View an entity of type Activity Log with bundle Activity Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('activity_log/activity_log/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"activity_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:12:"activity_log";i:2;s:12:"activity_log";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;i:2;}','','13','4','3','activity_log/activity_log/%','activity_log/activity_log/%','Delete','t','','','a:0:{}','132','View an entity of type Activity Log with bundle Activity Log','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('activity_log/activity_log/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"activity_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:12:"activity_log";i:2;s:12:"activity_log";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;i:2;}','','13','4','3','activity_log/activity_log/%','activity_log/activity_log/%','Edit','t','','','a:0:{}','132','View an entity of type Activity Log with bundle Activity Log','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('activity_log/activity_log/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"activity_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:12:"activity_log";i:2;s:12:"activity_log";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;i:2;}','','13','4','1','activity_log/activity_log/%','activity_log/activity_log/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('activity_log_reference/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','activity_log_reference/%','','t','','','a:0:{}','6','','','0',''),('activity_log_reference/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','activity_log_reference/%/edit','','t','','','a:0:{}','6','','','0',''),('activity_log_reference/activity_log_reference/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:22:"activity_log_reference";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;i:2;}','','6','3','0','','activity_log_reference/activity_log_reference/%','View Activity Log Reference','t','','','a:0:{}','6','View an entity of type Activity Log Reference with bundle Activity Log Reference','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('activity_log_reference/activity_log_reference/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:22:"activity_log_reference";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;i:2;}','','13','4','3','activity_log_reference/activity_log_reference/%','activity_log_reference/activity_log_reference/%','Delete','t','','','a:0:{}','132','View an entity of type Activity Log Reference with bundle Activity Log Reference','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('activity_log_reference/activity_log_reference/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:22:"activity_log_reference";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;i:2;}','','13','4','3','activity_log_reference/activity_log_reference/%','activity_log_reference/activity_log_reference/%','Edit','t','','','a:0:{}','132','View an entity of type Activity Log Reference with bundle Activity Log Reference','','1','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('activity_log_reference/activity_log_reference/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:22:"activity_log_reference";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;i:2;}','','13','4','1','activity_log_reference/activity_log_reference/%','activity_log_reference/activity_log_reference/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','1','1','0','','admin','Administration','t','','','a:0:{}','6','','','9','modules/system/system.admin.inc'),('admin/appearance','','','user_access','a:1:{i:0;s:17:"administer themes";}','system_themes_page','a:0:{}','','3','2','0','','admin/appearance','Appearance','t','','','a:0:{}','6','Select and configure your themes.','left','-6','modules/system/system.admin.inc'),('admin/appearance/default','','','user_access','a:1:{i:0;s:17:"administer themes";}','system_theme_default','a:0:{}','','7','3','0','','admin/appearance/default','Set default theme','t','','','a:0:{}','0','','','0','modules/system/system.admin.inc'),('admin/appearance/disable','','','user_access','a:1:{i:0;s:17:"administer themes";}','system_theme_disable','a:0:{}','','7','3','0','','admin/appearance/disable','Disable theme','t','','','a:0:{}','0','','','0','modules/system/system.admin.inc'),('admin/appearance/enable','','','user_access','a:1:{i:0;s:17:"administer themes";}','system_theme_enable','a:0:{}','','7','3','0','','admin/appearance/enable','Enable theme','t','','','a:0:{}','0','','','0','modules/system/system.admin.inc'),('admin/appearance/list','','','user_access','a:1:{i:0;s:17:"administer themes";}','system_themes_page','a:0:{}','','7','3','1','admin/appearance','admin/appearance','List','t','','','a:0:{}','140','Select and configure your theme','','-1','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/appearance/settings','','','user_access','a:1:{i:0;s:17:"administer themes";}','drupal_get_form','a:1:{i:0;s:21:"system_theme_settings";}','','7','3','1','admin/appearance','admin/appearance','Settings','t','','','a:0:{}','132','Configure default and theme specific settings.','','20','modules/system/system.admin.inc'),('admin/appearance/settings/adaptivetheme','','','_system_themes_access','a:1:{i:0;O:8:"stdClass":13:{s:8:"filename";s:57:"sites/all/themes/adaptivetheme/at_core/adaptivetheme.info";s:4:"name";s:13:"adaptivetheme";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:21:{s:4:"name";s:7:"AT Core";s:11:"description";s:210:"AT Core is the framework that drives the responsive layout system and provides an extensive set of tools for theme development. You do not need to enable this theme. Use the provided AT Subtheme to get started.";s:4:"core";s:3:"7.x";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:53:"sites/all/themes/adaptivetheme/at_core/screenshot.png";s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:17:"css/at.layout.css";s:56:"sites/all/themes/adaptivetheme/at_core/css/at.layout.css";}}s:10:"unset_core";a:37:{s:33:"modules/aggregator/aggregator.css";s:14:"aggregator.css";s:23:"modules/block/block.css";s:9:"block.css";s:21:"modules/book/book.css";s:8:"book.css";s:23:"modules/color/color.css";s:9:"color.css";s:27:"modules/comment/comment.css";s:11:"comment.css";s:33:"modules/contextual/contextual.css";s:14:"contextual.css";s:31:"modules/dashboard/dashboard.css";s:13:"dashboard.css";s:23:"modules/dblog/dblog.css";s:9:"dblog.css";s:29:"modules/field/theme/field.css";s:9:"field.css";s:29:"modules/field_ui/field_ui.css";s:12:"field_ui.css";s:21:"modules/file/file.css";s:8:"file.css";s:25:"modules/filter/filter.css";s:10:"filter.css";s:23:"modules/forum/forum.css";s:9:"forum.css";s:21:"modules/help/help.css";s:8:"help.css";s:29:"modules/image/image.admin.css";s:15:"image.admin.css";s:23:"modules/image/image.css";s:9:"image.css";s:25:"modules/locale/locale.css";s:10:"locale.css";s:21:"modules/menu/menu.css";s:8:"menu.css";s:21:"modules/node/node.css";s:8:"node.css";s:25:"modules/openid/openid.css";s:10:"openid.css";s:21:"modules/poll/poll.css";s:8:"poll.css";s:27:"modules/profile/profile.css";s:11:"profile.css";s:25:"modules/search/search.css";s:10:"search.css";s:35:"modules/shortcut/shortcut.admin.css";s:18:"shortcut.admin.css";s:29:"modules/shortcut/shortcut.css";s:12:"shortcut.css";s:33:"modules/simpletest/simpletest.css";s:14:"simpletest.css";s:31:"modules/system/system.admin.css";s:16:"system.admin.css";s:30:"modules/system/system.base.css";s:15:"system.base.css";s:37:"modules/system/system.maintenance.css";s:22:"system.maintenance.css";s:31:"modules/system/system.menus.css";s:16:"system.menus.css";s:34:"modules/system/system.messages.css";s:19:"system.messages.css";s:31:"modules/system/system.theme.css";s:16:"system.theme.css";s:29:"modules/taxonomy/taxonomy.css";s:12:"taxonomy.css";s:27:"modules/toolbar/toolbar.css";s:11:"toolbar.css";s:27:"modules/tracker/tracker.css";s:11:"tracker.css";s:25:"modules/update/update.css";s:10:"update.css";s:21:"modules/user/user.css";s:8:"user.css";}s:7:"regions";a:17:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:7:"content";s:12:"Main Content";s:11:"highlighted";s:11:"Highlighted";s:13:"content_aside";s:5:"Aside";s:17:"secondary_content";s:9:"Secondary";s:16:"tertiary_content";s:8:"Tertiary";s:6:"footer";s:6:"Footer";s:11:"leaderboard";s:11:"Leaderboard";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:7:"plugins";a:2:{s:11:"page_layout";a:1:{s:7:"layouts";s:12:"layouts/core";}s:6:"panels";a:1:{s:7:"layouts";s:14:"layouts/panels";}}s:8:"settings";a:209:{s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1140";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:581px) and (max-width:768px)";s:27:"smalltouch_landscape_layout";s:12:"one_col_vert";s:30:"smalltouch_landscape_page_unit";s:1:"%";s:33:"smalltouch_landscape_sidebar_unit";s:1:"%";s:31:"smalltouch_landscape_page_width";s:3:"100";s:34:"smalltouch_landscape_sidebar_first";s:2:"50";s:35:"smalltouch_landscape_sidebar_second";s:2:"50";s:32:"smalltouch_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:580px)";s:26:"smalltouch_portrait_layout";s:13:"one_col_stack";s:29:"smalltouch_portrait_page_unit";s:1:"%";s:32:"smalltouch_portrait_sidebar_unit";s:1:"%";s:30:"smalltouch_portrait_page_width";s:3:"100";s:33:"smalltouch_portrait_sidebar_first";s:3:"100";s:34:"smalltouch_portrait_sidebar_second";s:3:"100";s:31:"smalltouch_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:9:"five-5x20";s:18:"bigscreen_six_6x16";s:8:"six-6x16";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:9:"five-5x20";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smalltouch_landscape_two_50";s:12:"two-50-stack";s:30:"smalltouch_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smalltouch_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smalltouch_landscape_two_brick";s:15:"two-brick-stack";s:31:"smalltouch_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smalltouch_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smalltouch_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smalltouch_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smalltouch_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smalltouch_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smalltouch_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smalltouch_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smalltouch_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"1";s:21:"global_default_layout";s:19:"smalltouch-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:19:"load_onmediaqueryjs";s:1:"0";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"0";s:20:"enable_font_settings";s:1:"0";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"0";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"0";s:14:"base_font_type";s:6:"<none>";s:19:"site_name_font_type";s:6:"<none>";s:21:"site_slogan_font_type";s:6:"<none>";s:20:"page_title_font_type";s:6:"<none>";s:20:"node_title_font_type";s:6:"<none>";s:23:"comment_title_font_type";s:6:"<none>";s:21:"block_title_font_type";s:6:"<none>";s:19:"main_menu_font_type";s:6:"<none>";s:24:"secondary_menu_font_type";s:6:"<none>";s:20:"block_menu_font_type";s:6:"<none>";s:19:"selectors_font_type";s:6:"<none>";s:14:"base_font_size";s:6:"<none>";s:19:"site_name_font_size";s:6:"<none>";s:21:"site_slogan_font_size";s:6:"<none>";s:20:"page_title_font_size";s:6:"<none>";s:20:"node_title_font_size";s:6:"<none>";s:23:"comment_title_font_size";s:6:"<none>";s:21:"block_title_font_size";s:6:"<none>";s:19:"main_menu_font_size";s:6:"<none>";s:24:"secondary_menu_font_size";s:6:"<none>";s:20:"block_menu_font_size";s:6:"<none>";s:31:"content_headings_h1h4_font_type";s:6:"<none>";s:31:"content_headings_h5h6_font_type";s:6:"<none>";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:14:"site_name_case";s:5:"snc-n";s:16:"site_name_weight";s:5:"snw-b";s:19:"site_name_alignment";s:5:"sna-l";s:16:"site_name_shadow";s:5:"sns-n";s:16:"site_slogan_case";s:5:"ssc-n";s:18:"site_slogan_weight";s:5:"ssw-b";s:21:"site_slogan_alignment";s:5:"ssa-l";s:18:"site_slogan_shadow";s:5:"sss-n";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-l";s:22:"image_alignment_teaser";s:5:"iat-l";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:10:"rel_author";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:56:"width=device-width, initial-scale=1.0, user-scalable=yes";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:35:"adaptivetheme_meta_ie_document_mode";s:0:"";s:29:"adaptivetheme_meta_clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:0:"";s:23:"apple_touch_icon_path_m";s:0:"";s:23:"apple_touch_icon_path_h";s:0:"";s:10:"custom_css";s:0:"";}s:7:"version";s:7:"7.x-3.2";s:7:"project";s:13:"adaptivetheme";s:9:"datestamp";s:10:"1395575059";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:10:"sub_themes";a:4:{s:19:"adaptivetheme_admin";s:8:"AT Admin";s:22:"adaptivetheme_subtheme";s:11:"AT Subtheme";s:17:"bookpoints_custom";s:23:"Bookpoints Customizable";s:7:"corolla";s:7:"Corolla";}s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:17:"css/at.layout.css";s:56:"sites/all/themes/adaptivetheme/at_core/css/at.layout.css";}}s:6:"engine";s:11:"phptemplate";}}','drupal_get_form','a:2:{i:0;s:21:"system_theme_settings";i:1;s:13:"adaptivetheme";}','','15','4','1','admin/appearance/settings','admin/appearance','AT Core','t','','','a:0:{}','132','','','0','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/appearance/settings/adaptivetheme_admin','','','_system_themes_access','a:1:{i:0;O:8:"stdClass":14:{s:8:"filename";s:64:"sites/all/themes/adaptivetheme/at_admin/adaptivetheme_admin.info";s:4:"name";s:19:"adaptivetheme_admin";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:20:{s:4:"name";s:8:"AT Admin";s:11:"description";s:144:"A better admin theme for Drupal 7. Clean, calm, invisible. Includes left and right sidebars, Overlay support and all AT''s theme setting goodies.";s:4:"core";s:3:"7.x";s:10:"base theme";s:13:"adaptivetheme";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:54:"sites/all/themes/adaptivetheme/at_admin/screenshot.png";s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:16:"css/at_admin.css";s:56:"sites/all/themes/adaptivetheme/at_admin/css/at_admin.css";}}s:7:"regions";a:11:{s:7:"content";s:12:"Main content";s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:11:"highlighted";s:11:"Highlighted";s:4:"help";s:4:"Help";s:6:"footer";s:6:"Footer";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"settings";a:210:{s:20:"shortcut_module_link";s:1:"1";s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:2:"px";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:3:"180";s:24:"bigscreen_sidebar_second";s:3:"180";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1330";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:581px) and (max-width:768px)";s:27:"smalltouch_landscape_layout";s:12:"one_col_vert";s:30:"smalltouch_landscape_page_unit";s:1:"%";s:33:"smalltouch_landscape_sidebar_unit";s:1:"%";s:31:"smalltouch_landscape_page_width";s:3:"100";s:34:"smalltouch_landscape_sidebar_first";s:2:"50";s:35:"smalltouch_landscape_sidebar_second";s:2:"50";s:32:"smalltouch_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:580px)";s:26:"smalltouch_portrait_layout";s:13:"one_col_stack";s:29:"smalltouch_portrait_page_unit";s:1:"%";s:32:"smalltouch_portrait_sidebar_unit";s:1:"%";s:30:"smalltouch_portrait_page_width";s:3:"100";s:33:"smalltouch_portrait_sidebar_first";s:3:"100";s:34:"smalltouch_portrait_sidebar_second";s:3:"100";s:31:"smalltouch_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:9:"five-5x20";s:18:"bigscreen_six_6x16";s:8:"six-6x16";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:18:"five-5x20-2x3-grid";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smalltouch_landscape_two_50";s:12:"two-50-stack";s:30:"smalltouch_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smalltouch_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smalltouch_landscape_two_brick";s:15:"two-brick-stack";s:31:"smalltouch_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smalltouch_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smalltouch_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smalltouch_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smalltouch_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smalltouch_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smalltouch_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smalltouch_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smalltouch_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"0";s:21:"global_default_layout";s:19:"smalltouch-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:19:"load_onmediaqueryjs";s:1:"0";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"1";s:20:"enable_font_settings";s:1:"0";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"0";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"1";s:14:"base_font_type";s:0:"";s:19:"site_name_font_type";s:0:"";s:21:"site_slogan_font_type";s:0:"";s:20:"page_title_font_type";s:0:"";s:20:"node_title_font_type";s:0:"";s:23:"comment_title_font_type";s:0:"";s:21:"block_title_font_type";s:0:"";s:9:"base_font";s:6:"bf-sss";s:14:"site_name_font";s:6:"snf-sl";s:16:"site_slogan_font";s:6:"ssf-sl";s:14:"main_menu_font";s:6:"mmf-sl";s:15:"page_title_font";s:6:"ptf-sl";s:15:"node_title_font";s:6:"ntf-sl";s:18:"comment_title_font";s:6:"ctf-sl";s:16:"block_title_font";s:6:"btf-sl";s:14:"base_font_size";s:3:"1em";s:19:"site_name_font_size";s:3:"2em";s:21:"site_slogan_font_size";s:5:"1.2em";s:20:"page_title_font_size";s:3:"2em";s:20:"node_title_font_size";s:5:"1.6em";s:23:"comment_title_font_size";s:5:"1.4em";s:21:"block_title_font_size";s:5:"1.4em";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:14:"site_name_case";s:5:"snc-n";s:16:"site_name_weight";s:5:"snw-b";s:19:"site_name_alignment";s:5:"sna-l";s:16:"site_name_shadow";s:5:"sns-n";s:16:"site_slogan_case";s:5:"ssc-n";s:18:"site_slogan_weight";s:5:"ssw-b";s:21:"site_slogan_alignment";s:5:"ssa-l";s:18:"site_slogan_shadow";s:5:"sss-n";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:6:"btc-uc";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-l";s:22:"image_alignment_teaser";s:5:"iat-l";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"1";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"1";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:10:"rel_author";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:56:"width=device-width, initial-scale=1.0, user-scalable=yes";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:35:"adaptivetheme_meta_ie_document_mode";s:0:"";s:29:"adaptivetheme_meta_clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:23:"images/touch-icon-l.png";s:23:"apple_touch_icon_path_m";s:23:"images/touch-icon-m.png";s:23:"apple_touch_icon_path_h";s:23:"images/touch-icon-h.png";s:10:"custom_css";s:0:"";}s:8:"features";a:5:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:7:"favicon";i:3;s:9:"main_menu";i:4;s:14:"secondary_menu";}s:7:"version";s:7:"7.x-3.2";s:7:"project";s:13:"adaptivetheme";s:9:"datestamp";s:10:"1395575059";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:11:"base_themes";a:1:{s:13:"adaptivetheme";s:7:"AT Core";}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:16:"css/at_admin.css";s:56:"sites/all/themes/adaptivetheme/at_admin/css/at_admin.css";}}s:6:"engine";s:11:"phptemplate";s:10:"base_theme";s:13:"adaptivetheme";}}','drupal_get_form','a:2:{i:0;s:21:"system_theme_settings";i:1;s:19:"adaptivetheme_admin";}','','15','4','1','admin/appearance/settings','admin/appearance','AT Admin','t','','','a:0:{}','132','','','0','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/appearance/settings/adaptivetheme_subtheme','','','_system_themes_access','a:1:{i:0;O:8:"stdClass":14:{s:8:"filename";s:70:"sites/all/themes/adaptivetheme/at_subtheme/adaptivetheme_subtheme.info";s:4:"name";s:22:"adaptivetheme_subtheme";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:21:{s:4:"name";s:11:"AT Subtheme";s:11:"description";s:580:"Copy this subtheme to get started - see the <b><a href="http://adaptivethemes.com/documentation/adaptivethemes-documentation" target="_blank" title="Adaptivethemes.com - Rocking the hardest since 2006">documentation</a></b> for guidence or the included README. Drush users can generate a new theme using the command: drush adaptivetheme. If you need help please use the <b><a href="http://drupal.org/project/issues/adaptivetheme" target="_blank">issue queue</a></b> or ask in the IRC channel: <b><a href="irc://irc.freenode.net/drupal-adaptivetheme">#drupal-adaptivetheme</a></b>.";s:4:"core";s:3:"7.x";s:10:"base theme";s:13:"adaptivetheme";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:57:"sites/all/themes/adaptivetheme/at_subtheme/screenshot.png";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:19:"css/global.base.css";s:62:"sites/all/themes/adaptivetheme/at_subtheme/css/global.base.css";s:21:"css/global.styles.css";s:64:"sites/all/themes/adaptivetheme/at_subtheme/css/global.styles.css";}}s:7:"regions";a:17:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:7:"content";s:12:"Main Content";s:11:"highlighted";s:11:"Highlighted";s:13:"content_aside";s:5:"Aside";s:17:"secondary_content";s:9:"Secondary";s:16:"tertiary_content";s:8:"Tertiary";s:6:"footer";s:6:"Footer";s:11:"leaderboard";s:11:"Leaderboard";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:":plugins";a:2:{s:11:"page_layout";a:1:{s:7:"layouts";s:12:"layouts/page";}s:6:"panels";a:1:{s:7:"layouts";s:14:"layouts/panels";}}s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:6:"slogan";i:3;s:17:"node_user_picture";i:4;s:20:"comment_user_picture";i:5;s:25:"comment_user_verification";i:6;s:7:"favicon";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:8:"settings";a:231:{s:11:"toggle_logo";s:1:"1";s:11:"toggle_name";s:1:"1";s:13:"toggle_slogan";s:1:"1";s:24:"toggle_node_user_picture";s:1:"1";s:27:"toggle_comment_user_picture";s:1:"1";s:32:"toggle_comment_user_verification";s:1:"1";s:14:"toggle_favicon";s:1:"1";s:16:"toggle_main_menu";s:1:"1";s:21:"toggle_secondary_menu";s:1:"1";s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1140";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:581px) and (max-width:768px)";s:27:"smalltouch_landscape_layout";s:12:"one_col_vert";s:30:"smalltouch_landscape_page_unit";s:1:"%";s:33:"smalltouch_landscape_sidebar_unit";s:1:"%";s:31:"smalltouch_landscape_page_width";s:3:"100";s:34:"smalltouch_landscape_sidebar_first";s:2:"50";s:35:"smalltouch_landscape_sidebar_second";s:2:"50";s:32:"smalltouch_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:580px)";s:26:"smalltouch_portrait_layout";s:13:"one_col_stack";s:29:"smalltouch_portrait_page_unit";s:1:"%";s:32:"smalltouch_portrait_sidebar_unit";s:1:"%";s:30:"smalltouch_portrait_page_width";s:3:"100";s:33:"smalltouch_portrait_sidebar_first";s:3:"100";s:34:"smalltouch_portrait_sidebar_second";s:3:"100";s:31:"smalltouch_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:18:"five-5x20-2x3-grid";s:18:"bigscreen_six_6x16";s:17:"six-6x16-3x2-grid";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:9:"five-5x20";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smalltouch_landscape_two_50";s:12:"two-50-stack";s:30:"smalltouch_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smalltouch_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smalltouch_landscape_two_brick";s:15:"two-brick-stack";s:31:"smalltouch_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smalltouch_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smalltouch_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smalltouch_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smalltouch_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smalltouch_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smalltouch_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smalltouch_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smalltouch_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"1";s:21:"global_default_layout";s:19:"smalltouch-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"0";s:20:"enable_font_settings";s:1:"0";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"0";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"0";s:14:"base_font_type";s:6:"<none>";s:19:"site_name_font_type";s:6:"<none>";s:21:"site_slogan_font_type";s:6:"<none>";s:20:"page_title_font_type";s:6:"<none>";s:20:"node_title_font_type";s:6:"<none>";s:23:"comment_title_font_type";s:6:"<none>";s:21:"block_title_font_type";s:6:"<none>";s:19:"main_menu_font_type";s:6:"<none>";s:24:"secondary_menu_font_type";s:6:"<none>";s:20:"block_menu_font_type";s:6:"<none>";s:19:"selectors_font_type";s:6:"<none>";s:31:"content_headings_h1h4_font_type";s:6:"<none>";s:31:"content_headings_h5h6_font_type";s:6:"<none>";s:14:"base_font_size";s:6:"<none>";s:19:"site_name_font_size";s:6:"<none>";s:21:"site_slogan_font_size";s:6:"<none>";s:20:"page_title_font_size";s:6:"<none>";s:20:"node_title_font_size";s:6:"<none>";s:23:"comment_title_font_size";s:6:"<none>";s:21:"block_title_font_size";s:6:"<none>";s:19:"main_menu_font_size";s:6:"<none>";s:24:"secondary_menu_font_size";s:6:"<none>";s:20:"block_menu_font_size";s:6:"<none>";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:14:"site_name_case";s:5:"snc-n";s:16:"site_name_weight";s:5:"snw-b";s:19:"site_name_alignment";s:5:"sna-l";s:16:"site_name_shadow";s:5:"sns-n";s:16:"site_slogan_case";s:5:"ssc-n";s:18:"site_slogan_weight";s:5:"ssw-b";s:21:"site_slogan_alignment";s:5:"ssa-l";s:18:"site_slogan_shadow";s:5:"sss-n";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-n";s:22:"image_alignment_teaser";s:5:"iat-n";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:20:"user_block_user_name";s:1:"1";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:17:"unset_menu_titles";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:10:"rel_author";s:1:"0";s:27:"menu_toggle_tablet_portrait";s:1:"1";s:28:"menu_toggle_tablet_landscape";s:1:"0";s:21:"menu_toggle_main_menu";s:1:"1";s:26:"menu_toggle_secondary_menu";s:1:"1";s:23:"menu_toggle_leaderboard";s:1:"0";s:18:"menu_toggle_header";s:1:"0";s:20:"menu_toggle_menu_bar";s:1:"1";s:27:"menu_toggle_main_menu_title";s:9:"Main menu";s:32:"menu_toggle_secondary_menu_title";s:9:"User menu";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:56:"width=device-width, initial-scale=1.0, user-scalable=yes";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:35:"adaptivetheme_meta_ie_document_mode";s:0:"";s:29:"adaptivetheme_meta_clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:17:"icon_path_default";s:24:"images/default-60x60.png";s:26:"apple_touch_icon_path_ipad";s:30:"images/ipad-standard-76x76.png";s:35:"apple_touch_icon_path_iphone_retina";s:32:"images/iphone-retina-120x120.png";s:33:"apple_touch_icon_path_ipad_retina";s:30:"images/ipad-retina-152x152.png";s:8:"icon_rel";s:1:"0";s:10:"custom_css";s:0:"";}s:7:"version";s:7:"7.x-3.2";s:7:"project";s:13:"adaptivetheme";s:9:"datestamp";s:10:"1395575059";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:11:"base_themes";a:1:{s:13:"adaptivetheme";s:7:"AT Core";}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:19:"css/global.base.css";s:62:"sites/all/themes/adaptivetheme/at_subtheme/css/global.base.css";s:21:"css/global.styles.css";s:64:"sites/all/themes/adaptivetheme/at_subtheme/css/global.styles.css";}}s:6:"engine";s:11:"phptemplate";s:10:"base_theme";s:13:"adaptivetheme";}}','drupal_get_form','a:2:{i:0;s:21:"system_theme_settings";i:1;s:22:"adaptivetheme_subtheme";}','','15','4','1','admin/appearance/settings','admin/appearance','AT Subtheme','t','','','a:0:{}','132','','','0','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/appearance/settings/bartik','','','_system_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:25:"themes/bartik/bartik.info";s:4:"name";s:6:"bartik";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:19:{s:4:"name";s:6:"Bartik";s:11:"description";s:48:"A flexible, recolorable theme with many regions.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:2:{s:3:"all";a:3:{s:14:"css/layout.css";s:28:"themes/bartik/css/layout.css";s:13:"css/style.css";s:27:"themes/bartik/css/style.css";s:14:"css/colors.css";s:28:"themes/bartik/css/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:27:"themes/bartik/css/print.css";}}s:7:"regions";a:20:{s:6:"header";s:6:"Header";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:11:"highlighted";s:11:"Highlighted";s:8:"featured";s:8:"Featured";s:7:"content";s:7:"Content";s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:14:"triptych_first";s:14:"Triptych first";s:15:"triptych_middle";s:15:"Triptych middle";s:13:"triptych_last";s:13:"Triptych last";s:18:"footer_firstcolumn";s:19:"Footer first column";s:19:"footer_secondcolumn";s:20:"Footer second column";s:18:"footer_thirdcolumn";s:19:"Footer third column";s:19:"footer_fourthcolumn";s:20:"Footer fourth column";s:6:"footer";s:6:"Footer";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"settings";a:1:{s:20:"shortcut_module_link";s:1:"0";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:28:"themes/bartik/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:2:{s:3:"all";a:3:{s:14:"css/layout.css";s:28:"themes/bartik/css/layout.css";s:13:"css/style.css";s:27:"themes/bartik/css/style.css";s:14:"css/colors.css";s:28:"themes/bartik/css/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:27:"themes/bartik/css/print.css";}}s:6:"engine";s:11:"phptemplate";}}','drupal_get_form','a:2:{i:0;s:21:"system_theme_settings";i:1;s:6:"bartik";}','','15','4','1','admin/appearance/settings','admin/appearance','Bartik','t','','','a:0:{}','132','','','0','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/appearance/settings/bookpoints_custom','','','_system_themes_access','a:1:{i:0;O:8:"stdClass":15:{s:8:"filename";s:57:"sites/all/themes/bookpoints_custom/bookpoints_custom.info";s:4:"name";s:17:"bookpoints_custom";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"1";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:18:{s:4:"name";s:23:"Bookpoints Customizable";s:11:"description";s:68:"A customizable, color-able theme built on AdaptiveTheme and Corolla.";s:4:"core";s:3:"7.x";s:7:"release";s:7:"7.x-3.x";s:10:"base theme";s:7:"corolla";s:11:"stylesheets";a:1:{s:3:"all";a:3:{s:16:"color/colors.css";s:51:"sites/all/themes/bookpoints_custom/color/colors.css";s:14:"css/styles.css";s:49:"sites/all/themes/bookpoints_custom/css/styles.css";s:24:"css/reader_dashboard.css";s:59:"sites/all/themes/bookpoints_custom/css/reader_dashboard.css";}}s:14:"ie_stylesheets";a:1:{s:6:"screen";a:1:{s:8:"lte IE 9";a:1:{i:0;s:16:"css/ie-lte-9.css";}}}s:7:"scripts";a:1:{s:11:"js/stars.js";s:46:"sites/all/themes/bookpoints_custom/js/stars.js";}s:7:"regions";a:25:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:11:"highlighted";s:11:"Highlighted";s:7:"content";s:12:"Main content";s:13:"content_aside";s:14:"Content bottom";s:17:"secondary_content";s:17:"Secondary content";s:16:"tertiary_content";s:16:"Tertiary content";s:6:"footer";s:6:"Footer";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:12:"three_33_top";s:26:"AT Three column 3x33 - top";s:14:"three_33_first";s:27:"AT Three column 3x33 - left";s:15:"three_33_second";s:29:"AT Three column 3x33 - center";s:14:"three_33_third";s:28:"AT Three column 3x33 - right";s:15:"three_33_bottom";s:29:"AT Three column 3x33 - bottom";s:10:"four_first";s:23:"AT Four column 4x25 - 1";s:11:"four_second";s:23:"AT Four column 4x25 - 2";s:10:"four_third";s:23:"AT Four column 4x25 - 3";s:11:"four_fourth";s:23:"AT Four column 4x25 - 4";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:7:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:6:"slogan";i:3;s:17:"node_user_picture";i:4;s:20:"comment_user_picture";i:5;s:25:"comment_user_verification";i:6;s:7:"favicon";}s:8:"settings";a:206:{s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1200";s:21:"bigscreen_media_query";s:37:"only screen and (min-width:64.0625em)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:58:"only screen and (min-width:48.0625em) and (max-width:64em)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:58:"only screen and (min-width:30.0625em) and (max-width:48em)";s:27:"smartphone_landscape_layout";s:12:"one_col_vert";s:30:"smartphone_landscape_page_unit";s:1:"%";s:33:"smartphone_landscape_sidebar_unit";s:1:"%";s:31:"smartphone_landscape_page_width";s:3:"100";s:34:"smartphone_landscape_sidebar_first";s:2:"50";s:35:"smartphone_landscape_sidebar_second";s:2:"50";s:32:"smartphone_landscape_media_query";s:58:"only screen and (min-width:20.0625em) and (max-width:30em)";s:26:"smartphone_portrait_layout";s:13:"one_col_stack";s:29:"smartphone_portrait_page_unit";s:1:"%";s:32:"smartphone_portrait_sidebar_unit";s:1:"%";s:30:"smartphone_portrait_page_width";s:3:"100";s:33:"smartphone_portrait_sidebar_first";s:3:"100";s:34:"smartphone_portrait_sidebar_second";s:3:"100";s:31:"smartphone_portrait_media_query";s:32:"only screen and (max-width:20em)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:18:"five-5x20-2x3-grid";s:18:"bigscreen_six_6x16";s:17:"six-6x16-3x2-grid";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:18:"five-5x20-2x3-grid";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smartphone_landscape_two_50";s:12:"two-50-stack";s:30:"smartphone_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smartphone_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smartphone_landscape_two_brick";s:15:"two-brick-stack";s:31:"smartphone_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smartphone_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smartphone_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smartphone_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smartphone_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smartphone_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smartphone_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smartphone_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smartphone_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"0";s:21:"global_default_layout";s:19:"smartphone-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"1";s:20:"enable_font_settings";s:1:"1";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"1";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:18:"enable_menu_toggle";s:1:"1";s:22:"enable_markup_overides";s:1:"1";s:14:"base_font_type";s:0:"";s:19:"site_name_font_type";s:0:"";s:21:"site_slogan_font_type";s:0:"";s:20:"page_title_font_type";s:0:"";s:20:"node_title_font_type";s:0:"";s:23:"comment_title_font_type";s:0:"";s:21:"block_title_font_type";s:0:"";s:9:"base_font";s:6:"bf-sss";s:14:"site_name_font";s:6:"snf-sl";s:16:"site_slogan_font";s:6:"ssf-sl";s:14:"main_menu_font";s:6:"mmf-sl";s:15:"page_title_font";s:6:"ptf-sl";s:15:"node_title_font";s:6:"ntf-sl";s:18:"comment_title_font";s:6:"ctf-sl";s:16:"block_title_font";s:6:"btf-sl";s:14:"base_font_size";s:3:"1em";s:19:"site_name_font_size";s:5:"3.5em";s:21:"site_slogan_font_size";s:5:"1.2em";s:20:"page_title_font_size";s:3:"2em";s:20:"node_title_font_size";s:5:"1.6em";s:23:"comment_title_font_size";s:5:"1.4em";s:21:"block_title_font_size";s:5:"1.4em";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-n";s:22:"image_alignment_teaser";s:5:"iat-n";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:17:"unset_menu_titles";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:35:"width=device-width, initial-scale=1";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:11:"chrome_edge";s:1:"0";s:10:"clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:23:"images/touch-icon-l.png";s:23:"apple_touch_icon_path_m";s:23:"images/touch-icon-m.png";s:23:"apple_touch_icon_path_h";s:23:"images/touch-icon-h.png";s:10:"custom_css";s:0:"";s:21:"content_corner_radius";s:4:"rc-6";s:18:"tabs_corner_radius";s:5:"rct-6";s:11:"box_shadows";s:4:"bs-n";s:15:"body_background";s:4:"bb-n";s:12:"menu_bullets";s:5:"mb-dd";s:17:"menu_bar_position";s:5:"mbp-l";}s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:49:"sites/all/themes/bookpoints_custom/screenshot.png";s:3:"php";s:5:"5.2.4";s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:11:"base_themes";a:2:{s:13:"adaptivetheme";s:7:"AT Core";s:7:"corolla";s:7:"Corolla";}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:3:"all";a:3:{s:16:"color/colors.css";s:51:"sites/all/themes/bookpoints_custom/color/colors.css";s:14:"css/styles.css";s:49:"sites/all/themes/bookpoints_custom/css/styles.css";s:24:"css/reader_dashboard.css";s:59:"sites/all/themes/bookpoints_custom/css/reader_dashboard.css";}}s:7:"scripts";a:1:{s:11:"js/stars.js";s:46:"sites/all/themes/bookpoints_custom/js/stars.js";}s:6:"engine";s:11:"phptemplate";s:10:"base_theme";s:7:"corolla";}}','drupal_get_form','a:2:{i:0;s:21:"system_theme_settings";i:1;s:17:"bookpoints_custom";}','','15','4','1','admin/appearance/settings','admin/appearance','Bookpoints Customizable','t','','','a:0:{}','132','','','0','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/appearance/settings/corolla','','','_system_themes_access','a:1:{i:0;O:8:"stdClass":15:{s:8:"filename";s:37:"sites/all/themes/corolla/corolla.info";s:4:"name";s:7:"corolla";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:21:{s:4:"name";s:7:"Corolla";s:11:"description";s:367:"Corolla is a subtheme of <a href="http://drupal.org/project/adaptivetheme">Adaptivetheme 7.x-3.x</a>. To use this theme you must first download and install the 7.x-3.x version of Adaptivetheme. Corolla is colorable and has many theme settings for layout, fonts, headings and much more. Corolla also supports layouts for mobile devices such as tablets and smartphones.";s:4:"core";s:3:"7.x";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"base theme";s:13:"adaptivetheme";s:10:"screenshot";s:39:"sites/all/themes/corolla/screenshot.png";s:11:"stylesheets";a:2:{s:3:"all";a:12:{s:21:"css/html-elements.css";s:46:"sites/all/themes/corolla/css/html-elements.css";s:13:"css/forms.css";s:38:"sites/all/themes/corolla/css/forms.css";s:14:"css/tables.css";s:39:"sites/all/themes/corolla/css/tables.css";s:12:"css/page.css";s:37:"sites/all/themes/corolla/css/page.css";s:16:"css/articles.css";s:41:"sites/all/themes/corolla/css/articles.css";s:16:"css/comments.css";s:41:"sites/all/themes/corolla/css/comments.css";s:14:"css/fields.css";s:39:"sites/all/themes/corolla/css/fields.css";s:14:"css/blocks.css";s:39:"sites/all/themes/corolla/css/blocks.css";s:18:"css/navigation.css";s:43:"sites/all/themes/corolla/css/navigation.css";s:13:"css/fonts.css";s:38:"sites/all/themes/corolla/css/fonts.css";s:30:"css/corolla.settings.style.css";s:55:"sites/all/themes/corolla/css/corolla.settings.style.css";s:16:"color/colors.css";s:41:"sites/all/themes/corolla/color/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:38:"sites/all/themes/corolla/css/print.css";}}s:14:"ie_stylesheets";a:1:{s:6:"screen";a:1:{s:8:"lte IE 9";a:1:{i:0;s:16:"css/ie-lte-9.css";}}}s:7:"regions";a:25:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:11:"highlighted";s:11:"Highlighted";s:7:"content";s:12:"Main content";s:13:"content_aside";s:14:"Content bottom";s:17:"secondary_content";s:17:"Secondary content";s:16:"tertiary_content";s:16:"Tertiary content";s:6:"footer";s:6:"Footer";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:12:"three_33_top";s:26:"AT Three column 3x33 - top";s:14:"three_33_first";s:27:"AT Three column 3x33 - left";s:15:"three_33_second";s:29:"AT Three column 3x33 - center";s:14:"three_33_third";s:28:"AT Three column 3x33 - right";s:15:"three_33_bottom";s:29:"AT Three column 3x33 - bottom";s:10:"four_first";s:23:"AT Four column 4x25 - 1";s:11:"four_second";s:23:"AT Four column 4x25 - 2";s:10:"four_third";s:23:"AT Four column 4x25 - 3";s:11:"four_fourth";s:23:"AT Four column 4x25 - 4";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:7:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:6:"slogan";i:3;s:17:"node_user_picture";i:4;s:20:"comment_user_picture";i:5;s:25:"comment_user_verification";i:6;s:7:"favicon";}s:8:"settings";a:213:{s:11:"toggle_logo";s:1:"1";s:11:"toggle_name";s:1:"1";s:13:"toggle_slogan";s:1:"1";s:24:"toggle_node_user_picture";s:1:"1";s:27:"toggle_comment_user_picture";s:1:"1";s:32:"toggle_comment_user_verification";s:1:"1";s:14:"toggle_favicon";s:1:"1";s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1140";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:481px) and (max-width:768px)";s:27:"smartphone_landscape_layout";s:12:"one_col_vert";s:30:"smartphone_landscape_page_unit";s:1:"%";s:33:"smartphone_landscape_sidebar_unit";s:1:"%";s:31:"smartphone_landscape_page_width";s:3:"100";s:34:"smartphone_landscape_sidebar_first";s:2:"50";s:35:"smartphone_landscape_sidebar_second";s:2:"50";s:32:"smartphone_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:480px)";s:26:"smartphone_portrait_layout";s:13:"one_col_stack";s:29:"smartphone_portrait_page_unit";s:1:"%";s:32:"smartphone_portrait_sidebar_unit";s:1:"%";s:30:"smartphone_portrait_page_width";s:3:"100";s:33:"smartphone_portrait_sidebar_first";s:3:"100";s:34:"smartphone_portrait_sidebar_second";s:3:"100";s:31:"smartphone_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:18:"five-5x20-2x3-grid";s:18:"bigscreen_six_6x16";s:17:"six-6x16-3x2-grid";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:18:"five-5x20-2x3-grid";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smartphone_landscape_two_50";s:12:"two-50-stack";s:30:"smartphone_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smartphone_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smartphone_landscape_two_brick";s:15:"two-brick-stack";s:31:"smartphone_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smartphone_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smartphone_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smartphone_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smartphone_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smartphone_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smartphone_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smartphone_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smartphone_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"0";s:21:"global_default_layout";s:19:"smartphone-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"1";s:20:"enable_font_settings";s:1:"1";s:23:"enable_heading_settings";s:1:"1";s:21:"enable_image_settings";s:1:"1";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"1";s:14:"base_font_type";s:0:"";s:19:"site_name_font_type";s:0:"";s:21:"site_slogan_font_type";s:0:"";s:20:"page_title_font_type";s:0:"";s:20:"node_title_font_type";s:0:"";s:23:"comment_title_font_type";s:0:"";s:21:"block_title_font_type";s:0:"";s:9:"base_font";s:6:"bf-sss";s:14:"site_name_font";s:6:"snf-sl";s:16:"site_slogan_font";s:6:"ssf-sl";s:14:"main_menu_font";s:6:"mmf-sl";s:15:"page_title_font";s:6:"ptf-sl";s:15:"node_title_font";s:6:"ntf-sl";s:18:"comment_title_font";s:6:"ctf-sl";s:16:"block_title_font";s:6:"btf-sl";s:14:"base_font_size";s:3:"1em";s:19:"site_name_font_size";s:5:"3.5em";s:21:"site_slogan_font_size";s:5:"1.2em";s:20:"page_title_font_size";s:3:"2em";s:20:"node_title_font_size";s:5:"1.6em";s:23:"comment_title_font_size";s:5:"1.4em";s:21:"block_title_font_size";s:5:"1.4em";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-n";s:22:"image_alignment_teaser";s:5:"iat-n";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:17:"unset_menu_titles";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:35:"width=device-width, initial-scale=1";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:11:"chrome_edge";s:1:"0";s:10:"clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:23:"images/touch-icon-l.png";s:23:"apple_touch_icon_path_m";s:23:"images/touch-icon-m.png";s:23:"apple_touch_icon_path_h";s:23:"images/touch-icon-h.png";s:10:"custom_css";s:0:"";s:21:"content_corner_radius";s:4:"rc-6";s:18:"tabs_corner_radius";s:5:"rct-6";s:11:"box_shadows";s:4:"bs-n";s:15:"body_background";s:4:"bb-n";s:12:"menu_bullets";s:5:"mb-dd";s:17:"menu_bar_position";s:5:"mbp-l";}s:7:"version";s:7:"7.x-3.0";s:7:"project";s:7:"corolla";s:9:"datestamp";s:10:"1395577158";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:10:"sub_themes";a:1:{s:17:"bookpoints_custom";s:23:"Bookpoints Customizable";}s:11:"base_themes";a:1:{s:13:"adaptivetheme";s:7:"AT Core";}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:2:{s:3:"all";a:12:{s:21:"css/html-elements.css";s:46:"sites/all/themes/corolla/css/html-elements.css";s:13:"css/forms.css";s:38:"sites/all/themes/corolla/css/forms.css";s:14:"css/tables.css";s:39:"sites/all/themes/corolla/css/tables.css";s:12:"css/page.css";s:37:"sites/all/themes/corolla/css/page.css";s:16:"css/articles.css";s:41:"sites/all/themes/corolla/css/articles.css";s:16:"css/comments.css";s:41:"sites/all/themes/corolla/css/comments.css";s:14:"css/fields.css";s:39:"sites/all/themes/corolla/css/fields.css";s:14:"css/blocks.css";s:39:"sites/all/themes/corolla/css/blocks.css";s:18:"css/navigation.css";s:43:"sites/all/themes/corolla/css/navigation.css";s:13:"css/fonts.css";s:38:"sites/all/themes/corolla/css/fonts.css";s:30:"css/corolla.settings.style.css";s:55:"sites/all/themes/corolla/css/corolla.settings.style.css";s:16:"color/colors.css";s:41:"sites/all/themes/corolla/color/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:38:"sites/all/themes/corolla/css/print.css";}}s:6:"engine";s:11:"phptemplate";s:10:"base_theme";s:13:"adaptivetheme";}}','drupal_get_form','a:2:{i:0;s:21:"system_theme_settings";i:1;s:7:"corolla";}','','15','4','1','admin/appearance/settings','admin/appearance','Corolla','t','','','a:0:{}','132','','','0','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/appearance/settings/garland','','','_system_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:27:"themes/garland/garland.info";s:4:"name";s:7:"garland";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:19:{s:4:"name";s:7:"Garland";s:11:"description";s:111:"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:2:{s:3:"all";a:1:{s:9:"style.css";s:24:"themes/garland/style.css";}s:5:"print";a:1:{s:9:"print.css";s:24:"themes/garland/print.css";}}s:8:"settings";a:1:{s:13:"garland_width";s:5:"fluid";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:7:"regions";a:12:{s:13:"sidebar_first";s:12:"Left sidebar";s:14:"sidebar_second";s:13:"Right sidebar";s:7:"content";s:7:"Content";s:6:"header";s:6:"Header";s:6:"footer";s:6:"Footer";s:11:"highlighted";s:11:"Highlighted";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:29:"themes/garland/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:2:{s:3:"all";a:1:{s:9:"style.css";s:24:"themes/garland/style.css";}s:5:"print";a:1:{s:9:"print.css";s:24:"themes/garland/print.css";}}s:6:"engine";s:11:"phptemplate";}}','drupal_get_form','a:2:{i:0;s:21:"system_theme_settings";i:1;s:7:"garland";}','','15','4','1','admin/appearance/settings','admin/appearance','Garland','t','','','a:0:{}','132','','','0','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/appearance/settings/global','','','user_access','a:1:{i:0;s:17:"administer themes";}','drupal_get_form','a:1:{i:0;s:21:"system_theme_settings";}','','15','4','1','admin/appearance/settings','admin/appearance','Global settings','t','','','a:0:{}','140','','','-1','modules/system/system.admin.inc'),('admin/appearance/settings/seven','','','_system_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:23:"themes/seven/seven.info";s:4:"name";s:5:"seven";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:19:{s:4:"name";s:5:"Seven";s:11:"description";s:65:"A simple one-column, tableless, fluid width administration theme.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:9:"reset.css";s:22:"themes/seven/reset.css";s:9:"style.css";s:22:"themes/seven/style.css";}}s:8:"settings";a:1:{s:20:"shortcut_module_link";s:1:"1";}s:7:"regions";a:8:{s:7:"content";s:7:"Content";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:13:"sidebar_first";s:13:"First sidebar";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:14:"regions_hidden";a:3:{i:0;s:13:"sidebar_first";i:1;s:8:"page_top";i:2;s:11:"page_bottom";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:27:"themes/seven/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:9:"reset.css";s:22:"themes/seven/reset.css";s:9:"style.css";s:22:"themes/seven/style.css";}}s:6:"engine";s:11:"phptemplate";}}','drupal_get_form','a:2:{i:0;s:21:"system_theme_settings";i:1;s:5:"seven";}','','15','4','1','admin/appearance/settings','admin/appearance','Seven','t','','','a:0:{}','132','','','0','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/appearance/settings/skeletontheme','','','_system_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:49:"sites/all/themes/skeletontheme/skeletontheme.info";s:4:"name";s:13:"skeletontheme";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:18:{s:4:"name";s:8:"Skeleton";s:11:"description";s:361:"Skeleton is a powerful, clean, responsive theme ported to Drupal by <a href="http://www.morethanthemes.com/" target="_blank">More Than (just) Themes</a>. If you like this theme, we encourage you to try also our other <a href="http://www.morethanthemes.com" target="_blank">Premium</a> and <a href="http://drupalizing.com" target="_blank">Free</a> Drupal themes.";s:7:"version";s:7:"7.x-1.4";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:3:"all";a:5:{s:16:"css/skeleton.css";s:47:"sites/all/themes/skeletontheme/css/skeleton.css";s:13:"css/style.css";s:44:"sites/all/themes/skeletontheme/css/style.css";s:15:"css/buttons.css";s:46:"sites/all/themes/skeletontheme/css/buttons.css";s:14:"css/layout.css";s:45:"sites/all/themes/skeletontheme/css/layout.css";s:16:"color/colors.css";s:47:"sites/all/themes/skeletontheme/color/colors.css";}}s:7:"regions";a:20:{s:15:"header_top_left";s:15:"Header top left";s:16:"header_top_right";s:16:"Header top right";s:12:"header_right";s:12:"Header right";s:6:"header";s:6:"Header";s:11:"highlighted";s:11:"Highlighted";s:7:"content";s:7:"Content";s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:13:"featured_left";s:13:"Featured left";s:14:"featured_right";s:14:"Featured right";s:12:"footer_first";s:12:"Footer first";s:13:"footer_second";s:13:"Footer second";s:12:"footer_third";s:12:"Footer third";s:6:"footer";s:6:"Footer";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"settings";a:3:{s:21:"responsive_menu_state";s:1:"1";s:27:"responsive_menu_switchwidth";s:3:"760";s:29:"responsive_menu_topoptiontext";s:13:"Select a page";}s:7:"project";s:13:"skeletontheme";s:9:"datestamp";s:10:"1396987453";s:6:"engine";s:11:"phptemplate";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:45:"sites/all/themes/skeletontheme/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:3:"all";a:5:{s:16:"css/skeleton.css";s:47:"sites/all/themes/skeletontheme/css/skeleton.css";s:13:"css/style.css";s:44:"sites/all/themes/skeletontheme/css/style.css";s:15:"css/buttons.css";s:46:"sites/all/themes/skeletontheme/css/buttons.css";s:14:"css/layout.css";s:45:"sites/all/themes/skeletontheme/css/layout.css";s:16:"color/colors.css";s:47:"sites/all/themes/skeletontheme/color/colors.css";}}s:6:"engine";s:11:"phptemplate";}}','drupal_get_form','a:2:{i:0;s:21:"system_theme_settings";i:1;s:13:"skeletontheme";}','','15','4','1','admin/appearance/settings','admin/appearance','Skeleton','t','','','a:0:{}','132','','','0','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/appearance/settings/stark','','','_system_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:23:"themes/stark/stark.info";s:4:"name";s:5:"stark";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:18:{s:4:"name";s:5:"Stark";s:11:"description";s:208:"This theme demonstrates Drupal''s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal''s default code, see the <a href="http://drupal.org/theme-guide">Theming Guide</a>.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:10:"layout.css";s:23:"themes/stark/layout.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:7:"regions";a:12:{s:13:"sidebar_first";s:12:"Left sidebar";s:14:"sidebar_second";s:13:"Right sidebar";s:7:"content";s:7:"Content";s:6:"header";s:6:"Header";s:6:"footer";s:6:"Footer";s:11:"highlighted";s:11:"Highlighted";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:27:"themes/stark/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:10:"layout.css";s:23:"themes/stark/layout.css";}}s:6:"engine";s:11:"phptemplate";}}','drupal_get_form','a:2:{i:0;s:21:"system_theme_settings";i:1;s:5:"stark";}','','15','4','1','admin/appearance/settings','admin/appearance','Stark','t','','','a:0:{}','132','','','0','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/compact','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_compact_page','a:0:{}','','3','2','0','','admin/compact','Compact mode','t','','','a:0:{}','0','','','0','modules/system/system.admin.inc'),('admin/config','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_config_page','a:0:{}','','3','2','0','','admin/config','Configuration','t','','','a:0:{}','6','Administer settings.','','0','modules/system/system.admin.inc'),('admin/config/administration','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','7','3','0','','admin/config/administration','Administration','t','','','a:0:{}','6','Administration tools.','','0','modules/system/system.admin.inc'),('admin/config/administration/admin_menu','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:25:"admin_menu_theme_settings";}','','15','4','0','','admin/config/administration/admin_menu','Administration menu','t','','','a:0:{}','6','Adjust administration menu settings.','','0','sites/all/modules/contrib/admin_menu/admin_menu.inc'),('admin/config/content','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','7','3','0','','admin/config/content','Content authoring','t','','','a:0:{}','6','Settings related to formatting and authoring content.','left','-15','modules/system/system.admin.inc'),('admin/config/content/entityform','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:19:"entityform_settings";}','','15','4','0','','admin/config/content/entityform','Entityform Settings','t','','','a:0:{}','6','','','0','sites/all/modules/contrib/entityform/entityform_type.admin.inc'),('admin/config/content/formats','','','user_access','a:1:{i:0;s:18:"administer filters";}','drupal_get_form','a:1:{i:0;s:21:"filter_admin_overview";}','','15','4','0','','admin/config/content/formats','Text formats','t','','','a:0:{}','6','Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.','','0','modules/filter/filter.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/content/formats/%','a:1:{i:4;s:18:"filter_format_load";}','','user_access','a:1:{i:0;s:18:"administer filters";}','filter_admin_format_page','a:1:{i:0;i:4;}','','30','5','0','','admin/config/content/formats/%','','filter_admin_format_title','a:1:{i:0;i:4;}','','a:0:{}','6','','','0','modules/filter/filter.admin.inc'),('admin/config/content/formats/%/disable','a:1:{i:4;s:18:"filter_format_load";}','','_filter_disable_format_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:20:"filter_admin_disable";i:1;i:4;}','','61','6','0','','admin/config/content/formats/%/disable','Disable text format','t','','','a:0:{}','6','','','0','modules/filter/filter.admin.inc'),('admin/config/content/formats/add','','','user_access','a:1:{i:0;s:18:"administer filters";}','filter_admin_format_page','a:0:{}','','31','5','1','admin/config/content/formats','admin/config/content/formats','Add text format','t','','','a:0:{}','388','','','1','modules/filter/filter.admin.inc'),('admin/config/content/formats/list','','','user_access','a:1:{i:0;s:18:"administer filters";}','drupal_get_form','a:1:{i:0;s:21:"filter_admin_overview";}','','31','5','1','admin/config/content/formats','admin/config/content/formats','List','t','','','a:0:{}','140','','','0','modules/filter/filter.admin.inc'),('admin/config/content/wysiwyg','','','user_access','a:1:{i:0;s:18:"administer filters";}','drupal_get_form','a:1:{i:0;s:24:"wysiwyg_profile_overview";}','','15','4','0','','admin/config/content/wysiwyg','Wysiwyg profiles','t','','','a:0:{}','6','Configure client-side editors.','','0','sites/all/modules/contrib/wysiwyg/wysiwyg.admin.inc'),('admin/config/content/wysiwyg/list','','','user_access','a:1:{i:0;s:18:"administer filters";}','drupal_get_form','a:1:{i:0;s:24:"wysiwyg_profile_overview";}','','31','5','1','admin/config/content/wysiwyg','admin/config/content/wysiwyg','List','t','','','a:0:{}','140','','','-10','sites/all/modules/contrib/wysiwyg/wysiwyg.admin.inc'),('admin/config/content/wysiwyg/profile/%','a:1:{i:5;s:29:"wysiwyg_ui_profile_cache_load";}','','user_access','a:1:{i:0;s:18:"administer filters";}','drupal_get_form','a:2:{i:0;s:20:"wysiwyg_profile_form";i:1;i:5;}','','62','6','0','','admin/config/content/wysiwyg/profile/%','','wysiwyg_admin_profile_title','a:1:{i:0;i:5;}','','a:0:{}','6','','','0','sites/all/modules/contrib/wysiwyg/wysiwyg.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/content/wysiwyg/profile/%/break-lock','a:1:{i:5;s:29:"wysiwyg_ui_profile_cache_load";}','','user_access','a:1:{i:0;s:18:"administer filters";}','drupal_get_form','a:2:{i:0;s:34:"wysiwyg_profile_break_lock_confirm";i:1;i:5;}','','125','7','0','','admin/config/content/wysiwyg/profile/%/break-lock','Break lock','t','','','a:0:{}','4','','','0','sites/all/modules/contrib/wysiwyg/wysiwyg.admin.inc'),('admin/config/content/wysiwyg/profile/%/delete','a:1:{i:5;s:29:"wysiwyg_ui_profile_cache_load";}','','user_access','a:1:{i:0;s:18:"administer filters";}','drupal_get_form','a:2:{i:0;s:30:"wysiwyg_profile_delete_confirm";i:1;i:5;}','','125','7','1','admin/config/content/wysiwyg/profile/%','admin/config/content/wysiwyg/profile/%','Remove','t','','','a:0:{}','132','','','10','sites/all/modules/contrib/wysiwyg/wysiwyg.admin.inc'),('admin/config/content/wysiwyg/profile/%/edit','a:1:{i:5;s:29:"wysiwyg_ui_profile_cache_load";}','','user_access','a:1:{i:0;s:18:"administer filters";}','drupal_get_form','a:2:{i:0;s:20:"wysiwyg_profile_form";i:1;i:5;}','','125','7','1','admin/config/content/wysiwyg/profile/%','admin/config/content/wysiwyg/profile/%','Edit','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/wysiwyg/wysiwyg.admin.inc'),('admin/config/date','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','system_admin_menu_block_page','a:0:{}','','7','3','0','','admin/config/date','Date API','t','','','a:0:{}','6','Settings for modules the use the Date API.','left','-10','modules/system/system.admin.inc'),('admin/config/date/calendar','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:23:"calendar_admin_settings";}','','15','4','0','','admin/config/date/calendar','Calendar','t','','','a:0:{}','6','Calendar administration.','','0',''),('admin/config/date/date_popup','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:19:"date_popup_settings";}','','15','4','0','','admin/config/date/date_popup','Date Popup','t','','','a:0:{}','6','Configure the Date Popup settings.','','0','');
INSERT INTO `menu_router` VALUES ('admin/config/date/tools','','','user_access','a:1:{i:0;s:21:"administer date tools";}','date_tools_page','a:0:{}','','15','4','0','','admin/config/date/tools','Date Tools','t','','','a:0:{}','6','Date Wizard and other tools to manage and create dates and calendars. ','','0',''),('admin/config/date/tools/about','','','user_access','a:1:{i:0;s:21:"administer date tools";}','date_tools_page','a:0:{}','','31','5','1','admin/config/date/tools','admin/config/date/tools','About','t','','','a:0:{}','140','Date Wizard and other tools to manage and create dates and calendars. ','','-5',''),('admin/config/date/tools/date_wizard','','','user_access','a:1:{i:0;s:21:"administer date tools";}','drupal_get_form','a:1:{i:0;s:22:"date_tools_wizard_form";}','','31','5','1','admin/config/date/tools','admin/config/date/tools','Date wizard','t','','','a:0:{}','132','Easy creation of date content types and calendars. ','','1','sites/all/modules/contrib/date/date_tools/date_tools.wizard.inc'),('admin/config/development','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','7','3','0','','admin/config/development','Development','t','','','a:0:{}','6','Development tools.','right','-10','modules/system/system.admin.inc'),('admin/config/development/devel','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:20:"devel_admin_settings";}','','15','4','0','','admin/config/development/devel','Devel settings','t','','','a:0:{}','6','Helper functions, pages, and blocks to assist Drupal developers. The devel blocks can be managed via the <a href="/admin/structure/block">block administration</a> page.','','0','sites/all/modules/contrib/devel/devel.admin.inc'),('admin/config/development/jquery_update','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:27:"jquery_update_settings_form";}','','15','4','0','','admin/config/development/jquery_update','jQuery update','t','','','a:0:{}','6','Configure settings related to the jQuery upgrade, the library path and compression.','','0','');
INSERT INTO `menu_router` VALUES ('admin/config/development/logging','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:23:"system_logging_settings";}','','15','4','0','','admin/config/development/logging','Logging and errors','t','','','a:0:{}','6','Settings for logging and alerts modules. Various modules can route Drupal''s system events to different destinations, such as syslog, database, email, etc.','','-15','modules/system/system.admin.inc'),('admin/config/development/maintenance','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:28:"system_site_maintenance_mode";}','','15','4','0','','admin/config/development/maintenance','Maintenance mode','t','','','a:0:{}','6','Take the site offline for maintenance or bring it back online.','','-10','modules/system/system.admin.inc'),('admin/config/development/performance','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:27:"system_performance_settings";}','','15','4','0','','admin/config/development/performance','Performance','t','','','a:0:{}','6','Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.','','-20','modules/system/system.admin.inc'),('admin/config/media','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','7','3','0','','admin/config/media','Media','t','','','a:0:{}','6','Media tools.','left','-10','modules/system/system.admin.inc'),('admin/config/media/file-system','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:27:"system_file_system_settings";}','','15','4','0','','admin/config/media/file-system','File system','t','','','a:0:{}','6','Tell Drupal where to store uploaded files and how they are accessed.','','-10','modules/system/system.admin.inc'),('admin/config/media/image-styles','','','user_access','a:1:{i:0;s:23:"administer image styles";}','image_style_list','a:0:{}','','15','4','0','','admin/config/media/image-styles','Image styles','t','','','a:0:{}','6','Configure styles that can be used for resizing or adjusting images on display.','','0','modules/image/image.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/media/image-styles/add','','','user_access','a:1:{i:0;s:23:"administer image styles";}','drupal_get_form','a:1:{i:0;s:20:"image_style_add_form";}','','31','5','1','admin/config/media/image-styles','admin/config/media/image-styles','Add style','t','','','a:0:{}','388','Add a new image style.','','2','modules/image/image.admin.inc'),('admin/config/media/image-styles/delete/%','a:1:{i:5;a:1:{s:16:"image_style_load";a:2:{i:0;N;i:1;s:1:"1";}}}','','user_access','a:1:{i:0;s:23:"administer image styles";}','drupal_get_form','a:2:{i:0;s:23:"image_style_delete_form";i:1;i:5;}','','62','6','0','','admin/config/media/image-styles/delete/%','Delete style','t','','','a:0:{}','6','Delete an image style.','','0','modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%','a:1:{i:5;s:16:"image_style_load";}','','user_access','a:1:{i:0;s:23:"administer image styles";}','drupal_get_form','a:2:{i:0;s:16:"image_style_form";i:1;i:5;}','','62','6','0','','admin/config/media/image-styles/edit/%','Edit style','t','','','a:0:{}','6','Configure an image style.','','0','modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%/add/%','a:2:{i:5;a:1:{s:16:"image_style_load";a:1:{i:0;i:5;}}i:7;a:1:{s:28:"image_effect_definition_load";a:1:{i:0;i:5;}}}','','user_access','a:1:{i:0;s:23:"administer image styles";}','drupal_get_form','a:3:{i:0;s:17:"image_effect_form";i:1;i:5;i:2;i:7;}','','250','8','0','','admin/config/media/image-styles/edit/%/add/%','Add image effect','t','','','a:0:{}','6','Add a new effect to a style.','','0','modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%/effects/%','a:2:{i:5;a:1:{s:16:"image_style_load";a:2:{i:0;i:5;i:1;s:1:"3";}}i:7;a:1:{s:17:"image_effect_load";a:2:{i:0;i:5;i:1;s:1:"3";}}}','','user_access','a:1:{i:0;s:23:"administer image styles";}','drupal_get_form','a:3:{i:0;s:17:"image_effect_form";i:1;i:5;i:2;i:7;}','','250','8','0','','admin/config/media/image-styles/edit/%/effects/%','Edit image effect','t','','','a:0:{}','6','Edit an existing effect within a style.','','0','modules/image/image.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/media/image-styles/edit/%/effects/%/delete','a:2:{i:5;a:1:{s:16:"image_style_load";a:2:{i:0;i:5;i:1;s:1:"3";}}i:7;a:1:{s:17:"image_effect_load";a:2:{i:0;i:5;i:1;s:1:"3";}}}','','user_access','a:1:{i:0;s:23:"administer image styles";}','drupal_get_form','a:3:{i:0;s:24:"image_effect_delete_form";i:1;i:5;i:2;i:7;}','','501','9','0','','admin/config/media/image-styles/edit/%/effects/%/delete','Delete image effect','t','','','a:0:{}','6','Delete an existing effect from a style.','','0','modules/image/image.admin.inc'),('admin/config/media/image-styles/list','','','user_access','a:1:{i:0;s:23:"administer image styles";}','image_style_list','a:0:{}','','31','5','1','admin/config/media/image-styles','admin/config/media/image-styles','List','t','','','a:0:{}','140','List the current image styles on the site.','','1','modules/image/image.admin.inc'),('admin/config/media/image-styles/revert/%','a:1:{i:5;a:1:{s:16:"image_style_load";a:2:{i:0;N;i:1;s:1:"2";}}}','','user_access','a:1:{i:0;s:23:"administer image styles";}','drupal_get_form','a:2:{i:0;s:23:"image_style_revert_form";i:1;i:5;}','','62','6','0','','admin/config/media/image-styles/revert/%','Revert style','t','','','a:0:{}','6','Revert an image style.','','0','modules/image/image.admin.inc'),('admin/config/media/image-toolkit','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:29:"system_image_toolkit_settings";}','','15','4','0','','admin/config/media/image-toolkit','Image toolkit','t','','','a:0:{}','6','Choose which image toolkit to use if you have installed optional toolkits.','','20','modules/system/system.admin.inc'),('admin/config/media/imce','','','user_access','a:1:{i:0;s:15:"administer imce";}','imce_admin','a:0:{}','','15','4','0','','admin/config/media/imce','IMCE','t','','','a:0:{}','6','Control how your image/file browser works.','','0','sites/all/modules/contrib/imce/inc/imce.admin.inc'),('admin/config/media/imce/profile','','','user_access','a:1:{i:0;s:15:"administer imce";}','imce_profile_operations','a:0:{}','','31','5','0','','admin/config/media/imce/profile','Add new profile','t','','','a:0:{}','4','','','0','sites/all/modules/contrib/imce/inc/imce.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/people','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','7','3','0','','admin/config/people','People','t','','','a:0:{}','6','Configure user accounts.','left','-20','modules/system/system.admin.inc'),('admin/config/people/accounts','','','user_access','a:1:{i:0;s:16:"administer users";}','drupal_get_form','a:1:{i:0;s:19:"user_admin_settings";}','','15','4','0','','admin/config/people/accounts','Account settings','t','','','a:0:{}','6','Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.','','-10','modules/user/user.admin.inc'),('admin/config/people/accounts/display','','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:16:"administer users";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:4:"user";i:2;s:4:"user";i:3;s:7:"default";}','','31','5','1','admin/config/people/accounts','admin/config/people/accounts','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:"user";i:1;s:4:"user";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:16:"administer users";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:4:"user";i:2;s:4:"user";i:3;s:7:"default";}','','63','6','1','admin/config/people/accounts/display','admin/config/people/accounts','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:"user";i:1;s:4:"user";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:16:"administer users";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:4:"user";i:2;s:4:"user";i:3;s:4:"full";}','','63','6','1','admin/config/people/accounts/display','admin/config/people/accounts','User account','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/people/accounts/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:"user";i:1;s:4:"user";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:16:"administer users";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:4:"user";i:2;s:4:"user";i:3;s:5:"token";}','','63','6','1','admin/config/people/accounts/display','admin/config/people/accounts','Tokens','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields','','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:16:"administer users";}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:4:"user";i:2;s:4:"user";}','','31','5','1','admin/config/people/accounts','admin/config/people/accounts','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%','a:1:{i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:4:"user";i:1;s:4:"user";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:16:"administer users";}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:5;}','','62','6','0','','admin/config/people/accounts/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/delete','a:1:{i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:4:"user";i:1;s:4:"user";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:16:"administer users";}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:5;}','','125','7','1','admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/edit','a:1:{i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:4:"user";i:1;s:4:"user";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:16:"administer users";}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:5;}','','125','7','1','admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/people/accounts/fields/%/field-settings','a:1:{i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:4:"user";i:1;s:4:"user";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:16:"administer users";}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:5;}','','125','7','1','admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/widget-type','a:1:{i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:4:"user";i:1;s:4:"user";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:16:"administer users";}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:5;}','','125','7','1','admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/groups/%/delete','a:1:{i:5;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:4:"user";i:1;s:4:"user";i:2;s:1:"0";i:3;s:4:"%map";}}}','','user_access','a:1:{i:0;s:16:"administer users";}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:5;}','','125','7','0','','admin/config/people/accounts/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/config/people/accounts/groups/%/enable','a:1:{i:5;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:4:"user";i:1;s:4:"user";i:2;s:1:"0";i:3;s:4:"%map";}}}','','user_access','a:1:{i:0;s:16:"administer users";}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:5;}','','125','7','0','','admin/config/people/accounts/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/config/people/accounts/settings','','','user_access','a:1:{i:0;s:16:"administer users";}','drupal_get_form','a:1:{i:0;s:19:"user_admin_settings";}','','31','5','1','admin/config/people/accounts','admin/config/people/accounts','Settings','t','','','a:0:{}','140','','','-10','modules/user/user.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/people/ip-blocking','','','user_access','a:1:{i:0;s:18:"block IP addresses";}','system_ip_blocking','a:0:{}','','15','4','0','','admin/config/people/ip-blocking','IP address blocking','t','','','a:0:{}','6','Manage blocked IP addresses.','','10','modules/system/system.admin.inc'),('admin/config/people/ip-blocking/delete/%','a:1:{i:5;s:15:"blocked_ip_load";}','','user_access','a:1:{i:0;s:18:"block IP addresses";}','drupal_get_form','a:2:{i:0;s:25:"system_ip_blocking_delete";i:1;i:5;}','','62','6','0','','admin/config/people/ip-blocking/delete/%','Delete IP address','t','','','a:0:{}','6','','','0','modules/system/system.admin.inc'),('admin/config/people/terms_of_use','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:27:"terms_of_use_admin_settings";}','','15','4','0','','admin/config/people/terms_of_use','Terms of Use','t','','','a:0:{}','6','Add Terms of Use to the registration page.','','0','sites/all/modules/contrib/terms_of_use/terms_of_use.admin.inc'),('admin/config/regional','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','7','3','0','','admin/config/regional','Regional and language','t','','','a:0:{}','6','Regional settings, localization and translation.','left','-5','modules/system/system.admin.inc'),('admin/config/regional/date-time','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:25:"system_date_time_settings";}','','15','4','0','','admin/config/regional/date-time','Date and time','t','','','a:0:{}','6','Configure display formats for date and time.','','-15','modules/system/system.admin.inc'),('admin/config/regional/date-time/date-views','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:19:"date_views_settings";}','','31','5','1','admin/config/regional/date-time','admin/config/regional/date-time','Date views','t','','','a:0:{}','132','Configure settings for date views.','','0','');
INSERT INTO `menu_router` VALUES ('admin/config/regional/date-time/formats','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','system_date_time_formats','a:0:{}','','31','5','1','admin/config/regional/date-time','admin/config/regional/date-time','Formats','t','','','a:0:{}','132','Configure display format strings for date and time.','','-9','modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/%/delete','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:2:{i:0;s:30:"system_date_delete_format_form";i:1;i:5;}','','125','7','0','','admin/config/regional/date-time/formats/%/delete','Delete date format','t','','','a:0:{}','6','Allow users to delete a configured date format.','','0','modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/%/edit','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:2:{i:0;s:34:"system_configure_date_formats_form";i:1;i:5;}','','125','7','0','','admin/config/regional/date-time/formats/%/edit','Edit date format','t','','','a:0:{}','6','Allow users to edit a configured date format.','','0','modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/add','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:34:"system_configure_date_formats_form";}','','63','6','1','admin/config/regional/date-time/formats','admin/config/regional/date-time','Add format','t','','','a:0:{}','388','Allow users to add additional date formats.','','-10','modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/lookup','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','system_date_time_lookup','a:0:{}','','63','6','0','','admin/config/regional/date-time/formats/lookup','Date and time lookup','t','','','a:0:{}','0','','','0','modules/system/system.admin.inc'),('admin/config/regional/date-time/types','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:25:"system_date_time_settings";}','','31','5','1','admin/config/regional/date-time','admin/config/regional/date-time','Types','t','','','a:0:{}','140','Configure display formats for date and time.','','-10','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/regional/date-time/types/%/delete','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:2:{i:0;s:35:"system_delete_date_format_type_form";i:1;i:5;}','','125','7','0','','admin/config/regional/date-time/types/%/delete','Delete date type','t','','','a:0:{}','6','Allow users to delete a configured date type.','','0','modules/system/system.admin.inc'),('admin/config/regional/date-time/types/add','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:32:"system_add_date_format_type_form";}','','63','6','1','admin/config/regional/date-time/types','admin/config/regional/date-time','Add date type','t','','','a:0:{}','388','Add new date type.','','-10','modules/system/system.admin.inc'),('admin/config/regional/settings','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:24:"system_regional_settings";}','','15','4','0','','admin/config/regional/settings','Regional settings','t','','','a:0:{}','6','Settings for the site''s default time zone and country.','','-20','modules/system/system.admin.inc'),('admin/config/regional/stringoverrides','','','user_access','a:1:{i:0;s:27:"administer string overrides";}','drupal_get_form','a:1:{i:0;s:21:"stringoverrides_admin";}','','15','4','0','','admin/config/regional/stringoverrides','String overrides','t','','','a:0:{}','6','Provides a quick and easy way of replacing text on the site.','','0','sites/all/modules/contrib/stringoverrides/stringoverrides.admin.inc'),('admin/config/regional/stringoverrides/manage/en','','','user_access','a:1:{i:0;s:27:"administer string overrides";}','drupal_get_form','a:2:{i:0;s:21:"stringoverrides_admin";i:1;s:2:"en";}','','63','6','1','admin/config/regional/stringoverrides','admin/config/regional/stringoverrides','Overrides','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/stringoverrides/stringoverrides.admin.inc'),('admin/config/search','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','7','3','0','','admin/config/search','Search and metadata','t','','','a:0:{}','6','Local site search, metadata and SEO.','left','-10','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/search/clean-urls','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:25:"system_clean_url_settings";}','','15','4','0','','admin/config/search/clean-urls','Clean URLs','t','','','a:0:{}','6','Enable or disable clean URLs for your site.','','5','modules/system/system.admin.inc'),('admin/config/search/clean-urls/check','','','1','a:0:{}','drupal_json_output','a:1:{i:0;a:1:{s:6:"status";b:1;}}','','31','5','0','','admin/config/search/clean-urls/check','Clean URL check','t','','','a:0:{}','0','','','0','modules/system/system.admin.inc'),('admin/config/search/path','','','user_access','a:1:{i:0;s:22:"administer url aliases";}','path_admin_overview','a:0:{}','','15','4','0','','admin/config/search/path','URL aliases','t','','','a:0:{}','6','Change your site''s URL paths by aliasing them.','','-5','modules/path/path.admin.inc'),('admin/config/search/path/add','','','user_access','a:1:{i:0;s:22:"administer url aliases";}','path_admin_edit','a:0:{}','','31','5','1','admin/config/search/path','admin/config/search/path','Add alias','t','','','a:0:{}','388','','','0','modules/path/path.admin.inc'),('admin/config/search/path/delete/%','a:1:{i:5;s:9:"path_load";}','','user_access','a:1:{i:0;s:22:"administer url aliases";}','drupal_get_form','a:2:{i:0;s:25:"path_admin_delete_confirm";i:1;i:5;}','','62','6','0','','admin/config/search/path/delete/%','Delete alias','t','','','a:0:{}','6','','','0','modules/path/path.admin.inc'),('admin/config/search/path/delete_bulk','','','user_access','a:1:{i:0;s:22:"administer url aliases";}','drupal_get_form','a:1:{i:0;s:21:"pathauto_admin_delete";}','','31','5','1','admin/config/search/path','admin/config/search/path','Delete aliases','t','','','a:0:{}','132','','','40','sites/all/modules/contrib/pathauto/pathauto.admin.inc'),('admin/config/search/path/edit/%','a:1:{i:5;s:9:"path_load";}','','user_access','a:1:{i:0;s:22:"administer url aliases";}','path_admin_edit','a:1:{i:0;i:5;}','','62','6','0','','admin/config/search/path/edit/%','Edit alias','t','','','a:0:{}','6','','','0','modules/path/path.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/search/path/list','','','user_access','a:1:{i:0;s:22:"administer url aliases";}','path_admin_overview','a:0:{}','','31','5','1','admin/config/search/path','admin/config/search/path','List','t','','','a:0:{}','140','','','-10','modules/path/path.admin.inc'),('admin/config/search/path/patterns','','','user_access','a:1:{i:0;s:19:"administer pathauto";}','drupal_get_form','a:1:{i:0;s:22:"pathauto_patterns_form";}','','31','5','1','admin/config/search/path','admin/config/search/path','Patterns','t','','','a:0:{}','132','','','10','sites/all/modules/contrib/pathauto/pathauto.admin.inc'),('admin/config/search/path/settings','','','user_access','a:1:{i:0;s:19:"administer pathauto";}','drupal_get_form','a:1:{i:0;s:22:"pathauto_settings_form";}','','31','5','1','admin/config/search/path','admin/config/search/path','Settings','t','','','a:0:{}','132','','','20','sites/all/modules/contrib/pathauto/pathauto.admin.inc'),('admin/config/search/path/update_bulk','','','user_access','a:1:{i:0;s:22:"administer url aliases";}','drupal_get_form','a:1:{i:0;s:25:"pathauto_bulk_update_form";}','','31','5','1','admin/config/search/path','admin/config/search/path','Bulk generate','t','','','a:0:{}','132','','','30','sites/all/modules/contrib/pathauto/pathauto.admin.inc'),('admin/config/search/settings','','','user_access','a:1:{i:0;s:17:"administer search";}','drupal_get_form','a:1:{i:0;s:21:"search_admin_settings";}','','15','4','0','','admin/config/search/settings','Search settings','t','','','a:0:{}','6','Configure relevance settings for search and other indexing options.','','-10','modules/search/search.admin.inc'),('admin/config/search/settings/reindex','','','user_access','a:1:{i:0;s:17:"administer search";}','drupal_get_form','a:1:{i:0;s:22:"search_reindex_confirm";}','','31','5','0','','admin/config/search/settings/reindex','Clear index','t','','','a:0:{}','4','','','0','modules/search/search.admin.inc'),('admin/config/services','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','7','3','0','','admin/config/services','Web services','t','','','a:0:{}','6','Tools related to web services.','right','0','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/services/rss-publishing','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:25:"system_rss_feeds_settings";}','','15','4','0','','admin/config/services/rss-publishing','RSS publishing','t','','','a:0:{}','6','Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.','','0','modules/system/system.admin.inc'),('admin/config/system','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','7','3','0','','admin/config/system','System','t','','','a:0:{}','6','General system related configuration.','right','-20','modules/system/system.admin.inc'),('admin/config/system/actions','','','user_access','a:1:{i:0;s:18:"administer actions";}','system_actions_manage','a:0:{}','','15','4','0','','admin/config/system/actions','Actions','t','','','a:0:{}','6','Manage the actions defined for your site.','','0','modules/system/system.admin.inc'),('admin/config/system/actions/configure','','','user_access','a:1:{i:0;s:18:"administer actions";}','drupal_get_form','a:1:{i:0;s:24:"system_actions_configure";}','','31','5','0','','admin/config/system/actions/configure','Configure an advanced action','t','','','a:0:{}','4','','','0','modules/system/system.admin.inc'),('admin/config/system/actions/delete/%','a:1:{i:5;s:12:"actions_load";}','','user_access','a:1:{i:0;s:18:"administer actions";}','drupal_get_form','a:2:{i:0;s:26:"system_actions_delete_form";i:1;i:5;}','','62','6','0','','admin/config/system/actions/delete/%','Delete action','t','','','a:0:{}','6','Delete an action.','','0','modules/system/system.admin.inc'),('admin/config/system/actions/manage','','','user_access','a:1:{i:0;s:18:"administer actions";}','system_actions_manage','a:0:{}','','31','5','1','admin/config/system/actions','admin/config/system/actions','Manage actions','t','','','a:0:{}','140','Manage the actions defined for your site.','','-2','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/system/actions/orphan','','','user_access','a:1:{i:0;s:18:"administer actions";}','system_actions_remove_orphans','a:0:{}','','31','5','0','','admin/config/system/actions/orphan','Remove orphans','t','','','a:0:{}','0','','','0','modules/system/system.admin.inc'),('admin/config/system/backup_migrate','','','user_access','a:1:{i:0;s:25:"access backup and migrate";}','backup_migrate_menu_callback','a:3:{i:0;s:0:"";i:1;s:37:"backup_migrate_ui_manual_backup_quick";i:2;b:1;}','','15','4','0','','admin/config/system/backup_migrate','Backup and Migrate','t','','','a:0:{}','6','Backup/restore your database and files or migrate data to or from another Drupal site.','','0',''),('admin/config/system/backup_migrate/backups','','','user_access','a:1:{i:0;s:19:"access backup files";}','backup_migrate_menu_callback','a:3:{i:0;s:0:"";i:1;s:31:"backup_migrate_ui_saved_backups";i:2;b:1;}','','31','5','1','admin/config/system/backup_migrate','admin/config/system/backup_migrate','Saved Backups','t','','','a:0:{}','132','Previously created backups','','2',''),('admin/config/system/backup_migrate/export','','','user_access','a:1:{i:0;s:25:"access backup and migrate";}','backup_migrate_menu_callback','a:3:{i:0;s:0:"";i:1;s:37:"backup_migrate_ui_manual_backup_quick";i:2;b:1;}','','31','5','1','admin/config/system/backup_migrate','admin/config/system/backup_migrate','Backup','t','','','a:0:{}','140','Backup the database.','','0',''),('admin/config/system/backup_migrate/export/advanced','','','user_access','a:1:{i:0;s:14:"perform backup";}','backup_migrate_menu_callback','a:3:{i:0;s:0:"";i:1;s:40:"backup_migrate_ui_manual_backup_advanced";i:2;b:1;}','','63','6','1','admin/config/system/backup_migrate/export','admin/config/system/backup_migrate','Advanced Backup','t','','','a:0:{}','132','Backup the database.','','1',''),('admin/config/system/backup_migrate/export/quick','','','user_access','a:1:{i:0;s:14:"perform backup";}','backup_migrate_menu_callback','a:3:{i:0;s:0:"";i:1;s:37:"backup_migrate_ui_manual_backup_quick";i:2;b:1;}','','63','6','1','admin/config/system/backup_migrate/export','admin/config/system/backup_migrate','Quick Backup','t','','','a:0:{}','140','Backup the database.','','0','');
INSERT INTO `menu_router` VALUES ('admin/config/system/backup_migrate/nodesquirrel','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:2:{i:0;s:25:"destinations.nodesquirrel";i:1;s:36:"backup_migrate_nodesquirrel_settings";}','','31','5','1','admin/config/system/backup_migrate','admin/config/system/backup_migrate','NodeSquirrel','t','','','a:0:{}','132','','','10',''),('admin/config/system/backup_migrate/restore','','','user_access','a:1:{i:0;s:19:"restore from backup";}','backup_migrate_menu_callback','a:3:{i:0;s:0:"";i:1;s:32:"backup_migrate_ui_manual_restore";i:2;b:1;}','','31','5','1','admin/config/system/backup_migrate','admin/config/system/backup_migrate','Restore','t','','','a:0:{}','132','Restore the database from a previous backup','','1',''),('admin/config/system/backup_migrate/schedule','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:27:"backup_migrate_crud_ui_list";i:2;b:1;i:3;s:8:"schedule";}','','31','5','1','admin/config/system/backup_migrate','admin/config/system/backup_migrate','Schedules','t','','','a:0:{}','132','','','2',''),('admin/config/system/backup_migrate/schedule/add','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:29:"backup_migrate_crud_ui_create";i:2;b:1;i:3;s:8:"schedule";}','','63','6','1','admin/config/system/backup_migrate/schedule','admin/config/system/backup_migrate','Add !type','t','a:1:{s:5:"!type";s:8:"Schedule";}','','a:0:{}','388','','','2',''),('admin/config/system/backup_migrate/schedule/delete','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:29:"backup_migrate_crud_ui_delete";i:2;b:1;i:3;s:8:"schedule";}','','63','6','0','','admin/config/system/backup_migrate/schedule/delete','Delete !type','t','a:1:{s:5:"!type";s:8:"Schedule";}','','a:0:{}','0','','','0',''),('admin/config/system/backup_migrate/schedule/edit','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:27:"backup_migrate_crud_ui_edit";i:2;b:1;i:3;s:8:"schedule";}','','63','6','0','','admin/config/system/backup_migrate/schedule/edit','Edit !type','t','a:1:{s:5:"!type";s:8:"Schedule";}','','a:0:{}','0','','','0','');
INSERT INTO `menu_router` VALUES ('admin/config/system/backup_migrate/schedule/export','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:29:"backup_migrate_crud_ui_export";i:2;b:1;i:3;s:8:"schedule";}','','63','6','0','','admin/config/system/backup_migrate/schedule/export','Export !type','t','a:1:{s:5:"!type";s:8:"Schedule";}','','a:0:{}','0','','','0',''),('admin/config/system/backup_migrate/schedule/list','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:27:"backup_migrate_crud_ui_list";i:2;b:1;i:3;s:8:"schedule";}','','63','6','1','admin/config/system/backup_migrate/schedule','admin/config/system/backup_migrate','List !type','t','a:1:{s:5:"!type";s:9:"Schedules";}','','a:0:{}','140','','','1',''),('admin/config/system/backup_migrate/settings','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:3:{i:0;s:4:"crud";i:1;s:31:"backup_migrate_crud_ui_list_all";i:2;b:1;}','','31','5','1','admin/config/system/backup_migrate','admin/config/system/backup_migrate','Settings','t','','','a:0:{}','132','Module settings.','','4',''),('admin/config/system/backup_migrate/settings/destination','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:27:"backup_migrate_crud_ui_list";i:2;b:1;i:3;s:11:"destination";}','','63','6','1','admin/config/system/backup_migrate/settings','admin/config/system/backup_migrate','Destinations','t','','','a:0:{}','132','','','2',''),('admin/config/system/backup_migrate/settings/destination/add','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:29:"backup_migrate_crud_ui_create";i:2;b:1;i:3;s:11:"destination";}','','127','7','1','admin/config/system/backup_migrate/settings/destination','admin/config/system/backup_migrate','Add !type','t','a:1:{s:5:"!type";s:11:"Destination";}','','a:0:{}','388','','','2','');
INSERT INTO `menu_router` VALUES ('admin/config/system/backup_migrate/settings/destination/delete','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:29:"backup_migrate_crud_ui_delete";i:2;b:1;i:3;s:11:"destination";}','','127','7','0','','admin/config/system/backup_migrate/settings/destination/delete','Delete !type','t','a:1:{s:5:"!type";s:11:"Destination";}','','a:0:{}','0','','','0',''),('admin/config/system/backup_migrate/settings/destination/downloadfile','','','user_access','a:1:{i:0;s:19:"access backup files";}','backup_migrate_menu_callback','a:3:{i:0;s:12:"destinations";i:1;s:43:"backup_migrate_ui_destination_download_file";i:2;b:1;}','','127','7','0','','admin/config/system/backup_migrate/settings/destination/downloadfile','Download File','t','','','a:0:{}','0','Download a backup file','','0',''),('admin/config/system/backup_migrate/settings/destination/edit','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:27:"backup_migrate_crud_ui_edit";i:2;b:1;i:3;s:11:"destination";}','','127','7','0','','admin/config/system/backup_migrate/settings/destination/edit','Edit !type','t','a:1:{s:5:"!type";s:11:"Destination";}','','a:0:{}','0','','','0',''),('admin/config/system/backup_migrate/settings/destination/export','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:29:"backup_migrate_crud_ui_export";i:2;b:1;i:3;s:11:"destination";}','','127','7','0','','admin/config/system/backup_migrate/settings/destination/export','Export !type','t','a:1:{s:5:"!type";s:11:"Destination";}','','a:0:{}','0','','','0',''),('admin/config/system/backup_migrate/settings/destination/list','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:27:"backup_migrate_crud_ui_list";i:2;b:1;i:3;s:11:"destination";}','','127','7','1','admin/config/system/backup_migrate/settings/destination','admin/config/system/backup_migrate','List !type','t','a:1:{s:5:"!type";s:12:"Destinations";}','','a:0:{}','140','','','1','');
INSERT INTO `menu_router` VALUES ('admin/config/system/backup_migrate/settings/destination/list/deletefile','','','user_access','a:1:{i:0;s:19:"delete backup files";}','backup_migrate_menu_callback','a:3:{i:0;s:12:"destinations";i:1;s:41:"backup_migrate_ui_destination_delete_file";i:2;b:1;}','','255','8','1','admin/config/system/backup_migrate/settings/destination/list','admin/config/system/backup_migrate','Delete File','t','','','a:0:{}','132','Delete a backup file','','0',''),('admin/config/system/backup_migrate/settings/destination/list/files','','','user_access','a:1:{i:0;s:19:"access backup files";}','backup_migrate_menu_callback','a:3:{i:0;s:12:"destinations";i:1;s:43:"backup_migrate_ui_destination_display_files";i:2;b:1;}','','255','8','1','admin/config/system/backup_migrate/settings/destination/list','admin/config/system/backup_migrate','Destination Files','t','','','a:0:{}','132','','','0',''),('admin/config/system/backup_migrate/settings/destination/list/restorefile','','','user_access','a:1:{i:0;s:19:"restore from backup";}','backup_migrate_menu_callback','a:3:{i:0;s:12:"destinations";i:1;s:42:"backup_migrate_ui_destination_restore_file";i:2;b:1;}','','255','8','1','admin/config/system/backup_migrate/settings/destination/list','admin/config/system/backup_migrate','Restore from backup','t','','','a:0:{}','132','Restore database from a backup file on the server','','0',''),('admin/config/system/backup_migrate/settings/import','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:3:{i:0;s:4:"crud";i:1;s:29:"backup_migrate_crud_ui_import";i:2;b:1;}','','63','6','1','admin/config/system/backup_migrate/settings','admin/config/system/backup_migrate','Import','t','','','a:0:{}','132','Import backup and migrate settings.','','10',''),('admin/config/system/backup_migrate/settings/profile','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:27:"backup_migrate_crud_ui_list";i:2;b:1;i:3;s:7:"profile";}','','63','6','1','admin/config/system/backup_migrate/settings','admin/config/system/backup_migrate','Settings Profiles','t','','','a:0:{}','132','','','2','');
INSERT INTO `menu_router` VALUES ('admin/config/system/backup_migrate/settings/profile/add','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:29:"backup_migrate_crud_ui_create";i:2;b:1;i:3;s:7:"profile";}','','127','7','1','admin/config/system/backup_migrate/settings/profile','admin/config/system/backup_migrate','Add !type','t','a:1:{s:5:"!type";s:16:"Settings Profile";}','','a:0:{}','388','','','2',''),('admin/config/system/backup_migrate/settings/profile/delete','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:29:"backup_migrate_crud_ui_delete";i:2;b:1;i:3;s:7:"profile";}','','127','7','0','','admin/config/system/backup_migrate/settings/profile/delete','Delete !type','t','a:1:{s:5:"!type";s:16:"Settings Profile";}','','a:0:{}','0','','','0',''),('admin/config/system/backup_migrate/settings/profile/edit','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:27:"backup_migrate_crud_ui_edit";i:2;b:1;i:3;s:7:"profile";}','','127','7','0','','admin/config/system/backup_migrate/settings/profile/edit','Edit !type','t','a:1:{s:5:"!type";s:16:"Settings Profile";}','','a:0:{}','0','','','0',''),('admin/config/system/backup_migrate/settings/profile/export','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:29:"backup_migrate_crud_ui_export";i:2;b:1;i:3;s:7:"profile";}','','127','7','0','','admin/config/system/backup_migrate/settings/profile/export','Export !type','t','a:1:{s:5:"!type";s:16:"Settings Profile";}','','a:0:{}','0','','','0',''),('admin/config/system/backup_migrate/settings/profile/list','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:27:"backup_migrate_crud_ui_list";i:2;b:1;i:3;s:7:"profile";}','','127','7','1','admin/config/system/backup_migrate/settings/profile','admin/config/system/backup_migrate','List !type','t','a:1:{s:5:"!type";s:17:"Settings Profiles";}','','a:0:{}','140','','','1','');
INSERT INTO `menu_router` VALUES ('admin/config/system/backup_migrate/settings/source','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:27:"backup_migrate_crud_ui_list";i:2;b:1;i:3;s:6:"source";}','','63','6','1','admin/config/system/backup_migrate/settings','admin/config/system/backup_migrate','Sources','t','','','a:0:{}','132','','','2',''),('admin/config/system/backup_migrate/settings/source/add','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:29:"backup_migrate_crud_ui_create";i:2;b:1;i:3;s:6:"source";}','','127','7','1','admin/config/system/backup_migrate/settings/source','admin/config/system/backup_migrate','Add !type','t','a:1:{s:5:"!type";s:6:"Source";}','','a:0:{}','388','','','2',''),('admin/config/system/backup_migrate/settings/source/delete','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:29:"backup_migrate_crud_ui_delete";i:2;b:1;i:3;s:6:"source";}','','127','7','0','','admin/config/system/backup_migrate/settings/source/delete','Delete !type','t','a:1:{s:5:"!type";s:6:"Source";}','','a:0:{}','0','','','0',''),('admin/config/system/backup_migrate/settings/source/edit','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:27:"backup_migrate_crud_ui_edit";i:2;b:1;i:3;s:6:"source";}','','127','7','0','','admin/config/system/backup_migrate/settings/source/edit','Edit !type','t','a:1:{s:5:"!type";s:6:"Source";}','','a:0:{}','0','','','0',''),('admin/config/system/backup_migrate/settings/source/export','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:29:"backup_migrate_crud_ui_export";i:2;b:1;i:3;s:6:"source";}','','127','7','0','','admin/config/system/backup_migrate/settings/source/export','Export !type','t','a:1:{s:5:"!type";s:6:"Source";}','','a:0:{}','0','','','0','');
INSERT INTO `menu_router` VALUES ('admin/config/system/backup_migrate/settings/source/list','','','user_access','a:1:{i:0;s:29:"administer backup and migrate";}','backup_migrate_menu_callback','a:4:{i:0;s:4:"crud";i:1;s:27:"backup_migrate_crud_ui_list";i:2;b:1;i:3;s:6:"source";}','','127','7','1','admin/config/system/backup_migrate/settings/source','admin/config/system/backup_migrate','List !type','t','a:1:{s:5:"!type";s:7:"Sources";}','','a:0:{}','140','','','1',''),('admin/config/system/cron','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:20:"system_cron_settings";}','','15','4','0','','admin/config/system/cron','Cron','t','','','a:0:{}','6','Manage automatic site maintenance tasks.','','20','modules/system/system.admin.inc'),('admin/config/system/googleanalytics','','','user_access','a:1:{i:0;s:27:"administer google analytics";}','drupal_get_form','a:1:{i:0;s:35:"googleanalytics_admin_settings_form";}','','15','4','0','','admin/config/system/googleanalytics','Google Analytics','t','','','a:0:{}','6','Configure tracking behavior to get insights into your website traffic and marketing effectiveness.','','0','sites/all/modules/contrib/google_analytics/googleanalytics.admin.inc'),('admin/config/system/site-information','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:32:"system_site_information_settings";}','','15','4','0','','admin/config/system/site-information','Site information','t','','','a:0:{}','6','Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.','','-20','modules/system/system.admin.inc'),('admin/config/system/smtp','','','user_access','a:1:{i:0;s:22:"administer smtp module";}','drupal_get_form','a:1:{i:0;s:19:"smtp_admin_settings";}','','15','4','0','','admin/config/system/smtp','SMTP Authentication Support','t','','','a:0:{}','6','Allow for site emails to be sent through an SMTP server of your choice.','','0','sites/all/modules/contrib/smtp/smtp.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/system/statistics','','','user_access','a:1:{i:0;s:21:"administer statistics";}','drupal_get_form','a:1:{i:0;s:24:"statistics_settings_form";}','','15','4','0','','admin/config/system/statistics','Statistics','t','','','a:0:{}','6','Control details about what and how your site logs access statistics.','','-15','modules/statistics/statistics.admin.inc'),('admin/config/user-interface','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','7','3','0','','admin/config/user-interface','User interface','t','','','a:0:{}','6','Tools that enhance the user interface.','right','-15','modules/system/system.admin.inc'),('admin/config/user-interface/shortcut','','','user_access','a:1:{i:0;s:20:"administer shortcuts";}','shortcut_set_admin','a:0:{}','','15','4','0','','admin/config/user-interface/shortcut','Shortcuts','t','','','a:0:{}','6','Add and modify shortcut sets.','','0','modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%','a:1:{i:4;s:17:"shortcut_set_load";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:"shortcut_set_customize";i:1;i:4;}','','30','5','0','','admin/config/user-interface/shortcut/%','Edit shortcuts','shortcut_set_title_callback','a:1:{i:0;i:4;}','','a:0:{}','6','','','0','modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/add-link','a:1:{i:4;s:17:"shortcut_set_load";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:17:"shortcut_link_add";i:1;i:4;}','','61','6','1','admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Add shortcut','t','','','a:0:{}','388','','','0','modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/add-link-inline','a:1:{i:4;s:17:"shortcut_set_load";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','shortcut_link_add_inline','a:1:{i:0;i:4;}','','61','6','0','','admin/config/user-interface/shortcut/%/add-link-inline','Add shortcut','t','','','a:0:{}','0','','','0','modules/shortcut/shortcut.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/user-interface/shortcut/%/delete','a:1:{i:4;s:17:"shortcut_set_load";}','','shortcut_set_delete_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:24:"shortcut_set_delete_form";i:1;i:4;}','','61','6','0','','admin/config/user-interface/shortcut/%/delete','Delete shortcut set','t','','','a:0:{}','6','','','0','modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/edit','a:1:{i:4;s:17:"shortcut_set_load";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:"shortcut_set_edit_form";i:1;i:4;}','','61','6','1','admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Edit set name','t','','','a:0:{}','132','','','10','modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/links','a:1:{i:4;s:17:"shortcut_set_load";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:"shortcut_set_customize";i:1;i:4;}','','61','6','1','admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','List links','t','','','a:0:{}','140','','','0','modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/add-set','','','user_access','a:1:{i:0;s:20:"administer shortcuts";}','drupal_get_form','a:1:{i:0;s:21:"shortcut_set_add_form";}','','31','5','1','admin/config/user-interface/shortcut','admin/config/user-interface/shortcut','Add shortcut set','t','','','a:0:{}','388','','','0','modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/link/%','a:1:{i:5;s:14:"menu_link_load";}','','shortcut_link_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:18:"shortcut_link_edit";i:1;i:5;}','','62','6','0','','admin/config/user-interface/shortcut/link/%','Edit shortcut','t','','','a:0:{}','6','','','0','modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/link/%/delete','a:1:{i:5;s:14:"menu_link_load";}','','shortcut_link_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:20:"shortcut_link_delete";i:1;i:5;}','','125','7','0','','admin/config/user-interface/shortcut/link/%/delete','Delete shortcut','t','','','a:0:{}','6','','','0','modules/shortcut/shortcut.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/workflow','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','7','3','0','','admin/config/workflow','Workflow','t','','','a:0:{}','6','Content workflow, editorial workflow tools.','right','5','modules/system/system.admin.inc'),('admin/config/workflow/rules','','','user_access','a:1:{i:0;s:16:"administer rules";}','drupal_get_form','a:2:{i:0;s:29:"rules_admin_reaction_overview";i:1;s:36:"admin/config/workflow/rules/reaction";}','','15','4','0','','admin/config/workflow/rules','Rules','t','','','a:0:{}','6','Manage reaction rules and rule components.','right','0','sites/all/modules/contrib/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/autocomplete_tags','','','user_access','a:1:{i:0;s:16:"administer rules";}','rules_autocomplete_tags','a:1:{i:0;i:5;}','','31','5','0','','admin/config/workflow/rules/autocomplete_tags','Rules tags autocomplete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components','','','user_access','a:1:{i:0;s:16:"administer rules";}','drupal_get_form','a:2:{i:0;s:31:"rules_admin_components_overview";i:1;s:38:"admin/config/workflow/rules/components";}','','31','5','1','admin/config/workflow/rules','admin/config/workflow/rules','Components','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/components/add','','','user_access','a:1:{i:0;s:16:"administer rules";}','drupal_get_form','a:2:{i:0;s:25:"rules_admin_add_component";i:1;s:38:"admin/config/workflow/rules/components";}','','63','6','1','admin/config/workflow/rules/components','admin/config/workflow/rules','Add new component','t','','','a:0:{}','388','','','0','sites/all/modules/contrib/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/components/import','','','user_access','a:1:{i:0;s:16:"administer rules";}','drupal_get_form','a:2:{i:0;s:20:"rules_ui_import_form";i:1;s:38:"admin/config/workflow/rules/components";}','','63','6','1','admin/config/workflow/rules/components','admin/config/workflow/rules','Import component','t','','','a:0:{}','388','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc');
INSERT INTO `menu_router` VALUES ('admin/config/workflow/rules/components/manage/%','a:1:{i:6;s:17:"rules_config_load";}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:31:"rules_ui_form_edit_rules_config";i:1;i:6;i:2;s:38:"admin/config/workflow/rules/components";}','','126','7','0','','admin/config/workflow/rules/components/manage/%','','rules_get_title','a:2:{i:0;s:24:"Editing !plugin "!label"";i:1;i:6;}','','a:0:{}','4','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/%','a:2:{i:6;s:17:"rules_config_load";i:7;N;}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:37:"rules_ui_form_rules_config_confirm_op";i:1;i:6;i:2;i:7;i:3;s:38:"admin/config/workflow/rules/components";}','','252','8','0','','admin/config/workflow/rules/components/manage/%/%','','t','','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/add-case/%','a:2:{i:6;a:1:{s:17:"rules_config_load";a:1:{i:0;i:6;}}i:8;a:1:{s:18:"rules_element_load";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:5:{i:0;s:26:"rules_conditional_add_case";i:1;i:6;i:2;i:9;i:3;i:8;i:4;s:38:"admin/config/workflow/rules/components";}','','506','9','0','','admin/config/workflow/rules/components/manage/%/add-case/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:9;}}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.rules_admin.inc'),('admin/config/workflow/rules/components/manage/%/add-predicate/%','a:2:{i:6;a:1:{s:17:"rules_config_load";a:1:{i:0;i:6;}}i:8;a:1:{s:18:"rules_element_load";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:5:{i:0;s:31:"rules_conditional_add_predicate";i:1;i:6;i:2;i:9;i:3;i:8;i:4;s:38:"admin/config/workflow/rules/components";}','','506','9','0','','admin/config/workflow/rules/components/manage/%/add-predicate/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:9;}}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.rules_admin.inc');
INSERT INTO `menu_router` VALUES ('admin/config/workflow/rules/components/manage/%/add/%','a:2:{i:6;a:1:{s:17:"rules_config_load";a:1:{i:0;i:6;}}i:8;a:1:{s:18:"rules_element_load";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:5:{i:0;s:20:"rules_ui_add_element";i:1;i:6;i:2;i:9;i:3;i:8;i:4;s:38:"admin/config/workflow/rules/components";}','','506','9','0','','admin/config/workflow/rules/components/manage/%/add/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:9;}}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/add/event','a:1:{i:6;a:1:{s:17:"rules_config_load";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:23:"rules_ui_add_event_page";i:1;i:6;i:2;s:38:"admin/config/workflow/rules/components";}','','507','9','0','','admin/config/workflow/rules/components/manage/%/add/event','','rules_get_title','a:2:{i:0;s:32:"Adding event to !plugin "!label"";i:1;i:6;}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/autocomplete','a:1:{i:6;s:17:"rules_config_load";}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','rules_ui_form_data_selection_auto_completion','a:3:{i:0;i:8;i:1;i:9;i:2;i:10;}','','253','8','0','','admin/config/workflow/rules/components/manage/%/autocomplete','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/clone','a:1:{i:6;s:17:"rules_config_load";}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:32:"rules_ui_form_clone_rules_config";i:1;i:6;i:2;s:38:"admin/config/workflow/rules/components";}','','253','8','0','','admin/config/workflow/rules/components/manage/%/clone','','rules_get_title','a:2:{i:0;s:24:"Cloning !plugin "!label"";i:1;i:6;}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc');
INSERT INTO `menu_router` VALUES ('admin/config/workflow/rules/components/manage/%/delete/%','a:2:{i:6;a:1:{s:17:"rules_config_load";a:1:{i:0;i:6;}}i:8;a:1:{s:18:"rules_element_load";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:23:"rules_ui_delete_element";i:1;i:6;i:2;i:8;i:3;s:38:"admin/config/workflow/rules/components";}','','506','9','0','','admin/config/workflow/rules/components/manage/%/delete/%','','rules_get_title','a:2:{i:0;s:24:"Editing !plugin "!label"";i:1;i:8;}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/delete/event','a:1:{i:6;s:17:"rules_config_load";}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:"rules_ui_remove_event";i:1;i:6;i:2;i:9;i:3;s:38:"admin/config/workflow/rules/components";}','','507','9','0','','admin/config/workflow/rules/components/manage/%/delete/event','Remove event','t','','','a:0:{}','6','Remove an event from a reaction rule.','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/edit/%','a:2:{i:6;a:1:{s:17:"rules_config_load";a:1:{i:0;i:6;}}i:8;a:1:{s:18:"rules_element_load";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:"rules_ui_edit_element";i:1;i:6;i:2;i:8;i:3;s:38:"admin/config/workflow/rules/components";}','','506','9','0','','admin/config/workflow/rules/components/manage/%/edit/%','','rules_get_title','a:2:{i:0;s:24:"Editing !plugin "!label"";i:1;i:8;}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/execute','a:1:{i:6;s:17:"rules_config_load";}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:34:"rules_ui_form_execute_rules_config";i:1;i:6;i:2;s:38:"admin/config/workflow/rules/components";}','','253','8','0','','admin/config/workflow/rules/components/manage/%/execute','','rules_get_title','a:2:{i:0;s:26:"Executing !plugin "!label"";i:1;i:6;}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc');
INSERT INTO `menu_router` VALUES ('admin/config/workflow/rules/components/manage/%/export','a:1:{i:6;s:17:"rules_config_load";}','','rules_config_access','a:2:{i:0;s:4:"view";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:33:"rules_ui_form_export_rules_config";i:1;i:6;i:2;s:38:"admin/config/workflow/rules/components";}','','253','8','0','','admin/config/workflow/rules/components/manage/%/export','','rules_get_title','a:2:{i:0;s:26:"Export of !plugin "!label"";i:1;i:6;}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction','','','user_access','a:1:{i:0;s:16:"administer rules";}','drupal_get_form','a:2:{i:0;s:29:"rules_admin_reaction_overview";i:1;s:36:"admin/config/workflow/rules/reaction";}','','31','5','1','admin/config/workflow/rules','admin/config/workflow/rules','Rules','t','','','a:0:{}','140','','','-1','sites/all/modules/contrib/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/reaction/add','','','user_access','a:1:{i:0;s:16:"administer rules";}','drupal_get_form','a:2:{i:0;s:29:"rules_admin_add_reaction_rule";i:1;s:36:"admin/config/workflow/rules/reaction";}','','63','6','1','admin/config/workflow/rules/reaction','admin/config/workflow/rules','Add new rule','t','','','a:0:{}','388','','','0','sites/all/modules/contrib/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/reaction/import','','','user_access','a:1:{i:0;s:16:"administer rules";}','drupal_get_form','a:2:{i:0;s:20:"rules_ui_import_form";i:1;s:36:"admin/config/workflow/rules/reaction";}','','63','6','1','admin/config/workflow/rules/reaction','admin/config/workflow/rules','Import rule','t','','','a:0:{}','388','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%','a:1:{i:6;s:17:"rules_config_load";}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:31:"rules_ui_form_edit_rules_config";i:1;i:6;i:2;s:36:"admin/config/workflow/rules/reaction";}','','126','7','0','','admin/config/workflow/rules/reaction/manage/%','','rules_get_title','a:2:{i:0;s:24:"Editing !plugin "!label"";i:1;i:6;}','','a:0:{}','4','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc');
INSERT INTO `menu_router` VALUES ('admin/config/workflow/rules/reaction/manage/%/%','a:2:{i:6;s:17:"rules_config_load";i:7;N;}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:37:"rules_ui_form_rules_config_confirm_op";i:1;i:6;i:2;i:7;i:3;s:36:"admin/config/workflow/rules/reaction";}','','252','8','0','','admin/config/workflow/rules/reaction/manage/%/%','','t','','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/add-case/%','a:2:{i:6;a:1:{s:17:"rules_config_load";a:1:{i:0;i:6;}}i:8;a:1:{s:18:"rules_element_load";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:5:{i:0;s:26:"rules_conditional_add_case";i:1;i:6;i:2;i:9;i:3;i:8;i:4;s:36:"admin/config/workflow/rules/reaction";}','','506','9','0','','admin/config/workflow/rules/reaction/manage/%/add-case/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:9;}}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.rules_admin.inc'),('admin/config/workflow/rules/reaction/manage/%/add-predicate/%','a:2:{i:6;a:1:{s:17:"rules_config_load";a:1:{i:0;i:6;}}i:8;a:1:{s:18:"rules_element_load";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:5:{i:0;s:31:"rules_conditional_add_predicate";i:1;i:6;i:2;i:9;i:3;i:8;i:4;s:36:"admin/config/workflow/rules/reaction";}','','506','9','0','','admin/config/workflow/rules/reaction/manage/%/add-predicate/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:9;}}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.rules_admin.inc'),('admin/config/workflow/rules/reaction/manage/%/add/%','a:2:{i:6;a:1:{s:17:"rules_config_load";a:1:{i:0;i:6;}}i:8;a:1:{s:18:"rules_element_load";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:5:{i:0;s:20:"rules_ui_add_element";i:1;i:6;i:2;i:9;i:3;i:8;i:4;s:36:"admin/config/workflow/rules/reaction";}','','506','9','0','','admin/config/workflow/rules/reaction/manage/%/add/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:9;}}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc');
INSERT INTO `menu_router` VALUES ('admin/config/workflow/rules/reaction/manage/%/add/event','a:1:{i:6;a:1:{s:17:"rules_config_load";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:23:"rules_ui_add_event_page";i:1;i:6;i:2;s:36:"admin/config/workflow/rules/reaction";}','','507','9','0','','admin/config/workflow/rules/reaction/manage/%/add/event','','rules_get_title','a:2:{i:0;s:32:"Adding event to !plugin "!label"";i:1;i:6;}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/autocomplete','a:1:{i:6;s:17:"rules_config_load";}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','rules_ui_form_data_selection_auto_completion','a:3:{i:0;i:8;i:1;i:9;i:2;i:10;}','','253','8','0','','admin/config/workflow/rules/reaction/manage/%/autocomplete','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/clone','a:1:{i:6;s:17:"rules_config_load";}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:32:"rules_ui_form_clone_rules_config";i:1;i:6;i:2;s:36:"admin/config/workflow/rules/reaction";}','','253','8','0','','admin/config/workflow/rules/reaction/manage/%/clone','','rules_get_title','a:2:{i:0;s:24:"Cloning !plugin "!label"";i:1;i:6;}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/delete/%','a:2:{i:6;a:1:{s:17:"rules_config_load";a:1:{i:0;i:6;}}i:8;a:1:{s:18:"rules_element_load";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:23:"rules_ui_delete_element";i:1;i:6;i:2;i:8;i:3;s:36:"admin/config/workflow/rules/reaction";}','','506','9','0','','admin/config/workflow/rules/reaction/manage/%/delete/%','','rules_get_title','a:2:{i:0;s:24:"Editing !plugin "!label"";i:1;i:8;}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc');
INSERT INTO `menu_router` VALUES ('admin/config/workflow/rules/reaction/manage/%/delete/event','a:1:{i:6;s:17:"rules_config_load";}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:"rules_ui_remove_event";i:1;i:6;i:2;i:9;i:3;s:36:"admin/config/workflow/rules/reaction";}','','507','9','0','','admin/config/workflow/rules/reaction/manage/%/delete/event','Remove event','t','','','a:0:{}','6','Remove an event from a reaction rule.','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/edit/%','a:2:{i:6;a:1:{s:17:"rules_config_load";a:1:{i:0;i:6;}}i:8;a:1:{s:18:"rules_element_load";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:"rules_ui_edit_element";i:1;i:6;i:2;i:8;i:3;s:36:"admin/config/workflow/rules/reaction";}','','506','9','0','','admin/config/workflow/rules/reaction/manage/%/edit/%','','rules_get_title','a:2:{i:0;s:24:"Editing !plugin "!label"";i:1;i:8;}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/execute','a:1:{i:6;s:17:"rules_config_load";}','','rules_config_access','a:2:{i:0;s:6:"update";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:34:"rules_ui_form_execute_rules_config";i:1;i:6;i:2;s:36:"admin/config/workflow/rules/reaction";}','','253','8','0','','admin/config/workflow/rules/reaction/manage/%/execute','','rules_get_title','a:2:{i:0;s:26:"Executing !plugin "!label"";i:1;i:6;}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/export','a:1:{i:6;s:17:"rules_config_load";}','','rules_config_access','a:2:{i:0;s:4:"view";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:33:"rules_ui_form_export_rules_config";i:1;i:6;i:2;s:36:"admin/config/workflow/rules/reaction";}','','253','8','0','','admin/config/workflow/rules/reaction/manage/%/export','','rules_get_title','a:2:{i:0;s:26:"Export of !plugin "!label"";i:1;i:6;}','','a:0:{}','6','','','0','sites/all/modules/contrib/rules/ui/ui.forms.inc');
INSERT INTO `menu_router` VALUES ('admin/config/workflow/rules/settings','','','user_access','a:1:{i:0;s:16:"administer rules";}','drupal_get_form','a:1:{i:0;s:20:"rules_admin_settings";}','','31','5','1','admin/config/workflow/rules','admin/config/workflow/rules','Settings','t','','','a:0:{}','132','','','1','sites/all/modules/contrib/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/settings/advanced','','','user_access','a:1:{i:0;s:16:"administer rules";}','drupal_get_form','a:1:{i:0;s:29:"rules_admin_settings_advanced";}','','63','6','1','admin/config/workflow/rules/settings','admin/config/workflow/rules','Advanced','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/settings/basic','','','user_access','a:1:{i:0;s:16:"administer rules";}','drupal_get_form','a:1:{i:0;s:20:"rules_admin_settings";}','','63','6','1','admin/config/workflow/rules/settings','admin/config/workflow/rules','Basic','t','','','a:0:{}','140','','','-10','sites/all/modules/contrib/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/upgrade','','','user_access','a:1:{i:0;s:16:"administer rules";}','drupal_get_form','a:1:{i:0;s:18:"rules_upgrade_form";}','','31','5','0','','admin/config/workflow/rules/upgrade','Upgrade','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/rules/includes/rules.upgrade.inc'),('admin/config/workflow/rules/upgrade/clear','','','user_access','a:1:{i:0;s:16:"administer rules";}','drupal_get_form','a:1:{i:0;s:32:"rules_upgrade_confirm_clear_form";}','','63','6','0','','admin/config/workflow/rules/upgrade/clear','Clear','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/rules/includes/rules.upgrade.inc'),('admin/config/workflow/workflow','','','entity_access','a:2:{i:0;s:4:"view";i:1;s:8:"Workflow";}','drupal_get_form','a:2:{i:0;s:22:"Workflow_overview_form";i:1;s:8:"Workflow";}','','15','4','0','','admin/config/workflow/workflow','Workflows','t','','','a:0:{}','6','Manage Workflows.','','0','sites/all/modules/contrib/entity/includes/entity.ui.inc');
INSERT INTO `menu_router` VALUES ('admin/config/workflow/workflow/add','','','entity_access','a:2:{i:0;s:6:"create";i:1;s:8:"Workflow";}','entity_ui_get_form','a:3:{i:0;s:8:"Workflow";i:1;N;i:2;s:3:"add";}','','31','5','1','admin/config/workflow/workflow','admin/config/workflow/workflow','','entity_ui_get_action_title','a:2:{i:0;s:3:"add";i:1;s:8:"Workflow";}','','a:0:{}','388','','','0',''),('admin/config/workflow/workflow/import','','','entity_access','a:2:{i:0;s:6:"create";i:1;s:8:"Workflow";}','drupal_get_form','a:4:{i:0;s:23:"Workflow_operation_form";i:1;s:8:"Workflow";i:2;N;i:3;s:6:"import";}','','31','5','1','admin/config/workflow/workflow','admin/config/workflow/workflow','','entity_ui_get_action_title','a:2:{i:0;s:6:"import";i:1;s:8:"Workflow";}','','a:0:{}','388','','','0','sites/all/modules/contrib/entity/includes/entity.ui.inc'),('admin/config/workflow/workflow/list','','','entity_access','a:2:{i:0;s:4:"view";i:1;s:8:"Workflow";}','drupal_get_form','a:2:{i:0;s:22:"Workflow_overview_form";i:1;s:8:"Workflow";}','','31','5','1','admin/config/workflow/workflow','admin/config/workflow/workflow','List','t','','','a:0:{}','140','','','-10','sites/all/modules/contrib/entity/includes/entity.ui.inc'),('admin/config/workflow/workflow/manage/%','a:1:{i:5;a:1:{s:13:"workflow_load";a:1:{i:0;s:8:"Workflow";}}}','','entity_access','a:3:{i:0;s:6:"update";i:1;s:8:"Workflow";i:2;i:5;}','entity_ui_get_form','a:2:{i:0;s:8:"Workflow";i:1;i:5;}','','62','6','0','','admin/config/workflow/workflow/manage/%','Edit','entity_label','a:2:{i:0;s:8:"Workflow";i:1;i:5;}','','a:0:{}','6','','','0',''),('admin/config/workflow/workflow/manage/%/%','a:2:{i:5;a:1:{s:13:"workflow_load";a:1:{i:0;s:8:"Workflow";}}i:6;N;}','','entity_access','a:3:{i:0;s:6:"delete";i:1;s:8:"Workflow";i:2;i:5;}','drupal_get_form','a:4:{i:0;s:23:"Workflow_operation_form";i:1;s:8:"Workflow";i:2;i:5;i:3;i:6;}','','124','7','0','','admin/config/workflow/workflow/manage/%/%','','t','','','a:0:{}','6','','','0','sites/all/modules/contrib/entity/includes/entity.ui.inc');
INSERT INTO `menu_router` VALUES ('admin/config/workflow/workflow/manage/%/clone','a:1:{i:5;a:1:{s:13:"workflow_load";a:1:{i:0;s:8:"Workflow";}}}','','entity_access','a:2:{i:0;s:6:"create";i:1;s:8:"Workflow";}','entity_ui_get_form','a:3:{i:0;s:8:"Workflow";i:1;i:5;i:2;s:5:"clone";}','','125','7','0','','admin/config/workflow/workflow/manage/%/clone','Clone','t','','','a:0:{}','6','','','0',''),('admin/config/workflow/workflow/manage/%/edit','a:1:{i:5;a:1:{s:13:"workflow_load";a:1:{i:0;s:8:"Workflow";}}}','','entity_access','a:3:{i:0;s:6:"update";i:1;s:8:"Workflow";i:2;i:5;}','entity_ui_get_form','a:2:{i:0;s:8:"Workflow";i:1;i:5;}','','125','7','1','admin/config/workflow/workflow/manage/%','admin/config/workflow/workflow/manage/%','Edit','t','','','a:0:{}','140','','','0',''),('admin/config/workflow/workflow/manage/%/labels','a:1:{i:5;a:1:{s:13:"workflow_load";a:1:{i:0;s:8:"Workflow";}}}','','user_access','a:1:{i:0;s:19:"administer workflow";}','drupal_get_form','a:3:{i:0;s:29:"workflow_admin_ui_labels_form";i:1;i:5;i:2;i:6;}','','125','7','1','admin/config/workflow/workflow/manage/%','admin/config/workflow/workflow/manage/%','Labels','t','','','a:0:{}','132','','','13','sites/all/modules/contrib/workflow/workflow_admin_ui/workflow_admin_ui.page.labels.inc'),('admin/config/workflow/workflow/manage/%/permissions','a:1:{i:5;a:1:{s:13:"workflow_load";a:1:{i:0;s:8:"Workflow";}}}','','user_access','a:1:{i:0;s:19:"administer workflow";}','workflow_admin_ui_view_permissions_form','a:2:{i:0;i:5;i:1;i:6;}','','125','7','1','admin/config/workflow/workflow/manage/%','admin/config/workflow/workflow/manage/%','Permission summary','t','','','a:0:{}','132','','','14','sites/all/modules/contrib/workflow/workflow_admin_ui/workflow_admin_ui.page.permissions.inc'),('admin/config/workflow/workflow/manage/%/states','a:1:{i:5;a:1:{s:13:"workflow_load";a:1:{i:0;s:8:"Workflow";}}}','','user_access','a:1:{i:0;s:19:"administer workflow";}','drupal_get_form','a:3:{i:0;s:29:"workflow_admin_ui_states_form";i:1;i:5;i:2;i:6;}','','125','7','1','admin/config/workflow/workflow/manage/%','admin/config/workflow/workflow/manage/%','States','t','','','a:0:{}','132','','','11','sites/all/modules/contrib/workflow/workflow_admin_ui/workflow_admin_ui.page.states.inc');
INSERT INTO `menu_router` VALUES ('admin/config/workflow/workflow/manage/%/transitions','a:1:{i:5;a:1:{s:13:"workflow_load";a:1:{i:0;s:8:"Workflow";}}}','','user_access','a:1:{i:0;s:19:"administer workflow";}','drupal_get_form','a:3:{i:0;s:34:"workflow_admin_ui_transitions_form";i:1;i:5;i:2;i:6;}','','125','7','1','admin/config/workflow/workflow/manage/%','admin/config/workflow/workflow/manage/%','Transitions','t','','','a:0:{}','132','','','12','sites/all/modules/contrib/workflow/workflow_admin_ui/workflow_admin_ui.page.transitions.inc'),('admin/content','','','user_access','a:1:{i:0;s:23:"access content overview";}','views_page','a:2:{i:0;s:16:"admin_views_node";i:1;s:8:"system_1";}','','3','2','0','','admin/content','Content','t','','','a:0:{}','6','Administer content and comments.','','-10','modules/node/node.admin.inc'),('admin/content/comment','','','user_access','a:1:{i:0;s:19:"administer comments";}','views_page','a:2:{i:0;s:19:"admin_views_comment";i:1;s:8:"system_1";}','','7','3','1','admin/content','admin/content','Comments','t','','','a:0:{}','134','List and edit site comments and the comment approval queue.','','0','modules/comment/comment.admin.inc'),('admin/content/comment/approval','','','user_access','a:1:{i:0;s:19:"administer comments";}','views_page','a:2:{i:0;s:19:"admin_views_comment";i:1;s:8:"system_2";}','','15','4','1','admin/content/comment','admin/content','Unapproved comments','comment_count_unpublished','','','a:0:{}','132','','','0','modules/comment/comment.admin.inc'),('admin/content/comment/new','','','user_access','a:1:{i:0;s:19:"administer comments";}','comment_admin','a:0:{}','','15','4','1','admin/content/comment','admin/content','Published comments','t','','','a:0:{}','140','','','-10','modules/comment/comment.admin.inc'),('admin/content/node','','','user_access','a:1:{i:0;s:23:"access content overview";}','drupal_get_form','a:1:{i:0;s:18:"node_admin_content";}','','7','3','1','admin/content','admin/content','Content','t','','','a:0:{}','140','','','-10','modules/node/node.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/dashboard','','','user_access','a:1:{i:0;s:16:"access dashboard";}','dashboard_admin','a:0:{}','','3','2','0','','admin/dashboard','Dashboard','t','','','a:0:{}','6','View and customize your dashboard.','','-15',''),('admin/dashboard/block-content/%/%','a:2:{i:3;N;i:4;N;}','','user_access','a:1:{i:0;s:17:"administer blocks";}','dashboard_show_block_content','a:2:{i:0;i:3;i:1;i:4;}','','28','5','0','','admin/dashboard/block-content/%/%','','t','','','a:0:{}','0','','','0',''),('admin/dashboard/configure','','','user_access','a:1:{i:0;s:17:"administer blocks";}','dashboard_admin_blocks','a:0:{}','','7','3','0','','admin/dashboard/configure','Configure available dashboard blocks','t','','','a:0:{}','4','Configure which blocks can be shown on the dashboard.','','0',''),('admin/dashboard/customize','','','user_access','a:1:{i:0;s:16:"access dashboard";}','dashboard_admin','a:1:{i:0;b:1;}','','7','3','0','','admin/dashboard/customize','Customize dashboard','t','','','a:0:{}','4','Customize your dashboard.','','0',''),('admin/dashboard/drawer','','','user_access','a:1:{i:0;s:17:"administer blocks";}','dashboard_show_disabled','a:0:{}','','7','3','0','','admin/dashboard/drawer','','t','','','a:0:{}','0','','','0',''),('admin/dashboard/update','','','user_access','a:1:{i:0;s:17:"administer blocks";}','dashboard_update','a:0:{}','','7','3','0','','admin/dashboard/update','','t','','','a:0:{}','0','','','0',''),('admin/help','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_main','a:0:{}','','3','2','0','','admin/help','Help','t','','','a:0:{}','6','Reference for usage, configuration, and modules.','','9','modules/help/help.admin.inc'),('admin/help/admin_menu','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/admin_menu','admin_menu','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/ah','','','user_access','a:1:{i:0;s:24:"view advanced help index";}','advanced_help_index_page','a:0:{}','','7','3','1','admin/help','admin/help','Advanced Help','t','','','a:0:{}','132','','','2','');
INSERT INTO `menu_router` VALUES ('admin/help/backup_migrate','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/backup_migrate','backup_migrate','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/block','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/block','block','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/calendar','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/calendar','calendar','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/color','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/color','color','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/comment','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/comment','comment','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/content_access','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/content_access','content_access','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/contextual','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/contextual','contextual','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/dashboard','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/dashboard','dashboard','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/date','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/date','date','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/help/date_tools','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/date_tools','date_tools','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/dblog','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/dblog','dblog','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/devel','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/devel','devel','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/entityform','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/entityform','entityform','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/features','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/features','features','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/feeds_ui','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/feeds_ui','feeds_ui','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/field','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/field','field','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/field_collection','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/field_collection','field_collection','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/field_permissions','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/field_permissions','field_permissions','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/help/field_sql_storage','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/field_sql_storage','field_sql_storage','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/field_ui','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/field_ui','field_ui','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/file','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/file','file','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/filter','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/filter','filter','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/googleanalytics','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/googleanalytics','googleanalytics','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/help','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/help','help','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/image','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/image','image','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/jquery_update','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/jquery_update','jquery_update','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/libraries','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/libraries','libraries','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/help/list','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/list','list','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/menu','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/menu','menu','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/node','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/node','node','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/number','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/number','number','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/options','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/options','options','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/path','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/path','path','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/pathauto','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/pathauto','pathauto','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/php','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/php','php','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/rdf','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/rdf','rdf','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/help/rules','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/rules','rules','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/search','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/search','search','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/shortcut','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/shortcut','shortcut','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/smtp','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/smtp','smtp','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/statistics','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/statistics','statistics','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/stringoverrides','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/stringoverrides','stringoverrides','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/system','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/system','system','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/tab1','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_main','a:0:{}','','7','3','1','admin/help','admin/help','Help','t','','','a:0:{}','140','','','0','modules/help/help.admin.inc'),('admin/help/taxonomy','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/taxonomy','taxonomy','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/help/text','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/text','text','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/token','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/token','token','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/user','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/user','user','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/workflow','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/workflow','workflow','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/workflow_admin_ui','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/workflow_admin_ui','workflow_admin_ui','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/help/wysiwyg','','','user_access','a:1:{i:0;s:27:"access administration pages";}','help_page','a:1:{i:0;i:2;}','','7','3','0','','admin/help/wysiwyg','wysiwyg','t','','','a:0:{}','4','','','0','modules/help/help.admin.inc'),('admin/index','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_index','a:0:{}','','3','2','1','admin','admin','Index','t','','','a:0:{}','132','','','-18','modules/system/system.admin.inc'),('admin/library/all-tickets','','','views_access','a:1:{i:0;a:2:{i:0;s:17:"views_check_roles";i:1;a:1:{i:0;a:2:{i:3;s:1:"3";i:5;s:1:"5";}}}}','views_page','a:2:{i:0;s:7:"drawing";i:1;s:6:"page_3";}','','7','3','0','','admin/library/all-tickets','','t','','','a:0:{}','0','','','0',''),('admin/modules','','','user_access','a:1:{i:0;s:18:"administer modules";}','drupal_get_form','a:1:{i:0;s:14:"system_modules";}','','3','2','0','','admin/modules','Modules','t','','','a:0:{}','6','Extend site functionality.','','-2','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/modules/list','','','user_access','a:1:{i:0;s:18:"administer modules";}','drupal_get_form','a:1:{i:0;s:14:"system_modules";}','','7','3','1','admin/modules','admin/modules','List','t','','','a:0:{}','140','','','0','modules/system/system.admin.inc'),('admin/modules/list/confirm','','','user_access','a:1:{i:0;s:18:"administer modules";}','drupal_get_form','a:1:{i:0;s:14:"system_modules";}','','15','4','0','','admin/modules/list/confirm','List','t','','','a:0:{}','4','','','0','modules/system/system.admin.inc'),('admin/modules/uninstall','','','user_access','a:1:{i:0;s:18:"administer modules";}','drupal_get_form','a:1:{i:0;s:24:"system_modules_uninstall";}','','7','3','1','admin/modules','admin/modules','Uninstall','t','','','a:0:{}','132','','','20','modules/system/system.admin.inc'),('admin/modules/uninstall/confirm','','','user_access','a:1:{i:0;s:18:"administer modules";}','drupal_get_form','a:1:{i:0;s:24:"system_modules_uninstall";}','','15','4','0','','admin/modules/uninstall/confirm','Uninstall','t','','','a:0:{}','4','','','0','modules/system/system.admin.inc'),('admin/people','','','user_access','a:1:{i:0;s:16:"administer users";}','views_page','a:2:{i:0;s:16:"admin_views_user";i:1;s:8:"system_1";}','','3','2','0','','admin/people','People','t','','','a:0:{}','6','Manage user accounts, roles, and permissions.','left','-4','modules/user/user.admin.inc'),('admin/people/create','','','user_access','a:1:{i:0;s:16:"administer users";}','user_admin','a:1:{i:0;s:6:"create";}','','7','3','1','admin/people','admin/people','Add user','t','','','a:0:{}','388','','','0','modules/user/user.admin.inc'),('admin/people/people','','','user_access','a:1:{i:0;s:16:"administer users";}','user_admin','a:1:{i:0;s:4:"list";}','','7','3','1','admin/people','admin/people','List','t','','','a:0:{}','140','Find and manage people interacting with your site.','','-10','modules/user/user.admin.inc'),('admin/people/permissions','','','user_access','a:1:{i:0;s:22:"administer permissions";}','drupal_get_form','a:1:{i:0;s:22:"user_admin_permissions";}','','7','3','1','admin/people','admin/people','Permissions','t','','','a:0:{}','132','Determine access to features by selecting permissions for roles.','','0','modules/user/user.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/people/permissions/list','','','user_access','a:1:{i:0;s:22:"administer permissions";}','drupal_get_form','a:1:{i:0;s:22:"user_admin_permissions";}','','15','4','1','admin/people/permissions','admin/people','Permissions','t','','','a:0:{}','140','Determine access to features by selecting permissions for roles.','','-8','modules/user/user.admin.inc'),('admin/people/permissions/roles','','','user_access','a:1:{i:0;s:22:"administer permissions";}','drupal_get_form','a:1:{i:0;s:16:"user_admin_roles";}','','15','4','1','admin/people/permissions','admin/people','Roles','t','','','a:0:{}','132','List, edit, or add user roles.','','-5','modules/user/user.admin.inc'),('admin/people/permissions/roles/delete/%','a:1:{i:5;s:14:"user_role_load";}','','user_role_edit_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:30:"user_admin_role_delete_confirm";i:1;i:5;}','','62','6','0','','admin/people/permissions/roles/delete/%','Delete role','t','','','a:0:{}','6','','','0','modules/user/user.admin.inc'),('admin/people/permissions/roles/edit/%','a:1:{i:5;s:14:"user_role_load";}','','user_role_edit_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:15:"user_admin_role";i:1;i:5;}','','62','6','0','','admin/people/permissions/roles/edit/%','Edit role','t','','','a:0:{}','6','','','0','modules/user/user.admin.inc'),('admin/reports','','','user_access','a:1:{i:0;s:19:"access site reports";}','system_admin_menu_block_page','a:0:{}','','3','2','0','','admin/reports','Reports','t','','','a:0:{}','6','View reports, updates, and errors.','left','5','modules/system/system.admin.inc'),('admin/reports/access-denied','','','user_access','a:1:{i:0;s:19:"access site reports";}','dblog_top','a:1:{i:0;s:13:"access denied";}','','7','3','0','','admin/reports/access-denied','Top ''access denied'' errors','t','','','a:0:{}','6','View ''access denied'' errors (403s).','','0','modules/dblog/dblog.admin.inc'),('admin/reports/access/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:17:"access statistics";}','statistics_access_log','a:1:{i:0;i:3;}','','14','4','0','','admin/reports/access/%','Details','t','','','a:0:{}','6','View access log.','','0','modules/statistics/statistics.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/reports/dblog','','','user_access','a:1:{i:0;s:19:"access site reports";}','dblog_overview','a:0:{}','','7','3','0','','admin/reports/dblog','Recent log messages','t','','','a:0:{}','6','View events that have recently been logged.','','-1','modules/dblog/dblog.admin.inc'),('admin/reports/entityforms','','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:19:"view any entityform";}}}','views_page','a:2:{i:0;s:20:"entityform_type_list";i:1;s:4:"page";}','','7','3','0','','admin/reports/entityforms','Entityform Submissions','t','','','a:0:{}','6','View Submissions for all Entityforms','','0',''),('admin/reports/entityforms/submissions/%','a:1:{i:4;s:20:"entityform_type_load";}','','user_access','a:1:{i:0;s:19:"view any entityform";}','entityform_submission_page','a:3:{i:0;i:4;i:1;i:5;i:2;s:6:"admins";}','','30','5','1','admin/reports/entityforms','admin/reports/entityforms','','entityform_type_page_title','a:2:{i:0;i:1;i:1;s:18:"submissions report";}','','a:0:{}','132','','','0',''),('admin/reports/event/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:19:"access site reports";}','dblog_event','a:1:{i:0;i:3;}','','14','4','0','','admin/reports/event/%','Details','t','','','a:0:{}','6','','','0','modules/dblog/dblog.admin.inc'),('admin/reports/feeds','','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:16:"administer feeds";}}}','views_page','a:2:{i:0;s:9:"feeds_log";i:1;s:6:"page_3";}','','7','3','0','','admin/reports/feeds','Feeds log','t','','','a:0:{}','6','Review log messages of imports and subscriptions to feeds.','','0',''),('admin/reports/fields','','','user_access','a:1:{i:0;s:24:"administer content types";}','field_ui_fields_list','a:0:{}','','7','3','0','','admin/reports/fields','Field list','t','','','a:0:{}','6','Overview of fields on all entity types.','','0','modules/field_ui/field_ui.admin.inc'),('admin/reports/fields/list','','','user_access','a:1:{i:0;s:24:"administer content types";}','field_ui_fields_list','a:0:{}','','15','4','1','admin/reports/fields','admin/reports/fields','List','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/reports/fields/permissions','','','user_access','a:1:{i:0;s:28:"administer field permissions";}','field_permissions_overview','a:0:{}','','15','4','1','admin/reports/fields','admin/reports/fields','Permissions','t','','','a:0:{}','132','Report and troubleshoot field permissions.','','0','sites/all/modules/contrib/field_permissions/field_permissions.admin.inc'),('admin/reports/fields/views-fields','','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_field_list','a:0:{}','','15','4','1','admin/reports/fields','admin/reports/fields','Used in views','t','','','a:0:{}','132','Overview of fields used in all views.','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/reports/hits','','','user_access','a:1:{i:0;s:17:"access statistics";}','statistics_recent_hits','a:0:{}','','7','3','0','','admin/reports/hits','Recent hits','t','','','a:0:{}','6','View pages that have recently been visited.','','0','modules/statistics/statistics.admin.inc'),('admin/reports/libraries','','','user_access','a:1:{i:0;s:19:"access site reports";}','drupal_get_form','a:1:{i:0;s:24:"libraries_admin_overview";}','','7','3','0','','admin/reports/libraries','Libraries','t','','','a:0:{}','6','An overview of libraries installed on this site.','','0','sites/all/modules/contrib/libraries/libraries.admin.inc'),('admin/reports/libraries/%','a:1:{i:3;s:17:"libraries_ui_load";}','','user_access','a:1:{i:0;s:19:"access site reports";}','drupal_get_form','a:2:{i:0;s:35:"libraries_admin_library_status_form";i:1;i:3;}','','14','4','0','','admin/reports/libraries/%','Library status report','t','','','a:0:{}','6','Status overview for a single library','','0','sites/all/modules/contrib/libraries/libraries.admin.inc'),('admin/reports/page-not-found','','','user_access','a:1:{i:0;s:19:"access site reports";}','dblog_top','a:1:{i:0;s:14:"page not found";}','','7','3','0','','admin/reports/page-not-found','Top ''page not found'' errors','t','','','a:0:{}','6','View ''page not found'' errors (404s).','','0','modules/dblog/dblog.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/reports/pages','','','user_access','a:1:{i:0;s:17:"access statistics";}','statistics_top_pages','a:0:{}','','7','3','0','','admin/reports/pages','Top pages','t','','','a:0:{}','6','View pages that have been hit frequently.','','1','modules/statistics/statistics.admin.inc'),('admin/reports/referrers','','','user_access','a:1:{i:0;s:17:"access statistics";}','statistics_top_referrers','a:0:{}','','7','3','0','','admin/reports/referrers','Top referrers','t','','','a:0:{}','6','View top referrers.','','0','modules/statistics/statistics.admin.inc'),('admin/reports/search','','','user_access','a:1:{i:0;s:19:"access site reports";}','dblog_top','a:1:{i:0;s:6:"search";}','','7','3','0','','admin/reports/search','Top search phrases','t','','','a:0:{}','6','View most popular search phrases.','','0','modules/dblog/dblog.admin.inc'),('admin/reports/status','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','system_status','a:0:{}','','7','3','0','','admin/reports/status','Status report','t','','','a:0:{}','6','Get a status report about your site''s operation and any detected problems.','','-60','modules/system/system.admin.inc'),('admin/reports/status/php','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','system_php','a:0:{}','','15','4','0','','admin/reports/status/php','PHP','t','','','a:0:{}','0','','','0','modules/system/system.admin.inc'),('admin/reports/status/rebuild','','','user_access','a:1:{i:0;s:27:"access administration pages";}','drupal_get_form','a:1:{i:0;s:30:"node_configure_rebuild_confirm";}','','15','4','0','','admin/reports/status/rebuild','Rebuild permissions','t','','','a:0:{}','0','','','0','modules/node/node.admin.inc'),('admin/reports/status/run-cron','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','system_run_cron','a:0:{}','','15','4','0','','admin/reports/status/run-cron','Run cron','t','','','a:0:{}','0','','','0','modules/system/system.admin.inc'),('admin/reports/views-plugins','','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_plugin_list','a:0:{}','','7','3','0','','admin/reports/views-plugins','Views plugins','t','','','a:0:{}','6','Overview of plugins used in all views.','','0','sites/all/modules/contrib/views/includes/admin.inc');
INSERT INTO `menu_router` VALUES ('admin/reports/visitors','','','user_access','a:1:{i:0;s:17:"access statistics";}','statistics_top_visitors','a:0:{}','','7','3','0','','admin/reports/visitors','Top visitors','t','','','a:0:{}','6','View visitors that hit many pages.','','2','modules/statistics/statistics.admin.inc'),('admin/structure','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','3','2','0','','admin/structure','Structure','t','','','a:0:{}','6','Administer blocks, content types, menus, etc.','right','-8','modules/system/system.admin.inc'),('admin/structure/block','','','user_access','a:1:{i:0;s:36:"access the block administration page";}','block_admin_display','a:1:{i:0;s:17:"bookpoints_custom";}','','7','3','0','','admin/structure/block','Blocks','t','','','a:0:{}','6','Configure what block content appears in your site''s sidebars and other regions.','','0','modules/block/block.admin.inc'),('admin/structure/block/add','','','user_access','a:1:{i:0;s:13:"create blocks";}','drupal_get_form','a:1:{i:0;s:20:"block_add_block_form";}','','15','4','1','admin/structure/block','admin/structure/block','Add block','t','','','a:0:{}','388','','','0','modules/block/block.admin.inc'),('admin/structure/block/block-access','','','user_access','a:1:{i:0;s:32:"administer block access settings";}','block_access_admin_list','a:0:{}','','15','4','1','admin/structure/block','admin/structure/block','Block Access Settings','t','','','a:0:{}','388','Configure block access defaults','','0','sites/all/modules/contrib/block_access/block_access.admin.inc'),('admin/structure/block/block-access/edit','','','user_access','a:1:{i:0;s:32:"administer block access settings";}','drupal_get_form','a:2:{i:0;s:24:"block_access_module_form";i:1;i:5;}','','31','5','0','','admin/structure/block/block-access/edit','Block Access Settings','t','','','a:0:{}','0','Configure block access defaults','','0','sites/all/modules/contrib/block_access/block_access.admin.inc'),('admin/structure/block/delete','','','block_access_check_delete','a:1:{i:0;i:4;}','block_admin_display','a:1:{i:0;s:17:"bookpoints_custom";}','','15','4','0','','admin/structure/block/delete','','t','','','a:0:{}','6','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/demo/adaptivetheme','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":13:{s:8:"filename";s:57:"sites/all/themes/adaptivetheme/at_core/adaptivetheme.info";s:4:"name";s:13:"adaptivetheme";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:21:{s:4:"name";s:7:"AT Core";s:11:"description";s:210:"AT Core is the framework that drives the responsive layout system and provides an extensive set of tools for theme development. You do not need to enable this theme. Use the provided AT Subtheme to get started.";s:4:"core";s:3:"7.x";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:53:"sites/all/themes/adaptivetheme/at_core/screenshot.png";s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:17:"css/at.layout.css";s:56:"sites/all/themes/adaptivetheme/at_core/css/at.layout.css";}}s:10:"unset_core";a:37:{s:33:"modules/aggregator/aggregator.css";s:14:"aggregator.css";s:23:"modules/block/block.css";s:9:"block.css";s:21:"modules/book/book.css";s:8:"book.css";s:23:"modules/color/color.css";s:9:"color.css";s:27:"modules/comment/comment.css";s:11:"comment.css";s:33:"modules/contextual/contextual.css";s:14:"contextual.css";s:31:"modules/dashboard/dashboard.css";s:13:"dashboard.css";s:23:"modules/dblog/dblog.css";s:9:"dblog.css";s:29:"modules/field/theme/field.css";s:9:"field.css";s:29:"modules/field_ui/field_ui.css";s:12:"field_ui.css";s:21:"modules/file/file.css";s:8:"file.css";s:25:"modules/filter/filter.css";s:10:"filter.css";s:23:"modules/forum/forum.css";s:9:"forum.css";s:21:"modules/help/help.css";s:8:"help.css";s:29:"modules/image/image.admin.css";s:15:"image.admin.css";s:23:"modules/image/image.css";s:9:"image.css";s:25:"modules/locale/locale.css";s:10:"locale.css";s:21:"modules/menu/menu.css";s:8:"menu.css";s:21:"modules/node/node.css";s:8:"node.css";s:25:"modules/openid/openid.css";s:10:"openid.css";s:21:"modules/poll/poll.css";s:8:"poll.css";s:27:"modules/profile/profile.css";s:11:"profile.css";s:25:"modules/search/search.css";s:10:"search.css";s:35:"modules/shortcut/shortcut.admin.css";s:18:"shortcut.admin.css";s:29:"modules/shortcut/shortcut.css";s:12:"shortcut.css";s:33:"modules/simpletest/simpletest.css";s:14:"simpletest.css";s:31:"modules/system/system.admin.css";s:16:"system.admin.css";s:30:"modules/system/system.base.css";s:15:"system.base.css";s:37:"modules/system/system.maintenance.css";s:22:"system.maintenance.css";s:31:"modules/system/system.menus.css";s:16:"system.menus.css";s:34:"modules/system/system.messages.css";s:19:"system.messages.css";s:31:"modules/system/system.theme.css";s:16:"system.theme.css";s:29:"modules/taxonomy/taxonomy.css";s:12:"taxonomy.css";s:27:"modules/toolbar/toolbar.css";s:11:"toolbar.css";s:27:"modules/tracker/tracker.css";s:11:"tracker.css";s:25:"modules/update/update.css";s:10:"update.css";s:21:"modules/user/user.css";s:8:"user.css";}s:7:"regions";a:17:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:7:"content";s:12:"Main Content";s:11:"highlighted";s:11:"Highlighted";s:13:"content_aside";s:5:"Aside";s:17:"secondary_content";s:9:"Secondary";s:16:"tertiary_content";s:8:"Tertiary";s:6:"footer";s:6:"Footer";s:11:"leaderboard";s:11:"Leaderboard";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:7:"plugins";a:2:{s:11:"page_layout";a:1:{s:7:"layouts";s:12:"layouts/core";}s:6:"panels";a:1:{s:7:"layouts";s:14:"layouts/panels";}}s:8:"settings";a:209:{s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1140";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:581px) and (max-width:768px)";s:27:"smalltouch_landscape_layout";s:12:"one_col_vert";s:30:"smalltouch_landscape_page_unit";s:1:"%";s:33:"smalltouch_landscape_sidebar_unit";s:1:"%";s:31:"smalltouch_landscape_page_width";s:3:"100";s:34:"smalltouch_landscape_sidebar_first";s:2:"50";s:35:"smalltouch_landscape_sidebar_second";s:2:"50";s:32:"smalltouch_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:580px)";s:26:"smalltouch_portrait_layout";s:13:"one_col_stack";s:29:"smalltouch_portrait_page_unit";s:1:"%";s:32:"smalltouch_portrait_sidebar_unit";s:1:"%";s:30:"smalltouch_portrait_page_width";s:3:"100";s:33:"smalltouch_portrait_sidebar_first";s:3:"100";s:34:"smalltouch_portrait_sidebar_second";s:3:"100";s:31:"smalltouch_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:9:"five-5x20";s:18:"bigscreen_six_6x16";s:8:"six-6x16";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:9:"five-5x20";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smalltouch_landscape_two_50";s:12:"two-50-stack";s:30:"smalltouch_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smalltouch_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smalltouch_landscape_two_brick";s:15:"two-brick-stack";s:31:"smalltouch_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smalltouch_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smalltouch_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smalltouch_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smalltouch_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smalltouch_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smalltouch_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smalltouch_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smalltouch_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"1";s:21:"global_default_layout";s:19:"smalltouch-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:19:"load_onmediaqueryjs";s:1:"0";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"0";s:20:"enable_font_settings";s:1:"0";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"0";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"0";s:14:"base_font_type";s:6:"<none>";s:19:"site_name_font_type";s:6:"<none>";s:21:"site_slogan_font_type";s:6:"<none>";s:20:"page_title_font_type";s:6:"<none>";s:20:"node_title_font_type";s:6:"<none>";s:23:"comment_title_font_type";s:6:"<none>";s:21:"block_title_font_type";s:6:"<none>";s:19:"main_menu_font_type";s:6:"<none>";s:24:"secondary_menu_font_type";s:6:"<none>";s:20:"block_menu_font_type";s:6:"<none>";s:19:"selectors_font_type";s:6:"<none>";s:14:"base_font_size";s:6:"<none>";s:19:"site_name_font_size";s:6:"<none>";s:21:"site_slogan_font_size";s:6:"<none>";s:20:"page_title_font_size";s:6:"<none>";s:20:"node_title_font_size";s:6:"<none>";s:23:"comment_title_font_size";s:6:"<none>";s:21:"block_title_font_size";s:6:"<none>";s:19:"main_menu_font_size";s:6:"<none>";s:24:"secondary_menu_font_size";s:6:"<none>";s:20:"block_menu_font_size";s:6:"<none>";s:31:"content_headings_h1h4_font_type";s:6:"<none>";s:31:"content_headings_h5h6_font_type";s:6:"<none>";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:14:"site_name_case";s:5:"snc-n";s:16:"site_name_weight";s:5:"snw-b";s:19:"site_name_alignment";s:5:"sna-l";s:16:"site_name_shadow";s:5:"sns-n";s:16:"site_slogan_case";s:5:"ssc-n";s:18:"site_slogan_weight";s:5:"ssw-b";s:21:"site_slogan_alignment";s:5:"ssa-l";s:18:"site_slogan_shadow";s:5:"sss-n";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-l";s:22:"image_alignment_teaser";s:5:"iat-l";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:10:"rel_author";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:56:"width=device-width, initial-scale=1.0, user-scalable=yes";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:35:"adaptivetheme_meta_ie_document_mode";s:0:"";s:29:"adaptivetheme_meta_clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:0:"";s:23:"apple_touch_icon_path_m";s:0:"";s:23:"apple_touch_icon_path_h";s:0:"";s:10:"custom_css";s:0:"";}s:7:"version";s:7:"7.x-3.2";s:7:"project";s:13:"adaptivetheme";s:9:"datestamp";s:10:"1395575059";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:10:"sub_themes";a:4:{s:19:"adaptivetheme_admin";s:8:"AT Admin";s:22:"adaptivetheme_subtheme";s:11:"AT Subtheme";s:17:"bookpoints_custom";s:23:"Bookpoints Customizable";s:7:"corolla";s:7:"Corolla";}s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:17:"css/at.layout.css";s:56:"sites/all/themes/adaptivetheme/at_core/css/at.layout.css";}}s:6:"engine";s:11:"phptemplate";}}','block_admin_demo','a:1:{i:0;s:13:"adaptivetheme";}','','31','5','0','','admin/structure/block/demo/adaptivetheme','AT Core','t','','_block_custom_theme','a:1:{i:0;s:13:"adaptivetheme";}','0','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/demo/adaptivetheme_admin','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":14:{s:8:"filename";s:64:"sites/all/themes/adaptivetheme/at_admin/adaptivetheme_admin.info";s:4:"name";s:19:"adaptivetheme_admin";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:20:{s:4:"name";s:8:"AT Admin";s:11:"description";s:144:"A better admin theme for Drupal 7. Clean, calm, invisible. Includes left and right sidebars, Overlay support and all AT''s theme setting goodies.";s:4:"core";s:3:"7.x";s:10:"base theme";s:13:"adaptivetheme";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:54:"sites/all/themes/adaptivetheme/at_admin/screenshot.png";s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:16:"css/at_admin.css";s:56:"sites/all/themes/adaptivetheme/at_admin/css/at_admin.css";}}s:7:"regions";a:11:{s:7:"content";s:12:"Main content";s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:11:"highlighted";s:11:"Highlighted";s:4:"help";s:4:"Help";s:6:"footer";s:6:"Footer";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"settings";a:210:{s:20:"shortcut_module_link";s:1:"1";s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:2:"px";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:3:"180";s:24:"bigscreen_sidebar_second";s:3:"180";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1330";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:581px) and (max-width:768px)";s:27:"smalltouch_landscape_layout";s:12:"one_col_vert";s:30:"smalltouch_landscape_page_unit";s:1:"%";s:33:"smalltouch_landscape_sidebar_unit";s:1:"%";s:31:"smalltouch_landscape_page_width";s:3:"100";s:34:"smalltouch_landscape_sidebar_first";s:2:"50";s:35:"smalltouch_landscape_sidebar_second";s:2:"50";s:32:"smalltouch_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:580px)";s:26:"smalltouch_portrait_layout";s:13:"one_col_stack";s:29:"smalltouch_portrait_page_unit";s:1:"%";s:32:"smalltouch_portrait_sidebar_unit";s:1:"%";s:30:"smalltouch_portrait_page_width";s:3:"100";s:33:"smalltouch_portrait_sidebar_first";s:3:"100";s:34:"smalltouch_portrait_sidebar_second";s:3:"100";s:31:"smalltouch_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:9:"five-5x20";s:18:"bigscreen_six_6x16";s:8:"six-6x16";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:18:"five-5x20-2x3-grid";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smalltouch_landscape_two_50";s:12:"two-50-stack";s:30:"smalltouch_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smalltouch_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smalltouch_landscape_two_brick";s:15:"two-brick-stack";s:31:"smalltouch_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smalltouch_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smalltouch_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smalltouch_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smalltouch_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smalltouch_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smalltouch_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smalltouch_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smalltouch_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"0";s:21:"global_default_layout";s:19:"smalltouch-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:19:"load_onmediaqueryjs";s:1:"0";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"1";s:20:"enable_font_settings";s:1:"0";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"0";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"1";s:14:"base_font_type";s:0:"";s:19:"site_name_font_type";s:0:"";s:21:"site_slogan_font_type";s:0:"";s:20:"page_title_font_type";s:0:"";s:20:"node_title_font_type";s:0:"";s:23:"comment_title_font_type";s:0:"";s:21:"block_title_font_type";s:0:"";s:9:"base_font";s:6:"bf-sss";s:14:"site_name_font";s:6:"snf-sl";s:16:"site_slogan_font";s:6:"ssf-sl";s:14:"main_menu_font";s:6:"mmf-sl";s:15:"page_title_font";s:6:"ptf-sl";s:15:"node_title_font";s:6:"ntf-sl";s:18:"comment_title_font";s:6:"ctf-sl";s:16:"block_title_font";s:6:"btf-sl";s:14:"base_font_size";s:3:"1em";s:19:"site_name_font_size";s:3:"2em";s:21:"site_slogan_font_size";s:5:"1.2em";s:20:"page_title_font_size";s:3:"2em";s:20:"node_title_font_size";s:5:"1.6em";s:23:"comment_title_font_size";s:5:"1.4em";s:21:"block_title_font_size";s:5:"1.4em";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:14:"site_name_case";s:5:"snc-n";s:16:"site_name_weight";s:5:"snw-b";s:19:"site_name_alignment";s:5:"sna-l";s:16:"site_name_shadow";s:5:"sns-n";s:16:"site_slogan_case";s:5:"ssc-n";s:18:"site_slogan_weight";s:5:"ssw-b";s:21:"site_slogan_alignment";s:5:"ssa-l";s:18:"site_slogan_shadow";s:5:"sss-n";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:6:"btc-uc";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-l";s:22:"image_alignment_teaser";s:5:"iat-l";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"1";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"1";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:10:"rel_author";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:56:"width=device-width, initial-scale=1.0, user-scalable=yes";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:35:"adaptivetheme_meta_ie_document_mode";s:0:"";s:29:"adaptivetheme_meta_clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:23:"images/touch-icon-l.png";s:23:"apple_touch_icon_path_m";s:23:"images/touch-icon-m.png";s:23:"apple_touch_icon_path_h";s:23:"images/touch-icon-h.png";s:10:"custom_css";s:0:"";}s:8:"features";a:5:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:7:"favicon";i:3;s:9:"main_menu";i:4;s:14:"secondary_menu";}s:7:"version";s:7:"7.x-3.2";s:7:"project";s:13:"adaptivetheme";s:9:"datestamp";s:10:"1395575059";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:11:"base_themes";a:1:{s:13:"adaptivetheme";s:7:"AT Core";}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:16:"css/at_admin.css";s:56:"sites/all/themes/adaptivetheme/at_admin/css/at_admin.css";}}s:6:"engine";s:11:"phptemplate";s:10:"base_theme";s:13:"adaptivetheme";}}','block_admin_demo','a:1:{i:0;s:19:"adaptivetheme_admin";}','','31','5','0','','admin/structure/block/demo/adaptivetheme_admin','AT Admin','t','','_block_custom_theme','a:1:{i:0;s:19:"adaptivetheme_admin";}','0','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/demo/adaptivetheme_subtheme','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":14:{s:8:"filename";s:70:"sites/all/themes/adaptivetheme/at_subtheme/adaptivetheme_subtheme.info";s:4:"name";s:22:"adaptivetheme_subtheme";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:21:{s:4:"name";s:11:"AT Subtheme";s:11:"description";s:580:"Copy this subtheme to get started - see the <b><a href="http://adaptivethemes.com/documentation/adaptivethemes-documentation" target="_blank" title="Adaptivethemes.com - Rocking the hardest since 2006">documentation</a></b> for guidence or the included README. Drush users can generate a new theme using the command: drush adaptivetheme. If you need help please use the <b><a href="http://drupal.org/project/issues/adaptivetheme" target="_blank">issue queue</a></b> or ask in the IRC channel: <b><a href="irc://irc.freenode.net/drupal-adaptivetheme">#drupal-adaptivetheme</a></b>.";s:4:"core";s:3:"7.x";s:10:"base theme";s:13:"adaptivetheme";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:57:"sites/all/themes/adaptivetheme/at_subtheme/screenshot.png";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:19:"css/global.base.css";s:62:"sites/all/themes/adaptivetheme/at_subtheme/css/global.base.css";s:21:"css/global.styles.css";s:64:"sites/all/themes/adaptivetheme/at_subtheme/css/global.styles.css";}}s:7:"regions";a:17:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:7:"content";s:12:"Main Content";s:11:"highlighted";s:11:"Highlighted";s:13:"content_aside";s:5:"Aside";s:17:"secondary_content";s:9:"Secondary";s:16:"tertiary_content";s:8:"Tertiary";s:6:"footer";s:6:"Footer";s:11:"leaderboard";s:11:"Leaderboard";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:":plugins";a:2:{s:11:"page_layout";a:1:{s:7:"layouts";s:12:"layouts/page";}s:6:"panels";a:1:{s:7:"layouts";s:14:"layouts/panels";}}s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:6:"slogan";i:3;s:17:"node_user_picture";i:4;s:20:"comment_user_picture";i:5;s:25:"comment_user_verification";i:6;s:7:"favicon";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:8:"settings";a:231:{s:11:"toggle_logo";s:1:"1";s:11:"toggle_name";s:1:"1";s:13:"toggle_slogan";s:1:"1";s:24:"toggle_node_user_picture";s:1:"1";s:27:"toggle_comment_user_picture";s:1:"1";s:32:"toggle_comment_user_verification";s:1:"1";s:14:"toggle_favicon";s:1:"1";s:16:"toggle_main_menu";s:1:"1";s:21:"toggle_secondary_menu";s:1:"1";s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1140";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:581px) and (max-width:768px)";s:27:"smalltouch_landscape_layout";s:12:"one_col_vert";s:30:"smalltouch_landscape_page_unit";s:1:"%";s:33:"smalltouch_landscape_sidebar_unit";s:1:"%";s:31:"smalltouch_landscape_page_width";s:3:"100";s:34:"smalltouch_landscape_sidebar_first";s:2:"50";s:35:"smalltouch_landscape_sidebar_second";s:2:"50";s:32:"smalltouch_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:580px)";s:26:"smalltouch_portrait_layout";s:13:"one_col_stack";s:29:"smalltouch_portrait_page_unit";s:1:"%";s:32:"smalltouch_portrait_sidebar_unit";s:1:"%";s:30:"smalltouch_portrait_page_width";s:3:"100";s:33:"smalltouch_portrait_sidebar_first";s:3:"100";s:34:"smalltouch_portrait_sidebar_second";s:3:"100";s:31:"smalltouch_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:18:"five-5x20-2x3-grid";s:18:"bigscreen_six_6x16";s:17:"six-6x16-3x2-grid";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:9:"five-5x20";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smalltouch_landscape_two_50";s:12:"two-50-stack";s:30:"smalltouch_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smalltouch_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smalltouch_landscape_two_brick";s:15:"two-brick-stack";s:31:"smalltouch_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smalltouch_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smalltouch_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smalltouch_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smalltouch_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smalltouch_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smalltouch_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smalltouch_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smalltouch_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"1";s:21:"global_default_layout";s:19:"smalltouch-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"0";s:20:"enable_font_settings";s:1:"0";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"0";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"0";s:14:"base_font_type";s:6:"<none>";s:19:"site_name_font_type";s:6:"<none>";s:21:"site_slogan_font_type";s:6:"<none>";s:20:"page_title_font_type";s:6:"<none>";s:20:"node_title_font_type";s:6:"<none>";s:23:"comment_title_font_type";s:6:"<none>";s:21:"block_title_font_type";s:6:"<none>";s:19:"main_menu_font_type";s:6:"<none>";s:24:"secondary_menu_font_type";s:6:"<none>";s:20:"block_menu_font_type";s:6:"<none>";s:19:"selectors_font_type";s:6:"<none>";s:31:"content_headings_h1h4_font_type";s:6:"<none>";s:31:"content_headings_h5h6_font_type";s:6:"<none>";s:14:"base_font_size";s:6:"<none>";s:19:"site_name_font_size";s:6:"<none>";s:21:"site_slogan_font_size";s:6:"<none>";s:20:"page_title_font_size";s:6:"<none>";s:20:"node_title_font_size";s:6:"<none>";s:23:"comment_title_font_size";s:6:"<none>";s:21:"block_title_font_size";s:6:"<none>";s:19:"main_menu_font_size";s:6:"<none>";s:24:"secondary_menu_font_size";s:6:"<none>";s:20:"block_menu_font_size";s:6:"<none>";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:14:"site_name_case";s:5:"snc-n";s:16:"site_name_weight";s:5:"snw-b";s:19:"site_name_alignment";s:5:"sna-l";s:16:"site_name_shadow";s:5:"sns-n";s:16:"site_slogan_case";s:5:"ssc-n";s:18:"site_slogan_weight";s:5:"ssw-b";s:21:"site_slogan_alignment";s:5:"ssa-l";s:18:"site_slogan_shadow";s:5:"sss-n";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-n";s:22:"image_alignment_teaser";s:5:"iat-n";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:20:"user_block_user_name";s:1:"1";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:17:"unset_menu_titles";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:10:"rel_author";s:1:"0";s:27:"menu_toggle_tablet_portrait";s:1:"1";s:28:"menu_toggle_tablet_landscape";s:1:"0";s:21:"menu_toggle_main_menu";s:1:"1";s:26:"menu_toggle_secondary_menu";s:1:"1";s:23:"menu_toggle_leaderboard";s:1:"0";s:18:"menu_toggle_header";s:1:"0";s:20:"menu_toggle_menu_bar";s:1:"1";s:27:"menu_toggle_main_menu_title";s:9:"Main menu";s:32:"menu_toggle_secondary_menu_title";s:9:"User menu";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:56:"width=device-width, initial-scale=1.0, user-scalable=yes";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:35:"adaptivetheme_meta_ie_document_mode";s:0:"";s:29:"adaptivetheme_meta_clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:17:"icon_path_default";s:24:"images/default-60x60.png";s:26:"apple_touch_icon_path_ipad";s:30:"images/ipad-standard-76x76.png";s:35:"apple_touch_icon_path_iphone_retina";s:32:"images/iphone-retina-120x120.png";s:33:"apple_touch_icon_path_ipad_retina";s:30:"images/ipad-retina-152x152.png";s:8:"icon_rel";s:1:"0";s:10:"custom_css";s:0:"";}s:7:"version";s:7:"7.x-3.2";s:7:"project";s:13:"adaptivetheme";s:9:"datestamp";s:10:"1395575059";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:11:"base_themes";a:1:{s:13:"adaptivetheme";s:7:"AT Core";}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:19:"css/global.base.css";s:62:"sites/all/themes/adaptivetheme/at_subtheme/css/global.base.css";s:21:"css/global.styles.css";s:64:"sites/all/themes/adaptivetheme/at_subtheme/css/global.styles.css";}}s:6:"engine";s:11:"phptemplate";s:10:"base_theme";s:13:"adaptivetheme";}}','block_admin_demo','a:1:{i:0;s:22:"adaptivetheme_subtheme";}','','31','5','0','','admin/structure/block/demo/adaptivetheme_subtheme','AT Subtheme','t','','_block_custom_theme','a:1:{i:0;s:22:"adaptivetheme_subtheme";}','0','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/demo/bartik','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:25:"themes/bartik/bartik.info";s:4:"name";s:6:"bartik";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:19:{s:4:"name";s:6:"Bartik";s:11:"description";s:48:"A flexible, recolorable theme with many regions.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:2:{s:3:"all";a:3:{s:14:"css/layout.css";s:28:"themes/bartik/css/layout.css";s:13:"css/style.css";s:27:"themes/bartik/css/style.css";s:14:"css/colors.css";s:28:"themes/bartik/css/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:27:"themes/bartik/css/print.css";}}s:7:"regions";a:20:{s:6:"header";s:6:"Header";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:11:"highlighted";s:11:"Highlighted";s:8:"featured";s:8:"Featured";s:7:"content";s:7:"Content";s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:14:"triptych_first";s:14:"Triptych first";s:15:"triptych_middle";s:15:"Triptych middle";s:13:"triptych_last";s:13:"Triptych last";s:18:"footer_firstcolumn";s:19:"Footer first column";s:19:"footer_secondcolumn";s:20:"Footer second column";s:18:"footer_thirdcolumn";s:19:"Footer third column";s:19:"footer_fourthcolumn";s:20:"Footer fourth column";s:6:"footer";s:6:"Footer";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"settings";a:1:{s:20:"shortcut_module_link";s:1:"0";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:28:"themes/bartik/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:2:{s:3:"all";a:3:{s:14:"css/layout.css";s:28:"themes/bartik/css/layout.css";s:13:"css/style.css";s:27:"themes/bartik/css/style.css";s:14:"css/colors.css";s:28:"themes/bartik/css/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:27:"themes/bartik/css/print.css";}}s:6:"engine";s:11:"phptemplate";}}','block_admin_demo','a:1:{i:0;s:6:"bartik";}','','31','5','0','','admin/structure/block/demo/bartik','Bartik','t','','_block_custom_theme','a:1:{i:0;s:6:"bartik";}','0','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/demo/bookpoints_custom','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":15:{s:8:"filename";s:57:"sites/all/themes/bookpoints_custom/bookpoints_custom.info";s:4:"name";s:17:"bookpoints_custom";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"1";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:18:{s:4:"name";s:23:"Bookpoints Customizable";s:11:"description";s:68:"A customizable, color-able theme built on AdaptiveTheme and Corolla.";s:4:"core";s:3:"7.x";s:7:"release";s:7:"7.x-3.x";s:10:"base theme";s:7:"corolla";s:11:"stylesheets";a:1:{s:3:"all";a:3:{s:16:"color/colors.css";s:51:"sites/all/themes/bookpoints_custom/color/colors.css";s:14:"css/styles.css";s:49:"sites/all/themes/bookpoints_custom/css/styles.css";s:24:"css/reader_dashboard.css";s:59:"sites/all/themes/bookpoints_custom/css/reader_dashboard.css";}}s:14:"ie_stylesheets";a:1:{s:6:"screen";a:1:{s:8:"lte IE 9";a:1:{i:0;s:16:"css/ie-lte-9.css";}}}s:7:"scripts";a:1:{s:11:"js/stars.js";s:46:"sites/all/themes/bookpoints_custom/js/stars.js";}s:7:"regions";a:25:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:11:"highlighted";s:11:"Highlighted";s:7:"content";s:12:"Main content";s:13:"content_aside";s:14:"Content bottom";s:17:"secondary_content";s:17:"Secondary content";s:16:"tertiary_content";s:16:"Tertiary content";s:6:"footer";s:6:"Footer";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:12:"three_33_top";s:26:"AT Three column 3x33 - top";s:14:"three_33_first";s:27:"AT Three column 3x33 - left";s:15:"three_33_second";s:29:"AT Three column 3x33 - center";s:14:"three_33_third";s:28:"AT Three column 3x33 - right";s:15:"three_33_bottom";s:29:"AT Three column 3x33 - bottom";s:10:"four_first";s:23:"AT Four column 4x25 - 1";s:11:"four_second";s:23:"AT Four column 4x25 - 2";s:10:"four_third";s:23:"AT Four column 4x25 - 3";s:11:"four_fourth";s:23:"AT Four column 4x25 - 4";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:7:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:6:"slogan";i:3;s:17:"node_user_picture";i:4;s:20:"comment_user_picture";i:5;s:25:"comment_user_verification";i:6;s:7:"favicon";}s:8:"settings";a:206:{s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1200";s:21:"bigscreen_media_query";s:37:"only screen and (min-width:64.0625em)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:58:"only screen and (min-width:48.0625em) and (max-width:64em)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:58:"only screen and (min-width:30.0625em) and (max-width:48em)";s:27:"smartphone_landscape_layout";s:12:"one_col_vert";s:30:"smartphone_landscape_page_unit";s:1:"%";s:33:"smartphone_landscape_sidebar_unit";s:1:"%";s:31:"smartphone_landscape_page_width";s:3:"100";s:34:"smartphone_landscape_sidebar_first";s:2:"50";s:35:"smartphone_landscape_sidebar_second";s:2:"50";s:32:"smartphone_landscape_media_query";s:58:"only screen and (min-width:20.0625em) and (max-width:30em)";s:26:"smartphone_portrait_layout";s:13:"one_col_stack";s:29:"smartphone_portrait_page_unit";s:1:"%";s:32:"smartphone_portrait_sidebar_unit";s:1:"%";s:30:"smartphone_portrait_page_width";s:3:"100";s:33:"smartphone_portrait_sidebar_first";s:3:"100";s:34:"smartphone_portrait_sidebar_second";s:3:"100";s:31:"smartphone_portrait_media_query";s:32:"only screen and (max-width:20em)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:18:"five-5x20-2x3-grid";s:18:"bigscreen_six_6x16";s:17:"six-6x16-3x2-grid";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:18:"five-5x20-2x3-grid";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smartphone_landscape_two_50";s:12:"two-50-stack";s:30:"smartphone_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smartphone_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smartphone_landscape_two_brick";s:15:"two-brick-stack";s:31:"smartphone_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smartphone_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smartphone_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smartphone_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smartphone_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smartphone_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smartphone_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smartphone_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smartphone_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"0";s:21:"global_default_layout";s:19:"smartphone-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"1";s:20:"enable_font_settings";s:1:"1";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"1";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:18:"enable_menu_toggle";s:1:"1";s:22:"enable_markup_overides";s:1:"1";s:14:"base_font_type";s:0:"";s:19:"site_name_font_type";s:0:"";s:21:"site_slogan_font_type";s:0:"";s:20:"page_title_font_type";s:0:"";s:20:"node_title_font_type";s:0:"";s:23:"comment_title_font_type";s:0:"";s:21:"block_title_font_type";s:0:"";s:9:"base_font";s:6:"bf-sss";s:14:"site_name_font";s:6:"snf-sl";s:16:"site_slogan_font";s:6:"ssf-sl";s:14:"main_menu_font";s:6:"mmf-sl";s:15:"page_title_font";s:6:"ptf-sl";s:15:"node_title_font";s:6:"ntf-sl";s:18:"comment_title_font";s:6:"ctf-sl";s:16:"block_title_font";s:6:"btf-sl";s:14:"base_font_size";s:3:"1em";s:19:"site_name_font_size";s:5:"3.5em";s:21:"site_slogan_font_size";s:5:"1.2em";s:20:"page_title_font_size";s:3:"2em";s:20:"node_title_font_size";s:5:"1.6em";s:23:"comment_title_font_size";s:5:"1.4em";s:21:"block_title_font_size";s:5:"1.4em";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-n";s:22:"image_alignment_teaser";s:5:"iat-n";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:17:"unset_menu_titles";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:35:"width=device-width, initial-scale=1";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:11:"chrome_edge";s:1:"0";s:10:"clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:23:"images/touch-icon-l.png";s:23:"apple_touch_icon_path_m";s:23:"images/touch-icon-m.png";s:23:"apple_touch_icon_path_h";s:23:"images/touch-icon-h.png";s:10:"custom_css";s:0:"";s:21:"content_corner_radius";s:4:"rc-6";s:18:"tabs_corner_radius";s:5:"rct-6";s:11:"box_shadows";s:4:"bs-n";s:15:"body_background";s:4:"bb-n";s:12:"menu_bullets";s:5:"mb-dd";s:17:"menu_bar_position";s:5:"mbp-l";}s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:49:"sites/all/themes/bookpoints_custom/screenshot.png";s:3:"php";s:5:"5.2.4";s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:11:"base_themes";a:2:{s:13:"adaptivetheme";s:7:"AT Core";s:7:"corolla";s:7:"Corolla";}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:3:"all";a:3:{s:16:"color/colors.css";s:51:"sites/all/themes/bookpoints_custom/color/colors.css";s:14:"css/styles.css";s:49:"sites/all/themes/bookpoints_custom/css/styles.css";s:24:"css/reader_dashboard.css";s:59:"sites/all/themes/bookpoints_custom/css/reader_dashboard.css";}}s:7:"scripts";a:1:{s:11:"js/stars.js";s:46:"sites/all/themes/bookpoints_custom/js/stars.js";}s:6:"engine";s:11:"phptemplate";s:10:"base_theme";s:7:"corolla";}}','block_admin_demo','a:1:{i:0;s:17:"bookpoints_custom";}','','31','5','0','','admin/structure/block/demo/bookpoints_custom','Bookpoints Customizable','t','','_block_custom_theme','a:1:{i:0;s:17:"bookpoints_custom";}','0','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/demo/corolla','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":15:{s:8:"filename";s:37:"sites/all/themes/corolla/corolla.info";s:4:"name";s:7:"corolla";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:21:{s:4:"name";s:7:"Corolla";s:11:"description";s:367:"Corolla is a subtheme of <a href="http://drupal.org/project/adaptivetheme">Adaptivetheme 7.x-3.x</a>. To use this theme you must first download and install the 7.x-3.x version of Adaptivetheme. Corolla is colorable and has many theme settings for layout, fonts, headings and much more. Corolla also supports layouts for mobile devices such as tablets and smartphones.";s:4:"core";s:3:"7.x";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"base theme";s:13:"adaptivetheme";s:10:"screenshot";s:39:"sites/all/themes/corolla/screenshot.png";s:11:"stylesheets";a:2:{s:3:"all";a:12:{s:21:"css/html-elements.css";s:46:"sites/all/themes/corolla/css/html-elements.css";s:13:"css/forms.css";s:38:"sites/all/themes/corolla/css/forms.css";s:14:"css/tables.css";s:39:"sites/all/themes/corolla/css/tables.css";s:12:"css/page.css";s:37:"sites/all/themes/corolla/css/page.css";s:16:"css/articles.css";s:41:"sites/all/themes/corolla/css/articles.css";s:16:"css/comments.css";s:41:"sites/all/themes/corolla/css/comments.css";s:14:"css/fields.css";s:39:"sites/all/themes/corolla/css/fields.css";s:14:"css/blocks.css";s:39:"sites/all/themes/corolla/css/blocks.css";s:18:"css/navigation.css";s:43:"sites/all/themes/corolla/css/navigation.css";s:13:"css/fonts.css";s:38:"sites/all/themes/corolla/css/fonts.css";s:30:"css/corolla.settings.style.css";s:55:"sites/all/themes/corolla/css/corolla.settings.style.css";s:16:"color/colors.css";s:41:"sites/all/themes/corolla/color/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:38:"sites/all/themes/corolla/css/print.css";}}s:14:"ie_stylesheets";a:1:{s:6:"screen";a:1:{s:8:"lte IE 9";a:1:{i:0;s:16:"css/ie-lte-9.css";}}}s:7:"regions";a:25:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:11:"highlighted";s:11:"Highlighted";s:7:"content";s:12:"Main content";s:13:"content_aside";s:14:"Content bottom";s:17:"secondary_content";s:17:"Secondary content";s:16:"tertiary_content";s:16:"Tertiary content";s:6:"footer";s:6:"Footer";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:12:"three_33_top";s:26:"AT Three column 3x33 - top";s:14:"three_33_first";s:27:"AT Three column 3x33 - left";s:15:"three_33_second";s:29:"AT Three column 3x33 - center";s:14:"three_33_third";s:28:"AT Three column 3x33 - right";s:15:"three_33_bottom";s:29:"AT Three column 3x33 - bottom";s:10:"four_first";s:23:"AT Four column 4x25 - 1";s:11:"four_second";s:23:"AT Four column 4x25 - 2";s:10:"four_third";s:23:"AT Four column 4x25 - 3";s:11:"four_fourth";s:23:"AT Four column 4x25 - 4";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:7:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:6:"slogan";i:3;s:17:"node_user_picture";i:4;s:20:"comment_user_picture";i:5;s:25:"comment_user_verification";i:6;s:7:"favicon";}s:8:"settings";a:213:{s:11:"toggle_logo";s:1:"1";s:11:"toggle_name";s:1:"1";s:13:"toggle_slogan";s:1:"1";s:24:"toggle_node_user_picture";s:1:"1";s:27:"toggle_comment_user_picture";s:1:"1";s:32:"toggle_comment_user_verification";s:1:"1";s:14:"toggle_favicon";s:1:"1";s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1140";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:481px) and (max-width:768px)";s:27:"smartphone_landscape_layout";s:12:"one_col_vert";s:30:"smartphone_landscape_page_unit";s:1:"%";s:33:"smartphone_landscape_sidebar_unit";s:1:"%";s:31:"smartphone_landscape_page_width";s:3:"100";s:34:"smartphone_landscape_sidebar_first";s:2:"50";s:35:"smartphone_landscape_sidebar_second";s:2:"50";s:32:"smartphone_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:480px)";s:26:"smartphone_portrait_layout";s:13:"one_col_stack";s:29:"smartphone_portrait_page_unit";s:1:"%";s:32:"smartphone_portrait_sidebar_unit";s:1:"%";s:30:"smartphone_portrait_page_width";s:3:"100";s:33:"smartphone_portrait_sidebar_first";s:3:"100";s:34:"smartphone_portrait_sidebar_second";s:3:"100";s:31:"smartphone_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:18:"five-5x20-2x3-grid";s:18:"bigscreen_six_6x16";s:17:"six-6x16-3x2-grid";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:18:"five-5x20-2x3-grid";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smartphone_landscape_two_50";s:12:"two-50-stack";s:30:"smartphone_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smartphone_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smartphone_landscape_two_brick";s:15:"two-brick-stack";s:31:"smartphone_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smartphone_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smartphone_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smartphone_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smartphone_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smartphone_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smartphone_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smartphone_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smartphone_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"0";s:21:"global_default_layout";s:19:"smartphone-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"1";s:20:"enable_font_settings";s:1:"1";s:23:"enable_heading_settings";s:1:"1";s:21:"enable_image_settings";s:1:"1";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"1";s:14:"base_font_type";s:0:"";s:19:"site_name_font_type";s:0:"";s:21:"site_slogan_font_type";s:0:"";s:20:"page_title_font_type";s:0:"";s:20:"node_title_font_type";s:0:"";s:23:"comment_title_font_type";s:0:"";s:21:"block_title_font_type";s:0:"";s:9:"base_font";s:6:"bf-sss";s:14:"site_name_font";s:6:"snf-sl";s:16:"site_slogan_font";s:6:"ssf-sl";s:14:"main_menu_font";s:6:"mmf-sl";s:15:"page_title_font";s:6:"ptf-sl";s:15:"node_title_font";s:6:"ntf-sl";s:18:"comment_title_font";s:6:"ctf-sl";s:16:"block_title_font";s:6:"btf-sl";s:14:"base_font_size";s:3:"1em";s:19:"site_name_font_size";s:5:"3.5em";s:21:"site_slogan_font_size";s:5:"1.2em";s:20:"page_title_font_size";s:3:"2em";s:20:"node_title_font_size";s:5:"1.6em";s:23:"comment_title_font_size";s:5:"1.4em";s:21:"block_title_font_size";s:5:"1.4em";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-n";s:22:"image_alignment_teaser";s:5:"iat-n";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:17:"unset_menu_titles";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:35:"width=device-width, initial-scale=1";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:11:"chrome_edge";s:1:"0";s:10:"clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:23:"images/touch-icon-l.png";s:23:"apple_touch_icon_path_m";s:23:"images/touch-icon-m.png";s:23:"apple_touch_icon_path_h";s:23:"images/touch-icon-h.png";s:10:"custom_css";s:0:"";s:21:"content_corner_radius";s:4:"rc-6";s:18:"tabs_corner_radius";s:5:"rct-6";s:11:"box_shadows";s:4:"bs-n";s:15:"body_background";s:4:"bb-n";s:12:"menu_bullets";s:5:"mb-dd";s:17:"menu_bar_position";s:5:"mbp-l";}s:7:"version";s:7:"7.x-3.0";s:7:"project";s:7:"corolla";s:9:"datestamp";s:10:"1395577158";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:10:"sub_themes";a:1:{s:17:"bookpoints_custom";s:23:"Bookpoints Customizable";}s:11:"base_themes";a:1:{s:13:"adaptivetheme";s:7:"AT Core";}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:2:{s:3:"all";a:12:{s:21:"css/html-elements.css";s:46:"sites/all/themes/corolla/css/html-elements.css";s:13:"css/forms.css";s:38:"sites/all/themes/corolla/css/forms.css";s:14:"css/tables.css";s:39:"sites/all/themes/corolla/css/tables.css";s:12:"css/page.css";s:37:"sites/all/themes/corolla/css/page.css";s:16:"css/articles.css";s:41:"sites/all/themes/corolla/css/articles.css";s:16:"css/comments.css";s:41:"sites/all/themes/corolla/css/comments.css";s:14:"css/fields.css";s:39:"sites/all/themes/corolla/css/fields.css";s:14:"css/blocks.css";s:39:"sites/all/themes/corolla/css/blocks.css";s:18:"css/navigation.css";s:43:"sites/all/themes/corolla/css/navigation.css";s:13:"css/fonts.css";s:38:"sites/all/themes/corolla/css/fonts.css";s:30:"css/corolla.settings.style.css";s:55:"sites/all/themes/corolla/css/corolla.settings.style.css";s:16:"color/colors.css";s:41:"sites/all/themes/corolla/color/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:38:"sites/all/themes/corolla/css/print.css";}}s:6:"engine";s:11:"phptemplate";s:10:"base_theme";s:13:"adaptivetheme";}}','block_admin_demo','a:1:{i:0;s:7:"corolla";}','','31','5','0','','admin/structure/block/demo/corolla','Corolla','t','','_block_custom_theme','a:1:{i:0;s:7:"corolla";}','0','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/demo/garland','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:27:"themes/garland/garland.info";s:4:"name";s:7:"garland";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:19:{s:4:"name";s:7:"Garland";s:11:"description";s:111:"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:2:{s:3:"all";a:1:{s:9:"style.css";s:24:"themes/garland/style.css";}s:5:"print";a:1:{s:9:"print.css";s:24:"themes/garland/print.css";}}s:8:"settings";a:1:{s:13:"garland_width";s:5:"fluid";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:7:"regions";a:12:{s:13:"sidebar_first";s:12:"Left sidebar";s:14:"sidebar_second";s:13:"Right sidebar";s:7:"content";s:7:"Content";s:6:"header";s:6:"Header";s:6:"footer";s:6:"Footer";s:11:"highlighted";s:11:"Highlighted";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:29:"themes/garland/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:2:{s:3:"all";a:1:{s:9:"style.css";s:24:"themes/garland/style.css";}s:5:"print";a:1:{s:9:"print.css";s:24:"themes/garland/print.css";}}s:6:"engine";s:11:"phptemplate";}}','block_admin_demo','a:1:{i:0;s:7:"garland";}','','31','5','0','','admin/structure/block/demo/garland','Garland','t','','_block_custom_theme','a:1:{i:0;s:7:"garland";}','0','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/demo/seven','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:23:"themes/seven/seven.info";s:4:"name";s:5:"seven";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:19:{s:4:"name";s:5:"Seven";s:11:"description";s:65:"A simple one-column, tableless, fluid width administration theme.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:9:"reset.css";s:22:"themes/seven/reset.css";s:9:"style.css";s:22:"themes/seven/style.css";}}s:8:"settings";a:1:{s:20:"shortcut_module_link";s:1:"1";}s:7:"regions";a:8:{s:7:"content";s:7:"Content";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:13:"sidebar_first";s:13:"First sidebar";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:14:"regions_hidden";a:3:{i:0;s:13:"sidebar_first";i:1;s:8:"page_top";i:2;s:11:"page_bottom";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:27:"themes/seven/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:9:"reset.css";s:22:"themes/seven/reset.css";s:9:"style.css";s:22:"themes/seven/style.css";}}s:6:"engine";s:11:"phptemplate";}}','block_admin_demo','a:1:{i:0;s:5:"seven";}','','31','5','0','','admin/structure/block/demo/seven','Seven','t','','_block_custom_theme','a:1:{i:0;s:5:"seven";}','0','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/demo/skeletontheme','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:49:"sites/all/themes/skeletontheme/skeletontheme.info";s:4:"name";s:13:"skeletontheme";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:18:{s:4:"name";s:8:"Skeleton";s:11:"description";s:361:"Skeleton is a powerful, clean, responsive theme ported to Drupal by <a href="http://www.morethanthemes.com/" target="_blank">More Than (just) Themes</a>. If you like this theme, we encourage you to try also our other <a href="http://www.morethanthemes.com" target="_blank">Premium</a> and <a href="http://drupalizing.com" target="_blank">Free</a> Drupal themes.";s:7:"version";s:7:"7.x-1.4";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:3:"all";a:5:{s:16:"css/skeleton.css";s:47:"sites/all/themes/skeletontheme/css/skeleton.css";s:13:"css/style.css";s:44:"sites/all/themes/skeletontheme/css/style.css";s:15:"css/buttons.css";s:46:"sites/all/themes/skeletontheme/css/buttons.css";s:14:"css/layout.css";s:45:"sites/all/themes/skeletontheme/css/layout.css";s:16:"color/colors.css";s:47:"sites/all/themes/skeletontheme/color/colors.css";}}s:7:"regions";a:20:{s:15:"header_top_left";s:15:"Header top left";s:16:"header_top_right";s:16:"Header top right";s:12:"header_right";s:12:"Header right";s:6:"header";s:6:"Header";s:11:"highlighted";s:11:"Highlighted";s:7:"content";s:7:"Content";s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:13:"featured_left";s:13:"Featured left";s:14:"featured_right";s:14:"Featured right";s:12:"footer_first";s:12:"Footer first";s:13:"footer_second";s:13:"Footer second";s:12:"footer_third";s:12:"Footer third";s:6:"footer";s:6:"Footer";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"settings";a:3:{s:21:"responsive_menu_state";s:1:"1";s:27:"responsive_menu_switchwidth";s:3:"760";s:29:"responsive_menu_topoptiontext";s:13:"Select a page";}s:7:"project";s:13:"skeletontheme";s:9:"datestamp";s:10:"1396987453";s:6:"engine";s:11:"phptemplate";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:45:"sites/all/themes/skeletontheme/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:3:"all";a:5:{s:16:"css/skeleton.css";s:47:"sites/all/themes/skeletontheme/css/skeleton.css";s:13:"css/style.css";s:44:"sites/all/themes/skeletontheme/css/style.css";s:15:"css/buttons.css";s:46:"sites/all/themes/skeletontheme/css/buttons.css";s:14:"css/layout.css";s:45:"sites/all/themes/skeletontheme/css/layout.css";s:16:"color/colors.css";s:47:"sites/all/themes/skeletontheme/color/colors.css";}}s:6:"engine";s:11:"phptemplate";}}','block_admin_demo','a:1:{i:0;s:13:"skeletontheme";}','','31','5','0','','admin/structure/block/demo/skeletontheme','Skeleton','t','','_block_custom_theme','a:1:{i:0;s:13:"skeletontheme";}','0','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/demo/stark','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:23:"themes/stark/stark.info";s:4:"name";s:5:"stark";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:18:{s:4:"name";s:5:"Stark";s:11:"description";s:208:"This theme demonstrates Drupal''s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal''s default code, see the <a href="http://drupal.org/theme-guide">Theming Guide</a>.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:10:"layout.css";s:23:"themes/stark/layout.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:7:"regions";a:12:{s:13:"sidebar_first";s:12:"Left sidebar";s:14:"sidebar_second";s:13:"Right sidebar";s:7:"content";s:7:"Content";s:6:"header";s:6:"Header";s:6:"footer";s:6:"Footer";s:11:"highlighted";s:11:"Highlighted";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:27:"themes/stark/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:10:"layout.css";s:23:"themes/stark/layout.css";}}s:6:"engine";s:11:"phptemplate";}}','block_admin_demo','a:1:{i:0;s:5:"stark";}','','31','5','0','','admin/structure/block/demo/stark','Stark','t','','_block_custom_theme','a:1:{i:0;s:5:"stark";}','0','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/list/adaptivetheme','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":13:{s:8:"filename";s:57:"sites/all/themes/adaptivetheme/at_core/adaptivetheme.info";s:4:"name";s:13:"adaptivetheme";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:21:{s:4:"name";s:7:"AT Core";s:11:"description";s:210:"AT Core is the framework that drives the responsive layout system and provides an extensive set of tools for theme development. You do not need to enable this theme. Use the provided AT Subtheme to get started.";s:4:"core";s:3:"7.x";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:53:"sites/all/themes/adaptivetheme/at_core/screenshot.png";s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:17:"css/at.layout.css";s:56:"sites/all/themes/adaptivetheme/at_core/css/at.layout.css";}}s:10:"unset_core";a:37:{s:33:"modules/aggregator/aggregator.css";s:14:"aggregator.css";s:23:"modules/block/block.css";s:9:"block.css";s:21:"modules/book/book.css";s:8:"book.css";s:23:"modules/color/color.css";s:9:"color.css";s:27:"modules/comment/comment.css";s:11:"comment.css";s:33:"modules/contextual/contextual.css";s:14:"contextual.css";s:31:"modules/dashboard/dashboard.css";s:13:"dashboard.css";s:23:"modules/dblog/dblog.css";s:9:"dblog.css";s:29:"modules/field/theme/field.css";s:9:"field.css";s:29:"modules/field_ui/field_ui.css";s:12:"field_ui.css";s:21:"modules/file/file.css";s:8:"file.css";s:25:"modules/filter/filter.css";s:10:"filter.css";s:23:"modules/forum/forum.css";s:9:"forum.css";s:21:"modules/help/help.css";s:8:"help.css";s:29:"modules/image/image.admin.css";s:15:"image.admin.css";s:23:"modules/image/image.css";s:9:"image.css";s:25:"modules/locale/locale.css";s:10:"locale.css";s:21:"modules/menu/menu.css";s:8:"menu.css";s:21:"modules/node/node.css";s:8:"node.css";s:25:"modules/openid/openid.css";s:10:"openid.css";s:21:"modules/poll/poll.css";s:8:"poll.css";s:27:"modules/profile/profile.css";s:11:"profile.css";s:25:"modules/search/search.css";s:10:"search.css";s:35:"modules/shortcut/shortcut.admin.css";s:18:"shortcut.admin.css";s:29:"modules/shortcut/shortcut.css";s:12:"shortcut.css";s:33:"modules/simpletest/simpletest.css";s:14:"simpletest.css";s:31:"modules/system/system.admin.css";s:16:"system.admin.css";s:30:"modules/system/system.base.css";s:15:"system.base.css";s:37:"modules/system/system.maintenance.css";s:22:"system.maintenance.css";s:31:"modules/system/system.menus.css";s:16:"system.menus.css";s:34:"modules/system/system.messages.css";s:19:"system.messages.css";s:31:"modules/system/system.theme.css";s:16:"system.theme.css";s:29:"modules/taxonomy/taxonomy.css";s:12:"taxonomy.css";s:27:"modules/toolbar/toolbar.css";s:11:"toolbar.css";s:27:"modules/tracker/tracker.css";s:11:"tracker.css";s:25:"modules/update/update.css";s:10:"update.css";s:21:"modules/user/user.css";s:8:"user.css";}s:7:"regions";a:17:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:7:"content";s:12:"Main Content";s:11:"highlighted";s:11:"Highlighted";s:13:"content_aside";s:5:"Aside";s:17:"secondary_content";s:9:"Secondary";s:16:"tertiary_content";s:8:"Tertiary";s:6:"footer";s:6:"Footer";s:11:"leaderboard";s:11:"Leaderboard";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:7:"plugins";a:2:{s:11:"page_layout";a:1:{s:7:"layouts";s:12:"layouts/core";}s:6:"panels";a:1:{s:7:"layouts";s:14:"layouts/panels";}}s:8:"settings";a:209:{s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1140";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:581px) and (max-width:768px)";s:27:"smalltouch_landscape_layout";s:12:"one_col_vert";s:30:"smalltouch_landscape_page_unit";s:1:"%";s:33:"smalltouch_landscape_sidebar_unit";s:1:"%";s:31:"smalltouch_landscape_page_width";s:3:"100";s:34:"smalltouch_landscape_sidebar_first";s:2:"50";s:35:"smalltouch_landscape_sidebar_second";s:2:"50";s:32:"smalltouch_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:580px)";s:26:"smalltouch_portrait_layout";s:13:"one_col_stack";s:29:"smalltouch_portrait_page_unit";s:1:"%";s:32:"smalltouch_portrait_sidebar_unit";s:1:"%";s:30:"smalltouch_portrait_page_width";s:3:"100";s:33:"smalltouch_portrait_sidebar_first";s:3:"100";s:34:"smalltouch_portrait_sidebar_second";s:3:"100";s:31:"smalltouch_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:9:"five-5x20";s:18:"bigscreen_six_6x16";s:8:"six-6x16";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:9:"five-5x20";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smalltouch_landscape_two_50";s:12:"two-50-stack";s:30:"smalltouch_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smalltouch_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smalltouch_landscape_two_brick";s:15:"two-brick-stack";s:31:"smalltouch_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smalltouch_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smalltouch_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smalltouch_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smalltouch_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smalltouch_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smalltouch_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smalltouch_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smalltouch_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"1";s:21:"global_default_layout";s:19:"smalltouch-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:19:"load_onmediaqueryjs";s:1:"0";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"0";s:20:"enable_font_settings";s:1:"0";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"0";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"0";s:14:"base_font_type";s:6:"<none>";s:19:"site_name_font_type";s:6:"<none>";s:21:"site_slogan_font_type";s:6:"<none>";s:20:"page_title_font_type";s:6:"<none>";s:20:"node_title_font_type";s:6:"<none>";s:23:"comment_title_font_type";s:6:"<none>";s:21:"block_title_font_type";s:6:"<none>";s:19:"main_menu_font_type";s:6:"<none>";s:24:"secondary_menu_font_type";s:6:"<none>";s:20:"block_menu_font_type";s:6:"<none>";s:19:"selectors_font_type";s:6:"<none>";s:14:"base_font_size";s:6:"<none>";s:19:"site_name_font_size";s:6:"<none>";s:21:"site_slogan_font_size";s:6:"<none>";s:20:"page_title_font_size";s:6:"<none>";s:20:"node_title_font_size";s:6:"<none>";s:23:"comment_title_font_size";s:6:"<none>";s:21:"block_title_font_size";s:6:"<none>";s:19:"main_menu_font_size";s:6:"<none>";s:24:"secondary_menu_font_size";s:6:"<none>";s:20:"block_menu_font_size";s:6:"<none>";s:31:"content_headings_h1h4_font_type";s:6:"<none>";s:31:"content_headings_h5h6_font_type";s:6:"<none>";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:14:"site_name_case";s:5:"snc-n";s:16:"site_name_weight";s:5:"snw-b";s:19:"site_name_alignment";s:5:"sna-l";s:16:"site_name_shadow";s:5:"sns-n";s:16:"site_slogan_case";s:5:"ssc-n";s:18:"site_slogan_weight";s:5:"ssw-b";s:21:"site_slogan_alignment";s:5:"ssa-l";s:18:"site_slogan_shadow";s:5:"sss-n";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-l";s:22:"image_alignment_teaser";s:5:"iat-l";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:10:"rel_author";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:56:"width=device-width, initial-scale=1.0, user-scalable=yes";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:35:"adaptivetheme_meta_ie_document_mode";s:0:"";s:29:"adaptivetheme_meta_clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:0:"";s:23:"apple_touch_icon_path_m";s:0:"";s:23:"apple_touch_icon_path_h";s:0:"";s:10:"custom_css";s:0:"";}s:7:"version";s:7:"7.x-3.2";s:7:"project";s:13:"adaptivetheme";s:9:"datestamp";s:10:"1395575059";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:10:"sub_themes";a:4:{s:19:"adaptivetheme_admin";s:8:"AT Admin";s:22:"adaptivetheme_subtheme";s:11:"AT Subtheme";s:17:"bookpoints_custom";s:23:"Bookpoints Customizable";s:7:"corolla";s:7:"Corolla";}s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:17:"css/at.layout.css";s:56:"sites/all/themes/adaptivetheme/at_core/css/at.layout.css";}}s:6:"engine";s:11:"phptemplate";}}','block_admin_display','a:1:{i:0;s:13:"adaptivetheme";}','','31','5','1','admin/structure/block','admin/structure/block','AT Core','t','','','a:0:{}','132','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/list/adaptivetheme/add','','','user_access','a:1:{i:0;s:17:"administer blocks";}','drupal_get_form','a:1:{i:0;s:20:"block_add_block_form";}','','63','6','1','admin/structure/block/list/adaptivetheme','admin/structure/block','Add block','t','','','a:0:{}','388','','','0','modules/block/block.admin.inc'),('admin/structure/block/list/adaptivetheme/add-entity-block','','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','entity_block_add','a:0:{}','','63','6','1','admin/structure/block/list/adaptivetheme','admin/structure/block','Add entity block','t','','','a:0:{}','388','Add a new entity block.','','0',''),('admin/structure/block/list/adaptivetheme_admin','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":14:{s:8:"filename";s:64:"sites/all/themes/adaptivetheme/at_admin/adaptivetheme_admin.info";s:4:"name";s:19:"adaptivetheme_admin";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:20:{s:4:"name";s:8:"AT Admin";s:11:"description";s:144:"A better admin theme for Drupal 7. Clean, calm, invisible. Includes left and right sidebars, Overlay support and all AT''s theme setting goodies.";s:4:"core";s:3:"7.x";s:10:"base theme";s:13:"adaptivetheme";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:54:"sites/all/themes/adaptivetheme/at_admin/screenshot.png";s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:16:"css/at_admin.css";s:56:"sites/all/themes/adaptivetheme/at_admin/css/at_admin.css";}}s:7:"regions";a:11:{s:7:"content";s:12:"Main content";s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:11:"highlighted";s:11:"Highlighted";s:4:"help";s:4:"Help";s:6:"footer";s:6:"Footer";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"settings";a:210:{s:20:"shortcut_module_link";s:1:"1";s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:2:"px";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:3:"180";s:24:"bigscreen_sidebar_second";s:3:"180";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1330";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:581px) and (max-width:768px)";s:27:"smalltouch_landscape_layout";s:12:"one_col_vert";s:30:"smalltouch_landscape_page_unit";s:1:"%";s:33:"smalltouch_landscape_sidebar_unit";s:1:"%";s:31:"smalltouch_landscape_page_width";s:3:"100";s:34:"smalltouch_landscape_sidebar_first";s:2:"50";s:35:"smalltouch_landscape_sidebar_second";s:2:"50";s:32:"smalltouch_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:580px)";s:26:"smalltouch_portrait_layout";s:13:"one_col_stack";s:29:"smalltouch_portrait_page_unit";s:1:"%";s:32:"smalltouch_portrait_sidebar_unit";s:1:"%";s:30:"smalltouch_portrait_page_width";s:3:"100";s:33:"smalltouch_portrait_sidebar_first";s:3:"100";s:34:"smalltouch_portrait_sidebar_second";s:3:"100";s:31:"smalltouch_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:9:"five-5x20";s:18:"bigscreen_six_6x16";s:8:"six-6x16";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:18:"five-5x20-2x3-grid";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smalltouch_landscape_two_50";s:12:"two-50-stack";s:30:"smalltouch_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smalltouch_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smalltouch_landscape_two_brick";s:15:"two-brick-stack";s:31:"smalltouch_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smalltouch_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smalltouch_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smalltouch_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smalltouch_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smalltouch_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smalltouch_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smalltouch_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smalltouch_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"0";s:21:"global_default_layout";s:19:"smalltouch-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:19:"load_onmediaqueryjs";s:1:"0";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"1";s:20:"enable_font_settings";s:1:"0";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"0";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"1";s:14:"base_font_type";s:0:"";s:19:"site_name_font_type";s:0:"";s:21:"site_slogan_font_type";s:0:"";s:20:"page_title_font_type";s:0:"";s:20:"node_title_font_type";s:0:"";s:23:"comment_title_font_type";s:0:"";s:21:"block_title_font_type";s:0:"";s:9:"base_font";s:6:"bf-sss";s:14:"site_name_font";s:6:"snf-sl";s:16:"site_slogan_font";s:6:"ssf-sl";s:14:"main_menu_font";s:6:"mmf-sl";s:15:"page_title_font";s:6:"ptf-sl";s:15:"node_title_font";s:6:"ntf-sl";s:18:"comment_title_font";s:6:"ctf-sl";s:16:"block_title_font";s:6:"btf-sl";s:14:"base_font_size";s:3:"1em";s:19:"site_name_font_size";s:3:"2em";s:21:"site_slogan_font_size";s:5:"1.2em";s:20:"page_title_font_size";s:3:"2em";s:20:"node_title_font_size";s:5:"1.6em";s:23:"comment_title_font_size";s:5:"1.4em";s:21:"block_title_font_size";s:5:"1.4em";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:14:"site_name_case";s:5:"snc-n";s:16:"site_name_weight";s:5:"snw-b";s:19:"site_name_alignment";s:5:"sna-l";s:16:"site_name_shadow";s:5:"sns-n";s:16:"site_slogan_case";s:5:"ssc-n";s:18:"site_slogan_weight";s:5:"ssw-b";s:21:"site_slogan_alignment";s:5:"ssa-l";s:18:"site_slogan_shadow";s:5:"sss-n";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:6:"btc-uc";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-l";s:22:"image_alignment_teaser";s:5:"iat-l";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"1";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"1";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:10:"rel_author";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:56:"width=device-width, initial-scale=1.0, user-scalable=yes";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:35:"adaptivetheme_meta_ie_document_mode";s:0:"";s:29:"adaptivetheme_meta_clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:23:"images/touch-icon-l.png";s:23:"apple_touch_icon_path_m";s:23:"images/touch-icon-m.png";s:23:"apple_touch_icon_path_h";s:23:"images/touch-icon-h.png";s:10:"custom_css";s:0:"";}s:8:"features";a:5:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:7:"favicon";i:3;s:9:"main_menu";i:4;s:14:"secondary_menu";}s:7:"version";s:7:"7.x-3.2";s:7:"project";s:13:"adaptivetheme";s:9:"datestamp";s:10:"1395575059";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:11:"base_themes";a:1:{s:13:"adaptivetheme";s:7:"AT Core";}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:16:"css/at_admin.css";s:56:"sites/all/themes/adaptivetheme/at_admin/css/at_admin.css";}}s:6:"engine";s:11:"phptemplate";s:10:"base_theme";s:13:"adaptivetheme";}}','block_admin_display','a:1:{i:0;s:19:"adaptivetheme_admin";}','','31','5','1','admin/structure/block','admin/structure/block','AT Admin','t','','','a:0:{}','132','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/list/adaptivetheme_admin/add','','','user_access','a:1:{i:0;s:17:"administer blocks";}','drupal_get_form','a:1:{i:0;s:20:"block_add_block_form";}','','63','6','1','admin/structure/block/list/adaptivetheme_admin','admin/structure/block','Add block','t','','','a:0:{}','388','','','0','modules/block/block.admin.inc'),('admin/structure/block/list/adaptivetheme_admin/add-entity-block','','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','entity_block_add','a:0:{}','','63','6','1','admin/structure/block/list/adaptivetheme_admin','admin/structure/block','Add entity block','t','','','a:0:{}','388','Add a new entity block.','','0',''),('admin/structure/block/list/adaptivetheme_subtheme','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":14:{s:8:"filename";s:70:"sites/all/themes/adaptivetheme/at_subtheme/adaptivetheme_subtheme.info";s:4:"name";s:22:"adaptivetheme_subtheme";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:21:{s:4:"name";s:11:"AT Subtheme";s:11:"description";s:580:"Copy this subtheme to get started - see the <b><a href="http://adaptivethemes.com/documentation/adaptivethemes-documentation" target="_blank" title="Adaptivethemes.com - Rocking the hardest since 2006">documentation</a></b> for guidence or the included README. Drush users can generate a new theme using the command: drush adaptivetheme. If you need help please use the <b><a href="http://drupal.org/project/issues/adaptivetheme" target="_blank">issue queue</a></b> or ask in the IRC channel: <b><a href="irc://irc.freenode.net/drupal-adaptivetheme">#drupal-adaptivetheme</a></b>.";s:4:"core";s:3:"7.x";s:10:"base theme";s:13:"adaptivetheme";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:57:"sites/all/themes/adaptivetheme/at_subtheme/screenshot.png";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:19:"css/global.base.css";s:62:"sites/all/themes/adaptivetheme/at_subtheme/css/global.base.css";s:21:"css/global.styles.css";s:64:"sites/all/themes/adaptivetheme/at_subtheme/css/global.styles.css";}}s:7:"regions";a:17:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:7:"content";s:12:"Main Content";s:11:"highlighted";s:11:"Highlighted";s:13:"content_aside";s:5:"Aside";s:17:"secondary_content";s:9:"Secondary";s:16:"tertiary_content";s:8:"Tertiary";s:6:"footer";s:6:"Footer";s:11:"leaderboard";s:11:"Leaderboard";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:":plugins";a:2:{s:11:"page_layout";a:1:{s:7:"layouts";s:12:"layouts/page";}s:6:"panels";a:1:{s:7:"layouts";s:14:"layouts/panels";}}s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:6:"slogan";i:3;s:17:"node_user_picture";i:4;s:20:"comment_user_picture";i:5;s:25:"comment_user_verification";i:6;s:7:"favicon";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:8:"settings";a:231:{s:11:"toggle_logo";s:1:"1";s:11:"toggle_name";s:1:"1";s:13:"toggle_slogan";s:1:"1";s:24:"toggle_node_user_picture";s:1:"1";s:27:"toggle_comment_user_picture";s:1:"1";s:32:"toggle_comment_user_verification";s:1:"1";s:14:"toggle_favicon";s:1:"1";s:16:"toggle_main_menu";s:1:"1";s:21:"toggle_secondary_menu";s:1:"1";s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1140";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:581px) and (max-width:768px)";s:27:"smalltouch_landscape_layout";s:12:"one_col_vert";s:30:"smalltouch_landscape_page_unit";s:1:"%";s:33:"smalltouch_landscape_sidebar_unit";s:1:"%";s:31:"smalltouch_landscape_page_width";s:3:"100";s:34:"smalltouch_landscape_sidebar_first";s:2:"50";s:35:"smalltouch_landscape_sidebar_second";s:2:"50";s:32:"smalltouch_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:580px)";s:26:"smalltouch_portrait_layout";s:13:"one_col_stack";s:29:"smalltouch_portrait_page_unit";s:1:"%";s:32:"smalltouch_portrait_sidebar_unit";s:1:"%";s:30:"smalltouch_portrait_page_width";s:3:"100";s:33:"smalltouch_portrait_sidebar_first";s:3:"100";s:34:"smalltouch_portrait_sidebar_second";s:3:"100";s:31:"smalltouch_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:18:"five-5x20-2x3-grid";s:18:"bigscreen_six_6x16";s:17:"six-6x16-3x2-grid";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:9:"five-5x20";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smalltouch_landscape_two_50";s:12:"two-50-stack";s:30:"smalltouch_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smalltouch_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smalltouch_landscape_two_brick";s:15:"two-brick-stack";s:31:"smalltouch_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smalltouch_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smalltouch_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smalltouch_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smalltouch_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smalltouch_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smalltouch_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smalltouch_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smalltouch_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"1";s:21:"global_default_layout";s:19:"smalltouch-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"0";s:20:"enable_font_settings";s:1:"0";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"0";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"0";s:14:"base_font_type";s:6:"<none>";s:19:"site_name_font_type";s:6:"<none>";s:21:"site_slogan_font_type";s:6:"<none>";s:20:"page_title_font_type";s:6:"<none>";s:20:"node_title_font_type";s:6:"<none>";s:23:"comment_title_font_type";s:6:"<none>";s:21:"block_title_font_type";s:6:"<none>";s:19:"main_menu_font_type";s:6:"<none>";s:24:"secondary_menu_font_type";s:6:"<none>";s:20:"block_menu_font_type";s:6:"<none>";s:19:"selectors_font_type";s:6:"<none>";s:31:"content_headings_h1h4_font_type";s:6:"<none>";s:31:"content_headings_h5h6_font_type";s:6:"<none>";s:14:"base_font_size";s:6:"<none>";s:19:"site_name_font_size";s:6:"<none>";s:21:"site_slogan_font_size";s:6:"<none>";s:20:"page_title_font_size";s:6:"<none>";s:20:"node_title_font_size";s:6:"<none>";s:23:"comment_title_font_size";s:6:"<none>";s:21:"block_title_font_size";s:6:"<none>";s:19:"main_menu_font_size";s:6:"<none>";s:24:"secondary_menu_font_size";s:6:"<none>";s:20:"block_menu_font_size";s:6:"<none>";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:14:"site_name_case";s:5:"snc-n";s:16:"site_name_weight";s:5:"snw-b";s:19:"site_name_alignment";s:5:"sna-l";s:16:"site_name_shadow";s:5:"sns-n";s:16:"site_slogan_case";s:5:"ssc-n";s:18:"site_slogan_weight";s:5:"ssw-b";s:21:"site_slogan_alignment";s:5:"ssa-l";s:18:"site_slogan_shadow";s:5:"sss-n";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-n";s:22:"image_alignment_teaser";s:5:"iat-n";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:20:"user_block_user_name";s:1:"1";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:17:"unset_menu_titles";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:10:"rel_author";s:1:"0";s:27:"menu_toggle_tablet_portrait";s:1:"1";s:28:"menu_toggle_tablet_landscape";s:1:"0";s:21:"menu_toggle_main_menu";s:1:"1";s:26:"menu_toggle_secondary_menu";s:1:"1";s:23:"menu_toggle_leaderboard";s:1:"0";s:18:"menu_toggle_header";s:1:"0";s:20:"menu_toggle_menu_bar";s:1:"1";s:27:"menu_toggle_main_menu_title";s:9:"Main menu";s:32:"menu_toggle_secondary_menu_title";s:9:"User menu";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:56:"width=device-width, initial-scale=1.0, user-scalable=yes";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:35:"adaptivetheme_meta_ie_document_mode";s:0:"";s:29:"adaptivetheme_meta_clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:17:"icon_path_default";s:24:"images/default-60x60.png";s:26:"apple_touch_icon_path_ipad";s:30:"images/ipad-standard-76x76.png";s:35:"apple_touch_icon_path_iphone_retina";s:32:"images/iphone-retina-120x120.png";s:33:"apple_touch_icon_path_ipad_retina";s:30:"images/ipad-retina-152x152.png";s:8:"icon_rel";s:1:"0";s:10:"custom_css";s:0:"";}s:7:"version";s:7:"7.x-3.2";s:7:"project";s:13:"adaptivetheme";s:9:"datestamp";s:10:"1395575059";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:11:"base_themes";a:1:{s:13:"adaptivetheme";s:7:"AT Core";}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:19:"css/global.base.css";s:62:"sites/all/themes/adaptivetheme/at_subtheme/css/global.base.css";s:21:"css/global.styles.css";s:64:"sites/all/themes/adaptivetheme/at_subtheme/css/global.styles.css";}}s:6:"engine";s:11:"phptemplate";s:10:"base_theme";s:13:"adaptivetheme";}}','block_admin_display','a:1:{i:0;s:22:"adaptivetheme_subtheme";}','','31','5','1','admin/structure/block','admin/structure/block','AT Subtheme','t','','','a:0:{}','132','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/list/adaptivetheme_subtheme/add','','','user_access','a:1:{i:0;s:17:"administer blocks";}','drupal_get_form','a:1:{i:0;s:20:"block_add_block_form";}','','63','6','1','admin/structure/block/list/adaptivetheme_subtheme','admin/structure/block','Add block','t','','','a:0:{}','388','','','0','modules/block/block.admin.inc'),('admin/structure/block/list/adaptivetheme_subtheme/add-entity-block','','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','entity_block_add','a:0:{}','','63','6','1','admin/structure/block/list/adaptivetheme_subtheme','admin/structure/block','Add entity block','t','','','a:0:{}','388','Add a new entity block.','','0',''),('admin/structure/block/list/bartik','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:25:"themes/bartik/bartik.info";s:4:"name";s:6:"bartik";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:19:{s:4:"name";s:6:"Bartik";s:11:"description";s:48:"A flexible, recolorable theme with many regions.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:2:{s:3:"all";a:3:{s:14:"css/layout.css";s:28:"themes/bartik/css/layout.css";s:13:"css/style.css";s:27:"themes/bartik/css/style.css";s:14:"css/colors.css";s:28:"themes/bartik/css/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:27:"themes/bartik/css/print.css";}}s:7:"regions";a:20:{s:6:"header";s:6:"Header";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:11:"highlighted";s:11:"Highlighted";s:8:"featured";s:8:"Featured";s:7:"content";s:7:"Content";s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:14:"triptych_first";s:14:"Triptych first";s:15:"triptych_middle";s:15:"Triptych middle";s:13:"triptych_last";s:13:"Triptych last";s:18:"footer_firstcolumn";s:19:"Footer first column";s:19:"footer_secondcolumn";s:20:"Footer second column";s:18:"footer_thirdcolumn";s:19:"Footer third column";s:19:"footer_fourthcolumn";s:20:"Footer fourth column";s:6:"footer";s:6:"Footer";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"settings";a:1:{s:20:"shortcut_module_link";s:1:"0";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:28:"themes/bartik/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:2:{s:3:"all";a:3:{s:14:"css/layout.css";s:28:"themes/bartik/css/layout.css";s:13:"css/style.css";s:27:"themes/bartik/css/style.css";s:14:"css/colors.css";s:28:"themes/bartik/css/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:27:"themes/bartik/css/print.css";}}s:6:"engine";s:11:"phptemplate";}}','block_admin_display','a:1:{i:0;s:6:"bartik";}','','31','5','1','admin/structure/block','admin/structure/block','Bartik','t','','','a:0:{}','132','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/list/bartik/add','','','user_access','a:1:{i:0;s:17:"administer blocks";}','drupal_get_form','a:1:{i:0;s:20:"block_add_block_form";}','','63','6','1','admin/structure/block/list/bartik','admin/structure/block','Add block','t','','','a:0:{}','388','','','0','modules/block/block.admin.inc'),('admin/structure/block/list/bartik/add-entity-block','','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','entity_block_add','a:0:{}','','63','6','1','admin/structure/block/list/bartik','admin/structure/block','Add entity block','t','','','a:0:{}','388','Add a new entity block.','','0',''),('admin/structure/block/list/bookpoints_custom','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":15:{s:8:"filename";s:57:"sites/all/themes/bookpoints_custom/bookpoints_custom.info";s:4:"name";s:17:"bookpoints_custom";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"1";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:18:{s:4:"name";s:23:"Bookpoints Customizable";s:11:"description";s:68:"A customizable, color-able theme built on AdaptiveTheme and Corolla.";s:4:"core";s:3:"7.x";s:7:"release";s:7:"7.x-3.x";s:10:"base theme";s:7:"corolla";s:11:"stylesheets";a:1:{s:3:"all";a:3:{s:16:"color/colors.css";s:51:"sites/all/themes/bookpoints_custom/color/colors.css";s:14:"css/styles.css";s:49:"sites/all/themes/bookpoints_custom/css/styles.css";s:24:"css/reader_dashboard.css";s:59:"sites/all/themes/bookpoints_custom/css/reader_dashboard.css";}}s:14:"ie_stylesheets";a:1:{s:6:"screen";a:1:{s:8:"lte IE 9";a:1:{i:0;s:16:"css/ie-lte-9.css";}}}s:7:"scripts";a:1:{s:11:"js/stars.js";s:46:"sites/all/themes/bookpoints_custom/js/stars.js";}s:7:"regions";a:25:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:11:"highlighted";s:11:"Highlighted";s:7:"content";s:12:"Main content";s:13:"content_aside";s:14:"Content bottom";s:17:"secondary_content";s:17:"Secondary content";s:16:"tertiary_content";s:16:"Tertiary content";s:6:"footer";s:6:"Footer";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:12:"three_33_top";s:26:"AT Three column 3x33 - top";s:14:"three_33_first";s:27:"AT Three column 3x33 - left";s:15:"three_33_second";s:29:"AT Three column 3x33 - center";s:14:"three_33_third";s:28:"AT Three column 3x33 - right";s:15:"three_33_bottom";s:29:"AT Three column 3x33 - bottom";s:10:"four_first";s:23:"AT Four column 4x25 - 1";s:11:"four_second";s:23:"AT Four column 4x25 - 2";s:10:"four_third";s:23:"AT Four column 4x25 - 3";s:11:"four_fourth";s:23:"AT Four column 4x25 - 4";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:7:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:6:"slogan";i:3;s:17:"node_user_picture";i:4;s:20:"comment_user_picture";i:5;s:25:"comment_user_verification";i:6;s:7:"favicon";}s:8:"settings";a:206:{s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1200";s:21:"bigscreen_media_query";s:37:"only screen and (min-width:64.0625em)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:58:"only screen and (min-width:48.0625em) and (max-width:64em)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:58:"only screen and (min-width:30.0625em) and (max-width:48em)";s:27:"smartphone_landscape_layout";s:12:"one_col_vert";s:30:"smartphone_landscape_page_unit";s:1:"%";s:33:"smartphone_landscape_sidebar_unit";s:1:"%";s:31:"smartphone_landscape_page_width";s:3:"100";s:34:"smartphone_landscape_sidebar_first";s:2:"50";s:35:"smartphone_landscape_sidebar_second";s:2:"50";s:32:"smartphone_landscape_media_query";s:58:"only screen and (min-width:20.0625em) and (max-width:30em)";s:26:"smartphone_portrait_layout";s:13:"one_col_stack";s:29:"smartphone_portrait_page_unit";s:1:"%";s:32:"smartphone_portrait_sidebar_unit";s:1:"%";s:30:"smartphone_portrait_page_width";s:3:"100";s:33:"smartphone_portrait_sidebar_first";s:3:"100";s:34:"smartphone_portrait_sidebar_second";s:3:"100";s:31:"smartphone_portrait_media_query";s:32:"only screen and (max-width:20em)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:18:"five-5x20-2x3-grid";s:18:"bigscreen_six_6x16";s:17:"six-6x16-3x2-grid";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:18:"five-5x20-2x3-grid";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smartphone_landscape_two_50";s:12:"two-50-stack";s:30:"smartphone_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smartphone_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smartphone_landscape_two_brick";s:15:"two-brick-stack";s:31:"smartphone_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smartphone_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smartphone_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smartphone_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smartphone_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smartphone_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smartphone_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smartphone_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smartphone_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"0";s:21:"global_default_layout";s:19:"smartphone-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"1";s:20:"enable_font_settings";s:1:"1";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"1";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:18:"enable_menu_toggle";s:1:"1";s:22:"enable_markup_overides";s:1:"1";s:14:"base_font_type";s:0:"";s:19:"site_name_font_type";s:0:"";s:21:"site_slogan_font_type";s:0:"";s:20:"page_title_font_type";s:0:"";s:20:"node_title_font_type";s:0:"";s:23:"comment_title_font_type";s:0:"";s:21:"block_title_font_type";s:0:"";s:9:"base_font";s:6:"bf-sss";s:14:"site_name_font";s:6:"snf-sl";s:16:"site_slogan_font";s:6:"ssf-sl";s:14:"main_menu_font";s:6:"mmf-sl";s:15:"page_title_font";s:6:"ptf-sl";s:15:"node_title_font";s:6:"ntf-sl";s:18:"comment_title_font";s:6:"ctf-sl";s:16:"block_title_font";s:6:"btf-sl";s:14:"base_font_size";s:3:"1em";s:19:"site_name_font_size";s:5:"3.5em";s:21:"site_slogan_font_size";s:5:"1.2em";s:20:"page_title_font_size";s:3:"2em";s:20:"node_title_font_size";s:5:"1.6em";s:23:"comment_title_font_size";s:5:"1.4em";s:21:"block_title_font_size";s:5:"1.4em";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-n";s:22:"image_alignment_teaser";s:5:"iat-n";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:17:"unset_menu_titles";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:35:"width=device-width, initial-scale=1";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:11:"chrome_edge";s:1:"0";s:10:"clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:23:"images/touch-icon-l.png";s:23:"apple_touch_icon_path_m";s:23:"images/touch-icon-m.png";s:23:"apple_touch_icon_path_h";s:23:"images/touch-icon-h.png";s:10:"custom_css";s:0:"";s:21:"content_corner_radius";s:4:"rc-6";s:18:"tabs_corner_radius";s:5:"rct-6";s:11:"box_shadows";s:4:"bs-n";s:15:"body_background";s:4:"bb-n";s:12:"menu_bullets";s:5:"mb-dd";s:17:"menu_bar_position";s:5:"mbp-l";}s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:49:"sites/all/themes/bookpoints_custom/screenshot.png";s:3:"php";s:5:"5.2.4";s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:11:"base_themes";a:2:{s:13:"adaptivetheme";s:7:"AT Core";s:7:"corolla";s:7:"Corolla";}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:3:"all";a:3:{s:16:"color/colors.css";s:51:"sites/all/themes/bookpoints_custom/color/colors.css";s:14:"css/styles.css";s:49:"sites/all/themes/bookpoints_custom/css/styles.css";s:24:"css/reader_dashboard.css";s:59:"sites/all/themes/bookpoints_custom/css/reader_dashboard.css";}}s:7:"scripts";a:1:{s:11:"js/stars.js";s:46:"sites/all/themes/bookpoints_custom/js/stars.js";}s:6:"engine";s:11:"phptemplate";s:10:"base_theme";s:7:"corolla";}}','block_admin_display','a:1:{i:0;s:17:"bookpoints_custom";}','','31','5','1','admin/structure/block','admin/structure/block','Bookpoints Customizable','t','','','a:0:{}','140','','','-10','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/list/corolla','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":15:{s:8:"filename";s:37:"sites/all/themes/corolla/corolla.info";s:4:"name";s:7:"corolla";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:21:{s:4:"name";s:7:"Corolla";s:11:"description";s:367:"Corolla is a subtheme of <a href="http://drupal.org/project/adaptivetheme">Adaptivetheme 7.x-3.x</a>. To use this theme you must first download and install the 7.x-3.x version of Adaptivetheme. Corolla is colorable and has many theme settings for layout, fonts, headings and much more. Corolla also supports layouts for mobile devices such as tablets and smartphones.";s:4:"core";s:3:"7.x";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"base theme";s:13:"adaptivetheme";s:10:"screenshot";s:39:"sites/all/themes/corolla/screenshot.png";s:11:"stylesheets";a:2:{s:3:"all";a:12:{s:21:"css/html-elements.css";s:46:"sites/all/themes/corolla/css/html-elements.css";s:13:"css/forms.css";s:38:"sites/all/themes/corolla/css/forms.css";s:14:"css/tables.css";s:39:"sites/all/themes/corolla/css/tables.css";s:12:"css/page.css";s:37:"sites/all/themes/corolla/css/page.css";s:16:"css/articles.css";s:41:"sites/all/themes/corolla/css/articles.css";s:16:"css/comments.css";s:41:"sites/all/themes/corolla/css/comments.css";s:14:"css/fields.css";s:39:"sites/all/themes/corolla/css/fields.css";s:14:"css/blocks.css";s:39:"sites/all/themes/corolla/css/blocks.css";s:18:"css/navigation.css";s:43:"sites/all/themes/corolla/css/navigation.css";s:13:"css/fonts.css";s:38:"sites/all/themes/corolla/css/fonts.css";s:30:"css/corolla.settings.style.css";s:55:"sites/all/themes/corolla/css/corolla.settings.style.css";s:16:"color/colors.css";s:41:"sites/all/themes/corolla/color/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:38:"sites/all/themes/corolla/css/print.css";}}s:14:"ie_stylesheets";a:1:{s:6:"screen";a:1:{s:8:"lte IE 9";a:1:{i:0;s:16:"css/ie-lte-9.css";}}}s:7:"regions";a:25:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:11:"highlighted";s:11:"Highlighted";s:7:"content";s:12:"Main content";s:13:"content_aside";s:14:"Content bottom";s:17:"secondary_content";s:17:"Secondary content";s:16:"tertiary_content";s:16:"Tertiary content";s:6:"footer";s:6:"Footer";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:12:"three_33_top";s:26:"AT Three column 3x33 - top";s:14:"three_33_first";s:27:"AT Three column 3x33 - left";s:15:"three_33_second";s:29:"AT Three column 3x33 - center";s:14:"three_33_third";s:28:"AT Three column 3x33 - right";s:15:"three_33_bottom";s:29:"AT Three column 3x33 - bottom";s:10:"four_first";s:23:"AT Four column 4x25 - 1";s:11:"four_second";s:23:"AT Four column 4x25 - 2";s:10:"four_third";s:23:"AT Four column 4x25 - 3";s:11:"four_fourth";s:23:"AT Four column 4x25 - 4";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:7:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:6:"slogan";i:3;s:17:"node_user_picture";i:4;s:20:"comment_user_picture";i:5;s:25:"comment_user_verification";i:6;s:7:"favicon";}s:8:"settings";a:213:{s:11:"toggle_logo";s:1:"1";s:11:"toggle_name";s:1:"1";s:13:"toggle_slogan";s:1:"1";s:24:"toggle_node_user_picture";s:1:"1";s:27:"toggle_comment_user_picture";s:1:"1";s:32:"toggle_comment_user_verification";s:1:"1";s:14:"toggle_favicon";s:1:"1";s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1140";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:481px) and (max-width:768px)";s:27:"smartphone_landscape_layout";s:12:"one_col_vert";s:30:"smartphone_landscape_page_unit";s:1:"%";s:33:"smartphone_landscape_sidebar_unit";s:1:"%";s:31:"smartphone_landscape_page_width";s:3:"100";s:34:"smartphone_landscape_sidebar_first";s:2:"50";s:35:"smartphone_landscape_sidebar_second";s:2:"50";s:32:"smartphone_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:480px)";s:26:"smartphone_portrait_layout";s:13:"one_col_stack";s:29:"smartphone_portrait_page_unit";s:1:"%";s:32:"smartphone_portrait_sidebar_unit";s:1:"%";s:30:"smartphone_portrait_page_width";s:3:"100";s:33:"smartphone_portrait_sidebar_first";s:3:"100";s:34:"smartphone_portrait_sidebar_second";s:3:"100";s:31:"smartphone_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:18:"five-5x20-2x3-grid";s:18:"bigscreen_six_6x16";s:17:"six-6x16-3x2-grid";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:18:"five-5x20-2x3-grid";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smartphone_landscape_two_50";s:12:"two-50-stack";s:30:"smartphone_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smartphone_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smartphone_landscape_two_brick";s:15:"two-brick-stack";s:31:"smartphone_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smartphone_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smartphone_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smartphone_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smartphone_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smartphone_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smartphone_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smartphone_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smartphone_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"0";s:21:"global_default_layout";s:19:"smartphone-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"1";s:20:"enable_font_settings";s:1:"1";s:23:"enable_heading_settings";s:1:"1";s:21:"enable_image_settings";s:1:"1";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"1";s:14:"base_font_type";s:0:"";s:19:"site_name_font_type";s:0:"";s:21:"site_slogan_font_type";s:0:"";s:20:"page_title_font_type";s:0:"";s:20:"node_title_font_type";s:0:"";s:23:"comment_title_font_type";s:0:"";s:21:"block_title_font_type";s:0:"";s:9:"base_font";s:6:"bf-sss";s:14:"site_name_font";s:6:"snf-sl";s:16:"site_slogan_font";s:6:"ssf-sl";s:14:"main_menu_font";s:6:"mmf-sl";s:15:"page_title_font";s:6:"ptf-sl";s:15:"node_title_font";s:6:"ntf-sl";s:18:"comment_title_font";s:6:"ctf-sl";s:16:"block_title_font";s:6:"btf-sl";s:14:"base_font_size";s:3:"1em";s:19:"site_name_font_size";s:5:"3.5em";s:21:"site_slogan_font_size";s:5:"1.2em";s:20:"page_title_font_size";s:3:"2em";s:20:"node_title_font_size";s:5:"1.6em";s:23:"comment_title_font_size";s:5:"1.4em";s:21:"block_title_font_size";s:5:"1.4em";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-n";s:22:"image_alignment_teaser";s:5:"iat-n";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:17:"unset_menu_titles";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:35:"width=device-width, initial-scale=1";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:11:"chrome_edge";s:1:"0";s:10:"clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:23:"images/touch-icon-l.png";s:23:"apple_touch_icon_path_m";s:23:"images/touch-icon-m.png";s:23:"apple_touch_icon_path_h";s:23:"images/touch-icon-h.png";s:10:"custom_css";s:0:"";s:21:"content_corner_radius";s:4:"rc-6";s:18:"tabs_corner_radius";s:5:"rct-6";s:11:"box_shadows";s:4:"bs-n";s:15:"body_background";s:4:"bb-n";s:12:"menu_bullets";s:5:"mb-dd";s:17:"menu_bar_position";s:5:"mbp-l";}s:7:"version";s:7:"7.x-3.0";s:7:"project";s:7:"corolla";s:9:"datestamp";s:10:"1395577158";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:10:"sub_themes";a:1:{s:17:"bookpoints_custom";s:23:"Bookpoints Customizable";}s:11:"base_themes";a:1:{s:13:"adaptivetheme";s:7:"AT Core";}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:2:{s:3:"all";a:12:{s:21:"css/html-elements.css";s:46:"sites/all/themes/corolla/css/html-elements.css";s:13:"css/forms.css";s:38:"sites/all/themes/corolla/css/forms.css";s:14:"css/tables.css";s:39:"sites/all/themes/corolla/css/tables.css";s:12:"css/page.css";s:37:"sites/all/themes/corolla/css/page.css";s:16:"css/articles.css";s:41:"sites/all/themes/corolla/css/articles.css";s:16:"css/comments.css";s:41:"sites/all/themes/corolla/css/comments.css";s:14:"css/fields.css";s:39:"sites/all/themes/corolla/css/fields.css";s:14:"css/blocks.css";s:39:"sites/all/themes/corolla/css/blocks.css";s:18:"css/navigation.css";s:43:"sites/all/themes/corolla/css/navigation.css";s:13:"css/fonts.css";s:38:"sites/all/themes/corolla/css/fonts.css";s:30:"css/corolla.settings.style.css";s:55:"sites/all/themes/corolla/css/corolla.settings.style.css";s:16:"color/colors.css";s:41:"sites/all/themes/corolla/color/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:38:"sites/all/themes/corolla/css/print.css";}}s:6:"engine";s:11:"phptemplate";s:10:"base_theme";s:13:"adaptivetheme";}}','block_admin_display','a:1:{i:0;s:7:"corolla";}','','31','5','1','admin/structure/block','admin/structure/block','Corolla','t','','','a:0:{}','132','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/list/corolla/add','','','user_access','a:1:{i:0;s:17:"administer blocks";}','drupal_get_form','a:1:{i:0;s:20:"block_add_block_form";}','','63','6','1','admin/structure/block/list/corolla','admin/structure/block','Add block','t','','','a:0:{}','388','','','0','modules/block/block.admin.inc'),('admin/structure/block/list/corolla/add-entity-block','','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','entity_block_add','a:0:{}','','63','6','1','admin/structure/block/list/corolla','admin/structure/block','Add entity block','t','','','a:0:{}','388','Add a new entity block.','','0',''),('admin/structure/block/list/garland','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:27:"themes/garland/garland.info";s:4:"name";s:7:"garland";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:19:{s:4:"name";s:7:"Garland";s:11:"description";s:111:"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:2:{s:3:"all";a:1:{s:9:"style.css";s:24:"themes/garland/style.css";}s:5:"print";a:1:{s:9:"print.css";s:24:"themes/garland/print.css";}}s:8:"settings";a:1:{s:13:"garland_width";s:5:"fluid";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:7:"regions";a:12:{s:13:"sidebar_first";s:12:"Left sidebar";s:14:"sidebar_second";s:13:"Right sidebar";s:7:"content";s:7:"Content";s:6:"header";s:6:"Header";s:6:"footer";s:6:"Footer";s:11:"highlighted";s:11:"Highlighted";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:29:"themes/garland/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:2:{s:3:"all";a:1:{s:9:"style.css";s:24:"themes/garland/style.css";}s:5:"print";a:1:{s:9:"print.css";s:24:"themes/garland/print.css";}}s:6:"engine";s:11:"phptemplate";}}','block_admin_display','a:1:{i:0;s:7:"garland";}','','31','5','1','admin/structure/block','admin/structure/block','Garland','t','','','a:0:{}','132','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/list/garland/add','','','user_access','a:1:{i:0;s:17:"administer blocks";}','drupal_get_form','a:1:{i:0;s:20:"block_add_block_form";}','','63','6','1','admin/structure/block/list/garland','admin/structure/block','Add block','t','','','a:0:{}','388','','','0','modules/block/block.admin.inc'),('admin/structure/block/list/garland/add-entity-block','','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','entity_block_add','a:0:{}','','63','6','1','admin/structure/block/list/garland','admin/structure/block','Add entity block','t','','','a:0:{}','388','Add a new entity block.','','0',''),('admin/structure/block/list/seven','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:23:"themes/seven/seven.info";s:4:"name";s:5:"seven";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:19:{s:4:"name";s:5:"Seven";s:11:"description";s:65:"A simple one-column, tableless, fluid width administration theme.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:9:"reset.css";s:22:"themes/seven/reset.css";s:9:"style.css";s:22:"themes/seven/style.css";}}s:8:"settings";a:1:{s:20:"shortcut_module_link";s:1:"1";}s:7:"regions";a:8:{s:7:"content";s:7:"Content";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:13:"sidebar_first";s:13:"First sidebar";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:14:"regions_hidden";a:3:{i:0;s:13:"sidebar_first";i:1;s:8:"page_top";i:2;s:11:"page_bottom";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:27:"themes/seven/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:9:"reset.css";s:22:"themes/seven/reset.css";s:9:"style.css";s:22:"themes/seven/style.css";}}s:6:"engine";s:11:"phptemplate";}}','block_admin_display','a:1:{i:0;s:5:"seven";}','','31','5','1','admin/structure/block','admin/structure/block','Seven','t','','','a:0:{}','132','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/list/seven/add','','','user_access','a:1:{i:0;s:17:"administer blocks";}','drupal_get_form','a:1:{i:0;s:20:"block_add_block_form";}','','63','6','1','admin/structure/block/list/seven','admin/structure/block','Add block','t','','','a:0:{}','388','','','0','modules/block/block.admin.inc'),('admin/structure/block/list/seven/add-entity-block','','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','entity_block_add','a:0:{}','','63','6','1','admin/structure/block/list/seven','admin/structure/block','Add entity block','t','','','a:0:{}','388','Add a new entity block.','','0',''),('admin/structure/block/list/skeletontheme','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:49:"sites/all/themes/skeletontheme/skeletontheme.info";s:4:"name";s:13:"skeletontheme";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:18:{s:4:"name";s:8:"Skeleton";s:11:"description";s:361:"Skeleton is a powerful, clean, responsive theme ported to Drupal by <a href="http://www.morethanthemes.com/" target="_blank">More Than (just) Themes</a>. If you like this theme, we encourage you to try also our other <a href="http://www.morethanthemes.com" target="_blank">Premium</a> and <a href="http://drupalizing.com" target="_blank">Free</a> Drupal themes.";s:7:"version";s:7:"7.x-1.4";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:3:"all";a:5:{s:16:"css/skeleton.css";s:47:"sites/all/themes/skeletontheme/css/skeleton.css";s:13:"css/style.css";s:44:"sites/all/themes/skeletontheme/css/style.css";s:15:"css/buttons.css";s:46:"sites/all/themes/skeletontheme/css/buttons.css";s:14:"css/layout.css";s:45:"sites/all/themes/skeletontheme/css/layout.css";s:16:"color/colors.css";s:47:"sites/all/themes/skeletontheme/color/colors.css";}}s:7:"regions";a:20:{s:15:"header_top_left";s:15:"Header top left";s:16:"header_top_right";s:16:"Header top right";s:12:"header_right";s:12:"Header right";s:6:"header";s:6:"Header";s:11:"highlighted";s:11:"Highlighted";s:7:"content";s:7:"Content";s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:13:"featured_left";s:13:"Featured left";s:14:"featured_right";s:14:"Featured right";s:12:"footer_first";s:12:"Footer first";s:13:"footer_second";s:13:"Footer second";s:12:"footer_third";s:12:"Footer third";s:6:"footer";s:6:"Footer";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"settings";a:3:{s:21:"responsive_menu_state";s:1:"1";s:27:"responsive_menu_switchwidth";s:3:"760";s:29:"responsive_menu_topoptiontext";s:13:"Select a page";}s:7:"project";s:13:"skeletontheme";s:9:"datestamp";s:10:"1396987453";s:6:"engine";s:11:"phptemplate";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:45:"sites/all/themes/skeletontheme/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:3:"all";a:5:{s:16:"css/skeleton.css";s:47:"sites/all/themes/skeletontheme/css/skeleton.css";s:13:"css/style.css";s:44:"sites/all/themes/skeletontheme/css/style.css";s:15:"css/buttons.css";s:46:"sites/all/themes/skeletontheme/css/buttons.css";s:14:"css/layout.css";s:45:"sites/all/themes/skeletontheme/css/layout.css";s:16:"color/colors.css";s:47:"sites/all/themes/skeletontheme/color/colors.css";}}s:6:"engine";s:11:"phptemplate";}}','block_admin_display','a:1:{i:0;s:13:"skeletontheme";}','','31','5','1','admin/structure/block','admin/structure/block','Skeleton','t','','','a:0:{}','132','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/list/skeletontheme/add','','','user_access','a:1:{i:0;s:17:"administer blocks";}','drupal_get_form','a:1:{i:0;s:20:"block_add_block_form";}','','63','6','1','admin/structure/block/list/skeletontheme','admin/structure/block','Add block','t','','','a:0:{}','388','','','0','modules/block/block.admin.inc'),('admin/structure/block/list/skeletontheme/add-entity-block','','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','entity_block_add','a:0:{}','','63','6','1','admin/structure/block/list/skeletontheme','admin/structure/block','Add entity block','t','','','a:0:{}','388','Add a new entity block.','','0',''),('admin/structure/block/list/stark','','','_block_themes_access','a:1:{i:0;O:8:"stdClass":12:{s:8:"filename";s:23:"themes/stark/stark.info";s:4:"name";s:5:"stark";s:4:"type";s:5:"theme";s:5:"owner";s:45:"themes/engines/phptemplate/phptemplate.engine";s:6:"status";s:1:"0";s:9:"bootstrap";s:1:"0";s:14:"schema_version";s:2:"-1";s:6:"weight";s:1:"0";s:4:"info";a:18:{s:4:"name";s:5:"Stark";s:11:"description";s:208:"This theme demonstrates Drupal''s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal''s default code, see the <a href="http://drupal.org/theme-guide">Theming Guide</a>.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:10:"layout.css";s:23:"themes/stark/layout.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:7:"regions";a:12:{s:13:"sidebar_first";s:12:"Left sidebar";s:14:"sidebar_second";s:13:"Right sidebar";s:7:"content";s:7:"Content";s:6:"header";s:6:"Header";s:6:"footer";s:6:"Footer";s:11:"highlighted";s:11:"Highlighted";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:27:"themes/stark/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}s:6:"prefix";s:11:"phptemplate";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:10:"layout.css";s:23:"themes/stark/layout.css";}}s:6:"engine";s:11:"phptemplate";}}','block_admin_display','a:1:{i:0;s:5:"stark";}','','31','5','1','admin/structure/block','admin/structure/block','Stark','t','','','a:0:{}','132','','','0','modules/block/block.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/block/list/stark/add','','','user_access','a:1:{i:0;s:17:"administer blocks";}','drupal_get_form','a:1:{i:0;s:20:"block_add_block_form";}','','63','6','1','admin/structure/block/list/stark','admin/structure/block','Add block','t','','','a:0:{}','388','','','0','modules/block/block.admin.inc'),('admin/structure/block/list/stark/add-entity-block','','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','entity_block_add','a:0:{}','','63','6','1','admin/structure/block/list/stark','admin/structure/block','Add entity block','t','','','a:0:{}','388','Add a new entity block.','','0',''),('admin/structure/block/manage/%/%','a:2:{i:4;N;i:5;N;}','','block_access_check_config','a:2:{i:0;i:4;i:1;i:5;}','drupal_get_form','a:3:{i:0;s:21:"block_admin_configure";i:1;i:4;i:2;i:5;}','','60','6','0','','admin/structure/block/manage/%/%','Configure block','t','','','a:0:{}','6','','','0','modules/block/block.admin.inc'),('admin/structure/block/manage/%/%/configure','a:2:{i:4;N;i:5;N;}','','block_access_check_config','a:2:{i:0;i:4;i:1;i:5;}','drupal_get_form','a:3:{i:0;s:21:"block_admin_configure";i:1;i:4;i:2;i:5;}','','121','7','2','admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Configure block','t','','','a:0:{}','140','','','0','modules/block/block.admin.inc'),('admin/structure/block/manage/%/%/delete','a:2:{i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:17:"administer blocks";}','drupal_get_form','a:3:{i:0;s:25:"block_custom_block_delete";i:1;i:4;i:2;i:5;}','','121','7','0','admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Delete block','t','','','a:0:{}','132','','','0','modules/block/block.admin.inc'),('admin/structure/entity-blocks','','','user_access','a:1:{i:0;s:23:"adminiter entity blocks";}','entity_block_list','a:0:{}','','7','3','0','','admin/structure/entity-blocks','Entity blocks','t','','','a:0:{}','6','Administer entity blocks.','','0',''),('admin/structure/entity-blocks/%entity_block/edit','','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','drupal_get_form','a:2:{i:0;s:17:"entity_block_form";i:1;i:3;}','','31','5','0','','admin/structure/entity-blocks/%entity_block/edit','Edit','t','','','a:0:{}','6','','','0','');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-blocks/manage/add','','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','entity_block_add','a:0:{}','','31','5','1','admin/structure/entity-blocks','admin/structure/entity-blocks','Add entity block','t','','','a:0:{}','388','','','0',''),('admin/structure/entity-blocks/manage/display','','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer entity blocks";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"entity_block";i:2;s:12:"entity_block";i:3;s:7:"default";}','','31','5','1','admin/structure/entity-blocks','admin/structure/entity-blocks','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-blocks/manage/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"entity_block";i:1;s:12:"entity_block";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:24:"administer entity blocks";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"entity_block";i:2;s:12:"entity_block";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-blocks/manage/display','admin/structure/entity-blocks','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-blocks/manage/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"entity_block";i:1;s:12:"entity_block";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:24:"administer entity blocks";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"entity_block";i:2;s:12:"entity_block";i:3;s:5:"token";}','','63','6','1','admin/structure/entity-blocks/manage/display','admin/structure/entity-blocks','Tokens','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-blocks/manage/fields','','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer entity blocks";}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:12:"entity_block";i:2;s:12:"entity_block";}','','31','5','1','admin/structure/entity-blocks','admin/structure/entity-blocks','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-blocks/manage/fields/%','a:1:{i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"entity_block";i:1;s:12:"entity_block";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer entity blocks";}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:5;}','','62','6','0','','admin/structure/entity-blocks/manage/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-blocks/manage/fields/%/delete','a:1:{i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"entity_block";i:1;s:12:"entity_block";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer entity blocks";}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:5;}','','125','7','1','admin/structure/entity-blocks/manage/fields/%','admin/structure/entity-blocks/manage/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-blocks/manage/fields/%/edit','a:1:{i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"entity_block";i:1;s:12:"entity_block";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer entity blocks";}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:5;}','','125','7','1','admin/structure/entity-blocks/manage/fields/%','admin/structure/entity-blocks/manage/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-blocks/manage/fields/%/field-settings','a:1:{i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"entity_block";i:1;s:12:"entity_block";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer entity blocks";}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:5;}','','125','7','1','admin/structure/entity-blocks/manage/fields/%','admin/structure/entity-blocks/manage/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-blocks/manage/fields/%/widget-type','a:1:{i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"entity_block";i:1;s:12:"entity_block";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer entity blocks";}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:5;}','','125','7','1','admin/structure/entity-blocks/manage/fields/%','admin/structure/entity-blocks/manage/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-blocks/manage/groups/%/delete','a:1:{i:5;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:12:"entity_block";i:1;s:12:"entity_block";i:2;s:1:"0";i:3;s:4:"%map";}}}','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:5;}','','125','7','0','','admin/structure/entity-blocks/manage/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-blocks/manage/groups/%/enable','a:1:{i:5;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:12:"entity_block";i:1;s:12:"entity_block";i:2;s:1:"0";i:3;s:4:"%map";}}}','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:5;}','','125','7','0','','admin/structure/entity-blocks/manage/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-blocks/manage/list','','','user_access','a:1:{i:0;s:23:"adminiter entity blocks";}','entity_block_list','a:0:{}','','31','5','1','admin/structure/entity-blocks','admin/structure/entity-blocks','List','t','','','a:0:{}','140','','','0',''),('admin/structure/entity-type','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck list entity types";}}','eck__entity_type__list','a:0:{}','','7','3','0','','admin/structure/entity-type','Entity types','t','','','a:0:{}','6','A centralized administrative section for entity types','','0','sites/all/modules/contrib/eck/eck.entity_type.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck list activity bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/activity','Activity','t','','','a:0:{}','6','View all the bundles for ''Activity''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/activity/activity','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:41:"eck administer activity activity entities";i:3;s:35:"eck list activity activity entities";}}','eck__entity__list','a:2:{i:0;s:8:"activity";i:1;s:8:"activity";}','','31','5','0','','admin/structure/entity-type/activity/activity','Activity','t','','','a:0:{}','6','View all entites of type Activity with bundle Activity','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity/activity/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:8:"activity";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:8:"activity";i:2;s:8:"activity";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/activity/activity/%/delete','Delete Activity','t','','','a:0:{}','6','Delete an entity of type Activity with bundle Activity','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity/activity/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:8:"activity";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:8:"activity";i:2;s:8:"activity";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/activity/activity/%/edit','Edit Activity','t','','','a:0:{}','6','Edit an entity of type Activity with bundle Activity','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity/activity/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:8:"activity";i:2;s:8:"activity";}','eck__entity__add','a:2:{i:0;s:8:"activity";i:1;s:8:"activity";}','','63','6','0','','admin/structure/entity-type/activity/activity/add','Add Activity','t','','','a:0:{}','6','Add an entity of type Activity with bundle Activity','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity/activity/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:31:"eck administer activity bundles";i:3;s:27:"eck delete activity bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/activity/activity','admin/structure/entity-type/activity/activity','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/activity/activity/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:8:"activity";i:2;s:8:"activity";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/activity/activity','admin/structure/entity-type/activity/activity','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/activity/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:8:"activity";i:2;s:8:"activity";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/activity/activity/display','admin/structure/entity-type/activity/activity','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity/activity/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:8:"activity";i:2;s:8:"activity";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/activity/activity/display','admin/structure/entity-type/activity/activity','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/activity/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:8:"activity";i:2;s:8:"activity";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/activity/activity/display','admin/structure/entity-type/activity/activity','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/activity/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:8:"activity";i:2;s:8:"activity";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/activity/activity/display','admin/structure/entity-type/activity/activity','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity/activity/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:8:"activity";i:2;s:8:"activity";}','','63','6','1','admin/structure/entity-type/activity/activity','admin/structure/entity-type/activity/activity','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/activity/activity/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:8:"activity";i:2;s:8:"activity";}','','63','6','1','admin/structure/entity-type/activity/activity','admin/structure/entity-type/activity/activity','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/activity/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/activity/activity/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/activity/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity/activity/fields/%','admin/structure/entity-type/activity/activity/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity/activity/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity/activity/fields/%','admin/structure/entity-type/activity/activity/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/activity/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity/activity/fields/%','admin/structure/entity-type/activity/activity/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/activity/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity/activity/fields/%','admin/structure/entity-type/activity/activity/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity/activity/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/activity/activity/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/activity/activity/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:8:"activity";i:1;s:8:"activity";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/activity/activity/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/activity/activity/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:41:"eck administer activity activity entities";i:3;s:35:"eck list activity activity entities";}}','eck__entity__list','a:2:{i:0;s:8:"activity";i:1;s:8:"activity";}','','63','6','1','admin/structure/entity-type/activity/activity','admin/structure/entity-type/activity/activity','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:31:"eck administer activity bundles";i:3;s:24:"eck add activity bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/activity','admin/structure/entity-type/activity','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Activity Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:8:"activity";}','','31','5','1','admin/structure/entity-type/activity','admin/structure/entity-type/activity','Delete','t','','','a:0:{}','132','Delete the ''Activity'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/activity/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:8:"activity";}','','31','5','1','admin/structure/entity-type/activity','admin/structure/entity-type/activity','Edit','t','','','a:0:{}','132','Edit the ''Activity'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/activity/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck list activity bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/activity','admin/structure/entity-type/activity','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/activity/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:26:"manage activity properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:8:"activity";}','','31','5','1','admin/structure/entity-type/activity','admin/structure/entity-type/activity','Manage properties','t','','','a:0:{}','132','Manage the properties of the Activity entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/activity/secret_code','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:44:"eck administer activity secret_code entities";i:3;s:38:"eck list activity secret_code entities";}}','eck__entity__list','a:2:{i:0;s:8:"activity";i:1;s:11:"secret_code";}','','31','5','0','','admin/structure/entity-type/activity/secret_code','Secret Code','t','','','a:0:{}','6','View all entites of type Activity with bundle Secret Code','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity/secret_code/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:8:"activity";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:8:"activity";i:2;s:11:"secret_code";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/activity/secret_code/%/delete','Delete Secret Code','t','','','a:0:{}','6','Delete an entity of type Activity with bundle Secret Code','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity/secret_code/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:8:"activity";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:8:"activity";i:2;s:11:"secret_code";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/activity/secret_code/%/edit','Edit Secret Code','t','','','a:0:{}','6','Edit an entity of type Activity with bundle Secret Code','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity/secret_code/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:8:"activity";i:2;s:11:"secret_code";}','eck__entity__add','a:2:{i:0;s:8:"activity";i:1;s:11:"secret_code";}','','63','6','0','','admin/structure/entity-type/activity/secret_code/add','Add Secret Code','t','','','a:0:{}','6','Add an entity of type Activity with bundle Secret Code','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity/secret_code/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:31:"eck administer activity bundles";i:3;s:27:"eck delete activity bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/activity/secret_code','admin/structure/entity-type/activity/secret_code','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity/secret_code/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:8:"activity";i:2;s:11:"secret_code";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/activity/secret_code','admin/structure/entity-type/activity/secret_code','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/secret_code/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:8:"activity";i:2;s:11:"secret_code";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/activity/secret_code/display','admin/structure/entity-type/activity/secret_code','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/secret_code/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:8:"activity";i:2;s:11:"secret_code";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/activity/secret_code/display','admin/structure/entity-type/activity/secret_code','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity/secret_code/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:8:"activity";i:2;s:11:"secret_code";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/activity/secret_code/display','admin/structure/entity-type/activity/secret_code','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/secret_code/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:8:"activity";i:2;s:11:"secret_code";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/activity/secret_code/display','admin/structure/entity-type/activity/secret_code','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/secret_code/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:8:"activity";i:2;s:11:"secret_code";}','','63','6','1','admin/structure/entity-type/activity/secret_code','admin/structure/entity-type/activity/secret_code','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity/secret_code/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:8:"activity";i:2;s:11:"secret_code";}','','63','6','1','admin/structure/entity-type/activity/secret_code','admin/structure/entity-type/activity/secret_code','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/secret_code/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/activity/secret_code/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/secret_code/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity/secret_code/fields/%','admin/structure/entity-type/activity/secret_code/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/secret_code/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity/secret_code/fields/%','admin/structure/entity-type/activity/secret_code/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity/secret_code/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity/secret_code/fields/%','admin/structure/entity-type/activity/secret_code/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/secret_code/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity/secret_code/fields/%','admin/structure/entity-type/activity/secret_code/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity/secret_code/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/activity/secret_code/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity/secret_code/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:8:"activity";i:1;s:11:"secret_code";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:31:"eck administer activity bundles";i:3;s:25:"eck edit activity bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/activity/secret_code/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/activity/secret_code/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:44:"eck administer activity secret_code entities";i:3;s:38:"eck list activity secret_code entities";}}','eck__entity__list','a:2:{i:0;s:8:"activity";i:1;s:11:"secret_code";}','','63','6','1','admin/structure/entity-type/activity/secret_code','admin/structure/entity-type/activity/secret_code','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity_log','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck list activity_log bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/activity_log','Activity Log','t','','','a:0:{}','6','View all the bundles for ''Activity Log''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/activity_log/activity_log','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:49:"eck administer activity_log activity_log entities";i:3;s:43:"eck list activity_log activity_log entities";}}','eck__entity__list','a:2:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";}','','31','5','0','','admin/structure/entity-type/activity_log/activity_log','Activity Log','t','','','a:0:{}','6','View all entites of type Activity Log with bundle Activity Log','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log/activity_log/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"activity_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:12:"activity_log";i:2;s:12:"activity_log";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/activity_log/activity_log/%/delete','Delete Activity Log','t','','','a:0:{}','6','Delete an entity of type Activity Log with bundle Activity Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity_log/activity_log/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"activity_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:12:"activity_log";i:2;s:12:"activity_log";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/activity_log/activity_log/%/edit','Edit Activity Log','t','','','a:0:{}','6','Edit an entity of type Activity Log with bundle Activity Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity_log/activity_log/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:12:"activity_log";i:2;s:12:"activity_log";}','eck__entity__add','a:2:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";}','','63','6','0','','admin/structure/entity-type/activity_log/activity_log/add','Add Activity Log','t','','','a:0:{}','6','Add an entity of type Activity Log with bundle Activity Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity_log/activity_log/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:31:"eck delete activity_log bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/activity_log/activity_log','admin/structure/entity-type/activity_log/activity_log','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log/activity_log/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"activity_log";i:2;s:12:"activity_log";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/activity_log/activity_log','admin/structure/entity-type/activity_log/activity_log','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log/activity_log/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"activity_log";i:2;s:12:"activity_log";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/activity_log/activity_log/display','admin/structure/entity-type/activity_log/activity_log','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log/activity_log/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"activity_log";i:2;s:12:"activity_log";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/activity_log/activity_log/display','admin/structure/entity-type/activity_log/activity_log','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log/activity_log/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"activity_log";i:2;s:12:"activity_log";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/activity_log/activity_log/display','admin/structure/entity-type/activity_log/activity_log','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log/activity_log/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"activity_log";i:2;s:12:"activity_log";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/activity_log/activity_log/display','admin/structure/entity-type/activity_log/activity_log','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log/activity_log/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:12:"activity_log";i:2;s:12:"activity_log";}','','63','6','1','admin/structure/entity-type/activity_log/activity_log','admin/structure/entity-type/activity_log/activity_log','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log/activity_log/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:12:"activity_log";i:2;s:12:"activity_log";}','','63','6','1','admin/structure/entity-type/activity_log/activity_log','admin/structure/entity-type/activity_log/activity_log','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log/activity_log/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/activity_log/activity_log/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log/activity_log/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity_log/activity_log/fields/%','admin/structure/entity-type/activity_log/activity_log/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log/activity_log/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity_log/activity_log/fields/%','admin/structure/entity-type/activity_log/activity_log/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log/activity_log/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity_log/activity_log/fields/%','admin/structure/entity-type/activity_log/activity_log/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log/activity_log/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity_log/activity_log/fields/%','admin/structure/entity-type/activity_log/activity_log/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log/activity_log/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/activity_log/activity_log/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/activity_log/activity_log/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck edit activity_log bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/activity_log/activity_log/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/activity_log/activity_log/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:49:"eck administer activity_log activity_log entities";i:3;s:43:"eck list activity_log activity_log entities";}}','eck__entity__list','a:2:{i:0;s:12:"activity_log";i:1;s:12:"activity_log";}','','63','6','1','admin/structure/entity-type/activity_log/activity_log','admin/structure/entity-type/activity_log/activity_log','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity_log/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:28:"eck add activity_log bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/activity_log','admin/structure/entity-type/activity_log','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Activity Log Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:12:"activity_log";}','','31','5','1','admin/structure/entity-type/activity_log','admin/structure/entity-type/activity_log','Delete','t','','','a:0:{}','132','Delete the ''Activity Log'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/activity_log/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:12:"activity_log";}','','31','5','1','admin/structure/entity-type/activity_log','admin/structure/entity-type/activity_log','Edit','t','','','a:0:{}','132','Edit the ''Activity Log'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/activity_log/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:35:"eck administer activity_log bundles";i:3;s:29:"eck list activity_log bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/activity_log','admin/structure/entity-type/activity_log','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/activity_log/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:30:"manage activity_log properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:12:"activity_log";}','','31','5','1','admin/structure/entity-type/activity_log','admin/structure/entity-type/activity_log','Manage properties','t','','','a:0:{}','132','Manage the properties of the Activity Log entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log_reference','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck list activity_log_reference bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/activity_log_reference','Activity Log Reference','t','','','a:0:{}','6','View all the bundles for ''Activity Log Reference''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:69:"eck administer activity_log_reference activity_log_reference entities";i:3;s:63:"eck list activity_log_reference activity_log_reference entities";}}','eck__entity__list','a:2:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";}','','31','5','0','','admin/structure/entity-type/activity_log_reference/activity_log_reference','Activity Log Reference','t','','','a:0:{}','6','View all entites of type Activity Log Reference with bundle Activity Log Reference','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:22:"activity_log_reference";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/activity_log_reference/activity_log_reference/%/delete','Delete Activity Log Reference','t','','','a:0:{}','6','Delete an entity of type Activity Log Reference with bundle Activity Log Reference','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:22:"activity_log_reference";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/activity_log_reference/activity_log_reference/%/edit','Edit Activity Log Reference','t','','','a:0:{}','6','Edit an entity of type Activity Log Reference with bundle Activity Log Reference','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log_reference/activity_log_reference/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";}','eck__entity__add','a:2:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";}','','63','6','0','','admin/structure/entity-type/activity_log_reference/activity_log_reference/add','Add Activity Log Reference','t','','','a:0:{}','6','Add an entity of type Activity Log Reference with bundle Activity Log Reference','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:41:"eck delete activity_log_reference bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/activity_log_reference/activity_log_reference','admin/structure/entity-type/activity_log_reference/activity_log_reference','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/activity_log_reference/activity_log_reference','admin/structure/entity-type/activity_log_reference/activity_log_reference','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/activity_log_reference/activity_log_reference/display','admin/structure/entity-type/activity_log_reference/activity_log_reference','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log_reference/activity_log_reference/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/activity_log_reference/activity_log_reference/display','admin/structure/entity-type/activity_log_reference/activity_log_reference','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/activity_log_reference/activity_log_reference/display','admin/structure/entity-type/activity_log_reference/activity_log_reference','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/activity_log_reference/activity_log_reference/display','admin/structure/entity-type/activity_log_reference/activity_log_reference','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log_reference/activity_log_reference/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";}','','63','6','1','admin/structure/entity-type/activity_log_reference/activity_log_reference','admin/structure/entity-type/activity_log_reference/activity_log_reference','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:22:"activity_log_reference";i:2;s:22:"activity_log_reference";}','','63','6','1','admin/structure/entity-type/activity_log_reference/activity_log_reference','admin/structure/entity-type/activity_log_reference/activity_log_reference','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%','admin/structure/entity-type/activity_log_reference/activity_log_reference/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/activity_log_reference/activity_log_reference/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/activity_log_reference/activity_log_reference/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck edit activity_log_reference bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/activity_log_reference/activity_log_reference/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log_reference/activity_log_reference/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:69:"eck administer activity_log_reference activity_log_reference entities";i:3;s:63:"eck list activity_log_reference activity_log_reference entities";}}','eck__entity__list','a:2:{i:0;s:22:"activity_log_reference";i:1;s:22:"activity_log_reference";}','','63','6','1','admin/structure/entity-type/activity_log_reference/activity_log_reference','admin/structure/entity-type/activity_log_reference/activity_log_reference','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/activity_log_reference/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:38:"eck add activity_log_reference bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/activity_log_reference','admin/structure/entity-type/activity_log_reference','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Activity Log Reference Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/activity_log_reference/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:22:"activity_log_reference";}','','31','5','1','admin/structure/entity-type/activity_log_reference','admin/structure/entity-type/activity_log_reference','Delete','t','','','a:0:{}','132','Delete the ''Activity Log Reference'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/activity_log_reference/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:22:"activity_log_reference";}','','31','5','1','admin/structure/entity-type/activity_log_reference','admin/structure/entity-type/activity_log_reference','Edit','t','','','a:0:{}','132','Edit the ''Activity Log Reference'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/activity_log_reference/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:45:"eck administer activity_log_reference bundles";i:3;s:39:"eck list activity_log_reference bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/activity_log_reference','admin/structure/entity-type/activity_log_reference','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/activity_log_reference/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:40:"manage activity_log_reference properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:22:"activity_log_reference";}','','31','5','1','admin/structure/entity-type/activity_log_reference','admin/structure/entity-type/activity_log_reference','Manage properties','t','','','a:0:{}','132','Manage the properties of the Activity Log Reference entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/add','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:20:"eck add entity types";}}','drupal_get_form','a:1:{i:0;s:22:"eck__entity_type__form";}','','15','4','1','admin/structure/entity-type','admin/structure/entity-type','Add entity type','t','','','a:0:{}','388','Add a new entity type','','-1','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/badge','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck list badge bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/badge','Badge','t','','','a:0:{}','6','View all the bundles for ''Badge''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/badge/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:28:"eck administer badge bundles";i:3;s:21:"eck add badge bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/badge','admin/structure/entity-type/badge','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Badge Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/badge/badge','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:35:"eck administer badge badge entities";i:3;s:29:"eck list badge badge entities";}}','eck__entity__list','a:2:{i:0;s:5:"badge";i:1;s:5:"badge";}','','31','5','0','','admin/structure/entity-type/badge/badge','Badge','t','','','a:0:{}','6','View all entites of type Badge with bundle Badge','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/badge/badge/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"badge";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:5:"badge";i:2;s:5:"badge";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/badge/badge/%/delete','Delete Badge','t','','','a:0:{}','6','Delete an entity of type Badge with bundle Badge','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/badge/badge/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"badge";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:5:"badge";i:2;s:5:"badge";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/badge/badge/%/edit','Edit Badge','t','','','a:0:{}','6','Edit an entity of type Badge with bundle Badge','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/badge/badge/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:5:"badge";i:2;s:5:"badge";}','eck__entity__add','a:2:{i:0;s:5:"badge";i:1;s:5:"badge";}','','63','6','0','','admin/structure/entity-type/badge/badge/add','Add Badge','t','','','a:0:{}','6','Add an entity of type Badge with bundle Badge','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/badge/badge/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:28:"eck administer badge bundles";i:3;s:24:"eck delete badge bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/badge/badge','admin/structure/entity-type/badge/badge','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/badge/badge/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"badge";i:2;s:5:"badge";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/badge/badge','admin/structure/entity-type/badge/badge','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/badge/badge/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"badge";i:2;s:5:"badge";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/badge/badge/display','admin/structure/entity-type/badge/badge','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/badge/badge/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"badge";i:2;s:5:"badge";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/badge/badge/display','admin/structure/entity-type/badge/badge','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/badge/badge/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"badge";i:2;s:5:"badge";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/badge/badge/display','admin/structure/entity-type/badge/badge','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/badge/badge/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"badge";i:2;s:5:"badge";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/badge/badge/display','admin/structure/entity-type/badge/badge','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/badge/badge/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:5:"badge";i:2;s:5:"badge";}','','63','6','1','admin/structure/entity-type/badge/badge','admin/structure/entity-type/badge/badge','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/badge/badge/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:5:"badge";i:2;s:5:"badge";}','','63','6','1','admin/structure/entity-type/badge/badge','admin/structure/entity-type/badge/badge','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/badge/badge/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/badge/badge/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/badge/badge/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/badge/badge/fields/%','admin/structure/entity-type/badge/badge/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/badge/badge/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/badge/badge/fields/%','admin/structure/entity-type/badge/badge/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/badge/badge/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/badge/badge/fields/%','admin/structure/entity-type/badge/badge/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/badge/badge/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/badge/badge/fields/%','admin/structure/entity-type/badge/badge/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/badge/badge/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/badge/badge/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/badge/badge/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck edit badge bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/badge/badge/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/badge/badge/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:35:"eck administer badge badge entities";i:3;s:29:"eck list badge badge entities";}}','eck__entity__list','a:2:{i:0;s:5:"badge";i:1;s:5:"badge";}','','63','6','1','admin/structure/entity-type/badge/badge','admin/structure/entity-type/badge/badge','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/badge/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:5:"badge";}','','31','5','1','admin/structure/entity-type/badge','admin/structure/entity-type/badge','Delete','t','','','a:0:{}','132','Delete the ''Badge'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/badge/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:5:"badge";}','','31','5','1','admin/structure/entity-type/badge','admin/structure/entity-type/badge','Edit','t','','','a:0:{}','132','Edit the ''Badge'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/badge/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:28:"eck administer badge bundles";i:3;s:22:"eck list badge bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/badge','admin/structure/entity-type/badge','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/badge/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"manage badge properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:5:"badge";}','','31','5','1','admin/structure/entity-type/badge','admin/structure/entity-type/badge','Manage properties','t','','','a:0:{}','132','Manage the properties of the Badge entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/branch','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck list branch bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/branch','Branch','t','','','a:0:{}','6','View all the bundles for ''Branch''','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/branch/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:29:"eck administer branch bundles";i:3;s:22:"eck add branch bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/branch','admin/structure/entity-type/branch','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Branch Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/branch/branch','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:37:"eck administer branch branch entities";i:3;s:31:"eck list branch branch entities";}}','eck__entity__list','a:2:{i:0;s:6:"branch";i:1;s:6:"branch";}','','31','5','0','','admin/structure/entity-type/branch/branch','Branch','t','','','a:0:{}','6','View all entites of type Branch with bundle Branch','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/branch/branch/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"branch";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:6:"branch";i:2;s:6:"branch";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/branch/branch/%/delete','Delete Branch','t','','','a:0:{}','6','Delete an entity of type Branch with bundle Branch','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/branch/branch/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"branch";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:6:"branch";i:2;s:6:"branch";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/branch/branch/%/edit','Edit Branch','t','','','a:0:{}','6','Edit an entity of type Branch with bundle Branch','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/branch/branch/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:6:"branch";i:2;s:6:"branch";}','eck__entity__add','a:2:{i:0;s:6:"branch";i:1;s:6:"branch";}','','63','6','0','','admin/structure/entity-type/branch/branch/add','Add Branch','t','','','a:0:{}','6','Add an entity of type Branch with bundle Branch','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/branch/branch/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:29:"eck administer branch bundles";i:3;s:25:"eck delete branch bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/branch/branch','admin/structure/entity-type/branch/branch','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/branch/branch/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"branch";i:2;s:6:"branch";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/branch/branch','admin/structure/entity-type/branch/branch','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/branch/branch/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"branch";i:2;s:6:"branch";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/branch/branch/display','admin/structure/entity-type/branch/branch','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/branch/branch/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"branch";i:2;s:6:"branch";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/branch/branch/display','admin/structure/entity-type/branch/branch','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/branch/branch/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"branch";i:2;s:6:"branch";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/branch/branch/display','admin/structure/entity-type/branch/branch','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/branch/branch/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"branch";i:2;s:6:"branch";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/branch/branch/display','admin/structure/entity-type/branch/branch','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/branch/branch/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:6:"branch";i:2;s:6:"branch";}','','63','6','1','admin/structure/entity-type/branch/branch','admin/structure/entity-type/branch/branch','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/branch/branch/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:6:"branch";i:2;s:6:"branch";}','','63','6','1','admin/structure/entity-type/branch/branch','admin/structure/entity-type/branch/branch','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/branch/branch/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/branch/branch/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/branch/branch/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/branch/branch/fields/%','admin/structure/entity-type/branch/branch/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/branch/branch/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/branch/branch/fields/%','admin/structure/entity-type/branch/branch/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/branch/branch/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/branch/branch/fields/%','admin/structure/entity-type/branch/branch/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/branch/branch/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/branch/branch/fields/%','admin/structure/entity-type/branch/branch/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/branch/branch/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/branch/branch/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/branch/branch/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck edit branch bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/branch/branch/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/branch/branch/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:37:"eck administer branch branch entities";i:3;s:31:"eck list branch branch entities";}}','eck__entity__list','a:2:{i:0;s:6:"branch";i:1;s:6:"branch";}','','63','6','1','admin/structure/entity-type/branch/branch','admin/structure/entity-type/branch/branch','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/branch/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:6:"branch";}','','31','5','1','admin/structure/entity-type/branch','admin/structure/entity-type/branch','Delete','t','','','a:0:{}','132','Delete the ''Branch'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/branch/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:6:"branch";}','','31','5','1','admin/structure/entity-type/branch','admin/structure/entity-type/branch','Edit','t','','','a:0:{}','132','Edit the ''Branch'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/branch/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:29:"eck administer branch bundles";i:3;s:23:"eck list branch bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/branch','admin/structure/entity-type/branch','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/branch/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:24:"manage branch properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:6:"branch";}','','31','5','1','admin/structure/entity-type/branch','admin/structure/entity-type/branch','Manage properties','t','','','a:0:{}','132','Manage the properties of the Branch entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/drawing_ticket','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck list drawing_ticket bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/drawing_ticket','Drawing Ticket','t','','','a:0:{}','6','View all the bundles for ''Drawing Ticket''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/drawing_ticket/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:30:"eck add drawing_ticket bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/drawing_ticket','admin/structure/entity-type/drawing_ticket','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Drawing Ticket Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/drawing_ticket/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:14:"drawing_ticket";}','','31','5','1','admin/structure/entity-type/drawing_ticket','admin/structure/entity-type/drawing_ticket','Delete','t','','','a:0:{}','132','Delete the ''Drawing Ticket'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:53:"eck administer drawing_ticket drawing_ticket entities";i:3;s:47:"eck list drawing_ticket drawing_ticket entities";}}','eck__entity__list','a:2:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";}','','31','5','0','','admin/structure/entity-type/drawing_ticket/drawing_ticket','Drawing Ticket','t','','','a:0:{}','6','View all entites of type Drawing Ticket with bundle Drawing Ticket','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:14:"drawing_ticket";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/drawing_ticket/drawing_ticket/%/delete','Delete Drawing Ticket','t','','','a:0:{}','6','Delete an entity of type Drawing Ticket with bundle Drawing Ticket','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:14:"drawing_ticket";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/drawing_ticket/drawing_ticket/%/edit','Edit Drawing Ticket','t','','','a:0:{}','6','Edit an entity of type Drawing Ticket with bundle Drawing Ticket','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/drawing_ticket/drawing_ticket/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";}','eck__entity__add','a:2:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";}','','63','6','0','','admin/structure/entity-type/drawing_ticket/drawing_ticket/add','Add Drawing Ticket','t','','','a:0:{}','6','Add an entity of type Drawing Ticket with bundle Drawing Ticket','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:33:"eck delete drawing_ticket bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/drawing_ticket/drawing_ticket','admin/structure/entity-type/drawing_ticket/drawing_ticket','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/drawing_ticket/drawing_ticket','admin/structure/entity-type/drawing_ticket/drawing_ticket','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/drawing_ticket/drawing_ticket/display','admin/structure/entity-type/drawing_ticket/drawing_ticket','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/drawing_ticket/drawing_ticket/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/drawing_ticket/drawing_ticket/display','admin/structure/entity-type/drawing_ticket/drawing_ticket','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/drawing_ticket/drawing_ticket/display','admin/structure/entity-type/drawing_ticket/drawing_ticket','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/drawing_ticket/drawing_ticket/display','admin/structure/entity-type/drawing_ticket/drawing_ticket','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/drawing_ticket/drawing_ticket/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";}','','63','6','1','admin/structure/entity-type/drawing_ticket/drawing_ticket','admin/structure/entity-type/drawing_ticket/drawing_ticket','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";}','','63','6','1','admin/structure/entity-type/drawing_ticket/drawing_ticket','admin/structure/entity-type/drawing_ticket/drawing_ticket','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%','admin/structure/entity-type/drawing_ticket/drawing_ticket/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/drawing_ticket/drawing_ticket/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/drawing_ticket/drawing_ticket/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck edit drawing_ticket bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/drawing_ticket/drawing_ticket/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/drawing_ticket/drawing_ticket/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:53:"eck administer drawing_ticket drawing_ticket entities";i:3;s:47:"eck list drawing_ticket drawing_ticket entities";}}','eck__entity__list','a:2:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";}','','63','6','1','admin/structure/entity-type/drawing_ticket/drawing_ticket','admin/structure/entity-type/drawing_ticket/drawing_ticket','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/drawing_ticket/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:14:"drawing_ticket";}','','31','5','1','admin/structure/entity-type/drawing_ticket','admin/structure/entity-type/drawing_ticket','Edit','t','','','a:0:{}','132','Edit the ''Drawing Ticket'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/drawing_ticket/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:37:"eck administer drawing_ticket bundles";i:3;s:31:"eck list drawing_ticket bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/drawing_ticket','admin/structure/entity-type/drawing_ticket','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/drawing_ticket/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:32:"manage drawing_ticket properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:14:"drawing_ticket";}','','31','5','1','admin/structure/entity-type/drawing_ticket','admin/structure/entity-type/drawing_ticket','Manage properties','t','','','a:0:{}','132','Manage the properties of the Drawing Ticket entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/level','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck list level bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/level','Level','t','','','a:0:{}','6','View all the bundles for ''Level''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/level/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:28:"eck administer level bundles";i:3;s:21:"eck add level bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/level','admin/structure/entity-type/level','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Level Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/level/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:5:"level";}','','31','5','1','admin/structure/entity-type/level','admin/structure/entity-type/level','Delete','t','','','a:0:{}','132','Delete the ''Level'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/level/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:5:"level";}','','31','5','1','admin/structure/entity-type/level','admin/structure/entity-type/level','Edit','t','','','a:0:{}','132','Edit the ''Level'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/level/level','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:35:"eck administer level level entities";i:3;s:29:"eck list level level entities";}}','eck__entity__list','a:2:{i:0;s:5:"level";i:1;s:5:"level";}','','31','5','0','','admin/structure/entity-type/level/level','Level','t','','','a:0:{}','6','View all entites of type Level with bundle Level','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/level/level/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"level";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:5:"level";i:2;s:5:"level";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:5:"level";i:1;s:5:"level";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/level/level/%/delete','Delete Level','t','','','a:0:{}','6','Delete an entity of type Level with bundle Level','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/level/level/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"level";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:5:"level";i:2;s:5:"level";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:5:"level";i:1;s:5:"level";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/level/level/%/edit','Edit Level','t','','','a:0:{}','6','Edit an entity of type Level with bundle Level','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/level/level/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:5:"level";i:2;s:5:"level";}','eck__entity__add','a:2:{i:0;s:5:"level";i:1;s:5:"level";}','','63','6','0','','admin/structure/entity-type/level/level/add','Add Level','t','','','a:0:{}','6','Add an entity of type Level with bundle Level','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/level/level/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:28:"eck administer level bundles";i:3;s:24:"eck delete level bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/level/level','admin/structure/entity-type/level/level','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/level/level/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"level";i:2;s:5:"level";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/level/level','admin/structure/entity-type/level/level','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/level/level/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:5:"level";i:1;s:5:"level";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"level";i:2;s:5:"level";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/level/level/display','admin/structure/entity-type/level/level','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/level/level/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:5:"level";i:1;s:5:"level";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"level";i:2;s:5:"level";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/level/level/display','admin/structure/entity-type/level/level','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/level/level/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:5:"level";i:1;s:5:"level";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"level";i:2;s:5:"level";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/level/level/display','admin/structure/entity-type/level/level','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/level/level/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:5:"level";i:1;s:5:"level";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"level";i:2;s:5:"level";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/level/level/display','admin/structure/entity-type/level/level','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/level/level/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:5:"level";i:2;s:5:"level";}','','63','6','1','admin/structure/entity-type/level/level','admin/structure/entity-type/level/level','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/level/level/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:5:"level";i:2;s:5:"level";}','','63','6','1','admin/structure/entity-type/level/level','admin/structure/entity-type/level/level','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/level/level/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"level";i:1;s:5:"level";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/level/level/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/level/level/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"level";i:1;s:5:"level";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/level/level/fields/%','admin/structure/entity-type/level/level/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/level/level/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"level";i:1;s:5:"level";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/level/level/fields/%','admin/structure/entity-type/level/level/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/level/level/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"level";i:1;s:5:"level";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/level/level/fields/%','admin/structure/entity-type/level/level/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/level/level/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"level";i:1;s:5:"level";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/level/level/fields/%','admin/structure/entity-type/level/level/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/level/level/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:5:"level";i:1;s:5:"level";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/level/level/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/level/level/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:5:"level";i:1;s:5:"level";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck edit level bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/level/level/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/level/level/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:35:"eck administer level level entities";i:3;s:29:"eck list level level entities";}}','eck__entity__list','a:2:{i:0;s:5:"level";i:1;s:5:"level";}','','63','6','1','admin/structure/entity-type/level/level','admin/structure/entity-type/level/level','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/level/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:28:"eck administer level bundles";i:3;s:22:"eck list level bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/level','admin/structure/entity-type/level','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/level/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"manage level properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:5:"level";}','','31','5','1','admin/structure/entity-type/level','admin/structure/entity-type/level','Manage properties','t','','','a:0:{}','132','Manage the properties of the Level entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/nag_message','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck list nag_message bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/nag_message','Nag Message','t','','','a:0:{}','6','View all the bundles for ''Nag Message''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/nag_message/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:27:"eck add nag_message bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/nag_message','admin/structure/entity-type/nag_message','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Nag Message Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/nag_message/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:11:"nag_message";}','','31','5','1','admin/structure/entity-type/nag_message','admin/structure/entity-type/nag_message','Delete','t','','','a:0:{}','132','Delete the ''Nag Message'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/nag_message/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:11:"nag_message";}','','31','5','1','admin/structure/entity-type/nag_message','admin/structure/entity-type/nag_message','Edit','t','','','a:0:{}','132','Edit the ''Nag Message'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/nag_message/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck list nag_message bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/nag_message','admin/structure/entity-type/nag_message','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/nag_message/nag_message','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:47:"eck administer nag_message nag_message entities";i:3;s:41:"eck list nag_message nag_message entities";}}','eck__entity__list','a:2:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";}','','31','5','0','','admin/structure/entity-type/nag_message/nag_message','Nag Message','t','','','a:0:{}','6','View all entites of type Nag Message with bundle Nag Message','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/nag_message/nag_message/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:11:"nag_message";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:11:"nag_message";i:2;s:11:"nag_message";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/nag_message/nag_message/%/delete','Delete Nag Message','t','','','a:0:{}','6','Delete an entity of type Nag Message with bundle Nag Message','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/nag_message/nag_message/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:11:"nag_message";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:11:"nag_message";i:2;s:11:"nag_message";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/nag_message/nag_message/%/edit','Edit Nag Message','t','','','a:0:{}','6','Edit an entity of type Nag Message with bundle Nag Message','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/nag_message/nag_message/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:11:"nag_message";i:2;s:11:"nag_message";}','eck__entity__add','a:2:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";}','','63','6','0','','admin/structure/entity-type/nag_message/nag_message/add','Add Nag Message','t','','','a:0:{}','6','Add an entity of type Nag Message with bundle Nag Message','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/nag_message/nag_message/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:30:"eck delete nag_message bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/nag_message/nag_message','admin/structure/entity-type/nag_message/nag_message','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/nag_message/nag_message/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:11:"nag_message";i:2;s:11:"nag_message";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/nag_message/nag_message','admin/structure/entity-type/nag_message/nag_message','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/nag_message/nag_message/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:11:"nag_message";i:2;s:11:"nag_message";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/nag_message/nag_message/display','admin/structure/entity-type/nag_message/nag_message','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/nag_message/nag_message/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:11:"nag_message";i:2;s:11:"nag_message";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/nag_message/nag_message/display','admin/structure/entity-type/nag_message/nag_message','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/nag_message/nag_message/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:11:"nag_message";i:2;s:11:"nag_message";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/nag_message/nag_message/display','admin/structure/entity-type/nag_message/nag_message','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/nag_message/nag_message/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:11:"nag_message";i:2;s:11:"nag_message";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/nag_message/nag_message/display','admin/structure/entity-type/nag_message/nag_message','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/nag_message/nag_message/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:11:"nag_message";i:2;s:11:"nag_message";}','','63','6','1','admin/structure/entity-type/nag_message/nag_message','admin/structure/entity-type/nag_message/nag_message','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/nag_message/nag_message/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:11:"nag_message";i:2;s:11:"nag_message";}','','63','6','1','admin/structure/entity-type/nag_message/nag_message','admin/structure/entity-type/nag_message/nag_message','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/nag_message/nag_message/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/nag_message/nag_message/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/nag_message/nag_message/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/nag_message/nag_message/fields/%','admin/structure/entity-type/nag_message/nag_message/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/nag_message/nag_message/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/nag_message/nag_message/fields/%','admin/structure/entity-type/nag_message/nag_message/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/nag_message/nag_message/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/nag_message/nag_message/fields/%','admin/structure/entity-type/nag_message/nag_message/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/nag_message/nag_message/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/nag_message/nag_message/fields/%','admin/structure/entity-type/nag_message/nag_message/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/nag_message/nag_message/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/nag_message/nag_message/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/nag_message/nag_message/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer nag_message bundles";i:3;s:28:"eck edit nag_message bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/nag_message/nag_message/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/nag_message/nag_message/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:47:"eck administer nag_message nag_message entities";i:3;s:41:"eck list nag_message nag_message entities";}}','eck__entity__list','a:2:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";}','','63','6','1','admin/structure/entity-type/nag_message/nag_message','admin/structure/entity-type/nag_message/nag_message','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/nag_message/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:29:"manage nag_message properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:11:"nag_message";}','','31','5','1','admin/structure/entity-type/nag_message','admin/structure/entity-type/nag_message','Manage properties','t','','','a:0:{}','132','Manage the properties of the Nag Message entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/points','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck list points bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/points','Points','t','','','a:0:{}','6','View all the bundles for ''Points''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/points/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:29:"eck administer points bundles";i:3;s:22:"eck add points bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/points','admin/structure/entity-type/points','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Points Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/points/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:6:"points";}','','31','5','1','admin/structure/entity-type/points','admin/structure/entity-type/points','Delete','t','','','a:0:{}','132','Delete the ''Points'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/points/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:6:"points";}','','31','5','1','admin/structure/entity-type/points','admin/structure/entity-type/points','Edit','t','','','a:0:{}','132','Edit the ''Points'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/points/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck list points bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/points','admin/structure/entity-type/points','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/points/points','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:37:"eck administer points points entities";i:3;s:31:"eck list points points entities";}}','eck__entity__list','a:2:{i:0;s:6:"points";i:1;s:6:"points";}','','31','5','0','','admin/structure/entity-type/points/points','Points','t','','','a:0:{}','6','View all entites of type Points with bundle Points','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/points/points/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"points";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:6:"points";i:2;s:6:"points";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:6:"points";i:1;s:6:"points";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/points/points/%/delete','Delete Points','t','','','a:0:{}','6','Delete an entity of type Points with bundle Points','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/points/points/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"points";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:6:"points";i:2;s:6:"points";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:6:"points";i:1;s:6:"points";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/points/points/%/edit','Edit Points','t','','','a:0:{}','6','Edit an entity of type Points with bundle Points','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/points/points/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:6:"points";i:2;s:6:"points";}','eck__entity__add','a:2:{i:0;s:6:"points";i:1;s:6:"points";}','','63','6','0','','admin/structure/entity-type/points/points/add','Add Points','t','','','a:0:{}','6','Add an entity of type Points with bundle Points','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/points/points/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:29:"eck administer points bundles";i:3;s:25:"eck delete points bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/points/points','admin/structure/entity-type/points/points','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/points/points/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"points";i:2;s:6:"points";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/points/points','admin/structure/entity-type/points/points','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/points/points/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"points";i:1;s:6:"points";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"points";i:2;s:6:"points";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/points/points/display','admin/structure/entity-type/points/points','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/points/points/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"points";i:1;s:6:"points";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"points";i:2;s:6:"points";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/points/points/display','admin/structure/entity-type/points/points','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/points/points/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"points";i:1;s:6:"points";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"points";i:2;s:6:"points";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/points/points/display','admin/structure/entity-type/points/points','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/points/points/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"points";i:1;s:6:"points";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"points";i:2;s:6:"points";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/points/points/display','admin/structure/entity-type/points/points','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/points/points/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:6:"points";i:2;s:6:"points";}','','63','6','1','admin/structure/entity-type/points/points','admin/structure/entity-type/points/points','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/points/points/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:6:"points";i:2;s:6:"points";}','','63','6','1','admin/structure/entity-type/points/points','admin/structure/entity-type/points/points','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/points/points/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"points";i:1;s:6:"points";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/points/points/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/points/points/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"points";i:1;s:6:"points";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/points/points/fields/%','admin/structure/entity-type/points/points/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/points/points/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"points";i:1;s:6:"points";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/points/points/fields/%','admin/structure/entity-type/points/points/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/points/points/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"points";i:1;s:6:"points";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/points/points/fields/%','admin/structure/entity-type/points/points/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/points/points/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"points";i:1;s:6:"points";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/points/points/fields/%','admin/structure/entity-type/points/points/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/points/points/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:6:"points";i:1;s:6:"points";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/points/points/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/points/points/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:6:"points";i:1;s:6:"points";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer points bundles";i:3;s:23:"eck edit points bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/points/points/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/points/points/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:37:"eck administer points points entities";i:3;s:31:"eck list points points entities";}}','eck__entity__list','a:2:{i:0;s:6:"points";i:1;s:6:"points";}','','63','6','1','admin/structure/entity-type/points/points','admin/structure/entity-type/points/points','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/points/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:24:"manage points properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:6:"points";}','','31','5','1','admin/structure/entity-type/points','admin/structure/entity-type/points','Manage properties','t','','','a:0:{}','132','Manage the properties of the Points entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/prize','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck list prize bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/prize','Prize','t','','','a:0:{}','6','View all the bundles for ''Prize''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/prize/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:28:"eck administer prize bundles";i:3;s:21:"eck add prize bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/prize','admin/structure/entity-type/prize','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Prize Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/prize/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:5:"prize";}','','31','5','1','admin/structure/entity-type/prize','admin/structure/entity-type/prize','Delete','t','','','a:0:{}','132','Delete the ''Prize'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/prize/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:5:"prize";}','','31','5','1','admin/structure/entity-type/prize','admin/structure/entity-type/prize','Edit','t','','','a:0:{}','132','Edit the ''Prize'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/prize/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck list prize bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/prize','admin/structure/entity-type/prize','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/prize/prize','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:35:"eck administer prize prize entities";i:3;s:29:"eck list prize prize entities";}}','eck__entity__list','a:2:{i:0;s:5:"prize";i:1;s:5:"prize";}','','31','5','0','','admin/structure/entity-type/prize/prize','Prize','t','','','a:0:{}','6','View all entites of type Prize with bundle Prize','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/prize/prize/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"prize";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:5:"prize";i:2;s:5:"prize";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/prize/prize/%/delete','Delete Prize','t','','','a:0:{}','6','Delete an entity of type Prize with bundle Prize','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/prize/prize/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"prize";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:5:"prize";i:2;s:5:"prize";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/prize/prize/%/edit','Edit Prize','t','','','a:0:{}','6','Edit an entity of type Prize with bundle Prize','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/prize/prize/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:5:"prize";i:2;s:5:"prize";}','eck__entity__add','a:2:{i:0;s:5:"prize";i:1;s:5:"prize";}','','63','6','0','','admin/structure/entity-type/prize/prize/add','Add Prize','t','','','a:0:{}','6','Add an entity of type Prize with bundle Prize','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/prize/prize/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:28:"eck administer prize bundles";i:3;s:24:"eck delete prize bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/prize/prize','admin/structure/entity-type/prize/prize','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/prize/prize/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"prize";i:2;s:5:"prize";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/prize/prize','admin/structure/entity-type/prize/prize','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/prize/prize/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"prize";i:2;s:5:"prize";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/prize/prize/display','admin/structure/entity-type/prize/prize','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/prize/prize/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"prize";i:2;s:5:"prize";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/prize/prize/display','admin/structure/entity-type/prize/prize','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/prize/prize/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"prize";i:2;s:5:"prize";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/prize/prize/display','admin/structure/entity-type/prize/prize','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/prize/prize/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:5:"prize";i:2;s:5:"prize";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/prize/prize/display','admin/structure/entity-type/prize/prize','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/prize/prize/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:5:"prize";i:2;s:5:"prize";}','','63','6','1','admin/structure/entity-type/prize/prize','admin/structure/entity-type/prize/prize','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/prize/prize/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:5:"prize";i:2;s:5:"prize";}','','63','6','1','admin/structure/entity-type/prize/prize','admin/structure/entity-type/prize/prize','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/prize/prize/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/prize/prize/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/prize/prize/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/prize/prize/fields/%','admin/structure/entity-type/prize/prize/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/prize/prize/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/prize/prize/fields/%','admin/structure/entity-type/prize/prize/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/prize/prize/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/prize/prize/fields/%','admin/structure/entity-type/prize/prize/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/prize/prize/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/prize/prize/fields/%','admin/structure/entity-type/prize/prize/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/prize/prize/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/prize/prize/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/prize/prize/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:28:"eck administer prize bundles";i:3;s:22:"eck edit prize bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/prize/prize/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/prize/prize/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:35:"eck administer prize prize entities";i:3;s:29:"eck list prize prize entities";}}','eck__entity__list','a:2:{i:0;s:5:"prize";i:1;s:5:"prize";}','','63','6','1','admin/structure/entity-type/prize/prize','admin/structure/entity-type/prize/prize','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/prize/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"manage prize properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:5:"prize";}','','31','5','1','admin/structure/entity-type/prize','admin/structure/entity-type/prize','Manage properties','t','','','a:0:{}','132','Manage the properties of the Prize entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/program','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck list program bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/program','Program','t','','','a:0:{}','6','View all the bundles for ''Program''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/program/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:30:"eck administer program bundles";i:3;s:23:"eck add program bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/program','admin/structure/entity-type/program','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Program Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/program/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:7:"program";}','','31','5','1','admin/structure/entity-type/program','admin/structure/entity-type/program','Delete','t','','','a:0:{}','132','Delete the ''Program'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/program/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:7:"program";}','','31','5','1','admin/structure/entity-type/program','admin/structure/entity-type/program','Edit','t','','','a:0:{}','132','Edit the ''Program'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/program/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck list program bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/program','admin/structure/entity-type/program','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/program/program','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:39:"eck administer program program entities";i:3;s:33:"eck list program program entities";}}','eck__entity__list','a:2:{i:0;s:7:"program";i:1;s:7:"program";}','','31','5','0','','admin/structure/entity-type/program/program','Program','t','','','a:0:{}','6','View all entites of type Program with bundle Program','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/program/program/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:7:"program";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:7:"program";i:2;s:7:"program";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:7:"program";i:1;s:7:"program";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/program/program/%/delete','Delete Program','t','','','a:0:{}','6','Delete an entity of type Program with bundle Program','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/program/program/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:7:"program";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:7:"program";i:2;s:7:"program";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:7:"program";i:1;s:7:"program";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/program/program/%/edit','Edit Program','t','','','a:0:{}','6','Edit an entity of type Program with bundle Program','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/program/program/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:7:"program";i:2;s:7:"program";}','eck__entity__add','a:2:{i:0;s:7:"program";i:1;s:7:"program";}','','63','6','0','','admin/structure/entity-type/program/program/add','Add Program','t','','','a:0:{}','6','Add an entity of type Program with bundle Program','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/program/program/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:30:"eck administer program bundles";i:3;s:26:"eck delete program bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/program/program','admin/structure/entity-type/program/program','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/program/program/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:7:"program";i:2;s:7:"program";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/program/program','admin/structure/entity-type/program/program','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/program/program/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:"program";i:1;s:7:"program";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:7:"program";i:2;s:7:"program";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/program/program/display','admin/structure/entity-type/program/program','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/program/program/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:"program";i:1;s:7:"program";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:7:"program";i:2;s:7:"program";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/program/program/display','admin/structure/entity-type/program/program','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/program/program/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:"program";i:1;s:7:"program";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:7:"program";i:2;s:7:"program";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/program/program/display','admin/structure/entity-type/program/program','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/program/program/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:"program";i:1;s:7:"program";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:7:"program";i:2;s:7:"program";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/program/program/display','admin/structure/entity-type/program/program','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/program/program/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:7:"program";i:2;s:7:"program";}','','63','6','1','admin/structure/entity-type/program/program','admin/structure/entity-type/program/program','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/program/program/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:7:"program";i:2;s:7:"program";}','','63','6','1','admin/structure/entity-type/program/program','admin/structure/entity-type/program/program','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/program/program/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:7:"program";i:1;s:7:"program";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/program/program/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/program/program/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:7:"program";i:1;s:7:"program";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/program/program/fields/%','admin/structure/entity-type/program/program/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/program/program/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:7:"program";i:1;s:7:"program";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/program/program/fields/%','admin/structure/entity-type/program/program/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/program/program/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:7:"program";i:1;s:7:"program";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/program/program/fields/%','admin/structure/entity-type/program/program/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/program/program/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:7:"program";i:1;s:7:"program";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/program/program/fields/%','admin/structure/entity-type/program/program/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/program/program/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:7:"program";i:1;s:7:"program";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/program/program/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/program/program/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:7:"program";i:1;s:7:"program";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:30:"eck administer program bundles";i:3;s:24:"eck edit program bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/program/program/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/program/program/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:39:"eck administer program program entities";i:3;s:33:"eck list program program entities";}}','eck__entity__list','a:2:{i:0;s:7:"program";i:1;s:7:"program";}','','63','6','1','admin/structure/entity-type/program/program','admin/structure/entity-type/program/program','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/program/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:25:"manage program properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:7:"program";}','','31','5','1','admin/structure/entity-type/program','admin/structure/entity-type/program','Manage properties','t','','','a:0:{}','132','Manage the properties of the Program entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck list reader bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/reader','Reader','t','','','a:0:{}','6','View all the bundles for ''Reader''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:29:"eck administer reader bundles";i:3;s:22:"eck add reader bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/reader','admin/structure/entity-type/reader','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Reader Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:6:"reader";}','','31','5','1','admin/structure/entity-type/reader','admin/structure/entity-type/reader','Delete','t','','','a:0:{}','132','Delete the ''Reader'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/reader/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:6:"reader";}','','31','5','1','admin/structure/entity-type/reader','admin/structure/entity-type/reader','Edit','t','','','a:0:{}','132','Edit the ''Reader'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/reader/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck list reader bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/reader','admin/structure/entity-type/reader','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:24:"manage reader properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:6:"reader";}','','31','5','1','admin/structure/entity-type/reader','admin/structure/entity-type/reader','Manage properties','t','','','a:0:{}','132','Manage the properties of the Reader entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/reader/reader','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:37:"eck administer reader reader entities";i:3;s:31:"eck list reader reader entities";}}','eck__entity__list','a:2:{i:0;s:6:"reader";i:1;s:6:"reader";}','','31','5','0','','admin/structure/entity-type/reader/reader','Reader','t','','','a:0:{}','6','View all entites of type Reader with bundle Reader','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader/reader/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"reader";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:6:"reader";i:2;s:6:"reader";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reader/reader/%/delete','Delete Reader','t','','','a:0:{}','6','Delete an entity of type Reader with bundle Reader','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader/reader/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"reader";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:6:"reader";i:2;s:6:"reader";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reader/reader/%/edit','Edit Reader','t','','','a:0:{}','6','Edit an entity of type Reader with bundle Reader','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader/reader/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:6:"reader";i:2;s:6:"reader";}','eck__entity__add','a:2:{i:0;s:6:"reader";i:1;s:6:"reader";}','','63','6','0','','admin/structure/entity-type/reader/reader/add','Add Reader','t','','','a:0:{}','6','Add an entity of type Reader with bundle Reader','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader/reader/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:29:"eck administer reader bundles";i:3;s:25:"eck delete reader bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/reader/reader','admin/structure/entity-type/reader/reader','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader/reader/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"reader";i:2;s:6:"reader";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/reader/reader','admin/structure/entity-type/reader/reader','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader/reader/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"reader";i:2;s:6:"reader";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/reader/reader/display','admin/structure/entity-type/reader/reader','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader/reader/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"reader";i:2;s:6:"reader";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/reader/reader/display','admin/structure/entity-type/reader/reader','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader/reader/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"reader";i:2;s:6:"reader";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/reader/reader/display','admin/structure/entity-type/reader/reader','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader/reader/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"reader";i:2;s:6:"reader";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/reader/reader/display','admin/structure/entity-type/reader/reader','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader/reader/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:6:"reader";i:2;s:6:"reader";}','','63','6','1','admin/structure/entity-type/reader/reader','admin/structure/entity-type/reader/reader','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader/reader/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:6:"reader";i:2;s:6:"reader";}','','63','6','1','admin/structure/entity-type/reader/reader','admin/structure/entity-type/reader/reader','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader/reader/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/reader/reader/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader/reader/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader/reader/fields/%','admin/structure/entity-type/reader/reader/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader/reader/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader/reader/fields/%','admin/structure/entity-type/reader/reader/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader/reader/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader/reader/fields/%','admin/structure/entity-type/reader/reader/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader/reader/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader/reader/fields/%','admin/structure/entity-type/reader/reader/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader/reader/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reader/reader/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/reader/reader/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer reader bundles";i:3;s:23:"eck edit reader bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reader/reader/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/reader/reader/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:37:"eck administer reader reader entities";i:3;s:31:"eck list reader reader entities";}}','eck__entity__list','a:2:{i:0;s:6:"reader";i:1;s:6:"reader";}','','63','6','1','admin/structure/entity-type/reader/reader','admin/structure/entity-type/reader/reader','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_activity_log','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck list reader_activity_log bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/reader_activity_log','Reader Activity Log','t','','','a:0:{}','6','View all the bundles for ''Reader Activity Log''','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_activity_log/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:35:"eck add reader_activity_log bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/reader_activity_log','admin/structure/entity-type/reader_activity_log','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Reader Activity Log Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_activity_log/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:19:"reader_activity_log";}','','31','5','1','admin/structure/entity-type/reader_activity_log','admin/structure/entity-type/reader_activity_log','Delete','t','','','a:0:{}','132','Delete the ''Reader Activity Log'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/reader_activity_log/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:19:"reader_activity_log";}','','31','5','1','admin/structure/entity-type/reader_activity_log','admin/structure/entity-type/reader_activity_log','Edit','t','','','a:0:{}','132','Edit the ''Reader Activity Log'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/reader_activity_log/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck list reader_activity_log bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/reader_activity_log','admin/structure/entity-type/reader_activity_log','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_activity_log/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:37:"manage reader_activity_log properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:19:"reader_activity_log";}','','31','5','1','admin/structure/entity-type/reader_activity_log','admin/structure/entity-type/reader_activity_log','Manage properties','t','','','a:0:{}','132','Manage the properties of the Reader Activity Log entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:63:"eck administer reader_activity_log reader_activity_log entities";i:3;s:57:"eck list reader_activity_log reader_activity_log entities";}}','eck__entity__list','a:2:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";}','','31','5','0','','admin/structure/entity-type/reader_activity_log/reader_activity_log','Reader Activity Log','t','','','a:0:{}','6','View all entites of type Reader Activity Log with bundle Reader Activity Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:19:"reader_activity_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reader_activity_log/reader_activity_log/%/delete','Delete Reader Activity Log','t','','','a:0:{}','6','Delete an entity of type Reader Activity Log with bundle Reader Activity Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:19:"reader_activity_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reader_activity_log/reader_activity_log/%/edit','Edit Reader Activity Log','t','','','a:0:{}','6','Edit an entity of type Reader Activity Log with bundle Reader Activity Log','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_activity_log/reader_activity_log/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";}','eck__entity__add','a:2:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";}','','63','6','0','','admin/structure/entity-type/reader_activity_log/reader_activity_log/add','Add Reader Activity Log','t','','','a:0:{}','6','Add an entity of type Reader Activity Log with bundle Reader Activity Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:38:"eck delete reader_activity_log bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/reader_activity_log/reader_activity_log','admin/structure/entity-type/reader_activity_log/reader_activity_log','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/reader_activity_log/reader_activity_log','admin/structure/entity-type/reader_activity_log/reader_activity_log','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/reader_activity_log/reader_activity_log/display','admin/structure/entity-type/reader_activity_log/reader_activity_log','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_activity_log/reader_activity_log/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/reader_activity_log/reader_activity_log/display','admin/structure/entity-type/reader_activity_log/reader_activity_log','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/reader_activity_log/reader_activity_log/display','admin/structure/entity-type/reader_activity_log/reader_activity_log','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/reader_activity_log/reader_activity_log/display','admin/structure/entity-type/reader_activity_log/reader_activity_log','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_activity_log/reader_activity_log/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";}','','63','6','1','admin/structure/entity-type/reader_activity_log/reader_activity_log','admin/structure/entity-type/reader_activity_log/reader_activity_log','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";}','','63','6','1','admin/structure/entity-type/reader_activity_log/reader_activity_log','admin/structure/entity-type/reader_activity_log/reader_activity_log','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%','admin/structure/entity-type/reader_activity_log/reader_activity_log/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reader_activity_log/reader_activity_log/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/reader_activity_log/reader_activity_log/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:42:"eck administer reader_activity_log bundles";i:3;s:36:"eck edit reader_activity_log bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reader_activity_log/reader_activity_log/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_activity_log/reader_activity_log/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:63:"eck administer reader_activity_log reader_activity_log entities";i:3;s:57:"eck list reader_activity_log reader_activity_log entities";}}','eck__entity__list','a:2:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";}','','63','6','1','admin/structure/entity-type/reader_activity_log/reader_activity_log','admin/structure/entity-type/reader_activity_log/reader_activity_log','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_badge','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck list reader_badge bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/reader_badge','Reader Badge','t','','','a:0:{}','6','View all the bundles for ''Reader Badge''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_badge/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:28:"eck add reader_badge bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/reader_badge','admin/structure/entity-type/reader_badge','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Reader Badge Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_badge/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:12:"reader_badge";}','','31','5','1','admin/structure/entity-type/reader_badge','admin/structure/entity-type/reader_badge','Delete','t','','','a:0:{}','132','Delete the ''Reader Badge'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_badge/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:12:"reader_badge";}','','31','5','1','admin/structure/entity-type/reader_badge','admin/structure/entity-type/reader_badge','Edit','t','','','a:0:{}','132','Edit the ''Reader Badge'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/reader_badge/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck list reader_badge bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/reader_badge','admin/structure/entity-type/reader_badge','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_badge/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:30:"manage reader_badge properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:12:"reader_badge";}','','31','5','1','admin/structure/entity-type/reader_badge','admin/structure/entity-type/reader_badge','Manage properties','t','','','a:0:{}','132','Manage the properties of the Reader Badge entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/reader_badge/reader_badge','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:49:"eck administer reader_badge reader_badge entities";i:3;s:43:"eck list reader_badge reader_badge entities";}}','eck__entity__list','a:2:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";}','','31','5','0','','admin/structure/entity-type/reader_badge/reader_badge','Reader Badge','t','','','a:0:{}','6','View all entites of type Reader Badge with bundle Reader Badge','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_badge/reader_badge/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"reader_badge";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reader_badge/reader_badge/%/delete','Delete Reader Badge','t','','','a:0:{}','6','Delete an entity of type Reader Badge with bundle Reader Badge','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_badge/reader_badge/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"reader_badge";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reader_badge/reader_badge/%/edit','Edit Reader Badge','t','','','a:0:{}','6','Edit an entity of type Reader Badge with bundle Reader Badge','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_badge/reader_badge/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";}','eck__entity__add','a:2:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";}','','63','6','0','','admin/structure/entity-type/reader_badge/reader_badge/add','Add Reader Badge','t','','','a:0:{}','6','Add an entity of type Reader Badge with bundle Reader Badge','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_badge/reader_badge/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:31:"eck delete reader_badge bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/reader_badge/reader_badge','admin/structure/entity-type/reader_badge/reader_badge','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_badge/reader_badge/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/reader_badge/reader_badge','admin/structure/entity-type/reader_badge/reader_badge','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_badge/reader_badge/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/reader_badge/reader_badge/display','admin/structure/entity-type/reader_badge/reader_badge','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_badge/reader_badge/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/reader_badge/reader_badge/display','admin/structure/entity-type/reader_badge/reader_badge','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_badge/reader_badge/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/reader_badge/reader_badge/display','admin/structure/entity-type/reader_badge/reader_badge','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_badge/reader_badge/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/reader_badge/reader_badge/display','admin/structure/entity-type/reader_badge/reader_badge','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_badge/reader_badge/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";}','','63','6','1','admin/structure/entity-type/reader_badge/reader_badge','admin/structure/entity-type/reader_badge/reader_badge','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_badge/reader_badge/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";}','','63','6','1','admin/structure/entity-type/reader_badge/reader_badge','admin/structure/entity-type/reader_badge/reader_badge','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_badge/reader_badge/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/reader_badge/reader_badge/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_badge/reader_badge/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_badge/reader_badge/fields/%','admin/structure/entity-type/reader_badge/reader_badge/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_badge/reader_badge/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_badge/reader_badge/fields/%','admin/structure/entity-type/reader_badge/reader_badge/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_badge/reader_badge/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_badge/reader_badge/fields/%','admin/structure/entity-type/reader_badge/reader_badge/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_badge/reader_badge/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_badge/reader_badge/fields/%','admin/structure/entity-type/reader_badge/reader_badge/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_badge/reader_badge/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reader_badge/reader_badge/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/reader_badge/reader_badge/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_badge bundles";i:3;s:29:"eck edit reader_badge bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reader_badge/reader_badge/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/reader_badge/reader_badge/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:49:"eck administer reader_badge reader_badge entities";i:3;s:43:"eck list reader_badge reader_badge entities";}}','eck__entity__list','a:2:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";}','','63','6','1','admin/structure/entity-type/reader_badge/reader_badge','admin/structure/entity-type/reader_badge/reader_badge','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_log','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck list reader_log bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/reader_log','Reader Log','t','','','a:0:{}','6','View all the bundles for ''Reader Log''','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_log/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:26:"eck add reader_log bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/reader_log','admin/structure/entity-type/reader_log','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Reader Log Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_log/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:10:"reader_log";}','','31','5','1','admin/structure/entity-type/reader_log','admin/structure/entity-type/reader_log','Delete','t','','','a:0:{}','132','Delete the ''Reader Log'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/reader_log/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:10:"reader_log";}','','31','5','1','admin/structure/entity-type/reader_log','admin/structure/entity-type/reader_log','Edit','t','','','a:0:{}','132','Edit the ''Reader Log'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/reader_log/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck list reader_log bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/reader_log','admin/structure/entity-type/reader_log','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_log/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:28:"manage reader_log properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:10:"reader_log";}','','31','5','1','admin/structure/entity-type/reader_log','admin/structure/entity-type/reader_log','Manage properties','t','','','a:0:{}','132','Manage the properties of the Reader Log entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_log/reader_log','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:45:"eck administer reader_log reader_log entities";i:3;s:39:"eck list reader_log reader_log entities";}}','eck__entity__list','a:2:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";}','','31','5','0','','admin/structure/entity-type/reader_log/reader_log','Reader Log','t','','','a:0:{}','6','View all entites of type Reader Log with bundle Reader Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_log/reader_log/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:10:"reader_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:10:"reader_log";i:2;s:10:"reader_log";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reader_log/reader_log/%/delete','Delete Reader Log','t','','','a:0:{}','6','Delete an entity of type Reader Log with bundle Reader Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_log/reader_log/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:10:"reader_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:10:"reader_log";i:2;s:10:"reader_log";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reader_log/reader_log/%/edit','Edit Reader Log','t','','','a:0:{}','6','Edit an entity of type Reader Log with bundle Reader Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_log/reader_log/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:10:"reader_log";i:2;s:10:"reader_log";}','eck__entity__add','a:2:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";}','','63','6','0','','admin/structure/entity-type/reader_log/reader_log/add','Add Reader Log','t','','','a:0:{}','6','Add an entity of type Reader Log with bundle Reader Log','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_log/reader_log/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:29:"eck delete reader_log bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/reader_log/reader_log','admin/structure/entity-type/reader_log/reader_log','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_log/reader_log/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:10:"reader_log";i:2;s:10:"reader_log";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/reader_log/reader_log','admin/structure/entity-type/reader_log/reader_log','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_log/reader_log/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:10:"reader_log";i:2;s:10:"reader_log";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/reader_log/reader_log/display','admin/structure/entity-type/reader_log/reader_log','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_log/reader_log/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:10:"reader_log";i:2;s:10:"reader_log";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/reader_log/reader_log/display','admin/structure/entity-type/reader_log/reader_log','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_log/reader_log/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:10:"reader_log";i:2;s:10:"reader_log";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/reader_log/reader_log/display','admin/structure/entity-type/reader_log/reader_log','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_log/reader_log/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:10:"reader_log";i:2;s:10:"reader_log";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/reader_log/reader_log/display','admin/structure/entity-type/reader_log/reader_log','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_log/reader_log/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:10:"reader_log";i:2;s:10:"reader_log";}','','63','6','1','admin/structure/entity-type/reader_log/reader_log','admin/structure/entity-type/reader_log/reader_log','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_log/reader_log/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:10:"reader_log";i:2;s:10:"reader_log";}','','63','6','1','admin/structure/entity-type/reader_log/reader_log','admin/structure/entity-type/reader_log/reader_log','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_log/reader_log/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/reader_log/reader_log/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_log/reader_log/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_log/reader_log/fields/%','admin/structure/entity-type/reader_log/reader_log/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_log/reader_log/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_log/reader_log/fields/%','admin/structure/entity-type/reader_log/reader_log/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_log/reader_log/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_log/reader_log/fields/%','admin/structure/entity-type/reader_log/reader_log/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_log/reader_log/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_log/reader_log/fields/%','admin/structure/entity-type/reader_log/reader_log/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_log/reader_log/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reader_log/reader_log/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/reader_log/reader_log/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:33:"eck administer reader_log bundles";i:3;s:27:"eck edit reader_log bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reader_log/reader_log/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/reader_log/reader_log/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:45:"eck administer reader_log reader_log entities";i:3;s:39:"eck list reader_log reader_log entities";}}','eck__entity__list','a:2:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";}','','63','6','1','admin/structure/entity-type/reader_log/reader_log','admin/structure/entity-type/reader_log/reader_log','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_prize','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck list reader_prize bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/reader_prize','Reader Prize','t','','','a:0:{}','6','View all the bundles for ''Reader Prize''','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_prize/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:28:"eck add reader_prize bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/reader_prize','admin/structure/entity-type/reader_prize','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Reader Prize Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_prize/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:12:"reader_prize";}','','31','5','1','admin/structure/entity-type/reader_prize','admin/structure/entity-type/reader_prize','Delete','t','','','a:0:{}','132','Delete the ''Reader Prize'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/reader_prize/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:12:"reader_prize";}','','31','5','1','admin/structure/entity-type/reader_prize','admin/structure/entity-type/reader_prize','Edit','t','','','a:0:{}','132','Edit the ''Reader Prize'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/reader_prize/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck list reader_prize bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/reader_prize','admin/structure/entity-type/reader_prize','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_prize/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:30:"manage reader_prize properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:12:"reader_prize";}','','31','5','1','admin/structure/entity-type/reader_prize','admin/structure/entity-type/reader_prize','Manage properties','t','','','a:0:{}','132','Manage the properties of the Reader Prize entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/reader_prize/reader_prize','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:49:"eck administer reader_prize reader_prize entities";i:3;s:43:"eck list reader_prize reader_prize entities";}}','eck__entity__list','a:2:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";}','','31','5','0','','admin/structure/entity-type/reader_prize/reader_prize','Reader Prize','t','','','a:0:{}','6','View all entites of type Reader Prize with bundle Reader Prize','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_prize/reader_prize/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"reader_prize";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reader_prize/reader_prize/%/delete','Delete Reader Prize','t','','','a:0:{}','6','Delete an entity of type Reader Prize with bundle Reader Prize','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_prize/reader_prize/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"reader_prize";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reader_prize/reader_prize/%/edit','Edit Reader Prize','t','','','a:0:{}','6','Edit an entity of type Reader Prize with bundle Reader Prize','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_prize/reader_prize/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";}','eck__entity__add','a:2:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";}','','63','6','0','','admin/structure/entity-type/reader_prize/reader_prize/add','Add Reader Prize','t','','','a:0:{}','6','Add an entity of type Reader Prize with bundle Reader Prize','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_prize/reader_prize/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:31:"eck delete reader_prize bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/reader_prize/reader_prize','admin/structure/entity-type/reader_prize/reader_prize','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_prize/reader_prize/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/reader_prize/reader_prize','admin/structure/entity-type/reader_prize/reader_prize','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_prize/reader_prize/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/reader_prize/reader_prize/display','admin/structure/entity-type/reader_prize/reader_prize','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_prize/reader_prize/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/reader_prize/reader_prize/display','admin/structure/entity-type/reader_prize/reader_prize','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_prize/reader_prize/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/reader_prize/reader_prize/display','admin/structure/entity-type/reader_prize/reader_prize','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_prize/reader_prize/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/reader_prize/reader_prize/display','admin/structure/entity-type/reader_prize/reader_prize','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_prize/reader_prize/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";}','','63','6','1','admin/structure/entity-type/reader_prize/reader_prize','admin/structure/entity-type/reader_prize/reader_prize','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_prize/reader_prize/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";}','','63','6','1','admin/structure/entity-type/reader_prize/reader_prize','admin/structure/entity-type/reader_prize/reader_prize','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_prize/reader_prize/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/reader_prize/reader_prize/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_prize/reader_prize/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_prize/reader_prize/fields/%','admin/structure/entity-type/reader_prize/reader_prize/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_prize/reader_prize/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_prize/reader_prize/fields/%','admin/structure/entity-type/reader_prize/reader_prize/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_prize/reader_prize/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_prize/reader_prize/fields/%','admin/structure/entity-type/reader_prize/reader_prize/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_prize/reader_prize/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_prize/reader_prize/fields/%','admin/structure/entity-type/reader_prize/reader_prize/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_prize/reader_prize/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reader_prize/reader_prize/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/reader_prize/reader_prize/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:35:"eck administer reader_prize bundles";i:3;s:29:"eck edit reader_prize bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reader_prize/reader_prize/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/reader_prize/reader_prize/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:49:"eck administer reader_prize reader_prize entities";i:3;s:43:"eck list reader_prize reader_prize entities";}}','eck__entity__list','a:2:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";}','','63','6','1','admin/structure/entity-type/reader_prize/reader_prize','admin/structure/entity-type/reader_prize/reader_prize','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_ticket','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck list reader_ticket bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/reader_ticket','Reader Ticket','t','','','a:0:{}','6','View all the bundles for ''Reader Ticket''','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_ticket/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:29:"eck add reader_ticket bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/reader_ticket','admin/structure/entity-type/reader_ticket','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Reader Ticket Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_ticket/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:13:"reader_ticket";}','','31','5','1','admin/structure/entity-type/reader_ticket','admin/structure/entity-type/reader_ticket','Delete','t','','','a:0:{}','132','Delete the ''Reader Ticket'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/reader_ticket/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:13:"reader_ticket";}','','31','5','1','admin/structure/entity-type/reader_ticket','admin/structure/entity-type/reader_ticket','Edit','t','','','a:0:{}','132','Edit the ''Reader Ticket'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/reader_ticket/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck list reader_ticket bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/reader_ticket','admin/structure/entity-type/reader_ticket','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_ticket/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:31:"manage reader_ticket properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:13:"reader_ticket";}','','31','5','1','admin/structure/entity-type/reader_ticket','admin/structure/entity-type/reader_ticket','Manage properties','t','','','a:0:{}','132','Manage the properties of the Reader Ticket entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:51:"eck administer reader_ticket reader_ticket entities";i:3;s:45:"eck list reader_ticket reader_ticket entities";}}','eck__entity__list','a:2:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";}','','31','5','0','','admin/structure/entity-type/reader_ticket/reader_ticket','Reader Ticket','t','','','a:0:{}','6','View all entites of type Reader Ticket with bundle Reader Ticket','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:13:"reader_ticket";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reader_ticket/reader_ticket/%/delete','Delete Reader Ticket','t','','','a:0:{}','6','Delete an entity of type Reader Ticket with bundle Reader Ticket','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:13:"reader_ticket";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reader_ticket/reader_ticket/%/edit','Edit Reader Ticket','t','','','a:0:{}','6','Edit an entity of type Reader Ticket with bundle Reader Ticket','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_ticket/reader_ticket/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";}','eck__entity__add','a:2:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";}','','63','6','0','','admin/structure/entity-type/reader_ticket/reader_ticket/add','Add Reader Ticket','t','','','a:0:{}','6','Add an entity of type Reader Ticket with bundle Reader Ticket','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:32:"eck delete reader_ticket bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/reader_ticket/reader_ticket','admin/structure/entity-type/reader_ticket/reader_ticket','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/reader_ticket/reader_ticket','admin/structure/entity-type/reader_ticket/reader_ticket','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/reader_ticket/reader_ticket/display','admin/structure/entity-type/reader_ticket/reader_ticket','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_ticket/reader_ticket/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/reader_ticket/reader_ticket/display','admin/structure/entity-type/reader_ticket/reader_ticket','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/reader_ticket/reader_ticket/display','admin/structure/entity-type/reader_ticket/reader_ticket','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/reader_ticket/reader_ticket/display','admin/structure/entity-type/reader_ticket/reader_ticket','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_ticket/reader_ticket/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";}','','63','6','1','admin/structure/entity-type/reader_ticket/reader_ticket','admin/structure/entity-type/reader_ticket/reader_ticket','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";}','','63','6','1','admin/structure/entity-type/reader_ticket/reader_ticket','admin/structure/entity-type/reader_ticket/reader_ticket','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_ticket/reader_ticket/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%','admin/structure/entity-type/reader_ticket/reader_ticket/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reader_ticket/reader_ticket/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reader_ticket/reader_ticket/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:36:"eck administer reader_ticket bundles";i:3;s:30:"eck edit reader_ticket bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reader_ticket/reader_ticket/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/reader_ticket/reader_ticket/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:51:"eck administer reader_ticket reader_ticket entities";i:3;s:45:"eck list reader_ticket reader_ticket entities";}}','eck__entity__list','a:2:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";}','','63','6','1','admin/structure/entity-type/reader_ticket/reader_ticket','admin/structure/entity-type/reader_ticket/reader_ticket','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reading_log','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck list reading_log bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/reading_log','Reading Log','t','','','a:0:{}','6','View all the bundles for ''Reading Log''','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reading_log/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:27:"eck add reading_log bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/reading_log','admin/structure/entity-type/reading_log','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''Reading Log Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reading_log/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:11:"reading_log";}','','31','5','1','admin/structure/entity-type/reading_log','admin/structure/entity-type/reading_log','Delete','t','','','a:0:{}','132','Delete the ''Reading Log'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/reading_log/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:11:"reading_log";}','','31','5','1','admin/structure/entity-type/reading_log','admin/structure/entity-type/reading_log','Edit','t','','','a:0:{}','132','Edit the ''Reading Log'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/reading_log/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck list reading_log bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/reading_log','admin/structure/entity-type/reading_log','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reading_log/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:29:"manage reading_log properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:11:"reading_log";}','','31','5','1','admin/structure/entity-type/reading_log','admin/structure/entity-type/reading_log','Manage properties','t','','','a:0:{}','132','Manage the properties of the Reading Log entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc'),('admin/structure/entity-type/reading_log/reading_log','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:47:"eck administer reading_log reading_log entities";i:3;s:41:"eck list reading_log reading_log entities";}}','eck__entity__list','a:2:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";}','','31','5','0','','admin/structure/entity-type/reading_log/reading_log','Reading Log','t','','','a:0:{}','6','View all entites of type Reading Log with bundle Reading Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reading_log/reading_log/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:11:"reading_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:11:"reading_log";i:2;s:11:"reading_log";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reading_log/reading_log/%/delete','Delete Reading Log','t','','','a:0:{}','6','Delete an entity of type Reading Log with bundle Reading Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reading_log/reading_log/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:11:"reading_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:11:"reading_log";i:2;s:11:"reading_log";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/reading_log/reading_log/%/edit','Edit Reading Log','t','','','a:0:{}','6','Edit an entity of type Reading Log with bundle Reading Log','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reading_log/reading_log/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:11:"reading_log";i:2;s:11:"reading_log";}','eck__entity__add','a:2:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";}','','63','6','0','','admin/structure/entity-type/reading_log/reading_log/add','Add Reading Log','t','','','a:0:{}','6','Add an entity of type Reading Log with bundle Reading Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/reading_log/reading_log/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:30:"eck delete reading_log bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/reading_log/reading_log','admin/structure/entity-type/reading_log/reading_log','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reading_log/reading_log/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:11:"reading_log";i:2;s:11:"reading_log";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/reading_log/reading_log','admin/structure/entity-type/reading_log/reading_log','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reading_log/reading_log/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:11:"reading_log";i:2;s:11:"reading_log";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/reading_log/reading_log/display','admin/structure/entity-type/reading_log/reading_log','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reading_log/reading_log/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:11:"reading_log";i:2;s:11:"reading_log";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/reading_log/reading_log/display','admin/structure/entity-type/reading_log/reading_log','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reading_log/reading_log/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:11:"reading_log";i:2;s:11:"reading_log";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/reading_log/reading_log/display','admin/structure/entity-type/reading_log/reading_log','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reading_log/reading_log/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:11:"reading_log";i:2;s:11:"reading_log";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/reading_log/reading_log/display','admin/structure/entity-type/reading_log/reading_log','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reading_log/reading_log/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:11:"reading_log";i:2;s:11:"reading_log";}','','63','6','1','admin/structure/entity-type/reading_log/reading_log','admin/structure/entity-type/reading_log/reading_log','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/reading_log/reading_log/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:11:"reading_log";i:2;s:11:"reading_log";}','','63','6','1','admin/structure/entity-type/reading_log/reading_log','admin/structure/entity-type/reading_log/reading_log','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reading_log/reading_log/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/reading_log/reading_log/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reading_log/reading_log/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reading_log/reading_log/fields/%','admin/structure/entity-type/reading_log/reading_log/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reading_log/reading_log/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reading_log/reading_log/fields/%','admin/structure/entity-type/reading_log/reading_log/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reading_log/reading_log/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reading_log/reading_log/fields/%','admin/structure/entity-type/reading_log/reading_log/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/reading_log/reading_log/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/reading_log/reading_log/fields/%','admin/structure/entity-type/reading_log/reading_log/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/reading_log/reading_log/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reading_log/reading_log/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/reading_log/reading_log/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:34:"eck administer reading_log bundles";i:3;s:28:"eck edit reading_log bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/reading_log/reading_log/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/reading_log/reading_log/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:47:"eck administer reading_log reading_log entities";i:3;s:41:"eck list reading_log reading_log entities";}}','eck__entity__list','a:2:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";}','','63','6','1','admin/structure/entity-type/reading_log/reading_log','admin/structure/entity-type/reading_log/reading_log','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/school','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck list school bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','15','4','0','','admin/structure/entity-type/school','School','t','','','a:0:{}','6','View all the bundles for ''School''','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/school/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:15:"eck add bundles";i:2;s:29:"eck administer school bundles";i:3;s:22:"eck add school bundles";}}','drupal_get_form','a:2:{i:0;s:16:"eck__bundle__add";i:1;i:3;}','','31','5','1','admin/structure/entity-type/school','admin/structure/entity-type/school','Add bundle ','t','','','a:0:{}','388','Add a(n) new ''School Bundle''','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/school/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:23:"eck delete entity types";}}','drupal_get_form','a:2:{i:0;s:29:"eck__entity_type__delete_form";i:1;s:6:"school";}','','31','5','1','admin/structure/entity-type/school','admin/structure/entity-type/school','Delete','t','','','a:0:{}','132','Delete the ''School'' Entity Type','','3','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/school/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:21:"eck edit entity types";}}','drupal_get_form','a:2:{i:0;s:22:"eck__entity_type__form";i:1;s:6:"school";}','','31','5','1','admin/structure/entity-type/school','admin/structure/entity-type/school','Edit','t','','','a:0:{}','132','Edit the ''School'' entity type','','2','sites/all/modules/contrib/eck/eck.entity_type.inc'),('admin/structure/entity-type/school/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck list bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck list school bundles";}}','eck__bundle__list','a:1:{i:0;i:3;}','','31','5','1','admin/structure/entity-type/school','admin/structure/entity-type/school','Bundle List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/school/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:"eck administer entity types";i:1;s:24:"manage school properties";}}','drupal_get_form','a:2:{i:0;s:21:"eck__properties__form";i:1;s:6:"school";}','','31','5','1','admin/structure/entity-type/school','admin/structure/entity-type/school','Manage properties','t','','','a:0:{}','132','Manage the properties of the School entity type','','4','sites/all/modules/contrib/eck/eck.properties.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/school/school','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:37:"eck administer school school entities";i:3;s:31:"eck list school school entities";}}','eck__entity__list','a:2:{i:0;s:6:"school";i:1;s:6:"school";}','','31','5','0','','admin/structure/entity-type/school/school','School','t','','','a:0:{}','6','View all entites of type School with bundle School','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/school/school/%/delete','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"school";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:6:"school";i:2;s:6:"school";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:6:"school";i:1;s:6:"school";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/school/school/%/delete','Delete School','t','','','a:0:{}','6','Delete an entity of type School with bundle School','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/school/school/%/edit','a:1:{i:5;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"school";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:6:"school";i:2;s:6:"school";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:6:"school";i:1;s:6:"school";i:2;i:5;}','','125','7','0','','admin/structure/entity-type/school/school/%/edit','Edit School','t','','','a:0:{}','6','Edit an entity of type School with bundle School','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/school/school/add','','','eck__entity_menu_access','a:3:{i:0;s:3:"add";i:1;s:6:"school";i:2;s:6:"school";}','eck__entity__add','a:2:{i:0;s:6:"school";i:1;s:6:"school";}','','63','6','0','','admin/structure/entity-type/school/school/add','Add School','t','','','a:0:{}','6','Add an entity of type School with bundle School','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entity-type/school/school/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:18:"eck delete bundles";i:2;s:29:"eck administer school bundles";i:3;s:25:"eck delete school bundles";}}','drupal_get_form','a:3:{i:0;s:24:"eck__bundle__delete_form";i:1;i:3;i:2;i:4;}','','63','6','1','admin/structure/entity-type/school/school','admin/structure/entity-type/school/school','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/school/school/display','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"school";i:2;s:6:"school";i:3;s:7:"default";}','','63','6','1','admin/structure/entity-type/school/school','admin/structure/entity-type/school/school','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/school/school/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"school";i:1;s:6:"school";i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"school";i:2;s:6:"school";i:3;s:7:"default";}','','127','7','1','admin/structure/entity-type/school/school/display','admin/structure/entity-type/school/school','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/school/school/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"school";i:1;s:6:"school";i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"school";i:2;s:6:"school";i:3;s:4:"full";}','','127','7','1','admin/structure/entity-type/school/school/display','admin/structure/entity-type/school/school','Full','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/school/school/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"school";i:1;s:6:"school";i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"school";i:2;s:6:"school";i:3;s:6:"teaser";}','','127','7','1','admin/structure/entity-type/school/school/display','admin/structure/entity-type/school/school','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/school/school/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:6:"school";i:1;s:6:"school";i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:26:"eck__multiple_access_check";i:5;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:6:"school";i:2;s:6:"school";i:3;s:5:"token";}','','127','7','1','admin/structure/entity-type/school/school/display','admin/structure/entity-type/school/school','Tokens','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/school/school/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}','drupal_get_form','a:3:{i:0;s:22:"eck__bundle__edit_form";i:1;s:6:"school";i:2;s:6:"school";}','','63','6','1','admin/structure/entity-type/school/school','admin/structure/entity-type/school/school','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/eck/eck.bundle.inc'),('admin/structure/entity-type/school/school/fields','','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:6:"school";i:2;s:6:"school";}','','63','6','1','admin/structure/entity-type/school/school','admin/structure/entity-type/school/school','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/school/school/fields/%','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"school";i:1;s:6:"school";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','126','7','0','','admin/structure/entity-type/school/school/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/school/school/fields/%/delete','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"school";i:1;s:6:"school";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/school/school/fields/%','admin/structure/entity-type/school/school/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/school/school/fields/%/edit','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"school";i:1;s:6:"school";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/school/school/fields/%','admin/structure/entity-type/school/school/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/school/school/fields/%/field-settings','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"school";i:1;s:6:"school";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/school/school/fields/%','admin/structure/entity-type/school/school/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/school/school/fields/%/widget-type','a:1:{i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:6:"school";i:1;s:6:"school";i:2;s:1:"0";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:26:"eck__multiple_access_check";i:1;a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','253','8','1','admin/structure/entity-type/school/school/fields/%','admin/structure/entity-type/school/school/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/school/school/groups/%/delete','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:6:"school";i:1;s:6:"school";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/school/school/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entity-type/school/school/groups/%/enable','a:1:{i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:6:"school";i:1;s:6:"school";i:2;s:1:"0";i:3;s:4:"%map";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:"eck administer bundles";i:1;s:16:"eck edit bundles";i:2;s:29:"eck administer school bundles";i:3;s:23:"eck edit school bundles";}}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','253','8','0','','admin/structure/entity-type/school/school/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/school/school/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:"eck administer entities";i:1;s:17:"eck list entities";i:2;s:37:"eck administer school school entities";i:3;s:31:"eck list school school entities";}}','eck__entity__list','a:2:{i:0;s:6:"school";i:1;s:6:"school";}','','63','6','1','admin/structure/entity-type/school/school','admin/structure/entity-type/school/school','Entity List','t','','','a:0:{}','140','','','100','sites/all/modules/contrib/eck/eck.entity.inc'),('admin/structure/entityforms/list','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','15','4','1','admin/structure','admin/structure','Entityforms','t','','','a:0:{}','132','Add edit and update entityforms.','','0','modules/system/system.admin.inc'),('admin/structure/entityform_types','','','entity_access','a:2:{i:0;s:4:"view";i:1;s:15:"entityform_type";}','drupal_get_form','a:2:{i:0;s:29:"entityform_type_overview_form";i:1;s:15:"entityform_type";}','','7','3','0','','admin/structure/entityform_types','Entityform Types','t','','','a:0:{}','6','Manage entityform entity types, including adding and removing fields and the display of fields.','','0','sites/all/modules/contrib/entity/includes/entity.ui.inc'),('admin/structure/entityform_types/add','','','entity_access','a:2:{i:0;s:6:"create";i:1;s:15:"entityform_type";}','entity_ui_get_form','a:3:{i:0;s:15:"entityform_type";i:1;N;i:2;s:3:"add";}','','15','4','1','admin/structure/entityform_types','admin/structure/entityform_types','','entity_ui_get_action_title','a:2:{i:0;s:3:"add";i:1;s:15:"entityform_type";}','','a:0:{}','388','','','0','sites/all/modules/contrib/entityform/entityform_type.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entityform_types/import','','','entity_access','a:2:{i:0;s:6:"create";i:1;s:15:"entityform_type";}','drupal_get_form','a:4:{i:0;s:30:"entityform_type_operation_form";i:1;s:15:"entityform_type";i:2;N;i:3;s:6:"import";}','','15','4','1','admin/structure/entityform_types','admin/structure/entityform_types','','entity_ui_get_action_title','a:2:{i:0;s:6:"import";i:1;s:15:"entityform_type";}','','a:0:{}','388','','','0','sites/all/modules/contrib/entity/includes/entity.ui.inc'),('admin/structure/entityform_types/list','','','entity_access','a:2:{i:0;s:4:"view";i:1;s:15:"entityform_type";}','drupal_get_form','a:2:{i:0;s:29:"entityform_type_overview_form";i:1;s:15:"entityform_type";}','','15','4','1','admin/structure/entityform_types','admin/structure/entityform_types','List','t','','','a:0:{}','140','','','-10','sites/all/modules/contrib/entity/includes/entity.ui.inc'),('admin/structure/entityform_types/manage/%','a:1:{i:4;a:1:{s:18:"entity_object_load";a:1:{i:0;s:15:"entityform_type";}}}','','entity_access','a:3:{i:0;s:6:"update";i:1;s:15:"entityform_type";i:2;i:4;}','entity_ui_get_form','a:2:{i:0;s:15:"entityform_type";i:1;i:4;}','','30','5','0','','admin/structure/entityform_types/manage/%','Edit','entity_label','a:2:{i:0;s:15:"entityform_type";i:1;i:4;}','','a:0:{}','6','','','0','sites/all/modules/contrib/entityform/entityform_type.admin.inc'),('admin/structure/entityform_types/manage/%/%','a:2:{i:4;a:1:{s:18:"entity_object_load";a:1:{i:0;s:15:"entityform_type";}}i:5;N;}','','entity_access','a:3:{i:0;s:6:"delete";i:1;s:15:"entityform_type";i:2;i:4;}','drupal_get_form','a:4:{i:0;s:30:"entityform_type_operation_form";i:1;s:15:"entityform_type";i:2;i:4;i:3;i:5;}','','60','6','0','','admin/structure/entityform_types/manage/%/%','','t','','','a:0:{}','6','','','0','sites/all/modules/contrib/entity/includes/entity.ui.inc'),('admin/structure/entityform_types/manage/%/clone','a:1:{i:4;a:1:{s:18:"entity_object_load";a:1:{i:0;s:15:"entityform_type";}}}','','entity_access','a:2:{i:0;s:6:"create";i:1;s:15:"entityform_type";}','entity_ui_get_form','a:3:{i:0;s:15:"entityform_type";i:1;i:4;i:2;s:5:"clone";}','','61','6','0','','admin/structure/entityform_types/manage/%/clone','Clone','t','','','a:0:{}','6','','','0','sites/all/modules/contrib/entityform/entityform_type.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/entityform_types/manage/%/edit','a:1:{i:4;a:1:{s:18:"entity_object_load";a:1:{i:0;s:15:"entityform_type";}}}','','entity_access','a:3:{i:0;s:6:"update";i:1;s:15:"entityform_type";i:2;i:4;}','entity_ui_get_form','a:2:{i:0;s:15:"entityform_type";i:1;i:4;}','','61','6','3','admin/structure/entityform_types/manage/%','admin/structure/entityform_types/manage/%','Edit','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/entityform/entityform_type.admin.inc'),('admin/structure/entityform_types/manage/%/preview','a:1:{i:4;s:20:"entityform_type_load";}','','user_access','a:1:{i:0;s:27:"administer entityform types";}','entityform_form_wrapper','a:3:{i:0;i:4;i:1;s:6:"submit";i:2;s:7:"preview";}','','61','6','1','admin/structure/entityform_types/manage/%','admin/structure/entityform_types/manage/%','Form Preview','t','','','a:0:{}','132','','','110','sites/all/modules/contrib/entityform/entityform.admin.inc'),('admin/structure/entityform_types/manage/%/submissions','a:1:{i:4;s:20:"entityform_type_load";}','','user_access','a:1:{i:0;s:19:"view any entityform";}','entityform_submission_page','a:3:{i:0;i:4;i:1;i:6;i:2;s:6:"admins";}','','61','6','1','admin/structure/entityform_types/manage/%','admin/structure/entityform_types/manage/%','','entityform_type_page_title','a:2:{i:0;i:1;i:1;s:18:"submissions report";}','','a:0:{}','132','','','100',''),('admin/structure/features','','','user_access','a:1:{i:0;s:15:"manage features";}','drupal_get_form','a:1:{i:0;s:19:"features_admin_form";}','','7','3','0','','admin/structure/features','Features','t','','','a:0:{}','6','Manage features.','','0','sites/all/modules/contrib/features/features.admin.inc'),('admin/structure/features/%','a:1:{i:3;a:1:{s:12:"feature_load";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:19:"administer features";}','drupal_get_form','a:2:{i:0;s:25:"features_admin_components";i:1;i:3;}','','14','4','0','','admin/structure/features/%','','features_get_feature_title','a:1:{i:0;i:3;}','','a:0:{}','0','Display components of a feature.','','0','sites/all/modules/contrib/features/features.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/features/%/lock','a:1:{i:3;a:1:{s:12:"feature_load";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:15:"manage features";}','features_admin_lock','a:3:{i:0;i:3;i:1;i:5;i:2;i:6;}','','29','5','0','','admin/structure/features/%/lock','Lock','t','','','a:0:{}','0','Lock a feature or components.','','0','sites/all/modules/contrib/features/features.admin.inc'),('admin/structure/features/%/recreate','a:1:{i:3;a:1:{s:12:"feature_load";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:19:"administer features";}','drupal_get_form','a:2:{i:0;s:20:"features_export_form";i:1;i:3;}','','29','5','1','admin/structure/features/%','admin/structure/features/%','Recreate','t','','','a:0:{}','132','Recreate an existing feature.','','11','sites/all/modules/contrib/features/features.admin.inc'),('admin/structure/features/%/status','a:1:{i:3;a:1:{s:12:"feature_load";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:19:"administer features";}','features_feature_status','a:1:{i:0;i:3;}','','29','5','0','','admin/structure/features/%/status','Status','t','','','a:0:{}','0','Javascript status call back.','','0','sites/all/modules/contrib/features/features.admin.inc'),('admin/structure/features/%/view','a:1:{i:3;a:1:{s:12:"feature_load";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:19:"administer features";}','drupal_get_form','a:2:{i:0;s:25:"features_admin_components";i:1;i:3;}','','29','5','1','admin/structure/features/%','admin/structure/features/%','View','t','','','a:0:{}','140','Display components of a feature.','','-10','sites/all/modules/contrib/features/features.admin.inc'),('admin/structure/features/cleanup','','','user_access','a:1:{i:0;s:15:"manage features";}','features_cleanup','a:0:{}','','15','4','0','','admin/structure/features/cleanup','Cleanup','t','','','a:0:{}','0','Clear cache after enabling/disabling a feature.','','1','sites/all/modules/contrib/features/features.admin.inc'),('admin/structure/features/create','','','user_access','a:1:{i:0;s:19:"administer features";}','drupal_get_form','a:1:{i:0;s:20:"features_export_form";}','','15','4','1','admin/structure/features','admin/structure/features','Create feature','t','','','a:0:{}','132','Create a new feature.','','10','sites/all/modules/contrib/features/features.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/features/manage','','','user_access','a:1:{i:0;s:15:"manage features";}','drupal_get_form','a:1:{i:0;s:19:"features_admin_form";}','','15','4','1','admin/structure/features','admin/structure/features','Manage','t','','','a:0:{}','140','Enable and disable features.','','0','sites/all/modules/contrib/features/features.admin.inc'),('admin/structure/features/settings','','','user_access','a:1:{i:0;s:19:"administer features";}','drupal_get_form','a:1:{i:0;s:22:"features_settings_form";}','','15','4','1','admin/structure/features','admin/structure/features','Settings','t','','','a:0:{}','132','Adjust settings for using features module.','','11','sites/all/modules/contrib/features/features.admin.inc'),('admin/structure/feeds','','','user_access','a:1:{i:0;s:16:"administer feeds";}','drupal_get_form','a:1:{i:0;s:22:"feeds_ui_overview_form";}','','7','3','0','','admin/structure/feeds','Feeds importers','t','','','a:0:{}','6','Configure one or more Feeds importers to aggregate RSS and Atom feeds, import CSV files or more.','','0','sites/all/modules/contrib/feeds/feeds_ui/feeds_ui.admin.inc'),('admin/structure/feeds/%','a:1:{i:3;s:19:"feeds_importer_load";}','','user_access','a:1:{i:0;s:16:"administer feeds";}','feeds_ui_edit_page','a:1:{i:0;i:3;}','','14','4','0','','admin/structure/feeds/%','','feeds_ui_importer_title','a:1:{i:0;i:3;}','','a:0:{}','6','','','0','sites/all/modules/contrib/feeds/feeds_ui/feeds_ui.admin.inc'),('admin/structure/feeds/%/clone','a:1:{i:3;s:19:"feeds_importer_load";}','','user_access','a:1:{i:0;s:16:"administer feeds";}','drupal_get_form','a:2:{i:0;s:20:"feeds_ui_create_form";i:1;i:3;}','','29','5','1','admin/structure/feeds/%','admin/structure/feeds/%','Clone','t','','','a:0:{}','132','','','3','sites/all/modules/contrib/feeds/feeds_ui/feeds_ui.admin.inc'),('admin/structure/feeds/%/delete','a:1:{i:3;s:19:"feeds_importer_load";}','','user_access','a:1:{i:0;s:16:"administer feeds";}','drupal_get_form','a:2:{i:0;s:20:"feeds_ui_delete_form";i:1;i:3;}','','29','5','1','admin/structure/feeds/%','admin/structure/feeds/%','Delete','t','','','a:0:{}','132','','','4','sites/all/modules/contrib/feeds/feeds_ui/feeds_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/feeds/%/edit','a:1:{i:3;s:19:"feeds_importer_load";}','','user_access','a:1:{i:0;s:16:"administer feeds";}','feeds_ui_edit_page','a:1:{i:0;i:3;}','','29','5','1','admin/structure/feeds/%','admin/structure/feeds/%','Edit','t','','','a:0:{}','140','','','1','sites/all/modules/contrib/feeds/feeds_ui/feeds_ui.admin.inc'),('admin/structure/feeds/%/export','a:1:{i:3;s:19:"feeds_importer_load";}','','user_access','a:1:{i:0;s:16:"administer feeds";}','drupal_get_form','a:2:{i:0;s:20:"feeds_ui_export_form";i:1;i:3;}','','29','5','1','admin/structure/feeds/%','admin/structure/feeds/%','Export','t','','','a:0:{}','132','','','2','sites/all/modules/contrib/feeds/feeds_ui/feeds_ui.admin.inc'),('admin/structure/feeds/create','','','user_access','a:1:{i:0;s:16:"administer feeds";}','drupal_get_form','a:1:{i:0;s:20:"feeds_ui_create_form";}','','15','4','1','admin/structure/feeds','admin/structure/feeds','Add importer','t','','','a:0:{}','388','','','0','sites/all/modules/contrib/feeds/feeds_ui/feeds_ui.admin.inc'),('admin/structure/feeds/import','','','feeds_importer_import_access','a:0:{}','drupal_get_form','a:1:{i:0;s:24:"feeds_ui_importer_import";}','','15','4','1','admin/structure/feeds','admin/structure/feeds','Import importer','t','','','a:0:{}','388','','','0','sites/all/modules/contrib/feeds/feeds_ui/feeds_ui.admin.inc'),('admin/structure/field-collections','','','user_access','a:1:{i:0;s:28:"administer field collections";}','field_collections_overview','a:0:{}','','7','3','0','','admin/structure/field-collections','Field collections','t','','','a:0:{}','6','Manage fields on field collections.','','0','sites/all/modules/contrib/field_collection/field_collection.admin.inc'),('admin/structure/field-collections/%','a:1:{i:3;s:32:"field_collection_field_name_load";}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:28:"administer field collections";}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:21:"field_collection_item";i:2;i:3;}','','14','4','0','','admin/structure/field-collections/%','Manage fields','field_collection_admin_page_title','a:1:{i:0;i:3;}','','a:0:{}','6','','','1','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/field-collections/%/display','a:1:{i:3;s:32:"field_collection_field_name_load";}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:28:"administer field collections";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:21:"field_collection_item";i:2;i:3;i:3;s:7:"default";}','','29','5','1','admin/structure/field-collections/%','admin/structure/field-collections/%','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/display/default','a:1:{i:3;s:32:"field_collection_field_name_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:28:"administer field collections";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:21:"field_collection_item";i:2;i:3;i:3;s:7:"default";}','','59','6','1','admin/structure/field-collections/%/display','admin/structure/field-collections/%','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/display/full','a:1:{i:3;s:32:"field_collection_field_name_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:28:"administer field collections";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:21:"field_collection_item";i:2;i:3;i:3;s:4:"full";}','','59','6','1','admin/structure/field-collections/%/display','admin/structure/field-collections/%','Full content','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/display/token','a:1:{i:3;s:32:"field_collection_field_name_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:28:"administer field collections";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:21:"field_collection_item";i:2;i:3;i:3;s:5:"token";}','','59','6','1','admin/structure/field-collections/%/display','admin/structure/field-collections/%','Tokens','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/field-collections/%/fields','a:1:{i:3;s:32:"field_collection_field_name_load";}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:28:"administer field collections";}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:21:"field_collection_item";i:2;i:3;}','','29','5','1','admin/structure/field-collections/%','admin/structure/field-collections/%','Manage fields','t','','','a:0:{}','140','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%','a:2:{i:3;a:1:{s:32:"field_collection_field_name_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:28:"administer field collections";}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:5;}','','58','6','0','','admin/structure/field-collections/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%/delete','a:2:{i:3;a:1:{s:32:"field_collection_field_name_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:28:"administer field collections";}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:5;}','','117','7','1','admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%/edit','a:2:{i:3;a:1:{s:32:"field_collection_field_name_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:28:"administer field collections";}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:5;}','','117','7','1','admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/field-collections/%/fields/%/field-settings','a:2:{i:3;a:1:{s:32:"field_collection_field_name_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:28:"administer field collections";}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:5;}','','117','7','1','admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%/widget-type','a:2:{i:3;a:1:{s:32:"field_collection_field_name_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:28:"administer field collections";}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:5;}','','117','7','1','admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/groups/%/delete','a:2:{i:3;a:1:{s:32:"field_collection_field_name_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','user_access','a:1:{i:0;s:28:"administer field collections";}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:5;}','','117','7','0','','admin/structure/field-collections/%/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/field-collections/%/groups/%/enable','a:2:{i:3;a:1:{s:32:"field_collection_field_name_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:21:"field_collection_item";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','user_access','a:1:{i:0;s:28:"administer field collections";}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:5;}','','117','7','0','','admin/structure/field-collections/%/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/menu','','','user_access','a:1:{i:0;s:15:"administer menu";}','menu_overview_page','a:0:{}','','7','3','0','','admin/structure/menu','Menus','t','','','a:0:{}','6','Add new menus to your site, edit existing menus, and rename and reorganize menu links.','','0','modules/menu/menu.admin.inc'),('admin/structure/menu/add','','','user_access','a:1:{i:0;s:15:"administer menu";}','drupal_get_form','a:2:{i:0;s:14:"menu_edit_menu";i:1;s:3:"add";}','','15','4','1','admin/structure/menu','admin/structure/menu','Add menu','t','','','a:0:{}','388','','','0','modules/menu/menu.admin.inc'),('admin/structure/menu/item/%/delete','a:1:{i:4;s:14:"menu_link_load";}','','user_access','a:1:{i:0;s:15:"administer menu";}','menu_item_delete_page','a:1:{i:0;i:4;}','','61','6','0','','admin/structure/menu/item/%/delete','Delete menu link','t','','','a:0:{}','6','','','0','modules/menu/menu.admin.inc'),('admin/structure/menu/item/%/edit','a:1:{i:4;s:14:"menu_link_load";}','','user_access','a:1:{i:0;s:15:"administer menu";}','drupal_get_form','a:4:{i:0;s:14:"menu_edit_item";i:1;s:4:"edit";i:2;i:4;i:3;N;}','','61','6','0','','admin/structure/menu/item/%/edit','Edit menu link','t','','','a:0:{}','6','','','0','modules/menu/menu.admin.inc'),('admin/structure/menu/item/%/reset','a:1:{i:4;s:14:"menu_link_load";}','','user_access','a:1:{i:0;s:15:"administer menu";}','drupal_get_form','a:2:{i:0;s:23:"menu_reset_item_confirm";i:1;i:4;}','','61','6','0','','admin/structure/menu/item/%/reset','Reset menu link','t','','','a:0:{}','6','','','0','modules/menu/menu.admin.inc'),('admin/structure/menu/list','','','user_access','a:1:{i:0;s:15:"administer menu";}','menu_overview_page','a:0:{}','','15','4','1','admin/structure/menu','admin/structure/menu','List menus','t','','','a:0:{}','140','','','-10','modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%','a:1:{i:4;s:9:"menu_load";}','','user_access','a:1:{i:0;s:15:"administer menu";}','drupal_get_form','a:2:{i:0;s:18:"menu_overview_form";i:1;i:4;}','','30','5','0','','admin/structure/menu/manage/%','Customize menu','menu_overview_title','a:1:{i:0;i:4;}','','a:0:{}','6','','','0','modules/menu/menu.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/menu/manage/%/add','a:1:{i:4;s:9:"menu_load";}','','user_access','a:1:{i:0;s:15:"administer menu";}','drupal_get_form','a:4:{i:0;s:14:"menu_edit_item";i:1;s:3:"add";i:2;N;i:3;i:4;}','','61','6','1','admin/structure/menu/manage/%','admin/structure/menu/manage/%','Add link','t','','','a:0:{}','388','','','0','modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/delete','a:1:{i:4;s:9:"menu_load";}','','user_access','a:1:{i:0;s:15:"administer menu";}','menu_delete_menu_page','a:1:{i:0;i:4;}','','61','6','0','','admin/structure/menu/manage/%/delete','Delete menu','t','','','a:0:{}','6','','','0','modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/edit','a:1:{i:4;s:9:"menu_load";}','','user_access','a:1:{i:0;s:15:"administer menu";}','drupal_get_form','a:3:{i:0;s:14:"menu_edit_menu";i:1;s:4:"edit";i:2;i:4;}','','61','6','3','admin/structure/menu/manage/%','admin/structure/menu/manage/%','Edit menu','t','','','a:0:{}','132','','','0','modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/list','a:1:{i:4;s:9:"menu_load";}','','user_access','a:1:{i:0;s:15:"administer menu";}','drupal_get_form','a:2:{i:0;s:18:"menu_overview_form";i:1;i:4;}','','61','6','3','admin/structure/menu/manage/%','admin/structure/menu/manage/%','List links','t','','','a:0:{}','140','','','-10','modules/menu/menu.admin.inc'),('admin/structure/menu/parents','','','user_access','a:1:{i:0;s:15:"administer menu";}','menu_parent_options_js','a:0:{}','','15','4','0','','admin/structure/menu/parents','Parent menu items','t','','','a:0:{}','0','','','0',''),('admin/structure/menu/settings','','','user_access','a:1:{i:0;s:15:"administer menu";}','drupal_get_form','a:1:{i:0;s:14:"menu_configure";}','','15','4','1','admin/structure/menu','admin/structure/menu','Settings','t','','','a:0:{}','132','','','5','modules/menu/menu.admin.inc'),('admin/structure/mini-panels','','','ctools_export_ui_task_access','a:2:{i:0;s:11:"panels_mini";i:1;s:4:"list";}','ctools_export_ui_switcher_page','a:2:{i:0;s:11:"panels_mini";i:1;s:4:"list";}','','7','3','0','','admin/structure/mini-panels','Mini panels','t','','','a:0:{}','6','Add, edit or delete mini panels, which can be used as blocks or content panes in other panels.','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/mini-panels/add','','','ctools_export_ui_task_access','a:2:{i:0;s:11:"panels_mini";i:1;s:3:"add";}','ctools_export_ui_switcher_page','a:2:{i:0;s:11:"panels_mini";i:1;s:3:"add";}','','15','4','1','admin/structure/mini-panels','admin/structure/mini-panels','Add','t','','','a:0:{}','388','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/import','','','ctools_export_ui_task_access','a:2:{i:0;s:11:"panels_mini";i:1;s:6:"import";}','ctools_export_ui_switcher_page','a:2:{i:0;s:11:"panels_mini";i:1;s:6:"import";}','','15','4','1','admin/structure/mini-panels','admin/structure/mini-panels','Import','t','','','a:0:{}','388','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list','','','ctools_export_ui_task_access','a:2:{i:0;s:11:"panels_mini";i:1;s:4:"list";}','ctools_export_ui_switcher_page','a:2:{i:0;s:11:"panels_mini";i:1;s:4:"list";}','','15','4','1','admin/structure/mini-panels','admin/structure/mini-panels','List','t','','','a:0:{}','140','','','-10','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:11:"panels_mini";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:"panels_mini";i:1;s:4:"edit";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:"panels_mini";i:1;s:4:"edit";i:2;i:4;}','','30','5','0','','admin/structure/mini-panels/list/%','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%/clone','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:11:"panels_mini";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:"panels_mini";i:1;s:5:"clone";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:"panels_mini";i:1;s:5:"clone";i:2;i:4;}','','61','6','0','','admin/structure/mini-panels/list/%/clone','Clone','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/mini-panels/list/%/delete','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:11:"panels_mini";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:"panels_mini";i:1;s:6:"delete";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:"panels_mini";i:1;s:6:"delete";i:2;i:4;}','','61','6','0','','admin/structure/mini-panels/list/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%/disable','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:11:"panels_mini";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:"panels_mini";i:1;s:7:"disable";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:"panels_mini";i:1;s:7:"disable";i:2;i:4;}','','61','6','0','','admin/structure/mini-panels/list/%/disable','Disable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%/edit','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:11:"panels_mini";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:"panels_mini";i:1;s:4:"edit";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:"panels_mini";i:1;s:4:"edit";i:2;i:4;}','','61','6','1','admin/structure/mini-panels/list/%','admin/structure/mini-panels/list/%','Edit','t','','','a:0:{}','140','','','-10','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%/enable','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:11:"panels_mini";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:"panels_mini";i:1;s:6:"enable";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:"panels_mini";i:1;s:6:"enable";i:2;i:4;}','','61','6','0','','admin/structure/mini-panels/list/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%/export','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:11:"panels_mini";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:"panels_mini";i:1;s:6:"export";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:"panels_mini";i:1;s:6:"export";i:2;i:4;}','','61','6','1','admin/structure/mini-panels/list/%','admin/structure/mini-panels/list/%','Export','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/mini-panels/list/%/revert','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:11:"panels_mini";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:"panels_mini";i:1;s:6:"revert";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:"panels_mini";i:1;s:6:"delete";i:2;i:4;}','','61','6','0','','admin/structure/mini-panels/list/%/revert','Revert','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/settings','','','user_access','a:1:{i:0;s:18:"create mini panels";}','panels_mini_settings','a:0:{}','','15','4','1','admin/structure/mini-panels','admin/structure/mini-panels','Settings','t','','','a:0:{}','132','','','0',''),('admin/structure/pages','','','user_access','a:1:{i:0;s:16:"use page manager";}','page_manager_list_page','a:0:{}','','7','3','0','','admin/structure/pages','Pages','t','','ajax_base_page_theme','a:0:{}','6','Add, edit and remove overridden system pages and user defined pages from the system.','','0','sites/all/modules/contrib/ctools/page_manager/page_manager.admin.inc'),('admin/structure/pages/%/disable/%','a:2:{i:3;s:14:"ctools_js_load";i:5;s:23:"page_manager_cache_load";}','a:1:{i:3;s:16:"ctools_js_to_arg";}','user_access','a:1:{i:0;s:16:"use page manager";}','page_manager_enable_page','a:3:{i:0;b:1;i:1;i:3;i:2;i:5;}','','58','6','0','','admin/structure/pages/%/disable/%','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/page_manager/page_manager.admin.inc'),('admin/structure/pages/%/enable/%','a:2:{i:3;s:14:"ctools_js_load";i:5;s:23:"page_manager_cache_load";}','a:1:{i:3;s:16:"ctools_js_to_arg";}','user_access','a:1:{i:0;s:16:"use page manager";}','page_manager_enable_page','a:3:{i:0;b:0;i:1;i:3;i:2;i:5;}','','58','6','0','','admin/structure/pages/%/enable/%','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/page_manager/page_manager.admin.inc'),('admin/structure/pages/%/operation/%','a:2:{i:3;s:14:"ctools_js_load";i:5;s:23:"page_manager_cache_load";}','a:1:{i:3;s:16:"ctools_js_to_arg";}','user_access','a:1:{i:0;s:16:"use page manager";}','page_manager_edit_page_operation','a:2:{i:0;i:3;i:1;i:5;}','','58','6','0','','admin/structure/pages/%/operation/%','','t','','ajax_base_page_theme','a:0:{}','6','','','0','sites/all/modules/contrib/ctools/page_manager/page_manager.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/pages/add','','','user_access','a:1:{i:0;s:23:"administer page manager";}','page_manager_page_add_subtask','a:0:{}','','15','4','1','admin/structure/pages','admin/structure/pages','Add custom page','t','','ajax_base_page_theme','a:0:{}','388','','','0','sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc'),('admin/structure/pages/argument','','','user_access','a:1:{i:0;s:23:"administer page manager";}','page_manager_page_subtask_argument_ajax','a:0:{}','','15','4','0','','admin/structure/pages/argument','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc'),('admin/structure/pages/edit/%','a:1:{i:4;s:23:"page_manager_cache_load";}','','user_access','a:1:{i:0;s:16:"use page manager";}','page_manager_edit_page','a:1:{i:0;i:4;}','','30','5','0','','admin/structure/pages/edit/%','Edit','t','','ajax_base_page_theme','a:0:{}','6','','','0','sites/all/modules/contrib/ctools/page_manager/page_manager.admin.inc'),('admin/structure/pages/import','','','ctools_access_multiperm','a:2:{i:0;s:23:"administer page manager";i:1;s:17:"use ctools import";}','drupal_get_form','a:2:{i:0;s:32:"page_manager_page_import_subtask";i:1;s:4:"page";}','','15','4','1','admin/structure/pages','admin/structure/pages','Import page','t','','ajax_base_page_theme','a:0:{}','388','','','0','sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc'),('admin/structure/pages/list','','','user_access','a:1:{i:0;s:16:"use page manager";}','page_manager_list_page','a:0:{}','','15','4','1','admin/structure/pages','admin/structure/pages','List','t','','ajax_base_page_theme','a:0:{}','140','','','-10','sites/all/modules/contrib/ctools/page_manager/page_manager.admin.inc'),('admin/structure/pages/wizard','','','user_access','a:1:{i:0;s:16:"use page manager";}','page_manager_page_wizard_list','a:1:{i:0;i:4;}','','15','4','1','admin/structure/pages','admin/structure/pages','Wizards','t','','ajax_base_page_theme','a:0:{}','132','','','-5','sites/all/modules/contrib/ctools/includes/page-wizard.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/pages/wizard/%','a:1:{i:4;N;}','','user_access','a:1:{i:0;s:16:"use page manager";}','page_manager_page_wizard','a:1:{i:0;i:4;}','','30','5','0','','admin/structure/pages/wizard/%','Wizard','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/page-wizard.inc'),('admin/structure/panels','','','user_access','a:1:{i:0;s:20:"use panels dashboard";}','panels_admin_page','a:0:{}','','7','3','0','','admin/structure/panels','Panels','t','','','a:0:{}','6','Get a bird''s eye view of items related to Panels.','','0','sites/all/modules/contrib/panels/includes/callbacks.inc'),('admin/structure/panels/dashboard','','','user_access','a:1:{i:0;s:20:"use panels dashboard";}','panels_admin_page','a:0:{}','','15','4','1','admin/structure/panels','admin/structure/panels','Dashboard','t','','','a:0:{}','140','','','-10','sites/all/modules/contrib/panels/includes/callbacks.inc'),('admin/structure/panels/layouts','','','ctools_export_ui_task_access','a:2:{i:0;s:14:"panels_layouts";i:1;s:4:"list";}','ctools_export_ui_switcher_page','a:2:{i:0;s:14:"panels_layouts";i:1;s:4:"list";}','','15','4','1','admin/structure/panels','admin/structure/panels','Layouts','t','','','a:0:{}','132','Add, edit or delete custom content layouts.','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/add-flexible','','','ctools_export_ui_task_access','a:2:{i:0;s:14:"panels_layouts";i:1;s:3:"add";}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:"panels_layouts";i:1;s:3:"add";i:2;s:8:"flexible";}','','31','5','1','admin/structure/panels/layouts','admin/structure/panels','Add flexible layout','t','','','a:0:{}','388','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/import','','','ctools_export_ui_task_access','a:2:{i:0;s:14:"panels_layouts";i:1;s:6:"import";}','ctools_export_ui_switcher_page','a:2:{i:0;s:14:"panels_layouts";i:1;s:6:"import";}','','31','5','1','admin/structure/panels/layouts','admin/structure/panels','Import','t','','','a:0:{}','388','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/panels/layouts/list','','','ctools_export_ui_task_access','a:2:{i:0;s:14:"panels_layouts";i:1;s:4:"list";}','ctools_export_ui_switcher_page','a:2:{i:0;s:14:"panels_layouts";i:1;s:4:"list";}','','31','5','1','admin/structure/panels/layouts','admin/structure/panels','List','t','','','a:0:{}','140','','','-10','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%','a:1:{i:5;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:14:"panels_layouts";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:"panels_layouts";i:1;s:4:"edit";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:"panels_layouts";i:1;s:4:"edit";i:2;i:5;}','','62','6','0','','admin/structure/panels/layouts/list/%','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/clone','a:1:{i:5;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:14:"panels_layouts";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:"panels_layouts";i:1;s:5:"clone";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:"panels_layouts";i:1;s:5:"clone";i:2;i:5;}','','125','7','0','','admin/structure/panels/layouts/list/%/clone','Clone','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/delete','a:1:{i:5;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:14:"panels_layouts";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:"panels_layouts";i:1;s:6:"delete";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:"panels_layouts";i:1;s:6:"delete";i:2;i:5;}','','125','7','0','','admin/structure/panels/layouts/list/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/disable','a:1:{i:5;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:14:"panels_layouts";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:"panels_layouts";i:1;s:7:"disable";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:"panels_layouts";i:1;s:7:"disable";i:2;i:5;}','','125','7','0','','admin/structure/panels/layouts/list/%/disable','Disable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/panels/layouts/list/%/edit','a:1:{i:5;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:14:"panels_layouts";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:"panels_layouts";i:1;s:4:"edit";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:"panels_layouts";i:1;s:4:"edit";i:2;i:5;}','','125','7','1','admin/structure/panels/layouts/list/%','admin/structure/panels/layouts/list/%','Edit','t','','','a:0:{}','140','','','-10','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/enable','a:1:{i:5;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:14:"panels_layouts";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:"panels_layouts";i:1;s:6:"enable";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:"panels_layouts";i:1;s:6:"enable";i:2;i:5;}','','125','7','0','','admin/structure/panels/layouts/list/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/export','a:1:{i:5;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:14:"panels_layouts";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:"panels_layouts";i:1;s:6:"export";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:"panels_layouts";i:1;s:6:"export";i:2;i:5;}','','125','7','1','admin/structure/panels/layouts/list/%','admin/structure/panels/layouts/list/%','Export','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/revert','a:1:{i:5;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:14:"panels_layouts";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:"panels_layouts";i:1;s:6:"revert";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:"panels_layouts";i:1;s:6:"delete";i:2;i:5;}','','125','7','0','','admin/structure/panels/layouts/list/%/revert','Revert','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/settings','','','user_access','a:1:{i:0;s:20:"use panels dashboard";}','drupal_get_form','a:1:{i:0;s:26:"panels_admin_settings_page";}','','15','4','1','admin/structure/panels','admin/structure/panels','Settings','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/panels/includes/callbacks.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/panels/settings/general','','','user_access','a:1:{i:0;s:23:"administer page manager";}','drupal_get_form','a:1:{i:0;s:26:"panels_admin_settings_page";}','','31','5','1','admin/structure/panels/settings','admin/structure/panels','General','t','','','a:0:{}','140','','','-10','sites/all/modules/contrib/panels/includes/callbacks.inc'),('admin/structure/panels/settings/panel-node','','','user_access','a:1:{i:0;s:22:"administer panel-nodes";}','panels_node_settings','a:0:{}','','31','5','1','admin/structure/panels/settings','admin/structure/panels','Panel nodes','t','','','a:0:{}','132','Configure which content is available to add to panel node displays.','','0',''),('admin/structure/panels/settings/panel-page','','','user_access','a:1:{i:0;s:20:"use panels dashboard";}','panels_admin_panel_context_page','a:0:{}','','31','5','1','admin/structure/panels/settings','admin/structure/panels','Panel pages','t','','','a:0:{}','132','','','-10','sites/all/modules/contrib/panels/includes/callbacks.inc'),('admin/structure/panels/settings/panels-mini','','','user_access','a:1:{i:0;s:18:"create mini panels";}','panels_mini_settings','a:0:{}','','31','5','1','admin/structure/panels/settings','admin/structure/panels','Mini panels','t','','','a:0:{}','132','','','0',''),('admin/structure/taxonomy','','','user_access','a:1:{i:0;s:19:"administer taxonomy";}','drupal_get_form','a:1:{i:0;s:30:"taxonomy_overview_vocabularies";}','','7','3','0','','admin/structure/taxonomy','Taxonomy','t','','','a:0:{}','6','Manage tagging, categorization, and classification of your content.','','0','modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%','a:1:{i:3;s:37:"taxonomy_vocabulary_machine_name_load";}','','user_access','a:1:{i:0;s:19:"administer taxonomy";}','drupal_get_form','a:2:{i:0;s:23:"taxonomy_overview_terms";i:1;i:3;}','','14','4','0','','admin/structure/taxonomy/%','','entity_label','a:2:{i:0;s:19:"taxonomy_vocabulary";i:1;i:3;}','','a:0:{}','6','','','0','modules/taxonomy/taxonomy.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/taxonomy/%/add','a:1:{i:3;s:37:"taxonomy_vocabulary_machine_name_load";}','','user_access','a:1:{i:0;s:19:"administer taxonomy";}','drupal_get_form','a:3:{i:0;s:18:"taxonomy_form_term";i:1;a:0:{}i:2;i:3;}','','29','5','1','admin/structure/taxonomy/%','admin/structure/taxonomy/%','Add term','t','','','a:0:{}','388','','','0','modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%/display','a:1:{i:3;s:37:"taxonomy_vocabulary_machine_name_load";}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:19:"administer taxonomy";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:13:"taxonomy_term";i:2;i:3;i:3;s:7:"default";}','','29','5','1','admin/structure/taxonomy/%','admin/structure/taxonomy/%','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/display/default','a:1:{i:3;s:37:"taxonomy_vocabulary_machine_name_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:19:"administer taxonomy";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:13:"taxonomy_term";i:2;i:3;i:3;s:7:"default";}','','59','6','1','admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/display/full','a:1:{i:3;s:37:"taxonomy_vocabulary_machine_name_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:19:"administer taxonomy";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:13:"taxonomy_term";i:2;i:3;i:3;s:4:"full";}','','59','6','1','admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Taxonomy term page','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/taxonomy/%/display/token','a:1:{i:3;s:37:"taxonomy_vocabulary_machine_name_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:19:"administer taxonomy";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:13:"taxonomy_term";i:2;i:3;i:3;s:5:"token";}','','59','6','1','admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Tokens','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/edit','a:1:{i:3;s:37:"taxonomy_vocabulary_machine_name_load";}','','user_access','a:1:{i:0;s:19:"administer taxonomy";}','drupal_get_form','a:2:{i:0;s:24:"taxonomy_form_vocabulary";i:1;i:3;}','','29','5','1','admin/structure/taxonomy/%','admin/structure/taxonomy/%','Edit','t','','','a:0:{}','132','','','-10','modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%/fields','a:1:{i:3;s:37:"taxonomy_vocabulary_machine_name_load";}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:19:"administer taxonomy";}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:13:"taxonomy_term";i:2;i:3;}','','29','5','1','admin/structure/taxonomy/%','admin/structure/taxonomy/%','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%','a:2:{i:3;a:1:{s:37:"taxonomy_vocabulary_machine_name_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:19:"administer taxonomy";}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:5;}','','58','6','0','','admin/structure/taxonomy/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/taxonomy/%/fields/%/delete','a:2:{i:3;a:1:{s:37:"taxonomy_vocabulary_machine_name_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:19:"administer taxonomy";}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:5;}','','117','7','1','admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/edit','a:2:{i:3;a:1:{s:37:"taxonomy_vocabulary_machine_name_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:19:"administer taxonomy";}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:5;}','','117','7','1','admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/field-settings','a:2:{i:3;a:1:{s:37:"taxonomy_vocabulary_machine_name_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:19:"administer taxonomy";}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:5;}','','117','7','1','admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/widget-type','a:2:{i:3;a:1:{s:37:"taxonomy_vocabulary_machine_name_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:19:"administer taxonomy";}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:5;}','','117','7','1','admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/taxonomy/%/groups/%/delete','a:2:{i:3;a:1:{s:37:"taxonomy_vocabulary_machine_name_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','user_access','a:1:{i:0;s:19:"administer taxonomy";}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:5;}','','117','7','0','','admin/structure/taxonomy/%/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/taxonomy/%/groups/%/enable','a:2:{i:3;a:1:{s:37:"taxonomy_vocabulary_machine_name_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}i:5;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:13:"taxonomy_term";i:1;i:3;i:2;s:1:"3";i:3;s:4:"%map";}}}','','user_access','a:1:{i:0;s:19:"administer taxonomy";}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:5;}','','117','7','0','','admin/structure/taxonomy/%/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/taxonomy/%/list','a:1:{i:3;s:37:"taxonomy_vocabulary_machine_name_load";}','','user_access','a:1:{i:0;s:19:"administer taxonomy";}','drupal_get_form','a:2:{i:0;s:23:"taxonomy_overview_terms";i:1;i:3;}','','29','5','1','admin/structure/taxonomy/%','admin/structure/taxonomy/%','List','t','','','a:0:{}','140','','','-20','modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/add','','','user_access','a:1:{i:0;s:19:"administer taxonomy";}','drupal_get_form','a:1:{i:0;s:24:"taxonomy_form_vocabulary";}','','15','4','1','admin/structure/taxonomy','admin/structure/taxonomy','Add vocabulary','t','','','a:0:{}','388','','','0','modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/list','','','user_access','a:1:{i:0;s:19:"administer taxonomy";}','drupal_get_form','a:1:{i:0;s:30:"taxonomy_overview_vocabularies";}','','15','4','1','admin/structure/taxonomy','admin/structure/taxonomy','List','t','','','a:0:{}','140','','','-10','modules/taxonomy/taxonomy.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/types','','','user_access','a:1:{i:0;s:24:"administer content types";}','node_overview_types','a:0:{}','','7','3','0','','admin/structure/types','Content types','t','','','a:0:{}','6','Manage content types, including default status, front page promotion, comment settings, etc.','','0','modules/node/content_types.inc'),('admin/structure/types/add','','','user_access','a:1:{i:0;s:24:"administer content types";}','drupal_get_form','a:1:{i:0;s:14:"node_type_form";}','','15','4','1','admin/structure/types','admin/structure/types','Add content type','t','','','a:0:{}','388','','','0','modules/node/content_types.inc'),('admin/structure/types/list','','','user_access','a:1:{i:0;s:24:"administer content types";}','node_overview_types','a:0:{}','','15','4','1','admin/structure/types','admin/structure/types','List','t','','','a:0:{}','140','','','-10','modules/node/content_types.inc'),('admin/structure/types/manage/%','a:1:{i:4;s:14:"node_type_load";}','','user_access','a:1:{i:0;s:24:"administer content types";}','drupal_get_form','a:2:{i:0;s:14:"node_type_form";i:1;i:4;}','','30','5','0','','admin/structure/types/manage/%','Edit content type','node_type_page_title','a:1:{i:0;i:4;}','','a:0:{}','6','','','0','modules/node/content_types.inc'),('admin/structure/types/manage/%/access','a:1:{i:4;s:14:"node_type_load";}','','content_access_admin_settings_access','a:0:{}','drupal_get_form','a:2:{i:0;s:29:"content_access_admin_settings";i:1;i:4;}','','61','6','1','admin/structure/types/manage/%','admin/structure/types/manage/%','Access control','t','','_node_custom_theme','a:0:{}','132','Configure content access control.','','1','sites/all/modules/contrib/content_access/content_access.admin.inc'),('admin/structure/types/manage/%/comment/display','a:1:{i:4;s:22:"comment_node_type_load";}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:7:"comment";i:2;i:4;i:3;s:7:"default";}','','123','7','1','admin/structure/types/manage/%','admin/structure/types/manage/%','Comment display','t','','','a:0:{}','132','','','4','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/types/manage/%/comment/display/default','a:1:{i:4;s:22:"comment_node_type_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:"comment";i:1;i:4;i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:7:"comment";i:2;i:4;i:3;s:7:"default";}','','247','8','1','admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/full','a:1:{i:4;s:22:"comment_node_type_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:"comment";i:1;i:4;i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:7:"comment";i:2;i:4;i:3;s:4:"full";}','','247','8','1','admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Full comment','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/token','a:1:{i:4;s:22:"comment_node_type_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:"comment";i:1;i:4;i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:7:"comment";i:2;i:4;i:3;s:5:"token";}','','247','8','1','admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Tokens','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields','a:1:{i:4;s:22:"comment_node_type_load";}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:7:"comment";i:2;i:4;}','','123','7','1','admin/structure/types/manage/%','admin/structure/types/manage/%','Comment fields','t','','','a:0:{}','132','','','3','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/types/manage/%/comment/fields/%','a:2:{i:4;a:1:{s:22:"comment_node_type_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:7;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:7;}','','246','8','0','','admin/structure/types/manage/%/comment/fields/%','','field_ui_menu_title','a:1:{i:0;i:7;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/delete','a:2:{i:4;a:1:{s:22:"comment_node_type_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:7;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:7;}','','493','9','1','admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/edit','a:2:{i:4;a:1:{s:22:"comment_node_type_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:7;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:7;}','','493','9','1','admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/field-settings','a:2:{i:4;a:1:{s:22:"comment_node_type_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:7;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:7;}','','493','9','1','admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/types/manage/%/comment/fields/%/widget-type','a:2:{i:4;a:1:{s:22:"comment_node_type_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:7;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:7;}','','493','9','1','admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/groups/%/delete','a:2:{i:4;a:1:{s:22:"comment_node_type_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:7;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','user_access','a:1:{i:0;s:24:"administer content types";}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:7;}','','493','9','0','','admin/structure/types/manage/%/comment/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/types/manage/%/comment/groups/%/enable','a:2:{i:4;a:1:{s:22:"comment_node_type_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:7;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:7:"comment";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','user_access','a:1:{i:0;s:24:"administer content types";}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:7;}','','493','9','0','','admin/structure/types/manage/%/comment/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/types/manage/%/delete','a:1:{i:4;s:14:"node_type_load";}','','user_access','a:1:{i:0;s:24:"administer content types";}','drupal_get_form','a:2:{i:0;s:24:"node_type_delete_confirm";i:1;i:4;}','','61','6','0','','admin/structure/types/manage/%/delete','Delete','t','','','a:0:{}','6','','','0','modules/node/content_types.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/types/manage/%/display','a:1:{i:4;s:14:"node_type_load";}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:4:"node";i:2;i:4;i:3;s:7:"default";}','','61','6','1','admin/structure/types/manage/%','admin/structure/types/manage/%','Manage display','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/default','a:1:{i:4;s:14:"node_type_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:"node";i:1;i:4;i:2;s:7:"default";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:4:"node";i:2;i:4;i:3;s:7:"default";}','','123','7','1','admin/structure/types/manage/%/display','admin/structure/types/manage/%','Default','t','','','a:0:{}','140','','','-10','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/full','a:1:{i:4;s:14:"node_type_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:"node";i:1;i:4;i:2;s:4:"full";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:4:"node";i:2;i:4;i:3;s:4:"full";}','','123','7','1','admin/structure/types/manage/%/display','admin/structure/types/manage/%','Full content','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/rss','a:1:{i:4;s:14:"node_type_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:"node";i:1;i:4;i:2;s:3:"rss";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:4:"node";i:2;i:4;i:3;s:3:"rss";}','','123','7','1','admin/structure/types/manage/%/display','admin/structure/types/manage/%','RSS','t','','','a:0:{}','132','','','2','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/types/manage/%/display/search_index','a:1:{i:4;s:14:"node_type_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:"node";i:1;i:4;i:2;s:12:"search_index";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:4:"node";i:2;i:4;i:3;s:12:"search_index";}','','123','7','1','admin/structure/types/manage/%/display','admin/structure/types/manage/%','Search index','t','','','a:0:{}','132','','','3','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/search_result','a:1:{i:4;s:14:"node_type_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:"node";i:1;i:4;i:2;s:13:"search_result";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:4:"node";i:2;i:4;i:3;s:13:"search_result";}','','123','7','1','admin/structure/types/manage/%/display','admin/structure/types/manage/%','Search result highlighting input','t','','','a:0:{}','132','','','4','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/teaser','a:1:{i:4;s:14:"node_type_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:"node";i:1;i:4;i:2;s:6:"teaser";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:4:"node";i:2;i:4;i:3;s:6:"teaser";}','','123','7','1','admin/structure/types/manage/%/display','admin/structure/types/manage/%','Teaser','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/token','a:1:{i:4;s:14:"node_type_load";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:"node";i:1;i:4;i:2;s:5:"token";i:3;s:21:"field_ui_admin_access";i:4;s:11:"user_access";i:5;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:4:{i:0;s:30:"field_ui_display_overview_form";i:1;s:4:"node";i:2;i:4;i:3;s:5:"token";}','','123','7','1','admin/structure/types/manage/%/display','admin/structure/types/manage/%','Tokens','t','','','a:0:{}','132','','','5','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/types/manage/%/edit','a:1:{i:4;s:14:"node_type_load";}','','user_access','a:1:{i:0;s:24:"administer content types";}','drupal_get_form','a:2:{i:0;s:14:"node_type_form";i:1;i:4;}','','61','6','1','admin/structure/types/manage/%','admin/structure/types/manage/%','Edit','t','','','a:0:{}','140','','','0','modules/node/content_types.inc'),('admin/structure/types/manage/%/fields','a:1:{i:4;s:14:"node_type_load";}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:3:{i:0;s:28:"field_ui_field_overview_form";i:1;s:4:"node";i:2;i:4;}','','61','6','1','admin/structure/types/manage/%','admin/structure/types/manage/%','Manage fields','t','','','a:0:{}','132','','','1','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%','a:2:{i:4;a:1:{s:14:"node_type_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','122','7','0','','admin/structure/types/manage/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}','6','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/delete','a:2:{i:4;a:1:{s:14:"node_type_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:2:{i:0;s:26:"field_ui_field_delete_form";i:1;i:6;}','','245','8','1','admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Delete','t','','','a:0:{}','132','','','10','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/edit','a:2:{i:4;a:1:{s:14:"node_type_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:2:{i:0;s:24:"field_ui_field_edit_form";i:1;i:6;}','','245','8','1','admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Edit','t','','','a:0:{}','140','','','0','modules/field_ui/field_ui.admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/types/manage/%/fields/%/field-settings','a:2:{i:4;a:1:{s:14:"node_type_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:2:{i:0;s:28:"field_ui_field_settings_form";i:1;i:6;}','','245','8','1','admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Field settings','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/widget-type','a:2:{i:4;a:1:{s:14:"node_type_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:6;a:1:{s:18:"field_ui_menu_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','field_ui_admin_access','a:2:{i:0;s:11:"user_access";i:1;a:1:{i:0;s:24:"administer content types";}}','drupal_get_form','a:2:{i:0;s:25:"field_ui_widget_type_form";i:1;i:6;}','','245','8','1','admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Widget type','t','','','a:0:{}','132','','','0','modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/groups/%/delete','a:2:{i:4;a:1:{s:14:"node_type_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','user_access','a:1:{i:0;s:24:"administer content types";}','drupal_get_form','a:2:{i:0;s:23:"field_group_delete_form";i:1;i:6;}','','245','8','0','','admin/structure/types/manage/%/groups/%/delete','Delete','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/types/manage/%/groups/%/enable','a:2:{i:4;a:1:{s:14:"node_type_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}i:6;a:1:{s:21:"field_group_menu_load";a:4:{i:0;s:4:"node";i:1;i:4;i:2;s:1:"4";i:3;s:4:"%map";}}}','','user_access','a:1:{i:0;s:24:"administer content types";}','drupal_get_form','a:2:{i:0;s:23:"field_group_enable_form";i:1;i:6;}','','245','8','0','','admin/structure/types/manage/%/groups/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/field_group/field_group.field_ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/views','','','ctools_export_ui_task_access','a:2:{i:0;s:8:"views_ui";i:1;s:4:"list";}','ctools_export_ui_switcher_page','a:2:{i:0;s:8:"views_ui";i:1;s:4:"list";}','','7','3','0','','admin/structure/views','Views','t','','','a:0:{}','6','Manage customized lists of content.','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/add','','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_add_page','a:0:{}','','15','4','1','admin/structure/views','admin/structure/views','Add new view','t','','','a:0:{}','388','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/add-template','','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_add_template_page','a:0:{}','','15','4','1','admin/structure/views','admin/structure/views','Add view from template','t','','','a:0:{}','388','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/ajax/%/%','a:2:{i:4;N;i:5;s:19:"views_ui_cache_load";}','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_ajax_form','a:3:{i:0;b:1;i:1;i:4;i:2;i:5;}','ajax_deliver','60','6','0','','admin/structure/views/ajax/%/%','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/ajax/preview/%/%','a:2:{i:5;s:19:"views_ui_cache_load";i:6;N;}','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_preview','a:2:{i:0;i:5;i:1;i:6;}','ajax_deliver','124','7','0','','admin/structure/views/ajax/preview/%/%','','t','','','a:0:{}','6','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/import','','','views_import_access','a:1:{i:0;s:16:"administer views";}','drupal_get_form','a:1:{i:0;s:20:"views_ui_import_page";}','','15','4','1','admin/structure/views','admin/structure/views','Import','t','','','a:0:{}','388','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/list','','','ctools_export_ui_task_access','a:2:{i:0;s:8:"views_ui";i:1;s:4:"list";}','ctools_export_ui_switcher_page','a:2:{i:0;s:8:"views_ui";i:1;s:4:"list";}','','15','4','1','admin/structure/views','admin/structure/views','List','t','','','a:0:{}','140','','','-10','sites/all/modules/contrib/ctools/includes/export-ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/views/nojs/%/%','a:2:{i:4;N;i:5;s:19:"views_ui_cache_load";}','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_ajax_form','a:3:{i:0;b:0;i:1;i:4;i:2;i:5;}','','60','6','0','','admin/structure/views/nojs/%/%','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/nojs/preview/%/%','a:2:{i:5;s:19:"views_ui_cache_load";i:6;N;}','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_preview','a:2:{i:0;i:5;i:1;i:6;}','','124','7','0','','admin/structure/views/nojs/preview/%/%','','t','','','a:0:{}','6','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/settings','','','user_access','a:1:{i:0;s:16:"administer views";}','drupal_get_form','a:1:{i:0;s:29:"views_ui_admin_settings_basic";}','','15','4','1','admin/structure/views','admin/structure/views','Settings','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/settings/advanced','','','user_access','a:1:{i:0;s:16:"administer views";}','drupal_get_form','a:1:{i:0;s:32:"views_ui_admin_settings_advanced";}','','31','5','1','admin/structure/views/settings','admin/structure/views','Advanced','t','','','a:0:{}','132','','','1','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/settings/basic','','','user_access','a:1:{i:0;s:16:"administer views";}','drupal_get_form','a:1:{i:0;s:29:"views_ui_admin_settings_basic";}','','31','5','1','admin/structure/views/settings','admin/structure/views','Basic','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/template/%/add','a:1:{i:4;N;}','','ctools_export_ui_task_access','a:3:{i:0;s:8:"views_ui";i:1;s:12:"add_template";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:"views_ui";i:1;s:12:"add_template";i:2;i:4;}','','61','6','0','','admin/structure/views/template/%/add','Add from template','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/views/view/%','a:1:{i:4;s:19:"views_ui_cache_load";}','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_edit_page','a:1:{i:0;i:4;}','','30','5','0','','admin/structure/views/view/%','','views_ui_edit_page_title','a:1:{i:0;i:4;}','','a:0:{}','6','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/view/%/break-lock','a:1:{i:4;s:19:"views_ui_cache_load";}','','user_access','a:1:{i:0;s:16:"administer views";}','drupal_get_form','a:2:{i:0;s:27:"views_ui_break_lock_confirm";i:1;i:4;}','','61','6','0','','admin/structure/views/view/%/break-lock','Break lock','t','','','a:0:{}','4','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/view/%/clone','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:8:"views_ui";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:"views_ui";i:1;s:5:"clone";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:"views_ui";i:1;s:5:"clone";i:2;i:4;}','','61','6','0','','admin/structure/views/view/%/clone','Clone','t','','','a:0:{}','4','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/delete','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:8:"views_ui";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:"views_ui";i:1;s:6:"delete";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:"views_ui";i:1;s:6:"delete";i:2;i:4;}','','61','6','0','','admin/structure/views/view/%/delete','Delete','t','','','a:0:{}','4','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/disable','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:8:"views_ui";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:"views_ui";i:1;s:7:"disable";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:"views_ui";i:1;s:7:"disable";i:2;i:4;}','','61','6','0','','admin/structure/views/view/%/disable','Disable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/views/view/%/edit','a:1:{i:4;s:19:"views_ui_cache_load";}','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_edit_page','a:1:{i:0;i:4;}','','61','6','3','admin/structure/views/view/%','admin/structure/views/view/%','Edit view','t','','ajax_base_page_theme','a:0:{}','140','','','-10','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/view/%/edit/%/ajax','a:2:{i:4;s:19:"views_ui_cache_load";i:6;N;}','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_ajax_get_form','a:3:{i:0;s:18:"views_ui_edit_form";i:1;i:4;i:2;i:6;}','ajax_deliver','245','8','0','','admin/structure/views/view/%/edit/%/ajax','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/view/%/enable','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:8:"views_ui";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:"views_ui";i:1;s:6:"enable";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:"views_ui";i:1;s:6:"enable";i:2;i:4;}','','61','6','0','','admin/structure/views/view/%/enable','Enable','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/export','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:8:"views_ui";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:"views_ui";i:1;s:6:"export";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:"views_ui";i:1;s:6:"export";i:2;i:4;}','','61','6','0','','admin/structure/views/view/%/export','Export','t','','','a:0:{}','4','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/preview/%','a:2:{i:4;s:19:"views_ui_cache_load";i:6;N;}','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_build_preview','a:2:{i:0;i:4;i:1;i:6;}','','122','7','3','','admin/structure/views/view/%/preview/%','','t','','','a:0:{}','4','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/view/%/preview/%/ajax','a:2:{i:4;s:19:"views_ui_cache_load";i:6;N;}','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_build_preview','a:2:{i:0;i:4;i:1;i:6;}','ajax_deliver','245','8','0','','admin/structure/views/view/%/preview/%/ajax','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/views/includes/admin.inc');
INSERT INTO `menu_router` VALUES ('admin/structure/views/view/%/revert','a:1:{i:4;a:1:{s:21:"ctools_export_ui_load";a:1:{i:0;s:8:"views_ui";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:"views_ui";i:1;s:6:"revert";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:"views_ui";i:1;s:6:"delete";i:2;i:4;}','','61','6','0','','admin/structure/views/view/%/revert','Revert','t','','','a:0:{}','4','','','0','sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/tasks','','','user_access','a:1:{i:0;s:27:"access administration pages";}','system_admin_menu_block_page','a:0:{}','','3','2','1','admin','admin','Tasks','t','','','a:0:{}','140','','','-20','modules/system/system.admin.inc'),('admin/ticket-killer','','','views_access','a:1:{i:0;a:2:{i:0;s:17:"views_check_roles";i:1;a:1:{i:0;a:1:{i:3;s:1:"3";}}}}','views_page','a:2:{i:0;s:19:"admin_ticket_killer";i:1;s:6:"page_2";}','','3','2','0','','admin/ticket-killer','','t','','','a:0:{}','0','','','0',''),('admin/views/ajax/autocomplete/tag','','','user_access','a:1:{i:0;s:16:"administer views";}','views_ui_autocomplete_tag','a:0:{}','','31','5','0','','admin/views/ajax/autocomplete/tag','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/views/includes/admin.inc'),('admin/views/ajax/autocomplete/taxonomy','','','user_access','a:1:{i:0;s:14:"access content";}','views_ajax_autocomplete_taxonomy','a:0:{}','','31','5','0','','admin/views/ajax/autocomplete/taxonomy','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/views/includes/ajax.inc'),('admin/views/ajax/autocomplete/user','','','user_access','a:1:{i:0;s:20:"access user profiles";}','views_ajax_autocomplete_user','a:0:{}','','31','5','0','','admin/views/ajax/autocomplete/user','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/views/includes/ajax.inc'),('admin_menu/flush-cache','','','user_access','a:1:{i:0;s:12:"flush caches";}','admin_menu_flush_cache','a:0:{}','','3','2','0','','admin_menu/flush-cache','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/admin_menu/admin_menu.inc');
INSERT INTO `menu_router` VALUES ('badge/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','badge/%','','t','','','a:0:{}','6','','','0',''),('badge/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','badge/%/edit','','t','','','a:0:{}','6','','','0',''),('badge/badge/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"badge";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:5:"badge";i:2;s:5:"badge";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;i:2;}','','6','3','0','','badge/badge/%','View Badge','t','','','a:0:{}','6','View an entity of type Badge with bundle Badge','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('badge/badge/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"badge";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:5:"badge";i:2;s:5:"badge";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;i:2;}','','13','4','3','badge/badge/%','badge/badge/%','Delete','t','','','a:0:{}','132','View an entity of type Badge with bundle Badge','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('badge/badge/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"badge";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:5:"badge";i:2;s:5:"badge";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;i:2;}','','13','4','3','badge/badge/%','badge/badge/%','Edit','t','','','a:0:{}','132','View an entity of type Badge with bundle Badge','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('badge/badge/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"badge";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:5:"badge";i:2;s:5:"badge";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:5:"badge";i:1;s:5:"badge";i:2;i:2;}','','13','4','1','badge/badge/%','badge/badge/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('batch','','','1','a:0:{}','system_batch_page','a:0:{}','','1','1','0','','batch','','t','','_system_batch_theme','a:0:{}','0','','','0','modules/system/system.admin.inc');
INSERT INTO `menu_router` VALUES ('book-lists','','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:14:"access content";}}}','views_page','a:2:{i:0;s:10:"book_lists";i:1;s:4:"page";}','','1','1','0','','book-lists','Book Lists','t','','','a:0:{}','6','','','0',''),('branch/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','branch/%','','t','','','a:0:{}','6','','','0',''),('branch/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','branch/%/edit','','t','','','a:0:{}','6','','','0',''),('branch/branch/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"branch";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:6:"branch";i:2;s:6:"branch";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;i:2;}','','6','3','0','','branch/branch/%','View Branch','t','','','a:0:{}','6','View an entity of type Branch with bundle Branch','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('branch/branch/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"branch";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:6:"branch";i:2;s:6:"branch";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;i:2;}','','13','4','3','branch/branch/%','branch/branch/%','Delete','t','','','a:0:{}','132','View an entity of type Branch with bundle Branch','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('branch/branch/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"branch";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:6:"branch";i:2;s:6:"branch";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;i:2;}','','13','4','3','branch/branch/%','branch/branch/%','Edit','t','','','a:0:{}','132','View an entity of type Branch with bundle Branch','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('branch/branch/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"branch";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:6:"branch";i:2;s:6:"branch";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:6:"branch";i:1;s:6:"branch";i:2;i:2;}','','13','4','1','branch/branch/%','branch/branch/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('calendar','','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:14:"access content";}}}','views_page','a:2:{i:0;s:8:"calendar";i:1;s:6:"page_1";}','','1','1','0','','calendar','Calendar','t','','','a:0:{}','6','','','0',''),('calendar-node-field-date/year','','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:14:"access content";}}}','views_page','a:2:{i:0;s:8:"calendar";i:1;s:4:"page";}','','3','2','1','','calendar-node-field-date/year','Year','t','','','a:0:{}','132','','','4',''),('calendar/day','','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:14:"access content";}}}','views_page','a:2:{i:0;s:8:"calendar";i:1;s:6:"page_3";}','','3','2','1','calendar','calendar','Day','t','','','a:0:{}','132','','','3',''),('calendar/month','','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:14:"access content";}}}','views_page','a:2:{i:0;s:8:"calendar";i:1;s:6:"page_1";}','','3','2','1','calendar','calendar','Month','t','','','a:0:{}','140','','','0',''),('calendar/week','','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:14:"access content";}}}','views_page','a:2:{i:0;s:8:"calendar";i:1;s:6:"page_2";}','','3','2','1','calendar','calendar','Week','t','','','a:0:{}','132','','','2',''),('claim/%/prize','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:14:"access content";}','claim_prize','a:0:{}','','5','3','0','','claim/%/prize','Claim Prize','t','','','a:0:{}','6','','','0',''),('comment/%','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:15:"access comments";}','comment_permalink','a:1:{i:0;i:1;}','','2','2','0','','comment/%','Comment permalink','t','','','a:0:{}','6','','','0',''),('comment/%/approve','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:19:"administer comments";}','comment_approve','a:1:{i:0;i:1;}','','5','3','0','','comment/%/approve','Approve','t','','','a:0:{}','6','','','1','modules/comment/comment.pages.inc'),('comment/%/delete','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:19:"administer comments";}','comment_confirm_delete_page','a:1:{i:0;i:1;}','','5','3','1','comment/%','comment/%','Delete','t','','','a:0:{}','132','','','2','modules/comment/comment.admin.inc');
INSERT INTO `menu_router` VALUES ('comment/%/devel','a:1:{i:1;s:12:"comment_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_load_object','a:2:{i:0;s:7:"comment";i:1;i:1;}','','5','3','1','comment/%','comment/%','Devel','t','','','a:0:{}','132','','','100','sites/all/modules/contrib/devel/devel.pages.inc'),('comment/%/devel/load','a:1:{i:1;s:12:"comment_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_load_object','a:2:{i:0;s:7:"comment";i:1;i:1;}','','11','4','1','comment/%/devel','comment/%','Load','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('comment/%/devel/render','a:1:{i:1;s:12:"comment_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_render_object','a:2:{i:0;s:7:"comment";i:1;i:1;}','','11','4','1','comment/%/devel','comment/%','Render','t','','','a:0:{}','132','','','100','sites/all/modules/contrib/devel/devel.pages.inc'),('comment/%/devel/token','a:1:{i:1;s:12:"comment_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','token_devel_token_object','a:2:{i:0;s:7:"comment";i:1;i:1;}','','11','4','1','comment/%/devel','comment/%','Tokens','t','','','a:0:{}','132','','','5','sites/all/modules/contrib/token/token.pages.inc'),('comment/%/edit','a:1:{i:1;s:12:"comment_load";}','','comment_access','a:2:{i:0;s:4:"edit";i:1;i:1;}','comment_edit_page','a:1:{i:0;i:1;}','','5','3','1','comment/%','comment/%','Edit','t','','','a:0:{}','132','','','0',''),('comment/%/view','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:15:"access comments";}','comment_permalink','a:1:{i:0;i:1;}','','5','3','1','comment/%','comment/%','View comment','t','','','a:0:{}','140','','','-10',''),('comment/reply/%','a:1:{i:2;s:9:"node_load";}','','node_access','a:2:{i:0;s:4:"view";i:1;i:2;}','comment_reply','a:1:{i:0;i:2;}','','6','3','0','','comment/reply/%','Add new comment','t','','','a:0:{}','6','','','0','modules/comment/comment.pages.inc'),('ctools/autocomplete/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:14:"access content";}','ctools_content_autocomplete_entity','a:1:{i:0;i:2;}','','6','3','0','','ctools/autocomplete/%','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/content.menu.inc');
INSERT INTO `menu_router` VALUES ('ctools/context/ajax/access/add','','','user_access','a:1:{i:0;s:14:"access content";}','ctools_access_ajax_add','a:0:{}','','31','5','0','','ctools/context/ajax/access/add','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/access/configure','','','user_access','a:1:{i:0;s:14:"access content";}','ctools_access_ajax_edit','a:0:{}','','31','5','0','','ctools/context/ajax/access/configure','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/access/delete','','','user_access','a:1:{i:0;s:14:"access content";}','ctools_access_ajax_delete','a:0:{}','','31','5','0','','ctools/context/ajax/access/delete','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/add','','','user_access','a:1:{i:0;s:14:"access content";}','ctools_context_ajax_item_add','a:0:{}','','15','4','0','','ctools/context/ajax/add','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/context-admin.inc'),('ctools/context/ajax/configure','','','user_access','a:1:{i:0;s:14:"access content";}','ctools_context_ajax_item_edit','a:0:{}','','15','4','0','','ctools/context/ajax/configure','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/context-admin.inc'),('ctools/context/ajax/delete','','','user_access','a:1:{i:0;s:14:"access content";}','ctools_context_ajax_item_delete','a:0:{}','','15','4','0','','ctools/context/ajax/delete','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/includes/context-admin.inc'),('devel/arguments','','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_querylog_arguments','a:0:{}','','3','2','0','','devel/arguments','Arguments query','t','','','a:0:{}','0','Return a given query, with arguments instead of placeholders. Used by query log','','0','sites/all/modules/contrib/devel/devel.pages.inc');
INSERT INTO `menu_router` VALUES ('devel/cache/clear','','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_cache_clear','a:0:{}','','7','3','0','','devel/cache/clear','Clear cache','t','','','a:0:{}','6','Clear the CSS cache and all database cache tables which store page, node, theme and variable caches.','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/elements','','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_elements_page','a:0:{}','','3','2','0','','devel/elements','Hook_elements()','t','','','a:0:{}','6','View the active form/render elements for this site.','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/entity/info','','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_entity_info_page','a:0:{}','','7','3','0','','devel/entity/info','Entity info','t','','','a:0:{}','6','View entity information across the whole site.','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/explain','','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_querylog_explain','a:0:{}','','3','2','0','','devel/explain','Explain query','t','','','a:0:{}','0','Run an EXPLAIN on a given query. Used by query log','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/field/info','','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_field_info_page','a:0:{}','','7','3','0','','devel/field/info','Field info','t','','','a:0:{}','6','View fields information across the whole site.','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/menu/item','','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_menu_item','a:0:{}','','7','3','0','','devel/menu/item','Menu item','t','','','a:0:{}','6','Details about a given menu item.','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/menu/reset','','','user_access','a:1:{i:0;s:24:"access devel information";}','drupal_get_form','a:1:{i:0;s:18:"devel_menu_rebuild";}','','7','3','0','','devel/menu/reset','Rebuild menus','t','','','a:0:{}','6','Rebuild menu based on hook_menu() and revert any custom changes. All menu items return to their default settings.','','0','sites/all/modules/contrib/devel/devel.pages.inc');
INSERT INTO `menu_router` VALUES ('devel/php','','','user_access','a:1:{i:0;s:16:"execute php code";}','drupal_get_form','a:1:{i:0;s:18:"devel_execute_form";}','','3','2','0','','devel/php','Execute PHP Code','t','','','a:0:{}','6','Execute some PHP code','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/phpinfo','','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_phpinfo','a:0:{}','','3','2','0','','devel/phpinfo','PHPinfo()','t','','','a:0:{}','6','View your server''s PHP configuration','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/reference','','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_function_reference','a:0:{}','','3','2','0','','devel/reference','Function reference','t','','','a:0:{}','6','View a list of currently defined user functions with documentation links.','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/reinstall','','','user_access','a:1:{i:0;s:24:"access devel information";}','drupal_get_form','a:1:{i:0;s:15:"devel_reinstall";}','','3','2','0','','devel/reinstall','Reinstall modules','t','','','a:0:{}','6','Run hook_uninstall() and then hook_install() for a given module.','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/run-cron','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','system_run_cron','a:0:{}','','3','2','0','','devel/run-cron','Run cron','t','','','a:0:{}','6','','','0','modules/system/system.admin.inc'),('devel/session','','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_session','a:0:{}','','3','2','0','','devel/session','Session viewer','t','','','a:0:{}','6','List the contents of $_SESSION.','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/settings','','','user_access','a:1:{i:0;s:29:"administer site configuration";}','drupal_get_form','a:1:{i:0;s:20:"devel_admin_settings";}','','3','2','0','','devel/settings','Devel settings','t','','','a:0:{}','6','Helper functions, pages, and blocks to assist Drupal developers. The devel blocks can be managed via the <a href="/admin/structure/block">block administration</a> page.','','0','sites/all/modules/contrib/devel/devel.admin.inc');
INSERT INTO `menu_router` VALUES ('devel/switch','','','_devel_switch_user_access','a:1:{i:0;i:2;}','devel_switch_user','a:0:{}','','3','2','0','','devel/switch','Switch user','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/theme/registry','','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_theme_registry','a:0:{}','','7','3','0','','devel/theme/registry','Theme registry','t','','','a:0:{}','6','View a list of available theme functions across the whole site.','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/variable','','','user_access','a:1:{i:0;s:24:"access devel information";}','drupal_get_form','a:1:{i:0;s:19:"devel_variable_form";}','','3','2','0','','devel/variable','Variable editor','t','','','a:0:{}','6','Edit and delete site variables.','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('devel/variable/edit/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:24:"access devel information";}','drupal_get_form','a:2:{i:0;s:19:"devel_variable_edit";i:1;i:3;}','','14','4','0','','devel/variable/edit/%','Variable editor','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('drawing_ticket/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','drawing_ticket/%','','t','','','a:0:{}','6','','','0',''),('drawing_ticket/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','drawing_ticket/%/edit','','t','','','a:0:{}','6','','','0',''),('drawing_ticket/drawing_ticket/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:14:"drawing_ticket";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;i:2;}','','6','3','0','','drawing_ticket/drawing_ticket/%','View Drawing Ticket','t','','','a:0:{}','6','View an entity of type Drawing Ticket with bundle Drawing Ticket','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('drawing_ticket/drawing_ticket/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:14:"drawing_ticket";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;i:2;}','','13','4','3','drawing_ticket/drawing_ticket/%','drawing_ticket/drawing_ticket/%','Delete','t','','','a:0:{}','132','View an entity of type Drawing Ticket with bundle Drawing Ticket','','2','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('drawing_ticket/drawing_ticket/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:14:"drawing_ticket";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;i:2;}','','13','4','3','drawing_ticket/drawing_ticket/%','drawing_ticket/drawing_ticket/%','Edit','t','','','a:0:{}','132','View an entity of type Drawing Ticket with bundle Drawing Ticket','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('drawing_ticket/drawing_ticket/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:14:"drawing_ticket";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:14:"drawing_ticket";i:2;s:14:"drawing_ticket";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:14:"drawing_ticket";i:1;s:14:"drawing_ticket";i:2;i:2;}','','13','4','1','drawing_ticket/drawing_ticket/%','drawing_ticket/drawing_ticket/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('eform/%/confirm','a:1:{i:1;s:20:"entityform_type_load";}','','entityform_access','a:2:{i:0;s:7:"confirm";i:1;i:1;}','entityform_confirm_page','a:2:{i:0;i:1;i:1;i:3;}','','5','3','0','','eform/%/confirm','','entityform_type_page_title','a:2:{i:0;i:1;i:1;s:7:"confirm";}','','a:0:{}','6','','','0',''),('eform/%/draft','a:1:{i:1;s:20:"entityform_type_load";}','','1','a:2:{i:0;s:10:"draft_save";i:1;i:1;}','entityform_draft_page','a:1:{i:0;i:1;}','','5','3','0','','eform/%/draft','Form Saved','t','','','a:0:{}','6','','','0',''),('eform/%/submissions','a:1:{i:1;s:20:"entityform_type_load";}','','user_access','a:1:{i:0;s:19:"view own entityform";}','entityform_submission_page','a:3:{i:0;i:1;i:1;i:3;i:2;s:4:"user";}','','5','3','0','','eform/%/submissions','','entityform_type_page_title','a:2:{i:0;i:1;i:1;s:16:"view submissions";}','','a:0:{}','6','','','0',''),('eform/submit/%','a:1:{i:2;s:21:"entityform_empty_load";}','','entityform_access','a:2:{i:0;s:6:"submit";i:1;i:2;}','entityform_form_wrapper','a:2:{i:0;i:2;i:1;s:6:"submit";}','','6','3','0','','eform/submit/%','','entityform_page_title','a:2:{i:0;i:2;i:1;i:1;}','','a:0:{}','0','','','0','sites/all/modules/contrib/entityform/entityform.admin.inc');
INSERT INTO `menu_router` VALUES ('entityform-submissions/downloads/%/csv','a:1:{i:2;N;}','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:19:"view any entityform";}}}','views_page','a:3:{i:0;s:11:"entityforms";i:1;s:14:"autofields_csv";i:2;i:2;}','','13','4','0','','entityform-submissions/downloads/%/csv','','t','','','a:0:{}','0','','','0',''),('entityform-submissions/downloads/%/xml','a:1:{i:2;N;}','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:19:"view any entityform";}}}','views_page','a:3:{i:0;s:11:"entityforms";i:1;s:14:"autofields_xml";i:2;i:2;}','','13','4','0','','entityform-submissions/downloads/%/xml','','t','','','a:0:{}','0','','','0',''),('entityform-submissions/submissions/%','a:1:{i:2;N;}','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:19:"view any entityform";}}}','views_page','a:3:{i:0;s:11:"entityforms";i:1;s:22:"entityforms_admin_page";i:2;i:2;}','','6','3','0','','entityform-submissions/submissions/%','Submissions','t','','','a:0:{}','6','','','0',''),('entityform-submissions/submissions/%/list','a:1:{i:2;N;}','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:19:"view any entityform";}}}','views_page','a:3:{i:0;s:11:"entityforms";i:1;s:22:"entityforms_admin_page";i:2;i:2;}','','13','4','1','entityform-submissions/submissions/%','entityform-submissions/submissions/%','List','t','','','a:0:{}','140','View Submissions for all Entityforms','','0',''),('entityform-submissions/submissions/%/table','a:1:{i:2;N;}','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:19:"view any entityform";}}}','views_page','a:3:{i:0;s:11:"entityforms";i:1;s:16:"autofields_table";i:2;i:2;}','','13','4','1','entityform-submissions/submissions/%','entityform-submissions/submissions/%','Table','t','','','a:0:{}','132','View Submissions for all Entityforms','','0',''),('entityform-user-submissions/submissions/%','a:1:{i:2;N;}','','views_access','a:1:{i:0;b:1;}','views_page','a:3:{i:0;s:16:"user_entityforms";i:1;s:22:"entityforms_admin_page";i:2;i:2;}','','6','3','0','','entityform-user-submissions/submissions/%','Submissions','t','','','a:0:{}','6','','','0','');
INSERT INTO `menu_router` VALUES ('entityform-user-submissions/submissions/%/list','a:1:{i:2;N;}','','views_access','a:1:{i:0;b:1;}','views_page','a:3:{i:0;s:16:"user_entityforms";i:1;s:22:"entityforms_admin_page";i:2;i:2;}','','13','4','1','entityform-user-submissions/submissions/%','entityform-user-submissions/submissions/%','List','t','','','a:0:{}','140','View Submissions for all Entityforms','','0',''),('entityform/%','a:1:{i:1;s:15:"entityform_load";}','','entityform_access','a:2:{i:0;s:4:"view";i:1;i:1;}','entityform_page_view','a:1:{i:0;i:1;}','','2','2','0','','entityform/%','','entityform_page_title','a:1:{i:0;i:1;}','','a:0:{}','0','','','0',''),('entityform/%/delete','a:1:{i:1;s:15:"entityform_load";}','','entityform_access','a:2:{i:0;s:6:"delete";i:1;i:1;}','entityform_delete_form_wrapper','a:1:{i:0;i:1;}','','5','3','3','entityform/%','entityform/%','Delete','t','','','a:0:{}','132','','','10','sites/all/modules/contrib/entityform/entityform.admin.inc'),('entityform/%/edit','a:1:{i:1;s:15:"entityform_load";}','','entityform_access','a:2:{i:0;s:4:"edit";i:1;i:1;}','entityform_form_wrapper','a:2:{i:0;i:1;i:1;s:4:"edit";}','','5','3','3','entityform/%','entityform/%','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/entityform/entityform.admin.inc'),('entityform/%/view','a:1:{i:1;s:15:"entityform_load";}','','entityform_access','a:2:{i:0;s:4:"view";i:1;i:1;}','entityform_page_view','a:1:{i:0;i:1;}','','5','3','1','entityform/%','entityform/%','View','t','','','a:0:{}','140','','','-10',''),('entityreference/autocomplete/entity_block/%/%','a:2:{i:3;N;i:4;N;}','','user_access','a:1:{i:0;s:24:"administer entity blocks";}','entity_block_autocomplete_callback','a:2:{i:0;i:3;i:1;i:4;}','','28','5','0','','entityreference/autocomplete/entity_block/%/%','Entity Block Autocomplete','t','','','a:0:{}','0','','','0',''),('entityreference/autocomplete/single/%/%/%','a:3:{i:3;N;i:4;N;i:5;N;}','','entityreference_autocomplete_access_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','entityreference_autocomplete_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','','56','6','0','','entityreference/autocomplete/single/%/%/%','Entity Reference Autocomplete','t','','','a:0:{}','0','','','0','');
INSERT INTO `menu_router` VALUES ('entityreference/autocomplete/tags/%/%/%','a:3:{i:3;N;i:4;N;i:5;N;}','','entityreference_autocomplete_access_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','entityreference_autocomplete_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','','56','6','0','','entityreference/autocomplete/tags/%/%/%','Entity Reference Autocomplete','t','','','a:0:{}','0','','','0',''),('features/ajaxcallback/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:19:"administer features";}','features_export_components_json','a:1:{i:0;i:2;}','','6','3','0','','features/ajaxcallback/%','','features_get_feature_components','','','a:0:{}','0','Return components of a feature.','','0','sites/all/modules/contrib/features/features.admin.inc'),('features/autocomplete/packages','','','user_access','a:1:{i:0;s:15:"manage features";}','features_autocomplete_packages','a:0:{}','','7','3','0','','features/autocomplete/packages','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/features/features.admin.inc'),('feeds/importer/%','a:1:{i:2;s:19:"feeds_importer_load";}','','1','a:0:{}','feeds_fetcher_callback','a:2:{i:0;i:2;i:1;i:3;}','','6','3','0','','feeds/importer/%','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/feeds/feeds.pages.inc'),('field-collection/field-booklist-books/%','a:1:{i:2;s:26:"field_collection_item_load";}','','field_collection_item_access','a:2:{i:0;s:4:"view";i:1;i:2;}','field_collection_item_page_view','a:1:{i:0;i:2;}','','6','3','0','','field-collection/field-booklist-books/%','','t','','','a:0:{}','6','','','0','sites/all/modules/contrib/field_collection/field_collection.pages.inc'),('field-collection/field-booklist-books/%/delete','a:1:{i:2;s:26:"field_collection_item_load";}','','field_collection_item_access','a:2:{i:0;s:6:"delete";i:1;i:2;}','drupal_get_form','a:2:{i:0;s:36:"field_collection_item_delete_confirm";i:1;i:2;}','','13','4','2','field-collection/field-booklist-books/%','field-collection/field-booklist-books/%','Delete','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/field_collection/field_collection.pages.inc');
INSERT INTO `menu_router` VALUES ('field-collection/field-booklist-books/%/edit','a:1:{i:2;s:26:"field_collection_item_load";}','','field_collection_item_access','a:2:{i:0;s:6:"update";i:1;i:2;}','drupal_get_form','a:2:{i:0;s:26:"field_collection_item_form";i:1;i:2;}','','13','4','3','field-collection/field-booklist-books/%','field-collection/field-booklist-books/%','Edit','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/field_collection/field_collection.pages.inc'),('field-collection/field-booklist-books/%/revisions/%','a:2:{i:2;s:26:"field_collection_item_load";i:4;s:35:"field_collection_item_revision_load";}','','field_collection_item_access','a:2:{i:0;s:4:"view";i:1;i:4;}','field_collection_item_page_view','a:1:{i:0;i:4;}','','26','5','0','','field-collection/field-booklist-books/%/revisions/%','','t','','','a:0:{}','6','','','0','sites/all/modules/contrib/field_collection/field_collection.pages.inc'),('field-collection/field-booklist-books/%/view','a:1:{i:2;s:26:"field_collection_item_load";}','','field_collection_item_access','a:2:{i:0;s:4:"view";i:1;i:2;}','field_collection_item_page_view','a:1:{i:0;i:2;}','','13','4','1','field-collection/field-booklist-books/%','field-collection/field-booklist-books/%','View','t','','','a:0:{}','140','','','-10','sites/all/modules/contrib/field_collection/field_collection.pages.inc'),('field-collection/field-booklist-books/add/%/%','a:2:{i:3;N;i:4;N;}','','1','a:0:{}','field_collection_item_add','a:3:{i:0;s:20:"field_booklist_books";i:1;i:3;i:2;i:4;}','','28','5','0','','field-collection/field-booklist-books/add/%/%','','t','','','a:0:{}','6','','','0','sites/all/modules/contrib/field_collection/field_collection.pages.inc'),('file/ajax','','','user_access','a:1:{i:0;s:14:"access content";}','file_ajax_upload','a:0:{}','ajax_deliver','3','2','0','','file/ajax','','t','','ajax_base_page_theme','a:0:{}','0','','','0',''),('file/progress','','','user_access','a:1:{i:0;s:14:"access content";}','file_ajax_progress','a:0:{}','','3','2','0','','file/progress','','t','','ajax_base_page_theme','a:0:{}','0','','','0','');
INSERT INTO `menu_router` VALUES ('filter/tips','','','1','a:0:{}','filter_tips_long','a:0:{}','','3','2','0','','filter/tips','Compose tips','t','','','a:0:{}','20','','','0','modules/filter/filter.pages.inc'),('filter/tips/%','a:1:{i:2;s:18:"filter_format_load";}','','filter_access','a:1:{i:0;i:2;}','filter_tips_long','a:1:{i:0;i:2;}','','6','3','0','','filter/tips/%','Compose tips','t','','','a:0:{}','6','','','0','modules/filter/filter.pages.inc'),('galecia_profile_builder/wizard_form','','','user_access','a:1:{i:0;s:14:"access content";}','drupal_get_form','a:1:{i:0;s:28:"galecia_profile_builder_form";}','','3','2','0','','galecia_profile_builder/wizard_form','Add Readers','t','','','a:0:{}','0','','','0',''),('help/%/%','a:2:{i:1;N;i:2;N;}','','user_access','a:1:{i:0;s:24:"view advanced help topic";}','advanced_help_topic_page','a:2:{i:0;i:1;i:1;i:2;}','','4','3','0','','help/%/%','','t','','','a:0:{}','0','','','0',''),('help/ah/search/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:24:"view advanced help index";}','advanced_help_search_view','a:1:{i:0;s:13:"advanced_help";}','','14','4','0','','help/ah/search/%','Search help','t','','','a:0:{}','6','','','0',''),('home','','','ctools_access_menu','a:1:{i:0;a:4:{s:7:"plugins";a:0:{}s:5:"logic";s:3:"and";s:4:"type";s:4:"none";s:8:"settings";N;}}','page_manager_page_execute','a:1:{i:0;s:4:"home";}','','1','1','0','','home','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.inc'),('imce','','','imce_access','a:2:{i:0;b:0;i:1;i:1;}','imce','a:0:{}','','1','1','0','','imce','File browser','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/imce/inc/imce.page.inc'),('import','','','feeds_page_access','a:0:{}','feeds_page','a:0:{}','','1','1','0','','import','Import','t','','','a:0:{}','6','','','0','sites/all/modules/contrib/feeds/feeds.pages.inc'),('import/%','a:1:{i:1;s:19:"feeds_importer_load";}','','feeds_access','a:2:{i:0;s:6:"import";i:1;i:1;}','drupal_get_form','a:2:{i:0;s:17:"feeds_import_form";i:1;i:1;}','','2','2','0','','import/%','','feeds_importer_title','a:1:{i:0;i:1;}','','a:0:{}','6','','','0','sites/all/modules/contrib/feeds/feeds.pages.inc');
INSERT INTO `menu_router` VALUES ('import/%/delete-items','a:1:{i:1;s:19:"feeds_importer_load";}','','feeds_access','a:2:{i:0;s:5:"clear";i:1;i:1;}','drupal_get_form','a:2:{i:0;s:21:"feeds_delete_tab_form";i:1;i:1;}','','5','3','1','import/%','import/%','Delete items','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/feeds/feeds.pages.inc'),('import/%/import','a:1:{i:1;s:19:"feeds_importer_load";}','','feeds_access','a:2:{i:0;s:6:"import";i:1;i:1;}','drupal_get_form','a:2:{i:0;s:17:"feeds_import_form";i:1;i:1;}','','5','3','1','import/%','import/%','Import','t','','','a:0:{}','140','','','-10','sites/all/modules/contrib/feeds/feeds.pages.inc'),('import/%/log','a:1:{i:1;N;}','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:16:"administer feeds";}}}','views_page','a:3:{i:0;s:9:"feeds_log";i:1;s:6:"page_1";i:2;i:1;}','','5','3','1','import/%','import/%','Log','t','','','a:0:{}','132','','','0',''),('import/%/template','a:1:{i:1;s:19:"feeds_importer_load";}','','feeds_access','a:2:{i:0;s:6:"import";i:1;i:1;}','feeds_importer_template','a:1:{i:0;i:1;}','','5','3','0','','import/%/template','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/feeds/feeds.pages.inc'),('import/%/unlock','a:1:{i:1;s:19:"feeds_importer_load";}','','feeds_access','a:2:{i:0;s:6:"unlock";i:1;i:1;}','drupal_get_form','a:2:{i:0;s:21:"feeds_unlock_tab_form";i:1;i:1;}','','5','3','1','import/%','import/%','Unlock','t','','','a:0:{}','132','','','0','sites/all/modules/contrib/feeds/feeds.pages.inc'),('js/admin_menu/cache','','','user_access','a:1:{i:0;s:26:"access administration menu";}','admin_menu_js_cache','a:0:{}','admin_menu_deliver','7','3','0','','js/admin_menu/cache','','t','','','a:0:{}','0','','','0',''),('level/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','level/%','','t','','','a:0:{}','6','','','0',''),('level/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','level/%/edit','','t','','','a:0:{}','6','','','0',''),('level/level/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"level";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:5:"level";i:2;s:5:"level";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:5:"level";i:1;s:5:"level";i:2;i:2;}','','6','3','0','','level/level/%','View Level','t','','','a:0:{}','6','View an entity of type Level with bundle Level','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('level/level/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"level";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:5:"level";i:2;s:5:"level";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:5:"level";i:1;s:5:"level";i:2;i:2;}','','13','4','3','level/level/%','level/level/%','Delete','t','','','a:0:{}','132','View an entity of type Level with bundle Level','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('level/level/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"level";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:5:"level";i:2;s:5:"level";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:5:"level";i:1;s:5:"level";i:2;i:2;}','','13','4','3','level/level/%','level/level/%','Edit','t','','','a:0:{}','132','View an entity of type Level with bundle Level','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('level/level/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"level";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:5:"level";i:2;s:5:"level";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:5:"level";i:1;s:5:"level";i:2;i:2;}','','13','4','1','level/level/%','level/level/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('library/dashboard','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','library_dashboard_page','a:0:{}','','3','2','0','','library/dashboard','LIBRARY DASHBOARD','t','','','a:0:{}','6','','','0',''),('library/dashboard-widgets/reader_counts','','','views_access','a:1:{i:0;b:1;}','views_page','a:2:{i:0;s:17:"program_dashboard";i:1;s:4:"page";}','','7','3','0','','library/dashboard-widgets/reader_counts','','t','','','a:0:{}','0','','','0',''),('library/dashboard/activities/manage_activities','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','manage_activities','a:0:{}','','15','4','0','','library/dashboard/activities/manage_activities','Manage Activities','t','','','a:0:{}','6','','','0',''),('library/dashboard/activities/program/activity/add','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','add_activity_pages','a:0:{}','','63','6','0','','library/dashboard/activities/program/activity/add','Add Activity','t','','','a:0:{}','6','','','0','');
INSERT INTO `menu_router` VALUES ('library/dashboard/all_users','','','ctools_access_menu','a:1:{i:0;a:2:{s:4:"type";s:4:"none";s:8:"settings";N;}}','page_manager_page_execute','a:1:{i:0;s:9:"all_users";}','','7','3','0','','library/dashboard/all_users','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.inc'),('library/dashboard/badges/manage_badges','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','manage_badges','a:0:{}','','15','4','0','','library/dashboard/badges/manage_badges','Manage Badges','t','','','a:0:{}','6','','','0',''),('library/dashboard/branches','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','branches_page','a:0:{}','','7','3','0','','library/dashboard/branches','Branches','t','','','a:0:{}','6','','','0',''),('library/dashboard/branches/add','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','add_branch_page','a:0:{}','','15','4','0','','library/dashboard/branches/add','Add Branch','t','','','a:0:{}','6','','','0',''),('library/dashboard/branches/manage_prizes','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','manage_prizes_page','a:0:{}','','15','4','0','','library/dashboard/branches/manage_prizes','Manage Prizes','t','','','a:0:{}','6','','','0',''),('library/dashboard/branches/program/badge/add','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','add_badge_pages','a:0:{}','','63','6','0','','library/dashboard/branches/program/badge/add','Add Badge','t','','','a:0:{}','6','','','0',''),('library/dashboard/branches/program/drawing_ticket/add','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','add_drawing_ticket_pages','a:0:{}','','63','6','0','','library/dashboard/branches/program/drawing_ticket/add','Add Drawing Ticket','t','','','a:0:{}','6','','','0',''),('library/dashboard/branches/program/prize/add','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','add_prize_pages','a:0:{}','','63','6','0','','library/dashboard/branches/program/prize/add','Add Prize','t','','','a:0:{}','6','','','0','');
INSERT INTO `menu_router` VALUES ('library/dashboard/drawing','','','views_access','a:1:{i:0;a:2:{i:0;s:17:"views_check_roles";i:1;a:1:{i:0;a:2:{i:3;s:1:"3";i:5;s:1:"5";}}}}','views_page','a:2:{i:0;s:7:"drawing";i:1;s:6:"page_1";}','','7','3','0','','library/dashboard/drawing','Manage Drawings','t','','','a:0:{}','6','','','0',''),('library/dashboard/drawing/manage_tickets','','','views_access','a:1:{i:0;a:2:{i:0;s:17:"views_check_roles";i:1;a:1:{i:0;a:2:{i:3;s:1:"3";i:5;s:1:"5";}}}}','views_page','a:2:{i:0;s:7:"drawing";i:1;s:6:"page_2";}','','15','4','0','','library/dashboard/drawing/manage_tickets','','t','','','a:0:{}','0','','','0',''),('library/dashboard/level/points','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','add_points_page','a:0:{}','','15','4','0','','library/dashboard/level/points','Add Level','t','','','a:0:{}','6','','','0',''),('library/dashboard/program','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','program_pages','a:0:{}','','7','3','0','','library/dashboard/program','All Programs','t','','','a:0:{}','6','','','0',''),('library/dashboard/program/add','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','add_program_pages','a:0:{}','','15','4','0','','library/dashboard/program/add','Add Programs','t','','','a:0:{}','6','','','0',''),('library/dashboard/program/level/add','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','add_levels_page','a:0:{}','','31','5','0','','library/dashboard/program/level/add','Add Level','t','','','a:0:{}','6','','','0',''),('library/dashboard/program/program_overview_page','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','program_overview_page','a:0:{}','','15','4','0','','library/dashboard/program/program_overview_page','Program Overview','t','','','a:0:{}','6','','','0',''),('library/dashboard/program/{program_id}/{level_id}/edit','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','edit_level_page','a:0:{}','','63','6','0','','library/dashboard/program/{program_id}/{level_id}/edit','Add Level','t','','','a:0:{}','6','','','0','');
INSERT INTO `menu_router` VALUES ('library/dashboard/readers','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','reader_page','a:0:{}','','7','3','0','','library/dashboard/readers','Readers List','t','','','a:0:{}','6','','','0',''),('library/dashboard/readers/reader_overview','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','reader_overview','a:0:{}','','15','4','0','','library/dashboard/readers/reader_overview','Reader Overview','t','','','a:0:{}','6','','','0',''),('library/dashboard/schools','','','views_access','a:1:{i:0;a:2:{i:0;s:17:"views_check_roles";i:1;a:1:{i:0;a:1:{i:3;s:1:"3";}}}}','views_page','a:2:{i:0;s:7:"schools";i:1;s:4:"page";}','','7','3','0','','library/dashboard/schools','Schools','t','','','a:0:{}','6','','','0',''),('library/dashboard/secret_codes/manage_secret_codes','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','manage_secret_codes','a:0:{}','','15','4','0','','library/dashboard/secret_codes/manage_secret_codes','Manage Secret Codes','t','','','a:0:{}','6','','','0',''),('library/dashboard/secret_codes/program/secret_code/add','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','add_secret_code_pages','a:0:{}','','63','6','0','','library/dashboard/secret_codes/program/secret_code/add','Add Secret Code','t','','','a:0:{}','6','','','0',''),('library/dashboard/user_search','','','user_access','a:1:{i:0;s:24:"access library dashboard";}','user_search','a:0:{}','','7','3','0','','library/dashboard/user_search','User Search','t','','','a:0:{}','6','','','0',''),('library/manage-book-lists','','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:14:"access content";}}}','views_page','a:2:{i:0;s:10:"book_lists";i:1;s:6:"page_1";}','','3','2','0','','library/manage-book-lists','Book Lists','t','','','a:0:{}','6','','','0',''),('library/manage-events','','','views_access','a:1:{i:0;a:2:{i:0;s:17:"views_check_roles";i:1;a:1:{i:0;a:2:{i:3;s:1:"3";i:5;s:1:"5";}}}}','views_page','a:2:{i:0;s:13:"manage_events";i:1;s:4:"page";}','','3','2','0','','library/manage-events','Manage Events','t','','','a:0:{}','6','','','0','');
INSERT INTO `menu_router` VALUES ('my/book-log','','','views_access','a:1:{i:0;a:2:{i:0;s:17:"views_check_roles";i:1;a:1:{i:0;a:1:{i:2;s:1:"2";}}}}','views_page','a:2:{i:0;s:9:"book_logs";i:1;s:6:"page_1";}','','3','2','0','','my/book-log','','t','','','a:0:{}','0','','','0',''),('nag_message/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','nag_message/%','','t','','','a:0:{}','6','','','0',''),('nag_message/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','nag_message/%/edit','','t','','','a:0:{}','6','','','0',''),('nag_message/nag_message/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:11:"nag_message";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:11:"nag_message";i:2;s:11:"nag_message";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;i:2;}','','6','3','0','','nag_message/nag_message/%','View Nag Message','t','','','a:0:{}','6','View an entity of type Nag Message with bundle Nag Message','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('nag_message/nag_message/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:11:"nag_message";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:11:"nag_message";i:2;s:11:"nag_message";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;i:2;}','','13','4','3','nag_message/nag_message/%','nag_message/nag_message/%','Delete','t','','','a:0:{}','132','View an entity of type Nag Message with bundle Nag Message','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('nag_message/nag_message/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:11:"nag_message";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:11:"nag_message";i:2;s:11:"nag_message";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;i:2;}','','13','4','3','nag_message/nag_message/%','nag_message/nag_message/%','Edit','t','','','a:0:{}','132','View an entity of type Nag Message with bundle Nag Message','','1','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('nag_message/nag_message/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:11:"nag_message";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:11:"nag_message";i:2;s:11:"nag_message";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:11:"nag_message";i:1;s:11:"nag_message";i:2;i:2;}','','13','4','1','nag_message/nag_message/%','nag_message/nag_message/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('node','','','user_access','a:1:{i:0;s:14:"access content";}','node_page_default','a:0:{}','','1','1','0','','node','','t','','','a:0:{}','0','','','0',''),('node/%','a:1:{i:1;s:9:"node_load";}','','node_access','a:2:{i:0;s:4:"view";i:1;i:1;}','node_page_view','a:1:{i:0;i:1;}','','2','2','0','','node/%','','node_page_title','a:1:{i:0;i:1;}','','a:0:{}','6','','','0',''),('node/%/access','a:1:{i:1;s:9:"node_load";}','','content_access_node_page_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:19:"content_access_page";i:1;i:1;}','','5','3','3','node/%','node/%','Access control','t','','_node_custom_theme','a:0:{}','132','','','3','sites/all/modules/contrib/content_access/content_access.admin.inc'),('node/%/delete','a:1:{i:1;s:9:"node_load";}','','node_access','a:2:{i:0;s:6:"delete";i:1;i:1;}','drupal_get_form','a:2:{i:0;s:19:"node_delete_confirm";i:1;i:1;}','','5','3','2','node/%','node/%','Delete','t','','','a:0:{}','132','','','1','modules/node/node.pages.inc'),('node/%/delete-items','a:1:{i:1;s:9:"node_load";}','','feeds_access','a:2:{i:0;s:5:"clear";i:1;i:1;}','drupal_get_form','a:3:{i:0;s:21:"feeds_delete_tab_form";i:1;N;i:2;i:1;}','','5','3','1','node/%','node/%','Delete items','t','','','a:0:{}','132','','','11','sites/all/modules/contrib/feeds/feeds.pages.inc'),('node/%/devel','a:1:{i:1;s:9:"node_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_load_object','a:2:{i:0;s:4:"node";i:1;i:1;}','','5','3','1','node/%','node/%','Devel','t','','','a:0:{}','132','','','100','sites/all/modules/contrib/devel/devel.pages.inc');
INSERT INTO `menu_router` VALUES ('node/%/devel/load','a:1:{i:1;s:9:"node_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_load_object','a:2:{i:0;s:4:"node";i:1;i:1;}','','11','4','1','node/%/devel','node/%','Load','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('node/%/devel/render','a:1:{i:1;s:9:"node_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_render_object','a:2:{i:0;s:4:"node";i:1;i:1;}','','11','4','1','node/%/devel','node/%','Render','t','','','a:0:{}','132','','','100','sites/all/modules/contrib/devel/devel.pages.inc'),('node/%/devel/token','a:1:{i:1;s:9:"node_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','token_devel_token_object','a:2:{i:0;s:4:"node";i:1;i:1;}','','11','4','1','node/%/devel','node/%','Tokens','t','','','a:0:{}','132','','','5','sites/all/modules/contrib/token/token.pages.inc'),('node/%/edit','a:1:{i:1;s:9:"node_load";}','','node_access','a:2:{i:0;s:6:"update";i:1;i:1;}','node_page_edit','a:1:{i:0;i:1;}','','5','3','3','node/%','node/%','Edit','t','','','a:0:{}','132','','','0','modules/node/node.pages.inc'),('node/%/import','a:1:{i:1;s:9:"node_load";}','','feeds_access','a:2:{i:0;s:6:"import";i:1;i:1;}','drupal_get_form','a:2:{i:0;s:21:"feeds_import_tab_form";i:1;i:1;}','','5','3','1','node/%','node/%','Import','t','','','a:0:{}','132','','','10','sites/all/modules/contrib/feeds/feeds.pages.inc'),('node/%/log','a:1:{i:1;a:1:{s:14:"views_arg_load";a:3:{i:0;s:9:"feeds_log";i:1;s:6:"page_2";i:2;s:6:"%index";}}}','','views_access','a:1:{i:0;a:2:{i:0;s:16:"views_check_perm";i:1;a:1:{i:0;s:16:"administer feeds";}}}','views_page','a:3:{i:0;s:9:"feeds_log";i:1;s:6:"page_2";i:2;i:1;}','','5','3','1','node/%','node/%','Log','t','','','a:0:{}','132','','','12',''),('node/%/panel_content','a:1:{i:1;s:9:"node_load";}','','panels_node_edit_node','a:1:{i:0;i:1;}','panels_node_edit_content','a:1:{i:0;i:1;}','','5','3','1','node/%','node/%','Panel content','t','','','a:0:{}','132','','','3','');
INSERT INTO `menu_router` VALUES ('node/%/panel_layout','a:1:{i:1;s:9:"node_load";}','','panels_node_edit_node','a:1:{i:0;i:1;}','panels_node_edit_layout','a:1:{i:0;i:1;}','','5','3','1','node/%','node/%','Panel layout','t','','','a:0:{}','132','','','2',''),('node/%/revisions','a:1:{i:1;s:9:"node_load";}','','_node_revision_access','a:1:{i:0;i:1;}','node_revision_overview','a:1:{i:0;i:1;}','','5','3','1','node/%','node/%','Revisions','t','','','a:0:{}','132','','','2','modules/node/node.pages.inc'),('node/%/revisions/%/delete','a:2:{i:1;a:1:{s:9:"node_load";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:2:{i:0;i:1;i:1;s:6:"delete";}','drupal_get_form','a:2:{i:0;s:28:"node_revision_delete_confirm";i:1;i:1;}','','21','5','0','','node/%/revisions/%/delete','Delete earlier revision','t','','','a:0:{}','6','','','0','modules/node/node.pages.inc'),('node/%/revisions/%/revert','a:2:{i:1;a:1:{s:9:"node_load";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:2:{i:0;i:1;i:1;s:6:"update";}','drupal_get_form','a:2:{i:0;s:28:"node_revision_revert_confirm";i:1;i:1;}','','21','5','0','','node/%/revisions/%/revert','Revert to earlier revision','t','','','a:0:{}','6','','','0','modules/node/node.pages.inc'),('node/%/revisions/%/view','a:2:{i:1;a:1:{s:9:"node_load";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:1:{i:0;i:1;}','node_show','a:2:{i:0;i:1;i:1;b:1;}','','21','5','0','','node/%/revisions/%/view','Revisions','t','','','a:0:{}','6','','','0',''),('node/%/track','a:1:{i:1;s:9:"node_load";}','','user_access','a:1:{i:0;s:17:"access statistics";}','statistics_node_tracker','a:0:{}','','5','3','1','node/%','node/%','Track','t','','','a:0:{}','132','','','2','modules/statistics/statistics.pages.inc'),('node/%/unlock','a:1:{i:1;s:9:"node_load";}','','feeds_access','a:2:{i:0;s:6:"unlock";i:1;i:1;}','drupal_get_form','a:3:{i:0;s:21:"feeds_unlock_tab_form";i:1;N;i:2;i:1;}','','5','3','1','node/%','node/%','Unlock','t','','','a:0:{}','132','','','11','sites/all/modules/contrib/feeds/feeds.pages.inc'),('node/%/view','a:1:{i:1;s:9:"node_load";}','','node_access','a:2:{i:0;s:4:"view";i:1;i:1;}','node_page_view','a:1:{i:0;i:1;}','','5','3','1','node/%','node/%','View','t','','','a:0:{}','140','','','-10','');
INSERT INTO `menu_router` VALUES ('node/add','','','_node_add_access','a:0:{}','node_add_page','a:0:{}','','3','2','0','','node/add','Add content','t','','','a:0:{}','6','','','0','modules/node/node.pages.inc'),('node/add/article','','','node_access','a:2:{i:0;s:6:"create";i:1;s:7:"article";}','node_add','a:1:{i:0;s:7:"article";}','','7','3','0','','node/add/article','Article','check_plain','','','a:0:{}','6','Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.','','0','modules/node/node.pages.inc'),('node/add/book-list','','','node_access','a:2:{i:0;s:6:"create";i:1;s:9:"book_list";}','node_add','a:1:{i:0;s:9:"book_list";}','','7','3','0','','node/add/book-list','Book List','check_plain','','','a:0:{}','6','A book list is a collection of books that can be displayed in a variety of formats.','','0','modules/node/node.pages.inc'),('node/add/customformfields','','','node_access','a:2:{i:0;s:6:"create";i:1;s:16:"customformfields";}','node_add','a:1:{i:0;s:16:"customformfields";}','','7','3','0','','node/add/customformfields','CustomFormFields','check_plain','','','a:0:{}','6','','','0','modules/node/node.pages.inc'),('node/add/event','','','node_access','a:2:{i:0;s:6:"create";i:1;s:5:"event";}','node_add','a:1:{i:0;s:5:"event";}','','7','3','0','','node/add/event','Event','check_plain','','','a:0:{}','6','A date content type that is linked to a Views calendar.','','0','modules/node/node.pages.inc'),('node/add/page','','','node_access','a:2:{i:0;s:6:"create";i:1;s:4:"page";}','node_add','a:1:{i:0;s:4:"page";}','','7','3','0','','node/add/page','Basic page','check_plain','','','a:0:{}','6','Use <em>basic pages</em> for your static content, such as an ''About us'' page.','','0','modules/node/node.pages.inc'),('node/add/panel','','','node_access','a:2:{i:0;s:6:"create";i:1;s:5:"panel";}','node_add','a:1:{i:0;s:5:"panel";}','','7','3','0','','node/add/panel','Panel','check_plain','','','a:0:{}','6','A panel layout broken up into rows and columns.','','0','modules/node/node.pages.inc'),('node/add/panel/choose-layout','','','panels_add_panel_access_callback','a:0:{}','panels_node_add','a:0:{}','','15','4','0','','node/add/panel/choose-layout','Choose layout','t','','','a:0:{}','0','','','0','');
INSERT INTO `menu_router` VALUES ('panels/ajax','','','user_access','a:1:{i:0;s:14:"access content";}','panels_ajax_router','a:0:{}','ajax_deliver','3','2','0','','panels/ajax','','t','','ajax_base_page_theme','a:0:{}','0','','','0',''),('points/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','points/%','','t','','','a:0:{}','6','','','0',''),('points/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','points/%/edit','','t','','','a:0:{}','6','','','0',''),('points/points/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"points";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:6:"points";i:2;s:6:"points";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:6:"points";i:1;s:6:"points";i:2;i:2;}','','6','3','0','','points/points/%','View Points','t','','','a:0:{}','6','View an entity of type Points with bundle Points','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('points/points/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"points";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:6:"points";i:2;s:6:"points";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:6:"points";i:1;s:6:"points";i:2;i:2;}','','13','4','3','points/points/%','points/points/%','Delete','t','','','a:0:{}','132','View an entity of type Points with bundle Points','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('points/points/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"points";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:6:"points";i:2;s:6:"points";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:6:"points";i:1;s:6:"points";i:2;i:2;}','','13','4','3','points/points/%','points/points/%','Edit','t','','','a:0:{}','132','View an entity of type Points with bundle Points','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('points/points/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"points";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:6:"points";i:2;s:6:"points";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:6:"points";i:1;s:6:"points";i:2;i:2;}','','13','4','1','points/points/%','points/points/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('prize/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','prize/%','','t','','','a:0:{}','6','','','0',''),('prize/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','prize/%/edit','','t','','','a:0:{}','6','','','0',''),('prize/prize/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"prize";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:5:"prize";i:2;s:5:"prize";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;i:2;}','','6','3','0','','prize/prize/%','View Prize','t','','','a:0:{}','6','View an entity of type Prize with bundle Prize','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('prize/prize/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"prize";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:5:"prize";i:2;s:5:"prize";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;i:2;}','','13','4','3','prize/prize/%','prize/prize/%','Delete','t','','','a:0:{}','132','View an entity of type Prize with bundle Prize','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('prize/prize/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"prize";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:5:"prize";i:2;s:5:"prize";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;i:2;}','','13','4','3','prize/prize/%','prize/prize/%','Edit','t','','','a:0:{}','132','View an entity of type Prize with bundle Prize','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('prize/prize/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:5:"prize";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:5:"prize";i:2;s:5:"prize";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:5:"prize";i:1;s:5:"prize";i:2;i:2;}','','13','4','1','prize/prize/%','prize/prize/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('program/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','program/%','','t','','','a:0:{}','6','','','0','');
INSERT INTO `menu_router` VALUES ('program/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','program/%/edit','','t','','','a:0:{}','6','','','0',''),('program/program/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:7:"program";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:7:"program";i:2;s:7:"program";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:7:"program";i:1;s:7:"program";i:2;i:2;}','','6','3','0','','program/program/%','View Program','t','','','a:0:{}','6','View an entity of type Program with bundle Program','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('program/program/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:7:"program";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:7:"program";i:2;s:7:"program";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:7:"program";i:1;s:7:"program";i:2;i:2;}','','13','4','3','program/program/%','program/program/%','Delete','t','','','a:0:{}','132','View an entity of type Program with bundle Program','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('program/program/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:7:"program";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:7:"program";i:2;s:7:"program";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:7:"program";i:1;s:7:"program";i:2;i:2;}','','13','4','3','program/program/%','program/program/%','Edit','t','','','a:0:{}','132','View an entity of type Program with bundle Program','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('program/program/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:7:"program";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:7:"program";i:2;s:7:"program";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:7:"program";i:1;s:7:"program";i:2;i:2;}','','13','4','1','program/program/%','program/program/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('reader-dashboard','','','ctools_access_menu','a:1:{i:0;a:4:{s:7:"plugins";a:1:{i:0;a:4:{s:4:"name";s:4:"role";s:8:"settings";a:1:{s:4:"rids";a:1:{i:0;i:2;}}s:7:"context";s:14:"logged-in-user";s:3:"not";b:0;}}s:5:"logic";s:3:"and";s:4:"type";s:4:"none";s:8:"settings";N;}}','page_manager_page_execute','a:1:{i:0;s:16:"reader_dashboard";}','','1','1','0','','reader-dashboard','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.inc');
INSERT INTO `menu_router` VALUES ('reader/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','reader/%','','t','','','a:0:{}','6','','','0',''),('reader/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','reader/%/edit','','t','','','a:0:{}','6','','','0',''),('reader/dashboard','','','user_access','a:1:{i:0;s:23:"access reader dashboard";}','reader_dashboard','a:0:{}','','3','2','0','','reader/dashboard','Reader Dashboard','t','','','a:0:{}','6','','','0',''),('reader/dashboard/activity_log_reference','','','user_access','a:1:{i:0;s:23:"access reader dashboard";}','activity_log_page','a:0:{}','','7','3','0','','reader/dashboard/activity_log_reference','Activity Log','t','','','a:0:{}','6','','','0',''),('reader/dashboard/activity_log_reference/add','','','user_access','a:1:{i:0;s:23:"access reader dashboard";}','activity_log_add_page','a:0:{}','','15','4','0','','reader/dashboard/activity_log_reference/add','Add activity log','t','','','a:0:{}','6','','','0',''),('reader/dashboard/history/reading','','','user_access','a:1:{i:0;s:23:"access reader dashboard";}','reader_history','a:0:{}','','15','4','0','','reader/dashboard/history/reading','View history','t','','','a:0:{}','6','','','0',''),('reader/dashboard/profile/add','','','user_access','a:1:{i:0;s:23:"access reader dashboard";}','reader_add','a:0:{}','','15','4','0','','reader/dashboard/profile/add','Add Profile','t','','','a:0:{}','6','','','0',''),('reader/dashboard/program/activity/add','','','user_access','a:1:{i:0;s:23:"access reader dashboard";}','log_add','a:0:{}','','31','5','0','','reader/dashboard/program/activity/add','Add activity','t','','','a:0:{}','6','','','0',''),('reader/reader/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"reader";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:6:"reader";i:2;s:6:"reader";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;i:2;}','','6','3','0','','reader/reader/%','View Reader','t','','','a:0:{}','6','View an entity of type Reader with bundle Reader','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('reader/reader/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"reader";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:6:"reader";i:2;s:6:"reader";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;i:2;}','','13','4','3','reader/reader/%','reader/reader/%','Delete','t','','','a:0:{}','132','View an entity of type Reader with bundle Reader','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('reader/reader/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"reader";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:6:"reader";i:2;s:6:"reader";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;i:2;}','','13','4','3','reader/reader/%','reader/reader/%','Edit','t','','','a:0:{}','132','View an entity of type Reader with bundle Reader','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('reader/reader/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"reader";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:6:"reader";i:2;s:6:"reader";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:6:"reader";i:1;s:6:"reader";i:2;i:2;}','','13','4','1','reader/reader/%','reader/reader/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_activity_log/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','reader_activity_log/%','','t','','','a:0:{}','6','','','0',''),('reader_activity_log/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','reader_activity_log/%/edit','','t','','','a:0:{}','6','','','0',''),('reader_activity_log/reader_activity_log/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:19:"reader_activity_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;i:2;}','','6','3','0','','reader_activity_log/reader_activity_log/%','View Reader Activity Log','t','','','a:0:{}','6','View an entity of type Reader Activity Log with bundle Reader Activity Log','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('reader_activity_log/reader_activity_log/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:19:"reader_activity_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;i:2;}','','13','4','3','reader_activity_log/reader_activity_log/%','reader_activity_log/reader_activity_log/%','Delete','t','','','a:0:{}','132','View an entity of type Reader Activity Log with bundle Reader Activity Log','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_activity_log/reader_activity_log/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:19:"reader_activity_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;i:2;}','','13','4','3','reader_activity_log/reader_activity_log/%','reader_activity_log/reader_activity_log/%','Edit','t','','','a:0:{}','132','View an entity of type Reader Activity Log with bundle Reader Activity Log','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_activity_log/reader_activity_log/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:19:"reader_activity_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:19:"reader_activity_log";i:2;s:19:"reader_activity_log";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:19:"reader_activity_log";i:1;s:19:"reader_activity_log";i:2;i:2;}','','13','4','1','reader_activity_log/reader_activity_log/%','reader_activity_log/reader_activity_log/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_badge/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','reader_badge/%','','t','','','a:0:{}','6','','','0',''),('reader_badge/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','reader_badge/%/edit','','t','','','a:0:{}','6','','','0','');
INSERT INTO `menu_router` VALUES ('reader_badge/reader_badge/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"reader_badge";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;i:2;}','','6','3','0','','reader_badge/reader_badge/%','View Reader Badge','t','','','a:0:{}','6','View an entity of type Reader Badge with bundle Reader Badge','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_badge/reader_badge/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"reader_badge";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;i:2;}','','13','4','3','reader_badge/reader_badge/%','reader_badge/reader_badge/%','Delete','t','','','a:0:{}','132','View an entity of type Reader Badge with bundle Reader Badge','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_badge/reader_badge/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"reader_badge";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;i:2;}','','13','4','3','reader_badge/reader_badge/%','reader_badge/reader_badge/%','Edit','t','','','a:0:{}','132','View an entity of type Reader Badge with bundle Reader Badge','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_badge/reader_badge/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"reader_badge";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:12:"reader_badge";i:2;s:12:"reader_badge";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:12:"reader_badge";i:1;s:12:"reader_badge";i:2;i:2;}','','13','4','1','reader_badge/reader_badge/%','reader_badge/reader_badge/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('reader_log/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','reader_log/%','','t','','','a:0:{}','6','','','0',''),('reader_log/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','reader_log/%/edit','','t','','','a:0:{}','6','','','0',''),('reader_log/reader_log/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:10:"reader_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:10:"reader_log";i:2;s:10:"reader_log";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;i:2;}','','6','3','0','','reader_log/reader_log/%','View Reader Log','t','','','a:0:{}','6','View an entity of type Reader Log with bundle Reader Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_log/reader_log/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:10:"reader_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:10:"reader_log";i:2;s:10:"reader_log";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;i:2;}','','13','4','3','reader_log/reader_log/%','reader_log/reader_log/%','Delete','t','','','a:0:{}','132','View an entity of type Reader Log with bundle Reader Log','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_log/reader_log/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:10:"reader_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:10:"reader_log";i:2;s:10:"reader_log";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;i:2;}','','13','4','3','reader_log/reader_log/%','reader_log/reader_log/%','Edit','t','','','a:0:{}','132','View an entity of type Reader Log with bundle Reader Log','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_log/reader_log/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:10:"reader_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:10:"reader_log";i:2;s:10:"reader_log";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:10:"reader_log";i:1;s:10:"reader_log";i:2;i:2;}','','13','4','1','reader_log/reader_log/%','reader_log/reader_log/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('reader_prize/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','reader_prize/%','','t','','','a:0:{}','6','','','0',''),('reader_prize/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','reader_prize/%/edit','','t','','','a:0:{}','6','','','0',''),('reader_prize/reader_prize/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"reader_prize";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;i:2;}','','6','3','0','','reader_prize/reader_prize/%','View Reader Prize','t','','','a:0:{}','6','View an entity of type Reader Prize with bundle Reader Prize','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_prize/reader_prize/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"reader_prize";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;i:2;}','','13','4','3','reader_prize/reader_prize/%','reader_prize/reader_prize/%','Delete','t','','','a:0:{}','132','View an entity of type Reader Prize with bundle Reader Prize','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_prize/reader_prize/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"reader_prize";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;i:2;}','','13','4','3','reader_prize/reader_prize/%','reader_prize/reader_prize/%','Edit','t','','','a:0:{}','132','View an entity of type Reader Prize with bundle Reader Prize','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_prize/reader_prize/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:12:"reader_prize";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:12:"reader_prize";i:2;s:12:"reader_prize";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:12:"reader_prize";i:1;s:12:"reader_prize";i:2;i:2;}','','13','4','1','reader_prize/reader_prize/%','reader_prize/reader_prize/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('reader_ticket/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','reader_ticket/%','','t','','','a:0:{}','6','','','0',''),('reader_ticket/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','reader_ticket/%/edit','','t','','','a:0:{}','6','','','0',''),('reader_ticket/reader_ticket/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:13:"reader_ticket";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;i:2;}','','6','3','0','','reader_ticket/reader_ticket/%','View Reader Ticket','t','','','a:0:{}','6','View an entity of type Reader Ticket with bundle Reader Ticket','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_ticket/reader_ticket/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:13:"reader_ticket";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;i:2;}','','13','4','3','reader_ticket/reader_ticket/%','reader_ticket/reader_ticket/%','Delete','t','','','a:0:{}','132','View an entity of type Reader Ticket with bundle Reader Ticket','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_ticket/reader_ticket/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:13:"reader_ticket";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;i:2;}','','13','4','3','reader_ticket/reader_ticket/%','reader_ticket/reader_ticket/%','Edit','t','','','a:0:{}','132','View an entity of type Reader Ticket with bundle Reader Ticket','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('reader_ticket/reader_ticket/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:13:"reader_ticket";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:13:"reader_ticket";i:2;s:13:"reader_ticket";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:13:"reader_ticket";i:1;s:13:"reader_ticket";i:2;i:2;}','','13','4','1','reader_ticket/reader_ticket/%','reader_ticket/reader_ticket/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('reading_log/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','reading_log/%','','t','','','a:0:{}','6','','','0',''),('reading_log/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','reading_log/%/edit','','t','','','a:0:{}','6','','','0',''),('reading_log/reading_log/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:11:"reading_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:11:"reading_log";i:2;s:11:"reading_log";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;i:2;}','','6','3','0','','reading_log/reading_log/%','View Reading Log','t','','','a:0:{}','6','View an entity of type Reading Log with bundle Reading Log','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('reading_log/reading_log/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:11:"reading_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:11:"reading_log";i:2;s:11:"reading_log";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;i:2;}','','13','4','3','reading_log/reading_log/%','reading_log/reading_log/%','Delete','t','','','a:0:{}','132','View an entity of type Reading Log with bundle Reading Log','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('reading_log/reading_log/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:11:"reading_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:11:"reading_log";i:2;s:11:"reading_log";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;i:2;}','','13','4','3','reading_log/reading_log/%','reading_log/reading_log/%','Edit','t','','','a:0:{}','132','View an entity of type Reading Log with bundle Reading Log','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('reading_log/reading_log/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:11:"reading_log";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:11:"reading_log";i:2;s:11:"reading_log";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:11:"reading_log";i:1;s:11:"reading_log";i:2;i:2;}','','13','4','1','reading_log/reading_log/%','reading_log/reading_log/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('rss.xml','','','user_access','a:1:{i:0;s:14:"access content";}','node_feed','a:2:{i:0;b:0;i:1;a:0:{}}','','1','1','0','','rss.xml','RSS feed','t','','','a:0:{}','0','','','0',''),('school/%','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','2','2','0','','school/%','','t','','','a:0:{}','6','','','0',''),('school/%/edit','a:1:{i:1;N;}','','0','a:0:{}','','a:0:{}','','5','3','0','','school/%/edit','','t','','','a:0:{}','6','','','0',''),('school/school/%','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"school";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:6:"school";i:2;s:6:"school";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:6:"school";i:1;s:6:"school";i:2;i:2;}','','6','3','0','','school/school/%','View School','t','','','a:0:{}','6','View an entity of type School with bundle School','','0','sites/all/modules/contrib/eck/eck.entity.inc'),('school/school/%/delete','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"school";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:"delete";i:1;s:6:"school";i:2;s:6:"school";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:6:"school";i:1;s:6:"school";i:2;i:2;}','','13','4','3','school/school/%','school/school/%','Delete','t','','','a:0:{}','132','View an entity of type School with bundle School','','2','sites/all/modules/contrib/eck/eck.entity.inc'),('school/school/%/edit','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"school";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"edit";i:1;s:6:"school";i:2;s:6:"school";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:6:"school";i:1;s:6:"school";i:2;i:2;}','','13','4','3','school/school/%','school/school/%','Edit','t','','','a:0:{}','132','View an entity of type School with bundle School','','1','sites/all/modules/contrib/eck/eck.entity.inc'),('school/school/%/view','a:1:{i:2;a:1:{s:14:"eckentity_load";a:1:{i:0;s:6:"school";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:"view";i:1;s:6:"school";i:2;s:6:"school";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:6:"school";i:1;s:6:"school";i:2;i:2;}','','13','4','1','school/school/%','school/school/%','View','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/eck/eck.entity.inc');
INSERT INTO `menu_router` VALUES ('search','','','search_is_active','a:0:{}','search_view','a:0:{}','','1','1','0','','search','Search','t','','','a:0:{}','20','','','0','modules/search/search.pages.inc'),('search/advanced_help/%','a:1:{i:2;s:14:"menu_tail_load";}','a:1:{i:2;s:16:"menu_tail_to_arg";}','user_access','a:1:{i:0;s:24:"view advanced help index";}','search_view','a:0:{}','','6','3','0','','search/advanced_help/%','','t','','','a:0:{}','6','','','0','modules/search/search.pages.inc'),('search/user','','','_search_menu_access','a:1:{i:0;s:4:"user";}','search_view','a:2:{i:0;s:4:"user";i:1;s:0:"";}','','3','2','1','search','search','Users','t','','','a:0:{}','132','','','-10','modules/search/search.pages.inc'),('search/user/%','a:1:{i:2;a:1:{s:14:"menu_tail_load";a:2:{i:0;s:4:"%map";i:1;s:6:"%index";}}}','a:1:{i:2;s:16:"menu_tail_to_arg";}','_search_menu_access','a:1:{i:0;s:4:"user";}','search_view','a:2:{i:0;s:4:"user";i:1;i:2;}','','6','3','1','search/user','search/user/%','Users','t','','','a:0:{}','132','','','0','modules/search/search.pages.inc'),('sites/default/files/styles/%','a:1:{i:4;s:16:"image_style_load";}','','1','a:0:{}','image_style_deliver','a:1:{i:0;i:4;}','','30','5','0','','sites/default/files/styles/%','Generate image style','t','','','a:0:{}','0','','','0',''),('system/ajax','','','1','a:0:{}','ajax_form_callback','a:0:{}','ajax_deliver','3','2','0','','system/ajax','AHAH callback','t','','ajax_base_page_theme','a:0:{}','0','','','0','includes/form.inc'),('system/files','','','1','a:0:{}','file_download','a:1:{i:0;s:7:"private";}','','3','2','0','','system/files','File download','t','','','a:0:{}','0','','','0',''),('system/files/styles/%','a:1:{i:3;s:16:"image_style_load";}','','1','a:0:{}','image_style_deliver','a:1:{i:0;i:3;}','','14','4','0','','system/files/styles/%','Generate image style','t','','','a:0:{}','0','','','0',''),('system/temporary','','','1','a:0:{}','file_download','a:1:{i:0;s:9:"temporary";}','','3','2','0','','system/temporary','Temporary files','t','','','a:0:{}','0','','','0','');
INSERT INTO `menu_router` VALUES ('system/timezone','','','1','a:0:{}','system_timezone','a:0:{}','','3','2','0','','system/timezone','Time zone','t','','','a:0:{}','0','','','0','modules/system/system.admin.inc'),('taxonomy/autocomplete','','','user_access','a:1:{i:0;s:14:"access content";}','taxonomy_autocomplete','a:0:{}','','3','2','0','','taxonomy/autocomplete','Autocomplete taxonomy','t','','','a:0:{}','0','','','0','modules/taxonomy/taxonomy.pages.inc'),('taxonomy/term/%','a:1:{i:2;s:18:"taxonomy_term_load";}','','user_access','a:1:{i:0;s:14:"access content";}','taxonomy_term_page','a:1:{i:0;i:2;}','','6','3','0','','taxonomy/term/%','Taxonomy term','taxonomy_term_title','a:1:{i:0;i:2;}','','a:0:{}','6','','','0','modules/taxonomy/taxonomy.pages.inc'),('taxonomy/term/%/devel','a:1:{i:2;s:18:"taxonomy_term_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_load_object','a:3:{i:0;s:13:"taxonomy_term";i:1;i:2;i:2;s:4:"term";}','','13','4','1','taxonomy/term/%','taxonomy/term/%','Devel','t','','','a:0:{}','132','','','100','sites/all/modules/contrib/devel/devel.pages.inc'),('taxonomy/term/%/devel/load','a:1:{i:2;s:18:"taxonomy_term_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_load_object','a:3:{i:0;s:13:"taxonomy_term";i:1;i:2;i:2;s:4:"term";}','','27','5','1','taxonomy/term/%/devel','taxonomy/term/%','Load','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('taxonomy/term/%/devel/render','a:1:{i:2;s:18:"taxonomy_term_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_render_object','a:3:{i:0;s:13:"taxonomy_term";i:1;i:2;i:2;s:4:"term";}','','27','5','1','taxonomy/term/%/devel','taxonomy/term/%','Render','t','','','a:0:{}','132','','','100','sites/all/modules/contrib/devel/devel.pages.inc'),('taxonomy/term/%/devel/token','a:1:{i:2;s:18:"taxonomy_term_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','token_devel_token_object','a:2:{i:0;s:13:"taxonomy_term";i:1;i:2;}','','27','5','1','taxonomy/term/%/devel','taxonomy/term/%','Tokens','t','','','a:0:{}','132','','','5','sites/all/modules/contrib/token/token.pages.inc');
INSERT INTO `menu_router` VALUES ('taxonomy/term/%/edit','a:1:{i:2;s:18:"taxonomy_term_load";}','','taxonomy_term_edit_access','a:1:{i:0;i:2;}','drupal_get_form','a:3:{i:0;s:18:"taxonomy_form_term";i:1;i:2;i:2;N;}','','13','4','1','taxonomy/term/%','taxonomy/term/%','Edit','t','','','a:0:{}','132','','','10','modules/taxonomy/taxonomy.admin.inc'),('taxonomy/term/%/feed','a:1:{i:2;s:18:"taxonomy_term_load";}','','user_access','a:1:{i:0;s:14:"access content";}','taxonomy_term_feed','a:1:{i:0;i:2;}','','13','4','0','','taxonomy/term/%/feed','Taxonomy term','taxonomy_term_title','a:1:{i:0;i:2;}','','a:0:{}','0','','','0','modules/taxonomy/taxonomy.pages.inc'),('taxonomy/term/%/view','a:1:{i:2;s:18:"taxonomy_term_load";}','','user_access','a:1:{i:0;s:14:"access content";}','taxonomy_term_page','a:1:{i:0;i:2;}','','13','4','1','taxonomy/term/%','taxonomy/term/%','View','t','','','a:0:{}','140','','','0','modules/taxonomy/taxonomy.pages.inc'),('terms_of_use/autocomplete','','','user_access','a:1:{i:0;s:14:"access content";}','terms_of_use_autocomplete','a:0:{}','','3','2','0','','terms_of_use/autocomplete','Autocomplete node title','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/terms_of_use/terms_of_use.admin.inc'),('token/autocomplete/%','a:1:{i:2;s:15:"token_type_load";}','','1','a:0:{}','token_autocomplete_token','a:1:{i:0;i:2;}','','6','3','0','','token/autocomplete/%','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/token/token.pages.inc'),('token/flush-cache','','','user_access','a:1:{i:0;s:12:"flush caches";}','token_flush_cache_callback','a:0:{}','','3','2','0','','token/flush-cache','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/token/token.pages.inc'),('token/tree','','','1','a:0:{}','token_page_output_tree','a:0:{}','','3','2','0','','token/tree','','t','','ajax_base_page_theme','a:0:{}','0','','','0','sites/all/modules/contrib/token/token.pages.inc'),('unclaim/%/prize','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:14:"access content";}','unclaim_prize','a:0:{}','','5','3','0','','unclaim/%/prize','Unclaim Prize','t','','','a:0:{}','6','','','0','');
INSERT INTO `menu_router` VALUES ('user','','','1','a:0:{}','user_page','a:0:{}','','1','1','0','','user','User account','user_menu_title','','','a:0:{}','6','','','-10','modules/user/user.pages.inc'),('user/%','a:1:{i:1;s:9:"user_load";}','','user_view_access','a:1:{i:0;i:1;}','user_view_page','a:1:{i:0;i:1;}','','2','2','0','','user/%','My account','user_page_title','a:1:{i:0;i:1;}','','a:0:{}','6','','','0',''),('user/%/cancel','a:1:{i:1;s:9:"user_load";}','','user_cancel_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:24:"user_cancel_confirm_form";i:1;i:1;}','','5','3','0','','user/%/cancel','Cancel account','t','','','a:0:{}','6','','','0','modules/user/user.pages.inc'),('user/%/cancel/confirm/%/%','a:3:{i:1;s:9:"user_load";i:4;N;i:5;N;}','','user_cancel_access','a:1:{i:0;i:1;}','user_cancel_confirm','a:3:{i:0;i:1;i:1;i:4;i:2;i:5;}','','44','6','0','','user/%/cancel/confirm/%/%','Confirm account cancellation','t','','','a:0:{}','6','','','0','modules/user/user.pages.inc'),('user/%/devel','a:1:{i:1;s:9:"user_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_load_object','a:2:{i:0;s:4:"user";i:1;i:1;}','','5','3','1','user/%','user/%','Devel','t','','','a:0:{}','132','','','100','sites/all/modules/contrib/devel/devel.pages.inc'),('user/%/devel/load','a:1:{i:1;s:9:"user_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_load_object','a:2:{i:0;s:4:"user";i:1;i:1;}','','11','4','1','user/%/devel','user/%','Load','t','','','a:0:{}','140','','','0','sites/all/modules/contrib/devel/devel.pages.inc'),('user/%/devel/render','a:1:{i:1;s:9:"user_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','devel_render_object','a:2:{i:0;s:4:"user";i:1;i:1;}','','11','4','1','user/%/devel','user/%','Render','t','','','a:0:{}','132','','','100','sites/all/modules/contrib/devel/devel.pages.inc'),('user/%/devel/token','a:1:{i:1;s:9:"user_load";}','','user_access','a:1:{i:0;s:24:"access devel information";}','token_devel_token_object','a:2:{i:0;s:4:"user";i:1;i:1;}','','11','4','1','user/%/devel','user/%','Tokens','t','','','a:0:{}','132','','','5','sites/all/modules/contrib/token/token.pages.inc');
INSERT INTO `menu_router` VALUES ('user/%/edit','a:1:{i:1;s:9:"user_load";}','','user_edit_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:17:"user_profile_form";i:1;i:1;}','','5','3','1','user/%','user/%','Edit','t','','','a:0:{}','132','','','0','modules/user/user.pages.inc'),('user/%/edit/account','a:1:{i:1;a:1:{s:18:"user_category_load";a:2:{i:0;s:4:"%map";i:1;s:6:"%index";}}}','','user_edit_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:17:"user_profile_form";i:1;i:1;}','','11','4','1','user/%/edit','user/%','Account','t','','','a:0:{}','140','','','0','modules/user/user.pages.inc'),('user/%/imce','a:1:{i:1;s:9:"user_load";}','','imce_user_page_access','a:1:{i:0;i:1;}','imce_user_page','a:1:{i:0;i:1;}','','5','3','1','user/%','user/%','File browser','t','','','a:0:{}','132','','','10','sites/all/modules/contrib/imce/inc/imce.page.inc'),('user/%/shortcuts','a:1:{i:1;s:9:"user_load";}','','shortcut_set_switch_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:19:"shortcut_set_switch";i:1;i:1;}','','5','3','1','user/%','user/%','Shortcuts','t','','','a:0:{}','132','','','0','modules/shortcut/shortcut.admin.inc'),('user/%/track/navigation','a:1:{i:1;s:9:"user_load";}','','user_access','a:1:{i:0;s:17:"access statistics";}','statistics_user_tracker','a:0:{}','','11','4','1','user/%','user/%','Track page visits','t','','','a:0:{}','132','','','2','modules/statistics/statistics.pages.inc'),('user/%/view','a:1:{i:1;s:9:"user_load";}','','user_view_access','a:1:{i:0;i:1;}','user_view_page','a:1:{i:0;i:1;}','','5','3','1','user/%','user/%','View','t','','','a:0:{}','140','','','-10',''),('user/autocomplete','','','user_access','a:1:{i:0;s:20:"access user profiles";}','user_autocomplete','a:0:{}','','3','2','0','','user/autocomplete','User autocomplete','t','','','a:0:{}','0','','','0','modules/user/user.pages.inc'),('user/login','','','user_is_anonymous','a:0:{}','user_page','a:0:{}','','3','2','1','user','user','Log in','t','','','a:0:{}','140','','','0','modules/user/user.pages.inc'),('user/logout','','','user_is_logged_in','a:0:{}','user_logout','a:0:{}','','3','2','0','','user/logout','Log out','t','','','a:0:{}','6','','','10','modules/user/user.pages.inc');
INSERT INTO `menu_router` VALUES ('user/password','','','1','a:0:{}','drupal_get_form','a:1:{i:0;s:9:"user_pass";}','','3','2','1','user','user','Request new password','t','','','a:0:{}','132','','','0','modules/user/user.pages.inc'),('user/register','','','user_register_access','a:0:{}','drupal_get_form','a:1:{i:0;s:18:"user_register_form";}','','3','2','1','user','user','Create new account','t','','','a:0:{}','132','','','0',''),('user/reset/%/%/%','a:3:{i:2;N;i:3;N;i:4;N;}','','1','a:0:{}','drupal_get_form','a:4:{i:0;s:15:"user_pass_reset";i:1;i:2;i:2;i:3;i:3;i:4;}','','24','5','0','','user/reset/%/%/%','Reset password','t','','','a:0:{}','0','','','0','modules/user/user.pages.inc'),('views/ajax','','','1','a:0:{}','views_ajax','a:0:{}','ajax_deliver','3','2','0','','views/ajax','Views','t','','ajax_base_page_theme','a:0:{}','0','Ajax callback for view loading.','','0','sites/all/modules/contrib/views/includes/ajax.inc'),('workflow_transition/%/edit','a:1:{i:1;s:24:"workflow_transition_load";}','','user_access','a:1:{i:0;s:21:"edit workflow comment";}','entity_ui_get_form','a:2:{i:0;s:18:"WorkflowTransition";i:1;i:1;}','','5','3','0','','workflow_transition/%/edit','Edit workflow log comment','t','','','a:0:{}','6','Edit workflow transition comment.','','0',''),('wysiwyg/%','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:14:"access content";}','wysiwyg_dialog','a:1:{i:0;i:1;}','wysiwyg_deliver_dialog_page','2','2','0','','wysiwyg/%','','t','','','a:0:{}','0','','','0','sites/all/modules/contrib/wysiwyg/wysiwyg.dialog.inc'),('wysiwyg_theme/%','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:14:"access content";}','_wysiwyg_theme_check_active','a:1:{i:0;i:1;}','_wysiwyg_delivery_dummy','2','2','0','','wysiwyg_theme/%','','t','','_wysiwyg_theme_callback','a:1:{i:0;i:1;}','0','','','0','');
DROP TABLE IF EXISTS `node`;
CREATE TABLE `node` (   `nid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a node.',   `vid` int(10) unsigned DEFAULT NULL COMMENT 'The current node_revision.vid version identifier.',   `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The node_type.type of this node.',   `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The languages.language of this node.',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this node, always treated as non-markup plain text.',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that owns this node; initially, this is the user that created it.',   `status` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the node is published (visible to non-administrators).',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was created.',   `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was most recently saved.',   `comment` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this node: 0 = no, 1 = closed (read only), 2 = open (read/write).',   `promote` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node should be displayed on the front page.',   `sticky` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node should be displayed at the top of lists in which it appears.',   `tnid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The translation set id for this node, which equals the node id of the source post in each set.',   `translate` int(11) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this translation page needs to be updated.',   PRIMARY KEY (`nid`),   UNIQUE KEY `vid` (`vid`),   KEY `node_changed` (`changed`),   KEY `node_created` (`created`),   KEY `node_frontpage` (`promote`,`status`,`sticky`,`created`),   KEY `node_status_type` (`status`,`type`,`nid`),   KEY `node_title_type` (`title`,`type`(4)),   KEY `node_type` (`type`(4)),   KEY `uid` (`uid`),   KEY `tnid` (`tnid`),   KEY `translate` (`translate`),   KEY `language` (`language`) ) ENGINE=InnoDB AUTO_INCREMENT=20 DEFAULT CHARSET=utf8 COMMENT='The base table for nodes.' AUTO_INCREMENT=20;
INSERT INTO `node` VALUES ('1','1','page','und','Reading Activity','1','1','1477421813','1477502749','1','0','0','0','0'),('2','2','page','und','All profiles','1','1','1477491877','1477502386','1','0','0','0','0'),('3','3','page','und','Add Profile','1','1','1477492486','1477502520','1','0','0','0','0'),('4','4','page','und','History','1','1','1477492734','1477502766','1','0','0','0','0'),('5','5','page','und','Reading Activity History','1','1','1477493237','1477502793','1','0','0','0','0'),('6','6','page','und','Program History','1','1','1477493433','1477502849','1','0','0','0','0'),('7','7','page','und','Price History','1','1','1477493623','1477502830','1','0','0','0','0'),('8','8','page','und','Point History','1','1','1477493691','1477502814','1','0','0','0','0'),('9','9','page','und','Add Branch','1','1','1477494055','1477494055','1','0','0','0','0'),('10','10','page','und','Add Program','1','1','1477494212','1477503454','1','0','0','0','0'),('11','11','page','und','Add Badge','1','1','1477494378','1477504586','1','0','0','0','0'),('12','12','page','und','Add Prize','1','1','1477494523','1477504618','1','0','0','0','0'),('13','13','page','und','Add Level','1','1','1477495065','1477495065','1','0','0','0','0'),('14','14','page','und','Add Points','1','1','1477495198','1477504790','1','0','0','0','0'),('15','15','page','und','Reader Dashboard','1','1','1477497160','1477497160','1','0','0','0','0'),('16','16','page','und','Readers List','1','1','1477503709','1477504046','1','0','0','0','0'),('17','17','panel','und','all prizes view','1','1','1481039276','1481039276','2','0','0','0','0'),('18','18','page','und','Instructions & Help','1','1','1491538906','1491538906','1','0','0','0','0'),('19','19','article','und','Terms of Use','0','1','1493614693','1493614688','2','1','0','0','0');
DROP TABLE IF EXISTS `node_access`;
CREATE TABLE `node_access` (   `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record affects.',   `gid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The grant ID a user must possess in the specified realm to gain this row’s privileges on the node.',   `realm` varchar(255) NOT NULL DEFAULT '' COMMENT 'The realm in which the user must possess the grant ID. Each node access node can define one or more realms.',   `grant_view` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can view this node.',   `grant_update` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can edit this node.',   `grant_delete` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can delete this node.',   PRIMARY KEY (`nid`,`gid`,`realm`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Identifies which realm/grant pairs a user must possess in...';
INSERT INTO `node_access` VALUES ('1','0','all','1','0','0'),('2','0','all','1','0','0'),('3','0','all','1','0','0'),('4','0','all','1','0','0'),('5','0','all','1','0','0'),('6','0','all','1','0','0'),('7','0','all','1','0','0'),('8','0','all','1','0','0'),('9','0','all','1','0','0'),('10','0','all','1','0','0'),('11','0','all','1','0','0'),('12','0','all','1','0','0'),('13','0','all','1','0','0'),('14','0','all','1','0','0'),('15','0','all','1','0','0'),('16','0','all','1','0','0'),('17','0','all','1','0','0'),('18','0','all','1','0','0'),('19','0','all','1','0','0');
DROP TABLE IF EXISTS `node_comment_statistics`;
CREATE TABLE `node_comment_statistics` (   `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid for which the statistics are compiled.',   `cid` int(11) NOT NULL DEFAULT '0' COMMENT 'The comment.cid of the last comment.',   `last_comment_timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of the last comment that was posted within this node, from comment.changed.',   `last_comment_name` varchar(60) DEFAULT NULL COMMENT 'The name of the latest author to post a comment on this node, from comment.name.',   `last_comment_uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The user ID of the latest author to post a comment on this node, from comment.uid.',   `comment_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The total number of comments on this node.',   PRIMARY KEY (`nid`),   KEY `node_comment_timestamp` (`last_comment_timestamp`),   KEY `comment_count` (`comment_count`),   KEY `last_comment_uid` (`last_comment_uid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maintains statistics of node and comments posts to show ...';
INSERT INTO `node_comment_statistics` VALUES ('1','0','1477421813',null,'1','0'),('2','0','1477491877',null,'1','0'),('3','0','1477492486',null,'1','0'),('4','0','1477492734',null,'1','0'),('5','0','1477493237',null,'1','0'),('6','0','1477493433',null,'1','0'),('7','0','1477493623',null,'1','0'),('8','0','1477493691',null,'1','0'),('9','0','1477494055',null,'1','0'),('10','0','1477494212',null,'1','0'),('11','0','1477494378',null,'1','0'),('12','0','1477494523',null,'1','0'),('13','0','1477495065',null,'1','0'),('14','0','1477495198',null,'1','0'),('15','0','1477497160',null,'1','0'),('16','0','1477503709',null,'1','0'),('17','0','1481039276',null,'1','0'),('18','0','1491538906',null,'1','0'),('19','0','1493614688',null,'0','0');
DROP TABLE IF EXISTS `node_counter`;
CREATE TABLE `node_counter` (   `nid` int(11) NOT NULL DEFAULT '0' COMMENT 'The node.nid for these statistics.',   `totalcount` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'The total number of times the node has been viewed.',   `daycount` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT 'The total number of times the node has been viewed today.',   `timestamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The most recent time the node has been viewed.',   PRIMARY KEY (`nid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Access statistics for nodes.';
INSERT INTO `node_counter` VALUES ('5','8','0','1492836649'),('18','224','0','1493442481'),('47','2','0','1492655371'),('50','1','0','1492007514'),('52','1','0','1492037455'),('77','1','0','1492140237'),('84','1','0','1491986710'),('143','1','0','1492004798'),('145','1','0','1492479485'),('283','1','0','1491990375');
DROP TABLE IF EXISTS `node_revision`;
CREATE TABLE `node_revision` (   `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node this version belongs to.',   `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for this version.',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that created this version.',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this version.',   `log` longtext NOT NULL COMMENT 'The log entry explaining the changes in this version.',   `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when this version was created.',   `status` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the node (at the time of this revision) is published (visible to non-administrators).',   `comment` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this node (at the time of this revision): 0 = no, 1 = closed (read only), 2 = open (read/write).',   `promote` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node (at the time of this revision) should be displayed on the front page.',   `sticky` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node (at the time of this revision) should be displayed at the top of lists in which it appears.',   PRIMARY KEY (`vid`),   KEY `nid` (`nid`),   KEY `uid` (`uid`) ) ENGINE=InnoDB AUTO_INCREMENT=20 DEFAULT CHARSET=utf8 COMMENT='Stores information about each saved version of a node.' AUTO_INCREMENT=20;
INSERT INTO `node_revision` VALUES ('1','1','1','Reading Activity','','1477502749','1','1','0','0'),('2','2','1','All profiles','','1477502386','1','1','0','0'),('3','3','1','Add Profile','','1477502520','1','1','0','0'),('4','4','1','History','','1477502766','1','1','0','0'),('5','5','1','Reading Activity History','','1477502793','1','1','0','0'),('6','6','1','Program History','','1477502849','1','1','0','0'),('7','7','1','Price History','','1477502830','1','1','0','0'),('8','8','1','Point History','','1477502814','1','1','0','0'),('9','9','1','Add Branch','','1477494055','1','1','0','0'),('10','10','1','Add Program','','1477503454','1','1','0','0'),('11','11','1','Add Badge','','1477504586','1','1','0','0'),('12','12','1','Add Prize','','1477504618','1','1','0','0'),('13','13','1','Add Level','','1477495065','1','1','0','0'),('14','14','1','Add Points','','1477504790','1','1','0','0'),('15','15','1','Reader Dashboard','','1477497160','1','1','0','0'),('16','16','1','Readers List','','1477504046','1','1','0','0'),('17','17','1','all prizes view','','1481039276','1','2','0','0'),('18','18','1','Instructions & Help','','1491538906','1','1','0','0'),('19','19','0','Terms of Use','Created by FeedsNodeProcessor','1493614688','1','2','1','0');
DROP TABLE IF EXISTS `node_type`;
CREATE TABLE `node_type` (   `type` varchar(32) NOT NULL COMMENT 'The machine-readable name of this type.',   `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The human-readable name of this type.',   `base` varchar(255) NOT NULL COMMENT 'The base string used to construct callbacks corresponding to this node type.',   `module` varchar(255) NOT NULL COMMENT 'The module defining this node type.',   `description` mediumtext NOT NULL COMMENT 'A brief description of this type.',   `help` mediumtext NOT NULL COMMENT 'Help information shown to the user when creating a node of this type.',   `has_title` tinyint(3) unsigned NOT NULL COMMENT 'Boolean indicating whether this type uses the node.title field.',   `title_label` varchar(255) NOT NULL DEFAULT '' COMMENT 'The label displayed for the title field on the edit form.',   `custom` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this type is defined by a module (FALSE) or by a user via Add content type (TRUE).',   `modified` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this type has been modified by an administrator; currently not used in any way.',   `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether the administrator can change the machine name of this type.',   `disabled` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether the node type is disabled.',   `orig_type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The original machine-readable name of this node type. This may be different from the current type name if the locked field is 0.',   PRIMARY KEY (`type`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about all defined node types.';
INSERT INTO `node_type` VALUES ('article','Article','node_content','node','Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.','','1','Title','1','1','0','0','article'),('book_list','Book List','node_content','booklist','A book list is a collection of books that can be displayed in a variety of formats.','','1','Title','0','0','1','0','book_list'),('customformfields','CustomFormFields','node_content','node','','','1','Title','1','1','0','0','customformfields'),('event','Event','node_content','bookpoints_events','A date content type that is linked to a Views calendar.','','1','Title','0','0','1','0','event'),('page','Basic page','node_content','node','Use <em>basic pages</em> for your static content, such as an ''About us'' page.','','1','Title','1','1','0','0','page'),('panel','Panel','panels_node_hook','panels_node','A panel layout broken up into rows and columns.','','1','Title','0','0','1','0','panel');
DROP TABLE IF EXISTS `page_manager_handlers`;
CREATE TABLE `page_manager_handlers` (   `did` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary ID field for the table. Not used for anything except internal lookups.',   `name` varchar(255) DEFAULT NULL COMMENT 'Unique ID for this task handler. Used to identify it programmatically.',   `task` varchar(64) DEFAULT NULL COMMENT 'ID of the task this handler is for.',   `subtask` varchar(64) NOT NULL DEFAULT '' COMMENT 'ID of the subtask this handler is for.',   `handler` varchar(64) DEFAULT NULL COMMENT 'ID of the task handler being used.',   `weight` int(11) DEFAULT NULL COMMENT 'The order in which this handler appears. Lower numbers go first.',   `conf` longtext NOT NULL COMMENT 'Serialized configuration of the handler, if needed.',   PRIMARY KEY (`did`),   UNIQUE KEY `name` (`name`),   KEY `fulltask` (`task`,`subtask`,`weight`) ) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8 AUTO_INCREMENT=6;
INSERT INTO `page_manager_handlers` VALUES ('1','page_all_users__panel','page','all_users','panel_context','0','a:11:{s:5:"title";s:5:"Panel";s:9:"no_blocks";i:0;s:8:"pipeline";s:8:"standard";s:22:"body_classes_to_remove";s:0:"";s:19:"body_classes_to_add";s:0:"";s:6:"css_id";s:0:"";s:3:"css";s:0:"";s:8:"contexts";a:0:{}s:13:"relationships";a:0:{}s:4:"name";s:5:"panel";s:3:"did";s:1:"2";}'),('2','page_reader_dashboard__panel','page','reader_dashboard','panel_context','0','a:11:{s:5:"title";s:5:"Panel";s:9:"no_blocks";i:0;s:8:"pipeline";s:8:"standard";s:22:"body_classes_to_remove";s:0:"";s:19:"body_classes_to_add";s:0:"";s:6:"css_id";s:16:"reader-dashboard";s:3:"css";s:0:"";s:8:"contexts";a:0:{}s:13:"relationships";a:0:{}s:4:"name";s:5:"panel";s:3:"did";s:1:"3";}'),('3','page_home__panel','page','home','panel_context','0','a:12:{s:5:"title";s:4:"Anon";s:9:"no_blocks";i:0;s:8:"pipeline";s:8:"standard";s:22:"body_classes_to_remove";s:0:"";s:19:"body_classes_to_add";s:0:"";s:6:"css_id";s:0:"";s:3:"css";s:0:"";s:8:"contexts";a:0:{}s:13:"relationships";a:0:{}s:4:"name";s:5:"panel";s:6:"access";a:1:{s:5:"logic";s:3:"and";}s:3:"did";s:1:"4";}'),('4','page_home__panel_context_102235d3-2bab-4a99-81c7-8ccd6657a29d','page','home','panel_context','-1','a:12:{s:5:"title";s:8:"Lib Dash";s:9:"no_blocks";i:0;s:8:"pipeline";s:8:"standard";s:22:"body_classes_to_remove";s:0:"";s:19:"body_classes_to_add";s:0:"";s:6:"css_id";s:0:"";s:3:"css";s:0:"";s:8:"contexts";a:0:{}s:13:"relationships";a:0:{}s:4:"name";s:0:"";s:6:"access";a:2:{s:7:"plugins";a:1:{i:0;a:4:{s:4:"name";s:4:"role";s:8:"settings";a:1:{s:4:"rids";a:2:{i:0;i:3;i:1;i:5;}}s:7:"context";s:14:"logged-in-user";s:3:"not";b:0;}}s:5:"logic";s:3:"and";}s:3:"did";s:1:"5";}'),('5','page-home__reader_redirect','page','home','http_response','0','a:7:{s:5:"title";s:15:"Reader Redirect";s:8:"contexts";a:0:{}s:13:"relationships";a:0:{}s:4:"code";s:3:"301";s:11:"destination";s:16:"reader-dashboard";s:4:"name";s:15:"reader_redirect";s:6:"access";a:2:{s:7:"plugins";a:1:{i:0;a:4:{s:4:"name";s:4:"role";s:8:"settings";a:1:{s:4:"rids";a:1:{i:0;i:4;}}s:7:"context";s:14:"logged-in-user";s:3:"not";b:0;}}s:5:"logic";s:3:"and";}}');
DROP TABLE IF EXISTS `page_manager_pages`;
CREATE TABLE `page_manager_pages` (   `pid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary ID field for the table. Not used for anything except internal lookups.',   `name` varchar(255) DEFAULT NULL COMMENT 'Unique ID for this subtask. Used to identify it programmatically.',   `task` varchar(64) DEFAULT 'page' COMMENT 'What type of page this is, so that we can use the same mechanism for creating tighter UIs for targeted pages.',   `admin_title` varchar(255) DEFAULT NULL COMMENT 'Human readable title for this page subtask.',   `admin_description` longtext COMMENT 'Administrative description of this item.',   `path` varchar(255) DEFAULT NULL COMMENT 'The menu path that will invoke this task.',   `access` longtext NOT NULL COMMENT 'Access configuration for this path.',   `menu` longtext NOT NULL COMMENT 'Serialized configuration of Drupal menu visibility settings for this item.',   `arguments` longtext NOT NULL COMMENT 'Configuration of arguments for this menu item.',   `conf` longtext NOT NULL COMMENT 'Serialized configuration of the page, if needed.',   PRIMARY KEY (`pid`),   UNIQUE KEY `name` (`name`),   KEY `task` (`task`) ) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='Contains page subtasks for implementing pages with...' AUTO_INCREMENT=4;
INSERT INTO `page_manager_pages` VALUES ('1','all_users','page','All Users','','library/dashboard/all_users','a:0:{}','a:0:{}','a:0:{}','a:1:{s:11:"admin_paths";b:0;}'),('2','reader_dashboard','page','Reader Dashboard','','reader-dashboard','a:2:{s:7:"plugins";a:1:{i:0;a:4:{s:4:"name";s:4:"role";s:8:"settings";a:1:{s:4:"rids";a:1:{i:0;i:2;}}s:7:"context";s:14:"logged-in-user";s:3:"not";b:0;}}s:5:"logic";s:3:"and";}','a:0:{}','a:0:{}','a:1:{s:11:"admin_paths";b:0;}'),('3','home','page','Home Page','This is the home page of the site for anonymous users.','home','a:2:{s:7:"plugins";a:0:{}s:5:"logic";s:3:"and";}','a:0:{}','a:0:{}','a:1:{s:11:"admin_paths";b:0;}');
DROP TABLE IF EXISTS `page_manager_weights`;
CREATE TABLE `page_manager_weights` (   `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Unique ID for this task handler. Used to identify it programmatically.',   `weight` int(11) DEFAULT NULL COMMENT 'The order in which this handler appears. Lower numbers go first.',   PRIMARY KEY (`name`),   KEY `weights` (`name`,`weight`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Contains override weights for page_manager handlers that...';
INSERT INTO `page_manager_weights` VALUES ('page-home__reader_redirect','-2'),('page_home__panel','0');
DROP TABLE IF EXISTS `panels_allowed_types`;
CREATE TABLE `panels_allowed_types` (   `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the module requiring allowed type settings.',   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'Ctools content type to allow.',   `allowed` tinyint(4) DEFAULT '1' COMMENT 'A boolean for if the type is allowed or not.',   KEY `type_idx` (`type`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `panels_display`;
CREATE TABLE `panels_display` (   `did` int(11) NOT NULL AUTO_INCREMENT,   `layout` varchar(255) DEFAULT '',   `layout_settings` longtext,   `panel_settings` longtext,   `cache` text,   `title` varchar(255) DEFAULT '',   `hide_title` tinyint(4) DEFAULT '0',   `title_pane` int(11) DEFAULT '0',   `uuid` char(36) DEFAULT NULL,   `storage_type` varchar(255) DEFAULT '',   `storage_id` varchar(255) DEFAULT '',   PRIMARY KEY (`did`) ) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8 AUTO_INCREMENT=6;
INSERT INTO `panels_display` VALUES ('1','three_inset_left','a:0:{}','a:1:{s:14:"style_settings";a:6:{s:7:"default";N;s:24:"three_inset_left_sidebar";N;s:20:"three_inset_left_top";N;s:23:"three_inset_left_middle";N;s:22:"three_inset_left_inset";N;s:23:"three_inset_left_bottom";N;}}','a:0:{}','','0','0','612e8196-6082-4a86-95c1-339bbed631aa','panels_node','17'),('2','one','a:0:{}','a:1:{s:14:"style_settings";a:2:{s:7:"default";N;s:8:"one_main";N;}}','a:0:{}','','0','1','a870ba86-798f-4838-b053-b2b91f99cd50','page_manager','page_all_users__panel'),('3','three_3x33','a:0:{}','a:1:{s:14:"style_settings";a:6:{s:7:"default";N;s:12:"three_33_top";N;s:14:"three_33_first";N;s:15:"three_33_second";N;s:14:"three_33_third";N;s:15:"three_33_bottom";N;}}','a:0:{}','','0','0','278ef641-01df-444b-8012-f12d72b8edd1','page_manager','page_reader_dashboard__panel'),('4','three_3x33','a:0:{}','a:1:{s:14:"style_settings";a:10:{s:7:"default";N;s:13:"two_33_66_top";N;s:15:"two_33_66_first";N;s:16:"two_33_66_second";N;s:16:"two_33_66_bottom";N;s:12:"three_33_top";N;s:14:"three_33_first";N;s:15:"three_33_second";N;s:14:"three_33_third";N;s:15:"three_33_bottom";N;}}','a:0:{}','','1','7','d3c9e21b-b0f3-46a4-a088-b713c9c4e379','page_manager','page_home__panel'),('5','two_50','a:0:{}','a:1:{s:14:"style_settings";a:5:{s:7:"default";N;s:10:"two_50_top";N;s:12:"two_50_first";N;s:13:"two_50_second";N;s:13:"two_50_bottom";N;}}','a:0:{}','Library Dashboard','0','0','cf99f9b6-22e5-42a6-91dc-1a7734db5dd7','page_manager','page_home__panel_context_102235d3-2bab-4a99-81c7-8ccd6657a29d');
DROP TABLE IF EXISTS `panels_layout`;
CREATE TABLE `panels_layout` (   `lid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'A database primary key to ensure uniqueness.',   `name` varchar(255) DEFAULT NULL COMMENT 'Unique ID for this content. Used to identify it programmatically.',   `admin_title` varchar(255) DEFAULT NULL COMMENT 'Administrative title for this layout.',   `admin_description` longtext COMMENT 'Administrative description for this layout.',   `category` varchar(255) DEFAULT NULL COMMENT 'Administrative category for this layout.',   `plugin` varchar(255) DEFAULT NULL COMMENT 'The layout plugin that owns this layout.',   `settings` longtext COMMENT 'Serialized settings for the actual layout. The contents of this field are up to the plugin that uses it.',   PRIMARY KEY (`lid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Contains exportable customized layouts for this site.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `panels_mini`;
CREATE TABLE `panels_mini` (   `pid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary key for uniqueness.',   `name` varchar(255) DEFAULT NULL COMMENT 'The unique name of the mini panel.',   `category` varchar(64) DEFAULT NULL COMMENT 'The category this mini panel appears in on the add content pane.',   `did` int(11) DEFAULT NULL COMMENT 'The display ID of the panel.',   `admin_title` varchar(128) DEFAULT NULL COMMENT 'The administrative title of the mini panel.',   `admin_description` longtext COMMENT 'Administrative title of this mini panel.',   `requiredcontexts` longtext COMMENT 'An array of required contexts.',   `contexts` longtext COMMENT 'An array of contexts embedded into the panel.',   `relationships` longtext COMMENT 'An array of relationships embedded into the panel.',   PRIMARY KEY (`pid`),   UNIQUE KEY `name` (`name`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `panels_node`;
CREATE TABLE `panels_node` (   `nid` int(11) NOT NULL DEFAULT '0',   `css_id` varchar(255) DEFAULT NULL,   `did` int(11) NOT NULL,   `pipeline` varchar(255) DEFAULT NULL,   PRIMARY KEY (`did`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
INSERT INTO `panels_node` VALUES ('17','','1','standard');
DROP TABLE IF EXISTS `panels_pane`;
CREATE TABLE `panels_pane` (   `pid` int(11) NOT NULL AUTO_INCREMENT,   `did` int(11) NOT NULL DEFAULT '0',   `panel` varchar(255) DEFAULT '',   `type` varchar(255) DEFAULT '',   `subtype` varchar(255) DEFAULT '',   `shown` tinyint(4) DEFAULT '1',   `access` longtext,   `configuration` longtext,   `cache` longtext,   `style` longtext,   `css` longtext,   `extras` longtext,   `position` smallint(6) DEFAULT '0',   `locks` longtext,   `uuid` char(36) DEFAULT NULL,   PRIMARY KEY (`pid`),   KEY `did_idx` (`did`) ) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8 AUTO_INCREMENT=12;
INSERT INTO `panels_pane` VALUES ('1','2','one_main','views','user_search','1','a:0:{}','a:15:{s:23:"override_pager_settings";i:0;s:9:"use_pager";i:0;s:14:"nodes_per_page";s:1:"5";s:8:"pager_id";s:1:"0";s:6:"offset";s:1:"0";s:9:"more_link";i:0;s:10:"feed_icons";i:0;s:10:"panel_args";i:0;s:12:"link_to_view";i:0;s:4:"args";s:2:"%2";s:3:"url";s:0:"";s:7:"display";s:5:"block";s:14:"override_title";i:0;s:19:"override_title_text";s:0:"";s:22:"override_title_heading";s:2:"h2";}','a:0:{}','a:1:{s:8:"settings";N;}','a:0:{}','a:0:{}','0','a:0:{}','8c4d2635-fcb0-4e5c-9383-f46cd0b1a957'),('2','3','three_33_first','block','block-2','1','a:0:{}','a:3:{s:14:"override_title";i:1;s:19:"override_title_text";s:21:"Reader Dashboard Left";s:22:"override_title_heading";s:2:"h2";}','a:0:{}','a:2:{s:8:"settings";N;s:5:"style";s:5:"block";}','a:0:{}','a:0:{}','0','a:0:{}','0c46589d-61cb-4344-8a8f-2ff4aabe9004'),('3','3','three_33_second','block','block-3','1','a:0:{}','a:3:{s:14:"override_title";i:1;s:19:"override_title_text";s:12:"Middle Panel";s:22:"override_title_heading";s:2:"h2";}','a:0:{}','a:2:{s:8:"settings";N;s:5:"style";s:5:"block";}','a:0:{}','a:0:{}','0','a:0:{}','9e3ec9f4-0b08-458b-b23c-68f72e8e113d'),('4','3','three_33_third','block','block-4','1','a:0:{}','a:3:{s:14:"override_title";i:1;s:19:"override_title_text";s:11:"Right Panel";s:22:"override_title_heading";s:2:"h2";}','a:0:{}','a:2:{s:8:"settings";N;s:5:"style";s:5:"block";}','a:0:{}','a:0:{}','0','a:0:{}','d7b0b221-6571-4a8f-966b-e87f9273a728'),('5','3','three_33_top','block','block-5','1','a:1:{s:7:"plugins";a:1:{i:0;a:3:{s:4:"name";s:3:"php";s:8:"settings";a:2:{s:11:"description";s:6:"Nag Me";s:3:"php";s:719:"global $user;\n\n$current_user=$user->uid;\n\n$user_details=galecia_reader_dashboard_check_registration($current_user);\n\n$nag_me=FALSE;\n\nforeach ($user_details as $key => $value) {\n \n    $current_reader=$user_details[$key];\n\n    $prizes=entity_load(''reader_prize'', FALSE);\n\n    $readers_prizes=array();\n\n    foreach($prizes as $key=>$value) {\n        if ($value->field_readers[''und''][0][''target_id''] == $current_reader) {\n\n            $readers_prizes[]=$value;\n\n        }   \n\n   }\n}\n\nif(!empty($readers_prizes)) {\n\nforeach ($readers_prizes as $key => $value){\n\n        if($value->field_status[''und''][0][''value''] == ''Unclaimed'') {\n        $nag_me=TRUE;\n        }\n\n    }\n\n}\n\n    if($nag_me==TRUE) {\n\n       return TRUE;\n    }";}s:3:"not";b:0;}}}','a:3:{s:14:"override_title";i:1;s:19:"override_title_text";s:0:"";s:22:"override_title_heading";s:2:"h2";}','a:0:{}','a:2:{s:8:"settings";N;s:5:"style";s:5:"block";}','a:0:{}','a:0:{}','0','a:0:{}','622f49ce-4ab7-449e-a70c-c6b459966eea');
INSERT INTO `panels_pane` VALUES ('6','3','three_33_bottom','block','block-6','1','a:0:{}','a:3:{s:14:"override_title";i:1;s:19:"override_title_text";s:0:"";s:22:"override_title_heading";s:2:"h2";}','a:0:{}','a:2:{s:8:"settings";N;s:5:"style";s:5:"block";}','a:0:{}','a:0:{}','0','a:0:{}','96dc79ea-5931-4a43-a6bd-c6f14dd90731'),('7','4','three_33_second','page_site_name','page_site_name','1','a:0:{}','a:4:{s:6:"linked";i:0;s:14:"override_title";i:1;s:19:"override_title_text";s:17:"Welcome to %title";s:22:"override_title_heading";s:2:"h2";}','a:0:{}','a:1:{s:8:"settings";N;}','a:0:{}','a:0:{}','0','a:0:{}','73516fa8-182d-4be3-b424-f6300e1abb70'),('8','4','three_33_third','block','block-7','1','a:0:{}','a:3:{s:14:"override_title";i:1;s:19:"override_title_text";s:0:"";s:22:"override_title_heading";s:2:"h2";}','a:0:{}','a:1:{s:8:"settings";N;}','a:0:{}','a:0:{}','0','a:0:{}','c837398f-ecab-4073-9719-c528fae10bb9'),('9','4','three_33_second','block','block-1','1','a:0:{}','a:3:{s:14:"override_title";i:1;s:19:"override_title_text";s:0:"";s:22:"override_title_heading";s:2:"h2";}','a:0:{}','a:1:{s:8:"settings";N;}','a:0:{}','a:0:{}','1','a:0:{}','e690b014-f36d-407d-b20e-17c5849da014'),('10','4','three_33_first','block','user-login','1','a:0:{}','a:3:{s:14:"override_title";i:0;s:19:"override_title_text";s:0:"";s:22:"override_title_heading";s:2:"h2";}','a:0:{}','a:1:{s:8:"settings";N;}','a:0:{}','a:0:{}','0','a:0:{}','7c13ee87-9f08-4d55-8a9e-c2c8a54eb482'),('11','5','two_50_first','views','program_dashboard','1','a:0:{}','a:15:{s:23:"override_pager_settings";i:0;s:9:"use_pager";i:1;s:14:"nodes_per_page";s:2:"10";s:8:"pager_id";s:1:"0";s:6:"offset";s:1:"0";s:9:"more_link";i:0;s:10:"feed_icons";i:0;s:10:"panel_args";i:0;s:12:"link_to_view";i:0;s:4:"args";s:0:"";s:3:"url";s:0:"";s:7:"display";s:7:"default";s:14:"override_title";i:0;s:19:"override_title_text";s:0:"";s:22:"override_title_heading";s:2:"h2";}','a:0:{}','a:1:{s:8:"settings";N;}','a:0:{}','a:0:{}','0','a:0:{}','88299557-289f-406f-9bc7-c7dd7003c317');
DROP TABLE IF EXISTS `panels_renderer_pipeline`;
CREATE TABLE `panels_renderer_pipeline` (   `rpid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'A database primary key to ensure uniqueness.',   `name` varchar(255) DEFAULT NULL COMMENT 'Unique ID for this content. Used to identify it programmatically.',   `admin_title` varchar(255) DEFAULT NULL COMMENT 'Administrative title for this pipeline.',   `admin_description` longtext COMMENT 'Administrative description for this pipeline.',   `weight` smallint(6) DEFAULT '0',   `settings` longtext COMMENT 'Serialized settings for the actual pipeline. The contents of this field are up to the plugin that uses it.',   PRIMARY KEY (`rpid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Contains renderer pipelines for Panels. Each pipeline...' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `pathauto_state`;
CREATE TABLE `pathauto_state` (   `entity_type` varchar(32) NOT NULL COMMENT 'An entity type.',   `entity_id` int(10) unsigned NOT NULL COMMENT 'An entity ID.',   `pathauto` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The automatic alias status of the entity.',   PRIMARY KEY (`entity_type`,`entity_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='The status of each entity alias (whether it was...';
INSERT INTO `pathauto_state` VALUES ('node','1','0'),('node','2','0'),('node','3','0'),('node','4','0'),('node','5','0'),('node','6','0'),('node','7','0'),('node','8','0'),('node','9','0'),('node','10','0'),('node','11','0'),('node','12','0'),('node','13','0'),('node','14','0'),('node','15','1'),('node','16','0'),('node','17','0'),('node','18','0'),('taxonomy_term','1','1'),('taxonomy_term','2','1'),('taxonomy_term','3','1'),('taxonomy_term','4','1'),('taxonomy_term','9','1'),('taxonomy_term','11','1');
DROP TABLE IF EXISTS `queue`;
CREATE TABLE `queue` (   `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique item ID.',   `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The queue name.',   `data` longblob COMMENT 'The arbitrary data for the item.',   `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the claim lease expires on the item.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the item was created.',   PRIMARY KEY (`item_id`),   KEY `name_created` (`name`,`created`),   KEY `expire` (`expire`) ) ENGINE=InnoDB AUTO_INCREMENT=3463 DEFAULT CHARSET=utf8 COMMENT='Stores items in queues.' AUTO_INCREMENT=3463;
INSERT INTO `queue` VALUES ('3459','smtp_send_queue','a:11:{s:2:"id";s:14:"smtp_smtp-test";s:6:"module";s:4:"smtp";s:3:"key";s:9:"smtp-test";s:2:"to";s:16:"craner@gmail.com";s:4:"from";s:28:"no-reply@readingbydesign.org";s:8:"language";O:8:"stdClass":11:{s:8:"language";s:2:"en";s:4:"name";s:7:"English";s:6:"native";s:7:"English";s:9:"direction";i:0;s:7:"enabled";i:1;s:7:"plurals";i:0;s:7:"formula";s:0:"";s:6:"domain";s:0:"";s:6:"prefix";s:0:"";s:6:"weight";i:0;s:10:"javascript";s:0:"";}s:6:"params";a:2:{s:7:"subject";s:23:"Drupal SMTP test e-mail";s:4:"body";a:1:{i:0;s:87:"If you receive this message it means your site is capable of using SMTP to send e-mail.";}}s:4:"send";b:1;s:7:"subject";s:23:"Drupal SMTP test e-mail";s:4:"body";s:88:"If you receive this message it means your site is capable of using SMTP to\nsend e-mail.\n";s:7:"headers";a:7:{s:12:"MIME-Version";s:3:"1.0";s:12:"Content-Type";s:51:"text/plain; charset=UTF-8; format=flowed; delsp=yes";s:25:"Content-Transfer-Encoding";s:4:"8Bit";s:8:"X-Mailer";s:6:"Drupal";s:11:"Return-Path";s:28:"no-reply@readingbydesign.org";s:6:"Sender";s:28:"no-reply@readingbydesign.org";s:4:"From";s:28:"no-reply@readingbydesign.org";}}','0','1493657315'),('3460','smtp_send_queue','a:11:{s:2:"id";s:14:"smtp_smtp-test";s:6:"module";s:4:"smtp";s:3:"key";s:9:"smtp-test";s:2:"to";s:15:"jim@galecia.com";s:4:"from";s:28:"no-reply@readingbydesign.org";s:8:"language";O:8:"stdClass":11:{s:8:"language";s:2:"en";s:4:"name";s:7:"English";s:6:"native";s:7:"English";s:9:"direction";i:0;s:7:"enabled";i:1;s:7:"plurals";i:0;s:7:"formula";s:0:"";s:6:"domain";s:0:"";s:6:"prefix";s:0:"";s:6:"weight";i:0;s:10:"javascript";s:0:"";}s:6:"params";a:2:{s:7:"subject";s:23:"Drupal SMTP test e-mail";s:4:"body";a:1:{i:0;s:87:"If you receive this message it means your site is capable of using SMTP to send e-mail.";}}s:4:"send";b:1;s:7:"subject";s:23:"Drupal SMTP test e-mail";s:4:"body";s:88:"If you receive this message it means your site is capable of using SMTP to\nsend e-mail.\n";s:7:"headers";a:7:{s:12:"MIME-Version";s:3:"1.0";s:12:"Content-Type";s:51:"text/plain; charset=UTF-8; format=flowed; delsp=yes";s:25:"Content-Transfer-Encoding";s:4:"8Bit";s:8:"X-Mailer";s:6:"Drupal";s:11:"Return-Path";s:28:"no-reply@readingbydesign.org";s:6:"Sender";s:28:"no-reply@readingbydesign.org";s:4:"From";s:28:"no-reply@readingbydesign.org";}}','0','1493657315');
INSERT INTO `queue` VALUES ('3461','smtp_send_queue','a:11:{s:2:"id";s:14:"smtp_smtp-test";s:6:"module";s:4:"smtp";s:3:"key";s:9:"smtp-test";s:2:"to";s:15:"jim@galecia.com";s:4:"from";s:28:"no-reply@readingbydesign.org";s:8:"language";O:8:"stdClass":11:{s:8:"language";s:2:"en";s:4:"name";s:7:"English";s:6:"native";s:7:"English";s:9:"direction";i:0;s:7:"enabled";i:1;s:7:"plurals";i:0;s:7:"formula";s:0:"";s:6:"domain";s:0:"";s:6:"prefix";s:0:"";s:6:"weight";i:0;s:10:"javascript";s:0:"";}s:6:"params";a:2:{s:7:"subject";s:23:"Drupal SMTP test e-mail";s:4:"body";a:1:{i:0;s:87:"If you receive this message it means your site is capable of using SMTP to send e-mail.";}}s:4:"send";b:1;s:7:"subject";s:23:"Drupal SMTP test e-mail";s:4:"body";s:88:"If you receive this message it means your site is capable of using SMTP to\nsend e-mail.\n";s:7:"headers";a:7:{s:12:"MIME-Version";s:3:"1.0";s:12:"Content-Type";s:51:"text/plain; charset=UTF-8; format=flowed; delsp=yes";s:25:"Content-Transfer-Encoding";s:4:"8Bit";s:8:"X-Mailer";s:6:"Drupal";s:11:"Return-Path";s:28:"no-reply@readingbydesign.org";s:6:"Sender";s:28:"no-reply@readingbydesign.org";s:4:"From";s:28:"no-reply@readingbydesign.org";}}','0','1493657315'),('3462','smtp_send_queue','a:11:{s:2:"id";s:14:"smtp_smtp-test";s:6:"module";s:4:"smtp";s:3:"key";s:9:"smtp-test";s:2:"to";s:15:"jim@galecia.com";s:4:"from";s:28:"no-reply@readingbydesign.org";s:8:"language";O:8:"stdClass":11:{s:8:"language";s:2:"en";s:4:"name";s:7:"English";s:6:"native";s:7:"English";s:9:"direction";i:0;s:7:"enabled";i:1;s:7:"plurals";i:0;s:7:"formula";s:0:"";s:6:"domain";s:0:"";s:6:"prefix";s:0:"";s:6:"weight";i:0;s:10:"javascript";s:0:"";}s:6:"params";a:2:{s:7:"subject";s:23:"Drupal SMTP test e-mail";s:4:"body";a:1:{i:0;s:87:"If you receive this message it means your site is capable of using SMTP to send e-mail.";}}s:4:"send";b:1;s:7:"subject";s:23:"Drupal SMTP test e-mail";s:4:"body";s:88:"If you receive this message it means your site is capable of using SMTP to\nsend e-mail.\n";s:7:"headers";a:7:{s:12:"MIME-Version";s:3:"1.0";s:12:"Content-Type";s:51:"text/plain; charset=UTF-8; format=flowed; delsp=yes";s:25:"Content-Transfer-Encoding";s:4:"8Bit";s:8:"X-Mailer";s:6:"Drupal";s:11:"Return-Path";s:28:"no-reply@readingbydesign.org";s:6:"Sender";s:28:"no-reply@readingbydesign.org";s:4:"From";s:28:"no-reply@readingbydesign.org";}}','0','1493657315');
DROP TABLE IF EXISTS `rdf_mapping`;
CREATE TABLE `rdf_mapping` (   `type` varchar(128) NOT NULL COMMENT 'The name of the entity type a mapping applies to (node, user, comment, etc.).',   `bundle` varchar(128) NOT NULL COMMENT 'The name of the bundle a mapping applies to.',   `mapping` longblob COMMENT 'The serialized mapping of the bundle type and fields to RDF terms.',   PRIMARY KEY (`type`,`bundle`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores custom RDF mappings for user defined content types...';
INSERT INTO `rdf_mapping` VALUES ('node','article','a:11:{s:11:"field_image";a:2:{s:10:"predicates";a:2:{i:0;s:8:"og:image";i:1;s:12:"rdfs:seeAlso";}s:4:"type";s:3:"rel";}s:10:"field_tags";a:2:{s:10:"predicates";a:1:{i:0;s:10:"dc:subject";}s:4:"type";s:3:"rel";}s:7:"rdftype";a:2:{i:0;s:9:"sioc:Item";i:1;s:13:"foaf:Document";}s:5:"title";a:1:{s:10:"predicates";a:1:{i:0;s:8:"dc:title";}}s:7:"created";a:3:{s:10:"predicates";a:2:{i:0;s:7:"dc:date";i:1;s:10:"dc:created";}s:8:"datatype";s:12:"xsd:dateTime";s:8:"callback";s:12:"date_iso8601";}s:7:"changed";a:3:{s:10:"predicates";a:1:{i:0;s:11:"dc:modified";}s:8:"datatype";s:12:"xsd:dateTime";s:8:"callback";s:12:"date_iso8601";}s:4:"body";a:1:{s:10:"predicates";a:1:{i:0;s:15:"content:encoded";}}s:3:"uid";a:2:{s:10:"predicates";a:1:{i:0;s:16:"sioc:has_creator";}s:4:"type";s:3:"rel";}s:4:"name";a:1:{s:10:"predicates";a:1:{i:0;s:9:"foaf:name";}}s:13:"comment_count";a:2:{s:10:"predicates";a:1:{i:0;s:16:"sioc:num_replies";}s:8:"datatype";s:11:"xsd:integer";}s:13:"last_activity";a:3:{s:10:"predicates";a:1:{i:0;s:23:"sioc:last_activity_date";}s:8:"datatype";s:12:"xsd:dateTime";s:8:"callback";s:12:"date_iso8601";}}'),('node','page','a:9:{s:7:"rdftype";a:1:{i:0;s:13:"foaf:Document";}s:5:"title";a:1:{s:10:"predicates";a:1:{i:0;s:8:"dc:title";}}s:7:"created";a:3:{s:10:"predicates";a:2:{i:0;s:7:"dc:date";i:1;s:10:"dc:created";}s:8:"datatype";s:12:"xsd:dateTime";s:8:"callback";s:12:"date_iso8601";}s:7:"changed";a:3:{s:10:"predicates";a:1:{i:0;s:11:"dc:modified";}s:8:"datatype";s:12:"xsd:dateTime";s:8:"callback";s:12:"date_iso8601";}s:4:"body";a:1:{s:10:"predicates";a:1:{i:0;s:15:"content:encoded";}}s:3:"uid";a:2:{s:10:"predicates";a:1:{i:0;s:16:"sioc:has_creator";}s:4:"type";s:3:"rel";}s:4:"name";a:1:{s:10:"predicates";a:1:{i:0;s:9:"foaf:name";}}s:13:"comment_count";a:2:{s:10:"predicates";a:1:{i:0;s:16:"sioc:num_replies";}s:8:"datatype";s:11:"xsd:integer";}s:13:"last_activity";a:3:{s:10:"predicates";a:1:{i:0;s:23:"sioc:last_activity_date";}s:8:"datatype";s:12:"xsd:dateTime";s:8:"callback";s:12:"date_iso8601";}}');
DROP TABLE IF EXISTS `registry`;
CREATE TABLE `registry` (   `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function, class, or interface.',   `type` varchar(9) NOT NULL DEFAULT '' COMMENT 'Either function or class or interface.',   `filename` varchar(255) NOT NULL COMMENT 'Name of the file.',   `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the module the file belongs to.',   `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The order in which this module’s hooks should be invoked relative to other modules. Equal-weighted modules are ordered by name.',   PRIMARY KEY (`name`,`type`),   KEY `hook` (`type`,`weight`,`module`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Each record is a function, class, or interface name and...';
INSERT INTO `registry` VALUES ('AccessDeniedTestCase','class','modules/system/system.test','system','0'),('addressfield_views_handler_field_administrative_area','class','sites/all/modules/contrib/addressfield/views/addressfield_views_handler_field_administrative_area.inc','addressfield','0'),('addressfield_views_handler_field_country','class','sites/all/modules/contrib/addressfield/views/addressfield_views_handler_field_country.inc','addressfield','0'),('addressfield_views_handler_filter_country','class','sites/all/modules/contrib/addressfield/views/addressfield_views_handler_filter_country.inc','addressfield','0'),('AdminMenuCustomizedTestCase','class','sites/all/modules/contrib/admin_menu/tests/admin_menu.test','admin_menu','0'),('AdminMenuDynamicLinksTestCase','class','sites/all/modules/contrib/admin_menu/tests/admin_menu.test','admin_menu','0'),('AdminMenuLinkTypesTestCase','class','sites/all/modules/contrib/admin_menu/tests/admin_menu.test','admin_menu','0'),('AdminMenuPermissionsTestCase','class','sites/all/modules/contrib/admin_menu/tests/admin_menu.test','admin_menu','0'),('AdminMenuWebTestCase','class','sites/all/modules/contrib/admin_menu/tests/admin_menu.test','admin_menu','0'),('AdminMetaTagTestCase','class','modules/system/system.test','system','0'),('AdminViewsAccessHandlerTestCase','class','sites/all/modules/contrib/admin_views/tests/admin_views.test','admin_views','0'),('AdminViewsDefaultViewsTestCase','class','sites/all/modules/contrib/admin_views/tests/admin_views.test','admin_views','0'),('AdminViewsPageDisplayTestCase','class','sites/all/modules/contrib/admin_views/tests/admin_views.test','admin_views','0'),('AdminViewsSystemDisplayTestCase','class','sites/all/modules/contrib/admin_views/tests/admin_views.test','admin_views','0'),('AdminViewsWebTestCase','class','sites/all/modules/contrib/admin_views/tests/admin_views.test','admin_views','0'),('ArchiverInterface','interface','includes/archiver.inc','','0'),('ArchiverTar','class','modules/system/system.archiver.inc','system','0'),('ArchiverZip','class','modules/system/system.archiver.inc','system','0');
INSERT INTO `registry` VALUES ('Archive_Tar','class','modules/system/system.tar.inc','system','0'),('backup_migrate_destination','class','sites/all/modules/contrib/backup_migrate/includes/destinations.inc','backup_migrate','0'),('backup_migrate_destination_remote','class','sites/all/modules/contrib/backup_migrate/includes/destinations.inc','backup_migrate','0'),('backup_migrate_profile','class','sites/all/modules/contrib/backup_migrate/includes/profiles.inc','backup_migrate','0'),('backup_migrate_schedule','class','sites/all/modules/contrib/backup_migrate/includes/schedules.inc','backup_migrate','0'),('BatchMemoryQueue','class','includes/batch.queue.inc','','0'),('BatchQueue','class','includes/batch.queue.inc','','0'),('BlockAccessConfigSpecificTestCase','class','sites/all/modules/contrib/block_access/tests/op_config.test','block_access','0'),('BlockAccessConfigTestCase','class','sites/all/modules/contrib/block_access/tests/op_basic_config.test','block_access','0'),('BlockAccessDeleteTestCase','class','sites/all/modules/contrib/block_access/tests/op_basic_delete.test','block_access','0'),('BlockAccessDisableTestCase','class','sites/all/modules/contrib/block_access/tests/op_basic_disable.test','block_access','0'),('BlockAccessEnableTestCase','class','sites/all/modules/contrib/block_access/tests/op_basic_enable.test','block_access','0'),('BlockAccessMoveTestCase','class','sites/all/modules/contrib/block_access/tests/op_basic_move.test','block_access','0'),('BlockAccessRegionSpecificTestCase','class','sites/all/modules/contrib/block_access/tests/op_region.test','block_access','0'),('BlockAccessTestCase','class','sites/all/modules/contrib/block_access/tests/common.test','block_access','0'),('BlockAccessUITestCase','class','sites/all/modules/contrib/block_access/tests/ui.test','block_access','0'),('BlockAccessViewTestCase','class','sites/all/modules/contrib/block_access/tests/op_basic_view.test','block_access','0'),('BlockAdminThemeTestCase','class','modules/block/block.test','block','0'),('BlockCacheTestCase','class','modules/block/block.test','block','0');
INSERT INTO `registry` VALUES ('BlockClassContextTestCase','class','sites/all/modules/contrib/block_class/block_class.test','block_class','0'),('BlockClassFeaturesTestCase','class','sites/all/modules/contrib/block_class/block_class.test','block_class','0'),('BlockClassPermissionTestCase','class','sites/all/modules/contrib/block_class/block_class.test','block_class','0'),('BlockClassTestCase','class','sites/all/modules/contrib/block_class/block_class.test','block_class','0'),('BlockClassUpdateDisplayTestCase','class','sites/all/modules/contrib/block_class/block_class.test','block_class','0'),('BlockHashTestCase','class','modules/block/block.test','block','0'),('BlockHiddenRegionTestCase','class','modules/block/block.test','block','0'),('BlockHTMLIdTestCase','class','modules/block/block.test','block','0'),('BlockInvalidRegionTestCase','class','modules/block/block.test','block','0'),('BlockTemplateSuggestionsUnitTest','class','modules/block/block.test','block','0'),('BlockTestCase','class','modules/block/block.test','block','0'),('BlockViewModuleDeltaAlterWebTest','class','modules/block/block.test','block','0'),('calendar_plugin_row','class','sites/all/modules/contrib/calendar/includes/calendar_plugin_row.inc','calendar','0'),('calendar_plugin_style','class','sites/all/modules/contrib/calendar/includes/calendar_plugin_style.inc','calendar','0'),('ColorTestCase','class','modules/color/color.test','color','0'),('CommentActionsTestCase','class','modules/comment/comment.test','comment','0'),('CommentAnonymous','class','modules/comment/comment.test','comment','0'),('CommentApprovalTest','class','modules/comment/comment.test','comment','0'),('CommentBlockFunctionalTest','class','modules/comment/comment.test','comment','0'),('CommentContentRebuild','class','modules/comment/comment.test','comment','0'),('CommentController','class','modules/comment/comment.module','comment','0'),('CommentFieldsTest','class','modules/comment/comment.test','comment','0'),('CommentHelperCase','class','modules/comment/comment.test','comment','0'),('CommentInterfaceTest','class','modules/comment/comment.test','comment','0');
INSERT INTO `registry` VALUES ('CommentNodeAccessTest','class','modules/comment/comment.test','comment','0'),('CommentNodeChangesTestCase','class','modules/comment/comment.test','comment','0'),('CommentPagerTest','class','modules/comment/comment.test','comment','0'),('CommentPreviewTest','class','modules/comment/comment.test','comment','0'),('CommentRSSUnitTest','class','modules/comment/comment.test','comment','0'),('CommentThreadingTestCase','class','modules/comment/comment.test','comment','0'),('CommentTokenReplaceTestCase','class','modules/comment/comment.test','comment','0'),('CommonSyndicationParserTestCase','class','sites/all/modules/contrib/feeds/tests/common_syndication_parser.test','feeds','0'),('ConfirmFormTest','class','modules/system/system.test','system','0'),('ContentAccessACLTestCase','class','sites/all/modules/contrib/content_access/tests/content_access_acl.test','content_access','0'),('ContentAccessModuleTestCase','class','sites/all/modules/contrib/content_access/tests/content_access.test','content_access','0'),('ContextualDynamicContextTestCase','class','modules/contextual/contextual.test','contextual','0'),('CronQueueTestCase','class','modules/system/system.test','system','0'),('CronRunTestCase','class','modules/system/system.test','system','0'),('CSVExportViewsDataExportTests','class','sites/all/modules/contrib/views_data_export/tests/csv_export.test','views_data_export','0'),('CToolsCssCache','class','sites/all/modules/contrib/ctools/includes/css-cache.inc','ctools','0'),('CtoolsObjectCache','class','sites/all/modules/contrib/ctools/tests/css_cache.test','ctools','0'),('ctools_context','class','sites/all/modules/contrib/ctools/includes/context.inc','ctools','0'),('ctools_context_optional','class','sites/all/modules/contrib/ctools/includes/context.inc','ctools','0'),('ctools_context_required','class','sites/all/modules/contrib/ctools/includes/context.inc','ctools','0'),('ctools_export_ui','class','sites/all/modules/contrib/ctools/plugins/export_ui/ctools_export_ui.class.php','ctools','0'),('ctools_math_expr','class','sites/all/modules/contrib/ctools/includes/math-expr.inc','ctools','0');
INSERT INTO `registry` VALUES ('ctools_math_expr_stack','class','sites/all/modules/contrib/ctools/includes/math-expr.inc','ctools','0'),('ctools_stylizer_image_processor','class','sites/all/modules/contrib/ctools/includes/stylizer.inc','ctools','0'),('DashboardBlocksTestCase','class','modules/dashboard/dashboard.test','dashboard','0'),('Database','class','includes/database/database.inc','','0'),('DatabaseCondition','class','includes/database/query.inc','','0'),('DatabaseConnection','class','includes/database/database.inc','','0'),('DatabaseConnectionNotDefinedException','class','includes/database/database.inc','','0'),('DatabaseConnection_mysql','class','includes/database/mysql/database.inc','','0'),('DatabaseConnection_pgsql','class','includes/database/pgsql/database.inc','','0'),('DatabaseConnection_sqlite','class','includes/database/sqlite/database.inc','','0'),('DatabaseDriverNotSpecifiedException','class','includes/database/database.inc','','0'),('DatabaseLog','class','includes/database/log.inc','','0'),('DatabaseSchema','class','includes/database/schema.inc','','0'),('DatabaseSchemaObjectDoesNotExistException','class','includes/database/schema.inc','','0'),('DatabaseSchemaObjectExistsException','class','includes/database/schema.inc','','0'),('DatabaseSchema_mysql','class','includes/database/mysql/schema.inc','','0'),('DatabaseSchema_pgsql','class','includes/database/pgsql/schema.inc','','0'),('DatabaseSchema_sqlite','class','includes/database/sqlite/schema.inc','','0'),('DatabaseStatementBase','class','includes/database/database.inc','','0'),('DatabaseStatementEmpty','class','includes/database/database.inc','','0'),('DatabaseStatementInterface','interface','includes/database/database.inc','','0'),('DatabaseStatementPrefetch','class','includes/database/prefetch.inc','','0'),('DatabaseStatement_sqlite','class','includes/database/sqlite/database.inc','','0'),('DatabaseTaskException','class','includes/install.inc','','0'),('DatabaseTasks','class','includes/install.inc','','0'),('DatabaseTasks_mysql','class','includes/database/mysql/install.inc','','0'),('DatabaseTasks_pgsql','class','includes/database/pgsql/install.inc','','0');
INSERT INTO `registry` VALUES ('DatabaseTasks_sqlite','class','includes/database/sqlite/install.inc','','0'),('DatabaseTransaction','class','includes/database/database.inc','','0'),('DatabaseTransactionCommitFailedException','class','includes/database/database.inc','','0'),('DatabaseTransactionExplicitCommitNotAllowedException','class','includes/database/database.inc','','0'),('DatabaseTransactionNameNonUniqueException','class','includes/database/database.inc','','0'),('DatabaseTransactionNoActiveException','class','includes/database/database.inc','','0'),('DatabaseTransactionOutOfOrderException','class','includes/database/database.inc','','0'),('DateAPITestCase','class','sites/all/modules/contrib/date/tests/date_api.test','date','0'),('DateFieldBasic','class','sites/all/modules/contrib/date/tests/date_field.test','date','0'),('DateFieldTestCase','class','sites/all/modules/contrib/date/tests/date_field.test','date','0'),('DateFormatTestCase','class','modules/system/system.test','system','0'),('DateMigrateExampleUnitTest','class','sites/all/modules/contrib/date/tests/date_migrate.test','date','0'),('DateMigrateFieldHandler','class','sites/all/modules/contrib/date/date.migrate.inc','date','0'),('DateObject','class','sites/all/modules/contrib/date/date_api/date_api.module','date_api','0'),('DateRepeatFormTestCase','class','sites/all/modules/contrib/date/date_repeat/tests/date_repeat_form.test','date_repeat','0'),('DateRepeatTestCase','class','sites/all/modules/contrib/date/date_repeat/tests/date_repeat.test','date_repeat','0'),('DateTimeFunctionalTest','class','modules/system/system.test','system','0'),('DateTimezoneTestCase','class','sites/all/modules/contrib/date/tests/date_timezone.test','date','0'),('DateToolsTestCase','class','sites/all/modules/contrib/date/date_tools/tests/date_tools.test','date_tools','0'),('DateUITestCase','class','sites/all/modules/contrib/date/tests/date.test','date','0'),('DateValidationTestCase','class','sites/all/modules/contrib/date/tests/date_validation.test','date','0'),('DateViewsPopupTestCase','class','sites/all/modules/contrib/date/tests/date_views_popup.test','date','0');
INSERT INTO `registry` VALUES ('date_sql_handler','class','sites/all/modules/contrib/date/date_api/date_api_sql.inc','date_api','0'),('date_views_argument_handler','class','sites/all/modules/contrib/date/date_views/includes/date_views_argument_handler.inc','date_views','0'),('date_views_argument_handler_simple','class','sites/all/modules/contrib/date/date_views/includes/date_views_argument_handler_simple.inc','date_views','0'),('date_views_filter_handler','class','sites/all/modules/contrib/date/date_views/includes/date_views_filter_handler.inc','date_views','0'),('date_views_filter_handler_simple','class','sites/all/modules/contrib/date/date_views/includes/date_views_filter_handler_simple.inc','date_views','0'),('date_views_plugin_pager','class','sites/all/modules/contrib/date/date_views/includes/date_views_plugin_pager.inc','date_views','0'),('DBLogTestCase','class','modules/dblog/dblog.test','dblog','0'),('DefaultMailSystem','class','modules/system/system.mail.inc','system','0'),('DeleteQuery','class','includes/database/query.inc','','0'),('DeleteQuery_sqlite','class','includes/database/sqlite/query.inc','','0'),('DevelMailLog','class','sites/all/modules/contrib/devel/devel.mail.inc','devel','0'),('DevelMailTest','class','sites/all/modules/contrib/devel/devel.test','devel','0'),('DOCExportViewsDataExportTests','class','sites/all/modules/contrib/views_data_export/tests/doc_export.test','views_data_export','0'),('DrupalCacheArray','class','includes/bootstrap.inc','','0'),('DrupalCacheInterface','interface','includes/cache.inc','','0'),('DrupalDatabaseCache','class','includes/cache.inc','','0'),('DrupalDefaultEntityController','class','includes/entity.inc','','0'),('DrupalEntityControllerInterface','interface','includes/entity.inc','','0'),('DrupalFakeCache','class','includes/cache-install.inc','','0'),('DrupalLocalStreamWrapper','class','includes/stream_wrappers.inc','','0'),('DrupalPrivateStreamWrapper','class','includes/stream_wrappers.inc','','0'),('DrupalPublicStreamWrapper','class','includes/stream_wrappers.inc','','0'),('DrupalQueue','class','modules/system/system.queue.inc','system','0');
INSERT INTO `registry` VALUES ('DrupalQueueInterface','interface','modules/system/system.queue.inc','system','0'),('DrupalReliableQueueInterface','interface','modules/system/system.queue.inc','system','0'),('DrupalSetMessageTest','class','modules/system/system.test','system','0'),('DrupalStreamWrapperInterface','interface','includes/stream_wrappers.inc','','0'),('DrupalTemporaryStreamWrapper','class','includes/stream_wrappers.inc','','0'),('DrupalUpdateException','class','includes/update.inc','','0'),('DrupalUpdaterInterface','interface','includes/updater.inc','','0'),('EckInlineEntityFormController','class','sites/all/modules/contrib/eck/includes/eck.inline_entity_form.inc','eck','0'),('eck_views_handler_field_link','class','sites/all/modules/contrib/eck/views/handlers/eck_views_handler_field_link.inc','eck','0'),('eck_views_handler_field_link_delete','class','sites/all/modules/contrib/eck/views/handlers/eck_views_handler_field_link_delete.inc','eck','0'),('eck_views_handler_field_link_edit','class','sites/all/modules/contrib/eck/views/handlers/eck_views_handler_field_link_edit.inc','eck','0'),('EnableDisableTestCase','class','modules/system/system.test','system','0'),('Entity','class','sites/all/modules/contrib/entity/includes/entity.inc','entity','0'),('EntityAPICommentNodeAccessTestCase','class','sites/all/modules/contrib/entity/entity.test','entity','0'),('EntityAPIController','class','sites/all/modules/contrib/entity/includes/entity.controller.inc','entity','0'),('EntityAPIControllerExportable','class','sites/all/modules/contrib/entity/includes/entity.controller.inc','entity','0'),('EntityAPIControllerInterface','interface','sites/all/modules/contrib/entity/includes/entity.controller.inc','entity','0'),('EntityAPIControllerRevisionableInterface','interface','sites/all/modules/contrib/entity/includes/entity.controller.inc','entity','0'),('EntityAPIi18nItegrationTestCase','class','sites/all/modules/contrib/entity/entity.test','entity','0'),('EntityAPIRulesIntegrationTestCase','class','sites/all/modules/contrib/entity/entity.test','entity','0'),('EntityAPITestCase','class','sites/all/modules/contrib/entity/entity.test','entity','0');
INSERT INTO `registry` VALUES ('EntityBlockController','class','sites/all/modules/contrib/entity_block/entity_block.controller.inc','entity_block','0'),('EntityBlockControllerInterface','interface','sites/all/modules/contrib/entity_block/entity_block.controller.inc','entity_block','0'),('EntityBundleableUIController','class','sites/all/modules/contrib/entity/includes/entity.ui.inc','entity','0'),('EntityContentUIController','class','sites/all/modules/contrib/entity/includes/entity.ui.inc','entity','0'),('EntityDB','class','sites/all/modules/contrib/entity/includes/entity.inc','entity','0'),('EntityDBExtendable','class','sites/all/modules/contrib/entity/includes/entity.inc','entity','0'),('EntityDefaultExtraFieldsController','class','sites/all/modules/contrib/entity/entity.info.inc','entity','0'),('EntityDefaultFeaturesController','class','sites/all/modules/contrib/entity/entity.features.inc','entity','0'),('EntityDefaultI18nStringController','class','sites/all/modules/contrib/entity/entity.i18n.inc','entity','0'),('EntityDefaultMetadataController','class','sites/all/modules/contrib/entity/entity.info.inc','entity','0'),('EntityDefaultRulesController','class','sites/all/modules/contrib/entity/entity.rules.inc','entity','0'),('EntityDefaultUIController','class','sites/all/modules/contrib/entity/includes/entity.ui.inc','entity','0'),('EntityDefaultViewsController','class','sites/all/modules/contrib/entity/views/entity.views.inc','entity','0'),('EntityDrupalWrapper','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity','0'),('EntityExtendable','class','sites/all/modules/contrib/entity/includes/entity.inc','entity','0'),('EntityExtraFieldsControllerInterface','interface','sites/all/modules/contrib/entity/entity.info.inc','entity','0'),('EntityFieldHandlerHelper','class','sites/all/modules/contrib/entity/views/handlers/entity_views_field_handler_helper.inc','entity','0'),('EntityFieldQuery','class','includes/entity.inc','','0'),('EntityFieldQueryException','class','includes/entity.inc','','0'),('EntityformCRUDTestCase','class','sites/all/modules/contrib/entityform/entityform.test','entityform','0');
INSERT INTO `registry` VALUES ('EntityformMetadataController','class','sites/all/modules/contrib/entityform/entityform.info.inc','entityform','0'),('EntityformTestCase','class','sites/all/modules/contrib/entityform/entityform.test','entityform','0'),('EntityformTypeMetadataController','class','sites/all/modules/contrib/entityform/entityform.info.inc','entityform','0'),('EntityformTypeUIController','class','sites/all/modules/contrib/entityform/entityform_type.admin.inc','entityform','0'),('EntityformUIController','class','sites/all/modules/contrib/entityform/entityform.admin.inc','entityform','0'),('entityform_handler_delete_link_field','class','sites/all/modules/contrib/entityform/views/entityform_handler_delete_link_field.inc','entityform','0'),('entityform_handler_edit_link_field','class','sites/all/modules/contrib/entityform/views/entityform_handler_edit_link_field.inc','entityform','0'),('entityform_handler_entityform_operations_field','class','sites/all/modules/contrib/entityform/views/entityform_handler_entityform_operations_field.inc','entityform','0'),('entityform_handler_link_field','class','sites/all/modules/contrib/entityform/views/entityform_handler_link_field.inc','entityform','0'),('entityform_type_handler_submit_link_field','class','sites/all/modules/contrib/entityform/views/entityform_type_handler_submit_link_field.inc','entityform','0'),('EntityInterface','interface','sites/all/modules/contrib/entity/includes/entity.inc','entity','0'),('EntityListWrapper','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity','0'),('EntityMalformedException','class','includes/entity.inc','','0'),('EntityMetadataArrayObject','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity','0'),('EntityMetadataIntegrationTestCase','class','sites/all/modules/contrib/entity/entity.test','entity','0'),('EntityMetadataNodeAccessTestCase','class','sites/all/modules/contrib/entity/entity.test','entity','0'),('EntityMetadataNodeCreateAccessTestCase','class','sites/all/modules/contrib/entity/entity.test','entity','0');
INSERT INTO `registry` VALUES ('EntityMetadataNodeRevisionAccessTestCase','class','sites/all/modules/contrib/entity/entity.test','entity','0'),('EntityMetadataTaxonomyAccessTestCase','class','sites/all/modules/contrib/entity/entity.test','entity','0'),('EntityMetadataTestCase','class','sites/all/modules/contrib/entity/entity.test','entity','0'),('EntityMetadataWrapper','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity','0'),('EntityMetadataWrapperException','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity','0'),('EntityMetadataWrapperIterator','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity','0'),('EntityPropertiesTestCase','class','modules/field/tests/field.test','field','0'),('EntityReferenceAdminTestCase','class','sites/all/modules/contrib/entityreference/tests/entityreference.admin.test','entityreference','0'),('EntityReferenceBehavior_TaxonomyIndex','class','sites/all/modules/contrib/entityreference/plugins/behavior/EntityReferenceBehavior_TaxonomyIndex.class.php','entityreference','0'),('EntityReferenceBehavior_ViewsFilterSelect','class','sites/all/modules/contrib/entityreference/plugins/behavior/EntityReferenceBehavior_ViewsFilterSelect.class.php','entityreference','0'),('EntityReferenceHandlersTestCase','class','sites/all/modules/contrib/entityreference/tests/entityreference.handlers.test','entityreference','0'),('EntityReferenceTaxonomyTestCase','class','sites/all/modules/contrib/entityreference/tests/entityreference.taxonomy.test','entityreference','0'),('EntityReference_BehaviorHandler','interface','sites/all/modules/contrib/entityreference/plugins/behavior/abstract.inc','entityreference','0'),('EntityReference_BehaviorHandler_Abstract','class','sites/all/modules/contrib/entityreference/plugins/behavior/abstract.inc','entityreference','0'),('EntityReference_BehaviorHandler_Broken','class','sites/all/modules/contrib/entityreference/plugins/behavior/abstract.inc','entityreference','0'),('entityreference_plugin_display','class','sites/all/modules/contrib/entityreference/views/entityreference_plugin_display.inc','entityreference','0');
INSERT INTO `registry` VALUES ('entityreference_plugin_row_fields','class','sites/all/modules/contrib/entityreference/views/entityreference_plugin_row_fields.inc','entityreference','0'),('entityreference_plugin_style','class','sites/all/modules/contrib/entityreference/views/entityreference_plugin_style.inc','entityreference','0'),('EntityReference_SelectionHandler','interface','sites/all/modules/contrib/entityreference/plugins/selection/abstract.inc','entityreference','0'),('EntityReference_SelectionHandler_Broken','class','sites/all/modules/contrib/entityreference/plugins/selection/abstract.inc','entityreference','0'),('EntityReference_SelectionHandler_Generic','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference','0'),('EntityReference_SelectionHandler_Generic_comment','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference','0'),('EntityReference_SelectionHandler_Generic_file','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference','0'),('EntityReference_SelectionHandler_Generic_node','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference','0'),('EntityReference_SelectionHandler_Generic_taxonomy_term','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference','0'),('EntityReference_SelectionHandler_Generic_user','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference','0'),('EntityReference_SelectionHandler_Views','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Views.class.php','entityreference','0'),('EntityStructureWrapper','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity','0');
INSERT INTO `registry` VALUES ('EntityTokenTestCase','class','sites/all/modules/contrib/entity/entity.test','entity','0'),('EntityTranslationECKHandler','class','sites/all/modules/contrib/eck/includes/translation.handler.eck.inc','eck','0'),('EntityValueWrapper','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity','0'),('EntityWebTestCase','class','sites/all/modules/contrib/entity/entity.test','entity','0'),('EntityWorkflowUIController','class','sites/all/modules/contrib/workflow/workflow_admin_ui/includes/Entity/EntityWorkflowUIController.php','workflow_admin_ui','0'),('entity_views_handler_area_entity','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_area_entity.inc','entity','0'),('entity_views_handler_field_boolean','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_boolean.inc','entity','0'),('entity_views_handler_field_date','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_date.inc','entity','0'),('entity_views_handler_field_duration','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_duration.inc','entity','0'),('entity_views_handler_field_entity','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_entity.inc','entity','0'),('entity_views_handler_field_field','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_field.inc','entity','0'),('entity_views_handler_field_numeric','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_numeric.inc','entity','0'),('entity_views_handler_field_options','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_options.inc','entity','0'),('entity_views_handler_field_text','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_text.inc','entity','0'),('entity_views_handler_field_uri','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_uri.inc','entity','0'),('entity_views_handler_relationship','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_relationship.inc','entity','0');
INSERT INTO `registry` VALUES ('entity_views_handler_relationship_by_bundle','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_relationship_by_bundle.inc','entity','0'),('entity_views_plugin_row_entity_view','class','sites/all/modules/contrib/entity/views/plugins/entity_views_plugin_row_entity_view.inc','entity','0'),('FacesExtendable','class','sites/all/modules/contrib/rules/includes/faces.inc','rules','0'),('FacesExtendableException','class','sites/all/modules/contrib/rules/includes/faces.inc','rules','0'),('FacesExtender','class','sites/all/modules/contrib/rules/includes/faces.inc','rules','0'),('FacesExtenderInterface','interface','sites/all/modules/contrib/rules/includes/faces.inc','rules','0'),('FeaturesCtoolsIntegrationTest','class','sites/all/modules/contrib/features/tests/features.test','features','0'),('FeaturesDetectionTestCase','class','sites/all/modules/contrib/features/tests/features.test','features','0'),('FeaturesEnableTestCase','class','sites/all/modules/contrib/features/tests/features.test','features','0'),('FeaturesUserTestCase','class','sites/all/modules/contrib/features/tests/features.test','features','0'),('FeedsAccessException','class','sites/all/modules/contrib/feeds/plugins/FeedsProcessor.inc','feeds','0'),('FeedsConfigurable','class','sites/all/modules/contrib/feeds/includes/FeedsConfigurable.inc','feeds','0'),('FeedsContentTypeTest','class','sites/all/modules/contrib/feeds/tests/feeds_content_type.test','feeds','0'),('FeedsCSVParser','class','sites/all/modules/contrib/feeds/plugins/FeedsCSVParser.inc','feeds','0'),('FeedsCSVParserTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_parser_csv.test','feeds','0'),('FeedsCSVtoTermsTest','class','sites/all/modules/contrib/feeds/tests/feeds_processor_term.test','feeds','0'),('FeedsCSVtoUsersTest','class','sites/all/modules/contrib/feeds/tests/feeds_processor_user.test','feeds','0'),('FeedsDateTime','class','sites/all/modules/contrib/feeds/plugins/FeedsParser.inc','feeds','0'),('FeedsDateTimeElement','class','sites/all/modules/contrib/feeds/plugins/FeedsParser.inc','feeds','0');
INSERT INTO `registry` VALUES ('FeedsDateTimeTest','class','sites/all/modules/contrib/feeds/tests/feeds_date_time.test','feeds','0'),('FeedsElement','class','sites/all/modules/contrib/feeds/plugins/FeedsParser.inc','feeds','0'),('FeedsEnclosure','class','sites/all/modules/contrib/feeds/plugins/FeedsParser.inc','feeds','0'),('FeedsEntityProcessor','class','sites/all/modules/contrib/feeds_entity_processor/src/FeedsEntityProcessor.inc','feeds_entity_processor','0'),('FeedsEntityProcessorBasicTest','class','sites/all/modules/contrib/feeds_entity_processor/tests/src/FeedsEntityProcessorBasicTest.test','feeds_entity_processor','0'),('FeedsEntityProcessorPropertyBoolean','class','sites/all/modules/contrib/feeds_entity_processor/src/Property/FeedsEntityProcessorPropertyBoolean.php','feeds_entity_processor','0'),('FeedsEntityProcessorPropertyDate','class','sites/all/modules/contrib/feeds_entity_processor/src/Property/FeedsEntityProcessorPropertyDate.php','feeds_entity_processor','0'),('FeedsEntityProcessorPropertyDefault','class','sites/all/modules/contrib/feeds_entity_processor/src/Property/FeedsEntityProcessorPropertyDefault.php','feeds_entity_processor','0'),('FeedsEntityProcessorPropertyEntity','class','sites/all/modules/contrib/feeds_entity_processor/src/Property/FeedsEntityProcessorPropertyEntity.php','feeds_entity_processor','0'),('FeedsEntityProcessorPropertyEntityType','class','sites/all/modules/contrib/feeds_entity_processor/src/Property/FeedsEntityProcessorPropertyEntityType.php','feeds_entity_processor','0'),('FeedsEntityProcessorPropertyInterface','interface','sites/all/modules/contrib/feeds_entity_processor/src/Property/FeedsEntityProcessorPropertyInterface.php','feeds_entity_processor','0'),('FeedsEntityProcessorPropertyTest','class','sites/all/modules/contrib/feeds_entity_processor/tests/src/FeedsEntityProcessorPropertyTest.test','feeds_entity_processor','0'),('FeedsExamplesNodeTestCase','class','sites/all/modules/contrib/feeds/feeds_import/feeds_import.test','feeds_import','0'),('FeedsExamplesUserTestCase','class','sites/all/modules/contrib/feeds/feeds_import/feeds_import.test','feeds_import','0');
INSERT INTO `registry` VALUES ('FeedsFetcher','class','sites/all/modules/contrib/feeds/plugins/FeedsFetcher.inc','feeds','0'),('FeedsFetcherResult','class','sites/all/modules/contrib/feeds/plugins/FeedsFetcher.inc','feeds','0'),('FeedsFileFetcher','class','sites/all/modules/contrib/feeds/plugins/FeedsFileFetcher.inc','feeds','0'),('FeedsFileFetcherResult','class','sites/all/modules/contrib/feeds/plugins/FeedsFileFetcher.inc','feeds','0'),('FeedsFileFetcherTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_fetcher_file.test','feeds','0'),('FeedsFileHTTPTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_fetcher_http.test','feeds','0'),('FeedsGeoTermElement','class','sites/all/modules/contrib/feeds/plugins/FeedsParser.inc','feeds','0'),('FeedsHTTPFetcher','class','sites/all/modules/contrib/feeds/plugins/FeedsHTTPFetcher.inc','feeds','0'),('FeedsHTTPFetcherResult','class','sites/all/modules/contrib/feeds/plugins/FeedsHTTPFetcher.inc','feeds','0'),('FeedsHTTPRequestTestCase','class','sites/all/modules/contrib/feeds/tests/http_request.test','feeds','0'),('Feedsi18nNodeTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_i18n_node.test','feeds','0'),('Feedsi18nTaxonomyTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_i18n_taxonomy.test','feeds','0'),('Feedsi18nTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_i18n.test','feeds','0'),('FeedsImporter','class','sites/all/modules/contrib/feeds/includes/FeedsImporter.inc','feeds','0'),('FeedsLockException','class','sites/all/modules/contrib/feeds/includes/FeedsSource.inc','feeds','0'),('FeedsMapperConfigTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_config.test','feeds','0'),('FeedsMapperDateMultipleTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_date_multiple.test','feeds','0'),('FeedsMapperDateTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_date.test','feeds','0'),('FeedsMapperFieldTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_field.test','feeds','0'),('FeedsMapperFileTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_file.test','feeds','0');
INSERT INTO `registry` VALUES ('FeedsMapperFormatConfig','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_format_config.test','feeds','0'),('FeedsMapperHookTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_hooks.test','feeds','0'),('FeedsMapperLinkTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_link.test','feeds','0'),('FeedsMapperListTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_list.test','feeds','0'),('FeedsMapperMultilingualFieldsTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_multilingual_fields.test','feeds','0'),('FeedsMapperNodeSummaryTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_summary.test','feeds','0'),('FeedsMapperPathPathautoTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_path.test','feeds','0'),('FeedsMapperPathTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_path.test','feeds','0'),('FeedsMapperProfileTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_profile.test','feeds','0'),('FeedsMapperTaxonomyTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_taxonomy.test','feeds','0'),('FeedsMapperTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper.test','feeds','0'),('FeedsMapperUniqueTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_mapper_unique.test','feeds','0'),('FeedsMissingPlugin','class','sites/all/modules/contrib/feeds/plugins/FeedsPlugin.inc','feeds','0'),('FeedsNodeProcessor','class','sites/all/modules/contrib/feeds/plugins/FeedsNodeProcessor.inc','feeds','0'),('FeedsNotExistingException','class','sites/all/modules/contrib/feeds/includes/FeedsConfigurable.inc','feeds','0'),('FeedsOPMLParser','class','sites/all/modules/contrib/feeds/plugins/FeedsOPMLParser.inc','feeds','0'),('FeedsParser','class','sites/all/modules/contrib/feeds/plugins/FeedsParser.inc','feeds','0'),('FeedsParserResult','class','sites/all/modules/contrib/feeds/plugins/FeedsParser.inc','feeds','0'),('FeedsPlugin','class','sites/all/modules/contrib/feeds/plugins/FeedsPlugin.inc','feeds','0');
INSERT INTO `registry` VALUES ('FeedsProcessor','class','sites/all/modules/contrib/feeds/plugins/FeedsProcessor.inc','feeds','0'),('FeedsProcessorBundleNotDefined','class','sites/all/modules/contrib/feeds/plugins/FeedsProcessor.inc','feeds','0'),('FeedsPushTest','class','sites/all/modules/contrib/feeds/tests/feeds_push.test','feeds','0'),('FeedsResult','class','sites/all/modules/contrib/feeds/plugins/FeedsPlugin.inc','feeds','0'),('FeedsRSStoNodesTest','class','sites/all/modules/contrib/feeds/tests/feeds_processor_node.test','feeds','0'),('FeedsRulesTest','class','sites/all/modules/contrib/feeds/tests/feeds_rules.test','feeds','0'),('FeedsSchedulerTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_scheduler.test','feeds','0'),('FeedsSimplePieEnclosure','class','sites/all/modules/contrib/feeds/plugins/FeedsSimplePieParser.inc','feeds','0'),('FeedsSimplePieParser','class','sites/all/modules/contrib/feeds/plugins/FeedsSimplePieParser.inc','feeds','0'),('FeedsSitemapParser','class','sites/all/modules/contrib/feeds/plugins/FeedsSitemapParser.inc','feeds','0'),('FeedsSitemapParserTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_parser_sitemap.test','feeds','0'),('FeedsSource','class','sites/all/modules/contrib/feeds/includes/FeedsSource.inc','feeds','0'),('FeedsSourceInterface','interface','sites/all/modules/contrib/feeds/includes/FeedsSource.inc','feeds','0'),('FeedsState','class','sites/all/modules/contrib/feeds/includes/FeedsSource.inc','feeds','0'),('FeedsSyndicationParser','class','sites/all/modules/contrib/feeds/plugins/FeedsSyndicationParser.inc','feeds','0'),('FeedsSyndicationParserTestCase','class','sites/all/modules/contrib/feeds/tests/feeds_parser_syndication.test','feeds','0'),('FeedsTermElement','class','sites/all/modules/contrib/feeds/plugins/FeedsParser.inc','feeds','0'),('FeedsTermProcessor','class','sites/all/modules/contrib/feeds/plugins/FeedsTermProcessor.inc','feeds','0'),('FeedsTokenTest','class','sites/all/modules/contrib/feeds/tests/feeds_tokens.test','feeds','0'),('FeedsUIUserInterfaceTestCase','class','sites/all/modules/contrib/feeds/feeds_ui/feeds_ui.test','feeds_ui','0');
INSERT INTO `registry` VALUES ('FeedsUnitTestCase','class','sites/all/modules/contrib/feeds/tests/feeds.test','feeds','0'),('FeedsUnitTestHelper','class','sites/all/modules/contrib/feeds/tests/feeds.test','feeds','0'),('FeedsUserProcessor','class','sites/all/modules/contrib/feeds/plugins/FeedsUserProcessor.inc','feeds','0'),('FeedsValidationException','class','sites/all/modules/contrib/feeds/plugins/FeedsProcessor.inc','feeds','0'),('FeedsWebTestCase','class','sites/all/modules/contrib/feeds/tests/feeds.test','feeds','0'),('feeds_views_handler_argument_importer_id','class','sites/all/modules/contrib/feeds/views/feeds_views_handler_argument_importer_id.inc','feeds','0'),('feeds_views_handler_field_importer_name','class','sites/all/modules/contrib/feeds/views/feeds_views_handler_field_importer_name.inc','feeds','0'),('feeds_views_handler_field_log_message','class','sites/all/modules/contrib/feeds/views/feeds_views_handler_field_log_message.inc','feeds','0'),('feeds_views_handler_field_severity','class','sites/all/modules/contrib/feeds/views/feeds_views_handler_field_severity.inc','feeds','0'),('feeds_views_handler_field_source','class','sites/all/modules/contrib/feeds/views/feeds_views_handler_field_source.inc','feeds','0'),('feeds_views_handler_filter_severity','class','sites/all/modules/contrib/feeds/views/feeds_views_handler_filter_severity.inc','feeds','0'),('feeds_views_plugin_argument_validate_feed_nid','class','sites/all/modules/contrib/feeds/views/feeds_views_plugin_argument_validate_feed_nid.inc','feeds','0'),('FieldAttachOtherTestCase','class','modules/field/tests/field.test','field','0'),('FieldAttachStorageTestCase','class','modules/field/tests/field.test','field','0'),('FieldAttachTestCase','class','modules/field/tests/field.test','field','0'),('FieldBulkDeleteTestCase','class','modules/field/tests/field.test','field','0'),('FieldCollectionBasicTestCase','class','sites/all/modules/contrib/field_collection/field_collection.test','field_collection','0'),('FieldCollectionContentTranslationTestCase','class','sites/all/modules/contrib/field_collection/field_collection.test','field_collection','0');
INSERT INTO `registry` VALUES ('FieldCollectionItemEntity','class','sites/all/modules/contrib/field_collection/field_collection.entity.inc','field_collection','0'),('FieldCollectionItemMetadataController','class','sites/all/modules/contrib/field_collection/field_collection.info.inc','field_collection','0'),('FieldCollectionRulesIntegrationTestCase','class','sites/all/modules/contrib/field_collection/field_collection.test','field_collection','0'),('FieldCrudTestCase','class','modules/field/tests/field.test','field','0'),('FieldDisplayAPITestCase','class','modules/field/tests/field.test','field','0'),('FieldException','class','modules/field/field.module','field','0'),('FieldFormTestCase','class','modules/field/tests/field.test','field','0'),('FieldInfo','class','modules/field/field.info.class.inc','field','0'),('FieldInfoTestCase','class','modules/field/tests/field.test','field','0'),('FieldInstanceCrudTestCase','class','modules/field/tests/field.test','field','0'),('FieldPermissionsTestCase','class','sites/all/modules/contrib/field_permissions/field_permissions.test','field_permissions','0'),('FieldsOverlapException','class','includes/database/database.inc','','0'),('FieldSqlStorageTestCase','class','modules/field/modules/field_sql_storage/field_sql_storage.test','field_sql_storage','0'),('FieldTestCase','class','modules/field/tests/field.test','field','0'),('FieldTranslationsTestCase','class','modules/field/tests/field.test','field','0'),('FieldUIAlterTestCase','class','modules/field_ui/field_ui.test','field_ui','0'),('FieldUIManageDisplayTestCase','class','modules/field_ui/field_ui.test','field_ui','0'),('FieldUIManageFieldsTestCase','class','modules/field_ui/field_ui.test','field_ui','0'),('FieldUITestCase','class','modules/field_ui/field_ui.test','field_ui','0'),('FieldUpdateForbiddenException','class','modules/field/field.module','field','0'),('FieldValidationException','class','modules/field/field.attach.inc','field','0'),('field_collection_handler_relationship','class','sites/all/modules/contrib/field_collection/views/field_collection_handler_relationship.inc','field_collection','0');
INSERT INTO `registry` VALUES ('FileFieldAnonymousSubmission','class','modules/file/tests/file.test','file','0'),('FileFieldDisplayTestCase','class','modules/file/tests/file.test','file','0'),('FileFieldPathTestCase','class','modules/file/tests/file.test','file','0'),('FileFieldRevisionTestCase','class','modules/file/tests/file.test','file','0'),('FileFieldTestCase','class','modules/file/tests/file.test','file','0'),('FileFieldValidateTestCase','class','modules/file/tests/file.test','file','0'),('FileFieldWidgetTestCase','class','modules/file/tests/file.test','file','0'),('FileManagedFileElementTestCase','class','modules/file/tests/file.test','file','0'),('FilePrivateTestCase','class','modules/file/tests/file.test','file','0'),('FileTaxonomyTermTestCase','class','modules/file/tests/file.test','file','0'),('FileTokenReplaceTestCase','class','modules/file/tests/file.test','file','0'),('FileTransfer','class','includes/filetransfer/filetransfer.inc','','0'),('FileTransferChmodInterface','interface','includes/filetransfer/filetransfer.inc','','0'),('FileTransferException','class','includes/filetransfer/filetransfer.inc','','0'),('FileTransferFTP','class','includes/filetransfer/ftp.inc','','0'),('FileTransferFTPExtension','class','includes/filetransfer/ftp.inc','','0'),('FileTransferLocal','class','includes/filetransfer/local.inc','','0'),('FileTransferSSH','class','includes/filetransfer/ssh.inc','','0'),('FilterAdminTestCase','class','modules/filter/filter.test','filter','0'),('FilterCRUDTestCase','class','modules/filter/filter.test','filter','0'),('FilterDefaultFormatTestCase','class','modules/filter/filter.test','filter','0'),('FilterDOMSerializeTestCase','class','modules/filter/filter.test','filter','0'),('FilterFormatAccessTestCase','class','modules/filter/filter.test','filter','0'),('FilterHooksTestCase','class','modules/filter/filter.test','filter','0'),('FilterNoFormatTestCase','class','modules/filter/filter.test','filter','0'),('FilterSecurityTestCase','class','modules/filter/filter.test','filter','0'),('FilterSettingsTestCase','class','modules/filter/filter.test','filter','0');
INSERT INTO `registry` VALUES ('FilterUnitTestCase','class','modules/filter/filter.test','filter','0'),('FloodFunctionalTest','class','modules/system/system.test','system','0'),('FrontPageTestCase','class','modules/system/system.test','system','0'),('GoogleAnalyticsBasicTest','class','sites/all/modules/contrib/google_analytics/googleanalytics.test','googleanalytics','0'),('GoogleAnalyticsCustomDimensionsAndMetricsTest','class','sites/all/modules/contrib/google_analytics/googleanalytics.test','googleanalytics','0'),('GoogleAnalyticsPhpFilterTest','class','sites/all/modules/contrib/google_analytics/googleanalytics.test','googleanalytics','0'),('GoogleAnalyticsRolesTest','class','sites/all/modules/contrib/google_analytics/googleanalytics.test','googleanalytics','0'),('GoogleAnalyticsSearchTest','class','sites/all/modules/contrib/google_analytics/googleanalytics.test','googleanalytics','0'),('GoogleAnalyticsStatusMessagesTest','class','sites/all/modules/contrib/google_analytics/googleanalytics.test','googleanalytics','0'),('GroupDisplayTestCase','class','sites/all/modules/contrib/field_group/tests/field_group.display.test','field_group','0'),('GroupUITestCase','class','sites/all/modules/contrib/field_group/tests/field_group.ui.test','field_group','0'),('HelpTestCase','class','modules/help/help.test','help','0'),('HookRequirementsTestCase','class','modules/system/system.test','system','0'),('HRCurlException','class','sites/all/modules/contrib/feeds/libraries/http_request.inc','feeds','0'),('ImageAdminStylesUnitTest','class','modules/image/image.test','image','0'),('ImageAdminUiTestCase','class','modules/image/image.test','image','0'),('ImageDimensionsScaleTestCase','class','modules/image/image.test','image','0'),('ImageDimensionsTestCase','class','modules/image/image.test','image','0'),('ImageEffectsUnitTest','class','modules/image/image.test','image','0'),('ImageFieldDefaultImagesTestCase','class','modules/image/image.test','image','0'),('ImageFieldDisplayTestCase','class','modules/image/image.test','image','0'),('ImageFieldTestCase','class','modules/image/image.test','image','0');
INSERT INTO `registry` VALUES ('ImageFieldValidateTestCase','class','modules/image/image.test','image','0'),('ImageStyleFlushTest','class','modules/image/image.test','image','0'),('ImageStylesPathAndUrlTestCase','class','modules/image/image.test','image','0'),('ImageThemeFunctionWebTestCase','class','modules/image/image.test','image','0'),('InfoFileParserTestCase','class','modules/system/system.test','system','0'),('InsertQuery','class','includes/database/query.inc','','0'),('InsertQuery_mysql','class','includes/database/mysql/query.inc','','0'),('InsertQuery_pgsql','class','includes/database/pgsql/query.inc','','0'),('InsertQuery_sqlite','class','includes/database/sqlite/query.inc','','0'),('InvalidMergeQueryException','class','includes/database/database.inc','','0'),('IPAddressBlockingTestCase','class','modules/system/system.test','system','0'),('JobScheduler','class','sites/all/modules/contrib/job_scheduler/JobScheduler.inc','job_scheduler','0'),('JobSchedulerCronTab','class','sites/all/modules/contrib/job_scheduler/JobSchedulerCronTab.inc','job_scheduler','0'),('JobSchedulerException','class','sites/all/modules/contrib/job_scheduler/JobScheduler.inc','job_scheduler','0'),('LibrariesAdminWebTest','class','sites/all/modules/contrib/libraries/tests/LibrariesAdminWebTest.test','libraries','0'),('LibrariesLoadWebTest','class','sites/all/modules/contrib/libraries/tests/LibrariesLoadWebTest.test','libraries','0'),('LibrariesUnitTest','class','sites/all/modules/contrib/libraries/tests/LibrariesUnitTest.test','libraries','0'),('LibrariesWebTestBase','class','sites/all/modules/contrib/libraries/tests/LibrariesWebTestBase.test','libraries','0'),('LinkAttributeCrudTest','class','sites/all/modules/contrib/link/tests/link.attribute.test','link','0'),('LinkBaseTestClass','class','sites/all/modules/contrib/link/tests/link.test','link','0'),('LinkContentCrudTest','class','sites/all/modules/contrib/link/tests/link.crud.test','link','0'),('LinkEntityTokenTest','class','sites/all/modules/contrib/link/tests/link.entity_token.test','link','0'),('LinkTokenTest','class','sites/all/modules/contrib/link/tests/link.token.test','link','0');
INSERT INTO `registry` VALUES ('LinkUITest','class','sites/all/modules/contrib/link/tests/link.crud_browser.test','link','0'),('LinkValidateSpecificURL','class','sites/all/modules/contrib/link/tests/link.validate.test','link','0'),('LinkValidateTest','class','sites/all/modules/contrib/link/tests/link.validate.test','link','0'),('LinkValidateTestCase','class','sites/all/modules/contrib/link/tests/link.validate.test','link','0'),('LinkValidateTestNews','class','sites/all/modules/contrib/link/tests/link.validate.test','link','0'),('LinkValidateUrlLight','class','sites/all/modules/contrib/link/tests/link.validate.test','link','0'),('link_views_handler_argument_target','class','sites/all/modules/contrib/link/views/link_views_handler_argument_target.inc','link','0'),('link_views_handler_filter_protocol','class','sites/all/modules/contrib/link/views/link_views_handler_filter_protocol.inc','link','0'),('ListDynamicValuesTestCase','class','modules/field/modules/list/tests/list.test','list','0'),('ListDynamicValuesValidationTestCase','class','modules/field/modules/list/tests/list.test','list','0'),('ListFieldTestCase','class','modules/field/modules/list/tests/list.test','list','0'),('ListFieldUITestCase','class','modules/field/modules/list/tests/list.test','list','0'),('MailSystemInterface','interface','includes/mail.inc','','0'),('MemoryQueue','class','modules/system/system.queue.inc','system','0'),('MenuNodeTestCase','class','modules/menu/menu.test','menu','0'),('MenuTestCase','class','modules/menu/menu.test','menu','0'),('MergeQuery','class','includes/database/query.inc','','0'),('MigrateAddressFieldHandler','class','sites/all/modules/contrib/addressfield/addressfield.migrate.inc','addressfield','0'),('MigrateDestinationFieldCollection','class','sites/all/modules/contrib/field_collection/field_collection.migrate.inc','field_collection','0'),('MigrateEntityReferenceFieldHandler','class','sites/all/modules/contrib/entityreference/entityreference.migrate.inc','entityreference','0'),('MigrateLinkFieldHandler','class','sites/all/modules/contrib/link/link.migrate.inc','link','0');
INSERT INTO `registry` VALUES ('ModuleDependencyTestCase','class','modules/system/system.test','system','0'),('ModuleRequiredTestCase','class','modules/system/system.test','system','0'),('ModuleTestCase','class','modules/system/system.test','system','0'),('ModuleUpdater','class','modules/system/system.updater.inc','system','0'),('ModuleVersionTestCase','class','modules/system/system.test','system','0'),('MultiStepNodeFormBasicOptionsTest','class','modules/node/node.test','node','0'),('NewDefaultThemeBlocks','class','modules/block/block.test','block','0'),('NodeAccessBaseTableTestCase','class','modules/node/node.test','node','0'),('NodeAccessFieldTestCase','class','modules/node/node.test','node','0'),('NodeAccessPagerTestCase','class','modules/node/node.test','node','0'),('NodeAccessRebuildTestCase','class','modules/node/node.test','node','0'),('NodeAccessRecordsTestCase','class','modules/node/node.test','node','0'),('NodeAccessTestCase','class','modules/node/node.test','node','0'),('NodeAdminTestCase','class','modules/node/node.test','node','0'),('NodeBlockFunctionalTest','class','modules/node/node.test','node','0'),('NodeBlockTestCase','class','modules/node/node.test','node','0'),('NodeBuildContent','class','modules/node/node.test','node','0'),('NodeController','class','modules/node/node.module','node','0'),('NodeCreationTestCase','class','modules/node/node.test','node','0'),('NodeEntityFieldQueryAlter','class','modules/node/node.test','node','0'),('NodeEntityViewModeAlterTest','class','modules/node/node.test','node','0'),('NodeFeedTestCase','class','modules/node/node.test','node','0'),('NodeLoadHooksTestCase','class','modules/node/node.test','node','0'),('NodeLoadMultipleTestCase','class','modules/node/node.test','node','0'),('NodeMultiByteUtf8Test','class','modules/node/node.test','node','0'),('NodePageCacheTest','class','modules/node/node.test','node','0'),('NodePostSettingsTestCase','class','modules/node/node.test','node','0'),('NodeQueryAlter','class','modules/node/node.test','node','0'),('NodeRevisionPermissionsTestCase','class','modules/node/node.test','node','0'),('NodeRevisionsTestCase','class','modules/node/node.test','node','0');
INSERT INTO `registry` VALUES ('NodeRSSContentTestCase','class','modules/node/node.test','node','0'),('NodeSaveTestCase','class','modules/node/node.test','node','0'),('NodeTitleTestCase','class','modules/node/node.test','node','0'),('NodeTitleXSSTestCase','class','modules/node/node.test','node','0'),('NodeTokenReplaceTestCase','class','modules/node/node.test','node','0'),('NodeTypePersistenceTestCase','class','modules/node/node.test','node','0'),('NodeTypeTestCase','class','modules/node/node.test','node','0'),('NodeWebTestCase','class','modules/node/node.test','node','0'),('NoFieldsException','class','includes/database/database.inc','','0'),('NoHelpTestCase','class','modules/help/help.test','help','0'),('NonDefaultBlockAdmin','class','modules/block/block.test','block','0'),('NumberFieldTestCase','class','modules/field/modules/number/number.test','number','0'),('OptionsSelectDynamicValuesTestCase','class','modules/field/modules/options/options.test','options','0'),('OptionsWidgetsTestCase','class','modules/field/modules/options/options.test','options','0'),('PageEditTestCase','class','modules/node/node.test','node','0'),('PageNotFoundTestCase','class','modules/system/system.test','system','0'),('PagePreviewTestCase','class','modules/node/node.test','node','0'),('PagerDefault','class','includes/pager.inc','','0'),('PageTitleFiltering','class','modules/system/system.test','system','0'),('PageViewTestCase','class','modules/node/node.test','node','0'),('PanelsEntityViewWebTestCase','class','sites/all/modules/contrib/panels/tests/PanelsEntityViewWebTestCase.test','panels','0'),('PanelsLegacyState','class','sites/all/modules/contrib/panels/includes/legacy.inc','panels','0'),('PanelsNodeViewWebTestCase','class','sites/all/modules/contrib/panels/tests/PanelsNodeViewWebTestCase.test','panels','0'),('PanelsTermViewWebTestCase','class','sites/all/modules/contrib/panels/tests/PanelsTermViewWebTestCase.test','panels','0'),('PanelsUserViewWebTestCase','class','sites/all/modules/contrib/panels/tests/PanelsUserViewWebTestCase.test','panels','0'),('panels_allowed_layouts','class','sites/all/modules/contrib/panels/includes/common.inc','panels','0');
INSERT INTO `registry` VALUES ('panels_cache_object','class','sites/all/modules/contrib/panels/includes/plugins.inc','panels','0'),('panels_display','class','sites/all/modules/contrib/panels/panels.module','panels','0'),('panels_layouts_ui','class','sites/all/modules/contrib/panels/plugins/export_ui/panels_layouts_ui.class.php','panels','0'),('panels_mini_ui','class','sites/all/modules/contrib/panels/panels_mini/plugins/export_ui/panels_mini_ui.class.php','panels_mini','0'),('panels_renderer_editor','class','sites/all/modules/contrib/panels/plugins/display_renderers/panels_renderer_editor.class.php','panels','0'),('panels_renderer_ipe','class','sites/all/modules/contrib/panels/panels_ipe/plugins/display_renderers/panels_renderer_ipe.class.php','panels_ipe','0'),('panels_renderer_simple','class','sites/all/modules/contrib/panels/plugins/display_renderers/panels_renderer_simple.class.php','panels','0'),('panels_renderer_standard','class','sites/all/modules/contrib/panels/plugins/display_renderers/panels_renderer_standard.class.php','panels','0'),('panels_views_plugin_row_fields','class','sites/all/modules/contrib/panels/plugins/views/panels_views_plugin_row_fields.inc','panels','0'),('ParserCSV','class','sites/all/modules/contrib/feeds/libraries/ParserCSV.inc','feeds','0'),('ParserCSVEncodingException','class','sites/all/modules/contrib/feeds/libraries/ParserCSV.inc','feeds','0'),('ParserCSVIterator','class','sites/all/modules/contrib/feeds/libraries/ParserCSV.inc','feeds','0'),('ParserCSVTest','class','sites/all/modules/contrib/feeds/tests/parser_csv.test','feeds','0'),('PathautoBulkUpdateTestCase','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto','0'),('PathautoFunctionalTestCase','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto','0'),('PathautoFunctionalTestHelper','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto','0'),('PathautoLocaleTestCase','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto','0'),('PathautoMigrationHandler','class','sites/all/modules/contrib/pathauto/pathauto.migrate.inc','pathauto','0');
INSERT INTO `registry` VALUES ('PathautoTestHelper','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto','0'),('PathautoTokenTestCase','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto','0'),('PathautoUnitTestCase','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto','0'),('PathLanguageTestCase','class','modules/path/path.test','path','0'),('PathLanguageUITestCase','class','modules/path/path.test','path','0'),('PathMonolingualTestCase','class','modules/path/path.test','path','0'),('PathTaxonomyTermTestCase','class','modules/path/path.test','path','0'),('PathTestCase','class','modules/path/path.test','path','0'),('PHPAccessTestCase','class','modules/php/php.test','php','0'),('PHPFilterTestCase','class','modules/php/php.test','php','0'),('PHPMailer','class','sites/all/modules/contrib/smtp/smtp.phpmailer.inc','smtp','0'),('phpmailerException','class','sites/all/modules/contrib/smtp/smtp.phpmailer.inc','smtp','0'),('PHPTestCase','class','modules/php/php.test','php','0'),('PuSHEnvironment','class','sites/all/modules/contrib/feeds/plugins/FeedsHTTPFetcher.inc','feeds','0'),('PuSHSubscriber','class','sites/all/modules/contrib/feeds/libraries/PuSHSubscriber.inc','feeds','0'),('PuSHSubscriberEnvironmentInterface','interface','sites/all/modules/contrib/feeds/libraries/PuSHSubscriber.inc','feeds','0'),('PuSHSubscription','class','sites/all/modules/contrib/feeds/plugins/FeedsHTTPFetcher.inc','feeds','0'),('PuSHSubscriptionInterface','interface','sites/all/modules/contrib/feeds/libraries/PuSHSubscriber.inc','feeds','0'),('Query','class','includes/database/query.inc','','0'),('QueryAlterableInterface','interface','includes/database/query.inc','','0'),('QueryConditionInterface','interface','includes/database/query.inc','','0'),('QueryExtendableInterface','interface','includes/database/select.inc','','0'),('QueryPlaceholderInterface','interface','includes/database/query.inc','','0'),('QueueTestCase','class','modules/system/system.test','system','0'),('RdfCommentAttributesTestCase','class','modules/rdf/rdf.test','rdf','0'),('RdfCrudTestCase','class','modules/rdf/rdf.test','rdf','0');
INSERT INTO `registry` VALUES ('RdfGetRdfNamespacesTestCase','class','modules/rdf/rdf.test','rdf','0'),('RdfMappingDefinitionTestCase','class','modules/rdf/rdf.test','rdf','0'),('RdfMappingHookTestCase','class','modules/rdf/rdf.test','rdf','0'),('RdfRdfaMarkupTestCase','class','modules/rdf/rdf.test','rdf','0'),('RdfTrackerAttributesTestCase','class','modules/rdf/rdf.test','rdf','0'),('RetrieveFileTestCase','class','modules/system/system.test','system','0'),('Rule','class','sites/all/modules/contrib/rules/includes/rules.plugins.inc','rules','0'),('RuleConditionSet','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.plugin.inc','rules_conditional','0'),('RuleConditionSetTestCase','class','sites/all/modules/contrib/rules_conditional/tests/rules_conditional.test','rules_conditional','0'),('RuleConditionSetUI','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.ui.inc','rules_conditional','0'),('RulesAbstractPlugin','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesAbstractPluginDefaults','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesAbstractPluginUI','class','sites/all/modules/contrib/rules/ui/ui.core.inc','rules','0'),('RulesAction','class','sites/all/modules/contrib/rules/includes/rules.plugins.inc','rules','0'),('RulesActionContainer','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesActionContainerUI','class','sites/all/modules/contrib/rules/ui/ui.core.inc','rules','0'),('RulesActionHandlerBase','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesActionHandlerInterface','interface','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesActionInterface','interface','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesActionSet','class','sites/all/modules/contrib/rules/includes/rules.plugins.inc','rules','0'),('RulesAnd','class','sites/all/modules/contrib/rules/includes/rules.plugins.inc','rules','0'),('RulesCondition','class','sites/all/modules/contrib/rules/includes/rules.plugins.inc','rules','0');
INSERT INTO `registry` VALUES ('RulesConditional','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.plugin.inc','rules_conditional','0'),('RulesConditionalBaseTestCase','class','sites/all/modules/contrib/rules_conditional/tests/rules_conditional.test','rules_conditional','0'),('RulesConditionalCase','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.plugin.inc','rules_conditional','0'),('RulesConditionalCaseUI','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.ui.inc','rules_conditional','0'),('RulesConditionalContainer','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.core.inc','rules_conditional','0'),('RulesConditionalDefaultCase','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.plugin.inc','rules_conditional','0'),('RulesConditionalElement','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.core.inc','rules_conditional','0'),('RulesConditionalElse','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.plugin.inc','rules_conditional','0'),('RulesConditionalEmptyUI','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.ui.inc','rules_conditional','0'),('RulesConditionalFrameworkTestCase','class','sites/all/modules/contrib/rules_conditional/tests/rules_conditional.test','rules_conditional','0'),('RulesConditionalIf','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.plugin.inc','rules_conditional','0'),('RulesConditionalPluginUI','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.ui.inc','rules_conditional','0'),('RulesConditionalPredicateElement','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.core.inc','rules_conditional','0'),('RulesConditionalPredicateUI','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.ui.inc','rules_conditional','0'),('RulesConditionalSwitch','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.plugin.inc','rules_conditional','0');
INSERT INTO `registry` VALUES ('RulesConditionalSwitchTestCase','class','sites/all/modules/contrib/rules_conditional/tests/rules_conditional.test','rules_conditional','0'),('RulesConditionalTestCase','class','sites/all/modules/contrib/rules_conditional/tests/rules_conditional.test','rules_conditional','0'),('RulesConditionalUITestCase','class','sites/all/modules/contrib/rules_conditional/tests/rules_conditional.test','rules_conditional','0'),('RulesConditionalWhile','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.plugin.inc','rules_conditional','0'),('RulesConditionalWhileTestCase','class','sites/all/modules/contrib/rules_conditional/tests/rules_conditional.test','rules_conditional','0'),('RulesConditionalWhileUI','class','sites/all/modules/contrib/rules_conditional/includes/rules_conditional.ui.inc','rules_conditional','0'),('RulesConditionContainer','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesConditionContainerUI','class','sites/all/modules/contrib/rules/ui/ui.core.inc','rules','0'),('RulesConditionHandlerBase','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesConditionHandlerInterface','interface','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesConditionInterface','interface','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesContainerPlugin','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesContainerPluginUI','class','sites/all/modules/contrib/rules/ui/ui.core.inc','rules','0'),('RulesData','class','sites/all/modules/contrib/rules/includes/rules.state.inc','rules','0'),('RulesDataDirectInputFormInterface','interface','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataInputEvaluator','class','sites/all/modules/contrib/rules/includes/rules.processor.inc','rules','0'),('RulesDataInputOptionsListInterface','interface','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataProcessor','class','sites/all/modules/contrib/rules/includes/rules.processor.inc','rules','0');
INSERT INTO `registry` VALUES ('RulesDataUI','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIBoolean','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIBundleEntity','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIDate','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIDecimal','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIDuration','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIEntity','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIEntityExportable','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIInteger','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIIPAddress','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIListEntity','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIListInteger','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIListText','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIListToken','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUITaxonomyVocabulary','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIText','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUITextFormatted','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUITextToken','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataUIURI','class','sites/all/modules/contrib/rules/ui/ui.data.inc','rules','0'),('RulesDataWrapperSavableInterface','interface','sites/all/modules/contrib/rules/includes/rules.state.inc','rules','0'),('RulesDateInputEvaluator','class','sites/all/modules/contrib/rules/modules/rules_core.eval.inc','rules','0'),('RulesDateOffsetProcessor','class','sites/all/modules/contrib/rules/modules/rules_core.eval.inc','rules','0');
INSERT INTO `registry` VALUES ('RulesDependencyException','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesElementMap','class','sites/all/modules/contrib/rules/ui/ui.core.inc','rules','0'),('RulesEntityController','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesEvaluationException','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesEventDefaultHandler','class','sites/all/modules/contrib/rules/includes/rules.event.inc','rules','0'),('RulesEventDispatcherInterface','interface','sites/all/modules/contrib/rules/includes/rules.event.inc','rules','0'),('RulesEventDispatcherTestCase','class','sites/all/modules/contrib/rules/tests/rules.test','rules','0'),('RulesEventHandlerBase','class','sites/all/modules/contrib/rules/includes/rules.event.inc','rules','0'),('RulesEventHandlerEntityBundle','class','sites/all/modules/contrib/rules/includes/rules.event.inc','rules','0'),('RulesEventHandlerInterface','interface','sites/all/modules/contrib/rules/includes/rules.event.inc','rules','0'),('RulesEventSet','class','sites/all/modules/contrib/rules/includes/rules.plugins.inc','rules','0'),('RulesException','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesExtendable','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesFeaturesController','class','sites/all/modules/contrib/rules/rules.features.inc','rules','0'),('RulesIdentifiableDataWrapper','class','sites/all/modules/contrib/rules/includes/rules.state.inc','rules','0'),('RulesIntegrationTestCase','class','sites/all/modules/contrib/rules/tests/rules.test','rules','0'),('RulesIntegrityException','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesInvocationEnabledTestCase','class','sites/all/modules/contrib/rules/tests/rules.test','rules','0'),('RulesLog','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesLoop','class','sites/all/modules/contrib/rules/includes/rules.plugins.inc','rules','0');
INSERT INTO `registry` VALUES ('RulesLoopUI','class','sites/all/modules/contrib/rules/ui/ui.plugins.inc','rules','0'),('RulesNodeConditionBase','class','sites/all/modules/contrib/rules/modules/node.eval.inc','rules','0'),('RulesNodeConditionPromoted','class','sites/all/modules/contrib/rules/modules/node.eval.inc','rules','0'),('RulesNodeConditionPublished','class','sites/all/modules/contrib/rules/modules/node.eval.inc','rules','0'),('RulesNodeConditionSticky','class','sites/all/modules/contrib/rules/modules/node.eval.inc','rules','0'),('RulesNodeConditionType','class','sites/all/modules/contrib/rules/modules/node.eval.inc','rules','0'),('RulesNumericOffsetProcessor','class','sites/all/modules/contrib/rules/modules/rules_core.eval.inc','rules','0'),('RulesOptimizationInterface','interface','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesOr','class','sites/all/modules/contrib/rules/includes/rules.plugins.inc','rules','0'),('RulesPHPDataProcessor','class','sites/all/modules/contrib/rules/modules/php.eval.inc','rules','0'),('RulesPHPEvaluator','class','sites/all/modules/contrib/rules/modules/php.eval.inc','rules','0'),('RulesPlugin','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesPluginFeaturesIntegrationInterace','interface','sites/all/modules/contrib/rules/rules.features.inc','rules','0'),('RulesPluginHandlerBase','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesPluginHandlerInterface','interface','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesPluginImplInterface','interface','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesPluginUI','class','sites/all/modules/contrib/rules/ui/ui.core.inc','rules','0'),('RulesPluginUIInterface','interface','sites/all/modules/contrib/rules/ui/ui.core.inc','rules','0'),('RulesReactionRule','class','sites/all/modules/contrib/rules/includes/rules.plugins.inc','rules','0'),('RulesReactionRuleUI','class','sites/all/modules/contrib/rules/ui/ui.plugins.inc','rules','0');
INSERT INTO `registry` VALUES ('RulesRecursiveElementIterator','class','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesRuleSet','class','sites/all/modules/contrib/rules/includes/rules.plugins.inc','rules','0'),('RulesRuleSetUI','class','sites/all/modules/contrib/rules/ui/ui.plugins.inc','rules','0'),('RulesRuleUI','class','sites/all/modules/contrib/rules/ui/ui.plugins.inc','rules','0'),('RulesState','class','sites/all/modules/contrib/rules/includes/rules.state.inc','rules','0'),('RulesTaxonomyVocabularyWrapper','class','sites/all/modules/contrib/rules/modules/rules_core.eval.inc','rules','0'),('RulesTestCase','class','sites/all/modules/contrib/rules/tests/rules.test','rules','0'),('RulesTestDataCase','class','sites/all/modules/contrib/rules/tests/rules.test','rules','0'),('RulesTokenEvaluator','class','sites/all/modules/contrib/rules/modules/system.eval.inc','rules','0'),('RulesTriggerableInterface','interface','sites/all/modules/contrib/rules/includes/rules.core.inc','rules','0'),('RulesTriggerTestCase','class','sites/all/modules/contrib/rules/tests/rules.test','rules','0'),('RulesUICategory','class','sites/all/modules/contrib/rules/ui/ui.core.inc','rules','0'),('RulesUIController','class','sites/all/modules/contrib/rules/ui/ui.controller.inc','rules','0'),('RulesURIInputEvaluator','class','sites/all/modules/contrib/rules/modules/rules_core.eval.inc','rules','0'),('SchemaCache','class','includes/bootstrap.inc','','0'),('SearchAdvancedSearchForm','class','modules/search/search.test','search','0'),('SearchBlockTestCase','class','modules/search/search.test','search','0'),('SearchCommentCountToggleTestCase','class','modules/search/search.test','search','0'),('SearchCommentTestCase','class','modules/search/search.test','search','0'),('SearchConfigSettingsForm','class','modules/search/search.test','search','0'),('SearchEmbedForm','class','modules/search/search.test','search','0'),('SearchExactTestCase','class','modules/search/search.test','search','0'),('SearchExcerptTestCase','class','modules/search/search.test','search','0'),('SearchExpressionInsertExtractTestCase','class','modules/search/search.test','search','0');
INSERT INTO `registry` VALUES ('SearchKeywordsConditions','class','modules/search/search.test','search','0'),('SearchLanguageTestCase','class','modules/search/search.test','search','0'),('SearchMatchTestCase','class','modules/search/search.test','search','0'),('SearchNodeAccessTest','class','modules/search/search.test','search','0'),('SearchNodeTagTest','class','modules/search/search.test','search','0'),('SearchNumberMatchingTestCase','class','modules/search/search.test','search','0'),('SearchNumbersTestCase','class','modules/search/search.test','search','0'),('SearchPageOverride','class','modules/search/search.test','search','0'),('SearchPageText','class','modules/search/search.test','search','0'),('SearchQuery','class','modules/search/search.extender.inc','search','0'),('SearchRankingTestCase','class','modules/search/search.test','search','0'),('SearchSetLocaleTest','class','modules/search/search.test','search','0'),('SearchSimplifyTestCase','class','modules/search/search.test','search','0'),('SearchTokenizerTestCase','class','modules/search/search.test','search','0'),('SelectQuery','class','includes/database/select.inc','','0'),('SelectQueryExtender','class','includes/database/select.inc','','0'),('SelectQueryInterface','interface','includes/database/select.inc','','0'),('SelectQuery_pgsql','class','includes/database/pgsql/select.inc','','0'),('SelectQuery_sqlite','class','includes/database/sqlite/select.inc','','0'),('ShortcutLinksTestCase','class','modules/shortcut/shortcut.test','shortcut','0'),('ShortcutSetsTestCase','class','modules/shortcut/shortcut.test','shortcut','0'),('ShortcutTestCase','class','modules/shortcut/shortcut.test','shortcut','0'),('ShutdownFunctionsTest','class','modules/system/system.test','system','0'),('SiteMaintenanceTestCase','class','modules/system/system.test','system','0'),('SkipDotsRecursiveDirectoryIterator','class','includes/filetransfer/filetransfer.inc','','0'),('SMTP','class','sites/all/modules/contrib/smtp/smtp.transport.inc','smtp','0'),('SmtpMailSystem','class','sites/all/modules/contrib/smtp/smtp.mail.inc','smtp','0'),('SmtpUnitTest','class','sites/all/modules/contrib/smtp/tests/smtp.unit.test','smtp','0');
INSERT INTO `registry` VALUES ('StatisticsAdminTestCase','class','modules/statistics/statistics.test','statistics','0'),('StatisticsBlockVisitorsTestCase','class','modules/statistics/statistics.test','statistics','0'),('StatisticsLoggingTestCase','class','modules/statistics/statistics.test','statistics','0'),('StatisticsReportsTestCase','class','modules/statistics/statistics.test','statistics','0'),('StatisticsTestCase','class','modules/statistics/statistics.test','statistics','0'),('StatisticsTokenReplaceTestCase','class','modules/statistics/statistics.test','statistics','0'),('StreamWrapperInterface','interface','includes/stream_wrappers.inc','','0'),('SummaryLengthTestCase','class','modules/node/node.test','node','0'),('SystemAdminTestCase','class','modules/system/system.test','system','0'),('SystemAuthorizeCase','class','modules/system/system.test','system','0'),('SystemBlockTestCase','class','modules/system/system.test','system','0'),('SystemIndexPhpTest','class','modules/system/system.test','system','0'),('SystemInfoAlterTestCase','class','modules/system/system.test','system','0'),('SystemMainContentFallback','class','modules/system/system.test','system','0'),('SystemQueue','class','modules/system/system.queue.inc','system','0'),('SystemThemeFunctionalTest','class','modules/system/system.test','system','0'),('SystemValidTokenTest','class','modules/system/system.test','system','0'),('TableSort','class','includes/tablesort.inc','','0'),('TaxonomyEFQTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyHooksTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyLegacyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyLoadMultipleTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyQueryAlterTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyRSSTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyTermController','class','modules/taxonomy/taxonomy.module','taxonomy','0'),('TaxonomyTermFieldMultipleVocabularyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0');
INSERT INTO `registry` VALUES ('TaxonomyTermFieldTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyTermFunctionTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyTermIndexTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyTermTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyThemeTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyTokenReplaceTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyVocabularyController','class','modules/taxonomy/taxonomy.module','taxonomy','0'),('TaxonomyVocabularyFunctionalTest','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyVocabularyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TaxonomyWebTestCase','class','modules/taxonomy/taxonomy.test','taxonomy','0'),('TestingMailSystem','class','modules/system/system.mail.inc','system','0'),('TextFieldTestCase','class','modules/field/modules/text/text.test','text','0'),('TextSummaryTestCase','class','modules/field/modules/text/text.test','text','0'),('TextTranslationTestCase','class','modules/field/modules/text/text.test','text','0'),('ThemeRegistry','class','includes/theme.inc','','0'),('ThemeUpdater','class','modules/system/system.updater.inc','system','0'),('TokenArrayTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenBlockTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenCommentTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenCurrentPageTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenDateTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenEntityTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenFileTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenMenuTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenNodeTestCase','class','sites/all/modules/contrib/token/token.test','token','0');
INSERT INTO `registry` VALUES ('TokenProfileTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenRandomTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenReplaceTestCase','class','modules/system/system.test','system','0'),('TokenScanTest','class','modules/system/system.test','system','0'),('TokenTaxonomyTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenTestHelper','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenUnitTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenURLTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TokenUserTestCase','class','sites/all/modules/contrib/token/token.test','token','0'),('TOUSettingsTestCase','class','sites/all/modules/contrib/terms_of_use/tests/terms_of_use.test','terms_of_use','0'),('TOUWebTestCase','class','sites/all/modules/contrib/terms_of_use/tests/terms_of_use.test','terms_of_use','0'),('TruncateQuery','class','includes/database/query.inc','','0'),('TruncateQuery_mysql','class','includes/database/mysql/query.inc','','0'),('TruncateQuery_sqlite','class','includes/database/sqlite/query.inc','','0'),('TXTExportViewsDataExportTests','class','sites/all/modules/contrib/views_data_export/tests/txt_export.test','views_data_export','0'),('UpdateQuery','class','includes/database/query.inc','','0'),('UpdateQuery_pgsql','class','includes/database/pgsql/query.inc','','0'),('UpdateQuery_sqlite','class','includes/database/sqlite/query.inc','','0'),('Updater','class','includes/updater.inc','','0'),('UpdaterException','class','includes/updater.inc','','0'),('UpdaterFileTransferException','class','includes/updater.inc','','0'),('UpdateScriptFunctionalTest','class','modules/system/system.test','system','0'),('UserAccountLinksUnitTests','class','modules/user/user.test','user','0'),('UserAdminTestCase','class','modules/user/user.test','user','0'),('UserAuthmapAssignmentTestCase','class','modules/user/user.test','user','0'),('UserAutocompleteTestCase','class','modules/user/user.test','user','0');
INSERT INTO `registry` VALUES ('UserBlocksUnitTests','class','modules/user/user.test','user','0'),('UserCancelTestCase','class','modules/user/user.test','user','0'),('UserController','class','modules/user/user.module','user','0'),('UserCreateTestCase','class','modules/user/user.test','user','0'),('UserEditedOwnAccountTestCase','class','modules/user/user.test','user','0'),('UserEditRebuildTestCase','class','modules/user/user.test','user','0'),('UserEditTestCase','class','modules/user/user.test','user','0'),('UserLoginTestCase','class','modules/user/user.test','user','0'),('UserPasswordResetTestCase','class','modules/user/user.test','user','0'),('UserPermissionsTestCase','class','modules/user/user.test','user','0'),('UserPictureTestCase','class','modules/user/user.test','user','0'),('UserRegistrationTestCase','class','modules/user/user.test','user','0'),('UserRoleAdminTestCase','class','modules/user/user.test','user','0'),('UserRolesAssignmentTestCase','class','modules/user/user.test','user','0'),('UserSaveTestCase','class','modules/user/user.test','user','0'),('UserSignatureTestCase','class','modules/user/user.test','user','0'),('UserTimeZoneFunctionalTest','class','modules/user/user.test','user','0'),('UserTokenReplaceTestCase','class','modules/user/user.test','user','0'),('UserUserSearchTestCase','class','modules/user/user.test','user','0'),('UserValidateCurrentPassCustomForm','class','modules/user/user.test','user','0'),('UserValidationTestCase','class','modules/user/user.test','user','0'),('view','class','sites/all/modules/contrib/views/includes/view.inc','views','10'),('ViewsAccessTest','class','sites/all/modules/contrib/views/tests/views_access.test','views','0'),('ViewsAnalyzeTest','class','sites/all/modules/contrib/views/tests/views_analyze.test','views','0'),('ViewsArgumentDefaultTest','class','sites/all/modules/contrib/views/tests/views_argument_default.test','views','0'),('ViewsArgumentValidatorTest','class','sites/all/modules/contrib/views/tests/views_argument_validator.test','views','0'),('ViewsBasicTest','class','sites/all/modules/contrib/views/tests/views_basic.test','views','0');
INSERT INTO `registry` VALUES ('ViewsBulkOperationsAction','class','sites/all/modules/contrib/views_bulk_operations/plugins/operation_types/action.class.php','views_bulk_operations','0'),('ViewsBulkOperationsBaseOperation','class','sites/all/modules/contrib/views_bulk_operations/plugins/operation_types/base.class.php','views_bulk_operations','0'),('ViewsBulkOperationsRulesComponent','class','sites/all/modules/contrib/views_bulk_operations/plugins/operation_types/rules_component.class.php','views_bulk_operations','0'),('ViewsCacheTest','class','sites/all/modules/contrib/views/tests/views_cache.test','views','0'),('ViewsDataExportAccessTest','class','sites/all/modules/contrib/views_data_export/tests/access.test','views_data_export','0'),('ViewsDataExportBaseTest','class','sites/all/modules/contrib/views_data_export/tests/base.test','views_data_export','0'),('ViewsDataExportGarbageCollectionTest','class','sites/all/modules/contrib/views_data_export/tests/garbagecollection.test','views_data_export','0'),('ViewsDataExportSimpleExportTest','class','sites/all/modules/contrib/views_data_export/tests/base.test','views_data_export','0'),('ViewsExposedFormTest','class','sites/all/modules/contrib/views/tests/views_exposed_form.test','views','10'),('viewsFieldApiDataTest','class','sites/all/modules/contrib/views/tests/field/views_fieldapi.test','views','0'),('ViewsFieldApiTestHelper','class','sites/all/modules/contrib/views/tests/field/views_fieldapi.test','views','0'),('ViewsGlossaryTestCase','class','sites/all/modules/contrib/views/tests/views_glossary.test','views','0'),('ViewsHandlerAreaTextTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_area_text.test','views','0'),('viewsHandlerArgumentCommentUserUidTest','class','sites/all/modules/contrib/views/tests/comment/views_handler_argument_comment_user_uid.test','views','0'),('ViewsHandlerArgumentNullTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_argument_null.test','views','0'),('ViewsHandlerArgumentStringTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_argument_string.test','views','0');
INSERT INTO `registry` VALUES ('ViewsHandlerFieldBooleanTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_boolean.test','views','0'),('ViewsHandlerFieldCustomTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_custom.test','views','0'),('ViewsHandlerFieldDateTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_date.test','views','0'),('viewsHandlerFieldFieldTest','class','sites/all/modules/contrib/views/tests/field/views_fieldapi.test','views','0'),('ViewsHandlerFieldMath','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_math.test','views','0'),('ViewsHandlerFieldTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field.test','views','0'),('ViewsHandlerFieldUrlTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_url.test','views','0'),('viewsHandlerFieldUserNameTest','class','sites/all/modules/contrib/views/tests/user/views_handler_field_user_name.test','views','0'),('ViewsHandlerFileExtensionTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_file_extension.test','views','0'),('ViewsHandlerFilterCombineTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_filter_combine.test','views','0'),('viewsHandlerFilterCommentUserUidTest','class','sites/all/modules/contrib/views/tests/comment/views_handler_filter_comment_user_uid.test','views','0'),('ViewsHandlerFilterCounterTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_counter.test','views','0'),('ViewsHandlerFilterDateTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_filter_date.test','views','0'),('ViewsHandlerFilterEqualityTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_filter_equality.test','views','0'),('ViewsHandlerFilterInOperator','class','sites/all/modules/contrib/views/tests/handlers/views_handler_filter_in_operator.test','views','0'),('ViewsHandlerFilterNumericTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_filter_numeric.test','views','0');
INSERT INTO `registry` VALUES ('ViewsHandlerFilterStringTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_filter_string.test','views','0'),('ViewsHandlerRelationshipNodeTermDataTest','class','sites/all/modules/contrib/views/tests/taxonomy/views_handler_relationship_node_term_data.test','views','0'),('ViewsHandlerSortDateTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_sort_date.test','views','0'),('ViewsHandlerSortRandomTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_sort_random.test','views','0'),('ViewsHandlerSortTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_sort.test','views','0'),('ViewsHandlersTest','class','sites/all/modules/contrib/views/tests/views_handlers.test','views','0'),('ViewsHandlerTest','class','sites/all/modules/contrib/views/tests/handlers/views_handlers.test','views','0'),('ViewsHandlerTestFileSize','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_file_size.test','views','0'),('ViewsHandlerTestXss','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_xss.test','views','0'),('ViewsModuleTest','class','sites/all/modules/contrib/views/tests/views_module.test','views','0'),('ViewsNodeRevisionRelationsTestCase','class','sites/all/modules/contrib/views/tests/node/views_node_revision_relations.test','views','0'),('ViewsPagerTest','class','sites/all/modules/contrib/views/tests/views_pager.test','views','0'),('ViewsPagerTestCase','class','sites/all/modules/contrib/date/tests/date_views_pager.test','date','0'),('ViewsPluginDisplayTestCase','class','sites/all/modules/contrib/views/tests/plugins/views_plugin_display.test','views','0'),('viewsPluginStyleJumpMenuTest','class','sites/all/modules/contrib/views/tests/styles/views_plugin_style_jump_menu.test','views','0'),('ViewsPluginStyleMappingTest','class','sites/all/modules/contrib/views/tests/styles/views_plugin_style_mapping.test','views','0'),('ViewsPluginStyleTestBase','class','sites/all/modules/contrib/views/tests/styles/views_plugin_style_base.test','views','0');
INSERT INTO `registry` VALUES ('ViewsPluginStyleTestCase','class','sites/all/modules/contrib/views/tests/styles/views_plugin_style.test','views','10'),('ViewsPluginStyleUnformattedTestCase','class','sites/all/modules/contrib/views/tests/styles/views_plugin_style_unformatted.test','views','0'),('ViewsQueryGroupByTest','class','sites/all/modules/contrib/views/tests/views_groupby.test','views','0'),('viewsSearchQuery','class','sites/all/modules/contrib/views/modules/search/views_handler_filter_search.inc','views','10'),('ViewsSqlTest','class','sites/all/modules/contrib/views/tests/views_query.test','views','0'),('ViewsTestCase','class','sites/all/modules/contrib/views/tests/views_query.test','views','0'),('ViewsTranslatableTest','class','sites/all/modules/contrib/views/tests/views_translatable.test','views','0'),('ViewsUiBaseViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','views_ui','0'),('ViewsUiCommentViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_comment_views_wizard.class.php','views_ui','0'),('ViewsUiFileManagedViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_file_managed_views_wizard.class.php','views_ui','0'),('viewsUiGroupbyTestCase','class','sites/all/modules/contrib/views/tests/views_groupby.test','views','0'),('ViewsUiNodeRevisionViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_node_revision_views_wizard.class.php','views_ui','0'),('ViewsUiNodeViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_node_views_wizard.class.php','views_ui','0'),('ViewsUiTaxonomyTermViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_taxonomy_term_views_wizard.class.php','views_ui','0'),('ViewsUiUsersViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_users_views_wizard.class.php','views_ui','0'),('ViewsUIWizardBasicTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views','0');
INSERT INTO `registry` VALUES ('ViewsUIWizardDefaultViewsTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views','0'),('ViewsUIWizardHelper','class','sites/all/modules/contrib/views/tests/views_ui.test','views','0'),('ViewsUIWizardItemsPerPageTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views','0'),('ViewsUIWizardJumpMenuTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views','0'),('ViewsUIWizardMenuTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views','0'),('ViewsUIWizardOverrideDisplaysTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views','0'),('ViewsUIWizardSortingTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views','0'),('ViewsUIWizardTaggedWithTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views','0'),('ViewsUpgradeTestCase','class','sites/all/modules/contrib/views/tests/views_upgrade.test','views','0'),('ViewsUserArgumentDefault','class','sites/all/modules/contrib/views/tests/user/views_user_argument_default.test','views','0'),('ViewsUserArgumentValidate','class','sites/all/modules/contrib/views/tests/user/views_user_argument_validate.test','views','0'),('ViewsUserTestCase','class','sites/all/modules/contrib/views/tests/user/views_user.test','views','0'),('ViewsViewTest','class','sites/all/modules/contrib/views/tests/views_view.test','views','0'),('ViewsWizardException','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','views_ui','0'),('ViewsWizardInterface','interface','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','views_ui','0'),('views_bulk_operations_handler_field_operations','class','sites/all/modules/contrib/views_bulk_operations/views/views_bulk_operations_handler_field_operations.inc','views_bulk_operations','0'),('views_content_plugin_display_ctools_context','class','sites/all/modules/contrib/ctools/views_content/plugins/views/views_content_plugin_display_ctools_context.inc','views_content','0');
INSERT INTO `registry` VALUES ('views_content_plugin_display_panel_pane','class','sites/all/modules/contrib/ctools/views_content/plugins/views/views_content_plugin_display_panel_pane.inc','views_content','0'),('views_content_plugin_style_ctools_context','class','sites/all/modules/contrib/ctools/views_content/plugins/views/views_content_plugin_style_ctools_context.inc','views_content','0'),('views_data_export_plugin_display_export','class','sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_display_export.inc','views_data_export','0'),('views_data_export_plugin_query_default_batched','class','sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_display_export.inc','views_data_export','0'),('views_data_export_plugin_query_pgsql_batched','class','sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_display_export.inc','views_data_export','0'),('views_data_export_plugin_style_export','class','sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_style_export.inc','views_data_export','0'),('views_data_export_plugin_style_export_csv','class','sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_style_export_csv.inc','views_data_export','0'),('views_data_export_plugin_style_export_xml','class','sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_style_export_xml.inc','views_data_export','0'),('views_db_object','class','sites/all/modules/contrib/views/includes/view.inc','views','10'),('views_display','class','sites/all/modules/contrib/views/includes/view.inc','views','10'),('views_handler','class','sites/all/modules/contrib/views/includes/handlers.inc','views','10'),('views_handler_area','class','sites/all/modules/contrib/views/handlers/views_handler_area.inc','views','0'),('views_handler_area_broken','class','sites/all/modules/contrib/views/handlers/views_handler_area.inc','views','0'),('views_handler_area_messages','class','sites/all/modules/contrib/views/handlers/views_handler_area_messages.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_area_result','class','sites/all/modules/contrib/views/handlers/views_handler_area_result.inc','views','10'),('views_handler_area_text','class','sites/all/modules/contrib/views/handlers/views_handler_area_text.inc','views','0'),('views_handler_area_text_custom','class','sites/all/modules/contrib/views/handlers/views_handler_area_text_custom.inc','views','0'),('views_handler_area_view','class','sites/all/modules/contrib/views/handlers/views_handler_area_view.inc','views','0'),('views_handler_argument','class','sites/all/modules/contrib/views/handlers/views_handler_argument.inc','views','0'),('views_handler_argument_aggregator_category_cid','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_argument_aggregator_category_cid.inc','views','0'),('views_handler_argument_aggregator_fid','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_argument_aggregator_fid.inc','views','0'),('views_handler_argument_aggregator_iid','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_argument_aggregator_iid.inc','views','0'),('views_handler_argument_broken','class','sites/all/modules/contrib/views/handlers/views_handler_argument.inc','views','0'),('views_handler_argument_comment_user_uid','class','sites/all/modules/contrib/views/modules/comment/views_handler_argument_comment_user_uid.inc','views','0'),('views_handler_argument_date','class','sites/all/modules/contrib/views/handlers/views_handler_argument_date.inc','views','0'),('views_handler_argument_field_list','class','sites/all/modules/contrib/views/modules/field/views_handler_argument_field_list.inc','views','0'),('views_handler_argument_field_list_string','class','sites/all/modules/contrib/views/modules/field/views_handler_argument_field_list_string.inc','views','0'),('views_handler_argument_file_fid','class','sites/all/modules/contrib/views/modules/system/views_handler_argument_file_fid.inc','views','0'),('views_handler_argument_formula','class','sites/all/modules/contrib/views/handlers/views_handler_argument_formula.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_argument_group_by_numeric','class','sites/all/modules/contrib/views/handlers/views_handler_argument_group_by_numeric.inc','views','0'),('views_handler_argument_locale_group','class','sites/all/modules/contrib/views/modules/locale/views_handler_argument_locale_group.inc','views','0'),('views_handler_argument_locale_language','class','sites/all/modules/contrib/views/modules/locale/views_handler_argument_locale_language.inc','views','0'),('views_handler_argument_many_to_one','class','sites/all/modules/contrib/views/handlers/views_handler_argument_many_to_one.inc','views','0'),('views_handler_argument_node_created_day','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','views','10'),('views_handler_argument_node_created_fulldate','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','views','10'),('views_handler_argument_node_created_month','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','views','10'),('views_handler_argument_node_created_week','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','views','10'),('views_handler_argument_node_created_year','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','views','10'),('views_handler_argument_node_created_year_month','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','views','10'),('views_handler_argument_node_language','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_node_language.inc','views','0'),('views_handler_argument_node_nid','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_node_nid.inc','views','0'),('views_handler_argument_node_tnid','class','sites/all/modules/contrib/views/modules/translation/views_handler_argument_node_tnid.inc','views','0'),('views_handler_argument_node_type','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_node_type.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_argument_node_uid_revision','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_node_uid_revision.inc','views','0'),('views_handler_argument_node_vid','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_node_vid.inc','views','0'),('views_handler_argument_null','class','sites/all/modules/contrib/views/handlers/views_handler_argument_null.inc','views','0'),('views_handler_argument_numeric','class','sites/all/modules/contrib/views/handlers/views_handler_argument_numeric.inc','views','0'),('views_handler_argument_search','class','sites/all/modules/contrib/views/modules/search/views_handler_argument_search.inc','views','10'),('views_handler_argument_string','class','sites/all/modules/contrib/views/handlers/views_handler_argument_string.inc','views','0'),('views_handler_argument_taxonomy','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_taxonomy.inc','views','0'),('views_handler_argument_term_node_tid','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid.inc','views','10'),('views_handler_argument_term_node_tid_depth','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid_depth.inc','views','0'),('views_handler_argument_term_node_tid_depth_join','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_join.inc','views','0'),('views_handler_argument_term_node_tid_depth_modifier','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc','views','0'),('views_handler_argument_tracker_comment_user_uid','class','sites/all/modules/contrib/views/modules/tracker/views_handler_argument_tracker_comment_user_uid.inc','views','0'),('views_handler_argument_users_roles_rid','class','sites/all/modules/contrib/views/modules/user/views_handler_argument_users_roles_rid.inc','views','0'),('views_handler_argument_user_uid','class','sites/all/modules/contrib/views/modules/user/views_handler_argument_user_uid.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_argument_vocabulary_machine_name','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc','views','0'),('views_handler_argument_vocabulary_vid','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_vocabulary_vid.inc','views','0'),('views_handler_field','class','sites/all/modules/contrib/views/handlers/views_handler_field.inc','views','0'),('views_handler_field_accesslog_path','class','sites/all/modules/contrib/views/modules/statistics/views_handler_field_accesslog_path.inc','views','0'),('views_handler_field_aggregator_category','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_field_aggregator_category.inc','views','0'),('views_handler_field_aggregator_title_link','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_field_aggregator_title_link.inc','views','0'),('views_handler_field_aggregator_xss','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_field_aggregator_xss.inc','views','0'),('views_handler_field_boolean','class','sites/all/modules/contrib/views/handlers/views_handler_field_boolean.inc','views','0'),('views_handler_field_broken','class','sites/all/modules/contrib/views/handlers/views_handler_field.inc','views','0'),('views_handler_field_comment','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment.inc','views','0'),('views_handler_field_comment_depth','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_depth.inc','views','0'),('views_handler_field_comment_link','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link.inc','views','0'),('views_handler_field_comment_link_approve','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_approve.inc','views','0'),('views_handler_field_comment_link_delete','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_delete.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_field_comment_link_edit','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_edit.inc','views','0'),('views_handler_field_comment_link_reply','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_reply.inc','views','0'),('views_handler_field_comment_node_link','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_node_link.inc','views','0'),('views_handler_field_comment_username','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_username.inc','views','0'),('views_handler_field_contact_link','class','sites/all/modules/contrib/views/modules/contact/views_handler_field_contact_link.inc','views','0'),('views_handler_field_contextual_links','class','sites/all/modules/contrib/views/handlers/views_handler_field_contextual_links.inc','views','0'),('views_handler_field_counter','class','sites/all/modules/contrib/views/handlers/views_handler_field_counter.inc','views','0'),('views_handler_field_ctools_dropdown','class','sites/all/modules/contrib/views/handlers/views_handler_field_ctools_dropdown.inc','views','0'),('views_handler_field_custom','class','sites/all/modules/contrib/views/handlers/views_handler_field_custom.inc','views','0'),('views_handler_field_date','class','sites/all/modules/contrib/views/handlers/views_handler_field_date.inc','views','0'),('views_handler_field_entity','class','sites/all/modules/contrib/views/handlers/views_handler_field_entity.inc','views','0'),('views_handler_field_field','class','sites/all/modules/contrib/views/modules/field/views_handler_field_field.inc','views','0'),('views_handler_field_file','class','sites/all/modules/contrib/views/modules/system/views_handler_field_file.inc','views','0'),('views_handler_field_file_extension','class','sites/all/modules/contrib/views/modules/system/views_handler_field_file_extension.inc','views','0'),('views_handler_field_file_filemime','class','sites/all/modules/contrib/views/modules/system/views_handler_field_file_filemime.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_field_file_size','class','sites/all/modules/contrib/views/handlers/views_handler_field.inc','views','0'),('views_handler_field_file_status','class','sites/all/modules/contrib/views/modules/system/views_handler_field_file_status.inc','views','0'),('views_handler_field_file_uri','class','sites/all/modules/contrib/views/modules/system/views_handler_field_file_uri.inc','views','0'),('views_handler_field_filter_format_name','class','sites/all/modules/contrib/views/modules/filter/views_handler_field_filter_format_name.inc','views','0'),('views_handler_field_history_user_timestamp','class','sites/all/modules/contrib/views/modules/node/views_handler_field_history_user_timestamp.inc','views','0'),('views_handler_field_last_comment_timestamp','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_last_comment_timestamp.inc','views','0'),('views_handler_field_links','class','sites/all/modules/contrib/views/handlers/views_handler_field_links.inc','views','0'),('views_handler_field_locale_group','class','sites/all/modules/contrib/views/modules/locale/views_handler_field_locale_group.inc','views','0'),('views_handler_field_locale_language','class','sites/all/modules/contrib/views/modules/locale/views_handler_field_locale_language.inc','views','0'),('views_handler_field_locale_link_edit','class','sites/all/modules/contrib/views/modules/locale/views_handler_field_locale_link_edit.inc','views','0'),('views_handler_field_machine_name','class','sites/all/modules/contrib/views/handlers/views_handler_field_machine_name.inc','views','0'),('views_handler_field_markup','class','sites/all/modules/contrib/views/handlers/views_handler_field_markup.inc','views','0'),('views_handler_field_math','class','sites/all/modules/contrib/views/handlers/views_handler_field_math.inc','views','0'),('views_handler_field_ncs_last_comment_name','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_ncs_last_comment_name.inc','views','0'),('views_handler_field_ncs_last_updated','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_ncs_last_updated.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_field_node','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node.inc','views','0'),('views_handler_field_node_comment','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_node_comment.inc','views','0'),('views_handler_field_node_counter_timestamp','class','sites/all/modules/contrib/views/modules/statistics/views_handler_field_node_counter_timestamp.inc','views','0'),('views_handler_field_node_language','class','sites/all/modules/contrib/views/modules/locale/views_handler_field_node_language.inc','views','0'),('views_handler_field_node_link','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_link.inc','views','0'),('views_handler_field_node_link_delete','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_link_delete.inc','views','0'),('views_handler_field_node_link_edit','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_link_edit.inc','views','0'),('views_handler_field_node_link_translate','class','sites/all/modules/contrib/views/modules/translation/views_handler_field_node_link_translate.inc','views','0'),('views_handler_field_node_new_comments','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_node_new_comments.inc','views','0'),('views_handler_field_node_path','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_path.inc','views','0'),('views_handler_field_node_revision','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision.inc','views','0'),('views_handler_field_node_revision_link','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision_link.inc','views','0'),('views_handler_field_node_revision_link_delete','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision_link_delete.inc','views','0'),('views_handler_field_node_revision_link_revert','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision_link_revert.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_field_node_translation_link','class','sites/all/modules/contrib/views/modules/translation/views_handler_field_node_translation_link.inc','views','0'),('views_handler_field_node_type','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_type.inc','views','0'),('views_handler_field_node_version_count','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_version_count.inc','views','0'),('views_handler_field_numeric','class','sites/all/modules/contrib/views/handlers/views_handler_field_numeric.inc','views','0'),('views_handler_field_prerender_list','class','sites/all/modules/contrib/views/handlers/views_handler_field_prerender_list.inc','views','0'),('views_handler_field_profile_date','class','sites/all/modules/contrib/views/modules/profile/views_handler_field_profile_date.inc','views','0'),('views_handler_field_profile_list','class','sites/all/modules/contrib/views/modules/profile/views_handler_field_profile_list.inc','views','0'),('views_handler_field_search_score','class','sites/all/modules/contrib/views/modules/search/views_handler_field_search_score.inc','views','0'),('views_handler_field_serialized','class','sites/all/modules/contrib/views/handlers/views_handler_field_serialized.inc','views','0'),('views_handler_field_statistics_numeric','class','sites/all/modules/contrib/views/modules/statistics/views_handler_field_statistics_numeric.inc','views','0'),('views_handler_field_taxonomy','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_field_taxonomy.inc','views','10'),('views_handler_field_term_link_edit','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_field_term_link_edit.inc','views','0'),('views_handler_field_term_node_tid','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_field_term_node_tid.inc','views','10'),('views_handler_field_time_interval','class','sites/all/modules/contrib/views/handlers/views_handler_field_time_interval.inc','views','0'),('views_handler_field_url','class','sites/all/modules/contrib/views/handlers/views_handler_field_url.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_field_user','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user.inc','views','0'),('views_handler_field_user_language','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_language.inc','views','0'),('views_handler_field_user_link','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_link.inc','views','0'),('views_handler_field_user_link_cancel','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_link_cancel.inc','views','0'),('views_handler_field_user_link_edit','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_link_edit.inc','views','0'),('views_handler_field_user_mail','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_mail.inc','views','0'),('views_handler_field_user_name','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_name.inc','views','10'),('views_handler_field_user_permissions','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_permissions.inc','views','0'),('views_handler_field_user_picture','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_picture.inc','views','0'),('views_handler_field_user_roles','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_roles.inc','views','0'),('views_handler_field_xss','class','sites/all/modules/contrib/views/handlers/views_handler_field.inc','views','0'),('views_handler_filter','class','sites/all/modules/contrib/views/handlers/views_handler_filter.inc','views','10'),('views_handler_filter_aggregator_category_cid','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_filter_aggregator_category_cid.inc','views','0'),('views_handler_filter_boolean_operator','class','sites/all/modules/contrib/views/handlers/views_handler_filter_boolean_operator.inc','views','0'),('views_handler_filter_boolean_operator_string','class','sites/all/modules/contrib/views/handlers/views_handler_filter_boolean_operator_string.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_filter_broken','class','sites/all/modules/contrib/views/handlers/views_handler_filter.inc','views','10'),('views_handler_filter_combine','class','sites/all/modules/contrib/views/handlers/views_handler_filter_combine.inc','views','0'),('views_handler_filter_comment_user_uid','class','sites/all/modules/contrib/views/modules/comment/views_handler_filter_comment_user_uid.inc','views','0'),('views_handler_filter_date','class','sites/all/modules/contrib/views/handlers/views_handler_filter_date.inc','views','0'),('views_handler_filter_entity_bundle','class','sites/all/modules/contrib/views/handlers/views_handler_filter_entity_bundle.inc','views','0'),('views_handler_filter_equality','class','sites/all/modules/contrib/views/handlers/views_handler_filter_equality.inc','views','0'),('views_handler_filter_fields_compare','class','sites/all/modules/contrib/views/handlers/views_handler_filter_fields_compare.inc','views','0'),('views_handler_filter_field_list','class','sites/all/modules/contrib/views/modules/field/views_handler_filter_field_list.inc','views','0'),('views_handler_filter_field_list_boolean','class','sites/all/modules/contrib/views/modules/field/views_handler_filter_field_list_boolean.inc','views','0'),('views_handler_filter_file_status','class','sites/all/modules/contrib/views/modules/system/views_handler_filter_file_status.inc','views','0'),('views_handler_filter_group_by_numeric','class','sites/all/modules/contrib/views/handlers/views_handler_filter_group_by_numeric.inc','views','0'),('views_handler_filter_history_user_timestamp','class','sites/all/modules/contrib/views/modules/node/views_handler_filter_history_user_timestamp.inc','views','0'),('views_handler_filter_in_operator','class','sites/all/modules/contrib/views/handlers/views_handler_filter_in_operator.inc','views','0'),('views_handler_filter_locale_group','class','sites/all/modules/contrib/views/modules/locale/views_handler_filter_locale_group.inc','views','0'),('views_handler_filter_locale_language','class','sites/all/modules/contrib/views/modules/locale/views_handler_filter_locale_language.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_filter_locale_version','class','sites/all/modules/contrib/views/modules/locale/views_handler_filter_locale_version.inc','views','0'),('views_handler_filter_many_to_one','class','sites/all/modules/contrib/views/handlers/views_handler_filter_many_to_one.inc','views','0'),('views_handler_filter_ncs_last_updated','class','sites/all/modules/contrib/views/modules/comment/views_handler_filter_ncs_last_updated.inc','views','0'),('views_handler_filter_node_access','class','sites/all/modules/contrib/views/modules/node/views_handler_filter_node_access.inc','views','0'),('views_handler_filter_node_comment','class','sites/all/modules/contrib/views/modules/comment/views_handler_filter_node_comment.inc','views','0'),('views_handler_filter_node_language','class','sites/all/modules/contrib/views/modules/locale/views_handler_filter_node_language.inc','views','0'),('views_handler_filter_node_status','class','sites/all/modules/contrib/views/modules/node/views_handler_filter_node_status.inc','views','0'),('views_handler_filter_node_tnid','class','sites/all/modules/contrib/views/modules/translation/views_handler_filter_node_tnid.inc','views','0'),('views_handler_filter_node_tnid_child','class','sites/all/modules/contrib/views/modules/translation/views_handler_filter_node_tnid_child.inc','views','0'),('views_handler_filter_node_type','class','sites/all/modules/contrib/views/modules/node/views_handler_filter_node_type.inc','views','0'),('views_handler_filter_node_uid_revision','class','sites/all/modules/contrib/views/modules/node/views_handler_filter_node_uid_revision.inc','views','0'),('views_handler_filter_node_version_count','class','sites/all/modules/contrib/views/modules/node/views_handler_filter_node_version_count.inc','views','0'),('views_handler_filter_numeric','class','sites/all/modules/contrib/views/handlers/views_handler_filter_numeric.inc','views','0'),('views_handler_filter_profile_selection','class','sites/all/modules/contrib/views/modules/profile/views_handler_filter_profile_selection.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_filter_search','class','sites/all/modules/contrib/views/modules/search/views_handler_filter_search.inc','views','10'),('views_handler_filter_string','class','sites/all/modules/contrib/views/handlers/views_handler_filter_string.inc','views','0'),('views_handler_filter_system_type','class','sites/all/modules/contrib/views/modules/system/views_handler_filter_system_type.inc','views','0'),('views_handler_filter_term_node_tid','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_term_node_tid.inc','views','10'),('views_handler_filter_term_node_tid_depth','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_term_node_tid_depth.inc','views','0'),('views_handler_filter_term_node_tid_depth_join','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_term_node_tid_depth_join.inc','views','0'),('views_handler_filter_tracker_boolean_operator','class','sites/all/modules/contrib/views/modules/tracker/views_handler_filter_tracker_boolean_operator.inc','views','0'),('views_handler_filter_tracker_comment_user_uid','class','sites/all/modules/contrib/views/modules/tracker/views_handler_filter_tracker_comment_user_uid.inc','views','0'),('views_handler_filter_user_current','class','sites/all/modules/contrib/views/modules/user/views_handler_filter_user_current.inc','views','0'),('views_handler_filter_user_name','class','sites/all/modules/contrib/views/modules/user/views_handler_filter_user_name.inc','views','0'),('views_handler_filter_user_permissions','class','sites/all/modules/contrib/views/modules/user/views_handler_filter_user_permissions.inc','views','0'),('views_handler_filter_user_roles','class','sites/all/modules/contrib/views/modules/user/views_handler_filter_user_roles.inc','views','0'),('views_handler_filter_vocabulary_machine_name','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc','views','0'),('views_handler_filter_vocabulary_vid','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_vocabulary_vid.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_relationship','class','sites/all/modules/contrib/views/handlers/views_handler_relationship.inc','views','0'),('views_handler_relationship_broken','class','sites/all/modules/contrib/views/handlers/views_handler_relationship.inc','views','0'),('views_handler_relationship_entity_reverse','class','sites/all/modules/contrib/views/modules/field/views_handler_relationship_entity_reverse.inc','views','0'),('views_handler_relationship_groupwise_max','class','sites/all/modules/contrib/views/handlers/views_handler_relationship_groupwise_max.inc','views','0'),('views_handler_relationship_node_term_data','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_relationship_node_term_data.inc','views','10'),('views_handler_relationship_translation','class','sites/all/modules/contrib/views/modules/translation/views_handler_relationship_translation.inc','views','0'),('views_handler_sort','class','sites/all/modules/contrib/views/handlers/views_handler_sort.inc','views','0'),('views_handler_sort_broken','class','sites/all/modules/contrib/views/handlers/views_handler_sort.inc','views','0'),('views_handler_sort_comment_thread','class','sites/all/modules/contrib/views/modules/comment/views_handler_sort_comment_thread.inc','views','0'),('views_handler_sort_date','class','sites/all/modules/contrib/views/handlers/views_handler_sort_date.inc','views','0'),('views_handler_sort_group_by_numeric','class','sites/all/modules/contrib/views/handlers/views_handler_sort_group_by_numeric.inc','views','0'),('views_handler_sort_menu_hierarchy','class','sites/all/modules/contrib/views/handlers/views_handler_sort_menu_hierarchy.inc','views','0'),('views_handler_sort_ncs_last_comment_name','class','sites/all/modules/contrib/views/modules/comment/views_handler_sort_ncs_last_comment_name.inc','views','0'),('views_handler_sort_ncs_last_updated','class','sites/all/modules/contrib/views/modules/comment/views_handler_sort_ncs_last_updated.inc','views','0'),('views_handler_sort_node_language','class','sites/all/modules/contrib/views/modules/locale/views_handler_sort_node_language.inc','views','0');
INSERT INTO `registry` VALUES ('views_handler_sort_node_version_count','class','sites/all/modules/contrib/views/modules/node/views_handler_sort_node_version_count.inc','views','0'),('views_handler_sort_random','class','sites/all/modules/contrib/views/handlers/views_handler_sort_random.inc','views','0'),('views_handler_sort_search_score','class','sites/all/modules/contrib/views/modules/search/views_handler_sort_search_score.inc','views','0'),('views_join','class','sites/all/modules/contrib/views/includes/handlers.inc','views','10'),('views_join_subquery','class','sites/all/modules/contrib/views/includes/handlers.inc','views','10'),('views_many_to_one_helper','class','sites/all/modules/contrib/views/includes/handlers.inc','views','10'),('views_object','class','sites/all/modules/contrib/views/includes/base.inc','views','0'),('views_plugin','class','sites/all/modules/contrib/views/includes/plugins.inc','views','0'),('views_plugin_access','class','sites/all/modules/contrib/views/plugins/views_plugin_access.inc','views','0'),('views_plugin_access_menu','class','sites/all/modules/contrib/admin_views/plugins/views_plugin_access_menu.inc','admin_views','0'),('views_plugin_access_none','class','sites/all/modules/contrib/views/plugins/views_plugin_access_none.inc','views','0'),('views_plugin_access_perm','class','sites/all/modules/contrib/views/plugins/views_plugin_access_perm.inc','views','0'),('views_plugin_access_role','class','sites/all/modules/contrib/views/plugins/views_plugin_access_role.inc','views','0'),('views_plugin_argument_default','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_default.inc','views','0'),('views_plugin_argument_default_book_root','class','sites/all/modules/contrib/views/modules/book/views_plugin_argument_default_book_root.inc','views','0'),('views_plugin_argument_default_current_user','class','sites/all/modules/contrib/views/modules/user/views_plugin_argument_default_current_user.inc','views','0'),('views_plugin_argument_default_fixed','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_default_fixed.inc','views','0');
INSERT INTO `registry` VALUES ('views_plugin_argument_default_node','class','sites/all/modules/contrib/views/modules/node/views_plugin_argument_default_node.inc','views','0'),('views_plugin_argument_default_php','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_default_php.inc','views','0'),('views_plugin_argument_default_raw','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_default_raw.inc','views','0'),('views_plugin_argument_default_taxonomy_tid','class','sites/all/modules/contrib/views/modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc','views','0'),('views_plugin_argument_default_user','class','sites/all/modules/contrib/views/modules/user/views_plugin_argument_default_user.inc','views','0'),('views_plugin_argument_validate','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_validate.inc','views','0'),('views_plugin_argument_validate_node','class','sites/all/modules/contrib/views/modules/node/views_plugin_argument_validate_node.inc','views','0'),('views_plugin_argument_validate_numeric','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_validate_numeric.inc','views','0'),('views_plugin_argument_validate_php','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_validate_php.inc','views','0'),('views_plugin_argument_validate_taxonomy_term','class','sites/all/modules/contrib/views/modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc','views','10'),('views_plugin_argument_validate_user','class','sites/all/modules/contrib/views/modules/user/views_plugin_argument_validate_user.inc','views','0'),('views_plugin_cache','class','sites/all/modules/contrib/views/plugins/views_plugin_cache.inc','views','10'),('views_plugin_cache_none','class','sites/all/modules/contrib/views/plugins/views_plugin_cache_none.inc','views','0'),('views_plugin_cache_time','class','sites/all/modules/contrib/views/plugins/views_plugin_cache_time.inc','views','10'),('views_plugin_display','class','sites/all/modules/contrib/views/plugins/views_plugin_display.inc','views','10');
INSERT INTO `registry` VALUES ('views_plugin_display_attachment','class','sites/all/modules/contrib/views/plugins/views_plugin_display_attachment.inc','views','0'),('views_plugin_display_block','class','sites/all/modules/contrib/views/plugins/views_plugin_display_block.inc','views','10'),('views_plugin_display_default','class','sites/all/modules/contrib/views/plugins/views_plugin_display_default.inc','views','0'),('views_plugin_display_embed','class','sites/all/modules/contrib/views/plugins/views_plugin_display_embed.inc','views','0'),('views_plugin_display_extender','class','sites/all/modules/contrib/views/plugins/views_plugin_display_extender.inc','views','0'),('views_plugin_display_feed','class','sites/all/modules/contrib/views/plugins/views_plugin_display_feed.inc','views','0'),('views_plugin_display_page','class','sites/all/modules/contrib/views/plugins/views_plugin_display_page.inc','views','10'),('views_plugin_display_system','class','sites/all/modules/contrib/admin_views/plugins/views_plugin_display_system.inc','admin_views','0'),('views_plugin_exposed_form','class','sites/all/modules/contrib/views/plugins/views_plugin_exposed_form.inc','views','0'),('views_plugin_exposed_form_basic','class','sites/all/modules/contrib/views/plugins/views_plugin_exposed_form_basic.inc','views','0'),('views_plugin_exposed_form_input_required','class','sites/all/modules/contrib/views/plugins/views_plugin_exposed_form_input_required.inc','views','0'),('views_plugin_localization','class','sites/all/modules/contrib/views/plugins/views_plugin_localization.inc','views','0'),('views_plugin_localization_core','class','sites/all/modules/contrib/views/plugins/views_plugin_localization_core.inc','views','0'),('views_plugin_localization_none','class','sites/all/modules/contrib/views/plugins/views_plugin_localization_none.inc','views','0'),('views_plugin_localization_test','class','sites/all/modules/contrib/views/tests/views_plugin_localization_test.inc','views','0'),('views_plugin_pager','class','sites/all/modules/contrib/views/plugins/views_plugin_pager.inc','views','0');
INSERT INTO `registry` VALUES ('views_plugin_pager_full','class','sites/all/modules/contrib/views/plugins/views_plugin_pager_full.inc','views','0'),('views_plugin_pager_mini','class','sites/all/modules/contrib/views/plugins/views_plugin_pager_mini.inc','views','0'),('views_plugin_pager_none','class','sites/all/modules/contrib/views/plugins/views_plugin_pager_none.inc','views','0'),('views_plugin_pager_some','class','sites/all/modules/contrib/views/plugins/views_plugin_pager_some.inc','views','0'),('views_plugin_query','class','sites/all/modules/contrib/views/plugins/views_plugin_query.inc','views','10'),('views_plugin_query_default','class','sites/all/modules/contrib/views/plugins/views_plugin_query_default.inc','views','10'),('views_plugin_row','class','sites/all/modules/contrib/views/plugins/views_plugin_row.inc','views','0'),('views_plugin_row_aggregator_rss','class','sites/all/modules/contrib/views/modules/aggregator/views_plugin_row_aggregator_rss.inc','views','0'),('views_plugin_row_comment_rss','class','sites/all/modules/contrib/views/modules/comment/views_plugin_row_comment_rss.inc','views','0'),('views_plugin_row_comment_view','class','sites/all/modules/contrib/views/modules/comment/views_plugin_row_comment_view.inc','views','0'),('views_plugin_row_fields','class','sites/all/modules/contrib/views/plugins/views_plugin_row_fields.inc','views','0'),('views_plugin_row_node_rss','class','sites/all/modules/contrib/views/modules/node/views_plugin_row_node_rss.inc','views','0'),('views_plugin_row_node_view','class','sites/all/modules/contrib/views/modules/node/views_plugin_row_node_view.inc','views','10'),('views_plugin_row_rss_fields','class','sites/all/modules/contrib/views/plugins/views_plugin_row_rss_fields.inc','views','0'),('views_plugin_row_search_view','class','sites/all/modules/contrib/views/modules/search/views_plugin_row_search_view.inc','views','0'),('views_plugin_row_user_view','class','sites/all/modules/contrib/views/modules/user/views_plugin_row_user_view.inc','views','10'),('views_plugin_style','class','sites/all/modules/contrib/views/plugins/views_plugin_style.inc','views','10');
INSERT INTO `registry` VALUES ('views_plugin_style_default','class','sites/all/modules/contrib/views/plugins/views_plugin_style_default.inc','views','0'),('views_plugin_style_grid','class','sites/all/modules/contrib/views/plugins/views_plugin_style_grid.inc','views','0'),('views_plugin_style_jump_menu','class','sites/all/modules/contrib/views/plugins/views_plugin_style_jump_menu.inc','views','10'),('views_plugin_style_list','class','sites/all/modules/contrib/views/plugins/views_plugin_style_list.inc','views','0'),('views_plugin_style_mapping','class','sites/all/modules/contrib/views/plugins/views_plugin_style_mapping.inc','views','10'),('views_plugin_style_rss','class','sites/all/modules/contrib/views/plugins/views_plugin_style_rss.inc','views','0'),('views_plugin_style_summary','class','sites/all/modules/contrib/views/plugins/views_plugin_style_summary.inc','views','0'),('views_plugin_style_summary_jump_menu','class','sites/all/modules/contrib/views/plugins/views_plugin_style_summary_jump_menu.inc','views','0'),('views_plugin_style_summary_unformatted','class','sites/all/modules/contrib/views/plugins/views_plugin_style_summary_unformatted.inc','views','0'),('views_plugin_style_table','class','sites/all/modules/contrib/views/plugins/views_plugin_style_table.inc','views','0'),('views_test_area_access','class','sites/all/modules/contrib/views/tests/test_handlers/views_test_area_access.inc','views','0'),('views_test_plugin_access_test_dynamic','class','sites/all/modules/contrib/views/tests/test_plugins/views_test_plugin_access_test_dynamic.inc','views','0'),('views_test_plugin_access_test_static','class','sites/all/modules/contrib/views/tests/test_plugins/views_test_plugin_access_test_static.inc','views','0'),('views_test_plugin_style_test_mapping','class','sites/all/modules/contrib/views/tests/test_plugins/views_test_plugin_style_test_mapping.inc','views','0'),('views_ui','class','sites/all/modules/contrib/views/plugins/export_ui/views_ui.class.php','views_ui','0'),('Workflow','class','sites/all/modules/contrib/workflow/includes/Entity/Workflow.php','workflow','0');
INSERT INTO `registry` VALUES ('WorkflowConfigTransition','class','sites/all/modules/contrib/workflow/includes/Entity/WorkflowConfigTransition.php','workflow','0'),('WorkflowConfigTransitionController','class','sites/all/modules/contrib/workflow/includes/Entity/WorkflowConfigTransition.php','workflow','0'),('WorkflowController','class','sites/all/modules/contrib/workflow/includes/Entity/Workflow.php','workflow','0'),('WorkflowD7Base','class','sites/all/modules/contrib/workflow/includes/Field/WorkflowD7Base.php','workflow','0'),('WorkflowDefaultWidget','class','sites/all/modules/contrib/workflow/includes/Field/WorkflowDefaultWidget.php','workflow','0'),('WorkflowInterface','interface','sites/all/modules/contrib/workflow/includes/Entity/WorkflowInterface.php','workflow','0'),('WorkflowItem','class','sites/all/modules/contrib/workflow/includes/Field/WorkflowItem.php','workflow','0'),('WorkflowScheduledTransition','class','sites/all/modules/contrib/workflow/includes/Entity/WorkflowScheduledTransition.php','workflow','0'),('WorkflowState','class','sites/all/modules/contrib/workflow/includes/Entity/WorkflowState.php','workflow','0'),('WorkflowStateController','class','sites/all/modules/contrib/workflow/includes/Entity/WorkflowState.php','workflow','0'),('WorkflowTransition','class','sites/all/modules/contrib/workflow/includes/Entity/WorkflowTransition.php','workflow','0'),('WorkflowTransitionController','class','sites/all/modules/contrib/workflow/includes/Entity/WorkflowTransition.php','workflow','0'),('WorkflowTransitionForm','class','sites/all/modules/contrib/workflow/includes/Form/WorkflowTransitionForm.php','workflow','0'),('WysiwygProfileController','class','sites/all/modules/contrib/wysiwyg/wysiwyg.module','wysiwyg','0'),('XLSExportViewsDataExportTests','class','sites/all/modules/contrib/views_data_export/tests/xls_export.test','views_data_export','0'),('XMLExportViewsDataExportTests','class','sites/all/modules/contrib/views_data_export/tests/xml_export.test','views_data_export','0');
DROP TABLE IF EXISTS `registry_file`;
CREATE TABLE `registry_file` (   `filename` varchar(255) NOT NULL COMMENT 'Path to the file.',   `hash` varchar(64) NOT NULL COMMENT 'sha-256 hash of the file’s contents when last parsed.',   PRIMARY KEY (`filename`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Files parsed to build the registry.';
INSERT INTO `registry_file` VALUES ('includes/actions.inc','f36b066681463c7dfe189e0430cb1a89bf66f7e228cbb53cdfcd93987193f759'),('includes/ajax.inc','3d1c0d2efcdab327224122df1156a665f9bbf60873907dde2f189b018d4e9be3'),('includes/archiver.inc','bdbb21b712a62f6b913590b609fd17cd9f3c3b77c0d21f68e71a78427ed2e3e9'),('includes/authorize.inc','6d64d8c21aa01eb12fc29918732e4df6b871ed06e5d41373cb95c197ed661d13'),('includes/batch.inc','1fe00f9a25481cd43e19fbd6bd37b7ff9dca79f8405ec3e55ffb011be12ec2c3'),('includes/batch.queue.inc','554b2e92e1dad0f7fd5a19cb8dff7e109f10fbe2441a5692d076338ec908de0f'),('includes/bootstrap.inc','1a59544d949fce7a04f8f07f28e1c4605d289e5808f8a239c5d707fdbf387e3d'),('includes/cache-install.inc','e7ed123c5805703c84ad2cce9c1ca46b3ce8caeeea0d8ef39a3024a4ab95fa0e'),('includes/cache.inc','033c9bf2555dba29382b077f78cc00c82fd7f42a959ba31b710adddf6fdf24fe'),('includes/common.inc','8c58d9dfd7fe677917102fbb938b59044469d8a2455b0e62ee14bd72fdb3f20e'),('includes/database/database.inc','2ef46543fb9cf61ed9fa9aed4e44dd31630c22604ea6b8e48b57ebd7ad11a111'),('includes/database/log.inc','9feb5a17ae2fabcf26a96d2a634ba73da501f7bcfc3599a693d916a6971d00d1'),('includes/database/mysql/database.inc','32a577354dba6030043500873f8a2a7359c80c179a213284b026c1a9b0452b70'),('includes/database/mysql/install.inc','6ae316941f771732fbbabed7e1d6b4cbb41b1f429dd097d04b3345aa15e461a0'),('includes/database/mysql/query.inc','0212a871646c223bf77aa26b945c77a8974855373967b5fb9fdc09f8a1de88a6'),('includes/database/mysql/schema.inc','2ef729f8d6466d5cd87ba233152d88590bce629d8366040b2509b4e24258d780'),('includes/database/pgsql/database.inc','8bb1a65c8dcc9ab145a68c69677ee6bf897b8d176344b500c6c8e07f6a81033f'),('includes/database/pgsql/install.inc','585b80c5bbd6f134bff60d06397f15154657a577d4da8d1b181858905f09dea5'),('includes/database/pgsql/query.inc','0df57377686c921e722a10b49d5e433b131176c8059a4ace4680964206fc14b4'),('includes/database/pgsql/schema.inc','1588daadfa53506aa1f5d94572162a45a46dc3ceabdd0e2f224532ded6508403'),('includes/database/pgsql/select.inc','fd4bba7887c1dc6abc8f080fc3a76c01d92ea085434e355dc1ecb50d8743c22d');
INSERT INTO `registry_file` VALUES ('includes/database/prefetch.inc','b5b207a66a69ecb52ee4f4459af16a7b5eabedc87254245f37cc33bebb61c0fb'),('includes/database/query.inc','4016a397f10f071cac338fd0a9b004296106e42ab2b9db8c7ff0db341658e88f'),('includes/database/schema.inc','9fecfd13fc1d4056a62d385840dccd052ea0e184dc47101f4bd8f57f10b68174'),('includes/database/select.inc','02a2d4345287df62b163ca2524e99b7370c9ec167bc937245328683d4e3e3d56'),('includes/database/sqlite/database.inc','62f6669c4610557c4b34ada9f0a0f61d6cb7b377e0a9032d2efca7b5f39b0965'),('includes/database/sqlite/install.inc','6620f354aa175a116ba3a0562c980d86cc3b8b481042fc3cc5ed6a4d1a7a6d74'),('includes/database/sqlite/query.inc','f33ab1b6350736a231a4f3f93012d3aac4431ac4e5510fb3a015a5aa6cab8303'),('includes/database/sqlite/schema.inc','cd829700205a8574f8b9d88cd1eaf909519c64754c6f84d6c62b5d21f5886f8d'),('includes/database/sqlite/select.inc','8d1c426dbd337733c206cce9f59a172546c6ed856d8ef3f1c7bef05a16f7bf68'),('includes/date.inc','1de2c25e3b67a9919fc6c8061594442b6fb2cdd3a48ddf1591ee3aa98484b737'),('includes/entity.inc','f06b508f93e72ba70f979d8391be57662c018a03a32fac0a6d3baa752740133d'),('includes/errors.inc','2ced35723e95483694205a55c8ee29498cc8ae162e0c345288ea174c9dcf1ff7'),('includes/file.inc','b5374e98eb062566e8993da228692c77c3ddb4350714b542282846f33608bac3'),('includes/file.mimetypes.inc','33266e837f4ce076378e7e8cef6c5af46446226ca4259f83e13f605856a7f147'),('includes/filetransfer/filetransfer.inc','fdea8ae48345ec91885ac48a9bc53daf87616271472bb7c29b7e3ce219b22034'),('includes/filetransfer/ftp.inc','51eb119b8e1221d598ffa6cc46c8a322aa77b49a3d8879f7fb38b7221cf7e06d'),('includes/filetransfer/local.inc','7cbfdb46abbdf539640db27e66fb30e5265128f31002bd0dfc3af16ae01a9492'),('includes/filetransfer/ssh.inc','92f1232158cb32ab04cbc93ae38ad3af04796e18f66910a9bc5ca8e437f06891'),('includes/form.inc','a0e219d53d641f08d6f1d609e53f06f3f8b1c591d20113d0992557c815b44a72'),('includes/graph.inc','8e0e313a8bb33488f371df11fc1b58d7cf80099b886cd1003871e2c896d1b536'),('includes/image.inc','bcdc7e1599c02227502b9d0fe36eeb2b529b130a392bc709eb737647bd361826');
INSERT INTO `registry_file` VALUES ('includes/install.core.inc','189653e4bb7d4828bd6e1b61015fabcc7182e23d9dd8858170f98114d99400c8'),('includes/install.inc','fbb23627b06abb070b4531da786c1e06bf1dbd6f923bb2b404f4808c2340b0f9'),('includes/iso.inc','0ce4c225edcfa9f037703bc7dd09d4e268a69bcc90e55da0a3f04c502bd2f349'),('includes/json-encode.inc','02a822a652d00151f79db9aa9e171c310b69b93a12f549bc2ce00533a8efa14e'),('includes/language.inc','4e08f30843a7ccaeea5c041083e9f77d33d57ff002f1ab4f66168e2c683ce128'),('includes/locale.inc','ca50acc0780cbffeca17f99a0997f91b8b9402f0eec1898c3122e1d73664d01d'),('includes/lock.inc','a181c8bd4f88d292a0a73b9f1fbd727e3314f66ec3631f288e6b9a54ba2b70fa'),('includes/mail.inc','41d0e657119a05f8d7e85ebf32e74b12a1c3107d717a348158414b113e208b9c'),('includes/menu.inc','8e7a8a1a4666a8ca66d1b19cc97be4cf82c3bb0e835e652ee366bec9b74a8c23'),('includes/module.inc','8dab73e50e6bcd680a26f55597d2d103ba68a29089f888e2a2c206fc38eaa669'),('includes/pager.inc','6f9494b85c07a2cc3be4e54aff2d2757485238c476a7da084d25bde1d88be6d8'),('includes/password.inc','fd9a1c94fe5a0fa7c7049a2435c7280b1d666b2074595010e3c492dd15712775'),('includes/path.inc','2dca08d14a46e5ac6a665b7a5dde78045d8de2b35aaa78c6fb811e1125ce4953'),('includes/registry.inc','f47b20859f0fc80bf4bb2849a1282d6c54006957b69da0e5f4691de585ca4cdf'),('includes/session.inc','5851ff6941aba2744dd0c247f077fc02fbbe24e9786e04ea0a3c372d68ca6d16'),('includes/stream_wrappers.inc','b8a5a53f3d3ef26ea868037547f76af8049ce0c55b464810c627310a84f24924'),('includes/tablesort.inc','2d88768a544829595dd6cda2a5eb008bedb730f36bba6dfe005d9ddd999d5c0f'),('includes/theme.inc','5d8b96db9760367eb86821085a17a144a58cb355e6f547e321321ee34535da7b'),('includes/theme.maintenance.inc','39f068b3eee4d10a90d6aa3c86db587b6d25844c2919d418d34d133cfe330f5a'),('includes/token.inc','5e7898cd78689e2c291ed3cd8f41c032075656896f1db57e49217aac19ae0428'),('includes/unicode.entities.inc','2b858138596d961fbaa4c6e3986e409921df7f76b6ee1b109c4af5970f1e0f54'),('includes/unicode.inc','e18772dafe0f80eb139fcfc582fef1704ba9f730647057d4f4841d6a6e4066ca'),('includes/update.inc','25c30f1e61ef9c91a7bdeb37791c2215d9dc2ae07dba124722d783ca31bb01e7');
INSERT INTO `registry_file` VALUES ('includes/updater.inc','d2da0e74ed86e93c209f16069f3d32e1a134ceb6c06a0044f78e841a1b54e380'),('includes/utility.inc','3458fd2b55ab004dd0cc529b8e58af12916e8bd36653b072bdd820b26b907ed5'),('includes/xmlrpc.inc','ea24176ec445c440ba0c825fc7b04a31b440288df8ef02081560dc418e34e659'),('includes/xmlrpcs.inc','925c4d5bf429ad9650f059a8862a100bd394dce887933f5b3e7e32309a51fd8e'),('modules/block/block.test','40d9de00589211770a85c47d38c8ad61c598ec65d9332128a882eb8750e65a16'),('modules/color/color.test','610ba154f42b6af5871fb09cdb0bc7badc29b03845c08d86e0e524840dd27568'),('modules/comment/comment.module','db858137ff6ce06d87cb3b8f5275bed90c33a6d9aa7d46e7a74524cc2f052309'),('modules/comment/comment.test','332d14e197b4ebe85b1b70a15602981d99d332e2293576c0e44cf18a808c7aac'),('modules/contextual/contextual.test','023dafa199bd325ecc55a17b2a3db46ac0a31e23059f701f789f3bc42427ba0b'),('modules/dashboard/dashboard.test','125df00fc6deb985dc554aa7807a48e60a68dbbddbad9ec2c4718da724f0e683'),('modules/dblog/dblog.test','79ba7991c3f40f9241e9a03ffa43faf945c82658ca9b52ec62bd13bd80f41269'),('modules/field/field.attach.inc','2df4687b5ec078c4893dc1fea514f67524fd5293de717b9e05caf977e5ae2327'),('modules/field/field.info.class.inc','cf18178e119d43897d3abd882ba3acc0cf59d1ad747663437c57b1ec4d0a4322'),('modules/field/field.module','48b5b83f214a8d19e446f46c5d7a1cd35faa656ccb7b540f9f02462a440cacdd'),('modules/field/modules/field_sql_storage/field_sql_storage.test','315eedaf2022afc884c35efd3b7c400eddab6ea30bec91924bc82ab5cd3e79f2'),('modules/field/modules/list/tests/list.test','c1a214d7efd3247dd947d742a8514ec9649da62593608dfdccee6913d48e5709'),('modules/field/modules/number/number.test','fc8f193904f1c5f87dcf51a279975214b34aa1349fe9c38b09c4e6740b059b49'),('modules/field/modules/options/options.test','1b30956b6f46840ccb41b99bda08f328172f008f1fb4164c65fe9e4047fffa5f'),('modules/field/modules/text/text.test','5c28b9da26417d2ed8a169850989c0b59f2b188a0161eb58e2b87c67994d602d'),('modules/field/tests/field.test','5eaad7a933ef8ea05b958056492ce17858cd542111f0fe81dd1a5949ad8f966e'),('modules/field_ui/field_ui.test','f535e5627c969e9083a63aaf72d4ac645e30709d7b87af15c6c3b870481f283a');
INSERT INTO `registry_file` VALUES ('modules/file/tests/file.test','091b59b7fe1b7068569f0290006e21265b3b7986ebbc1d56cedd3ceff6f581ca'),('modules/filter/filter.test','b8aa5e6b832422c6ad5fe963898ec9526c814614f27ecccb67107ce194997d6a'),('modules/help/help.test','bc934de8c71bd9874a05ccb5e8f927f4c227b3b2397d739e8504c8fd6ae5a83c'),('modules/image/image.test','6e7a0cbcb58f6210127b0ac7c1d118d488abd0925fe8db10a3405af87f1d9fe1'),('modules/menu/menu.test','71efd7117a882fdcdd50971b4a68f7f2895b532e09acf094d747f27a15742c5b'),('modules/node/node.module','70f969229d03819dba439546ae7aef30283b93e410af1b45f5a25b90d3cb8edd'),('modules/node/node.test','35bf40fde62f3a1de95bab9f037b84f20c2f93a1c579d7d19e4a87afe75dc330'),('modules/path/path.test','2004183b2c7c86028bf78c519c6a7afc4397a8267874462b0c2b49b0f8c20322'),('modules/php/php.test','d234f9c1ab18a05834a3cb6dc532fb4c259aa25612551f953ba6e3bb714657b8'),('modules/rdf/rdf.test','9849d2b717119aa6b5f1496929e7ac7c9c0a6e98486b66f3876bda0a8c165525'),('modules/search/search.extender.inc','013a6a841cc48a6dc991153fb692b8d1546e56b78d9c95e97e0d7e92296d3481'),('modules/search/search.test','e43c21510d510885dfad6484afa931382083b75b7e67286bda56a6aafe265f28'),('modules/shortcut/shortcut.test','0d78280d4d0a05aa772218e45911552e39611ca9c258b9dd436307914ac3f254'),('modules/statistics/statistics.test','7abe4cce7ef548637d709e22cf340f9973b6d77615a470949d20a6426f5b08f2'),('modules/system/system.archiver.inc','faa849f3e646a910ab82fd6c8bbf0a4e6b8c60725d7ba81ec0556bd716616cd1'),('modules/system/system.mail.inc','d31e1769f5defbe5f27dc68f641ab80fb8d3de92f6e895f4c654ec05fc7e5f0f'),('modules/system/system.queue.inc','a77a5913d84368092805ac551ca63737c1d829455504fcccb95baa2932f28009'),('modules/system/system.tar.inc','d0d2f191d79b3227852e7436908386bdd7a25f78c73f3c8bf9ef5903892ae993'),('modules/system/system.test','7a94d94c13eb60684678e62f25cec44d46714a1ca4987f62d86d358e8978902a'),('modules/system/system.updater.inc','9433fa8d39500b8c59ab05f41c0aac83b2586a43be4aa949821380e36c4d3c48'),('modules/taxonomy/taxonomy.module','19992c2e810a7b7a1c228d178b0b6c5f358082d515b8a6e77b0415a430e23997');
INSERT INTO `registry_file` VALUES ('modules/taxonomy/taxonomy.test','ce91ff8a2879d65fdb3477d3f437cad8ef50b8963dadb75ae203854987b2c23a'),('modules/user/user.module','a1d316fcd7d849a1b31aacd029b36ed2695481035251347abe865d5fcc87eea4'),('modules/user/user.test','aa8aa5e3673e9f9a3a75d5465f433c9b43633f8fd05bc4f6055942162e65f42e'),('profiles/pantheon/pantheon.profile','7a3ce6281f7828df14cf9d4de3aaf317dfea664ba085a3943a30284a2d571d94'),('sites/all/modules/contrib/addressfield/addressfield.migrate.inc','1750da9b75d2f5b4f1303bc7592774e971080ba13d467e3d95265279d6261a4f'),('sites/all/modules/contrib/addressfield/views/addressfield_views_handler_field_administrative_area.inc','557ad6bbaeab17cc99820f08887169e1408e5fff8c17c44b66b5e56e5fd62db2'),('sites/all/modules/contrib/addressfield/views/addressfield_views_handler_field_country.inc','e87fd32bd4ba5229040ab7020206774fec2717236d4a39c729362b5c7a55f03c'),('sites/all/modules/contrib/addressfield/views/addressfield_views_handler_filter_country.inc','51956e153daca9f27e4c8bbecfa2398a4ef50391d2f5bcac258586a6d1dd1fb2'),('sites/all/modules/contrib/admin_menu/tests/admin_menu.test','185f8244f7a086cda1bd9435ec529e8632598e9b09d1e0d7363b75cf87c04afb'),('sites/all/modules/contrib/admin_views/plugins/views_plugin_access_menu.inc','6ce5434e7275a5d128978ee6d5ddbe438b73bb338ad50cf60e9248b2baf43a2e'),('sites/all/modules/contrib/admin_views/plugins/views_plugin_display_system.inc','227ee06aee0b236600640a9842600fe192d5de270fa4d4de69a37369d91044fa'),('sites/all/modules/contrib/admin_views/tests/admin_views.test','5e7e0ea77399f813e9b45778e5644323825ce55334a0d0267791a22d512233e4'),('sites/all/modules/contrib/backup_migrate/includes/destinations.inc','49f309b9a745138f28fa152e5b90ba1488b0106541c19d0f83e38c90da3a1789'),('sites/all/modules/contrib/backup_migrate/includes/profiles.inc','43792cd7a43e5402beab0452ecbf6aec9594f9275873027317413ee0f3f4a234'),('sites/all/modules/contrib/backup_migrate/includes/schedules.inc','8b83d4acb074ee95be35ceacd3647de25dfc0d8cae68e33141e1e3f3f6c62f5a'),('sites/all/modules/contrib/block_access/block_access.admin.inc','5cfbc06dadafe84752571e9b29beb7ac26e760259d3ea87a857d31eb52fe1c62');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/block_access/block_access.db.inc','e32f2ba86dee38e8ce389f72878a33c0d808af28408402503fcb8bfbe60a551f'),('sites/all/modules/contrib/block_access/block_access.install','4c2b07ce7501c1a627e6472c48daf4116e2f679ccfe54975654fed1152ac9b8f'),('sites/all/modules/contrib/block_access/block_access.module','e552f27511d3913138d964b6b2a6b25d448ace0d3918750bbb50cadae9c5929d'),('sites/all/modules/contrib/block_access/block_access.theme.inc','d7cd52a476e68b7e2975d976bfe78a3649ce19b0057812e01f8996b35ac5ce0b'),('sites/all/modules/contrib/block_access/tests/common.test','c22d8ff8d212ed0d069c6ec0862d57173cdc5f16630c4744fb4ed10e1b5bfc26'),('sites/all/modules/contrib/block_access/tests/op_basic_config.test','7ffbab32a47fa5c5229d8d1fa99914af1c648178ec70e4f54f419481c64a6cbd'),('sites/all/modules/contrib/block_access/tests/op_basic_delete.test','ca02200acc2e3b320db055063fdfa1aa18969e5eb979d52d5d6f2397964e1e43'),('sites/all/modules/contrib/block_access/tests/op_basic_disable.test','0dced18259bac407fbda0ecb178a5216415d4446deeffba833dbb8ef9eb123ff'),('sites/all/modules/contrib/block_access/tests/op_basic_enable.test','93d56b8326dc64549d09bffeac5fa452155937e48f19b8df883ac6815663e4c7'),('sites/all/modules/contrib/block_access/tests/op_basic_move.test','7de31a269b6988c6dcf2b483da609f37939f49069f8bd2d3c2ae687681063c73'),('sites/all/modules/contrib/block_access/tests/op_basic_view.test','8d2434750f5e3c75463749159a6d1fe2a428d32641df54283cafafc56ea27e81'),('sites/all/modules/contrib/block_access/tests/op_config.test','9764af04059ceab128096cded89bb35bf37267409a5a8ab1d839560c1860c215'),('sites/all/modules/contrib/block_access/tests/op_region.test','9cd6a7002df714146a2736a9fbea5b527532ff9fa9159ef6f97ec9a8881a2b45'),('sites/all/modules/contrib/block_access/tests/ui.test','ae195950a3550381af5befcbde1661e7e2c968e85e7b9347453d74044b00497b'),('sites/all/modules/contrib/block_class/block_class.test','ad3e6238a7a0c025d2cac75cfa089c90ce721a94241925db4484ceb6a04ec8a4'),('sites/all/modules/contrib/calendar/calendar.install','85517f33935a333f0414974417f8be0c42ff18a384c1cf890162c5e73160216b');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/calendar/calendar.module','0387183e6dae4f92e4208ccf69d6ef17163f22d506ee4a86e210c70d708b3459'),('sites/all/modules/contrib/calendar/includes/calendar.views.inc','89f3265426ed077d0ea32c7462160ed60eeebb562f5e99abc4703fbd22761127'),('sites/all/modules/contrib/calendar/includes/calendar.views_template.inc','502a562d7d3ce8f4d935e6ea63350fa422f3f29b0b1907f8a27811aa5cbaa2ff'),('sites/all/modules/contrib/calendar/includes/calendar_plugin_row.inc','3eb1f3738276b798e773613e528a8fc36dba46cf98593ec30e46edd2130a85f7'),('sites/all/modules/contrib/calendar/includes/calendar_plugin_style.inc','1c4394b0e6ab59c18bed21af2e976d02e7545e8748893846ed9672a00bb000ff'),('sites/all/modules/contrib/calendar/theme/calendar-style.tpl.php','9746be8e78f6165db12e1800298bf8e5f771182f049d7c1aa2edbd83a1f48fe4'),('sites/all/modules/contrib/calendar/theme/theme.inc','54f635b589c2525f0ed4750b73cea6d5244c3335995866fcd399167c1cb3da25'),('sites/all/modules/contrib/content_access/tests/content_access.test','0a2459c1d62ff611a9b080e69902dc44315525c45819b9495423c6a4e546a26a'),('sites/all/modules/contrib/content_access/tests/content_access_acl.test','0ac7887079deff5d0747bf0d8f8f42c314194de0feba8b63721df5047de08d9c'),('sites/all/modules/contrib/ctools/includes/context.inc','4082504a7e4ac0da7808dd86159fa2f161be3f3d310e9dbd94c199ae2e714143'),('sites/all/modules/contrib/ctools/includes/css-cache.inc','db90ff67669d9fa445e91074ac67fb97cdb191a19e68d42744f0fd4158649cfa'),('sites/all/modules/contrib/ctools/includes/math-expr.inc','3c60674360d5caa754895f32d87cde6a122f61800d4b762e7e09d49501fd47b8'),('sites/all/modules/contrib/ctools/includes/stylizer.inc','3f91f5ed42fb6ee1b65ddef7ac22577b07a5d75ca1eb2df60041243ced5c7079'),('sites/all/modules/contrib/ctools/plugins/export_ui/ctools_export_ui.class.php','2fd87a7d80689e4d44673b31c07b762144eb8ac57324fd0b9cd9ede5f4ea34b5'),('sites/all/modules/contrib/ctools/tests/css_cache.test','0dbc038efedb1fa06d2617b7c72b3a45d6ee5b5b791dcb1134876f174a2a7733'),('sites/all/modules/contrib/ctools/views_content/plugins/views/views_content_plugin_display_ctools_context.inc','451bc0ca2cbfdba11159e339de3890480e009de853412034b81d4afe7c102809');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/ctools/views_content/plugins/views/views_content_plugin_display_panel_pane.inc','f3e75d212bd63e6b739105652869c9dbd9ad7b6caa38e068a7c717d593289611'),('sites/all/modules/contrib/ctools/views_content/plugins/views/views_content_plugin_style_ctools_context.inc','71a211a7602d33bd3a4adfdbbcd5f121bdfac8a2c47ec9f8cbaf74be6c83b05a'),('sites/all/modules/contrib/date/date.migrate.inc','47ffb48daf97c13ef154cf2ffff577018f02a7091b85dfb39e9c2c89e1da6a5d'),('sites/all/modules/contrib/date/date_api/date_api.module','af2124c5727d839871309b31fe288fe3945d6ef67eb469ddcc02839be98860dc'),('sites/all/modules/contrib/date/date_api/date_api_sql.inc','5a484b487c13fd6094348e2011c19e72d6c6c9ceb0b0a4143ef5542cd1c495fa'),('sites/all/modules/contrib/date/date_repeat/tests/date_repeat.test','3702268fa89aa7ed9bcae025f0fb21bd67f90e89d53122049854de60a5316d4a'),('sites/all/modules/contrib/date/date_repeat/tests/date_repeat_form.test','2ec4e5d57d5b9f1adf81505d40890c63dc684f2d0f00669b9c8c12518eb3bf4a'),('sites/all/modules/contrib/date/date_tools/tests/date_tools.test','bdb9b310295207ce2284b23556810296e1477b9604e98a3d0fb21aba7da04394'),('sites/all/modules/contrib/date/date_views/includes/date_views.views.inc','7ddcf452b6da1c6e8d6e983674f1108b1d13a93d63948a5c7c9831e4e1c6ccee'),('sites/all/modules/contrib/date/date_views/includes/date_views_argument_handler.inc','8f4debf9b3db7698f2633c39b75aa252e40db5aba07a082468614773e2958e9a'),('sites/all/modules/contrib/date/date_views/includes/date_views_argument_handler_simple.inc','082dc7463949c86d32e637c2eb0d0568670ae7100c39ee8b4b52e96246487d28'),('sites/all/modules/contrib/date/date_views/includes/date_views_filter_handler.inc','936bbe570617d6b1d2878fe869c722c5826e6d913c48c1b1a842a5500c2ef5fd'),('sites/all/modules/contrib/date/date_views/includes/date_views_filter_handler_simple.inc','93f85798f6b2b962c90c5d2520beedc45fa443453cd206bba0db3d7e0a33d0bd'),('sites/all/modules/contrib/date/date_views/includes/date_views_plugin_pager.inc','43d496c6c834cd26d4b74ddd6291d5da959d402e60b360b37aa90126808a0a4d');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/date/tests/date.test','6cb38e9ed60bfdfa268051b47fcad699f1c8104accc7286abafbeddbbc9d143c'),('sites/all/modules/contrib/date/tests/date_api.test','280148ca742592a1e22f663fe4d810532b95d09975db0182347a0bbd6917f996'),('sites/all/modules/contrib/date/tests/date_field.test','bae59aee63ed204e27909709e59eeae1a6192e5f7456de2ce2cce06c49732dc4'),('sites/all/modules/contrib/date/tests/date_migrate.test','a43f448732d474c5136d89ff560b7e14c1ff5622f9c35a1998aa0570cd0c536c'),('sites/all/modules/contrib/date/tests/date_timezone.test','598ac52aa82f79fe90faa401c2c6dc7114295c0321800ea9a9b4058717d00409'),('sites/all/modules/contrib/date/tests/date_validation.test','2e4d27c29192c9d55eb27b985d7e9838702c4324d36ed6e3a85999e9f25ada99'),('sites/all/modules/contrib/date/tests/date_views_pager.test','aceff66e11dd3ea418e9905b28384432f4fe7cf9746e711cf56add73e64336dd'),('sites/all/modules/contrib/date/tests/date_views_popup.test','0684ad4977093fd7338eb045f85ceda195e82f50bd33fecbf0dca00e42b0385e'),('sites/all/modules/contrib/devel/devel.mail.inc','49da9730e719dd57db1eb0c416874a5bc0b5a0af50d06f0e3e3832514b653e15'),('sites/all/modules/contrib/devel/devel.test','6d18fc4c80d6c92d827f967baa36a11a0efc82b02bb79c1ebb53da515322f084'),('sites/all/modules/contrib/eck/includes/eck.inline_entity_form.inc','583803912c459b0a9304d3b674188377c9495b0ca931984e332d75b24f6e747a'),('sites/all/modules/contrib/eck/includes/translation.handler.eck.inc','0e1c4eb01d72360a9808df48c68a907d681adfbe8ab8e22b5b23efad25fda275'),('sites/all/modules/contrib/eck/views/handlers/eck_views_handler_field_link.inc','39eab956a6428b31be35656f45afe7e1700ddbd36a7c7ae90a6102c4f7c26495'),('sites/all/modules/contrib/eck/views/handlers/eck_views_handler_field_link_delete.inc','c74054fda0eb91d262e22c2845b0b9c6134349dabb5468a20a5a058d27497664'),('sites/all/modules/contrib/eck/views/handlers/eck_views_handler_field_link_edit.inc','17f96f6388e328652d840b55a7941a1a05d003e435819663eaa7e505662f004b'),('sites/all/modules/contrib/entity/entity.features.inc','53f537caf6ad9355fb92b2c6db019959abdf399d80764151dd976b0891f37436');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/entity/entity.i18n.inc','41e0e62af7e2774f62b162d597bb3244551c280296b692b29d039a2c243d7059'),('sites/all/modules/contrib/entity/entity.info.inc','8799080b9393c9560e64feae1276fb7d26fef4d92bb0edacc863ee3e7b67bf04'),('sites/all/modules/contrib/entity/entity.rules.inc','774199059d1b3ebe6d3fe7a49dbb1550df489055a3d066b5de54edda8dd7ba84'),('sites/all/modules/contrib/entity/entity.test','aba6490cd2041438d832dc8f63b213e0d171a5a218f6d51a9fe00c51e95069ce'),('sites/all/modules/contrib/entity/entity_token.module','0c1ad6fb6f8c430e47a81be6d08180883c5a1ee728ce8b5dd0775713b34fb862'),('sites/all/modules/contrib/entity/entity_token.tokens.inc','084edf8f860f3c9843e23cc2e06a9084dcb644ee6d99c21cdd7bd924138d518f'),('sites/all/modules/contrib/entity/includes/entity.controller.inc','b85d1882fae38ee8a0e82bf75952f44f65a58fd95e3bf0c3cb2a1321cf4d308a'),('sites/all/modules/contrib/entity/includes/entity.inc','02c3c8b1d4b7230f875c4fae8e6ba3bd57431e01f312b32f3ed305a7be734774'),('sites/all/modules/contrib/entity/includes/entity.ui.inc','49653cbbccc4b4e51f957727aa95803c149fac9565f53ed553e2cd1c1c3580ff'),('sites/all/modules/contrib/entity/includes/entity.wrapper.inc','ba890faf0f18d6262bc211db1fdf0ca7742058b1f454cf3d9a9f281c71bface7'),('sites/all/modules/contrib/entity/views/entity.views.inc','089b8ed3103f62778be3395a99ddfbd84da4235f5ad431392f8984eaa4bf349f'),('sites/all/modules/contrib/entity/views/handlers/entity_views_field_handler_helper.inc','88e4cbbbeab9bbaa4c928118bdefb158ea99f343f813cf88cce01ed7fbf8bf6a'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_area_entity.inc','7b7bb88e53861739b7279f705f0492fc83ce95f5b20d89339480f546422ebf25'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_boolean.inc','b28b8eee8761ba7a6af35d97ab7aaee28406e6c227271f9769818560626c5791'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_date.inc','b0f5be5b399de94934b24e84c8cf6053a043f6b00c60dcffa752daeafdd38778'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_duration.inc','ed7bb64cb63b94a20c8cde98cfb053b5ea252804396cf61ac562faf1d850266b');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_entity.inc','4f255918a22fefebe9c7734f200751457a7ca4d3648e32a98511bb51968d7521'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_field.inc','893121efbce2a7181e31147bade260c9cc657cbd33b0d254cb28b2650e57566d'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_numeric.inc','f14e2b063930e8820af381b4f5e83c7278440e7804ab88cfde865b6c94e7c0f6'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_options.inc','27ef31b8ee7b9999930380d6a5fdb477772329c4ddbd5c70cc34bcdc7543ce56'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_text.inc','5fb0a85d35d29944c699ceaf6efed5eda2df757009e44caba8ff2be397568b60'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_uri.inc','79ecaa3eb17dfdd0ca077351b75a2c0adf411ebc04720e7cc0e2397674225f24'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_relationship.inc','b69bc538d1e1e0f91f8485ca54c3b6e2be025caa47619734c467377cf89041b9'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_relationship_by_bundle.inc','65300c793c4591d60ad908dc02cf3148fe4e899fa6ad218e875fd92d411374dc'),('sites/all/modules/contrib/entity/views/plugins/entity_views_plugin_row_entity_view.inc','e489ca209c66b76228383864b8267067e7cf3a1e375d9a195339f89932fed71f'),('sites/all/modules/contrib/entityform/entityform.admin.inc','6053de68ee12056479126de5178ff12aa5fe7019365158a35ff2e74799d59a71'),('sites/all/modules/contrib/entityform/entityform.info.inc','24aef805de37df04e6da4bc5c1b9a78c6085116cbbdc3165250e23cb9480d114'),('sites/all/modules/contrib/entityform/entityform.pages.admin.inc','034a404db1da941635edcad20b4d1bded48ee5d1f3cf1a48f40776c868faf539'),('sites/all/modules/contrib/entityform/entityform.test','7e0e06fead779d7ad46e10ce9c7752c9586ba005f39b2978ee44dd416f50b44d'),('sites/all/modules/contrib/entityform/entityform_type.admin.inc','075095689d07833e6c3565dad7bc5c2afbecca000edf8c66a6a4cea8b1cf1fc3');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/entityform/views/entityform.views.inc','b9a8db888639b28c4db127fbb48487a0e474b28a1bcd7509679fb64044eed3c3'),('sites/all/modules/contrib/entityform/views/entityform.views_default.inc','5cbeec91005fdc28107f80f4707f79520c8eecacb3d5333b8db9983747a13399'),('sites/all/modules/contrib/entityform/views/entityform_handler_delete_link_field.inc','789051b949c58624b68a4288bb7b9a0313191472d5052c93725746123e91ab38'),('sites/all/modules/contrib/entityform/views/entityform_handler_edit_link_field.inc','263ffd11b11ed27a25a6a5f8a3a5ddccb6a474093882f01898cfb8647fe43414'),('sites/all/modules/contrib/entityform/views/entityform_handler_entityform_operations_field.inc','4918488eedc2d8cb1862beed727dccfe094005615b3e2cf755de18b85a7c82b3'),('sites/all/modules/contrib/entityform/views/entityform_handler_link_field.inc','440235e1614d237d6714b6fe6b53336f014f67b5c4d226b89b89d62f903a0e18'),('sites/all/modules/contrib/entityform/views/entityform_type_handler_submit_link_field.inc','0cfd866eb69ac66c4923dbf5a73ccc989d04ba4aacd04158ff7f924c72dbdccb'),('sites/all/modules/contrib/entityreference/entityreference.migrate.inc','6dfe7be97f3198bff6c145dce9a0f521c3695c380d24fe6d3feb97362363407d'),('sites/all/modules/contrib/entityreference/plugins/behavior/abstract.inc','a7959ddece2ce3490f92d916162e07aed313e28ca299ca0375bad633b42d93e3'),('sites/all/modules/contrib/entityreference/plugins/behavior/EntityReferenceBehavior_TaxonomyIndex.class.php','92fa0cf46ecdf6200659646e6666c562ea506c40efa41a8edd4758dc0c551b92'),('sites/all/modules/contrib/entityreference/plugins/behavior/EntityReferenceBehavior_ViewsFilterSelect.class.php','f6805f62bbd376d98676706602aeb1c4d16e645acb429d31032bc3fb37d850d3'),('sites/all/modules/contrib/entityreference/plugins/selection/abstract.inc','7ecf94f5dc3456e4a5c87117d19deb98c368617fb07d610505b1dfa351f14a0b'),('sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','4e1483f4b1fd242d3c7c92b098d0254b9b4b3e68c9f93aa7c8815e9cea2b3912'),('sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Views.class.php','40f8da81ef2620a67d721c471d1902f7b93b3edbd51ed6838aa25b81fd84ecc1');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/entityreference/plugins/selection/views.inc','7bbe8900b6b71c2d41e370deaccca869884d0fe9ca81772d7d5bca5f58ec1cd8'),('sites/all/modules/contrib/entityreference/tests/entityreference.admin.test','9b38cb7f8a55bfcd5c4e009297849d09bfd0a6465c7eac76b418f5cba927004b'),('sites/all/modules/contrib/entityreference/tests/entityreference.feeds.test','b19193542031d2e1a247ffac8852e9219e5f7f0ed38298207ffe27cd1af9352a'),('sites/all/modules/contrib/entityreference/tests/entityreference.handlers.test','2fa170925ac5303c519378f1763e918cc2f111205220d90998b547a08db90d8c'),('sites/all/modules/contrib/entityreference/tests/entityreference.taxonomy.test','8e4f7d9ae621df0f587b6fcbf139adea2a35c69305ef018ced88447a41164c5f'),('sites/all/modules/contrib/entityreference/views/entityreference_plugin_display.inc','9216a065ea4fdb2daacb1280e5c9549e3400b8553b5293534cf65a0d703ab189'),('sites/all/modules/contrib/entityreference/views/entityreference_plugin_row_fields.inc','7f5a58c099c2df6fd1c3ae285197a4648841d44fa107bcb2064bc1edf435ea8b'),('sites/all/modules/contrib/entityreference/views/entityreference_plugin_style.inc','ad9a7ea5a37c2d9658c2b1d19ade3011c27ed5d9959423ebf7a390372507e6b0'),('sites/all/modules/contrib/entity_block/entity_block.controller.inc','3fc8557a63744d750b545dbf03532a0e9cbfe7acf44f3c6a5b3beb709812e0d2'),('sites/all/modules/contrib/features/tests/features.test','5fc1c5733eb4c76c32f1a79736c064f1f89001f7987eb7bf183c8d438c8f8baf'),('sites/all/modules/contrib/feeds/feeds_import/feeds_import.test','85d84166fd75c9362f69056ce6bc098f9ba1b47afbc8d8cf74c8bec34319a0cb'),('sites/all/modules/contrib/feeds/feeds_ui/feeds_ui.test','4c5320fa3cb4c46958903da0479e420c9b8a9d560a00fa70e538bdd2aba0484f'),('sites/all/modules/contrib/feeds/includes/FeedsConfigurable.inc','b37352dc5adf623b1ef2271cdb3321530936b91b7e0f2031f3773a140f801aed'),('sites/all/modules/contrib/feeds/includes/FeedsImporter.inc','2686efe0f6e1fb414fd724e8bca028348ea3602b85f0fae55c6bb5ca58bb9531'),('sites/all/modules/contrib/feeds/includes/FeedsSource.inc','734913967a03f339d66f676bbc7b0b08a5ac6014ee745a9a31cc4826f70b52b9');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/feeds/libraries/http_request.inc','ef24d23ad3dc2e9ebd40fddd3604d04562a5d258b05eab2f40523520eface95a'),('sites/all/modules/contrib/feeds/libraries/ParserCSV.inc','33b0daa530b1ac15f065748aade55172d4f1ab25e09a11763e7880f15c8eabd0'),('sites/all/modules/contrib/feeds/libraries/PuSHSubscriber.inc','bedf505ccb6082b54dde8ad2963fb8b4ca68a316edd6186f33dffdbab10af3dd'),('sites/all/modules/contrib/feeds/plugins/FeedsCSVParser.inc','9ba71ed54a2f96a137cb3c1098016a8c3d62ffc1fb3c24206a63dc23b2991386'),('sites/all/modules/contrib/feeds/plugins/FeedsFetcher.inc','73d5b7ec5f7912db3b615d451acb138c1a0eefb78137dc0f508aa1a588894be1'),('sites/all/modules/contrib/feeds/plugins/FeedsFileFetcher.inc','58399804e628d9cfe8cd9863de300bc3a39399e5b870bf8444cd7028f23b162d'),('sites/all/modules/contrib/feeds/plugins/FeedsHTTPFetcher.inc','938010f79c299e20f2a41176ffabfd7996e5de6109bc6096a94a6d46b75b743e'),('sites/all/modules/contrib/feeds/plugins/FeedsNodeProcessor.inc','ecf59c10e95a0e02f77358cd7f5f1f18cf251381baf92e3774d287421ee8ed16'),('sites/all/modules/contrib/feeds/plugins/FeedsOPMLParser.inc','9f781a61284b7c7f5881bf6ba228df7f16f8d52d9e617544cdbbfd16886d787d'),('sites/all/modules/contrib/feeds/plugins/FeedsParser.inc','38d54078a146bcc1bd8f45346c3c517293432445e2a4964ac6382ebd0a81710e'),('sites/all/modules/contrib/feeds/plugins/FeedsPlugin.inc','23e3e988e3d2f3f9771a126c98c7180478ac75352b14f10856cf4b5220547bc1'),('sites/all/modules/contrib/feeds/plugins/FeedsProcessor.inc','96d18841ab31f85e36f0f3fe8befcf72a14226b589ce6cf1cd063c2a3456516a'),('sites/all/modules/contrib/feeds/plugins/FeedsSimplePieParser.inc','45204f81664abfccfbe2b80fc64ea5e3f6fbf61fd9d2a3c2f29161524a9763fd'),('sites/all/modules/contrib/feeds/plugins/FeedsSitemapParser.inc','800ed6c6465fd202c9075a48ff7677eb4f375569dde89021289b6677cb8fbdba'),('sites/all/modules/contrib/feeds/plugins/FeedsSyndicationParser.inc','b25252e46714f15f4f0c6b204bc29eddbe057de689a43957a731070194f2fd73'),('sites/all/modules/contrib/feeds/plugins/FeedsTermProcessor.inc','0c1c728d57a00dbbecfe223e2b3cf76352679f860aee7be1169bef2e3eef298f');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/feeds/plugins/FeedsUserProcessor.inc','03892e84777161337e8e6cdc55eb7b038a9f2234ed13ffcac7f535434893083f'),('sites/all/modules/contrib/feeds/tests/common_syndication_parser.test','e0c7b3fd257c9e623ce340a3e386f1cb7381cf35d3ac24ce0d9e7c3ac4da1cab'),('sites/all/modules/contrib/feeds/tests/feeds.test','f96f0897ddfe01ab559f2812e7b858b2104e282e3b3ac863247085e87aa5194e'),('sites/all/modules/contrib/feeds/tests/feeds_content_type.test','395dbb79de7323da21333f398177d8d355710e90ac058dff2bd57a55ac4b31ce'),('sites/all/modules/contrib/feeds/tests/feeds_date_time.test','43e5705a95f31ab5013c3d4f622a8dbdc48a799666143ff3cd5e785977bc0ebb'),('sites/all/modules/contrib/feeds/tests/feeds_fetcher_file.test','b23c33573c707cbf30077d593a39b3b96c47532db7a2bb62f5e7c5cedbda7138'),('sites/all/modules/contrib/feeds/tests/feeds_fetcher_http.test','f731e081405a52586648930aeb0feba27a39ddf832671655894e00aec9e58cc3'),('sites/all/modules/contrib/feeds/tests/feeds_i18n.test','d89c74d3241e0929b2066467e144a059f8f25e9f6b8f0b6d74f0205cea61ad2a'),('sites/all/modules/contrib/feeds/tests/feeds_i18n_node.test','0f243ab826f3ed137da27d55551e2986beaa132b14a5c39d77848e3016093c01'),('sites/all/modules/contrib/feeds/tests/feeds_i18n_taxonomy.test','e935be0e03ad6f4c0c72db414d9010570cb046351ad86dc1954143688a0f0b11'),('sites/all/modules/contrib/feeds/tests/feeds_mapper.test','a4cec47f0db3f396afd419deb312daaf414bb43d475d6a873ce342a51d6f25ab'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_config.test','0c539fb83ff68811e0bbb43c9cec1ed2cfac1dd6104678738ca24431780d2903'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_date.test','20e7fa9da4c350fd35eadf99d741f3eacff52c39addcf74e47d5c4ebd1d7e2ec'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_date_multiple.test','c3c38d7061be3549e306aad97ba290cf3e3843adc77391e0d3b3b3c378c47098'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_field.test','03af558d51b320f1b4c4a0dde0c5d040af9919ca1097b59149adc16734b16b11'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_file.test','8fa13b98a2b02d1d7ced0225e589c00d4395c2f3b76f1e6a5d8d1edc525aada2');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/feeds/tests/feeds_mapper_format_config.test','e2cb1d681f4922935778f3fa2e69223e4a22cfeffd6706e6df2e9f3e6511e173'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_hooks.test','491ece3a53ccc0acd8f2605913191e31c71933956a078b870d9087879f00341e'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_link.test','6bab501ad968984da77e307c0f7c1c2a7f2064a8e69faa10811e9f3ac10c6e28'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_list.test','b277f6ed265b1132405ebdba42b9052597c279a87432c9795845d38eb156c8c4'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_multilingual_fields.test','3a99081f110d3b04c08eed7ca9ef53504eac781b818836ff9217ecf9b20b375b'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_path.test','26afdc588e1d0f28dd3262f59b9f088aab1a85e7fe573d2e8856989c686a90bc'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_profile.test','b2bf66651e7b81c6ba35cb2f3287cdd0ee28da0faac79baf5f39bc5648cc14e7'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_summary.test','c978b5e1dd87b43852f6c0a9da6cd42d45e47f76fb20e2999b2916d83146e58f'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_taxonomy.test','02b34019d79f92d5fa24f9b1d9d4912a9a7d5a33a5c5af1f358a08d31d9d3e1e'),('sites/all/modules/contrib/feeds/tests/feeds_mapper_unique.test','9f8dd0c4929a359e503208e01ecb1aaa574385f4e9af98255036a0bf2ab31514'),('sites/all/modules/contrib/feeds/tests/feeds_parser_csv.test','12966dce2f76cf1a71d4a1650a6cf061618494a1b10f359eb18ad4b753b61268'),('sites/all/modules/contrib/feeds/tests/feeds_parser_sitemap.test','7c3d72d275a3806ef4cc5df0e936d713a66e3787f45d1e87ddc0e4722f6bd629'),('sites/all/modules/contrib/feeds/tests/feeds_parser_syndication.test','86ee9c4ac5d9bec8286b54c374f8e4b092d06870f84ecd925f2dbd2abdc1d76c'),('sites/all/modules/contrib/feeds/tests/feeds_processor_node.test','22742b7d62dac04672d173f44c6e9035c471adf66992302b579d8e02359adb9f'),('sites/all/modules/contrib/feeds/tests/feeds_processor_term.test','acb6a09a810135138aed375765fefe25b7385877dd2aca02e0fef5b5e1a8d28b'),('sites/all/modules/contrib/feeds/tests/feeds_processor_user.test','e3d0e0dfc9df53d26f2fbd715dd2850c183618f2d307d5091a64a306b95d23ee');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/feeds/tests/feeds_push.test','6ddc67dd8948e395870b93ce59aedb3a812e4cc2bd558c5ae0ce6444a7bd7015'),('sites/all/modules/contrib/feeds/tests/feeds_rules.test','28cbe93c4b62cdc300c6fbdb9e86de05e84a5575ade8d5d1ba82dcefc0f775f0'),('sites/all/modules/contrib/feeds/tests/feeds_scheduler.test','72ac48ab806a995111bca4f214c75e1f10b2bc3a283c72e150c14d2e9bd92097'),('sites/all/modules/contrib/feeds/tests/feeds_tokens.test','a3bfe417cb8c8d3329ed16333900ff263cfbdc1ceb35bf864fb8f8697a8d6746'),('sites/all/modules/contrib/feeds/tests/http_request.test','55369c006f44dd793224f6110f451c152db4280133f6050b00a8c491377b7445'),('sites/all/modules/contrib/feeds/tests/parser_csv.test','49a5dd5fd1bd1ed950984919ffd42b7cfefe562b91dd77a88f83fc8a28ddd663'),('sites/all/modules/contrib/feeds/views/feeds_views_handler_argument_importer_id.inc','058606597d98bbadd84dd882ee3879dbcb90d0cf9a65c07e7b42a6f9af6741dd'),('sites/all/modules/contrib/feeds/views/feeds_views_handler_field_importer_name.inc','24c83b98ce3a073f806e4e89f0624f3588da43c8046884b068aea894b0469123'),('sites/all/modules/contrib/feeds/views/feeds_views_handler_field_log_message.inc','ee32391e54561de2d79a778833ad52243ab022f99a591bcfe3d2667d62fcc2b4'),('sites/all/modules/contrib/feeds/views/feeds_views_handler_field_severity.inc','fb9a5fc0b2c91395e1daf278b5a72bdb11938df9e98ee94e1bd7f9e35d258666'),('sites/all/modules/contrib/feeds/views/feeds_views_handler_field_source.inc','0a0e6df5be8b00b87afda0588c2d6b8cbfe6fb65664f8d9c2ef4acddaffc19f0'),('sites/all/modules/contrib/feeds/views/feeds_views_handler_filter_severity.inc','0b5feb901629a60b79d5247cbd94d026869504a5cab39a7380e7fe48970898ba'),('sites/all/modules/contrib/feeds/views/feeds_views_plugin_argument_validate_feed_nid.inc','436d15cc321e5919808af5948185b58179d6563da3f02f10d72ae270311ef9f6'),('sites/all/modules/contrib/feeds_entity_processor/src/FeedsEntityProcessor.inc','47e1aa47a28e519f569688a193454a565ecc212dc80b68d17fad03183286024c'),('sites/all/modules/contrib/feeds_entity_processor/src/Property/FeedsEntityProcessorPropertyBoolean.php','093502ab216e92b937e17e6a434915a80e636835f9e3080bf6893489489da147');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/feeds_entity_processor/src/Property/FeedsEntityProcessorPropertyDate.php','7cb55aa7231f9f3fafda48bd5e2ebc763688af04a1cf4905777abb384b37033a'),('sites/all/modules/contrib/feeds_entity_processor/src/Property/FeedsEntityProcessorPropertyDefault.php','896f33adee8b23eff41a7f9551f1f8e7073f9bc22890ce459221bea7e5076ba7'),('sites/all/modules/contrib/feeds_entity_processor/src/Property/FeedsEntityProcessorPropertyEntity.php','387363dea0d8741991123302f21a019d1a881c4a08af0b02dcca4dc9d8b3fc9c'),('sites/all/modules/contrib/feeds_entity_processor/src/Property/FeedsEntityProcessorPropertyEntityType.php','a4b430c35f79c895a0ffde58968cef87576ba09fc8816cdbffd7f9b480b1df25'),('sites/all/modules/contrib/feeds_entity_processor/src/Property/FeedsEntityProcessorPropertyInterface.php','3183520eb2d89a1ca803f89a7f3c913a37582aed5b2b4b0d858f165a65a1925e'),('sites/all/modules/contrib/feeds_entity_processor/tests/src/FeedsEntityProcessorBasicTest.test','1624bca9408d6e85c4797b0856ba2c791ecf8f1499db4d0488c959e0838061ad'),('sites/all/modules/contrib/feeds_entity_processor/tests/src/FeedsEntityProcessorPropertyTest.test','2a5e7fba36653d22e1a8030cbd99cfd8c7fcb5ae84e5a6f451991cfd97d3b638'),('sites/all/modules/contrib/field_collection/field_collection.entity.inc','0c8c9df7a84f5c6c77083eb3e1639f1c8bcdd003490fc643e01ffd938a2c8dcf'),('sites/all/modules/contrib/field_collection/field_collection.info.inc','e11b810756dabe6eb24b70a3a84390480a2de7c5d65ea5a1f0d6045802f8405e'),('sites/all/modules/contrib/field_collection/field_collection.migrate.inc','e483818782fc66acd36ce6499dcdd8725c8eb16595406dff57471c72366c9187'),('sites/all/modules/contrib/field_collection/field_collection.test','1a545c913d61eda017ac0419add102f50b08e51dfd90e0443bd33903f783ed61'),('sites/all/modules/contrib/field_collection/views/field_collection_handler_relationship.inc','6e8c13805c1ff233410bb408d524786df4ca64fc10ee4bd874a16277243efba1'),('sites/all/modules/contrib/field_group/tests/field_group.display.test','68b48634e0311fb4a804d39d8c03acc3de868719df0f4cca495c81e9de4e2035');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/field_group/tests/field_group.ui.test','17486a055b85febf5cc55cdb638bf104ef3acab75b76735763650217dd5ab9d4'),('sites/all/modules/contrib/field_group_multiple/field_group_multiple.field_ui.inc','9870f531f16c31ff43976d6e213bb0cd8eba5eca54ab6b4ab967ab6b9d4b5147'),('sites/all/modules/contrib/field_permissions/field_permissions.test','2f5fe79392e39a4cb9162a70e7a92dc048670764aa57618eb327ac646e858dbb'),('sites/all/modules/contrib/google_analytics/googleanalytics.test','828d81df014c82cc872c12428e28cf1275f5954b368ace8cdfde37c7ae0fc4cb'),('sites/all/modules/contrib/job_scheduler/JobScheduler.inc','4194dd0d19aee82e87f3697c1320bd95df64f0d11d3fe07d458c4165c9be484b'),('sites/all/modules/contrib/job_scheduler/JobSchedulerCronTab.inc','f89d6deb43ed6f314fd458f55b537b2bdd81a395ccdcd4f5dacc470398409f11'),('sites/all/modules/contrib/job_scheduler/job_scheduler.install','8ac4ea805e0f7048f08982fcaaf564fa6c6822569c81692f6886d6629692b40e'),('sites/all/modules/contrib/job_scheduler/job_scheduler.module','0b788f6530460e41e4fd3a1e5f17686851419dfb1708826f6fd828b48da798b8'),('sites/all/modules/contrib/jquery_update/jquery_update.install','d377a4e1df5c9606b4d603fbf14296f6d4df921bb3e188341a0c602651498388'),('sites/all/modules/contrib/jquery_update/jquery_update.module','5550809cea16a9f09ebcd6e70fc36a19a2aa3fd6180039d2e2382b86d659a8c3'),('sites/all/modules/contrib/libraries/tests/LibrariesAdminWebTest.test','933af00ee9ad342999e20c0a82440ab04933b5d7713ffe2e7371a9af15492bf5'),('sites/all/modules/contrib/libraries/tests/LibrariesLoadWebTest.test','4cfaf88ce29e72f8ecd52b02cc9f7bac2ea60a715530cd9ff4fea929dac161ee'),('sites/all/modules/contrib/libraries/tests/LibrariesUnitTest.test','08139d770447993484828d0a642b6a771314c74e392074e94c2b7dcebc10b093'),('sites/all/modules/contrib/libraries/tests/LibrariesWebTestBase.test','056dfdd67ac9d6a84ffbe0f507e165fd6f07a0c82c3c7efbc1874e870e85e83a'),('sites/all/modules/contrib/link/link.migrate.inc','0a17ff0daa79813174fff92e9db787e75e710fe757b6924eec193c66fe13f3df'),('sites/all/modules/contrib/link/link.module','39bc7a76730d855c17544d4a67ef6dbf3e018b74bc2f2b5d2431b6a370e1da3d');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/link/tests/link.attribute.test','92c76292e0b2f74ef21d6bca563cf5d47d0331d72bacc454a550c6ace51697cc'),('sites/all/modules/contrib/link/tests/link.crud.test','de19e2c5e8c6cb02f25d7051bdd1db77852379ac59ce8185c25b4bf927478f22'),('sites/all/modules/contrib/link/tests/link.crud_browser.test','13da1fde2aa1c45ec11c8b343004d116aed074789a5b46f8dd6b299781e9755d'),('sites/all/modules/contrib/link/tests/link.entity_token.test','e3c414eb7bdc1a27b8408446ded03b77c52b3419f38f6a3d3ada68effda4b616'),('sites/all/modules/contrib/link/tests/link.test','fe5d8cd577fbfc07929e7216e115530a28777ace9b7135fbc853a3a78d550456'),('sites/all/modules/contrib/link/tests/link.token.test','74d2a9888005d08fba8c6d3720592a4d9dffa5d30a25fee1714ce89fa0688041'),('sites/all/modules/contrib/link/tests/link.validate.test','ff8a018f4ecf621e8f5f0fdec7c8d505305778c615ef17a84c7542bee0e29c47'),('sites/all/modules/contrib/link/views/link_views_handler_argument_target.inc','d77c23c6b085382c63e7dbce3d95afc9756517edcdc4cd455892d8333520d4c9'),('sites/all/modules/contrib/link/views/link_views_handler_filter_protocol.inc','e10a0d2de73bfa9a56fadbac023c6ac16022ced40c0444ab6ffed1b5d7ea7358'),('sites/all/modules/contrib/panels/includes/common.inc','caa1b8672ef3e2ea07039f5ea8b84aa30c20949a755c01a92339ba6e60a4dd18'),('sites/all/modules/contrib/panels/includes/legacy.inc','dc65c1a82f4a063f9cbebbd8a0ceb512a3b41a1ee2603ec8045034412a791aab'),('sites/all/modules/contrib/panels/includes/plugins.inc','d852baa024f1d5232d3083e2dd9821bb1ccd688356361bb5fc23096a9840f993'),('sites/all/modules/contrib/panels/panels.module','f49b984f3ef3111dab12c17bd47429e71efdac2a4f8f65d88a382990067c9706'),('sites/all/modules/contrib/panels/panels_ipe/panels_ipe.module','589dd1dc6efaf0b9f6d45ae5c9fbba93785226beed2803370e047d184bfebf7f'),('sites/all/modules/contrib/panels/panels_ipe/plugins/display_renderers/panels_renderer_ipe.class.php','6d1d286c45ff7e1fcfd30c76e2f1a81353cd18221a2b9ea51bf4a2e00889ec03'),('sites/all/modules/contrib/panels/panels_mini/plugins/export_ui/panels_mini_ui.class.php','f316e9ced4793382669274bf8519ff7848e1b8d834545286b16e0933c8f1ecf4');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/panels/panels_node/panels_node.module','d2f62fb29607b3d3d82a1a236d5e032a87831abeb649d7957fdd1de21919658c'),('sites/all/modules/contrib/panels/plugins/display_renderers/panels_renderer_editor.class.php','fb84a9cbc0bdc50dec1b50ce72f66f5d92552952850bade6ee66ba2541febf3c'),('sites/all/modules/contrib/panels/plugins/display_renderers/panels_renderer_simple.class.php','420aeca22872635ebd5ab3ce719dd8e1d7fef339271db5f20a0834b812084a6e'),('sites/all/modules/contrib/panels/plugins/display_renderers/panels_renderer_standard.class.php','2f57201f4de2a1d616bf3af238d1673ed0149dff296328b3ee986bd9bc0b60ef'),('sites/all/modules/contrib/panels/plugins/export_ui/panels_layouts_ui.class.php','53dce95a6ce9985a374565102f745e2c2655424fa29cb666432d596a71e82696'),('sites/all/modules/contrib/panels/plugins/views/panels_views_plugin_row_fields.inc','d8bcbc2e4e992e7692b807e2a2f2d5c528b7633c054d268adbbc7586fed744c9'),('sites/all/modules/contrib/panels/tests/PanelsEntityViewWebTestCase.test','268042545997af02dff42c7a9ec121d0d0f0581743c2cc916a3f950c97106dd4'),('sites/all/modules/contrib/panels/tests/PanelsNodeViewWebTestCase.test','e56c3c424863b5f68114dd20b633deb8a4cb6d98107f83f7d610c4a22eb764c2'),('sites/all/modules/contrib/panels/tests/PanelsTermViewWebTestCase.test','24d75f1cef700156fb8ed3609bbf3ab4ef5780a6b8a2aa3bab25f9a0b2ccfa95'),('sites/all/modules/contrib/panels/tests/PanelsUserViewWebTestCase.test','15009c9943cfd529822044916c597a130a408a0d764e31c62bdebfb37766546b'),('sites/all/modules/contrib/pathauto/pathauto.migrate.inc','31084f25620be5620aecf9d60356dba662b6eda426c0c94ba996821110e4b1cc'),('sites/all/modules/contrib/pathauto/pathauto.test','1297560df48bad9b325d775d3bc64a411c03a0fd630c5e53ff8e46c4550a6977'),('sites/all/modules/contrib/rules/includes/faces.inc','72352c57a12e740b80e235ee5fe245b91c5bca9938f4751670acc8e719626bcb'),('sites/all/modules/contrib/rules/includes/rules.core.inc','e7d13cae20c6610a6236b1cedd891efdaf97490e1924e3c26c73994ca421d199'),('sites/all/modules/contrib/rules/includes/rules.event.inc','286bb8005acf30a6f4fdb23ff75843f70a82a99ac3e225c31290aad10e2a50ae');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/rules/includes/rules.plugins.inc','d760fa99514c4acdc6e7abf6d820a979615304ed677eb291955356115dcbe44c'),('sites/all/modules/contrib/rules/includes/rules.processor.inc','902d554987e019cfe9c8818a83a96db7e02c556efb4c63961ee9d091ee98c988'),('sites/all/modules/contrib/rules/includes/rules.state.inc','26cb9d0792e6313e0582816527eef3e1310a07c5e3065b2b26e3408dca500bf0'),('sites/all/modules/contrib/rules/modules/node.eval.inc','7873fe5eaa00b0f6b189bb6e4d43efe63d587009e05ae502c15076c63b931a6c'),('sites/all/modules/contrib/rules/modules/php.eval.inc','4d579f9d83912a1ff4e3e35b20a7792fb7e282d8d07c706e944ffbb6b20c42f6'),('sites/all/modules/contrib/rules/modules/rules_core.eval.inc','edf268c4e9a24d700ef08ca5cf8addc93a437d30cb0129aeb7aa93e76f8f855e'),('sites/all/modules/contrib/rules/modules/system.eval.inc','1076decc24a4779c7a582b446b9147d65ddd03cec530ee62809c86e49c62f736'),('sites/all/modules/contrib/rules/rules.features.inc','dc219fc6df253743cfe775503edffd6ba8b76fe9d8b549294242b0691cad0302'),('sites/all/modules/contrib/rules/rules_admin/rules_admin.inc','5bcd9e3059d4ee4dbcec6dd959bbc518a8c2d0dcadd506cd1c5c31aab2cda463'),('sites/all/modules/contrib/rules/rules_admin/rules_admin.module','38cd2e74c2d951d4a4d6025191cf4aa87be9ece9b2bf5b248ce0bfdfc62aa9cb'),('sites/all/modules/contrib/rules/tests/rules.test','61d6f9cfb2ff09eb595639a31dbd651de0606288d7b85d29089f564bc91ca516'),('sites/all/modules/contrib/rules/ui/ui.controller.inc','c0d16bd7340a766225865d942dcdad23aead4275e3f18b326e23f42f2313f30b'),('sites/all/modules/contrib/rules/ui/ui.core.inc','ba58ed06bf4c3471c5958c2072315e016ab563a74291b89666b868214b8b0725'),('sites/all/modules/contrib/rules/ui/ui.data.inc','4646714b3c18f527193308316313944a410f95c3cc849c8605d6dcf63ef035c1'),('sites/all/modules/contrib/rules/ui/ui.plugins.inc','d290f1ab6933f0a9189c5197c471d422d04d315b137079863ef746ed4ef673c4'),('sites/all/modules/contrib/rules_conditional/includes/rules_conditional.core.inc','849905425a38b0c9b24bf62003fdbc98d51b5512ab5fc889db241434848b3462'),('sites/all/modules/contrib/rules_conditional/includes/rules_conditional.plugin.inc','a8562c58aa14149f9b8dae9707f820d90b58f61b51ee9491be858e1f40610adf');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/rules_conditional/includes/rules_conditional.ui.inc','5240ff2ab880b9a86dde193cf4f36a6b216d9317054e3b5f9189dcaef3116cb6'),('sites/all/modules/contrib/rules_conditional/tests/rules_conditional.test','4f1740263e6a10cea3adac44efa1c89c8f58976af325f617104e5b38642eeb7f'),('sites/all/modules/contrib/smtp/smtp.mail.inc','cafeb98d7e67d996dcd2bf7cf116a456557d0c17a78bdb6c39699f8dcf981d59'),('sites/all/modules/contrib/smtp/smtp.phpmailer.inc','398ce4ebf7478970d76fb3757933675d5fa3407d9b9a376786cfda26708ff6ae'),('sites/all/modules/contrib/smtp/smtp.transport.inc','202155876c446233a8a879965157a5ee43e4c2e8b8f702f21866e1549bdbd601'),('sites/all/modules/contrib/smtp/tests/smtp.unit.test','376c3739f03b91ad4e094f287599a279dc3bba612c3af7b85bf6b4c66fe07baf'),('sites/all/modules/contrib/stringoverrides/stringoverrides.admin.inc','bb97dab251c7d7d77ec889e3c5fa63605b43a8f5d532ca48ad497eccccfde9d7'),('sites/all/modules/contrib/stringoverrides/stringoverrides.install','f111baca29797df07d02fc796bd14b81381da0810b97f69c5260c5b0579185ff'),('sites/all/modules/contrib/stringoverrides/stringoverrides.module','4604387c870afbc500d60e420e992c8fce9cedabaeac40d30c4b33685884ba89'),('sites/all/modules/contrib/terms_of_use/tests/terms_of_use.test','f6072950b660c8d213fa8203a85590e126aefe19320a6be2e86a4ed54650aceb'),('sites/all/modules/contrib/token/token.test','79c44cc6bb46caa41eaf371df9c77d7ef98bbee7d96c04ca1039375dc6674961'),('sites/all/modules/contrib/views/handlers/views_handler_area.inc','95d4374c805c057c9855304ded14ce316cdee8aca0744120a74400e2a8173fae'),('sites/all/modules/contrib/views/handlers/views_handler_area_messages.inc','de94f83a65b47d55bbb4949fcf93dd4ad628a4a105cea2b47cdc22593f3e5925'),('sites/all/modules/contrib/views/handlers/views_handler_area_result.inc','f406d7e4409545ffea2e56c9a10f87f20adef2276c6d6bbc8003885cccc8ca3b'),('sites/all/modules/contrib/views/handlers/views_handler_area_text.inc','531d0ac3b64206970593762df0abac60524f607253c3af876dd66ba747786dce'),('sites/all/modules/contrib/views/handlers/views_handler_area_text_custom.inc','35b702060c192b0adf6601ed437d0a02effd3accb71c07d6156013c8be9d5a15');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/handlers/views_handler_area_view.inc','e604b5716d9ea202ab0b8e51d2bd0a4a8eeab461db0a74bf37745d6cbba25c41'),('sites/all/modules/contrib/views/handlers/views_handler_argument.inc','1f0498d1878e331f59b9f0cc87b67df330437c736e565a05fe1a14ab65ec3f26'),('sites/all/modules/contrib/views/handlers/views_handler_argument_date.inc','1b423d5a437bbd8ed97d0bfb69c635d36f15114699a7bc0056568cc87937477d'),('sites/all/modules/contrib/views/handlers/views_handler_argument_formula.inc','5a29748494a7e1c37606224de0c3cac45566efe057e4748b6676a898ac224a61'),('sites/all/modules/contrib/views/handlers/views_handler_argument_group_by_numeric.inc','b8d29f27592448b63f15138510128203d726590daef56cf153a09407c90ec481'),('sites/all/modules/contrib/views/handlers/views_handler_argument_many_to_one.inc','b2de259c2d00fe7ed04eb5d45eb5107ce60535dd0275823883cc29b04d1a3974'),('sites/all/modules/contrib/views/handlers/views_handler_argument_null.inc','26699660fd0915ec078d7eb35a93ef39fd53e3a2a4841c0ac5dbf0bb02207bee'),('sites/all/modules/contrib/views/handlers/views_handler_argument_numeric.inc','ae23d847fa0f1e92baec32665a8894e26660999e338bebffb49ee42daac5a063'),('sites/all/modules/contrib/views/handlers/views_handler_argument_string.inc','f8fe4daf0a636cc93d520a0d5ff212840d8bdaa704ddc3c59a24667f341ed3a1'),('sites/all/modules/contrib/views/handlers/views_handler_field.inc','3d059d737e738436a15651f9ac8374f460a71eb569619ba0a8a14a55a3efc87e'),('sites/all/modules/contrib/views/handlers/views_handler_field_boolean.inc','dc00b916a223935e05f51d94a2dffbaf430b162517072f7c2122332af41e8fc2'),('sites/all/modules/contrib/views/handlers/views_handler_field_contextual_links.inc','2f54701c9f71a4a525e724a6787b5e0089a3c38e426d1925bf8344d017d571bf'),('sites/all/modules/contrib/views/handlers/views_handler_field_counter.inc','865a5ad7df830dae9e167709446e66cebf3e32e91ec05b5c2b887c96d0d6b0d8'),('sites/all/modules/contrib/views/handlers/views_handler_field_ctools_dropdown.inc','a78c424ef884ae9878c0b140d532bdf3b116fdc0e8a7cd519848c675d5b1a5a6');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/handlers/views_handler_field_custom.inc','a3d25fc20401ae0a1af4b7d6e83376a5b7dc18ab0aed17a3c6d81e2314cf19f8'),('sites/all/modules/contrib/views/handlers/views_handler_field_date.inc','79cb6583981104d70d20393fe62281c749680f375cb67355635ef00688258934'),('sites/all/modules/contrib/views/handlers/views_handler_field_entity.inc','909ab36aff896ad8fa4306d95a052172ec27e471ab385a035fcadef8d019e0f9'),('sites/all/modules/contrib/views/handlers/views_handler_field_links.inc','331a7c8e68a9a94a41a0d7e3e2b6a5c8436792cf244b409ffd732f9cbbab3642'),('sites/all/modules/contrib/views/handlers/views_handler_field_machine_name.inc','df2fe47cf9c6d2e7de8627c08da809fb60883c38697340966f303c223e22aee4'),('sites/all/modules/contrib/views/handlers/views_handler_field_markup.inc','a0c652fdf47f7efe35bbf2371f00e230409fe90ea0038eb101bf0c93ae0718e9'),('sites/all/modules/contrib/views/handlers/views_handler_field_math.inc','08c9fb88b20ca346ee3dc29773b2341ea294ba85b659dbd8c1cc92a9ddf900e8'),('sites/all/modules/contrib/views/handlers/views_handler_field_numeric.inc','1e36f9d55b4cfeb268068e5c9bd6f326999c04191485d3db4610e94e6f57fad9'),('sites/all/modules/contrib/views/handlers/views_handler_field_prerender_list.inc','0fe605bf457886fbca5f041a422fc51c6a1927654dcd06cbfc619496fe57de0e'),('sites/all/modules/contrib/views/handlers/views_handler_field_serialized.inc','ad3d82a9f37ae4c71a875526c353839da2ff529351efc7861f8b7c9d4b5a47db'),('sites/all/modules/contrib/views/handlers/views_handler_field_time_interval.inc','280d569784312d19dabfb7aeb94639442ae37e16cba02659a8251de08a4f1de2'),('sites/all/modules/contrib/views/handlers/views_handler_field_url.inc','7ca57a8dcc42a3d1e7e7ec5defa64a689cb678073e15153ff6a7cafe54c90249'),('sites/all/modules/contrib/views/handlers/views_handler_filter.inc','4c8937c5b6399c42bb6659169f5c8563ca415fd7effab1ddeeebf2bb6b9a8011'),('sites/all/modules/contrib/views/handlers/views_handler_filter_boolean_operator.inc','f4ca59e4e1f91f219a1b33690a4ad412269946804fe7cacf24f2574b2c6d8599'),('sites/all/modules/contrib/views/handlers/views_handler_filter_boolean_operator_string.inc','0ddd32cda535112c187de1c062797849ff90d9b312a8659056e76d2d209f694a');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/handlers/views_handler_filter_combine.inc','802f033bba6a9965896b02e3c3e0ea4493e4be282f2c5444ebbeec7e8a478072'),('sites/all/modules/contrib/views/handlers/views_handler_filter_date.inc','fb63877ecfa64f2be8557a21dcf34e28b59c4a9c5f561f55738162d2301c4aa1'),('sites/all/modules/contrib/views/handlers/views_handler_filter_entity_bundle.inc','02db977a67a09f70bdc8e2bbc46a05fff8a6d8bd6423308c95418476e84714a3'),('sites/all/modules/contrib/views/handlers/views_handler_filter_equality.inc','2100cdd7f5232348adae494c5122ba41ff051eee0a8cc14aeaf6a66202cb7ed1'),('sites/all/modules/contrib/views/handlers/views_handler_filter_fields_compare.inc','e116c3796f1bd409b150f5ab896b9bab956d6e71a82e5770ed6fde44605751b2'),('sites/all/modules/contrib/views/handlers/views_handler_filter_group_by_numeric.inc','9401c4c0fe0d678898e5288ef8152784a12e0743df21dec15457353eb2cdb01d'),('sites/all/modules/contrib/views/handlers/views_handler_filter_in_operator.inc','8fd7f075468bddde5c4208b1c3a6105f8fea0ac0c214452a37c00fc2f3453a7d'),('sites/all/modules/contrib/views/handlers/views_handler_filter_many_to_one.inc','b4a415c2824195d3d7d0e37ada9d69ebec0b9cd833ebcac2439efc20aac15595'),('sites/all/modules/contrib/views/handlers/views_handler_filter_numeric.inc','8a999227d17674a70381ab8b45fbdc91269a83a45e5f7514607ed8b4a5bf6a9f'),('sites/all/modules/contrib/views/handlers/views_handler_filter_string.inc','140006335ac5b19b6253b431afde624db70385b9d22390b8c275296ae469cc7b'),('sites/all/modules/contrib/views/handlers/views_handler_relationship.inc','4fefdb6c9c48b72dcfe86484123b97eb5f5b90b6a440d8026d71f74dccbd1cd6'),('sites/all/modules/contrib/views/handlers/views_handler_relationship_groupwise_max.inc','47dcfe351159b10153697c17b3a92607edb34a258ba3b44087c947b9cc88e86f'),('sites/all/modules/contrib/views/handlers/views_handler_sort.inc','06aab8d75f3dce81eb032128b8f755bfff752dcefc2e5d494b137bca161fdefa'),('sites/all/modules/contrib/views/handlers/views_handler_sort_date.inc','d7e771abf74585bd09cc8e666747a093f40848b451de8ba67c8158317946f1b2');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/handlers/views_handler_sort_group_by_numeric.inc','4ba1c38c9af32789a951b8f9377e13631ae26bf1dac3371b31a37ead25b32eb8'),('sites/all/modules/contrib/views/handlers/views_handler_sort_menu_hierarchy.inc','ccd65ea3b3270366b7175e2cd7cc9167a09c27e1486949e4a05495ff5c7be5c1'),('sites/all/modules/contrib/views/handlers/views_handler_sort_random.inc','05a00c3bf76c3278ae0ce39a206a6224089faf5ac4a00dd5b8a558f06fab8e46'),('sites/all/modules/contrib/views/includes/base.inc','5ad8155dbc31cc4460b65747d99b70a64a83f6fefa00231c8d965293a7a183ee'),('sites/all/modules/contrib/views/includes/handlers.inc','5cab753c012d357ce2a10b645eca4254b3647fdfe2452510eee37c8a12639a14'),('sites/all/modules/contrib/views/includes/plugins.inc','11c03b1c69be7e9969ec0665b07ddfe170c9505f8d4e862cb27f1232a2a4240e'),('sites/all/modules/contrib/views/includes/view.inc','99e60c217d6dc781ec48ae8fc841e636eee31d977936e1980a34eca28734ad2e'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_argument_aggregator_category_cid.inc','97acf41d6694fd4451909c18b118f482db9f39aa4b8c5cfa75d044d410c46012'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_argument_aggregator_fid.inc','c37def91d635b01db36809141d147d263cc910895e11c05e73d703e86b39fd43'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_argument_aggregator_iid.inc','344f2806344d9c6356f2e19d297522f53bab7a4cebdf23c76d04c85c9e0a0d8e'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_field_aggregator_category.inc','252b30b832d8c0097d6878f5d56beecfc8cc1fc7cc8b5a4670d8d95a80b4f17d'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_field_aggregator_title_link.inc','1bb18967b11f2f4de62075d27e483f175b5e3431622c2e5e8292afcd000beadf'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_field_aggregator_xss.inc','2db2e1f0500e0a252c7367e6a92906870b3247f9d424f999c381368ee2c76597'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_filter_aggregator_category_cid.inc','7c7c0690c836ac1b75bca3433aca587b79aec3e7d072ce97dc9b33a35780ad4f');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/modules/aggregator/views_plugin_row_aggregator_rss.inc','591e5bb7272e389fe5fc2b563f8887dbc3674811ffbb41333d36a7a9a1859e56'),('sites/all/modules/contrib/views/modules/book/views_plugin_argument_default_book_root.inc','bd3bd9496bf519b1688cf39396f3afa495a29c8190a3e173c0740f4d20606a53'),('sites/all/modules/contrib/views/modules/comment/views_handler_argument_comment_user_uid.inc','5e29f7523010a074bda7c619b24c5d31e0c060cdbe47136b8b16b2f198ed4b4a'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment.inc','a126d690cc5bf8491cb4bee4cc8237b90e86768bebbbecb8a9409a3c1e00fa9e'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_depth.inc','1dc353a31d3c71c67d0b3e6854d9e767e421010fbbf6a8b04a14035e5f7c097f'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link.inc','1f7382f7cb05c65a7cba44e4cd58022bbc6ce5597b96228d1891d7720510bf0e'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_approve.inc','f6db8a0b4dd9fffba9d8ecb7b7363ba99d3b2dc7176436a0a6dd7a93195a5789'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_delete.inc','905a4cb1f91a4b40ee1ca1d1ded9958ae18e82286589fec100adb676769b1fe9'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_edit.inc','8139c932cde20f366a3019111c054b1ed00dbc0c40634b91239b400243b7723a'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_reply.inc','8807884efb840407696c909b9d5d07f60bde9d7f385a59eca214178ce5369558'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_node_link.inc','64746ff2b80a5f8e83b996a325c3d5c8393934c331510b93d5815ea11c1db162'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_username.inc','1ce3fa61b3933a3e15466760e4c5d4a85407ba4c8753422b766fc04395fa4d02'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_last_comment_timestamp.inc','30c55ec6d55bf4928b757f2a236aab56d34a8e6955944a1471e9d7b7aed057c0');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/modules/comment/views_handler_field_ncs_last_comment_name.inc','82025f3ad22b63abc57172d358b3f975006109802f4a5ecac93ce3785c505cae'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_ncs_last_updated.inc','facfbc5defd843f4dfb60e645f09a784234d87876628c8de98d2dfa6bb98a895'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_node_comment.inc','0cf9e8fb416dca35c3b9df3125eb3a8585f798c6a8f8d0e1034b1fccb5cec38b'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_node_new_comments.inc','e0830d1f70dea473e46ab2b86e380ef741b2907f033777889f812f46989f2ff7'),('sites/all/modules/contrib/views/modules/comment/views_handler_filter_comment_user_uid.inc','f526c2c4153b28d7b144054828261ba7b26566169350477cd4fb3f5b5f280719'),('sites/all/modules/contrib/views/modules/comment/views_handler_filter_ncs_last_updated.inc','9369675dfee24891fe19bddf85a847c275b8127949c55112ae5cb4d422977d24'),('sites/all/modules/contrib/views/modules/comment/views_handler_filter_node_comment.inc','70706c47bad9180c2426005da6c178ed8d27b75b28cb797ca2a1925a96dcef09'),('sites/all/modules/contrib/views/modules/comment/views_handler_sort_comment_thread.inc','a64bc780cba372bd408f08a5ea9289cdf3d40562bdf2f7320657be9a9f6c7882'),('sites/all/modules/contrib/views/modules/comment/views_handler_sort_ncs_last_comment_name.inc','9f039e8b8a046c058fda620804e3503be7b3e7e3e4119f0b015ccbae0922635b'),('sites/all/modules/contrib/views/modules/comment/views_handler_sort_ncs_last_updated.inc','fa8b9c3614ad5838aa40194940d9dc6935175a16e141ac919f40e74a7428c4e3'),('sites/all/modules/contrib/views/modules/comment/views_plugin_row_comment_rss.inc','96f651234e30a3aff805ae9a524c99813a286bf75b5a9fd8da2d7d4fbec50810'),('sites/all/modules/contrib/views/modules/comment/views_plugin_row_comment_view.inc','82d7296fa3109ca170f66f6f3b5e1209af98a9519bb5e4a2c42d9fc0e95d7078'),('sites/all/modules/contrib/views/modules/contact/views_handler_field_contact_link.inc','ec783b215a06c89c0933107a580c144051118305dd0129ac28a7fea5f95a8fd5');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/modules/field/views_handler_argument_field_list.inc','eff5152a2c120425a2a75fe7dbcb49ed86e5d48392b0f45b49c2e7abee9fa72b'),('sites/all/modules/contrib/views/modules/field/views_handler_argument_field_list_string.inc','534af91d92da7a622580ab8b262f9ef76241671a5185f30ba81898806c7b7f15'),('sites/all/modules/contrib/views/modules/field/views_handler_field_field.inc','94ff7382dba773fc637c777e20b810ae7d4aa4936fb0bc067e6a3824ba929d2d'),('sites/all/modules/contrib/views/modules/field/views_handler_filter_field_list.inc','3b55cd0a14453c95ebd534507ab842a8505496d0b7e4c7fcd61c186034c7322d'),('sites/all/modules/contrib/views/modules/field/views_handler_filter_field_list_boolean.inc','d33035e141ca686b3f18da1e97adaa1ff8e5d1db266340d3030e873a744685e2'),('sites/all/modules/contrib/views/modules/field/views_handler_relationship_entity_reverse.inc','060035c5430c81671e4541bcf7de833c8a1eb3fa3f3a9db94dd3cebfa4299ef1'),('sites/all/modules/contrib/views/modules/filter/views_handler_field_filter_format_name.inc','fc3f074ffb39822182783a8d5cf2b89ffcc097ccbb2ed15818a72a99e3a18468'),('sites/all/modules/contrib/views/modules/locale/views_handler_argument_locale_group.inc','c8545411096da40f48eef8ec59391f4729c884079482e3e5b3cdd5578a1f9ad7'),('sites/all/modules/contrib/views/modules/locale/views_handler_argument_locale_language.inc','a1b6505bb26e4b3abce543b9097cd0a7b8cddf00bf1e49fbba86febebb0f4486'),('sites/all/modules/contrib/views/modules/locale/views_handler_field_locale_group.inc','5b62afe18f92ee4a5fb49eb0995e65b4744bbe3b9c24ffe8f6c21f3191c04afc'),('sites/all/modules/contrib/views/modules/locale/views_handler_field_locale_language.inc','0cc08bd2d42e07f26e7acc92642b36f0ac62bf23ee9ba3fd21e6cab9a80e9f72'),('sites/all/modules/contrib/views/modules/locale/views_handler_field_locale_link_edit.inc','3883d3f37030d6d8e397e79ccb99ec3cb715ba7a789510f4b79b7515e314e7ae'),('sites/all/modules/contrib/views/modules/locale/views_handler_field_node_language.inc','a6ccdb6c1c4df3b4fd31b714f5aa4ac99771ffce63439d6c5de6c0ae2f09a2c1');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/modules/locale/views_handler_filter_locale_group.inc','40fbc041bab64f336f59d1e0593f184b879b2a0c9e2a6050709bdc54cceb2716'),('sites/all/modules/contrib/views/modules/locale/views_handler_filter_locale_language.inc','3433893d988aad36b918dd6214f5258b701506bc9c0c6a72fd854a036b635e20'),('sites/all/modules/contrib/views/modules/locale/views_handler_filter_locale_version.inc','9337ea5216784ffc67a0aa45c946e65ad11fc40849189cc70911a81366b78620'),('sites/all/modules/contrib/views/modules/locale/views_handler_filter_node_language.inc','d7edea3f35891cc76aa3bb185b9c1404378623ea7fd214c2a1f0d824df12779a'),('sites/all/modules/contrib/views/modules/locale/views_handler_sort_node_language.inc','b7b70efcf7de1f4dee4722ac8aa16031f17d62e60b1b5772f9985cadf91e4415'),('sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','80ee0e32fd48de1fa9d91645f27f7f26e8700acd3b1120a6d414bb1a794f6d0e'),('sites/all/modules/contrib/views/modules/node/views_handler_argument_node_language.inc','7ee3ba02bddaa6aeef9961cdf6af7bb386fc2b12529f095b28520bb98af51775'),('sites/all/modules/contrib/views/modules/node/views_handler_argument_node_nid.inc','11c5b62413ffd1b2c66d4b60a2fe21cf6eb839ae40d4ef81c7a938c5be3e30de'),('sites/all/modules/contrib/views/modules/node/views_handler_argument_node_type.inc','9e21b4cc4ae861f58c804ea7e2c17fbc5dd2a7938b9abfeb54437b531fc95e6e'),('sites/all/modules/contrib/views/modules/node/views_handler_argument_node_uid_revision.inc','675c99f8da9748ac507e202f546914bee3ed4065f6ce83a23a2aaafdaefd084e'),('sites/all/modules/contrib/views/modules/node/views_handler_argument_node_vid.inc','7e5da5594a336c1d0f4cf080ab3fcd690e0de1ee6b5e1830b5fb76a46bced19c'),('sites/all/modules/contrib/views/modules/node/views_handler_field_history_user_timestamp.inc','7d6d9c8273d317ab908d4873a32086dbd5f78a2b2d07b7ed79975841a2cadea6'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node.inc','99a0ef52b68e8913eb3563d5c47097c09e46c6493fcb006f383c6f6798edb7fc'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_link.inc','26d8309a3a9140682d7d90e4d16ff664a3d7ce662af6ccbf75dc4c493515d7d9');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/modules/node/views_handler_field_node_link_delete.inc','3eeed8c9ffc088ee28b8ffaa5e2b084db24284acc4d1b2e69f90c96cc889016d'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_link_edit.inc','28f8c3b7d3d60c31fec3cdf81c84cfbb20f492220457694a0e150c3ddee030c0'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_path.inc','f392fde21e434fd40fc672546ef684780179d91827350ba9c348bb1cc5924727'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision.inc','3f510d58acaa8f844292b86c388cb1e78eac8c732bb5e7c9e92439c425710240'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision_link.inc','ace72f296cf4a4da4b7dd7b303532aebf93b6b1c18a5d30b51b65738475e3889'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision_link_delete.inc','0a36602f080c4ef2bb5cb7dbddc5533deab7743c2fbf3bd88b9e478432cac7fb'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision_link_revert.inc','80ddc7f0c001fde9af491bb22d6044b85324fe90bea611fc3822408fd60008fa'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_type.inc','f8f39c6f238f837270d1b2e42e67bf9ab400a37fe24246c8b86dfcfacc1c4fd9'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_version_count.inc','1298f7f7ee4b6e6e2957b266fbb7c63e102b9d7e9ccca8d5a86592736bce9493'),('sites/all/modules/contrib/views/modules/node/views_handler_filter_history_user_timestamp.inc','2970f270e071cad079880e9598d9f7b71d4dd2a2a42a31cd4489029a3cafe158'),('sites/all/modules/contrib/views/modules/node/views_handler_filter_node_access.inc','ca625167c8928f1c5b354c27c120ed9b19c1df665dc3b02ed6d96b58194d6243'),('sites/all/modules/contrib/views/modules/node/views_handler_filter_node_status.inc','f7099a59d3f237f2870ecb6b0b5e49dd9d785b1085e94baf55687251e7f3231b'),('sites/all/modules/contrib/views/modules/node/views_handler_filter_node_type.inc','6842082e7b6e131d6e002e627e6b4490b93ca6ffe7fc0b158d31843217c8c929'),('sites/all/modules/contrib/views/modules/node/views_handler_filter_node_uid_revision.inc','2cfe9ba95e5ea8c240a57cfa1bed58385cbfed0c7f35e3d8c4da6d873b5a61fa');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/modules/node/views_handler_filter_node_version_count.inc','de61f3547604e5905486cdae5f5e94d1a45bdac4d3c43157193dd6fe0dd6473c'),('sites/all/modules/contrib/views/modules/node/views_handler_sort_node_version_count.inc','ce2a392319ebed3dbb2b660f3d6f4c6690b1cd46cf6b1c01802f12158114c4c4'),('sites/all/modules/contrib/views/modules/node/views_plugin_argument_default_node.inc','7fb79c8f4adb9bcef7c7da4bf4046fe3490e16c244f6ab96fdca97a8567315ff'),('sites/all/modules/contrib/views/modules/node/views_plugin_argument_validate_node.inc','f10d3f4081eed5ca32c41b67e9a0e6f35b2f8ba2cd7897230cb5a680b410a6de'),('sites/all/modules/contrib/views/modules/node/views_plugin_row_node_rss.inc','1e55454684102fad08c947695c370a890a22ea22c3c9aca3207f2299aa3daf7e'),('sites/all/modules/contrib/views/modules/node/views_plugin_row_node_view.inc','6b7dfe1a3b16eae682b2664a48bb6af16f040b4ca2c8e71f8b771a0577a66bae'),('sites/all/modules/contrib/views/modules/profile/views_handler_field_profile_date.inc','e206509ef8b592e602e005f6e3fa5ba8ef7222bdb5bacd0aaeea898c4001e9b0'),('sites/all/modules/contrib/views/modules/profile/views_handler_field_profile_list.inc','da5fa527ab4bb6a1ff44cc2f9cec91cf3b094670f9e6e3884e1fedce714afe6f'),('sites/all/modules/contrib/views/modules/profile/views_handler_filter_profile_selection.inc','758dea53760a1b655986c33d21345ac396ad41d10ddf39dd16bc7d8c68e72da7'),('sites/all/modules/contrib/views/modules/search/views_handler_argument_search.inc','9de18defd5d9320b6333dc496627657be1dd8ccb145dfc136a80f1bcee6e1f55'),('sites/all/modules/contrib/views/modules/search/views_handler_field_search_score.inc','711af637c864b775672d9f6203fc2da0902ed17404181d1117b400012aac366f'),('sites/all/modules/contrib/views/modules/search/views_handler_filter_search.inc','aa2ae23905b84b77ee6042f8f26542eedd7422bdd7518255a289db7da0f6400b'),('sites/all/modules/contrib/views/modules/search/views_handler_sort_search_score.inc','9d23dd6c464d486266749106caec1d10cec2da1cc3ae5f907f39056c46badbdf'),('sites/all/modules/contrib/views/modules/search/views_plugin_row_search_view.inc','bc25864154d4df0a58bc1ac1148581c76df36267a1d18f8caee2e3e1233c8286');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/modules/statistics/views_handler_field_accesslog_path.inc','7843e5f4b35f4322d673b5646e840c274f7d747f2c60c4d4e9c47e282e6db37d'),('sites/all/modules/contrib/views/modules/statistics/views_handler_field_node_counter_timestamp.inc','a1de51345d268dc0f080104ff9ae4c9ca1f7a2dd45560a59630b2bb03bdc54c9'),('sites/all/modules/contrib/views/modules/statistics/views_handler_field_statistics_numeric.inc','b46b6b14e14631941ac2dc9baf0b1290c148f42801f05cb419f84a2091d03e40'),('sites/all/modules/contrib/views/modules/system/views_handler_argument_file_fid.inc','e9bf1fdf12f210f0a77774381b670c77ee88e7789971ce732b254f6be5a0e451'),('sites/all/modules/contrib/views/modules/system/views_handler_field_file.inc','0fff4adb471c0c164a78f507b035a68d41f404ab10535f06f6c11206f39a7681'),('sites/all/modules/contrib/views/modules/system/views_handler_field_file_extension.inc','768aa56198c7e82327391084f5dd27d7efdb8179ff6b8c941f892fe30469a0da'),('sites/all/modules/contrib/views/modules/system/views_handler_field_file_filemime.inc','bdd7f1255f3000f7f2900341d4c4ca378244b96390ef52a30db2962d017b61a4'),('sites/all/modules/contrib/views/modules/system/views_handler_field_file_status.inc','bfb0b9d796a4dbf95c4bb7a3deef7724bcda9e0d9067939b74ec787da934f2b0'),('sites/all/modules/contrib/views/modules/system/views_handler_field_file_uri.inc','350d7dde27ee97cb4279360374eb8633ce7fee115a109346bea85c2c4e3a68c2'),('sites/all/modules/contrib/views/modules/system/views_handler_filter_file_status.inc','9210a34795f9db36974525e718c91c03c28554da1199932791925d7c4a2f3b11'),('sites/all/modules/contrib/views/modules/system/views_handler_filter_system_type.inc','d27513703a75c4d8af79b489266cf4102a36e350c3d90404dab24403ab637205'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_taxonomy.inc','8962fa76f1e03316932468b0fd805817af94726beb82bf9f4786e0c709264662'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid.inc','e50f47ac64a93c2a43b6bd940119dee46b9f25f79f5d25a93fd0df7d707c93ab');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid_depth.inc','5b2806fbad4a6cc104e733a3a0faf6eb1c19975930c67c4149fb3267976e0b7d'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_join.inc','ca667646f99645c00e6dfb7eb52e2f54faf848be41c99af5caf2201dcd56926b'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc','d85ebe68290239b25fc240451655b825325854e9707cf742fbd75de81e0f1aa7'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc','888647527bec3444b2d0a571a77900396d7c5e884bca04a2a3667a61f6377b5e'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_vocabulary_vid.inc','bf4be783ef6899f004f4dbd06c1bf2cd6dbc322678c825eec36bee81d667e81f'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_field_taxonomy.inc','fcafbbf79b79829eff211aa69580aa746b6d21a29416758bd43e25b5433f9a02'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_field_term_link_edit.inc','3da63f6feb1fa3312853b54585d761d037dac8841b4c06e01e35463c9098064a'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_field_term_node_tid.inc','d7bb6f685b85de9f9cc87500b3e5a07493832f032d826e20700bbd1baa020a61'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_term_node_tid.inc','6ecc68ee0efaaedd1ae8b290e587955a7d6c3ea361f671921167df55d353922e'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_term_node_tid_depth.inc','0b05ec052dcc03081e20338808dda17beb0bdf869b0cfc1375ca96cfb758c22a'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_term_node_tid_depth_join.inc','76d59ca83bdcb40493055829a9132646ed89478d7eb6e468db2d879e66e3794c'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc','f1787b436b914cfe5ca6f2575d4c0595f4f496795711d6e8a116a39986728b0a'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_vocabulary_vid.inc','2a4d7dfbb6b795d217e2617595238f552bbea04b80217c933f1ee9978ceb7a0e');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/modules/taxonomy/views_handler_relationship_node_term_data.inc','0bfd4c7882054565fb4ff52cf5697fe8cffca69d24717ebc37e6eacc14fe2312'),('sites/all/modules/contrib/views/modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc','fc4c3ace525162fc922de581af0710c7d92dc355e9630040a29a5c3a6ab7f9af'),('sites/all/modules/contrib/views/modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc','8a9d828e5e4387d831172a5c658fac8ef584d843be6c95e9b4e357af6c8f97de'),('sites/all/modules/contrib/views/modules/tracker/views_handler_argument_tracker_comment_user_uid.inc','91f5b7e9537942eee7a1798906f772cb9806eebfdc201c54fcdecf027cd71d0f'),('sites/all/modules/contrib/views/modules/tracker/views_handler_filter_tracker_boolean_operator.inc','5efea908902052d68141017b6f29f17381e7bb8ebb6d88245471926f0a552207'),('sites/all/modules/contrib/views/modules/tracker/views_handler_filter_tracker_comment_user_uid.inc','05e07f74d1e3978afd4c80a9b4bd72444872b84a44949a512f1d3040ce28421c'),('sites/all/modules/contrib/views/modules/translation/views_handler_argument_node_tnid.inc','b0e3c87d3790cfa2e265f3d9700f2b3c2857932aa4b6e003e5d0114fc1b4d499'),('sites/all/modules/contrib/views/modules/translation/views_handler_field_node_link_translate.inc','27a1ac81b50d4807d9a1eff4c5dc8929e4472f9d363f70f5391a794db73424a2'),('sites/all/modules/contrib/views/modules/translation/views_handler_field_node_translation_link.inc','641ff25cd317bb803de2ace4bd23e8c5f5af5ba4ac38aab7be2fdc58fbb9e86a'),('sites/all/modules/contrib/views/modules/translation/views_handler_filter_node_tnid.inc','0942fd793740e3aec032a1abb7132f53788a9cdeaeb3d931cac908ac30b73950'),('sites/all/modules/contrib/views/modules/translation/views_handler_filter_node_tnid_child.inc','2a7a96d6caa4a99996549be0457bf40fa619731543a636d4573e55c190c64c7a'),('sites/all/modules/contrib/views/modules/translation/views_handler_relationship_translation.inc','9137c85f5ca309d4ee0d3243c470563a5853f5926b8cbd3e843438d4308c9516'),('sites/all/modules/contrib/views/modules/user/views_handler_argument_users_roles_rid.inc','72da80e7f3c6980da024d86f37ba3721021cc1ead2cfcc1ab9b27897b7b5077a');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/modules/user/views_handler_argument_user_uid.inc','a4af1bdc1ec5e40587c22c14e839980050baaa346c9d5934ef3f01794932cdc5'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user.inc','1a2141524e43d86b52c7828fe6df61dd603ad433743c1139cfc5cc28ccb5ce74'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_language.inc','5a3da9e08ebeebbcb5abc6a9b16e0d380c5bb5c57b608afb540a3ca6dc1b2959'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_link.inc','5a0f35d5305a29816658385ecbd804bf43c92d4b3629fbe4bd9b8d0e9574b6ff'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_link_cancel.inc','b865881b15ce86b5a00f2892d3fc62f40131417527211275ff9a3d09d485750b'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_link_edit.inc','5d7c1155d9eccbd6b07c7446fe2b6a8848d6a500f508ac3779f16df56816f92b'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_mail.inc','b7355b704f19322afb4876cea27744367e20098d4ed973e480bf2baf1ddd111c'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_name.inc','3be11e273d7a0e8d1e1406b94ba651a6f545f9d48d94758495449b68487f4426'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_permissions.inc','ec37373524bf23ae107adda6b825570c550e6654c0f0956409fc58df2c860903'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_picture.inc','0103d136a91fb219fd981801301b7df00adf90617900ded08efbf6d7df04959b'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_roles.inc','ab5068c4f01a05c6511f7d4b973a77650d5b5c481d4a73f63b7a9b1ef9c0d138'),('sites/all/modules/contrib/views/modules/user/views_handler_filter_user_current.inc','7f70b7e3b3c10e75d95f54afc9c2fe2f1af9b7a9eab2308d2961b2588dc05845'),('sites/all/modules/contrib/views/modules/user/views_handler_filter_user_name.inc','5225e5d89051313e0e49ea833709bb4dc44369afeee970b0cfaf1818ababa22c'),('sites/all/modules/contrib/views/modules/user/views_handler_filter_user_permissions.inc','a72e8d02c1075cebfee33e5b046460eef9193b2a7c1d47ff130457e4485b6fe5');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/modules/user/views_handler_filter_user_roles.inc','3bb69fbc4e352ce8e4840ec78bdd0f1f29e8709097ce6b29cc2fedd2c74c023e'),('sites/all/modules/contrib/views/modules/user/views_plugin_argument_default_current_user.inc','11e729115350deffe46ebfe3a55281fa169a90e38a76c3a9d98f26c87900a22b'),('sites/all/modules/contrib/views/modules/user/views_plugin_argument_default_user.inc','fe567f009a8e20f402f104b157fd44c04d6bd886a39b2f3355104f644f905419'),('sites/all/modules/contrib/views/modules/user/views_plugin_argument_validate_user.inc','40d623b0a678fa7c292da92582f06449d0396341ab161069f0fe8d1086ab95da'),('sites/all/modules/contrib/views/modules/user/views_plugin_row_user_view.inc','6a6c1bfac677eb9ffd25870cd72939c903f2c92d6d18e3abc6c634ac153e5c2b'),('sites/all/modules/contrib/views/plugins/export_ui/views_ui.class.php','8cd921da4fc00f0441808c6d521fa9fdfc753976244518a001a6354975eb6fe8'),('sites/all/modules/contrib/views/plugins/views_plugin_access.inc','cc16bf7dc4c10eab382e948cfd91902ac1055514b627e3c50932376d3e3f1b91'),('sites/all/modules/contrib/views/plugins/views_plugin_access_none.inc','8e0a6b706c60abf63ab84d8624567ca12a5b80ad293e4334790065fbe6fa14d4'),('sites/all/modules/contrib/views/plugins/views_plugin_access_perm.inc','1807a9c91485a5abd3fb2f6590ed4bc185fdabe308db37b169be8abdfc30cab2'),('sites/all/modules/contrib/views/plugins/views_plugin_access_role.inc','8784836ea87ec6b0974125ed95ed6bbf6fdf91624f496f22c28e9229c695068d'),('sites/all/modules/contrib/views/plugins/views_plugin_argument_default.inc','43e593760f0e8f031f2e7b861385caa5e39f37de400fe4595925288c78f52f23'),('sites/all/modules/contrib/views/plugins/views_plugin_argument_default_fixed.inc','daaa3b59b54cbb11e411e010303f67a51348bb97a4e06997b475f4c41e91c4e0'),('sites/all/modules/contrib/views/plugins/views_plugin_argument_default_php.inc','7a133b603294bfe498bfdeb50fade0b6e3cf8862270376067d86f69e7dc50eb8'),('sites/all/modules/contrib/views/plugins/views_plugin_argument_default_raw.inc','4318e0dfa56f167183453cf8cd913f3b7ee539b77a096507905e36db12ded97e');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/plugins/views_plugin_argument_validate.inc','2ada4fdc59b366f33209c0cfc515b06e765b487091760cfa22e94ca1c028c9cb'),('sites/all/modules/contrib/views/plugins/views_plugin_argument_validate_numeric.inc','c050d3b5723dbfdca9ad312c7fa198e509c626057b95eed326820ce733dd9730'),('sites/all/modules/contrib/views/plugins/views_plugin_argument_validate_php.inc','56a09922081a5e368d5796907727e35cbf43b0d634e53f947990c8a42d5b5f3e'),('sites/all/modules/contrib/views/plugins/views_plugin_cache.inc','870ceb5dd920212f4297849046e696b50dbe35a9ad4ac28b7021a7dd03aa64d9'),('sites/all/modules/contrib/views/plugins/views_plugin_cache_none.inc','a0d0ba252e1e2b65350c7ce648b97364726fa8ded5a366bfcce30c62daee4450'),('sites/all/modules/contrib/views/plugins/views_plugin_cache_time.inc','fb55f3236b30f00f3ca5228c40115444a0e2f164a4f54e6fe07dee514e183569'),('sites/all/modules/contrib/views/plugins/views_plugin_display.inc','dd190a0984bfd20a876e6437898ec691b4f46bc7a8d2e9ef17e054d03294536f'),('sites/all/modules/contrib/views/plugins/views_plugin_display_attachment.inc','6124e2ec51eadd7500fb878c25d9c5044b4ae9b6323dbbaa40b4806b69dd4cc0'),('sites/all/modules/contrib/views/plugins/views_plugin_display_block.inc','7ad6a90efa396f68276e93e19a6273c88782d514c1f1cea6ed0b046287e16a10'),('sites/all/modules/contrib/views/plugins/views_plugin_display_default.inc','91c6554d8f41f848bf30093d44d076051c54e998f6b50bdc2a922bfeeef9c54d'),('sites/all/modules/contrib/views/plugins/views_plugin_display_embed.inc','5424f2ea9e031faade7a562b8013aea193db5b0bc1be92b97bd7967de0d7bfff'),('sites/all/modules/contrib/views/plugins/views_plugin_display_extender.inc','75fb9f80e7f153715b911690c7140f251df588e6a541fab5881fbfafc0bbf778'),('sites/all/modules/contrib/views/plugins/views_plugin_display_feed.inc','f2fb6152e12da300b9bb8e1b45621dfe921c3ce0e769970ee1532e32a3657c53'),('sites/all/modules/contrib/views/plugins/views_plugin_display_page.inc','ece0ae5d5d730ef646178b09bc41a59e091c96a6ac3b3db5bdb9e61d194787bb'),('sites/all/modules/contrib/views/plugins/views_plugin_exposed_form.inc','0632ce61b4e39f8c0f39866987e4908657020298520fcf7c2712c0135e77d95b');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/plugins/views_plugin_exposed_form_basic.inc','c736e1862b393e15ecc80deb58663405a1d68c2db07eb620d8e640406876cd17'),('sites/all/modules/contrib/views/plugins/views_plugin_exposed_form_input_required.inc','98b81e3b78f7242dd30a3754830bdde2fb1dfe8f002ae0daa06976f1bb64fa75'),('sites/all/modules/contrib/views/plugins/views_plugin_localization.inc','d7239cc693994dcd069c1f1e7847a7902c5bd29b8d64a93cdf37c602576661fb'),('sites/all/modules/contrib/views/plugins/views_plugin_localization_core.inc','f0900c0640e7c779e9b876223ea395f613c8fe8449f6c8eb5d060e2d54a6afcc'),('sites/all/modules/contrib/views/plugins/views_plugin_localization_none.inc','4930c3a13ddc0df3065f4920a836ffdc933b037e1337764e6687d7311f49dd8a'),('sites/all/modules/contrib/views/plugins/views_plugin_pager.inc','d7c32e38f149e9009e175395dff2b00ec429867653c7535301b705a7cc69d9ed'),('sites/all/modules/contrib/views/plugins/views_plugin_pager_full.inc','60e4dec532de00bf7e785e5fa29a0be43c7b550efa85df0346a1712a3c39f7cd'),('sites/all/modules/contrib/views/plugins/views_plugin_pager_mini.inc','0a9d101d5a4217fb888c643bfddd7bf7f2f9c0937faa2753a31452a5ee68190b'),('sites/all/modules/contrib/views/plugins/views_plugin_pager_none.inc','822cab1ada25f4902a0505f13db86886061d2ced655438b33b197d031ccceddd'),('sites/all/modules/contrib/views/plugins/views_plugin_pager_some.inc','bc6aa7cbf1bc09374eced33334195c8897e4078336b8306d02d71c7aaaa22c99'),('sites/all/modules/contrib/views/plugins/views_plugin_query.inc','475a7ff0d4c7c7e27d7971ebd909a87bdb8322c47d6023b68f50f6fe6a1ec059'),('sites/all/modules/contrib/views/plugins/views_plugin_query_default.inc','d5f89543721a3cd24f6a18114c630f741d11029d933f1b01d59f349219b747d6'),('sites/all/modules/contrib/views/plugins/views_plugin_row.inc','3ca81529526b930cfb0dda202757f203649236b90441e3c035bb79cd419ee2a6'),('sites/all/modules/contrib/views/plugins/views_plugin_row_fields.inc','875fb2868cdbcc5f7af03098cbe55b9bb91ef512e5e52ccde89f7a02a0c5fbe2'),('sites/all/modules/contrib/views/plugins/views_plugin_row_rss_fields.inc','62f4a0ceef14aec9958ee8b98d352303f10818ddc66031814cc8b9d21752ade9');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/plugins/views_plugin_style.inc','1ac358d216da612e1731d6b1c730d2ee57ccb8cdd31ad768ae97af542325244f'),('sites/all/modules/contrib/views/plugins/views_plugin_style_default.inc','bf411e635d2fd9e09eb245b43581a0a7b670359180ccb042d42a5e579bbe9c30'),('sites/all/modules/contrib/views/plugins/views_plugin_style_grid.inc','35094b7f644b7e0692c9026b6b6b4c4c864c37fcdedef04b359dd2bdba496a47'),('sites/all/modules/contrib/views/plugins/views_plugin_style_jump_menu.inc','53a438d8a5398877eacdbff97f3b0c418ebc2fa16e69efd5e4a31b0b986e03a3'),('sites/all/modules/contrib/views/plugins/views_plugin_style_list.inc','407b928d2c74a91903b681088bccce926d2268d0a9a6a34c185a4849dc0d7e31'),('sites/all/modules/contrib/views/plugins/views_plugin_style_mapping.inc','a6b430a148dda1b07ecee314b897c1da41ce375566adf50ee23ae1da822fddf3'),('sites/all/modules/contrib/views/plugins/views_plugin_style_rss.inc','ac72d530faffee78a1695a0b3893528ceb8451f18be0521c580485904a5ba57b'),('sites/all/modules/contrib/views/plugins/views_plugin_style_summary.inc','872df59f8f389eaf9b019e82d859dd198d31166e26a9102132e3932c7f1f2916'),('sites/all/modules/contrib/views/plugins/views_plugin_style_summary_jump_menu.inc','2ec0d225824ee65b6bb61317979e1dabe2be524a66ab19da924c6949dd31af3b'),('sites/all/modules/contrib/views/plugins/views_plugin_style_summary_unformatted.inc','c1e6f9dd1d75e29fee271171440d2182e633a1dbbc996cb186f637ff7ad93ed9'),('sites/all/modules/contrib/views/plugins/views_plugin_style_table.inc','0cbcc5d256a13953fbd3e5966a33d2426d5c3bd8c228ef370daebf2f428e693c'),('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','d8325414c8ddde5c955a5cfb053b77478bb4d73cb2f7d75b857b082bc5a1e12d'),('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_comment_views_wizard.class.php','585a8e885a18d4d2dee260859492eb332d70166abf2d201777ebf0d2083d2ebe'),('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_file_managed_views_wizard.class.php','5734fb564ba9e2485cfa5d4a49f0c76f65a9be357b78e769ee4af92c4ef9e22a');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_node_revision_views_wizard.class.php','6faf9ef92501a4f1aeaf86bcff9edaeb47bd7526ba50d06b841c9366149e7725'),('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_node_views_wizard.class.php','f10e588fcfe2dc37d0df1c520c3cd797b85d6f729335606b1aa11fcb5884e6eb'),('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_taxonomy_term_views_wizard.class.php','87d72dba2aef587994307cb287b638a409d148911e4b90109798ecacf5a721e7'),('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_users_views_wizard.class.php','f9fe2fb1ee87a1871e6ad32bad61b2457313f24da1bd5423977ced12de542919'),('sites/all/modules/contrib/views/tests/comment/views_handler_argument_comment_user_uid.test','b8b417ef0e05806a88bd7d5e2f7dcb41339fbf5b66f39311defc9fb65476d561'),('sites/all/modules/contrib/views/tests/comment/views_handler_filter_comment_user_uid.test','347c6ffd4383706dbde844235aaf31cff44a22e95d2e6d8ef4da34a41b70edd1'),('sites/all/modules/contrib/views/tests/field/views_fieldapi.test','53e6d57c2d1d6cd0cd92e15ca4077ba532214daf41e9c7c0f940c7c8dbd86a66'),('sites/all/modules/contrib/views/tests/handlers/views_handlers.test','f94dd3c4ba0bb1ffbf42704f600b94a808c1202a9ca26e7bdef8e7921c2724e9'),('sites/all/modules/contrib/views/tests/handlers/views_handler_area_text.test','af74a74a3357567b844606add76d7ca1271317778dd7bd245a216cf963c738b4'),('sites/all/modules/contrib/views/tests/handlers/views_handler_argument_null.test','1d174e1f467b905d67217bd755100d78ffeca4aa4ada5c4be40270cd6d30b721'),('sites/all/modules/contrib/views/tests/handlers/views_handler_argument_string.test','3d0213af0041146abb61dcdc750869ed773d0ac80cfa74ffbadfdd03b1f11c52'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field.test','af552bf825ab77486b3d0d156779b7c4806ce5a983c6116ad68b633daf9bb927'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_boolean.test','d334b12a850f36b41fe89ab30a9d758fd3ce434286bd136404344b7b288460ae'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_counter.test','75b31942adf06b107f5ffd3c97545fde8cd1040b1d00f682e3c7c1320026e26c');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/tests/handlers/views_handler_field_custom.test','1446bc3d5a6b1180a79edfa46a5268dbf7f089836aa3bc45df00ddaff9dd0ce1'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_date.test','02df76a93a42d6131957748b1e69254835f9e44a47dafca1e833914e6b7f88a0'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_file_extension.test','606ca091ad7e5709f7653324aaa021484d1f0e07e8639b3f0f7c26d3cfdee53c'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_file_size.test','49184db68af398a54e81c8a76261acd861da8fd7846b9d51dcf476d61396bfb9'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_math.test','6e39e4f782e6b36151ceafb41a5509f7c661be79b393b24f6f5496d724535887'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_url.test','b41f762a71594b438a2e60a79c8260ba54e6305635725b0747e29f0d3ffe08c9'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_xss.test','f129ee16c03f84673e33990cbb2da5aa88c362f46e9ba1620b2a842ffd1c9cd2'),('sites/all/modules/contrib/views/tests/handlers/views_handler_filter_combine.test','05842d83a11822afe7d566835f5db9f0f94fdb27ddfc388d38138767bdf36f8b'),('sites/all/modules/contrib/views/tests/handlers/views_handler_filter_date.test','ad2ca901c6a4ac3a82fc349a33826f043c6c80f773f40374be2e95acb39491e3'),('sites/all/modules/contrib/views/tests/handlers/views_handler_filter_equality.test','c88f21c9cbf1aae83393b26616908f8020c18fe378d76256c7ba192df2ec17af'),('sites/all/modules/contrib/views/tests/handlers/views_handler_filter_in_operator.test','89420a4071677232e0eb82b184b37b818a82bdb2ff90a8b21293f9ecb21808bf'),('sites/all/modules/contrib/views/tests/handlers/views_handler_filter_numeric.test','35ac7a34e696b979e86ef7209b6697098d9abe218e30a02cc4fe39fb11f2a852'),('sites/all/modules/contrib/views/tests/handlers/views_handler_filter_string.test','b7d090780748faad478e619fd55673d746d4a0cf343d9e40ea96881324c34cbd'),('sites/all/modules/contrib/views/tests/handlers/views_handler_sort.test','f4ff79e6bc54e83c4eb2777811f33702b7e9fe7416ef70ae00d100fa54d44fec');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/tests/handlers/views_handler_sort_date.test','f548584d7c6a71cabd3ce07e04053a38df3f3e1685210ce8114238fd05344c10'),('sites/all/modules/contrib/views/tests/handlers/views_handler_sort_random.test','4fdba9bf05a26720ffa97e7a37da65ddc9044bd2832f8c89007b82feb062f182'),('sites/all/modules/contrib/views/tests/node/views_node_revision_relations.test','9467497a6d693615b48c8f57611a850002317bcb091b926d2efbbe56a4e61480'),('sites/all/modules/contrib/views/tests/plugins/views_plugin_display.test','4a6b136543a60999604c54125fa9d4f5aa61a5dcc71e2133d89325d81bc0fc2d'),('sites/all/modules/contrib/views/tests/styles/views_plugin_style.test','92d9a02f87f07d091999b961045b1dd654165059d8d1931b5c2ea1d88d0b439f'),('sites/all/modules/contrib/views/tests/styles/views_plugin_style_base.test','54fb7816d18416d8b0db67e9f55aa2aa50ac204eb9311be14b6700b7d7a95ae7'),('sites/all/modules/contrib/views/tests/styles/views_plugin_style_jump_menu.test','b88baa8aebe183943a6e4cf2df314fef13ac41b5844cd5fa4aa91557dd624895'),('sites/all/modules/contrib/views/tests/styles/views_plugin_style_mapping.test','a4e68bc8cfbeff4a1d9b8085fd115bfe7a8c4b84c049573fa0409b0dc8c2f053'),('sites/all/modules/contrib/views/tests/styles/views_plugin_style_unformatted.test','033ca29d41af47cd7bd12d50fea6c956dde247202ebda9df7f637111481bb51d'),('sites/all/modules/contrib/views/tests/taxonomy/views_handler_relationship_node_term_data.test','6074f5c7ae63225ea0cd26626ace6c017740e226f4d3c234e39869c31308223d'),('sites/all/modules/contrib/views/tests/test_handlers/views_test_area_access.inc','619e39bc4535976865b96751535d0d5aac4a7a87c1d47cb6d4c4bb9c9fa74716'),('sites/all/modules/contrib/views/tests/test_plugins/views_test_plugin_access_test_dynamic.inc','6a3ce8c256b84734b6b67a893ab24465a5f62d7bdf9ab5d22082a31849346b7d'),('sites/all/modules/contrib/views/tests/test_plugins/views_test_plugin_access_test_static.inc','e345e42d443cfa73db0ed2be61291117ebd57b86196cdb77c6f440e93443def3'),('sites/all/modules/contrib/views/tests/test_plugins/views_test_plugin_style_test_mapping.inc','0b2c68626105bd5f6b9074022a37c3d09d3a6bd70b811bb26d5eacad6d74546f');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/tests/user/views_handler_field_user_name.test','69641b6da26d8daee9a2ceb2d0df56668bf09b86db1d4071c275b6e8d0885f9e'),('sites/all/modules/contrib/views/tests/user/views_user.test','fbb63b42a0b7051bd4d33cf36841f39d7cc13a63b0554eca431b2a08c19facae'),('sites/all/modules/contrib/views/tests/user/views_user_argument_default.test','6423f2db7673763991b1fd0c452a7d84413c7dd888ca6c95545fadc531cfaaf4'),('sites/all/modules/contrib/views/tests/user/views_user_argument_validate.test','c88c9e5d162958f8924849758486a0d83822ada06088f5cf71bfbe76932d8d84'),('sites/all/modules/contrib/views/tests/views_access.test','f8b9d04b43c09a67ec722290a30408c1df8c163cf6e5863b41468bb4e381ee6f'),('sites/all/modules/contrib/views/tests/views_analyze.test','5548e36c99bb626209d63e5cddbc31f49ad83865c983d2662c6826b328d24ffb'),('sites/all/modules/contrib/views/tests/views_argument_default.test','5950937aae4608bba5b86f366ef3a56cc6518bbccfeaeacda79fa13246d220e4'),('sites/all/modules/contrib/views/tests/views_argument_validator.test','31f8f49946c8aa3b03d6d9a2281bdfb11c54071b28e83fb3e827ca6ff5e38c88'),('sites/all/modules/contrib/views/tests/views_basic.test','655bd33983f84bbea68a3f24bfab545d2c02f36a478566edf35a98a58ff0c6cf'),('sites/all/modules/contrib/views/tests/views_cache.test','4e9b8ae1d9e72a9eaee95f5083004316d2199617f7d6c8f4bea40e99d17efcd8'),('sites/all/modules/contrib/views/tests/views_exposed_form.test','6962c7ed8a38030ec1cfa94485de07ceb1f9393216985bd8bfecac768f6c0950'),('sites/all/modules/contrib/views/tests/views_glossary.test','118d50177a68a6f88e3727e10f8bcc6f95176282cc42fbd604458eeb932a36e8'),('sites/all/modules/contrib/views/tests/views_groupby.test','f26ad6857dc4821a4a0780642bda05fcb69ed506968e521f759bb28be4080143'),('sites/all/modules/contrib/views/tests/views_handlers.test','a696e3d6b1748da03a04ac532f403700d07c920b9c405c628a6c94ea6764f501'),('sites/all/modules/contrib/views/tests/views_module.test','5137e27449639d3e02f1b27206ef3ff96957546333b517318dfe8f58239dc860'),('sites/all/modules/contrib/views/tests/views_pager.test','6f448c8c13c5177afb35103119d6281958a2d6dbdfb96ae5f4ee77cb3b44adc5');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views/tests/views_plugin_localization_test.inc','baedcf6c7381f9c5d3a5062f7d256f96808d06e04b6e73eff8e791e5f5293f45'),('sites/all/modules/contrib/views/tests/views_query.test','f8cb1649e43c8a2b036fec742e86b8eb9c2c4c095a4c4e7a7c3ca13c6ce8e6e6'),('sites/all/modules/contrib/views/tests/views_test.views_default.inc','4c65cc385b3e3c2e17fe054eb7a1ec70f4dd4b0394bdb108de2ddc0a7b435635'),('sites/all/modules/contrib/views/tests/views_translatable.test','6899c7b09ab72c262480cf78d200ecddfb683e8f2495438a55b35ae0e103a1b3'),('sites/all/modules/contrib/views/tests/views_ui.test','f9687a363d7cc2828739583e3eedeb68c99acd505ff4e3036c806a42b93a2688'),('sites/all/modules/contrib/views/tests/views_upgrade.test','c48bd74b85809dd78d963e525e38f3b6dd7e12aa249f73bd6a20247a40d6713a'),('sites/all/modules/contrib/views/tests/views_view.test','a52e010d27cc2eb29804a3acd30f574adf11fad1f5860e431178b61cddbdbb69'),('sites/all/modules/contrib/views/views_ui.module','418d555f71e72cb771a01ad7bfe7410c4d8191738271fa4e7cbb063940afb2a0'),('sites/all/modules/contrib/views_bulk_operations/plugins/operation_types/action.class.php','de329cc0601cb107b315b9f415e292803ba929951ae7250cd712c75330a0404e'),('sites/all/modules/contrib/views_bulk_operations/plugins/operation_types/base.class.php','bbbe7c4c19b2ab588517138c378cde40b395762a20626bf8359b5be8650f8681'),('sites/all/modules/contrib/views_bulk_operations/plugins/operation_types/rules_component.class.php','4213d0ae15822b69b848ca5421b5455c60510f06b7d8984472163d368bb6ac93'),('sites/all/modules/contrib/views_bulk_operations/views/views_bulk_operations_handler_field_operations.inc','876ac2c9749d76d19c73283eb76323fece8c7121431edb82c50986e546844e57'),('sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_display_export.inc','a99e65dc1c9d46694d5a5903d36dd633daaa907661ab61e7d7a7928609483fc2'),('sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_style_export.inc','6b636c361bd46f3fcc5d96a82516bd81ff0051eae71d631e5ac55e82e6f7afe1'),('sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_style_export_csv.inc','dd0c99a58562ca7b401116c2d7a7c90b65fb966983bf7d56764b32a7ae3b34d0');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_style_export_xml.inc','870530b0b4707f939df9f249273caec89b7c921ed6d3828220201fe7dff0b129'),('sites/all/modules/contrib/views_data_export/tests/access.test','0f1177398f26f3f94c395dad6ffaf22267c6de43c3961240ae0696b14854f06e'),('sites/all/modules/contrib/views_data_export/tests/base.test','1634952f835d0fab7876eadd1e73980888d0e97982baf32e2b81d5d314924015'),('sites/all/modules/contrib/views_data_export/tests/csv_export.test','c05cbd0c4f60d782f8038415603a700d9ab81e02ead1c44a7e7a61b37fd3c984'),('sites/all/modules/contrib/views_data_export/tests/doc_export.test','5c26967afa44fe6fdfff2d5e670cd99dbbbba92087fc6ad70f32babb740ce416'),('sites/all/modules/contrib/views_data_export/tests/garbagecollection.test','f87471cf4b4a92608378236f2f6103a535ba76fa4cbd1599eae6736adf055363'),('sites/all/modules/contrib/views_data_export/tests/txt_export.test','92392af48a4a459097843d1ca8dd5deb3df1dea2d47c79d6ed46fe37400de40c'),('sites/all/modules/contrib/views_data_export/tests/xls_export.test','f98d0ec1339a5c85646466ec4f0d278ac229c8bd61d043629fe59eb89502b5e2'),('sites/all/modules/contrib/views_data_export/tests/xml_export.test','9a6305af6b12f8790343ec78b817da9321202c2401ecfe771829875ea570d8e8'),('sites/all/modules/contrib/workflow/includes/Entity/Workflow.php','1230671cd7a750040d4a63ded53bbb00ef40b7b2901fc01fa0efb1bc2c54c927'),('sites/all/modules/contrib/workflow/includes/Entity/WorkflowConfigTransition.php','6f338ee57075ccf3ad7ec10185e7689f035270b7f18a47a7d361193ed152076d'),('sites/all/modules/contrib/workflow/includes/Entity/WorkflowInterface.php','5f109aed47f9ee3f175db4afe902ddefcadeedd345b23933f9ef34f0ab31b4d8'),('sites/all/modules/contrib/workflow/includes/Entity/WorkflowScheduledTransition.php','ea628ce7d683f9912cfb66f30de558699f1569c966d12dc04af83059f9bf746e'),('sites/all/modules/contrib/workflow/includes/Entity/WorkflowState.php','1e7432d9c0810a806def8e9ca61189c178d7ab20c0e1c2a5613ebd744efe5530'),('sites/all/modules/contrib/workflow/includes/Entity/WorkflowTransition.php','63ec0616ff75a258e59b1b51f9d34c4fc56b81a3b17f68d965509f32e040a6f6');
INSERT INTO `registry_file` VALUES ('sites/all/modules/contrib/workflow/includes/Field/WorkflowD7Base.php','ead0961bc2d0c4df8da68246d7ee62e7ba4d4c8b62de4ea14a36ffdda339367a'),('sites/all/modules/contrib/workflow/includes/Field/WorkflowDefaultWidget.php','fc7534e951799bd9909585212a0f9ae369397cbce430d290526144bea58da170'),('sites/all/modules/contrib/workflow/includes/Field/WorkflowItem.php','d9be59a1ebdcc609961ef1575b2e33592ad44bc37f6c913ccba7a0a54ab32c6f'),('sites/all/modules/contrib/workflow/includes/Form/WorkflowTransitionForm.php','aaa28e82e6fdee535492f9427117fb178f443f6a99b9ab1d8ad959a8f354b8a8'),('sites/all/modules/contrib/workflow/workflow_admin_ui/includes/Entity/EntityWorkflowUIController.php','ab0eb60738179aac27dd283692c197a3b1bbeb1dd6a777e1b6d7764e633bf832'),('sites/all/modules/contrib/wysiwyg/tests/wysiwyg.test','351bd7ed3eb279052b92cd900ceaedb3baa97ab502eed61a390efed83d8cefd8'),('sites/all/modules/contrib/wysiwyg/wysiwyg.module','a51cb9018c355af0cf4557929f05b5dba6f1c5560c1530f640766963f576e723');
DROP TABLE IF EXISTS `role`;
CREATE TABLE `role` (   `rid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique role ID.',   `name` varchar(64) NOT NULL DEFAULT '' COMMENT 'Unique role name.',   `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this role in listings and the user interface.',   PRIMARY KEY (`rid`),   UNIQUE KEY `name` (`name`),   KEY `name_weight` (`name`,`weight`) ) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8 COMMENT='Stores user roles.' AUTO_INCREMENT=6;
INSERT INTO `role` VALUES ('3','administrator','2'),('1','anonymous user','0'),('2','authenticated user','1'),('5','Librarian','4'),('4','Reader','3');
DROP TABLE IF EXISTS `role_permission`;
CREATE TABLE `role_permission` (   `rid` int(10) unsigned NOT NULL COMMENT 'Foreign Key: role.rid.',   `permission` varchar(128) NOT NULL DEFAULT '' COMMENT 'A single permission granted to the role identified by rid.',   `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The module declaring the permission.',   PRIMARY KEY (`rid`,`permission`),   KEY `permission` (`permission`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the permissions assigned to user roles.';
INSERT INTO `role_permission` VALUES ('1','access comments','comment'),('1','access content','node'),('1','create field_account_family_notes','field_permissions'),('1','eck list branch branch entities','eck'),('1','eck list branch bundles','eck'),('1','eck view branch branch entities','eck'),('1','eck view branch bundles','eck'),('2','access comments','comment'),('2','access content','node'),('2','eck add reader reader entities','eck'),('2','eck edit reader reader entities','eck'),('2','eck list activity_log_reference activity_log_reference entities','eck'),('2','eck list badge badge entities','eck'),('2','eck list branch branch entities','eck'),('2','eck list branch bundles','eck'),('2','eck list drawing_ticket drawing_ticket entities','eck'),('2','eck list level bundles','eck'),('2','eck list level level entities','eck'),('2','eck list nag_message nag_message entities','eck'),('2','eck list points points entities','eck'),('2','eck list prize prize entities','eck'),('2','eck list program bundles','eck'),('2','eck list program program entities','eck'),('2','eck list reader bundles','eck'),('2','eck list reader reader entities','eck'),('2','eck list reader_activity_log reader_activity_log entities','eck'),('2','eck list reader_badge bundles','eck'),('2','eck list reader_badge reader_badge entities','eck'),('2','eck list reader_log bundles','eck'),('2','eck list reader_log reader_log entities','eck');
INSERT INTO `role_permission` VALUES ('2','eck list reader_prize bundles','eck'),('2','eck list reader_prize reader_prize entities','eck'),('2','eck list reader_ticket bundles','eck'),('2','eck list reader_ticket reader_ticket entities','eck'),('2','eck list reading_log bundles','eck'),('2','eck list reading_log reading_log entities','eck'),('2','eck list school bundles','eck'),('2','eck list school school entities','eck'),('2','eck view activity_log_reference activity_log_reference entities','eck'),('2','eck view badge badge entities','eck'),('2','eck view branch branch entities','eck'),('2','eck view branch bundles','eck'),('2','eck view drawing_ticket drawing_ticket entities','eck'),('2','eck view level bundles','eck'),('2','eck view level level entities','eck'),('2','eck view nag_message nag_message entities','eck'),('2','eck view points points entities','eck'),('2','eck view prize prize entities','eck'),('2','eck view program bundles','eck'),('2','eck view program program entities','eck'),('2','eck view reader bundles','eck'),('2','eck view reader reader entities','eck'),('2','eck view reader_activity_log reader_activity_log entities','eck'),('2','eck view reader_badge bundles','eck'),('2','eck view reader_badge reader_badge entities','eck'),('2','eck view reader_log bundles','eck'),('2','eck view reader_log reader_log entities','eck'),('2','eck view reader_prize bundles','eck'),('2','eck view reader_prize reader_prize entities','eck'),('2','eck view reader_ticket bundles','eck');
INSERT INTO `role_permission` VALUES ('2','eck view reader_ticket reader_ticket entities','eck'),('2','eck view reading_log bundles','eck'),('2','eck view reading_log reading_log entities','eck'),('2','eck view school bundles','eck'),('2','eck view school school entities','eck'),('2','post comments','comment'),('2','skip comment approval','comment'),('3','access administration menu','admin_menu'),('3','access administration pages','system'),('3','access all views','views'),('3','access backup and migrate','backup_migrate'),('3','access backup files','backup_migrate'),('3','access comments','comment'),('3','access content','node'),('3','access content overview','node'),('3','access contextual links','contextual'),('3','access dashboard','dashboard'),('3','access devel information','devel'),('3','access overlay','overlay'),('3','access private fields','field_permissions'),('3','access rules debug','rules'),('3','access site in maintenance mode','system'),('3','access site reports','system'),('3','access statistics','statistics'),('3','access the block administration page','block_access'),('3','access toolbar','toolbar'),('3','access user profiles','user'),('3','add JS snippets for google analytics','googleanalytics'),('3','administer actions','system'),('3','administer advanced pane settings','panels');
INSERT INTO `role_permission` VALUES ('3','administer backup and migrate','backup_migrate'),('3','administer block access settings','block_access'),('3','administer block classes','block_class'),('3','administer blocks','block'),('3','administer comments','comment'),('3','administer content types','node'),('3','administer date tools','date_tools'),('3','administer entity blocks','entity_block'),('3','administer entityform types','entityform'),('3','administer features','features'),('3','administer feeds','feeds'),('3','administer field collections','field_collection'),('3','administer field permissions','field_permissions'),('3','administer fieldgroups','field_group'),('3','administer fields','field'),('3','administer filters','filter'),('3','administer google analytics','googleanalytics'),('3','administer image styles','image'),('3','administer imce','imce'),('3','administer menu','menu'),('3','administer mini panels','panels_mini'),('3','administer modules','system'),('3','administer nodes','node'),('3','administer page manager','page_manager'),('3','administer pane access','panels'),('3','administer panel-nodes','panels_node'),('3','administer panels display styles','panels'),('3','administer panels layouts','panels'),('3','administer panels pane styles','panels'),('3','administer panels region styles','panels');
INSERT INTO `role_permission` VALUES ('3','administer panels styles','panels'),('3','administer pathauto','pathauto'),('3','administer permissions','user'),('3','administer rules','rules'),('3','administer search','search'),('3','administer shortcuts','shortcut'),('3','administer site configuration','system'),('3','administer smtp module','smtp'),('3','administer software updates','system'),('3','administer statistics','statistics'),('3','administer string overrides','stringoverrides'),('3','administer taxonomy','taxonomy'),('3','administer themes','system'),('3','administer url aliases','path'),('3','administer users','user'),('3','administer views','views'),('3','administer workflow','workflow_admin_ui'),('3','block IP addresses','system'),('3','bypass access in place editing','panels'),('3','bypass node access','node'),('3','bypass rules access','rules'),('3','cancel account','user'),('3','change layouts in place editing','panels'),('3','change own username','user'),('3','configure all block body fields','block_access'),('3','configure all block descriptions','block_access'),('3','configure all block titles','block_access'),('3','configure all blocks','block_access'),('3','configure all content type visibility settings','block_access'),('3','configure all language settings','block_access');
INSERT INTO `role_permission` VALUES ('3','configure all page visibility settings','block_access'),('3','configure all region settings','block_access'),('3','configure all role visibility settings','block_access'),('3','configure all user visibility settings','block_access'),('3','configure all visibility settings','block_access'),('3','create article content','node'),('3','create blocks','block_access'),('3','create book_list content','node'),('3','create event content','node'),('3','create field_account_family_notes','field_permissions'),('3','create mini panels','panels_mini'),('3','create page content','node'),('3','create url aliases','path'),('3','customize shortcut links','shortcut'),('3','delete all blocks','block_access'),('3','delete any article content','node'),('3','delete any book_list content','node'),('3','delete any entityform','entityform'),('3','delete any event content','node'),('3','delete any page content','node'),('3','delete backup files','backup_migrate'),('3','delete own article content','node'),('3','delete own book_list content','node'),('3','delete own entityform','entityform'),('3','delete own event content','node'),('3','delete own page content','node'),('3','delete revisions','node'),('3','delete terms in 1','taxonomy'),('3','disable all blocks','block_access'),('3','display drupal links','admin_menu');
INSERT INTO `role_permission` VALUES ('3','eck add activity_log_reference activity_log_reference entities','eck'),('3','eck add badge badge entities','eck'),('3','eck add bundles','eck'),('3','eck add drawing_ticket drawing_ticket entities','eck'),('3','eck add entities','eck'),('3','eck add entity types','eck'),('3','eck add level level entities','eck'),('3','eck add nag_message bundles','eck'),('3','eck add nag_message nag_message entities','eck'),('3','eck add points points entities','eck'),('3','eck add prize prize entities','eck'),('3','eck add reader_activity_log reader_activity_log entities','eck'),('3','eck add reader_prize reader_prize entities','eck'),('3','eck add reader_ticket reader_ticket entities','eck'),('3','eck add reading_log reading_log entities','eck'),('3','eck administer activity_log_reference activity_log_reference entities','eck'),('3','eck administer bundles','eck'),('3','eck administer drawing_ticket drawing_ticket entities','eck'),('3','eck administer entities','eck'),('3','eck administer entity types','eck'),('3','eck administer nag_message nag_message entities','eck'),('3','eck administer points points entities','eck'),('3','eck delete activity_log_reference activity_log_reference entities','eck'),('3','eck delete badge badge entities','eck'),('3','eck delete branch branch entities','eck'),('3','eck delete bundles','eck'),('3','eck delete drawing_ticket drawing_ticket entities','eck'),('3','eck delete entities','eck'),('3','eck delete entity types','eck'),('3','eck delete level level entities','eck');
INSERT INTO `role_permission` VALUES ('3','eck delete nag_message bundles','eck'),('3','eck delete nag_message nag_message entities','eck'),('3','eck delete points points entities','eck'),('3','eck delete reader_prize reader_prize entities','eck'),('3','eck delete reading_log reading_log entities','eck'),('3','eck edit activity_log_reference activity_log_reference entities','eck'),('3','eck edit badge badge entities','eck'),('3','eck edit bundles','eck'),('3','eck edit drawing_ticket drawing_ticket entities','eck'),('3','eck edit entities','eck'),('3','eck edit entity types','eck'),('3','eck edit level level entities','eck'),('3','eck edit nag_message bundles','eck'),('3','eck edit nag_message nag_message entities','eck'),('3','eck edit points points entities','eck'),('3','eck edit prize prize entities','eck'),('3','eck edit reader_activity_log reader_activity_log entities','eck'),('3','eck edit reader_prize reader_prize entities','eck'),('3','eck edit reader_ticket reader_ticket entities','eck'),('3','eck edit reading_log reading_log entities','eck'),('3','eck list activity_log_reference activity_log_reference entities','eck'),('3','eck list badge badge entities','eck'),('3','eck list bundles','eck'),('3','eck list entities','eck'),('3','eck list entity types','eck'),('3','eck list reader_activity_log reader_activity_log entities','eck'),('3','eck view activity_log_reference activity_log_reference entities','eck'),('3','eck view entities','eck'),('3','edit any article content','node'),('3','edit any book_list content','node');
INSERT INTO `role_permission` VALUES ('3','edit any entityform','entityform'),('3','edit any event content','node'),('3','edit any page content','node'),('3','edit field_account_family_notes','field_permissions'),('3','edit own article content','node'),('3','edit own book_list content','node'),('3','edit own comments','comment'),('3','edit own entityform','entityform'),('3','edit own event content','node'),('3','edit own field_account_family_notes','field_permissions'),('3','edit own page content','node'),('3','edit terms in 1','taxonomy'),('3','edit workflow comment','workflow'),('3','enable all blocks','block_access'),('3','execute php code','devel'),('3','flush caches','admin_menu'),('3','generate features','features'),('3','grant content access','content_access'),('3','grant own content access','content_access'),('3','manage features','features'),('3','move all blocks','block_access'),('3','notify of path changes','pathauto'),('3','opt-in or out of tracking','googleanalytics'),('3','participate in workflow','workflow'),('3','perform backup','backup_migrate'),('3','post comments','comment'),('3','rename features','features'),('3','restore from backup','backup_migrate'),('3','revert revisions','node'),('3','schedule workflow transitions','workflow');
INSERT INTO `role_permission` VALUES ('3','search content','search'),('3','select account cancellation method','user'),('3','show workflow state form','workflow'),('3','skip comment approval','comment'),('3','switch shortcut sets','shortcut'),('3','switch users','devel'),('3','use advanced search','search'),('3','use ctools import','ctools'),('3','use ipe with page manager','panels'),('3','use page manager','page_manager'),('3','use panels caching features','panels'),('3','use panels dashboard','panels'),('3','use panels in place editing','panels'),('3','use panels locks','panels'),('3','use PHP for settings','php'),('3','use PHP for tracking visibility','googleanalytics'),('3','use text format filtered_html','filter'),('3','use text format full_html','filter'),('3','view advanced help index','advanced_help'),('3','view advanced help popup','advanced_help'),('3','view advanced help topic','advanced_help'),('3','view all blocks','block_access'),('3','view any entityform','entityform'),('3','view date repeats','date_repeat_field'),('3','view field_account_family_notes','field_permissions'),('3','view own entityform','entityform'),('3','view own field_account_family_notes','field_permissions'),('3','view own unpublished content','node'),('3','view pane admin links','panels'),('3','view post access counter','statistics');
INSERT INTO `role_permission` VALUES ('3','view revisions','node'),('3','view the administration theme','system'),('4','access reader dashboard','galecia_reader_dashboard'),('4','access site in maintenance mode','system'),('4','eck list branch bundles','eck'),('4','eck list level bundles','eck'),('4','eck list prize bundles','eck'),('4','eck list prize prize entities','eck'),('4','eck list program bundles','eck'),('4','eck list reader_activity_log bundles','eck'),('4','eck list reader_activity_log reader_activity_log entities','eck'),('4','eck view branch bundles','eck'),('4','eck view entities','eck'),('4','eck view level bundles','eck'),('4','eck view prize bundles','eck'),('4','eck view prize prize entities','eck'),('4','eck view program bundles','eck'),('4','eck view reader_activity_log bundles','eck'),('4','view own entityform','entityform'),('5','access comments','comment'),('5','access content','node'),('5','access library dashboard','library_dashboard'),('5','access reader dashboard','galecia_reader_dashboard'),('5','access site in maintenance mode','system'),('5','access user profiles','user'),('5','administer users','user'),('5','create book_list content','node'),('5','create event content','node'),('5','eck add activity activity entities','eck'),('5','eck add activity secret_code entities','eck');
INSERT INTO `role_permission` VALUES ('5','eck add activity_log_reference activity_log_reference entities','eck'),('5','eck add badge badge entities','eck'),('5','eck add branch branch entities','eck'),('5','eck add branch bundles','eck'),('5','eck add drawing_ticket drawing_ticket entities','eck'),('5','eck add level bundles','eck'),('5','eck add level level entities','eck'),('5','eck add nag_message bundles','eck'),('5','eck add nag_message nag_message entities','eck'),('5','eck add points points entities','eck'),('5','eck add prize bundles','eck'),('5','eck add prize prize entities','eck'),('5','eck add program bundles','eck'),('5','eck add program program entities','eck'),('5','eck add reader_activity_log reader_activity_log entities','eck'),('5','eck add reader_badge reader_badge entities','eck'),('5','eck add reader_log reader_log entities','eck'),('5','eck add reader_prize reader_prize entities','eck'),('5','eck add reader_ticket reader_ticket entities','eck'),('5','eck add reading_log reading_log entities','eck'),('5','eck add school school entities','eck'),('5','eck administer nag_message nag_message entities','eck'),('5','eck administer points points entities','eck'),('5','eck administer reader_log reader_log entities','eck'),('5','eck delete activity activity entities','eck'),('5','eck delete activity secret_code entities','eck'),('5','eck delete activity_log_reference activity_log_reference entities','eck'),('5','eck delete badge badge entities','eck'),('5','eck delete drawing_ticket drawing_ticket entities','eck'),('5','eck delete points points entities','eck');
INSERT INTO `role_permission` VALUES ('5','eck edit activity activity entities','eck'),('5','eck edit activity secret_code entities','eck'),('5','eck edit activity_log_reference activity_log_reference entities','eck'),('5','eck edit badge badge entities','eck'),('5','eck edit branch branch entities','eck'),('5','eck edit branch bundles','eck'),('5','eck edit drawing_ticket drawing_ticket entities','eck'),('5','eck edit level bundles','eck'),('5','eck edit level level entities','eck'),('5','eck edit nag_message nag_message entities','eck'),('5','eck edit points points entities','eck'),('5','eck edit prize bundles','eck'),('5','eck edit prize prize entities','eck'),('5','eck edit program bundles','eck'),('5','eck edit program program entities','eck'),('5','eck edit reader_activity_log reader_activity_log entities','eck'),('5','eck edit reader_badge reader_badge entities','eck'),('5','eck edit reader_ticket reader_ticket entities','eck'),('5','eck edit reading_log reading_log entities','eck'),('5','eck edit school school entities','eck'),('5','eck list activity activity entities','eck'),('5','eck list activity secret_code entities','eck'),('5','eck list activity_log_reference activity_log_reference entities','eck'),('5','eck list badge badge entities','eck'),('5','eck list branch branch entities','eck'),('5','eck list branch bundles','eck'),('5','eck list level bundles','eck'),('5','eck list level level entities','eck'),('5','eck list prize bundles','eck'),('5','eck list prize prize entities','eck');
INSERT INTO `role_permission` VALUES ('5','eck list program bundles','eck'),('5','eck list program program entities','eck'),('5','eck list reader_activity_log bundles','eck'),('5','eck list reader_activity_log reader_activity_log entities','eck'),('5','eck view activity_log_reference activity_log_reference entities','eck'),('5','eck view branch branch entities','eck'),('5','eck view branch bundles','eck'),('5','eck view entities','eck'),('5','eck view level bundles','eck'),('5','eck view level level entities','eck'),('5','eck view prize bundles','eck'),('5','eck view prize prize entities','eck'),('5','eck view program bundles','eck'),('5','eck view program program entities','eck'),('5','eck view reader_activity_log bundles','eck'),('5','edit field_account_family_notes','field_permissions'),('5','edit own book_list content','node'),('5','edit own entityform','entityform'),('5','edit own event content','node'),('5','edit terms in 1','taxonomy'),('5','edit terms in 2','taxonomy'),('5','edit terms in 3','taxonomy'),('5','use text format filtered_html','filter'),('5','use text format full_html','filter'),('5','view advanced help index','advanced_help'),('5','view advanced help popup','advanced_help'),('5','view advanced help topic','advanced_help'),('5','view field_account_family_notes','field_permissions'),('5','view own entityform','entityform'),('5','view own field_account_family_notes','field_permissions');
INSERT INTO `role_permission` VALUES ('5','view own unpublished content','node');
DROP TABLE IF EXISTS `rules_config`;
CREATE TABLE `rules_config` (   `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The internal identifier for any configuration.',   `name` varchar(64) NOT NULL COMMENT 'The name of the configuration.',   `label` varchar(255) NOT NULL DEFAULT 'unlabeled' COMMENT 'The label of the configuration.',   `plugin` varchar(127) NOT NULL COMMENT 'The name of the plugin of this configuration.',   `active` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the configuration is active. Usage depends on how the using module makes use of it.',   `weight` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Weight of the configuration. Usage depends on how the using module makes use of it.',   `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The exportable status of the entity.',   `dirty` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Dirty configurations fail the integrity check, e.g. due to missing dependencies.',   `module` varchar(255) DEFAULT NULL COMMENT 'The name of the providing module if the entity has been defined in code.',   `owner` varchar(255) NOT NULL DEFAULT 'rules' COMMENT 'The name of the module via which the rule has been configured.',   `access_exposed` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether to use a permission to control access for using components.',   `data` longblob COMMENT 'Everything else, serialized.',   PRIMARY KEY (`id`),   UNIQUE KEY `name` (`name`),   KEY `plugin` (`plugin`) ) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8 AUTO_INCREMENT=21;
INSERT INTO `rules_config` VALUES ('1','rules_reader_login_redirect','Reader Login Redirect','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":17:{s:9:"\0*\0parent";N;s:2:"id";s:1:"1";s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:27:"rules_reader_login_redirect";s:5:"label";s:21:"Reader Login Redirect";s:6:"plugin";s:13:"reaction rule";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:4:"data";r:1;s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:3:"url";s:16:"reader-dashboard";s:11:"url:process";O:22:"RulesURIInputEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:8:"redirect";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:4:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:27;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:14:"account:select";s:7:"account";s:5:"roles";a:1:{i:4;s:1:"4";}s:9:"operation";s:2:"OR";}s:14:"\0*\0elementName";s:13:"user_has_role";s:9:"\0*\0negate";b:0;}i:1;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:27;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:1:{s:11:"data:select";s:21:"account:field-readers";}s:14:"\0*\0elementName";s:13:"data_is_empty";s:9:"\0*\0negate";b:1;}i:2;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:27;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:6:"source";s:18:"[account:edit-url]";s:14:"source:process";O:19:"RulesTokenEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:14:"path_has_alias";s:9:"\0*\0negate";b:1;}i:3;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:27;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"text:select";s:22:"site:current-page:path";s:5:"match";s:10:"user/reset";}s:14:"\0*\0elementName";s:12:"text_matches";s:9:"\0*\0negate";b:1;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:10:"user_login";}s:16:"\0*\0eventSettings";a:0:{}}');
INSERT INTO `rules_config` VALUES ('2','rules_add_reader_role','Add Reader Role','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":21:{s:9:"\0*\0parent";N;s:2:"id";s:1:"2";s:12:"\0*\0elementId";i:1;s:6:"weight";s:1:"0";s:8:"settings";a:0:{}s:4:"name";s:21:"rules_add_reader_role";s:5:"label";s:15:"Add Reader Role";s:6:"plugin";s:13:"reaction rule";s:6:"active";i:1;s:6:"status";s:1:"1";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";b:0;s:4:"data";r:1;s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:2:{s:14:"account:select";s:7:"account";s:5:"roles";a:1:{i:4;s:1:"4";}}s:14:"\0*\0elementName";s:13:"user_add_role";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:30;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:0;s:8:"settings";a:3:{s:14:"account:select";s:7:"account";s:5:"roles";a:1:{i:5;s:1:"5";}s:9:"operation";s:2:"OR";}s:14:"\0*\0elementName";s:13:"user_has_role";s:9:"\0*\0negate";b:1;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:11:"user_insert";}s:16:"\0*\0eventSettings";a:0:{}}'),('3','rules_reader_logout_redirect','Reader Logout Redirect','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":17:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:28:"rules_reader_logout_redirect";s:5:"label";s:22:"Reader Logout Redirect";s:6:"plugin";s:13:"reaction rule";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:4:"data";r:1;s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:3:"url";s:7:"<front>";s:11:"url:process";O:22:"RulesURIInputEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:8:"redirect";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:11:"user_logout";}s:16:"\0*\0eventSettings";a:0:{}}');
INSERT INTO `rules_config` VALUES ('4','rules_library_login_redirect_','Library Login Redirect ','reaction rule','0','0','1','0','rules','rules','0','O:17:"RulesReactionRule":21:{s:9:"\0*\0parent";N;s:2:"id";s:1:"4";s:12:"\0*\0elementId";i:1;s:6:"weight";s:1:"0";s:8:"settings";a:0:{}s:4:"name";s:29:"rules_library_login_redirect_";s:5:"label";s:23:"Library Login Redirect ";s:6:"plugin";s:13:"reaction rule";s:6:"active";b:0;s:6:"status";s:1:"1";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"data";r:1;s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:0;s:8:"settings";a:4:{s:3:"url";s:19:"/library/dashboard/";s:5:"force";s:1:"1";s:11:"destination";b:0;s:11:"url:process";O:22:"RulesURIInputEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:8:"redirect";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:33;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:3:{s:14:"account:select";s:7:"account";s:5:"roles";a:1:{i:5;s:1:"5";}s:9:"operation";s:3:"AND";}s:14:"\0*\0elementName";s:13:"user_has_role";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:10:"user_login";}s:16:"\0*\0eventSettings";a:0:{}}'),('5','rules_reader_login_redirect_no_profile','Reader Login Redirect No Profile','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":21:{s:9:"\0*\0parent";N;s:2:"id";s:1:"5";s:12:"\0*\0elementId";i:1;s:6:"weight";s:1:"0";s:8:"settings";a:0:{}s:4:"name";s:38:"rules_reader_login_redirect_no_profile";s:5:"label";s:32:"Reader Login Redirect No Profile";s:6:"plugin";s:13:"reaction rule";s:6:"active";i:1;s:6:"status";s:1:"1";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";b:0;s:4:"data";r:1;s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:5;s:6:"weight";i:0;s:8:"settings";a:4:{s:3:"url";s:28:"reader/dashboard/profile/add";s:5:"force";s:1:"1";s:11:"destination";b:0;s:11:"url:process";O:22:"RulesURIInputEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:8:"redirect";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:2:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:33;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:3:{s:14:"account:select";s:7:"account";s:5:"roles";a:1:{i:4;s:1:"4";}s:9:"operation";s:2:"OR";}s:14:"\0*\0elementName";s:13:"user_has_role";s:9:"\0*\0negate";b:0;}i:1;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:33;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:1;s:8:"settings";a:1:{s:11:"data:select";s:21:"account:field-readers";}s:14:"\0*\0elementName";s:13:"data_is_empty";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:10:"user_login";}s:16:"\0*\0eventSettings";a:0:{}}');
INSERT INTO `rules_config` VALUES ('6','rules_onaddreadingentry','OnAddReadingEntry','reaction rule','1','-1','1','0','rules','rules','0','O:17:"RulesReactionRule":17:{s:9:"\0*\0parent";N;s:2:"id";s:1:"6";s:12:"\0*\0elementId";N;s:6:"weight";s:2:"-1";s:8:"settings";a:0:{}s:4:"name";s:23:"rules_onaddreadingentry";s:5:"label";s:17:"OnAddReadingEntry";s:6:"plugin";s:13:"reaction rule";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:4:"data";r:1;s:11:"\0*\0children";a:12:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:11:"reading_log";s:9:"id:select";s:14:"reading-log:id";s:18:"entity_fetched:var";s:14:"reading_log_id";s:20:"entity_fetched:label";s:14:"reading log id";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:6:{s:4:"type";s:11:"reading_log";s:8:"property";s:21:"field_units_completed";s:12:"value:select";s:33:"reading-log:field-units-completed";s:5:"limit";s:1:"1";s:18:"entity_fetched:var";s:13:"fetched_units";s:20:"entity_fetched:label";s:13:"Fetched Units";}s:14:"\0*\0elementName";s:12:"entity_query";}i:2;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"program";s:9:"id:select";s:40:"reading-log:field-program-reference:0:id";s:18:"entity_fetched:var";s:24:"program_reference_entity";s:20:"entity_fetched:label";s:17:"Program Reference";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:3;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"integer";s:12:"value:select";s:33:"reading-log:field-units-completed";s:18:"variable_added:var";s:24:"units_completed_variable";s:20:"variable_added:label";s:24:"Units Completed Variable";}s:14:"\0*\0elementName";s:12:"variable_add";}i:4;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"integer";s:12:"value:select";s:30:"reading-log:field-readers:0:id";s:18:"variable_added:var";s:16:"reader_entity_id";s:20:"variable_added:label";s:16:"Reader Entity ID";}s:14:"\0*\0elementName";s:12:"variable_add";}i:5;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:6:"points";s:10:"param_type";s:6:"points";s:18:"entity_created:var";s:14:"entity_created";s:20:"entity_created:label";s:14:"Created entity";}s:14:"\0*\0elementName";s:13:"entity_create";}i:6;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:28:"entity-created:field-readers";s:12:"value:select";s:25:"reading-log:field-readers";}s:14:"\0*\0elementName";s:8:"data_set";}i:7;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:38:"entity-created:field-program-reference";s:12:"value:select";s:35:"reading-log:field-program-reference";}s:14:"\0*\0elementName";s:8:"data_set";}i:8;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:44:"entity-created:field-reading-log-reference:0";s:12:"value:select";s:14:"reading-log-id";}s:14:"\0*\0elementName";s:8:"data_set";}i:9;O:16:"RulesConditional":7:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:18:"RulesConditionalIf":8:{s:9:"\0*\0parent";r:110;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:2:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:117;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:5:{s:14:"input_1:select";s:24:"units-completed-variable";s:2:"op";s:1:"*";s:14:"input_2:select";s:51:"program-reference-entity:field-per-unit-point-value";s:10:"result:var";s:6:"result";s:12:"result:label";s:18:"Calculation result";}s:14:"\0*\0elementName";s:9:"data_calc";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:117;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:27:"entity-created:field-points";s:12:"value:select";s:6:"result";}s:14:"\0*\0elementName";s:8:"data_set";}}s:7:"\0*\0info";a:0:{}s:12:"\0*\0predicate";O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:117;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:24:"program-reference-entity";s:5:"field";s:26:"field_per_unit_point_value";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}}s:7:"\0*\0info";a:0:{}}i:10;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:1:{s:7:"message";s:36:"Thank you for submitting your entry!";}s:14:"\0*\0elementName";s:14:"drupal_message";}i:11;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:14:"entity-created";s:9:"immediate";s:1:"1";}s:14:"\0*\0elementName";s:11:"entity_save";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:4:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:175;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:11:"reading-log";s:5:"field";s:13:"field_readers";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:1;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:175;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:11:"reading-log";s:5:"field";s:23:"field_program_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:2;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:175;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:11:"reading-log";s:5:"field";s:21:"field_units_completed";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:3;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:175;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:11:"reading-log";s:5:"field";s:22:"field_points_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:18:"reading_log_insert";}s:16:"\0*\0eventSettings";a:0:{}}');
INSERT INTO `rules_config` VALUES ('7','rules_prize_nag_message','Prize Nag Message','reaction rule','0','0','1','0','rules','rules','0','O:17:"RulesReactionRule":21:{s:9:"\0*\0parent";N;s:2:"id";s:1:"7";s:12:"\0*\0elementId";N;s:6:"weight";s:1:"0";s:8:"settings";a:0:{}s:4:"name";s:23:"rules_prize_nag_message";s:5:"label";s:17:"Prize Nag Message";s:6:"plugin";s:13:"reaction rule";s:6:"active";b:0;s:6:"status";s:1:"1";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"data";r:1;s:4:"tags";a:0:{}s:11:"\0*\0children";a:7:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:11:"nag_message";s:10:"param_type";s:11:"nag_message";s:18:"entity_created:var";s:11:"nag_message";s:20:"entity_created:label";s:11:"Nag Message";}s:14:"\0*\0elementName";s:13:"entity_create";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:11:"data:select";s:25:"nag-message:field-message";s:5:"value";s:95:"Hello [reader-prize:field-readers], you have a new prize available! Check with your front desk!";s:13:"value:process";O:19:"RulesTokenEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:8:"data_set";}i:2;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:32:"nag-message:field-current-reader";s:12:"value:select";s:28:"reader-prize:field-readers:0";}s:14:"\0*\0elementName";s:8:"data_set";}i:3;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:11:"data:select";s:17:"nag-message:title";s:5:"value";s:46:"Nag Message for Reader Prize [reader-prize:id]";s:13:"value:process";O:19:"RulesTokenEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:8:"data_set";}i:4;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:1:{s:11:"data:select";s:11:"nag-message";}s:14:"\0*\0elementName";s:11:"entity_save";}i:5;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:5:{s:4:"type";s:6:"reader";s:8:"property";s:2:"id";s:12:"value:select";s:35:"nag-message:field-current-reader:id";s:18:"entity_fetched:var";s:14:"entity_fetched";s:20:"entity_fetched:label";s:14:"Fetched entity";}s:14:"\0*\0elementName";s:12:"entity_query";}i:6;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:14:"entity-fetched";s:12:"value:select";s:0:"";}s:14:"\0*\0elementName";s:8:"data_set";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:7:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:93;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:14:"account:select";s:17:"site:current-user";s:5:"roles";a:1:{i:4;s:1:"4";}}s:14:"\0*\0elementName";s:13:"user_has_role";s:9:"\0*\0negate";b:0;}i:1;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:93;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:12:"reader-prize";s:5:"field";s:12:"field_status";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:2;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:93;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:11:"data:select";s:25:"reader-prize:field-status";s:2:"op";s:2:"==";s:5:"value";s:9:"Unclaimed";}s:14:"\0*\0elementName";s:7:"data_is";s:9:"\0*\0negate";b:0;}i:3;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:93;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:12:"reader-prize";s:5:"field";s:13:"field_readers";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:4;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:93;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:11:"data:select";s:41:"site:current-user:field-current-reader:id";s:2:"op";s:2:"==";s:12:"value:select";s:31:"reader-prize:field-readers:0:id";}s:14:"\0*\0elementName";s:7:"data_is";s:9:"\0*\0negate";b:0;}i:5;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:93;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:17:"site:current-user";s:5:"field";s:20:"field_current_reader";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:6;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:93;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:12:"reader-prize";s:4:"type";s:12:"reader_prize";}s:14:"\0*\0elementName";s:17:"entity_is_of_type";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:19:"reader_prize_insert";}s:16:"\0*\0eventSettings";a:0:{}}');
INSERT INTO `rules_config` VALUES ('8','rules_sum_and_update_points_on_reader_update','Sum and Update Points on Reader Update','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":17:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:44:"rules_sum_and_update_points_on_reader_update";s:5:"label";s:38:"Sum and Update Points on Reader Update";s:6:"plugin";s:13:"reaction rule";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:4:"data";r:1;s:11:"\0*\0children";a:4:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"integer";s:5:"value";s:1:"0";s:18:"variable_added:var";s:14:"variable_added";s:20:"variable_added:label";s:5:"Total";}s:14:"\0*\0elementName";s:12:"variable_add";}i:1;O:9:"RulesLoop":7:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:8:"item:var";s:9:"list_item";s:10:"item:label";s:17:"Current list item";s:11:"list:select";s:29:"reader:field-points-reference";}s:11:"\0*\0children";a:2:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:26;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:6:"points";s:9:"id:select";s:12:"list-item:id";s:18:"entity_fetched:var";s:14:"entity_fetched";s:20:"entity_fetched:label";s:14:"Fetched entity";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:16:"RulesConditional":7:{s:9:"\0*\0parent";r:26;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:18:"RulesConditionalIf":8:{s:9:"\0*\0parent";r:47;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:2:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:54;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:5:{s:14:"input_1:select";s:14:"variable-added";s:2:"op";s:1:"+";s:14:"input_2:select";s:27:"entity-fetched:field-points";s:10:"result:var";s:6:"result";s:12:"result:label";s:18:"Calculation result";}s:14:"\0*\0elementName";s:9:"data_calc";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:54;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:14:"variable-added";s:12:"value:select";s:6:"result";}s:14:"\0*\0elementName";s:8:"data_set";}}s:7:"\0*\0info";a:0:{}s:12:"\0*\0predicate";O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:54;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:14:"entity-fetched";s:5:"field";s:12:"field_points";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}}s:7:"\0*\0info";a:0:{}}}s:7:"\0*\0info";a:0:{}}i:2;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:27:"reader:field-current-points";s:12:"value:select";s:14:"variable-added";}s:14:"\0*\0elementName";s:8:"data_set";}i:3;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:1:{s:11:"data:select";s:6:"reader";}s:14:"\0*\0elementName";s:11:"entity_save";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:3:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:113;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:6:"reader";s:5:"field";s:22:"field_points_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:1;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:113;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"list:select";s:29:"reader:field-points-reference";s:11:"item:select";s:31:"reader:field-points-reference:0";}s:14:"\0*\0elementName";s:13:"list_contains";s:9:"\0*\0negate";b:0;}i:2;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:113;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:6:"reader";s:5:"field";s:20:"field_current_points";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"reader_update";}s:16:"\0*\0eventSettings";a:0:{}}');
INSERT INTO `rules_config` VALUES ('9','rules_upon_adding_points_update_reading_log','Upon Adding Points Update Reading Log','reaction rule','1','3','1','0','rules','rules','0','O:17:"RulesReactionRule":21:{s:9:"\0*\0parent";N;s:2:"id";s:1:"9";s:12:"\0*\0elementId";i:1;s:6:"weight";s:1:"3";s:8:"settings";a:0:{}s:4:"name";s:43:"rules_upon_adding_points_update_reading_log";s:5:"label";s:37:"Upon Adding Points Update Reading Log";s:6:"plugin";s:13:"reaction rule";s:6:"active";i:1;s:6:"status";s:1:"1";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";b:0;s:4:"data";r:1;s:4:"tags";a:0:{}s:11:"\0*\0children";a:3:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:11:"reading_log";s:9:"id:select";s:39:"points:field-reading-log-reference:0:id";s:20:"entity_fetched:label";s:14:"Fetched entity";s:18:"entity_fetched:var";s:14:"entity_fetched";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:7;s:6:"weight";i:1;s:8:"settings";a:6:{s:4:"type";s:6:"points";s:8:"property";s:2:"id";s:12:"value:select";s:9:"points:id";s:5:"limit";s:1:"1";s:20:"entity_fetched:label";s:13:"loaded points";s:18:"entity_fetched:var";s:13:"loaded_points";}s:14:"\0*\0elementName";s:12:"entity_query";}i:2;O:16:"RulesConditional":7:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:5;s:6:"weight";i:2;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:18:"RulesConditionalIf":8:{s:9:"\0*\0parent";r:43;s:2:"id";N;s:12:"\0*\0elementId";i:6;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:50;s:2:"id";N;s:12:"\0*\0elementId";i:8;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:37:"entity-fetched:field-points-reference";s:12:"value:select";s:13:"loaded-points";}s:14:"\0*\0elementName";s:8:"data_set";}}s:7:"\0*\0info";a:0:{}s:12:"\0*\0predicate";O:14:"RulesCondition":7:{s:9:"\0*\0parent";O:18:"RulesConditionalIf":8:{s:9:"\0*\0parent";O:16:"RulesConditional":7:{s:9:"\0*\0parent";O:17:"RulesReactionRule":19:{s:9:"\0*\0parent";N;s:2:"id";s:1:"9";s:12:"\0*\0elementId";i:1;s:6:"weight";s:1:"3";s:8:"settings";a:0:{}s:4:"name";s:43:"rules_upon_adding_points_update_reading_log";s:5:"label";s:37:"Upon Adding Points Update Reading Log";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";s:1:"0";s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"tags";a:0:{}s:11:"\0*\0children";a:3:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:70;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:11:"reading_log";s:9:"id:select";s:39:"points:field-reading-log-reference:0:id";s:20:"entity_fetched:label";s:14:"Fetched entity";s:18:"entity_fetched:var";s:14:"entity_fetched";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:70;s:2:"id";N;s:12:"\0*\0elementId";i:7;s:6:"weight";i:1;s:8:"settings";a:6:{s:4:"type";s:6:"points";s:8:"property";s:2:"id";s:12:"value:select";s:9:"points:id";s:5:"limit";s:1:"1";s:20:"entity_fetched:label";s:13:"loaded points";s:18:"entity_fetched:var";s:13:"loaded_points";}s:14:"\0*\0elementName";s:12:"entity_query";}i:2;r:69;}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:70;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:3:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:112;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:6:"points";s:5:"field";s:27:"field_reading_log_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:1;O:7:"RulesOr":8:{s:9:"\0*\0parent";r:112;s:2:"id";N;s:12:"\0*\0elementId";i:9;s:6:"weight";i:1;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}i:2;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:112;s:2:"id";N;s:12:"\0*\0elementId";i:10;s:6:"weight";i:2;s:8:"settings";a:2:{s:13:"entity:select";s:6:"points";s:5:"field";s:28:"field_activity_log_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"points_insert";}s:16:"\0*\0eventSettings";a:0:{}}s:2:"id";N;s:12:"\0*\0elementId";i:5;s:6:"weight";i:2;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;r:68;}s:7:"\0*\0info";a:0:{}}s:2:"id";N;s:12:"\0*\0elementId";i:6;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:68;s:2:"id";N;s:12:"\0*\0elementId";i:8;s:6:"weight";i:0;s:8:"settings";a:2:{s:11:"data:select";s:37:"entity-fetched:field-points-reference";s:12:"value:select";s:13:"loaded-points";}s:14:"\0*\0elementName";s:8:"data_set";}}s:7:"\0*\0info";a:0:{}s:12:"\0*\0predicate";r:67;}s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:14:"entity-fetched";s:5:"field";s:22:"field_points_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}}s:7:"\0*\0info";a:0:{}}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:2:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:186;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:6:"points";s:5:"field";s:27:"field_reading_log_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}i:1;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:186;s:2:"id";N;s:12:"\0*\0elementId";i:9;s:6:"weight";i:1;s:8:"settings";a:1:{s:11:"data:select";s:34:"points:field-reading-log-reference";}s:14:"\0*\0elementName";s:13:"data_is_empty";s:9:"\0*\0negate";b:1;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"points_insert";}s:16:"\0*\0eventSettings";a:0:{}}');
INSERT INTO `rules_config` VALUES ('10','rules_upon_adding_points_update_reader_points_reference','Upon Adding Points Update Reader Points Reference','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":21:{s:9:"\0*\0parent";N;s:2:"id";s:2:"10";s:12:"\0*\0elementId";i:1;s:6:"weight";s:1:"0";s:8:"settings";a:0:{}s:4:"name";s:55:"rules_upon_adding_points_update_reader_points_reference";s:5:"label";s:49:"Upon Adding Points Update Reader Points Reference";s:6:"plugin";s:13:"reaction rule";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"data";r:1;s:4:"tags";a:0:{}s:11:"\0*\0children";a:3:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:6:"reader";s:9:"id:select";s:25:"points:field-readers:0:id";s:20:"entity_fetched:label";s:14:"Fetched entity";s:18:"entity_fetched:var";s:14:"entity_fetched";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:5;s:6:"weight";i:1;s:8:"settings";a:6:{s:4:"type";s:6:"points";s:8:"property";s:2:"id";s:12:"value:select";s:9:"points:id";s:5:"limit";s:1:"1";s:20:"entity_fetched:label";s:13:"loaded points";s:18:"entity_fetched:var";s:13:"loaded_points";}s:14:"\0*\0elementName";s:12:"entity_query";}i:2;O:16:"RulesConditional":7:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:6;s:6:"weight";i:2;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:18:"RulesConditionalIf":8:{s:9:"\0*\0parent";r:43;s:2:"id";N;s:12:"\0*\0elementId";i:7;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:50;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:4:{s:11:"list:select";s:37:"entity-fetched:field-points-reference";s:11:"item:select";s:15:"loaded-points:0";s:6:"unique";b:0;s:3:"pos";s:3:"end";}s:14:"\0*\0elementName";s:8:"list_add";}}s:7:"\0*\0info";a:0:{}s:12:"\0*\0predicate";O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:50;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:14:"entity-fetched";s:5:"field";s:22:"field_points_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}}s:7:"\0*\0info";a:0:{}}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:81;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:6:"points";s:5:"field";s:13:"field_readers";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"points_insert";}s:16:"\0*\0eventSettings";a:0:{}}');
INSERT INTO `rules_config` VALUES ('11','rules_badge_earned_message','Badge Earned Message','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":17:{s:9:"\0*\0parent";N;s:2:"id";s:2:"11";s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:26:"rules_badge_earned_message";s:5:"label";s:20:"Badge Earned Message";s:6:"plugin";s:13:"reaction rule";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:4:"data";r:1;s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:7:"message";s:34:"[reader-badge:field_badge_message]";s:6:"repeat";s:1:"0";s:15:"message:process";O:19:"RulesTokenEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:28;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:14:"account:select";s:17:"site:current-user";s:5:"roles";a:1:{i:4;s:1:"4";}}s:14:"\0*\0elementName";s:13:"user_has_role";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:19:"reader_badge_insert";}s:16:"\0*\0eventSettings";a:0:{}}'),('12','rules_branch_add_another','Branch Add Another','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":21:{s:9:"\0*\0parent";N;s:2:"id";s:2:"12";s:12:"\0*\0elementId";i:1;s:6:"weight";s:1:"0";s:8:"settings";a:0:{}s:4:"name";s:24:"rules_branch_add_another";s:5:"label";s:18:"Branch Add Another";s:6:"plugin";s:13:"reaction rule";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"data";r:1;s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:7:"message";s:78:"<a href="/library/dashboard/branches/add">Click here to add another Branch</a>";s:4:"type";s:6:"status";s:6:"repeat";s:1:"1";}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"branch_insert";}s:16:"\0*\0eventSettings";a:0:{}}');
INSERT INTO `rules_config` VALUES ('13','rules_program_add_another','Program Add Another','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":21:{s:9:"\0*\0parent";N;s:2:"id";s:2:"13";s:12:"\0*\0elementId";i:1;s:6:"weight";s:1:"0";s:8:"settings";a:0:{}s:4:"name";s:25:"rules_program_add_another";s:5:"label";s:19:"Program Add Another";s:6:"plugin";s:13:"reaction rule";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"data";r:1;s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:3:{s:7:"message";s:78:"<a href="/library/dashboard/program/add">Click here to add another Program</a>";s:4:"type";s:6:"status";s:6:"repeat";s:1:"1";}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:14:"program_insert";}s:16:"\0*\0eventSettings";a:0:{}}'),('14','rules_badges_add_another','Badges Add Another','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":21:{s:9:"\0*\0parent";N;s:2:"id";s:2:"14";s:12:"\0*\0elementId";i:1;s:6:"weight";s:1:"0";s:8:"settings";a:0:{}s:4:"name";s:24:"rules_badges_add_another";s:5:"label";s:18:"Badges Add Another";s:6:"plugin";s:13:"reaction rule";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"data";r:1;s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:3:{s:7:"message";s:91:"<a href="/library/dashboard/branches/program/badge/add">Click here to add another Badge</a>";s:4:"type";s:6:"status";s:6:"repeat";s:1:"1";}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:12:"badge_insert";}s:16:"\0*\0eventSettings";a:0:{}}');
INSERT INTO `rules_config` VALUES ('15','rules_prize_add_another','Prize Add Another','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":21:{s:9:"\0*\0parent";N;s:2:"id";s:2:"15";s:12:"\0*\0elementId";i:1;s:6:"weight";s:1:"0";s:8:"settings";a:0:{}s:4:"name";s:23:"rules_prize_add_another";s:5:"label";s:17:"Prize Add Another";s:6:"plugin";s:13:"reaction rule";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"data";r:1;s:4:"tags";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:0;s:8:"settings";a:3:{s:7:"message";s:91:"<a href="/library/dashboard/branches/program/prize/add">Click here to add another Prize</a>";s:4:"type";s:6:"status";s:6:"repeat";s:1:"1";}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:12:"prize_insert";}s:16:"\0*\0eventSettings";a:0:{}}'),('16','rules_level_add_another','Level Add Another','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":21:{s:9:"\0*\0parent";N;s:2:"id";s:2:"16";s:12:"\0*\0elementId";i:1;s:6:"weight";s:1:"0";s:8:"settings";a:0:{}s:4:"name";s:23:"rules_level_add_another";s:5:"label";s:17:"Level Add Another";s:6:"plugin";s:13:"reaction rule";s:6:"active";s:1:"1";s:6:"status";s:1:"1";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";s:1:"0";s:4:"data";r:1;s:4:"tags";a:0:{}s:11:"\0*\0children";a:2:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:4;s:6:"weight";i:0;s:8:"settings";a:4:{s:4:"type";s:7:"program";s:9:"id:select";s:34:"level:field-program-reference:0:id";s:20:"entity_fetched:label";s:20:"Fetched Level Entity";s:18:"entity_fetched:var";s:20:"level_entity_fetched";}s:14:"\0*\0elementName";s:12:"entity_fetch";}i:1;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:3;s:6:"weight";i:1;s:8:"settings";a:4:{s:7:"message";s:155:"<a href="/library/dashboard/program/level/add/[level-entity-fetched:id]">Click here to add another Level to the [level:field-program-reference] Program</a>";s:4:"type";s:6:"status";s:6:"repeat";s:1:"1";s:15:"message:process";O:19:"RulesTokenEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:44;s:2:"id";N;s:12:"\0*\0elementId";i:6;s:6:"weight";i:0;s:8:"settings";a:2:{s:13:"entity:select";s:5:"level";s:5:"field";s:23:"field_program_reference";}s:14:"\0*\0elementName";s:16:"entity_has_field";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:12:"level_insert";}s:16:"\0*\0eventSettings";a:0:{}}');
INSERT INTO `rules_config` VALUES ('17','rules_prize_earned_message','Prize Earned Message','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":17:{s:9:"\0*\0parent";N;s:2:"id";s:2:"17";s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:26:"rules_prize_earned_message";s:5:"label";s:20:"Prize Earned Message";s:6:"plugin";s:13:"reaction rule";s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:4:"data";r:1;s:11:"\0*\0children";a:1:{i:0;O:11:"RulesAction":6:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:3:{s:7:"message";s:34:"[reader-prize:field-prize-message]";s:6:"repeat";s:1:"0";s:15:"message:process";O:19:"RulesTokenEvaluator":2:{s:10:"\0*\0setting";b:1;s:12:"\0*\0processor";N;}}s:14:"\0*\0elementName";s:14:"drupal_message";}}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:1:{i:0;O:14:"RulesCondition":7:{s:9:"\0*\0parent";r:28;s:2:"id";N;s:12:"\0*\0elementId";N;s:6:"weight";i:0;s:8:"settings";a:2:{s:14:"account:select";s:17:"site:current-user";s:5:"roles";a:1:{i:4;s:1:"4";}}s:14:"\0*\0elementName";s:13:"user_has_role";s:9:"\0*\0negate";b:0;}}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:19:"reader_prize_insert";}s:16:"\0*\0eventSettings";a:0:{}}'),('20','rules_badge_set_author','Badge Set Author','reaction rule','1','0','1','0','rules','rules','0','O:17:"RulesReactionRule":20:{s:9:"\0*\0parent";N;s:2:"id";N;s:12:"\0*\0elementId";i:1;s:6:"weight";i:0;s:8:"settings";a:0:{}s:4:"name";s:22:"rules_badge_set_author";s:5:"label";s:16:"Badge Set Author";s:6:"plugin";s:13:"reaction rule";s:6:"active";b:1;s:5:"dirty";b:0;s:6:"module";s:5:"rules";s:5:"owner";s:5:"rules";s:14:"access_exposed";b:0;s:4:"data";r:1;s:4:"tags";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:13:"\0*\0conditions";O:8:"RulesAnd":8:{s:9:"\0*\0parent";r:1;s:2:"id";N;s:12:"\0*\0elementId";i:2;s:6:"weight";i:0;s:8:"settings";a:0:{}s:11:"\0*\0children";a:0:{}s:7:"\0*\0info";a:0:{}s:9:"\0*\0negate";b:0;}s:9:"\0*\0events";a:1:{i:0;s:13:"badge_presave";}s:16:"\0*\0eventSettings";a:0:{}}');
DROP TABLE IF EXISTS `rules_dependencies`;
CREATE TABLE `rules_dependencies` (   `id` int(10) unsigned NOT NULL COMMENT 'The primary identifier of the configuration.',   `module` varchar(255) NOT NULL COMMENT 'The name of the module that is required for the configuration.',   PRIMARY KEY (`id`,`module`),   KEY `module` (`module`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
INSERT INTO `rules_dependencies` VALUES ('6','eck'),('7','eck'),('8','eck'),('9','eck'),('10','eck'),('11','eck'),('12','eck'),('13','eck'),('14','eck'),('15','eck'),('16','eck'),('17','eck'),('20','eck'),('1','path'),('1','rules'),('2','rules'),('3','rules'),('4','rules'),('5','rules'),('6','rules'),('7','rules'),('8','rules'),('9','rules'),('10','rules'),('11','rules'),('12','rules'),('13','rules'),('14','rules'),('15','rules'),('16','rules');
INSERT INTO `rules_dependencies` VALUES ('17','rules'),('6','rules_conditional'),('8','rules_conditional'),('9','rules_conditional'),('10','rules_conditional');
DROP TABLE IF EXISTS `rules_tags`;
CREATE TABLE `rules_tags` (   `id` int(10) unsigned NOT NULL COMMENT 'The primary identifier of the configuration.',   `tag` varchar(255) NOT NULL COMMENT 'The tag string associated with this configuration',   PRIMARY KEY (`id`,`tag`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `rules_trigger`;
CREATE TABLE `rules_trigger` (   `id` int(10) unsigned NOT NULL COMMENT 'The primary identifier of the configuration.',   `event` varchar(127) NOT NULL DEFAULT '' COMMENT 'The name of the event on which the configuration should be triggered.',   PRIMARY KEY (`id`,`event`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
INSERT INTO `rules_trigger` VALUES ('1','user_login'),('2','user_insert'),('3','user_logout'),('4','user_login'),('5','user_login'),('6','reading_log_insert'),('7','reader_prize_insert'),('8','reader_update'),('9','points_insert'),('10','points_insert'),('11','reader_badge_insert'),('12','branch_insert'),('13','program_insert'),('14','badge_insert'),('15','prize_insert'),('16','level_insert'),('17','reader_prize_insert'),('20','badge_presave');
DROP TABLE IF EXISTS `search_dataset`;
CREATE TABLE `search_dataset` (   `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Search item ID, e.g. node ID for nodes.',   `type` varchar(16) NOT NULL COMMENT 'Type of item, e.g. node.',   `data` longtext NOT NULL COMMENT 'List of space-separated words from the item.',   `reindex` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Set to force node reindexing.',   PRIMARY KEY (`sid`,`type`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores items that will be searched.';
DROP TABLE IF EXISTS `search_index`;
CREATE TABLE `search_index` (   `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'The search_total.word that is associated with the search item.',   `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The search_dataset.sid of the searchable item to which the word belongs.',   `type` varchar(16) NOT NULL COMMENT 'The search_dataset.type of the searchable item to which the word belongs.',   `score` float DEFAULT NULL COMMENT 'The numeric score of the word, higher being more important.',   PRIMARY KEY (`word`,`sid`,`type`),   KEY `sid_type` (`sid`,`type`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the search index, associating words, items and...';
DROP TABLE IF EXISTS `search_node_links`;
CREATE TABLE `search_node_links` (   `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The search_dataset.sid of the searchable item containing the link to the node.',   `type` varchar(16) NOT NULL DEFAULT '' COMMENT 'The search_dataset.type of the searchable item containing the link to the node.',   `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid that this item links to.',   `caption` longtext COMMENT 'The text used to link to the node.nid.',   PRIMARY KEY (`sid`,`type`,`nid`),   KEY `nid` (`nid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores items (like nodes) that link to other nodes, used...';
DROP TABLE IF EXISTS `search_total`;
CREATE TABLE `search_total` (   `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique word in the search index.',   `count` float DEFAULT NULL COMMENT 'The count of the word in the index using Zipf’s law to equalize the probability distribution.',   PRIMARY KEY (`word`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores search totals for words.';
DROP TABLE IF EXISTS `semaphore`;
CREATE TABLE `semaphore` (   `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique name.',   `value` varchar(255) NOT NULL DEFAULT '' COMMENT 'A value for the semaphore.',   `expire` double NOT NULL COMMENT 'A Unix timestamp with microseconds indicating when the semaphore should expire.',   PRIMARY KEY (`name`),   KEY `value` (`value`),   KEY `expire` (`expire`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table for holding semaphores, locks, flags, etc. that...';
DROP TABLE IF EXISTS `sequences`;
CREATE TABLE `sequences` (   `value` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The value of the sequence.',   PRIMARY KEY (`value`) ) ENGINE=InnoDB AUTO_INCREMENT=211 DEFAULT CHARSET=utf8 COMMENT='Stores IDs.' AUTO_INCREMENT=211;
INSERT INTO `sequences` VALUES ('210');
DROP TABLE IF EXISTS `sessions`;
CREATE TABLE `sessions` (   `uid` int(10) unsigned NOT NULL COMMENT 'The users.uid corresponding to a session, or 0 for anonymous user.',   `sid` varchar(128) NOT NULL COMMENT 'A session ID. The value is generated by Drupal’s session handlers.',   `ssid` varchar(128) NOT NULL DEFAULT '' COMMENT 'Secure session ID. The value is generated by Drupal’s session handlers.',   `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'The IP address that last used this session ID (sid).',   `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when this session last requested a page. Old records are purged by PHP automatically.',   `cache` int(11) NOT NULL DEFAULT '0' COMMENT 'The time of this user’s last post. This is used when the site has specified a minimum_cache_lifetime. See cache_get().',   `session` longblob COMMENT 'The serialized contents of $_SESSION, an array of name/value pairs that persists across page requests by this session ID. Drupal loads $_SESSION from here at the start of each request and saves it at the end.',   PRIMARY KEY (`sid`,`ssid`),   KEY `timestamp` (`timestamp`),   KEY `uid` (`uid`),   KEY `ssid` (`ssid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Drupal’s session handlers read and write into the...';
DROP TABLE IF EXISTS `shortcut_set`;
CREATE TABLE `shortcut_set` (   `set_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Primary Key: The menu_links.menu_name under which the set’s links are stored.',   `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of the set.',   PRIMARY KEY (`set_name`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about sets of shortcuts links.';
INSERT INTO `shortcut_set` VALUES ('shortcut-set-1','Default');
DROP TABLE IF EXISTS `shortcut_set_users`;
CREATE TABLE `shortcut_set_users` (   `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid for this set.',   `set_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The shortcut_set.set_name that will be displayed for this user.',   PRIMARY KEY (`uid`),   KEY `set_name` (`set_name`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps users to shortcut sets.';
DROP TABLE IF EXISTS `system`;
CREATE TABLE `system` (   `filename` varchar(255) NOT NULL DEFAULT '' COMMENT 'The path of the primary file for this item, relative to the Drupal root; e.g. modules/node/node.module.',   `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the item; e.g. node.',   `type` varchar(12) NOT NULL DEFAULT '' COMMENT 'The type of the item, either module, theme, or theme_engine.',   `owner` varchar(255) NOT NULL DEFAULT '' COMMENT 'A theme’s ’parent’ . Can be either a theme or an engine.',   `status` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether or not this item is enabled.',   `bootstrap` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether this module is loaded during Drupal’s early bootstrapping phase (e.g. even before the page cache is consulted).',   `schema_version` smallint(6) NOT NULL DEFAULT '-1' COMMENT 'The module’s database schema version number. -1 if the module is not installed (its tables do not exist); 0 or the largest N of the module’s hook_update_N() function that has either been run or existed when the module was first installed.',   `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The order in which this module’s hooks should be invoked relative to other modules. Equal-weighted modules are ordered by name.',   `info` blob COMMENT 'A serialized array containing information from the module’s .info file; keys can include name, description, package, version, core, dependencies, and php.',   PRIMARY KEY (`filename`),   KEY `system_list` (`status`,`bootstrap`,`type`,`weight`,`name`),   KEY `type_name` (`type`,`name`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A list of all modules, themes, and theme engines that are...';
INSERT INTO `system` VALUES ('modules/aggregator/aggregator.module','aggregator','module','','0','0','-1','0','a:14:{s:4:"name";s:10:"Aggregator";s:11:"description";s:57:"Aggregates syndicated content (RSS, RDF, and Atom feeds).";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:15:"aggregator.test";}s:9:"configure";s:41:"admin/config/services/aggregator/settings";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:14:"aggregator.css";s:33:"modules/aggregator/aggregator.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/aggregator/tests/aggregator_test.module','aggregator_test','module','','0','0','-1','0','a:13:{s:4:"name";s:23:"Aggregator module tests";s:11:"description";s:46:"Support module for aggregator related testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/block/block.module','block','module','','1','0','7009','-5','a:13:{s:4:"name";s:5:"Block";s:11:"description";s:140:"Controls the visual building blocks a page is constructed with. Blocks are boxes of content rendered into an area, or region, of a web page.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:10:"block.test";}s:9:"configure";s:21:"admin/structure/block";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/block/tests/block_test.module','block_test','module','','0','0','-1','0','a:13:{s:4:"name";s:10:"Block test";s:11:"description";s:21:"Provides test blocks.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/blog/blog.module','blog','module','','0','0','-1','0','a:12:{s:4:"name";s:4:"Blog";s:11:"description";s:25:"Enables multi-user blogs.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:9:"blog.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/book/book.module','book','module','','0','0','-1','0','a:14:{s:4:"name";s:4:"Book";s:11:"description";s:66:"Allows users to create and organize related content in an outline.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:9:"book.test";}s:9:"configure";s:27:"admin/content/book/settings";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:8:"book.css";s:21:"modules/book/book.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/color/color.module','color','module','','1','0','7001','0','a:12:{s:4:"name";s:5:"Color";s:11:"description";s:70:"Allows administrators to change the color scheme of compatible themes.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:10:"color.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/comment/comment.module','comment','module','','1','0','7009','0','a:14:{s:4:"name";s:7:"Comment";s:11:"description";s:57:"Allows users to comment on and discuss published content.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:4:"text";}s:5:"files";a:2:{i:0;s:14:"comment.module";i:1;s:12:"comment.test";}s:9:"configure";s:21:"admin/content/comment";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:11:"comment.css";s:27:"modules/comment/comment.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/contact/contact.module','contact','module','','0','0','-1','0','a:13:{s:4:"name";s:7:"Contact";s:11:"description";s:61:"Enables the use of both personal and site-wide contact forms.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:12:"contact.test";}s:9:"configure";s:23:"admin/structure/contact";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/contextual/contextual.module','contextual','module','','1','0','0','0','a:12:{s:4:"name";s:16:"Contextual links";s:11:"description";s:75:"Provides contextual links to perform actions related to elements on a page.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:15:"contextual.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/dashboard/dashboard.module','dashboard','module','','1','0','0','0','a:13:{s:4:"name";s:9:"Dashboard";s:11:"description";s:136:"Provides a dashboard page in the administrative interface for organizing administrative tasks and tracking information within your site.";s:4:"core";s:3:"7.x";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:5:"files";a:1:{i:0;s:14:"dashboard.test";}s:12:"dependencies";a:1:{i:0;s:5:"block";}s:9:"configure";s:25:"admin/dashboard/customize";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/dblog/dblog.module','dblog','module','','1','1','7003','0','a:12:{s:4:"name";s:16:"Database logging";s:11:"description";s:47:"Logs and records system events to the database.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:10:"dblog.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/field/field.module','field','module','','1','0','7004','0','a:14:{s:4:"name";s:5:"Field";s:11:"description";s:57:"Field API to add fields to entities like nodes and users.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:4:{i:0;s:12:"field.module";i:1;s:16:"field.attach.inc";i:2;s:20:"field.info.class.inc";i:3;s:16:"tests/field.test";}s:12:"dependencies";a:1:{i:0;s:17:"field_sql_storage";}s:8:"required";b:1;s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:15:"theme/field.css";s:29:"modules/field/theme/field.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/field/modules/field_sql_storage/field_sql_storage.module','field_sql_storage','module','','1','0','7002','0','a:13:{s:4:"name";s:17:"Field SQL storage";s:11:"description";s:37:"Stores field data in an SQL database.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:22:"field_sql_storage.test";}s:8:"required";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/field/modules/list/list.module','list','module','','1','0','7002','0','a:14:{s:4:"name";s:4:"List";s:11:"description";s:69:"Defines list field types. Use with Options to create selection lists.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:5:"field";i:1;s:7:"options";}s:5:"files";a:1:{i:0;s:15:"tests/list.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}'),('modules/field/modules/list/tests/list_test.module','list_test','module','','0','0','-1','0','a:13:{s:4:"name";s:9:"List test";s:11:"description";s:41:"Support module for the List module tests.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/field/modules/number/number.module','number','module','','1','0','0','0','a:14:{s:4:"name";s:6:"Number";s:11:"description";s:28:"Defines numeric field types.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:11:"number.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}'),('modules/field/modules/options/options.module','options','module','','1','0','0','0','a:12:{s:4:"name";s:7:"Options";s:11:"description";s:82:"Defines selection, check box and radio button widgets for text and numeric fields.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:12:"options.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/field/modules/text/text.module','text','module','','1','0','7000','0','a:14:{s:4:"name";s:4:"Text";s:11:"description";s:32:"Defines simple text field types.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:9:"text.test";}s:8:"required";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}'),('modules/field/tests/field_test.module','field_test','module','','0','0','-1','0','a:13:{s:4:"name";s:14:"Field API Test";s:11:"description";s:39:"Support module for the Field API tests.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:5:"files";a:1:{i:0;s:21:"field_test.entity.inc";}s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/field_ui/field_ui.module','field_ui','module','','1','0','0','0','a:12:{s:4:"name";s:8:"Field UI";s:11:"description";s:33:"User interface for the Field API.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:13:"field_ui.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/file/file.module','file','module','','1','0','0','0','a:12:{s:4:"name";s:4:"File";s:11:"description";s:26:"Defines a file field type.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:15:"tests/file.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/file/tests/file_module_test.module','file_module_test','module','','0','0','-1','0','a:13:{s:4:"name";s:9:"File test";s:11:"description";s:53:"Provides hooks for testing File module functionality.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/filter/filter.module','filter','module','','1','0','7010','0','a:14:{s:4:"name";s:6:"Filter";s:11:"description";s:43:"Filters content in preparation for display.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:11:"filter.test";}s:8:"required";b:1;s:9:"configure";s:28:"admin/config/content/formats";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/forum/forum.module','forum','module','','0','0','-1','0','a:14:{s:4:"name";s:5:"Forum";s:11:"description";s:27:"Provides discussion forums.";s:12:"dependencies";a:2:{i:0;s:8:"taxonomy";i:1;s:7:"comment";}s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:10:"forum.test";}s:9:"configure";s:21:"admin/structure/forum";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:9:"forum.css";s:23:"modules/forum/forum.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/help/help.module','help','module','','1','0','0','0','a:12:{s:4:"name";s:4:"Help";s:11:"description";s:35:"Manages the display of online help.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:9:"help.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/image/image.module','image','module','','1','0','7005','0','a:15:{s:4:"name";s:5:"Image";s:11:"description";s:34:"Provides image manipulation tools.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:4:"file";}s:5:"files";a:1:{i:0;s:10:"image.test";}s:9:"configure";s:31:"admin/config/media/image-styles";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}'),('modules/image/tests/image_module_test.module','image_module_test','module','','0','0','-1','0','a:13:{s:4:"name";s:10:"Image test";s:11:"description";s:69:"Provides hook implementations for testing Image module functionality.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:24:"image_module_test.module";}s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/locale/locale.module','locale','module','','0','0','-1','0','a:13:{s:4:"name";s:6:"Locale";s:11:"description";s:119:"Adds language handling functionality and enables the translation of the user interface to languages other than English.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:11:"locale.test";}s:9:"configure";s:30:"admin/config/regional/language";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/locale/tests/locale_test.module','locale_test','module','','0','0','-1','0','a:13:{s:4:"name";s:11:"Locale Test";s:11:"description";s:42:"Support module for the locale layer tests.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/menu/menu.module','menu','module','','1','0','7003','0','a:13:{s:4:"name";s:4:"Menu";s:11:"description";s:60:"Allows administrators to customize the site navigation menu.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:9:"menu.test";}s:9:"configure";s:20:"admin/structure/menu";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/node/node.module','node','module','','1','0','7016','0','a:15:{s:4:"name";s:4:"Node";s:11:"description";s:66:"Allows content to be submitted to the site and displayed on pages.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:11:"node.module";i:1;s:9:"node.test";}s:8:"required";b:1;s:9:"configure";s:21:"admin/structure/types";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:8:"node.css";s:21:"modules/node/node.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/node/tests/node_access_test.module','node_access_test','module','','0','0','-1','0','a:13:{s:4:"name";s:24:"Node module access tests";s:11:"description";s:43:"Support module for node permission testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/node/tests/node_test.module','node_test','module','','0','0','-1','0','a:13:{s:4:"name";s:17:"Node module tests";s:11:"description";s:40:"Support module for node related testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/node/tests/node_test_exception.module','node_test_exception','module','','0','0','-1','0','a:13:{s:4:"name";s:27:"Node module exception tests";s:11:"description";s:50:"Support module for node related exception testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/openid/openid.module','openid','module','','0','0','-1','0','a:12:{s:4:"name";s:6:"OpenID";s:11:"description";s:48:"Allows users to log into your site using OpenID.";s:7:"version";s:4:"7.54";s:7:"package";s:4:"Core";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:11:"openid.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/openid/tests/openid_test.module','openid_test','module','','0','0','-1','0','a:13:{s:4:"name";s:21:"OpenID dummy provider";s:11:"description";s:33:"OpenID provider used for testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:6:"openid";}s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/overlay/overlay.module','overlay','module','','0','0','0','0','a:12:{s:4:"name";s:7:"Overlay";s:11:"description";s:59:"Displays the Drupal administration interface in an overlay.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/pantheon/pantheon_api/pantheon_api.module','pantheon_api','module','','0','0','0','0','a:10:{s:4:"name";s:21:"Pantheon Platform API";s:11:"description";s:38:"Integration with the Pantheon Platform";s:7:"version";s:7:"7.x-1.0";s:7:"package";s:8:"Pantheon";s:4:"core";s:3:"7.x";s:3:"php";s:3:"5.2";s:5:"mtime";i:1489756937;s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/pantheon/pantheon_login/pantheon_login.module','pantheon_login','module','','0','0','0','0','a:11:{s:4:"name";s:14:"Pantheon Login";s:11:"description";s:67:"Allows users to log in as user #1 from their Pantheon Control Panel";s:7:"package";s:8:"Pantheon";s:7:"version";s:7:"7.x-1.0";s:6:"hidden";b:1;s:4:"core";s:3:"7.x";s:3:"php";s:3:"5.2";s:5:"mtime";i:1489756937;s:12:"dependencies";a:0:{}s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/path/path.module','path','module','','1','0','0','0','a:13:{s:4:"name";s:4:"Path";s:11:"description";s:28:"Allows users to rename URLs.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:9:"path.test";}s:9:"configure";s:24:"admin/config/search/path";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/php/php.module','php','module','','1','0','0','0','a:12:{s:4:"name";s:10:"PHP filter";s:11:"description";s:50:"Allows embedded PHP code/snippets to be evaluated.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:8:"php.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/poll/poll.module','poll','module','','0','0','-1','0','a:13:{s:4:"name";s:4:"Poll";s:11:"description";s:95:"Allows your site to capture votes on different topics in the form of multiple choice questions.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:9:"poll.test";}s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:8:"poll.css";s:21:"modules/poll/poll.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/profile/profile.module','profile','module','','0','0','-1','0','a:14:{s:4:"name";s:7:"Profile";s:11:"description";s:36:"Supports configurable user profiles.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:12:"profile.test";}s:9:"configure";s:27:"admin/config/people/profile";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/rdf/rdf.module','rdf','module','','1','0','0','0','a:12:{s:4:"name";s:3:"RDF";s:11:"description";s:148:"Enriches your content with metadata to let other applications (e.g. search engines, aggregators) better understand its relationships and attributes.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:8:"rdf.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/rdf/tests/rdf_test.module','rdf_test','module','','0','0','-1','0','a:13:{s:4:"name";s:16:"RDF module tests";s:11:"description";s:38:"Support module for RDF module testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:4:"blog";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/search/search.module','search','module','','1','0','7000','0','a:14:{s:4:"name";s:6:"Search";s:11:"description";s:36:"Enables site-wide keyword searching.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:19:"search.extender.inc";i:1;s:11:"search.test";}s:9:"configure";s:28:"admin/config/search/settings";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:10:"search.css";s:25:"modules/search/search.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/search/tests/search_embedded_form.module','search_embedded_form','module','','0','0','-1','0','a:13:{s:4:"name";s:20:"Search embedded form";s:11:"description";s:59:"Support module for search module testing of embedded forms.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/search/tests/search_extra_type.module','search_extra_type','module','','0','0','-1','0','a:13:{s:4:"name";s:16:"Test search type";s:11:"description";s:41:"Support module for search module testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/search/tests/search_node_tags.module','search_node_tags','module','','0','0','-1','0','a:13:{s:4:"name";s:21:"Test search node tags";s:11:"description";s:44:"Support module for Node search tags testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/shortcut/shortcut.module','shortcut','module','','1','0','0','0','a:13:{s:4:"name";s:8:"Shortcut";s:11:"description";s:60:"Allows users to manage customizable lists of shortcut links.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:13:"shortcut.test";}s:9:"configure";s:36:"admin/config/user-interface/shortcut";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/simpletest/simpletest.module','simpletest','module','','0','0','-1','0','a:13:{s:4:"name";s:7:"Testing";s:11:"description";s:53:"Provides a framework for unit and functional testing.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:50:{i:0;s:15:"simpletest.test";i:1;s:24:"drupal_web_test_case.php";i:2;s:18:"tests/actions.test";i:3;s:15:"tests/ajax.test";i:4;s:16:"tests/batch.test";i:5;s:15:"tests/boot.test";i:6;s:20:"tests/bootstrap.test";i:7;s:16:"tests/cache.test";i:8;s:17:"tests/common.test";i:9;s:24:"tests/database_test.test";i:10;s:22:"tests/entity_crud.test";i:11;s:32:"tests/entity_crud_hook_test.test";i:12;s:23:"tests/entity_query.test";i:13;s:16:"tests/error.test";i:14;s:15:"tests/file.test";i:15;s:23:"tests/filetransfer.test";i:16;s:15:"tests/form.test";i:17;s:16:"tests/graph.test";i:18;s:16:"tests/image.test";i:19;s:15:"tests/lock.test";i:20;s:15:"tests/mail.test";i:21;s:15:"tests/menu.test";i:22;s:17:"tests/module.test";i:23;s:16:"tests/pager.test";i:24;s:19:"tests/password.test";i:25;s:15:"tests/path.test";i:26;s:19:"tests/registry.test";i:27;s:17:"tests/schema.test";i:28;s:18:"tests/session.test";i:29;s:20:"tests/tablesort.test";i:30;s:16:"tests/theme.test";i:31;s:18:"tests/unicode.test";i:32;s:17:"tests/update.test";i:33;s:17:"tests/xmlrpc.test";i:34;s:26:"tests/upgrade/upgrade.test";i:35;s:34:"tests/upgrade/upgrade.comment.test";i:36;s:33:"tests/upgrade/upgrade.filter.test";i:37;s:32:"tests/upgrade/upgrade.forum.test";i:38;s:33:"tests/upgrade/upgrade.locale.test";i:39;s:31:"tests/upgrade/upgrade.menu.test";i:40;s:31:"tests/upgrade/upgrade.node.test";i:41;s:35:"tests/upgrade/upgrade.taxonomy.test";i:42;s:34:"tests/upgrade/upgrade.trigger.test";i:43;s:39:"tests/upgrade/upgrade.translatable.test";i:44;s:33:"tests/upgrade/upgrade.upload.test";i:45;s:31:"tests/upgrade/upgrade.user.test";i:46;s:36:"tests/upgrade/update.aggregator.test";i:47;s:33:"tests/upgrade/update.trigger.test";i:48;s:31:"tests/upgrade/update.field.test";i:49;s:30:"tests/upgrade/update.user.test";}s:9:"configure";s:41:"admin/config/development/testing/settings";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/simpletest/tests/actions_loop_test.module','actions_loop_test','module','','0','0','-1','0','a:13:{s:4:"name";s:17:"Actions loop test";s:11:"description";s:39:"Support module for action loop testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/ajax_forms_test.module','ajax_forms_test','module','','0','0','-1','0','a:13:{s:4:"name";s:26:"AJAX form test mock module";s:11:"description";s:25:"Test for AJAX form calls.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/ajax_test.module','ajax_test','module','','0','0','-1','0','a:13:{s:4:"name";s:9:"AJAX Test";s:11:"description";s:40:"Support module for AJAX framework tests.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/batch_test.module','batch_test','module','','0','0','-1','0','a:13:{s:4:"name";s:14:"Batch API test";s:11:"description";s:35:"Support module for Batch API tests.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/boot_test_1.module','boot_test_1','module','','0','0','-1','0','a:13:{s:4:"name";s:21:"Early bootstrap tests";s:11:"description";s:39:"A support module for hook_boot testing.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/simpletest/tests/boot_test_2.module','boot_test_2','module','','0','0','-1','0','a:13:{s:4:"name";s:21:"Early bootstrap tests";s:11:"description";s:44:"A support module for hook_boot hook testing.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/common_test.module','common_test','module','','0','0','-1','0','a:14:{s:4:"name";s:11:"Common Test";s:11:"description";s:32:"Support module for Common tests.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:2:{s:3:"all";a:1:{s:15:"common_test.css";s:40:"modules/simpletest/tests/common_test.css";}s:5:"print";a:1:{s:21:"common_test.print.css";s:46:"modules/simpletest/tests/common_test.print.css";}}s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/common_test_cron_helper.module','common_test_cron_helper','module','','0','0','-1','0','a:13:{s:4:"name";s:23:"Common Test Cron Helper";s:11:"description";s:56:"Helper module for CronRunTestCase::testCronExceptions().";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/database_test.module','database_test','module','','0','0','-1','0','a:13:{s:4:"name";s:13:"Database Test";s:11:"description";s:40:"Support module for Database layer tests.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/simpletest/tests/drupal_autoload_test/drupal_autoload_test.module','drupal_autoload_test','module','','0','0','-1','0','a:13:{s:4:"name";s:25:"Drupal code registry test";s:11:"description";s:45:"Support module for testing the code registry.";s:5:"files";a:2:{i:0;s:34:"drupal_autoload_test_interface.inc";i:1;s:30:"drupal_autoload_test_class.inc";}s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/drupal_system_listing_compatible_test/drupal_system_listing_compatible_test.module','drupal_system_listing_compatible_test','module','','0','0','-1','0','a:13:{s:4:"name";s:37:"Drupal system listing compatible test";s:11:"description";s:62:"Support module for testing the drupal_system_listing function.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/drupal_system_listing_incompatible_test/drupal_system_listing_incompatible_test.module','drupal_system_listing_incompatible_test','module','','0','0','-1','0','a:13:{s:4:"name";s:39:"Drupal system listing incompatible test";s:11:"description";s:62:"Support module for testing the drupal_system_listing function.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/entity_cache_test.module','entity_cache_test','module','','0','0','-1','0','a:13:{s:4:"name";s:17:"Entity cache test";s:11:"description";s:40:"Support module for testing entity cache.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:28:"entity_cache_test_dependency";}s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/simpletest/tests/entity_cache_test_dependency.module','entity_cache_test_dependency','module','','0','0','-1','0','a:13:{s:4:"name";s:28:"Entity cache test dependency";s:11:"description";s:51:"Support dependency module for testing entity cache.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/entity_crud_hook_test.module','entity_crud_hook_test','module','','0','0','-1','0','a:13:{s:4:"name";s:22:"Entity CRUD Hooks Test";s:11:"description";s:35:"Support module for CRUD hook tests.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/entity_query_access_test.module','entity_query_access_test','module','','0','0','-1','0','a:13:{s:4:"name";s:24:"Entity query access test";s:11:"description";s:49:"Support module for checking entity query results.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/error_test.module','error_test','module','','0','0','-1','0','a:13:{s:4:"name";s:10:"Error test";s:11:"description";s:47:"Support module for error and exception testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/file_test.module','file_test','module','','0','0','-1','0','a:13:{s:4:"name";s:9:"File test";s:11:"description";s:39:"Support module for file handling tests.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:16:"file_test.module";}s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/simpletest/tests/filter_test.module','filter_test','module','','0','0','-1','0','a:13:{s:4:"name";s:18:"Filter test module";s:11:"description";s:33:"Tests filter hooks and functions.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/form_test.module','form_test','module','','0','0','-1','0','a:13:{s:4:"name";s:12:"FormAPI Test";s:11:"description";s:34:"Support module for Form API tests.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/image_test.module','image_test','module','','0','0','-1','0','a:13:{s:4:"name";s:10:"Image test";s:11:"description";s:39:"Support module for image toolkit tests.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/menu_test.module','menu_test','module','','0','0','-1','0','a:13:{s:4:"name";s:15:"Hook menu tests";s:11:"description";s:37:"Support module for menu hook testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/module_test.module','module_test','module','','0','0','-1','0','a:13:{s:4:"name";s:11:"Module test";s:11:"description";s:41:"Support module for module system testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/simpletest/tests/path_test.module','path_test','module','','0','0','-1','0','a:13:{s:4:"name";s:15:"Hook path tests";s:11:"description";s:37:"Support module for path hook testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/psr_0_test/psr_0_test.module','psr_0_test','module','','0','0','-1','0','a:13:{s:4:"name";s:16:"PSR-0 Test cases";s:11:"description";s:44:"Test classes to be discovered by simpletest.";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/psr_4_test/psr_4_test.module','psr_4_test','module','','0','0','-1','0','a:13:{s:4:"name";s:16:"PSR-4 Test cases";s:11:"description";s:44:"Test classes to be discovered by simpletest.";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/requirements1_test.module','requirements1_test','module','','0','0','-1','0','a:13:{s:4:"name";s:19:"Requirements 1 Test";s:11:"description";s:80:"Tests that a module is not installed when it fails hook_requirements(''install'').";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/requirements2_test.module','requirements2_test','module','','0','0','-1','0','a:13:{s:4:"name";s:19:"Requirements 2 Test";s:11:"description";s:98:"Tests that a module is not installed when the one it depends on fails hook_requirements(''install).";s:12:"dependencies";a:2:{i:0;s:18:"requirements1_test";i:1;s:7:"comment";}s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/simpletest/tests/session_test.module','session_test','module','','0','0','-1','0','a:13:{s:4:"name";s:12:"Session test";s:11:"description";s:40:"Support module for session data testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/system_dependencies_test.module','system_dependencies_test','module','','0','0','-1','0','a:13:{s:4:"name";s:22:"System dependency test";s:11:"description";s:47:"Support module for testing system dependencies.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:19:"_missing_dependency";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/system_incompatible_core_version_dependencies_test.module','system_incompatible_core_version_dependencies_test','module','','0','0','-1','0','a:13:{s:4:"name";s:50:"System incompatible core version dependencies test";s:11:"description";s:47:"Support module for testing system dependencies.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:37:"system_incompatible_core_version_test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/system_incompatible_core_version_test.module','system_incompatible_core_version_test','module','','0','0','-1','0','a:13:{s:4:"name";s:37:"System incompatible core version test";s:11:"description";s:47:"Support module for testing system dependencies.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"5.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/simpletest/tests/system_incompatible_module_version_dependencies_test.module','system_incompatible_module_version_dependencies_test','module','','0','0','-1','0','a:13:{s:4:"name";s:52:"System incompatible module version dependencies test";s:11:"description";s:47:"Support module for testing system dependencies.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:46:"system_incompatible_module_version_test (>2.0)";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/system_incompatible_module_version_test.module','system_incompatible_module_version_test','module','','0','0','-1','0','a:13:{s:4:"name";s:39:"System incompatible module version test";s:11:"description";s:47:"Support module for testing system dependencies.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/system_project_namespace_test.module','system_project_namespace_test','module','','0','0','-1','0','a:13:{s:4:"name";s:29:"System project namespace test";s:11:"description";s:58:"Support module for testing project namespace dependencies.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:13:"drupal:filter";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/system_test.module','system_test','module','','0','0','-1','0','a:13:{s:4:"name";s:11:"System test";s:11:"description";s:34:"Support module for system testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:18:"system_test.module";}s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/simpletest/tests/taxonomy_test.module','taxonomy_test','module','','0','0','-1','0','a:13:{s:4:"name";s:20:"Taxonomy test module";s:11:"description";s:45:""Tests functions and hooks not used in core".";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:8:"taxonomy";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/theme_test.module','theme_test','module','','0','0','-1','0','a:13:{s:4:"name";s:10:"Theme test";s:11:"description";s:40:"Support module for theme system testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/update_script_test.module','update_script_test','module','','0','0','-1','0','a:13:{s:4:"name";s:18:"Update script test";s:11:"description";s:41:"Support module for update script testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/update_test_1.module','update_test_1','module','','0','0','-1','0','a:13:{s:4:"name";s:11:"Update test";s:11:"description";s:34:"Support module for update testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/update_test_2.module','update_test_2','module','','0','0','-1','0','a:13:{s:4:"name";s:11:"Update test";s:11:"description";s:34:"Support module for update testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/simpletest/tests/update_test_3.module','update_test_3','module','','0','0','-1','0','a:13:{s:4:"name";s:11:"Update test";s:11:"description";s:34:"Support module for update testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/url_alter_test.module','url_alter_test','module','','0','0','-1','0','a:13:{s:4:"name";s:15:"Url_alter tests";s:11:"description";s:45:"A support modules for url_alter hook testing.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/simpletest/tests/xmlrpc_test.module','xmlrpc_test','module','','0','0','-1','0','a:13:{s:4:"name";s:12:"XML-RPC Test";s:11:"description";s:75:"Support module for XML-RPC tests according to the validator1 specification.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/statistics/statistics.module','statistics','module','','1','1','7000','0','a:13:{s:4:"name";s:10:"Statistics";s:11:"description";s:37:"Logs access statistics for your site.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:15:"statistics.test";}s:9:"configure";s:30:"admin/config/system/statistics";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/syslog/syslog.module','syslog','module','','0','0','-1','0','a:13:{s:4:"name";s:6:"Syslog";s:11:"description";s:41:"Logs and records system events to syslog.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:11:"syslog.test";}s:9:"configure";s:32:"admin/config/development/logging";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/system/system.module','system','module','','1','1','7081','0','a:14:{s:4:"name";s:6:"System";s:11:"description";s:54:"Handles general site configuration for administrators.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:6:{i:0;s:19:"system.archiver.inc";i:1;s:15:"system.mail.inc";i:2;s:16:"system.queue.inc";i:3;s:14:"system.tar.inc";i:4;s:18:"system.updater.inc";i:5;s:11:"system.test";}s:8:"required";b:1;s:9:"configure";s:19:"admin/config/system";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/system/tests/cron_queue_test.module','cron_queue_test','module','','0','0','-1','0','a:13:{s:4:"name";s:15:"Cron Queue test";s:11:"description";s:41:"Support module for the cron queue runner.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/system/tests/system_cron_test.module','system_cron_test','module','','0','0','-1','0','a:13:{s:4:"name";s:16:"System Cron Test";s:11:"description";s:45:"Support module for testing the system_cron().";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/taxonomy/taxonomy.module','taxonomy','module','','1','0','7011','0','a:15:{s:4:"name";s:8:"Taxonomy";s:11:"description";s:38:"Enables the categorization of content.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:7:"options";}s:5:"files";a:2:{i:0;s:15:"taxonomy.module";i:1;s:13:"taxonomy.test";}s:9:"configure";s:24:"admin/structure/taxonomy";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}');
INSERT INTO `system` VALUES ('modules/toolbar/toolbar.module','toolbar','module','','0','0','0','0','a:12:{s:4:"name";s:7:"Toolbar";s:11:"description";s:99:"Provides a toolbar that shows the top-level administration menu items and links from other modules.";s:4:"core";s:3:"7.x";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/tracker/tracker.module','tracker','module','','0','0','-1','0','a:12:{s:4:"name";s:7:"Tracker";s:11:"description";s:45:"Enables tracking of recent content for users.";s:12:"dependencies";a:1:{i:0;s:7:"comment";}s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:12:"tracker.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/translation/tests/translation_test.module','translation_test','module','','0','0','-1','0','a:13:{s:4:"name";s:24:"Content Translation Test";s:11:"description";s:49:"Support module for the content translation tests.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/translation/translation.module','translation','module','','0','0','-1','0','a:12:{s:4:"name";s:19:"Content translation";s:11:"description";s:57:"Allows content to be translated into different languages.";s:12:"dependencies";a:1:{i:0;s:6:"locale";}s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:16:"translation.test";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/trigger/tests/trigger_test.module','trigger_test','module','','0','0','-1','0','a:13:{s:4:"name";s:12:"Trigger Test";s:11:"description";s:33:"Support module for Trigger tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/trigger/trigger.module','trigger','module','','0','0','-1','0','a:13:{s:4:"name";s:7:"Trigger";s:11:"description";s:90:"Enables actions to be fired on certain system events, such as when new content is created.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:12:"trigger.test";}s:9:"configure";s:23:"admin/structure/trigger";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/update/tests/aaa_update_test.module','aaa_update_test','module','','0','0','-1','0','a:13:{s:4:"name";s:15:"AAA Update test";s:11:"description";s:41:"Support module for update module testing.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/update/tests/bbb_update_test.module','bbb_update_test','module','','0','0','-1','0','a:13:{s:4:"name";s:15:"BBB Update test";s:11:"description";s:41:"Support module for update module testing.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/update/tests/ccc_update_test.module','ccc_update_test','module','','0','0','-1','0','a:13:{s:4:"name";s:15:"CCC Update test";s:11:"description";s:41:"Support module for update module testing.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:4:"7.54";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/update/tests/update_test.module','update_test','module','','0','0','-1','0','a:13:{s:4:"name";s:11:"Update test";s:11:"description";s:41:"Support module for update module testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('modules/update/update.module','update','module','','0','0','-1','0','a:13:{s:4:"name";s:14:"Update manager";s:11:"description";s:104:"Checks for available updates, and can securely install or update modules and themes via a web interface.";s:7:"version";s:4:"7.54";s:7:"package";s:4:"Core";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:11:"update.test";}s:9:"configure";s:30:"admin/reports/updates/settings";s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('modules/user/tests/user_form_test.module','user_form_test','module','','0','0','-1','0','a:13:{s:4:"name";s:22:"User module form tests";s:11:"description";s:37:"Support module for user form testing.";s:7:"package";s:7:"Testing";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('modules/user/user.module','user','module','','1','0','7019','0','a:15:{s:4:"name";s:4:"User";s:11:"description";s:47:"Manages the user registration and login system.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:11:"user.module";i:1;s:9:"user.test";}s:8:"required";b:1;s:9:"configure";s:19:"admin/config/people";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:8:"user.css";s:21:"modules/user/user.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('profiles/pantheon/pantheon.profile','pantheon','module','','1','0','0','1000','a:13:{s:4:"name";s:8:"Pantheon";s:11:"description";s:65:"Install with pre-configured integration for the Pantheon Platform";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:12:"dependencies";a:23:{i:0;s:5:"block";i:1;s:5:"color";i:2;s:7:"comment";i:3;s:10:"contextual";i:4;s:9:"dashboard";i:5;s:4:"help";i:6;s:5:"image";i:7;s:4:"list";i:8;s:4:"menu";i:9;s:6:"number";i:10;s:7:"options";i:11;s:4:"path";i:12;s:8:"taxonomy";i:13;s:5:"dblog";i:14;s:6:"search";i:15;s:8:"shortcut";i:16;s:7:"toolbar";i:17;s:7:"overlay";i:18;s:8:"field_ui";i:19;s:4:"file";i:20;s:3:"rdf";i:21;s:12:"pantheon_api";i:22;s:14:"pantheon_login";}s:5:"files";a:1:{i:0;s:16:"pantheon.profile";}s:5:"mtime";i:1490935291;s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:6:"hidden";b:1;s:8:"required";b:1;s:17:"distribution_name";s:6:"Drupal";}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/addressfield/addressfield.module','addressfield','module','','1','0','7001','0','a:14:{s:4:"name";s:13:"Address Field";s:11:"description";s:64:"Manage a flexible address field, implementing the xNAL standard.";s:4:"core";s:3:"7.x";s:7:"package";s:6:"Fields";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:5:"files";a:4:{i:0;s:24:"addressfield.migrate.inc";i:1;s:62:"views/addressfield_views_handler_field_administrative_area.inc";i:2;s:50:"views/addressfield_views_handler_field_country.inc";i:3;s:51:"views/addressfield_views_handler_filter_country.inc";}s:7:"version";s:7:"7.x-1.2";s:7:"project";s:12:"addressfield";s:9:"datestamp";s:10:"1444254070";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}'),('sites/all/modules/contrib/addressfield/example/addressfield_example.module','addressfield_example','module','','0','0','-1','0','a:13:{s:4:"name";s:21:"Address Field Example";s:11:"description";s:67:"Example module for how to implement an addressfield format handler.";s:4:"core";s:3:"7.x";s:7:"package";s:6:"Fields";s:6:"hidden";b:1;s:12:"dependencies";a:2:{i:0;s:6:"ctools";i:1;s:12:"addressfield";}s:7:"version";s:7:"7.x-1.2";s:7:"project";s:12:"addressfield";s:9:"datestamp";s:10:"1444254070";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/admin_language/admin_language.module','admin_language','module','','0','0','-1','0','a:13:{s:4:"name";s:23:"Administration language";s:11:"description";s:97:"Makes sure all administration pages are displayed in the preferred language of the administrator.";s:12:"dependencies";a:1:{i:0;s:6:"locale";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:9:"configure";s:45:"admin/config/regional/language/admin_language";s:7:"version";s:13:"7.x-1.0-beta4";s:7:"project";s:14:"admin_language";s:9:"datestamp";s:10:"1473428686";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/admin_menu/admin_devel/admin_devel.module','admin_devel','module','','0','0','-1','0','a:13:{s:4:"name";s:32:"Administration Development tools";s:11:"description";s:76:"Administration and debugging functionality for developers and site builders.";s:7:"package";s:14:"Administration";s:4:"core";s:3:"7.x";s:7:"scripts";a:1:{s:14:"admin_devel.js";s:63:"sites/all/modules/contrib/admin_menu/admin_devel/admin_devel.js";}s:7:"version";s:11:"7.x-3.0-rc5";s:7:"project";s:10:"admin_menu";s:9:"datestamp";s:10:"1419029284";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/admin_menu/admin_menu.module','admin_menu','module','','1','0','7304','100','a:13:{s:4:"name";s:19:"Administration menu";s:11:"description";s:123:"Provides a dropdown menu to most administrative tasks and other common destinations (to users with the proper permissions).";s:7:"package";s:14:"Administration";s:4:"core";s:3:"7.x";s:9:"configure";s:38:"admin/config/administration/admin_menu";s:12:"dependencies";a:1:{i:0;s:14:"system (>7.10)";}s:5:"files";a:1:{i:0;s:21:"tests/admin_menu.test";}s:7:"version";s:11:"7.x-3.0-rc5";s:7:"project";s:10:"admin_menu";s:9:"datestamp";s:10:"1419029284";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/admin_menu/admin_menu_toolbar/admin_menu_toolbar.module','admin_menu_toolbar','module','','0','0','-1','0','a:12:{s:4:"name";s:33:"Administration menu Toolbar style";s:11:"description";s:17:"A better Toolbar.";s:7:"package";s:14:"Administration";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:10:"admin_menu";}s:7:"version";s:11:"7.x-3.0-rc5";s:7:"project";s:10:"admin_menu";s:9:"datestamp";s:10:"1419029284";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/admin_views/admin_views.module','admin_views','module','','1','0','0','12','a:12:{s:4:"name";s:20:"Administration views";s:11:"description";s:75:"Replaces all system object management pages in Drupal core with real views.";s:7:"package";s:14:"Administration";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:5:"views";i:1;s:33:"views_bulk_operations (>=7.x-3.2)";}s:5:"files";a:3:{i:0;s:39:"plugins/views_plugin_display_system.inc";i:1;s:36:"plugins/views_plugin_access_menu.inc";i:2;s:22:"tests/admin_views.test";}s:7:"version";s:7:"7.x-1.6";s:7:"project";s:11:"admin_views";s:9:"datestamp";s:10:"1470165840";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/admin_views/tests/admin_views_test/admin_views_test.module','admin_views_test','module','','0','0','-1','0','a:13:{s:4:"name";s:25:"Administration views test";s:11:"description";s:32:"Administration views test module";s:4:"core";s:3:"7.x";s:7:"package";s:14:"administration";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-1.6";s:7:"project";s:11:"admin_views";s:9:"datestamp";s:10:"1470165840";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/advanced_help/advanced_help.module','advanced_help','module','','1','0','0','0','a:13:{s:4:"name";s:13:"Advanced help";s:11:"description";s:40:"Provide extended help and documentation.";s:4:"core";s:3:"7.x";s:12:"attributions";a:1:{s:10:"click_icon";a:7:{s:4:"type";s:5:"asset";s:9:"exception";s:8:"#2460769";s:6:"author";s:14:"Gisle Hannemyr";s:4:"hide";b:1;s:5:"title";s:14:"click_icon.png";s:7:"license";s:18:"Creative Commons 0";s:11:"license_url";s:50:"https://creativecommons.org/publicdomain/zero/1.0/";}}s:7:"version";s:7:"7.x-1.3";s:7:"project";s:13:"advanced_help";s:9:"datestamp";s:10:"1432557782";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/advanced_help/help_example/help_example.module','help_example','module','','0','0','-1','0','a:13:{s:4:"name";s:21:"Advanced help example";s:11:"description";s:62:"A example help module to demonstrate the advanced help module.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:13:"advanced_help";}s:12:"attributions";a:3:{s:18:"wikipedia_adaption";a:11:{s:4:"type";s:5:"asset";s:6:"weight";s:3:"-10";s:9:"exception";s:8:"#2460769";s:5:"title";s:68:"About PHP, History of PHP, Usage of PHP, PHP Syntax, Security of PHP";s:11:"license_url";s:46:"http://creativecommons.org/licenses/by-sa/3.0/";s:9:"org_title";s:15:"PHP (Wikipedia)";s:10:"org_author";s:31:"multiple Wikipedia contributors";s:14:"org_author_url";s:60:"http://en.wikipedia.org/w/index.php?title=PHP&action=history";s:12:"org_work_url";s:32:"http://en.wikipedia.org/wiki/PHP";s:11:"org_license";s:26:"Creative Commons BY-SA 3.0";s:15:"org_license_url";s:107:"http://en.wikipedia.org/wiki/Wikipedia:Text_of_Creative_Commons_Attribution-ShareAlike_3.0_Unported_License";}s:7:"lerdorf";a:7:{s:4:"type";s:5:"asset";s:9:"exception";s:8:"#2460769";s:6:"author";s:11:"Jud Dagnall";s:8:"work_url";s:45:"http://en.wikipedia.org/wiki/File:Lerdorf.jpg";s:5:"title";s:7:"Lerdorf";s:7:"license";s:26:"Creative Commons BY-SA 3.0";s:11:"license_url";s:53:"http://creativecommons.org/licenses/by-sa/3.0/deed.en";}s:7:"gutmans";a:8:{s:4:"type";s:5:"asset";s:9:"exception";s:8:"#2460769";s:6:"author";s:12:"Jim Winstead";s:10:"author_url";s:42:"https://www.flickr.com/people/81342178@N00";s:8:"work_url";s:52:"http://en.wikipedia.org/wiki/File:Andi_Gutmans_1.jpg";s:5:"title";s:12:"Andi Gutmans";s:7:"license";s:23:"Creative Commons BY 2.0";s:11:"license_url";s:50:"http://creativecommons.org/licenses/by/2.0/deed.en";}}s:7:"version";s:7:"7.x-1.3";s:7:"project";s:13:"advanced_help";s:9:"datestamp";s:10:"1432557782";s:5:"mtime";i:1490935291;s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/backup_migrate/backup_migrate.module','backup_migrate','module','','1','0','7304','0','a:13:{s:4:"name";s:18:"Backup and Migrate";s:11:"description";s:76:"Backup the Drupal database and files or migrate them to another environment.";s:4:"core";s:3:"7.x";s:5:"files";a:3:{i:0;s:25:"includes/destinations.inc";i:1;s:21:"includes/profiles.inc";i:2;s:22:"includes/schedules.inc";}s:9:"configure";s:34:"admin/config/system/backup_migrate";s:7:"version";s:7:"7.x-3.1";s:7:"project";s:14:"backup_migrate";s:9:"datestamp";s:10:"1431350582";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/block_access/block_access.module','block_access','module','','1','0','0','0','a:12:{s:4:"name";s:12:"Block Access";s:11:"description";s:54:"Provides flexible block administration access control.";s:7:"package";s:14:"Access control";s:4:"core";s:3:"7.x";s:5:"files";a:15:{i:0;s:20:"block_access.install";i:1;s:19:"block_access.module";i:2;s:22:"block_access.admin.inc";i:3;s:19:"block_access.db.inc";i:4;s:22:"block_access.theme.inc";i:5;s:17:"tests/common.test";i:6;s:13:"tests/ui.test";i:7;s:24:"tests/op_basic_view.test";i:8;s:24:"tests/op_basic_move.test";i:9;s:26:"tests/op_basic_enable.test";i:10;s:27:"tests/op_basic_disable.test";i:11;s:26:"tests/op_basic_config.test";i:12;s:26:"tests/op_basic_delete.test";i:13;s:20:"tests/op_config.test";i:14;s:20:"tests/op_region.test";}s:7:"version";s:7:"7.x-1.6";s:7:"project";s:12:"block_access";s:9:"datestamp";s:10:"1425477100";s:5:"mtime";i:1425477100;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/block_class/block_class.module','block_class','module','','1','0','7103','0','a:13:{s:4:"name";s:11:"Block Class";s:11:"description";s:39:"Allows assigning CSS classes to blocks.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"block";}s:5:"files";a:1:{i:0;s:16:"block_class.test";}s:17:"test_dependencies";a:3:{i:0;s:7:"context";i:1;s:14:"features (2.x)";i:2;s:14:"features_extra";}s:7:"version";s:7:"7.x-2.3";s:7:"project";s:11:"block_class";s:9:"datestamp";s:10:"1450415951";s:5:"mtime";i:1490935291;s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/block_class/tests/block_class_fe_block_test.module','block_class_fe_block_test','module','','0','0','-1','0','a:14:{s:4:"name";s:44:"Block Class FE Block Integration Test Helper";s:11:"description";s:99:"Helper module for testing the integration of Block Class with Features through the FE Block module.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Features";s:12:"dependencies";a:1:{i:0;s:8:"fe_block";}s:8:"features";a:2:{s:17:"fe_block_settings";a:1:{i:0;s:11:"user-online";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}}s:6:"hidden";b:1;s:7:"version";s:7:"7.x-2.3";s:7:"project";s:11:"block_class";s:9:"datestamp";s:10:"1450415951";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/calendar/calendar.module','calendar','module','','1','0','7002','0','a:13:{s:4:"name";s:8:"Calendar";s:11:"description";s:60:"Views plugin to display views containing dates as Calendars.";s:12:"dependencies";a:3:{i:0;s:5:"views";i:1;s:8:"date_api";i:2;s:10:"date_views";}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:25:"css/calendar_multiday.css";s:60:"sites/all/modules/contrib/calendar/css/calendar_multiday.css";}}s:5:"files";a:8:{i:0;s:16:"calendar.install";i:1;s:15:"calendar.module";i:2;s:27:"includes/calendar.views.inc";i:3;s:34:"includes/calendar_plugin_style.inc";i:4;s:32:"includes/calendar_plugin_row.inc";i:5;s:36:"includes/calendar.views_template.inc";i:6;s:15:"theme/theme.inc";i:7;s:28:"theme/calendar-style.tpl.php";}s:7:"version";s:7:"7.x-3.5";s:7:"project";s:8:"calendar";s:9:"datestamp";s:10:"1413299943";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/content_access/content_access.module','content_access','module','','1','0','7101','0','a:12:{s:4:"name";s:14:"Content Access";s:11:"description";s:41:"Provides flexible content access control.";s:4:"core";s:3:"7.x";s:7:"package";s:14:"Access control";s:5:"files";a:3:{i:0;s:24:"content_access.rules.inc";i:1;s:25:"tests/content_access.test";i:2;s:29:"tests/content_access_acl.test";}s:7:"version";s:19:"7.x-1.2-BETA2+0-dev";s:7:"project";s:14:"content_access";s:9:"datestamp";s:10:"1380566961";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/content_access/content_access_rules/content_access_rules.module','content_access_rules','module','','0','0','-1','0','a:12:{s:4:"name";s:33:"Content Access Rules Integrations";s:11:"description";s:94:"Integrates Rules with Content access. Allows to act on access events, conditions, and actions.";s:7:"package";s:14:"Access control";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:14:"content_access";i:1;s:5:"rules";}s:5:"files";a:1:{i:0;s:24:"content_access.rules.inc";}s:7:"version";s:19:"7.x-1.2-BETA2+0-dev";s:7:"project";s:14:"content_access";s:9:"datestamp";s:10:"1380566961";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/ctools/bulk_export/bulk_export.module','bulk_export','module','','0','0','-1','0','a:12:{s:4:"name";s:11:"Bulk Export";s:11:"description";s:67:"Performs bulk exporting of data objects known about by Chaos tools.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/ctools/ctools.module','ctools','module','','1','0','7001','0','a:12:{s:4:"name";s:11:"Chaos tools";s:11:"description";s:46:"A library of helpful tools by Merlin of Chaos.";s:4:"core";s:3:"7.x";s:7:"package";s:16:"Chaos tool suite";s:5:"files";a:5:{i:0;s:20:"includes/context.inc";i:1;s:22:"includes/css-cache.inc";i:2;s:22:"includes/math-expr.inc";i:3;s:21:"includes/stylizer.inc";i:4;s:20:"tests/css_cache.test";}s:7:"version";s:8:"7.x-1.11";s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/ctools/ctools_access_ruleset/ctools_access_ruleset.module','ctools_access_ruleset','module','','0','0','-1','0','a:12:{s:4:"name";s:15:"Custom rulesets";s:11:"description";s:81:"Create custom, exportable, reusable access rulesets for applications like Panels.";s:4:"core";s:3:"7.x";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/ctools/ctools_ajax_sample/ctools_ajax_sample.module','ctools_ajax_sample','module','','0','0','-1','0','a:12:{s:4:"name";s:33:"Chaos Tools (CTools) AJAX Example";s:11:"description";s:41:"Shows how to use the power of Chaos AJAX.";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:4:"core";s:3:"7.x";s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/ctools/ctools_custom_content/ctools_custom_content.module','ctools_custom_content','module','','0','0','-1','0','a:12:{s:4:"name";s:20:"Custom content panes";s:11:"description";s:79:"Create custom, exportable, reusable content panes for applications like Panels.";s:4:"core";s:3:"7.x";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/ctools/ctools_plugin_example/ctools_plugin_example.module','ctools_plugin_example','module','','0','0','-1','0','a:12:{s:4:"name";s:35:"Chaos Tools (CTools) Plugin Example";s:11:"description";s:75:"Shows how an external module can provide ctools plugins (for Panels, etc.).";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:12:"dependencies";a:4:{i:0;s:6:"ctools";i:1;s:6:"panels";i:2;s:12:"page_manager";i:3;s:13:"advanced_help";}s:4:"core";s:3:"7.x";s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/ctools/page_manager/page_manager.module','page_manager','module','','1','0','0','99','a:12:{s:4:"name";s:12:"Page manager";s:11:"description";s:54:"Provides a UI and API to manage pages within the site.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/ctools/stylizer/stylizer.module','stylizer','module','','0','0','-1','0','a:12:{s:4:"name";s:8:"Stylizer";s:11:"description";s:53:"Create custom styles for applications such as Panels.";s:4:"core";s:3:"7.x";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:12:"dependencies";a:2:{i:0;s:6:"ctools";i:1;s:5:"color";}s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/ctools/term_depth/term_depth.module','term_depth','module','','0','0','-1','0','a:12:{s:4:"name";s:17:"Term Depth access";s:11:"description";s:48:"Controls access to context based upon term depth";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/ctools/tests/ctools_export_test/ctools_export_test.module','ctools_export_test','module','','0','0','-1','0','a:13:{s:4:"name";s:18:"CTools export test";s:11:"description";s:25:"CTools export test module";s:4:"core";s:3:"7.x";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:6:"hidden";b:1;s:5:"files";a:1:{i:0;s:18:"ctools_export.test";}s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/ctools/tests/ctools_plugin_test.module','ctools_plugin_test','module','','0','0','-1','0','a:13:{s:4:"name";s:24:"Chaos tools plugins test";s:11:"description";s:42:"Provides hooks for testing ctools plugins.";s:7:"package";s:16:"Chaos tool suite";s:7:"version";s:8:"7.x-1.11";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:5:"files";a:6:{i:0;s:19:"ctools.plugins.test";i:1;s:17:"object_cache.test";i:2;s:8:"css.test";i:3;s:12:"context.test";i:4;s:20:"math_expression.test";i:5;s:26:"math_expression_stack.test";}s:6:"hidden";b:1;s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/ctools/views_content/views_content.module','views_content','module','','1','0','0','0','a:12:{s:4:"name";s:19:"Views content panes";s:11:"description";s:104:"Allows Views content to be used in Panels, Dashboard and other modules which use the CTools Content API.";s:7:"package";s:16:"Chaos tool suite";s:12:"dependencies";a:2:{i:0;s:6:"ctools";i:1;s:5:"views";}s:4:"core";s:3:"7.x";s:7:"version";s:8:"7.x-1.11";s:5:"files";a:3:{i:0;s:61:"plugins/views/views_content_plugin_display_ctools_context.inc";i:1;s:57:"plugins/views/views_content_plugin_display_panel_pane.inc";i:2;s:59:"plugins/views/views_content_plugin_style_ctools_context.inc";}s:7:"project";s:6:"ctools";s:9:"datestamp";s:10:"1476581654";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/date/date.module','date','module','','1','0','7004','0','a:14:{s:4:"name";s:4:"Date";s:11:"description";s:33:"Makes date/time fields available.";s:12:"dependencies";a:1:{i:0;s:8:"date_api";}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:3:"php";s:3:"5.2";s:5:"files";a:9:{i:0;s:16:"date.migrate.inc";i:1;s:19:"tests/date_api.test";i:2;s:15:"tests/date.test";i:3;s:21:"tests/date_field.test";i:4;s:23:"tests/date_migrate.test";i:5;s:26:"tests/date_validation.test";i:6;s:24:"tests/date_timezone.test";i:7;s:27:"tests/date_views_pager.test";i:8;s:27:"tests/date_views_popup.test";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:5:"mtime";i:1490935291;s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}'),('sites/all/modules/contrib/date/date_all_day/date_all_day.module','date_all_day','module','','1','0','0','0','a:12:{s:4:"name";s:12:"Date All Day";s:11:"description";s:142:"Adds ''All Day'' functionality to date fields, including an ''All Day'' theme and ''All Day'' checkboxes for the Date select and Date popup widgets.";s:12:"dependencies";a:2:{i:0;s:8:"date_api";i:1;s:4:"date";}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/date/date_api/date_api.module','date_api','module','','1','0','7001','0','a:13:{s:4:"name";s:8:"Date API";s:11:"description";s:45:"A Date API that can be used by other modules.";s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:3:"php";s:3:"5.2";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:8:"date.css";s:48:"sites/all/modules/contrib/date/date_api/date.css";}}s:5:"files";a:2:{i:0;s:15:"date_api.module";i:1;s:16:"date_api_sql.inc";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/date/date_context/date_context.module','date_context','module','','0','0','-1','0','a:12:{s:4:"name";s:12:"Date Context";s:11:"description";s:99:"Adds an option to the Context module to set a context condition based on the value of a date field.";s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:4:"date";i:1;s:7:"context";}s:5:"files";a:2:{i:0;s:19:"date_context.module";i:1;s:39:"plugins/date_context_date_condition.inc";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/date/date_migrate/date_migrate.module','date_migrate','module','','0','0','-1','0','a:13:{s:4:"name";s:14:"Date Migration";s:11:"description";s:73:"Obsolete data migration module. Disable if no other modules depend on it.";s:4:"core";s:3:"7.x";s:7:"package";s:9:"Date/Time";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/date/date_migrate/date_migrate_example/date_migrate_example.module','date_migrate_example','module','','0','0','-1','0','a:13:{s:4:"core";s:3:"7.x";s:12:"dependencies";a:5:{i:0;s:4:"date";i:1;s:11:"date_repeat";i:2;s:17:"date_repeat_field";i:3;s:8:"features";i:4;s:7:"migrate";}s:11:"description";s:42:"Examples of migrating with the Date module";s:8:"features";a:2:{s:5:"field";a:8:{i:0;s:30:"node-date_migrate_example-body";i:1;s:36:"node-date_migrate_example-field_date";i:2;s:42:"node-date_migrate_example-field_date_range";i:3;s:43:"node-date_migrate_example-field_date_repeat";i:4;s:41:"node-date_migrate_example-field_datestamp";i:5;s:47:"node-date_migrate_example-field_datestamp_range";i:6;s:40:"node-date_migrate_example-field_datetime";i:7;s:46:"node-date_migrate_example-field_datetime_range";}s:4:"node";a:1:{i:0;s:20:"date_migrate_example";}}s:5:"files";a:1:{i:0;s:32:"date_migrate_example.migrate.inc";}s:4:"name";s:22:"Date Migration Example";s:7:"package";s:8:"Features";s:7:"project";s:4:"date";s:7:"version";s:7:"7.x-2.9";s:9:"datestamp";s:10:"1441727353";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/date/date_popup/date_popup.module','date_popup','module','','1','0','0','0','a:14:{s:4:"name";s:10:"Date Popup";s:11:"description";s:84:"Enables jquery popup calendars and time entry widgets for selecting dates and times.";s:12:"dependencies";a:1:{i:0;s:8:"date_api";}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:9:"configure";s:28:"admin/config/date/date_popup";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:25:"themes/datepicker.1.7.css";s:67:"sites/all/modules/contrib/date/date_popup/themes/datepicker.1.7.css";}}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/date/date_repeat/date_repeat.module','date_repeat','module','','1','0','0','1','a:12:{s:4:"name";s:15:"Date Repeat API";s:11:"description";s:73:"A Date Repeat API to calculate repeating dates and times from iCal rules.";s:12:"dependencies";a:1:{i:0;s:8:"date_api";}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:3:"php";s:3:"5.2";s:5:"files";a:2:{i:0;s:22:"tests/date_repeat.test";i:1;s:27:"tests/date_repeat_form.test";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:5:"mtime";i:1490935291;s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/date/date_repeat_field/date_repeat_field.module','date_repeat_field','module','','1','0','0','0','a:13:{s:4:"name";s:17:"Date Repeat Field";s:11:"description";s:97:"Creates the option of Repeating date fields and manages Date fields that use the Date Repeat API.";s:12:"dependencies";a:3:{i:0;s:8:"date_api";i:1;s:4:"date";i:2;s:11:"date_repeat";}s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:21:"date_repeat_field.css";s:70:"sites/all/modules/contrib/date/date_repeat_field/date_repeat_field.css";}}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/date/date_tools/date_tools.module','date_tools','module','','1','0','0','0','a:13:{s:4:"name";s:10:"Date Tools";s:11:"description";s:52:"Tools to import and auto-create dates and calendars.";s:12:"dependencies";a:1:{i:0;s:4:"date";}s:7:"package";s:9:"Date/Time";s:4:"core";s:3:"7.x";s:9:"configure";s:23:"admin/config/date/tools";s:5:"files";a:1:{i:0;s:21:"tests/date_tools.test";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/date/date_views/date_views.module','date_views','module','','1','0','7200','0','a:12:{s:4:"name";s:10:"Date Views";s:11:"description";s:57:"Views integration for date fields and date functionality.";s:7:"package";s:9:"Date/Time";s:12:"dependencies";a:2:{i:0;s:8:"date_api";i:1;s:5:"views";}s:4:"core";s:3:"7.x";s:3:"php";s:3:"5.2";s:5:"files";a:6:{i:0;s:40:"includes/date_views_argument_handler.inc";i:1;s:47:"includes/date_views_argument_handler_simple.inc";i:2;s:38:"includes/date_views_filter_handler.inc";i:3;s:45:"includes/date_views_filter_handler_simple.inc";i:4;s:29:"includes/date_views.views.inc";i:5;s:36:"includes/date_views_plugin_pager.inc";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:4:"date";s:9:"datestamp";s:10:"1441727353";s:5:"mtime";i:1490935291;s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/devel/devel.module','devel','module','','1','1','7006','88','a:14:{s:4:"name";s:5:"Devel";s:11:"description";s:52:"Various blocks, pages, and functions for developers.";s:7:"package";s:11:"Development";s:4:"core";s:3:"7.x";s:9:"configure";s:30:"admin/config/development/devel";s:4:"tags";a:1:{i:0;s:9:"developer";}s:5:"files";a:2:{i:0;s:10:"devel.test";i:1;s:14:"devel.mail.inc";}s:7:"version";s:7:"7.x-1.5";s:7:"project";s:5:"devel";s:9:"datestamp";s:10:"1398963366";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/devel/devel_generate/devel_generate.module','devel_generate','module','','0','0','-1','0','a:14:{s:4:"name";s:14:"Devel generate";s:11:"description";s:48:"Generate dummy users, nodes, and taxonomy terms.";s:7:"package";s:11:"Development";s:4:"core";s:3:"7.x";s:4:"tags";a:1:{i:0;s:9:"developer";}s:9:"configure";s:33:"admin/config/development/generate";s:5:"files";a:1:{i:0;s:19:"devel_generate.test";}s:7:"version";s:7:"7.x-1.5";s:7:"project";s:5:"devel";s:9:"datestamp";s:10:"1398963366";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/devel/devel_node_access.module','devel_node_access','module','','0','0','-1','0','a:14:{s:4:"name";s:17:"Devel node access";s:11:"description";s:68:"Developer blocks and page illustrating relevant node_access records.";s:7:"package";s:11:"Development";s:12:"dependencies";a:1:{i:0;s:4:"menu";}s:4:"core";s:3:"7.x";s:9:"configure";s:30:"admin/config/development/devel";s:4:"tags";a:1:{i:0;s:9:"developer";}s:7:"version";s:7:"7.x-1.5";s:7:"project";s:5:"devel";s:9:"datestamp";s:10:"1398963366";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/eck/eck.module','eck','module','','1','0','7011','0','a:15:{s:4:"name";s:23:"Entity Construction Kit";s:11:"description";s:126:"ECK (Entity Construction Kit) Allows users to create and administer entity types, bundles, and entities from an easy to use UI";s:7:"package";s:3:"ECK";s:4:"core";s:3:"7.x";s:9:"configure";s:27:"admin/structure/entity-type";s:12:"dependencies";a:2:{i:0;s:6:"entity";i:1;s:6:"ctools";}s:5:"files";a:5:{i:0;s:47:"views/handlers/eck_views_handler_field_link.inc";i:1;s:52:"views/handlers/eck_views_handler_field_link_edit.inc";i:2;s:54:"views/handlers/eck_views_handler_field_link_delete.inc";i:3;s:36:"includes/translation.handler.eck.inc";i:4;s:35:"includes/eck.inline_entity_form.inc";}s:7:"version";s:11:"7.x-2.0-rc8";s:7:"project";s:3:"eck";s:9:"datestamp";s:10:"1448560416";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:60:"Entity types created by ECK are still present in the system.";}'),('sites/all/modules/contrib/eck/examples/eck_example.module','eck_example','module','','0','0','-1','0','a:12:{s:4:"name";s:11:"ECK Example";s:11:"description";s:67:"A module demonstrating the kind of things that ECK can do from code";s:7:"package";s:3:"ECK";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:3:"eck";}s:7:"version";s:11:"7.x-2.0-rc8";s:7:"project";s:3:"eck";s:9:"datestamp";s:10:"1448560416";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/eck/modules/eck_entitycache/eck_entitycache.module','eck_entitycache','module','','0','0','-1','0','a:12:{s:4:"name";s:17:"ECK - Entitycache";s:11:"description";s:53:"Integrates the ECK module with the Entitycache module";s:7:"package";s:27:"Performance and scalability";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:3:"eck";i:1;s:11:"entitycache";}s:7:"version";s:11:"7.x-2.0-rc8";s:7:"project";s:3:"eck";s:9:"datestamp";s:10:"1448560416";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/eck/modules/eck_services/eck_services.module','eck_services','module','','0','0','-1','0','a:12:{s:4:"name";s:12:"ECK Services";s:11:"description";s:25:"Service resources for ECK";s:4:"core";s:3:"7.x";s:7:"package";s:3:"ECK";s:12:"dependencies";a:2:{i:0;s:3:"eck";i:1;s:8:"services";}s:7:"version";s:11:"7.x-2.0-rc8";s:7:"project";s:3:"eck";s:9:"datestamp";s:10:"1448560416";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/entity/entity.module','entity','module','','1','0','7003','0','a:12:{s:4:"name";s:10:"Entity API";s:11:"description";s:69:"Enables modules to work with any entity type and to provide entities.";s:4:"core";s:3:"7.x";s:5:"files";a:24:{i:0;s:19:"entity.features.inc";i:1;s:15:"entity.i18n.inc";i:2;s:15:"entity.info.inc";i:3;s:16:"entity.rules.inc";i:4;s:11:"entity.test";i:5;s:19:"includes/entity.inc";i:6;s:30:"includes/entity.controller.inc";i:7;s:22:"includes/entity.ui.inc";i:8;s:27:"includes/entity.wrapper.inc";i:9;s:22:"views/entity.views.inc";i:10;s:52:"views/handlers/entity_views_field_handler_helper.inc";i:11;s:51:"views/handlers/entity_views_handler_area_entity.inc";i:12;s:53:"views/handlers/entity_views_handler_field_boolean.inc";i:13;s:50:"views/handlers/entity_views_handler_field_date.inc";i:14;s:54:"views/handlers/entity_views_handler_field_duration.inc";i:15;s:52:"views/handlers/entity_views_handler_field_entity.inc";i:16;s:51:"views/handlers/entity_views_handler_field_field.inc";i:17;s:53:"views/handlers/entity_views_handler_field_numeric.inc";i:18;s:53:"views/handlers/entity_views_handler_field_options.inc";i:19;s:50:"views/handlers/entity_views_handler_field_text.inc";i:20;s:49:"views/handlers/entity_views_handler_field_uri.inc";i:21;s:62:"views/handlers/entity_views_handler_relationship_by_bundle.inc";i:22;s:52:"views/handlers/entity_views_handler_relationship.inc";i:23;s:53:"views/plugins/entity_views_plugin_row_entity_view.inc";}s:7:"version";s:7:"7.x-1.8";s:7:"project";s:6:"entity";s:9:"datestamp";s:10:"1474546503";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/entity/entity_token.module','entity_token','module','','1','0','0','0','a:12:{s:4:"name";s:13:"Entity tokens";s:11:"description";s:99:"Provides token replacements for all properties that have no tokens and are known to the entity API.";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:23:"entity_token.tokens.inc";i:1;s:19:"entity_token.module";}s:12:"dependencies";a:1:{i:0;s:6:"entity";}s:7:"version";s:7:"7.x-1.8";s:7:"project";s:6:"entity";s:9:"datestamp";s:10:"1474546503";s:5:"mtime";i:1490935291;s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/entity/tests/entity_feature.module','entity_feature','module','','0','0','-1','0','a:13:{s:4:"name";s:21:"Entity feature module";s:11:"description";s:31:"Provides some entities in code.";s:7:"version";s:7:"7.x-1.8";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:21:"entity_feature.module";}s:12:"dependencies";a:1:{i:0;s:11:"entity_test";}s:6:"hidden";b:1;s:7:"project";s:6:"entity";s:9:"datestamp";s:10:"1474546503";s:5:"mtime";i:1490935291;s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/entity/tests/entity_test.module','entity_test','module','','0','0','-1','0','a:13:{s:4:"name";s:23:"Entity CRUD test module";s:11:"description";s:46:"Provides entity types based upon the CRUD API.";s:7:"version";s:7:"7.x-1.8";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:18:"entity_test.module";i:1;s:19:"entity_test.install";}s:12:"dependencies";a:1:{i:0;s:6:"entity";}s:6:"hidden";b:1;s:7:"project";s:6:"entity";s:9:"datestamp";s:10:"1474546503";s:5:"mtime";i:1490935291;s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/entity/tests/entity_test_i18n.module','entity_test_i18n','module','','0','0','-1','0','a:13:{s:4:"name";s:28:"Entity-test type translation";s:11:"description";s:37:"Allows translating entity-test types.";s:12:"dependencies";a:2:{i:0;s:11:"entity_test";i:1;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-1.8";s:7:"project";s:6:"entity";s:9:"datestamp";s:10:"1474546503";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/entityform/entityform.module','entityform','module','','1','0','7005','0','a:13:{s:4:"name";s:11:"Entityforms";s:11:"description";s:31:"Provides fieldable entity forms";s:4:"core";s:3:"7.x";s:7:"package";s:11:"Entityforms";s:9:"configure";s:32:"admin/structure/entityform_types";s:12:"dependencies";a:2:{i:0;s:6:"entity";i:1;s:5:"views";}s:5:"files";a:12:{i:0;s:20:"entityform.admin.inc";i:1;s:19:"entityform.info.inc";i:2;s:25:"entityform_type.admin.inc";i:3;s:26:"entityform.pages.admin.inc";i:4;s:26:"views/entityform.views.inc";i:5;s:39:"views/entityform_handler_link_field.inc";i:6;s:46:"views/entityform_handler_delete_link_field.inc";i:7;s:44:"views/entityform_handler_edit_link_field.inc";i:8;s:56:"views/entityform_handler_entityform_operations_field.inc";i:9;s:34:"views/entityform.views_default.inc";i:10;s:51:"views/entityform_type_handler_submit_link_field.inc";i:11;s:15:"entityform.test";}s:7:"version";s:11:"7.x-2.0-rc1";s:7:"project";s:10:"entityform";s:9:"datestamp";s:10:"1413913852";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/entityform/entityform_anonymous/entityform_anonymous.module','entityform_anonymous','module','','0','0','-1','0','a:12:{s:4:"name";s:20:"Entityform Anonymous";s:11:"description";s:51:"Allows tracking of anonymous Entityform submissions";s:4:"core";s:3:"7.x";s:7:"package";s:11:"Entityforms";s:12:"dependencies";a:2:{i:0;s:11:"session_api";i:1;s:10:"entityform";}s:7:"version";s:11:"7.x-2.0-rc1";s:7:"project";s:10:"entityform";s:9:"datestamp";s:10:"1413913852";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/entityform/entityform_notifications/entityform_notifications.module','entityform_notifications','module','','0','0','-1','0','a:12:{s:4:"name";s:25:"Entityforms Notifications";s:11:"description";s:97:"Enable this module if you want Entityforms to send e-mail notifications when a form is submitted.";s:4:"core";s:3:"7.x";s:7:"package";s:11:"Entityforms";s:12:"dependencies";a:4:{i:0;s:10:"entityform";i:1;s:12:"entity_rules";i:2;s:11:"entity2text";i:3;s:5:"rules";}s:7:"version";s:11:"7.x-2.0-rc1";s:7:"project";s:10:"entityform";s:9:"datestamp";s:10:"1413913852";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/entityform/entityform_test/entityform_test.module','entityform_test','module','','0','0','-1','0','a:13:{s:4:"name";s:15:"entityform_test";s:11:"description";s:33:"Feature for Entityform simpletest";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Features";s:12:"dependencies";a:5:{i:0;s:6:"entity";i:1;s:10:"entityform";i:2;s:8:"features";i:3;s:17:"field_sql_storage";i:4;s:4:"text";}s:8:"features";a:3:{s:15:"entityform_type";a:1:{i:0;s:21:"simpletest_entityform";}s:12:"features_api";a:1:{i:0;s:5:"api:1";}s:5:"field";a:1:{i:0;s:43:"entityform-simpletest_entityform-field_text";}}s:7:"version";s:11:"7.x-2.0-rc1";s:7:"project";s:10:"entityform";s:9:"datestamp";s:10:"1413913852";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/entityreference/entityreference.module','entityreference','module','','1','0','7002','0','a:15:{s:4:"name";s:16:"Entity Reference";s:11:"description";s:51:"Provides a field that can reference other entities.";s:7:"package";s:6:"Fields";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:6:"entity";i:1;s:6:"ctools";}s:17:"test_dependencies";a:2:{i:0;s:5:"feeds";i:1;s:5:"views";}s:5:"files";a:12:{i:0;s:27:"entityreference.migrate.inc";i:1;s:30:"plugins/selection/abstract.inc";i:2;s:27:"plugins/selection/views.inc";i:3;s:29:"plugins/behavior/abstract.inc";i:4;s:40:"views/entityreference_plugin_display.inc";i:5;s:38:"views/entityreference_plugin_style.inc";i:6;s:43:"views/entityreference_plugin_row_fields.inc";i:7;s:35:"tests/entityreference.handlers.test";i:8;s:35:"tests/entityreference.taxonomy.test";i:9;s:32:"tests/entityreference.admin.test";i:10;s:32:"tests/entityreference.feeds.test";i:11;s:45:"tests/entityreference.entity_translation.test";}s:7:"version";s:7:"7.x-1.2";s:7:"project";s:15:"entityreference";s:9:"datestamp";s:10:"1474306740";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/entityreference/examples/entityreference_behavior_example/entityreference_behavior_example.module','entityreference_behavior_example','module','','0','0','-1','0','a:12:{s:4:"name";s:33:"Entity Reference Behavior Example";s:11:"description";s:71:"Provides some example code for implementing Entity Reference behaviors.";s:4:"core";s:3:"7.x";s:7:"package";s:6:"Fields";s:12:"dependencies";a:1:{i:0;s:15:"entityreference";}s:7:"version";s:7:"7.x-1.2";s:7:"project";s:15:"entityreference";s:9:"datestamp";s:10:"1474306740";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/entityreference/tests/modules/entityreference_feeds_test/entityreference_feeds_test.module','entityreference_feeds_test','module','','0','0','-1','0','a:13:{s:4:"name";s:41:"Entityreference - Feeds integration tests";s:11:"description";s:65:"Support module for the Entityreference - Feeds integration tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:3:{i:0;s:5:"feeds";i:1;s:8:"feeds_ui";i:2;s:15:"entityreference";}s:7:"version";s:7:"7.x-1.2";s:7:"project";s:15:"entityreference";s:9:"datestamp";s:10:"1474306740";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/entity_block/entity_block.module','entity_block','module','','1','0','0','0','a:12:{s:4:"name";s:12:"Entity Block";s:11:"description";s:57:"Display entities (via view modes) using fieldable blocks.";s:4:"core";s:3:"7.x";s:7:"package";s:5:"Other";s:12:"dependencies";a:2:{i:0;s:5:"block";i:1;s:15:"entityreference";}s:5:"files";a:1:{i:0;s:27:"entity_block.controller.inc";}s:7:"version";s:11:"7.x-1.x-dev";s:7:"project";s:12:"entity_block";s:9:"datestamp";s:10:"1438801447";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/features/features.module','features','module','','1','0','7200','20','a:14:{s:4:"name";s:8:"Features";s:11:"description";s:39:"Provides feature management for Drupal.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Features";s:5:"files";a:1:{i:0;s:19:"tests/features.test";}s:17:"test_dependencies";a:4:{i:0;s:5:"image";i:1;s:9:"strongarm";i:2;s:8:"taxonomy";i:3;s:5:"views";}s:9:"configure";s:33:"admin/structure/features/settings";s:7:"version";s:8:"7.x-2.10";s:7:"project";s:8:"features";s:9:"datestamp";s:10:"1461011641";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/features/tests/features_test/features_test.module','features_test','module','','0','0','-1','0','a:14:{s:4:"name";s:14:"Features Tests";s:11:"description";s:33:"Test module for Features testing.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:3:"php";s:5:"5.2.0";s:12:"dependencies";a:5:{i:0;s:8:"features";i:1;s:5:"image";i:2;s:9:"strongarm";i:3;s:8:"taxonomy";i:4;s:5:"views";}s:8:"features";a:10:{s:6:"ctools";a:2:{i:0;s:21:"strongarm:strongarm:1";i:1;s:23:"views:views_default:3.0";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:10:"field_base";a:1:{i:0;s:19:"field_features_test";}s:14:"field_instance";a:1:{i:0;s:38:"node-features_test-field_features_test";}s:6:"filter";a:1:{i:0;s:13:"features_test";}s:5:"image";a:1:{i:0;s:13:"features_test";}s:4:"node";a:1:{i:0;s:13:"features_test";}s:8:"taxonomy";a:1:{i:0;s:22:"taxonomy_features_test";}s:15:"user_permission";a:1:{i:0;s:28:"create features_test content";}s:10:"views_view";a:1:{i:0;s:13:"features_test";}}s:6:"hidden";s:1:"1";s:7:"version";s:8:"7.x-2.10";s:7:"project";s:8:"features";s:9:"datestamp";s:10:"1461011641";s:5:"mtime";i:1490935291;s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/feeds/feeds.module','feeds','module','','1','1','7212','0','a:13:{s:4:"name";s:5:"Feeds";s:11:"description";s:58:"Aggregates RSS/Atom/RDF feeds, imports CSV files and more.";s:7:"package";s:5:"Feeds";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:6:"ctools";i:1;s:13:"job_scheduler";}s:17:"test_dependencies";a:7:{i:0;s:9:"date:date";i:1;s:37:"entity_translation:entity_translation";i:2;s:35:"feeds_xpathparser:feeds_xpathparser";i:3;s:18:"i18n:i18n_taxonomy";i:4;s:9:"link:link";i:5;s:11:"rules:rules";i:6;s:17:"variable:variable";}s:5:"files";a:65:{i:0;s:30:"includes/FeedsConfigurable.inc";i:1;s:26:"includes/FeedsImporter.inc";i:2;s:24:"includes/FeedsSource.inc";i:3;s:23:"libraries/ParserCSV.inc";i:4;s:26:"libraries/http_request.inc";i:5;s:28:"libraries/PuSHSubscriber.inc";i:6;s:26:"plugins/FeedsCSVParser.inc";i:7;s:24:"plugins/FeedsFetcher.inc";i:8;s:28:"plugins/FeedsFileFetcher.inc";i:9;s:28:"plugins/FeedsHTTPFetcher.inc";i:10;s:30:"plugins/FeedsNodeProcessor.inc";i:11;s:27:"plugins/FeedsOPMLParser.inc";i:12;s:23:"plugins/FeedsParser.inc";i:13;s:23:"plugins/FeedsPlugin.inc";i:14;s:26:"plugins/FeedsProcessor.inc";i:15;s:32:"plugins/FeedsSimplePieParser.inc";i:16;s:30:"plugins/FeedsSitemapParser.inc";i:17;s:34:"plugins/FeedsSyndicationParser.inc";i:18;s:30:"plugins/FeedsTermProcessor.inc";i:19;s:30:"plugins/FeedsUserProcessor.inc";i:20;s:16:"tests/feeds.test";i:21;s:36:"tests/common_syndication_parser.test";i:22;s:29:"tests/feeds_content_type.test";i:23;s:26:"tests/feeds_date_time.test";i:24;s:28:"tests/feeds_mapper_date.test";i:25;s:37:"tests/feeds_mapper_date_multiple.test";i:26;s:29:"tests/feeds_mapper_field.test";i:27;s:28:"tests/feeds_mapper_file.test";i:28;s:29:"tests/feeds_mapper_hooks.test";i:29;s:28:"tests/feeds_mapper_link.test";i:30;s:28:"tests/feeds_mapper_list.test";i:31;s:43:"tests/feeds_mapper_multilingual_fields.test";i:32;s:28:"tests/feeds_mapper_path.test";i:33;s:31:"tests/feeds_mapper_profile.test";i:34;s:30:"tests/feeds_mapper_unique.test";i:35;s:23:"tests/feeds_mapper.test";i:36;s:30:"tests/feeds_mapper_config.test";i:37;s:29:"tests/feeds_fetcher_file.test";i:38;s:37:"tests/feeds_mapper_format_config.test";i:39;s:29:"tests/feeds_fetcher_http.test";i:40;s:21:"tests/feeds_i18n.test";i:41;s:26:"tests/feeds_i18n_node.test";i:42;s:30:"tests/feeds_i18n_taxonomy.test";i:43;s:27:"tests/feeds_parser_csv.test";i:44;s:31:"tests/feeds_parser_sitemap.test";i:45;s:35:"tests/feeds_parser_syndication.test";i:46;s:31:"tests/feeds_processor_node.test";i:47;s:31:"tests/feeds_processor_term.test";i:48;s:31:"tests/feeds_processor_user.test";i:49;s:21:"tests/feeds_push.test";i:50;s:22:"tests/feeds_rules.test";i:51;s:26:"tests/feeds_scheduler.test";i:52;s:28:"tests/feeds_mapper_link.test";i:53;s:31:"tests/feeds_mapper_summary.test";i:54;s:32:"tests/feeds_mapper_taxonomy.test";i:55;s:23:"tests/feeds_tokens.test";i:56;s:23:"tests/http_request.test";i:57;s:21:"tests/parser_csv.test";i:58;s:50:"views/feeds_views_handler_argument_importer_id.inc";i:59;s:49:"views/feeds_views_handler_field_importer_name.inc";i:60;s:47:"views/feeds_views_handler_field_log_message.inc";i:61;s:44:"views/feeds_views_handler_field_severity.inc";i:62;s:42:"views/feeds_views_handler_field_source.inc";i:63;s:45:"views/feeds_views_handler_filter_severity.inc";i:64;s:55:"views/feeds_views_plugin_argument_validate_feed_nid.inc";}s:7:"version";s:13:"7.x-2.0-beta3";s:7:"project";s:5:"feeds";s:9:"datestamp";s:10:"1479993785";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/feeds/feeds_import/feeds_import.module','feeds_import','module','','1','0','0','0','a:13:{s:4:"name";s:12:"Feeds Import";s:11:"description";s:50:"An example of a node importer and a user importer.";s:4:"core";s:3:"7.x";s:7:"package";s:5:"Feeds";s:12:"dependencies";a:2:{i:0;s:6:"ctools";i:1;s:5:"feeds";}s:8:"features";a:3:{s:6:"ctools";a:1:{i:0;s:30:"feeds:feeds_importer_default:1";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:14:"feeds_importer";a:2:{i:0;s:4:"node";i:1;s:4:"user";}}s:5:"files";a:1:{i:0;s:17:"feeds_import.test";}s:7:"version";s:13:"7.x-2.0-beta3";s:7:"project";s:5:"feeds";s:9:"datestamp";s:10:"1479993785";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/feeds/feeds_news/feeds_news.module','feeds_news','module','','0','0','-1','0','a:13:{s:4:"name";s:10:"Feeds News";s:11:"description";s:93:"A news aggregator built with feeds, creates nodes from imported feed items. With OPML import.";s:4:"core";s:3:"7.x";s:7:"package";s:5:"Feeds";s:12:"dependencies";a:4:{i:0;s:6:"ctools";i:1;s:8:"features";i:2;s:5:"feeds";i:3;s:5:"views";}s:8:"features";a:7:{s:6:"ctools";a:2:{i:0;s:30:"feeds:feeds_importer_default:1";i:1;s:23:"views:views_default:3.0";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:14:"feeds_importer";a:2:{i:0;s:4:"feed";i:1;s:4:"opml";}s:10:"field_base";a:1:{i:0;s:27:"field_feed_item_description";}s:14:"field_instance";a:1:{i:0;s:42:"node-feed_item-field_feed_item_description";}s:4:"node";a:2:{i:0;s:4:"feed";i:1;s:9:"feed_item";}s:10:"views_view";a:1:{i:0;s:25:"feeds_defaults_feed_items";}}s:5:"files";a:2:{i:0;s:17:"feeds_news.module";i:1;s:15:"feeds_news.test";}s:7:"version";s:13:"7.x-2.0-beta3";s:7:"project";s:5:"feeds";s:9:"datestamp";s:10:"1479993785";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/feeds/feeds_ui/feeds_ui.module','feeds_ui','module','','1','0','7000','0','a:13:{s:4:"name";s:14:"Feeds Admin UI";s:11:"description";s:35:"Administrative UI for Feeds module.";s:7:"package";s:5:"Feeds";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"feeds";}s:9:"configure";s:21:"admin/structure/feeds";s:5:"files";a:1:{i:0;s:13:"feeds_ui.test";}s:7:"version";s:13:"7.x-2.0-beta3";s:7:"project";s:5:"feeds";s:9:"datestamp";s:10:"1479993785";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/feeds/tests/feeds_tests.module','feeds_tests','module','','0','0','-1','0','a:13:{s:4:"name";s:18:"Feeds module tests";s:11:"description";s:41:"Support module for Feeds related testing.";s:7:"package";s:7:"Testing";s:7:"version";s:13:"7.x-2.0-beta3";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:5:"feeds";s:9:"datestamp";s:10:"1479993785";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/feeds_entity_processor/feeds_entity_processor.module','feeds_entity_processor','module','','1','0','0','0','a:14:{s:4:"name";s:22:"Feeds entity processor";s:11:"description";s:46:"Provides a generic entity processor for Feeds.";s:7:"package";s:5:"Feeds";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:19:"feeds (7.x-2.x-dev)";i:1;s:6:"entity";}s:5:"files";a:7:{i:0;s:44:"tests/src/FeedsEntityProcessorBasicTest.test";i:1;s:47:"tests/src/FeedsEntityProcessorPropertyTest.test";i:2;s:52:"src/Property/FeedsEntityProcessorPropertyBoolean.php";i:3;s:49:"src/Property/FeedsEntityProcessorPropertyDate.php";i:4;s:52:"src/Property/FeedsEntityProcessorPropertyDefault.php";i:5;s:51:"src/Property/FeedsEntityProcessorPropertyEntity.php";i:6;s:54:"src/Property/FeedsEntityProcessorPropertyInterface.php";}s:7:"version";s:11:"7.x-1.x-dev";s:7:"project";s:22:"feeds_entity_processor";s:9:"datestamp";s:10:"1456071845";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:62:"Feeds is currently using this module for one or more importers";}'),('sites/all/modules/contrib/feeds_entity_processor/tests/modules/feeds_entity_processor_test/feeds_entity_processor_test.module','feeds_entity_processor_test','module','','0','0','-1','0','a:13:{s:4:"name";s:35:"Feeds entity processor module tests";s:11:"description";s:58:"Support module for Feeds entity processor related testing.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:5:"files";a:1:{i:0;s:50:"src/FeedsEntityProcessorTestMetadataController.php";}s:7:"version";s:11:"7.x-1.x-dev";s:7:"project";s:22:"feeds_entity_processor";s:9:"datestamp";s:10:"1456071845";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/field_collection/field_collection.module','field_collection','module','','1','0','7006','0','a:15:{s:4:"name";s:16:"Field collection";s:11:"description";s:81:"Provides a field collection field, to which any number of fields can be attached.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:6:"entity";}s:5:"files";a:5:{i:0;s:21:"field_collection.test";i:1;s:27:"field_collection.entity.inc";i:2;s:25:"field_collection.info.inc";i:3;s:47:"views/field_collection_handler_relationship.inc";i:4;s:28:"field_collection.migrate.inc";}s:9:"configure";s:33:"admin/structure/field-collections";s:7:"package";s:6:"Fields";s:7:"version";s:14:"7.x-1.0-beta11";s:7:"project";s:16:"field_collection";s:9:"datestamp";s:10:"1454338759";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}'),('sites/all/modules/contrib/field_group/field_group.module','field_group','module','','1','0','7008','1','a:12:{s:4:"name";s:11:"Field Group";s:11:"description";s:67:"Provides the ability to group your fields on both form and display.";s:7:"package";s:6:"Fields";s:12:"dependencies";a:2:{i:0;s:5:"field";i:1;s:6:"ctools";}s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:25:"tests/field_group.ui.test";i:1;s:30:"tests/field_group.display.test";}s:7:"version";s:7:"7.x-1.5";s:7:"project";s:11:"field_group";s:9:"datestamp";s:10:"1452033709";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/field_group/tests/field_group_test.module','field_group_test','module','','0','0','-1','0','a:13:{s:4:"name";s:16:"Field Group Test";s:11:"description";s:27:"Test module for Field Group";s:4:"core";s:3:"7.x";s:7:"package";s:6:"Fields";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-1.5";s:7:"project";s:11:"field_group";s:9:"datestamp";s:10:"1452033709";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/field_group_multiple/field_group_multiple.module','field_group_multiple','module','','1','0','0','2','a:12:{s:4:"name";s:20:"Field group multiple";s:11:"description";s:78:"Widget and display formatter for transposed grouping of multiple value fields.";s:7:"package";s:6:"Fields";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:33:"field_group_multiple.field_ui.inc";}s:12:"dependencies";a:3:{i:0;s:5:"field";i:1;s:6:"ctools";i:2;s:11:"field_group";}s:7:"version";s:13:"7.x-1.0-beta3";s:7:"project";s:20:"field_group_multiple";s:9:"datestamp";s:10:"1428343453";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/field_permissions/field_permissions.module','field_permissions','module','','1','0','7001','50','a:13:{s:4:"name";s:17:"Field Permissions";s:11:"description";s:61:"Set field-level permissions to create, update or view fields.";s:7:"package";s:6:"Fields";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:22:"field_permissions.test";}s:9:"configure";s:32:"admin/reports/fields/permissions";s:7:"version";s:7:"7.x-1.0";s:7:"project";s:17:"field_permissions";s:9:"datestamp";s:10:"1476649740";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/flag/flag.module','flag','module','','0','0','-1','0','a:14:{s:4:"name";s:4:"Flag";s:11:"description";s:55:"Create customized flags that users can set on entities.";s:4:"core";s:3:"7.x";s:7:"package";s:5:"Flags";s:9:"configure";s:21:"admin/structure/flags";s:17:"test_dependencies";a:2:{i:0;s:5:"token";i:1;s:5:"rules";}s:5:"files";a:16:{i:0;s:27:"includes/flag/flag_flag.inc";i:1;s:29:"includes/flag/flag_entity.inc";i:2;s:27:"includes/flag/flag_node.inc";i:3;s:30:"includes/flag/flag_comment.inc";i:4;s:27:"includes/flag/flag_user.inc";i:5;s:32:"includes/flag.cookie_storage.inc";i:6;s:24:"includes/flag.entity.inc";i:7;s:14:"flag.rules.inc";i:8;s:50:"includes/views/flag_handler_argument_entity_id.inc";i:9;s:41:"includes/views/flag_handler_field_ops.inc";i:10;s:45:"includes/views/flag_handler_field_flagged.inc";i:11;s:46:"includes/views/flag_handler_filter_flagged.inc";i:12;s:44:"includes/views/flag_handler_sort_flagged.inc";i:13;s:45:"includes/views/flag_handler_relationships.inc";i:14;s:61:"includes/views/flag_plugin_argument_validate_flaggability.inc";i:15;s:15:"tests/flag.test";}s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/flag/flag_actions.module','flag_actions','module','','0','0','-1','0','a:13:{s:4:"name";s:12:"Flag actions";s:11:"description";s:31:"Execute actions on Flag events.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:4:"flag";}s:7:"package";s:5:"Flags";s:9:"configure";s:29:"admin/structure/flags/actions";s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/flag/flag_bookmark/flag_bookmark.module','flag_bookmark','module','','0','0','-1','0','a:12:{s:4:"name";s:13:"Flag Bookmark";s:11:"description";s:55:"Provides an example bookmark flag and supporting views.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:4:"flag";}s:7:"package";s:5:"Flags";s:5:"files";a:1:{i:0;s:46:"plugins/flag_bookmark_plugin_validate_user.inc";}s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/flag/tests/flagaccesstest/flagaccesstest.module','flagaccesstest','module','','0','0','-1','0','a:13:{s:4:"name";s:26:"Flag hook_flag_access test";s:11:"description";s:26:"Tests for hook_flag_access";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:4:"flag";}s:7:"package";s:5:"Flags";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/flag/tests/flag_comment_flag_test/flag_comment_flag_test.module','flag_comment_flag_test','module','','0','0','-1','0','a:13:{s:4:"name";s:22:"Flag Comment Flag Test";s:11:"description";s:30:"Test module for comment flags.";s:12:"dependencies";a:2:{i:0;s:4:"flag";i:1;s:7:"comment";}s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:5:"mtime";i:1490935291;s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/flag/tests/flag_fields_test/flag_fields_test.module','flag_fields_test','module','','0','0','-1','0','a:13:{s:4:"name";s:16:"Flag Fields Test";s:11:"description";s:44:"Test module for fields on Flagging entities.";s:12:"dependencies";a:1:{i:0;s:4:"flag";}s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:5:"mtime";i:1490935291;s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/flag/tests/flag_hook_test/flag_hook_test.module','flag_hook_test','module','','0','0','-1','0','a:13:{s:4:"name";s:15:"Flag Hooks Test";s:11:"description";s:41:"Test module for invocation of flag hooks.";s:12:"dependencies";a:2:{i:0;s:4:"flag";i:1;s:5:"rules";}s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-3.9";s:7:"project";s:4:"flag";s:9:"datestamp";s:10:"1474619065";s:5:"mtime";i:1490935291;s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/google_analytics/googleanalytics.module','googleanalytics','module','','1','0','7205','0','a:14:{s:4:"name";s:16:"Google Analytics";s:11:"description";s:102:"Allows your site to be tracked by Google Analytics by adding a Javascript tracking code to every page.";s:4:"core";s:3:"7.x";s:7:"package";s:10:"Statistics";s:9:"configure";s:35:"admin/config/system/googleanalytics";s:5:"files";a:1:{i:0;s:20:"googleanalytics.test";}s:17:"test_dependencies";a:1:{i:0;s:5:"token";}s:7:"version";s:7:"7.x-2.3";s:7:"project";s:16:"google_analytics";s:9:"datestamp";s:10:"1470779953";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/gtranslate/gtranslate.module','gtranslate','module','','0','0','-1','0','a:13:{s:4:"name";s:10:"GTranslate";s:11:"description";s:45:"Uses Google power to translate your web site.";s:9:"configure";s:32:"admin/config/regional/gtranslate";s:7:"package";s:13:"Multilanguage";s:4:"core";s:3:"7.x";s:7:"version";s:8:"7.x-1.14";s:7:"project";s:10:"gtranslate";s:9:"datestamp";s:10:"1473179357";s:5:"mtime";i:1473179357;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/i18n/i18n.module','i18n','module','','0','0','-1','0','a:13:{s:4:"name";s:20:"Internationalization";s:11:"description";s:49:"Extends Drupal support for multilingual features.";s:12:"dependencies";a:2:{i:0;s:6:"locale";i:1;s:8:"variable";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:15:"i18n_object.inc";i:1;s:9:"i18n.test";}s:9:"configure";s:26:"admin/config/regional/i18n";s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/i18n/i18n_block/i18n_block.module','i18n_block','module','','0','0','-1','0','a:12:{s:4:"name";s:15:"Block languages";s:11:"description";s:68:"Enables language selector for blocks and optional block translation.";s:12:"dependencies";a:2:{i:0;s:5:"block";i:1;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:14:"i18n_block.inc";i:1;s:15:"i18n_block.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/i18n/i18n_contact/i18n_contact.module','i18n_contact','module','','0','0','-1','0','a:12:{s:4:"name";s:19:"Contact translation";s:11:"description";s:63:"Makes contact categories and replies available for translation.";s:12:"dependencies";a:2:{i:0;s:7:"contact";i:1;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/i18n/i18n_field/i18n_field.module','i18n_field','module','','0','0','-1','0','a:12:{s:4:"name";s:17:"Field translation";s:11:"description";s:26:"Translate field properties";s:12:"dependencies";a:2:{i:0;s:5:"field";i:1;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:14:"i18n_field.inc";i:1;s:15:"i18n_field.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/i18n/i18n_forum/i18n_forum.module','i18n_forum','module','','0','0','-1','0','a:12:{s:4:"name";s:18:"Multilingual forum";s:11:"description";s:60:"Enables multilingual forum, translates names and containers.";s:12:"dependencies";a:3:{i:0;s:5:"forum";i:1;s:13:"i18n_taxonomy";i:2;s:9:"i18n_node";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:15:"i18n_forum.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/i18n/i18n_menu/i18n_menu.module','i18n_menu','module','','0','0','-1','0','a:12:{s:4:"name";s:16:"Menu translation";s:11:"description";s:40:"Supports translatable custom menu items.";s:12:"dependencies";a:4:{i:0;s:4:"i18n";i:1;s:4:"menu";i:2;s:11:"i18n_string";i:3;s:16:"i18n_translation";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:13:"i18n_menu.inc";i:1;s:14:"i18n_menu.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/i18n/i18n_node/i18n_node.module','i18n_node','module','','0','0','-1','0','a:13:{s:4:"name";s:20:"Multilingual content";s:11:"description";s:46:"Extended node options for multilingual content";s:12:"dependencies";a:3:{i:0;s:11:"translation";i:1;s:4:"i18n";i:2;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:9:"configure";s:31:"admin/config/regional/i18n/node";s:5:"files";a:2:{i:0;s:14:"i18n_node.test";i:1;s:22:"i18n_node.variable.inc";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/i18n/i18n_path/i18n_path.module','i18n_path','module','','0','0','-1','0','a:12:{s:4:"name";s:16:"Path translation";s:11:"description";s:37:"Define translations for generic paths";s:12:"dependencies";a:1:{i:0;s:16:"i18n_translation";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:13:"i18n_path.inc";i:1;s:14:"i18n_path.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/i18n/i18n_redirect/i18n_redirect.module','i18n_redirect','module','','0','0','-1','0','a:12:{s:4:"name";s:20:"Translation redirect";s:11:"description";s:71:"Redirect to translated page when available. SEO for multilingual sites.";s:12:"dependencies";a:1:{i:0;s:4:"i18n";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/i18n/i18n_select/i18n_select.module','i18n_select','module','','0','0','-1','0','a:13:{s:4:"name";s:19:"Multilingual select";s:11:"description";s:45:"API module for multilingual content selection";s:12:"dependencies";a:1:{i:0;s:4:"i18n";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:9:"configure";s:33:"admin/config/regional/i18n/select";s:5:"files";a:1:{i:0;s:16:"i18n_select.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/i18n/i18n_string/i18n_string.module','i18n_string','module','','0','0','-1','0','a:13:{s:4:"name";s:18:"String translation";s:11:"description";s:57:"Provides support for translation of user defined strings.";s:12:"dependencies";a:2:{i:0;s:6:"locale";i:1;s:4:"i18n";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:3:{i:0;s:21:"i18n_string.admin.inc";i:1;s:15:"i18n_string.inc";i:2;s:16:"i18n_string.test";}s:9:"configure";s:34:"admin/config/regional/i18n/strings";s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/i18n/i18n_sync/i18n_sync.module','i18n_sync','module','','0','0','-1','0','a:12:{s:4:"name";s:24:"Synchronize translations";s:11:"description";s:74:"Synchronizes taxonomy and fields accross translations of the same content.";s:12:"dependencies";a:2:{i:0;s:4:"i18n";i:1;s:11:"translation";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:5:{i:0;s:16:"i18n_sync.module";i:1;s:17:"i18n_sync.install";i:2;s:20:"i18n_sync.module.inc";i:3;s:18:"i18n_sync.node.inc";i:4;s:14:"i18n_sync.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/i18n/i18n_taxonomy/i18n_taxonomy.module','i18n_taxonomy','module','','0','0','-1','0','a:12:{s:4:"name";s:20:"Taxonomy translation";s:11:"description";s:30:"Enables multilingual taxonomy.";s:12:"dependencies";a:3:{i:0;s:8:"taxonomy";i:1;s:11:"i18n_string";i:2;s:16:"i18n_translation";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:4:{i:0;s:17:"i18n_taxonomy.inc";i:1;s:23:"i18n_taxonomy.pages.inc";i:2;s:23:"i18n_taxonomy.admin.inc";i:3;s:18:"i18n_taxonomy.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/i18n/i18n_translation/i18n_translation.module','i18n_translation','module','','0','0','-1','0','a:12:{s:4:"name";s:16:"Translation sets";s:11:"description";s:47:"Simple translation sets API for generic objects";s:12:"dependencies";a:1:{i:0;s:4:"i18n";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:20:"i18n_translation.inc";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/i18n/i18n_user/i18n_user.module','i18n_user','module','','0','0','-1','0','a:12:{s:4:"name";s:21:"User mail translation";s:11:"description";s:43:"Translate emails sent from the User module.";s:4:"core";s:3:"7.x";s:7:"package";s:35:"Multilingual - Internationalization";s:12:"dependencies";a:1:{i:0;s:13:"i18n_variable";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/i18n/i18n_variable/i18n_variable.module','i18n_variable','module','','0','0','-1','0','a:13:{s:4:"name";s:20:"Variable translation";s:11:"description";s:71:"Multilingual variables that switch language depending on page language.";s:12:"dependencies";a:3:{i:0;s:4:"i18n";i:1;s:24:"variable_store (7.x-2.x)";i:2;s:24:"variable_realm (7.x-2.x)";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:9:"configure";s:35:"admin/config/regional/i18n/variable";s:5:"files";a:2:{i:0;s:23:"i18n_variable.class.inc";i:1;s:18:"i18n_variable.test";}s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/i18n/tests/i18n_test.module','i18n_test','module','','0','0','-1','0','a:13:{s:4:"name";s:26:"Internationalization tests";s:11:"description";s:55:"Helper module for testing i18n (do not enable manually)";s:12:"dependencies";a:3:{i:0;s:6:"locale";i:1;s:11:"translation";i:2;s:4:"i18n";}s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:8:"7.x-1.15";s:7:"project";s:4:"i18n";s:9:"datestamp";s:10:"1485834792";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/i18nviews/i18nviews.module','i18nviews','module','','0','0','-1','0','a:12:{s:4:"name";s:17:"Views translation";s:11:"description";s:80:"Translation of views strings and content selection for views. Requires Views 3.x";s:12:"dependencies";a:2:{i:0;s:5:"views";i:1;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:20:{i:0;s:13:"i18nviews.inc";i:1;s:18:"i18nviews.i18n.inc";i:2;s:49:"includes/i18nviews_handler_argument_node_type.inc";i:3;s:58:"includes/i18nviews_handler_argument_taxonomy_index_tid.inc";i:4;s:58:"includes/i18nviews_handler_argument_taxonomy_term_name.inc";i:5;s:62:"includes/i18nviews_handler_argument_taxonomy_term_language.inc";i:6;s:59:"includes/i18nviews_handler_argument_term_node_tid_depth.inc";i:7;s:46:"includes/i18nviews_handler_field_node_type.inc";i:8;s:62:"includes/i18nviews_handler_field_taxonomy_term_description.inc";i:9;s:59:"includes/i18nviews_handler_field_taxonomy_term_language.inc";i:10;s:55:"includes/i18nviews_handler_field_taxonomy_term_name.inc";i:11;s:50:"includes/i18nviews_handler_field_term_node_tid.inc";i:12;s:48:"includes/i18nviews_handler_filter_field_list.inc";i:13;s:47:"includes/i18nviews_handler_filter_node_type.inc";i:14;s:56:"includes/i18nviews_handler_filter_taxonomy_index_tid.inc";i:15;s:56:"includes/i18nviews_handler_filter_taxonomy_term_name.inc";i:16;s:60:"includes/i18nviews_handler_filter_taxonomy_term_language.inc";i:17;s:57:"includes/i18nviews_handler_filter_term_node_tid_depth.inc";i:18;s:66:"includes/i18nviews_plugin_argument_validate_i18n_taxonomy_term.inc";i:19;s:54:"includes/i18nviews_plugin_localization_i18nstrings.inc";}s:7:"version";s:14:"7.x-3.0-alpha1";s:7:"project";s:9:"i18nviews";s:9:"datestamp";s:10:"1454021946";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/imce/imce.module','imce','module','','1','0','7002','0','a:13:{s:4:"name";s:4:"IMCE";s:11:"description";s:82:"An image/file uploader and browser supporting personal directories and user quota.";s:4:"core";s:3:"7.x";s:7:"package";s:5:"Media";s:9:"configure";s:23:"admin/config/media/imce";s:7:"version";s:8:"7.x-1.10";s:7:"project";s:4:"imce";s:9:"datestamp";s:10:"1459346870";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/imce_wysiwyg/imce_wysiwyg.module','imce_wysiwyg','module','','1','0','0','0','a:12:{s:4:"name";s:23:"IMCE Wysiwyg API bridge";s:11:"description";s:82:"Makes IMCE available as plugin for client-side editors integrated via Wysiwyg API.";s:7:"package";s:14:"User interface";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:4:"imce";i:1;s:7:"wysiwyg";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:12:"imce_wysiwyg";s:9:"datestamp";s:10:"1317851503";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/job_scheduler/job_scheduler.module','job_scheduler','module','','1','0','7101','0','a:12:{s:4:"name";s:13:"Job Scheduler";s:11:"description";s:13:"Scheduler API";s:5:"files";a:4:{i:0;s:20:"job_scheduler.module";i:1;s:21:"job_scheduler.install";i:2;s:16:"JobScheduler.inc";i:3;s:23:"JobSchedulerCronTab.inc";}s:4:"core";s:3:"7.x";s:3:"php";s:3:"5.2";s:7:"version";s:14:"7.x-2.0-alpha3";s:7:"project";s:13:"job_scheduler";s:9:"datestamp";s:10:"1336466457";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/job_scheduler/modules/job_scheduler_trigger/job_scheduler_trigger.module','job_scheduler_trigger','module','','0','0','-1','0','a:12:{s:4:"name";s:21:"Job Scheduler Trigger";s:11:"description";s:62:"Creates scheduler triggers that fire up at certain days, times";s:4:"core";s:3:"7.x";s:3:"php";s:3:"5.2";s:12:"dependencies";a:1:{i:0;s:13:"job_scheduler";}s:7:"version";s:14:"7.x-2.0-alpha3";s:7:"project";s:13:"job_scheduler";s:9:"datestamp";s:10:"1336466457";s:5:"mtime";i:1490935291;s:7:"package";s:5:"Other";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/jquery_update/jquery_update.module','jquery_update','module','','1','0','7000','0','a:13:{s:4:"name";s:13:"jQuery Update";s:11:"description";s:53:"Update jQuery and jQuery UI to a more recent version.";s:7:"package";s:14:"User interface";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:20:"jquery_update.module";i:1;s:21:"jquery_update.install";}s:9:"configure";s:38:"admin/config/development/jquery_update";s:7:"version";s:7:"7.x-2.7";s:7:"project";s:13:"jquery_update";s:9:"datestamp";s:10:"1445379855";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/l10n_update/l10n_update.module','l10n_update','module','','0','0','-1','0','a:13:{s:4:"name";s:19:"Localization update";s:11:"description";s:58:"Provides automatic downloads and updates for translations.";s:12:"dependencies";a:1:{i:0;s:6:"locale";}s:4:"core";s:3:"7.x";s:3:"php";s:3:"5.3";s:7:"package";s:12:"Multilingual";s:9:"configure";s:37:"admin/config/regional/language/update";s:5:"files";a:24:{i:0;s:29:"includes/gettext/PoHeader.php";i:1;s:27:"includes/gettext/PoItem.php";i:2;s:35:"includes/gettext/PoMemoryWriter.php";i:3;s:40:"includes/gettext/PoMetadataInterface.php";i:4;s:38:"includes/gettext/PoReaderInterface.php";i:5;s:38:"includes/gettext/PoStreamInterface.php";i:6;s:35:"includes/gettext/PoStreamReader.php";i:7;s:35:"includes/gettext/PoStreamWriter.php";i:8;s:38:"includes/gettext/PoWriterInterface.php";i:9;s:27:"includes/locale/Gettext.php";i:10;s:36:"includes/locale/PoDatabaseReader.php";i:11;s:36:"includes/locale/PoDatabaseWriter.php";i:12;s:32:"includes/locale/SourceString.php";i:13;s:30:"includes/locale/StringBase.php";i:14;s:41:"includes/locale/StringDatabaseStorage.php";i:15;s:35:"includes/locale/StringInterface.php";i:16;s:42:"includes/locale/StringStorageException.php";i:17;s:42:"includes/locale/StringStorageInterface.php";i:18;s:37:"includes/locale/TranslationString.php";i:19;s:45:"includes/locale/TranslationsStreamWrapper.php";i:20;s:29:"tests/L10nUpdateCronTest.test";i:21;s:34:"tests/L10nUpdateInterfaceTest.test";i:22;s:25:"tests/L10nUpdateTest.test";i:23;s:29:"tests/L10nUpdateTestBase.test";}s:7:"version";s:7:"7.x-2.1";s:7:"project";s:11:"l10n_update";s:9:"datestamp";s:10:"1480765987";s:5:"mtime";i:1490935291;s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/l10n_update/tests/modules/l10n_update_test/l10n_update_test.module','l10n_update_test','module','','0','0','-1','0','a:14:{s:4:"name";s:24:"Localization Update test";s:4:"type";s:6:"module";s:11:"description";s:54:"Support module for Localization Update module testing.";s:7:"package";s:7:"Testing";s:7:"version";s:7:"7.x-2.1";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"project";s:11:"l10n_update";s:9:"datestamp";s:10:"1480765987";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/l10n_update/tests/modules/l10n_update_test_translate/l10n_update_test_translate.module','l10n_update_test_translate','module','','0','0','-1','0','a:16:{s:4:"name";s:34:"Localization Update test translate";s:4:"type";s:6:"module";s:11:"description";s:63:"Translation test module for Localization Update module testing.";s:7:"package";s:7:"Testing";s:7:"version";s:7:"7.x-2.1";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:29:"interface translation project";s:26:"l10n_update_test_translate";s:9:"l10n path";s:131:"sites/all/modules/contrib/l10n_update/tests/modules/l10n_update_test_translate/translations/l10n_update_test_translate.%language.po";s:7:"project";s:11:"l10n_update";s:9:"datestamp";s:10:"1480765987";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/libraries/libraries.module','libraries','module','','1','0','7201','0','a:12:{s:4:"name";s:9:"Libraries";s:11:"description";s:64:"Allows version-dependent and shared usage of external libraries.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:15:"system (>=7.11)";}s:5:"files";a:4:{i:0;s:32:"tests/LibrariesAdminWebTest.test";i:1;s:31:"tests/LibrariesLoadWebTest.test";i:2;s:28:"tests/LibrariesUnitTest.test";i:3;s:31:"tests/LibrariesWebTestBase.test";}s:7:"version";s:7:"7.x-2.3";s:7:"project";s:9:"libraries";s:9:"datestamp";s:10:"1463077450";s:5:"mtime";i:1490935291;s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/libraries/tests/modules/libraries_test_module/libraries_test_module.module','libraries_test_module','module','','0','0','-1','0','a:13:{s:4:"name";s:21:"Libraries test module";s:11:"description";s:36:"Tests library detection and loading.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:12:"dependencies";a:1:{i:0;s:9:"libraries";}s:6:"hidden";b:1;s:7:"version";s:7:"7.x-2.3";s:7:"project";s:9:"libraries";s:9:"datestamp";s:10:"1463077450";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/link/link.module','link','module','','1','0','7001','0','a:14:{s:4:"name";s:4:"Link";s:11:"description";s:32:"Defines simple link field types.";s:4:"core";s:3:"7.x";s:7:"package";s:6:"Fields";s:5:"files";a:11:{i:0;s:11:"link.module";i:1;s:16:"link.migrate.inc";i:2;s:15:"tests/link.test";i:3;s:25:"tests/link.attribute.test";i:4;s:20:"tests/link.crud.test";i:5;s:28:"tests/link.crud_browser.test";i:6;s:21:"tests/link.token.test";i:7;s:28:"tests/link.entity_token.test";i:8;s:24:"tests/link.validate.test";i:9;s:44:"views/link_views_handler_argument_target.inc";i:10;s:44:"views/link_views_handler_filter_protocol.inc";}s:7:"version";s:7:"7.x-1.4";s:7:"project";s:4:"link";s:9:"datestamp";s:10:"1452830642";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:8:"required";b:1;s:11:"explanation";s:73:"Field type(s) in use - see <a href="/admin/reports/fields">Field list</a>";}'),('sites/all/modules/contrib/module_filter/module_filter.module','module_filter','module','','0','0','-1','0','a:13:{s:4:"name";s:13:"Module filter";s:11:"description";s:24:"Filter the modules list.";s:4:"core";s:3:"7.x";s:7:"package";s:14:"Administration";s:5:"files";a:9:{i:0;s:21:"module_filter.install";i:1;s:16:"module_filter.js";i:2;s:20:"module_filter.module";i:3;s:23:"module_filter.admin.inc";i:4;s:23:"module_filter.theme.inc";i:5;s:21:"css/module_filter.css";i:6;s:25:"css/module_filter_tab.css";i:7;s:19:"js/module_filter.js";i:8;s:23:"js/module_filter_tab.js";}s:9:"configure";s:40:"admin/config/user-interface/modulefilter";s:7:"version";s:7:"7.x-2.0";s:7:"project";s:13:"module_filter";s:9:"datestamp";s:10:"1424631189";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/optional_mail/optional_mail_on_register.module','optional_mail_on_register','module','','0','0','-1','0','a:12:{s:4:"name";s:25:"Optional mail on register";s:11:"description";s:64:"New users need not enter a valid email address when registering.";s:4:"core";s:3:"7.x";s:7:"package";s:15:"User Management";s:5:"files";a:4:{i:0;s:30:"optional_mail_on_register.info";i:1;s:32:"optional_mail_on_register.module";i:2;s:28:"optional_mail_on_register.js";i:3;s:29:"optional_mail_on_register.css";}s:7:"version";s:7:"7.x-1.1";s:7:"project";s:13:"optional_mail";s:9:"datestamp";s:10:"1333497970";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/panels/i18n_panels/i18n_panels.module','i18n_panels','module','','0','0','-1','0','a:12:{s:4:"name";s:18:"Panels translation";s:11:"description";s:35:"Supports translatable panels items.";s:12:"dependencies";a:4:{i:0;s:4:"i18n";i:1;s:6:"panels";i:2;s:11:"i18n_string";i:3;s:16:"i18n_translation";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-3.8";s:7:"project";s:6:"panels";s:9:"datestamp";s:10:"1476582295";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/panels/panels.module','panels','module','','1','0','7308','0','a:13:{s:4:"name";s:6:"Panels";s:11:"description";s:107:"Core Panels display functions; provides no external UI, at least one other Panels module should be enabled.";s:4:"core";s:3:"7.x";s:7:"package";s:6:"Panels";s:9:"configure";s:22:"admin/structure/panels";s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:5:"files";a:9:{i:0;s:13:"panels.module";i:1;s:19:"includes/common.inc";i:2;s:19:"includes/legacy.inc";i:3;s:20:"includes/plugins.inc";i:4;s:48:"plugins/views/panels_views_plugin_row_fields.inc";i:5;s:38:"tests/PanelsEntityViewWebTestCase.test";i:6;s:36:"tests/PanelsNodeViewWebTestCase.test";i:7;s:36:"tests/PanelsTermViewWebTestCase.test";i:8;s:36:"tests/PanelsUserViewWebTestCase.test";}s:7:"version";s:7:"7.x-3.8";s:7:"project";s:6:"panels";s:9:"datestamp";s:10:"1476582295";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/panels/panels_ipe/panels_ipe.module','panels_ipe','module','','1','0','0','0','a:13:{s:4:"name";s:22:"Panels In-Place Editor";s:11:"description";s:101:"Provide a UI for managing some Panels directly on the frontend, instead of having to use the backend.";s:7:"package";s:6:"Panels";s:12:"dependencies";a:1:{i:0;s:6:"panels";}s:4:"core";s:3:"7.x";s:9:"configure";s:22:"admin/structure/panels";s:5:"files";a:1:{i:0;s:17:"panels_ipe.module";}s:7:"version";s:7:"7.x-3.8";s:7:"project";s:6:"panels";s:9:"datestamp";s:10:"1476582295";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/panels/panels_mini/panels_mini.module','panels_mini','module','','1','0','7301','0','a:12:{s:4:"name";s:11:"Mini panels";s:11:"description";s:89:"Create mini panels that can be used as blocks by Drupal and panes by other panel modules.";s:7:"package";s:6:"Panels";s:12:"dependencies";a:1:{i:0;s:6:"panels";}s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:42:"plugins/export_ui/panels_mini_ui.class.php";}s:7:"version";s:7:"7.x-3.8";s:7:"project";s:6:"panels";s:9:"datestamp";s:10:"1476582295";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/panels/panels_node/panels_node.module','panels_node','module','','1','0','7302','11','a:13:{s:4:"name";s:11:"Panel nodes";s:11:"description";s:65:"Create nodes that are divided into areas with selectable content.";s:7:"package";s:6:"Panels";s:12:"dependencies";a:1:{i:0;s:6:"panels";}s:9:"configure";s:22:"admin/structure/panels";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:18:"panels_node.module";}s:7:"version";s:7:"7.x-3.8";s:7:"project";s:6:"panels";s:9:"datestamp";s:10:"1476582295";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/pathauto/pathauto.module','pathauto','module','','1','0','7006','1','a:14:{s:4:"name";s:8:"Pathauto";s:11:"description";s:95:"Provides a mechanism for modules to automatically generate aliases for the content they manage.";s:12:"dependencies";a:2:{i:0;s:4:"path";i:1;s:5:"token";}s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:20:"pathauto.migrate.inc";i:1;s:13:"pathauto.test";}s:9:"configure";s:33:"admin/config/search/path/patterns";s:10:"recommends";a:1:{i:0;s:8:"redirect";}s:7:"version";s:7:"7.x-1.3";s:7:"project";s:8:"pathauto";s:9:"datestamp";s:10:"1444232655";s:5:"mtime";i:1490935291;s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/placeholder/placeholder.module','placeholder','module','','1','0','0','0','a:12:{s:4:"name";s:11:"Placeholder";s:11:"description";s:85:"Add support for the HTML5 placeholder attribute, with backward browser compatibility.";s:4:"core";s:3:"7.x";s:7:"package";s:5:"Other";s:12:"dependencies";a:1:{i:0;s:21:"libraries (>=7.x-2.2)";}s:7:"version";s:7:"7.x-1.1";s:7:"project";s:11:"placeholder";s:9:"datestamp";s:10:"1411850355";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/relation/relation.module','relation','module','','0','0','-1','0','a:12:{s:4:"name";s:8:"Relation";s:11:"description";s:41:"Describes relationships between entities.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Relation";s:5:"files";a:9:{i:0;s:21:"relation.database.inc";i:1;s:19:"tests/relation.test";i:2;s:25:"tests/relation.rules.test";i:3;s:25:"tests/relation.views.test";i:4;s:26:"tests/relation.ctools.test";i:5;s:39:"views/relation_handler_relationship.inc";i:6;s:43:"views/views_handler_field_relation_link.inc";i:7;s:50:"views/views_handler_field_relation_link_delete.inc";i:8;s:48:"views/views_handler_field_relation_link_edit.inc";}s:12:"dependencies";a:2:{i:0;s:17:"relation_endpoint";i:1;s:15:"system (>=7.33)";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/relation/relation_dummy_field/relation_dummy_field.module','relation_dummy_field','module','','0','0','-1','0','a:12:{s:4:"name";s:20:"Relation Dummy Field";s:11:"description";s:56:"Dummy field to display relation data inline on entities.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Relation";s:12:"dependencies";a:1:{i:0;s:8:"relation";}s:5:"files";a:1:{i:0;s:31:"tests/relation_dummy_field.test";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/relation/relation_endpoint.module','relation_endpoint','module','','0','0','-1','0','a:12:{s:4:"name";s:24:"Relation Endpoints Field";s:11:"description";s:84:"Helper module for Relation. Defines endpoints field (not usable except by relation).";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Relation";s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/relation/relation_entity_collector/relation_entity_collector.module','relation_entity_collector','module','','0','0','-1','0','a:13:{s:4:"name";s:31:"Relation Entity Collector block";s:11:"description";s:82:"A block to collect entities loaded on any page(s), and create relations from them.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Relation";s:12:"dependencies";a:2:{i:0;s:8:"relation";i:1;s:5:"block";}s:5:"files";a:1:{i:0;s:36:"tests/relation_entity_collector.test";}s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:29:"relation_entity_collector.css";s:90:"sites/all/modules/contrib/relation/relation_entity_collector/relation_entity_collector.css";}}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/relation/relation_feeds/relation_feeds.module','relation_feeds','module','','0','0','-1','0','a:12:{s:4:"name";s:14:"Relation feeds";s:11:"description";s:38:"Feeds integration module for Relation.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Relation";s:5:"files";a:1:{i:0;s:35:"tests/relation.feeds_processor.test";}s:12:"dependencies";a:2:{i:0;s:8:"relation";i:1;s:24:"feeds (!=7.x-1.0-alpha8)";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/relation/relation_migrate/relation_migrate.module','relation_migrate','module','','0','0','-1','0','a:12:{s:4:"name";s:16:"Relation migrate";s:11:"description";s:40:"Migrate integration module for Relation.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Relation";s:5:"files";a:3:{i:0;s:32:"relation_migrate.destination.inc";i:1;s:27:"relation_migrate.source.inc";i:2;s:30:"relation_migrate.migration.inc";}s:12:"dependencies";a:3:{i:0;s:8:"relation";i:1;s:11:"relation_ui";i:2;s:7:"migrate";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/relation/relation_migrate/tests/relation_migrate_test.module','relation_migrate_test','module','','0','0','-1','0','a:13:{s:4:"name";s:22:"Relation Migrate Tests";s:11:"description";s:60:"Support module for the Relation - Migrate integration tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:4:{i:0;s:14:"node_reference";i:1;s:14:"user_reference";i:2;s:15:"entityreference";i:3;s:5:"views";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/relation/relation_ui.module','relation_ui','module','','0','0','-1','0','a:13:{s:4:"name";s:11:"Relation UI";s:11:"description";s:105:"Administrative interface to relation. Without this module, you cannot create or edit your relation types.";s:7:"package";s:8:"Relation";s:4:"core";s:3:"7.x";s:9:"configure";s:24:"admin/structure/relation";s:12:"dependencies";a:1:{i:0;s:8:"relation";}s:5:"files";a:2:{i:0;s:18:"relation_ui.module";i:1;s:22:"tests/relation_ui.test";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/relation/tests/relation_ctools_test.module','relation_ctools_test','module','','0','0','-1','0','a:13:{s:4:"name";s:14:"Relation Tests";s:11:"description";s:59:"Support module for the Relation - ctools integration tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/relation/tests/relation_rules_test.module','relation_rules_test','module','','0','0','-1','0','a:13:{s:4:"name";s:14:"Relation Tests";s:11:"description";s:58:"Support module for the Relation - Rules integration tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-1.0";s:7:"project";s:8:"relation";s:9:"datestamp";s:10:"1439290741";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/rules/rules.module','rules','module','','1','1','7214','20','a:13:{s:4:"name";s:5:"Rules";s:11:"description";s:51:"React on events and conditionally evaluate actions.";s:7:"package";s:5:"Rules";s:4:"core";s:3:"7.x";s:5:"files";a:17:{i:0;s:18:"rules.features.inc";i:1;s:16:"tests/rules.test";i:2;s:18:"includes/faces.inc";i:3;s:23:"includes/rules.core.inc";i:4;s:24:"includes/rules.event.inc";i:5;s:28:"includes/rules.processor.inc";i:6;s:26:"includes/rules.plugins.inc";i:7;s:24:"includes/rules.state.inc";i:8;s:29:"includes/rules.dispatcher.inc";i:9;s:21:"modules/node.eval.inc";i:10;s:20:"modules/php.eval.inc";i:11;s:27:"modules/rules_core.eval.inc";i:12;s:23:"modules/system.eval.inc";i:13;s:20:"ui/ui.controller.inc";i:14;s:14:"ui/ui.core.inc";i:15;s:14:"ui/ui.data.inc";i:16;s:17:"ui/ui.plugins.inc";}s:12:"dependencies";a:2:{i:0;s:12:"entity_token";i:1;s:6:"entity";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:9:"configure";s:27:"admin/config/workflow/rules";}'),('sites/all/modules/contrib/rules/rules_admin/rules_admin.module','rules_admin','module','','1','0','0','0','a:12:{s:4:"name";s:8:"Rules UI";s:11:"description";s:44:"Administrative interface for managing rules.";s:7:"package";s:5:"Rules";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:18:"rules_admin.module";i:1;s:15:"rules_admin.inc";}s:12:"dependencies";a:1:{i:0;s:5:"rules";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/rules/rules_i18n/rules_i18n.module','rules_i18n','module','','0','0','-1','0','a:12:{s:4:"name";s:17:"Rules translation";s:11:"description";s:25:"Allows translating rules.";s:12:"dependencies";a:2:{i:0;s:5:"rules";i:1;s:11:"i18n_string";}s:7:"package";s:35:"Multilingual - Internationalization";s:4:"core";s:3:"7.x";s:5:"files";a:3:{i:0;s:19:"rules_i18n.i18n.inc";i:1;s:20:"rules_i18n.rules.inc";i:2;s:15:"rules_i18n.test";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/rules/rules_scheduler/rules_scheduler.module','rules_scheduler','module','','0','0','-1','0','a:13:{s:4:"name";s:15:"Rules Scheduler";s:11:"description";s:57:"Schedule the execution of Rules components using actions.";s:12:"dependencies";a:1:{i:0;s:5:"rules";}s:7:"package";s:5:"Rules";s:4:"core";s:3:"7.x";s:5:"files";a:9:{i:0;s:25:"rules_scheduler.admin.inc";i:1;s:22:"rules_scheduler.module";i:2;s:23:"rules_scheduler.install";i:3;s:25:"rules_scheduler.rules.inc";i:4;s:20:"rules_scheduler.test";i:5;s:36:"includes/rules_scheduler.handler.inc";i:6;s:42:"includes/rules_scheduler.views_default.inc";i:7;s:34:"includes/rules_scheduler.views.inc";i:8;s:41:"includes/rules_scheduler_views_filter.inc";}s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;s:9:"configure";s:36:"admin/config/workflow/rules/schedule";}'),('sites/all/modules/contrib/rules/rules_scheduler/tests/rules_scheduler_test.module','rules_scheduler_test','module','','0','0','-1','0','a:13:{s:4:"name";s:21:"Rules Scheduler Tests";s:11:"description";s:45:"Support module for the Rules Scheduler tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:24:"rules_scheduler_test.inc";}s:6:"hidden";b:1;s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/rules/tests/rules_test.module','rules_test','module','','0','0','-1','0','a:13:{s:4:"name";s:11:"Rules Tests";s:11:"description";s:35:"Support module for the Rules tests.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:20:"rules_test.rules.inc";i:1;s:29:"rules_test.rules_defaults.inc";}s:6:"hidden";b:1;s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/rules/tests/rules_test_invocation.module','rules_test_invocation','module','','0','0','-1','0','a:13:{s:4:"name";s:21:"Rules Test invocation";s:11:"description";s:40:"Helper module to test Rules invocations.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-2.9";s:7:"project";s:5:"rules";s:9:"datestamp";s:10:"1426527210";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/rules_conditional/rules_conditional.module','rules_conditional','module','','1','0','0','0','a:12:{s:4:"name";s:17:"Conditional Rules";s:11:"description";s:63:"Provides conditional control elements within action containers.";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"rules";}s:7:"package";s:5:"Rules";s:5:"files";a:4:{i:0;s:35:"includes/rules_conditional.core.inc";i:1;s:37:"includes/rules_conditional.plugin.inc";i:2;s:33:"includes/rules_conditional.ui.inc";i:3;s:28:"tests/rules_conditional.test";}s:7:"version";s:13:"7.x-1.0-beta2";s:7:"project";s:17:"rules_conditional";s:9:"datestamp";s:10:"1352752992";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/rules_conditional/tests/rules_conditional_test.module','rules_conditional_test','module','','0','0','-1','0','a:13:{s:4:"name";s:22:"Conditional Rules Test";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:5:"rules";i:1;s:17:"rules_conditional";}s:5:"files";a:1:{i:0;s:26:"rules_conditional_test.inc";}s:7:"package";s:5:"Rules";s:6:"hidden";b:1;s:7:"version";s:13:"7.x-1.0-beta2";s:7:"project";s:17:"rules_conditional";s:9:"datestamp";s:10:"1352752992";s:5:"mtime";i:1490935291;s:11:"description";s:0:"";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/sharedemail/sharedemail.module','sharedemail','module','','0','0','-1','0','a:13:{s:4:"name";s:13:"Shared E-mail";s:11:"description";s:65:"Allow an e-mail address to be used by more than one user account.";s:4:"core";s:3:"7.x";s:9:"configure";s:31:"admin/config/people/sharedemail";s:7:"version";s:7:"7.x-1.0";s:7:"project";s:11:"sharedemail";s:9:"datestamp";s:10:"1409870031";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/smtp/smtp.module','smtp','module','','1','0','7103','0','a:14:{s:4:"name";s:27:"SMTP Authentication Support";s:11:"description";s:71:"Allow for site emails to be sent through an SMTP server of your choice.";s:4:"core";s:3:"7.x";s:7:"package";s:4:"Mail";s:9:"configure";s:24:"admin/config/system/smtp";s:5:"files";a:4:{i:0;s:13:"smtp.mail.inc";i:1;s:18:"smtp.phpmailer.inc";i:2;s:18:"smtp.transport.inc";i:3;s:20:"tests/smtp.unit.test";}s:17:"test_dependencies";a:1:{i:0;s:7:"maillog";}s:7:"version";s:7:"7.x-1.6";s:7:"project";s:4:"smtp";s:9:"datestamp";s:10:"1482783785";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/smtp/tests/smtp_tests.module','smtp_tests','module','','0','0','-1','0','a:13:{s:4:"name";s:10:"SMTP tests";s:11:"description";s:41:"Contains helper logic for the SMTP tests.";s:7:"package";s:4:"Mail";s:4:"core";s:3:"7.x";s:6:"hidden";b:1;s:7:"version";s:7:"7.x-1.6";s:7:"project";s:4:"smtp";s:9:"datestamp";s:10:"1482783785";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/stringoverrides/stringoverrides.module','stringoverrides','module','','1','0','7000','0','a:13:{s:4:"name";s:16:"String Overrides";s:11:"description";s:48:"Provides a quick and easy way of replacing text.";s:4:"core";s:3:"7.x";s:5:"files";a:3:{i:0;s:22:"stringoverrides.module";i:1;s:23:"stringoverrides.install";i:2;s:25:"stringoverrides.admin.inc";}s:9:"configure";s:37:"admin/config/regional/stringoverrides";s:7:"version";s:7:"7.x-1.8";s:7:"project";s:15:"stringoverrides";s:9:"datestamp";s:10:"1304446316";s:5:"mtime";i:1304446316;s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/stringoverrides/stringoverrides_migrate.module','stringoverrides_migrate','module','','0','0','-1','0','a:12:{s:4:"name";s:24:"String Overrides Migrate";s:11:"description";s:59:"Tools for importing and exporting string override settings.";s:12:"dependencies";a:1:{i:0;s:15:"stringoverrides";}s:4:"core";s:3:"7.x";s:5:"files";a:2:{i:0;s:30:"stringoverrides_migrate.module";i:1;s:33:"stringoverrides_migrate.admin.inc";}s:7:"version";s:7:"7.x-1.8";s:7:"project";s:15:"stringoverrides";s:9:"datestamp";s:10:"1304446316";s:5:"mtime";i:1304446316;s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/telephone/telephone.module','telephone','module','','0','0','-1','0','a:12:{s:4:"name";s:9:"Telephone";s:11:"description";s:43:"Defines a field type for telephone numbers.";s:7:"package";s:6:"Fields";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"field";}s:5:"files";a:1:{i:0;s:21:"telephone.migrate.inc";}s:7:"version";s:14:"7.x-1.0-alpha1";s:7:"project";s:9:"telephone";s:9:"datestamp";s:10:"1389736105";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/terms_of_use/terms_of_use.module','terms_of_use','module','','1','0','0','0','a:13:{s:4:"name";s:12:"Terms of Use";s:11:"description";s:43:"Adds terms of Use to the registration page.";s:4:"core";s:3:"7.x";s:9:"configure";s:32:"admin/config/people/terms_of_use";s:5:"files";a:1:{i:0;s:23:"tests/terms_of_use.test";}s:7:"version";s:7:"7.x-1.2";s:7:"project";s:12:"terms_of_use";s:9:"datestamp";s:10:"1341924142";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/token/tests/token_test.module','token_test','module','','0','0','-1','0','a:13:{s:4:"name";s:10:"Token Test";s:11:"description";s:39:"Testing module for token functionality.";s:7:"package";s:7:"Testing";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:17:"token_test.module";}s:6:"hidden";b:1;s:7:"version";s:7:"7.x-1.6";s:7:"project";s:5:"token";s:9:"datestamp";s:10:"1425149060";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/token/token.module','token','module','','1','0','7001','0','a:12:{s:4:"name";s:5:"Token";s:11:"description";s:73:"Provides a user interface for the Token API and some missing core tokens.";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:10:"token.test";}s:7:"version";s:7:"7.x-1.6";s:7:"project";s:5:"token";s:9:"datestamp";s:10:"1425149060";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/transliteration/transliteration.module','transliteration','module','','0','0','-1','0','a:13:{s:4:"name";s:15:"Transliteration";s:11:"description";s:61:"Converts non-latin text to US-ASCII and sanitizes file names.";s:4:"core";s:3:"7.x";s:9:"configure";s:30:"admin/config/media/file-system";s:7:"version";s:7:"7.x-3.2";s:7:"project";s:15:"transliteration";s:9:"datestamp";s:10:"1395079444";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:7:"package";s:5:"Other";s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/uuid/uuid.module','uuid','module','','0','0','-1','0','a:13:{s:4:"name";s:21:"Universally Unique ID";s:11:"description";s:85:"Extends the entity functionality and adds support for universally unique identifiers.";s:4:"core";s:3:"7.x";s:7:"package";s:4:"UUID";s:9:"configure";s:24:"admin/config/system/uuid";s:5:"files";a:1:{i:0;s:9:"uuid.test";}s:12:"dependencies";a:2:{i:0;s:4:"node";i:1;s:4:"user";}s:7:"version";s:13:"7.x-1.0-beta2";s:7:"project";s:4:"uuid";s:9:"datestamp";s:10:"1470153540";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/uuid/uuid_path/uuid_path.module','uuid_path','module','','0','0','-1','0','a:12:{s:4:"name";s:9:"UUID Path";s:11:"description";s:46:"Provides export functionality for url aliases.";s:4:"core";s:3:"7.x";s:7:"package";s:4:"UUID";s:12:"dependencies";a:1:{i:0;s:4:"uuid";}s:7:"version";s:13:"7.x-1.0-beta2";s:7:"project";s:4:"uuid";s:9:"datestamp";s:10:"1470153540";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/uuid/uuid_services/uuid_services.module','uuid_services','module','','0','0','-1','0','a:12:{s:4:"name";s:13:"UUID Services";s:11:"description";s:84:"Provides integration with the Services module, like exposing a UUID entity resource.";s:4:"core";s:3:"7.x";s:7:"package";s:20:"Services - resources";s:12:"dependencies";a:3:{i:0;s:8:"services";i:1;s:4:"uuid";i:2;s:6:"entity";}s:7:"version";s:13:"7.x-1.0-beta2";s:7:"project";s:4:"uuid";s:9:"datestamp";s:10:"1470153540";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/uuid/uuid_services_example/uuid_services_example.module','uuid_services_example','module','','0','0','-1','0','a:13:{s:4:"name";s:21:"UUID Services Example";s:11:"description";s:90:"Example feature of a UUID service. Works well with the Deploy Example feature as a client.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Features";s:3:"php";s:5:"5.2.4";s:12:"dependencies";a:4:{i:0;s:11:"rest_server";i:1;s:8:"services";i:2;s:4:"uuid";i:3;s:13:"uuid_services";}s:8:"features";a:3:{s:6:"ctools";a:1:{i:0;s:19:"services:services:3";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:17:"services_endpoint";a:1:{i:0;s:21:"uuid_services_example";}}s:7:"version";s:13:"7.x-1.0-beta2";s:7:"project";s:4:"uuid";s:9:"datestamp";s:10:"1470153540";s:5:"mtime";i:1490935291;s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/variable/variable.module','variable','module','','0','0','-1','0','a:12:{s:4:"name";s:8:"Variable";s:11:"description";s:43:"Variable Information and basic variable API";s:7:"package";s:8:"Variable";s:4:"core";s:3:"7.x";s:5:"files";a:9:{i:0;s:27:"includes/forum.variable.inc";i:1;s:28:"includes/locale.variable.inc";i:2;s:26:"includes/menu.variable.inc";i:3;s:26:"includes/node.variable.inc";i:4;s:28:"includes/system.variable.inc";i:5;s:30:"includes/taxonomy.variable.inc";i:6;s:33:"includes/translation.variable.inc";i:7;s:26:"includes/user.variable.inc";i:8;s:13:"variable.test";}s:7:"version";s:7:"7.x-2.5";s:7:"project";s:8:"variable";s:9:"datestamp";s:10:"1398250128";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/variable/variable_admin/variable_admin.module','variable_admin','module','','0','0','-1','0','a:12:{s:4:"name";s:14:"Variable admin";s:11:"description";s:26:"Variable Administration UI";s:12:"dependencies";a:1:{i:0;s:8:"variable";}s:7:"package";s:8:"Variable";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.5";s:7:"project";s:8:"variable";s:9:"datestamp";s:10:"1398250128";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/variable/variable_example/variable_example.module','variable_example','module','','0','0','-1','0','a:12:{s:4:"name";s:16:"Variable example";s:11:"description";s:83:"An example module showing how to use the Variable API and providing some variables.";s:12:"dependencies";a:2:{i:0;s:8:"variable";i:1;s:14:"variable_store";}s:7:"package";s:15:"Example modules";s:4:"core";s:3:"7.x";s:5:"files";a:1:{i:0;s:29:"variable_example.variable.inc";}s:7:"version";s:7:"7.x-2.5";s:7:"project";s:8:"variable";s:9:"datestamp";s:10:"1398250128";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/variable/variable_realm/variable_realm.module','variable_realm','module','','0','0','-1','0','a:12:{s:4:"name";s:14:"Variable realm";s:11:"description";s:49:"API to use variable realms from different modules";s:12:"dependencies";a:1:{i:0;s:8:"variable";}s:7:"package";s:8:"Variable";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.5";s:5:"files";a:2:{i:0;s:24:"variable_realm.class.inc";i:1;s:30:"variable_realm_union.class.inc";}s:7:"project";s:8:"variable";s:9:"datestamp";s:10:"1398250128";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/variable/variable_store/variable_store.module','variable_store','module','','0','0','-1','0','a:12:{s:4:"name";s:14:"Variable store";s:11:"description";s:60:"Database storage for variable realms. This is an API module.";s:12:"dependencies";a:1:{i:0;s:8:"variable";}s:7:"package";s:8:"Variable";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.5";s:5:"files";a:2:{i:0;s:24:"variable_store.class.inc";i:1;s:19:"variable_store.test";}s:7:"project";s:8:"variable";s:9:"datestamp";s:10:"1398250128";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/variable/variable_views/variable_views.module','variable_views','module','','0','0','-1','0','a:12:{s:4:"name";s:14:"Variable views";s:11:"description";s:78:"Provides views integration for variable, included a default variable argument.";s:12:"dependencies";a:2:{i:0;s:8:"variable";i:1;s:5:"views";}s:7:"package";s:8:"Variable";s:4:"core";s:3:"7.x";s:5:"files";a:3:{i:0;s:51:"includes/views_plugin_argument_default_variable.inc";i:1;s:47:"includes/views_handler_field_variable_title.inc";i:2;s:47:"includes/views_handler_field_variable_value.inc";}s:7:"version";s:7:"7.x-2.5";s:7:"project";s:8:"variable";s:9:"datestamp";s:10:"1398250128";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/views/tests/views_test.module','views_test','module','','0','0','-1','0','a:13:{s:4:"name";s:10:"Views Test";s:11:"description";s:22:"Test module for Views.";s:7:"package";s:5:"Views";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"views";}s:6:"hidden";b:1;s:7:"version";s:8:"7.x-3.16";s:7:"project";s:5:"views";s:9:"datestamp";s:10:"1491158591";s:5:"mtime";i:1491158591;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/views/views.module','views','module','','1','0','7302','10','a:13:{s:4:"name";s:5:"Views";s:11:"description";s:55:"Create customized lists and queries from your database.";s:7:"package";s:5:"Views";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:13:"css/views.css";s:45:"sites/all/modules/contrib/views/css/views.css";}}s:12:"dependencies";a:1:{i:0;s:6:"ctools";}s:5:"files";a:313:{i:0;s:31:"handlers/views_handler_area.inc";i:1;s:40:"handlers/views_handler_area_messages.inc";i:2;s:38:"handlers/views_handler_area_result.inc";i:3;s:36:"handlers/views_handler_area_text.inc";i:4;s:43:"handlers/views_handler_area_text_custom.inc";i:5;s:36:"handlers/views_handler_area_view.inc";i:6;s:35:"handlers/views_handler_argument.inc";i:7;s:40:"handlers/views_handler_argument_date.inc";i:8;s:43:"handlers/views_handler_argument_formula.inc";i:9;s:47:"handlers/views_handler_argument_many_to_one.inc";i:10;s:40:"handlers/views_handler_argument_null.inc";i:11;s:43:"handlers/views_handler_argument_numeric.inc";i:12;s:42:"handlers/views_handler_argument_string.inc";i:13;s:52:"handlers/views_handler_argument_group_by_numeric.inc";i:14;s:32:"handlers/views_handler_field.inc";i:15;s:40:"handlers/views_handler_field_counter.inc";i:16;s:40:"handlers/views_handler_field_boolean.inc";i:17;s:49:"handlers/views_handler_field_contextual_links.inc";i:18;s:48:"handlers/views_handler_field_ctools_dropdown.inc";i:19;s:39:"handlers/views_handler_field_custom.inc";i:20;s:37:"handlers/views_handler_field_date.inc";i:21;s:39:"handlers/views_handler_field_entity.inc";i:22;s:38:"handlers/views_handler_field_links.inc";i:23;s:39:"handlers/views_handler_field_markup.inc";i:24;s:37:"handlers/views_handler_field_math.inc";i:25;s:40:"handlers/views_handler_field_numeric.inc";i:26;s:47:"handlers/views_handler_field_prerender_list.inc";i:27;s:46:"handlers/views_handler_field_time_interval.inc";i:28;s:43:"handlers/views_handler_field_serialized.inc";i:29;s:45:"handlers/views_handler_field_machine_name.inc";i:30;s:36:"handlers/views_handler_field_url.inc";i:31;s:33:"handlers/views_handler_filter.inc";i:32;s:50:"handlers/views_handler_filter_boolean_operator.inc";i:33;s:57:"handlers/views_handler_filter_boolean_operator_string.inc";i:34;s:41:"handlers/views_handler_filter_combine.inc";i:35;s:38:"handlers/views_handler_filter_date.inc";i:36;s:42:"handlers/views_handler_filter_equality.inc";i:37;s:47:"handlers/views_handler_filter_entity_bundle.inc";i:38;s:50:"handlers/views_handler_filter_group_by_numeric.inc";i:39;s:45:"handlers/views_handler_filter_in_operator.inc";i:40;s:45:"handlers/views_handler_filter_many_to_one.inc";i:41;s:41:"handlers/views_handler_filter_numeric.inc";i:42;s:40:"handlers/views_handler_filter_string.inc";i:43;s:48:"handlers/views_handler_filter_fields_compare.inc";i:44;s:39:"handlers/views_handler_relationship.inc";i:45;s:53:"handlers/views_handler_relationship_groupwise_max.inc";i:46;s:31:"handlers/views_handler_sort.inc";i:47;s:36:"handlers/views_handler_sort_date.inc";i:48;s:39:"handlers/views_handler_sort_formula.inc";i:49;s:48:"handlers/views_handler_sort_group_by_numeric.inc";i:50;s:46:"handlers/views_handler_sort_menu_hierarchy.inc";i:51;s:38:"handlers/views_handler_sort_random.inc";i:52;s:17:"includes/base.inc";i:53;s:21:"includes/handlers.inc";i:54;s:20:"includes/plugins.inc";i:55;s:17:"includes/view.inc";i:56;s:60:"modules/aggregator/views_handler_argument_aggregator_fid.inc";i:57;s:60:"modules/aggregator/views_handler_argument_aggregator_iid.inc";i:58;s:69:"modules/aggregator/views_handler_argument_aggregator_category_cid.inc";i:59;s:64:"modules/aggregator/views_handler_field_aggregator_title_link.inc";i:60;s:62:"modules/aggregator/views_handler_field_aggregator_category.inc";i:61;s:70:"modules/aggregator/views_handler_field_aggregator_item_description.inc";i:62;s:57:"modules/aggregator/views_handler_field_aggregator_xss.inc";i:63;s:67:"modules/aggregator/views_handler_filter_aggregator_category_cid.inc";i:64;s:54:"modules/aggregator/views_plugin_row_aggregator_rss.inc";i:65;s:56:"modules/book/views_plugin_argument_default_book_root.inc";i:66;s:59:"modules/comment/views_handler_argument_comment_user_uid.inc";i:67;s:47:"modules/comment/views_handler_field_comment.inc";i:68;s:53:"modules/comment/views_handler_field_comment_depth.inc";i:69;s:52:"modules/comment/views_handler_field_comment_link.inc";i:70;s:60:"modules/comment/views_handler_field_comment_link_approve.inc";i:71;s:59:"modules/comment/views_handler_field_comment_link_delete.inc";i:72;s:57:"modules/comment/views_handler_field_comment_link_edit.inc";i:73;s:58:"modules/comment/views_handler_field_comment_link_reply.inc";i:74;s:57:"modules/comment/views_handler_field_comment_node_link.inc";i:75;s:56:"modules/comment/views_handler_field_comment_username.inc";i:76;s:61:"modules/comment/views_handler_field_ncs_last_comment_name.inc";i:77;s:56:"modules/comment/views_handler_field_ncs_last_updated.inc";i:78;s:52:"modules/comment/views_handler_field_node_comment.inc";i:79;s:57:"modules/comment/views_handler_field_node_new_comments.inc";i:80;s:62:"modules/comment/views_handler_field_last_comment_timestamp.inc";i:81;s:57:"modules/comment/views_handler_filter_comment_user_uid.inc";i:82;s:57:"modules/comment/views_handler_filter_ncs_last_updated.inc";i:83;s:53:"modules/comment/views_handler_filter_node_comment.inc";i:84;s:53:"modules/comment/views_handler_sort_comment_thread.inc";i:85;s:60:"modules/comment/views_handler_sort_ncs_last_comment_name.inc";i:86;s:55:"modules/comment/views_handler_sort_ncs_last_updated.inc";i:87;s:48:"modules/comment/views_plugin_row_comment_rss.inc";i:88;s:49:"modules/comment/views_plugin_row_comment_view.inc";i:89;s:52:"modules/contact/views_handler_field_contact_link.inc";i:90;s:43:"modules/field/views_handler_field_field.inc";i:91;s:59:"modules/field/views_handler_relationship_entity_reverse.inc";i:92;s:51:"modules/field/views_handler_argument_field_list.inc";i:93;s:57:"modules/field/views_handler_filter_field_list_boolean.inc";i:94;s:58:"modules/field/views_handler_argument_field_list_string.inc";i:95;s:49:"modules/field/views_handler_filter_field_list.inc";i:96;s:57:"modules/filter/views_handler_field_filter_format_name.inc";i:97;s:52:"modules/locale/views_handler_field_node_language.inc";i:98;s:53:"modules/locale/views_handler_filter_node_language.inc";i:99;s:54:"modules/locale/views_handler_argument_locale_group.inc";i:100;s:57:"modules/locale/views_handler_argument_locale_language.inc";i:101;s:51:"modules/locale/views_handler_field_locale_group.inc";i:102;s:54:"modules/locale/views_handler_field_locale_language.inc";i:103;s:55:"modules/locale/views_handler_field_locale_link_edit.inc";i:104;s:52:"modules/locale/views_handler_filter_locale_group.inc";i:105;s:55:"modules/locale/views_handler_filter_locale_language.inc";i:106;s:54:"modules/locale/views_handler_filter_locale_version.inc";i:107;s:51:"modules/locale/views_handler_sort_node_language.inc";i:108;s:53:"modules/node/views_handler_argument_dates_various.inc";i:109;s:53:"modules/node/views_handler_argument_node_language.inc";i:110;s:48:"modules/node/views_handler_argument_node_nid.inc";i:111;s:49:"modules/node/views_handler_argument_node_type.inc";i:112;s:48:"modules/node/views_handler_argument_node_vid.inc";i:113;s:57:"modules/node/views_handler_argument_node_uid_revision.inc";i:114;s:59:"modules/node/views_handler_field_history_user_timestamp.inc";i:115;s:41:"modules/node/views_handler_field_node.inc";i:116;s:46:"modules/node/views_handler_field_node_link.inc";i:117;s:53:"modules/node/views_handler_field_node_link_delete.inc";i:118;s:51:"modules/node/views_handler_field_node_link_edit.inc";i:119;s:50:"modules/node/views_handler_field_node_revision.inc";i:120;s:55:"modules/node/views_handler_field_node_revision_link.inc";i:121;s:62:"modules/node/views_handler_field_node_revision_link_delete.inc";i:122;s:62:"modules/node/views_handler_field_node_revision_link_revert.inc";i:123;s:46:"modules/node/views_handler_field_node_path.inc";i:124;s:46:"modules/node/views_handler_field_node_type.inc";i:125;s:55:"modules/node/views_handler_field_node_version_count.inc";i:126;s:60:"modules/node/views_handler_filter_history_user_timestamp.inc";i:127;s:49:"modules/node/views_handler_filter_node_access.inc";i:128;s:49:"modules/node/views_handler_filter_node_status.inc";i:129;s:47:"modules/node/views_handler_filter_node_type.inc";i:130;s:55:"modules/node/views_handler_filter_node_uid_revision.inc";i:131;s:56:"modules/node/views_handler_filter_node_version_count.inc";i:132;s:54:"modules/node/views_handler_sort_node_version_count.inc";i:133;s:51:"modules/node/views_plugin_argument_default_node.inc";i:134;s:52:"modules/node/views_plugin_argument_validate_node.inc";i:135;s:42:"modules/node/views_plugin_row_node_rss.inc";i:136;s:43:"modules/node/views_plugin_row_node_view.inc";i:137;s:52:"modules/profile/views_handler_field_profile_date.inc";i:138;s:52:"modules/profile/views_handler_field_profile_list.inc";i:139;s:58:"modules/profile/views_handler_filter_profile_selection.inc";i:140;s:48:"modules/search/views_handler_argument_search.inc";i:141;s:51:"modules/search/views_handler_field_search_score.inc";i:142;s:46:"modules/search/views_handler_filter_search.inc";i:143;s:50:"modules/search/views_handler_sort_search_score.inc";i:144;s:47:"modules/search/views_plugin_row_search_view.inc";i:145;s:57:"modules/statistics/views_handler_field_accesslog_path.inc";i:146;s:65:"modules/statistics/views_handler_field_node_counter_timestamp.inc";i:147;s:61:"modules/statistics/views_handler_field_statistics_numeric.inc";i:148;s:50:"modules/system/views_handler_argument_file_fid.inc";i:149;s:43:"modules/system/views_handler_field_file.inc";i:150;s:53:"modules/system/views_handler_field_file_extension.inc";i:151;s:52:"modules/system/views_handler_field_file_filemime.inc";i:152;s:47:"modules/system/views_handler_field_file_uri.inc";i:153;s:50:"modules/system/views_handler_field_file_status.inc";i:154;s:51:"modules/system/views_handler_filter_file_status.inc";i:155;s:52:"modules/taxonomy/views_handler_argument_taxonomy.inc";i:156;s:57:"modules/taxonomy/views_handler_argument_term_node_tid.inc";i:157;s:63:"modules/taxonomy/views_handler_argument_term_node_tid_depth.inc";i:158;s:68:"modules/taxonomy/views_handler_argument_term_node_tid_depth_join.inc";i:159;s:72:"modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc";i:160;s:58:"modules/taxonomy/views_handler_argument_vocabulary_vid.inc";i:161;s:67:"modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc";i:162;s:49:"modules/taxonomy/views_handler_field_taxonomy.inc";i:163;s:54:"modules/taxonomy/views_handler_field_term_node_tid.inc";i:164;s:55:"modules/taxonomy/views_handler_field_term_link_edit.inc";i:165;s:55:"modules/taxonomy/views_handler_filter_term_node_tid.inc";i:166;s:61:"modules/taxonomy/views_handler_filter_term_node_tid_depth.inc";i:167;s:66:"modules/taxonomy/views_handler_filter_term_node_tid_depth_join.inc";i:168;s:56:"modules/taxonomy/views_handler_filter_vocabulary_vid.inc";i:169;s:65:"modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc";i:170;s:62:"modules/taxonomy/views_handler_relationship_node_term_data.inc";i:171;s:65:"modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc";i:172;s:63:"modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc";i:173;s:67:"modules/tracker/views_handler_argument_tracker_comment_user_uid.inc";i:174;s:65:"modules/tracker/views_handler_filter_tracker_comment_user_uid.inc";i:175;s:65:"modules/tracker/views_handler_filter_tracker_boolean_operator.inc";i:176;s:51:"modules/system/views_handler_filter_system_type.inc";i:177;s:56:"modules/translation/views_handler_argument_node_tnid.inc";i:178;s:63:"modules/translation/views_handler_field_node_link_translate.inc";i:179;s:65:"modules/translation/views_handler_field_node_translation_link.inc";i:180;s:54:"modules/translation/views_handler_filter_node_tnid.inc";i:181;s:60:"modules/translation/views_handler_filter_node_tnid_child.inc";i:182;s:62:"modules/translation/views_handler_relationship_translation.inc";i:183;s:48:"modules/user/views_handler_argument_user_uid.inc";i:184;s:55:"modules/user/views_handler_argument_users_roles_rid.inc";i:185;s:41:"modules/user/views_handler_field_user.inc";i:186;s:50:"modules/user/views_handler_field_user_language.inc";i:187;s:46:"modules/user/views_handler_field_user_link.inc";i:188;s:53:"modules/user/views_handler_field_user_link_cancel.inc";i:189;s:51:"modules/user/views_handler_field_user_link_edit.inc";i:190;s:46:"modules/user/views_handler_field_user_mail.inc";i:191;s:46:"modules/user/views_handler_field_user_name.inc";i:192;s:53:"modules/user/views_handler_field_user_permissions.inc";i:193;s:49:"modules/user/views_handler_field_user_picture.inc";i:194;s:47:"modules/user/views_handler_field_user_roles.inc";i:195;s:50:"modules/user/views_handler_filter_user_current.inc";i:196;s:47:"modules/user/views_handler_filter_user_name.inc";i:197;s:54:"modules/user/views_handler_filter_user_permissions.inc";i:198;s:48:"modules/user/views_handler_filter_user_roles.inc";i:199;s:59:"modules/user/views_plugin_argument_default_current_user.inc";i:200;s:51:"modules/user/views_plugin_argument_default_user.inc";i:201;s:52:"modules/user/views_plugin_argument_validate_user.inc";i:202;s:43:"modules/user/views_plugin_row_user_view.inc";i:203;s:31:"plugins/views_plugin_access.inc";i:204;s:36:"plugins/views_plugin_access_none.inc";i:205;s:36:"plugins/views_plugin_access_perm.inc";i:206;s:36:"plugins/views_plugin_access_role.inc";i:207;s:41:"plugins/views_plugin_argument_default.inc";i:208;s:45:"plugins/views_plugin_argument_default_php.inc";i:209;s:47:"plugins/views_plugin_argument_default_fixed.inc";i:210;s:45:"plugins/views_plugin_argument_default_raw.inc";i:211;s:42:"plugins/views_plugin_argument_validate.inc";i:212;s:50:"plugins/views_plugin_argument_validate_numeric.inc";i:213;s:46:"plugins/views_plugin_argument_validate_php.inc";i:214;s:30:"plugins/views_plugin_cache.inc";i:215;s:35:"plugins/views_plugin_cache_none.inc";i:216;s:35:"plugins/views_plugin_cache_time.inc";i:217;s:32:"plugins/views_plugin_display.inc";i:218;s:43:"plugins/views_plugin_display_attachment.inc";i:219;s:38:"plugins/views_plugin_display_block.inc";i:220;s:40:"plugins/views_plugin_display_default.inc";i:221;s:38:"plugins/views_plugin_display_embed.inc";i:222;s:41:"plugins/views_plugin_display_extender.inc";i:223;s:37:"plugins/views_plugin_display_feed.inc";i:224;s:37:"plugins/views_plugin_display_page.inc";i:225;s:43:"plugins/views_plugin_exposed_form_basic.inc";i:226;s:37:"plugins/views_plugin_exposed_form.inc";i:227;s:52:"plugins/views_plugin_exposed_form_input_required.inc";i:228;s:42:"plugins/views_plugin_localization_core.inc";i:229;s:37:"plugins/views_plugin_localization.inc";i:230;s:42:"plugins/views_plugin_localization_none.inc";i:231;s:30:"plugins/views_plugin_pager.inc";i:232;s:35:"plugins/views_plugin_pager_full.inc";i:233;s:35:"plugins/views_plugin_pager_mini.inc";i:234;s:35:"plugins/views_plugin_pager_none.inc";i:235;s:35:"plugins/views_plugin_pager_some.inc";i:236;s:30:"plugins/views_plugin_query.inc";i:237;s:38:"plugins/views_plugin_query_default.inc";i:238;s:28:"plugins/views_plugin_row.inc";i:239;s:35:"plugins/views_plugin_row_fields.inc";i:240;s:39:"plugins/views_plugin_row_rss_fields.inc";i:241;s:30:"plugins/views_plugin_style.inc";i:242;s:38:"plugins/views_plugin_style_default.inc";i:243;s:35:"plugins/views_plugin_style_grid.inc";i:244;s:35:"plugins/views_plugin_style_list.inc";i:245;s:40:"plugins/views_plugin_style_jump_menu.inc";i:246;s:38:"plugins/views_plugin_style_mapping.inc";i:247;s:34:"plugins/views_plugin_style_rss.inc";i:248;s:38:"plugins/views_plugin_style_summary.inc";i:249;s:48:"plugins/views_plugin_style_summary_jump_menu.inc";i:250;s:50:"plugins/views_plugin_style_summary_unformatted.inc";i:251;s:36:"plugins/views_plugin_style_table.inc";i:252;s:34:"tests/handlers/views_handlers.test";i:253;s:43:"tests/handlers/views_handler_area_text.test";i:254;s:47:"tests/handlers/views_handler_argument_null.test";i:255;s:49:"tests/handlers/views_handler_argument_string.test";i:256;s:39:"tests/handlers/views_handler_field.test";i:257;s:47:"tests/handlers/views_handler_field_boolean.test";i:258;s:46:"tests/handlers/views_handler_field_custom.test";i:259;s:47:"tests/handlers/views_handler_field_counter.test";i:260;s:44:"tests/handlers/views_handler_field_date.test";i:261;s:54:"tests/handlers/views_handler_field_file_extension.test";i:262;s:49:"tests/handlers/views_handler_field_file_size.test";i:263;s:44:"tests/handlers/views_handler_field_math.test";i:264;s:43:"tests/handlers/views_handler_field_url.test";i:265;s:43:"tests/handlers/views_handler_field_xss.test";i:266;s:48:"tests/handlers/views_handler_filter_combine.test";i:267;s:45:"tests/handlers/views_handler_filter_date.test";i:268;s:49:"tests/handlers/views_handler_filter_equality.test";i:269;s:52:"tests/handlers/views_handler_filter_in_operator.test";i:270;s:48:"tests/handlers/views_handler_filter_numeric.test";i:271;s:47:"tests/handlers/views_handler_filter_string.test";i:272;s:45:"tests/handlers/views_handler_sort_random.test";i:273;s:43:"tests/handlers/views_handler_sort_date.test";i:274;s:38:"tests/handlers/views_handler_sort.test";i:275;s:46:"tests/test_handlers/views_test_area_access.inc";i:276;s:60:"tests/test_plugins/views_test_plugin_access_test_dynamic.inc";i:277;s:59:"tests/test_plugins/views_test_plugin_access_test_static.inc";i:278;s:59:"tests/test_plugins/views_test_plugin_style_test_mapping.inc";i:279;s:39:"tests/plugins/views_plugin_display.test";i:280;s:46:"tests/styles/views_plugin_style_jump_menu.test";i:281;s:36:"tests/styles/views_plugin_style.test";i:282;s:41:"tests/styles/views_plugin_style_base.test";i:283;s:44:"tests/styles/views_plugin_style_mapping.test";i:284;s:48:"tests/styles/views_plugin_style_unformatted.test";i:285;s:23:"tests/views_access.test";i:286;s:24:"tests/views_analyze.test";i:287;s:22:"tests/views_basic.test";i:288;s:33:"tests/views_argument_default.test";i:289;s:35:"tests/views_argument_validator.test";i:290;s:29:"tests/views_exposed_form.test";i:291;s:31:"tests/field/views_fieldapi.test";i:292;s:25:"tests/views_glossary.test";i:293;s:24:"tests/views_groupby.test";i:294;s:25:"tests/views_handlers.test";i:295;s:23:"tests/views_module.test";i:296;s:22:"tests/views_pager.test";i:297;s:40:"tests/views_plugin_localization_test.inc";i:298;s:29:"tests/views_translatable.test";i:299;s:22:"tests/views_query.test";i:300;s:24:"tests/views_upgrade.test";i:301;s:34:"tests/views_test.views_default.inc";i:302;s:58:"tests/comment/views_handler_argument_comment_user_uid.test";i:303;s:56:"tests/comment/views_handler_filter_comment_user_uid.test";i:304;s:45:"tests/node/views_node_revision_relations.test";i:305;s:61:"tests/taxonomy/views_handler_relationship_node_term_data.test";i:306;s:45:"tests/user/views_handler_field_user_name.test";i:307;s:43:"tests/user/views_user_argument_default.test";i:308;s:44:"tests/user/views_user_argument_validate.test";i:309;s:26:"tests/user/views_user.test";i:310;s:22:"tests/views_cache.test";i:311;s:21:"tests/views_view.test";i:312;s:19:"tests/views_ui.test";}s:7:"version";s:8:"7.x-3.16";s:7:"project";s:5:"views";s:9:"datestamp";s:10:"1491158591";s:5:"mtime";i:1491158591;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/views/views_ui.module','views_ui','module','','1','0','0','0','a:13:{s:4:"name";s:8:"Views UI";s:11:"description";s:93:"Administrative interface to views. Without this module, you cannot create or edit your views.";s:7:"package";s:5:"Views";s:4:"core";s:3:"7.x";s:9:"configure";s:21:"admin/structure/views";s:12:"dependencies";a:1:{i:0;s:5:"views";}s:5:"files";a:2:{i:0;s:15:"views_ui.module";i:1;s:57:"plugins/views_wizard/views_ui_base_views_wizard.class.php";}s:7:"version";s:8:"7.x-3.16";s:7:"project";s:5:"views";s:9:"datestamp";s:10:"1491158591";s:5:"mtime";i:1491158591;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/views_bulk_operations/actions_permissions.module','actions_permissions','module','','0','0','-1','0','a:12:{s:4:"name";s:25:"Actions permissions (VBO)";s:11:"description";s:84:"Provides permission-based access control for actions. Used by Views Bulk Operations.";s:7:"package";s:14:"Administration";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-3.3";s:7:"project";s:21:"views_bulk_operations";s:9:"datestamp";s:10:"1435764542";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/views_bulk_operations/views_bulk_operations.module','views_bulk_operations','module','','1','0','0','0','a:12:{s:4:"name";s:21:"Views Bulk Operations";s:11:"description";s:74:"Provides a way of selecting multiple rows and applying operations to them.";s:12:"dependencies";a:2:{i:0;s:6:"entity";i:1;s:5:"views";}s:7:"package";s:5:"Views";s:4:"core";s:3:"7.x";s:3:"php";s:5:"5.2.9";s:5:"files";a:2:{i:0;s:38:"plugins/operation_types/base.class.php";i:1;s:56:"views/views_bulk_operations_handler_field_operations.inc";}s:7:"version";s:7:"7.x-3.3";s:7:"project";s:21:"views_bulk_operations";s:9:"datestamp";s:10:"1435764542";s:5:"mtime";i:1490935291;s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/views_data_export/views_data_export.module','views_data_export','module','','1','0','7301','0','a:12:{s:4:"name";s:17:"Views Data Export";s:11:"description";s:53:"Plugin to export views data into various file formats";s:7:"package";s:5:"Views";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:5:"views";}s:5:"files";a:12:{i:0;s:51:"plugins/views_data_export_plugin_display_export.inc";i:1;s:49:"plugins/views_data_export_plugin_style_export.inc";i:2;s:53:"plugins/views_data_export_plugin_style_export_csv.inc";i:3;s:53:"plugins/views_data_export_plugin_style_export_xml.inc";i:4;s:15:"tests/base.test";i:5;s:17:"tests/access.test";i:6;s:28:"tests/garbagecollection.test";i:7;s:21:"tests/csv_export.test";i:8;s:21:"tests/doc_export.test";i:9;s:21:"tests/txt_export.test";i:10;s:21:"tests/xls_export.test";i:11;s:21:"tests/xml_export.test";}s:7:"version";s:7:"7.x-3.1";s:7:"project";s:17:"views_data_export";s:9:"datestamp";s:10:"1474360174";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/workflow/workflow.module','workflow','module','','1','0','7017','0','a:12:{s:4:"name";s:12:"Workflow API";s:11:"description";s:94:"Workflow API. (Enable Workflow Node or Workflow Field to add arbitrary workflows to entities.)";s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:17:"entity (>7.x-1.5)";}s:5:"files";a:10:{i:0;s:28:"includes/Entity/Workflow.php";i:1;s:37:"includes/Entity/WorkflowInterface.php";i:2;s:33:"includes/Entity/WorkflowState.php";i:3;s:44:"includes/Entity/WorkflowConfigTransition.php";i:4;s:47:"includes/Entity/WorkflowScheduledTransition.php";i:5;s:38:"includes/Entity/WorkflowTransition.php";i:6;s:33:"includes/Field/WorkflowD7Base.php";i:7;s:31:"includes/Field/WorkflowItem.php";i:8;s:40:"includes/Field/WorkflowDefaultWidget.php";i:9;s:40:"includes/Form/WorkflowTransitionForm.php";}s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/workflow/workflow_access/workflow_access.module','workflow_access','module','','0','0','-1','0','a:12:{s:4:"name";s:15:"Workflow access";s:11:"description";s:130:"Content access control based on workflows and roles. Depends on the node_access system, so only works for entities of type ''node''.";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/workflow/workflow_actions/workflow_actions.module','workflow_actions','module','','0','0','-1','0','a:12:{s:4:"name";s:16:"Workflow Trigger";s:11:"description";s:57:"Enables actions to be fired upon a Workflow State change.";s:12:"dependencies";a:2:{i:0;s:8:"workflow";i:1;s:7:"trigger";}s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/workflow/workflow_admin_ui/workflow_admin_ui.module','workflow_admin_ui','module','','1','0','7001','0','a:14:{s:4:"name";s:11:"Workflow UI";s:11:"description";s:40:"Provides administrative UI for workflow.";s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:9:"configure";s:30:"admin/config/workflow/workflow";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:5:"files";a:1:{i:0;s:46:"includes/Entity/EntityWorkflowUIController.php";}s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:21:"workflow_admin_ui.css";s:74:"sites/all/modules/contrib/workflow/workflow_admin_ui/workflow_admin_ui.css";}}s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/workflow/workflow_cleanup/workflow_cleanup.module','workflow_cleanup','module','','0','0','-1','0','a:13:{s:4:"name";s:17:"Workflow Clean Up";s:11:"description";s:25:"Cleans up Workflow cruft.";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:4:"core";s:3:"7.x";s:7:"package";s:8:"Workflow";s:9:"configure";s:38:"admin/config/workflow/workflow/cleanup";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/workflow/workflow_field/workflowfield.module','workflowfield','module','','0','0','-1','0','a:12:{s:4:"name";s:14:"Workflow Field";s:11:"description";s:106:"Defines a Workflow field, widget and formatter. (Do not enable Workflow Field and Workflow Node together.)";s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:12:"dependencies";a:4:{i:0;s:6:"entity";i:1;s:5:"field";i:2;s:7:"options";i:3;s:8:"workflow";}s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/workflow/workflow_node/workflownode.module','workflownode','module','','0','0','-1','0','a:12:{s:4:"name";s:13:"Workflow Node";s:11:"description";s:115:"Adds a Workflow to nodes. (Use only if you come from a version below 7.x-2.x. If not, use ''Workfow Field'' instead).";s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/workflow/workflow_notify/workflow_notify.module','workflow_notify','module','','0','0','-1','0','a:13:{s:4:"name";s:15:"Workflow Notify";s:11:"description";s:37:"Notify roles of Workflow transitions.";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:9:"configure";s:30:"admin/config/workflow/workflow";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Workflow";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/workflow/workflow_notify/workflow_notify_og/workflow_notify_og.module','workflow_notify_og','module','','0','0','-1','0','a:12:{s:4:"name";s:18:"Workflow Notify OG";s:11:"description";s:50:"Notify roles by OG groups of Workflow transitions.";s:12:"dependencies";a:1:{i:0;s:15:"workflow_notify";}s:4:"core";s:3:"7.x";s:7:"package";s:8:"Workflow";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/workflow/workflow_revert/workflow_revert.module','workflow_revert','module','','0','0','-1','0','a:12:{s:4:"name";s:15:"Workflow Revert";s:11:"description";s:55:"Adds a ''Revert'' link to the first workflow history row.";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:4:"core";s:3:"7.x";s:7:"package";s:8:"Workflow";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/workflow/workflow_rules/workflow_rules.module','workflow_rules','module','','1','0','0','0','a:13:{s:4:"name";s:14:"Workflow Rules";s:11:"description";s:57:"Provides additional, workflow-specific Rules integration.";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Workflow";s:12:"dependencies";a:2:{i:0;s:8:"workflow";i:1;s:5:"rules";}s:9:"configure";s:27:"admin/config/workflow/rules";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/workflow/workflow_search_api/workflow_search_api.module','workflow_search_api','module','','0','0','-1','0','a:12:{s:4:"name";s:24:"Workflow Node Search API";s:11:"description";s:59:"Adds Workflow Node''s state information to Search API index.";s:12:"dependencies";a:3:{i:0;s:8:"workflow";i:1;s:12:"workflownode";i:2;s:6:"entity";}s:4:"core";s:3:"7.x";s:7:"package";s:8:"Workflow";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/workflow/workflow_vbo/workflow_vbo.module','workflow_vbo','module','','0','0','-1','0','a:12:{s:4:"name";s:16:"Workflow Actions";s:11:"description";s:175:"Provides actions that can be associated to triggers, or\n               used as VBO-action. Provided actions are ''set to next state''\n               and ''set to specific state''.";s:12:"dependencies";a:1:{i:0;s:8:"workflow";}s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/workflow/workflow_views/workflow_views.module','workflow_views','module','','0','0','-1','0','a:12:{s:4:"name";s:14:"Workflow views";s:11:"description";s:41:"Provides views integration for workflows.";s:7:"package";s:8:"Workflow";s:4:"core";s:3:"7.x";s:12:"dependencies";a:2:{i:0;s:8:"workflow";i:1;s:12:"views (>3.3)";}s:5:"files";a:7:{i:0;s:46:"handlers/workflow_views_handler_filter_sid.inc";i:1;s:45:"handlers/workflow_views_handler_field_sid.inc";i:2;s:47:"handlers/workflow_views_handler_field_state.inc";i:3;s:50:"handlers/workflow_views_handler_field_username.inc";i:4;s:60:"handlers/workflow_views_handler_field_node_link_workflow.inc";i:5;s:59:"handlers/workflow_views_handler_field_comment_link_edit.inc";i:6;s:50:"handlers/workflow_views_handler_argument_state.inc";}s:7:"version";s:7:"7.x-2.8";s:7:"project";s:8:"workflow";s:9:"datestamp";s:10:"1451565855";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/contrib/wysiwyg/tests/wysiwyg_test.module','wysiwyg_test','module','','0','0','-1','0','a:13:{s:4:"name";s:15:"Wysiwyg testing";s:11:"description";s:50:"Tests Wysiwyg module functionality. Do not enable.";s:4:"core";s:3:"7.x";s:7:"package";s:7:"Testing";s:6:"hidden";b:1;s:12:"dependencies";a:1:{i:0;s:7:"wysiwyg";}s:5:"files";a:1:{i:0;s:19:"wysiwyg_test.module";}s:7:"version";s:7:"7.x-2.3";s:7:"project";s:7:"wysiwyg";s:9:"datestamp";s:10:"1483223295";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/contrib/wysiwyg/wysiwyg.module','wysiwyg','module','','1','0','7204','0','a:13:{s:4:"name";s:7:"Wysiwyg";s:11:"description";s:48:"Allows to edit content with client-side editors.";s:7:"package";s:14:"User interface";s:4:"core";s:3:"7.x";s:9:"configure";s:28:"admin/config/content/wysiwyg";s:5:"files";a:2:{i:0;s:14:"wysiwyg.module";i:1;s:18:"tests/wysiwyg.test";}s:7:"version";s:7:"7.x-2.3";s:7:"project";s:7:"wysiwyg";s:9:"datestamp";s:10:"1483223295";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:9:"bootstrap";i:0;}'),('sites/all/modules/custom/booklist/booklist.module','booklist','module','','1','0','0','0','a:12:{s:4:"name";s:8:"booklist";s:4:"core";s:3:"7.x";s:7:"package";s:10:"Bookpoints";s:7:"version";s:16:"7.x-1.0-beta0319";s:8:"features";a:7:{s:6:"ctools";a:1:{i:0;s:23:"views:views_default:3.0";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:10:"field_base";a:5:{i:0;s:17:"field_bl_b_author";i:1;s:16:"field_bl_b_image";i:2;s:15:"field_bl_b_link";i:3;s:16:"field_bl_b_title";i:4;s:20:"field_booklist_books";}s:14:"field_instance";a:6:{i:0;s:60:"field_collection_item-field_booklist_books-field_bl_b_author";i:1;s:59:"field_collection_item-field_booklist_books-field_bl_b_image";i:2;s:58:"field_collection_item-field_booklist_books-field_bl_b_link";i:3;s:59:"field_collection_item-field_booklist_books-field_bl_b_title";i:4;s:19:"node-book_list-body";i:5;s:35:"node-book_list-field_booklist_books";}s:11:"menu_custom";a:2:{i:0;s:9:"main-menu";i:1;s:18:"menu-library-menu1";}s:4:"node";a:1:{i:0;s:9:"book_list";}s:10:"views_view";a:1:{i:0;s:10:"book_lists";}}s:12:"project path";s:24:"sites/all/modules/custom";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:11:"description";s:0:"";s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/custom/bookpoints_drawing/bookpoints_drawing.module','bookpoints_drawing','module','','1','0','0','0','a:13:{s:4:"name";s:18:"Bookpoints Drawing";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Features";s:7:"version";s:17:"7.x-1.0-beta0227a";s:12:"dependencies";a:1:{i:0;s:5:"views";}s:8:"features";a:3:{s:6:"ctools";a:1:{i:0;s:23:"views:views_default:3.0";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:10:"views_view";a:1:{i:0;s:7:"drawing";}}s:16:"features_exclude";a:1:{s:12:"dependencies";a:1:{s:6:"ctools";s:6:"ctools";}}s:12:"project path";s:24:"sites/all/modules/custom";s:5:"mtime";i:1490935291;s:11:"description";s:0:"";s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/custom/bookpoints_events/bookpoints_events.module','bookpoints_events','module','','1','0','0','0','a:13:{s:4:"name";s:17:"Bookpoints Events";s:4:"core";s:3:"7.x";s:7:"package";s:8:"Features";s:7:"version";s:17:"7.x-1.0-beta0319b";s:12:"dependencies";a:8:{i:0;s:8:"calendar";i:1;s:4:"date";i:2;s:10:"date_views";i:3;s:15:"entityreference";i:4;s:8:"features";i:5;s:7:"options";i:6;s:4:"text";i:7;s:5:"views";}s:8:"features";a:6:{s:6:"ctools";a:1:{i:0;s:23:"views:views_default:3.0";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:10:"field_base";a:3:{i:0;s:4:"body";i:1;s:10:"field_date";i:2;s:13:"field_program";}s:14:"field_instance";a:3:{i:0;s:15:"node-event-body";i:1;s:21:"node-event-field_date";i:2;s:24:"node-event-field_program";}s:4:"node";a:1:{i:0;s:5:"event";}s:10:"views_view";a:2:{i:0;s:8:"calendar";i:1;s:13:"manage_events";}}s:16:"features_exclude";a:1:{s:12:"dependencies";a:1:{s:6:"ctools";s:6:"ctools";}}s:12:"project path";s:24:"sites/all/modules/custom";s:5:"mtime";i:1490935291;s:11:"description";s:0:"";s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/custom/bookpoints_importers/bookpoints_importers.module','bookpoints_importers','module','','1','0','0','0','a:12:{s:4:"name";s:20:"Bookpoints Importers";s:4:"core";s:3:"7.x";s:7:"package";s:10:"Bookpoints";s:7:"version";s:16:"7.x-1.0-beta0324";s:12:"dependencies";a:4:{i:0;s:6:"ctools";i:1;s:3:"eck";i:2;s:5:"feeds";i:3;s:22:"feeds_entity_processor";}s:8:"features";a:3:{s:6:"ctools";a:1:{i:0;s:30:"feeds:feeds_importer_default:1";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:14:"feeds_importer";a:7:{i:0;s:17:"import_activities";i:1;s:13:"import_badges";i:2;s:15:"import_branches";i:3;s:13:"import_prizes";i:4;s:14:"import_schools";i:5;s:19:"import_secret_codes";i:6;s:21:"import_staff_accounts";}}s:12:"project path";s:24:"sites/all/modules/custom";s:5:"mtime";i:1490935291;s:11:"description";s:0:"";s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/custom/book_logs/book_logs.module','book_logs','module','','1','0','0','0','a:13:{s:4:"name";s:9:"Book Logs";s:11:"description";s:34:"Shows a user''s reader''s books read";s:4:"core";s:3:"7.x";s:7:"package";s:10:"Bookpoints";s:7:"version";s:17:"7.x-1.0-beta0319b";s:12:"dependencies";a:1:{i:0;s:5:"views";}s:8:"features";a:3:{s:6:"ctools";a:1:{i:0;s:23:"views:views_default:3.0";}s:12:"features_api";a:1:{i:0;s:5:"api:2";}s:10:"views_view";a:1:{i:0;s:9:"book_logs";}}s:16:"features_exclude";a:1:{s:12:"dependencies";a:1:{s:6:"ctools";s:6:"ctools";}}s:12:"project path";s:24:"sites/all/modules/custom";s:5:"mtime";i:1490935291;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/custom/galecia_model/galecia_model.module','galecia_model','module','','1','0','0','0','a:10:{s:4:"name";s:20:"Galecia Model Module";s:11:"description";s:73:"A custom module containing various functionality for the Galecia Project.";s:4:"core";s:3:"7.x";s:7:"package";s:9:"Dashboard";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:7:"version";N;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/custom/galecia_profile_builder/galecia_profile_builder.module','galecia_profile_builder','module','','1','0','0','0','a:10:{s:4:"name";s:23:"Galecia Profile Builder";s:11:"description";s:68:"This module will create a custom node form to add users and readers.";s:4:"core";s:3:"7.x";s:7:"package";s:12:"Custom Forms";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:7:"version";N;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/modules/custom/galecia_reader_dashboard/galecia_reader_dashboard.module','galecia_reader_dashboard','module','','1','0','0','0','a:10:{s:4:"name";s:31:"Galecia Reader Dashboard Module";s:11:"description";s:82:"A custom module containing various functionality for the Galecia Reader Dashboard.";s:4:"core";s:3:"7.x";s:7:"package";s:9:"Dashboard";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:7:"version";N;s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}');
INSERT INTO `system` VALUES ('sites/all/modules/custom/library_dashboard/library_dashboard.module','library_dashboard','module','','1','0','0','0','a:13:{s:4:"name";s:24:"Library Dashboard Module";s:11:"description";s:83:"A custom module containing various functionality for the Galicia Library Dashboard.";s:7:"package";s:7:"Galicia";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:16:"/css/galicia.css";s:59:"sites/all/modules/custom/library_dashboard//css/galicia.css";}}s:7:"version";s:7:"7.x-1.x";s:4:"core";s:3:"7.x";s:7:"project";s:17:"library_dashboard";s:9:"datestamp";s:10:"1426097283";s:5:"mtime";i:1490935291;s:12:"dependencies";a:0:{}s:3:"php";s:5:"5.2.4";s:5:"files";a:0:{}s:9:"bootstrap";i:0;}'),('sites/all/themes/adaptivetheme/at_admin/adaptivetheme_admin.info','adaptivetheme_admin','theme','themes/engines/phptemplate/phptemplate.engine','0','0','-1','0','a:20:{s:4:"name";s:8:"AT Admin";s:11:"description";s:144:"A better admin theme for Drupal 7. Clean, calm, invisible. Includes left and right sidebars, Overlay support and all AT''s theme setting goodies.";s:4:"core";s:3:"7.x";s:10:"base theme";s:13:"adaptivetheme";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:54:"sites/all/themes/adaptivetheme/at_admin/screenshot.png";s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:16:"css/at_admin.css";s:56:"sites/all/themes/adaptivetheme/at_admin/css/at_admin.css";}}s:7:"regions";a:11:{s:7:"content";s:12:"Main content";s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:11:"highlighted";s:11:"Highlighted";s:4:"help";s:4:"Help";s:6:"footer";s:6:"Footer";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"settings";a:210:{s:20:"shortcut_module_link";s:1:"1";s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:2:"px";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:3:"180";s:24:"bigscreen_sidebar_second";s:3:"180";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1330";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:581px) and (max-width:768px)";s:27:"smalltouch_landscape_layout";s:12:"one_col_vert";s:30:"smalltouch_landscape_page_unit";s:1:"%";s:33:"smalltouch_landscape_sidebar_unit";s:1:"%";s:31:"smalltouch_landscape_page_width";s:3:"100";s:34:"smalltouch_landscape_sidebar_first";s:2:"50";s:35:"smalltouch_landscape_sidebar_second";s:2:"50";s:32:"smalltouch_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:580px)";s:26:"smalltouch_portrait_layout";s:13:"one_col_stack";s:29:"smalltouch_portrait_page_unit";s:1:"%";s:32:"smalltouch_portrait_sidebar_unit";s:1:"%";s:30:"smalltouch_portrait_page_width";s:3:"100";s:33:"smalltouch_portrait_sidebar_first";s:3:"100";s:34:"smalltouch_portrait_sidebar_second";s:3:"100";s:31:"smalltouch_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:9:"five-5x20";s:18:"bigscreen_six_6x16";s:8:"six-6x16";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:18:"five-5x20-2x3-grid";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smalltouch_landscape_two_50";s:12:"two-50-stack";s:30:"smalltouch_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smalltouch_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smalltouch_landscape_two_brick";s:15:"two-brick-stack";s:31:"smalltouch_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smalltouch_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smalltouch_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smalltouch_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smalltouch_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smalltouch_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smalltouch_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smalltouch_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smalltouch_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"0";s:21:"global_default_layout";s:19:"smalltouch-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:19:"load_onmediaqueryjs";s:1:"0";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"1";s:20:"enable_font_settings";s:1:"0";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"0";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"1";s:14:"base_font_type";s:0:"";s:19:"site_name_font_type";s:0:"";s:21:"site_slogan_font_type";s:0:"";s:20:"page_title_font_type";s:0:"";s:20:"node_title_font_type";s:0:"";s:23:"comment_title_font_type";s:0:"";s:21:"block_title_font_type";s:0:"";s:9:"base_font";s:6:"bf-sss";s:14:"site_name_font";s:6:"snf-sl";s:16:"site_slogan_font";s:6:"ssf-sl";s:14:"main_menu_font";s:6:"mmf-sl";s:15:"page_title_font";s:6:"ptf-sl";s:15:"node_title_font";s:6:"ntf-sl";s:18:"comment_title_font";s:6:"ctf-sl";s:16:"block_title_font";s:6:"btf-sl";s:14:"base_font_size";s:3:"1em";s:19:"site_name_font_size";s:3:"2em";s:21:"site_slogan_font_size";s:5:"1.2em";s:20:"page_title_font_size";s:3:"2em";s:20:"node_title_font_size";s:5:"1.6em";s:23:"comment_title_font_size";s:5:"1.4em";s:21:"block_title_font_size";s:5:"1.4em";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:14:"site_name_case";s:5:"snc-n";s:16:"site_name_weight";s:5:"snw-b";s:19:"site_name_alignment";s:5:"sna-l";s:16:"site_name_shadow";s:5:"sns-n";s:16:"site_slogan_case";s:5:"ssc-n";s:18:"site_slogan_weight";s:5:"ssw-b";s:21:"site_slogan_alignment";s:5:"ssa-l";s:18:"site_slogan_shadow";s:5:"sss-n";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:6:"btc-uc";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-l";s:22:"image_alignment_teaser";s:5:"iat-l";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"1";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"1";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:10:"rel_author";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:56:"width=device-width, initial-scale=1.0, user-scalable=yes";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:35:"adaptivetheme_meta_ie_document_mode";s:0:"";s:29:"adaptivetheme_meta_clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:23:"images/touch-icon-l.png";s:23:"apple_touch_icon_path_m";s:23:"images/touch-icon-m.png";s:23:"apple_touch_icon_path_h";s:23:"images/touch-icon-h.png";s:10:"custom_css";s:0:"";}s:8:"features";a:5:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:7:"favicon";i:3;s:9:"main_menu";i:4;s:14:"secondary_menu";}s:7:"version";s:7:"7.x-3.2";s:7:"project";s:13:"adaptivetheme";s:9:"datestamp";s:10:"1395575059";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}');
INSERT INTO `system` VALUES ('sites/all/themes/adaptivetheme/at_core/adaptivetheme.info','adaptivetheme','theme','themes/engines/phptemplate/phptemplate.engine','0','0','-1','0','a:21:{s:4:"name";s:7:"AT Core";s:11:"description";s:210:"AT Core is the framework that drives the responsive layout system and provides an extensive set of tools for theme development. You do not need to enable this theme. Use the provided AT Subtheme to get started.";s:4:"core";s:3:"7.x";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:53:"sites/all/themes/adaptivetheme/at_core/screenshot.png";s:11:"stylesheets";a:1:{s:6:"screen";a:1:{s:17:"css/at.layout.css";s:56:"sites/all/themes/adaptivetheme/at_core/css/at.layout.css";}}s:10:"unset_core";a:37:{s:33:"modules/aggregator/aggregator.css";s:14:"aggregator.css";s:23:"modules/block/block.css";s:9:"block.css";s:21:"modules/book/book.css";s:8:"book.css";s:23:"modules/color/color.css";s:9:"color.css";s:27:"modules/comment/comment.css";s:11:"comment.css";s:33:"modules/contextual/contextual.css";s:14:"contextual.css";s:31:"modules/dashboard/dashboard.css";s:13:"dashboard.css";s:23:"modules/dblog/dblog.css";s:9:"dblog.css";s:29:"modules/field/theme/field.css";s:9:"field.css";s:29:"modules/field_ui/field_ui.css";s:12:"field_ui.css";s:21:"modules/file/file.css";s:8:"file.css";s:25:"modules/filter/filter.css";s:10:"filter.css";s:23:"modules/forum/forum.css";s:9:"forum.css";s:21:"modules/help/help.css";s:8:"help.css";s:29:"modules/image/image.admin.css";s:15:"image.admin.css";s:23:"modules/image/image.css";s:9:"image.css";s:25:"modules/locale/locale.css";s:10:"locale.css";s:21:"modules/menu/menu.css";s:8:"menu.css";s:21:"modules/node/node.css";s:8:"node.css";s:25:"modules/openid/openid.css";s:10:"openid.css";s:21:"modules/poll/poll.css";s:8:"poll.css";s:27:"modules/profile/profile.css";s:11:"profile.css";s:25:"modules/search/search.css";s:10:"search.css";s:35:"modules/shortcut/shortcut.admin.css";s:18:"shortcut.admin.css";s:29:"modules/shortcut/shortcut.css";s:12:"shortcut.css";s:33:"modules/simpletest/simpletest.css";s:14:"simpletest.css";s:31:"modules/system/system.admin.css";s:16:"system.admin.css";s:30:"modules/system/system.base.css";s:15:"system.base.css";s:37:"modules/system/system.maintenance.css";s:22:"system.maintenance.css";s:31:"modules/system/system.menus.css";s:16:"system.menus.css";s:34:"modules/system/system.messages.css";s:19:"system.messages.css";s:31:"modules/system/system.theme.css";s:16:"system.theme.css";s:29:"modules/taxonomy/taxonomy.css";s:12:"taxonomy.css";s:27:"modules/toolbar/toolbar.css";s:11:"toolbar.css";s:27:"modules/tracker/tracker.css";s:11:"tracker.css";s:25:"modules/update/update.css";s:10:"update.css";s:21:"modules/user/user.css";s:8:"user.css";}s:7:"regions";a:17:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:7:"content";s:12:"Main Content";s:11:"highlighted";s:11:"Highlighted";s:13:"content_aside";s:5:"Aside";s:17:"secondary_content";s:9:"Secondary";s:16:"tertiary_content";s:8:"Tertiary";s:6:"footer";s:6:"Footer";s:11:"leaderboard";s:11:"Leaderboard";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:7:"plugins";a:2:{s:11:"page_layout";a:1:{s:7:"layouts";s:12:"layouts/core";}s:6:"panels";a:1:{s:7:"layouts";s:14:"layouts/panels";}}s:8:"settings";a:209:{s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1140";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:581px) and (max-width:768px)";s:27:"smalltouch_landscape_layout";s:12:"one_col_vert";s:30:"smalltouch_landscape_page_unit";s:1:"%";s:33:"smalltouch_landscape_sidebar_unit";s:1:"%";s:31:"smalltouch_landscape_page_width";s:3:"100";s:34:"smalltouch_landscape_sidebar_first";s:2:"50";s:35:"smalltouch_landscape_sidebar_second";s:2:"50";s:32:"smalltouch_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:580px)";s:26:"smalltouch_portrait_layout";s:13:"one_col_stack";s:29:"smalltouch_portrait_page_unit";s:1:"%";s:32:"smalltouch_portrait_sidebar_unit";s:1:"%";s:30:"smalltouch_portrait_page_width";s:3:"100";s:33:"smalltouch_portrait_sidebar_first";s:3:"100";s:34:"smalltouch_portrait_sidebar_second";s:3:"100";s:31:"smalltouch_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:9:"five-5x20";s:18:"bigscreen_six_6x16";s:8:"six-6x16";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:9:"five-5x20";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smalltouch_landscape_two_50";s:12:"two-50-stack";s:30:"smalltouch_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smalltouch_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smalltouch_landscape_two_brick";s:15:"two-brick-stack";s:31:"smalltouch_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smalltouch_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smalltouch_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smalltouch_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smalltouch_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smalltouch_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smalltouch_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smalltouch_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smalltouch_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"1";s:21:"global_default_layout";s:19:"smalltouch-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:19:"load_onmediaqueryjs";s:1:"0";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"0";s:20:"enable_font_settings";s:1:"0";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"0";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"0";s:14:"base_font_type";s:6:"<none>";s:19:"site_name_font_type";s:6:"<none>";s:21:"site_slogan_font_type";s:6:"<none>";s:20:"page_title_font_type";s:6:"<none>";s:20:"node_title_font_type";s:6:"<none>";s:23:"comment_title_font_type";s:6:"<none>";s:21:"block_title_font_type";s:6:"<none>";s:19:"main_menu_font_type";s:6:"<none>";s:24:"secondary_menu_font_type";s:6:"<none>";s:20:"block_menu_font_type";s:6:"<none>";s:19:"selectors_font_type";s:6:"<none>";s:14:"base_font_size";s:6:"<none>";s:19:"site_name_font_size";s:6:"<none>";s:21:"site_slogan_font_size";s:6:"<none>";s:20:"page_title_font_size";s:6:"<none>";s:20:"node_title_font_size";s:6:"<none>";s:23:"comment_title_font_size";s:6:"<none>";s:21:"block_title_font_size";s:6:"<none>";s:19:"main_menu_font_size";s:6:"<none>";s:24:"secondary_menu_font_size";s:6:"<none>";s:20:"block_menu_font_size";s:6:"<none>";s:31:"content_headings_h1h4_font_type";s:6:"<none>";s:31:"content_headings_h5h6_font_type";s:6:"<none>";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:14:"site_name_case";s:5:"snc-n";s:16:"site_name_weight";s:5:"snw-b";s:19:"site_name_alignment";s:5:"sna-l";s:16:"site_name_shadow";s:5:"sns-n";s:16:"site_slogan_case";s:5:"ssc-n";s:18:"site_slogan_weight";s:5:"ssw-b";s:21:"site_slogan_alignment";s:5:"ssa-l";s:18:"site_slogan_shadow";s:5:"sss-n";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-l";s:22:"image_alignment_teaser";s:5:"iat-l";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:10:"rel_author";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:56:"width=device-width, initial-scale=1.0, user-scalable=yes";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:35:"adaptivetheme_meta_ie_document_mode";s:0:"";s:29:"adaptivetheme_meta_clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:0:"";s:23:"apple_touch_icon_path_m";s:0:"";s:23:"apple_touch_icon_path_h";s:0:"";s:10:"custom_css";s:0:"";}s:7:"version";s:7:"7.x-3.2";s:7:"project";s:13:"adaptivetheme";s:9:"datestamp";s:10:"1395575059";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}');
INSERT INTO `system` VALUES ('sites/all/themes/adaptivetheme/at_subtheme/adaptivetheme_subtheme.info','adaptivetheme_subtheme','theme','themes/engines/phptemplate/phptemplate.engine','0','0','-1','0','a:21:{s:4:"name";s:11:"AT Subtheme";s:11:"description";s:580:"Copy this subtheme to get started - see the <b><a href="http://adaptivethemes.com/documentation/adaptivethemes-documentation" target="_blank" title="Adaptivethemes.com - Rocking the hardest since 2006">documentation</a></b> for guidence or the included README. Drush users can generate a new theme using the command: drush adaptivetheme. If you need help please use the <b><a href="http://drupal.org/project/issues/adaptivetheme" target="_blank">issue queue</a></b> or ask in the IRC channel: <b><a href="irc://irc.freenode.net/drupal-adaptivetheme">#drupal-adaptivetheme</a></b>.";s:4:"core";s:3:"7.x";s:10:"base theme";s:13:"adaptivetheme";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:57:"sites/all/themes/adaptivetheme/at_subtheme/screenshot.png";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:19:"css/global.base.css";s:62:"sites/all/themes/adaptivetheme/at_subtheme/css/global.base.css";s:21:"css/global.styles.css";s:64:"sites/all/themes/adaptivetheme/at_subtheme/css/global.styles.css";}}s:7:"regions";a:17:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:7:"content";s:12:"Main Content";s:11:"highlighted";s:11:"Highlighted";s:13:"content_aside";s:5:"Aside";s:17:"secondary_content";s:9:"Secondary";s:16:"tertiary_content";s:8:"Tertiary";s:6:"footer";s:6:"Footer";s:11:"leaderboard";s:11:"Leaderboard";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:":plugins";a:2:{s:11:"page_layout";a:1:{s:7:"layouts";s:12:"layouts/page";}s:6:"panels";a:1:{s:7:"layouts";s:14:"layouts/panels";}}s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:6:"slogan";i:3;s:17:"node_user_picture";i:4;s:20:"comment_user_picture";i:5;s:25:"comment_user_verification";i:6;s:7:"favicon";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:8:"settings";a:231:{s:11:"toggle_logo";s:1:"1";s:11:"toggle_name";s:1:"1";s:13:"toggle_slogan";s:1:"1";s:24:"toggle_node_user_picture";s:1:"1";s:27:"toggle_comment_user_picture";s:1:"1";s:32:"toggle_comment_user_verification";s:1:"1";s:14:"toggle_favicon";s:1:"1";s:16:"toggle_main_menu";s:1:"1";s:21:"toggle_secondary_menu";s:1:"1";s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1140";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:581px) and (max-width:768px)";s:27:"smalltouch_landscape_layout";s:12:"one_col_vert";s:30:"smalltouch_landscape_page_unit";s:1:"%";s:33:"smalltouch_landscape_sidebar_unit";s:1:"%";s:31:"smalltouch_landscape_page_width";s:3:"100";s:34:"smalltouch_landscape_sidebar_first";s:2:"50";s:35:"smalltouch_landscape_sidebar_second";s:2:"50";s:32:"smalltouch_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:580px)";s:26:"smalltouch_portrait_layout";s:13:"one_col_stack";s:29:"smalltouch_portrait_page_unit";s:1:"%";s:32:"smalltouch_portrait_sidebar_unit";s:1:"%";s:30:"smalltouch_portrait_page_width";s:3:"100";s:33:"smalltouch_portrait_sidebar_first";s:3:"100";s:34:"smalltouch_portrait_sidebar_second";s:3:"100";s:31:"smalltouch_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:18:"five-5x20-2x3-grid";s:18:"bigscreen_six_6x16";s:17:"six-6x16-3x2-grid";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:9:"five-5x20";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smalltouch_landscape_two_50";s:12:"two-50-stack";s:30:"smalltouch_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smalltouch_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smalltouch_landscape_two_brick";s:15:"two-brick-stack";s:31:"smalltouch_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smalltouch_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smalltouch_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smalltouch_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smalltouch_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smalltouch_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smalltouch_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smalltouch_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smalltouch_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"1";s:21:"global_default_layout";s:19:"smalltouch-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"0";s:20:"enable_font_settings";s:1:"0";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"0";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"0";s:14:"base_font_type";s:6:"<none>";s:19:"site_name_font_type";s:6:"<none>";s:21:"site_slogan_font_type";s:6:"<none>";s:20:"page_title_font_type";s:6:"<none>";s:20:"node_title_font_type";s:6:"<none>";s:23:"comment_title_font_type";s:6:"<none>";s:21:"block_title_font_type";s:6:"<none>";s:19:"main_menu_font_type";s:6:"<none>";s:24:"secondary_menu_font_type";s:6:"<none>";s:20:"block_menu_font_type";s:6:"<none>";s:19:"selectors_font_type";s:6:"<none>";s:31:"content_headings_h1h4_font_type";s:6:"<none>";s:31:"content_headings_h5h6_font_type";s:6:"<none>";s:14:"base_font_size";s:6:"<none>";s:19:"site_name_font_size";s:6:"<none>";s:21:"site_slogan_font_size";s:6:"<none>";s:20:"page_title_font_size";s:6:"<none>";s:20:"node_title_font_size";s:6:"<none>";s:23:"comment_title_font_size";s:6:"<none>";s:21:"block_title_font_size";s:6:"<none>";s:19:"main_menu_font_size";s:6:"<none>";s:24:"secondary_menu_font_size";s:6:"<none>";s:20:"block_menu_font_size";s:6:"<none>";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:14:"site_name_case";s:5:"snc-n";s:16:"site_name_weight";s:5:"snw-b";s:19:"site_name_alignment";s:5:"sna-l";s:16:"site_name_shadow";s:5:"sns-n";s:16:"site_slogan_case";s:5:"ssc-n";s:18:"site_slogan_weight";s:5:"ssw-b";s:21:"site_slogan_alignment";s:5:"ssa-l";s:18:"site_slogan_shadow";s:5:"sss-n";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-n";s:22:"image_alignment_teaser";s:5:"iat-n";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:20:"user_block_user_name";s:1:"1";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:17:"unset_menu_titles";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:10:"rel_author";s:1:"0";s:27:"menu_toggle_tablet_portrait";s:1:"1";s:28:"menu_toggle_tablet_landscape";s:1:"0";s:21:"menu_toggle_main_menu";s:1:"1";s:26:"menu_toggle_secondary_menu";s:1:"1";s:23:"menu_toggle_leaderboard";s:1:"0";s:18:"menu_toggle_header";s:1:"0";s:20:"menu_toggle_menu_bar";s:1:"1";s:27:"menu_toggle_main_menu_title";s:9:"Main menu";s:32:"menu_toggle_secondary_menu_title";s:9:"User menu";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:56:"width=device-width, initial-scale=1.0, user-scalable=yes";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:35:"adaptivetheme_meta_ie_document_mode";s:0:"";s:29:"adaptivetheme_meta_clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:17:"icon_path_default";s:24:"images/default-60x60.png";s:26:"apple_touch_icon_path_ipad";s:30:"images/ipad-standard-76x76.png";s:35:"apple_touch_icon_path_iphone_retina";s:32:"images/iphone-retina-120x120.png";s:33:"apple_touch_icon_path_ipad_retina";s:30:"images/ipad-retina-152x152.png";s:8:"icon_rel";s:1:"0";s:10:"custom_css";s:0:"";}s:7:"version";s:7:"7.x-3.2";s:7:"project";s:13:"adaptivetheme";s:9:"datestamp";s:10:"1395575059";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}');
INSERT INTO `system` VALUES ('sites/all/themes/bookpoints_custom/bookpoints_custom.info','bookpoints_custom','theme','themes/engines/phptemplate/phptemplate.engine','1','0','-1','0','a:18:{s:4:"name";s:23:"Bookpoints Customizable";s:11:"description";s:68:"A customizable, color-able theme built on AdaptiveTheme and Corolla.";s:4:"core";s:3:"7.x";s:7:"release";s:7:"7.x-3.x";s:10:"base theme";s:7:"corolla";s:11:"stylesheets";a:1:{s:3:"all";a:3:{s:16:"color/colors.css";s:51:"sites/all/themes/bookpoints_custom/color/colors.css";s:14:"css/styles.css";s:49:"sites/all/themes/bookpoints_custom/css/styles.css";s:24:"css/reader_dashboard.css";s:59:"sites/all/themes/bookpoints_custom/css/reader_dashboard.css";}}s:14:"ie_stylesheets";a:1:{s:6:"screen";a:1:{s:8:"lte IE 9";a:1:{i:0;s:16:"css/ie-lte-9.css";}}}s:7:"scripts";a:1:{s:11:"js/stars.js";s:46:"sites/all/themes/bookpoints_custom/js/stars.js";}s:7:"regions";a:25:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:11:"highlighted";s:11:"Highlighted";s:7:"content";s:12:"Main content";s:13:"content_aside";s:14:"Content bottom";s:17:"secondary_content";s:17:"Secondary content";s:16:"tertiary_content";s:16:"Tertiary content";s:6:"footer";s:6:"Footer";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:12:"three_33_top";s:26:"AT Three column 3x33 - top";s:14:"three_33_first";s:27:"AT Three column 3x33 - left";s:15:"three_33_second";s:29:"AT Three column 3x33 - center";s:14:"three_33_third";s:28:"AT Three column 3x33 - right";s:15:"three_33_bottom";s:29:"AT Three column 3x33 - bottom";s:10:"four_first";s:23:"AT Four column 4x25 - 1";s:11:"four_second";s:23:"AT Four column 4x25 - 2";s:10:"four_third";s:23:"AT Four column 4x25 - 3";s:11:"four_fourth";s:23:"AT Four column 4x25 - 4";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:7:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:6:"slogan";i:3;s:17:"node_user_picture";i:4;s:20:"comment_user_picture";i:5;s:25:"comment_user_verification";i:6;s:7:"favicon";}s:8:"settings";a:206:{s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1200";s:21:"bigscreen_media_query";s:37:"only screen and (min-width:64.0625em)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:58:"only screen and (min-width:48.0625em) and (max-width:64em)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:58:"only screen and (min-width:30.0625em) and (max-width:48em)";s:27:"smartphone_landscape_layout";s:12:"one_col_vert";s:30:"smartphone_landscape_page_unit";s:1:"%";s:33:"smartphone_landscape_sidebar_unit";s:1:"%";s:31:"smartphone_landscape_page_width";s:3:"100";s:34:"smartphone_landscape_sidebar_first";s:2:"50";s:35:"smartphone_landscape_sidebar_second";s:2:"50";s:32:"smartphone_landscape_media_query";s:58:"only screen and (min-width:20.0625em) and (max-width:30em)";s:26:"smartphone_portrait_layout";s:13:"one_col_stack";s:29:"smartphone_portrait_page_unit";s:1:"%";s:32:"smartphone_portrait_sidebar_unit";s:1:"%";s:30:"smartphone_portrait_page_width";s:3:"100";s:33:"smartphone_portrait_sidebar_first";s:3:"100";s:34:"smartphone_portrait_sidebar_second";s:3:"100";s:31:"smartphone_portrait_media_query";s:32:"only screen and (max-width:20em)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:18:"five-5x20-2x3-grid";s:18:"bigscreen_six_6x16";s:17:"six-6x16-3x2-grid";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:18:"five-5x20-2x3-grid";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smartphone_landscape_two_50";s:12:"two-50-stack";s:30:"smartphone_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smartphone_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smartphone_landscape_two_brick";s:15:"two-brick-stack";s:31:"smartphone_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smartphone_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smartphone_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smartphone_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smartphone_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smartphone_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smartphone_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smartphone_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smartphone_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"0";s:21:"global_default_layout";s:19:"smartphone-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"1";s:20:"enable_font_settings";s:1:"1";s:23:"enable_heading_settings";s:1:"0";s:21:"enable_image_settings";s:1:"1";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:18:"enable_menu_toggle";s:1:"1";s:22:"enable_markup_overides";s:1:"1";s:14:"base_font_type";s:0:"";s:19:"site_name_font_type";s:0:"";s:21:"site_slogan_font_type";s:0:"";s:20:"page_title_font_type";s:0:"";s:20:"node_title_font_type";s:0:"";s:23:"comment_title_font_type";s:0:"";s:21:"block_title_font_type";s:0:"";s:9:"base_font";s:6:"bf-sss";s:14:"site_name_font";s:6:"snf-sl";s:16:"site_slogan_font";s:6:"ssf-sl";s:14:"main_menu_font";s:6:"mmf-sl";s:15:"page_title_font";s:6:"ptf-sl";s:15:"node_title_font";s:6:"ntf-sl";s:18:"comment_title_font";s:6:"ctf-sl";s:16:"block_title_font";s:6:"btf-sl";s:14:"base_font_size";s:3:"1em";s:19:"site_name_font_size";s:5:"3.5em";s:21:"site_slogan_font_size";s:5:"1.2em";s:20:"page_title_font_size";s:3:"2em";s:20:"node_title_font_size";s:5:"1.6em";s:23:"comment_title_font_size";s:5:"1.4em";s:21:"block_title_font_size";s:5:"1.4em";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-n";s:22:"image_alignment_teaser";s:5:"iat-n";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:17:"unset_menu_titles";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:35:"width=device-width, initial-scale=1";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:11:"chrome_edge";s:1:"0";s:10:"clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:23:"images/touch-icon-l.png";s:23:"apple_touch_icon_path_m";s:23:"images/touch-icon-m.png";s:23:"apple_touch_icon_path_h";s:23:"images/touch-icon-h.png";s:10:"custom_css";s:0:"";s:21:"content_corner_radius";s:4:"rc-6";s:18:"tabs_corner_radius";s:5:"rct-6";s:11:"box_shadows";s:4:"bs-n";s:15:"body_background";s:4:"bb-n";s:12:"menu_bullets";s:5:"mb-dd";s:17:"menu_bar_position";s:5:"mbp-l";}s:6:"engine";s:11:"phptemplate";s:10:"screenshot";s:49:"sites/all/themes/bookpoints_custom/screenshot.png";s:3:"php";s:5:"5.2.4";s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}');
INSERT INTO `system` VALUES ('sites/all/themes/corolla/corolla.info','corolla','theme','themes/engines/phptemplate/phptemplate.engine','0','0','-1','0','a:21:{s:4:"name";s:7:"Corolla";s:11:"description";s:367:"Corolla is a subtheme of <a href="http://drupal.org/project/adaptivetheme">Adaptivetheme 7.x-3.x</a>. To use this theme you must first download and install the 7.x-3.x version of Adaptivetheme. Corolla is colorable and has many theme settings for layout, fonts, headings and much more. Corolla also supports layouts for mobile devices such as tablets and smartphones.";s:4:"core";s:3:"7.x";s:7:"release";s:7:"7.x-3.x";s:6:"engine";s:11:"phptemplate";s:10:"base theme";s:13:"adaptivetheme";s:10:"screenshot";s:39:"sites/all/themes/corolla/screenshot.png";s:11:"stylesheets";a:2:{s:3:"all";a:12:{s:21:"css/html-elements.css";s:46:"sites/all/themes/corolla/css/html-elements.css";s:13:"css/forms.css";s:38:"sites/all/themes/corolla/css/forms.css";s:14:"css/tables.css";s:39:"sites/all/themes/corolla/css/tables.css";s:12:"css/page.css";s:37:"sites/all/themes/corolla/css/page.css";s:16:"css/articles.css";s:41:"sites/all/themes/corolla/css/articles.css";s:16:"css/comments.css";s:41:"sites/all/themes/corolla/css/comments.css";s:14:"css/fields.css";s:39:"sites/all/themes/corolla/css/fields.css";s:14:"css/blocks.css";s:39:"sites/all/themes/corolla/css/blocks.css";s:18:"css/navigation.css";s:43:"sites/all/themes/corolla/css/navigation.css";s:13:"css/fonts.css";s:38:"sites/all/themes/corolla/css/fonts.css";s:30:"css/corolla.settings.style.css";s:55:"sites/all/themes/corolla/css/corolla.settings.style.css";s:16:"color/colors.css";s:41:"sites/all/themes/corolla/color/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:38:"sites/all/themes/corolla/css/print.css";}}s:14:"ie_stylesheets";a:1:{s:6:"screen";a:1:{s:8:"lte IE 9";a:1:{i:0;s:16:"css/ie-lte-9.css";}}}s:7:"regions";a:25:{s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:6:"header";s:6:"Header";s:8:"menu_bar";s:8:"Menu Bar";s:4:"help";s:4:"Help";s:11:"highlighted";s:11:"Highlighted";s:7:"content";s:12:"Main content";s:13:"content_aside";s:14:"Content bottom";s:17:"secondary_content";s:17:"Secondary content";s:16:"tertiary_content";s:16:"Tertiary content";s:6:"footer";s:6:"Footer";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:12:"three_33_top";s:26:"AT Three column 3x33 - top";s:14:"three_33_first";s:27:"AT Three column 3x33 - left";s:15:"three_33_second";s:29:"AT Three column 3x33 - center";s:14:"three_33_third";s:28:"AT Three column 3x33 - right";s:15:"three_33_bottom";s:29:"AT Three column 3x33 - bottom";s:10:"four_first";s:23:"AT Four column 4x25 - 1";s:11:"four_second";s:23:"AT Four column 4x25 - 2";s:10:"four_third";s:23:"AT Four column 4x25 - 3";s:11:"four_fourth";s:23:"AT Four column 4x25 - 4";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:7:{i:0;s:4:"logo";i:1;s:4:"name";i:2;s:6:"slogan";i:3;s:17:"node_user_picture";i:4;s:20:"comment_user_picture";i:5;s:25:"comment_user_verification";i:6;s:7:"favicon";}s:8:"settings";a:213:{s:11:"toggle_logo";s:1:"1";s:11:"toggle_name";s:1:"1";s:13:"toggle_slogan";s:1:"1";s:24:"toggle_node_user_picture";s:1:"1";s:27:"toggle_comment_user_picture";s:1:"1";s:32:"toggle_comment_user_verification";s:1:"1";s:14:"toggle_favicon";s:1:"1";s:16:"bigscreen_layout";s:15:"three_col_grail";s:19:"bigscreen_page_unit";s:1:"%";s:22:"bigscreen_sidebar_unit";s:1:"%";s:24:"bigscreen_max_width_unit";s:2:"px";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_sidebar_first";s:2:"25";s:24:"bigscreen_sidebar_second";s:2:"25";s:23:"bigscreen_set_max_width";s:1:"1";s:19:"bigscreen_max_width";s:4:"1140";s:21:"bigscreen_media_query";s:34:"only screen and (min-width:1025px)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:26:"tablet_landscape_page_unit";s:1:"%";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:28:"tablet_landscape_media_query";s:56:"only screen and (min-width:769px) and (max-width:1024px)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:25:"tablet_portrait_page_unit";s:1:"%";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:27:"tablet_portrait_media_query";s:55:"only screen and (min-width:481px) and (max-width:768px)";s:27:"smartphone_landscape_layout";s:12:"one_col_vert";s:30:"smartphone_landscape_page_unit";s:1:"%";s:33:"smartphone_landscape_sidebar_unit";s:1:"%";s:31:"smartphone_landscape_page_width";s:3:"100";s:34:"smartphone_landscape_sidebar_first";s:2:"50";s:35:"smartphone_landscape_sidebar_second";s:2:"50";s:32:"smartphone_landscape_media_query";s:55:"only screen and (min-width:321px) and (max-width:480px)";s:26:"smartphone_portrait_layout";s:13:"one_col_stack";s:29:"smartphone_portrait_page_unit";s:1:"%";s:32:"smartphone_portrait_sidebar_unit";s:1:"%";s:30:"smartphone_portrait_page_width";s:3:"100";s:33:"smartphone_portrait_sidebar_first";s:3:"100";s:34:"smartphone_portrait_sidebar_second";s:3:"100";s:31:"smartphone_portrait_media_query";s:33:"only screen and (max-width:320px)";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_brick";s:9:"two-brick";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:18:"five-5x20-2x3-grid";s:18:"bigscreen_six_6x16";s:17:"six-6x16-3x2-grid";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:18:"five-5x20-2x3-grid";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:27:"smartphone_landscape_two_50";s:12:"two-50-stack";s:30:"smartphone_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smartphone_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smartphone_landscape_two_brick";s:15:"two-brick-stack";s:31:"smartphone_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smartphone_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:35:"smartphone_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smartphone_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:30:"smartphone_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smartphone_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smartphone_landscape_six_6x16";s:14:"six-6x16-stack";s:37:"smartphone_landscape_three_inset_left";s:22:"three-inset-left-stack";s:38:"smartphone_landscape_three_inset_right";s:23:"three-inset-right-stack";s:25:"disable_responsive_styles";s:1:"0";s:27:"enable_custom_media_queries";s:1:"0";s:21:"global_default_layout";s:19:"smartphone-portrait";s:28:"global_default_layout_toggle";s:1:"0";s:17:"global_files_path";s:12:"public_files";s:12:"load_html5js";s:1:"1";s:14:"load_respondjs";s:1:"0";s:13:"load_ltie8css";s:1:"0";s:15:"load_scalefixjs";s:1:"0";s:14:"expose_regions";s:1:"0";s:15:"load_all_panels";s:1:"0";s:27:"load_all_panels_no_sidebars";s:1:"0";s:16:"show_window_size";s:1:"0";s:18:"rebuild_theme_data";s:1:"0";s:17:"enable_extensions";s:1:"1";s:20:"enable_font_settings";s:1:"1";s:23:"enable_heading_settings";s:1:"1";s:21:"enable_image_settings";s:1:"1";s:24:"enable_apple_touch_icons";s:1:"0";s:18:"enable_exclude_css";s:1:"0";s:17:"enable_custom_css";s:1:"0";s:22:"enable_context_regions";s:1:"0";s:26:"enable_float_region_blocks";s:1:"0";s:22:"enable_markup_overides";s:1:"1";s:14:"base_font_type";s:0:"";s:19:"site_name_font_type";s:0:"";s:21:"site_slogan_font_type";s:0:"";s:20:"page_title_font_type";s:0:"";s:20:"node_title_font_type";s:0:"";s:23:"comment_title_font_type";s:0:"";s:21:"block_title_font_type";s:0:"";s:9:"base_font";s:6:"bf-sss";s:14:"site_name_font";s:6:"snf-sl";s:16:"site_slogan_font";s:6:"ssf-sl";s:14:"main_menu_font";s:6:"mmf-sl";s:15:"page_title_font";s:6:"ptf-sl";s:15:"node_title_font";s:6:"ntf-sl";s:18:"comment_title_font";s:6:"ctf-sl";s:16:"block_title_font";s:6:"btf-sl";s:14:"base_font_size";s:3:"1em";s:19:"site_name_font_size";s:5:"3.5em";s:21:"site_slogan_font_size";s:5:"1.2em";s:20:"page_title_font_size";s:3:"2em";s:20:"node_title_font_size";s:5:"1.6em";s:23:"comment_title_font_size";s:5:"1.4em";s:21:"block_title_font_size";s:5:"1.4em";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:15:"page_title_case";s:5:"ptc-n";s:17:"page_title_weight";s:5:"ptw-b";s:20:"page_title_alignment";s:5:"pta-l";s:17:"page_title_shadow";s:5:"pts-n";s:15:"node_title_case";s:5:"ntc-n";s:17:"node_title_weight";s:5:"ntw-b";s:20:"node_title_alignment";s:5:"nta-l";s:17:"node_title_shadow";s:5:"nts-n";s:18:"comment_title_case";s:5:"ctc-n";s:20:"comment_title_weight";s:5:"ctw-b";s:23:"comment_title_alignment";s:5:"cta-l";s:20:"comment_title_shadow";s:5:"cts-n";s:16:"block_title_case";s:5:"btc-n";s:18:"block_title_weight";s:5:"btw-b";s:21:"block_title_alignment";s:5:"bta-l";s:18:"block_title_shadow";s:5:"bts-n";s:15:"image_alignment";s:4:"ia-n";s:22:"image_alignment_teaser";s:5:"iat-n";s:18:"image_caption_full";s:1:"0";s:20:"image_caption_teaser";s:1:"0";s:12:"image_teaser";s:1:"0";s:18:"breadcrumb_display";s:1:"1";s:15:"breadcrumb_home";s:1:"0";s:16:"breadcrumb_label";s:1:"0";s:16:"breadcrumb_title";s:1:"0";s:20:"breadcrumb_separator";s:8:" &#187; ";s:29:"horizontal_login_block_enable";s:2:"on";s:22:"horizontal_login_block";s:1:"0";s:24:"login_block_remove_links";s:1:"0";s:25:"login_block_remove_openid";s:1:"0";s:19:"global_gutter_width";s:0:"";s:24:"page_full_width_wrappers";s:1:"0";s:29:"page_content_type_suggestions";s:1:"0";s:23:"menu_item_span_elements";s:1:"0";s:18:"extra_page_classes";s:1:"1";s:21:"extra_article_classes";s:1:"1";s:21:"extra_comment_classes";s:1:"1";s:19:"extra_block_classes";s:1:"1";s:18:"extra_menu_classes";s:1:"1";s:23:"extra_item_list_classes";s:1:"1";s:19:"comments_hide_title";s:1:"0";s:10:"feed_icons";s:1:"0";s:29:"unset_block_system_main_front";s:1:"0";s:17:"unset_menu_titles";s:1:"0";s:16:"skip_link_target";s:13:"#main-content";s:26:"adv_search_extra_fieldsets";s:1:"0";s:24:"mobile_friendly_metatags";s:1:"1";s:27:"adaptivetheme_meta_viewport";s:35:"width=device-width, initial-scale=1";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";b:1;s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:11:"chrome_edge";s:1:"0";s:10:"clear_type";s:1:"0";s:23:"apple_touch_icon_enable";s:1:"0";s:23:"apple_touch_icon_path_l";s:23:"images/touch-icon-l.png";s:23:"apple_touch_icon_path_m";s:23:"images/touch-icon-m.png";s:23:"apple_touch_icon_path_h";s:23:"images/touch-icon-h.png";s:10:"custom_css";s:0:"";s:21:"content_corner_radius";s:4:"rc-6";s:18:"tabs_corner_radius";s:5:"rct-6";s:11:"box_shadows";s:4:"bs-n";s:15:"body_background";s:4:"bb-n";s:12:"menu_bullets";s:5:"mb-dd";s:17:"menu_bar_position";s:5:"mbp-l";}s:7:"version";s:7:"7.x-3.0";s:7:"project";s:7:"corolla";s:9:"datestamp";s:10:"1395577158";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}');
INSERT INTO `system` VALUES ('sites/all/themes/skeletontheme/skeletontheme.info','skeletontheme','theme','themes/engines/phptemplate/phptemplate.engine','0','0','-1','0','a:18:{s:4:"name";s:8:"Skeleton";s:11:"description";s:361:"Skeleton is a powerful, clean, responsive theme ported to Drupal by <a href="http://www.morethanthemes.com/" target="_blank">More Than (just) Themes</a>. If you like this theme, we encourage you to try also our other <a href="http://www.morethanthemes.com" target="_blank">Premium</a> and <a href="http://drupalizing.com" target="_blank">Free</a> Drupal themes.";s:7:"version";s:7:"7.x-1.4";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:3:"all";a:5:{s:16:"css/skeleton.css";s:47:"sites/all/themes/skeletontheme/css/skeleton.css";s:13:"css/style.css";s:44:"sites/all/themes/skeletontheme/css/style.css";s:15:"css/buttons.css";s:46:"sites/all/themes/skeletontheme/css/buttons.css";s:14:"css/layout.css";s:45:"sites/all/themes/skeletontheme/css/layout.css";s:16:"color/colors.css";s:47:"sites/all/themes/skeletontheme/color/colors.css";}}s:7:"regions";a:20:{s:15:"header_top_left";s:15:"Header top left";s:16:"header_top_right";s:16:"Header top right";s:12:"header_right";s:12:"Header right";s:6:"header";s:6:"Header";s:11:"highlighted";s:11:"Highlighted";s:7:"content";s:7:"Content";s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:13:"featured_left";s:13:"Featured left";s:14:"featured_right";s:14:"Featured right";s:12:"footer_first";s:12:"Footer first";s:13:"footer_second";s:13:"Footer second";s:12:"footer_third";s:12:"Footer third";s:6:"footer";s:6:"Footer";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"settings";a:3:{s:21:"responsive_menu_state";s:1:"1";s:27:"responsive_menu_switchwidth";s:3:"760";s:29:"responsive_menu_topoptiontext";s:13:"Select a page";}s:7:"project";s:13:"skeletontheme";s:9:"datestamp";s:10:"1396987453";s:6:"engine";s:11:"phptemplate";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:45:"sites/all/themes/skeletontheme/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}');
INSERT INTO `system` VALUES ('themes/bartik/bartik.info','bartik','theme','themes/engines/phptemplate/phptemplate.engine','0','0','-1','0','a:19:{s:4:"name";s:6:"Bartik";s:11:"description";s:48:"A flexible, recolorable theme with many regions.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:2:{s:3:"all";a:3:{s:14:"css/layout.css";s:28:"themes/bartik/css/layout.css";s:13:"css/style.css";s:27:"themes/bartik/css/style.css";s:14:"css/colors.css";s:28:"themes/bartik/css/colors.css";}s:5:"print";a:1:{s:13:"css/print.css";s:27:"themes/bartik/css/print.css";}}s:7:"regions";a:20:{s:6:"header";s:6:"Header";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:11:"highlighted";s:11:"Highlighted";s:8:"featured";s:8:"Featured";s:7:"content";s:7:"Content";s:13:"sidebar_first";s:13:"Sidebar first";s:14:"sidebar_second";s:14:"Sidebar second";s:14:"triptych_first";s:14:"Triptych first";s:15:"triptych_middle";s:15:"Triptych middle";s:13:"triptych_last";s:13:"Triptych last";s:18:"footer_firstcolumn";s:19:"Footer first column";s:19:"footer_secondcolumn";s:20:"Footer second column";s:18:"footer_thirdcolumn";s:19:"Footer third column";s:19:"footer_fourthcolumn";s:20:"Footer fourth column";s:6:"footer";s:6:"Footer";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"settings";a:1:{s:20:"shortcut_module_link";s:1:"0";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:28:"themes/bartik/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}');
INSERT INTO `system` VALUES ('themes/garland/garland.info','garland','theme','themes/engines/phptemplate/phptemplate.engine','0','0','-1','0','a:19:{s:4:"name";s:7:"Garland";s:11:"description";s:111:"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:2:{s:3:"all";a:1:{s:9:"style.css";s:24:"themes/garland/style.css";}s:5:"print";a:1:{s:9:"print.css";s:24:"themes/garland/print.css";}}s:8:"settings";a:1:{s:13:"garland_width";s:5:"fluid";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:7:"regions";a:12:{s:13:"sidebar_first";s:12:"Left sidebar";s:14:"sidebar_second";s:13:"Right sidebar";s:7:"content";s:7:"Content";s:6:"header";s:6:"Header";s:6:"footer";s:6:"Footer";s:11:"highlighted";s:11:"Highlighted";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:29:"themes/garland/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}'),('themes/seven/seven.info','seven','theme','themes/engines/phptemplate/phptemplate.engine','0','0','-1','0','a:19:{s:4:"name";s:5:"Seven";s:11:"description";s:65:"A simple one-column, tableless, fluid width administration theme.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:6:"screen";a:2:{s:9:"reset.css";s:22:"themes/seven/reset.css";s:9:"style.css";s:22:"themes/seven/style.css";}}s:8:"settings";a:1:{s:20:"shortcut_module_link";s:1:"1";}s:7:"regions";a:8:{s:7:"content";s:7:"Content";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:13:"sidebar_first";s:13:"First sidebar";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:14:"regions_hidden";a:3:{i:0;s:13:"sidebar_first";i:1;s:8:"page_top";i:2;s:11:"page_bottom";}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:27:"themes/seven/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}');
INSERT INTO `system` VALUES ('themes/stark/stark.info','stark','theme','themes/engines/phptemplate/phptemplate.engine','0','0','-1','0','a:18:{s:4:"name";s:5:"Stark";s:11:"description";s:208:"This theme demonstrates Drupal''s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal''s default code, see the <a href="http://drupal.org/theme-guide">Theming Guide</a>.";s:7:"package";s:4:"Core";s:7:"version";s:4:"7.54";s:4:"core";s:3:"7.x";s:11:"stylesheets";a:1:{s:3:"all";a:1:{s:10:"layout.css";s:23:"themes/stark/layout.css";}}s:7:"project";s:6:"drupal";s:9:"datestamp";s:10:"1485986921";s:6:"engine";s:11:"phptemplate";s:7:"regions";a:12:{s:13:"sidebar_first";s:12:"Left sidebar";s:14:"sidebar_second";s:13:"Right sidebar";s:7:"content";s:7:"Content";s:6:"header";s:6:"Header";s:6:"footer";s:6:"Footer";s:11:"highlighted";s:11:"Highlighted";s:4:"help";s:4:"Help";s:8:"page_top";s:8:"Page top";s:11:"page_bottom";s:11:"Page bottom";s:14:"dashboard_main";s:16:"Dashboard (main)";s:17:"dashboard_sidebar";s:19:"Dashboard (sidebar)";s:18:"dashboard_inactive";s:20:"Dashboard (inactive)";}s:8:"features";a:9:{i:0;s:4:"logo";i:1;s:7:"favicon";i:2;s:4:"name";i:3;s:6:"slogan";i:4;s:17:"node_user_picture";i:5;s:20:"comment_user_picture";i:6;s:25:"comment_user_verification";i:7;s:9:"main_menu";i:8;s:14:"secondary_menu";}s:10:"screenshot";s:27:"themes/stark/screenshot.png";s:3:"php";s:5:"5.2.4";s:7:"scripts";a:0:{}s:5:"mtime";i:1490935291;s:15:"overlay_regions";a:3:{i:0;s:14:"dashboard_main";i:1;s:17:"dashboard_sidebar";i:2;s:18:"dashboard_inactive";}s:14:"regions_hidden";a:2:{i:0;s:8:"page_top";i:1;s:11:"page_bottom";}s:28:"overlay_supplemental_regions";a:1:{i:0;s:11:"page_bottom";}}');
DROP TABLE IF EXISTS `taxonomy_index`;
CREATE TABLE `taxonomy_index` (   `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record tracks.',   `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The term ID.',   `sticky` tinyint(4) DEFAULT '0' COMMENT 'Boolean indicating whether the node is sticky.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was created.',   KEY `term_node` (`tid`,`sticky`,`created`),   KEY `nid` (`nid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maintains denormalized information about node/term...';
DROP TABLE IF EXISTS `taxonomy_term_data`;
CREATE TABLE `taxonomy_term_data` (   `tid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique term ID.',   `vid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The taxonomy_vocabulary.vid of the vocabulary to which the term is assigned.',   `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The term name.',   `description` longtext COMMENT 'A description of the term.',   `format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the description.',   `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this term in relation to other terms.',   PRIMARY KEY (`tid`),   KEY `taxonomy_tree` (`vid`,`weight`,`name`),   KEY `vid_name` (`vid`,`name`),   KEY `name` (`name`) ) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8 COMMENT='Stores term information.' AUTO_INCREMENT=15;
INSERT INTO `taxonomy_term_data` VALUES ('1','2','Generic Starter','','filtered_html','0'),('2','4','Pikeville High School','','filtered_html','0'),('3','3','Generic Prize','','filtered_html','0'),('4','2','Jr. Deputy','','filtered_html','0'),('5','3','Pikeville High School',null,null,'0'),('9','4','Phelps High School','','filtered_html','0'),('10','2','Trusty',null,null,'0'),('11','2','Apollo','','filtered_html','0'),('12','3','Test Prize 2',null,null,'0'),('13','3','Test Prize 3',null,null,'0'),('14','3','Test Prize 4',null,null,'0');
DROP TABLE IF EXISTS `taxonomy_term_hierarchy`;
CREATE TABLE `taxonomy_term_hierarchy` (   `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: The taxonomy_term_data.tid of the term.',   `parent` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: The taxonomy_term_data.tid of the term’s parent. 0 indicates no parent.',   PRIMARY KEY (`tid`,`parent`),   KEY `parent` (`parent`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the hierarchical relationship between terms.';
INSERT INTO `taxonomy_term_hierarchy` VALUES ('1','0'),('2','0'),('3','0'),('4','0'),('5','0'),('9','0'),('10','0'),('11','0'),('12','0'),('13','0'),('14','0');
DROP TABLE IF EXISTS `taxonomy_vocabulary`;
CREATE TABLE `taxonomy_vocabulary` (   `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique vocabulary ID.',   `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the vocabulary.',   `machine_name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The vocabulary machine name.',   `description` longtext COMMENT 'Description of the vocabulary.',   `hierarchy` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The type of hierarchy allowed within the vocabulary. (0 = disabled, 1 = single, 2 = multiple)',   `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The module which created the vocabulary.',   `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this vocabulary in relation to other vocabularies.',   PRIMARY KEY (`vid`),   UNIQUE KEY `machine_name` (`machine_name`),   KEY `list` (`weight`,`name`) ) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='Stores vocabulary information.' AUTO_INCREMENT=5;
INSERT INTO `taxonomy_vocabulary` VALUES ('1','Tags','tags','Use tags to group articles on similar topics into categories.','0','taxonomy','0'),('2','Badge','badge','','0','taxonomy','0'),('3','Prize','prize','','0','taxonomy','0'),('4','School','school','','0','taxonomy','0');
DROP TABLE IF EXISTS `url_alias`;
CREATE TABLE `url_alias` (   `pid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'A unique path alias identifier.',   `source` varchar(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path this alias is for; e.g. node/12.',   `alias` varchar(255) NOT NULL DEFAULT '' COMMENT 'The alias for this path; e.g. title-of-the-story.',   `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The language this alias is for; if ’und’, the alias will be used for unknown languages. Each Drupal path can have an alias for each supported language.',   PRIMARY KEY (`pid`),   KEY `alias_language_pid` (`alias`,`language`,`pid`),   KEY `source_language_pid` (`source`,`language`,`pid`) ) ENGINE=InnoDB AUTO_INCREMENT=203 DEFAULT CHARSET=utf8 COMMENT='A list of URL aliases for Drupal paths; a user may visit...' AUTO_INCREMENT=203;
INSERT INTO `url_alias` VALUES ('1','node/1','reader/dashboard/reading_activity','und'),('2','taxonomy/term/1','badge/generic-starter','und'),('3','taxonomy/term/2','school/pikeville-high-school','und'),('4','taxonomy/term/3','prize/generic-prize','und'),('7','node/2','reader/dashboard/all_profiles','und'),('8','node/3','reader/dashboard/add_profile','und'),('9','node/4','reader/dashboard/history','und'),('10','node/5','reader/dashboard/history/reading_activity_history','und'),('11','node/6','reader/dashboard/history/program_history','und'),('12','node/7','reader/dashboard/history/price_history','und'),('13','node/8','reader/dashboard/history/point_history','und'),('14','node/9','library/dashboard/add_branch','und'),('15','node/10','library/dashboard/add_branch/add_program','und'),('16','node/11','library/dashboard/add_branch/add_program/add_badge','und'),('17','node/12','library/dashboard/add_branch/add_program/add_prize','und'),('18','node/13','library/dashboard/add_level','und'),('19','node/14','library/dashboard/add_level/add_points','und'),('20','node/15','content/reader-dashboard','und'),('21','node/16','library/dashboard/add_branch/add_program/readers_list','und'),('22','taxonomy/term/4','badge/jr-deputy','und'),('23','taxonomy/term/5','prize/pikeville-high-school','und'),('32','user/1','users/admin','und'),('48','taxonomy/term/9','school/phelps-high-school','und'),('50','taxonomy/term/10','badge/trusty','und'),('57','taxonomy/term/11','badge/apollo','und'),('58','taxonomy/term/12','prize/test-prize-2','und'),('59','taxonomy/term/13','prize/test-prize-3','und'),('60','taxonomy/term/14','prize/test-prize-4','und'),('71','node/17','library/dashboard/all_prizes','und'),('118','node/18','help','und');
INSERT INTO `url_alias` VALUES ('201','node/19','content/terms-use','und');
DROP TABLE IF EXISTS `users`;
CREATE TABLE `users` (   `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: Unique user ID.',   `name` varchar(60) NOT NULL DEFAULT '' COMMENT 'Unique user name.',   `pass` varchar(128) NOT NULL DEFAULT '' COMMENT 'User’s password (hashed).',   `mail` varchar(254) DEFAULT '' COMMENT 'User’s e-mail address.',   `theme` varchar(255) NOT NULL DEFAULT '' COMMENT 'User’s default theme.',   `signature` varchar(255) NOT NULL DEFAULT '' COMMENT 'User’s signature.',   `signature_format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the signature.',   `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for when user was created.',   `access` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for previous time user accessed the site.',   `login` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for user’s last login.',   `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether the user is active(1) or blocked(0).',   `timezone` varchar(32) DEFAULT NULL COMMENT 'User’s time zone.',   `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'User’s default language.',   `picture` int(11) NOT NULL DEFAULT '0' COMMENT 'Foreign key: file_managed.fid of user’s picture.',   `init` varchar(254) DEFAULT '' COMMENT 'E-mail address used for initial account creation.',   `data` longblob COMMENT 'A serialized array of name value pairs that are related to the user. Any form values posted during user edit are stored and are loaded into the $user object during user_load(). Use of this field is discouraged and it will likely disappear in a future...',   PRIMARY KEY (`uid`),   UNIQUE KEY `name` (`name`),   KEY `access` (`access`),   KEY `created` (`created`),   KEY `mail` (`mail`),   KEY `picture` (`picture`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores user data.';
INSERT INTO `users` VALUES ('0','','','','','',null,'0','0','0','0',null,'','0','',null),('1','admin','$S$D.SJ2ytJJPd.4abl32PCao0ezW0kl5Da7aU5s0EIibq1ohB07sTj','admin@example.com','','','filtered_html','1476997737','1493657314','1493501245','1','America/New_York','','0','hall.justin+bookpoints@bitsourceky.com','a:1:{s:7:"overlay";i:1;}');
DROP TABLE IF EXISTS `users_roles`;
CREATE TABLE `users_roles` (   `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: users.uid for user.',   `rid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: role.rid for role.',   PRIMARY KEY (`uid`,`rid`),   KEY `rid` (`rid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps users to roles.';
INSERT INTO `users_roles` VALUES ('1','3'),('1','5');
DROP TABLE IF EXISTS `variable`;
CREATE TABLE `variable` (   `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'The name of the variable.',   `value` longblob NOT NULL COMMENT 'The value of the variable.',   PRIMARY KEY (`name`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Named variable/value pairs created by Drupal core or any...';
INSERT INTO `variable` VALUES ('additional_settings__active_tab_customformfields','s:15:"edit-submission";'),('admin_theme','s:5:"seven";'),('anonymous','s:9:"Anonymous";'),('at_browscap_detect','b:0;'),('at_detection','b:0;'),('at_mobile_detect','b:0;'),('backup_migrate_copy_destination_id','s:0:"";'),('backup_migrate_destination_id','s:6:"manual";'),('backup_migrate_profile_id','s:7:"default";'),('backup_migrate_schedule_last_run_db_backup','i:1493629917;'),('backup_migrate_source_id','s:2:"db";'),('block_cache','i:0;'),('cache','i:1;'),('cache_class_cache_ctools_css','s:14:"CToolsCssCache";'),('cache_lifetime','s:1:"0";'),('clean_url','s:1:"1";'),('color_bookpoints_custom_files','a:2:{i:0;s:50:"public://color/bookpoints_custom-8bc2ab55/logo.png";i:1;s:52:"public://color/bookpoints_custom-8bc2ab55/colors.css";}'),('color_bookpoints_custom_logo','s:50:"public://color/bookpoints_custom-8bc2ab55/logo.png";'),('color_bookpoints_custom_palette','a:15:{s:4:"base";s:7:"#ffffff";s:10:"background";s:7:"#f92b2b";s:4:"text";s:7:"#2e2e2e";s:4:"link";s:7:"#086782";s:9:"linkhover";s:7:"#e25401";s:13:"linkunderline";s:7:"#cfdde5";s:6:"slogan";s:7:"#e25400";s:10:"navigation";s:7:"#2e2e2d";s:15:"navigationhover";s:7:"#e25402";s:3:"tab";s:7:"#f5f4f3";s:10:"blocktitle";s:4:"#555";s:6:"border";s:7:"#e1e1e1";s:12:"borderstrong";s:7:"#c4c4c4";s:8:"fieldset";s:7:"#fbfbfb";s:14:"fieldsetborder";s:7:"#e1e1e2";}'),('color_bookpoints_custom_stylesheets','a:1:{i:0;s:52:"public://color/bookpoints_custom-8bc2ab55/colors.css";}'),('comment_anonymous_customformfields','i:0;'),('comment_customformfields','s:1:"2";'),('comment_default_mode_customformfields','i:1;'),('comment_default_per_page_customformfields','s:2:"50";'),('comment_form_location_customformfields','i:1;'),('comment_page','i:0;'),('comment_preview_customformfields','s:1:"1";'),('comment_subject_field_customformfields','i:1;'),('configurable_timezones','i:0;'),('cron_key','s:43:"BR1YFjiaOZQapw4BcUmioQqphMaLZIU6Wi6cVDuled4";');
INSERT INTO `variable` VALUES ('cron_last','i:1493657314;'),('cron_safe_threshold','s:4:"3600";'),('css_js_query_string','s:6:"op9btc";'),('ctools_last_cron','i:1493618725;'),('date_api_use_iso8601','i:0;'),('date_api_version','s:3:"7.2";'),('date_db_tz_support','b:0;'),('date_default_timezone','s:19:"America/Los_Angeles";'),('date_first_day','s:1:"0";'),('date_format_long','s:16:"l, F j, Y - g:ia";'),('date_format_medium','s:15:"D, m/d/Y - g:ia";'),('date_format_short','s:12:"m/d/Y - g:ia";'),('date_views_day_format_without_year','s:6:"l, F j";'),('date_views_day_format_with_year','s:9:"l, F j, Y";'),('date_views_month_format_without_year','s:1:"F";'),('date_views_month_format_with_year','s:3:"F Y";'),('date_views_week_format_without_year','s:3:"F j";'),('date_views_week_format_with_year','s:6:"F j, Y";'),('dblog_row_limit','s:6:"100000";'),('default_nodes_main','s:2:"10";'),('dev_query','i:0;'),('drupal_css_cache_files','a:28:{s:64:"823ba1006db72809515d2221cd02ec1075d7b49b0c07f49307b3a7930bfdd9e4";s:64:"public://css/css_xE-rWrJf-fncB6ztZfd2huxqgxu4WO-qwma6Xer30m4.css";s:64:"ed23fd516419e3b27c4fd6a442740d7a67ffcf8294b677f48272796f33406f51";s:64:"public://css/css_6f863a7CwEda9mlYjOyvEYKQ9k-Bew8wHptgiX_iWc8.css";s:64:"c8dff0f513d2e4dc2337e381e0acb44356c1f762c6194dbf2e378e7da92aae1d";s:64:"public://css/css_xLFDRTFqZTZeUg7Pab0gP4cpz5TWo3PCH-KBo_HKQ6A.css";s:64:"c2084e5c59fefcfeb4f71e74262e865f27bb217f9de70e85e07e4faa8504f685";s:64:"public://css/css_HU48Xp17WNrsLahC3RI3o3rwdgTNptRTo-bSBMDXvdM.css";s:64:"28f414e71d4814cc205efc779f2573c24a6ed30f3868231196a094607767f891";s:64:"public://css/css_-bVWALg0MhS8WGHIzWD3cCAlgyaayVdVgiCUyg5_jXI.css";s:64:"ee1366a23fff471c70b932c180c3aadfb4725b829efd98dc21e3bd26547112a6";s:64:"public://css/css_5TxylIDFcnpmO5ucPRfXTdJiyW00MUBYhBuo7SANpds.css";s:64:"5251670ac26fa7b1cd6f82cb3e5d4db5812a68c4d9e98eb2262e095bb75c919d";s:64:"public://css/css_ubRfQwrKI0ypietOsUCKcwrwIAQQ0cqWgXijRr-rMIk.css";s:64:"f6d70c6d20648bb6dcdfcad2d5c37d1e5de0110b74d85d9e43caa417ed331584";s:64:"public://css/css_SirzpAJCqMfeAaV56qggGnmBO2vAOHKO466hUZ9TNxs.css";s:64:"c1596501629674b95bb76875e01288d19fb68fc080cca581caa96cdc19fd2cd9";s:64:"public://css/css_ydMpnUM6aYTf7ONGeKVGPgD3wPho356GM9kgptzXU4U.css";s:64:"704505d4cb3bad45e57f216d2433cbd4a9f7f12c8a995c6a5eb34b4351d104da";s:64:"public://css/css_47DEQpj8HBSa-_TImW-5JCeuQeRkm5NMpJWZG3hSuFU.css";s:64:"fb80a4bb53a2fc2513f5cd0a59ef4e9b6645c1f676cacf00105a1ffaf3b105b0";s:64:"public://css/css_47DEQpj8HBSa-_TImW-5JCeuQeRkm5NMpJWZG3hSuFU.css";s:64:"d24495f6752f8978f4b8e4a50730a769bb18a623b2408363c6262d7883bf37c4";s:64:"public://css/css_JtRWHQbhbutWb07PkmiQyz3mdBdjIpAfHLyGLbZ5Lss.css";s:64:"43c3f17b4f893858665e0762013af792b8ce45388082f6b9399dc525a0d13f96";s:64:"public://css/css_AbpHGcgLb-kRsJGnwFEktk7uzpZOCcBY74-YBdrKVGs.css";s:64:"ed14151b0158da1ad3053122aa2cd6aec7bd5677fc2b3bfe7b42fd3e42c66f8a";s:64:"public://css/css_bn8mDBJgqdeD2RMXNRFa7n8PEmt5j9uB383TXLc0WFc.css";s:64:"592db66916e1dd3416cbe95bcb34a5a68775eb0b7cf95e4c858671de35290cc9";s:64:"public://css/css_LS9OUalDR9-d_lCAvF3yUWjNU6yF8ZBm84jEPRvoyuQ.css";s:64:"b604eee3ac6564656a39f19e241f54e27779d7d428d4cf385975baec598dca49";s:64:"public://css/css_jkGJh3SYfgTBFGryokgEbGHs9lokqRZs68QV1RAyw_k.css";s:64:"8058c9d02768fbaddbc3ef702596fe20dfd6d25178fbf5277c36c24e46a8642e";s:64:"public://css/css_beZ3IHJfDELNCBIK4koaMqtwgwdgCkFm0cislPqLeqE.css";s:64:"ebb3f433ad4107b1ac31e9d7de0f9a5d399040e9f82b6364211dcfaadea158c0";s:64:"public://css/css_Nv0ct-zkzztuah_LbaPFF8ZkdSEk-LxBtTWMm9mN_F8.css";s:64:"e63d18275c509e080e08748aff152b6936e631d6477dd15f61868b0c2b552aa2";s:64:"public://css/css_UX1mPKT46nuvmRnkSX0ZptG80rHdyCbk8Z6W0Pel4ks.css";s:64:"bb7e65006bd63d690873dba9c0c8847e1ab00f75a4e78d950fa58bd19e37f288";s:64:"public://css/css_Aup6ZRIxg-xynD_e1UAyOeB6-yD72WWl9s660J4oJIM.css";s:64:"74b24cfe0a8400e69cb668dfd662fcf30a2f9bfcdc9d8bf915aa90b8e52e5c0a";s:64:"public://css/css_ZXOA7m0NCKUORabYp3VLAgS2Oql1SESOb3ROaph8Kf8.css";s:64:"54d61a85c80350801ca8daf0c9daf7e70b561e19899149dc8a76351b8d3c4702";s:64:"public://css/css_SJ9GUwrWFuvWfKjGz3tp866UK5kXr5HhMOvz7ZnJfbk.css";s:64:"694d3f608e7e1390716984b717e0dfc7fb49dc4bdbe73ad43071d5957b3fe782";s:64:"public://css/css_zy2YIE9iDQFiPEtFxa9MbCfNdPPRHAmJgGDiamEMyJc.css";s:64:"5e9734618b1aa477bcae50fad707aa76bffa108b198e02e3c07522285ff2917a";s:64:"public://css/css_K_8zfASPQWK2cpViWr_GmV5wmX94w58pG2KP5BKwRFQ.css";s:64:"5a88849e9fbdaf6ff4d22c8f5e93a3333cfea83c5ff660b78a026516b85fba3d";s:64:"public://css/css_Psu1T2ZOhKvuf2sRB1ey8uws32lQz382IM5-9E61o_w.css";s:64:"67574af8fcea0e2df72dadd8b4c0bceb03b26e418487efe2ecbcfa05437147e0";s:64:"public://css/css_Mz40XE39FW8STFTB1vtKLzwkyfH-aBlJNyF6nKngaWI.css";s:64:"d88df08ac0892312b12f168fb78014aebdec3ef030ed9e854db693a454364815";s:64:"public://css/css_1GB-4E4xLVuPNkCAwmaEEY87nY0gVucQuwPiJ03uEY8.css";s:64:"cb9f93e666a396bb3eb14c5fd16f7ebd1cdd0067733eb0a2ab1b294b6f14f76f";s:64:"public://css/css_1kF33EODTO5gDyEbdpAfYzMKbjG3ottD1s5np0BNI8U.css";}');
INSERT INTO `variable` VALUES ('drupal_http_request_fails','b:0;'),('drupal_js_cache_files','a:21:{s:64:"ab825633a66c1131c2525d95d738171329fba852993dccf14838f0ada6242ff0";s:61:"public://js/js_aczm2rRgH_slWBPnvD3KMrK7rwa1i99HOq8IUAb99Co.js";s:64:"fe578eb124a4f462e15eaec115d81e4a01318bf72bc341fef1f30b475e1bbc99";s:61:"public://js/js_fl5ILJk7lDKU0mZwEnc838AqDw702osEMwpvpz6TBKU.js";s:64:"4b5132119b8bb748a299497f035d5694590f941b4ea1bf6d7650eb9bfc4c9fc2";s:61:"public://js/js_OmTzEw2YkeSGlpopn2YDusFX8T2KRyiakU3dUjMQ7ck.js";s:64:"894d50601a5da8e76dd47df54662af06bc3635d48ac2d1710d3105abc9dd4700";s:61:"public://js/js_UWahaALNNWQrS_SzX_4xoqn_0OsxlvvtiWXDaNnEmhY.js";s:64:"74f0ecd2ef5df5c823f79d353827b3f9134c427c316bf4cb41e7bc32b2c2e5bc";s:61:"public://js/js_LlEfbJsHAz_rZ-EK4oEwe3pTGBMAWlHOb-MlOc7-gGg.js";s:64:"a7b3848fc42049812629a55191ad4b536094e7b498bb4398092502a90bb538ce";s:61:"public://js/js_J8g9CYxbqA01kH6y5TY-u78CcQ0HRP7n6EM1al8Q1p8.js";s:64:"a1c98abf3a61aaddcf83f0579c730d7ca20c49408a8ab766be13e229ab0fe853";s:61:"public://js/js_cmXWZGGkuDw6LkgPmspzFSVErOtx9jEqCHLnhpjKjOs.js";s:64:"87949585cc2bdbbde8e805830fabdee9a81299c6b18f2601507fbd018bd1ab17";s:61:"public://js/js_S-Z3XDHco2c3FHDDavKUftym5DeHre9HYh1abqDjpAg.js";s:64:"473f5f74968571104965dfaeeddcfa31b64b674fd252296d2b3822373ce0770e";s:61:"public://js/js_GA3uOoZyw11qKwkd-0KmNizpn97m7ZrMisYSQgrRvo4.js";s:64:"65ed06c7dc9ef42e987a138e4ee195b90722491d677c80ddec7f7067f596418d";s:61:"public://js/js_2mAMkMnTURVHpXwHxxxPLU1TdvjhdVsMCYT_3UQbmZ8.js";s:64:"c94c9378b3214f1897195e505d5b5e06c8b210143c54546c1fcfe043fe587ef2";s:61:"public://js/js_g0r14t83CyFOie9dtTvScCfDLjFx09CaftsI4p5WL58.js";s:64:"f29f64d47d30edb80b1a1a4201327bcb75f810b54146d5c5fc6b7799730b3acd";s:61:"public://js/js_Pij67y7kXxR5YqAlPv7GtSPSeZiZAjlLr2tCt82WvBQ.js";s:64:"8f55b7fc1366e422a203caecb6b53333d218be7f20fc507851dba00f1f8787a0";s:61:"public://js/js_1VipguKcew-I75KcWJODcNFqFHpbywlpqMi9g0aApPI.js";s:64:"111d860265abe08204bdf363fb75e432b0104dd26ec9ad3853b748098098279b";s:61:"public://js/js_KCd8rbJYUruV1tRJnh4um34UYvyhlrSVCPR1jNko2h8.js";s:64:"fc0d9ed5946dadb79c8f43ac520b320367897352222b1a40861315f07ad8b7f1";s:61:"public://js/js_getZ4gB1RvTnCypANaRMZQuKixRSImU33vddXGSZu3w.js";s:64:"628736fc2d3ea60b319da16ecb5a5dc412b8dc774c15251e67244da868eaf14d";s:61:"public://js/js_jfVdiU16mJCOqMu8KIit3ds2dHZrSy_yrCrIbVuMrDc.js";s:64:"048c964f0e063f999e535ceef86091784378b8bc2b1b94c9f8dff4005c898134";s:61:"public://js/js_BLxotNs2yt7YGlf9QRI9L9AMfdnkQfnN-_ADBTW3SiE.js";s:64:"4acf0fba602c685e94d0201bb7059a5502902f1d0723f903be7087f7a26b973a";s:61:"public://js/js_whXdcRAKSaQrTplJlmiPZO57mPbBK1EoY7WJZOV8tjU.js";s:64:"9806a539d4bab08ab3fbfde6560f7ea51e363fadb98ab9c5ea17e85828902c1b";s:61:"public://js/js_ZwtHh_UtMhEyIZ7P23uU_tO_tZHXgPG1rk11b_m8s9Y.js";s:64:"8714fd12b17944f31d9fea22486d8b8dc376bcff6da8d8d6a75eab3a3159d989";s:61:"public://js/js_xWb8oniZ6mHP9PkGTevh6VoT9P-hunxjOtpZUoDBCoI.js";s:64:"8ed0c4dc16644958e3caf1e65148709069b4f816d47e60e29b24db55a1b657d1";s:61:"public://js/js_aAlGj0C4DI7o_m9IO_M_DJP1CK2P4W9TmeC9iZ9SSKQ.js";}');
INSERT INTO `variable` VALUES ('drupal_private_key','s:43:"NgfT-C6pSl05DtEXu7NFHaz6-1Cuj7Olig5yAgsSFRg";'),('eck_clear_caches','b:0;'),('email__active_tab','s:24:"edit-email-admin-created";'),('empty_timezone_message','i:0;'),('entityreference:base-tables','a:36:{s:7:"comment";a:2:{i:0;s:7:"comment";i:1;s:3:"cid";}s:8:"activity";a:2:{i:0;s:12:"eck_activity";i:1;s:2:"id";}s:12:"activity_log";a:2:{i:0;s:16:"eck_activity_log";i:1;s:2:"id";}s:22:"activity_log_reference";a:2:{i:0;s:26:"eck_activity_log_reference";i:1;s:2:"id";}s:5:"badge";a:2:{i:0;s:9:"eck_badge";i:1;s:2:"id";}s:6:"branch";a:2:{i:0;s:10:"eck_branch";i:1;s:2:"id";}s:14:"drawing_ticket";a:2:{i:0;s:18:"eck_drawing_ticket";i:1;s:2:"id";}s:5:"level";a:2:{i:0;s:9:"eck_level";i:1;s:2:"id";}s:11:"nag_message";a:2:{i:0;s:15:"eck_nag_message";i:1;s:2:"id";}s:6:"points";a:2:{i:0;s:10:"eck_points";i:1;s:2:"id";}s:5:"prize";a:2:{i:0;s:9:"eck_prize";i:1;s:2:"id";}s:7:"program";a:2:{i:0;s:11:"eck_program";i:1;s:2:"id";}s:6:"reader";a:2:{i:0;s:10:"eck_reader";i:1;s:2:"id";}s:19:"reader_activity_log";a:2:{i:0;s:23:"eck_reader_activity_log";i:1;s:2:"id";}s:12:"reader_badge";a:2:{i:0;s:16:"eck_reader_badge";i:1;s:2:"id";}s:10:"reader_log";a:2:{i:0;s:14:"eck_reader_log";i:1;s:2:"id";}s:12:"reader_prize";a:2:{i:0;s:16:"eck_reader_prize";i:1;s:2:"id";}s:13:"reader_ticket";a:2:{i:0;s:17:"eck_reader_ticket";i:1;s:2:"id";}s:11:"reading_log";a:2:{i:0;s:15:"eck_reading_log";i:1;s:2:"id";}s:6:"school";a:2:{i:0;s:10:"eck_school";i:1;s:2:"id";}s:10:"entityform";a:2:{i:0;s:10:"entityform";i:1;s:13:"entityform_id";}s:15:"entityform_type";a:2:{i:0;s:15:"entityform_type";i:1;s:2:"id";}s:12:"entity_block";a:2:{i:0;s:12:"entity_block";i:1;s:15:"entity_block_id";}s:21:"field_collection_item";a:2:{i:0;s:21:"field_collection_item";i:1;s:7:"item_id";}s:4:"node";a:2:{i:0;s:4:"node";i:1;s:3:"nid";}s:4:"file";a:2:{i:0;s:12:"file_managed";i:1;s:3:"fid";}s:13:"taxonomy_term";a:2:{i:0;s:18:"taxonomy_term_data";i:1;s:3:"tid";}s:19:"taxonomy_vocabulary";a:2:{i:0;s:19:"taxonomy_vocabulary";i:1;s:3:"vid";}s:4:"user";a:2:{i:0;s:5:"users";i:1;s:3:"uid";}s:8:"Workflow";a:2:{i:0;s:9:"workflows";i:1;s:3:"wid";}s:13:"WorkflowState";a:2:{i:0;s:15:"workflow_states";i:1;s:3:"sid";}s:24:"WorkflowConfigTransition";a:2:{i:0;s:20:"workflow_transitions";i:1;s:3:"tid";}s:18:"WorkflowTransition";a:2:{i:0;s:21:"workflow_node_history";i:1;s:3:"hid";}s:27:"WorkflowScheduledTransition";a:2:{i:0;s:29:"workflow_scheduled_transition";i:1;s:3:"tid";}s:15:"wysiwyg_profile";a:2:{i:0;s:7:"wysiwyg";i:1;s:6:"format";}s:12:"rules_config";a:2:{i:0;s:12:"rules_config";i:1;s:2:"id";}}');
INSERT INTO `variable` VALUES ('entity_cache_tables_created','N;'),('error_level','s:1:"0";'),('features_codecache','a:6:{s:18:"bookpoints_drawing";a:2:{s:12:"dependencies";s:32:"242d389f813a156ec0b8c564d5aff0c6";s:10:"views_view";s:32:"3fe3aa0701ba26ca2598375e62ded574";}s:17:"bookpoints_events";a:5:{s:4:"node";s:32:"133c39be859aa51181bab45105b9f177";s:10:"field_base";s:32:"bba1b47dca5f2ab5b3e69fa66fc4c7d3";s:14:"field_instance";s:32:"ff004a21c6186c0ef9855f26cf900283";s:12:"dependencies";s:32:"8a5e7b996ae2ccc445d224152eaac2c4";s:10:"views_view";s:32:"0e0a4fdb20260f5dcc24f67c0473a505";}s:12:"feeds_import";a:2:{s:12:"dependencies";s:32:"981314fbdcdc839f8ba1d10a17259887";s:14:"feeds_importer";s:32:"758e3955b8f76773fe3278b415e34710";}s:8:"booklist";a:6:{s:4:"node";s:32:"18b940b32dd8c95cfc996a9f958601e9";s:10:"field_base";s:32:"361df17e9ea95cc0194aec1b84469c7d";s:14:"field_instance";s:32:"f27935be237b8390f3833ce4744c6902";s:11:"menu_custom";s:32:"d4c1e942ff7cb5bda175821ae83864b6";s:10:"menu_links";s:32:"cb282c8dde19fd0f0579694639d170c9";s:12:"dependencies";s:32:"1b648f196e25ac496dc5a8405ffbb218";}s:9:"book_logs";a:2:{s:12:"dependencies";s:32:"242d389f813a156ec0b8c564d5aff0c6";s:10:"views_view";s:32:"2c9f48a61524e62e74295ca8d2fa9596";}s:20:"bookpoints_importers";a:2:{s:12:"dependencies";s:32:"a84e0b758766d34d304d8a93b3a3bb95";s:14:"feeds_importer";s:32:"d0b7349960905c703e8f0e7612000753";}}'),('features_ignored_orphans','a:0:{}'),('features_modules_changed','b:0;'),('features_semaphore','a:0:{}'),('feeds_reschedule','b:0;'),('field_bundle_settings_activity_log_reference__activity_log_reference','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_activity_log__activity_log','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_activity__activity','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_activity__secret_code','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}');
INSERT INTO `variable` VALUES ('field_bundle_settings_badge__badge','a:2:{s:10:"view_modes";a:3:{s:6:"teaser";a:1:{s:15:"custom_settings";b:1;}s:4:"full";a:1:{s:15:"custom_settings";b:0;}s:5:"token";a:1:{s:15:"custom_settings";b:0;}}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_branch__branch','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_drawing_ticket__drawing_ticket','a:2:{s:10:"view_modes";a:3:{s:6:"teaser";a:1:{s:15:"custom_settings";b:1;}s:4:"full";a:1:{s:15:"custom_settings";b:0;}s:5:"token";a:1:{s:15:"custom_settings";b:0;}}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_level__level','a:2:{s:10:"view_modes";a:3:{s:6:"teaser";a:1:{s:15:"custom_settings";b:1;}s:4:"full";a:1:{s:15:"custom_settings";b:0;}s:5:"token";a:1:{s:15:"custom_settings";b:0;}}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_nag_message__nag_message','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_node__customformfields','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:2:{s:5:"title";a:1:{s:6:"weight";s:2:"-5";}s:4:"path";a:1:{s:6:"weight";s:2:"30";}}s:7:"display";a:0:{}}}'),('field_bundle_settings_points__points','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_prize__prize','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_program__program','a:2:{s:10:"view_modes";a:3:{s:6:"teaser";a:1:{s:15:"custom_settings";b:1;}s:4:"full";a:1:{s:15:"custom_settings";b:0;}s:5:"token";a:1:{s:15:"custom_settings";b:0;}}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_reader_activity_log__reader_activity_log','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}');
INSERT INTO `variable` VALUES ('field_bundle_settings_reader_badge__reader_badge','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_reader_log__reader_log','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_reader_prize__reader_prize','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_reader_ticket__reader_ticket','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_reader__reader','a:2:{s:10:"view_modes";a:3:{s:6:"teaser";a:1:{s:15:"custom_settings";b:1;}s:4:"full";a:1:{s:15:"custom_settings";b:0;}s:5:"token";a:1:{s:15:"custom_settings";b:0;}}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_reading_log__reading_log','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_school__school','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:0:{}s:7:"display";a:0:{}}}'),('field_bundle_settings_taxonomy_term__badge','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:3:{s:4:"path";a:1:{s:6:"weight";s:2:"30";}s:4:"name";a:1:{s:6:"weight";s:2:"-5";}s:11:"description";a:1:{s:6:"weight";s:1:"0";}}s:7:"display";a:0:{}}}'),('field_bundle_settings_user__user','a:2:{s:10:"view_modes";a:0:{}s:12:"extra_fields";a:2:{s:4:"form";a:7:{s:15:"googleanalytics";a:1:{s:6:"weight";s:1:"3";}s:12:"profile_main";a:1:{s:6:"weight";s:1:"0";}s:7:"account";a:1:{s:6:"weight";s:3:"-10";}s:8:"timezone";a:1:{s:6:"weight";s:1:"6";}s:7:"picture";a:1:{s:6:"weight";s:1:"5";}s:15:"overlay_control";a:1:{s:6:"weight";s:1:"5";}s:7:"wysiwyg";a:1:{s:6:"weight";s:1:"5";}}s:7:"display";a:0:{}}}'),('file_default_scheme','s:6:"public";'),('file_private_path','s:10:"../private";'),('file_public_path','s:19:"sites/default/files";'),('file_temporary_path','s:14:"../private/tmp";');
INSERT INTO `variable` VALUES ('filter_fallback_format','s:10:"plain_text";'),('imce_profiles','a:2:{i:1;a:10:{s:4:"name";s:6:"User-1";s:7:"usertab";i:1;s:8:"filesize";i:0;s:5:"quota";i:0;s:7:"tuquota";i:0;s:10:"extensions";s:1:"*";s:10:"dimensions";s:9:"1200x1200";s:7:"filenum";i:0;s:11:"directories";a:1:{i:0;a:7:{s:4:"name";s:1:".";s:6:"subnav";i:1;s:6:"browse";i:1;s:6:"upload";i:1;s:5:"thumb";i:1;s:6:"delete";i:1;s:6:"resize";i:1;}}s:10:"thumbnails";a:3:{i:0;a:4:{s:4:"name";s:5:"Small";s:10:"dimensions";s:5:"90x90";s:6:"prefix";s:6:"small_";s:6:"suffix";s:0:"";}i:1;a:4:{s:4:"name";s:6:"Medium";s:10:"dimensions";s:7:"120x120";s:6:"prefix";s:7:"medium_";s:6:"suffix";s:0:"";}i:2;a:4:{s:4:"name";s:5:"Large";s:10:"dimensions";s:7:"180x180";s:6:"prefix";s:6:"large_";s:6:"suffix";s:0:"";}}}i:2;a:10:{s:4:"name";s:13:"Basic profile";s:7:"usertab";i:0;s:8:"filesize";s:1:"8";s:5:"quota";s:0:"";s:7:"tuquota";s:3:"250";s:10:"extensions";s:16:"gif png jpg jpeg";s:10:"dimensions";s:7:"800x600";s:7:"filenum";s:1:"1";s:11:"directories";a:0:{}s:10:"thumbnails";a:1:{i:0;a:4:{s:4:"name";s:5:"Thumb";s:10:"dimensions";s:5:"90x90";s:6:"prefix";s:6:"thumb_";s:6:"suffix";s:0:"";}}}}'),('imce_roles_profiles','a:5:{i:3;a:3:{s:6:"weight";s:2:"-5";s:10:"public_pid";s:1:"2";s:11:"private_pid";s:1:"2";}i:4;a:3:{s:6:"weight";s:1:"0";s:10:"public_pid";i:0;s:11:"private_pid";i:0;}i:5;a:3:{s:6:"weight";s:1:"0";s:10:"public_pid";s:1:"2";s:11:"private_pid";s:1:"2";}i:2;a:3:{s:6:"weight";i:11;s:10:"public_pid";i:0;s:11:"private_pid";i:0;}i:1;a:3:{s:6:"weight";i:12;s:10:"public_pid";i:0;s:11:"private_pid";i:0;}}'),('imce_settings_absurls','i:0;'),('imce_settings_disable_private','i:1;'),('imce_settings_replace','s:1:"0";'),('imce_settings_textarea','s:0:"";'),('imce_settings_thumb_method','s:5:"scale";'),('install_profile','s:8:"pantheon";'),('install_task','s:4:"done";'),('install_time','i:1476997816;'),('job_scheduler_rebuild_all','b:0;'),('jquery_update_compression_type','s:3:"min";'),('jquery_update_jquery_admin_version','s:0:"";'),('jquery_update_jquery_cdn','s:6:"jquery";');
INSERT INTO `variable` VALUES ('jquery_update_jquery_version','s:3:"1.8";'),('locale_custom_strings_en','a:0:{}'),('mail_system','a:1:{s:14:"default-system";s:14:"SmtpMailSystem";}'),('menu_default_active_menus','a:9:{i:0;s:5:"devel";i:1;s:8:"features";i:3;s:18:"menu-library-menu1";i:4;s:9:"main-menu";i:5;s:10:"management";i:6;s:10:"navigation";i:7;s:17:"menu-library-menu";i:8;s:9:"user-menu";i:9;s:15:"menu-setup-menu";}'),('menu_expanded','a:0:{}'),('menu_masks','a:46:{i:0;i:507;i:1;i:506;i:2;i:501;i:3;i:493;i:4;i:255;i:5;i:253;i:6;i:252;i:7;i:250;i:8;i:247;i:9;i:246;i:10;i:245;i:11;i:127;i:12;i:126;i:13;i:125;i:14;i:124;i:15;i:123;i:16;i:122;i:17;i:121;i:18;i:117;i:19;i:63;i:20;i:62;i:21;i:61;i:22;i:60;i:23;i:59;i:24;i:58;i:25;i:56;i:26;i:44;i:27;i:31;i:28;i:30;i:29;i:29;i:30;i:28;i:31;i:27;i:32;i:26;i:33;i:24;i:34;i:21;i:35;i:15;i:36;i:14;i:37;i:13;i:38;i:11;i:39;i:7;i:40;i:6;i:41;i:5;i:42;i:4;i:43;i:3;i:44;i:2;i:45;i:1;}'),('menu_options_customformfields','a:1:{i:0;s:9:"main-menu";}'),('menu_parent_customformfields','s:11:"main-menu:0";'),('node_admin_theme','s:1:"1";'),('node_options_customformfields','a:2:{i:0;s:6:"status";i:1;s:7:"promote";}'),('node_options_page','a:1:{i:0;s:6:"status";}'),('node_preview_customformfields','s:1:"1";'),('node_submitted_customformfields','i:1;'),('node_submitted_page','b:0;'),('page_cache_maximum_age','s:3:"900";'),('page_compression','i:0;'),('pathauto_blog_pattern','s:17:"blogs/[user:name]";'),('pathauto_forum_pattern','s:29:"[term:vocabulary]/[term:name]";'),('pathauto_node_pattern','s:20:"content/[node:title]";'),('pathauto_punctuation_hyphen','i:1;'),('pathauto_taxonomy_term_pattern','s:29:"[term:vocabulary]/[term:name]";'),('pathauto_user_pattern','s:17:"users/[user:name]";'),('path_alias_whitelist','a:3:{s:4:"node";b:1;s:8:"taxonomy";b:1;s:4:"user";b:1;}'),('preprocess_css','i:1;'),('preprocess_js','i:1;'),('rules_debug','s:1:"0";'),('rules_debug_log','i:1;'),('rules_debug_region_bookpoints_custom','s:4:"help";'),('rules_debug_region_seven','s:4:"help";'),('rules_log_errors','s:1:"2";');
INSERT INTO `variable` VALUES ('rules_path_cleaning_callback','s:34:"rules_path_default_cleaning_method";'),('save_continue_customformfields','s:19:"Save and add fields";'),('search_active_modules','a:3:{s:17:"apachesolr_search";s:17:"apachesolr_search";s:4:"user";s:4:"user";s:4:"node";i:0;}'),('search_default_module','s:17:"apachesolr_search";'),('site_403','s:0:"";'),('site_404','s:0:"";'),('site_default_country','s:2:"US";'),('site_frontpage','s:4:"home";'),('site_mail','s:16:"site@example.com";'),('site_name','s:11:"Book Points";'),('site_slogan','s:17:"tagline goes here";'),('smtp_allowhtml','i:0;'),('smtp_client_helo','s:0:"";'),('smtp_client_hostname','s:19:"readingbydesign.org";'),('smtp_debugging','s:1:"0";'),('smtp_deliver','s:1:"1";'),('smtp_from','s:24:"team@readingbydesign.org";'),('smtp_fromname','s:10:"BookPoints";'),('smtp_host','s:20:"smtp-relay.gmail.com";'),('smtp_hostbackup','s:0:"";'),('smtp_on','s:1:"1";'),('smtp_password','s:25:"fas24rnb0..dFEF3LO.XX99!!";'),('smtp_port','s:3:"587";'),('smtp_previous_mail_system','s:17:"DefaultMailSystem";'),('smtp_protocol','s:3:"tls";'),('smtp_queue','i:0;'),('smtp_queue_fail','i:1;'),('smtp_reroute_address','s:0:"";'),('smtp_username','s:26:"server@readingbydesign.org";'),('statistics_count_content_views','i:1;');
INSERT INTO `variable` VALUES ('statistics_count_content_views_ajax','i:0;'),('statistics_day_timestamp','i:1493618724;'),('statistics_enable_access_log','i:1;'),('statistics_flush_accesslog_timer','s:7:"9676800";'),('terms_of_use_checkbox_label','s:24:"I agree with these terms";'),('terms_of_use_fieldset_name','s:12:"Terms of Use";'),('terms_of_use_node_id','s:2:"19";'),('terms_of_use_node_title','s:12:"Terms of Use";'),('theme_bookpoints_custom_files_directory','s:46:"public://adaptivetheme/bookpoints_custom_files";'),('theme_bookpoints_custom_settings','a:468:{s:11:"toggle_logo";i:1;s:11:"toggle_name";i:1;s:13:"toggle_slogan";i:1;s:24:"toggle_node_user_picture";i:0;s:27:"toggle_comment_user_picture";i:0;s:32:"toggle_comment_user_verification";i:0;s:14:"toggle_favicon";i:1;s:12:"default_logo";i:1;s:9:"logo_path";s:0:"";s:11:"logo_upload";s:0:"";s:15:"default_favicon";i:1;s:12:"favicon_path";s:0:"";s:14:"favicon_upload";s:0:"";s:16:"bigscreen_layout";s:15:"three_col_grail";s:22:"bigscreen_sidebar_unit";s:1:"%";s:23:"bigscreen_sidebar_first";s:2:"20";s:24:"bigscreen_sidebar_second";s:2:"28";s:19:"bigscreen_page_unit";s:1:"%";s:20:"bigscreen_page_width";s:3:"100";s:23:"bigscreen_set_max_width";i:1;s:24:"bigscreen_max_width_unit";s:2:"px";s:19:"bigscreen_max_width";s:4:"1600";s:21:"bigscreen_media_query";s:37:"only screen and (min-width:64.0625em)";s:23:"tablet_landscape_layout";s:15:"three_col_grail";s:29:"tablet_landscape_sidebar_unit";s:1:"%";s:30:"tablet_landscape_sidebar_first";s:2:"20";s:31:"tablet_landscape_sidebar_second";s:2:"20";s:26:"tablet_landscape_page_unit";s:1:"%";s:27:"tablet_landscape_page_width";s:3:"100";s:28:"tablet_landscape_media_query";s:58:"only screen and (min-width:48.0625em) and (max-width:64em)";s:22:"tablet_portrait_layout";s:12:"one_col_vert";s:28:"tablet_portrait_sidebar_unit";s:1:"%";s:29:"tablet_portrait_sidebar_first";s:2:"50";s:30:"tablet_portrait_sidebar_second";s:2:"50";s:25:"tablet_portrait_page_unit";s:1:"%";s:26:"tablet_portrait_page_width";s:3:"100";s:27:"tablet_portrait_media_query";s:58:"only screen and (min-width:30.0625em) and (max-width:48em)";s:27:"smalltouch_landscape_layout";s:12:"one_col_vert";s:33:"smalltouch_landscape_sidebar_unit";s:1:"%";s:34:"smalltouch_landscape_sidebar_first";s:2:"50";s:35:"smalltouch_landscape_sidebar_second";s:2:"50";s:32:"smalltouch_landscape_media_query";s:58:"only screen and (min-width:20.0625em) and (max-width:30em)";s:31:"smalltouch_landscape_page_width";s:3:"100";s:30:"smalltouch_landscape_page_unit";s:1:"%";s:31:"smalltouch_portrait_media_query";s:32:"only screen and (max-width:20em)";s:30:"smalltouch_portrait_page_width";s:3:"100";s:29:"smalltouch_portrait_page_unit";s:1:"%";s:33:"smalltouch_portrait_sidebar_first";s:3:"100";s:34:"smalltouch_portrait_sidebar_second";s:3:"100";s:32:"smalltouch_portrait_sidebar_unit";s:1:"%";s:26:"smalltouch_portrait_layout";s:13:"one_col_stack";s:24:"bigscreen_three_50_25_25";s:14:"three-50-25-25";s:20:"bigscreen_three_3x33";s:10:"three-3x33";s:24:"bigscreen_three_25_25_50";s:14:"three-25-25-50";s:24:"bigscreen_three_25_50_25";s:14:"three-25-50-25";s:19:"bigscreen_two_brick";s:9:"two-brick";s:16:"bigscreen_two_50";s:6:"two-50";s:19:"bigscreen_two_66_33";s:9:"two-66-33";s:19:"bigscreen_two_33_66";s:9:"two-33-66";s:19:"bigscreen_four_4x25";s:9:"four-4x25";s:19:"bigscreen_five_5x20";s:18:"five-5x20-2x3-grid";s:18:"bigscreen_six_6x16";s:17:"six-6x16-3x2-grid";s:27:"bigscreen_three_inset_right";s:17:"three-inset-right";s:26:"bigscreen_three_inset_left";s:16:"three-inset-left";s:31:"tablet_landscape_three_50_25_25";s:14:"three-50-25-25";s:27:"tablet_landscape_three_3x33";s:10:"three-3x33";s:31:"tablet_landscape_three_25_25_50";s:14:"three-25-25-50";s:31:"tablet_landscape_three_25_50_25";s:14:"three-25-50-25";s:26:"tablet_landscape_two_brick";s:9:"two-brick";s:23:"tablet_landscape_two_50";s:6:"two-50";s:26:"tablet_landscape_two_66_33";s:9:"two-66-33";s:26:"tablet_landscape_two_33_66";s:9:"two-33-66";s:26:"tablet_landscape_four_4x25";s:9:"four-4x25";s:26:"tablet_landscape_five_5x20";s:18:"five-5x20-2x3-grid";s:25:"tablet_landscape_six_6x16";s:17:"six-6x16-3x2-grid";s:34:"tablet_landscape_three_inset_right";s:17:"three-inset-right";s:33:"tablet_landscape_three_inset_left";s:16:"three-inset-left";s:30:"tablet_portrait_three_50_25_25";s:24:"three-50-25-25-stack-top";s:26:"tablet_portrait_three_3x33";s:20:"three-3x33-stack-top";s:30:"tablet_portrait_three_25_25_50";s:24:"three-25-25-50-stack-top";s:30:"tablet_portrait_three_25_50_25";s:24:"three-25-50-25-stack-top";s:25:"tablet_portrait_two_brick";s:9:"two-brick";s:22:"tablet_portrait_two_50";s:6:"two-50";s:25:"tablet_portrait_two_66_33";s:9:"two-66-33";s:25:"tablet_portrait_two_33_66";s:9:"two-33-66";s:25:"tablet_portrait_four_4x25";s:18:"four-4x25-2x2-grid";s:25:"tablet_portrait_five_5x20";s:20:"five-5x20-1x2x2-grid";s:24:"tablet_portrait_six_6x16";s:17:"six-6x16-2x3-grid";s:33:"tablet_portrait_three_inset_right";s:22:"three-inset-right-wrap";s:32:"tablet_portrait_three_inset_left";s:21:"three-inset-left-wrap";s:35:"smalltouch_landscape_three_50_25_25";s:20:"three-50-25-25-stack";s:31:"smalltouch_landscape_three_3x33";s:16:"three-3x33-stack";s:35:"smalltouch_landscape_three_25_25_50";s:20:"three-25-25-50-stack";s:35:"smalltouch_landscape_three_25_50_25";s:20:"three-25-50-25-stack";s:30:"smalltouch_landscape_two_brick";s:15:"two-brick-stack";s:27:"smalltouch_landscape_two_50";s:12:"two-50-stack";s:30:"smalltouch_landscape_two_66_33";s:15:"two-66-33-stack";s:30:"smalltouch_landscape_two_33_66";s:15:"two-33-66-stack";s:30:"smalltouch_landscape_four_4x25";s:15:"four-4x25-stack";s:30:"smalltouch_landscape_five_5x20";s:15:"five-5x20-stack";s:29:"smalltouch_landscape_six_6x16";s:14:"six-6x16-stack";s:38:"smalltouch_landscape_three_inset_right";s:23:"three-inset-right-stack";s:37:"smalltouch_landscape_three_inset_left";s:22:"three-inset-left-stack";s:28:"global_default_layout_toggle";i:0;s:21:"global_default_layout";s:19:"smalltouch-portrait";s:25:"disable_responsive_styles";i:0;s:17:"global_files_path";s:12:"public_files";s:17:"custom_files_path";s:0:"";s:17:"combine_css_files";i:0;s:16:"combine_js_files";i:0;s:27:"enable_custom_media_queries";i:0;s:12:"load_html5js";i:1;s:17:"load_matchmediajs";i:0;s:19:"load_onmediaqueryjs";i:0;s:13:"load_ltie8css";i:0;s:14:"load_respondjs";i:0;s:15:"load_scalefixjs";i:0;s:27:"adaptivetheme_meta_viewport";s:35:"width=device-width, initial-scale=1";s:34:"adaptivetheme_meta_mobileoptimized";s:5:"width";s:35:"adaptivetheme_meta_handheldfriendly";s:1:"1";s:47:"adaptivetheme_meta_apple_mobile_web_app_capable";s:3:"yes";s:35:"adaptivetheme_meta_ie_document_mode";s:0:"";s:29:"adaptivetheme_meta_clear_type";i:0;s:14:"expose_regions";i:0;s:16:"show_window_size";i:0;s:19:"atcore_version_test";i:0;s:15:"load_all_panels";i:0;s:27:"load_all_panels_no_sidebars";i:0;s:17:"enable_extensions";i:1;s:20:"enable_font_settings";i:1;s:23:"enable_heading_settings";i:0;s:21:"enable_image_settings";i:1;s:24:"enable_apple_touch_icons";i:0;s:18:"enable_exclude_css";i:0;s:17:"enable_custom_css";i:1;s:22:"enable_context_regions";i:0;s:18:"enable_menu_toggle";i:1;s:26:"enable_float_region_blocks";i:0;s:22:"enable_markup_overides";i:1;s:23:"at-settings__active_tab";s:11:"edit-extend";s:14:"base_font_type";s:3:"cfs";s:9:"base_font";s:5:"bf-cc";s:13:"base_font_gwf";s:0:"";s:24:"base_font_gwf_add_styles";i:0;s:28:"base_font_gwf_add_styles_300";i:0;s:34:"base_font_gwf_add_styles_300italic";i:0;s:28:"base_font_gwf_add_styles_400";i:0;s:34:"base_font_gwf_add_styles_400italic";i:0;s:28:"base_font_gwf_add_styles_700";i:0;s:34:"base_font_gwf_add_styles_700italic";i:0;s:26:"base_font_gwf_add_charsets";i:0;s:32:"base_font_gwf_add_charsets_latin";i:0;s:36:"base_font_gwf_add_charsets_latin-ext";i:0;s:32:"base_font_gwf_add_charsets_greek";i:0;s:36:"base_font_gwf_add_charsets_greek-ext";i:0;s:35:"base_font_gwf_add_charsets_cyrillic";i:0;s:39:"base_font_gwf_add_charsets_cyrillic-ext";i:0;s:32:"base_font_gwf_add_charsets_khmer";i:0;s:37:"base_font_gwf_add_charsets_vietnamese";i:0;s:13:"base_font_cfs";s:43:"''Helvetica Neue'',Helvetica,Arial,sans-serif";s:14:"base_font_size";s:4:"100%";s:19:"site_name_font_type";s:3:"cfs";s:14:"site_name_font";s:5:"bf-cc";s:18:"site_name_font_gwf";s:0:"";s:29:"site_name_font_gwf_add_styles";i:0;s:33:"site_name_font_gwf_add_styles_300";i:0;s:39:"site_name_font_gwf_add_styles_300italic";i:0;s:33:"site_name_font_gwf_add_styles_400";i:0;s:39:"site_name_font_gwf_add_styles_400italic";i:0;s:33:"site_name_font_gwf_add_styles_700";i:0;s:39:"site_name_font_gwf_add_styles_700italic";i:0;s:31:"site_name_font_gwf_add_charsets";i:0;s:37:"site_name_font_gwf_add_charsets_latin";i:0;s:41:"site_name_font_gwf_add_charsets_latin-ext";i:0;s:37:"site_name_font_gwf_add_charsets_greek";i:0;s:41:"site_name_font_gwf_add_charsets_greek-ext";i:0;s:40:"site_name_font_gwf_add_charsets_cyrillic";i:0;s:44:"site_name_font_gwf_add_charsets_cyrillic-ext";i:0;s:37:"site_name_font_gwf_add_charsets_khmer";i:0;s:42:"site_name_font_gwf_add_charsets_vietnamese";i:0;s:18:"site_name_font_cfs";s:43:"''Helvetica Neue'',Helvetica,Arial,sans-serif";s:19:"site_name_font_size";s:5:"3.2em";s:21:"site_slogan_font_type";s:3:"cfs";s:16:"site_slogan_font";s:5:"bf-cc";s:20:"site_slogan_font_gwf";s:0:"";s:31:"site_slogan_font_gwf_add_styles";i:0;s:35:"site_slogan_font_gwf_add_styles_300";i:0;s:41:"site_slogan_font_gwf_add_styles_300italic";i:0;s:35:"site_slogan_font_gwf_add_styles_400";i:0;s:41:"site_slogan_font_gwf_add_styles_400italic";i:0;s:35:"site_slogan_font_gwf_add_styles_700";i:0;s:41:"site_slogan_font_gwf_add_styles_700italic";i:0;s:33:"site_slogan_font_gwf_add_charsets";i:0;s:39:"site_slogan_font_gwf_add_charsets_latin";i:0;s:43:"site_slogan_font_gwf_add_charsets_latin-ext";i:0;s:39:"site_slogan_font_gwf_add_charsets_greek";i:0;s:43:"site_slogan_font_gwf_add_charsets_greek-ext";i:0;s:42:"site_slogan_font_gwf_add_charsets_cyrillic";i:0;s:46:"site_slogan_font_gwf_add_charsets_cyrillic-ext";i:0;s:39:"site_slogan_font_gwf_add_charsets_khmer";i:0;s:44:"site_slogan_font_gwf_add_charsets_vietnamese";i:0;s:20:"site_slogan_font_cfs";s:43:"''Helvetica Neue'',Helvetica,Arial,sans-serif";s:21:"site_slogan_font_size";s:5:"1.2em";s:20:"page_title_font_type";s:3:"cfs";s:15:"page_title_font";s:5:"bf-cc";s:19:"page_title_font_gwf";s:0:"";s:30:"page_title_font_gwf_add_styles";i:0;s:34:"page_title_font_gwf_add_styles_300";i:0;s:40:"page_title_font_gwf_add_styles_300italic";i:0;s:34:"page_title_font_gwf_add_styles_400";i:0;s:40:"page_title_font_gwf_add_styles_400italic";i:0;s:34:"page_title_font_gwf_add_styles_700";i:0;s:40:"page_title_font_gwf_add_styles_700italic";i:0;s:32:"page_title_font_gwf_add_charsets";i:0;s:38:"page_title_font_gwf_add_charsets_latin";i:0;s:42:"page_title_font_gwf_add_charsets_latin-ext";i:0;s:38:"page_title_font_gwf_add_charsets_greek";i:0;s:42:"page_title_font_gwf_add_charsets_greek-ext";i:0;s:41:"page_title_font_gwf_add_charsets_cyrillic";i:0;s:45:"page_title_font_gwf_add_charsets_cyrillic-ext";i:0;s:38:"page_title_font_gwf_add_charsets_khmer";i:0;s:43:"page_title_font_gwf_add_charsets_vietnamese";i:0;s:19:"page_title_font_cfs";s:43:"''Helvetica Neue'',Helvetica,Arial,sans-serif";s:20:"page_title_font_size";s:3:"2em";s:20:"node_title_font_type";s:3:"cfs";s:15:"node_title_font";s:5:"bf-cc";s:19:"node_title_font_gwf";s:0:"";s:30:"node_title_font_gwf_add_styles";i:0;s:34:"node_title_font_gwf_add_styles_300";i:0;s:40:"node_title_font_gwf_add_styles_300italic";i:0;s:34:"node_title_font_gwf_add_styles_400";i:0;s:40:"node_title_font_gwf_add_styles_400italic";i:0;s:34:"node_title_font_gwf_add_styles_700";i:0;s:40:"node_title_font_gwf_add_styles_700italic";i:0;s:32:"node_title_font_gwf_add_charsets";i:0;s:38:"node_title_font_gwf_add_charsets_latin";i:0;s:42:"node_title_font_gwf_add_charsets_latin-ext";i:0;s:38:"node_title_font_gwf_add_charsets_greek";i:0;s:42:"node_title_font_gwf_add_charsets_greek-ext";i:0;s:41:"node_title_font_gwf_add_charsets_cyrillic";i:0;s:45:"node_title_font_gwf_add_charsets_cyrillic-ext";i:0;s:38:"node_title_font_gwf_add_charsets_khmer";i:0;s:43:"node_title_font_gwf_add_charsets_vietnamese";i:0;s:19:"node_title_font_cfs";s:43:"''Helvetica Neue'',Helvetica,Arial,sans-serif";s:20:"node_title_font_size";s:5:"1.6em";s:23:"comment_title_font_type";s:3:"cfs";s:18:"comment_title_font";s:5:"bf-cc";s:22:"comment_title_font_gwf";s:0:"";s:33:"comment_title_font_gwf_add_styles";i:0;s:37:"comment_title_font_gwf_add_styles_300";i:0;s:43:"comment_title_font_gwf_add_styles_300italic";i:0;s:37:"comment_title_font_gwf_add_styles_400";i:0;s:43:"comment_title_font_gwf_add_styles_400italic";i:0;s:37:"comment_title_font_gwf_add_styles_700";i:0;s:43:"comment_title_font_gwf_add_styles_700italic";i:0;s:35:"comment_title_font_gwf_add_charsets";i:0;s:41:"comment_title_font_gwf_add_charsets_latin";i:0;s:45:"comment_title_font_gwf_add_charsets_latin-ext";i:0;s:41:"comment_title_font_gwf_add_charsets_greek";i:0;s:45:"comment_title_font_gwf_add_charsets_greek-ext";i:0;s:44:"comment_title_font_gwf_add_charsets_cyrillic";i:0;s:48:"comment_title_font_gwf_add_charsets_cyrillic-ext";i:0;s:41:"comment_title_font_gwf_add_charsets_khmer";i:0;s:46:"comment_title_font_gwf_add_charsets_vietnamese";i:0;s:22:"comment_title_font_cfs";s:43:"''Helvetica Neue'',Helvetica,Arial,sans-serif";s:23:"comment_title_font_size";s:5:"1.4em";s:21:"block_title_font_type";s:3:"cfs";s:16:"block_title_font";s:5:"bf-cc";s:20:"block_title_font_gwf";s:0:"";s:31:"block_title_font_gwf_add_styles";i:0;s:35:"block_title_font_gwf_add_styles_300";i:0;s:41:"block_title_font_gwf_add_styles_300italic";i:0;s:35:"block_title_font_gwf_add_styles_400";i:0;s:41:"block_title_font_gwf_add_styles_400italic";i:0;s:35:"block_title_font_gwf_add_styles_700";i:0;s:41:"block_title_font_gwf_add_styles_700italic";i:0;s:33:"block_title_font_gwf_add_charsets";i:0;s:39:"block_title_font_gwf_add_charsets_latin";i:0;s:43:"block_title_font_gwf_add_charsets_latin-ext";i:0;s:39:"block_title_font_gwf_add_charsets_greek";i:0;s:43:"block_title_font_gwf_add_charsets_greek-ext";i:0;s:42:"block_title_font_gwf_add_charsets_cyrillic";i:0;s:46:"block_title_font_gwf_add_charsets_cyrillic-ext";i:0;s:39:"block_title_font_gwf_add_charsets_khmer";i:0;s:44:"block_title_font_gwf_add_charsets_vietnamese";i:0;s:20:"block_title_font_cfs";s:43:"''Helvetica Neue'',Helvetica,Arial,sans-serif";s:21:"block_title_font_size";s:5:"1.4em";s:31:"content_headings_h1h4_font_type";s:3:"cfs";s:26:"content_headings_h1h4_font";s:5:"bf-cc";s:30:"content_headings_h1h4_font_gwf";s:0:"";s:41:"content_headings_h1h4_font_gwf_add_styles";i:0;s:45:"content_headings_h1h4_font_gwf_add_styles_300";i:0;s:51:"content_headings_h1h4_font_gwf_add_styles_300italic";i:0;s:45:"content_headings_h1h4_font_gwf_add_styles_400";i:0;s:51:"content_headings_h1h4_font_gwf_add_styles_400italic";i:0;s:45:"content_headings_h1h4_font_gwf_add_styles_700";i:0;s:51:"content_headings_h1h4_font_gwf_add_styles_700italic";i:0;s:43:"content_headings_h1h4_font_gwf_add_charsets";i:0;s:49:"content_headings_h1h4_font_gwf_add_charsets_latin";i:0;s:53:"content_headings_h1h4_font_gwf_add_charsets_latin-ext";i:0;s:49:"content_headings_h1h4_font_gwf_add_charsets_greek";i:0;s:53:"content_headings_h1h4_font_gwf_add_charsets_greek-ext";i:0;s:52:"content_headings_h1h4_font_gwf_add_charsets_cyrillic";i:0;s:56:"content_headings_h1h4_font_gwf_add_charsets_cyrillic-ext";i:0;s:49:"content_headings_h1h4_font_gwf_add_charsets_khmer";i:0;s:54:"content_headings_h1h4_font_gwf_add_charsets_vietnamese";i:0;s:30:"content_headings_h1h4_font_cfs";s:43:"''Helvetica Neue'',Helvetica,Arial,sans-serif";s:31:"content_headings_h5h6_font_type";s:3:"cfs";s:26:"content_headings_h5h6_font";s:5:"bf-cc";s:30:"content_headings_h5h6_font_gwf";s:0:"";s:41:"content_headings_h5h6_font_gwf_add_styles";i:0;s:45:"content_headings_h5h6_font_gwf_add_styles_300";i:0;s:51:"content_headings_h5h6_font_gwf_add_styles_300italic";i:0;s:45:"content_headings_h5h6_font_gwf_add_styles_400";i:0;s:51:"content_headings_h5h6_font_gwf_add_styles_400italic";i:0;s:45:"content_headings_h5h6_font_gwf_add_styles_700";i:0;s:51:"content_headings_h5h6_font_gwf_add_styles_700italic";i:0;s:43:"content_headings_h5h6_font_gwf_add_charsets";i:0;s:49:"content_headings_h5h6_font_gwf_add_charsets_latin";i:0;s:53:"content_headings_h5h6_font_gwf_add_charsets_latin-ext";i:0;s:49:"content_headings_h5h6_font_gwf_add_charsets_greek";i:0;s:53:"content_headings_h5h6_font_gwf_add_charsets_greek-ext";i:0;s:52:"content_headings_h5h6_font_gwf_add_charsets_cyrillic";i:0;s:56:"content_headings_h5h6_font_gwf_add_charsets_cyrillic-ext";i:0;s:49:"content_headings_h5h6_font_gwf_add_charsets_khmer";i:0;s:54:"content_headings_h5h6_font_gwf_add_charsets_vietnamese";i:0;s:30:"content_headings_h5h6_font_cfs";s:43:"''Helvetica Neue'',Helvetica,Arial,sans-serif";s:12:"h1_font_size";s:3:"2em";s:12:"h2_font_size";s:5:"1.6em";s:12:"h3_font_size";s:5:"1.4em";s:12:"h4_font_size";s:5:"1.2em";s:12:"h5_font_size";s:3:"1em";s:12:"h6_font_size";s:3:"1em";s:19:"main_menu_font_type";s:3:"cfs";s:14:"main_menu_font";s:5:"bf-cc";s:18:"main_menu_font_gwf";s:0:"";s:29:"main_menu_font_gwf_add_styles";i:0;s:33:"main_menu_font_gwf_add_styles_300";i:0;s:39:"main_menu_font_gwf_add_styles_300italic";i:0;s:33:"main_menu_font_gwf_add_styles_400";i:0;s:39:"main_menu_font_gwf_add_styles_400italic";i:0;s:33:"main_menu_font_gwf_add_styles_700";i:0;s:39:"main_menu_font_gwf_add_styles_700italic";i:0;s:31:"main_menu_font_gwf_add_charsets";i:0;s:37:"main_menu_font_gwf_add_charsets_latin";i:0;s:41:"main_menu_font_gwf_add_charsets_latin-ext";i:0;s:37:"main_menu_font_gwf_add_charsets_greek";i:0;s:41:"main_menu_font_gwf_add_charsets_greek-ext";i:0;s:40:"main_menu_font_gwf_add_charsets_cyrillic";i:0;s:44:"main_menu_font_gwf_add_charsets_cyrillic-ext";i:0;s:37:"main_menu_font_gwf_add_charsets_khmer";i:0;s:42:"main_menu_font_gwf_add_charsets_vietnamese";i:0;s:18:"main_menu_font_cfs";s:43:"''Helvetica Neue'',Helvetica,Arial,sans-serif";s:19:"main_menu_font_size";s:6:"<none>";s:24:"secondary_menu_font_type";s:3:"cfs";s:19:"secondary_menu_font";s:5:"bf-cc";s:23:"secondary_menu_font_gwf";s:0:"";s:34:"secondary_menu_font_gwf_add_styles";i:0;s:38:"secondary_menu_font_gwf_add_styles_300";i:0;s:44:"secondary_menu_font_gwf_add_styles_300italic";i:0;s:38:"secondary_menu_font_gwf_add_styles_400";i:0;s:44:"secondary_menu_font_gwf_add_styles_400italic";i:0;s:38:"secondary_menu_font_gwf_add_styles_700";i:0;s:44:"secondary_menu_font_gwf_add_styles_700italic";i:0;s:36:"secondary_menu_font_gwf_add_charsets";i:0;s:42:"secondary_menu_font_gwf_add_charsets_latin";i:0;s:46:"secondary_menu_font_gwf_add_charsets_latin-ext";i:0;s:42:"secondary_menu_font_gwf_add_charsets_greek";i:0;s:46:"secondary_menu_font_gwf_add_charsets_greek-ext";i:0;s:45:"secondary_menu_font_gwf_add_charsets_cyrillic";i:0;s:49:"secondary_menu_font_gwf_add_charsets_cyrillic-ext";i:0;s:42:"secondary_menu_font_gwf_add_charsets_khmer";i:0;s:47:"secondary_menu_font_gwf_add_charsets_vietnamese";i:0;s:23:"secondary_menu_font_cfs";s:43:"''Helvetica Neue'',Helvetica,Arial,sans-serif";s:24:"secondary_menu_font_size";s:6:"<none>";s:20:"block_menu_font_type";s:3:"cfs";s:15:"block_menu_font";s:5:"bf-cc";s:19:"block_menu_font_gwf";s:0:"";s:30:"block_menu_font_gwf_add_styles";i:0;s:34:"block_menu_font_gwf_add_styles_300";i:0;s:40:"block_menu_font_gwf_add_styles_300italic";i:0;s:34:"block_menu_font_gwf_add_styles_400";i:0;s:40:"block_menu_font_gwf_add_styles_400italic";i:0;s:34:"block_menu_font_gwf_add_styles_700";i:0;s:40:"block_menu_font_gwf_add_styles_700italic";i:0;s:32:"block_menu_font_gwf_add_charsets";i:0;s:38:"block_menu_font_gwf_add_charsets_latin";i:0;s:42:"block_menu_font_gwf_add_charsets_latin-ext";i:0;s:38:"block_menu_font_gwf_add_charsets_greek";i:0;s:42:"block_menu_font_gwf_add_charsets_greek-ext";i:0;s:41:"block_menu_font_gwf_add_charsets_cyrillic";i:0;s:45:"block_menu_font_gwf_add_charsets_cyrillic-ext";i:0;s:38:"block_menu_font_gwf_add_charsets_khmer";i:0;s:43:"block_menu_font_gwf_add_charsets_vietnamese";i:0;s:19:"block_menu_font_cfs";s:43:"''Helvetica Neue'',Helvetica,Arial,sans-serif";s:20:"block_menu_font_size";s:6:"<none>";s:19:"selectors_font_type";s:3:"cfs";s:14:"selectors_font";s:5:"bf-cc";s:18:"selectors_font_gwf";s:0:"";s:25:"selectors_font_add_styles";i:0;s:29:"selectors_font_add_styles_300";i:0;s:35:"selectors_font_add_styles_300italic";i:0;s:29:"selectors_font_add_styles_400";i:0;s:35:"selectors_font_add_styles_400italic";i:0;s:29:"selectors_font_add_styles_700";i:0;s:35:"selectors_font_add_styles_700italic";i:0;s:27:"selectors_font_add_charsets";i:0;s:33:"selectors_font_add_charsets_latin";i:0;s:37:"selectors_font_add_charsets_latin-ext";i:0;s:33:"selectors_font_add_charsets_greek";i:0;s:37:"selectors_font_add_charsets_greek-ext";i:0;s:36:"selectors_font_add_charsets_cyrillic";i:0;s:40:"selectors_font_add_charsets_cyrillic-ext";i:0;s:33:"selectors_font_add_charsets_khmer";i:0;s:38:"selectors_font_add_charsets_vietnamese";i:0;s:18:"selectors_font_cfs";s:43:"''Helvetica Neue'',Helvetica,Arial,sans-serif";s:13:"selectors_css";s:0:"";s:15:"image_alignment";s:4:"ia-n";s:22:"image_alignment_teaser";s:5:"iat-n";s:20:"image_caption_teaser";i:0;s:18:"image_caption_full";i:0;s:12:"image_teaser";i:0;s:27:"menu_toggle_tablet_portrait";i:0;s:28:"menu_toggle_tablet_landscape";i:0;s:21:"menu_toggle_main_menu";i:0;s:26:"menu_toggle_secondary_menu";i:0;s:23:"menu_toggle_leaderboard";i:0;s:18:"menu_toggle_header";i:0;s:20:"menu_toggle_menu_bar";i:0;s:27:"menu_toggle_main_menu_title";s:0:"";s:32:"menu_toggle_secondary_menu_title";s:0:"";s:19:"global_gutter_width";s:0:"";s:29:"page_content_type_suggestions";i:0;s:23:"menu_item_span_elements";i:0;s:18:"breadcrumb_display";i:1;s:15:"breadcrumb_home";i:0;s:16:"breadcrumb_label";i:0;s:16:"breadcrumb_title";i:0;s:20:"breadcrumb_separator";s:8:" &#187; ";s:24:"login_block_remove_links";i:0;s:25:"login_block_remove_openid";i:0;s:22:"horizontal_login_block";i:0;s:20:"user_block_user_name";i:0;s:22:"frontpage_remove_title";i:0;s:29:"unset_block_system_main_front";i:0;s:15:"feed_icons_hide";i:0;s:19:"comments_hide_title";i:0;s:17:"unset_menu_titles";i:0;s:26:"adv_search_extra_fieldsets";i:0;s:16:"skip_link_target";s:13:"#main-content";s:10:"rel_author";i:0;s:10:"logo_title";i:0;s:18:"extra_page_classes";i:1;s:21:"extra_article_classes";i:1;s:21:"extra_comment_classes";i:1;s:19:"extra_block_classes";i:1;s:18:"extra_menu_classes";i:1;s:23:"extra_item_list_classes";i:1;s:18:"attribution_toggle";i:0;s:21:"content_corner_radius";s:4:"rc-6";s:18:"tabs_corner_radius";s:5:"rct-6";s:14:"at__active_tab";s:9:"edit-font";s:10:"at-release";s:7:"7.x-3.x";s:8:"at-color";s:1:"1";s:6:"scheme";s:0:"";s:7:"palette";a:15:{s:4:"base";s:7:"#ffffff";s:10:"background";s:7:"#f92b2b";s:4:"text";s:7:"#2e2e2e";s:4:"link";s:7:"#086782";s:9:"linkhover";s:7:"#e25401";s:13:"linkunderline";s:7:"#cfdde5";s:6:"slogan";s:7:"#e25400";s:10:"navigation";s:7:"#2e2e2d";s:15:"navigationhover";s:7:"#e25402";s:3:"tab";s:7:"#f5f4f3";s:10:"blocktitle";s:4:"#555";s:6:"border";s:7:"#e1e1e1";s:12:"borderstrong";s:7:"#c4c4c4";s:8:"fieldset";s:7:"#fbfbfb";s:14:"fieldsetborder";s:7:"#e1e1e2";}s:5:"theme";s:17:"bookpoints_custom";s:4:"info";a:11:{s:6:"fields";a:17:{s:4:"base";s:4:"Base";s:10:"background";s:10:"Background";s:4:"text";s:4:"Text";s:4:"link";s:4:"Link";s:9:"linkhover";s:12:"Hovered Link";s:13:"linkunderline";s:14:"Link underline";s:6:"slogan";s:6:"Slogan";s:10:"navigation";s:10:"Navigation";s:15:"navigationhover";s:16:"Navigation hover";s:3:"tab";s:3:"Tab";s:10:"blocktitle";s:11:"Block title";s:6:"border";s:6:"Border";s:12:"borderstrong";s:13:"Border strong";s:8:"fieldset";s:8:"Fieldset";s:14:"fieldsetborder";s:15:"Fieldset border";s:13:"headerwrapper";s:14:"Header wrapper";s:9:"sitenamea";s:9:"Site Name";}s:7:"schemes";a:7:{s:7:"default";a:2:{s:5:"title";s:14:"Gray (Default)";s:6:"colors";a:17:{s:4:"base";s:7:"#ffffff";s:10:"background";s:7:"#f8f8f8";s:4:"text";s:7:"#2e2e2e";s:4:"link";s:7:"#086782";s:9:"linkhover";s:7:"#e25401";s:13:"linkunderline";s:7:"#cfdde5";s:6:"slogan";s:7:"#e25400";s:10:"navigation";s:7:"#2e2e2d";s:15:"navigationhover";s:7:"#e25402";s:3:"tab";s:7:"#f5f4f3";s:10:"blocktitle";s:7:"#779125";s:6:"border";s:7:"#e1e1e1";s:12:"borderstrong";s:7:"#c4c4c4";s:8:"fieldset";s:7:"#fbfbfb";s:14:"fieldsetborder";s:7:"#e1e1e2";s:13:"headerwrapper";s:7:"#c2e7f8";s:9:"sitenamea";s:7:"#ffffff";}}s:6:"green1";a:2:{s:5:"title";s:7:"Green 1";s:6:"colors";a:17:{s:4:"base";s:7:"#ffffff";s:10:"background";s:7:"#fbfbf6";s:4:"text";s:7:"#3d3d3d";s:4:"link";s:7:"#899833";s:9:"linkhover";s:7:"#e14601";s:13:"linkunderline";s:7:"#e3eac1";s:6:"slogan";s:7:"#899833";s:10:"navigation";s:7:"#8e9e35";s:15:"navigationhover";s:7:"#626c25";s:3:"tab";s:7:"#fbfbf6";s:10:"blocktitle";s:7:"#738b25";s:6:"border";s:7:"#e7e1ce";s:12:"borderstrong";s:7:"#d2c8aa";s:8:"fieldset";s:7:"#fdfdfb";s:14:"fieldsetborder";s:7:"#dad6c9";s:13:"headerwrapper";s:7:"#c2e7f8";s:9:"sitenamea";s:7:"#ffffff";}}s:6:"green2";a:2:{s:5:"title";s:7:"Green 2";s:6:"colors";a:17:{s:4:"base";s:7:"#ffffff";s:10:"background";s:7:"#fbfbf6";s:4:"text";s:7:"#3d3d3d";s:4:"link";s:7:"#157a9c";s:9:"linkhover";s:7:"#e14601";s:13:"linkunderline";s:7:"#cfdde5";s:6:"slogan";s:7:"#e14601";s:10:"navigation";s:7:"#8e9e35";s:15:"navigationhover";s:7:"#626c25";s:3:"tab";s:7:"#fbfbf6";s:10:"blocktitle";s:7:"#779125";s:6:"border";s:7:"#e7e1ce";s:12:"borderstrong";s:7:"#d2c8aa";s:8:"fieldset";s:7:"#fdfdfb";s:14:"fieldsetborder";s:7:"#dad6c9";s:13:"headerwrapper";s:7:"#c2e7f8";s:9:"sitenamea";s:7:"#ffffff";}}s:6:"purple";a:2:{s:5:"title";s:6:"Purple";s:6:"colors";a:16:{s:4:"base";s:7:"#ffffff";s:10:"background";s:7:"#fefafb";s:4:"text";s:7:"#2e2e2e";s:4:"link";s:7:"#6c0d28";s:9:"linkhover";s:7:"#e25401";s:13:"linkunderline";s:7:"#eac8d1";s:6:"slogan";s:7:"#e25401";s:10:"navigation";s:7:"#6c0d28";s:15:"navigationhover";s:7:"#83a80e";s:3:"tab";s:7:"#fbf3f6";s:10:"blocktitle";s:7:"#e25401";s:6:"border";s:7:"#f7d6e2";s:12:"borderstrong";s:7:"#d9a3b7";s:8:"fieldset";s:7:"#fefafb";s:14:"fieldsetborder";s:7:"#f7d6e2";s:9:"sitenamea";s:7:"#ffffff";}}s:3:"red";a:2:{s:5:"title";s:3:"Red";s:6:"colors";a:17:{s:4:"base";s:7:"#ffffff";s:10:"background";s:7:"#fefbfa";s:4:"text";s:7:"#2e2e2e";s:4:"link";s:7:"#b9400e";s:9:"linkhover";s:7:"#ef762f";s:13:"linkunderline";s:7:"#faded3";s:6:"slogan";s:7:"#ca592b";s:10:"navigation";s:7:"#b9400e";s:15:"navigationhover";s:7:"#7e2c0a";s:3:"tab";s:7:"#fdf6f4";s:10:"blocktitle";s:7:"#b9400e";s:6:"border";s:7:"#e8dad5";s:12:"borderstrong";s:7:"#e2bdae";s:8:"fieldset";s:7:"#fefbfa";s:14:"fieldsetborder";s:7:"#f7dad6";s:13:"headerwrapper";s:7:"#c2e7f8";s:9:"sitenamea";s:7:"#ffffff";}}s:6:"yellow";a:2:{s:5:"title";s:6:"Yellow";s:6:"colors";a:17:{s:4:"base";s:7:"#ffffff";s:10:"background";s:7:"#f9faef";s:4:"text";s:7:"#383838";s:4:"link";s:7:"#8d8017";s:9:"linkhover";s:7:"#de4c01";s:13:"linkunderline";s:7:"#f4eebc";s:6:"slogan";s:7:"#afa02f";s:10:"navigation";s:7:"#a0a465";s:15:"navigationhover";s:7:"#6c6f42";s:3:"tab";s:7:"#f7f8ec";s:10:"blocktitle";s:7:"#afa02f";s:6:"border";s:7:"#e2e5c3";s:12:"borderstrong";s:7:"#dcd093";s:8:"fieldset";s:7:"#fbfbf8";s:14:"fieldsetborder";s:7:"#ddd7b6";s:13:"headerwrapper";s:7:"#c2e7f8";s:9:"sitenamea";s:7:"#ffffff";}}s:0:"";a:2:{s:5:"title";s:6:"Custom";s:6:"colors";a:0:{}}}s:3:"css";a:1:{i:0;s:16:"color/colors.css";}s:4:"copy";a:1:{i:0;s:8:"logo.png";}s:9:"gradients";a:1:{i:0;a:3:{s:9:"dimension";a:4:{i:0;i:0;i:1;i:0;i:2;i:0;i:3;i:0;}s:9:"direction";s:8:"vertical";s:6:"colors";a:2:{i:0;s:4:"link";i:1;s:4:"text";}}}s:4:"fill";a:0:{}s:6:"slices";a:0:{}s:12:"blend_target";s:7:"#ffffff";s:13:"preview_image";s:17:"color/preview.png";s:11:"preview_css";s:17:"color/preview.css";s:10:"base_image";s:14:"color/base.png";}}');
INSERT INTO `variable` VALUES ('theme_default','s:17:"bookpoints_custom";'),('user_admin_role','s:1:"3";'),('user_cancel_method','s:17:"user_cancel_block";'),('user_default_timezone','s:1:"0";'),('user_email_verification','i:0;'),('user_mail_cancel_confirm_body','s:381:"[user:name],\r\n\r\nA request to cancel your account has been made at [site:name].\r\n\r\nYou may now cancel your account on [site:url-brief] by clicking this link or copying and pasting it into your browser:\r\n\r\n[user:cancel-url]\r\n\r\nNOTE: The cancellation of your account is not reversible.\r\n\r\nThis link expires in one day and nothing will happen if it is not used.\r\n\r\n--  [site:name] team";'),('user_mail_cancel_confirm_subject','s:59:"Account cancellation request for [user:name] at [site:name]";'),('user_mail_password_reset_body','s:407:"[user:name],\r\n\r\nA request to reset the password for your account has been made at [site:name].\r\n\r\nYou may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password. It expires after one day and nothing will happen if it''s not used.\r\n\r\n--  [site:name] team";'),('user_mail_password_reset_subject','s:60:"Replacement login information for [user:name] at [site:name]";'),('user_mail_register_admin_created_body','s:476:"[user:name],\r\n\r\nA site administrator at [site:name] has created an account for you. You may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team";'),('user_mail_register_admin_created_subject','s:58:"An administrator created an account for you at [site:name]";'),('user_mail_register_no_approval_required_body','s:450:"[user:name],\r\n\r\nThank you for registering at [site:name]. You may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team";');
INSERT INTO `variable` VALUES ('user_mail_register_no_approval_required_subject','s:46:"Account details for [user:name] at [site:name]";'),('user_mail_register_pending_approval_body','s:287:"[user:name],\r\n\r\nThank you for registering at [site:name]. Your application for an account is currently pending approval. Once it has been approved, you will receive another e-mail containing information about how to log in, set your password, and other details.\r\n\r\n\r\n--  [site:name] team";'),('user_mail_register_pending_approval_subject','s:71:"Account details for [user:name] at [site:name] (pending admin approval)";'),('user_mail_status_activated_body','s:461:"[user:name],\r\n\r\nYour account at [site:name] has been activated.\r\n\r\nYou may now log in by clicking this link or copying and pasting it into your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team";'),('user_mail_status_activated_notify','i:1;'),('user_mail_status_activated_subject','s:57:"Account details for [user:name] at [site:name] (approved)";'),('user_mail_status_blocked_body','s:85:"[user:name],\r\n\r\nYour account on [site:name] has been blocked.\r\n\r\n--  [site:name] team";'),('user_mail_status_blocked_notify','i:0;'),('user_mail_status_blocked_subject','s:56:"Account details for [user:name] at [site:name] (blocked)";'),('user_mail_status_canceled_body','s:86:"[user:name],\r\n\r\nYour account on [site:name] has been canceled.\r\n\r\n--  [site:name] team";'),('user_mail_status_canceled_notify','i:0;'),('user_mail_status_canceled_subject','s:57:"Account details for [user:name] at [site:name] (canceled)";'),('user_pictures','i:0;'),('user_picture_default','s:0:"";'),('user_picture_dimensions','s:9:"1024x1024";'),('user_picture_file_size','s:3:"800";'),('user_picture_guidelines','s:0:"";'),('user_picture_path','s:8:"pictures";');
INSERT INTO `variable` VALUES ('user_picture_style','s:9:"thumbnail";'),('user_register','s:1:"1";'),('user_signatures','i:0;');
DROP TABLE IF EXISTS `views_data_export`;
CREATE TABLE `views_data_export` (   `eid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Unique id for each on-going export.',   `view_name` varchar(128) NOT NULL DEFAULT '' COMMENT 'The unique name of the view. This is the primary field views are loaded from, and is used so that views may be internal and not necessarily in the database. May only be alphanumeric characters plus underscores.',   `view_display_id` varchar(64) NOT NULL DEFAULT '' COMMENT 'The unique name of the view. This is the primary field views are loaded from, and is used so that views may be internal and not necessarily in the database. May only be alphanumeric characters plus underscores.',   `time_stamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The time this export started',   `fid` int(10) unsigned NOT NULL COMMENT 'Files ID.',   `batch_state` varchar(32) NOT NULL DEFAULT 'init' COMMENT 'The current state of the batch.',   `sandbox` longblob,   PRIMARY KEY (`eid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Keep track of currently executing exports.' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `views_data_export_object_cache`;
CREATE TABLE `views_data_export_object_cache` (   `eid` varchar(64) DEFAULT NULL COMMENT 'The export ID this view equates too.',   `updated` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The time this cache was created or updated.',   `data` longblob COMMENT 'Serialized data being stored.',   KEY `eid` (`eid`),   KEY `updated` (`updated`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A modified version of the views_object_cache that ignores...';
DROP TABLE IF EXISTS `views_display`;
CREATE TABLE `views_display` (   `vid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The view this display is attached to.',   `id` varchar(64) NOT NULL DEFAULT '' COMMENT 'An identifier for this display; usually generated from the display_plugin, so should be something like page or page_1 or block_2, etc.',   `display_title` varchar(64) NOT NULL DEFAULT '' COMMENT 'The title of the display, viewable by the administrator.',   `display_plugin` varchar(64) NOT NULL DEFAULT '' COMMENT 'The type of the display. Usually page, block or embed, but is pluggable so may be other things.',   `position` int(11) DEFAULT '0' COMMENT 'The order in which this display is loaded.',   `display_options` longtext COMMENT 'A serialized array of options for this display; it contains options that are generally only pertinent to that display plugin type.',   PRIMARY KEY (`vid`,`id`),   KEY `vid` (`vid`,`position`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about each display attached to a view.';
INSERT INTO `views_display` VALUES ('1','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('1','default','Master','default','1','a:12:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"full";s:7:"options";a:7:{s:14:"items_per_page";s:1:"5";s:6:"offset";s:1:"0";s:2:"id";s:1:"0";s:11:"total_pages";s:0:"";s:8:"quantity";s:1:"9";s:4:"tags";a:4:{s:5:"first";s:8:"« first";s:8:"previous";s:12:"‹ previous";s:4:"next";s:8:"next ›";s:4:"last";s:7:"last »";}s:6:"expose";a:7:{s:14:"items_per_page";i:0;s:20:"items_per_page_label";s:14:"Items per page";s:22:"items_per_page_options";s:17:"5, 10, 20, 40, 60";s:26:"items_per_page_options_all";i:0;s:32:"items_per_page_options_all_label";s:7:"- All -";s:6:"offset";i:0;s:12:"offset_label";s:6:"Offset";}}}s:12:"style_plugin";s:5:"table";s:10:"row_plugin";s:6:"fields";s:6:"fields";a:4:{s:5:"title";a:21:{s:2:"id";s:5:"title";s:5:"table";s:10:"eck_branch";s:5:"field";s:5:"title";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:5:"Title";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;}s:20:"field_branch_address";a:35:{s:2:"id";s:20:"field_branch_address";s:5:"table";s:31:"field_data_field_branch_address";s:5:"field";s:20:"field_branch_address";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:14:"Branch Address";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:7:"country";s:4:"type";s:20:"addressfield_default";s:8:"settings";a:2:{s:19:"use_widget_handlers";i:1;s:15:"format_handlers";a:1:{s:7:"address";s:7:"address";}}s:12:"group_column";s:0:"";s:13:"group_columns";a:0:{}s:10:"group_rows";b:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";i:0;s:14:"delta_reversed";b:0;s:16:"delta_first_last";b:0;s:12:"delta_random";b:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:18:"field_branch_phone";a:35:{s:2:"id";s:18:"field_branch_phone";s:5:"table";s:29:"field_data_field_branch_phone";s:5:"field";s:18:"field_branch_phone";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:12:"Branch Phone";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:5:"value";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:12:"group_column";s:5:"value";s:13:"group_columns";a:0:{}s:10:"group_rows";b:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";i:0;s:14:"delta_reversed";b:0;s:16:"delta_first_last";b:0;s:12:"delta_random";b:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:9:"edit_link";a:22:{s:2:"id";s:9:"edit_link";s:5:"table";s:10:"eck_branch";s:5:"field";s:9:"edit_link";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:9:"Edit link";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";b:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:4:"text";s:0:"";}}s:7:"filters";a:1:{s:4:"type";a:13:{s:2:"id";s:4:"type";s:5:"table";s:10:"eck_branch";s:5:"field";s:4:"type";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:8:"operator";s:2:"in";s:5:"value";a:1:{s:6:"branch";s:6:"branch";}s:5:"group";s:1:"1";s:7:"exposed";b:0;s:6:"expose";a:12:{s:11:"operator_id";b:0;s:5:"label";s:0:"";s:11:"description";s:0:"";s:12:"use_operator";b:0;s:14:"operator_label";s:0:"";s:8:"operator";s:0:"";s:10:"identifier";s:0:"";s:8:"required";b:0;s:8:"remember";b:0;s:8:"multiple";b:0;s:14:"remember_roles";a:1:{i:2;i:2;}s:6:"reduce";b:0;}s:10:"is_grouped";b:0;s:10:"group_info";a:10:{s:5:"label";s:0:"";s:11:"description";s:0:"";s:10:"identifier";s:0:"";s:8:"optional";b:1;s:6:"widget";s:6:"select";s:8:"multiple";b:0;s:8:"remember";i:0;s:13:"default_group";s:3:"All";s:22:"default_group_multiple";a:0:{}s:11:"group_items";a:0:{}}}}s:5:"sorts";a:0:{}s:5:"title";s:8:"Branches";s:13:"style_options";a:12:{s:8:"grouping";a:0:{}s:9:"row_class";s:0:"";s:17:"default_row_class";i:1;s:17:"row_class_special";i:1;s:8:"override";i:1;s:6:"sticky";i:0;s:7:"caption";s:0:"";s:7:"summary";s:0:"";s:7:"columns";a:7:{s:5:"title";s:5:"title";s:2:"id";s:2:"id";s:17:"field_branch_name";s:17:"field_branch_name";s:20:"field_branch_address";s:20:"field_branch_address";s:18:"field_branch_phone";s:18:"field_branch_phone";s:9:"edit_link";s:9:"edit_link";s:11:"delete_link";s:11:"delete_link";}s:4:"info";a:7:{s:5:"title";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:2:"id";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:17:"field_branch_name";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:20:"field_branch_address";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:18:"field_branch_phone";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"edit_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:11:"delete_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}s:7:"default";s:2:"-1";s:11:"empty_table";i:0;}}');
INSERT INTO `views_display` VALUES ('2','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('2','default','Master','default','1','a:12:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:8:"Programs";s:8:"use_ajax";b:1;s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"none";s:7:"options";a:1:{s:6:"offset";s:1:"0";}}s:12:"style_plugin";s:5:"table";s:13:"style_options";a:3:{s:7:"columns";a:13:{s:5:"title";s:5:"title";s:2:"id";s:2:"id";s:18:"field_program_name";s:18:"field_program_name";s:25:"field_program_description";s:25:"field_program_description";s:25:"field_recommended_min_age";s:25:"field_recommended_min_age";s:25:"field_recommended_max_age";s:25:"field_recommended_max_age";s:18:"field_scoring_type";s:18:"field_scoring_type";s:20:"field_per_unit_label";s:20:"field_per_unit_label";s:26:"field_per_unit_point_value";s:26:"field_per_unit_point_value";s:19:"field_starter_badge";s:19:"field_starter_badge";s:9:"edit_link";s:9:"edit_link";s:11:"delete_link";s:11:"delete_link";s:9:"view_link";s:9:"view_link";}s:7:"default";s:2:"-1";s:4:"info";a:13:{s:5:"title";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:2:"id";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:18:"field_program_name";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:25:"field_program_description";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:25:"field_recommended_min_age";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:25:"field_recommended_max_age";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:18:"field_scoring_type";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:20:"field_per_unit_label";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:26:"field_per_unit_point_value";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:19:"field_starter_badge";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"edit_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:11:"delete_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"view_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}}s:6:"fields";a:5:{s:5:"title";a:21:{s:2:"id";s:5:"title";s:5:"table";s:11:"eck_program";s:5:"field";s:5:"title";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:5:"Title";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;}s:9:"nothing_1";a:5:{s:2:"id";s:9:"nothing_1";s:5:"table";s:5:"views";s:5:"field";s:7:"nothing";s:5:"label";s:16:"Number of Levels";s:5:"alter";a:1:{s:4:"text";s:5:"Helo.";}}s:9:"edit_link";a:4:{s:2:"id";s:9:"edit_link";s:5:"table";s:11:"eck_program";s:5:"field";s:9:"edit_link";s:5:"label";s:20:"Edit Program Details";}s:2:"id";a:4:{s:2:"id";s:2:"id";s:5:"table";s:11:"eck_program";s:5:"field";s:2:"id";s:7:"exclude";b:1;}s:7:"nothing";a:5:{s:2:"id";s:7:"nothing";s:5:"table";s:5:"views";s:5:"field";s:7:"nothing";s:5:"label";s:13:"Manage Levels";s:5:"alter";a:1:{s:4:"text";s:136:"<a href=''/library/dashboard/program/level/add/[id]''>Add</a> | <a href=''/library/dashboard/program/program_overview_page/[id]''>Manage</a>";}}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:11:"eck_program";s:5:"field";s:4:"type";s:5:"value";a:1:{s:7:"program";s:7:"program";}}}}');
INSERT INTO `views_display` VALUES ('3','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('3','default','Master','default','1','a:13:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:6:"Levels";s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"some";s:7:"options";a:1:{s:14:"items_per_page";s:1:"5";}}s:12:"style_plugin";s:7:"default";s:10:"row_plugin";s:6:"fields";s:13:"relationships";a:1:{s:33:"field_program_reference_target_id";a:3:{s:2:"id";s:33:"field_program_reference_target_id";s:5:"table";s:34:"field_data_field_program_reference";s:5:"field";s:33:"field_program_reference_target_id";}}s:6:"fields";a:2:{s:5:"title";a:4:{s:2:"id";s:5:"title";s:5:"table";s:9:"eck_level";s:5:"field";s:5:"title";s:5:"label";s:5:"Level";}s:21:"field_point_threshold";a:5:{s:2:"id";s:21:"field_point_threshold";s:5:"table";s:32:"field_data_field_point_threshold";s:5:"field";s:21:"field_point_threshold";s:5:"label";s:4:"Pts.";s:8:"settings";a:2:{s:18:"thousand_separator";s:0:"";s:13:"prefix_suffix";i:1;}}}s:9:"arguments";a:1:{s:24:"field_program_name_value";a:11:{s:2:"id";s:24:"field_program_name_value";s:5:"table";s:29:"field_data_field_program_name";s:5:"field";s:24:"field_program_name_value";s:12:"relationship";s:33:"field_program_reference_target_id";s:14:"default_action";s:5:"empty";s:21:"default_argument_type";s:5:"fixed";s:7:"summary";a:2:{s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:15:"summary_options";a:1:{s:14:"items_per_page";s:2:"25";}s:18:"specify_validation";b:1;s:8:"validate";a:1:{s:4:"fail";s:5:"empty";}s:5:"limit";s:1:"0";}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:9:"eck_level";s:5:"field";s:4:"type";s:5:"value";a:1:{s:5:"level";s:5:"level";}}}}'),('4','block','Block','block','2','a:5:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:8:"defaults";a:3:{s:12:"exposed_form";b:0;s:6:"fields";b:0;s:9:"arguments";b:0;}s:12:"exposed_form";a:2:{s:4:"type";s:5:"basic";s:7:"options";a:1:{s:12:"reset_button";b:1;}}s:6:"fields";a:6:{s:2:"id";a:3:{s:2:"id";s:2:"id";s:5:"table";s:10:"eck_reader";s:5:"field";s:2:"id";}s:16:"field_first_name";a:3:{s:2:"id";s:16:"field_first_name";s:5:"table";s:27:"field_data_field_first_name";s:5:"field";s:16:"field_first_name";}s:15:"field_last_name";a:3:{s:2:"id";s:15:"field_last_name";s:5:"table";s:26:"field_data_field_last_name";s:5:"field";s:15:"field_last_name";}s:4:"name";a:5:{s:2:"id";s:4:"name";s:5:"table";s:5:"users";s:5:"field";s:4:"name";s:12:"relationship";s:26:"field_parent_uid_target_id";s:5:"label";s:6:"Parent";}s:9:"edit_link";a:3:{s:2:"id";s:9:"edit_link";s:5:"table";s:10:"eck_reader";s:5:"field";s:9:"edit_link";}s:4:"id_1";a:5:{s:2:"id";s:4:"id_1";s:5:"table";s:10:"eck_reader";s:5:"field";s:2:"id";s:5:"label";s:13:"Manage Reader";s:5:"alter";a:4:{s:10:"alter_text";b:1;s:4:"text";s:4:"Link";s:9:"make_link";b:1;s:4:"path";s:46:"library/dashboard/readers/reader_overview/[id]";}}}s:9:"arguments";a:1:{s:26:"field_parent_uid_target_id";a:8:{s:2:"id";s:26:"field_parent_uid_target_id";s:5:"table";s:27:"field_data_field_parent_uid";s:5:"field";s:26:"field_parent_uid_target_id";s:21:"default_argument_type";s:5:"fixed";s:7:"summary";a:2:{s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:15:"summary_options";a:1:{s:14:"items_per_page";s:2:"25";}s:18:"specify_validation";b:1;s:8:"validate";a:1:{s:4:"fail";s:5:"empty";}}}}');
INSERT INTO `views_display` VALUES ('4','block_1','Block','block','3','a:4:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:8:"defaults";a:2:{s:12:"exposed_form";b:0;s:6:"fields";b:0;}s:12:"exposed_form";a:2:{s:4:"type";s:5:"basic";s:7:"options";a:1:{s:12:"reset_button";b:1;}}s:6:"fields";a:5:{s:2:"id";a:3:{s:2:"id";s:2:"id";s:5:"table";s:10:"eck_reader";s:5:"field";s:2:"id";}s:16:"field_first_name";a:4:{s:2:"id";s:16:"field_first_name";s:5:"table";s:27:"field_data_field_first_name";s:5:"field";s:16:"field_first_name";s:5:"label";s:4:"Name";}s:15:"field_last_name";a:3:{s:2:"id";s:15:"field_last_name";s:5:"table";s:26:"field_data_field_last_name";s:5:"field";s:15:"field_last_name";}s:4:"name";a:5:{s:2:"id";s:4:"name";s:5:"table";s:5:"users";s:5:"field";s:4:"name";s:12:"relationship";s:26:"field_parent_uid_target_id";s:5:"label";s:6:"Parent";}s:9:"edit_link";a:3:{s:2:"id";s:9:"edit_link";s:5:"table";s:10:"eck_reader";s:5:"field";s:9:"edit_link";}}}'),('4','block_2','Block 2','block','4','a:8:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:8:"defaults";a:9:{s:12:"exposed_form";b:0;s:12:"style_plugin";b:0;s:13:"style_options";b:0;s:10:"row_plugin";b:0;s:11:"row_options";b:0;s:6:"fields";b:0;s:9:"arguments";b:0;s:13:"filter_groups";b:0;s:7:"filters";b:0;}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:12:"style_plugin";s:7:"default";s:10:"row_plugin";s:6:"fields";s:6:"fields";a:4:{s:2:"id";a:3:{s:2:"id";s:2:"id";s:5:"table";s:10:"eck_reader";s:5:"field";s:2:"id";}s:16:"field_first_name";a:4:{s:2:"id";s:16:"field_first_name";s:5:"table";s:27:"field_data_field_first_name";s:5:"field";s:16:"field_first_name";s:5:"label";s:4:"Name";}s:15:"field_last_name";a:3:{s:2:"id";s:15:"field_last_name";s:5:"table";s:26:"field_data_field_last_name";s:5:"field";s:15:"field_last_name";}s:4:"name";a:5:{s:2:"id";s:4:"name";s:5:"table";s:5:"users";s:5:"field";s:4:"name";s:12:"relationship";s:26:"field_parent_uid_target_id";s:5:"label";s:6:"Parent";}}s:9:"arguments";a:1:{s:26:"field_parent_uid_target_id";a:9:{s:2:"id";s:26:"field_parent_uid_target_id";s:5:"table";s:27:"field_data_field_parent_uid";s:5:"field";s:26:"field_parent_uid_target_id";s:14:"default_action";s:5:"empty";s:21:"default_argument_type";s:5:"fixed";s:7:"summary";a:2:{s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:15:"summary_options";a:1:{s:14:"items_per_page";s:2:"25";}s:18:"specify_validation";b:1;s:8:"validate";a:1:{s:4:"fail";s:5:"empty";}}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:10:"eck_reader";s:5:"field";s:4:"type";s:5:"value";a:1:{s:6:"reader";s:6:"reader";}}}}');
INSERT INTO `views_display` VALUES ('4','block_3','Block 3','block','5','a:5:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:8:"defaults";a:4:{s:13:"relationships";b:0;s:6:"fields";b:0;s:13:"filter_groups";b:0;s:7:"filters";b:0;}s:13:"relationships";a:3:{s:26:"field_parent_uid_target_id";a:3:{s:2:"id";s:26:"field_parent_uid_target_id";s:5:"table";s:27:"field_data_field_parent_uid";s:5:"field";s:26:"field_parent_uid_target_id";}s:23:"field_program_target_id";a:3:{s:2:"id";s:23:"field_program_target_id";s:5:"table";s:24:"field_data_field_program";s:5:"field";s:23:"field_program_target_id";}s:34:"reverse_field_readers_reader_badge";a:3:{s:2:"id";s:34:"reverse_field_readers_reader_badge";s:5:"table";s:10:"eck_reader";s:5:"field";s:34:"reverse_field_readers_reader_badge";}}s:6:"fields";a:10:{s:2:"id";a:3:{s:2:"id";s:2:"id";s:5:"table";s:10:"eck_reader";s:5:"field";s:2:"id";}s:16:"field_first_name";a:4:{s:2:"id";s:16:"field_first_name";s:5:"table";s:27:"field_data_field_first_name";s:5:"field";s:16:"field_first_name";s:5:"label";s:4:"Name";}s:15:"field_last_name";a:3:{s:2:"id";s:15:"field_last_name";s:5:"table";s:26:"field_data_field_last_name";s:5:"field";s:15:"field_last_name";}s:4:"name";a:5:{s:2:"id";s:4:"name";s:5:"table";s:5:"users";s:5:"field";s:4:"name";s:12:"relationship";s:26:"field_parent_uid_target_id";s:5:"label";s:6:"Parent";}s:9:"edit_link";a:3:{s:2:"id";s:9:"edit_link";s:5:"table";s:10:"eck_reader";s:5:"field";s:9:"edit_link";}s:9:"field_age";a:4:{s:2:"id";s:9:"field_age";s:5:"table";s:20:"field_data_field_age";s:5:"field";s:9:"field_age";s:8:"settings";a:2:{s:18:"thousand_separator";s:0:"";s:13:"prefix_suffix";i:1;}}s:11:"field_grade";a:3:{s:2:"id";s:11:"field_grade";s:5:"table";s:22:"field_data_field_grade";s:5:"field";s:11:"field_grade";}s:19:"field_reader_school";a:4:{s:2:"id";s:19:"field_reader_school";s:5:"table";s:30:"field_data_field_reader_school";s:5:"field";s:19:"field_reader_school";s:8:"settings";a:1:{s:4:"link";i:0;}}s:20:"field_per_unit_label";a:4:{s:2:"id";s:20:"field_per_unit_label";s:5:"table";s:31:"field_data_field_per_unit_label";s:5:"field";s:20:"field_per_unit_label";s:12:"relationship";s:23:"field_program_target_id";}s:5:"title";a:21:{s:2:"id";s:5:"title";s:5:"table";s:11:"eck_program";s:5:"field";s:5:"title";s:12:"relationship";s:23:"field_program_target_id";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:5:"Title";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:10:"eck_reader";s:5:"field";s:4:"type";s:5:"value";a:1:{s:6:"reader";s:6:"reader";}}}}');
INSERT INTO `views_display` VALUES ('4','default','Master','default','1','a:14:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:1:{s:8:"distinct";b:1;}}s:5:"title";s:7:"Readers";s:8:"use_ajax";b:1;s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:2:{s:4:"type";s:5:"basic";s:7:"options";a:1:{s:12:"reset_button";b:1;}}s:5:"pager";a:2:{s:4:"type";s:4:"none";s:7:"options";a:1:{s:6:"offset";s:1:"0";}}s:12:"style_plugin";s:5:"table";s:13:"style_options";a:3:{s:7:"columns";a:11:{s:2:"id";s:2:"id";s:16:"field_first_name";s:16:"field_first_name";s:9:"field_age";s:9:"field_age";s:12:"field_school";s:12:"field_school";s:11:"field_grade";s:11:"field_grade";s:13:"field_program";s:13:"field_program";s:11:"field_level";s:11:"field_level";s:12:"field_points";s:12:"field_points";s:15:"field_my_badges";s:15:"field_my_badges";s:15:"field_my_prizes";s:15:"field_my_prizes";s:9:"edit_link";s:9:"edit_link";}s:7:"default";s:2:"-1";s:4:"info";a:11:{s:2:"id";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:16:"field_first_name";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"field_age";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:12:"field_school";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:11:"field_grade";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:13:"field_program";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:11:"field_level";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:12:"field_points";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:15:"field_my_badges";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:15:"field_my_prizes";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"edit_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}}s:13:"relationships";a:2:{s:26:"field_parent_uid_target_id";a:3:{s:2:"id";s:26:"field_parent_uid_target_id";s:5:"table";s:27:"field_data_field_parent_uid";s:5:"field";s:26:"field_parent_uid_target_id";}s:23:"field_program_target_id";a:3:{s:2:"id";s:23:"field_program_target_id";s:5:"table";s:24:"field_data_field_program";s:5:"field";s:23:"field_program_target_id";}}s:6:"fields";a:5:{s:2:"id";a:3:{s:2:"id";s:2:"id";s:5:"table";s:10:"eck_reader";s:5:"field";s:2:"id";}s:16:"field_first_name";a:4:{s:2:"id";s:16:"field_first_name";s:5:"table";s:27:"field_data_field_first_name";s:5:"field";s:16:"field_first_name";s:5:"label";s:4:"Name";}s:15:"field_last_name";a:3:{s:2:"id";s:15:"field_last_name";s:5:"table";s:26:"field_data_field_last_name";s:5:"field";s:15:"field_last_name";}s:4:"name";a:5:{s:2:"id";s:4:"name";s:5:"table";s:5:"users";s:5:"field";s:4:"name";s:12:"relationship";s:26:"field_parent_uid_target_id";s:5:"label";s:6:"Parent";}s:9:"edit_link";a:3:{s:2:"id";s:9:"edit_link";s:5:"table";s:10:"eck_reader";s:5:"field";s:9:"edit_link";}}s:9:"arguments";a:1:{s:2:"id";a:8:{s:2:"id";s:2:"id";s:5:"table";s:10:"eck_reader";s:5:"field";s:2:"id";s:21:"default_argument_type";s:5:"fixed";s:7:"summary";a:2:{s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:15:"summary_options";a:1:{s:14:"items_per_page";s:2:"25";}s:18:"specify_validation";b:1;s:8:"validate";a:1:{s:4:"fail";s:5:"empty";}}}s:7:"filters";a:3:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:10:"eck_reader";s:5:"field";s:4:"type";s:5:"value";a:1:{s:6:"reader";s:6:"reader";}}s:22:"field_first_name_value";a:13:{s:2:"id";s:22:"field_first_name_value";s:5:"table";s:27:"field_data_field_first_name";s:5:"field";s:22:"field_first_name_value";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:8:"operator";s:1:"=";s:5:"value";s:0:"";s:5:"group";s:1:"1";s:7:"exposed";b:1;s:6:"expose";a:11:{s:11:"operator_id";s:25:"field_first_name_value_op";s:5:"label";s:10:"First Name";s:11:"description";s:0:"";s:12:"use_operator";i:0;s:14:"operator_label";s:0:"";s:8:"operator";s:25:"field_first_name_value_op";s:10:"identifier";s:22:"field_first_name_value";s:8:"required";i:0;s:8:"remember";i:0;s:8:"multiple";b:0;s:14:"remember_roles";a:5:{i:2;s:1:"2";i:1;i:0;i:3;i:0;i:4;i:0;i:5;i:0;}}s:10:"is_grouped";b:0;s:10:"group_info";a:10:{s:5:"label";s:0:"";s:11:"description";s:0:"";s:10:"identifier";s:0:"";s:8:"optional";b:1;s:6:"widget";s:6:"select";s:8:"multiple";b:0;s:8:"remember";i:0;s:13:"default_group";s:3:"All";s:22:"default_group_multiple";a:0:{}s:11:"group_items";a:0:{}}}s:21:"field_last_name_value";a:13:{s:2:"id";s:21:"field_last_name_value";s:5:"table";s:26:"field_data_field_last_name";s:5:"field";s:21:"field_last_name_value";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:8:"operator";s:1:"=";s:5:"value";s:0:"";s:5:"group";s:1:"1";s:7:"exposed";b:1;s:6:"expose";a:11:{s:11:"operator_id";s:24:"field_last_name_value_op";s:5:"label";s:9:"Last Name";s:11:"description";s:0:"";s:12:"use_operator";i:0;s:14:"operator_label";s:0:"";s:8:"operator";s:24:"field_last_name_value_op";s:10:"identifier";s:21:"field_last_name_value";s:8:"required";i:0;s:8:"remember";i:0;s:8:"multiple";b:0;s:14:"remember_roles";a:5:{i:2;s:1:"2";i:1;i:0;i:3;i:0;i:4;i:0;i:5;i:0;}}s:10:"is_grouped";b:0;s:10:"group_info";a:10:{s:5:"label";s:0:"";s:11:"description";s:0:"";s:10:"identifier";s:0:"";s:8:"optional";b:1;s:6:"widget";s:6:"select";s:8:"multiple";b:0;s:8:"remember";i:0;s:13:"default_group";s:3:"All";s:22:"default_group_multiple";a:0:{}s:11:"group_items";a:0:{}}}}}');
INSERT INTO `views_display` VALUES ('5','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('5','default','Master','default','1','a:13:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:11:"Reader Logs";s:8:"use_ajax";b:1;s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"some";s:7:"options";a:2:{s:14:"items_per_page";s:2:"50";s:6:"offset";s:1:"0";}}s:12:"style_plugin";s:5:"table";s:13:"style_options";a:3:{s:7:"columns";a:2:{s:16:"field_book_title";s:16:"field_book_title";s:21:"field_units_completed";s:21:"field_units_completed";}s:7:"default";s:2:"-1";s:4:"info";a:2:{s:16:"field_book_title";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:21:"field_units_completed";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}}s:6:"fields";a:6:{s:16:"field_book_title";a:4:{s:2:"id";s:16:"field_book_title";s:5:"table";s:27:"field_data_field_book_title";s:5:"field";s:16:"field_book_title";s:12:"delta_offset";s:1:"0";}s:12:"field_author";a:3:{s:2:"id";s:12:"field_author";s:5:"table";s:23:"field_data_field_author";s:5:"field";s:12:"field_author";}s:15:"field_unit_type";a:3:{s:2:"id";s:15:"field_unit_type";s:5:"table";s:26:"field_data_field_unit_type";s:5:"field";s:15:"field_unit_type";}s:21:"field_units_completed";a:4:{s:2:"id";s:21:"field_units_completed";s:5:"table";s:32:"field_data_field_units_completed";s:5:"field";s:21:"field_units_completed";s:8:"settings";a:2:{s:18:"thousand_separator";s:0:"";s:13:"prefix_suffix";i:1;}}s:19:"field_points_earned";a:4:{s:2:"id";s:19:"field_points_earned";s:5:"table";s:30:"field_data_field_points_earned";s:5:"field";s:19:"field_points_earned";s:5:"label";s:13:"Points Earned";}s:11:"field_stars";a:4:{s:2:"id";s:11:"field_stars";s:5:"table";s:22:"field_data_field_stars";s:5:"field";s:11:"field_stars";s:5:"label";s:14:"My Star Rating";}}s:9:"arguments";a:1:{s:23:"field_readers_target_id";a:8:{s:2:"id";s:23:"field_readers_target_id";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:23:"field_readers_target_id";s:21:"default_argument_type";s:5:"fixed";s:7:"summary";a:2:{s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:15:"summary_options";a:1:{s:14:"items_per_page";s:2:"25";}s:18:"specify_validation";b:1;s:8:"validate";a:1:{s:4:"fail";s:5:"empty";}}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:14:"eck_reader_log";s:5:"field";s:4:"type";s:5:"value";a:1:{s:10:"reader_log";s:10:"reader_log";}}}}');
INSERT INTO `views_display` VALUES ('7','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('7','default','Master','default','1','a:11:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:6:"access";a:2:{s:4:"type";s:4:"perm";s:4:"perm";s:14:"access content";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"some";s:7:"options";a:1:{s:14:"items_per_page";s:1:"5";}}s:12:"style_plugin";s:5:"table";s:10:"row_plugin";s:6:"fields";s:6:"fields";a:1:{s:4:"name";a:7:{s:2:"id";s:4:"name";s:5:"table";s:18:"taxonomy_term_data";s:5:"field";s:4:"name";s:5:"alter";a:8:{s:10:"alter_text";i:0;s:9:"make_link";i:0;s:8:"absolute";i:0;s:4:"trim";i:0;s:13:"word_boundary";i:0;s:8:"ellipsis";i:0;s:10:"strip_tags";i:0;s:4:"html";i:0;}s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"link_to_taxonomy";i:1;}}s:7:"filters";a:1:{s:12:"machine_name";a:4:{s:2:"id";s:12:"machine_name";s:5:"table";s:19:"taxonomy_vocabulary";s:5:"field";s:12:"machine_name";s:5:"value";a:1:{s:5:"prize";s:5:"prize";}}}s:5:"sorts";a:0:{}s:5:"title";s:5:"prize";}'),('8','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('8','default','Master','default','1','a:12:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:13:"Entity Badges";s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"some";s:7:"options";a:1:{s:14:"items_per_page";s:1:"5";}}s:12:"style_plugin";s:5:"table";s:13:"style_options";a:3:{s:7:"columns";a:1:{s:2:"id";s:2:"id";}s:7:"default";s:2:"-1";s:4:"info";a:1:{s:2:"id";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}}s:13:"relationships";a:0:{}s:6:"fields";a:3:{s:2:"id";a:4:{s:2:"id";s:2:"id";s:5:"table";s:11:"eck_program";s:5:"field";s:2:"id";s:7:"exclude";b:1;}s:25:"field_program_description";a:3:{s:2:"id";s:25:"field_program_description";s:5:"table";s:36:"field_data_field_program_description";s:5:"field";s:25:"field_program_description";}s:26:"field_per_unit_point_value";a:6:{s:2:"id";s:26:"field_per_unit_point_value";s:5:"table";s:37:"field_data_field_per_unit_point_value";s:5:"field";s:26:"field_per_unit_point_value";s:5:"label";s:6:"Points";s:19:"element_label_colon";b:0;s:8:"settings";a:2:{s:18:"thousand_separator";s:0:"";s:13:"prefix_suffix";i:1;}}}s:9:"arguments";a:1:{s:2:"id";a:10:{s:2:"id";s:2:"id";s:5:"table";s:11:"eck_program";s:5:"field";s:2:"id";s:14:"default_action";s:7:"default";s:21:"default_argument_type";s:3:"raw";s:24:"default_argument_options";a:1:{s:5:"index";s:1:"2";}s:7:"summary";a:2:{s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:15:"summary_options";a:1:{s:14:"items_per_page";s:2:"25";}s:18:"specify_validation";b:1;s:8:"validate";a:2:{s:4:"type";s:7:"numeric";s:4:"fail";s:5:"empty";}}}}');
INSERT INTO `views_display` VALUES ('9','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('9','default','Master','default','1','a:12:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:8:"use_ajax";b:1;s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"none";s:7:"options";a:1:{s:6:"offset";s:1:"0";}}s:12:"style_plugin";s:5:"table";s:6:"header";a:1:{s:4:"area";a:11:{s:2:"id";s:4:"area";s:5:"table";s:5:"views";s:5:"field";s:4:"area";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:12:"Program Name";s:5:"empty";i:0;s:7:"content";s:37:"<h3>Manage Levels for [title_1]</h3> ";s:6:"format";s:9:"full_html";s:8:"tokenize";i:1;}}s:13:"relationships";a:3:{s:33:"field_program_reference_target_id";a:3:{s:2:"id";s:33:"field_program_reference_target_id";s:5:"table";s:34:"field_data_field_program_reference";s:5:"field";s:33:"field_program_reference_target_id";}s:28:"field_reader_badge_target_id";a:3:{s:2:"id";s:28:"field_reader_badge_target_id";s:5:"table";s:29:"field_data_field_reader_badge";s:5:"field";s:28:"field_reader_badge_target_id";}s:31:"field_prize_reference_target_id";a:3:{s:2:"id";s:31:"field_prize_reference_target_id";s:5:"table";s:32:"field_data_field_prize_reference";s:5:"field";s:31:"field_prize_reference_target_id";}}s:6:"fields";a:8:{s:5:"title";a:4:{s:2:"id";s:5:"title";s:5:"table";s:9:"eck_level";s:5:"field";s:5:"title";s:5:"label";s:5:"Level";}s:2:"id";a:5:{s:2:"id";s:2:"id";s:5:"table";s:11:"eck_program";s:5:"field";s:2:"id";s:12:"relationship";s:33:"field_program_reference_target_id";s:7:"exclude";b:1;}s:21:"field_point_threshold";a:5:{s:2:"id";s:21:"field_point_threshold";s:5:"table";s:32:"field_data_field_point_threshold";s:5:"field";s:21:"field_point_threshold";s:5:"label";s:6:"Points";s:8:"settings";a:2:{s:18:"thousand_separator";s:0:"";s:13:"prefix_suffix";i:1;}}s:21:"field_prize_reference";a:5:{s:2:"id";s:21:"field_prize_reference";s:5:"table";s:32:"field_data_field_prize_reference";s:5:"field";s:21:"field_prize_reference";s:5:"label";s:5:"Prize";s:8:"settings";a:1:{s:4:"link";i:0;}}s:21:"field_drawing_tickets";a:5:{s:2:"id";s:21:"field_drawing_tickets";s:5:"table";s:32:"field_data_field_drawing_tickets";s:5:"field";s:21:"field_drawing_tickets";s:5:"label";s:17:"Drawing Ticket(s)";s:8:"settings";a:2:{s:18:"thousand_separator";s:0:"";s:13:"prefix_suffix";i:1;}}s:9:"edit_link";a:3:{s:2:"id";s:9:"edit_link";s:5:"table";s:9:"eck_level";s:5:"field";s:9:"edit_link";}s:15:"rendered_entity";a:25:{s:2:"id";s:15:"rendered_entity";s:5:"table";s:18:"views_entity_badge";s:5:"field";s:15:"rendered_entity";s:12:"relationship";s:28:"field_reader_badge_target_id";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:5:"Badge";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:14:"link_to_entity";i:1;s:7:"display";s:5:"label";s:9:"view_mode";s:4:"full";s:13:"bypass_access";i:0;}s:7:"title_1";a:21:{s:2:"id";s:7:"title_1";s:5:"table";s:11:"eck_program";s:5:"field";s:5:"title";s:12:"relationship";s:33:"field_program_reference_target_id";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:0:"";s:7:"exclude";i:1;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";b:0;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;}}s:9:"arguments";a:1:{s:2:"id";a:11:{s:2:"id";s:2:"id";s:5:"table";s:11:"eck_program";s:5:"field";s:2:"id";s:12:"relationship";s:33:"field_program_reference_target_id";s:14:"default_action";s:7:"default";s:21:"default_argument_type";s:3:"raw";s:24:"default_argument_options";a:1:{s:5:"index";s:1:"4";}s:7:"summary";a:2:{s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:15:"summary_options";a:1:{s:14:"items_per_page";s:2:"25";}s:18:"specify_validation";b:1;s:8:"validate";a:2:{s:4:"type";s:7:"numeric";s:4:"fail";s:5:"empty";}}}}');
INSERT INTO `views_display` VALUES ('12','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('12','default','Master','default','1','a:12:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"some";s:7:"options";a:1:{s:14:"items_per_page";s:1:"5";}}s:12:"style_plugin";s:5:"table";s:10:"row_plugin";s:6:"fields";s:6:"fields";a:7:{s:2:"id";a:3:{s:5:"table";s:9:"eck_prize";s:5:"field";s:2:"id";s:2:"id";s:2:"id";}s:16:"field_prize_name";a:35:{s:2:"id";s:16:"field_prize_name";s:5:"table";s:27:"field_data_field_prize_name";s:5:"field";s:16:"field_prize_name";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:10:"Prize Name";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:5:"value";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:12:"group_column";s:5:"value";s:13:"group_columns";a:0:{}s:10:"group_rows";b:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";i:0;s:14:"delta_reversed";b:0;s:16:"delta_first_last";b:0;s:12:"delta_random";b:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:23:"field_prize_description";a:35:{s:2:"id";s:23:"field_prize_description";s:5:"table";s:34:"field_data_field_prize_description";s:5:"field";s:23:"field_prize_description";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:17:"Prize Description";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:5:"value";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:12:"group_column";s:5:"value";s:13:"group_columns";a:0:{}s:10:"group_rows";b:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";i:0;s:14:"delta_reversed";b:0;s:16:"delta_first_last";b:0;s:12:"delta_random";b:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:7:"created";a:26:{s:2:"id";s:7:"created";s:5:"table";s:9:"eck_prize";s:5:"field";s:7:"created";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:7:"Created";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:11:"date_format";s:4:"long";s:18:"custom_date_format";s:0:"";s:25:"second_date_format_custom";s:0:"";s:18:"second_date_format";s:4:"long";s:8:"timezone";s:0:"";}s:18:"field_prize_status";a:35:{s:2:"id";s:18:"field_prize_status";s:5:"table";s:29:"field_data_field_prize_status";s:5:"field";s:18:"field_prize_status";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:12:"Prize Status";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:5:"value";s:4:"type";s:12:"list_default";s:8:"settings";a:0:{}s:12:"group_column";s:5:"value";s:13:"group_columns";a:0:{}s:10:"group_rows";b:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";i:0;s:14:"delta_reversed";b:0;s:16:"delta_first_last";b:0;s:12:"delta_random";b:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:9:"edit_link";a:22:{s:2:"id";s:9:"edit_link";s:5:"table";s:9:"eck_prize";s:5:"field";s:9:"edit_link";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:9:"Edit link";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";b:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:4:"text";s:0:"";}s:11:"delete_link";a:22:{s:2:"id";s:11:"delete_link";s:5:"table";s:9:"eck_prize";s:5:"field";s:11:"delete_link";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:11:"Delete link";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";b:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:4:"text";s:0:"";}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:9:"eck_prize";s:5:"field";s:4:"type";s:5:"value";a:1:{s:5:"prize";s:5:"prize";}}}s:5:"sorts";a:0:{}s:5:"title";s:6:"prizes";s:13:"style_options";a:12:{s:8:"grouping";a:0:{}s:9:"row_class";s:0:"";s:17:"default_row_class";i:1;s:17:"row_class_special";i:1;s:8:"override";i:1;s:6:"sticky";i:0;s:7:"caption";s:0:"";s:7:"summary";s:0:"";s:7:"columns";a:7:{s:2:"id";s:2:"id";s:7:"created";s:7:"created";s:11:"delete_link";s:11:"delete_link";s:9:"edit_link";s:9:"edit_link";s:23:"field_prize_description";s:23:"field_prize_description";s:16:"field_prize_name";s:16:"field_prize_name";s:18:"field_prize_status";s:18:"field_prize_status";}s:4:"info";a:7:{s:2:"id";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:7:"created";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:11:"delete_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"edit_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:23:"field_prize_description";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:16:"field_prize_name";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:18:"field_prize_status";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}s:7:"default";s:2:"-1";s:11:"empty_table";i:0;}}');
INSERT INTO `views_display` VALUES ('13','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('13','default','Master','default','1','a:12:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"some";s:7:"options";a:1:{s:14:"items_per_page";s:1:"5";}}s:12:"style_plugin";s:5:"table";s:10:"row_plugin";s:6:"fields";s:6:"fields";a:6:{s:2:"id";a:3:{s:5:"table";s:18:"eck_drawing_ticket";s:5:"field";s:2:"id";s:2:"id";s:2:"id";}s:5:"title";a:21:{s:2:"id";s:5:"title";s:5:"table";s:18:"eck_drawing_ticket";s:5:"field";s:5:"title";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:5:"Title";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;}s:13:"field_program";a:35:{s:2:"id";s:13:"field_program";s:5:"table";s:24:"field_data_field_program";s:5:"field";s:13:"field_program";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:7:"Program";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:9:"target_id";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";i:0;}s:12:"group_column";s:9:"target_id";s:13:"group_columns";a:0:{}s:10:"group_rows";i:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";s:1:"0";s:14:"delta_reversed";i:0;s:16:"delta_first_last";i:0;s:12:"delta_random";i:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:13:"field_readers";a:35:{s:2:"id";s:13:"field_readers";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:13:"field_readers";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:7:"Readers";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:9:"target_id";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";i:0;}s:12:"group_column";s:9:"target_id";s:13:"group_columns";a:0:{}s:10:"group_rows";i:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";s:1:"0";s:14:"delta_reversed";i:0;s:16:"delta_first_last";i:0;s:12:"delta_random";i:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:9:"edit_link";a:22:{s:2:"id";s:9:"edit_link";s:5:"table";s:18:"eck_drawing_ticket";s:5:"field";s:9:"edit_link";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:9:"Edit link";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";b:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:4:"text";s:0:"";}s:11:"delete_link";a:22:{s:2:"id";s:11:"delete_link";s:5:"table";s:18:"eck_drawing_ticket";s:5:"field";s:11:"delete_link";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:11:"Delete link";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";b:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:4:"text";s:0:"";}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:18:"eck_drawing_ticket";s:5:"field";s:4:"type";s:5:"value";a:1:{s:14:"drawing_ticket";s:14:"drawing_ticket";}}}s:5:"sorts";a:0:{}s:5:"title";s:14:"Drawing Ticket";s:13:"style_options";a:12:{s:8:"grouping";a:0:{}s:9:"row_class";s:0:"";s:17:"default_row_class";i:1;s:17:"row_class_special";i:1;s:8:"override";i:1;s:6:"sticky";i:0;s:7:"caption";s:0:"";s:7:"summary";s:0:"";s:7:"columns";a:7:{s:2:"id";s:2:"id";s:18:"field_created_date";s:18:"field_created_date";s:11:"delete_link";s:11:"delete_link";s:9:"edit_link";s:9:"edit_link";s:5:"title";s:5:"title";s:13:"field_program";s:13:"field_program";s:13:"field_readers";s:13:"field_readers";}s:4:"info";a:7:{s:2:"id";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:18:"field_created_date";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:11:"delete_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"edit_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:5:"title";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:13:"field_program";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:13:"field_readers";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}s:7:"default";s:2:"-1";s:11:"empty_table";i:0;}}');
INSERT INTO `views_display` VALUES ('14','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('14','default','Master','default','1','a:14:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:24:"Reader Points For Reader";s:8:"use_ajax";b:1;s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"none";s:7:"options";a:1:{s:6:"offset";s:1:"0";}}s:12:"style_plugin";s:7:"default";s:10:"row_plugin";s:6:"fields";s:13:"relationships";a:2:{s:23:"field_readers_target_id";a:3:{s:2:"id";s:23:"field_readers_target_id";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:23:"field_readers_target_id";}s:26:"field_parent_uid_target_id";a:4:{s:2:"id";s:26:"field_parent_uid_target_id";s:5:"table";s:27:"field_data_field_parent_uid";s:5:"field";s:26:"field_parent_uid_target_id";s:12:"relationship";s:23:"field_readers_target_id";}}s:6:"fields";a:4:{s:2:"id";a:3:{s:2:"id";s:2:"id";s:5:"table";s:10:"eck_points";s:5:"field";s:2:"id";}s:13:"field_readers";a:5:{s:2:"id";s:13:"field_readers";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:13:"field_readers";s:8:"settings";a:1:{s:4:"link";i:0;}s:12:"delta_offset";s:1:"0";}s:12:"field_points";a:4:{s:2:"id";s:12:"field_points";s:5:"table";s:23:"field_data_field_points";s:5:"field";s:12:"field_points";s:8:"settings";a:2:{s:18:"thousand_separator";s:1:",";s:13:"prefix_suffix";i:1;}}s:16:"field_first_name";a:4:{s:2:"id";s:16:"field_first_name";s:5:"table";s:27:"field_data_field_first_name";s:5:"field";s:16:"field_first_name";s:12:"relationship";s:23:"field_readers_target_id";}}s:9:"arguments";a:1:{s:23:"field_readers_target_id";a:9:{s:2:"id";s:23:"field_readers_target_id";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:23:"field_readers_target_id";s:14:"default_action";s:13:"access denied";s:21:"default_argument_type";s:5:"fixed";s:7:"summary";a:2:{s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:15:"summary_options";a:1:{s:14:"items_per_page";s:2:"25";}s:18:"specify_validation";b:1;s:8:"validate";a:1:{s:4:"type";s:7:"numeric";}}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:10:"eck_points";s:5:"field";s:4:"type";s:5:"value";a:1:{s:6:"points";s:6:"points";}}}}');
INSERT INTO `views_display` VALUES ('15','block','Unclaimed','block','2','a:5:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:7:"filters";a:2:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:16:"eck_reader_prize";s:5:"field";s:4:"type";s:5:"value";a:1:{s:12:"reader_prize";s:12:"reader_prize";}}s:18:"field_status_value";a:14:{s:2:"id";s:18:"field_status_value";s:5:"table";s:23:"field_data_field_status";s:5:"field";s:18:"field_status_value";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:8:"operator";s:2:"or";s:5:"value";a:1:{s:9:"Unclaimed";s:9:"Unclaimed";}s:5:"group";s:1:"1";s:7:"exposed";b:0;s:6:"expose";a:12:{s:11:"operator_id";b:0;s:5:"label";s:0:"";s:11:"description";s:0:"";s:12:"use_operator";b:0;s:14:"operator_label";s:0:"";s:8:"operator";s:0:"";s:10:"identifier";s:0:"";s:8:"required";b:0;s:8:"remember";b:0;s:8:"multiple";b:0;s:14:"remember_roles";a:1:{i:2;i:2;}s:6:"reduce";b:0;}s:10:"is_grouped";b:0;s:10:"group_info";a:10:{s:5:"label";s:0:"";s:11:"description";s:0:"";s:10:"identifier";s:0:"";s:8:"optional";b:1;s:6:"widget";s:6:"select";s:8:"multiple";b:0;s:8:"remember";i:0;s:13:"default_group";s:3:"All";s:22:"default_group_multiple";a:0:{}s:11:"group_items";a:0:{}}s:17:"reduce_duplicates";i:0;}}s:8:"defaults";a:2:{s:7:"filters";b:0;s:13:"filter_groups";b:0;}s:13:"filter_groups";a:2:{s:8:"operator";s:3:"AND";s:6:"groups";a:1:{i:1;s:3:"AND";}}s:19:"display_description";s:0:"";}'),('15','block_1','Withdrawn','block','3','a:2:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:19:"display_description";s:0:"";}'),('15','block_2','Claimed','block','4','a:2:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:19:"display_description";s:0:"";}'),('15','default','Master','default','1','a:12:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"some";s:7:"options";a:1:{s:14:"items_per_page";s:1:"5";}}s:12:"style_plugin";s:7:"default";s:10:"row_plugin";s:6:"fields";s:6:"fields";a:2:{s:2:"id";a:3:{s:5:"table";s:16:"eck_reader_prize";s:5:"field";s:2:"id";s:2:"id";s:2:"id";}s:5:"title";a:21:{s:2:"id";s:5:"title";s:5:"table";s:16:"eck_reader_prize";s:5:"field";s:5:"title";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:5:"Title";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;}}s:7:"filters";a:2:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:16:"eck_reader_prize";s:5:"field";s:4:"type";s:5:"value";a:1:{s:12:"reader_prize";s:12:"reader_prize";}}s:18:"field_status_value";a:14:{s:2:"id";s:18:"field_status_value";s:5:"table";s:23:"field_data_field_status";s:5:"field";s:18:"field_status_value";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:8:"operator";s:2:"or";s:5:"value";a:1:{s:7:"Claimed";s:7:"Claimed";}s:5:"group";s:1:"1";s:7:"exposed";b:0;s:6:"expose";a:12:{s:11:"operator_id";b:0;s:5:"label";s:0:"";s:11:"description";s:0:"";s:12:"use_operator";b:0;s:14:"operator_label";s:0:"";s:8:"operator";s:0:"";s:10:"identifier";s:0:"";s:8:"required";b:0;s:8:"remember";b:0;s:8:"multiple";b:0;s:14:"remember_roles";a:1:{i:2;i:2;}s:6:"reduce";b:0;}s:10:"is_grouped";b:0;s:10:"group_info";a:10:{s:5:"label";s:0:"";s:11:"description";s:0:"";s:10:"identifier";s:0:"";s:8:"optional";b:1;s:6:"widget";s:6:"select";s:8:"multiple";b:0;s:8:"remember";i:0;s:13:"default_group";s:3:"All";s:22:"default_group_multiple";a:0:{}s:11:"group_items";a:0:{}}s:17:"reduce_duplicates";i:0;}}s:5:"sorts";a:0:{}s:5:"title";s:17:"All Reader Prizes";s:9:"arguments";a:0:{}}');
INSERT INTO `views_display` VALUES ('17','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('17','default','Master','default','1','a:16:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"none";s:7:"options";a:1:{s:6:"offset";s:1:"0";}}s:12:"style_plugin";s:5:"table";s:10:"row_plugin";s:6:"fields";s:6:"fields";a:5:{s:16:"field_first_name";a:35:{s:2:"id";s:16:"field_first_name";s:5:"table";s:27:"field_data_field_first_name";s:5:"field";s:16:"field_first_name";s:12:"relationship";s:23:"field_readers_target_id";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:10:"First Name";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:5:"value";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:12:"group_column";s:5:"value";s:13:"group_columns";a:0:{}s:10:"group_rows";b:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";i:0;s:14:"delta_reversed";b:0;s:16:"delta_first_last";b:0;s:12:"delta_random";b:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:15:"field_last_name";a:35:{s:2:"id";s:15:"field_last_name";s:5:"table";s:26:"field_data_field_last_name";s:5:"field";s:15:"field_last_name";s:12:"relationship";s:23:"field_readers_target_id";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:9:"Last Name";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:5:"value";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:12:"group_column";s:5:"value";s:13:"group_columns";a:0:{}s:10:"group_rows";b:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";i:0;s:14:"delta_reversed";b:0;s:16:"delta_first_last";b:0;s:12:"delta_random";b:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:5:"title";a:21:{s:2:"id";s:5:"title";s:5:"table";s:9:"eck_prize";s:5:"field";s:5:"title";s:12:"relationship";s:31:"field_prize_reference_target_id";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:5:"Title";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;}s:12:"field_status";a:35:{s:2:"id";s:12:"field_status";s:5:"table";s:23:"field_data_field_status";s:5:"field";s:12:"field_status";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:6:"Status";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:5:"value";s:4:"type";s:12:"list_default";s:8:"settings";a:0:{}s:12:"group_column";s:5:"value";s:13:"group_columns";a:0:{}s:10:"group_rows";b:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";i:0;s:14:"delta_reversed";b:0;s:16:"delta_first_last";b:0;s:12:"delta_random";b:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:9:"edit_link";a:22:{s:2:"id";s:9:"edit_link";s:5:"table";s:16:"eck_reader_prize";s:5:"field";s:9:"edit_link";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:9:"Edit link";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";b:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:4:"text";s:0:"";}}s:7:"filters";a:1:{s:4:"type";a:13:{s:2:"id";s:4:"type";s:5:"table";s:16:"eck_reader_prize";s:5:"field";s:4:"type";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:8:"operator";s:2:"in";s:5:"value";a:1:{s:12:"reader_prize";s:12:"reader_prize";}s:5:"group";s:1:"1";s:7:"exposed";b:0;s:6:"expose";a:12:{s:11:"operator_id";s:7:"type_op";s:5:"label";s:17:"reader_prize type";s:11:"description";s:0:"";s:12:"use_operator";i:0;s:14:"operator_label";s:0:"";s:8:"operator";s:7:"type_op";s:10:"identifier";s:4:"type";s:8:"required";i:0;s:8:"remember";i:0;s:8:"multiple";i:0;s:14:"remember_roles";a:5:{i:2;s:1:"2";i:1;i:0;i:3;i:0;i:4;i:0;i:5;i:0;}s:6:"reduce";i:0;}s:10:"is_grouped";b:0;s:10:"group_info";a:10:{s:5:"label";s:0:"";s:11:"description";s:0:"";s:10:"identifier";s:0:"";s:8:"optional";b:1;s:6:"widget";s:6:"select";s:8:"multiple";b:0;s:8:"remember";i:0;s:13:"default_group";s:3:"All";s:22:"default_group_multiple";a:0:{}s:11:"group_items";a:0:{}}}}s:5:"sorts";a:0:{}s:5:"title";s:16:"Prize Per Reader";s:13:"relationships";a:2:{s:23:"field_readers_target_id";a:8:{s:2:"id";s:23:"field_readers_target_id";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:23:"field_readers_target_id";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:43:"Reader entity referenced from field_readers";s:8:"required";i:0;}s:31:"field_prize_reference_target_id";a:8:{s:2:"id";s:31:"field_prize_reference_target_id";s:5:"table";s:32:"field_data_field_prize_reference";s:5:"field";s:31:"field_prize_reference_target_id";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:50:"Prize entity referenced from field_prize_reference";s:8:"required";i:0;}}s:8:"use_ajax";b:1;s:9:"arguments";a:1:{s:23:"field_readers_target_id";a:22:{s:2:"id";s:23:"field_readers_target_id";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:23:"field_readers_target_id";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:14:"default_action";s:6:"ignore";s:9:"exception";a:3:{s:5:"value";s:3:"all";s:12:"title_enable";i:0;s:5:"title";s:3:"All";}s:12:"title_enable";i:0;s:5:"title";s:0:"";s:17:"breadcrumb_enable";i:0;s:10:"breadcrumb";s:0:"";s:21:"default_argument_type";s:5:"fixed";s:24:"default_argument_options";a:1:{s:8:"argument";s:0:"";}s:25:"default_argument_skip_url";i:0;s:15:"summary_options";a:4:{s:9:"base_path";s:0:"";s:5:"count";s:1:"1";s:14:"items_per_page";s:2:"25";s:8:"override";i:0;}s:7:"summary";a:3:{s:10:"sort_order";s:3:"asc";s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:18:"specify_validation";i:1;s:8:"validate";a:2:{s:4:"type";s:4:"none";s:4:"fail";s:5:"empty";}s:16:"validate_options";a:0:{}s:12:"break_phrase";i:0;s:3:"not";i:0;}}s:13:"style_options";a:12:{s:8:"grouping";a:0:{}s:9:"row_class";s:0:"";s:17:"default_row_class";i:1;s:17:"row_class_special";i:1;s:8:"override";i:1;s:6:"sticky";i:0;s:7:"caption";s:0:"";s:7:"summary";s:0:"";s:7:"columns";a:5:{s:16:"field_first_name";s:16:"field_first_name";s:15:"field_last_name";s:15:"field_last_name";s:9:"edit_link";s:9:"edit_link";s:12:"field_status";s:12:"field_status";s:16:"field_prize_name";s:16:"field_prize_name";}s:4:"info";a:5:{s:16:"field_first_name";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:15:"field_last_name";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"edit_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:12:"field_status";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:16:"field_prize_name";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}s:7:"default";s:2:"-1";s:11:"empty_table";i:0;}s:8:"group_by";i:0;}');
INSERT INTO `views_display` VALUES ('18','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('18','default','Master','default','1','a:14:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:1:{s:8:"distinct";b:1;}}s:5:"title";s:11:"User Search";s:8:"use_ajax";b:1;s:15:"use_more_always";b:0;s:6:"access";a:2:{s:4:"type";s:4:"perm";s:4:"perm";s:20:"access user profiles";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:2:{s:4:"type";s:5:"basic";s:7:"options";a:1:{s:12:"reset_button";b:1;}}s:5:"pager";a:2:{s:4:"type";s:4:"none";s:7:"options";a:1:{s:6:"offset";s:1:"0";}}s:12:"style_plugin";s:5:"table";s:13:"style_options";a:3:{s:7:"columns";a:6:{s:4:"name";s:4:"name";s:16:"field_first_name";s:16:"field_first_name";s:15:"field_last_name";s:15:"field_last_name";s:4:"mail";s:4:"mail";s:13:"field_readers";s:13:"field_readers";s:9:"edit_node";s:9:"edit_node";}s:7:"default";s:2:"-1";s:4:"info";a:6:{s:4:"name";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:16:"field_first_name";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:15:"field_last_name";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:4:"mail";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:13:"field_readers";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"edit_node";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}}s:13:"relationships";a:1:{s:23:"field_readers_target_id";a:3:{s:2:"id";s:23:"field_readers_target_id";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:23:"field_readers_target_id";}}s:6:"fields";a:8:{s:4:"name";a:5:{s:2:"id";s:4:"name";s:5:"table";s:5:"users";s:5:"field";s:4:"name";s:5:"label";s:8:"Username";s:5:"alter";a:2:{s:13:"word_boundary";b:0;s:8:"ellipsis";b:0;}}s:16:"field_first_name";a:3:{s:2:"id";s:16:"field_first_name";s:5:"table";s:27:"field_data_field_first_name";s:5:"field";s:16:"field_first_name";}s:15:"field_last_name";a:3:{s:2:"id";s:15:"field_last_name";s:5:"table";s:26:"field_data_field_last_name";s:5:"field";s:15:"field_last_name";}s:18:"field_library_card";a:35:{s:2:"id";s:18:"field_library_card";s:5:"table";s:29:"field_data_field_library_card";s:5:"field";s:18:"field_library_card";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:12:"Library Card";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:5:"value";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:12:"group_column";s:5:"value";s:13:"group_columns";a:0:{}s:10:"group_rows";b:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";i:0;s:14:"delta_reversed";b:0;s:16:"delta_first_last";b:0;s:12:"delta_random";b:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:4:"mail";a:3:{s:2:"id";s:4:"mail";s:5:"table";s:5:"users";s:5:"field";s:4:"mail";}s:13:"field_readers";a:6:{s:2:"id";s:13:"field_readers";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:13:"field_readers";s:5:"alter";a:3:{s:10:"alter_text";b:1;s:9:"make_link";b:1;s:4:"path";s:68:"/library/dashboard/readers/reader_overview/[field_readers-target_id]";}s:8:"settings";a:1:{s:4:"link";i:0;}s:12:"delta_offset";s:1:"0";}s:26:"field_account_family_notes";a:35:{s:2:"id";s:26:"field_account_family_notes";s:5:"table";s:37:"field_data_field_account_family_notes";s:5:"field";s:26:"field_account_family_notes";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:20:"Account/Family Notes";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:5:"value";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:12:"group_column";s:5:"value";s:13:"group_columns";a:0:{}s:10:"group_rows";b:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";i:0;s:14:"delta_reversed";b:0;s:16:"delta_first_last";b:0;s:12:"delta_random";b:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:9:"edit_node";a:3:{s:2:"id";s:9:"edit_node";s:5:"table";s:5:"users";s:5:"field";s:9:"edit_node";}}s:5:"sorts";a:1:{s:7:"created";a:4:{s:2:"id";s:7:"created";s:5:"table";s:5:"users";s:5:"field";s:7:"created";s:5:"order";s:4:"DESC";}}s:7:"filters";a:5:{s:6:"status";a:6:{s:2:"id";s:6:"status";s:5:"table";s:5:"users";s:5:"field";s:6:"status";s:5:"value";s:1:"1";s:5:"group";i:1;s:6:"expose";a:1:{s:8:"operator";b:0;}}s:22:"field_first_name_value";a:13:{s:2:"id";s:22:"field_first_name_value";s:5:"table";s:27:"field_data_field_first_name";s:5:"field";s:22:"field_first_name_value";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:8:"operator";s:1:"=";s:5:"value";s:0:"";s:5:"group";s:1:"1";s:7:"exposed";b:1;s:6:"expose";a:11:{s:11:"operator_id";s:25:"field_first_name_value_op";s:5:"label";s:10:"First Name";s:11:"description";s:0:"";s:12:"use_operator";i:0;s:14:"operator_label";s:0:"";s:8:"operator";s:25:"field_first_name_value_op";s:10:"identifier";s:22:"field_first_name_value";s:8:"required";i:0;s:8:"remember";i:0;s:8:"multiple";b:0;s:14:"remember_roles";a:5:{i:2;s:1:"2";i:1;i:0;i:3;i:0;i:4;i:0;i:5;i:0;}}s:10:"is_grouped";b:0;s:10:"group_info";a:10:{s:5:"label";s:0:"";s:11:"description";s:0:"";s:10:"identifier";s:0:"";s:8:"optional";b:1;s:6:"widget";s:6:"select";s:8:"multiple";b:0;s:8:"remember";i:0;s:13:"default_group";s:3:"All";s:22:"default_group_multiple";a:0:{}s:11:"group_items";a:0:{}}}s:21:"field_last_name_value";a:13:{s:2:"id";s:21:"field_last_name_value";s:5:"table";s:26:"field_data_field_last_name";s:5:"field";s:21:"field_last_name_value";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:8:"operator";s:1:"=";s:5:"value";s:0:"";s:5:"group";s:1:"1";s:7:"exposed";b:1;s:6:"expose";a:11:{s:11:"operator_id";s:24:"field_last_name_value_op";s:5:"label";s:9:"Last Name";s:11:"description";s:0:"";s:12:"use_operator";i:0;s:14:"operator_label";s:0:"";s:8:"operator";s:24:"field_last_name_value_op";s:10:"identifier";s:21:"field_last_name_value";s:8:"required";i:0;s:8:"remember";i:0;s:8:"multiple";b:0;s:14:"remember_roles";a:5:{i:2;s:1:"2";i:1;i:0;i:3;i:0;i:4;i:0;i:5;i:0;}}s:10:"is_grouped";b:0;s:10:"group_info";a:10:{s:5:"label";s:0:"";s:11:"description";s:0:"";s:10:"identifier";s:0:"";s:8:"optional";b:1;s:6:"widget";s:6:"select";s:8:"multiple";b:0;s:8:"remember";i:0;s:13:"default_group";s:3:"All";s:22:"default_group_multiple";a:0:{}s:11:"group_items";a:0:{}}}s:4:"mail";a:5:{s:2:"id";s:4:"mail";s:5:"table";s:5:"users";s:5:"field";s:4:"mail";s:7:"exposed";b:1;s:6:"expose";a:5:{s:11:"operator_id";s:7:"mail_op";s:5:"label";s:6:"E-mail";s:8:"operator";s:7:"mail_op";s:10:"identifier";s:4:"mail";s:14:"remember_roles";a:5:{i:2;s:1:"2";i:1;i:0;i:3;i:0;i:4;i:0;i:5;i:0;}}}s:3:"uid";a:13:{s:2:"id";s:3:"uid";s:5:"table";s:5:"users";s:5:"field";s:3:"uid";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:8:"operator";s:2:"in";s:5:"value";s:0:"";s:5:"group";s:1:"1";s:7:"exposed";b:1;s:6:"expose";a:12:{s:11:"operator_id";s:6:"uid_op";s:5:"label";s:8:"Username";s:11:"description";s:0:"";s:12:"use_operator";i:0;s:14:"operator_label";s:0:"";s:8:"operator";s:6:"uid_op";s:10:"identifier";s:3:"uid";s:8:"required";i:0;s:8:"remember";i:0;s:8:"multiple";b:0;s:14:"remember_roles";a:5:{i:2;s:1:"2";i:1;i:0;i:3;i:0;i:4;i:0;i:5;i:0;}s:6:"reduce";i:0;}s:10:"is_grouped";b:0;s:10:"group_info";a:10:{s:5:"label";s:4:"Name";s:11:"description";s:0:"";s:10:"identifier";s:3:"uid";s:8:"optional";b:1;s:6:"widget";s:6:"select";s:8:"multiple";b:0;s:8:"remember";b:0;s:13:"default_group";s:3:"All";s:22:"default_group_multiple";a:0:{}s:11:"group_items";a:3:{i:1;a:0:{}i:2;a:0:{}i:3;a:0:{}}}}}}');
INSERT INTO `views_display` VALUES ('19','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('19','default','Master','default','1','a:12:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:21:"Reader Admin Overview";s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"some";s:7:"options";a:1:{s:14:"items_per_page";s:1:"5";}}s:12:"style_plugin";s:7:"default";s:10:"row_plugin";s:6:"fields";s:13:"relationships";a:2:{s:26:"field_parent_uid_target_id";a:3:{s:2:"id";s:26:"field_parent_uid_target_id";s:5:"table";s:27:"field_data_field_parent_uid";s:5:"field";s:26:"field_parent_uid_target_id";}s:23:"field_program_target_id";a:3:{s:2:"id";s:23:"field_program_target_id";s:5:"table";s:24:"field_data_field_program";s:5:"field";s:23:"field_program_target_id";}}s:6:"fields";a:9:{s:2:"id";a:3:{s:2:"id";s:2:"id";s:5:"table";s:10:"eck_reader";s:5:"field";s:2:"id";}s:16:"field_first_name";a:3:{s:2:"id";s:16:"field_first_name";s:5:"table";s:27:"field_data_field_first_name";s:5:"field";s:16:"field_first_name";}s:15:"field_last_name";a:3:{s:2:"id";s:15:"field_last_name";s:5:"table";s:26:"field_data_field_last_name";s:5:"field";s:15:"field_last_name";}s:9:"field_age";a:4:{s:2:"id";s:9:"field_age";s:5:"table";s:20:"field_data_field_age";s:5:"field";s:9:"field_age";s:8:"settings";a:2:{s:18:"thousand_separator";s:0:"";s:13:"prefix_suffix";i:1;}}s:19:"field_reader_school";a:4:{s:2:"id";s:19:"field_reader_school";s:5:"table";s:30:"field_data_field_reader_school";s:5:"field";s:19:"field_reader_school";s:8:"settings";a:1:{s:4:"link";i:0;}}s:11:"field_grade";a:3:{s:2:"id";s:11:"field_grade";s:5:"table";s:22:"field_data_field_grade";s:5:"field";s:11:"field_grade";}s:9:"edit_link";a:3:{s:2:"id";s:9:"edit_link";s:5:"table";s:10:"eck_reader";s:5:"field";s:9:"edit_link";}s:4:"name";a:4:{s:2:"id";s:4:"name";s:5:"table";s:5:"users";s:5:"field";s:4:"name";s:12:"relationship";s:26:"field_parent_uid_target_id";}s:5:"title";a:21:{s:2:"id";s:5:"title";s:5:"table";s:11:"eck_program";s:5:"field";s:5:"title";s:12:"relationship";s:23:"field_program_target_id";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:5:"Title";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:10:"eck_reader";s:5:"field";s:4:"type";s:5:"value";a:1:{s:6:"reader";s:6:"reader";}}}}');
INSERT INTO `views_display` VALUES ('20','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('20','default','Master','default','1','a:13:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:21:"Reading Log By Reader";s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"some";s:7:"options";a:1:{s:14:"items_per_page";s:1:"5";}}s:12:"style_plugin";s:7:"default";s:10:"row_plugin";s:6:"fields";s:13:"relationships";a:1:{s:32:"field_points_reference_target_id";a:4:{s:2:"id";s:32:"field_points_reference_target_id";s:5:"table";s:33:"field_data_field_points_reference";s:5:"field";s:32:"field_points_reference_target_id";s:5:"label";s:53:"Content entity referenced from field_points_reference";}}s:6:"fields";a:7:{s:2:"id";a:3:{s:2:"id";s:2:"id";s:5:"table";s:15:"eck_reading_log";s:5:"field";s:2:"id";}s:22:"field_points_reference";a:4:{s:2:"id";s:22:"field_points_reference";s:5:"table";s:33:"field_data_field_points_reference";s:5:"field";s:22:"field_points_reference";s:8:"settings";a:1:{s:4:"link";i:0;}}s:13:"field_readers";a:5:{s:2:"id";s:13:"field_readers";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:13:"field_readers";s:8:"settings";a:1:{s:4:"link";i:0;}s:12:"delta_offset";s:1:"0";}s:12:"field_author";a:3:{s:2:"id";s:12:"field_author";s:5:"table";s:23:"field_data_field_author";s:5:"field";s:12:"field_author";}s:16:"field_book_title";a:3:{s:2:"id";s:16:"field_book_title";s:5:"table";s:27:"field_data_field_book_title";s:5:"field";s:16:"field_book_title";}s:15:"field_unit_type";a:3:{s:2:"id";s:15:"field_unit_type";s:5:"table";s:26:"field_data_field_unit_type";s:5:"field";s:15:"field_unit_type";}s:21:"field_units_completed";a:4:{s:2:"id";s:21:"field_units_completed";s:5:"table";s:32:"field_data_field_units_completed";s:5:"field";s:21:"field_units_completed";s:8:"settings";a:2:{s:18:"thousand_separator";s:0:"";s:13:"prefix_suffix";i:1;}}}s:9:"arguments";a:1:{s:23:"field_readers_target_id";a:9:{s:2:"id";s:23:"field_readers_target_id";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:23:"field_readers_target_id";s:14:"default_action";s:5:"empty";s:21:"default_argument_type";s:5:"fixed";s:7:"summary";a:2:{s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:15:"summary_options";a:1:{s:14:"items_per_page";s:2:"25";}s:18:"specify_validation";b:1;s:8:"validate";a:2:{s:4:"type";s:7:"numeric";s:4:"fail";s:5:"empty";}}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:15:"eck_reading_log";s:5:"field";s:4:"type";s:5:"value";a:1:{s:11:"reading_log";s:11:"reading_log";}}}}');
INSERT INTO `views_display` VALUES ('21','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('21','default','Master','default','1','a:13:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:22:"Reader Badge by Reader";s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"none";s:7:"options";a:1:{s:6:"offset";s:1:"0";}}s:12:"style_plugin";s:7:"default";s:10:"row_plugin";s:6:"fields";s:13:"relationships";a:2:{s:23:"field_readers_target_id";a:3:{s:2:"id";s:23:"field_readers_target_id";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:23:"field_readers_target_id";}s:28:"field_reader_badge_target_id";a:3:{s:2:"id";s:28:"field_reader_badge_target_id";s:5:"table";s:29:"field_data_field_reader_badge";s:5:"field";s:28:"field_reader_badge_target_id";}}s:6:"fields";a:4:{s:2:"id";a:3:{s:2:"id";s:2:"id";s:5:"table";s:16:"eck_reader_badge";s:5:"field";s:2:"id";}s:23:"field_badge_description";a:4:{s:2:"id";s:23:"field_badge_description";s:5:"table";s:34:"field_data_field_badge_description";s:5:"field";s:23:"field_badge_description";s:12:"relationship";s:28:"field_reader_badge_target_id";}s:16:"field_badge_name";a:4:{s:2:"id";s:16:"field_badge_name";s:5:"table";s:27:"field_data_field_badge_name";s:5:"field";s:16:"field_badge_name";s:12:"relationship";s:28:"field_reader_badge_target_id";}s:17:"field_badge_image";a:6:{s:2:"id";s:17:"field_badge_image";s:5:"table";s:28:"field_data_field_badge_image";s:5:"field";s:17:"field_badge_image";s:12:"relationship";s:28:"field_reader_badge_target_id";s:17:"click_sort_column";s:3:"fid";s:8:"settings";a:2:{s:11:"image_style";s:0:"";s:10:"image_link";s:0:"";}}}s:9:"arguments";a:1:{s:23:"field_readers_target_id";a:9:{s:2:"id";s:23:"field_readers_target_id";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:23:"field_readers_target_id";s:14:"default_action";s:5:"empty";s:21:"default_argument_type";s:5:"fixed";s:7:"summary";a:2:{s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:15:"summary_options";a:1:{s:14:"items_per_page";s:2:"25";}s:18:"specify_validation";b:1;s:8:"validate";a:1:{s:4:"fail";s:5:"empty";}}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:16:"eck_reader_badge";s:5:"field";s:4:"type";s:5:"value";a:1:{s:12:"reader_badge";s:12:"reader_badge";}}}}');
INSERT INTO `views_display` VALUES ('23','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('23','default','Master','default','1','a:13:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"some";s:7:"options";a:1:{s:14:"items_per_page";s:1:"5";}}s:12:"style_plugin";s:5:"table";s:10:"row_plugin";s:6:"fields";s:6:"fields";a:5:{s:2:"id";a:3:{s:5:"table";s:26:"eck_activity_log_reference";s:5:"field";s:2:"id";s:2:"id";s:2:"id";}s:30:"field_activity_log_description";a:35:{s:2:"id";s:30:"field_activity_log_description";s:5:"table";s:41:"field_data_field_activity_log_description";s:5:"field";s:30:"field_activity_log_description";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:24:"Activity Log Description";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:5:"value";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:12:"group_column";s:5:"value";s:13:"group_columns";a:0:{}s:10:"group_rows";b:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";i:0;s:14:"delta_reversed";b:0;s:16:"delta_first_last";b:0;s:12:"delta_random";b:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:24:"field_activity_log_title";a:35:{s:2:"id";s:24:"field_activity_log_title";s:5:"table";s:35:"field_data_field_activity_log_title";s:5:"field";s:24:"field_activity_log_title";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:18:"Activity Log Title";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:5:"value";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:12:"group_column";s:5:"value";s:13:"group_columns";a:0:{}s:10:"group_rows";b:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";i:0;s:14:"delta_reversed";b:0;s:16:"delta_first_last";b:0;s:12:"delta_random";b:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:22:"field_points_reference";a:35:{s:2:"id";s:22:"field_points_reference";s:5:"table";s:33:"field_data_field_points_reference";s:5:"field";s:22:"field_points_reference";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:16:"Points Reference";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:9:"target_id";s:4:"type";s:21:"entityreference_label";s:8:"settings";a:1:{s:4:"link";i:0;}s:12:"group_column";s:9:"target_id";s:13:"group_columns";a:0:{}s:10:"group_rows";i:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";s:1:"0";s:14:"delta_reversed";i:0;s:16:"delta_first_last";i:0;s:12:"delta_random";i:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:9:"view_link";a:22:{s:2:"id";s:9:"view_link";s:5:"table";s:26:"eck_activity_log_reference";s:5:"field";s:9:"view_link";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:4:"Link";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";b:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:4:"text";s:0:"";}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:26:"eck_activity_log_reference";s:5:"field";s:4:"type";s:5:"value";a:1:{s:22:"activity_log_reference";s:22:"activity_log_reference";}}}s:5:"sorts";a:0:{}s:5:"title";s:17:"Activity Log Page";s:13:"style_options";a:12:{s:8:"grouping";a:0:{}s:9:"row_class";s:0:"";s:17:"default_row_class";i:1;s:17:"row_class_special";i:1;s:8:"override";i:1;s:6:"sticky";i:0;s:7:"caption";s:0:"";s:7:"summary";s:0:"";s:7:"columns";a:5:{s:2:"id";s:2:"id";s:30:"field_activity_log_description";s:30:"field_activity_log_description";s:24:"field_activity_log_title";s:24:"field_activity_log_title";s:9:"view_link";s:9:"view_link";s:22:"field_points_reference";s:22:"field_points_reference";}s:4:"info";a:5:{s:2:"id";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:30:"field_activity_log_description";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:24:"field_activity_log_title";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"view_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:22:"field_points_reference";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}s:7:"default";s:2:"-1";s:11:"empty_table";i:0;}s:9:"arguments";a:0:{}}');
INSERT INTO `views_display` VALUES ('24','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('24','default','Master','default','1','a:12:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:16:"Prize By Program";s:15:"use_more_always";b:0;s:8:"group_by";b:1;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"none";s:7:"options";a:1:{s:6:"offset";s:1:"0";}}s:12:"style_plugin";s:5:"table";s:13:"style_options";a:4:{s:8:"grouping";a:1:{i:0;a:3:{s:5:"field";s:18:"field_program_name";s:8:"rendered";i:1;s:14:"rendered_strip";i:0;}}s:7:"columns";a:3:{s:16:"field_prize_name";s:16:"field_prize_name";s:9:"edit_link";s:9:"edit_link";s:18:"field_program_name";s:18:"field_program_name";}s:7:"default";s:2:"-1";s:4:"info";a:3:{s:16:"field_prize_name";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"edit_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:18:"field_program_name";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}}s:13:"relationships";a:1:{s:33:"field_program_reference_target_id";a:3:{s:2:"id";s:33:"field_program_reference_target_id";s:5:"table";s:34:"field_data_field_program_reference";s:5:"field";s:33:"field_program_reference_target_id";}}s:6:"fields";a:3:{s:5:"title";a:21:{s:2:"id";s:5:"title";s:5:"table";s:9:"eck_prize";s:5:"field";s:5:"title";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:5:"Title";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;}s:9:"edit_link";a:3:{s:2:"id";s:9:"edit_link";s:5:"table";s:9:"eck_prize";s:5:"field";s:9:"edit_link";}s:18:"field_program_name";a:7:{s:2:"id";s:18:"field_program_name";s:5:"table";s:29:"field_data_field_program_name";s:5:"field";s:18:"field_program_name";s:12:"relationship";s:33:"field_program_reference_target_id";s:5:"label";s:0:"";s:7:"exclude";b:1;s:19:"element_label_colon";b:0;}}}');
INSERT INTO `views_display` VALUES ('25','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('25','default','Master','default','1','a:13:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:17:"Tickets By Reader";s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"none";s:7:"options";a:1:{s:6:"offset";s:1:"0";}}s:12:"style_plugin";s:7:"default";s:10:"row_plugin";s:6:"fields";s:13:"relationships";a:1:{s:23:"field_readers_target_id";a:3:{s:2:"id";s:23:"field_readers_target_id";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:23:"field_readers_target_id";}}s:6:"fields";a:5:{s:2:"id";a:3:{s:2:"id";s:2:"id";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:2:"id";}s:5:"title";a:3:{s:2:"id";s:5:"title";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:5:"title";}s:16:"field_first_name";a:4:{s:2:"id";s:16:"field_first_name";s:5:"table";s:27:"field_data_field_first_name";s:5:"field";s:16:"field_first_name";s:12:"relationship";s:23:"field_readers_target_id";}s:13:"field_program";a:6:{s:2:"id";s:13:"field_program";s:5:"table";s:24:"field_data_field_program";s:5:"field";s:13:"field_program";s:12:"relationship";s:23:"field_readers_target_id";s:8:"settings";a:1:{s:4:"link";i:0;}s:12:"delta_offset";s:1:"0";}s:15:"field_last_name";a:4:{s:2:"id";s:15:"field_last_name";s:5:"table";s:26:"field_data_field_last_name";s:5:"field";s:15:"field_last_name";s:12:"relationship";s:23:"field_readers_target_id";}}s:9:"arguments";a:1:{s:23:"field_readers_target_id";a:9:{s:2:"id";s:23:"field_readers_target_id";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:23:"field_readers_target_id";s:14:"default_action";s:5:"empty";s:21:"default_argument_type";s:5:"fixed";s:7:"summary";a:2:{s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:15:"summary_options";a:1:{s:14:"items_per_page";s:2:"25";}s:18:"specify_validation";b:1;s:8:"validate";a:2:{s:4:"type";s:7:"numeric";s:4:"fail";s:5:"empty";}}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:4:"type";s:5:"value";a:1:{s:13:"reader_ticket";s:13:"reader_ticket";}}}}');
INSERT INTO `views_display` VALUES ('26','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('26','default','Master','default','1','a:11:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:10:"Badge View";s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"full";s:7:"options";a:7:{s:14:"items_per_page";s:2:"20";s:6:"offset";s:1:"0";s:2:"id";s:1:"0";s:11:"total_pages";s:0:"";s:8:"quantity";s:1:"9";s:4:"tags";a:4:{s:5:"first";s:8:"« first";s:8:"previous";s:12:"‹ previous";s:4:"next";s:8:"next ›";s:4:"last";s:7:"last »";}s:6:"expose";a:7:{s:14:"items_per_page";i:0;s:20:"items_per_page_label";s:14:"Items per page";s:22:"items_per_page_options";s:17:"5, 10, 20, 40, 60";s:26:"items_per_page_options_all";i:0;s:32:"items_per_page_options_all_label";s:7:"- All -";s:6:"offset";i:0;s:12:"offset_label";s:6:"Offset";}}}s:12:"style_plugin";s:5:"table";s:13:"style_options";a:12:{s:8:"grouping";a:0:{}s:9:"row_class";s:0:"";s:17:"default_row_class";i:1;s:17:"row_class_special";i:0;s:8:"override";i:1;s:6:"sticky";i:0;s:7:"caption";s:0:"";s:7:"summary";s:0:"";s:7:"columns";a:4:{s:5:"title";s:5:"title";s:23:"field_badge_description";s:23:"field_badge_description";s:17:"field_badge_image";s:17:"field_badge_image";s:9:"edit_link";s:9:"edit_link";}s:4:"info";a:4:{s:5:"title";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:23:"field_badge_description";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:17:"field_badge_image";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"edit_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}s:7:"default";s:2:"-1";s:11:"empty_table";i:0;}s:6:"fields";a:4:{s:5:"title";a:21:{s:2:"id";s:5:"title";s:5:"table";s:9:"eck_badge";s:5:"field";s:5:"title";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:10:"Badge Name";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;}s:23:"field_badge_description";a:3:{s:2:"id";s:23:"field_badge_description";s:5:"table";s:34:"field_data_field_badge_description";s:5:"field";s:23:"field_badge_description";}s:17:"field_badge_image";a:5:{s:2:"id";s:17:"field_badge_image";s:5:"table";s:28:"field_data_field_badge_image";s:5:"field";s:17:"field_badge_image";s:17:"click_sort_column";s:3:"fid";s:8:"settings";a:2:{s:11:"image_style";s:0:"";s:10:"image_link";s:0:"";}}s:9:"edit_link";a:3:{s:2:"id";s:9:"edit_link";s:5:"table";s:9:"eck_badge";s:5:"field";s:9:"edit_link";}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:9:"eck_badge";s:5:"field";s:4:"type";s:5:"value";a:1:{s:5:"badge";s:5:"badge";}}}}');
INSERT INTO `views_display` VALUES ('27','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('27','block_1','Block','block','3','a:2:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:8:"defaults";a:1:{s:9:"arguments";b:0;}}'),('27','default','Master','default','1','a:13:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:6:{s:19:"disable_sql_rewrite";i:0;s:8:"distinct";i:1;s:13:"pure_distinct";i:0;s:5:"slave";i:0;s:13:"query_comment";s:0:"";s:10:"query_tags";a:0:{}}}s:5:"title";s:15:"Activities View";s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"none";s:7:"options";a:1:{s:6:"offset";s:1:"0";}}s:12:"style_plugin";s:5:"table";s:13:"style_options";a:3:{s:7:"columns";a:1:{s:2:"id";s:2:"id";}s:7:"default";s:2:"-1";s:4:"info";a:1:{s:2:"id";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}}s:13:"relationships";a:1:{s:35:"field_program_reference_target_id_1";a:3:{s:2:"id";s:35:"field_program_reference_target_id_1";s:5:"table";s:34:"field_data_field_program_reference";s:5:"field";s:33:"field_program_reference_target_id";}}s:6:"fields";a:6:{s:5:"title";a:3:{s:2:"id";s:5:"title";s:5:"table";s:12:"eck_activity";s:5:"field";s:5:"title";}s:26:"field_activity_description";a:3:{s:2:"id";s:26:"field_activity_description";s:5:"table";s:37:"field_data_field_activity_description";s:5:"field";s:26:"field_activity_description";}s:18:"field_reader_badge";a:5:{s:2:"id";s:18:"field_reader_badge";s:5:"table";s:29:"field_data_field_reader_badge";s:5:"field";s:18:"field_reader_badge";s:4:"type";s:27:"entityreference_entity_view";s:8:"settings";a:3:{s:9:"view_mode";s:7:"default";s:5:"links";i:1;s:20:"use_content_language";i:1;}}s:21:"field_activity_points";a:4:{s:2:"id";s:21:"field_activity_points";s:5:"table";s:32:"field_data_field_activity_points";s:5:"field";s:21:"field_activity_points";s:8:"settings";a:2:{s:18:"thousand_separator";s:0:"";s:13:"prefix_suffix";i:1;}}s:23:"field_program_reference";a:6:{s:2:"id";s:23:"field_program_reference";s:5:"table";s:34:"field_data_field_program_reference";s:5:"field";s:23:"field_program_reference";s:5:"label";s:7:"Program";s:8:"settings";a:1:{s:4:"link";i:0;}s:12:"delta_offset";s:1:"0";}s:9:"edit_link";a:3:{s:2:"id";s:9:"edit_link";s:5:"table";s:12:"eck_activity";s:5:"field";s:9:"edit_link";}}s:9:"arguments";a:1:{s:2:"id";a:10:{s:2:"id";s:2:"id";s:5:"table";s:11:"eck_program";s:5:"field";s:2:"id";s:12:"relationship";s:35:"field_program_reference_target_id_1";s:14:"default_action";s:5:"empty";s:21:"default_argument_type";s:5:"fixed";s:7:"summary";a:2:{s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:15:"summary_options";a:1:{s:14:"items_per_page";s:2:"25";}s:18:"specify_validation";b:1;s:8:"validate";a:1:{s:4:"fail";s:5:"empty";}}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:12:"eck_activity";s:5:"field";s:4:"type";s:5:"value";a:1:{s:8:"activity";s:8:"activity";}}}}');
INSERT INTO `views_display` VALUES ('28','block','Block','block','2','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('28','block_1','Block','block','3','a:2:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:8:"defaults";a:1:{s:9:"arguments";b:0;}}'),('28','default','Master','default','1','a:13:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:6:{s:19:"disable_sql_rewrite";i:0;s:8:"distinct";i:1;s:13:"pure_distinct";i:0;s:5:"slave";i:0;s:13:"query_comment";s:0:"";s:10:"query_tags";a:0:{}}}s:5:"title";s:17:"Secret Codes View";s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"none";s:7:"options";a:1:{s:6:"offset";s:1:"0";}}s:12:"style_plugin";s:5:"table";s:13:"style_options";a:3:{s:7:"columns";a:6:{s:2:"id";s:2:"id";s:26:"field_activity_description";s:26:"field_activity_description";s:9:"edit_link";s:9:"edit_link";s:19:"field_activity_code";s:19:"field_activity_code";s:5:"title";s:5:"title";s:18:"field_reader_badge";s:18:"field_reader_badge";}s:7:"default";s:2:"-1";s:4:"info";a:6:{s:2:"id";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:26:"field_activity_description";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"edit_link";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:19:"field_activity_code";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:5:"title";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:18:"field_reader_badge";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}}s:13:"relationships";a:1:{s:33:"field_program_reference_target_id";a:3:{s:2:"id";s:33:"field_program_reference_target_id";s:5:"table";s:34:"field_data_field_program_reference";s:5:"field";s:33:"field_program_reference_target_id";}}s:6:"fields";a:7:{s:5:"title";a:3:{s:2:"id";s:5:"title";s:5:"table";s:12:"eck_activity";s:5:"field";s:5:"title";}s:26:"field_activity_description";a:3:{s:2:"id";s:26:"field_activity_description";s:5:"table";s:37:"field_data_field_activity_description";s:5:"field";s:26:"field_activity_description";}s:19:"field_activity_code";a:3:{s:2:"id";s:19:"field_activity_code";s:5:"table";s:30:"field_data_field_activity_code";s:5:"field";s:19:"field_activity_code";}s:18:"field_reader_badge";a:5:{s:2:"id";s:18:"field_reader_badge";s:5:"table";s:29:"field_data_field_reader_badge";s:5:"field";s:18:"field_reader_badge";s:4:"type";s:27:"entityreference_entity_view";s:8:"settings";a:3:{s:9:"view_mode";s:7:"default";s:5:"links";i:1;s:20:"use_content_language";i:1;}}s:23:"field_program_reference";a:6:{s:2:"id";s:23:"field_program_reference";s:5:"table";s:34:"field_data_field_program_reference";s:5:"field";s:23:"field_program_reference";s:5:"label";s:7:"Program";s:8:"settings";a:1:{s:4:"link";i:0;}s:12:"delta_offset";s:1:"0";}s:9:"edit_link";a:3:{s:2:"id";s:9:"edit_link";s:5:"table";s:12:"eck_activity";s:5:"field";s:9:"edit_link";}s:2:"id";a:4:{s:2:"id";s:2:"id";s:5:"table";s:12:"eck_activity";s:5:"field";s:2:"id";s:7:"exclude";b:1;}}s:9:"arguments";a:1:{s:2:"id";a:10:{s:2:"id";s:2:"id";s:5:"table";s:11:"eck_program";s:5:"field";s:2:"id";s:12:"relationship";s:33:"field_program_reference_target_id";s:14:"default_action";s:5:"empty";s:21:"default_argument_type";s:5:"fixed";s:7:"summary";a:2:{s:17:"number_of_records";s:1:"0";s:6:"format";s:15:"default_summary";}s:15:"summary_options";a:1:{s:14:"items_per_page";s:2:"25";}s:18:"specify_validation";b:1;s:8:"validate";a:1:{s:4:"fail";s:5:"empty";}}}s:7:"filters";a:1:{s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:12:"eck_activity";s:5:"field";s:4:"type";s:5:"value";a:1:{s:11:"secret_code";s:11:"secret_code";}}}}');
INSERT INTO `views_display` VALUES ('29','default','Master','default','1','a:14:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:22:"Manage Drawing Tickets";s:15:"use_more_always";b:0;s:6:"access";a:2:{s:4:"type";s:4:"role";s:4:"role";a:2:{i:3;s:1:"3";i:5;s:1:"5";}}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:2:{s:4:"type";s:14:"input_required";s:7:"options";a:4:{s:13:"submit_button";s:12:"Draw winner!";s:12:"reset_button";b:1;s:19:"text_input_required";s:131:"Filter your drawing tickets and click the "Draw winner" button to select a winner.  You can keep clicking to draw multiple winners.";s:26:"text_input_required_format";s:13:"filtered_html";}}s:5:"pager";a:2:{s:4:"type";s:4:"full";s:7:"options";a:4:{s:14:"items_per_page";s:1:"1";s:6:"offset";s:1:"0";s:2:"id";s:1:"0";s:8:"quantity";s:1:"9";}}s:12:"style_plugin";s:5:"table";s:13:"style_options";a:3:{s:7:"columns";a:4:{s:2:"id";s:2:"id";s:13:"field_readers";s:13:"field_readers";s:5:"title";s:5:"title";s:7:"created";s:7:"created";}s:7:"default";s:2:"id";s:4:"info";a:4:{s:2:"id";a:5:{s:8:"sortable";i:1;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:13:"field_readers";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:5:"title";a:5:{s:8:"sortable";i:1;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:7:"created";a:5:{s:8:"sortable";i:1;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}}s:6:"header";a:1:{s:4:"area";a:3:{s:2:"id";s:4:"area";s:5:"table";s:5:"views";s:5:"field";s:4:"area";}}s:5:"empty";a:1:{s:4:"area";a:6:{s:2:"id";s:4:"area";s:5:"table";s:5:"views";s:5:"field";s:4:"area";s:5:"empty";b:1;s:7:"content";s:65:"No drawing tickets have been earned yet that match this search.  ";s:6:"format";s:13:"filtered_html";}}s:13:"relationships";a:3:{s:23:"field_readers_target_id";a:4:{s:2:"id";s:23:"field_readers_target_id";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:23:"field_readers_target_id";s:5:"label";s:43:"READER entity referenced from field_readers";}s:23:"field_program_target_id";a:4:{s:2:"id";s:23:"field_program_target_id";s:5:"table";s:24:"field_data_field_program";s:5:"field";s:23:"field_program_target_id";s:12:"relationship";s:23:"field_readers_target_id";}s:26:"reverse_field_readers_user";a:5:{s:2:"id";s:26:"reverse_field_readers_user";s:5:"table";s:10:"eck_reader";s:5:"field";s:26:"reverse_field_readers_user";s:12:"relationship";s:23:"field_readers_target_id";s:5:"label";s:42:"USER referencing Reader from field_readers";}}s:6:"fields";a:5:{s:2:"id";a:3:{s:2:"id";s:2:"id";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:2:"id";}s:7:"created";a:6:{s:2:"id";s:7:"created";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:7:"created";s:5:"label";s:6:"Earned";s:11:"date_format";s:5:"short";s:18:"second_date_format";s:4:"long";}s:13:"field_readers";a:6:{s:2:"id";s:13:"field_readers";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:13:"field_readers";s:5:"label";s:6:"Reader";s:8:"settings";a:1:{s:4:"link";i:1;}s:12:"delta_offset";s:1:"0";}s:5:"title";a:5:{s:2:"id";s:5:"title";s:5:"table";s:11:"eck_program";s:5:"field";s:5:"title";s:12:"relationship";s:23:"field_program_target_id";s:5:"label";s:7:"Program";}s:21:"field_favorite_branch";a:6:{s:2:"id";s:21:"field_favorite_branch";s:5:"table";s:32:"field_data_field_favorite_branch";s:5:"field";s:21:"field_favorite_branch";s:12:"relationship";s:26:"reverse_field_readers_user";s:5:"label";s:6:"Branch";s:8:"settings";a:1:{s:4:"link";i:0;}}}s:7:"filters";a:4:{s:4:"type";a:5:{s:2:"id";s:4:"type";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:4:"type";s:5:"value";a:1:{s:13:"reader_ticket";s:13:"reader_ticket";}s:5:"group";i:1;}s:11:"date_filter";a:10:{s:2:"id";s:11:"date_filter";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:11:"date_filter";s:8:"operator";s:7:"between";s:5:"group";i:1;s:7:"exposed";b:1;s:6:"expose";a:5:{s:11:"operator_id";s:14:"date_filter_op";s:5:"label";s:11:"Date Earned";s:8:"operator";s:14:"date_filter_op";s:10:"identifier";s:11:"date_filter";s:14:"remember_roles";a:5:{i:2;s:1:"2";i:1;i:0;i:3;i:0;i:4;i:0;i:5;i:0;}}s:9:"form_type";s:10:"date_popup";s:10:"year_range";s:5:"-0:+0";s:11:"date_fields";a:1:{s:25:"eck_reader_ticket.created";s:25:"eck_reader_ticket.created";}}s:23:"field_program_target_id";a:6:{s:2:"id";s:23:"field_program_target_id";s:5:"table";s:24:"field_data_field_program";s:5:"field";s:23:"field_program_target_id";s:12:"relationship";s:23:"field_readers_target_id";s:7:"exposed";b:1;s:6:"expose";a:6:{s:11:"operator_id";s:26:"field_program_target_id_op";s:5:"label";s:7:"Program";s:8:"operator";s:26:"field_program_target_id_op";s:10:"identifier";s:23:"field_program_target_id";s:8:"multiple";b:1;s:14:"remember_roles";a:5:{i:2;s:1:"2";i:1;i:0;i:3;i:0;i:4;i:0;i:5;i:0;}}}s:31:"field_favorite_branch_target_id";a:6:{s:2:"id";s:31:"field_favorite_branch_target_id";s:5:"table";s:32:"field_data_field_favorite_branch";s:5:"field";s:31:"field_favorite_branch_target_id";s:12:"relationship";s:26:"reverse_field_readers_user";s:7:"exposed";b:1;s:6:"expose";a:6:{s:11:"operator_id";s:34:"field_favorite_branch_target_id_op";s:5:"label";s:6:"Branch";s:8:"operator";s:34:"field_favorite_branch_target_id_op";s:10:"identifier";s:31:"field_favorite_branch_target_id";s:8:"multiple";b:1;s:14:"remember_roles";a:5:{i:2;s:1:"2";i:1;i:0;i:3;i:0;i:4;i:0;i:5;i:0;}}}}}');
INSERT INTO `views_display` VALUES ('29','page_1','winner','page','2','a:11:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:8:"defaults";a:11:{s:5:"title";b:0;s:5:"pager";b:0;s:12:"style_plugin";b:0;s:13:"style_options";b:0;s:10:"row_plugin";b:0;s:11:"row_options";b:0;s:6:"header";b:0;s:5:"sorts";b:0;s:13:"pager_options";b:0;s:6:"access";b:1;s:14:"access_options";b:1;}s:5:"title";s:14:"Draw a Winner!";s:5:"pager";a:2:{s:4:"type";s:4:"some";s:7:"options";a:2:{s:14:"items_per_page";s:1:"1";s:6:"offset";s:1:"0";}}s:12:"style_plugin";s:5:"table";s:13:"style_options";a:3:{s:7:"columns";a:5:{s:2:"id";s:2:"id";s:13:"field_readers";s:13:"field_readers";s:5:"title";s:5:"title";s:7:"created";s:7:"created";s:21:"field_favorite_branch";s:21:"field_favorite_branch";}s:7:"default";s:2:"-1";s:4:"info";a:5:{s:2:"id";a:5:{s:8:"sortable";i:1;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:13:"field_readers";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:5:"title";a:5:{s:8:"sortable";i:1;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:7:"created";a:5:{s:8:"sortable";i:1;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:21:"field_favorite_branch";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}}s:6:"header";a:1:{s:4:"area";a:6:{s:2:"id";s:4:"area";s:5:"table";s:5:"views";s:5:"field";s:4:"area";s:5:"empty";b:1;s:7:"content";s:70:"<a href="/library/dashboard/drawing/manage_tickets">Manage Tickets</a>";s:6:"format";s:13:"filtered_html";}}s:5:"sorts";a:1:{s:6:"random";a:3:{s:2:"id";s:6:"random";s:5:"table";s:5:"views";s:5:"field";s:6:"random";}}s:4:"path";s:25:"library/dashboard/drawing";s:4:"menu";a:3:{s:4:"type";s:6:"normal";s:5:"title";s:15:"Manage Drawings";s:4:"name";s:18:"menu-library-menu1";}s:13:"pager_options";N;}'),('29','page_2','manage','page','3','a:6:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:8:"defaults";a:3:{s:12:"exposed_form";b:0;s:5:"pager";b:0;s:6:"header";b:0;}s:12:"exposed_form";a:2:{s:4:"type";s:5:"basic";s:7:"options";a:1:{s:12:"reset_button";b:1;}}s:5:"pager";a:2:{s:4:"type";s:4:"full";s:7:"options";a:4:{s:14:"items_per_page";s:2:"50";s:6:"offset";s:1:"0";s:2:"id";s:1:"0";s:8:"quantity";s:1:"9";}}s:6:"header";a:1:{s:6:"result";a:5:{s:2:"id";s:6:"result";s:5:"table";s:5:"views";s:5:"field";s:6:"result";s:5:"empty";b:1;s:7:"content";s:59:"Displaying @start - @end of @total tickets for this search.";}}s:4:"path";s:40:"library/dashboard/drawing/manage_tickets";}');
INSERT INTO `views_display` VALUES ('29','page_3','admin','page','4','a:9:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:8:"defaults";a:5:{s:12:"exposed_form";b:0;s:5:"pager";b:0;s:6:"header";b:0;s:5:"title";b:0;s:6:"fields";b:0;}s:12:"exposed_form";a:2:{s:4:"type";s:5:"basic";s:7:"options";a:1:{s:12:"reset_button";b:1;}}s:5:"pager";a:2:{s:4:"type";s:4:"full";s:7:"options";a:4:{s:14:"items_per_page";s:2:"50";s:6:"offset";s:1:"0";s:2:"id";s:1:"0";s:8:"quantity";s:1:"9";}}s:6:"header";a:1:{s:6:"result";a:5:{s:2:"id";s:6:"result";s:5:"table";s:5:"views";s:5:"field";s:6:"result";s:5:"empty";b:1;s:7:"content";s:59:"Displaying @start - @end of @total tickets for this search.";}}s:4:"path";s:25:"admin/library/all-tickets";s:19:"display_description";s:0:"";s:5:"title";s:21:"Admin Drawing Tickets";s:6:"fields";a:6:{s:2:"id";a:3:{s:2:"id";s:2:"id";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:2:"id";}s:7:"created";a:6:{s:2:"id";s:7:"created";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:7:"created";s:5:"label";s:6:"Earned";s:11:"date_format";s:5:"short";s:18:"second_date_format";s:4:"long";}s:13:"field_readers";a:6:{s:2:"id";s:13:"field_readers";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:13:"field_readers";s:5:"label";s:6:"Reader";s:8:"settings";a:1:{s:4:"link";i:1;}s:12:"delta_offset";s:1:"0";}s:5:"title";a:5:{s:2:"id";s:5:"title";s:5:"table";s:11:"eck_program";s:5:"field";s:5:"title";s:12:"relationship";s:23:"field_program_target_id";s:5:"label";s:7:"Program";}s:21:"field_favorite_branch";a:6:{s:2:"id";s:21:"field_favorite_branch";s:5:"table";s:32:"field_data_field_favorite_branch";s:5:"field";s:21:"field_favorite_branch";s:12:"relationship";s:26:"reverse_field_readers_user";s:5:"label";s:6:"Branch";s:8:"settings";a:1:{s:4:"link";i:0;}}s:21:"views_bulk_operations";a:23:{s:2:"id";s:21:"views_bulk_operations";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:21:"views_bulk_operations";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:6:"Select";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:12:"vbo_settings";a:6:{s:12:"display_type";s:1:"0";s:23:"enable_select_all_pages";i:1;s:13:"row_clickable";i:1;s:12:"force_single";i:0;s:20:"entity_load_capacity";s:2:"10";s:13:"skip_batching";i:0;}s:14:"vbo_operations";a:6:{s:41:"action::views_bulk_operations_delete_item";a:5:{s:8:"selected";i:1;s:19:"postpone_processing";i:0;s:17:"skip_confirmation";i:0;s:14:"override_label";i:0;s:5:"label";s:0:"";}s:45:"action::views_bulk_operations_delete_revision";a:5:{s:8:"selected";i:0;s:19:"postpone_processing";i:0;s:17:"skip_confirmation";i:0;s:14:"override_label";i:0;s:5:"label";s:0:"";}s:43:"action::views_bulk_operations_script_action";a:5:{s:8:"selected";i:0;s:19:"postpone_processing";i:0;s:17:"skip_confirmation";i:0;s:14:"override_label";i:0;s:5:"label";s:0:"";}s:43:"action::views_bulk_operations_modify_action";a:6:{s:8:"selected";i:0;s:19:"postpone_processing";i:0;s:17:"skip_confirmation";i:0;s:14:"override_label";i:0;s:5:"label";s:0:"";s:8:"settings";a:2:{s:15:"show_all_tokens";i:1;s:14:"display_values";a:1:{s:5:"_all_";s:5:"_all_";}}}s:54:"action::views_bulk_operations_argument_selector_action";a:5:{s:8:"selected";i:0;s:17:"skip_confirmation";i:0;s:14:"override_label";i:0;s:5:"label";s:0:"";s:8:"settings";a:1:{s:3:"url";s:0:"";}}s:32:"action::system_send_email_action";a:5:{s:8:"selected";i:0;s:19:"postpone_processing";i:0;s:17:"skip_confirmation";i:0;s:14:"override_label";i:0;s:5:"label";s:0:"";}}}}}');
INSERT INTO `views_display` VALUES ('30','default','Master','default','1','a:13:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:6:"access";a:2:{s:4:"type";s:4:"role";s:4:"role";a:1:{i:3;s:1:"3";}}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"full";s:7:"options";a:1:{s:14:"items_per_page";s:2:"50";}}s:12:"style_plugin";s:5:"table";s:10:"row_plugin";s:6:"fields";s:6:"fields";a:4:{s:2:"id";a:3:{s:5:"table";s:10:"eck_school";s:5:"field";s:2:"id";s:2:"id";s:2:"id";}s:5:"title";a:21:{s:2:"id";s:5:"title";s:5:"table";s:10:"eck_school";s:5:"field";s:5:"title";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:5:"Title";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;}s:21:"field_school_address_";a:35:{s:2:"id";s:21:"field_school_address_";s:5:"table";s:32:"field_data_field_school_address_";s:5:"field";s:21:"field_school_address_";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:15:"School Address ";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:17:"click_sort_column";s:5:"value";s:4:"type";s:12:"text_default";s:8:"settings";a:0:{}s:12:"group_column";s:5:"value";s:13:"group_columns";a:0:{}s:10:"group_rows";b:1;s:11:"delta_limit";s:3:"all";s:12:"delta_offset";i:0;s:14:"delta_reversed";b:0;s:16:"delta_first_last";b:0;s:12:"delta_random";b:0;s:10:"multi_type";s:9:"separator";s:9:"separator";s:2:", ";s:17:"field_api_classes";i:0;}s:9:"edit_link";a:22:{s:2:"id";s:9:"edit_link";s:5:"table";s:10:"eck_school";s:5:"field";s:9:"edit_link";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:0:"";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";b:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:4:"text";s:4:"edit";}}s:7:"filters";a:0:{}s:5:"sorts";a:0:{}s:5:"title";s:14:"Manage Schools";s:5:"empty";a:1:{s:4:"area";a:11:{s:2:"id";s:4:"area";s:5:"table";s:5:"views";s:5:"field";s:4:"area";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:0:"";s:5:"empty";b:1;s:7:"content";s:31:"No schools have been added yet.";s:6:"format";s:13:"filtered_html";s:8:"tokenize";i:0;}}s:6:"header";a:1:{s:4:"area";a:11:{s:2:"id";s:4:"area";s:5:"table";s:5:"views";s:5:"field";s:4:"area";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:0:"";s:5:"empty";i:1;s:7:"content";s:71:"<a href="/admin/structure/entity-type/school/school/add">Add School</a>";s:6:"format";s:13:"filtered_html";s:8:"tokenize";i:0;}}}');
INSERT INTO `views_display` VALUES ('30','page','Page','page','2','a:3:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:4:"path";s:25:"library/dashboard/schools";s:4:"menu";a:3:{s:4:"type";s:6:"normal";s:5:"title";s:7:"Schools";s:4:"name";s:15:"menu-setup-menu";}}'),('31','default','Master','default','1','a:14:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:10:"Book Lists";s:15:"use_more_always";b:0;s:6:"access";a:1:{s:4:"type";s:4:"perm";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"some";s:7:"options";a:1:{s:14:"items_per_page";s:2:"10";}}s:12:"style_plugin";s:4:"grid";s:10:"row_plugin";s:6:"fields";s:13:"relationships";a:1:{s:26:"field_booklist_books_value";a:5:{s:2:"id";s:26:"field_booklist_books_value";s:5:"table";s:31:"field_data_field_booklist_books";s:5:"field";s:26:"field_booklist_books_value";s:8:"required";b:1;s:5:"delta";s:1:"0";}}s:6:"fields";a:3:{s:5:"title";a:6:{s:2:"id";s:5:"title";s:5:"table";s:4:"node";s:5:"field";s:5:"title";s:5:"label";s:0:"";s:5:"alter";a:2:{s:13:"word_boundary";b:0;s:8:"ellipsis";b:0;}s:19:"element_label_colon";b:0;}s:16:"field_bl_b_image";a:8:{s:2:"id";s:16:"field_bl_b_image";s:5:"table";s:27:"field_data_field_bl_b_image";s:5:"field";s:16:"field_bl_b_image";s:12:"relationship";s:26:"field_booklist_books_value";s:5:"label";s:0:"";s:19:"element_label_colon";b:0;s:17:"click_sort_column";s:3:"fid";s:8:"settings";a:2:{s:11:"image_style";s:0:"";s:10:"image_link";s:7:"content";}}s:4:"body";a:5:{s:2:"id";s:4:"body";s:5:"table";s:15:"field_data_body";s:5:"field";s:4:"body";s:5:"label";s:0:"";s:19:"element_label_colon";b:0;}}s:5:"sorts";a:1:{s:5:"title";a:4:{s:2:"id";s:5:"title";s:5:"table";s:4:"node";s:5:"field";s:5:"title";s:5:"order";s:4:"DESC";}}s:7:"filters";a:2:{s:6:"status";a:6:{s:2:"id";s:6:"status";s:5:"table";s:4:"node";s:5:"field";s:6:"status";s:5:"value";i:1;s:5:"group";i:1;s:6:"expose";a:1:{s:8:"operator";b:0;}}s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:4:"node";s:5:"field";s:4:"type";s:5:"value";a:1:{s:9:"book_list";s:9:"book_list";}}}s:5:"empty";a:1:{s:4:"area";a:11:{s:2:"id";s:4:"area";s:5:"table";s:5:"views";s:5:"field";s:4:"area";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:0:"";s:5:"empty";b:1;s:7:"content";s:34:"No Book Lists have been added yet.";s:6:"format";s:13:"filtered_html";s:8:"tokenize";i:0;}}}');
INSERT INTO `views_display` VALUES ('31','page','Book Lists (reader)','page','2','a:3:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:4:"path";s:10:"book-lists";s:4:"menu";a:3:{s:4:"type";s:6:"normal";s:5:"title";s:10:"Book Lists";s:4:"name";s:9:"main-menu";}}'),('31','page_1','Manage Book Lists','page','3','a:10:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:8:"defaults";a:8:{s:5:"title";b:0;s:12:"style_plugin";b:0;s:13:"style_options";b:0;s:10:"row_plugin";b:0;s:11:"row_options";b:0;s:6:"header";b:0;s:13:"relationships";b:0;s:6:"fields";b:0;}s:5:"title";s:17:"Manage Book Lists";s:12:"style_plugin";s:5:"table";s:13:"style_options";a:3:{s:7:"columns";a:3:{s:5:"title";s:5:"title";s:16:"field_bl_b_image";s:16:"field_bl_b_image";s:4:"body";s:4:"body";}s:7:"default";s:5:"title";s:4:"info";a:3:{s:5:"title";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:16:"field_bl_b_image";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:4:"body";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}}s:6:"header";a:1:{s:4:"area";a:6:{s:2:"id";s:4:"area";s:5:"table";s:5:"views";s:5:"field";s:4:"area";s:5:"empty";b:1;s:7:"content";s:53:"<a href="/node/add/book-list">Add a new book list</a>";s:6:"format";s:13:"filtered_html";}}s:13:"relationships";a:1:{s:26:"field_booklist_books_value";a:5:{s:2:"id";s:26:"field_booklist_books_value";s:5:"table";s:31:"field_data_field_booklist_books";s:5:"field";s:26:"field_booklist_books_value";s:8:"required";b:1;s:5:"delta";s:2:"-1";}}s:6:"fields";a:4:{s:5:"title";a:6:{s:2:"id";s:5:"title";s:5:"table";s:4:"node";s:5:"field";s:5:"title";s:5:"label";s:0:"";s:5:"alter";a:2:{s:13:"word_boundary";b:0;s:8:"ellipsis";b:0;}s:19:"element_label_colon";b:0;}s:16:"field_bl_b_image";a:8:{s:2:"id";s:16:"field_bl_b_image";s:5:"table";s:27:"field_data_field_bl_b_image";s:5:"field";s:16:"field_bl_b_image";s:12:"relationship";s:26:"field_booklist_books_value";s:5:"label";s:0:"";s:19:"element_label_colon";b:0;s:17:"click_sort_column";s:3:"fid";s:8:"settings";a:2:{s:11:"image_style";s:0:"";s:10:"image_link";s:7:"content";}}s:4:"body";a:5:{s:2:"id";s:4:"body";s:5:"table";s:15:"field_data_body";s:5:"field";s:4:"body";s:5:"label";s:0:"";s:19:"element_label_colon";b:0;}s:9:"edit_node";a:5:{s:2:"id";s:9:"edit_node";s:5:"table";s:17:"views_entity_node";s:5:"field";s:9:"edit_node";s:5:"label";s:4:"Edit";s:4:"text";s:4:"edit";}}s:4:"path";s:25:"library/manage-book-lists";s:4:"menu";a:7:{s:4:"type";s:6:"normal";s:5:"title";s:10:"Book Lists";s:11:"description";s:0:"";s:4:"name";s:18:"menu-library-menu1";s:6:"weight";s:1:"0";s:7:"context";i:0;s:19:"context_only_inline";i:0;}}');
INSERT INTO `views_display` VALUES ('32','default','Master','default','1','a:14:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:22:"Manage Drawing Tickets";s:15:"use_more_always";b:0;s:6:"access";a:2:{s:4:"type";s:4:"role";s:4:"role";a:1:{i:3;s:1:"3";}}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:2:{s:4:"type";s:14:"input_required";s:7:"options";a:4:{s:13:"submit_button";s:12:"Draw winner!";s:12:"reset_button";b:1;s:19:"text_input_required";s:131:"Filter your drawing tickets and click the "Draw winner" button to select a winner.  You can keep clicking to draw multiple winners.";s:26:"text_input_required_format";s:13:"filtered_html";}}s:5:"pager";a:2:{s:4:"type";s:4:"full";s:7:"options";a:4:{s:14:"items_per_page";s:1:"1";s:6:"offset";s:1:"0";s:2:"id";s:1:"0";s:8:"quantity";s:1:"9";}}s:12:"style_plugin";s:5:"table";s:13:"style_options";a:3:{s:7:"columns";a:4:{s:2:"id";s:2:"id";s:13:"field_readers";s:13:"field_readers";s:5:"title";s:5:"title";s:7:"created";s:7:"created";}s:7:"default";s:2:"id";s:4:"info";a:4:{s:2:"id";a:5:{s:8:"sortable";i:1;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:13:"field_readers";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:5:"title";a:5:{s:8:"sortable";i:1;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:7:"created";a:5:{s:8:"sortable";i:1;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}}s:6:"header";a:1:{s:4:"area";a:3:{s:2:"id";s:4:"area";s:5:"table";s:5:"views";s:5:"field";s:4:"area";}}s:5:"empty";a:1:{s:4:"area";a:6:{s:2:"id";s:4:"area";s:5:"table";s:5:"views";s:5:"field";s:4:"area";s:5:"empty";b:1;s:7:"content";s:65:"No drawing tickets have been earned yet that match this search.  ";s:6:"format";s:13:"filtered_html";}}s:13:"relationships";a:3:{s:23:"field_readers_target_id";a:4:{s:2:"id";s:23:"field_readers_target_id";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:23:"field_readers_target_id";s:5:"label";s:43:"READER entity referenced from field_readers";}s:23:"field_program_target_id";a:4:{s:2:"id";s:23:"field_program_target_id";s:5:"table";s:24:"field_data_field_program";s:5:"field";s:23:"field_program_target_id";s:12:"relationship";s:23:"field_readers_target_id";}s:26:"reverse_field_readers_user";a:5:{s:2:"id";s:26:"reverse_field_readers_user";s:5:"table";s:10:"eck_reader";s:5:"field";s:26:"reverse_field_readers_user";s:12:"relationship";s:23:"field_readers_target_id";s:5:"label";s:42:"USER referencing Reader from field_readers";}}s:6:"fields";a:6:{s:2:"id";a:3:{s:2:"id";s:2:"id";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:2:"id";}s:7:"created";a:6:{s:2:"id";s:7:"created";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:7:"created";s:5:"label";s:6:"Earned";s:11:"date_format";s:5:"short";s:18:"second_date_format";s:4:"long";}s:13:"field_readers";a:6:{s:2:"id";s:13:"field_readers";s:5:"table";s:24:"field_data_field_readers";s:5:"field";s:13:"field_readers";s:5:"label";s:6:"Reader";s:8:"settings";a:1:{s:4:"link";i:1;}s:12:"delta_offset";s:1:"0";}s:5:"title";a:5:{s:2:"id";s:5:"title";s:5:"table";s:11:"eck_program";s:5:"field";s:5:"title";s:12:"relationship";s:23:"field_program_target_id";s:5:"label";s:7:"Program";}s:21:"field_favorite_branch";a:6:{s:2:"id";s:21:"field_favorite_branch";s:5:"table";s:32:"field_data_field_favorite_branch";s:5:"field";s:21:"field_favorite_branch";s:12:"relationship";s:26:"reverse_field_readers_user";s:5:"label";s:6:"Branch";s:8:"settings";a:1:{s:4:"link";i:0;}}s:21:"views_bulk_operations";a:23:{s:2:"id";s:21:"views_bulk_operations";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:21:"views_bulk_operations";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:13:"Reader Ticket";s:7:"exclude";i:0;s:5:"alter";a:26:{s:10:"alter_text";i:0;s:4:"text";s:0:"";s:9:"make_link";i:0;s:4:"path";s:0:"";s:8:"absolute";i:0;s:8:"external";i:0;s:14:"replace_spaces";i:0;s:9:"path_case";s:4:"none";s:15:"trim_whitespace";i:0;s:3:"alt";s:0:"";s:3:"rel";s:0:"";s:10:"link_class";s:0:"";s:6:"prefix";s:0:"";s:6:"suffix";s:0:"";s:6:"target";s:0:"";s:5:"nl2br";i:0;s:10:"max_length";s:0:"";s:13:"word_boundary";i:1;s:8:"ellipsis";i:1;s:9:"more_link";i:0;s:14:"more_link_text";s:0:"";s:14:"more_link_path";s:0:"";s:10:"strip_tags";i:0;s:4:"trim";i:0;s:13:"preserve_tags";s:0:"";s:4:"html";i:0;}s:12:"element_type";s:0:"";s:13:"element_class";s:0:"";s:18:"element_label_type";s:0:"";s:19:"element_label_class";s:0:"";s:19:"element_label_colon";i:1;s:20:"element_wrapper_type";s:0:"";s:21:"element_wrapper_class";s:0:"";s:23:"element_default_classes";i:1;s:5:"empty";s:0:"";s:10:"hide_empty";i:0;s:10:"empty_zero";i:0;s:16:"hide_alter_empty";i:1;s:12:"vbo_settings";a:6:{s:12:"display_type";s:1:"0";s:23:"enable_select_all_pages";i:1;s:13:"row_clickable";i:1;s:12:"force_single";i:0;s:20:"entity_load_capacity";s:2:"10";s:13:"skip_batching";i:0;}s:14:"vbo_operations";a:6:{s:41:"action::views_bulk_operations_delete_item";a:5:{s:8:"selected";i:1;s:19:"postpone_processing";i:0;s:17:"skip_confirmation";i:0;s:14:"override_label";i:0;s:5:"label";s:0:"";}s:45:"action::views_bulk_operations_delete_revision";a:5:{s:8:"selected";i:0;s:19:"postpone_processing";i:0;s:17:"skip_confirmation";i:0;s:14:"override_label";i:0;s:5:"label";s:0:"";}s:43:"action::views_bulk_operations_script_action";a:5:{s:8:"selected";i:0;s:19:"postpone_processing";i:0;s:17:"skip_confirmation";i:0;s:14:"override_label";i:0;s:5:"label";s:0:"";}s:43:"action::views_bulk_operations_modify_action";a:6:{s:8:"selected";i:0;s:19:"postpone_processing";i:0;s:17:"skip_confirmation";i:0;s:14:"override_label";i:0;s:5:"label";s:0:"";s:8:"settings";a:2:{s:15:"show_all_tokens";i:1;s:14:"display_values";a:1:{s:5:"_all_";s:5:"_all_";}}}s:54:"action::views_bulk_operations_argument_selector_action";a:5:{s:8:"selected";i:0;s:17:"skip_confirmation";i:0;s:14:"override_label";i:0;s:5:"label";s:0:"";s:8:"settings";a:1:{s:3:"url";s:0:"";}}s:32:"action::system_send_email_action";a:5:{s:8:"selected";i:0;s:19:"postpone_processing";i:0;s:17:"skip_confirmation";i:0;s:14:"override_label";i:0;s:5:"label";s:0:"";}}}}s:7:"filters";a:4:{s:4:"type";a:5:{s:2:"id";s:4:"type";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:4:"type";s:5:"value";a:1:{s:13:"reader_ticket";s:13:"reader_ticket";}s:5:"group";i:1;}s:11:"date_filter";a:10:{s:2:"id";s:11:"date_filter";s:5:"table";s:17:"eck_reader_ticket";s:5:"field";s:11:"date_filter";s:8:"operator";s:7:"between";s:5:"group";i:1;s:7:"exposed";b:1;s:6:"expose";a:5:{s:11:"operator_id";s:14:"date_filter_op";s:5:"label";s:11:"Date Earned";s:8:"operator";s:14:"date_filter_op";s:10:"identifier";s:11:"date_filter";s:14:"remember_roles";a:5:{i:2;s:1:"2";i:1;i:0;i:3;i:0;i:4;i:0;i:5;i:0;}}s:9:"form_type";s:10:"date_popup";s:10:"year_range";s:5:"-0:+0";s:11:"date_fields";a:1:{s:25:"eck_reader_ticket.created";s:25:"eck_reader_ticket.created";}}s:23:"field_program_target_id";a:6:{s:2:"id";s:23:"field_program_target_id";s:5:"table";s:24:"field_data_field_program";s:5:"field";s:23:"field_program_target_id";s:12:"relationship";s:23:"field_readers_target_id";s:7:"exposed";b:1;s:6:"expose";a:6:{s:11:"operator_id";s:26:"field_program_target_id_op";s:5:"label";s:7:"Program";s:8:"operator";s:26:"field_program_target_id_op";s:10:"identifier";s:23:"field_program_target_id";s:8:"multiple";b:1;s:14:"remember_roles";a:5:{i:2;s:1:"2";i:1;i:0;i:3;i:0;i:4;i:0;i:5;i:0;}}}s:31:"field_favorite_branch_target_id";a:6:{s:2:"id";s:31:"field_favorite_branch_target_id";s:5:"table";s:32:"field_data_field_favorite_branch";s:5:"field";s:31:"field_favorite_branch_target_id";s:12:"relationship";s:26:"reverse_field_readers_user";s:7:"exposed";b:1;s:6:"expose";a:6:{s:11:"operator_id";s:34:"field_favorite_branch_target_id_op";s:5:"label";s:6:"Branch";s:8:"operator";s:34:"field_favorite_branch_target_id_op";s:10:"identifier";s:31:"field_favorite_branch_target_id";s:8:"multiple";b:1;s:14:"remember_roles";a:5:{i:2;s:1:"2";i:1;i:0;i:3;i:0;i:4;i:0;i:5;i:0;}}}}}');
INSERT INTO `views_display` VALUES ('32','page_2','manage','page','2','a:6:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:8:"defaults";a:3:{s:12:"exposed_form";b:0;s:5:"pager";b:0;s:6:"header";b:0;}s:12:"exposed_form";a:2:{s:4:"type";s:5:"basic";s:7:"options";a:1:{s:12:"reset_button";b:1;}}s:5:"pager";a:2:{s:4:"type";s:4:"full";s:7:"options";a:4:{s:14:"items_per_page";s:2:"50";s:6:"offset";s:1:"0";s:2:"id";s:1:"0";s:8:"quantity";s:1:"9";}}s:6:"header";a:1:{s:6:"result";a:5:{s:2:"id";s:6:"result";s:5:"table";s:5:"views";s:5:"field";s:6:"result";s:5:"empty";b:1;s:7:"content";s:59:"Displaying @start - @end of @total tickets for this search.";}}s:4:"path";s:19:"admin/ticket-killer";}'),('33','block_1','Block','block','3','a:1:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}}'),('33','default','Master','default','1','a:12:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:13:"Program Count";s:15:"use_more_always";b:0;s:8:"group_by";b:1;s:6:"access";a:1:{s:4:"type";s:4:"none";}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"full";s:7:"options";a:1:{s:14:"items_per_page";s:2:"10";}}s:12:"style_plugin";s:5:"table";s:13:"relationships";a:1:{s:23:"field_program_target_id";a:3:{s:2:"id";s:23:"field_program_target_id";s:5:"table";s:24:"field_data_field_program";s:5:"field";s:23:"field_program_target_id";}}s:6:"fields";a:2:{s:5:"title";a:5:{s:2:"id";s:5:"title";s:5:"table";s:11:"eck_program";s:5:"field";s:5:"title";s:12:"relationship";s:23:"field_program_target_id";s:5:"label";s:7:"Program";}s:2:"id";a:5:{s:2:"id";s:2:"id";s:5:"table";s:10:"eck_reader";s:5:"field";s:2:"id";s:10:"group_type";s:14:"count_distinct";s:5:"label";s:12:"# of readers";}}s:5:"empty";a:1:{s:4:"area";a:11:{s:2:"id";s:4:"area";s:5:"table";s:5:"views";s:5:"field";s:4:"area";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:0:"";s:5:"empty";b:1;s:7:"content";s:77:"You haven''t <a href="/library/dashboard/program/add">added a program</a> yet.";s:6:"format";s:13:"filtered_html";s:8:"tokenize";i:0;}}}');
INSERT INTO `views_display` VALUES ('33','page','Page','page','2','a:2:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:4:"path";s:39:"library/dashboard-widgets/reader_counts";}'),('34','default','Master','default','1','a:13:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:5:"title";s:13:"Manage Events";s:15:"use_more_always";b:0;s:6:"access";a:2:{s:4:"type";s:4:"role";s:4:"role";a:2:{i:3;s:1:"3";i:5;s:1:"5";}}s:5:"cache";a:1:{s:4:"type";s:4:"none";}s:12:"exposed_form";a:1:{s:4:"type";s:5:"basic";}s:5:"pager";a:2:{s:4:"type";s:4:"full";s:7:"options";a:1:{s:14:"items_per_page";s:2:"50";}}s:12:"style_plugin";s:5:"table";s:13:"style_options";a:3:{s:7:"columns";a:4:{s:10:"field_date";s:10:"field_date";s:5:"title";s:5:"title";s:4:"body";s:4:"body";s:9:"edit_node";s:9:"edit_node";}s:7:"default";s:10:"field_date";s:4:"info";a:4:{s:10:"field_date";a:5:{s:8:"sortable";i:1;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:5:"title";a:5:{s:8:"sortable";i:1;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:4:"body";a:5:{s:8:"sortable";i:0;s:18:"default_sort_order";s:3:"asc";s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}s:9:"edit_node";a:3:{s:5:"align";s:0:"";s:9:"separator";s:0:"";s:12:"empty_column";i:0;}}}s:6:"header";a:1:{s:4:"area";a:6:{s:2:"id";s:4:"area";s:5:"table";s:5:"views";s:5:"field";s:4:"area";s:5:"empty";b:1;s:7:"content";s:41:"<a href="/node/add/event">+ Add Event</a>";s:6:"format";s:13:"filtered_html";}}s:5:"empty";a:1:{s:4:"area";a:11:{s:2:"id";s:4:"area";s:5:"table";s:5:"views";s:5:"field";s:4:"area";s:12:"relationship";s:4:"none";s:10:"group_type";s:5:"group";s:7:"ui_name";s:0:"";s:5:"label";s:0:"";s:5:"empty";b:1;s:7:"content";s:69:"No events match this search.  (Maybe you haven''t entered any events?)";s:6:"format";s:13:"filtered_html";s:8:"tokenize";i:0;}}s:6:"fields";a:5:{s:10:"field_date";a:4:{s:2:"id";s:10:"field_date";s:5:"table";s:21:"field_data_field_date";s:5:"field";s:10:"field_date";s:8:"settings";a:7:{s:11:"format_type";s:5:"short";s:6:"fromto";s:4:"both";s:15:"multiple_number";s:0:"";s:13:"multiple_from";s:0:"";s:11:"multiple_to";s:0:"";s:19:"show_remaining_days";i:0;s:16:"show_repeat_rule";s:4:"show";}}s:5:"title";a:4:{s:2:"id";s:5:"title";s:5:"table";s:4:"node";s:5:"field";s:5:"title";s:5:"alter";a:2:{s:13:"word_boundary";b:0;s:8:"ellipsis";b:0;}}s:13:"field_program";a:5:{s:2:"id";s:13:"field_program";s:5:"table";s:24:"field_data_field_program";s:5:"field";s:13:"field_program";s:8:"settings";a:1:{s:4:"link";i:0;}s:12:"delta_offset";s:1:"0";}s:4:"body";a:3:{s:2:"id";s:4:"body";s:5:"table";s:15:"field_data_body";s:5:"field";s:4:"body";}s:9:"edit_node";a:5:{s:2:"id";s:9:"edit_node";s:5:"table";s:17:"views_entity_node";s:5:"field";s:9:"edit_node";s:5:"label";s:4:"Edit";s:4:"text";s:4:"edit";}}s:7:"filters";a:2:{s:6:"status";a:6:{s:2:"id";s:6:"status";s:5:"table";s:4:"node";s:5:"field";s:6:"status";s:5:"value";i:1;s:5:"group";i:1;s:6:"expose";a:1:{s:8:"operator";b:0;}}s:4:"type";a:4:{s:2:"id";s:4:"type";s:5:"table";s:4:"node";s:5:"field";s:4:"type";s:5:"value";a:1:{s:5:"event";s:5:"event";}}}}');
INSERT INTO `views_display` VALUES ('34','page','Page','page','2','a:3:{s:5:"query";a:2:{s:4:"type";s:11:"views_query";s:7:"options";a:0:{}}s:4:"path";s:21:"library/manage-events";s:4:"menu";a:3:{s:4:"type";s:6:"normal";s:5:"title";s:13:"Manage Events";s:4:"name";s:18:"menu-library-menu1";}}');
DROP TABLE IF EXISTS `views_view`;
CREATE TABLE `views_view` (   `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The view ID of the field, defined by the database.',   `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'The unique name of the view. This is the primary field views are loaded from, and is used so that views may be internal and not necessarily in the database. May only be alphanumeric characters plus underscores.',   `description` varchar(255) DEFAULT '' COMMENT 'A description of the view for the admin interface.',   `tag` varchar(255) DEFAULT '' COMMENT 'A tag used to group/sort views in the admin interface',   `base_table` varchar(64) NOT NULL DEFAULT '' COMMENT 'What table this view is based on, such as node, user, comment, or term.',   `human_name` varchar(255) DEFAULT '' COMMENT 'A human readable name used to be displayed in the admin interface',   `core` int(11) DEFAULT '0' COMMENT 'Stores the drupal core version of the view.',   PRIMARY KEY (`vid`),   UNIQUE KEY `name` (`name`) ) ENGINE=InnoDB AUTO_INCREMENT=35 DEFAULT CHARSET=utf8 COMMENT='Stores the general data for a view.' AUTO_INCREMENT=35;
INSERT INTO `views_view` VALUES ('1','branches','','default','eck_branch','Branches','7'),('2','programs','','default','eck_program','Programs','7'),('3','levels','','default','eck_level','Levels','7'),('4','readers','','default','eck_reader','Readers','7'),('5','reader_logs','','default','eck_reader_log','Reader Logs','7'),('7','prize','','default','taxonomy_term_data','prize','7'),('8','entity_badges','','default','eck_program','Entity Badges','7'),('9','program_level','','default','eck_level','Program Level','7'),('12','prizes','','default','eck_prize','prizes','7'),('13','drawing_ticket','','default','eck_drawing_ticket','Drawing Ticket','7'),('14','reader_points_for_reader','','default','eck_points','Reader Points For Reader','7'),('15','all_reader_prizes','','default','eck_reader_prize','All Reader Prizes','7'),('17','prize_per_reader','','default','eck_reader_prize','Prize Per Reader','7'),('18','user_search','','default','users','User Search','7'),('19','reader_admin_overview','','default','eck_reader','Reader Admin Overview','7'),('20','reading_log_by_reader','','default','eck_reading_log','Reading Log By Reader','7'),('21','reader_badge_by_reader','','default','eck_reader_badge','Reader Badge by Reader','7'),('23','activity_log_page','','default','eck_activity_log_reference','Activity Log Page','7'),('24','prize_by_program','','default','eck_prize','Prize By Program','7'),('25','tickets_by_reader','','default','eck_reader_ticket','Tickets By Reader','7'),('26','badge_view','','default','eck_badge','Badge View','7'),('27','activities_view','','default','eck_activity','Activities View','7'),('28','secret_codes_view','','default','eck_activity','Secret Codes View','7'),('29','drawing','Used to pick drawing winners','default','eck_reader_ticket','Drawing','7'),('30','schools','','default','eck_school','Schools','7'),('31','book_lists','','default','node','Book Lists','7'),('32','admin_ticket_killer','Used to pick drawing winners','default','eck_reader_ticket','Admin Ticket Killer','7'),('33','program_dashboard','','default','eck_reader','LibDash - Program Count','7'),('34','manage_events','','default','node','Manage Events','7');
DROP TABLE IF EXISTS `watchdog`;
CREATE TABLE `watchdog` (   `wid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique watchdog event ID.',   `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who triggered the event.',   `type` varchar(64) NOT NULL DEFAULT '' COMMENT 'Type of log message, for example `user` or `page not found.`',   `message` longtext NOT NULL COMMENT 'Text of log message to be passed into the t() function.',   `variables` longblob NOT NULL COMMENT 'Serialized array of variables that match the message string and that is passed into the t() function.',   `severity` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The severity level of the event; ranges from 0 (Emergency) to 7 (Debug)',   `link` varchar(255) DEFAULT '' COMMENT 'Link to view the result of the event.',   `location` text NOT NULL COMMENT 'URL of the origin of the event.',   `referer` text COMMENT 'URL of referring page.',   `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'Hostname of the user who triggered the event.',   `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Unix timestamp of when event occurred.',   PRIMARY KEY (`wid`),   KEY `type` (`type`),   KEY `uid` (`uid`),   KEY `severity` (`severity`) ) ENGINE=InnoDB AUTO_INCREMENT=17183 DEFAULT CHARSET=utf8 COMMENT='Table that contains logs of all system events.' AUTO_INCREMENT=17183;
DROP TABLE IF EXISTS `workflow_node`;
CREATE TABLE `workflow_node` (   `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record is for.',   `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The workflow_states.sid that this node is currently in.',   `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid who triggered this state.',   `stamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The unique stamp for the transition.',   PRIMARY KEY (`nid`),   KEY `nid` (`nid`,`sid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `workflow_node_history`;
CREATE TABLE `workflow_node_history` (   `hid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The unique ID for this record.',   `entity_type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The type of entity this transition belongs to.',   `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record is for.',   `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The current version identifier.',   `field_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The name of the field the transition relates to.',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The languages.language of the entity.',   `delta` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The sequence number for this data item, used for multi-value fields',   `old_sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The workflow_states.sid this transition started as.',   `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The workflow_states.sid this transition transitioned to.',   `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid who made this transition.',   `stamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The unique stamp for this transition.',   `comment` longtext COMMENT 'The comment explaining this transition.',   PRIMARY KEY (`hid`),   KEY `sid` (`entity_type`,`nid`,`sid`),   KEY `nid` (`nid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `workflow_scheduled_transition`;
CREATE TABLE `workflow_scheduled_transition` (   `tid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The unique ID for this record.',   `entity_type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The type of entity this transition belongs to.',   `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The entity ID of the object this transition belongs to.',   `field_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The name of the field the transition relates to.',   `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The languages.language of the entity.',   `delta` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The sequence number for this data item, used for multi-value fields',   `old_sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The workflow_states.sid this state starts at.',   `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The workflow_states.sid this state transitions to.',   `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The user who scheduled this state transition.',   `scheduled` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The date this transition is scheduled for.',   `comment` longtext COMMENT 'The comment explaining this transition.',   PRIMARY KEY (`tid`),   KEY `entity_type` (`entity_type`),   KEY `entity_id` (`entity_type`,`nid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `workflow_states`;
CREATE TABLE `workflow_states` (   `sid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a workflow state.',   `wid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The workflows.wid this state is part of.',   `name` varchar(255) DEFAULT '' COMMENT 'The machine-readable name of this state.',   `state` varchar(255) NOT NULL DEFAULT '' COMMENT 'The human-readable name of this state.',   `weight` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The weight (order) of the state.',   `sysid` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The type of state, usually either WORKFLOW_CREATION or empty.',   `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Whether the current state is active still.',   PRIMARY KEY (`sid`),   KEY `sysid` (`sysid`),   KEY `wid` (`wid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `workflow_transitions`;
CREATE TABLE `workflow_transitions` (   `tid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a workflow transition.',   `name` varchar(32) DEFAULT '' COMMENT 'The machine-readable name of this transition.',   `label` varchar(128) NOT NULL DEFAULT '' COMMENT 'The human-readable name of this transition.',   `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The workflow_states.sid start state.',   `target_sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The workflow_states.sid target state.',   `roles` varchar(255) DEFAULT NULL COMMENT 'The role.sid that a user must have to perform transition.',   PRIMARY KEY (`tid`),   KEY `sid` (`sid`),   KEY `target_sid` (`target_sid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `workflow_type_map`;
CREATE TABLE `workflow_type_map` (   `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The node_type.type the workflow is used on.',   `wid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The workflows.wid this record affects.',   KEY `type` (`type`,`wid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `workflows`;
CREATE TABLE `workflows` (   `wid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a workflow.',   `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The machine-readable name of this workflow.',   `label` varchar(255) NOT NULL DEFAULT '' COMMENT 'The human-readable name of this workflow.',   `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The exportable status of the entity.',   `module` varchar(255) DEFAULT NULL COMMENT 'The name of the providing module if the entity has been defined in code.',   `tab_roles` varchar(255) NOT NULL DEFAULT '' COMMENT 'The role IDs that can access the workflow tabs on node pages.',   `options` longtext COMMENT 'Additional settings for the workflow.',   PRIMARY KEY (`wid`),   UNIQUE KEY `name` (`name`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Workflows' AUTO_INCREMENT=1;
DROP TABLE IF EXISTS `wysiwyg`;
CREATE TABLE `wysiwyg` (   `format` varchar(255) NOT NULL COMMENT 'The filter_format.format of the text format.',   `editor` varchar(128) NOT NULL DEFAULT '' COMMENT 'Internal name of the editor attached to the text format.',   `settings` text COMMENT 'Configuration settings for the editor.',   PRIMARY KEY (`format`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores Wysiwyg profiles.';
INSERT INTO `wysiwyg` VALUES ('filtered_html','tinymce','a:39:{s:7:"buttons";a:3:{s:7:"default";a:11:{s:4:"bold";i:1;s:6:"italic";i:1;s:9:"underline";i:1;s:7:"bullist";i:1;s:7:"numlist";i:1;s:4:"link";i:1;s:6:"unlink";i:1;s:5:"image";i:1;s:3:"cut";i:1;s:4:"copy";i:1;s:5:"paste";i:1;}s:4:"imce";a:1:{s:4:"imce";i:1;}s:6:"drupal";a:1:{s:5:"break";i:1;}}s:5:"theme";s:0:"";s:8:"language";s:2:"en";s:31:"theme_advanced_toolbar_location";s:3:"top";s:28:"theme_advanced_toolbar_align";s:4:"left";s:33:"theme_advanced_statusbar_location";s:6:"bottom";s:19:"theme_advanced_path";i:1;s:23:"theme_advanced_resizing";i:1;s:32:"theme_advanced_resize_horizontal";i:0;s:6:"indent";i:0;s:11:"verify_html";i:1;s:22:"convert_fonts_to_spans";i:1;s:17:"remove_linebreaks";i:1;s:12:"preformatted";i:0;s:11:"css_setting";s:5:"theme";s:9:"css_theme";s:0:"";s:8:"css_path";s:0:"";s:27:"theme_advanced_blockformats";s:32:"p,address,pre,h2,h3,h4,h5,h6,div";s:21:"theme_advanced_styles";s:0:"";s:13:"style_formats";s:0:"";s:7:"formats";s:0:"";s:27:"paste_auto_cleanup_on_paste";i:1;s:16:"paste_block_drop";i:0;s:29:"paste_retain_style_properties";s:4:"none";s:28:"paste_strip_class_attributes";s:3:"mso";s:18:"paste_remove_spans";i:0;s:19:"paste_remove_styles";i:1;s:29:"paste_remove_styles_if_webkit";i:1;s:26:"paste_convert_middot_lists";i:1;s:31:"paste_convert_headers_to_strong";i:0;s:32:"paste_max_consecutive_linebreaks";s:1:"1";s:21:"paste_text_use_dialog";i:0;s:17:"paste_text_sticky";i:0;s:25:"paste_text_sticky_default";i:0;s:23:"paste_text_notifyalways";i:0;s:24:"paste_text_linebreaktype";s:8:"combined";s:21:"autoresize_min_height";s:0:"";s:21:"autoresize_max_height";s:0:"";s:20:"_profile_preferences";a:5:{s:7:"default";i:1;s:11:"user_choose";i:0;s:11:"show_toggle";i:1;s:16:"add_to_summaries";i:1;s:7:"version";s:5:"3.4.1";}}'),('full_html','tinymce','a:39:{s:7:"buttons";a:2:{s:7:"default";a:16:{s:4:"bold";i:1;s:6:"italic";i:1;s:9:"underline";i:1;s:13:"strikethrough";i:1;s:11:"justifyleft";i:1;s:13:"justifycenter";i:1;s:12:"justifyright";i:1;s:7:"bullist";i:1;s:7:"numlist";i:1;s:4:"link";i:1;s:6:"unlink";i:1;s:5:"image";i:1;s:12:"formatselect";i:1;s:3:"cut";i:1;s:4:"copy";i:1;s:5:"paste";i:1;}s:5:"table";a:1:{s:13:"tablecontrols";i:1;}}s:5:"theme";s:0:"";s:8:"language";s:2:"en";s:31:"theme_advanced_toolbar_location";s:3:"top";s:28:"theme_advanced_toolbar_align";s:4:"left";s:33:"theme_advanced_statusbar_location";s:6:"bottom";s:19:"theme_advanced_path";i:1;s:23:"theme_advanced_resizing";i:1;s:32:"theme_advanced_resize_horizontal";i:0;s:6:"indent";i:0;s:11:"verify_html";i:1;s:22:"convert_fonts_to_spans";i:1;s:17:"remove_linebreaks";i:1;s:12:"preformatted";i:0;s:11:"css_setting";s:5:"theme";s:9:"css_theme";s:0:"";s:8:"css_path";s:0:"";s:27:"theme_advanced_blockformats";s:32:"p,address,pre,h2,h3,h4,h5,h6,div";s:21:"theme_advanced_styles";s:0:"";s:13:"style_formats";s:0:"";s:7:"formats";s:0:"";s:27:"paste_auto_cleanup_on_paste";i:1;s:16:"paste_block_drop";i:0;s:29:"paste_retain_style_properties";s:4:"none";s:28:"paste_strip_class_attributes";s:3:"mso";s:18:"paste_remove_spans";i:0;s:19:"paste_remove_styles";i:1;s:29:"paste_remove_styles_if_webkit";i:1;s:26:"paste_convert_middot_lists";i:1;s:31:"paste_convert_headers_to_strong";i:0;s:32:"paste_max_consecutive_linebreaks";s:1:"1";s:21:"paste_text_use_dialog";i:0;s:17:"paste_text_sticky";i:0;s:25:"paste_text_sticky_default";i:0;s:23:"paste_text_notifyalways";i:0;s:24:"paste_text_linebreaktype";s:8:"combined";s:21:"autoresize_min_height";s:0:"";s:21:"autoresize_max_height";s:0:"";s:20:"_profile_preferences";a:5:{s:7:"default";i:1;s:11:"user_choose";i:0;s:11:"show_toggle";i:1;s:16:"add_to_summaries";i:1;s:7:"version";s:5:"3.4.1";}}');
DROP TABLE IF EXISTS `wysiwyg_user`;
CREATE TABLE `wysiwyg_user` (   `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user.',   `format` varchar(255) NOT NULL COMMENT 'The filter_format.format of the text format.',   `status` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the format is enabled by default.',   PRIMARY KEY (`uid`,`format`),   KEY `uid` (`uid`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores user preferences for wysiwyg profiles.';

  
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
